/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the BPF target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 10;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(BPFInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(BPFInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static BPFInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static BPFInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s32,
  GILLT_s64,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(32),
  LLT::scalar(64),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_BPFIsLittleEndianBit = 7,
  Feature_BPFIsBigEndianBit = 8,
  Feature_BPFHasALU32Bit = 5,
  Feature_BPFNoALU32Bit = 2,
  Feature_BPFHasLdsxBit = 4,
  Feature_BPFHasMovsxBit = 1,
  Feature_BPFHasBswapBit = 6,
  Feature_BPFHasSdivSmodBit = 0,
  Feature_BPFNoMovsxBit = 9,
  Feature_BPFHasStoreImmBit = 3,
};

PredicateBitset BPFInstructionSelector::
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsBigEndianBit);
  if (Subtarget->getHasAlu32())
    Features.set(Feature_BPFHasALU32Bit);
  if (!Subtarget->getHasAlu32())
    Features.set(Feature_BPFNoALU32Bit);
  if (Subtarget->hasLdsx())
    Features.set(Feature_BPFHasLdsxBit);
  if (Subtarget->hasMovsx())
    Features.set(Feature_BPFHasMovsxBit);
  if (Subtarget->hasBswap())
    Features.set(Feature_BPFHasBswapBit);
  if (Subtarget->hasSdivSmod())
    Features.set(Feature_BPFHasSdivSmodBit);
  if (!Subtarget->hasMovsx())
    Features.set(Feature_BPFNoMovsxBit);
  if (Subtarget->hasStoreImm())
    Features.set(Feature_BPFHasStoreImmBit);
  return Features;
}

void BPFInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const BPFSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset BPFInstructionSelector::
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_BPFHasBswap,
  GIFBS_BPFHasMovsx,
  GIFBS_BPFHasSdivSmod,
  GIFBS_BPFIsBigEndian,
  GIFBS_BPFIsLittleEndian,
  GIFBS_BPFNoMovsx,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_BPFHasBswapBit, },
  {Feature_BPFHasMovsxBit, },
  {Feature_BPFHasSdivSmodBit, },
  {Feature_BPFIsBigEndianBit, },
  {Feature_BPFIsLittleEndianBit, },
  {Feature_BPFNoMovsxBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

BPFInstructionSelector::ComplexMatcherMemFn
BPFInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool BPFInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool BPFInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("BPFInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
BPFInstructionSelector::CustomRendererFn
BPFInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool BPFInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool BPFInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("BPFInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *BPFInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(246), /*)*//*default:*//*Label 22*/ GIMT_Encode4(2631),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(782),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(848),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(962),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(1028),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(1100),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(1166),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(1238), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(1304),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1430),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1496), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 10*/ GIMT_Encode4(1562), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  322 */ /*TargetOpcode::G_ANYEXT*//*Label 11*/ GIMT_Encode4(1626),
     /*  326 */ /*TargetOpcode::G_TRUNC*//*Label 12*/ GIMT_Encode4(1689),
     /*  330 */ /*TargetOpcode::G_CONSTANT*//*Label 13*/ GIMT_Encode4(1731), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  346 */ /*TargetOpcode::G_SEXT*//*Label 14*/ GIMT_Encode4(1754),
     /*  350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 15*/ GIMT_Encode4(1870),
     /*  354 */ /*TargetOpcode::G_ZEXT*//*Label 16*/ GIMT_Encode4(2066),
     /*  358 */ /*TargetOpcode::G_SHL*//*Label 17*/ GIMT_Encode4(2093),
     /*  362 */ /*TargetOpcode::G_LSHR*//*Label 18*/ GIMT_Encode4(2159),
     /*  366 */ /*TargetOpcode::G_ASHR*//*Label 19*/ GIMT_Encode4(2483), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  714 */ /*TargetOpcode::G_BR*//*Label 20*/ GIMT_Encode4(2549), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  778 */ /*TargetOpcode::G_BSWAP*//*Label 21*/ GIMT_Encode4(2565),
     /*  782 */ // Label 0: @782
     /*  782 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 25*/ GIMT_Encode4(847),
     /*  793 */ /*GILLT_s32*//*Label 23*/ GIMT_Encode4(801),
     /*  797 */ /*GILLT_s64*//*Label 24*/ GIMT_Encode4(824),
     /*  801 */ // Label 23: @801
     /*  801 */ GIM_Try, /*On fail goto*//*Label 26*/ GIMT_Encode4(823), // Rule ID 46 //
     /*  806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  816 */   // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (ADD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr_32),
     /*  821 */   GIR_RootConstrainSelectedInstOperands,
     /*  822 */   // GIR_Coverage, 46,
     /*  822 */   GIR_Done,
     /*  823 */ // Label 26: @823
     /*  823 */ GIM_Reject,
     /*  824 */ // Label 24: @824
     /*  824 */ GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(846), // Rule ID 44 //
     /*  829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  839 */   // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (ADD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr),
     /*  844 */   GIR_RootConstrainSelectedInstOperands,
     /*  845 */   // GIR_Coverage, 44,
     /*  845 */   GIR_Done,
     /*  846 */ // Label 27: @846
     /*  846 */ GIM_Reject,
     /*  847 */ // Label 25: @847
     /*  847 */ GIM_Reject,
     /*  848 */ // Label 1: @848
     /*  848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 30*/ GIMT_Encode4(961),
     /*  859 */ /*GILLT_s32*//*Label 28*/ GIMT_Encode4(867),
     /*  863 */ /*GILLT_s64*//*Label 29*/ GIMT_Encode4(914),
     /*  867 */ // Label 28: @867
     /*  867 */ GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(913),
     /*  872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  882 */   GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(900), // Rule ID 97 //
     /*  887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  891 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG_32:{ *:[i32] } i32:{ *:[i32] }:$src)
     /*  891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_32),
     /*  894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  898 */     GIR_RootConstrainSelectedInstOperands,
     /*  899 */     // GIR_Coverage, 97,
     /*  899 */     GIR_EraseRootFromParent_Done,
     /*  900 */   // Label 32: @900
     /*  900 */   GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(912), // Rule ID 50 //
     /*  905 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SUB_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr_32),
     /*  910 */     GIR_RootConstrainSelectedInstOperands,
     /*  911 */     // GIR_Coverage, 50,
     /*  911 */     GIR_Done,
     /*  912 */   // Label 33: @912
     /*  912 */   GIM_Reject,
     /*  913 */ // Label 31: @913
     /*  913 */ GIM_Reject,
     /*  914 */ // Label 29: @914
     /*  914 */ GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(960),
     /*  919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  929 */   GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(947), // Rule ID 96 //
     /*  934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  938 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$src)  =>  (NEG_64:{ *:[i64] } i64:{ *:[i64] }:$src)
     /*  938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_64),
     /*  941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  945 */     GIR_RootConstrainSelectedInstOperands,
     /*  946 */     // GIR_Coverage, 96,
     /*  946 */     GIR_EraseRootFromParent_Done,
     /*  947 */   // Label 35: @947
     /*  947 */   GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(959), // Rule ID 48 //
     /*  952 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SUB_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr),
     /*  957 */     GIR_RootConstrainSelectedInstOperands,
     /*  958 */     // GIR_Coverage, 48,
     /*  958 */     GIR_Done,
     /*  959 */   // Label 36: @959
     /*  959 */   GIM_Reject,
     /*  960 */ // Label 34: @960
     /*  960 */ GIM_Reject,
     /*  961 */ // Label 30: @961
     /*  961 */ GIM_Reject,
     /*  962 */ // Label 2: @962
     /*  962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 39*/ GIMT_Encode4(1027),
     /*  973 */ /*GILLT_s32*//*Label 37*/ GIMT_Encode4(981),
     /*  977 */ /*GILLT_s64*//*Label 38*/ GIMT_Encode4(1004),
     /*  981 */ // Label 37: @981
     /*  981 */ GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(1003), // Rule ID 78 //
     /*  986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  996 */   // (mul:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MUL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr_32),
     /* 1001 */   GIR_RootConstrainSelectedInstOperands,
     /* 1002 */   // GIR_Coverage, 78,
     /* 1002 */   GIR_Done,
     /* 1003 */ // Label 40: @1003
     /* 1003 */ GIM_Reject,
     /* 1004 */ // Label 38: @1004
     /* 1004 */ GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(1026), // Rule ID 76 //
     /* 1009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1019 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MUL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr),
     /* 1024 */   GIR_RootConstrainSelectedInstOperands,
     /* 1025 */   // GIR_Coverage, 76,
     /* 1025 */   GIR_Done,
     /* 1026 */ // Label 41: @1026
     /* 1026 */ GIM_Reject,
     /* 1027 */ // Label 39: @1027
     /* 1027 */ GIM_Reject,
     /* 1028 */ // Label 3: @1028
     /* 1028 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 44*/ GIMT_Encode4(1099),
     /* 1039 */ /*GILLT_s32*//*Label 42*/ GIMT_Encode4(1047),
     /* 1043 */ /*GILLT_s64*//*Label 43*/ GIMT_Encode4(1073),
     /* 1047 */ // Label 42: @1047
     /* 1047 */ GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(1072), // Rule ID 90 //
     /* 1052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1065 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SDIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr_32),
     /* 1070 */   GIR_RootConstrainSelectedInstOperands,
     /* 1071 */   // GIR_Coverage, 90,
     /* 1071 */   GIR_Done,
     /* 1072 */ // Label 45: @1072
     /* 1072 */ GIM_Reject,
     /* 1073 */ // Label 43: @1073
     /* 1073 */ GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(1098), // Rule ID 88 //
     /* 1078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1091 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SDIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr),
     /* 1096 */   GIR_RootConstrainSelectedInstOperands,
     /* 1097 */   // GIR_Coverage, 88,
     /* 1097 */   GIR_Done,
     /* 1098 */ // Label 46: @1098
     /* 1098 */ GIM_Reject,
     /* 1099 */ // Label 44: @1099
     /* 1099 */ GIM_Reject,
     /* 1100 */ // Label 4: @1100
     /* 1100 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 49*/ GIMT_Encode4(1165),
     /* 1111 */ /*GILLT_s32*//*Label 47*/ GIMT_Encode4(1119),
     /* 1115 */ /*GILLT_s64*//*Label 48*/ GIMT_Encode4(1142),
     /* 1119 */ // Label 47: @1119
     /* 1119 */ GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(1141), // Rule ID 82 //
     /* 1124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1134 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (DIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr_32),
     /* 1139 */   GIR_RootConstrainSelectedInstOperands,
     /* 1140 */   // GIR_Coverage, 82,
     /* 1140 */   GIR_Done,
     /* 1141 */ // Label 50: @1141
     /* 1141 */ GIM_Reject,
     /* 1142 */ // Label 48: @1142
     /* 1142 */ GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(1164), // Rule ID 80 //
     /* 1147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1157 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (DIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr),
     /* 1162 */   GIR_RootConstrainSelectedInstOperands,
     /* 1163 */   // GIR_Coverage, 80,
     /* 1163 */   GIR_Done,
     /* 1164 */ // Label 51: @1164
     /* 1164 */ GIM_Reject,
     /* 1165 */ // Label 49: @1165
     /* 1165 */ GIM_Reject,
     /* 1166 */ // Label 5: @1166
     /* 1166 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 54*/ GIMT_Encode4(1237),
     /* 1177 */ /*GILLT_s32*//*Label 52*/ GIMT_Encode4(1185),
     /* 1181 */ /*GILLT_s64*//*Label 53*/ GIMT_Encode4(1211),
     /* 1185 */ // Label 52: @1185
     /* 1185 */ GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(1210), // Rule ID 94 //
     /* 1190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1203 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SMOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr_32),
     /* 1208 */   GIR_RootConstrainSelectedInstOperands,
     /* 1209 */   // GIR_Coverage, 94,
     /* 1209 */   GIR_Done,
     /* 1210 */ // Label 55: @1210
     /* 1210 */ GIM_Reject,
     /* 1211 */ // Label 53: @1211
     /* 1211 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1236), // Rule ID 92 //
     /* 1216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1229 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SMOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr),
     /* 1234 */   GIR_RootConstrainSelectedInstOperands,
     /* 1235 */   // GIR_Coverage, 92,
     /* 1235 */   GIR_Done,
     /* 1236 */ // Label 56: @1236
     /* 1236 */ GIM_Reject,
     /* 1237 */ // Label 54: @1237
     /* 1237 */ GIM_Reject,
     /* 1238 */ // Label 6: @1238
     /* 1238 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 59*/ GIMT_Encode4(1303),
     /* 1249 */ /*GILLT_s32*//*Label 57*/ GIMT_Encode4(1257),
     /* 1253 */ /*GILLT_s64*//*Label 58*/ GIMT_Encode4(1280),
     /* 1257 */ // Label 57: @1257
     /* 1257 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(1279), // Rule ID 86 //
     /* 1262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1272 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr_32),
     /* 1277 */   GIR_RootConstrainSelectedInstOperands,
     /* 1278 */   // GIR_Coverage, 86,
     /* 1278 */   GIR_Done,
     /* 1279 */ // Label 60: @1279
     /* 1279 */ GIM_Reject,
     /* 1280 */ // Label 58: @1280
     /* 1280 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(1302), // Rule ID 84 //
     /* 1285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1295 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr),
     /* 1300 */   GIR_RootConstrainSelectedInstOperands,
     /* 1301 */   // GIR_Coverage, 84,
     /* 1301 */   GIR_Done,
     /* 1302 */ // Label 61: @1302
     /* 1302 */ GIM_Reject,
     /* 1303 */ // Label 59: @1303
     /* 1303 */ GIM_Reject,
     /* 1304 */ // Label 7: @1304
     /* 1304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 64*/ GIMT_Encode4(1429),
     /* 1315 */ /*GILLT_s32*//*Label 62*/ GIMT_Encode4(1323),
     /* 1319 */ /*GILLT_s64*//*Label 63*/ GIMT_Encode4(1346),
     /* 1323 */ // Label 62: @1323
     /* 1323 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1345), // Rule ID 58 //
     /* 1328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1338 */   // (and:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (AND_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr_32),
     /* 1343 */   GIR_RootConstrainSelectedInstOperands,
     /* 1344 */   // GIR_Coverage, 58,
     /* 1344 */   GIR_Done,
     /* 1345 */ // Label 65: @1345
     /* 1345 */ GIM_Reject,
     /* 1346 */ // Label 63: @1346
     /* 1346 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(1428),
     /* 1351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1361 */   GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(1415), // Rule ID 167 //
     /* 1366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1370 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /* 1381 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$src, 4294967295:{ *:[i64] })  =>  (SRL_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } GPR:{ *:[i64] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1397 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRL_ri),
     /* 1405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414 */     // GIR_Coverage, 167,
     /* 1414 */     GIR_EraseRootFromParent_Done,
     /* 1415 */   // Label 67: @1415
     /* 1415 */   GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(1427), // Rule ID 56 //
     /* 1420 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (AND_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr),
     /* 1425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426 */     // GIR_Coverage, 56,
     /* 1426 */     GIR_Done,
     /* 1427 */   // Label 68: @1427
     /* 1427 */   GIM_Reject,
     /* 1428 */ // Label 66: @1428
     /* 1428 */ GIM_Reject,
     /* 1429 */ // Label 64: @1429
     /* 1429 */ GIM_Reject,
     /* 1430 */ // Label 8: @1430
     /* 1430 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 71*/ GIMT_Encode4(1495),
     /* 1441 */ /*GILLT_s32*//*Label 69*/ GIMT_Encode4(1449),
     /* 1445 */ /*GILLT_s64*//*Label 70*/ GIMT_Encode4(1472),
     /* 1449 */ // Label 69: @1449
     /* 1449 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1471), // Rule ID 54 //
     /* 1454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1464 */   // (or:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (OR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr_32),
     /* 1469 */   GIR_RootConstrainSelectedInstOperands,
     /* 1470 */   // GIR_Coverage, 54,
     /* 1470 */   GIR_Done,
     /* 1471 */ // Label 72: @1471
     /* 1471 */ GIM_Reject,
     /* 1472 */ // Label 70: @1472
     /* 1472 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1494), // Rule ID 52 //
     /* 1477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1487 */   // (or:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (OR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr),
     /* 1492 */   GIR_RootConstrainSelectedInstOperands,
     /* 1493 */   // GIR_Coverage, 52,
     /* 1493 */   GIR_Done,
     /* 1494 */ // Label 73: @1494
     /* 1494 */ GIM_Reject,
     /* 1495 */ // Label 71: @1495
     /* 1495 */ GIM_Reject,
     /* 1496 */ // Label 9: @1496
     /* 1496 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 76*/ GIMT_Encode4(1561),
     /* 1507 */ /*GILLT_s32*//*Label 74*/ GIMT_Encode4(1515),
     /* 1511 */ /*GILLT_s64*//*Label 75*/ GIMT_Encode4(1538),
     /* 1515 */ // Label 74: @1515
     /* 1515 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1537), // Rule ID 70 //
     /* 1520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1530 */   // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (XOR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr_32),
     /* 1535 */   GIR_RootConstrainSelectedInstOperands,
     /* 1536 */   // GIR_Coverage, 70,
     /* 1536 */   GIR_Done,
     /* 1537 */ // Label 77: @1537
     /* 1537 */ GIM_Reject,
     /* 1538 */ // Label 75: @1538
     /* 1538 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1560), // Rule ID 68 //
     /* 1543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1553 */   // (xor:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (XOR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr),
     /* 1558 */   GIR_RootConstrainSelectedInstOperands,
     /* 1559 */   // GIR_Coverage, 68,
     /* 1559 */   GIR_Done,
     /* 1560 */ // Label 78: @1560
     /* 1560 */ GIM_Reject,
     /* 1561 */ // Label 76: @1561
     /* 1561 */ GIM_Reject,
     /* 1562 */ // Label 10: @1562
     /* 1562 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1625), // Rule ID 107 //
     /* 1567 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 1570 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::bpf_pseudo),
     /* 1575 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1596 */   // MIs[1] Operand 1
     /* 1596 */   // No operand predicates
     /* 1596 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 1600 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1604 */   // MIs[2] Operand 1
     /* 1604 */   // No operand predicates
     /* 1604 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1606 */   // (intrinsic_w_chain:{ *:[i64] } 3835:{ *:[iPTR] }, (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)  =>  (LD_pseudo:{ *:[i64] } (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)
     /* 1606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_pseudo),
     /* 1609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1611 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pseudo
     /* 1614 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 1617 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 1623 */   GIR_RootConstrainSelectedInstOperands,
     /* 1624 */   // GIR_Coverage, 107,
     /* 1624 */   GIR_EraseRootFromParent_Done,
     /* 1625 */ // Label 79: @1625
     /* 1625 */ GIM_Reject,
     /* 1626 */ // Label 11: @1626
     /* 1626 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1688), // Rule ID 234 //
     /* 1631 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1645 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 1645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 1652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 1662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1687 */   // GIR_Coverage, 234,
     /* 1687 */   GIR_EraseRootFromParent_Done,
     /* 1688 */ // Label 80: @1688
     /* 1688 */ GIM_Reject,
     /* 1689 */ // Label 12: @1689
     /* 1689 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1730), // Rule ID 233 //
     /* 1694 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 1697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1708 */   // (trunc:{ *:[i32] } GPR:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 1708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 1711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1713 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 1719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1729 */   // GIR_Coverage, 233,
     /* 1729 */   GIR_EraseRootFromParent_Done,
     /* 1730 */ // Label 81: @1730
     /* 1730 */ GIM_Reject,
     /* 1731 */ // Label 13: @1731
     /* 1731 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1753), // Rule ID 98 //
     /* 1736 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1743 */   // MIs[0] Operand 1
     /* 1743 */   // No operand predicates
     /* 1743 */   // (imm:{ *:[i64] }):$imm  =>  (LD_imm64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 1743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_imm64),
     /* 1746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1748 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 1751 */   GIR_RootConstrainSelectedInstOperands,
     /* 1752 */   // GIR_Coverage, 98,
     /* 1752 */   GIR_EraseRootFromParent_Done,
     /* 1753 */ // Label 82: @1753
     /* 1753 */ GIM_Reject,
     /* 1754 */ // Label 14: @1754
     /* 1754 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1869),
     /* 1759 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1773 */   GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1832), // Rule ID 230 //
     /* 1778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFNoMovsx),
     /* 1781 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SRA_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 1784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 1799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 1814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRA_ri),
     /* 1822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831 */     // GIR_Coverage, 230,
     /* 1831 */     GIR_EraseRootFromParent_Done,
     /* 1832 */   // Label 84: @1832
     /* 1832 */   GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1868), // Rule ID 231 //
     /* 1837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1840 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOVSX_rr_32:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src))
     /* 1840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 1861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867 */     // GIR_Coverage, 231,
     /* 1867 */     GIR_EraseRootFromParent_Done,
     /* 1868 */   // Label 85: @1868
     /* 1868 */   GIM_Reject,
     /* 1869 */ // Label 83: @1869
     /* 1869 */ GIM_Reject,
     /* 1870 */ // Label 15: @1870
     /* 1870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 88*/ GIMT_Encode4(2065),
     /* 1881 */ /*GILLT_s32*//*Label 86*/ GIMT_Encode4(1889),
     /* 1885 */ /*GILLT_s64*//*Label 87*/ GIMT_Encode4(1963),
     /* 1889 */ // Label 86: @1889
     /* 1889 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1962),
     /* 1894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1905 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1933), // Rule ID 104 //
     /* 1910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1913 */     // MIs[0] Operand 2
     /* 1913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 1924 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_32_8:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_8),
     /* 1927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932 */     // GIR_Coverage, 104,
     /* 1932 */     GIR_EraseRootFromParent_Done,
     /* 1933 */   // Label 90: @1933
     /* 1933 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1961), // Rule ID 105 //
     /* 1938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1941 */     // MIs[0] Operand 2
     /* 1941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 1952 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_32_16:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_16),
     /* 1955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960 */     // GIR_Coverage, 105,
     /* 1960 */     GIR_EraseRootFromParent_Done,
     /* 1961 */   // Label 91: @1961
     /* 1961 */   GIM_Reject,
     /* 1962 */ // Label 89: @1962
     /* 1962 */ GIM_Reject,
     /* 1963 */ // Label 87: @1963
     /* 1963 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(2064),
     /* 1968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1979 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(2007), // Rule ID 101 //
     /* 1984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1987 */     // MIs[0] Operand 2
     /* 1987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 1998 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_8:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 1998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_8),
     /* 2001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006 */     // GIR_Coverage, 101,
     /* 2006 */     GIR_EraseRootFromParent_Done,
     /* 2007 */   // Label 93: @2007
     /* 2007 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(2035), // Rule ID 102 //
     /* 2012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2015 */     // MIs[0] Operand 2
     /* 2015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2026 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_16),
     /* 2029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034 */     // GIR_Coverage, 102,
     /* 2034 */     GIR_EraseRootFromParent_Done,
     /* 2035 */   // Label 94: @2035
     /* 2035 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(2063), // Rule ID 103 //
     /* 2040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2043 */     // MIs[0] Operand 2
     /* 2043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2054 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (MOVSX_rr_32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 2057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062 */     // GIR_Coverage, 103,
     /* 2062 */     GIR_EraseRootFromParent_Done,
     /* 2063 */   // Label 95: @2063
     /* 2063 */   GIM_Reject,
     /* 2064 */ // Label 92: @2064
     /* 2064 */ GIM_Reject,
     /* 2065 */ // Label 88: @2065
     /* 2065 */ GIM_Reject,
     /* 2066 */ // Label 16: @2066
     /* 2066 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(2092), // Rule ID 232 //
     /* 2071 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2085 */   // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 2085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 2090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2091 */   // GIR_Coverage, 232,
     /* 2091 */   GIR_Done,
     /* 2092 */ // Label 96: @2092
     /* 2092 */ GIM_Reject,
     /* 2093 */ // Label 17: @2093
     /* 2093 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 99*/ GIMT_Encode4(2158),
     /* 2104 */ /*GILLT_s32*//*Label 97*/ GIMT_Encode4(2112),
     /* 2108 */ /*GILLT_s64*//*Label 98*/ GIMT_Encode4(2135),
     /* 2112 */ // Label 97: @2112
     /* 2112 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2134), // Rule ID 62 //
     /* 2117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2127 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SLL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr_32),
     /* 2132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2133 */   // GIR_Coverage, 62,
     /* 2133 */   GIR_Done,
     /* 2134 */ // Label 100: @2134
     /* 2134 */ GIM_Reject,
     /* 2135 */ // Label 98: @2135
     /* 2135 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2157), // Rule ID 60 //
     /* 2140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2150 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SLL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr),
     /* 2155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2156 */   // GIR_Coverage, 60,
     /* 2156 */   GIR_Done,
     /* 2157 */ // Label 101: @2157
     /* 2157 */ GIM_Reject,
     /* 2158 */ // Label 99: @2158
     /* 2158 */ GIM_Reject,
     /* 2159 */ // Label 18: @2159
     /* 2159 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 104*/ GIMT_Encode4(2482),
     /* 2170 */ /*GILLT_s32*//*Label 102*/ GIMT_Encode4(2178),
     /* 2174 */ /*GILLT_s64*//*Label 103*/ GIMT_Encode4(2201),
     /* 2178 */ // Label 102: @2178
     /* 2178 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2200), // Rule ID 66 //
     /* 2183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2193 */   // (srl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr_32),
     /* 2198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199 */   // GIR_Coverage, 66,
     /* 2199 */   GIR_Done,
     /* 2200 */ // Label 105: @2200
     /* 2200 */ GIM_Reject,
     /* 2201 */ // Label 103: @2201
     /* 2201 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2481),
     /* 2206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2216 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2258), // Rule ID 139 //
     /* 2221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BSWAP16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP16),
     /* 2250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2257 */     // GIR_Coverage, 139,
     /* 2257 */     GIR_EraseRootFromParent_Done,
     /* 2258 */   // Label 107: @2258
     /* 2258 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2300), // Rule ID 140 //
     /* 2263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BSWAP32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP32),
     /* 2292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299 */     // GIR_Coverage, 140,
     /* 2299 */     GIR_EraseRootFromParent_Done,
     /* 2300 */   // Label 108: @2300
     /* 2300 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2342), // Rule ID 142 //
     /* 2305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2331 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE16),
     /* 2334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341 */     // GIR_Coverage, 142,
     /* 2341 */     GIR_EraseRootFromParent_Done,
     /* 2342 */   // Label 109: @2342
     /* 2342 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2384), // Rule ID 143 //
     /* 2347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2373 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE32),
     /* 2376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383 */     // GIR_Coverage, 143,
     /* 2383 */     GIR_EraseRootFromParent_Done,
     /* 2384 */   // Label 110: @2384
     /* 2384 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(2426), // Rule ID 145 //
     /* 2389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (LE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE16),
     /* 2418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425 */     // GIR_Coverage, 145,
     /* 2425 */     GIR_EraseRootFromParent_Done,
     /* 2426 */   // Label 111: @2426
     /* 2426 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(2468), // Rule ID 146 //
     /* 2431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2457 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (LE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE32),
     /* 2460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2467 */     // GIR_Coverage, 146,
     /* 2467 */     GIR_EraseRootFromParent_Done,
     /* 2468 */   // Label 112: @2468
     /* 2468 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(2480), // Rule ID 64 //
     /* 2473 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr),
     /* 2478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2479 */     // GIR_Coverage, 64,
     /* 2479 */     GIR_Done,
     /* 2480 */   // Label 113: @2480
     /* 2480 */   GIM_Reject,
     /* 2481 */ // Label 106: @2481
     /* 2481 */ GIM_Reject,
     /* 2482 */ // Label 104: @2482
     /* 2482 */ GIM_Reject,
     /* 2483 */ // Label 19: @2483
     /* 2483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 116*/ GIMT_Encode4(2548),
     /* 2494 */ /*GILLT_s32*//*Label 114*/ GIMT_Encode4(2502),
     /* 2498 */ /*GILLT_s64*//*Label 115*/ GIMT_Encode4(2525),
     /* 2502 */ // Label 114: @2502
     /* 2502 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2524), // Rule ID 74 //
     /* 2507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2517 */   // (sra:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRA_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr_32),
     /* 2522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2523 */   // GIR_Coverage, 74,
     /* 2523 */   GIR_Done,
     /* 2524 */ // Label 117: @2524
     /* 2524 */ GIM_Reject,
     /* 2525 */ // Label 115: @2525
     /* 2525 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2547), // Rule ID 72 //
     /* 2530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2540 */   // (sra:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRA_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr),
     /* 2545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2546 */   // GIR_Coverage, 72,
     /* 2546 */   GIR_Done,
     /* 2547 */ // Label 118: @2547
     /* 2547 */ GIM_Reject,
     /* 2548 */ // Label 116: @2548
     /* 2548 */ GIM_Reject,
     /* 2549 */ // Label 20: @2549
     /* 2549 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2564), // Rule ID 123 //
     /* 2554 */   // MIs[0] BrDst
     /* 2554 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2557 */   // (br (bb:{ *:[Other] }):$BrDst)  =>  (JMP (bb:{ *:[Other] }):$BrDst)
     /* 2557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::JMP),
     /* 2562 */   GIR_RootConstrainSelectedInstOperands,
     /* 2563 */   // GIR_Coverage, 123,
     /* 2563 */   GIR_Done,
     /* 2564 */ // Label 119: @2564
     /* 2564 */ GIM_Reject,
     /* 2565 */ // Label 21: @2565
     /* 2565 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2630),
     /* 2570 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2584 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2599), // Rule ID 141 //
     /* 2589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2592 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BSWAP64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BSWAP64),
     /* 2597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2598 */     // GIR_Coverage, 141,
     /* 2598 */     GIR_Done,
     /* 2599 */   // Label 121: @2599
     /* 2599 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2614), // Rule ID 144 //
     /* 2604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2607 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BE64),
     /* 2612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2613 */     // GIR_Coverage, 144,
     /* 2613 */     GIR_Done,
     /* 2614 */   // Label 122: @2614
     /* 2614 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2629), // Rule ID 147 //
     /* 2619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2622 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (LE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::LE64),
     /* 2627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2628 */     // GIR_Coverage, 147,
     /* 2628 */     GIR_Done,
     /* 2629 */   // Label 123: @2629
     /* 2629 */   GIM_Reject,
     /* 2630 */ // Label 120: @2630
     /* 2630 */ GIM_Reject,
     /* 2631 */ // Label 22: @2631
     /* 2631 */ GIM_Reject,
     /* 2632 */ }; // Size: 2632 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
