/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPostLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 10:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 10;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 9;	 // "p2i_to_i2p"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_to_add", 9) != 0)
        break;
      return 0;	 // "sub_to_add"
    }
    break;
  case 11:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "add_sub_reg", 11) != 0)
      break;
    return 15;	 // "add_sub_reg"
  case 13:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 2;	 // "load_and_mask"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 3;	 // "redundant_and"
    }
    break;
  case 14:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 6;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 12;	 // "fneg_fneg_fold"
    }
    break;
  case 15:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 1;	 // "extending_loads"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 4;	 // "select_same_val"
    }
    break;
  case 17:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 11;	 // "anyext_trunc_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_immed_chain", 16) != 0)
        break;
      return 23;	 // "shift_immed_chain"
    }
    break;
  case 18:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 7;	 // "binop_left_to_zero"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 20;	 // "fptrunc_fpext_fold"
    }
    break;
  case 19:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 8;	 // "binop_right_to_zero"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_zero", 18) != 0)
        break;
      return 5;	 // "right_identity_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "implify_neg_minmax", 18) != 0)
        break;
      return 26;	 // "simplify_neg_minmax"
    }
    break;
  case 20:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitcast_bitcast_fold", 20) != 0)
      break;
    return 19;	 // "bitcast_bitcast_fold"
  case 21:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "right_identity_one_fp", 21) != 0)
      break;
    return 14;	 // "right_identity_one_fp"
  case 22:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 13;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 17;	 // "trunc_buildvector_fold"
    }
    break;
  case 25:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_identity_fold", 24) != 0)
        break;
      return 16;	 // "buildvector_identity_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 22;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 25;	 // "commute_fp_constant_to_rhs"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 21;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_int_constant_to_rhs", 26) != 0)
        break;
      return 24;	 // "commute_int_constant_to_rhs"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 18;	 // "trunc_lshr_buildvector_fold"
    }
    break;
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 27}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPostLegalizerCombinerOption;
static cl::list<std::string> RISCVPostLegalizerCombinerDisableOption(
    "riscvpostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPostLegalizerCombinerOnlyEnableOption(
    "riscvpostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool RISCVPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
};

bool RISCVPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPostLegalizerCombinerImpl::CustomRendererFn
RISCVPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
};
bool RISCVPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(226), /*)*//*default:*//*Label 55*/ GIMT_Encode4(1922),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(702),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(805),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(861),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(919),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(931),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(943),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(955), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(967),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1025),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1084), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(1119),
     /*  110 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 11*/ GIMT_Encode4(1131), GIMT_Encode4(0),
     /*  118 */ /*TargetOpcode::G_PTRTOINT*//*Label 12*/ GIMT_Encode4(1143),
     /*  122 */ /*TargetOpcode::G_INTTOPTR*//*Label 13*/ GIMT_Encode4(1165),
     /*  126 */ /*TargetOpcode::G_BITCAST*//*Label 14*/ GIMT_Encode4(1177), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  170 */ /*TargetOpcode::G_LOAD*//*Label 15*/ GIMT_Encode4(1199),
     /*  174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 16*/ GIMT_Encode4(1211),
     /*  178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 17*/ GIMT_Encode4(1223), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  322 */ /*TargetOpcode::G_ANYEXT*//*Label 18*/ GIMT_Encode4(1235),
     /*  326 */ /*TargetOpcode::G_TRUNC*//*Label 19*/ GIMT_Encode4(1247), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  358 */ /*TargetOpcode::G_SHL*//*Label 20*/ GIMT_Encode4(1270),
     /*  362 */ /*TargetOpcode::G_LSHR*//*Label 21*/ GIMT_Encode4(1316),
     /*  366 */ /*TargetOpcode::G_ASHR*//*Label 22*/ GIMT_Encode4(1362), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  378 */ /*TargetOpcode::G_ROTR*//*Label 23*/ GIMT_Encode4(1408),
     /*  382 */ /*TargetOpcode::G_ROTL*//*Label 24*/ GIMT_Encode4(1432), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  402 */ /*TargetOpcode::G_SELECT*//*Label 25*/ GIMT_Encode4(1456),
     /*  406 */ /*TargetOpcode::G_UADDO*//*Label 26*/ GIMT_Encode4(1468), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  422 */ /*TargetOpcode::G_SADDO*//*Label 27*/ GIMT_Encode4(1480), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  438 */ /*TargetOpcode::G_UMULO*//*Label 28*/ GIMT_Encode4(1492),
     /*  442 */ /*TargetOpcode::G_SMULO*//*Label 29*/ GIMT_Encode4(1504),
     /*  446 */ /*TargetOpcode::G_UMULH*//*Label 30*/ GIMT_Encode4(1516),
     /*  450 */ /*TargetOpcode::G_SMULH*//*Label 31*/ GIMT_Encode4(1528),
     /*  454 */ /*TargetOpcode::G_UADDSAT*//*Label 32*/ GIMT_Encode4(1540),
     /*  458 */ /*TargetOpcode::G_SADDSAT*//*Label 33*/ GIMT_Encode4(1552), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  470 */ /*TargetOpcode::G_USHLSAT*//*Label 34*/ GIMT_Encode4(1564),
     /*  474 */ /*TargetOpcode::G_SSHLSAT*//*Label 35*/ GIMT_Encode4(1576),
     /*  478 */ /*TargetOpcode::G_SMULFIX*//*Label 36*/ GIMT_Encode4(1588),
     /*  482 */ /*TargetOpcode::G_UMULFIX*//*Label 37*/ GIMT_Encode4(1600),
     /*  486 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 38*/ GIMT_Encode4(1612),
     /*  490 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 39*/ GIMT_Encode4(1624), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  510 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(1636), GIMT_Encode4(0),
     /*  518 */ /*TargetOpcode::G_FMUL*//*Label 41*/ GIMT_Encode4(1671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  578 */ /*TargetOpcode::G_FNEG*//*Label 42*/ GIMT_Encode4(1726), GIMT_Encode4(0),
     /*  586 */ /*TargetOpcode::G_FPTRUNC*//*Label 43*/ GIMT_Encode4(1756), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  630 */ /*TargetOpcode::G_FMINNUM*//*Label 44*/ GIMT_Encode4(1778),
     /*  634 */ /*TargetOpcode::G_FMAXNUM*//*Label 45*/ GIMT_Encode4(1790),
     /*  638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 46*/ GIMT_Encode4(1802),
     /*  642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 47*/ GIMT_Encode4(1814),
     /*  646 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(1826),
     /*  650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(1838), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  678 */ /*TargetOpcode::G_PTR_ADD*//*Label 50*/ GIMT_Encode4(1850), GIMT_Encode4(0),
     /*  686 */ /*TargetOpcode::G_SMIN*//*Label 51*/ GIMT_Encode4(1874),
     /*  690 */ /*TargetOpcode::G_SMAX*//*Label 52*/ GIMT_Encode4(1886),
     /*  694 */ /*TargetOpcode::G_UMIN*//*Label 53*/ GIMT_Encode4(1898),
     /*  698 */ /*TargetOpcode::G_UMAX*//*Label 54*/ GIMT_Encode4(1910),
     /*  702 */ // Label 0: @702
     /*  702 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(713), // Rule ID 48 //
     /*  707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  710 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  713 */ // Label 56: @713
     /*  713 */ GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(747), // Rule ID 34 //
     /*  718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  721 */   // MIs[0] dst
     /*  721 */   // No operand predicates
     /*  721 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  721 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  729 */   // MIs[1] src
     /*  729 */   // No operand predicates
     /*  729 */   // MIs[1] __add_sub_reg_match_0.x
     /*  729 */   // No operand predicates
     /*  729 */   // MIs[0] __add_sub_reg_match_0.x
     /*  729 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  734 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  741 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  741 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  746 */   GIR_EraseRootFromParent_Done,
     /*  747 */ // Label 57: @747
     /*  747 */ GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(781), // Rule ID 33 //
     /*  752 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  755 */   // MIs[0] dst
     /*  755 */   // No operand predicates
     /*  755 */   // MIs[0] __add_sub_reg_match_0.x
     /*  755 */   // No operand predicates
     /*  755 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  755 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  763 */   // MIs[1] src
     /*  763 */   // No operand predicates
     /*  763 */   // MIs[1] __add_sub_reg_match_0.x
     /*  763 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  768 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  775 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /*  775 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  780 */   GIR_EraseRootFromParent_Done,
     /*  781 */ // Label 58: @781
     /*  781 */ GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(804), // Rule ID 8 //
     /*  786 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  789 */   // MIs[0] dst
     /*  789 */   // No operand predicates
     /*  789 */   // MIs[0] lhs
     /*  789 */   // No operand predicates
     /*  789 */   // MIs[0] Operand 2
     /*  789 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  793 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  798 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /*  798 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  803 */   GIR_EraseRootFromParent_Done,
     /*  804 */ // Label 59: @804
     /*  804 */ GIM_Reject,
     /*  805 */ // Label 1: @805
     /*  805 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(816), // Rule ID 77 //
     /*  810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /*  813 */   // Combiner Rule #26: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /*  813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /*  816 */ // Label 60: @816
     /*  816 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(839), // Rule ID 7 //
     /*  821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  824 */   // MIs[0] dst
     /*  824 */   // No operand predicates
     /*  824 */   // MIs[0] lhs
     /*  824 */   // No operand predicates
     /*  824 */   // MIs[0] Operand 2
     /*  824 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  828 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  833 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /*  833 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  838 */   GIR_EraseRootFromParent_Done,
     /*  839 */ // Label 61: @839
     /*  839 */ GIM_Try, /*On fail goto*//*Label 62*/ GIMT_Encode4(860), // Rule ID 0 //
     /*  844 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  847 */   // MIs[0] d
     /*  847 */   // No operand predicates
     /*  847 */   // MIs[0] op1
     /*  847 */   // No operand predicates
     /*  847 */   // MIs[0] c
     /*  847 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  855 */   // MIs[1] imm
     /*  855 */   // No operand predicates
     /*  855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  857 */   // Combiner Rule #0: sub_to_add
     /*  857 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  860 */ // Label 62: @860
     /*  860 */ GIM_Reject,
     /*  861 */ // Label 2: @861
     /*  861 */ GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(872), // Rule ID 49 //
     /*  866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  869 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /*  869 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  872 */ // Label 63: @872
     /*  872 */ GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(895), // Rule ID 26 //
     /*  877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /*  880 */   // MIs[0] dst
     /*  880 */   // No operand predicates
     /*  880 */   // MIs[0] lhs
     /*  880 */   // No operand predicates
     /*  880 */   // MIs[0] zero
     /*  880 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  884 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  889 */   // Combiner Rule #8: binop_right_to_zero
     /*  889 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  894 */   GIR_EraseRootFromParent_Done,
     /*  895 */ // Label 64: @895
     /*  895 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(918), // Rule ID 31 //
     /*  900 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  903 */   // MIs[0] dst
     /*  903 */   // No operand predicates
     /*  903 */   // MIs[0] x
     /*  903 */   // No operand predicates
     /*  903 */   // MIs[0] Operand 2
     /*  903 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  907 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  912 */   // Combiner Rule #13: right_identity_one_int
     /*  912 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  917 */   GIR_EraseRootFromParent_Done,
     /*  918 */ // Label 65: @918
     /*  918 */ GIM_Reject,
     /*  919 */ // Label 3: @919
     /*  919 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(930), // Rule ID 22 //
     /*  924 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  927 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /*  927 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  930 */ // Label 66: @930
     /*  930 */ GIM_Reject,
     /*  931 */ // Label 4: @931
     /*  931 */ GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(942), // Rule ID 23 //
     /*  936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  939 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /*  939 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  942 */ // Label 67: @942
     /*  942 */ GIM_Reject,
     /*  943 */ // Label 5: @943
     /*  943 */ GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(954), // Rule ID 24 //
     /*  948 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  951 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /*  951 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  954 */ // Label 68: @954
     /*  954 */ GIM_Reject,
     /*  955 */ // Label 6: @955
     /*  955 */ GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(966), // Rule ID 25 //
     /*  960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  963 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /*  963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  966 */ // Label 69: @966
     /*  966 */ GIM_Reject,
     /*  967 */ // Label 7: @967
     /*  967 */ GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(978), // Rule ID 4 //
     /*  972 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /*  975 */   // Combiner Rule #2: load_and_mask; wip_match_opcode 'G_AND'
     /*  975 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /*  978 */ // Label 70: @978
     /*  978 */ GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(989), // Rule ID 5 //
     /*  983 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /*  986 */   // Combiner Rule #3: redundant_and; wip_match_opcode 'G_AND'
     /*  986 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /*  989 */ // Label 71: @989
     /*  989 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1000), // Rule ID 50 //
     /*  994 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  997 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /*  997 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1000 */ // Label 72: @1000
     /* 1000 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1024), // Rule ID 17 //
     /* 1005 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1008 */   // MIs[0] dst
     /* 1008 */   // No operand predicates
     /* 1008 */   // MIs[0] src
     /* 1008 */   // No operand predicates
     /* 1008 */   // MIs[0] src
     /* 1008 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1013 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1018 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1018 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1023 */   GIR_EraseRootFromParent_Done,
     /* 1024 */ // Label 73: @1024
     /* 1024 */ GIM_Reject,
     /* 1025 */ // Label 8: @1025
     /* 1025 */ GIM_Try, /*On fail goto*//*Label 74*/ GIMT_Encode4(1036), // Rule ID 51 //
     /* 1030 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1033 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1033 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1036 */ // Label 74: @1036
     /* 1036 */ GIM_Try, /*On fail goto*//*Label 75*/ GIMT_Encode4(1060), // Rule ID 18 //
     /* 1041 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1044 */   // MIs[0] dst
     /* 1044 */   // No operand predicates
     /* 1044 */   // MIs[0] src
     /* 1044 */   // No operand predicates
     /* 1044 */   // MIs[0] src
     /* 1044 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1049 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1054 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1054 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1059 */   GIR_EraseRootFromParent_Done,
     /* 1060 */ // Label 75: @1060
     /* 1060 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(1083), // Rule ID 9 //
     /* 1065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1068 */   // MIs[0] dst
     /* 1068 */   // No operand predicates
     /* 1068 */   // MIs[0] lhs
     /* 1068 */   // No operand predicates
     /* 1068 */   // MIs[0] Operand 2
     /* 1068 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1072 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1077 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1077 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1082 */   GIR_EraseRootFromParent_Done,
     /* 1083 */ // Label 76: @1083
     /* 1083 */ GIM_Reject,
     /* 1084 */ // Label 9: @1084
     /* 1084 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1095), // Rule ID 52 //
     /* 1089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1092 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1095 */ // Label 77: @1095
     /* 1095 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1118), // Rule ID 10 //
     /* 1100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1103 */   // MIs[0] dst
     /* 1103 */   // No operand predicates
     /* 1103 */   // MIs[0] lhs
     /* 1103 */   // No operand predicates
     /* 1103 */   // MIs[0] Operand 2
     /* 1103 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1107 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1112 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1112 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1117 */   GIR_EraseRootFromParent_Done,
     /* 1118 */ // Label 78: @1118
     /* 1118 */ GIM_Reject,
     /* 1119 */ // Label 10: @1119
     /* 1119 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1130), // Rule ID 36 //
     /* 1124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1127 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1127 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1130 */ // Label 79: @1130
     /* 1130 */ GIM_Reject,
     /* 1131 */ // Label 11: @1131
     /* 1131 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1142), // Rule ID 35 //
     /* 1136 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1139 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1139 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1142 */ // Label 80: @1142
     /* 1142 */ GIM_Reject,
     /* 1143 */ // Label 12: @1143
     /* 1143 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1164), // Rule ID 28 //
     /* 1148 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1151 */   // MIs[0] dst
     /* 1151 */   // No operand predicates
     /* 1151 */   // MIs[0] t
     /* 1151 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1159 */   // MIs[1] ptr
     /* 1159 */   // No operand predicates
     /* 1159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1161 */   // Combiner Rule #10: i2p_to_p2i
     /* 1161 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1164 */ // Label 81: @1164
     /* 1164 */ GIM_Reject,
     /* 1165 */ // Label 13: @1165
     /* 1165 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1176), // Rule ID 27 //
     /* 1170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1173 */   // Combiner Rule #9: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 1176 */ // Label 82: @1176
     /* 1176 */ GIM_Reject,
     /* 1177 */ // Label 14: @1177
     /* 1177 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1198), // Rule ID 39 //
     /* 1182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1185 */   // MIs[0] dst
     /* 1185 */   // No operand predicates
     /* 1185 */   // MIs[0] src1
     /* 1185 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1193 */   // MIs[1] src0
     /* 1193 */   // No operand predicates
     /* 1193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1195 */   // Combiner Rule #19: bitcast_bitcast_fold
     /* 1195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1198 */ // Label 83: @1198
     /* 1198 */ GIM_Reject,
     /* 1199 */ // Label 15: @1199
     /* 1199 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1210), // Rule ID 1 //
     /* 1204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1207 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_LOAD'
     /* 1207 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1210 */ // Label 84: @1210
     /* 1210 */ GIM_Reject,
     /* 1211 */ // Label 16: @1211
     /* 1211 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1222), // Rule ID 2 //
     /* 1216 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1219 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 1219 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1222 */ // Label 85: @1222
     /* 1222 */ GIM_Reject,
     /* 1223 */ // Label 17: @1223
     /* 1223 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1234), // Rule ID 3 //
     /* 1228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1231 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 1231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1234 */ // Label 86: @1234
     /* 1234 */ GIM_Reject,
     /* 1235 */ // Label 18: @1235
     /* 1235 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1246), // Rule ID 29 //
     /* 1240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1243 */   // Combiner Rule #11: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 1243 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1246 */ // Label 87: @1246
     /* 1246 */ GIM_Reject,
     /* 1247 */ // Label 19: @1247
     /* 1247 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1258), // Rule ID 37 //
     /* 1252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1255 */   // Combiner Rule #17: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 1258 */ // Label 88: @1258
     /* 1258 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1269), // Rule ID 38 //
     /* 1263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 1266 */   // Combiner Rule #18: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1269 */ // Label 89: @1269
     /* 1269 */ GIM_Reject,
     /* 1270 */ // Label 20: @1270
     /* 1270 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1281), // Rule ID 19 //
     /* 1275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1278 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 1278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1281 */ // Label 90: @1281
     /* 1281 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1292), // Rule ID 43 //
     /* 1286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1289 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 1289 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1292 */ // Label 91: @1292
     /* 1292 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1315), // Rule ID 11 //
     /* 1297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1300 */   // MIs[0] dst
     /* 1300 */   // No operand predicates
     /* 1300 */   // MIs[0] lhs
     /* 1300 */   // No operand predicates
     /* 1300 */   // MIs[0] Operand 2
     /* 1300 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1304 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1309 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 1309 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1314 */   GIR_EraseRootFromParent_Done,
     /* 1315 */ // Label 92: @1315
     /* 1315 */ GIM_Reject,
     /* 1316 */ // Label 21: @1316
     /* 1316 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1327), // Rule ID 20 //
     /* 1321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1324 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 1324 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1327 */ // Label 93: @1327
     /* 1327 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1338), // Rule ID 45 //
     /* 1332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1335 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 1335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1338 */ // Label 94: @1338
     /* 1338 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1361), // Rule ID 13 //
     /* 1343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1346 */   // MIs[0] dst
     /* 1346 */   // No operand predicates
     /* 1346 */   // MIs[0] lhs
     /* 1346 */   // No operand predicates
     /* 1346 */   // MIs[0] Operand 2
     /* 1346 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1350 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1355 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 1355 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1360 */   GIR_EraseRootFromParent_Done,
     /* 1361 */ // Label 95: @1361
     /* 1361 */ GIM_Reject,
     /* 1362 */ // Label 22: @1362
     /* 1362 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1373), // Rule ID 21 //
     /* 1367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1370 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 1370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1373 */ // Label 96: @1373
     /* 1373 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1384), // Rule ID 44 //
     /* 1378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1381 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 1381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1384 */ // Label 97: @1384
     /* 1384 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1407), // Rule ID 12 //
     /* 1389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1392 */   // MIs[0] dst
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[0] lhs
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[0] Operand 2
     /* 1392 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1396 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1401 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 1401 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1406 */   GIR_EraseRootFromParent_Done,
     /* 1407 */ // Label 98: @1407
     /* 1407 */ GIM_Reject,
     /* 1408 */ // Label 23: @1408
     /* 1408 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1431), // Rule ID 16 //
     /* 1413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1416 */   // MIs[0] dst
     /* 1416 */   // No operand predicates
     /* 1416 */   // MIs[0] lhs
     /* 1416 */   // No operand predicates
     /* 1416 */   // MIs[0] Operand 2
     /* 1416 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1420 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1425 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 1425 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1430 */   GIR_EraseRootFromParent_Done,
     /* 1431 */ // Label 99: @1431
     /* 1431 */ GIM_Reject,
     /* 1432 */ // Label 24: @1432
     /* 1432 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1455), // Rule ID 15 //
     /* 1437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1440 */   // MIs[0] dst
     /* 1440 */   // No operand predicates
     /* 1440 */   // MIs[0] lhs
     /* 1440 */   // No operand predicates
     /* 1440 */   // MIs[0] Operand 2
     /* 1440 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1444 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1449 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 1449 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1454 */   GIR_EraseRootFromParent_Done,
     /* 1455 */ // Label 100: @1455
     /* 1455 */ GIM_Reject,
     /* 1456 */ // Label 25: @1456
     /* 1456 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1467), // Rule ID 6 //
     /* 1461 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1464 */   // Combiner Rule #4: select_same_val; wip_match_opcode 'G_SELECT'
     /* 1464 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1467 */ // Label 101: @1467
     /* 1467 */ GIM_Reject,
     /* 1468 */ // Label 26: @1468
     /* 1468 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1479), // Rule ID 57 //
     /* 1473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1476 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 1476 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1479 */ // Label 102: @1479
     /* 1479 */ GIM_Reject,
     /* 1480 */ // Label 27: @1480
     /* 1480 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1491), // Rule ID 58 //
     /* 1485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1488 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 1488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1491 */ // Label 103: @1491
     /* 1491 */ GIM_Reject,
     /* 1492 */ // Label 28: @1492
     /* 1492 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1503), // Rule ID 59 //
     /* 1497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1500 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 1500 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1503 */ // Label 104: @1503
     /* 1503 */ GIM_Reject,
     /* 1504 */ // Label 29: @1504
     /* 1504 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1515), // Rule ID 60 //
     /* 1509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1512 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 1512 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1515 */ // Label 105: @1515
     /* 1515 */ GIM_Reject,
     /* 1516 */ // Label 30: @1516
     /* 1516 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1527), // Rule ID 61 //
     /* 1521 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1524 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 1524 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1527 */ // Label 106: @1527
     /* 1527 */ GIM_Reject,
     /* 1528 */ // Label 31: @1528
     /* 1528 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1539), // Rule ID 62 //
     /* 1533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1536 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 1536 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1539 */ // Label 107: @1539
     /* 1539 */ GIM_Reject,
     /* 1540 */ // Label 32: @1540
     /* 1540 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1551), // Rule ID 63 //
     /* 1545 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1548 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 1548 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1551 */ // Label 108: @1551
     /* 1551 */ GIM_Reject,
     /* 1552 */ // Label 33: @1552
     /* 1552 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1563), // Rule ID 64 //
     /* 1557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1560 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 1560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1563 */ // Label 109: @1563
     /* 1563 */ GIM_Reject,
     /* 1564 */ // Label 34: @1564
     /* 1564 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1575), // Rule ID 47 //
     /* 1569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1572 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 1572 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1575 */ // Label 110: @1575
     /* 1575 */ GIM_Reject,
     /* 1576 */ // Label 35: @1576
     /* 1576 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1587), // Rule ID 46 //
     /* 1581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1584 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 1584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1587 */ // Label 111: @1587
     /* 1587 */ GIM_Reject,
     /* 1588 */ // Label 36: @1588
     /* 1588 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1599), // Rule ID 65 //
     /* 1593 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1596 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 1596 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1599 */ // Label 112: @1599
     /* 1599 */ GIM_Reject,
     /* 1600 */ // Label 37: @1600
     /* 1600 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1611), // Rule ID 66 //
     /* 1605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1608 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 1608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1611 */ // Label 113: @1611
     /* 1611 */ GIM_Reject,
     /* 1612 */ // Label 38: @1612
     /* 1612 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1623), // Rule ID 67 //
     /* 1617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1620 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 1620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1623 */ // Label 114: @1623
     /* 1623 */ GIM_Reject,
     /* 1624 */ // Label 39: @1624
     /* 1624 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1635), // Rule ID 68 //
     /* 1629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1632 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 1632 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1635 */ // Label 115: @1635
     /* 1635 */ GIM_Reject,
     /* 1636 */ // Label 40: @1636
     /* 1636 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1647), // Rule ID 69 //
     /* 1641 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1644 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 1644 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1647 */ // Label 116: @1647
     /* 1647 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1670), // Rule ID 41 //
     /* 1652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1655 */   // MIs[0] dst
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[0] x
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[0] y
     /* 1655 */   // No operand predicates
     /* 1655 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 1659 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1664 */   // Combiner Rule #21: right_identity_neg_zero_fp
     /* 1664 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1669 */   GIR_EraseRootFromParent_Done,
     /* 1670 */ // Label 117: @1670
     /* 1670 */ GIM_Reject,
     /* 1671 */ // Label 41: @1671
     /* 1671 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1682), // Rule ID 70 //
     /* 1676 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1679 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 1679 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1682 */ // Label 118: @1682
     /* 1682 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1705), // Rule ID 32 //
     /* 1687 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 1690 */   // MIs[0] dst
     /* 1690 */   // No operand predicates
     /* 1690 */   // MIs[0] x
     /* 1690 */   // No operand predicates
     /* 1690 */   // MIs[0] y
     /* 1690 */   // No operand predicates
     /* 1690 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 1694 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1699 */   // Combiner Rule #14: right_identity_one_fp
     /* 1699 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1704 */   GIR_EraseRootFromParent_Done,
     /* 1705 */ // Label 119: @1705
     /* 1705 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1725), // Rule ID 42 //
     /* 1710 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 1713 */   // MIs[0] dst
     /* 1713 */   // No operand predicates
     /* 1713 */   // MIs[0] x
     /* 1713 */   // No operand predicates
     /* 1713 */   // MIs[0] y
     /* 1713 */   // No operand predicates
     /* 1713 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 1717 */   // Combiner Rule #22: right_identity_neg_one_fp
     /* 1717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1720 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1722 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1724 */   GIR_EraseRootFromParent_Done,
     /* 1725 */ // Label 120: @1725
     /* 1725 */ GIM_Reject,
     /* 1726 */ // Label 42: @1726
     /* 1726 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1755), // Rule ID 30 //
     /* 1731 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1734 */   // MIs[0] dst
     /* 1734 */   // No operand predicates
     /* 1734 */   // MIs[0] t
     /* 1734 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1742 */   // MIs[1] src
     /* 1742 */   // No operand predicates
     /* 1742 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1749 */   // Combiner Rule #12: fneg_fneg_fold
     /* 1749 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1754 */   GIR_EraseRootFromParent_Done,
     /* 1755 */ // Label 121: @1755
     /* 1755 */ GIM_Reject,
     /* 1756 */ // Label 43: @1756
     /* 1756 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1777), // Rule ID 40 //
     /* 1761 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1764 */   // MIs[0] dst
     /* 1764 */   // No operand predicates
     /* 1764 */   // MIs[0] src1
     /* 1764 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 1772 */   // MIs[1] src0
     /* 1772 */   // No operand predicates
     /* 1772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1774 */   // Combiner Rule #20: fptrunc_fpext_fold
     /* 1774 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1777 */ // Label 122: @1777
     /* 1777 */ GIM_Reject,
     /* 1778 */ // Label 44: @1778
     /* 1778 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1789), // Rule ID 71 //
     /* 1783 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1786 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 1786 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1789 */ // Label 123: @1789
     /* 1789 */ GIM_Reject,
     /* 1790 */ // Label 45: @1790
     /* 1790 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1801), // Rule ID 72 //
     /* 1795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1798 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 1798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1801 */ // Label 124: @1801
     /* 1801 */ GIM_Reject,
     /* 1802 */ // Label 46: @1802
     /* 1802 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1813), // Rule ID 73 //
     /* 1807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1810 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 1810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1813 */ // Label 125: @1813
     /* 1813 */ GIM_Reject,
     /* 1814 */ // Label 47: @1814
     /* 1814 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1825), // Rule ID 74 //
     /* 1819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1822 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 1822 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1825 */ // Label 126: @1825
     /* 1825 */ GIM_Reject,
     /* 1826 */ // Label 48: @1826
     /* 1826 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1837), // Rule ID 75 //
     /* 1831 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1834 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 1834 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1837 */ // Label 127: @1837
     /* 1837 */ GIM_Reject,
     /* 1838 */ // Label 49: @1838
     /* 1838 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1849), // Rule ID 76 //
     /* 1843 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1846 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 1846 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1849 */ // Label 128: @1849
     /* 1849 */ GIM_Reject,
     /* 1850 */ // Label 50: @1850
     /* 1850 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1873), // Rule ID 14 //
     /* 1855 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1858 */   // MIs[0] dst
     /* 1858 */   // No operand predicates
     /* 1858 */   // MIs[0] lhs
     /* 1858 */   // No operand predicates
     /* 1858 */   // MIs[0] Operand 2
     /* 1858 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1862 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1867 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 1867 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1872 */   GIR_EraseRootFromParent_Done,
     /* 1873 */ // Label 129: @1873
     /* 1873 */ GIM_Reject,
     /* 1874 */ // Label 51: @1874
     /* 1874 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1885), // Rule ID 53 //
     /* 1879 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1882 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 1882 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1885 */ // Label 130: @1885
     /* 1885 */ GIM_Reject,
     /* 1886 */ // Label 52: @1886
     /* 1886 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1897), // Rule ID 54 //
     /* 1891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1894 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 1894 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1897 */ // Label 131: @1897
     /* 1897 */ GIM_Reject,
     /* 1898 */ // Label 53: @1898
     /* 1898 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1909), // Rule ID 55 //
     /* 1903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1906 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 1906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1909 */ // Label 132: @1909
     /* 1909 */ GIM_Reject,
     /* 1910 */ // Label 54: @1910
     /* 1910 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1921), // Rule ID 56 //
     /* 1915 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1918 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 1918 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1921 */ // Label 133: @1921
     /* 1921 */ GIM_Reject,
     /* 1922 */ // Label 55: @1922
     /* 1922 */ GIM_Reject,
     /* 1923 */ }; // Size: 1923 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

