/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the SPIRV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(SPIRVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(SPIRVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static SPIRVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static SPIRVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s64,
  GILLT_s64,
  GILLT_v2s64,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 64),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 64),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset SPIRVInstructionSelector::
computeAvailableModuleFeatures(const SPIRVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void SPIRVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const SPIRVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset SPIRVInstructionSelector::
computeAvailableFunctionFeatures(const SPIRVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

SPIRVInstructionSelector::ComplexMatcherMemFn
SPIRVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool SPIRVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool SPIRVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_PseudoConstF = GICXXPred_Invalid + 1,
};
bool SPIRVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_PseudoConstF: {
      return true; 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_ConstPseudoFalse = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_ConstPseudoNull,
  GICXXPred_APInt_Predicate_ConstPseudoTrue,
  GICXXPred_APInt_Predicate_PseudoConstI,
};
bool SPIRVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_ConstPseudoFalse: {
     return Imm.getBitWidth() == 1 && Imm.getZExtValue() == 0; 
  }
  case GICXXPred_APInt_Predicate_ConstPseudoNull: {
     return Imm.isZero(); 
  }
  case GICXXPred_APInt_Predicate_ConstPseudoTrue: {
     return Imm.getBitWidth() == 1 && Imm.getZExtValue() == 1; 
  }
  case GICXXPred_APInt_Predicate_PseudoConstI: {
     return Imm.getBitWidth() <= 32; 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool SPIRVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("SPIRVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFImm64,
  GICR_renderImm32,
};
SPIRVInstructionSelector::CustomRendererFn
SPIRVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &SPIRVInstructionSelector::renderFImm64,
  &SPIRVInstructionSelector::renderImm32,
};

bool SPIRVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool SPIRVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("SPIRVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *SPIRVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_Try, /*On fail goto*//*Label 0*/ GIMT_Encode4(3828),
     /*    5 */   GIM_CheckOpcode, /*MI*/0, GIMT_Encode2(SPIRV::ASSIGN_TYPE),
     /*    9 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 4*/ GIMT_Encode4(3827),
     /*   20 */   /*GILLT_p0s64*//*Label 1*/ GIMT_Encode4(32),
     /*   24 */   /*GILLT_s64*//*Label 2*/ GIMT_Encode4(179),
     /*   28 */   /*GILLT_v2s64*//*Label 3*/ GIMT_Encode4(2151),
     /*   32 */   // Label 1: @32
     /*   32 */   GIM_Try, /*On fail goto*//*Label 5*/ GIMT_Encode4(178),
     /*   37 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_p0s64,
     /*   40 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   43 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::pIDRegClassID),
     /*   47 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*   51 */     GIM_Try, /*On fail goto*//*Label 6*/ GIMT_Encode4(114), // Rule ID 56 //
     /*   56 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*   64 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   68 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_p0s64,
     /*   72 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_p0s64,
     /*   76 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*   81 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::pIDRegClassID),
     /*   86 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::pIDRegClassID),
     /*   91 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   93 */       // (assigntype:{ *:[i64] } (select:{ *:[i64] } iID:{ *:[i64] }:$cond, pID:{ *:[i64] }:$src1, pID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectSPSCond:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$cond, pID:{ *:[i64] }:$src1, pID:{ *:[i64] }:$src2)
     /*   93 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectSPSCond),
     /*   96 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   98 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  100 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  104 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  108 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  112 */       GIR_RootConstrainSelectedInstOperands,
     /*  113 */       // GIR_Coverage, 56,
     /*  113 */       GIR_EraseRootFromParent_Done,
     /*  114 */     // Label 6: @114
     /*  114 */     GIM_Try, /*On fail goto*//*Label 7*/ GIMT_Encode4(177), // Rule ID 57 //
     /*  119 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  127 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  131 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_p0s64,
     /*  135 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_p0s64,
     /*  139 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /*  144 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::pIDRegClassID),
     /*  149 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::pIDRegClassID),
     /*  154 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156 */       // (assigntype:{ *:[i64] } (select:{ *:[i64] } vID:{ *:[v2i64] }:$cond, pID:{ *:[i64] }:$src1, pID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectSPVCond:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$cond, pID:{ *:[i64] }:$src1, pID:{ *:[i64] }:$src2)
     /*  156 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectSPVCond),
     /*  159 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  161 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  163 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  167 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  171 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  175 */       GIR_RootConstrainSelectedInstOperands,
     /*  176 */       // GIR_Coverage, 57,
     /*  176 */       GIR_EraseRootFromParent_Done,
     /*  177 */     // Label 7: @177
     /*  177 */     GIM_Reject,
     /*  178 */   // Label 5: @178
     /*  178 */   GIM_Reject,
     /*  179 */   // Label 2: @179
     /*  179 */   GIM_Try, /*On fail goto*//*Label 8*/ GIMT_Encode4(2150),
     /*  184 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  190 */     GIM_Try, /*On fail goto*//*Label 9*/ GIMT_Encode4(231), // Rule ID 3 //
     /*  195 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  199 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  203 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /*  207 */       GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_PseudoConstF),
     /*  211 */       // MIs[1] Operand 1
     /*  211 */       // No operand predicates
     /*  211 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  215 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217 */       // (assigntype:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_PseudoConstF>><<X:fimm_to_i64>>:$src, TYPE:{ *:[i64] }:$type)  =>  (OpConstantF:{ *:[f64] } TYPE:{ *:[i64] }:$type, (fimm_to_i64:{ *:[f64] } (fpimm:{ *:[f64] }):$src))
     /*  217 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpConstantF),
     /*  220 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  222 */       GIR_RootToRootCopy, /*OpIdx*/2, // type
     /*  224 */       GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFImm64), // src
     /*  229 */       GIR_RootConstrainSelectedInstOperands,
     /*  230 */       // GIR_Coverage, 3,
     /*  230 */       GIR_EraseRootFromParent_Done,
     /*  231 */     // Label 9: @231
     /*  231 */     GIM_Try, /*On fail goto*//*Label 10*/ GIMT_Encode4(267), // Rule ID 0 //
     /*  236 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  240 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  244 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  248 */       GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_ConstPseudoTrue),
     /*  252 */       // MIs[1] Operand 1
     /*  252 */       // No operand predicates
     /*  252 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  256 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  258 */       // (assigntype:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_ConstPseudoTrue>>, TYPE:{ *:[i64] }:$src_ty)  =>  (OpConstantTrue:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty)
     /*  258 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpConstantTrue),
     /*  261 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  263 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  265 */       GIR_RootConstrainSelectedInstOperands,
     /*  266 */       // GIR_Coverage, 0,
     /*  266 */       GIR_EraseRootFromParent_Done,
     /*  267 */     // Label 10: @267
     /*  267 */     GIM_Try, /*On fail goto*//*Label 11*/ GIMT_Encode4(303), // Rule ID 1 //
     /*  272 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  276 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  280 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  284 */       GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_ConstPseudoFalse),
     /*  288 */       // MIs[1] Operand 1
     /*  288 */       // No operand predicates
     /*  288 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  292 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  294 */       // (assigntype:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_ConstPseudoFalse>>, TYPE:{ *:[i64] }:$src_ty)  =>  (OpConstantFalse:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty)
     /*  294 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpConstantFalse),
     /*  297 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  299 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  301 */       GIR_RootConstrainSelectedInstOperands,
     /*  302 */       // GIR_Coverage, 1,
     /*  302 */       GIR_EraseRootFromParent_Done,
     /*  303 */     // Label 11: @303
     /*  303 */     GIM_Try, /*On fail goto*//*Label 12*/ GIMT_Encode4(344), // Rule ID 2 //
     /*  308 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  312 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  316 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  320 */       GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_PseudoConstI),
     /*  324 */       // MIs[1] Operand 1
     /*  324 */       // No operand predicates
     /*  324 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  328 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  330 */       // (assigntype:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_PseudoConstI>><<X:imm_to_i32>>:$src, TYPE:{ *:[i64] }:$type)  =>  (OpConstantI:{ *:[i64] } TYPE:{ *:[i64] }:$type, (imm_to_i32:{ *:[i64] } (imm:{ *:[i64] }):$src))
     /*  330 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpConstantI),
     /*  333 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  335 */       GIR_RootToRootCopy, /*OpIdx*/2, // type
     /*  337 */       GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImm32), // src
     /*  342 */       GIR_RootConstrainSelectedInstOperands,
     /*  343 */       // GIR_Coverage, 2,
     /*  343 */       GIR_EraseRootFromParent_Done,
     /*  344 */     // Label 12: @344
     /*  344 */     GIM_Try, /*On fail goto*//*Label 13*/ GIMT_Encode4(415), // Rule ID 58 //
     /*  349 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  353 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  357 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  361 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  365 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  369 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  373 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  378 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  383 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  388 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  392 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  394 */       // (assigntype:{ *:[i64] } (select:{ *:[i64] } iID:{ *:[i64] }:$cond, iID:{ *:[i64] }:$src1, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectSISCond:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$cond, iID:{ *:[i64] }:$src1, iID:{ *:[i64] }:$src2)
     /*  394 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectSISCond),
     /*  397 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  399 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  401 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  405 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  409 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  413 */       GIR_RootConstrainSelectedInstOperands,
     /*  414 */       // GIR_Coverage, 58,
     /*  414 */       GIR_EraseRootFromParent_Done,
     /*  415 */     // Label 13: @415
     /*  415 */     GIM_Try, /*On fail goto*//*Label 14*/ GIMT_Encode4(486), // Rule ID 59 //
     /*  420 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  424 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  428 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  432 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  436 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  440 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  444 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /*  449 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  454 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  459 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  463 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465 */       // (assigntype:{ *:[i64] } (select:{ *:[i64] } vID:{ *:[v2i64] }:$cond, iID:{ *:[i64] }:$src1, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectSIVCond:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$cond, iID:{ *:[i64] }:$src1, iID:{ *:[i64] }:$src2)
     /*  465 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectSIVCond),
     /*  468 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  470 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  472 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  476 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  480 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  484 */       GIR_RootConstrainSelectedInstOperands,
     /*  485 */       // GIR_Coverage, 59,
     /*  485 */       GIR_EraseRootFromParent_Done,
     /*  486 */     // Label 14: @486
     /*  486 */     GIM_Try, /*On fail goto*//*Label 15*/ GIMT_Encode4(557), // Rule ID 60 //
     /*  491 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  495 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  499 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  503 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  507 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  511 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  515 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  520 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  525 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  530 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  534 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  536 */       // (assigntype:{ *:[f64] } (select:{ *:[f64] } iID:{ *:[i64] }:$cond, fID:{ *:[f64] }:$src1, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectSFSCond:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$cond, fID:{ *:[f64] }:$src1, fID:{ *:[f64] }:$src2)
     /*  536 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectSFSCond),
     /*  539 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  541 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  543 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  547 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  551 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  555 */       GIR_RootConstrainSelectedInstOperands,
     /*  556 */       // GIR_Coverage, 60,
     /*  556 */       GIR_EraseRootFromParent_Done,
     /*  557 */     // Label 15: @557
     /*  557 */     GIM_Try, /*On fail goto*//*Label 16*/ GIMT_Encode4(628), // Rule ID 61 //
     /*  562 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  566 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  570 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  574 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  578 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  582 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  586 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /*  591 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  596 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  601 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  605 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  607 */       // (assigntype:{ *:[f64] } (select:{ *:[f64] } vID:{ *:[v2i64] }:$cond, fID:{ *:[f64] }:$src1, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectSFVCond:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$cond, fID:{ *:[f64] }:$src1, fID:{ *:[f64] }:$src2)
     /*  607 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectSFVCond),
     /*  610 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  612 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  614 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  618 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  622 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  626 */       GIR_RootConstrainSelectedInstOperands,
     /*  627 */       // GIR_Coverage, 61,
     /*  627 */       GIR_EraseRootFromParent_Done,
     /*  628 */     // Label 16: @628
     /*  628 */     GIM_Try, /*On fail goto*//*Label 17*/ GIMT_Encode4(699), // Rule ID 62 //
     /*  633 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vpIDRegClassID),
     /*  637 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  641 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  645 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  649 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  653 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  657 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  662 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vpIDRegClassID),
     /*  667 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::vpIDRegClassID),
     /*  672 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  676 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  678 */       // (assigntype:{ *:[i64] } (select:{ *:[i64] } iID:{ *:[i64] }:$cond, vpID:{ *:[i64] }:$src1, vpID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectVPSCond:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$cond, vpID:{ *:[i64] }:$src1, vpID:{ *:[i64] }:$src2)
     /*  678 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectVPSCond),
     /*  681 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  683 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  685 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  689 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  693 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  697 */       GIR_RootConstrainSelectedInstOperands,
     /*  698 */       // GIR_Coverage, 62,
     /*  698 */       GIR_EraseRootFromParent_Done,
     /*  699 */     // Label 17: @699
     /*  699 */     GIM_Try, /*On fail goto*//*Label 18*/ GIMT_Encode4(770), // Rule ID 63 //
     /*  704 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vpIDRegClassID),
     /*  708 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  712 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  716 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  720 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  724 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  728 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /*  733 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vpIDRegClassID),
     /*  738 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::vpIDRegClassID),
     /*  743 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  747 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  749 */       // (assigntype:{ *:[i64] } (select:{ *:[i64] } vID:{ *:[v2i64] }:$cond, vpID:{ *:[i64] }:$src1, vpID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectVPVCond:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$cond, vpID:{ *:[i64] }:$src1, vpID:{ *:[i64] }:$src2)
     /*  749 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectVPVCond),
     /*  752 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  754 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  756 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /*  760 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  764 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /*  768 */       GIR_RootConstrainSelectedInstOperands,
     /*  769 */       // GIR_Coverage, 63,
     /*  769 */       GIR_EraseRootFromParent_Done,
     /*  770 */     // Label 18: @770
     /*  770 */     GIM_Try, /*On fail goto*//*Label 19*/ GIMT_Encode4(828), // Rule ID 6 //
     /*  775 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  779 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  783 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  787 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  791 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  795 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  800 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  805 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  809 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  811 */       // (assigntype:{ *:[i64] } (add:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpIAddS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /*  811 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpIAddS),
     /*  814 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  816 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  818 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  822 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  826 */       GIR_RootConstrainSelectedInstOperands,
     /*  827 */       // GIR_Coverage, 6,
     /*  827 */       GIR_EraseRootFromParent_Done,
     /*  828 */     // Label 19: @828
     /*  828 */     GIM_Try, /*On fail goto*//*Label 20*/ GIMT_Encode4(886), // Rule ID 54 //
     /*  833 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  837 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  841 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  845 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  849 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  853 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  858 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  863 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  867 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  869 */       // (assigntype:{ *:[i64] } (and:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpBitwiseAndS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /*  869 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpBitwiseAndS),
     /*  872 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  874 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  876 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  880 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  884 */       GIR_RootConstrainSelectedInstOperands,
     /*  885 */       // GIR_Coverage, 54,
     /*  885 */       GIR_EraseRootFromParent_Done,
     /*  886 */     // Label 20: @886
     /*  886 */     GIM_Try, /*On fail goto*//*Label 21*/ GIMT_Encode4(944), // Rule ID 46 //
     /*  891 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  899 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  903 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  907 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  911 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  916 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /*  921 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  925 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927 */       // (assigntype:{ *:[i64] } (sra:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpShiftRightArithmeticS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /*  927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpShiftRightArithmeticS),
     /*  930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  932 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  934 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  938 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  942 */       GIR_RootConstrainSelectedInstOperands,
     /*  943 */       // GIR_Coverage, 46,
     /*  943 */       GIR_EraseRootFromParent_Done,
     /*  944 */     // Label 21: @944
     /*  944 */     GIM_Try, /*On fail goto*//*Label 22*/ GIMT_Encode4(1002), // Rule ID 8 //
     /*  949 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /*  961 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  965 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  969 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  974 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /*  979 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /*  983 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985 */       // (assigntype:{ *:[f64] } (fadd:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFAddS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /*  985 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFAddS),
     /*  988 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  990 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /*  992 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  996 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1000 */       GIR_RootConstrainSelectedInstOperands,
     /* 1001 */       // GIR_Coverage, 8,
     /* 1001 */       GIR_EraseRootFromParent_Done,
     /* 1002 */     // Label 22: @1002
     /* 1002 */     GIM_Try, /*On fail goto*//*Label 23*/ GIMT_Encode4(1060), // Rule ID 28 //
     /* 1007 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1011 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1015 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FDIV),
     /* 1019 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1023 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1027 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1032 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1037 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1041 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1043 */       // (assigntype:{ *:[f64] } (fdiv:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFDivS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1043 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFDivS),
     /* 1046 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1048 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1050 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1054 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1058 */       GIR_RootConstrainSelectedInstOperands,
     /* 1059 */       // GIR_Coverage, 28,
     /* 1059 */       GIR_EraseRootFromParent_Done,
     /* 1060 */     // Label 23: @1060
     /* 1060 */     GIM_Try, /*On fail goto*//*Label 24*/ GIMT_Encode4(1118), // Rule ID 20 //
     /* 1065 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1069 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1073 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 1077 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1081 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1090 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1095 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1099 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1101 */       // (assigntype:{ *:[f64] } (fmul:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFMulS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1101 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFMulS),
     /* 1104 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1106 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1108 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1112 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1116 */       GIR_RootConstrainSelectedInstOperands,
     /* 1117 */       // GIR_Coverage, 20,
     /* 1117 */       GIR_EraseRootFromParent_Done,
     /* 1118 */     // Label 24: @1118
     /* 1118 */     GIM_Try, /*On fail goto*//*Label 25*/ GIMT_Encode4(1176), // Rule ID 36 //
     /* 1123 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1127 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1131 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREM),
     /* 1135 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1139 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1143 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1148 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1153 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1157 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1159 */       // (assigntype:{ *:[f64] } (frem:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFRemS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1159 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFRemS),
     /* 1162 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1164 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1166 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1170 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1174 */       GIR_RootConstrainSelectedInstOperands,
     /* 1175 */       // GIR_Coverage, 36,
     /* 1175 */       GIR_EraseRootFromParent_Done,
     /* 1176 */     // Label 25: @1176
     /* 1176 */     GIM_Try, /*On fail goto*//*Label 26*/ GIMT_Encode4(1234), // Rule ID 14 //
     /* 1181 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1185 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1189 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 1193 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1197 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1201 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1206 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1211 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1215 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1217 */       // (assigntype:{ *:[f64] } (fsub:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFSubS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1217 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFSubS),
     /* 1220 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1222 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1224 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1228 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1232 */       GIR_RootConstrainSelectedInstOperands,
     /* 1233 */       // GIR_Coverage, 14,
     /* 1233 */       GIR_EraseRootFromParent_Done,
     /* 1234 */     // Label 26: @1234
     /* 1234 */     GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(1292), // Rule ID 44 //
     /* 1239 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1243 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1247 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 1251 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1255 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1259 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1264 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1269 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1273 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1275 */       // (assigntype:{ *:[i64] } (srl:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpShiftRightLogicalS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1275 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpShiftRightLogicalS),
     /* 1278 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1280 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1282 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1290 */       GIR_RootConstrainSelectedInstOperands,
     /* 1291 */       // GIR_Coverage, 44,
     /* 1291 */       GIR_EraseRootFromParent_Done,
     /* 1292 */     // Label 27: @1292
     /* 1292 */     GIM_Try, /*On fail goto*//*Label 28*/ GIMT_Encode4(1350), // Rule ID 18 //
     /* 1297 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1301 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1305 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 1309 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1313 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1317 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1322 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1327 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1331 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333 */       // (assigntype:{ *:[i64] } (mul:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpIMulS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpIMulS),
     /* 1336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1338 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1340 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1344 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1348 */       GIR_RootConstrainSelectedInstOperands,
     /* 1349 */       // GIR_Coverage, 18,
     /* 1349 */       GIR_EraseRootFromParent_Done,
     /* 1350 */     // Label 28: @1350
     /* 1350 */     GIM_Try, /*On fail goto*//*Label 29*/ GIMT_Encode4(1408), // Rule ID 50 //
     /* 1355 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1359 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1363 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 1367 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1371 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1375 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1380 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1385 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1389 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1391 */       // (assigntype:{ *:[i64] } (or:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpBitwiseOrS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1391 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpBitwiseOrS),
     /* 1394 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1396 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1398 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1402 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1406 */       GIR_RootConstrainSelectedInstOperands,
     /* 1407 */       // GIR_Coverage, 50,
     /* 1407 */       GIR_EraseRootFromParent_Done,
     /* 1408 */     // Label 29: @1408
     /* 1408 */     GIM_Try, /*On fail goto*//*Label 30*/ GIMT_Encode4(1466), // Rule ID 26 //
     /* 1413 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1417 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1421 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SDIV),
     /* 1425 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1429 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1433 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1438 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1443 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1447 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449 */       // (assigntype:{ *:[i64] } (sdiv:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSDivS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1449 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSDivS),
     /* 1452 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1454 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1456 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1460 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1464 */       GIR_RootConstrainSelectedInstOperands,
     /* 1465 */       // GIR_Coverage, 26,
     /* 1465 */       GIR_EraseRootFromParent_Done,
     /* 1466 */     // Label 30: @1466
     /* 1466 */     GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(1524), // Rule ID 48 //
     /* 1471 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1475 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1479 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 1483 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1487 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1491 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1496 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1501 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1505 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1507 */       // (assigntype:{ *:[i64] } (shl:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpShiftLeftLogicalS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1507 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpShiftLeftLogicalS),
     /* 1510 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1512 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1514 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1518 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1522 */       GIR_RootConstrainSelectedInstOperands,
     /* 1523 */       // GIR_Coverage, 48,
     /* 1523 */       GIR_EraseRootFromParent_Done,
     /* 1524 */     // Label 31: @1524
     /* 1524 */     GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(1582), // Rule ID 34 //
     /* 1529 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1533 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1537 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SREM),
     /* 1541 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1545 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1549 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1554 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1559 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1563 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1565 */       // (assigntype:{ *:[i64] } (srem:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSRemS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1565 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSRemS),
     /* 1568 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1570 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1572 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1576 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1580 */       GIR_RootConstrainSelectedInstOperands,
     /* 1581 */       // GIR_Coverage, 34,
     /* 1581 */       GIR_EraseRootFromParent_Done,
     /* 1582 */     // Label 32: @1582
     /* 1582 */     GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(1640), // Rule ID 10 //
     /* 1587 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1591 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1595 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FADD),
     /* 1599 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1603 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1607 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1612 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1617 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1621 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1623 */       // (assigntype:{ *:[f64] } (strict_fadd:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFAddS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1623 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFAddS),
     /* 1626 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1628 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1630 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1634 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1638 */       GIR_RootConstrainSelectedInstOperands,
     /* 1639 */       // GIR_Coverage, 10,
     /* 1639 */       GIR_EraseRootFromParent_Done,
     /* 1640 */     // Label 33: @1640
     /* 1640 */     GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(1698), // Rule ID 30 //
     /* 1645 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1649 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1653 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FDIV),
     /* 1657 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1661 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1665 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1670 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1675 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1679 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1681 */       // (assigntype:{ *:[f64] } (strict_fdiv:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFDivS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1681 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFDivS),
     /* 1684 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1686 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1688 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1692 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1696 */       GIR_RootConstrainSelectedInstOperands,
     /* 1697 */       // GIR_Coverage, 30,
     /* 1697 */       GIR_EraseRootFromParent_Done,
     /* 1698 */     // Label 34: @1698
     /* 1698 */     GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(1756), // Rule ID 22 //
     /* 1703 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1707 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1711 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 1715 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1719 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1723 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1728 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1733 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1737 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1739 */       // (assigntype:{ *:[f64] } (strict_fmul:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFMulS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1739 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFMulS),
     /* 1742 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1744 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1746 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1750 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1754 */       GIR_RootConstrainSelectedInstOperands,
     /* 1755 */       // GIR_Coverage, 22,
     /* 1755 */       GIR_EraseRootFromParent_Done,
     /* 1756 */     // Label 35: @1756
     /* 1756 */     GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(1814), // Rule ID 38 //
     /* 1761 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1765 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1769 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FREM),
     /* 1773 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1777 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1781 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1786 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1791 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1795 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1797 */       // (assigntype:{ *:[f64] } (strict_frem:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFRemS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1797 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFRemS),
     /* 1800 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1802 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1804 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1808 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1812 */       GIR_RootConstrainSelectedInstOperands,
     /* 1813 */       // GIR_Coverage, 38,
     /* 1813 */       GIR_EraseRootFromParent_Done,
     /* 1814 */     // Label 36: @1814
     /* 1814 */     GIM_Try, /*On fail goto*//*Label 37*/ GIMT_Encode4(1872), // Rule ID 16 //
     /* 1819 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1823 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1827 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FSUB),
     /* 1831 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1835 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1839 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1844 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 1849 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1853 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1855 */       // (assigntype:{ *:[f64] } (strict_fsub:{ *:[f64] } fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFSubS:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src, fID:{ *:[f64] }:$src2)
     /* 1855 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFSubS),
     /* 1858 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1860 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1862 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1866 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1870 */       GIR_RootConstrainSelectedInstOperands,
     /* 1871 */       // GIR_Coverage, 16,
     /* 1871 */       GIR_EraseRootFromParent_Done,
     /* 1872 */     // Label 37: @1872
     /* 1872 */     GIM_Try, /*On fail goto*//*Label 38*/ GIMT_Encode4(1930), // Rule ID 12 //
     /* 1877 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1889 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1893 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1897 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1902 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1907 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1911 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913 */       // (assigntype:{ *:[i64] } (sub:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpISubS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpISubS),
     /* 1916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1918 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1920 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1924 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1928 */       GIR_RootConstrainSelectedInstOperands,
     /* 1929 */       // GIR_Coverage, 12,
     /* 1929 */       GIR_EraseRootFromParent_Done,
     /* 1930 */     // Label 38: @1930
     /* 1930 */     GIM_Try, /*On fail goto*//*Label 39*/ GIMT_Encode4(1988), // Rule ID 24 //
     /* 1935 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1939 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1943 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UDIV),
     /* 1947 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 1951 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 1955 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1960 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1965 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 1969 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1971 */       // (assigntype:{ *:[i64] } (udiv:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpUDivS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 1971 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpUDivS),
     /* 1974 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1976 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 1978 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 1982 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 1986 */       GIR_RootConstrainSelectedInstOperands,
     /* 1987 */       // GIR_Coverage, 24,
     /* 1987 */       GIR_EraseRootFromParent_Done,
     /* 1988 */     // Label 39: @1988
     /* 1988 */     GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(2046), // Rule ID 32 //
     /* 1993 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 1997 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2001 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UREM),
     /* 2005 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2009 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2013 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2018 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2023 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2027 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029 */       // (assigntype:{ *:[i64] } (urem:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpUModS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 2029 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpUModS),
     /* 2032 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2034 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2036 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2040 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2044 */       GIR_RootConstrainSelectedInstOperands,
     /* 2045 */       // GIR_Coverage, 32,
     /* 2045 */       GIR_EraseRootFromParent_Done,
     /* 2046 */     // Label 40: @2046
     /* 2046 */     GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(2104), // Rule ID 52 //
     /* 2051 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2055 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2059 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2063 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2067 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2071 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2076 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2081 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2085 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2087 */       // (assigntype:{ *:[i64] } (xor:{ *:[i64] } iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpBitwiseXorS:{ *:[i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$src, iID:{ *:[i64] }:$src2)
     /* 2087 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpBitwiseXorS),
     /* 2090 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2092 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2094 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2098 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2102 */       GIR_RootConstrainSelectedInstOperands,
     /* 2103 */       // GIR_Coverage, 52,
     /* 2103 */       GIR_EraseRootFromParent_Done,
     /* 2104 */     // Label 41: @2104
     /* 2104 */     GIM_Try, /*On fail goto*//*Label 42*/ GIMT_Encode4(2149), // Rule ID 4 //
     /* 2109 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 2113 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2117 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2121 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2125 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::fIDRegClassID),
     /* 2130 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2134 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2136 */       // (assigntype:{ *:[f64] } (fneg:{ *:[f64] } fID:{ *:[f64] }:$src), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFNegate:{ *:[f64] } TYPE:{ *:[i64] }:$src_ty, fID:{ *:[f64] }:$src)
     /* 2136 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFNegate),
     /* 2139 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2141 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2143 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2147 */       GIR_RootConstrainSelectedInstOperands,
     /* 2148 */       // GIR_Coverage, 4,
     /* 2148 */       GIR_EraseRootFromParent_Done,
     /* 2149 */     // Label 42: @2149
     /* 2149 */     GIM_Reject,
     /* 2150 */   // Label 8: @2150
     /* 2150 */   GIM_Reject,
     /* 2151 */   // Label 3: @2151
     /* 2151 */   GIM_Try, /*On fail goto*//*Label 43*/ GIMT_Encode4(3826),
     /* 2156 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2162 */     GIM_Try, /*On fail goto*//*Label 44*/ GIMT_Encode4(2233), // Rule ID 64 //
     /* 2167 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2171 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2175 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 2179 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2183 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2187 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 2191 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2196 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2201 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2206 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2210 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2212 */       // (assigntype:{ *:[v2i64] } (select:{ *:[v2i64] } iID:{ *:[i64] }:$cond, vID:{ *:[v2i64] }:$src1, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectVISCond:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$cond, vID:{ *:[v2i64] }:$src1, vID:{ *:[v2i64] }:$src2)
     /* 2212 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectVISCond),
     /* 2215 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2217 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2219 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /* 2223 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 2227 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 2231 */       GIR_RootConstrainSelectedInstOperands,
     /* 2232 */       // GIR_Coverage, 64,
     /* 2232 */       GIR_EraseRootFromParent_Done,
     /* 2233 */     // Label 44: @2233
     /* 2233 */     GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(2304), // Rule ID 65 //
     /* 2238 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2242 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2246 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 2250 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2254 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2258 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 2262 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2267 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2272 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2277 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2281 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2283 */       // (assigntype:{ *:[v2i64] } (select:{ *:[v2i64] } vID:{ *:[v2i64] }:$cond, vID:{ *:[v2i64] }:$src1, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectVIVCond:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$cond, vID:{ *:[v2i64] }:$src1, vID:{ *:[v2i64] }:$src2)
     /* 2283 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectVIVCond),
     /* 2286 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2288 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2290 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /* 2294 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 2298 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 2302 */       GIR_RootConstrainSelectedInstOperands,
     /* 2303 */       // GIR_Coverage, 65,
     /* 2303 */       GIR_EraseRootFromParent_Done,
     /* 2304 */     // Label 45: @2304
     /* 2304 */     GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(2375), // Rule ID 66 //
     /* 2309 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2313 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 2321 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2329 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 2333 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::iIDRegClassID),
     /* 2338 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2343 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2348 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2352 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354 */       // (assigntype:{ *:[v2f64] } (select:{ *:[v2f64] } iID:{ *:[i64] }:$cond, vfID:{ *:[v2f64] }:$src1, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectVFSCond:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, iID:{ *:[i64] }:$cond, vfID:{ *:[v2f64] }:$src1, vfID:{ *:[v2f64] }:$src2)
     /* 2354 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectVFSCond),
     /* 2357 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2359 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2361 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /* 2365 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 2369 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 2373 */       GIR_RootConstrainSelectedInstOperands,
     /* 2374 */       // GIR_Coverage, 66,
     /* 2374 */       GIR_EraseRootFromParent_Done,
     /* 2375 */     // Label 46: @2375
     /* 2375 */     GIM_Try, /*On fail goto*//*Label 47*/ GIMT_Encode4(2446), // Rule ID 67 //
     /* 2380 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2384 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 2392 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2396 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2400 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 2404 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2409 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2414 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2419 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2423 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425 */       // (assigntype:{ *:[v2f64] } (select:{ *:[v2f64] } vID:{ *:[v2i64] }:$cond, vfID:{ *:[v2f64] }:$src1, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSelectVFVCond:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$cond, vfID:{ *:[v2f64] }:$src1, vfID:{ *:[v2f64] }:$src2)
     /* 2425 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSelectVFVCond),
     /* 2428 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2430 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2432 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // cond
     /* 2436 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 2440 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 2444 */       GIR_RootConstrainSelectedInstOperands,
     /* 2445 */       // GIR_Coverage, 67,
     /* 2445 */       GIR_EraseRootFromParent_Done,
     /* 2446 */     // Label 47: @2446
     /* 2446 */     GIM_Try, /*On fail goto*//*Label 48*/ GIMT_Encode4(2504), // Rule ID 7 //
     /* 2451 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2455 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2459 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 2463 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2467 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2471 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2476 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2481 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2485 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2487 */       // (assigntype:{ *:[v2i64] } (add:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpIAddV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 2487 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpIAddV),
     /* 2490 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2492 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2494 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2498 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2502 */       GIR_RootConstrainSelectedInstOperands,
     /* 2503 */       // GIR_Coverage, 7,
     /* 2503 */       GIR_EraseRootFromParent_Done,
     /* 2504 */     // Label 48: @2504
     /* 2504 */     GIM_Try, /*On fail goto*//*Label 49*/ GIMT_Encode4(2562), // Rule ID 55 //
     /* 2509 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2513 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2517 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2521 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2525 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2529 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2534 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2539 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2543 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2545 */       // (assigntype:{ *:[v2i64] } (and:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpBitwiseAndV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 2545 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpBitwiseAndV),
     /* 2548 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2550 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2552 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2556 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2560 */       GIR_RootConstrainSelectedInstOperands,
     /* 2561 */       // GIR_Coverage, 55,
     /* 2561 */       GIR_EraseRootFromParent_Done,
     /* 2562 */     // Label 49: @2562
     /* 2562 */     GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(2620), // Rule ID 47 //
     /* 2567 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2571 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2575 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 2579 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2583 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2587 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2592 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2597 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2601 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2603 */       // (assigntype:{ *:[v2i64] } (sra:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpShiftRightArithmeticV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 2603 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpShiftRightArithmeticV),
     /* 2606 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2608 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2610 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2614 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2618 */       GIR_RootConstrainSelectedInstOperands,
     /* 2619 */       // GIR_Coverage, 47,
     /* 2619 */       GIR_EraseRootFromParent_Done,
     /* 2620 */     // Label 50: @2620
     /* 2620 */     GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(2678), // Rule ID 9 //
     /* 2625 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2629 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2633 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 2637 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2641 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2645 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2650 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2655 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2659 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2661 */       // (assigntype:{ *:[v2f64] } (fadd:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFAddV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 2661 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFAddV),
     /* 2664 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2666 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2668 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2672 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2676 */       GIR_RootConstrainSelectedInstOperands,
     /* 2677 */       // GIR_Coverage, 9,
     /* 2677 */       GIR_EraseRootFromParent_Done,
     /* 2678 */     // Label 51: @2678
     /* 2678 */     GIM_Try, /*On fail goto*//*Label 52*/ GIMT_Encode4(2736), // Rule ID 29 //
     /* 2683 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2687 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2691 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FDIV),
     /* 2695 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2699 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2703 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2708 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2713 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2717 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2719 */       // (assigntype:{ *:[v2f64] } (fdiv:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFDivV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 2719 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFDivV),
     /* 2722 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2724 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2726 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2730 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2734 */       GIR_RootConstrainSelectedInstOperands,
     /* 2735 */       // GIR_Coverage, 29,
     /* 2735 */       GIR_EraseRootFromParent_Done,
     /* 2736 */     // Label 52: @2736
     /* 2736 */     GIM_Try, /*On fail goto*//*Label 53*/ GIMT_Encode4(2794), // Rule ID 21 //
     /* 2741 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2745 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2749 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 2753 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2757 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2761 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2766 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2771 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2775 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2777 */       // (assigntype:{ *:[v2f64] } (fmul:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFMulV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 2777 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFMulV),
     /* 2780 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2782 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2784 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2788 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2792 */       GIR_RootConstrainSelectedInstOperands,
     /* 2793 */       // GIR_Coverage, 21,
     /* 2793 */       GIR_EraseRootFromParent_Done,
     /* 2794 */     // Label 53: @2794
     /* 2794 */     GIM_Try, /*On fail goto*//*Label 54*/ GIMT_Encode4(2852), // Rule ID 37 //
     /* 2799 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2803 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2807 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREM),
     /* 2811 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2815 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2819 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2824 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2829 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2833 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2835 */       // (assigntype:{ *:[v2f64] } (frem:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFRemV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 2835 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFRemV),
     /* 2838 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2840 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2842 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2846 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2850 */       GIR_RootConstrainSelectedInstOperands,
     /* 2851 */       // GIR_Coverage, 37,
     /* 2851 */       GIR_EraseRootFromParent_Done,
     /* 2852 */     // Label 54: @2852
     /* 2852 */     GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(2910), // Rule ID 15 //
     /* 2857 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2861 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2865 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 2869 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2873 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2877 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2882 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 2887 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2891 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2893 */       // (assigntype:{ *:[v2f64] } (fsub:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFSubV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 2893 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFSubV),
     /* 2896 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2898 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2900 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2904 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2908 */       GIR_RootConstrainSelectedInstOperands,
     /* 2909 */       // GIR_Coverage, 15,
     /* 2909 */       GIR_EraseRootFromParent_Done,
     /* 2910 */     // Label 55: @2910
     /* 2910 */     GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(2968), // Rule ID 45 //
     /* 2915 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2919 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2923 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2927 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2931 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2935 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2940 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2945 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 2949 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2951 */       // (assigntype:{ *:[v2i64] } (srl:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpShiftRightLogicalV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 2951 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpShiftRightLogicalV),
     /* 2954 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2956 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 2958 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2962 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 2966 */       GIR_RootConstrainSelectedInstOperands,
     /* 2967 */       // GIR_Coverage, 45,
     /* 2967 */       GIR_EraseRootFromParent_Done,
     /* 2968 */     // Label 56: @2968
     /* 2968 */     GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(3026), // Rule ID 19 //
     /* 2973 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2977 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2981 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 2985 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 2989 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 2993 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 2998 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3003 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3007 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3009 */       // (assigntype:{ *:[v2i64] } (mul:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpIMulV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3009 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpIMulV),
     /* 3012 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3014 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3016 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3020 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3024 */       GIR_RootConstrainSelectedInstOperands,
     /* 3025 */       // GIR_Coverage, 19,
     /* 3025 */       GIR_EraseRootFromParent_Done,
     /* 3026 */     // Label 57: @3026
     /* 3026 */     GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(3084), // Rule ID 51 //
     /* 3031 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3035 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3039 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3043 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3047 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3051 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3056 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3061 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3065 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3067 */       // (assigntype:{ *:[v2i64] } (or:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpBitwiseOrV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3067 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpBitwiseOrV),
     /* 3070 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3072 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3074 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3078 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3082 */       GIR_RootConstrainSelectedInstOperands,
     /* 3083 */       // GIR_Coverage, 51,
     /* 3083 */       GIR_EraseRootFromParent_Done,
     /* 3084 */     // Label 58: @3084
     /* 3084 */     GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(3142), // Rule ID 27 //
     /* 3089 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3093 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3097 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SDIV),
     /* 3101 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3105 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3109 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3114 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3119 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3123 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3125 */       // (assigntype:{ *:[v2i64] } (sdiv:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSDivV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSDivV),
     /* 3128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3130 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3132 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3136 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3140 */       GIR_RootConstrainSelectedInstOperands,
     /* 3141 */       // GIR_Coverage, 27,
     /* 3141 */       GIR_EraseRootFromParent_Done,
     /* 3142 */     // Label 59: @3142
     /* 3142 */     GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(3200), // Rule ID 49 //
     /* 3147 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3151 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3155 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 3159 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3163 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3167 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3172 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3177 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3181 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3183 */       // (assigntype:{ *:[v2i64] } (shl:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpShiftLeftLogicalV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3183 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpShiftLeftLogicalV),
     /* 3186 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3188 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3198 */       GIR_RootConstrainSelectedInstOperands,
     /* 3199 */       // GIR_Coverage, 49,
     /* 3199 */       GIR_EraseRootFromParent_Done,
     /* 3200 */     // Label 60: @3200
     /* 3200 */     GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(3258), // Rule ID 35 //
     /* 3205 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3209 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3213 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SREM),
     /* 3217 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3221 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3225 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3230 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3235 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3239 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3241 */       // (assigntype:{ *:[v2i64] } (srem:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpSRemV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3241 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpSRemV),
     /* 3244 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3246 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3248 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3252 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3256 */       GIR_RootConstrainSelectedInstOperands,
     /* 3257 */       // GIR_Coverage, 35,
     /* 3257 */       GIR_EraseRootFromParent_Done,
     /* 3258 */     // Label 61: @3258
     /* 3258 */     GIM_Try, /*On fail goto*//*Label 62*/ GIMT_Encode4(3316), // Rule ID 11 //
     /* 3263 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3267 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3271 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FADD),
     /* 3275 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3279 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3283 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3288 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3293 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3297 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3299 */       // (assigntype:{ *:[v2f64] } (strict_fadd:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFAddV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 3299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFAddV),
     /* 3302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3304 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3306 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3310 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3314 */       GIR_RootConstrainSelectedInstOperands,
     /* 3315 */       // GIR_Coverage, 11,
     /* 3315 */       GIR_EraseRootFromParent_Done,
     /* 3316 */     // Label 62: @3316
     /* 3316 */     GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(3374), // Rule ID 31 //
     /* 3321 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3325 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3329 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FDIV),
     /* 3333 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3337 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3341 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3346 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3351 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3355 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3357 */       // (assigntype:{ *:[v2f64] } (strict_fdiv:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFDivV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 3357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFDivV),
     /* 3360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3362 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3364 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3368 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3372 */       GIR_RootConstrainSelectedInstOperands,
     /* 3373 */       // GIR_Coverage, 31,
     /* 3373 */       GIR_EraseRootFromParent_Done,
     /* 3374 */     // Label 63: @3374
     /* 3374 */     GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(3432), // Rule ID 23 //
     /* 3379 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3383 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3387 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 3391 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3395 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3399 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3404 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3409 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3413 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3415 */       // (assigntype:{ *:[v2f64] } (strict_fmul:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFMulV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 3415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFMulV),
     /* 3418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3420 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3422 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3426 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3430 */       GIR_RootConstrainSelectedInstOperands,
     /* 3431 */       // GIR_Coverage, 23,
     /* 3431 */       GIR_EraseRootFromParent_Done,
     /* 3432 */     // Label 64: @3432
     /* 3432 */     GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(3490), // Rule ID 39 //
     /* 3437 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3441 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3445 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FREM),
     /* 3449 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3453 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3457 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3462 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3467 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3471 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3473 */       // (assigntype:{ *:[v2f64] } (strict_frem:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFRemV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 3473 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFRemV),
     /* 3476 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3478 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3480 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3484 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3488 */       GIR_RootConstrainSelectedInstOperands,
     /* 3489 */       // GIR_Coverage, 39,
     /* 3489 */       GIR_EraseRootFromParent_Done,
     /* 3490 */     // Label 65: @3490
     /* 3490 */     GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(3548), // Rule ID 17 //
     /* 3495 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3499 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3503 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FSUB),
     /* 3507 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3511 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3515 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3520 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3525 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3529 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3531 */       // (assigntype:{ *:[v2f64] } (strict_fsub:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpStrictFSubV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src, vfID:{ *:[v2f64] }:$src2)
     /* 3531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpStrictFSubV),
     /* 3534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3536 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3538 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3542 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3546 */       GIR_RootConstrainSelectedInstOperands,
     /* 3547 */       // GIR_Coverage, 17,
     /* 3547 */       GIR_EraseRootFromParent_Done,
     /* 3548 */     // Label 66: @3548
     /* 3548 */     GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(3606), // Rule ID 13 //
     /* 3553 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3557 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3561 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3565 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3569 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3573 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3578 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3583 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3587 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3589 */       // (assigntype:{ *:[v2i64] } (sub:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpISubV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3589 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpISubV),
     /* 3592 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3594 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3596 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3600 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3604 */       GIR_RootConstrainSelectedInstOperands,
     /* 3605 */       // GIR_Coverage, 13,
     /* 3605 */       GIR_EraseRootFromParent_Done,
     /* 3606 */     // Label 67: @3606
     /* 3606 */     GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(3664), // Rule ID 25 //
     /* 3611 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3615 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3619 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UDIV),
     /* 3623 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3627 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3631 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3636 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3641 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3645 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3647 */       // (assigntype:{ *:[v2i64] } (udiv:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpUDivV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3647 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpUDivV),
     /* 3650 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3652 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3654 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3658 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3662 */       GIR_RootConstrainSelectedInstOperands,
     /* 3663 */       // GIR_Coverage, 25,
     /* 3663 */       GIR_EraseRootFromParent_Done,
     /* 3664 */     // Label 68: @3664
     /* 3664 */     GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(3722), // Rule ID 33 //
     /* 3669 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3673 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3677 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UREM),
     /* 3681 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3685 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3689 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3694 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3699 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3703 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3705 */       // (assigntype:{ *:[v2i64] } (urem:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpUModV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3705 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpUModV),
     /* 3708 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3710 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3716 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3720 */       GIR_RootConstrainSelectedInstOperands,
     /* 3721 */       // GIR_Coverage, 33,
     /* 3721 */       GIR_EraseRootFromParent_Done,
     /* 3722 */     // Label 69: @3722
     /* 3722 */     GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(3780), // Rule ID 53 //
     /* 3727 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3731 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3735 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3739 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3743 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 3747 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3752 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::vIDRegClassID),
     /* 3757 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3761 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3763 */       // (assigntype:{ *:[v2i64] } (xor:{ *:[v2i64] } vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2), TYPE:{ *:[i64] }:$src_ty)  =>  (OpBitwiseXorV:{ *:[v2i64] } TYPE:{ *:[i64] }:$src_ty, vID:{ *:[v2i64] }:$src, vID:{ *:[v2i64] }:$src2)
     /* 3763 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpBitwiseXorV),
     /* 3766 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3768 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3770 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3774 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 3778 */       GIR_RootConstrainSelectedInstOperands,
     /* 3779 */       // GIR_Coverage, 53,
     /* 3779 */       GIR_EraseRootFromParent_Done,
     /* 3780 */     // Label 70: @3780
     /* 3780 */     GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(3825), // Rule ID 5 //
     /* 3785 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3789 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3793 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3797 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 3801 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(SPIRV::vfIDRegClassID),
     /* 3806 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(SPIRV::TYPERegClassID),
     /* 3810 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3812 */       // (assigntype:{ *:[v2f64] } (fneg:{ *:[v2f64] } vfID:{ *:[v2f64] }:$src), TYPE:{ *:[i64] }:$src_ty)  =>  (OpFNegateV:{ *:[v2f64] } TYPE:{ *:[i64] }:$src_ty, vfID:{ *:[v2f64] }:$src)
     /* 3812 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(SPIRV::OpFNegateV),
     /* 3815 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 3817 */       GIR_RootToRootCopy, /*OpIdx*/2, // src_ty
     /* 3819 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 3823 */       GIR_RootConstrainSelectedInstOperands,
     /* 3824 */       // GIR_Coverage, 5,
     /* 3824 */       GIR_EraseRootFromParent_Done,
     /* 3825 */     // Label 71: @3825
     /* 3825 */     GIM_Reject,
     /* 3826 */   // Label 43: @3826
     /* 3826 */   GIM_Reject,
     /* 3827 */   // Label 4: @3827
     /* 3827 */   GIM_Reject,
     /* 3828 */ // Label 0: @3828
     /* 3828 */ GIM_Reject,
     /* 3829 */ }; // Size: 3829 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const SPIRVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const SPIRVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
