/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AMDGPUPostLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AMDGPUPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 7:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "smulu64", 7) != 0)
      break;
    return 222;	 // "smulu64"
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 191;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 142;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 141;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 196;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 190;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 194;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 195;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 210;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 185;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 129;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 204;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 143;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 187;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 173;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 130;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 125;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 171;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 172;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 159;	 // "commute_shift"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oldable_fneg", 12) != 0)
        break;
      return 218;	 // "foldable_fneg"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 122;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 203;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 123;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 169;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 202;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 205;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 17 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 157;	 // "bitreverse_shl"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "vt_f32_ubyteN", 13) != 0)
        break;
      return 216;	 // "cvt_f32_ubyteN"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 168;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "char_to_float", 13) != 0)
        break;
      return 215;	 // "uchar_to_float"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 158;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 150;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 140;	 // "overlapping_and"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cp_sqrt_to_rsq", 14) != 0)
        break;
      return 219;	 // "rcp_sqrt_to_rsq"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 127;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 186;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 119;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 166;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 151;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 147;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 121;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 148;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 126;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 144;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 133;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 132;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 145;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 98;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 55;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 116;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 139;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 164;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 135;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 134;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 101;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 209;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 120;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 192;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 175;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 208;	 // "merge_of_x_and_undef"
    case 'r':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 2 strings to match.
        if (RuleIdentifier[3] != 'u')
          break;
        switch (RuleIdentifier[4]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
            break;
          return 117;	 // "reduce_shl_of_extend"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
            break;
          return 124;	 // "redundant_sext_inreg"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ove_fcanonicalize", 17) != 0)
          break;
        return 217;	 // "remove_fcanonicalize"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 207;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 9 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 193;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 167;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 136;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_promoted_fmed3", 20) != 0)
        break;
      return 213;	 // "expand_promoted_fmed3"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ign_extension_in_reg", 20) != 0)
        break;
      return 221;	 // "sign_extension_in_reg"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 206;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 197;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 165;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 184;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 155;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 156;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 153;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 211;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 174;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_sqrt_to_rsq_f16", 21) != 0)
          break;
        return 220;	 // "fdiv_by_sqrt_to_rsq_f16"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_right_zero", 21) != 0)
          break;
        return 154;	 // "funnel_shift_right_zero"
      }
      break;
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 137;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 118;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 128;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 146;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 161;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 198;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 189;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 152;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 200;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 188;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 201;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 131;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 149;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 163;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 199;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_select_to_fmin_fmax_legacy", 30) != 0)
        break;
      return 212;	 // "fcmp_select_to_fmin_fmax_legacy"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_element_", 21) != 0)
        break;
      switch (RuleIdentifier[22]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
          break;
        return 22;	 // "insert_vector_element_elt_undef"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
          break;
        return 21;	 // "insert_vector_element_idx_undef"
      }
      break;
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 160;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 176;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 180;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fmul_with_select_to_fldexp", 33) != 0)
        break;
      return 214;	 // "combine_fmul_with_select_to_fldexp"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_all_elts_from_build_vector", 33) != 0)
        break;
      return 66;	 // "extract_all_elts_from_build_vector"
    }
    break;
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 178;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 181;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 177;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 182;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 183;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 223}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AMDGPUPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AMDGPUPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AMDGPUPostLegalizerCombinerOption;
static cl::list<std::string> AMDGPUPostLegalizerCombinerDisableOption(
    "amdgpupostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AMDGPUPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AMDGPUPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AMDGPUPostLegalizerCombinerOnlyEnableOption(
    "amdgpupostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AMDGPUPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AMDGPUPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AMDGPUPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AMDGPUPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AMDGPUPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AMDGPUPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_Has16BitInstsBit = 1,
  Feature_NotHasMed3_16Bit = 2,
  Feature_HasFminFmaxLegacyBit = 0,
};

PredicateBitset AMDGPUPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (!Subtarget->hasMed3_16())
    Features.set(Feature_NotHasMed3_16Bit);
  if (Subtarget->hasFminFmaxLegacy())
    Features.set(Feature_HasFminFmaxLegacyBit);
  return Features;
}

void AMDGPUPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasFminFmaxLegacy,
  GIFBS_Has16BitInsts_NotHasMed3_16,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasFminFmaxLegacyBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasMed3_16Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AMDGPUPostLegalizerCombinerImpl::ComplexMatcherMemFn
AMDGPUPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
};
bool AMDGPUPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
};

bool AMDGPUPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AMDGPUPostLegalizerCombinerImpl::CustomRendererFn
AMDGPUPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AMDGPUPostLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
  GICXXCustomAction_GICombiner158,
  GICXXCustomAction_GICombiner159,
  GICXXCustomAction_GICombiner160,
};
bool AMDGPUPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getKnownBits()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    FMinFMaxLegacyInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFMinFMaxLegacy(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applySelectFCmpToFMinFMaxLegacy(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    // Match Patterns
    if(![&](){return Helper.matchExpandPromotedF16FMed3(*State.MIs[0], State.MIs[1]->getOperand(1).getReg(), State.MIs[1]->getOperand(2).getReg(), State.MIs[1]->getOperand(3).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandPromotedF16FMed3(*State.MIs[0], State.MIs[1]->getOperand(1).getReg(), State.MIs[1]->getOperand(2).getReg(), State.MIs[1]->getOperand(3).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineFmulWithSelectToFldexp(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    // Match Patterns
    if(![&](){return matchUCharToFloat(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    applyUCharToFloat(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    CvtF32UByteMatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCvtF32UByteN(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCvtF32UByteN(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchRemoveFcanonicalize(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchRcpSqrtToRsq(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner158:{
    // Match Patterns
    if(![&](){return matchFDivSqrtToRsqF16(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    applyFDivSqrtToRsqF16(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner159:{
    std::pair<MachineInstr *, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombineSignExtendInReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCombineSignExtendInReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner160:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombine_s_mul_u64(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceOpcodeWith(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(3700), /*)*//*default:*//*Label 100*/ GIMT_Encode4(20953),
     /*    10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(14730), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(14742),
     /*   146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(15299),
     /*   150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(15574),
     /*   154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(15751),
     /*   158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(15824),
     /*   162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(15908),
     /*   166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(15953), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(16020),
     /*   182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(16301),
     /*   186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(16546), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(16647), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(16659), GIMT_Encode4(0),
     /*   234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(16726),
     /*   238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(16800),
     /*   242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(16848),
     /*   246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(16860),
     /*   250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(16872),
     /*   254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(16915),
     /*   258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(16948),
     /*   262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(16991), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(17055),
     /*   306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(17067),
     /*   310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(17079), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(17091), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   438 */ /*TargetOpcode::G_INTRINSIC*//*Label 25*/ GIMT_Encode4(17103), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   454 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(17115),
     /*   458 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(17243), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   478 */ /*TargetOpcode::G_SEXT*//*Label 28*/ GIMT_Encode4(17601),
     /*   482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 29*/ GIMT_Encode4(17682),
     /*   486 */ /*TargetOpcode::G_ZEXT*//*Label 30*/ GIMT_Encode4(17738),
     /*   490 */ /*TargetOpcode::G_SHL*//*Label 31*/ GIMT_Encode4(17868),
     /*   494 */ /*TargetOpcode::G_LSHR*//*Label 32*/ GIMT_Encode4(18037),
     /*   498 */ /*TargetOpcode::G_ASHR*//*Label 33*/ GIMT_Encode4(18160),
     /*   502 */ /*TargetOpcode::G_FSHL*//*Label 34*/ GIMT_Encode4(18294),
     /*   506 */ /*TargetOpcode::G_FSHR*//*Label 35*/ GIMT_Encode4(18337),
     /*   510 */ /*TargetOpcode::G_ROTR*//*Label 36*/ GIMT_Encode4(18380),
     /*   514 */ /*TargetOpcode::G_ROTL*//*Label 37*/ GIMT_Encode4(18404),
     /*   518 */ /*TargetOpcode::G_ICMP*//*Label 38*/ GIMT_Encode4(18428),
     /*   522 */ /*TargetOpcode::G_FCMP*//*Label 39*/ GIMT_Encode4(18473), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   534 */ /*TargetOpcode::G_SELECT*//*Label 40*/ GIMT_Encode4(18485),
     /*   538 */ /*TargetOpcode::G_UADDO*//*Label 41*/ GIMT_Encode4(18607),
     /*   542 */ /*TargetOpcode::G_UADDE*//*Label 42*/ GIMT_Encode4(18630),
     /*   546 */ /*TargetOpcode::G_USUBO*//*Label 43*/ GIMT_Encode4(18642),
     /*   550 */ /*TargetOpcode::G_USUBE*//*Label 44*/ GIMT_Encode4(18654),
     /*   554 */ /*TargetOpcode::G_SADDO*//*Label 45*/ GIMT_Encode4(18666),
     /*   558 */ /*TargetOpcode::G_SADDE*//*Label 46*/ GIMT_Encode4(18689),
     /*   562 */ /*TargetOpcode::G_SSUBO*//*Label 47*/ GIMT_Encode4(18701),
     /*   566 */ /*TargetOpcode::G_SSUBE*//*Label 48*/ GIMT_Encode4(18713),
     /*   570 */ /*TargetOpcode::G_UMULO*//*Label 49*/ GIMT_Encode4(18725),
     /*   574 */ /*TargetOpcode::G_SMULO*//*Label 50*/ GIMT_Encode4(18759),
     /*   578 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(18793),
     /*   582 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(18816),
     /*   586 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(18828),
     /*   590 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(18840), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   602 */ /*TargetOpcode::G_USHLSAT*//*Label 55*/ GIMT_Encode4(18852),
     /*   606 */ /*TargetOpcode::G_SSHLSAT*//*Label 56*/ GIMT_Encode4(18875),
     /*   610 */ /*TargetOpcode::G_SMULFIX*//*Label 57*/ GIMT_Encode4(18898),
     /*   614 */ /*TargetOpcode::G_UMULFIX*//*Label 58*/ GIMT_Encode4(18910),
     /*   618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 59*/ GIMT_Encode4(18922),
     /*   622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 60*/ GIMT_Encode4(18934), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   642 */ /*TargetOpcode::G_FADD*//*Label 61*/ GIMT_Encode4(18946),
     /*   646 */ /*TargetOpcode::G_FSUB*//*Label 62*/ GIMT_Encode4(19058),
     /*   650 */ /*TargetOpcode::G_FMUL*//*Label 63*/ GIMT_Encode4(19147),
     /*   654 */ /*TargetOpcode::G_FMA*//*Label 64*/ GIMT_Encode4(19256),
     /*   658 */ /*TargetOpcode::G_FMAD*//*Label 65*/ GIMT_Encode4(19279),
     /*   662 */ /*TargetOpcode::G_FDIV*//*Label 66*/ GIMT_Encode4(19302),
     /*   666 */ /*TargetOpcode::G_FREM*//*Label 67*/ GIMT_Encode4(19375), GIMT_Encode4(0),
     /*   674 */ /*TargetOpcode::G_FPOWI*//*Label 68*/ GIMT_Encode4(19387), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   694 */ /*TargetOpcode::G_FLOG2*//*Label 69*/ GIMT_Encode4(19409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   710 */ /*TargetOpcode::G_FNEG*//*Label 70*/ GIMT_Encode4(19431), GIMT_Encode4(0),
     /*   718 */ /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(19493),
     /*   722 */ /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(19560),
     /*   726 */ /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(19582),
     /*   730 */ /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(19604),
     /*   734 */ /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(19642), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   746 */ /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(19680), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 77*/ GIMT_Encode4(19759),
     /*   762 */ /*TargetOpcode::G_FMINNUM*//*Label 78*/ GIMT_Encode4(19800),
     /*   766 */ /*TargetOpcode::G_FMAXNUM*//*Label 79*/ GIMT_Encode4(19834),
     /*   770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 80*/ GIMT_Encode4(19868),
     /*   774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 81*/ GIMT_Encode4(19880),
     /*   778 */ /*TargetOpcode::G_FMINIMUM*//*Label 82*/ GIMT_Encode4(19892),
     /*   782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 83*/ GIMT_Encode4(19926), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   810 */ /*TargetOpcode::G_PTR_ADD*//*Label 84*/ GIMT_Encode4(19960), GIMT_Encode4(0),
     /*   818 */ /*TargetOpcode::G_SMIN*//*Label 85*/ GIMT_Encode4(20050),
     /*   822 */ /*TargetOpcode::G_SMAX*//*Label 86*/ GIMT_Encode4(20084),
     /*   826 */ /*TargetOpcode::G_UMIN*//*Label 87*/ GIMT_Encode4(20118),
     /*   830 */ /*TargetOpcode::G_UMAX*//*Label 88*/ GIMT_Encode4(20152),
     /*   834 */ /*TargetOpcode::G_ABS*//*Label 89*/ GIMT_Encode4(20186), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   846 */ /*TargetOpcode::G_BR*//*Label 90*/ GIMT_Encode4(20198), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(20210),
     /*   870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(20340),
     /*   874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 93*/ GIMT_Encode4(20717), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   914 */ /*TargetOpcode::G_BITREVERSE*//*Label 94*/ GIMT_Encode4(20783), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   966 */ /*TargetOpcode::G_FSQRT*//*Label 95*/ GIMT_Encode4(20872), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 14714 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 96*/ GIMT_Encode4(20905),
     /* 14718 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 97*/ GIMT_Encode4(20917),
     /* 14722 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 98*/ GIMT_Encode4(20929),
     /* 14726 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 99*/ GIMT_Encode4(20941),
     /* 14730 */ // Label 0: @14730
     /* 14730 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(14741), // Rule ID 13 //
     /* 14735 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 14738 */   // MIs[0] d
     /* 14738 */   // No operand predicates
     /* 14738 */   // MIs[0] s
     /* 14738 */   // No operand predicates
     /* 14738 */   // Combiner Rule #13: copy_prop
     /* 14738 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 14741 */ // Label 101: @14741
     /* 14741 */ GIM_Reject,
     /* 14742 */ // Label 1: @14742
     /* 14742 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(14753), // Rule ID 16 //
     /* 14747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 14750 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 14750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 14753 */ // Label 102: @14753
     /* 14753 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(14764), // Rule ID 93 //
     /* 14758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 14761 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 14761 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 14764 */ // Label 103: @14764
     /* 14764 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(14775), // Rule ID 140 //
     /* 14769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 14772 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 14772 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 14775 */ // Label 104: @14775
     /* 14775 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(14786), // Rule ID 229 //
     /* 14780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 14783 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 14783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 14786 */ // Label 105: @14786
     /* 14786 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(14797), // Rule ID 277 //
     /* 14791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 14794 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 14794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 14797 */ // Label 106: @14797
     /* 14797 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(14808), // Rule ID 306 //
     /* 14802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 14805 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 14805 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 14808 */ // Label 107: @14808
     /* 14808 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(14842), // Rule ID 0 //
     /* 14813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 14816 */   // MIs[0] root
     /* 14816 */   // No operand predicates
     /* 14816 */   // MIs[0] sub
     /* 14816 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14824 */   // MIs[1] Operand 1
     /* 14824 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 14828 */   // MIs[1] A
     /* 14828 */   // No operand predicates
     /* 14828 */   // MIs[0] B
     /* 14828 */   // No operand predicates
     /* 14828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14830 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 14830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14833 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 14835 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 14837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 14841 */   GIR_EraseRootFromParent_Done,
     /* 14842 */ // Label 108: @14842
     /* 14842 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(14879), // Rule ID 12 //
     /* 14847 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 14850 */   // MIs[0] root
     /* 14850 */   // No operand predicates
     /* 14850 */   // MIs[0] sub
     /* 14850 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14858 */   // MIs[1] A
     /* 14858 */   // No operand predicates
     /* 14858 */   // MIs[1] c1
     /* 14858 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14862 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14866 */   // MIs[2] imm1
     /* 14866 */   // No operand predicates
     /* 14866 */   // MIs[0] c2
     /* 14866 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 14870 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14874 */   // MIs[3] imm2
     /* 14874 */   // No operand predicates
     /* 14874 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 14876 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 14876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 14879 */ // Label 109: @14879
     /* 14879 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(14913), // Rule ID 3 //
     /* 14884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 14887 */   // MIs[0] root
     /* 14887 */   // No operand predicates
     /* 14887 */   // MIs[0] sub
     /* 14887 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14895 */   // MIs[1] B
     /* 14895 */   // No operand predicates
     /* 14895 */   // MIs[1] A
     /* 14895 */   // No operand predicates
     /* 14895 */   // MIs[0] A
     /* 14895 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14900 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14907 */   // Combiner Rule #3: BMinusAPlusA
     /* 14907 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14912 */   GIR_EraseRootFromParent_Done,
     /* 14913 */ // Label 110: @14913
     /* 14913 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(14947), // Rule ID 130 //
     /* 14918 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 14921 */   // MIs[0] dst
     /* 14921 */   // No operand predicates
     /* 14921 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 14921 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14929 */   // MIs[1] src
     /* 14929 */   // No operand predicates
     /* 14929 */   // MIs[1] __add_sub_reg_match_0.x
     /* 14929 */   // No operand predicates
     /* 14929 */   // MIs[0] __add_sub_reg_match_0.x
     /* 14929 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14934 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14941 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 14941 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14946 */   GIR_EraseRootFromParent_Done,
     /* 14947 */ // Label 111: @14947
     /* 14947 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(14992), // Rule ID 5 //
     /* 14952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 14955 */   // MIs[0] root
     /* 14955 */   // No operand predicates
     /* 14955 */   // MIs[0] sub1
     /* 14955 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14963 */   // MIs[1] A
     /* 14963 */   // No operand predicates
     /* 14963 */   // MIs[1] B
     /* 14963 */   // No operand predicates
     /* 14963 */   // MIs[0] sub2
     /* 14963 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14967 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14971 */   // MIs[2] B
     /* 14971 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14976 */   // MIs[2] C
     /* 14976 */   // No operand predicates
     /* 14976 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14978 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 14978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14981 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 14983 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 14987 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 14991 */   GIR_EraseRootFromParent_Done,
     /* 14992 */ // Label 112: @14992
     /* 14992 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(15037), // Rule ID 4 //
     /* 14997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 15000 */   // MIs[0] root
     /* 15000 */   // No operand predicates
     /* 15000 */   // MIs[0] sub1
     /* 15000 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15008 */   // MIs[1] A
     /* 15008 */   // No operand predicates
     /* 15008 */   // MIs[1] B
     /* 15008 */   // No operand predicates
     /* 15008 */   // MIs[0] sub2
     /* 15008 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15012 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15016 */   // MIs[2] C
     /* 15016 */   // No operand predicates
     /* 15016 */   // MIs[2] A
     /* 15016 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 15021 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15023 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 15023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15026 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 15032 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 15036 */   GIR_EraseRootFromParent_Done,
     /* 15037 */ // Label 113: @15037
     /* 15037 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(15072), // Rule ID 39 //
     /* 15042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 15045 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15051 */   // MIs[0] root
     /* 15051 */   // No operand predicates
     /* 15051 */   // MIs[0] left
     /* 15051 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15059 */   // MIs[1] imm1
     /* 15059 */   // No operand predicates
     /* 15059 */   // MIs[0] right
     /* 15059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15063 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15067 */   // MIs[2] imm2
     /* 15067 */   // No operand predicates
     /* 15067 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15069 */   // Combiner Rule #37: add_of_vscale
     /* 15069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 15072 */ // Label 114: @15072
     /* 15072 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(15106), // Rule ID 1 //
     /* 15077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 15080 */   // MIs[0] root
     /* 15080 */   // No operand predicates
     /* 15080 */   // MIs[0] A
     /* 15080 */   // No operand predicates
     /* 15080 */   // MIs[0] sub
     /* 15080 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15088 */   // MIs[1] Operand 1
     /* 15088 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 15092 */   // MIs[1] B
     /* 15092 */   // No operand predicates
     /* 15092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15094 */   // Combiner Rule #1: APlusZeroMinusB
     /* 15094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15097 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15099 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 15101 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 15105 */   GIR_EraseRootFromParent_Done,
     /* 15106 */ // Label 115: @15106
     /* 15106 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(15140), // Rule ID 2 //
     /* 15111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 15114 */   // MIs[0] root
     /* 15114 */   // No operand predicates
     /* 15114 */   // MIs[0] A
     /* 15114 */   // No operand predicates
     /* 15114 */   // MIs[0] sub
     /* 15114 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15122 */   // MIs[1] B
     /* 15122 */   // No operand predicates
     /* 15122 */   // MIs[1] A
     /* 15122 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15127 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15134 */   // Combiner Rule #2: APlusBMinusB
     /* 15134 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15139 */   GIR_EraseRootFromParent_Done,
     /* 15140 */ // Label 116: @15140
     /* 15140 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(15174), // Rule ID 129 //
     /* 15145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 15148 */   // MIs[0] dst
     /* 15148 */   // No operand predicates
     /* 15148 */   // MIs[0] __add_sub_reg_match_0.x
     /* 15148 */   // No operand predicates
     /* 15148 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 15148 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15156 */   // MIs[1] src
     /* 15156 */   // No operand predicates
     /* 15156 */   // MIs[1] __add_sub_reg_match_0.x
     /* 15156 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15161 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15166 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15168 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 15168 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15173 */   GIR_EraseRootFromParent_Done,
     /* 15174 */ // Label 117: @15174
     /* 15174 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(15219), // Rule ID 6 //
     /* 15179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 15182 */   // MIs[0] root
     /* 15182 */   // No operand predicates
     /* 15182 */   // MIs[0] A
     /* 15182 */   // No operand predicates
     /* 15182 */   // MIs[0] sub1
     /* 15182 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15190 */   // MIs[1] B
     /* 15190 */   // No operand predicates
     /* 15190 */   // MIs[1] add1
     /* 15190 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15194 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15198 */   // MIs[2] A
     /* 15198 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15203 */   // MIs[2] C
     /* 15203 */   // No operand predicates
     /* 15203 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15205 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 15205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15208 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15210 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 15214 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 15218 */   GIR_EraseRootFromParent_Done,
     /* 15219 */ // Label 118: @15219
     /* 15219 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(15264), // Rule ID 7 //
     /* 15224 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 15227 */   // MIs[0] root
     /* 15227 */   // No operand predicates
     /* 15227 */   // MIs[0] A
     /* 15227 */   // No operand predicates
     /* 15227 */   // MIs[0] sub1
     /* 15227 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15235 */   // MIs[1] B
     /* 15235 */   // No operand predicates
     /* 15235 */   // MIs[1] add1
     /* 15235 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15239 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15243 */   // MIs[2] C
     /* 15243 */   // No operand predicates
     /* 15243 */   // MIs[2] A
     /* 15243 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15248 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15250 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 15250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15253 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15255 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 15259 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 15263 */   GIR_EraseRootFromParent_Done,
     /* 15264 */ // Label 119: @15264
     /* 15264 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(15287), // Rule ID 104 //
     /* 15269 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 15272 */   // MIs[0] dst
     /* 15272 */   // No operand predicates
     /* 15272 */   // MIs[0] lhs
     /* 15272 */   // No operand predicates
     /* 15272 */   // MIs[0] Operand 2
     /* 15272 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15276 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15281 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 15281 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15286 */   GIR_EraseRootFromParent_Done,
     /* 15287 */ // Label 120: @15287
     /* 15287 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(15298), // Rule ID 148 //
     /* 15292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 15295 */   // MIs[0] root
     /* 15295 */   // No operand predicates
     /* 15295 */   // MIs[0] src1
     /* 15295 */   // No operand predicates
     /* 15295 */   // MIs[0] src2
     /* 15295 */   // No operand predicates
     /* 15295 */   // Combiner Rule #106: reassoc_comm_binops
     /* 15295 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 15298 */ // Label 121: @15298
     /* 15298 */ GIM_Reject,
     /* 15299 */ // Label 2: @15299
     /* 15299 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(15310), // Rule ID 94 //
     /* 15304 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 15307 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 15307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 15310 */ // Label 122: @15310
     /* 15310 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(15321), // Rule ID 237 //
     /* 15315 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15318 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 15318 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15321 */ // Label 123: @15321
     /* 15321 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(15332), // Rule ID 278 //
     /* 15326 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15329 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 15329 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15332 */ // Label 124: @15332
     /* 15332 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(15343), // Rule ID 303 //
     /* 15337 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 15340 */   // Combiner Rule #185: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 15340 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 15343 */ // Label 125: @15343
     /* 15343 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(15354), // Rule ID 337 //
     /* 15348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 15351 */   // Combiner Rule #192: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 15351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 15354 */ // Label 126: @15354
     /* 15354 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(15391), // Rule ID 8 //
     /* 15359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 15362 */   // MIs[0] root
     /* 15362 */   // No operand predicates
     /* 15362 */   // MIs[0] add
     /* 15362 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15370 */   // MIs[1] A
     /* 15370 */   // No operand predicates
     /* 15370 */   // MIs[1] c1
     /* 15370 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15374 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15378 */   // MIs[2] imm1
     /* 15378 */   // No operand predicates
     /* 15378 */   // MIs[0] c2
     /* 15378 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15382 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15386 */   // MIs[3] imm2
     /* 15386 */   // No operand predicates
     /* 15386 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15388 */   // Combiner Rule #8: APlusC1MinusC2
     /* 15388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 15391 */ // Label 127: @15391
     /* 15391 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(15428), // Rule ID 11 //
     /* 15396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 15399 */   // MIs[0] root
     /* 15399 */   // No operand predicates
     /* 15399 */   // MIs[0] sub1
     /* 15399 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15407 */   // MIs[1] c1
     /* 15407 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 15411 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15415 */   // MIs[2] imm1
     /* 15415 */   // No operand predicates
     /* 15415 */   // MIs[1] A
     /* 15415 */   // No operand predicates
     /* 15415 */   // MIs[0] c2
     /* 15415 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15419 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15423 */   // MIs[3] imm2
     /* 15423 */   // No operand predicates
     /* 15423 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15425 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 15425 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 15428 */ // Label 128: @15428
     /* 15428 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(15465), // Rule ID 10 //
     /* 15433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 15436 */   // MIs[0] root
     /* 15436 */   // No operand predicates
     /* 15436 */   // MIs[0] sub1
     /* 15436 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15444 */   // MIs[1] A
     /* 15444 */   // No operand predicates
     /* 15444 */   // MIs[1] c1
     /* 15444 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15448 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15452 */   // MIs[2] imm1
     /* 15452 */   // No operand predicates
     /* 15452 */   // MIs[0] c2
     /* 15452 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15456 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15460 */   // MIs[3] imm2
     /* 15460 */   // No operand predicates
     /* 15460 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15462 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 15462 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 15465 */ // Label 129: @15465
     /* 15465 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(15502), // Rule ID 9 //
     /* 15470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 15473 */   // MIs[0] root
     /* 15473 */   // No operand predicates
     /* 15473 */   // MIs[0] c2
     /* 15473 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15477 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15481 */   // MIs[1] imm2
     /* 15481 */   // No operand predicates
     /* 15481 */   // MIs[0] add
     /* 15481 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15485 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15489 */   // MIs[2] A
     /* 15489 */   // No operand predicates
     /* 15489 */   // MIs[2] c1
     /* 15489 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 15493 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15497 */   // MIs[3] imm1
     /* 15497 */   // No operand predicates
     /* 15497 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15499 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 15499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 15502 */ // Label 130: @15502
     /* 15502 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(15529), // Rule ID 42 //
     /* 15507 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 15510 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15516 */   // MIs[0] root
     /* 15516 */   // No operand predicates
     /* 15516 */   // MIs[0] x
     /* 15516 */   // No operand predicates
     /* 15516 */   // MIs[0] right
     /* 15516 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15524 */   // MIs[1] imm
     /* 15524 */   // No operand predicates
     /* 15524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15526 */   // Combiner Rule #40: sub_of_vscale
     /* 15526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 15529 */ // Label 131: @15529
     /* 15529 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(15552), // Rule ID 103 //
     /* 15534 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 15537 */   // MIs[0] dst
     /* 15537 */   // No operand predicates
     /* 15537 */   // MIs[0] lhs
     /* 15537 */   // No operand predicates
     /* 15537 */   // MIs[0] Operand 2
     /* 15537 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15541 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15546 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 15546 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15551 */   GIR_EraseRootFromParent_Done,
     /* 15552 */ // Label 132: @15552
     /* 15552 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(15573), // Rule ID 15 //
     /* 15557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 15560 */   // MIs[0] d
     /* 15560 */   // No operand predicates
     /* 15560 */   // MIs[0] op1
     /* 15560 */   // No operand predicates
     /* 15560 */   // MIs[0] c
     /* 15560 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15568 */   // MIs[1] imm
     /* 15568 */   // No operand predicates
     /* 15568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15570 */   // Combiner Rule #15: sub_to_add
     /* 15570 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 15573 */ // Label 133: @15573
     /* 15573 */ GIM_Reject,
     /* 15574 */ // Label 3: @15574
     /* 15574 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(15585), // Rule ID 77 //
     /* 15579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 15582 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 15582 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 15585 */ // Label 134: @15585
     /* 15585 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(15596), // Rule ID 234 //
     /* 15590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15593 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 15593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15596 */ // Label 135: @15596
     /* 15596 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(15607), // Rule ID 307 //
     /* 15601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 15604 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 15604 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 15607 */ // Label 136: @15607
     /* 15607 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(15618), // Rule ID 374 //
     /* 15612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 15615 */   // Combiner Rule #222: smulu64; wip_match_opcode 'G_MUL'
     /* 15615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner160),
     /* 15618 */ // Label 137: @15618
     /* 15618 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(15658), // Rule ID 17 //
     /* 15623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 15626 */   // MIs[0] dst
     /* 15626 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 15630 */   // MIs[0] x
     /* 15630 */   // No operand predicates
     /* 15630 */   // MIs[0] Operand 2
     /* 15630 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 15634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 15637 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 15647 */   // Combiner Rule #17: mul_by_neg_one
     /* 15647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15650 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 15652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15655 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 15657 */   GIR_EraseRootFromParent_Done,
     /* 15658 */ // Label 138: @15658
     /* 15658 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(15693), // Rule ID 40 //
     /* 15663 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 15666 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15672 */   // MIs[0] root
     /* 15672 */   // No operand predicates
     /* 15672 */   // MIs[0] left
     /* 15672 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15680 */   // MIs[1] scale
     /* 15680 */   // No operand predicates
     /* 15680 */   // MIs[0] x
     /* 15680 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15684 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15688 */   // MIs[2] imm1
     /* 15688 */   // No operand predicates
     /* 15688 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15690 */   // Combiner Rule #38: mul_of_vscale
     /* 15690 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 15693 */ // Label 139: @15693
     /* 15693 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(15716), // Rule ID 122 //
     /* 15698 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 15701 */   // MIs[0] dst
     /* 15701 */   // No operand predicates
     /* 15701 */   // MIs[0] lhs
     /* 15701 */   // No operand predicates
     /* 15701 */   // MIs[0] zero
     /* 15701 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15705 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 15710 */   // Combiner Rule #86: binop_right_to_zero
     /* 15710 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 15715 */   GIR_EraseRootFromParent_Done,
     /* 15716 */ // Label 140: @15716
     /* 15716 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(15739), // Rule ID 127 //
     /* 15721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 15724 */   // MIs[0] dst
     /* 15724 */   // No operand predicates
     /* 15724 */   // MIs[0] x
     /* 15724 */   // No operand predicates
     /* 15724 */   // MIs[0] Operand 2
     /* 15724 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 15728 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15733 */   // Combiner Rule #91: right_identity_one_int
     /* 15733 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15738 */   GIR_EraseRootFromParent_Done,
     /* 15739 */ // Label 141: @15739
     /* 15739 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(15750), // Rule ID 14 //
     /* 15744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 15747 */   // MIs[0] d
     /* 15747 */   // No operand predicates
     /* 15747 */   // MIs[0] op1
     /* 15747 */   // No operand predicates
     /* 15747 */   // MIs[0] op2
     /* 15747 */   // No operand predicates
     /* 15747 */   // Combiner Rule #14: mul_to_shl
     /* 15747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 15750 */ // Label 142: @15750
     /* 15750 */ GIM_Reject,
     /* 15751 */ // Label 4: @15751
     /* 15751 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(15762), // Rule ID 118 //
     /* 15756 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15759 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 15759 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15762 */ // Label 143: @15762
     /* 15762 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(15773), // Rule ID 209 //
     /* 15767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15770 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 15770 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15773 */ // Label 144: @15773
     /* 15773 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(15784), // Rule ID 240 //
     /* 15778 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15781 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 15781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15784 */ // Label 145: @15784
     /* 15784 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(15795), // Rule ID 258 //
     /* 15789 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 15792 */   // Combiner Rule #170: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 15792 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 15795 */ // Label 146: @15795
     /* 15795 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(15806), // Rule ID 283 //
     /* 15800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15803 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 15803 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15806 */ // Label 147: @15806
     /* 15806 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(15823), // Rule ID 259 //
     /* 15811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 15814 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 15820 */   // MIs[0] dst
     /* 15820 */   // No operand predicates
     /* 15820 */   // MIs[0] x
     /* 15820 */   // No operand predicates
     /* 15820 */   // MIs[0] y
     /* 15820 */   // No operand predicates
     /* 15820 */   // Combiner Rule #171: sdiv_by_pow2
     /* 15820 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 15823 */ // Label 148: @15823
     /* 15823 */ GIM_Reject,
     /* 15824 */ // Label 5: @15824
     /* 15824 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(15835), // Rule ID 80 //
     /* 15829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 15832 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 15832 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 15835 */ // Label 149: @15835
     /* 15835 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(15846), // Rule ID 119 //
     /* 15840 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15843 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 15843 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15846 */ // Label 150: @15846
     /* 15846 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(15857), // Rule ID 210 //
     /* 15851 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15854 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 15854 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15857 */ // Label 151: @15857
     /* 15857 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(15868), // Rule ID 239 //
     /* 15862 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15865 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 15865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15868 */ // Label 152: @15868
     /* 15868 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(15879), // Rule ID 257 //
     /* 15873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 15876 */   // Combiner Rule #169: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 15876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 15879 */ // Label 153: @15879
     /* 15879 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(15890), // Rule ID 285 //
     /* 15884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15887 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 15887 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15890 */ // Label 154: @15890
     /* 15890 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(15907), // Rule ID 260 //
     /* 15895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 15898 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 15904 */   // MIs[0] dst
     /* 15904 */   // No operand predicates
     /* 15904 */   // MIs[0] x
     /* 15904 */   // No operand predicates
     /* 15904 */   // MIs[0] y
     /* 15904 */   // No operand predicates
     /* 15904 */   // Combiner Rule #172: udiv_by_pow2
     /* 15904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 15907 */ // Label 155: @15907
     /* 15907 */ GIM_Reject,
     /* 15908 */ // Label 6: @15908
     /* 15908 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(15919), // Rule ID 120 //
     /* 15913 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15916 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 15916 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15919 */ // Label 156: @15919
     /* 15919 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(15930), // Rule ID 211 //
     /* 15924 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15927 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 15927 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15930 */ // Label 157: @15930
     /* 15930 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(15941), // Rule ID 242 //
     /* 15935 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15938 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 15938 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15941 */ // Label 158: @15941
     /* 15941 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(15952), // Rule ID 284 //
     /* 15946 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15949 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 15949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15952 */ // Label 159: @15952
     /* 15952 */ GIM_Reject,
     /* 15953 */ // Label 7: @15953
     /* 15953 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(15964), // Rule ID 81 //
     /* 15958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 15961 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 15961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 15964 */ // Label 160: @15964
     /* 15964 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(15975), // Rule ID 121 //
     /* 15969 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15972 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 15972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15975 */ // Label 161: @15975
     /* 15975 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(15986), // Rule ID 168 //
     /* 15980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 15983 */   // Combiner Rule #126: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 15983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 15986 */ // Label 162: @15986
     /* 15986 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(15997), // Rule ID 212 //
     /* 15991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15994 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 15994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15997 */ // Label 163: @15997
     /* 15997 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(16008), // Rule ID 241 //
     /* 16002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16005 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 16005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16008 */ // Label 164: @16008
     /* 16008 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(16019), // Rule ID 286 //
     /* 16013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16016 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 16016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16019 */ // Label 165: @16019
     /* 16019 */ GIM_Reject,
     /* 16020 */ // Label 8: @16020
     /* 16020 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(16031), // Rule ID 72 //
     /* 16025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 16028 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 16028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 16031 */ // Label 166: @16031
     /* 16031 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(16042), // Rule ID 76 //
     /* 16036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 16039 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 16039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 16042 */ // Label 167: @16042
     /* 16042 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(16053), // Rule ID 141 //
     /* 16047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 16050 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 16050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 16053 */ // Label 168: @16053
     /* 16053 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(16064), // Rule ID 160 //
     /* 16058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 16061 */   // Combiner Rule #118: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 16061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 16064 */ // Label 169: @16064
     /* 16064 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(16075), // Rule ID 165 //
     /* 16069 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 16072 */   // Combiner Rule #123: redundant_and; wip_match_opcode 'G_AND'
     /* 16072 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 16075 */ // Label 170: @16075
     /* 16075 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(16086), // Rule ID 182 //
     /* 16080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 16083 */   // Combiner Rule #140: overlapping_and; wip_match_opcode 'G_AND'
     /* 16083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 16086 */ // Label 171: @16086
     /* 16086 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(16097), // Rule ID 231 //
     /* 16091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16094 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 16094 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16097 */ // Label 172: @16097
     /* 16097 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(16108), // Rule ID 268 //
     /* 16102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 16105 */   // Combiner Rule #175: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 16105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 16108 */ // Label 173: @16108
     /* 16108 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(16119), // Rule ID 280 //
     /* 16113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16116 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 16116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16119 */ // Label 174: @16119
     /* 16119 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(16130), // Rule ID 308 //
     /* 16124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 16127 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 16127 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 16130 */ // Label 175: @16130
     /* 16130 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(16141), // Rule ID 335 //
     /* 16135 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 16138 */   // Combiner Rule #190: match_ands; wip_match_opcode 'G_AND'
     /* 16138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 16141 */ // Label 176: @16141
     /* 16141 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(16239), // Rule ID 154 //
     /* 16146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 16149 */   // MIs[0] root
     /* 16149 */   // No operand predicates
     /* 16149 */   // MIs[0] d1
     /* 16149 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16157 */   // MIs[1] p
     /* 16157 */   // No operand predicates
     /* 16157 */   // MIs[1] s1
     /* 16157 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 16161 */   // MIs[1] Operand 3
     /* 16161 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 16165 */   // MIs[0] d2
     /* 16165 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16169 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16173 */   // MIs[2] p
     /* 16173 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 16178 */   // MIs[2] s2
     /* 16178 */   // No operand predicates
     /* 16178 */   // MIs[2] Operand 3
     /* 16178 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 16182 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 16186 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 16191 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 16201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16204 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 16204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 16207 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16212 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 16216 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 16220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16224 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 16228 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 16232 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 16235 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16238 */   GIR_EraseRootFromParent_Done,
     /* 16239 */ // Label 177: @16239
     /* 16239 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(16276), // Rule ID 224 //
     /* 16244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 16247 */   // MIs[0] root
     /* 16247 */   // No operand predicates
     /* 16247 */   // MIs[0] shift
     /* 16247 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16251 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 16255 */   // MIs[1] x
     /* 16255 */   // No operand predicates
     /* 16255 */   // MIs[1] lsb
     /* 16255 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16259 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16263 */   // MIs[2] imm1
     /* 16263 */   // No operand predicates
     /* 16263 */   // MIs[0] mask
     /* 16263 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 16267 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16271 */   // MIs[3] imm2
     /* 16271 */   // No operand predicates
     /* 16271 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 16273 */   // Combiner Rule #161: bitfield_extract_from_and
     /* 16273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 16276 */ // Label 178: @16276
     /* 16276 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(16300), // Rule ID 113 //
     /* 16281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 16284 */   // MIs[0] dst
     /* 16284 */   // No operand predicates
     /* 16284 */   // MIs[0] src
     /* 16284 */   // No operand predicates
     /* 16284 */   // MIs[0] src
     /* 16284 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 16289 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16294 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 16294 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16299 */   GIR_EraseRootFromParent_Done,
     /* 16300 */ // Label 179: @16300
     /* 16300 */ GIM_Reject,
     /* 16301 */ // Label 9: @16301
     /* 16301 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(16312), // Rule ID 78 //
     /* 16306 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 16309 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 16309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 16312 */ // Label 180: @16312
     /* 16312 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(16323), // Rule ID 142 //
     /* 16317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 16320 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 16320 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 16323 */ // Label 181: @16323
     /* 16323 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(16334), // Rule ID 167 //
     /* 16328 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 16331 */   // Combiner Rule #125: redundant_or; wip_match_opcode 'G_OR'
     /* 16331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 16334 */ // Label 182: @16334
     /* 16334 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(16345), // Rule ID 208 //
     /* 16339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 16342 */   // Combiner Rule #150: load_or_combine; wip_match_opcode 'G_OR'
     /* 16342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 16345 */ // Label 183: @16345
     /* 16345 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(16356), // Rule ID 213 //
     /* 16350 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 16353 */   // Combiner Rule #152: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 16353 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 16356 */ // Label 184: @16356
     /* 16356 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(16367), // Rule ID 235 //
     /* 16361 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16364 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 16364 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16367 */ // Label 185: @16367
     /* 16367 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(16378), // Rule ID 281 //
     /* 16372 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16375 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 16375 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16378 */ // Label 186: @16378
     /* 16378 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(16389), // Rule ID 309 //
     /* 16383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 16386 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 16386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 16389 */ // Label 187: @16389
     /* 16389 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(16400), // Rule ID 336 //
     /* 16394 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 16397 */   // Combiner Rule #191: match_ors; wip_match_opcode 'G_OR'
     /* 16397 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 16400 */ // Label 188: @16400
     /* 16400 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(16498), // Rule ID 155 //
     /* 16405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 16408 */   // MIs[0] root
     /* 16408 */   // No operand predicates
     /* 16408 */   // MIs[0] d1
     /* 16408 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16416 */   // MIs[1] p
     /* 16416 */   // No operand predicates
     /* 16416 */   // MIs[1] s1
     /* 16416 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 16420 */   // MIs[1] Operand 3
     /* 16420 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 16424 */   // MIs[0] d2
     /* 16424 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16428 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16432 */   // MIs[2] p
     /* 16432 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 16437 */   // MIs[2] s2
     /* 16437 */   // No operand predicates
     /* 16437 */   // MIs[2] Operand 3
     /* 16437 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 16441 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 16445 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16447 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 16450 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 16460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16463 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 16463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 16466 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16471 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 16475 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 16479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 16487 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 16491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 16494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16497 */   GIR_EraseRootFromParent_Done,
     /* 16498 */ // Label 189: @16498
     /* 16498 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(16522), // Rule ID 114 //
     /* 16503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 16506 */   // MIs[0] dst
     /* 16506 */   // No operand predicates
     /* 16506 */   // MIs[0] src
     /* 16506 */   // No operand predicates
     /* 16506 */   // MIs[0] src
     /* 16506 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 16511 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16516 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 16516 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16521 */   GIR_EraseRootFromParent_Done,
     /* 16522 */ // Label 190: @16522
     /* 16522 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(16545), // Rule ID 105 //
     /* 16527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 16530 */   // MIs[0] dst
     /* 16530 */   // No operand predicates
     /* 16530 */   // MIs[0] lhs
     /* 16530 */   // No operand predicates
     /* 16530 */   // MIs[0] Operand 2
     /* 16530 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 16534 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16539 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 16539 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16544 */   GIR_EraseRootFromParent_Done,
     /* 16545 */ // Label 191: @16545
     /* 16545 */ GIM_Reject,
     /* 16546 */ // Label 10: @16546
     /* 16546 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(16557), // Rule ID 95 //
     /* 16551 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 16554 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 16554 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 16557 */ // Label 192: @16557
     /* 16557 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(16568), // Rule ID 143 //
     /* 16562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 16565 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 16565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 16568 */ // Label 193: @16568
     /* 16568 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(16579), // Rule ID 172 //
     /* 16573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 16576 */   // Combiner Rule #130: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 16576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 16579 */ // Label 194: @16579
     /* 16579 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(16590), // Rule ID 196 //
     /* 16584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 16587 */   // Combiner Rule #146: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 16587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 16590 */ // Label 195: @16590
     /* 16590 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(16601), // Rule ID 238 //
     /* 16595 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16598 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 16598 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16601 */ // Label 196: @16601
     /* 16601 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(16612), // Rule ID 282 //
     /* 16606 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16609 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 16609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16612 */ // Label 197: @16612
     /* 16612 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(16623), // Rule ID 310 //
     /* 16617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 16620 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 16620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 16623 */ // Label 198: @16623
     /* 16623 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(16646), // Rule ID 106 //
     /* 16628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 16631 */   // MIs[0] dst
     /* 16631 */   // No operand predicates
     /* 16631 */   // MIs[0] lhs
     /* 16631 */   // No operand predicates
     /* 16631 */   // MIs[0] Operand 2
     /* 16631 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 16635 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16640 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 16640 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16645 */   GIR_EraseRootFromParent_Done,
     /* 16646 */ // Label 199: @16646
     /* 16646 */ GIM_Reject,
     /* 16647 */ // Label 11: @16647
     /* 16647 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(16658), // Rule ID 139 //
     /* 16652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 16655 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 16655 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 16658 */ // Label 200: @16658
     /* 16658 */ GIM_Reject,
     /* 16659 */ // Label 12: @16659
     /* 16659 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(16670), // Rule ID 346 //
     /* 16664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 16667 */   // Combiner Rule #201: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16667 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 16670 */ // Label 201: @16670
     /* 16670 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(16681), // Rule ID 347 //
     /* 16675 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 16678 */   // Combiner Rule #202: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16678 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 16681 */ // Label 202: @16681
     /* 16681 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(16692), // Rule ID 349 //
     /* 16686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 16689 */   // Combiner Rule #204: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16689 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 16692 */ // Label 203: @16692
     /* 16692 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(16703), // Rule ID 350 //
     /* 16697 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 16700 */   // Combiner Rule #205: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16700 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 16703 */ // Label 204: @16703
     /* 16703 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(16714), // Rule ID 351 //
     /* 16708 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 16711 */   // Combiner Rule #206: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16711 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 16714 */ // Label 205: @16714
     /* 16714 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(16725), // Rule ID 352 //
     /* 16719 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 16722 */   // Combiner Rule #207: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16722 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 16725 */ // Label 206: @16725
     /* 16725 */ GIM_Reject,
     /* 16726 */ // Label 13: @16726
     /* 16726 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(16737), // Rule ID 348 //
     /* 16731 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 16734 */   // Combiner Rule #203: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 16734 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 16737 */ // Label 207: @16737
     /* 16737 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(16799),
     /* 16742 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 16745 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(16766), // Rule ID 353 //
     /* 16750 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 16753 */     // MIs[0] root
     /* 16753 */     // No operand predicates
     /* 16753 */     // MIs[0] x
     /* 16753 */     // No operand predicates
     /* 16753 */     // MIs[0] undef
     /* 16753 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 16757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16763 */     // Combiner Rule #208: merge_of_x_and_undef
     /* 16763 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 16766 */   // Label 209: @16766
     /* 16766 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(16798), // Rule ID 354 //
     /* 16771 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 16774 */     // MIs[0] root
     /* 16774 */     // No operand predicates
     /* 16774 */     // MIs[0] x
     /* 16774 */     // No operand predicates
     /* 16774 */     // MIs[0] zero
     /* 16774 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 16778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16782 */     // MIs[1] Operand 1
     /* 16782 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 16793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16795 */     // Combiner Rule #209: merge_of_x_and_zero
     /* 16795 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 16798 */   // Label 210: @16798
     /* 16798 */   GIM_Reject,
     /* 16799 */ // Label 208: @16799
     /* 16799 */ GIM_Reject,
     /* 16800 */ // Label 14: @16800
     /* 16800 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(16811), // Rule ID 68 //
     /* 16805 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 16808 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 16808 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 16811 */ // Label 211: @16811
     /* 16811 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(16822), // Rule ID 97 //
     /* 16816 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 16819 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 16819 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 16822 */ // Label 212: @16822
     /* 16822 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(16833), // Rule ID 132 //
     /* 16827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 16830 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 16830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 16833 */ // Label 213: @16833
     /* 16833 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(16847), // Rule ID 345 //
     /* 16838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 16841 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 16844 */   // MIs[0] dst
     /* 16844 */   // No operand predicates
     /* 16844 */   // MIs[0] unused
     /* 16844 */   // No operand predicates
     /* 16844 */   // Combiner Rule #200: combine_use_vector_truncate
     /* 16844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 16847 */ // Label 214: @16847
     /* 16847 */ GIM_Reject,
     /* 16848 */ // Label 15: @16848
     /* 16848 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(16859), // Rule ID 131 //
     /* 16853 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 16856 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 16856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 16859 */ // Label 215: @16859
     /* 16859 */ GIM_Reject,
     /* 16860 */ // Label 16: @16860
     /* 16860 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(16871), // Rule ID 338 //
     /* 16865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 16868 */   // Combiner Rule #193: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 16868 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 16871 */ // Label 216: @16871
     /* 16871 */ GIM_Reject,
     /* 16872 */ // Label 17: @16872
     /* 16872 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(16893), // Rule ID 124 //
     /* 16877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 16880 */   // MIs[0] dst
     /* 16880 */   // No operand predicates
     /* 16880 */   // MIs[0] t
     /* 16880 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 16888 */   // MIs[1] ptr
     /* 16888 */   // No operand predicates
     /* 16888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16890 */   // Combiner Rule #88: i2p_to_p2i
     /* 16890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 16893 */ // Label 217: @16893
     /* 16893 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(16914), // Rule ID 89 //
     /* 16898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 16901 */   // MIs[0] dst
     /* 16901 */   // No operand predicates
     /* 16901 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 16901 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16911 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 16911 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 16914 */ // Label 218: @16914
     /* 16914 */ GIM_Reject,
     /* 16915 */ // Label 18: @16915
     /* 16915 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(16926), // Rule ID 123 //
     /* 16920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 16923 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 16923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 16926 */ // Label 219: @16926
     /* 16926 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(16947), // Rule ID 90 //
     /* 16931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 16934 */   // MIs[0] dst
     /* 16934 */   // No operand predicates
     /* 16934 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 16934 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16944 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 16944 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 16947 */ // Label 220: @16947
     /* 16947 */ GIM_Reject,
     /* 16948 */ // Label 19: @16948
     /* 16948 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(16969), // Rule ID 135 //
     /* 16953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 16956 */   // MIs[0] dst
     /* 16956 */   // No operand predicates
     /* 16956 */   // MIs[0] src1
     /* 16956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 16964 */   // MIs[1] src0
     /* 16964 */   // No operand predicates
     /* 16964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16966 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 16966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 16969 */ // Label 221: @16969
     /* 16969 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(16990), // Rule ID 87 //
     /* 16974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 16977 */   // MIs[0] dst
     /* 16977 */   // No operand predicates
     /* 16977 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 16977 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16987 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 16987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 16990 */ // Label 222: @16990
     /* 16990 */ GIM_Reject,
     /* 16991 */ // Label 20: @16991
     /* 16991 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(17020), // Rule ID 18 //
     /* 16996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 16999 */   // MIs[0] dst
     /* 16999 */   // No operand predicates
     /* 16999 */   // MIs[0] src
     /* 16999 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 17007 */   // MIs[1] __idempotent_prop_match_0.x
     /* 17007 */   // No operand predicates
     /* 17007 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17014 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 17014 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17019 */   GIR_EraseRootFromParent_Done,
     /* 17020 */ // Label 223: @17020
     /* 17020 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(17043), // Rule ID 43 //
     /* 17025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 17028 */   // MIs[0] root
     /* 17028 */   // No operand predicates
     /* 17028 */   // MIs[0] src
     /* 17028 */   // No operand predicates
     /* 17028 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 17032 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17037 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 17037 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17042 */   GIR_EraseRootFromParent_Done,
     /* 17043 */ // Label 224: @17043
     /* 17043 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(17054), // Rule ID 44 //
     /* 17048 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 17051 */   // MIs[0] dst
     /* 17051 */   // No operand predicates
     /* 17051 */   // MIs[0] src
     /* 17051 */   // No operand predicates
     /* 17051 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 17051 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 17054 */ // Label 225: @17054
     /* 17054 */ GIM_Reject,
     /* 17055 */ // Label 21: @17055
     /* 17055 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(17066), // Rule ID 69 //
     /* 17060 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17063 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 17063 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17066 */ // Label 226: @17066
     /* 17066 */ GIM_Reject,
     /* 17067 */ // Label 22: @17067
     /* 17067 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(17078), // Rule ID 70 //
     /* 17072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17075 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 17075 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17078 */ // Label 227: @17078
     /* 17078 */ GIM_Reject,
     /* 17079 */ // Label 23: @17079
     /* 17079 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(17090), // Rule ID 71 //
     /* 17084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17087 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 17087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17090 */ // Label 228: @17090
     /* 17090 */ GIM_Reject,
     /* 17091 */ // Label 24: @17091
     /* 17091 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(17102), // Rule ID 99 //
     /* 17096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 17099 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 17099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 17102 */ // Label 229: @17102
     /* 17102 */ GIM_Reject,
     /* 17103 */ // Label 25: @17103
     /* 17103 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(17114), // Rule ID 370 //
     /* 17108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 17111 */   // Combiner Rule #219: rcp_sqrt_to_rsq; wip_match_opcode 'G_INTRINSIC'
     /* 17111 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 17114 */ // Label 230: @17114
     /* 17114 */ GIM_Reject,
     /* 17115 */ // Label 26: @17115
     /* 17115 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(17126), // Rule ID 125 //
     /* 17120 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 17123 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 17123 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 17126 */ // Label 231: @17126
     /* 17126 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(17137), // Rule ID 255 //
     /* 17131 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 17134 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 17134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 17137 */ // Label 232: @17137
     /* 17137 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(17158), // Rule ID 56 //
     /* 17142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 17145 */   // MIs[0] root
     /* 17145 */   // No operand predicates
     /* 17145 */   // MIs[0] select
     /* 17145 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17153 */   // MIs[1] cond
     /* 17153 */   // No operand predicates
     /* 17153 */   // MIs[1] true
     /* 17153 */   // No operand predicates
     /* 17153 */   // MIs[1] false
     /* 17153 */   // No operand predicates
     /* 17153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17155 */   // Combiner Rule #54: select_of_anyext
     /* 17155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 17158 */ // Label 233: @17158
     /* 17158 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(17179), // Rule ID 52 //
     /* 17163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 17166 */   // MIs[0] root
     /* 17166 */   // No operand predicates
     /* 17166 */   // MIs[0] second
     /* 17166 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17174 */   // MIs[1] src
     /* 17174 */   // No operand predicates
     /* 17174 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17176 */   // Combiner Rule #50: anyext_of_anyext
     /* 17176 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17179 */ // Label 234: @17179
     /* 17179 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(17200), // Rule ID 54 //
     /* 17184 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 17187 */   // MIs[0] root
     /* 17187 */   // No operand predicates
     /* 17187 */   // MIs[0] second
     /* 17187 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17195 */   // MIs[1] src
     /* 17195 */   // No operand predicates
     /* 17195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17197 */   // Combiner Rule #52: anyext_of_sext
     /* 17197 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17200 */ // Label 235: @17200
     /* 17200 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(17221), // Rule ID 53 //
     /* 17205 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 17208 */   // MIs[0] root
     /* 17208 */   // No operand predicates
     /* 17208 */   // MIs[0] second
     /* 17208 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17216 */   // MIs[1] src
     /* 17216 */   // No operand predicates
     /* 17216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17218 */   // Combiner Rule #51: anyext_of_zext
     /* 17218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17221 */ // Label 236: @17221
     /* 17221 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(17242), // Rule ID 88 //
     /* 17226 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 17229 */   // MIs[0] dst
     /* 17229 */   // No operand predicates
     /* 17229 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17229 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17233 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17239 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 17239 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 17242 */ // Label 237: @17242
     /* 17242 */ GIM_Reject,
     /* 17243 */ // Label 27: @17243
     /* 17243 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(17254), // Rule ID 133 //
     /* 17248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 17251 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 17251 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 17254 */ // Label 238: @17254
     /* 17254 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(17265), // Rule ID 134 //
     /* 17259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 17262 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 17262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 17265 */ // Label 239: @17265
     /* 17265 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(17276), // Rule ID 171 //
     /* 17270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 17273 */   // Combiner Rule #129: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 17273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 17276 */ // Label 240: @17276
     /* 17276 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(17297), // Rule ID 57 //
     /* 17281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 17284 */   // MIs[0] root
     /* 17284 */   // No operand predicates
     /* 17284 */   // MIs[0] select
     /* 17284 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17292 */   // MIs[1] cond
     /* 17292 */   // No operand predicates
     /* 17292 */   // MIs[1] true
     /* 17292 */   // No operand predicates
     /* 17292 */   // MIs[1] false
     /* 17292 */   // No operand predicates
     /* 17292 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17294 */   // Combiner Rule #55: select_of_truncate
     /* 17294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 17297 */ // Label 241: @17297
     /* 17297 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(17326), // Rule ID 59 //
     /* 17302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 17305 */   // MIs[0] root
     /* 17305 */   // No operand predicates
     /* 17305 */   // MIs[0] binop
     /* 17305 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 17313 */   // MIs[1] x
     /* 17313 */   // No operand predicates
     /* 17313 */   // MIs[1] const
     /* 17313 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17317 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17321 */   // MIs[2] imm
     /* 17321 */   // No operand predicates
     /* 17321 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17323 */   // Combiner Rule #57: narrow_binop_add
     /* 17323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17326 */ // Label 242: @17326
     /* 17326 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(17355), // Rule ID 62 //
     /* 17331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 17334 */   // MIs[0] root
     /* 17334 */   // No operand predicates
     /* 17334 */   // MIs[0] binop
     /* 17334 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 17342 */   // MIs[1] x
     /* 17342 */   // No operand predicates
     /* 17342 */   // MIs[1] const
     /* 17342 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17346 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17350 */   // MIs[2] imm
     /* 17350 */   // No operand predicates
     /* 17350 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17352 */   // Combiner Rule #60: narrow_binop_and
     /* 17352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17355 */ // Label 243: @17355
     /* 17355 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(17384), // Rule ID 61 //
     /* 17360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 17363 */   // MIs[0] root
     /* 17363 */   // No operand predicates
     /* 17363 */   // MIs[0] binop
     /* 17363 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 17371 */   // MIs[1] x
     /* 17371 */   // No operand predicates
     /* 17371 */   // MIs[1] const
     /* 17371 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17375 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17379 */   // MIs[2] imm
     /* 17379 */   // No operand predicates
     /* 17379 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17381 */   // Combiner Rule #59: narrow_binop_mul
     /* 17381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17384 */ // Label 244: @17384
     /* 17384 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(17413), // Rule ID 63 //
     /* 17389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 17392 */   // MIs[0] root
     /* 17392 */   // No operand predicates
     /* 17392 */   // MIs[0] binop
     /* 17392 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 17400 */   // MIs[1] x
     /* 17400 */   // No operand predicates
     /* 17400 */   // MIs[1] const
     /* 17400 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17404 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17408 */   // MIs[2] imm
     /* 17408 */   // No operand predicates
     /* 17408 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17410 */   // Combiner Rule #61: narrow_binop_or
     /* 17410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17413 */ // Label 245: @17413
     /* 17413 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(17442), // Rule ID 60 //
     /* 17418 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 17421 */   // MIs[0] root
     /* 17421 */   // No operand predicates
     /* 17421 */   // MIs[0] binop
     /* 17421 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 17429 */   // MIs[1] x
     /* 17429 */   // No operand predicates
     /* 17429 */   // MIs[1] const
     /* 17429 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17433 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17437 */   // MIs[2] imm
     /* 17437 */   // No operand predicates
     /* 17437 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17439 */   // Combiner Rule #58: narrow_binop_sub
     /* 17439 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17442 */ // Label 246: @17442
     /* 17442 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(17471), // Rule ID 64 //
     /* 17447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 17450 */   // MIs[0] root
     /* 17450 */   // No operand predicates
     /* 17450 */   // MIs[0] binop
     /* 17450 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 17458 */   // MIs[1] x
     /* 17458 */   // No operand predicates
     /* 17458 */   // MIs[1] const
     /* 17458 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17462 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17466 */   // MIs[2] imm
     /* 17466 */   // No operand predicates
     /* 17466 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17468 */   // Combiner Rule #62: narrow_binop_xor
     /* 17468 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17471 */ // Label 247: @17471
     /* 17471 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(17492), // Rule ID 47 //
     /* 17476 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 17479 */   // MIs[0] root
     /* 17479 */   // No operand predicates
     /* 17479 */   // MIs[0] ext
     /* 17479 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17487 */   // MIs[1] src
     /* 17487 */   // No operand predicates
     /* 17487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17489 */   // Combiner Rule #45: truncate_of_anyext
     /* 17489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17492 */ // Label 248: @17492
     /* 17492 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(17516), // Rule ID 58 //
     /* 17497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 17500 */   // MIs[0] root
     /* 17500 */   // No operand predicates
     /* 17500 */   // MIs[0] bv
     /* 17500 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 17508 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 17511 */   // MIs[1] unused
     /* 17511 */   // No operand predicates
     /* 17511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17513 */   // Combiner Rule #56: buildvector_of_truncate
     /* 17513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 17516 */ // Label 249: @17516
     /* 17516 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(17537), // Rule ID 46 //
     /* 17521 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 17524 */   // MIs[0] root
     /* 17524 */   // No operand predicates
     /* 17524 */   // MIs[0] ext
     /* 17524 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17532 */   // MIs[1] src
     /* 17532 */   // No operand predicates
     /* 17532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17534 */   // Combiner Rule #44: truncate_of_sext
     /* 17534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17537 */ // Label 250: @17537
     /* 17537 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(17558), // Rule ID 45 //
     /* 17542 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 17545 */   // MIs[0] root
     /* 17545 */   // No operand predicates
     /* 17545 */   // MIs[0] ext
     /* 17545 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17553 */   // MIs[1] src
     /* 17553 */   // No operand predicates
     /* 17553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17555 */   // Combiner Rule #43: truncate_of_zext
     /* 17555 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17558 */ // Label 251: @17558
     /* 17558 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(17579), // Rule ID 86 //
     /* 17563 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 17566 */   // MIs[0] dst
     /* 17566 */   // No operand predicates
     /* 17566 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17566 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17576 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 17576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 17579 */ // Label 252: @17579
     /* 17579 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(17600), // Rule ID 65 //
     /* 17584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 17587 */   // MIs[0] root
     /* 17587 */   // No operand predicates
     /* 17587 */   // MIs[0] int
     /* 17587 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17595 */   // MIs[1] imm
     /* 17595 */   // No operand predicates
     /* 17595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17597 */   // Combiner Rule #63: integer_of_truncate
     /* 17597 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17600 */ // Label 253: @17600
     /* 17600 */ GIM_Reject,
     /* 17601 */ // Label 28: @17601
     /* 17601 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(17612), // Rule ID 254 //
     /* 17606 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 17609 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 17609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 17612 */ // Label 254: @17612
     /* 17612 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(17633), // Rule ID 51 //
     /* 17617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 17620 */   // MIs[0] root
     /* 17620 */   // No operand predicates
     /* 17620 */   // MIs[0] second
     /* 17620 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17628 */   // MIs[1] src
     /* 17628 */   // No operand predicates
     /* 17628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17630 */   // Combiner Rule #49: sext_of_anyext
     /* 17630 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17633 */ // Label 255: @17633
     /* 17633 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(17654), // Rule ID 50 //
     /* 17638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 17641 */   // MIs[0] root
     /* 17641 */   // No operand predicates
     /* 17641 */   // MIs[0] second
     /* 17641 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17649 */   // MIs[1] src
     /* 17649 */   // No operand predicates
     /* 17649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17651 */   // Combiner Rule #48: sext_of_sext
     /* 17651 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17654 */ // Label 256: @17654
     /* 17654 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(17681), // Rule ID 339 //
     /* 17659 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 17662 */   // MIs[0] root
     /* 17662 */   // No operand predicates
     /* 17662 */   // MIs[0] src
     /* 17662 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 17670 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 17676 */   // MIs[1] x
     /* 17676 */   // No operand predicates
     /* 17676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17678 */   // Combiner Rule #194: sext_trunc
     /* 17678 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 17681 */ // Label 257: @17681
     /* 17681 */ GIM_Reject,
     /* 17682 */ // Label 29: @17682
     /* 17682 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(17693), // Rule ID 158 //
     /* 17687 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 17690 */   // Combiner Rule #116: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 17690 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 17693 */ // Label 258: @17693
     /* 17693 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(17704), // Rule ID 166 //
     /* 17698 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 17701 */   // Combiner Rule #124: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 17701 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 17704 */ // Label 259: @17704
     /* 17704 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(17715), // Rule ID 223 //
     /* 17709 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 17712 */   // Combiner Rule #160: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 17712 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 17715 */ // Label 260: @17715
     /* 17715 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(17726), // Rule ID 373 //
     /* 17720 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 17723 */   // Combiner Rule #221: sign_extension_in_reg; wip_match_opcode 'G_SEXT_INREG'
     /* 17723 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner159),
     /* 17726 */ // Label 261: @17726
     /* 17726 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(17737), // Rule ID 170 //
     /* 17731 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 17734 */   // MIs[0] dst
     /* 17734 */   // No operand predicates
     /* 17734 */   // MIs[0] src
     /* 17734 */   // No operand predicates
     /* 17734 */   // MIs[0] imm
     /* 17734 */   // No operand predicates
     /* 17734 */   // Combiner Rule #128: sext_inreg_to_zext_inreg
     /* 17734 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 17737 */ // Label 262: @17737
     /* 17737 */ GIM_Reject,
     /* 17738 */ // Label 30: @17738
     /* 17738 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(17749), // Rule ID 169 //
     /* 17743 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 17746 */   // Combiner Rule #127: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 17746 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 17749 */ // Label 263: @17749
     /* 17749 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(17760), // Rule ID 253 //
     /* 17754 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 17757 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 17757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 17760 */ // Label 264: @17760
     /* 17760 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(17781), // Rule ID 55 //
     /* 17765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 17768 */   // MIs[0] root
     /* 17768 */   // No operand predicates
     /* 17768 */   // MIs[0] select
     /* 17768 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17776 */   // MIs[1] cond
     /* 17776 */   // No operand predicates
     /* 17776 */   // MIs[1] true
     /* 17776 */   // No operand predicates
     /* 17776 */   // MIs[1] false
     /* 17776 */   // No operand predicates
     /* 17776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17778 */   // Combiner Rule #53: select_of_zext
     /* 17778 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 17781 */ // Label 265: @17781
     /* 17781 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(17802), // Rule ID 49 //
     /* 17786 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 17789 */   // MIs[0] root
     /* 17789 */   // No operand predicates
     /* 17789 */   // MIs[0] second
     /* 17789 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17797 */   // MIs[1] src
     /* 17797 */   // No operand predicates
     /* 17797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17799 */   // Combiner Rule #47: zext_of_anyext
     /* 17799 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17802 */ // Label 266: @17802
     /* 17802 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(17829), // Rule ID 340 //
     /* 17807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 17810 */   // MIs[0] root
     /* 17810 */   // No operand predicates
     /* 17810 */   // MIs[0] src
     /* 17810 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 17818 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 17824 */   // MIs[1] x
     /* 17824 */   // No operand predicates
     /* 17824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17826 */   // Combiner Rule #195: zext_trunc
     /* 17826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 17829 */ // Label 267: @17829
     /* 17829 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(17850), // Rule ID 48 //
     /* 17834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 17837 */   // MIs[0] root
     /* 17837 */   // No operand predicates
     /* 17837 */   // MIs[0] second
     /* 17837 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17845 */   // MIs[1] src
     /* 17845 */   // No operand predicates
     /* 17845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17847 */   // Combiner Rule #46: zext_of_zext
     /* 17847 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17850 */ // Label 268: @17850
     /* 17850 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(17867), // Rule ID 341 //
     /* 17855 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 17858 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 17864 */   // MIs[0] root
     /* 17864 */   // No operand predicates
     /* 17864 */   // MIs[0] x
     /* 17864 */   // No operand predicates
     /* 17864 */   // Combiner Rule #196: nneg_zext
     /* 17864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 17867 */ // Label 269: @17867
     /* 17867 */ GIM_Reject,
     /* 17868 */ // Label 31: @17868
     /* 17868 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(17879), // Rule ID 79 //
     /* 17873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 17876 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 17876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 17879 */ // Label 270: @17879
     /* 17879 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(17890), // Rule ID 82 //
     /* 17884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 17887 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 17887 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 17890 */ // Label 271: @17890
     /* 17890 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(17901), // Rule ID 115 //
     /* 17895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 17898 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 17898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 17901 */ // Label 272: @17901
     /* 17901 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(17912), // Rule ID 198 //
     /* 17906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 17909 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 17909 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 17912 */ // Label 273: @17912
     /* 17912 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(17923), // Rule ID 203 //
     /* 17917 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 17920 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 17920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 17923 */ // Label 274: @17923
     /* 17923 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(17934), // Rule ID 222 //
     /* 17928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 17931 */   // Combiner Rule #159: commute_shift; wip_match_opcode 'G_SHL'
     /* 17931 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 17934 */ // Label 275: @17934
     /* 17934 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(17945), // Rule ID 236 //
     /* 17939 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 17942 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 17942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 17945 */ // Label 276: @17945
     /* 17945 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(17956), // Rule ID 289 //
     /* 17950 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 17953 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 17953 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 17956 */ // Label 277: @17956
     /* 17956 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(17991), // Rule ID 41 //
     /* 17961 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 17964 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 17970 */   // MIs[0] root
     /* 17970 */   // No operand predicates
     /* 17970 */   // MIs[0] left
     /* 17970 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 17978 */   // MIs[1] imm
     /* 17978 */   // No operand predicates
     /* 17978 */   // MIs[0] x
     /* 17978 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 17982 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17986 */   // MIs[2] imm1
     /* 17986 */   // No operand predicates
     /* 17986 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17988 */   // Combiner Rule #39: shl_of_vscale
     /* 17988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 17991 */ // Label 278: @17991
     /* 17991 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(18014), // Rule ID 107 //
     /* 17996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 17999 */   // MIs[0] dst
     /* 17999 */   // No operand predicates
     /* 17999 */   // MIs[0] lhs
     /* 17999 */   // No operand predicates
     /* 17999 */   // MIs[0] Operand 2
     /* 17999 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18003 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18008 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 18008 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18013 */   GIR_EraseRootFromParent_Done,
     /* 18014 */ // Label 279: @18014
     /* 18014 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(18025), // Rule ID 144 //
     /* 18019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 18022 */   // MIs[0] root
     /* 18022 */   // No operand predicates
     /* 18022 */   // MIs[0] mi.shifted
     /* 18022 */   // No operand predicates
     /* 18022 */   // MIs[0] mi.amt
     /* 18022 */   // No operand predicates
     /* 18022 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 18022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 18025 */ // Label 280: @18025
     /* 18025 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(18036), // Rule ID 159 //
     /* 18030 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 18033 */   // MIs[0] dst
     /* 18033 */   // No operand predicates
     /* 18033 */   // MIs[0] src0
     /* 18033 */   // No operand predicates
     /* 18033 */   // MIs[0] src1
     /* 18033 */   // No operand predicates
     /* 18033 */   // Combiner Rule #117: reduce_shl_of_extend
     /* 18033 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 18036 */ // Label 281: @18036
     /* 18036 */ GIM_Reject,
     /* 18037 */ // Label 32: @18037
     /* 18037 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(18048), // Rule ID 84 //
     /* 18042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 18045 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 18045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 18048 */ // Label 282: @18048
     /* 18048 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(18059), // Rule ID 116 //
     /* 18053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 18056 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 18056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 18059 */ // Label 283: @18059
     /* 18059 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(18070), // Rule ID 200 //
     /* 18064 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18067 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 18067 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18070 */ // Label 284: @18070
     /* 18070 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(18081), // Rule ID 205 //
     /* 18075 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18078 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 18078 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18081 */ // Label 285: @18081
     /* 18081 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(18092), // Rule ID 226 //
     /* 18086 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 18089 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 18089 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 18092 */ // Label 286: @18092
     /* 18092 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(18103), // Rule ID 228 //
     /* 18097 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 18100 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 18100 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 18103 */ // Label 287: @18103
     /* 18103 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(18114), // Rule ID 233 //
     /* 18108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 18111 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 18111 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 18114 */ // Label 288: @18114
     /* 18114 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(18125), // Rule ID 287 //
     /* 18119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 18122 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 18122 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 18125 */ // Label 289: @18125
     /* 18125 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(18148), // Rule ID 109 //
     /* 18130 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18133 */   // MIs[0] dst
     /* 18133 */   // No operand predicates
     /* 18133 */   // MIs[0] lhs
     /* 18133 */   // No operand predicates
     /* 18133 */   // MIs[0] Operand 2
     /* 18133 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18137 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18142 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 18142 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18147 */   GIR_EraseRootFromParent_Done,
     /* 18148 */ // Label 290: @18148
     /* 18148 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(18159), // Rule ID 146 //
     /* 18153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 18156 */   // MIs[0] root
     /* 18156 */   // No operand predicates
     /* 18156 */   // MIs[0] mi.shifted
     /* 18156 */   // No operand predicates
     /* 18156 */   // MIs[0] mi.amt
     /* 18156 */   // No operand predicates
     /* 18156 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 18156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 18159 */ // Label 291: @18159
     /* 18159 */ GIM_Reject,
     /* 18160 */ // Label 33: @18160
     /* 18160 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(18171), // Rule ID 83 //
     /* 18165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 18168 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 18168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 18171 */ // Label 292: @18171
     /* 18171 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(18182), // Rule ID 117 //
     /* 18176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 18179 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 18179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 18182 */ // Label 293: @18182
     /* 18182 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(18193), // Rule ID 157 //
     /* 18187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 18190 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 18190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 18193 */ // Label 294: @18193
     /* 18193 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(18204), // Rule ID 199 //
     /* 18198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18201 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 18201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18204 */ // Label 295: @18204
     /* 18204 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(18215), // Rule ID 204 //
     /* 18209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18212 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 18212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18215 */ // Label 296: @18215
     /* 18215 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(18226), // Rule ID 225 //
     /* 18220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 18223 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 18223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 18226 */ // Label 297: @18226
     /* 18226 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(18237), // Rule ID 227 //
     /* 18231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 18234 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 18234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 18237 */ // Label 298: @18237
     /* 18237 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(18248), // Rule ID 232 //
     /* 18242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 18245 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 18245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 18248 */ // Label 299: @18248
     /* 18248 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(18259), // Rule ID 288 //
     /* 18253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 18256 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 18256 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 18259 */ // Label 300: @18259
     /* 18259 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(18282), // Rule ID 108 //
     /* 18264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18267 */   // MIs[0] dst
     /* 18267 */   // No operand predicates
     /* 18267 */   // MIs[0] lhs
     /* 18267 */   // No operand predicates
     /* 18267 */   // MIs[0] Operand 2
     /* 18267 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18271 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18276 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 18276 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18281 */   GIR_EraseRootFromParent_Done,
     /* 18282 */ // Label 301: @18282
     /* 18282 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(18293), // Rule ID 145 //
     /* 18287 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 18290 */   // MIs[0] root
     /* 18290 */   // No operand predicates
     /* 18290 */   // MIs[0] mi.shifted
     /* 18290 */   // No operand predicates
     /* 18290 */   // MIs[0] mi.amt
     /* 18290 */   // No operand predicates
     /* 18290 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 18290 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 18293 */ // Label 302: @18293
     /* 18293 */ GIM_Reject,
     /* 18294 */ // Label 34: @18294
     /* 18294 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(18305), // Rule ID 214 //
     /* 18299 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 18302 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 18302 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 18305 */ // Label 303: @18305
     /* 18305 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(18316), // Rule ID 218 //
     /* 18310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 18313 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 18313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 18316 */ // Label 304: @18316
     /* 18316 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(18336), // Rule ID 217 //
     /* 18321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 18324 */   // MIs[0] x
     /* 18324 */   // No operand predicates
     /* 18324 */   // MIs[0] y
     /* 18324 */   // No operand predicates
     /* 18324 */   // MIs[0] z
     /* 18324 */   // No operand predicates
     /* 18324 */   // MIs[0] Operand 3
     /* 18324 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 18328 */   // Combiner Rule #155: funnel_shift_left_zero
     /* 18328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 18331 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 18333 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 18335 */   GIR_EraseRootFromParent_Done,
     /* 18336 */ // Label 305: @18336
     /* 18336 */ GIM_Reject,
     /* 18337 */ // Label 35: @18337
     /* 18337 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(18348), // Rule ID 215 //
     /* 18342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 18345 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 18345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 18348 */ // Label 306: @18348
     /* 18348 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(18359), // Rule ID 219 //
     /* 18353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 18356 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 18356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 18359 */ // Label 307: @18359
     /* 18359 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(18379), // Rule ID 216 //
     /* 18364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 18367 */   // MIs[0] x
     /* 18367 */   // No operand predicates
     /* 18367 */   // MIs[0] y
     /* 18367 */   // No operand predicates
     /* 18367 */   // MIs[0] z
     /* 18367 */   // No operand predicates
     /* 18367 */   // MIs[0] Operand 3
     /* 18367 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 18371 */   // Combiner Rule #154: funnel_shift_right_zero
     /* 18371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 18374 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 18376 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 18378 */   GIR_EraseRootFromParent_Done,
     /* 18379 */ // Label 308: @18379
     /* 18379 */ GIM_Reject,
     /* 18380 */ // Label 36: @18380
     /* 18380 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(18403), // Rule ID 112 //
     /* 18385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18388 */   // MIs[0] dst
     /* 18388 */   // No operand predicates
     /* 18388 */   // MIs[0] lhs
     /* 18388 */   // No operand predicates
     /* 18388 */   // MIs[0] Operand 2
     /* 18388 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18392 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18397 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 18397 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18402 */   GIR_EraseRootFromParent_Done,
     /* 18403 */ // Label 309: @18403
     /* 18403 */ GIM_Reject,
     /* 18404 */ // Label 37: @18404
     /* 18404 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(18427), // Rule ID 111 //
     /* 18409 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18412 */   // MIs[0] dst
     /* 18412 */   // No operand predicates
     /* 18412 */   // MIs[0] lhs
     /* 18412 */   // No operand predicates
     /* 18412 */   // MIs[0] Operand 2
     /* 18412 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18416 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18421 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 18421 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18426 */   GIR_EraseRootFromParent_Done,
     /* 18427 */ // Label 310: @18427
     /* 18427 */ GIM_Reject,
     /* 18428 */ // Label 38: @18428
     /* 18428 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(18439), // Rule ID 152 //
     /* 18433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 18436 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 18436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 18439 */ // Label 311: @18439
     /* 18439 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(18450), // Rule ID 153 //
     /* 18444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 18447 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 18447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 18450 */ // Label 312: @18450
     /* 18450 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(18461), // Rule ID 156 //
     /* 18455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 18458 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 18458 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 18461 */ // Label 313: @18461
     /* 18461 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(18472), // Rule ID 150 //
     /* 18466 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 18469 */   // MIs[0] root
     /* 18469 */   // No operand predicates
     /* 18469 */   // MIs[0] pred
     /* 18469 */   // No operand predicates
     /* 18469 */   // MIs[0] lhs
     /* 18469 */   // No operand predicates
     /* 18469 */   // MIs[0] rhs
     /* 18469 */   // No operand predicates
     /* 18469 */   // Combiner Rule #108: canonicalize_icmp
     /* 18469 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 18472 */ // Label 314: @18472
     /* 18472 */ GIM_Reject,
     /* 18473 */ // Label 39: @18473
     /* 18473 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(18484), // Rule ID 151 //
     /* 18478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 18481 */   // MIs[0] root
     /* 18481 */   // No operand predicates
     /* 18481 */   // MIs[0] pred
     /* 18481 */   // No operand predicates
     /* 18481 */   // MIs[0] lhs
     /* 18481 */   // No operand predicates
     /* 18481 */   // MIs[0] rhs
     /* 18481 */   // No operand predicates
     /* 18481 */   // Combiner Rule #109: canonicalize_fcmp
     /* 18481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 18484 */ // Label 315: @18484
     /* 18484 */ GIM_Reject,
     /* 18485 */ // Label 40: @18485
     /* 18485 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(18496), // Rule ID 102 //
     /* 18490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 18493 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 18493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 18496 */ // Label 316: @18496
     /* 18496 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(18507), // Rule ID 162 //
     /* 18501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 18504 */   // Combiner Rule #120: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 18504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 18507 */ // Label 317: @18507
     /* 18507 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(18518), // Rule ID 164 //
     /* 18512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 18515 */   // Combiner Rule #122: match_selects; wip_match_opcode 'G_SELECT'
     /* 18515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 18518 */ // Label 318: @18518
     /* 18518 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(18529), // Rule ID 304 //
     /* 18523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 18526 */   // Combiner Rule #186: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 18526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 18529 */ // Label 319: @18529
     /* 18529 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(18556), // Rule ID 359 //
     /* 18534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFminFmaxLegacy),
     /* 18537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 18540 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18543 */   // MIs[0] cond
     /* 18543 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 18551 */   // MIs[1] pred
     /* 18551 */   // No operand predicates
     /* 18551 */   // MIs[1] lhs
     /* 18551 */   // No operand predicates
     /* 18551 */   // MIs[1] rhs
     /* 18551 */   // No operand predicates
     /* 18551 */   // MIs[0] true
     /* 18551 */   // No operand predicates
     /* 18551 */   // MIs[0] false
     /* 18551 */   // No operand predicates
     /* 18551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18553 */   // Combiner Rule #212: fcmp_select_to_fmin_fmax_legacy
     /* 18553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 18556 */ // Label 320: @18556
     /* 18556 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(18577), // Rule ID 163 //
     /* 18561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 18564 */   // MIs[0] root
     /* 18564 */   // No operand predicates
     /* 18564 */   // MIs[0] tst
     /* 18564 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 18572 */   // MIs[1] tst1
     /* 18572 */   // No operand predicates
     /* 18572 */   // MIs[1] a
     /* 18572 */   // No operand predicates
     /* 18572 */   // MIs[1] b
     /* 18572 */   // No operand predicates
     /* 18572 */   // MIs[0] x
     /* 18572 */   // No operand predicates
     /* 18572 */   // MIs[0] y
     /* 18572 */   // No operand predicates
     /* 18572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18574 */   // Combiner Rule #121: select_to_iminmax
     /* 18574 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 18577 */ // Label 321: @18577
     /* 18577 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(18606), // Rule ID 161 //
     /* 18582 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 18585 */   // MIs[0] dst
     /* 18585 */   // No operand predicates
     /* 18585 */   // MIs[0] undef
     /* 18585 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 18593 */   // MIs[0] x
     /* 18593 */   // No operand predicates
     /* 18593 */   // MIs[0] y
     /* 18593 */   // No operand predicates
     /* 18593 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 18598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18600 */   // Combiner Rule #119: select_undef_cmp
     /* 18600 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 18605 */   GIR_EraseRootFromParent_Done,
     /* 18606 */ // Label 322: @18606
     /* 18606 */ GIM_Reject,
     /* 18607 */ // Label 41: @18607
     /* 18607 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(18618), // Rule ID 315 //
     /* 18612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18615 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 18615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18618 */ // Label 323: @18618
     /* 18618 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18629), // Rule ID 356 //
     /* 18623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 18626 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_UADDO'
     /* 18626 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 18629 */ // Label 324: @18629
     /* 18629 */ GIM_Reject,
     /* 18630 */ // Label 42: @18630
     /* 18630 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18641), // Rule ID 187 //
     /* 18635 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18638 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 18638 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18641 */ // Label 325: @18641
     /* 18641 */ GIM_Reject,
     /* 18642 */ // Label 43: @18642
     /* 18642 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18653), // Rule ID 358 //
     /* 18647 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 18650 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 18650 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 18653 */ // Label 326: @18653
     /* 18653 */ GIM_Reject,
     /* 18654 */ // Label 44: @18654
     /* 18654 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18665), // Rule ID 189 //
     /* 18659 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18662 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 18662 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18665 */ // Label 327: @18665
     /* 18665 */ GIM_Reject,
     /* 18666 */ // Label 45: @18666
     /* 18666 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18677), // Rule ID 316 //
     /* 18671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18674 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 18674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18677 */ // Label 328: @18677
     /* 18677 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18688), // Rule ID 355 //
     /* 18682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 18685 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_SADDO'
     /* 18685 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 18688 */ // Label 329: @18688
     /* 18688 */ GIM_Reject,
     /* 18689 */ // Label 46: @18689
     /* 18689 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18700), // Rule ID 188 //
     /* 18694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18697 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 18697 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18700 */ // Label 330: @18700
     /* 18700 */ GIM_Reject,
     /* 18701 */ // Label 47: @18701
     /* 18701 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18712), // Rule ID 357 //
     /* 18706 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 18709 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 18709 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 18712 */ // Label 331: @18712
     /* 18712 */ GIM_Reject,
     /* 18713 */ // Label 48: @18713
     /* 18713 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18724), // Rule ID 190 //
     /* 18718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18721 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 18721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18724 */ // Label 332: @18724
     /* 18724 */ GIM_Reject,
     /* 18725 */ // Label 49: @18725
     /* 18725 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18736), // Rule ID 183 //
     /* 18730 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 18733 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 18733 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 18736 */ // Label 333: @18736
     /* 18736 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18747), // Rule ID 185 //
     /* 18741 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 18744 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 18744 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 18747 */ // Label 334: @18747
     /* 18747 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18758), // Rule ID 317 //
     /* 18752 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18755 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 18755 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18758 */ // Label 335: @18758
     /* 18758 */ GIM_Reject,
     /* 18759 */ // Label 50: @18759
     /* 18759 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18770), // Rule ID 184 //
     /* 18764 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 18767 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 18767 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 18770 */ // Label 336: @18770
     /* 18770 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18781), // Rule ID 186 //
     /* 18775 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 18778 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 18778 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 18781 */ // Label 337: @18781
     /* 18781 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18792), // Rule ID 318 //
     /* 18786 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18789 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 18789 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18792 */ // Label 338: @18792
     /* 18792 */ GIM_Reject,
     /* 18793 */ // Label 51: @18793
     /* 18793 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18804), // Rule ID 261 //
     /* 18798 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 18801 */   // Combiner Rule #173: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 18801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 18804 */ // Label 339: @18804
     /* 18804 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18815), // Rule ID 319 //
     /* 18809 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18812 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 18812 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18815 */ // Label 340: @18815
     /* 18815 */ GIM_Reject,
     /* 18816 */ // Label 52: @18816
     /* 18816 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18827), // Rule ID 320 //
     /* 18821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18824 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 18824 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18827 */ // Label 341: @18827
     /* 18827 */ GIM_Reject,
     /* 18828 */ // Label 53: @18828
     /* 18828 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18839), // Rule ID 321 //
     /* 18833 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18836 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 18836 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18839 */ // Label 342: @18839
     /* 18839 */ GIM_Reject,
     /* 18840 */ // Label 54: @18840
     /* 18840 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18851), // Rule ID 322 //
     /* 18845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18848 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 18848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18851 */ // Label 343: @18851
     /* 18851 */ GIM_Reject,
     /* 18852 */ // Label 55: @18852
     /* 18852 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18863), // Rule ID 202 //
     /* 18857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18860 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 18860 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18863 */ // Label 344: @18863
     /* 18863 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18874), // Rule ID 206 //
     /* 18868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18871 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 18871 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18874 */ // Label 345: @18874
     /* 18874 */ GIM_Reject,
     /* 18875 */ // Label 56: @18875
     /* 18875 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18886), // Rule ID 201 //
     /* 18880 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18883 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 18883 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18886 */ // Label 346: @18886
     /* 18886 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18897), // Rule ID 207 //
     /* 18891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18894 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 18894 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18897 */ // Label 347: @18897
     /* 18897 */ GIM_Reject,
     /* 18898 */ // Label 57: @18898
     /* 18898 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18909), // Rule ID 323 //
     /* 18903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18906 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 18906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18909 */ // Label 348: @18909
     /* 18909 */ GIM_Reject,
     /* 18910 */ // Label 58: @18910
     /* 18910 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18921), // Rule ID 324 //
     /* 18915 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18918 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 18918 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18921 */ // Label 349: @18921
     /* 18921 */ GIM_Reject,
     /* 18922 */ // Label 59: @18922
     /* 18922 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18933), // Rule ID 325 //
     /* 18927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18930 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 18930 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18933 */ // Label 350: @18933
     /* 18933 */ GIM_Reject,
     /* 18934 */ // Label 60: @18934
     /* 18934 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18945), // Rule ID 326 //
     /* 18939 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18942 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 18942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18945 */ // Label 351: @18945
     /* 18945 */ GIM_Reject,
     /* 18946 */ // Label 61: @18946
     /* 18946 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18957), // Rule ID 247 //
     /* 18951 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 18954 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 18954 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 18957 */ // Label 352: @18957
     /* 18957 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18968), // Rule ID 262 //
     /* 18962 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 18965 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 18965 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 18968 */ // Label 353: @18968
     /* 18968 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18979), // Rule ID 269 //
     /* 18973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 18976 */   // Combiner Rule #176: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 18976 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 18979 */ // Label 354: @18979
     /* 18979 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18990), // Rule ID 270 //
     /* 18984 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 18987 */   // Combiner Rule #177: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 18987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 18990 */ // Label 355: @18990
     /* 18990 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19001), // Rule ID 271 //
     /* 18995 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 18998 */   // Combiner Rule #178: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 18998 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 19001 */ // Label 356: @19001
     /* 19001 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19012), // Rule ID 272 //
     /* 19006 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 19009 */   // Combiner Rule #179: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19009 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 19012 */ // Label 357: @19012
     /* 19012 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19023), // Rule ID 295 //
     /* 19017 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19020 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 19020 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19023 */ // Label 358: @19023
     /* 19023 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19034), // Rule ID 327 //
     /* 19028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19031 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 19031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19034 */ // Label 359: @19034
     /* 19034 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19057), // Rule ID 137 //
     /* 19039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 19042 */   // MIs[0] dst
     /* 19042 */   // No operand predicates
     /* 19042 */   // MIs[0] x
     /* 19042 */   // No operand predicates
     /* 19042 */   // MIs[0] y
     /* 19042 */   // No operand predicates
     /* 19042 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 19046 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19051 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 19051 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19056 */   GIR_EraseRootFromParent_Done,
     /* 19057 */ // Label 360: @19057
     /* 19057 */ GIM_Reject,
     /* 19058 */ // Label 62: @19058
     /* 19058 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19069), // Rule ID 248 //
     /* 19063 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 19066 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 19066 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 19069 */ // Label 361: @19069
     /* 19069 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19080), // Rule ID 263 //
     /* 19074 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19077 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 19077 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19080 */ // Label 362: @19080
     /* 19080 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19091), // Rule ID 273 //
     /* 19085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 19088 */   // Combiner Rule #180: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 19091 */ // Label 363: @19091
     /* 19091 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19102), // Rule ID 274 //
     /* 19096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 19099 */   // Combiner Rule #181: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19102 */ // Label 364: @19102
     /* 19102 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19113), // Rule ID 275 //
     /* 19107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19110 */   // Combiner Rule #182: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 19113 */ // Label 365: @19113
     /* 19113 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19124), // Rule ID 276 //
     /* 19118 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 19121 */   // Combiner Rule #183: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19121 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 19124 */ // Label 366: @19124
     /* 19124 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19135), // Rule ID 296 //
     /* 19129 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19132 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 19132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19135 */ // Label 367: @19135
     /* 19135 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(19146), // Rule ID 305 //
     /* 19140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 19143 */   // Combiner Rule #187: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 19143 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 19146 */ // Label 368: @19146
     /* 19146 */ GIM_Reject,
     /* 19147 */ // Label 63: @19147
     /* 19147 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(19158), // Rule ID 249 //
     /* 19152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 19155 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 19155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 19158 */ // Label 369: @19158
     /* 19158 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(19169), // Rule ID 264 //
     /* 19163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19166 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 19166 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19169 */ // Label 370: @19169
     /* 19169 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(19180), // Rule ID 294 //
     /* 19174 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19177 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 19177 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19180 */ // Label 371: @19180
     /* 19180 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(19191), // Rule ID 328 //
     /* 19185 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19188 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 19188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19191 */ // Label 372: @19191
     /* 19191 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(19212), // Rule ID 361 //
     /* 19196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 19199 */   // MIs[0] dst
     /* 19199 */   // No operand predicates
     /* 19199 */   // MIs[0] x
     /* 19199 */   // No operand predicates
     /* 19199 */   // MIs[0] select
     /* 19199 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 19207 */   // MIs[1] y
     /* 19207 */   // No operand predicates
     /* 19207 */   // MIs[1] A
     /* 19207 */   // No operand predicates
     /* 19207 */   // MIs[1] B
     /* 19207 */   // No operand predicates
     /* 19207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19209 */   // Combiner Rule #214: combine_fmul_with_select_to_fldexp
     /* 19209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 19212 */ // Label 373: @19212
     /* 19212 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(19235), // Rule ID 128 //
     /* 19217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 19220 */   // MIs[0] dst
     /* 19220 */   // No operand predicates
     /* 19220 */   // MIs[0] x
     /* 19220 */   // No operand predicates
     /* 19220 */   // MIs[0] y
     /* 19220 */   // No operand predicates
     /* 19220 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 19224 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19229 */   // Combiner Rule #92: right_identity_one_fp
     /* 19229 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19234 */   GIR_EraseRootFromParent_Done,
     /* 19235 */ // Label 374: @19235
     /* 19235 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(19255), // Rule ID 138 //
     /* 19240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 19243 */   // MIs[0] dst
     /* 19243 */   // No operand predicates
     /* 19243 */   // MIs[0] x
     /* 19243 */   // No operand predicates
     /* 19243 */   // MIs[0] y
     /* 19243 */   // No operand predicates
     /* 19243 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 19247 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 19247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19250 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 19252 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 19254 */   GIR_EraseRootFromParent_Done,
     /* 19255 */ // Label 375: @19255
     /* 19255 */ GIM_Reject,
     /* 19256 */ // Label 64: @19256
     /* 19256 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(19267), // Rule ID 252 //
     /* 19261 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 19264 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 19264 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19267 */ // Label 376: @19267
     /* 19267 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(19278), // Rule ID 267 //
     /* 19272 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19275 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 19275 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19278 */ // Label 377: @19278
     /* 19278 */ GIM_Reject,
     /* 19279 */ // Label 65: @19279
     /* 19279 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(19290), // Rule ID 251 //
     /* 19284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 19287 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 19287 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19290 */ // Label 378: @19290
     /* 19290 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(19301), // Rule ID 266 //
     /* 19295 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19298 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 19298 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19301 */ // Label 379: @19301
     /* 19301 */ GIM_Reject,
     /* 19302 */ // Label 66: @19302
     /* 19302 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(19313), // Rule ID 250 //
     /* 19307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 19310 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 19310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 19313 */ // Label 380: @19313
     /* 19313 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(19324), // Rule ID 265 //
     /* 19318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19321 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 19321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19324 */ // Label 381: @19324
     /* 19324 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(19335), // Rule ID 297 //
     /* 19329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19332 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 19332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19335 */ // Label 382: @19335
     /* 19335 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(19374), // Rule ID 372 //
     /* 19340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 19343 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 19346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 19349 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::FmContract),
     /* 19355 */   // MIs[0] y
     /* 19355 */   // No operand predicates
     /* 19355 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSQRT),
     /* 19363 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::FmContract),
     /* 19369 */   // MIs[1] x
     /* 19369 */   // No operand predicates
     /* 19369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19371 */   // Combiner Rule #220: fdiv_by_sqrt_to_rsq_f16
     /* 19371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner158),
     /* 19374 */ // Label 383: @19374
     /* 19374 */ GIM_Reject,
     /* 19375 */ // Label 67: @19375
     /* 19375 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(19386), // Rule ID 298 //
     /* 19380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19383 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 19383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19386 */ // Label 384: @19386
     /* 19386 */ GIM_Reject,
     /* 19387 */ // Label 68: @19387
     /* 19387 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(19408), // Rule ID 195 //
     /* 19392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 19395 */   // MIs[0] dst
     /* 19395 */   // No operand predicates
     /* 19395 */   // MIs[0] float
     /* 19395 */   // No operand predicates
     /* 19395 */   // MIs[0] int
     /* 19395 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 19403 */   // MIs[1] imm
     /* 19403 */   // No operand predicates
     /* 19403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19405 */   // Combiner Rule #145: expand_const_fpowi
     /* 19405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 19408 */ // Label 385: @19408
     /* 19408 */ GIM_Reject,
     /* 19409 */ // Label 69: @19409
     /* 19409 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(19430), // Rule ID 177 //
     /* 19414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 19417 */   // MIs[0] dst
     /* 19417 */   // No operand predicates
     /* 19417 */   // MIs[0] src0
     /* 19417 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19425 */   // MIs[1] cst
     /* 19425 */   // No operand predicates
     /* 19425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19427 */   // Combiner Rule #135: constant_fold_flog2
     /* 19427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19430 */ // Label 386: @19430
     /* 19430 */ GIM_Reject,
     /* 19431 */ // Label 70: @19431
     /* 19431 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(19442), // Rule ID 369 //
     /* 19436 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 19439 */   // Combiner Rule #218: foldable_fneg; wip_match_opcode 'G_FNEG'
     /* 19439 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 19442 */ // Label 387: @19442
     /* 19442 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(19463), // Rule ID 174 //
     /* 19447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 19450 */   // MIs[0] dst
     /* 19450 */   // No operand predicates
     /* 19450 */   // MIs[0] src0
     /* 19450 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19458 */   // MIs[1] cst
     /* 19458 */   // No operand predicates
     /* 19458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19460 */   // Combiner Rule #132: constant_fold_fneg
     /* 19460 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19463 */ // Label 388: @19463
     /* 19463 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(19492), // Rule ID 126 //
     /* 19468 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 19471 */   // MIs[0] dst
     /* 19471 */   // No operand predicates
     /* 19471 */   // MIs[0] t
     /* 19471 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19479 */   // MIs[1] src
     /* 19479 */   // No operand predicates
     /* 19479 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 19484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19486 */   // Combiner Rule #90: fneg_fneg_fold
     /* 19486 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 19491 */   GIR_EraseRootFromParent_Done,
     /* 19492 */ // Label 389: @19492
     /* 19492 */ GIM_Reject,
     /* 19493 */ // Label 71: @19493
     /* 19493 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(19517), // Rule ID 360 //
     /* 19498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasMed3_16),
     /* 19501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 19504 */   // MIs[0] fptrunc_dst
     /* 19504 */   // No operand predicates
     /* 19504 */   // MIs[0] fmed3_dst
     /* 19504 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_FMED3),
     /* 19512 */   // MIs[1] src0
     /* 19512 */   // No operand predicates
     /* 19512 */   // MIs[1] src1
     /* 19512 */   // No operand predicates
     /* 19512 */   // MIs[1] src2
     /* 19512 */   // No operand predicates
     /* 19512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19514 */   // Combiner Rule #213: expand_promoted_fmed3
     /* 19514 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 19517 */ // Label 390: @19517
     /* 19517 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(19538), // Rule ID 178 //
     /* 19522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 19525 */   // MIs[0] dst
     /* 19525 */   // No operand predicates
     /* 19525 */   // MIs[0] src0
     /* 19525 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19533 */   // MIs[1] cst
     /* 19533 */   // No operand predicates
     /* 19533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19535 */   // Combiner Rule #136: constant_fold_fptrunc
     /* 19535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19538 */ // Label 391: @19538
     /* 19538 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(19559), // Rule ID 136 //
     /* 19543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 19546 */   // MIs[0] dst
     /* 19546 */   // No operand predicates
     /* 19546 */   // MIs[0] src1
     /* 19546 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 19554 */   // MIs[1] src0
     /* 19554 */   // No operand predicates
     /* 19554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19556 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 19556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 19559 */ // Label 392: @19559
     /* 19559 */ GIM_Reject,
     /* 19560 */ // Label 72: @19560
     /* 19560 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(19581), // Rule ID 91 //
     /* 19565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 19568 */   // MIs[0] dst
     /* 19568 */   // No operand predicates
     /* 19568 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 19568 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 19576 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19578 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 19578 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 19581 */ // Label 393: @19581
     /* 19581 */ GIM_Reject,
     /* 19582 */ // Label 73: @19582
     /* 19582 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(19603), // Rule ID 92 //
     /* 19587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 19590 */   // MIs[0] dst
     /* 19590 */   // No operand predicates
     /* 19590 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 19590 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 19598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19600 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 19600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 19603 */ // Label 394: @19603
     /* 19603 */ GIM_Reject,
     /* 19604 */ // Label 74: @19604
     /* 19604 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(19615), // Rule ID 75 //
     /* 19609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 19612 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 19612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 19615 */ // Label 395: @19615
     /* 19615 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(19626), // Rule ID 363 //
     /* 19620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 19623 */   // Combiner Rule #215: uchar_to_float; wip_match_opcode 'G_SITOFP'
     /* 19623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 19626 */ // Label 396: @19626
     /* 19626 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(19641), // Rule ID 179 //
     /* 19631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 19634 */   // MIs[0] dst
     /* 19634 */   // No operand predicates
     /* 19634 */   // MIs[0] Operand 1
     /* 19634 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 19638 */   // Combiner Rule #137: itof_const_zero_fold_si
     /* 19638 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19641 */ // Label 397: @19641
     /* 19641 */ GIM_Reject,
     /* 19642 */ // Label 75: @19642
     /* 19642 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(19653), // Rule ID 74 //
     /* 19647 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 19650 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 19650 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 19653 */ // Label 398: @19653
     /* 19653 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19664), // Rule ID 362 //
     /* 19658 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 19661 */   // Combiner Rule #215: uchar_to_float; wip_match_opcode 'G_UITOFP'
     /* 19661 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 19664 */ // Label 399: @19664
     /* 19664 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19679), // Rule ID 180 //
     /* 19669 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 19672 */   // MIs[0] dst
     /* 19672 */   // No operand predicates
     /* 19672 */   // MIs[0] Operand 1
     /* 19672 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 19676 */   // Combiner Rule #138: itof_const_zero_fold_ui
     /* 19676 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19679 */ // Label 400: @19679
     /* 19679 */ GIM_Reject,
     /* 19680 */ // Label 76: @19680
     /* 19680 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19709), // Rule ID 19 //
     /* 19685 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 19688 */   // MIs[0] dst
     /* 19688 */   // No operand predicates
     /* 19688 */   // MIs[0] src
     /* 19688 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 19696 */   // MIs[1] __idempotent_prop_match_0.x
     /* 19696 */   // No operand predicates
     /* 19696 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19703 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 19703 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19708 */   GIR_EraseRootFromParent_Done,
     /* 19709 */ // Label 401: @19709
     /* 19709 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19730), // Rule ID 175 //
     /* 19714 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 19717 */   // MIs[0] dst
     /* 19717 */   // No operand predicates
     /* 19717 */   // MIs[0] src0
     /* 19717 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19725 */   // MIs[1] cst
     /* 19725 */   // No operand predicates
     /* 19725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19727 */   // Combiner Rule #133: constant_fold_fabs
     /* 19727 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19730 */ // Label 402: @19730
     /* 19730 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19758), // Rule ID 256 //
     /* 19735 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 19738 */   // MIs[0] dst
     /* 19738 */   // No operand predicates
     /* 19738 */   // MIs[0] tmp
     /* 19738 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19746 */   // MIs[1] x
     /* 19746 */   // No operand predicates
     /* 19746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19748 */   // Combiner Rule #168: fabs_fneg_fold
     /* 19748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 19751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 19753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 19757 */   GIR_EraseRootFromParent_Done,
     /* 19758 */ // Label 403: @19758
     /* 19758 */ GIM_Reject,
     /* 19759 */ // Label 77: @19759
     /* 19759 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19770), // Rule ID 368 //
     /* 19764 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 19767 */   // Combiner Rule #217: remove_fcanonicalize; wip_match_opcode 'G_FCANONICALIZE'
     /* 19767 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 19770 */ // Label 404: @19770
     /* 19770 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19799), // Rule ID 20 //
     /* 19775 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 19778 */   // MIs[0] dst
     /* 19778 */   // No operand predicates
     /* 19778 */   // MIs[0] src
     /* 19778 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 19786 */   // MIs[1] __idempotent_prop_match_0.x
     /* 19786 */   // No operand predicates
     /* 19786 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19793 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 19793 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19798 */   GIR_EraseRootFromParent_Done,
     /* 19799 */ // Label 405: @19799
     /* 19799 */ GIM_Reject,
     /* 19800 */ // Label 78: @19800
     /* 19800 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19811), // Rule ID 191 //
     /* 19805 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19808 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 19808 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19811 */ // Label 406: @19811
     /* 19811 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19822), // Rule ID 299 //
     /* 19816 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19819 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 19819 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19822 */ // Label 407: @19822
     /* 19822 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19833), // Rule ID 329 //
     /* 19827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19830 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 19830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19833 */ // Label 408: @19833
     /* 19833 */ GIM_Reject,
     /* 19834 */ // Label 79: @19834
     /* 19834 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19845), // Rule ID 192 //
     /* 19839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19842 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 19842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19845 */ // Label 409: @19845
     /* 19845 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(19856), // Rule ID 300 //
     /* 19850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19853 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 19853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19856 */ // Label 410: @19856
     /* 19856 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(19867), // Rule ID 330 //
     /* 19861 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19864 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 19864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19867 */ // Label 411: @19867
     /* 19867 */ GIM_Reject,
     /* 19868 */ // Label 80: @19868
     /* 19868 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(19879), // Rule ID 331 //
     /* 19873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19876 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 19876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19879 */ // Label 412: @19879
     /* 19879 */ GIM_Reject,
     /* 19880 */ // Label 81: @19880
     /* 19880 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(19891), // Rule ID 332 //
     /* 19885 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19888 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 19888 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19891 */ // Label 413: @19891
     /* 19891 */ GIM_Reject,
     /* 19892 */ // Label 82: @19892
     /* 19892 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(19903), // Rule ID 193 //
     /* 19897 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19900 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 19900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19903 */ // Label 414: @19903
     /* 19903 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(19914), // Rule ID 301 //
     /* 19908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19911 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 19911 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19914 */ // Label 415: @19914
     /* 19914 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(19925), // Rule ID 333 //
     /* 19919 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19922 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 19922 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19925 */ // Label 416: @19925
     /* 19925 */ GIM_Reject,
     /* 19926 */ // Label 83: @19926
     /* 19926 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19937), // Rule ID 194 //
     /* 19931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19934 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 19934 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19937 */ // Label 417: @19937
     /* 19937 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19948), // Rule ID 302 //
     /* 19942 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19945 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 19945 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19948 */ // Label 418: @19948
     /* 19948 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19959), // Rule ID 334 //
     /* 19953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19956 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 19956 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19959 */ // Label 419: @19959
     /* 19959 */ GIM_Reject,
     /* 19960 */ // Label 84: @19960
     /* 19960 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19971), // Rule ID 147 //
     /* 19965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 19968 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 19968 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 19971 */ // Label 420: @19971
     /* 19971 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19982), // Rule ID 149 //
     /* 19976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 19979 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 19979 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 19982 */ // Label 421: @19982
     /* 19982 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19993), // Rule ID 181 //
     /* 19987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 19990 */   // Combiner Rule #139: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 19990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 19993 */ // Label 422: @19993
     /* 19993 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20004), // Rule ID 197 //
     /* 19998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 20001 */   // Combiner Rule #147: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 20001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 20004 */ // Label 423: @20004
     /* 20004 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20015), // Rule ID 230 //
     /* 20009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20012 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 20012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20015 */ // Label 424: @20015
     /* 20015 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20026), // Rule ID 279 //
     /* 20020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20023 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 20023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20026 */ // Label 425: @20026
     /* 20026 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20049), // Rule ID 110 //
     /* 20031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 20034 */   // MIs[0] dst
     /* 20034 */   // No operand predicates
     /* 20034 */   // MIs[0] lhs
     /* 20034 */   // No operand predicates
     /* 20034 */   // MIs[0] Operand 2
     /* 20034 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 20038 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20043 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 20043 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20048 */   GIR_EraseRootFromParent_Done,
     /* 20049 */ // Label 426: @20049
     /* 20049 */ GIM_Reject,
     /* 20050 */ // Label 85: @20050
     /* 20050 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20061), // Rule ID 243 //
     /* 20055 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20058 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 20058 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20061 */ // Label 427: @20061
     /* 20061 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20072), // Rule ID 290 //
     /* 20066 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20069 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 20069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20072 */ // Label 428: @20072
     /* 20072 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20083), // Rule ID 311 //
     /* 20077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20080 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 20080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20083 */ // Label 429: @20083
     /* 20083 */ GIM_Reject,
     /* 20084 */ // Label 86: @20084
     /* 20084 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20095), // Rule ID 244 //
     /* 20089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20092 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 20092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20095 */ // Label 430: @20095
     /* 20095 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20106), // Rule ID 291 //
     /* 20100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20103 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 20103 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20106 */ // Label 431: @20106
     /* 20106 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20117), // Rule ID 312 //
     /* 20111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20114 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 20114 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20117 */ // Label 432: @20117
     /* 20117 */ GIM_Reject,
     /* 20118 */ // Label 87: @20118
     /* 20118 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(20129), // Rule ID 245 //
     /* 20123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20126 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 20126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20129 */ // Label 433: @20129
     /* 20129 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(20140), // Rule ID 292 //
     /* 20134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20137 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 20137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20140 */ // Label 434: @20140
     /* 20140 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(20151), // Rule ID 313 //
     /* 20145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20148 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 20148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20151 */ // Label 435: @20151
     /* 20151 */ GIM_Reject,
     /* 20152 */ // Label 88: @20152
     /* 20152 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(20163), // Rule ID 246 //
     /* 20157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20160 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 20160 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20163 */ // Label 436: @20163
     /* 20163 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(20174), // Rule ID 293 //
     /* 20168 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20171 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 20171 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20174 */ // Label 437: @20174
     /* 20174 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(20185), // Rule ID 314 //
     /* 20179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20182 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 20182 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20185 */ // Label 438: @20185
     /* 20185 */ GIM_Reject,
     /* 20186 */ // Label 89: @20186
     /* 20186 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(20197), // Rule ID 85 //
     /* 20191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 20194 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 20194 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 20197 */ // Label 439: @20197
     /* 20197 */ GIM_Reject,
     /* 20198 */ // Label 90: @20198
     /* 20198 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(20209), // Rule ID 173 //
     /* 20203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 20206 */   // Combiner Rule #131: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 20206 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 20209 */ // Label 440: @20209
     /* 20209 */ GIM_Reject,
     /* 20210 */ // Label 91: @20210
     /* 20210 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(20221), // Rule ID 26 //
     /* 20215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 20218 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 20221 */ // Label 441: @20221
     /* 20221 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(20232), // Rule ID 66 //
     /* 20226 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 20229 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20229 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 20232 */ // Label 442: @20232
     /* 20232 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(20243), // Rule ID 100 //
     /* 20237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 20240 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20240 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 20243 */ // Label 443: @20243
     /* 20243 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(20282), // Rule ID 38 //
     /* 20248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 20251 */   // MIs[0] root
     /* 20251 */   // No operand predicates
     /* 20251 */   // MIs[0] src
     /* 20251 */   // No operand predicates
     /* 20251 */   // MIs[0] elt
     /* 20251 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 20259 */   // MIs[1] src
     /* 20259 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 20264 */   // MIs[1] idx
     /* 20264 */   // No operand predicates
     /* 20264 */   // MIs[0] idx
     /* 20264 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 20269 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20276 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 20276 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20281 */   GIR_EraseRootFromParent_Done,
     /* 20282 */ // Label 444: @20282
     /* 20282 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(20315), // Rule ID 24 //
     /* 20287 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 20290 */   // MIs[0] root
     /* 20290 */   // No operand predicates
     /* 20290 */   // MIs[0] src
     /* 20290 */   // No operand predicates
     /* 20290 */   // MIs[0] elt
     /* 20290 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20294 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20298 */   // MIs[0] idx
     /* 20298 */   // No operand predicates
     /* 20298 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 20302 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20309 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 20309 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20314 */   GIR_EraseRootFromParent_Done,
     /* 20315 */ // Label 445: @20315
     /* 20315 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(20339), // Rule ID 23 //
     /* 20320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 20323 */   // MIs[0] root
     /* 20323 */   // No operand predicates
     /* 20323 */   // MIs[0] src
     /* 20323 */   // No operand predicates
     /* 20323 */   // MIs[0] elt
     /* 20323 */   // No operand predicates
     /* 20323 */   // MIs[0] idx
     /* 20323 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20333 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 20333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20336 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20338 */   GIR_EraseRootFromParent_Done,
     /* 20339 */ // Label 446: @20339
     /* 20339 */ GIM_Reject,
     /* 20340 */ // Label 92: @20340
     /* 20340 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(20351), // Rule ID 25 //
     /* 20345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 20348 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 20351 */ // Label 447: @20351
     /* 20351 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(20362), // Rule ID 67 //
     /* 20356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 20359 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 20362 */ // Label 448: @20362
     /* 20362 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(20373), // Rule ID 73 //
     /* 20367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 20370 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 20373 */ // Label 449: @20373
     /* 20373 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(20384), // Rule ID 101 //
     /* 20378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 20381 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 20384 */ // Label 450: @20384
     /* 20384 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(20408), // Rule ID 36 //
     /* 20389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 20392 */   // MIs[0] root
     /* 20392 */   // No operand predicates
     /* 20392 */   // MIs[0] src
     /* 20392 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20400 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 20403 */   // MIs[1] x
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] y
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] z
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] a
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] b
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] c
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] d
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[1] e
     /* 20403 */   // No operand predicates
     /* 20403 */   // MIs[0] idx
     /* 20403 */   // No operand predicates
     /* 20403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20405 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 20405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20408 */ // Label 451: @20408
     /* 20408 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(20432), // Rule ID 35 //
     /* 20413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 20416 */   // MIs[0] root
     /* 20416 */   // No operand predicates
     /* 20416 */   // MIs[0] src
     /* 20416 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20424 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 20427 */   // MIs[1] x
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[1] y
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[1] z
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[1] a
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[1] b
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[1] c
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[1] d
     /* 20427 */   // No operand predicates
     /* 20427 */   // MIs[0] idx
     /* 20427 */   // No operand predicates
     /* 20427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20429 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 20429 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20432 */ // Label 452: @20432
     /* 20432 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(20456), // Rule ID 34 //
     /* 20437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 20440 */   // MIs[0] root
     /* 20440 */   // No operand predicates
     /* 20440 */   // MIs[0] src
     /* 20440 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20448 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 20451 */   // MIs[1] x
     /* 20451 */   // No operand predicates
     /* 20451 */   // MIs[1] y
     /* 20451 */   // No operand predicates
     /* 20451 */   // MIs[1] z
     /* 20451 */   // No operand predicates
     /* 20451 */   // MIs[1] a
     /* 20451 */   // No operand predicates
     /* 20451 */   // MIs[1] b
     /* 20451 */   // No operand predicates
     /* 20451 */   // MIs[1] c
     /* 20451 */   // No operand predicates
     /* 20451 */   // MIs[0] idx
     /* 20451 */   // No operand predicates
     /* 20451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20453 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 20453 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20456 */ // Label 453: @20456
     /* 20456 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(20480), // Rule ID 33 //
     /* 20461 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 20464 */   // MIs[0] root
     /* 20464 */   // No operand predicates
     /* 20464 */   // MIs[0] src
     /* 20464 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20472 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 20475 */   // MIs[1] x
     /* 20475 */   // No operand predicates
     /* 20475 */   // MIs[1] y
     /* 20475 */   // No operand predicates
     /* 20475 */   // MIs[1] z
     /* 20475 */   // No operand predicates
     /* 20475 */   // MIs[1] a
     /* 20475 */   // No operand predicates
     /* 20475 */   // MIs[1] b
     /* 20475 */   // No operand predicates
     /* 20475 */   // MIs[0] idx
     /* 20475 */   // No operand predicates
     /* 20475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20477 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 20477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20480 */ // Label 454: @20480
     /* 20480 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(20504), // Rule ID 32 //
     /* 20485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 20488 */   // MIs[0] root
     /* 20488 */   // No operand predicates
     /* 20488 */   // MIs[0] src
     /* 20488 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20496 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 20499 */   // MIs[1] x
     /* 20499 */   // No operand predicates
     /* 20499 */   // MIs[1] y
     /* 20499 */   // No operand predicates
     /* 20499 */   // MIs[1] z
     /* 20499 */   // No operand predicates
     /* 20499 */   // MIs[1] a
     /* 20499 */   // No operand predicates
     /* 20499 */   // MIs[0] idx
     /* 20499 */   // No operand predicates
     /* 20499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20501 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 20501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20504 */ // Label 455: @20504
     /* 20504 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(20528), // Rule ID 31 //
     /* 20509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 20512 */   // MIs[0] root
     /* 20512 */   // No operand predicates
     /* 20512 */   // MIs[0] src
     /* 20512 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20520 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 20523 */   // MIs[1] x
     /* 20523 */   // No operand predicates
     /* 20523 */   // MIs[1] y
     /* 20523 */   // No operand predicates
     /* 20523 */   // MIs[1] z
     /* 20523 */   // No operand predicates
     /* 20523 */   // MIs[0] idx
     /* 20523 */   // No operand predicates
     /* 20523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20525 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 20525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20528 */ // Label 456: @20528
     /* 20528 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(20562), // Rule ID 27 //
     /* 20533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 20536 */   // MIs[0] root
     /* 20536 */   // No operand predicates
     /* 20536 */   // MIs[0] src
     /* 20536 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 20544 */   // MIs[1] x
     /* 20544 */   // No operand predicates
     /* 20544 */   // MIs[1] value
     /* 20544 */   // No operand predicates
     /* 20544 */   // MIs[1] idx
     /* 20544 */   // No operand predicates
     /* 20544 */   // MIs[0] idx
     /* 20544 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 20549 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 20554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20556 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 20556 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 20561 */   GIR_EraseRootFromParent_Done,
     /* 20562 */ // Label 457: @20562
     /* 20562 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(20583), // Rule ID 28 //
     /* 20567 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 20570 */   // MIs[0] root
     /* 20570 */   // No operand predicates
     /* 20570 */   // MIs[0] src
     /* 20570 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 20578 */   // MIs[1] x
     /* 20578 */   // No operand predicates
     /* 20578 */   // MIs[1] value
     /* 20578 */   // No operand predicates
     /* 20578 */   // MIs[1] idx2
     /* 20578 */   // No operand predicates
     /* 20578 */   // MIs[0] idx1
     /* 20578 */   // No operand predicates
     /* 20578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20580 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 20580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 20583 */ // Label 458: @20583
     /* 20583 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(20612), // Rule ID 37 //
     /* 20588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 20591 */   // MIs[0] root
     /* 20591 */   // No operand predicates
     /* 20591 */   // MIs[0] src
     /* 20591 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 20599 */   // MIs[1] src1
     /* 20599 */   // No operand predicates
     /* 20599 */   // MIs[1] src2
     /* 20599 */   // No operand predicates
     /* 20599 */   // MIs[1] mask
     /* 20599 */   // No operand predicates
     /* 20599 */   // MIs[0] idx
     /* 20599 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 20603 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20607 */   // MIs[2] imm
     /* 20607 */   // No operand predicates
     /* 20607 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20609 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 20609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 20612 */ // Label 459: @20612
     /* 20612 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(20636), // Rule ID 30 //
     /* 20617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 20620 */   // MIs[0] root
     /* 20620 */   // No operand predicates
     /* 20620 */   // MIs[0] src
     /* 20620 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20628 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 20631 */   // MIs[1] x
     /* 20631 */   // No operand predicates
     /* 20631 */   // MIs[1] y
     /* 20631 */   // No operand predicates
     /* 20631 */   // MIs[0] idx
     /* 20631 */   // No operand predicates
     /* 20631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20633 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 20633 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20636 */ // Label 460: @20636
     /* 20636 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(20668), // Rule ID 29 //
     /* 20641 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 20644 */   // MIs[0] root
     /* 20644 */   // No operand predicates
     /* 20644 */   // MIs[0] src
     /* 20644 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 20652 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 20655 */   // MIs[1] unused
     /* 20655 */   // No operand predicates
     /* 20655 */   // MIs[0] idx
     /* 20655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 20659 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20663 */   // MIs[2] imm
     /* 20663 */   // No operand predicates
     /* 20663 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20665 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 20665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 20668 */ // Label 461: @20668
     /* 20668 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(20692), // Rule ID 21 //
     /* 20673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 20676 */   // MIs[0] root
     /* 20676 */   // No operand predicates
     /* 20676 */   // MIs[0] vector
     /* 20676 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20684 */   // MIs[0] idx
     /* 20684 */   // No operand predicates
     /* 20684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20686 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 20686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20689 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20691 */   GIR_EraseRootFromParent_Done,
     /* 20692 */ // Label 462: @20692
     /* 20692 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(20716), // Rule ID 22 //
     /* 20697 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 20700 */   // MIs[0] root
     /* 20700 */   // No operand predicates
     /* 20700 */   // MIs[0] vector
     /* 20700 */   // No operand predicates
     /* 20700 */   // MIs[0] idx
     /* 20700 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20710 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 20710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20713 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20715 */   GIR_EraseRootFromParent_Done,
     /* 20716 */ // Label 463: @20716
     /* 20716 */ GIM_Reject,
     /* 20717 */ // Label 93: @20717
     /* 20717 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(20728), // Rule ID 96 //
     /* 20722 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 20725 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20725 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 20728 */ // Label 464: @20728
     /* 20728 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(20739), // Rule ID 98 //
     /* 20733 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 20736 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20736 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 20739 */ // Label 465: @20739
     /* 20739 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(20750), // Rule ID 342 //
     /* 20744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 20747 */   // Combiner Rule #197: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 20750 */ // Label 466: @20750
     /* 20750 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(20761), // Rule ID 344 //
     /* 20755 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 20758 */   // Combiner Rule #199: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20758 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 20761 */ // Label 467: @20761
     /* 20761 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(20782), // Rule ID 343 //
     /* 20766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 20769 */   // MIs[0] root
     /* 20769 */   // No operand predicates
     /* 20769 */   // MIs[0] src1
     /* 20769 */   // No operand predicates
     /* 20769 */   // MIs[0] undef
     /* 20769 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20777 */   // MIs[0] mask
     /* 20777 */   // No operand predicates
     /* 20777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20779 */   // Combiner Rule #198: combine_shuffle_undef_rhs
     /* 20779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 20782 */ // Label 468: @20782
     /* 20782 */ GIM_Reject,
     /* 20783 */ // Label 94: @20783
     /* 20783 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(20827), // Rule ID 221 //
     /* 20788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 20791 */   // MIs[0] d
     /* 20791 */   // No operand predicates
     /* 20791 */   // MIs[0] src
     /* 20791 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 20799 */   // MIs[1] rev
     /* 20799 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 20803 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 20807 */   // MIs[2] val
     /* 20807 */   // No operand predicates
     /* 20807 */   // MIs[1] amt
     /* 20807 */   // No operand predicates
     /* 20807 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 20811 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20813 */   // Combiner Rule #158: bitreverse_lshr
     /* 20813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 20816 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 20818 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 20822 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 20826 */   GIR_EraseRootFromParent_Done,
     /* 20827 */ // Label 469: @20827
     /* 20827 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(20871), // Rule ID 220 //
     /* 20832 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 20835 */   // MIs[0] d
     /* 20835 */   // No operand predicates
     /* 20835 */   // MIs[0] src
     /* 20835 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 20843 */   // MIs[1] rev
     /* 20843 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 20847 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 20851 */   // MIs[2] val
     /* 20851 */   // No operand predicates
     /* 20851 */   // MIs[1] amt
     /* 20851 */   // No operand predicates
     /* 20851 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 20855 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20857 */   // Combiner Rule #157: bitreverse_shl
     /* 20857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 20860 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 20862 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 20866 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 20870 */   GIR_EraseRootFromParent_Done,
     /* 20871 */ // Label 470: @20871
     /* 20871 */ GIM_Reject,
     /* 20872 */ // Label 95: @20872
     /* 20872 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(20883), // Rule ID 371 //
     /* 20877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 20880 */   // Combiner Rule #219: rcp_sqrt_to_rsq; wip_match_opcode 'G_FSQRT'
     /* 20880 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 20883 */ // Label 471: @20883
     /* 20883 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(20904), // Rule ID 176 //
     /* 20888 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 20891 */   // MIs[0] dst
     /* 20891 */   // No operand predicates
     /* 20891 */   // MIs[0] src0
     /* 20891 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 20899 */   // MIs[1] cst
     /* 20899 */   // No operand predicates
     /* 20899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20901 */   // Combiner Rule #134: constant_fold_fsqrt
     /* 20901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 20904 */ // Label 472: @20904
     /* 20904 */ GIM_Reject,
     /* 20905 */ // Label 96: @20905
     /* 20905 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(20916), // Rule ID 364 //
     /* 20910 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20913 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE0'
     /* 20913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20916 */ // Label 473: @20916
     /* 20916 */ GIM_Reject,
     /* 20917 */ // Label 97: @20917
     /* 20917 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(20928), // Rule ID 365 //
     /* 20922 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20925 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE1'
     /* 20925 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20928 */ // Label 474: @20928
     /* 20928 */ GIM_Reject,
     /* 20929 */ // Label 98: @20929
     /* 20929 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(20940), // Rule ID 366 //
     /* 20934 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20937 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE2'
     /* 20937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20940 */ // Label 475: @20940
     /* 20940 */ GIM_Reject,
     /* 20941 */ // Label 99: @20941
     /* 20941 */ GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(20952), // Rule ID 367 //
     /* 20946 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20949 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE3'
     /* 20949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20952 */ // Label 476: @20952
     /* 20952 */ GIM_Reject,
     /* 20953 */ // Label 100: @20953
     /* 20953 */ GIM_Reject,
     /* 20954 */ }; // Size: 20954 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

