/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AMDGPUPreLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AMDGPUPreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 191;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 142;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 141;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 196;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 190;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 194;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 195;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 210;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 185;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 129;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 204;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 143;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 187;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 173;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 130;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 125;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 171;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 172;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 159;	 // "commute_shift"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oldable_fneg", 12) != 0)
        break;
      return 214;	 // "foldable_fneg"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 122;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 203;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 123;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 169;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 202;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 205;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 157;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 168;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 158;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 150;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 140;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 127;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "lamp_i64_to_i16", 15) != 0)
        break;
      return 213;	 // "clamp_i64_to_i16"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 186;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 119;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 166;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 151;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 147;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 121;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 148;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 126;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 144;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 133;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 132;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 145;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 98;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 55;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 116;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 139;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 164;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 135;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 134;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 101;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 209;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 120;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 192;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 175;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 208;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 117;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 124;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 207;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 193;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 167;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 136;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 206;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 197;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 165;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 184;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 155;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 156;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 153;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 211;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 174;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 154;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 137;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 118;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 128;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 146;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 161;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 198;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 189;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 152;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 200;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 188;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 201;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 131;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 149;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 163;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 199;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 160;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 176;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 180;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fmul_with_select_to_fldexp", 33) != 0)
        break;
      return 212;	 // "combine_fmul_with_select_to_fldexp"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_all_elts_from_build_vector", 33) != 0)
        break;
      return 66;	 // "extract_all_elts_from_build_vector"
    }
    break;
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 178;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 181;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 177;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 182;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 183;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 215}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AMDGPUPreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AMDGPUPreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AMDGPUPreLegalizerCombinerOption;
static cl::list<std::string> AMDGPUPreLegalizerCombinerDisableOption(
    "amdgpuprelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AMDGPUPreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AMDGPUPreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AMDGPUPreLegalizerCombinerOnlyEnableOption(
    "amdgpuprelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AMDGPUPreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AMDGPUPreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AMDGPUPreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AMDGPUPreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AMDGPUPreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AMDGPUPreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUPreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUPreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUPreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUPreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AMDGPUPreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void AMDGPUPreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUPreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AMDGPUPreLegalizerCombinerImpl::ComplexMatcherMemFn
AMDGPUPreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
};
bool AMDGPUPreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
};

bool AMDGPUPreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AMDGPUPreLegalizerCombinerImpl::CustomRendererFn
AMDGPUPreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AMDGPUPreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
};
bool AMDGPUPreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getKnownBits()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineFmulWithSelectToFldexp(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    ClampI64ToI16MatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchClampI64ToI16(*State.MIs[0], MRI, MF, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyClampI64ToI16(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUPreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(260), /*)*//*default:*//*Label 95*/ GIMT_Encode4(6988),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(982),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1539),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1814),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(1980),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2053),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2137),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2182), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2249),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2530),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(2775), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(2876), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(2888), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(2955),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(3029),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(3077),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(3089),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(3101),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(3144),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(3177),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(3220), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(3284),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(3296),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(3308), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(3320), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  454 */ /*TargetOpcode::G_ANYEXT*//*Label 25*/ GIMT_Encode4(3332),
     /*  458 */ /*TargetOpcode::G_TRUNC*//*Label 26*/ GIMT_Encode4(3460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_SEXT*//*Label 27*/ GIMT_Encode4(3829),
     /*  482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 28*/ GIMT_Encode4(3910),
     /*  486 */ /*TargetOpcode::G_ZEXT*//*Label 29*/ GIMT_Encode4(3955),
     /*  490 */ /*TargetOpcode::G_SHL*//*Label 30*/ GIMT_Encode4(4085),
     /*  494 */ /*TargetOpcode::G_LSHR*//*Label 31*/ GIMT_Encode4(4254),
     /*  498 */ /*TargetOpcode::G_ASHR*//*Label 32*/ GIMT_Encode4(4377),
     /*  502 */ /*TargetOpcode::G_FSHL*//*Label 33*/ GIMT_Encode4(4511),
     /*  506 */ /*TargetOpcode::G_FSHR*//*Label 34*/ GIMT_Encode4(4554),
     /*  510 */ /*TargetOpcode::G_ROTR*//*Label 35*/ GIMT_Encode4(4597),
     /*  514 */ /*TargetOpcode::G_ROTL*//*Label 36*/ GIMT_Encode4(4621),
     /*  518 */ /*TargetOpcode::G_ICMP*//*Label 37*/ GIMT_Encode4(4645),
     /*  522 */ /*TargetOpcode::G_FCMP*//*Label 38*/ GIMT_Encode4(4690), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  534 */ /*TargetOpcode::G_SELECT*//*Label 39*/ GIMT_Encode4(4702),
     /*  538 */ /*TargetOpcode::G_UADDO*//*Label 40*/ GIMT_Encode4(4797),
     /*  542 */ /*TargetOpcode::G_UADDE*//*Label 41*/ GIMT_Encode4(4820),
     /*  546 */ /*TargetOpcode::G_USUBO*//*Label 42*/ GIMT_Encode4(4832),
     /*  550 */ /*TargetOpcode::G_USUBE*//*Label 43*/ GIMT_Encode4(4844),
     /*  554 */ /*TargetOpcode::G_SADDO*//*Label 44*/ GIMT_Encode4(4856),
     /*  558 */ /*TargetOpcode::G_SADDE*//*Label 45*/ GIMT_Encode4(4879),
     /*  562 */ /*TargetOpcode::G_SSUBO*//*Label 46*/ GIMT_Encode4(4891),
     /*  566 */ /*TargetOpcode::G_SSUBE*//*Label 47*/ GIMT_Encode4(4903),
     /*  570 */ /*TargetOpcode::G_UMULO*//*Label 48*/ GIMT_Encode4(4915),
     /*  574 */ /*TargetOpcode::G_SMULO*//*Label 49*/ GIMT_Encode4(4949),
     /*  578 */ /*TargetOpcode::G_UMULH*//*Label 50*/ GIMT_Encode4(4983),
     /*  582 */ /*TargetOpcode::G_SMULH*//*Label 51*/ GIMT_Encode4(5006),
     /*  586 */ /*TargetOpcode::G_UADDSAT*//*Label 52*/ GIMT_Encode4(5018),
     /*  590 */ /*TargetOpcode::G_SADDSAT*//*Label 53*/ GIMT_Encode4(5030), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  602 */ /*TargetOpcode::G_USHLSAT*//*Label 54*/ GIMT_Encode4(5042),
     /*  606 */ /*TargetOpcode::G_SSHLSAT*//*Label 55*/ GIMT_Encode4(5065),
     /*  610 */ /*TargetOpcode::G_SMULFIX*//*Label 56*/ GIMT_Encode4(5088),
     /*  614 */ /*TargetOpcode::G_UMULFIX*//*Label 57*/ GIMT_Encode4(5100),
     /*  618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 58*/ GIMT_Encode4(5112),
     /*  622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 59*/ GIMT_Encode4(5124), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  642 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(5136),
     /*  646 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(5248),
     /*  650 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(5337),
     /*  654 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(5446),
     /*  658 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(5469),
     /*  662 */ /*TargetOpcode::G_FDIV*//*Label 65*/ GIMT_Encode4(5492),
     /*  666 */ /*TargetOpcode::G_FREM*//*Label 66*/ GIMT_Encode4(5526), GIMT_Encode4(0),
     /*  674 */ /*TargetOpcode::G_FPOWI*//*Label 67*/ GIMT_Encode4(5538), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FLOG2*//*Label 68*/ GIMT_Encode4(5560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  710 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(5582), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FPTRUNC*//*Label 70*/ GIMT_Encode4(5644),
     /*  722 */ /*TargetOpcode::G_FPTOSI*//*Label 71*/ GIMT_Encode4(5687),
     /*  726 */ /*TargetOpcode::G_FPTOUI*//*Label 72*/ GIMT_Encode4(5709),
     /*  730 */ /*TargetOpcode::G_SITOFP*//*Label 73*/ GIMT_Encode4(5731),
     /*  734 */ /*TargetOpcode::G_UITOFP*//*Label 74*/ GIMT_Encode4(5758), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  746 */ /*TargetOpcode::G_FABS*//*Label 75*/ GIMT_Encode4(5785), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 76*/ GIMT_Encode4(5864),
     /*  762 */ /*TargetOpcode::G_FMINNUM*//*Label 77*/ GIMT_Encode4(5894),
     /*  766 */ /*TargetOpcode::G_FMAXNUM*//*Label 78*/ GIMT_Encode4(5928),
     /*  770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 79*/ GIMT_Encode4(5962),
     /*  774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 80*/ GIMT_Encode4(5974),
     /*  778 */ /*TargetOpcode::G_FMINIMUM*//*Label 81*/ GIMT_Encode4(5986),
     /*  782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 82*/ GIMT_Encode4(6020), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  810 */ /*TargetOpcode::G_PTR_ADD*//*Label 83*/ GIMT_Encode4(6054), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_SMIN*//*Label 84*/ GIMT_Encode4(6144),
     /*  822 */ /*TargetOpcode::G_SMAX*//*Label 85*/ GIMT_Encode4(6178),
     /*  826 */ /*TargetOpcode::G_UMIN*//*Label 86*/ GIMT_Encode4(6212),
     /*  830 */ /*TargetOpcode::G_UMAX*//*Label 87*/ GIMT_Encode4(6246),
     /*  834 */ /*TargetOpcode::G_ABS*//*Label 88*/ GIMT_Encode4(6280), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(6292), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(6304),
     /*  870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(6434),
     /*  874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 92*/ GIMT_Encode4(6811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  914 */ /*TargetOpcode::G_BITREVERSE*//*Label 93*/ GIMT_Encode4(6877), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  966 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(6966),
     /*  970 */ // Label 0: @970
     /*  970 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(981), // Rule ID 13 //
     /*  975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  978 */   // MIs[0] d
     /*  978 */   // No operand predicates
     /*  978 */   // MIs[0] s
     /*  978 */   // No operand predicates
     /*  978 */   // Combiner Rule #13: copy_prop
     /*  978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  981 */ // Label 96: @981
     /*  981 */ GIM_Reject,
     /*  982 */ // Label 1: @982
     /*  982 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(993), // Rule ID 16 //
     /*  987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /*  990 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /*  990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /*  993 */ // Label 97: @993
     /*  993 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1004), // Rule ID 93 //
     /*  998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1001 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1004 */ // Label 98: @1004
     /* 1004 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1015), // Rule ID 140 //
     /* 1009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 1012 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 1015 */ // Label 99: @1015
     /* 1015 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1026), // Rule ID 229 //
     /* 1020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 1023 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1026 */ // Label 100: @1026
     /* 1026 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1037), // Rule ID 277 //
     /* 1031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 1034 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1037 */ // Label 101: @1037
     /* 1037 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1048), // Rule ID 306 //
     /* 1042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 1045 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1048 */ // Label 102: @1048
     /* 1048 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1082), // Rule ID 0 //
     /* 1053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1056 */   // MIs[0] root
     /* 1056 */   // No operand predicates
     /* 1056 */   // MIs[0] sub
     /* 1056 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1064 */   // MIs[1] Operand 1
     /* 1064 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1068 */   // MIs[1] A
     /* 1068 */   // No operand predicates
     /* 1068 */   // MIs[0] B
     /* 1068 */   // No operand predicates
     /* 1068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1070 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1073 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1075 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1077 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1081 */   GIR_EraseRootFromParent_Done,
     /* 1082 */ // Label 103: @1082
     /* 1082 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1119), // Rule ID 12 //
     /* 1087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1090 */   // MIs[0] root
     /* 1090 */   // No operand predicates
     /* 1090 */   // MIs[0] sub
     /* 1090 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1098 */   // MIs[1] A
     /* 1098 */   // No operand predicates
     /* 1098 */   // MIs[1] c1
     /* 1098 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1102 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1106 */   // MIs[2] imm1
     /* 1106 */   // No operand predicates
     /* 1106 */   // MIs[0] c2
     /* 1106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1110 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1114 */   // MIs[3] imm2
     /* 1114 */   // No operand predicates
     /* 1114 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1116 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1119 */ // Label 104: @1119
     /* 1119 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1153), // Rule ID 3 //
     /* 1124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1127 */   // MIs[0] root
     /* 1127 */   // No operand predicates
     /* 1127 */   // MIs[0] sub
     /* 1127 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1135 */   // MIs[1] B
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[1] A
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[0] A
     /* 1135 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1140 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1147 */   // Combiner Rule #3: BMinusAPlusA
     /* 1147 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1152 */   GIR_EraseRootFromParent_Done,
     /* 1153 */ // Label 105: @1153
     /* 1153 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1187), // Rule ID 130 //
     /* 1158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1161 */   // MIs[0] dst
     /* 1161 */   // No operand predicates
     /* 1161 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1169 */   // MIs[1] src
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1169 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1174 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1181 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1181 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1186 */   GIR_EraseRootFromParent_Done,
     /* 1187 */ // Label 106: @1187
     /* 1187 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1232), // Rule ID 5 //
     /* 1192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1195 */   // MIs[0] root
     /* 1195 */   // No operand predicates
     /* 1195 */   // MIs[0] sub1
     /* 1195 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1203 */   // MIs[1] A
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[1] B
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[0] sub2
     /* 1203 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1207 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1211 */   // MIs[2] B
     /* 1211 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1216 */   // MIs[2] C
     /* 1216 */   // No operand predicates
     /* 1216 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1218 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1221 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1223 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1227 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1231 */   GIR_EraseRootFromParent_Done,
     /* 1232 */ // Label 107: @1232
     /* 1232 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1277), // Rule ID 4 //
     /* 1237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1240 */   // MIs[0] root
     /* 1240 */   // No operand predicates
     /* 1240 */   // MIs[0] sub1
     /* 1240 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1248 */   // MIs[1] A
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[1] B
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[0] sub2
     /* 1248 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1252 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1256 */   // MIs[2] C
     /* 1256 */   // No operand predicates
     /* 1256 */   // MIs[2] A
     /* 1256 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1261 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1263 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1266 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1268 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1272 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1276 */   GIR_EraseRootFromParent_Done,
     /* 1277 */ // Label 108: @1277
     /* 1277 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1312), // Rule ID 39 //
     /* 1282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1285 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1291 */   // MIs[0] root
     /* 1291 */   // No operand predicates
     /* 1291 */   // MIs[0] left
     /* 1291 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1299 */   // MIs[1] imm1
     /* 1299 */   // No operand predicates
     /* 1299 */   // MIs[0] right
     /* 1299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1303 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1307 */   // MIs[2] imm2
     /* 1307 */   // No operand predicates
     /* 1307 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1309 */   // Combiner Rule #37: add_of_vscale
     /* 1309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1312 */ // Label 109: @1312
     /* 1312 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1346), // Rule ID 1 //
     /* 1317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1320 */   // MIs[0] root
     /* 1320 */   // No operand predicates
     /* 1320 */   // MIs[0] A
     /* 1320 */   // No operand predicates
     /* 1320 */   // MIs[0] sub
     /* 1320 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1328 */   // MIs[1] Operand 1
     /* 1328 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1332 */   // MIs[1] B
     /* 1332 */   // No operand predicates
     /* 1332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1337 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1339 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1341 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1345 */   GIR_EraseRootFromParent_Done,
     /* 1346 */ // Label 110: @1346
     /* 1346 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1380), // Rule ID 2 //
     /* 1351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1354 */   // MIs[0] root
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] A
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] sub
     /* 1354 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1362 */   // MIs[1] B
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[1] A
     /* 1362 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1367 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374 */   // Combiner Rule #2: APlusBMinusB
     /* 1374 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1379 */   GIR_EraseRootFromParent_Done,
     /* 1380 */ // Label 111: @1380
     /* 1380 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1414), // Rule ID 129 //
     /* 1385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1388 */   // MIs[0] dst
     /* 1388 */   // No operand predicates
     /* 1388 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1388 */   // No operand predicates
     /* 1388 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1388 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1396 */   // MIs[1] src
     /* 1396 */   // No operand predicates
     /* 1396 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1396 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1401 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1408 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1408 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1413 */   GIR_EraseRootFromParent_Done,
     /* 1414 */ // Label 112: @1414
     /* 1414 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1459), // Rule ID 6 //
     /* 1419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1422 */   // MIs[0] root
     /* 1422 */   // No operand predicates
     /* 1422 */   // MIs[0] A
     /* 1422 */   // No operand predicates
     /* 1422 */   // MIs[0] sub1
     /* 1422 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1430 */   // MIs[1] B
     /* 1430 */   // No operand predicates
     /* 1430 */   // MIs[1] add1
     /* 1430 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1434 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1438 */   // MIs[2] A
     /* 1438 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1443 */   // MIs[2] C
     /* 1443 */   // No operand predicates
     /* 1443 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1445 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1448 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1450 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1454 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1458 */   GIR_EraseRootFromParent_Done,
     /* 1459 */ // Label 113: @1459
     /* 1459 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1504), // Rule ID 7 //
     /* 1464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1467 */   // MIs[0] root
     /* 1467 */   // No operand predicates
     /* 1467 */   // MIs[0] A
     /* 1467 */   // No operand predicates
     /* 1467 */   // MIs[0] sub1
     /* 1467 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1475 */   // MIs[1] B
     /* 1475 */   // No operand predicates
     /* 1475 */   // MIs[1] add1
     /* 1475 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1479 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1483 */   // MIs[2] C
     /* 1483 */   // No operand predicates
     /* 1483 */   // MIs[2] A
     /* 1483 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1488 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1490 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1493 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1503 */   GIR_EraseRootFromParent_Done,
     /* 1504 */ // Label 114: @1504
     /* 1504 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1527), // Rule ID 104 //
     /* 1509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1512 */   // MIs[0] dst
     /* 1512 */   // No operand predicates
     /* 1512 */   // MIs[0] lhs
     /* 1512 */   // No operand predicates
     /* 1512 */   // MIs[0] Operand 2
     /* 1512 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1516 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1521 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1521 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1526 */   GIR_EraseRootFromParent_Done,
     /* 1527 */ // Label 115: @1527
     /* 1527 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1538), // Rule ID 148 //
     /* 1532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 1535 */   // MIs[0] root
     /* 1535 */   // No operand predicates
     /* 1535 */   // MIs[0] src1
     /* 1535 */   // No operand predicates
     /* 1535 */   // MIs[0] src2
     /* 1535 */   // No operand predicates
     /* 1535 */   // Combiner Rule #106: reassoc_comm_binops
     /* 1535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 1538 */ // Label 116: @1538
     /* 1538 */ GIM_Reject,
     /* 1539 */ // Label 2: @1539
     /* 1539 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1550), // Rule ID 94 //
     /* 1544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1547 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1550 */ // Label 117: @1550
     /* 1550 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1561), // Rule ID 237 //
     /* 1555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 1558 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1558 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1561 */ // Label 118: @1561
     /* 1561 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1572), // Rule ID 278 //
     /* 1566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 1569 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1572 */ // Label 119: @1572
     /* 1572 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1583), // Rule ID 303 //
     /* 1577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1580 */   // Combiner Rule #185: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1583 */ // Label 120: @1583
     /* 1583 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1594), // Rule ID 337 //
     /* 1588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 1591 */   // Combiner Rule #192: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 1594 */ // Label 121: @1594
     /* 1594 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1631), // Rule ID 8 //
     /* 1599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1602 */   // MIs[0] root
     /* 1602 */   // No operand predicates
     /* 1602 */   // MIs[0] add
     /* 1602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1610 */   // MIs[1] A
     /* 1610 */   // No operand predicates
     /* 1610 */   // MIs[1] c1
     /* 1610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1618 */   // MIs[2] imm1
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[0] c2
     /* 1618 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1622 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1626 */   // MIs[3] imm2
     /* 1626 */   // No operand predicates
     /* 1626 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1628 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1631 */ // Label 122: @1631
     /* 1631 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1668), // Rule ID 11 //
     /* 1636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1639 */   // MIs[0] root
     /* 1639 */   // No operand predicates
     /* 1639 */   // MIs[0] sub1
     /* 1639 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1647 */   // MIs[1] c1
     /* 1647 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1651 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1655 */   // MIs[2] imm1
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[1] A
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[0] c2
     /* 1655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1659 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1663 */   // MIs[3] imm2
     /* 1663 */   // No operand predicates
     /* 1663 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1665 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1668 */ // Label 123: @1668
     /* 1668 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1705), // Rule ID 10 //
     /* 1673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1676 */   // MIs[0] root
     /* 1676 */   // No operand predicates
     /* 1676 */   // MIs[0] sub1
     /* 1676 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1684 */   // MIs[1] A
     /* 1684 */   // No operand predicates
     /* 1684 */   // MIs[1] c1
     /* 1684 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1688 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1692 */   // MIs[2] imm1
     /* 1692 */   // No operand predicates
     /* 1692 */   // MIs[0] c2
     /* 1692 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1696 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1700 */   // MIs[3] imm2
     /* 1700 */   // No operand predicates
     /* 1700 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1702 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1702 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1705 */ // Label 124: @1705
     /* 1705 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1742), // Rule ID 9 //
     /* 1710 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1713 */   // MIs[0] root
     /* 1713 */   // No operand predicates
     /* 1713 */   // MIs[0] c2
     /* 1713 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1721 */   // MIs[1] imm2
     /* 1721 */   // No operand predicates
     /* 1721 */   // MIs[0] add
     /* 1721 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1725 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1729 */   // MIs[2] A
     /* 1729 */   // No operand predicates
     /* 1729 */   // MIs[2] c1
     /* 1729 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1733 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1737 */   // MIs[3] imm1
     /* 1737 */   // No operand predicates
     /* 1737 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1739 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1739 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1742 */ // Label 125: @1742
     /* 1742 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1769), // Rule ID 42 //
     /* 1747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1750 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1756 */   // MIs[0] root
     /* 1756 */   // No operand predicates
     /* 1756 */   // MIs[0] x
     /* 1756 */   // No operand predicates
     /* 1756 */   // MIs[0] right
     /* 1756 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1764 */   // MIs[1] imm
     /* 1764 */   // No operand predicates
     /* 1764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1766 */   // Combiner Rule #40: sub_of_vscale
     /* 1766 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 1769 */ // Label 126: @1769
     /* 1769 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1792), // Rule ID 103 //
     /* 1774 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1777 */   // MIs[0] dst
     /* 1777 */   // No operand predicates
     /* 1777 */   // MIs[0] lhs
     /* 1777 */   // No operand predicates
     /* 1777 */   // MIs[0] Operand 2
     /* 1777 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1781 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1786 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1786 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1791 */   GIR_EraseRootFromParent_Done,
     /* 1792 */ // Label 127: @1792
     /* 1792 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1813), // Rule ID 15 //
     /* 1797 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1800 */   // MIs[0] d
     /* 1800 */   // No operand predicates
     /* 1800 */   // MIs[0] op1
     /* 1800 */   // No operand predicates
     /* 1800 */   // MIs[0] c
     /* 1800 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1808 */   // MIs[1] imm
     /* 1808 */   // No operand predicates
     /* 1808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1810 */   // Combiner Rule #15: sub_to_add
     /* 1810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1813 */ // Label 128: @1813
     /* 1813 */ GIM_Reject,
     /* 1814 */ // Label 3: @1814
     /* 1814 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1825), // Rule ID 77 //
     /* 1819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 1822 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1822 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 1825 */ // Label 129: @1825
     /* 1825 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1836), // Rule ID 234 //
     /* 1830 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 1833 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1833 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1836 */ // Label 130: @1836
     /* 1836 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1847), // Rule ID 307 //
     /* 1841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 1844 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1847 */ // Label 131: @1847
     /* 1847 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1887), // Rule ID 17 //
     /* 1852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1855 */   // MIs[0] dst
     /* 1855 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 1859 */   // MIs[0] x
     /* 1859 */   // No operand predicates
     /* 1859 */   // MIs[0] Operand 2
     /* 1859 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 1863 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 1866 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 1876 */   // Combiner Rule #17: mul_by_neg_one
     /* 1876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1884 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1886 */   GIR_EraseRootFromParent_Done,
     /* 1887 */ // Label 132: @1887
     /* 1887 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1922), // Rule ID 40 //
     /* 1892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1895 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1901 */   // MIs[0] root
     /* 1901 */   // No operand predicates
     /* 1901 */   // MIs[0] left
     /* 1901 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1909 */   // MIs[1] scale
     /* 1909 */   // No operand predicates
     /* 1909 */   // MIs[0] x
     /* 1909 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1913 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1917 */   // MIs[2] imm1
     /* 1917 */   // No operand predicates
     /* 1917 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1919 */   // Combiner Rule #38: mul_of_vscale
     /* 1919 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1922 */ // Label 133: @1922
     /* 1922 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1945), // Rule ID 122 //
     /* 1927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 1930 */   // MIs[0] dst
     /* 1930 */   // No operand predicates
     /* 1930 */   // MIs[0] lhs
     /* 1930 */   // No operand predicates
     /* 1930 */   // MIs[0] zero
     /* 1930 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1934 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1939 */   // Combiner Rule #86: binop_right_to_zero
     /* 1939 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1944 */   GIR_EraseRootFromParent_Done,
     /* 1945 */ // Label 134: @1945
     /* 1945 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1968), // Rule ID 127 //
     /* 1950 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 1953 */   // MIs[0] dst
     /* 1953 */   // No operand predicates
     /* 1953 */   // MIs[0] x
     /* 1953 */   // No operand predicates
     /* 1953 */   // MIs[0] Operand 2
     /* 1953 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 1957 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1962 */   // Combiner Rule #91: right_identity_one_int
     /* 1962 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1967 */   GIR_EraseRootFromParent_Done,
     /* 1968 */ // Label 135: @1968
     /* 1968 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(1979), // Rule ID 14 //
     /* 1973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 1976 */   // MIs[0] d
     /* 1976 */   // No operand predicates
     /* 1976 */   // MIs[0] op1
     /* 1976 */   // No operand predicates
     /* 1976 */   // MIs[0] op2
     /* 1976 */   // No operand predicates
     /* 1976 */   // Combiner Rule #14: mul_to_shl
     /* 1976 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 1979 */ // Label 136: @1979
     /* 1979 */ GIM_Reject,
     /* 1980 */ // Label 4: @1980
     /* 1980 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(1991), // Rule ID 118 //
     /* 1985 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 1988 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 1988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 1991 */ // Label 137: @1991
     /* 1991 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2002), // Rule ID 209 //
     /* 1996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 1999 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 1999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2002 */ // Label 138: @2002
     /* 2002 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2013), // Rule ID 240 //
     /* 2007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2010 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2013 */ // Label 139: @2013
     /* 2013 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2024), // Rule ID 258 //
     /* 2018 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 2021 */   // Combiner Rule #170: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2024 */ // Label 140: @2024
     /* 2024 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2035), // Rule ID 283 //
     /* 2029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2032 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2032 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2035 */ // Label 141: @2035
     /* 2035 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2052), // Rule ID 259 //
     /* 2040 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2043 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2049 */   // MIs[0] dst
     /* 2049 */   // No operand predicates
     /* 2049 */   // MIs[0] x
     /* 2049 */   // No operand predicates
     /* 2049 */   // MIs[0] y
     /* 2049 */   // No operand predicates
     /* 2049 */   // Combiner Rule #171: sdiv_by_pow2
     /* 2049 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2052 */ // Label 142: @2052
     /* 2052 */ GIM_Reject,
     /* 2053 */ // Label 5: @2053
     /* 2053 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2064), // Rule ID 80 //
     /* 2058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2061 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2064 */ // Label 143: @2064
     /* 2064 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2075), // Rule ID 119 //
     /* 2069 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2072 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2072 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2075 */ // Label 144: @2075
     /* 2075 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2086), // Rule ID 210 //
     /* 2080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2083 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2086 */ // Label 145: @2086
     /* 2086 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2097), // Rule ID 239 //
     /* 2091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2094 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2094 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2097 */ // Label 146: @2097
     /* 2097 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2108), // Rule ID 257 //
     /* 2102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 2105 */   // Combiner Rule #169: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 2108 */ // Label 147: @2108
     /* 2108 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2119), // Rule ID 285 //
     /* 2113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2116 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2119 */ // Label 148: @2119
     /* 2119 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2136), // Rule ID 260 //
     /* 2124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2127 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2133 */   // MIs[0] dst
     /* 2133 */   // No operand predicates
     /* 2133 */   // MIs[0] x
     /* 2133 */   // No operand predicates
     /* 2133 */   // MIs[0] y
     /* 2133 */   // No operand predicates
     /* 2133 */   // Combiner Rule #172: udiv_by_pow2
     /* 2133 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2136 */ // Label 149: @2136
     /* 2136 */ GIM_Reject,
     /* 2137 */ // Label 6: @2137
     /* 2137 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2148), // Rule ID 120 //
     /* 2142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2145 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2148 */ // Label 150: @2148
     /* 2148 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2159), // Rule ID 211 //
     /* 2153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2156 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2159 */ // Label 151: @2159
     /* 2159 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2170), // Rule ID 242 //
     /* 2164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2167 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2170 */ // Label 152: @2170
     /* 2170 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2181), // Rule ID 284 //
     /* 2175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2178 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2181 */ // Label 153: @2181
     /* 2181 */ GIM_Reject,
     /* 2182 */ // Label 7: @2182
     /* 2182 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2193), // Rule ID 81 //
     /* 2187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2190 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2193 */ // Label 154: @2193
     /* 2193 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2204), // Rule ID 121 //
     /* 2198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2201 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2204 */ // Label 155: @2204
     /* 2204 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2215), // Rule ID 168 //
     /* 2209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 2212 */   // Combiner Rule #126: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2215 */ // Label 156: @2215
     /* 2215 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2226), // Rule ID 212 //
     /* 2220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2223 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2226 */ // Label 157: @2226
     /* 2226 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2237), // Rule ID 241 //
     /* 2231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2234 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2237 */ // Label 158: @2237
     /* 2237 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2248), // Rule ID 286 //
     /* 2242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2245 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2248 */ // Label 159: @2248
     /* 2248 */ GIM_Reject,
     /* 2249 */ // Label 8: @2249
     /* 2249 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2260), // Rule ID 72 //
     /* 2254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 2257 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 2257 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 2260 */ // Label 160: @2260
     /* 2260 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2271), // Rule ID 76 //
     /* 2265 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2268 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2268 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2271 */ // Label 161: @2271
     /* 2271 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2282), // Rule ID 141 //
     /* 2276 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2279 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2279 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2282 */ // Label 162: @2282
     /* 2282 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2293), // Rule ID 160 //
     /* 2287 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 2290 */   // Combiner Rule #118: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2290 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2293 */ // Label 163: @2293
     /* 2293 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2304), // Rule ID 165 //
     /* 2298 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 2301 */   // Combiner Rule #123: redundant_and; wip_match_opcode 'G_AND'
     /* 2301 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 2304 */ // Label 164: @2304
     /* 2304 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2315), // Rule ID 182 //
     /* 2309 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 2312 */   // Combiner Rule #140: overlapping_and; wip_match_opcode 'G_AND'
     /* 2312 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 2315 */ // Label 165: @2315
     /* 2315 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2326), // Rule ID 231 //
     /* 2320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2323 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2326 */ // Label 166: @2326
     /* 2326 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2337), // Rule ID 268 //
     /* 2331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 2334 */   // Combiner Rule #175: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 2337 */ // Label 167: @2337
     /* 2337 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2348), // Rule ID 280 //
     /* 2342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2345 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2348 */ // Label 168: @2348
     /* 2348 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2359), // Rule ID 308 //
     /* 2353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 2356 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2359 */ // Label 169: @2359
     /* 2359 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2370), // Rule ID 335 //
     /* 2364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2367 */   // Combiner Rule #190: match_ands; wip_match_opcode 'G_AND'
     /* 2367 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 2370 */ // Label 170: @2370
     /* 2370 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2468), // Rule ID 154 //
     /* 2375 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 2378 */   // MIs[0] root
     /* 2378 */   // No operand predicates
     /* 2378 */   // MIs[0] d1
     /* 2378 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2386 */   // MIs[1] p
     /* 2386 */   // No operand predicates
     /* 2386 */   // MIs[1] s1
     /* 2386 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2390 */   // MIs[1] Operand 3
     /* 2390 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2394 */   // MIs[0] d2
     /* 2394 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2398 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2402 */   // MIs[2] p
     /* 2402 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2407 */   // MIs[2] s2
     /* 2407 */   // No operand predicates
     /* 2407 */   // MIs[2] Operand 3
     /* 2407 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2411 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2415 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2420 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2433 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 2433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2436 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2441 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2445 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2453 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2457 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2461 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2464 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2467 */   GIR_EraseRootFromParent_Done,
     /* 2468 */ // Label 171: @2468
     /* 2468 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2505), // Rule ID 224 //
     /* 2473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 2476 */   // MIs[0] root
     /* 2476 */   // No operand predicates
     /* 2476 */   // MIs[0] shift
     /* 2476 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2484 */   // MIs[1] x
     /* 2484 */   // No operand predicates
     /* 2484 */   // MIs[1] lsb
     /* 2484 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2488 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2492 */   // MIs[2] imm1
     /* 2492 */   // No operand predicates
     /* 2492 */   // MIs[0] mask
     /* 2492 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2496 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2500 */   // MIs[3] imm2
     /* 2500 */   // No operand predicates
     /* 2500 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2502 */   // Combiner Rule #161: bitfield_extract_from_and
     /* 2502 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 2505 */ // Label 172: @2505
     /* 2505 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2529), // Rule ID 113 //
     /* 2510 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2513 */   // MIs[0] dst
     /* 2513 */   // No operand predicates
     /* 2513 */   // MIs[0] src
     /* 2513 */   // No operand predicates
     /* 2513 */   // MIs[0] src
     /* 2513 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2518 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2523 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2523 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2528 */   GIR_EraseRootFromParent_Done,
     /* 2529 */ // Label 173: @2529
     /* 2529 */ GIM_Reject,
     /* 2530 */ // Label 9: @2530
     /* 2530 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2541), // Rule ID 78 //
     /* 2535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2538 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2541 */ // Label 174: @2541
     /* 2541 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2552), // Rule ID 142 //
     /* 2546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2549 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2552 */ // Label 175: @2552
     /* 2552 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2563), // Rule ID 167 //
     /* 2557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2560 */   // Combiner Rule #125: redundant_or; wip_match_opcode 'G_OR'
     /* 2560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 2563 */ // Label 176: @2563
     /* 2563 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2574), // Rule ID 208 //
     /* 2568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 2571 */   // Combiner Rule #150: load_or_combine; wip_match_opcode 'G_OR'
     /* 2571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 2574 */ // Label 177: @2574
     /* 2574 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2585), // Rule ID 213 //
     /* 2579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2582 */   // Combiner Rule #152: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2582 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2585 */ // Label 178: @2585
     /* 2585 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2596), // Rule ID 235 //
     /* 2590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2593 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2596 */ // Label 179: @2596
     /* 2596 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2607), // Rule ID 281 //
     /* 2601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2604 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2604 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2607 */ // Label 180: @2607
     /* 2607 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2618), // Rule ID 309 //
     /* 2612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 2615 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2618 */ // Label 181: @2618
     /* 2618 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2629), // Rule ID 336 //
     /* 2623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2626 */   // Combiner Rule #191: match_ors; wip_match_opcode 'G_OR'
     /* 2626 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2629 */ // Label 182: @2629
     /* 2629 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2727), // Rule ID 155 //
     /* 2634 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2637 */   // MIs[0] root
     /* 2637 */   // No operand predicates
     /* 2637 */   // MIs[0] d1
     /* 2637 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2645 */   // MIs[1] p
     /* 2645 */   // No operand predicates
     /* 2645 */   // MIs[1] s1
     /* 2645 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2649 */   // MIs[1] Operand 3
     /* 2649 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2653 */   // MIs[0] d2
     /* 2653 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2657 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2661 */   // MIs[2] p
     /* 2661 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2666 */   // MIs[2] s2
     /* 2666 */   // No operand predicates
     /* 2666 */   // MIs[2] Operand 3
     /* 2666 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2670 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2674 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2676 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2679 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2689 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2692 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 2692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2695 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2700 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2704 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2716 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2720 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2723 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2726 */   GIR_EraseRootFromParent_Done,
     /* 2727 */ // Label 183: @2727
     /* 2727 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2751), // Rule ID 114 //
     /* 2732 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2735 */   // MIs[0] dst
     /* 2735 */   // No operand predicates
     /* 2735 */   // MIs[0] src
     /* 2735 */   // No operand predicates
     /* 2735 */   // MIs[0] src
     /* 2735 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2740 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2745 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 2745 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2750 */   GIR_EraseRootFromParent_Done,
     /* 2751 */ // Label 184: @2751
     /* 2751 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2774), // Rule ID 105 //
     /* 2756 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2759 */   // MIs[0] dst
     /* 2759 */   // No operand predicates
     /* 2759 */   // MIs[0] lhs
     /* 2759 */   // No operand predicates
     /* 2759 */   // MIs[0] Operand 2
     /* 2759 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2763 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2768 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 2768 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2773 */   GIR_EraseRootFromParent_Done,
     /* 2774 */ // Label 185: @2774
     /* 2774 */ GIM_Reject,
     /* 2775 */ // Label 10: @2775
     /* 2775 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2786), // Rule ID 95 //
     /* 2780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 2783 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 2783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 2786 */ // Label 186: @2786
     /* 2786 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2797), // Rule ID 143 //
     /* 2791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2794 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 2794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2797 */ // Label 187: @2797
     /* 2797 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2808), // Rule ID 172 //
     /* 2802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 2805 */   // Combiner Rule #130: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 2805 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 2808 */ // Label 188: @2808
     /* 2808 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2819), // Rule ID 196 //
     /* 2813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 2816 */   // Combiner Rule #146: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 2816 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 2819 */ // Label 189: @2819
     /* 2819 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2830), // Rule ID 238 //
     /* 2824 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 2827 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 2827 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2830 */ // Label 190: @2830
     /* 2830 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2841), // Rule ID 282 //
     /* 2835 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 2838 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 2838 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2841 */ // Label 191: @2841
     /* 2841 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2852), // Rule ID 310 //
     /* 2846 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 2849 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 2849 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2852 */ // Label 192: @2852
     /* 2852 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2875), // Rule ID 106 //
     /* 2857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2860 */   // MIs[0] dst
     /* 2860 */   // No operand predicates
     /* 2860 */   // MIs[0] lhs
     /* 2860 */   // No operand predicates
     /* 2860 */   // MIs[0] Operand 2
     /* 2860 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2864 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2869 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 2869 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2874 */   GIR_EraseRootFromParent_Done,
     /* 2875 */ // Label 193: @2875
     /* 2875 */ GIM_Reject,
     /* 2876 */ // Label 11: @2876
     /* 2876 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2887), // Rule ID 139 //
     /* 2881 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 2884 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 2884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 2887 */ // Label 194: @2887
     /* 2887 */ GIM_Reject,
     /* 2888 */ // Label 12: @2888
     /* 2888 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2899), // Rule ID 346 //
     /* 2893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 2896 */   // Combiner Rule #201: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 2899 */ // Label 195: @2899
     /* 2899 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2910), // Rule ID 347 //
     /* 2904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 2907 */   // Combiner Rule #202: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2907 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 2910 */ // Label 196: @2910
     /* 2910 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2921), // Rule ID 349 //
     /* 2915 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 2918 */   // Combiner Rule #204: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2918 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 2921 */ // Label 197: @2921
     /* 2921 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2932), // Rule ID 350 //
     /* 2926 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 2929 */   // Combiner Rule #205: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 2932 */ // Label 198: @2932
     /* 2932 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2943), // Rule ID 351 //
     /* 2937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 2940 */   // Combiner Rule #206: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 2943 */ // Label 199: @2943
     /* 2943 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2954), // Rule ID 352 //
     /* 2948 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 2951 */   // Combiner Rule #207: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2951 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 2954 */ // Label 200: @2954
     /* 2954 */ GIM_Reject,
     /* 2955 */ // Label 13: @2955
     /* 2955 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2966), // Rule ID 348 //
     /* 2960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 2963 */   // Combiner Rule #203: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 2963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 2966 */ // Label 201: @2966
     /* 2966 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3028),
     /* 2971 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 2974 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2995), // Rule ID 353 //
     /* 2979 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 2982 */     // MIs[0] root
     /* 2982 */     // No operand predicates
     /* 2982 */     // MIs[0] x
     /* 2982 */     // No operand predicates
     /* 2982 */     // MIs[0] undef
     /* 2982 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2992 */     // Combiner Rule #208: merge_of_x_and_undef
     /* 2992 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 2995 */   // Label 203: @2995
     /* 2995 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3027), // Rule ID 354 //
     /* 3000 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3003 */     // MIs[0] root
     /* 3003 */     // No operand predicates
     /* 3003 */     // MIs[0] x
     /* 3003 */     // No operand predicates
     /* 3003 */     // MIs[0] zero
     /* 3003 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3011 */     // MIs[1] Operand 1
     /* 3011 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3024 */     // Combiner Rule #209: merge_of_x_and_zero
     /* 3024 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3027 */   // Label 204: @3027
     /* 3027 */   GIM_Reject,
     /* 3028 */ // Label 202: @3028
     /* 3028 */ GIM_Reject,
     /* 3029 */ // Label 14: @3029
     /* 3029 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3040), // Rule ID 68 //
     /* 3034 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3037 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3037 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 3040 */ // Label 205: @3040
     /* 3040 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3051), // Rule ID 97 //
     /* 3045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3048 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3048 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3051 */ // Label 206: @3051
     /* 3051 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3062), // Rule ID 132 //
     /* 3056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3059 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3059 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3062 */ // Label 207: @3062
     /* 3062 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3076), // Rule ID 345 //
     /* 3067 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 3070 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3073 */   // MIs[0] dst
     /* 3073 */   // No operand predicates
     /* 3073 */   // MIs[0] unused
     /* 3073 */   // No operand predicates
     /* 3073 */   // Combiner Rule #200: combine_use_vector_truncate
     /* 3073 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 3076 */ // Label 208: @3076
     /* 3076 */ GIM_Reject,
     /* 3077 */ // Label 15: @3077
     /* 3077 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3088), // Rule ID 131 //
     /* 3082 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3085 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3088 */ // Label 209: @3088
     /* 3088 */ GIM_Reject,
     /* 3089 */ // Label 16: @3089
     /* 3089 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3100), // Rule ID 338 //
     /* 3094 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 3097 */   // Combiner Rule #193: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3097 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 3100 */ // Label 210: @3100
     /* 3100 */ GIM_Reject,
     /* 3101 */ // Label 17: @3101
     /* 3101 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3122), // Rule ID 124 //
     /* 3106 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3109 */   // MIs[0] dst
     /* 3109 */   // No operand predicates
     /* 3109 */   // MIs[0] t
     /* 3109 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3117 */   // MIs[1] ptr
     /* 3117 */   // No operand predicates
     /* 3117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3119 */   // Combiner Rule #88: i2p_to_p2i
     /* 3119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3122 */ // Label 211: @3122
     /* 3122 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3143), // Rule ID 89 //
     /* 3127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3130 */   // MIs[0] dst
     /* 3130 */   // No operand predicates
     /* 3130 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3130 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3138 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3140 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3140 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3143 */ // Label 212: @3143
     /* 3143 */ GIM_Reject,
     /* 3144 */ // Label 18: @3144
     /* 3144 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3155), // Rule ID 123 //
     /* 3149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3152 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 3155 */ // Label 213: @3155
     /* 3155 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3176), // Rule ID 90 //
     /* 3160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3163 */   // MIs[0] dst
     /* 3163 */   // No operand predicates
     /* 3163 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3163 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3173 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3176 */ // Label 214: @3176
     /* 3176 */ GIM_Reject,
     /* 3177 */ // Label 19: @3177
     /* 3177 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3198), // Rule ID 135 //
     /* 3182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3185 */   // MIs[0] dst
     /* 3185 */   // No operand predicates
     /* 3185 */   // MIs[0] src1
     /* 3185 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3193 */   // MIs[1] src0
     /* 3193 */   // No operand predicates
     /* 3193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3195 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 3195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3198 */ // Label 215: @3198
     /* 3198 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3219), // Rule ID 87 //
     /* 3203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3206 */   // MIs[0] dst
     /* 3206 */   // No operand predicates
     /* 3206 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3206 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3216 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3219 */ // Label 216: @3219
     /* 3219 */ GIM_Reject,
     /* 3220 */ // Label 20: @3220
     /* 3220 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3249), // Rule ID 18 //
     /* 3225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3228 */   // MIs[0] dst
     /* 3228 */   // No operand predicates
     /* 3228 */   // MIs[0] src
     /* 3228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3236 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3236 */   // No operand predicates
     /* 3236 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3241 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3243 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3243 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3248 */   GIR_EraseRootFromParent_Done,
     /* 3249 */ // Label 217: @3249
     /* 3249 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3272), // Rule ID 43 //
     /* 3254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3257 */   // MIs[0] root
     /* 3257 */   // No operand predicates
     /* 3257 */   // MIs[0] src
     /* 3257 */   // No operand predicates
     /* 3257 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3261 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3266 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3266 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3271 */   GIR_EraseRootFromParent_Done,
     /* 3272 */ // Label 218: @3272
     /* 3272 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3283), // Rule ID 44 //
     /* 3277 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3280 */   // MIs[0] dst
     /* 3280 */   // No operand predicates
     /* 3280 */   // MIs[0] src
     /* 3280 */   // No operand predicates
     /* 3280 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3280 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3283 */ // Label 219: @3283
     /* 3283 */ GIM_Reject,
     /* 3284 */ // Label 21: @3284
     /* 3284 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3295), // Rule ID 69 //
     /* 3289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3292 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3295 */ // Label 220: @3295
     /* 3295 */ GIM_Reject,
     /* 3296 */ // Label 22: @3296
     /* 3296 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3307), // Rule ID 70 //
     /* 3301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3304 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3307 */ // Label 221: @3307
     /* 3307 */ GIM_Reject,
     /* 3308 */ // Label 23: @3308
     /* 3308 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3319), // Rule ID 71 //
     /* 3313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3316 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3316 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3319 */ // Label 222: @3319
     /* 3319 */ GIM_Reject,
     /* 3320 */ // Label 24: @3320
     /* 3320 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3331), // Rule ID 99 //
     /* 3325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3328 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 3331 */ // Label 223: @3331
     /* 3331 */ GIM_Reject,
     /* 3332 */ // Label 25: @3332
     /* 3332 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3343), // Rule ID 125 //
     /* 3337 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3340 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3340 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3343 */ // Label 224: @3343
     /* 3343 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3354), // Rule ID 255 //
     /* 3348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 3351 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3354 */ // Label 225: @3354
     /* 3354 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3375), // Rule ID 56 //
     /* 3359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 3362 */   // MIs[0] root
     /* 3362 */   // No operand predicates
     /* 3362 */   // MIs[0] select
     /* 3362 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3370 */   // MIs[1] cond
     /* 3370 */   // No operand predicates
     /* 3370 */   // MIs[1] true
     /* 3370 */   // No operand predicates
     /* 3370 */   // MIs[1] false
     /* 3370 */   // No operand predicates
     /* 3370 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3372 */   // Combiner Rule #54: select_of_anyext
     /* 3372 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3375 */ // Label 226: @3375
     /* 3375 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3396), // Rule ID 52 //
     /* 3380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3383 */   // MIs[0] root
     /* 3383 */   // No operand predicates
     /* 3383 */   // MIs[0] second
     /* 3383 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3391 */   // MIs[1] src
     /* 3391 */   // No operand predicates
     /* 3391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3393 */   // Combiner Rule #50: anyext_of_anyext
     /* 3393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3396 */ // Label 227: @3396
     /* 3396 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3417), // Rule ID 54 //
     /* 3401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3404 */   // MIs[0] root
     /* 3404 */   // No operand predicates
     /* 3404 */   // MIs[0] second
     /* 3404 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3412 */   // MIs[1] src
     /* 3412 */   // No operand predicates
     /* 3412 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3414 */   // Combiner Rule #52: anyext_of_sext
     /* 3414 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3417 */ // Label 228: @3417
     /* 3417 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3438), // Rule ID 53 //
     /* 3422 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3425 */   // MIs[0] root
     /* 3425 */   // No operand predicates
     /* 3425 */   // MIs[0] second
     /* 3425 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3433 */   // MIs[1] src
     /* 3433 */   // No operand predicates
     /* 3433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3435 */   // Combiner Rule #51: anyext_of_zext
     /* 3435 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3438 */ // Label 229: @3438
     /* 3438 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3459), // Rule ID 88 //
     /* 3443 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3446 */   // MIs[0] dst
     /* 3446 */   // No operand predicates
     /* 3446 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3446 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3456 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3456 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3459 */ // Label 230: @3459
     /* 3459 */ GIM_Reject,
     /* 3460 */ // Label 26: @3460
     /* 3460 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3471), // Rule ID 133 //
     /* 3465 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3468 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3468 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3471 */ // Label 231: @3471
     /* 3471 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3482), // Rule ID 134 //
     /* 3476 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3479 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3479 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3482 */ // Label 232: @3482
     /* 3482 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3493), // Rule ID 171 //
     /* 3487 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 3490 */   // Combiner Rule #129: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3490 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 3493 */ // Label 233: @3493
     /* 3493 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3504), // Rule ID 360 //
     /* 3498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 3501 */   // Combiner Rule #213: clamp_i64_to_i16; wip_match_opcode 'G_TRUNC'
     /* 3501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 3504 */ // Label 234: @3504
     /* 3504 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3525), // Rule ID 57 //
     /* 3509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3512 */   // MIs[0] root
     /* 3512 */   // No operand predicates
     /* 3512 */   // MIs[0] select
     /* 3512 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3520 */   // MIs[1] cond
     /* 3520 */   // No operand predicates
     /* 3520 */   // MIs[1] true
     /* 3520 */   // No operand predicates
     /* 3520 */   // MIs[1] false
     /* 3520 */   // No operand predicates
     /* 3520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3522 */   // Combiner Rule #55: select_of_truncate
     /* 3522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3525 */ // Label 235: @3525
     /* 3525 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3554), // Rule ID 59 //
     /* 3530 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3533 */   // MIs[0] root
     /* 3533 */   // No operand predicates
     /* 3533 */   // MIs[0] binop
     /* 3533 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3541 */   // MIs[1] x
     /* 3541 */   // No operand predicates
     /* 3541 */   // MIs[1] const
     /* 3541 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3545 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3549 */   // MIs[2] imm
     /* 3549 */   // No operand predicates
     /* 3549 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3551 */   // Combiner Rule #57: narrow_binop_add
     /* 3551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3554 */ // Label 236: @3554
     /* 3554 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3583), // Rule ID 62 //
     /* 3559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3562 */   // MIs[0] root
     /* 3562 */   // No operand predicates
     /* 3562 */   // MIs[0] binop
     /* 3562 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3570 */   // MIs[1] x
     /* 3570 */   // No operand predicates
     /* 3570 */   // MIs[1] const
     /* 3570 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3574 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3578 */   // MIs[2] imm
     /* 3578 */   // No operand predicates
     /* 3578 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3580 */   // Combiner Rule #60: narrow_binop_and
     /* 3580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3583 */ // Label 237: @3583
     /* 3583 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3612), // Rule ID 61 //
     /* 3588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3591 */   // MIs[0] root
     /* 3591 */   // No operand predicates
     /* 3591 */   // MIs[0] binop
     /* 3591 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3599 */   // MIs[1] x
     /* 3599 */   // No operand predicates
     /* 3599 */   // MIs[1] const
     /* 3599 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3603 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3607 */   // MIs[2] imm
     /* 3607 */   // No operand predicates
     /* 3607 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3609 */   // Combiner Rule #59: narrow_binop_mul
     /* 3609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3612 */ // Label 238: @3612
     /* 3612 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3641), // Rule ID 63 //
     /* 3617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3620 */   // MIs[0] root
     /* 3620 */   // No operand predicates
     /* 3620 */   // MIs[0] binop
     /* 3620 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3628 */   // MIs[1] x
     /* 3628 */   // No operand predicates
     /* 3628 */   // MIs[1] const
     /* 3628 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3632 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3636 */   // MIs[2] imm
     /* 3636 */   // No operand predicates
     /* 3636 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3638 */   // Combiner Rule #61: narrow_binop_or
     /* 3638 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3641 */ // Label 239: @3641
     /* 3641 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3670), // Rule ID 60 //
     /* 3646 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3649 */   // MIs[0] root
     /* 3649 */   // No operand predicates
     /* 3649 */   // MIs[0] binop
     /* 3649 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3657 */   // MIs[1] x
     /* 3657 */   // No operand predicates
     /* 3657 */   // MIs[1] const
     /* 3657 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3661 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3665 */   // MIs[2] imm
     /* 3665 */   // No operand predicates
     /* 3665 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3667 */   // Combiner Rule #58: narrow_binop_sub
     /* 3667 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3670 */ // Label 240: @3670
     /* 3670 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3699), // Rule ID 64 //
     /* 3675 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3678 */   // MIs[0] root
     /* 3678 */   // No operand predicates
     /* 3678 */   // MIs[0] binop
     /* 3678 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3686 */   // MIs[1] x
     /* 3686 */   // No operand predicates
     /* 3686 */   // MIs[1] const
     /* 3686 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3690 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3694 */   // MIs[2] imm
     /* 3694 */   // No operand predicates
     /* 3694 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3696 */   // Combiner Rule #62: narrow_binop_xor
     /* 3696 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3699 */ // Label 241: @3699
     /* 3699 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3720), // Rule ID 47 //
     /* 3704 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3707 */   // MIs[0] root
     /* 3707 */   // No operand predicates
     /* 3707 */   // MIs[0] ext
     /* 3707 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3715 */   // MIs[1] src
     /* 3715 */   // No operand predicates
     /* 3715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3717 */   // Combiner Rule #45: truncate_of_anyext
     /* 3717 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3720 */ // Label 242: @3720
     /* 3720 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3744), // Rule ID 58 //
     /* 3725 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3728 */   // MIs[0] root
     /* 3728 */   // No operand predicates
     /* 3728 */   // MIs[0] bv
     /* 3728 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3736 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 3739 */   // MIs[1] unused
     /* 3739 */   // No operand predicates
     /* 3739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3741 */   // Combiner Rule #56: buildvector_of_truncate
     /* 3741 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3744 */ // Label 243: @3744
     /* 3744 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3765), // Rule ID 46 //
     /* 3749 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 3752 */   // MIs[0] root
     /* 3752 */   // No operand predicates
     /* 3752 */   // MIs[0] ext
     /* 3752 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3760 */   // MIs[1] src
     /* 3760 */   // No operand predicates
     /* 3760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3762 */   // Combiner Rule #44: truncate_of_sext
     /* 3762 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3765 */ // Label 244: @3765
     /* 3765 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3786), // Rule ID 45 //
     /* 3770 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 3773 */   // MIs[0] root
     /* 3773 */   // No operand predicates
     /* 3773 */   // MIs[0] ext
     /* 3773 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3781 */   // MIs[1] src
     /* 3781 */   // No operand predicates
     /* 3781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3783 */   // Combiner Rule #43: truncate_of_zext
     /* 3783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3786 */ // Label 245: @3786
     /* 3786 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3807), // Rule ID 86 //
     /* 3791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3794 */   // MIs[0] dst
     /* 3794 */   // No operand predicates
     /* 3794 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3794 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3804 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 3804 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3807 */ // Label 246: @3807
     /* 3807 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3828), // Rule ID 65 //
     /* 3812 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3815 */   // MIs[0] root
     /* 3815 */   // No operand predicates
     /* 3815 */   // MIs[0] int
     /* 3815 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3823 */   // MIs[1] imm
     /* 3823 */   // No operand predicates
     /* 3823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3825 */   // Combiner Rule #63: integer_of_truncate
     /* 3825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3828 */ // Label 247: @3828
     /* 3828 */ GIM_Reject,
     /* 3829 */ // Label 27: @3829
     /* 3829 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3840), // Rule ID 254 //
     /* 3834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 3837 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 3837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3840 */ // Label 248: @3840
     /* 3840 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3861), // Rule ID 51 //
     /* 3845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3848 */   // MIs[0] root
     /* 3848 */   // No operand predicates
     /* 3848 */   // MIs[0] second
     /* 3848 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3856 */   // MIs[1] src
     /* 3856 */   // No operand predicates
     /* 3856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3858 */   // Combiner Rule #49: sext_of_anyext
     /* 3858 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3861 */ // Label 249: @3861
     /* 3861 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3882), // Rule ID 50 //
     /* 3866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3869 */   // MIs[0] root
     /* 3869 */   // No operand predicates
     /* 3869 */   // MIs[0] second
     /* 3869 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3877 */   // MIs[1] src
     /* 3877 */   // No operand predicates
     /* 3877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3879 */   // Combiner Rule #48: sext_of_sext
     /* 3879 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3882 */ // Label 250: @3882
     /* 3882 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3909), // Rule ID 339 //
     /* 3887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 3890 */   // MIs[0] root
     /* 3890 */   // No operand predicates
     /* 3890 */   // MIs[0] src
     /* 3890 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 3898 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 3904 */   // MIs[1] x
     /* 3904 */   // No operand predicates
     /* 3904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3906 */   // Combiner Rule #194: sext_trunc
     /* 3906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3909 */ // Label 251: @3909
     /* 3909 */ GIM_Reject,
     /* 3910 */ // Label 28: @3910
     /* 3910 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3921), // Rule ID 158 //
     /* 3915 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 3918 */   // Combiner Rule #116: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 3918 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 3921 */ // Label 252: @3921
     /* 3921 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3932), // Rule ID 166 //
     /* 3926 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 3929 */   // Combiner Rule #124: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 3932 */ // Label 253: @3932
     /* 3932 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3943), // Rule ID 223 //
     /* 3937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 3940 */   // Combiner Rule #160: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 3943 */ // Label 254: @3943
     /* 3943 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3954), // Rule ID 170 //
     /* 3948 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 3951 */   // MIs[0] dst
     /* 3951 */   // No operand predicates
     /* 3951 */   // MIs[0] src
     /* 3951 */   // No operand predicates
     /* 3951 */   // MIs[0] imm
     /* 3951 */   // No operand predicates
     /* 3951 */   // Combiner Rule #128: sext_inreg_to_zext_inreg
     /* 3951 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 3954 */ // Label 255: @3954
     /* 3954 */ GIM_Reject,
     /* 3955 */ // Label 29: @3955
     /* 3955 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(3966), // Rule ID 169 //
     /* 3960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 3963 */   // Combiner Rule #127: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 3963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 3966 */ // Label 256: @3966
     /* 3966 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(3977), // Rule ID 253 //
     /* 3971 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 3974 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 3974 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3977 */ // Label 257: @3977
     /* 3977 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(3998), // Rule ID 55 //
     /* 3982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 3985 */   // MIs[0] root
     /* 3985 */   // No operand predicates
     /* 3985 */   // MIs[0] select
     /* 3985 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3993 */   // MIs[1] cond
     /* 3993 */   // No operand predicates
     /* 3993 */   // MIs[1] true
     /* 3993 */   // No operand predicates
     /* 3993 */   // MIs[1] false
     /* 3993 */   // No operand predicates
     /* 3993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3995 */   // Combiner Rule #53: select_of_zext
     /* 3995 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3998 */ // Label 258: @3998
     /* 3998 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4019), // Rule ID 49 //
     /* 4003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4006 */   // MIs[0] root
     /* 4006 */   // No operand predicates
     /* 4006 */   // MIs[0] second
     /* 4006 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4014 */   // MIs[1] src
     /* 4014 */   // No operand predicates
     /* 4014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4016 */   // Combiner Rule #47: zext_of_anyext
     /* 4016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4019 */ // Label 259: @4019
     /* 4019 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4046), // Rule ID 340 //
     /* 4024 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 4027 */   // MIs[0] root
     /* 4027 */   // No operand predicates
     /* 4027 */   // MIs[0] src
     /* 4027 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4035 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4041 */   // MIs[1] x
     /* 4041 */   // No operand predicates
     /* 4041 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4043 */   // Combiner Rule #195: zext_trunc
     /* 4043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4046 */ // Label 260: @4046
     /* 4046 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4067), // Rule ID 48 //
     /* 4051 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4054 */   // MIs[0] root
     /* 4054 */   // No operand predicates
     /* 4054 */   // MIs[0] second
     /* 4054 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4062 */   // MIs[1] src
     /* 4062 */   // No operand predicates
     /* 4062 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4064 */   // Combiner Rule #46: zext_of_zext
     /* 4064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4067 */ // Label 261: @4067
     /* 4067 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4084), // Rule ID 341 //
     /* 4072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4075 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4081 */   // MIs[0] root
     /* 4081 */   // No operand predicates
     /* 4081 */   // MIs[0] x
     /* 4081 */   // No operand predicates
     /* 4081 */   // Combiner Rule #196: nneg_zext
     /* 4081 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4084 */ // Label 262: @4084
     /* 4084 */ GIM_Reject,
     /* 4085 */ // Label 30: @4085
     /* 4085 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4096), // Rule ID 79 //
     /* 4090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 4093 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4093 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 4096 */ // Label 263: @4096
     /* 4096 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4107), // Rule ID 82 //
     /* 4101 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4104 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4104 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4107 */ // Label 264: @4107
     /* 4107 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4118), // Rule ID 115 //
     /* 4112 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4115 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4115 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4118 */ // Label 265: @4118
     /* 4118 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4129), // Rule ID 198 //
     /* 4123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 4126 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4129 */ // Label 266: @4129
     /* 4129 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4140), // Rule ID 203 //
     /* 4134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4137 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4140 */ // Label 267: @4140
     /* 4140 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4151), // Rule ID 222 //
     /* 4145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 4148 */   // Combiner Rule #159: commute_shift; wip_match_opcode 'G_SHL'
     /* 4148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4151 */ // Label 268: @4151
     /* 4151 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4162), // Rule ID 236 //
     /* 4156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4159 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4162 */ // Label 269: @4162
     /* 4162 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4173), // Rule ID 289 //
     /* 4167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 4170 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4173 */ // Label 270: @4173
     /* 4173 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4208), // Rule ID 41 //
     /* 4178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4181 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4187 */   // MIs[0] root
     /* 4187 */   // No operand predicates
     /* 4187 */   // MIs[0] left
     /* 4187 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4195 */   // MIs[1] imm
     /* 4195 */   // No operand predicates
     /* 4195 */   // MIs[0] x
     /* 4195 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4199 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4203 */   // MIs[2] imm1
     /* 4203 */   // No operand predicates
     /* 4203 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4205 */   // Combiner Rule #39: shl_of_vscale
     /* 4205 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4208 */ // Label 271: @4208
     /* 4208 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4231), // Rule ID 107 //
     /* 4213 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4216 */   // MIs[0] dst
     /* 4216 */   // No operand predicates
     /* 4216 */   // MIs[0] lhs
     /* 4216 */   // No operand predicates
     /* 4216 */   // MIs[0] Operand 2
     /* 4216 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4220 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4225 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4225 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4230 */   GIR_EraseRootFromParent_Done,
     /* 4231 */ // Label 272: @4231
     /* 4231 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4242), // Rule ID 144 //
     /* 4236 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4239 */   // MIs[0] root
     /* 4239 */   // No operand predicates
     /* 4239 */   // MIs[0] mi.shifted
     /* 4239 */   // No operand predicates
     /* 4239 */   // MIs[0] mi.amt
     /* 4239 */   // No operand predicates
     /* 4239 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 4239 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4242 */ // Label 273: @4242
     /* 4242 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4253), // Rule ID 159 //
     /* 4247 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 4250 */   // MIs[0] dst
     /* 4250 */   // No operand predicates
     /* 4250 */   // MIs[0] src0
     /* 4250 */   // No operand predicates
     /* 4250 */   // MIs[0] src1
     /* 4250 */   // No operand predicates
     /* 4250 */   // Combiner Rule #117: reduce_shl_of_extend
     /* 4250 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4253 */ // Label 274: @4253
     /* 4253 */ GIM_Reject,
     /* 4254 */ // Label 31: @4254
     /* 4254 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4265), // Rule ID 84 //
     /* 4259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4262 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4265 */ // Label 275: @4265
     /* 4265 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4276), // Rule ID 116 //
     /* 4270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4273 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4276 */ // Label 276: @4276
     /* 4276 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4287), // Rule ID 200 //
     /* 4281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 4284 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4287 */ // Label 277: @4287
     /* 4287 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4298), // Rule ID 205 //
     /* 4292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4295 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4295 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4298 */ // Label 278: @4298
     /* 4298 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4309), // Rule ID 226 //
     /* 4303 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4306 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4306 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4309 */ // Label 279: @4309
     /* 4309 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4320), // Rule ID 228 //
     /* 4314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4317 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4320 */ // Label 280: @4320
     /* 4320 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4331), // Rule ID 233 //
     /* 4325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4328 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4331 */ // Label 281: @4331
     /* 4331 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4342), // Rule ID 287 //
     /* 4336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 4339 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4342 */ // Label 282: @4342
     /* 4342 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4365), // Rule ID 109 //
     /* 4347 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4350 */   // MIs[0] dst
     /* 4350 */   // No operand predicates
     /* 4350 */   // MIs[0] lhs
     /* 4350 */   // No operand predicates
     /* 4350 */   // MIs[0] Operand 2
     /* 4350 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4354 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4359 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4359 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4364 */   GIR_EraseRootFromParent_Done,
     /* 4365 */ // Label 283: @4365
     /* 4365 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4376), // Rule ID 146 //
     /* 4370 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4373 */   // MIs[0] root
     /* 4373 */   // No operand predicates
     /* 4373 */   // MIs[0] mi.shifted
     /* 4373 */   // No operand predicates
     /* 4373 */   // MIs[0] mi.amt
     /* 4373 */   // No operand predicates
     /* 4373 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 4373 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4376 */ // Label 284: @4376
     /* 4376 */ GIM_Reject,
     /* 4377 */ // Label 32: @4377
     /* 4377 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4388), // Rule ID 83 //
     /* 4382 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4385 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4385 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4388 */ // Label 285: @4388
     /* 4388 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4399), // Rule ID 117 //
     /* 4393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4396 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4399 */ // Label 286: @4399
     /* 4399 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4410), // Rule ID 157 //
     /* 4404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4407 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4410 */ // Label 287: @4410
     /* 4410 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4421), // Rule ID 199 //
     /* 4415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 4418 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4418 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4421 */ // Label 288: @4421
     /* 4421 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4432), // Rule ID 204 //
     /* 4426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4429 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4429 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4432 */ // Label 289: @4432
     /* 4432 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4443), // Rule ID 225 //
     /* 4437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4440 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4440 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4443 */ // Label 290: @4443
     /* 4443 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4454), // Rule ID 227 //
     /* 4448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4451 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4454 */ // Label 291: @4454
     /* 4454 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4465), // Rule ID 232 //
     /* 4459 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4462 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4462 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4465 */ // Label 292: @4465
     /* 4465 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4476), // Rule ID 288 //
     /* 4470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 4473 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4476 */ // Label 293: @4476
     /* 4476 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4499), // Rule ID 108 //
     /* 4481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4484 */   // MIs[0] dst
     /* 4484 */   // No operand predicates
     /* 4484 */   // MIs[0] lhs
     /* 4484 */   // No operand predicates
     /* 4484 */   // MIs[0] Operand 2
     /* 4484 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4488 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4493 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4493 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4498 */   GIR_EraseRootFromParent_Done,
     /* 4499 */ // Label 294: @4499
     /* 4499 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4510), // Rule ID 145 //
     /* 4504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4507 */   // MIs[0] root
     /* 4507 */   // No operand predicates
     /* 4507 */   // MIs[0] mi.shifted
     /* 4507 */   // No operand predicates
     /* 4507 */   // MIs[0] mi.amt
     /* 4507 */   // No operand predicates
     /* 4507 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 4507 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4510 */ // Label 295: @4510
     /* 4510 */ GIM_Reject,
     /* 4511 */ // Label 33: @4511
     /* 4511 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4522), // Rule ID 214 //
     /* 4516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 4519 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4519 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4522 */ // Label 296: @4522
     /* 4522 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4533), // Rule ID 218 //
     /* 4527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4530 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4530 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4533 */ // Label 297: @4533
     /* 4533 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4553), // Rule ID 217 //
     /* 4538 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4541 */   // MIs[0] x
     /* 4541 */   // No operand predicates
     /* 4541 */   // MIs[0] y
     /* 4541 */   // No operand predicates
     /* 4541 */   // MIs[0] z
     /* 4541 */   // No operand predicates
     /* 4541 */   // MIs[0] Operand 3
     /* 4541 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4545 */   // Combiner Rule #155: funnel_shift_left_zero
     /* 4545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4548 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4550 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4552 */   GIR_EraseRootFromParent_Done,
     /* 4553 */ // Label 298: @4553
     /* 4553 */ GIM_Reject,
     /* 4554 */ // Label 34: @4554
     /* 4554 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4565), // Rule ID 215 //
     /* 4559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 4562 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4565 */ // Label 299: @4565
     /* 4565 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4576), // Rule ID 219 //
     /* 4570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4573 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4576 */ // Label 300: @4576
     /* 4576 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4596), // Rule ID 216 //
     /* 4581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4584 */   // MIs[0] x
     /* 4584 */   // No operand predicates
     /* 4584 */   // MIs[0] y
     /* 4584 */   // No operand predicates
     /* 4584 */   // MIs[0] z
     /* 4584 */   // No operand predicates
     /* 4584 */   // MIs[0] Operand 3
     /* 4584 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4588 */   // Combiner Rule #154: funnel_shift_right_zero
     /* 4588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4591 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4593 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4595 */   GIR_EraseRootFromParent_Done,
     /* 4596 */ // Label 301: @4596
     /* 4596 */ GIM_Reject,
     /* 4597 */ // Label 35: @4597
     /* 4597 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4620), // Rule ID 112 //
     /* 4602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4605 */   // MIs[0] dst
     /* 4605 */   // No operand predicates
     /* 4605 */   // MIs[0] lhs
     /* 4605 */   // No operand predicates
     /* 4605 */   // MIs[0] Operand 2
     /* 4605 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4609 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4614 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4614 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4619 */   GIR_EraseRootFromParent_Done,
     /* 4620 */ // Label 302: @4620
     /* 4620 */ GIM_Reject,
     /* 4621 */ // Label 36: @4621
     /* 4621 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4644), // Rule ID 111 //
     /* 4626 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4629 */   // MIs[0] dst
     /* 4629 */   // No operand predicates
     /* 4629 */   // MIs[0] lhs
     /* 4629 */   // No operand predicates
     /* 4629 */   // MIs[0] Operand 2
     /* 4629 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4633 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4638 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4638 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4643 */   GIR_EraseRootFromParent_Done,
     /* 4644 */ // Label 303: @4644
     /* 4644 */ GIM_Reject,
     /* 4645 */ // Label 37: @4645
     /* 4645 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4656), // Rule ID 152 //
     /* 4650 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4653 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4653 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4656 */ // Label 304: @4656
     /* 4656 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4667), // Rule ID 153 //
     /* 4661 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4664 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4664 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4667 */ // Label 305: @4667
     /* 4667 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4678), // Rule ID 156 //
     /* 4672 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 4675 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4675 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4678 */ // Label 306: @4678
     /* 4678 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4689), // Rule ID 150 //
     /* 4683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 4686 */   // MIs[0] root
     /* 4686 */   // No operand predicates
     /* 4686 */   // MIs[0] pred
     /* 4686 */   // No operand predicates
     /* 4686 */   // MIs[0] lhs
     /* 4686 */   // No operand predicates
     /* 4686 */   // MIs[0] rhs
     /* 4686 */   // No operand predicates
     /* 4686 */   // Combiner Rule #108: canonicalize_icmp
     /* 4686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 4689 */ // Label 307: @4689
     /* 4689 */ GIM_Reject,
     /* 4690 */ // Label 38: @4690
     /* 4690 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4701), // Rule ID 151 //
     /* 4695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4698 */   // MIs[0] root
     /* 4698 */   // No operand predicates
     /* 4698 */   // MIs[0] pred
     /* 4698 */   // No operand predicates
     /* 4698 */   // MIs[0] lhs
     /* 4698 */   // No operand predicates
     /* 4698 */   // MIs[0] rhs
     /* 4698 */   // No operand predicates
     /* 4698 */   // Combiner Rule #109: canonicalize_fcmp
     /* 4698 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4701 */ // Label 308: @4701
     /* 4701 */ GIM_Reject,
     /* 4702 */ // Label 39: @4702
     /* 4702 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4713), // Rule ID 102 //
     /* 4707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 4710 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 4713 */ // Label 309: @4713
     /* 4713 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4724), // Rule ID 162 //
     /* 4718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 4721 */   // Combiner Rule #120: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 4724 */ // Label 310: @4724
     /* 4724 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4735), // Rule ID 164 //
     /* 4729 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 4732 */   // Combiner Rule #122: match_selects; wip_match_opcode 'G_SELECT'
     /* 4732 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 4735 */ // Label 311: @4735
     /* 4735 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4746), // Rule ID 304 //
     /* 4740 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4743 */   // Combiner Rule #186: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 4743 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 4746 */ // Label 312: @4746
     /* 4746 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4767), // Rule ID 163 //
     /* 4751 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 4754 */   // MIs[0] root
     /* 4754 */   // No operand predicates
     /* 4754 */   // MIs[0] tst
     /* 4754 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 4762 */   // MIs[1] tst1
     /* 4762 */   // No operand predicates
     /* 4762 */   // MIs[1] a
     /* 4762 */   // No operand predicates
     /* 4762 */   // MIs[1] b
     /* 4762 */   // No operand predicates
     /* 4762 */   // MIs[0] x
     /* 4762 */   // No operand predicates
     /* 4762 */   // MIs[0] y
     /* 4762 */   // No operand predicates
     /* 4762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4764 */   // Combiner Rule #121: select_to_iminmax
     /* 4764 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 4767 */ // Label 313: @4767
     /* 4767 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4796), // Rule ID 161 //
     /* 4772 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4775 */   // MIs[0] dst
     /* 4775 */   // No operand predicates
     /* 4775 */   // MIs[0] undef
     /* 4775 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4783 */   // MIs[0] x
     /* 4783 */   // No operand predicates
     /* 4783 */   // MIs[0] y
     /* 4783 */   // No operand predicates
     /* 4783 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4788 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4790 */   // Combiner Rule #119: select_undef_cmp
     /* 4790 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4795 */   GIR_EraseRootFromParent_Done,
     /* 4796 */ // Label 314: @4796
     /* 4796 */ GIM_Reject,
     /* 4797 */ // Label 40: @4797
     /* 4797 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4808), // Rule ID 315 //
     /* 4802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 4805 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 4805 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4808 */ // Label 315: @4808
     /* 4808 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4819), // Rule ID 356 //
     /* 4813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 4816 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_UADDO'
     /* 4816 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 4819 */ // Label 316: @4819
     /* 4819 */ GIM_Reject,
     /* 4820 */ // Label 41: @4820
     /* 4820 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4831), // Rule ID 187 //
     /* 4825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4828 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 4828 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4831 */ // Label 317: @4831
     /* 4831 */ GIM_Reject,
     /* 4832 */ // Label 42: @4832
     /* 4832 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4843), // Rule ID 358 //
     /* 4837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 4840 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 4840 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4843 */ // Label 318: @4843
     /* 4843 */ GIM_Reject,
     /* 4844 */ // Label 43: @4844
     /* 4844 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(4855), // Rule ID 189 //
     /* 4849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4852 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 4852 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4855 */ // Label 319: @4855
     /* 4855 */ GIM_Reject,
     /* 4856 */ // Label 44: @4856
     /* 4856 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(4867), // Rule ID 316 //
     /* 4861 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 4864 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 4864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4867 */ // Label 320: @4867
     /* 4867 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(4878), // Rule ID 355 //
     /* 4872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 4875 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_SADDO'
     /* 4875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 4878 */ // Label 321: @4878
     /* 4878 */ GIM_Reject,
     /* 4879 */ // Label 45: @4879
     /* 4879 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(4890), // Rule ID 188 //
     /* 4884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4887 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 4887 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4890 */ // Label 322: @4890
     /* 4890 */ GIM_Reject,
     /* 4891 */ // Label 46: @4891
     /* 4891 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(4902), // Rule ID 357 //
     /* 4896 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 4899 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 4899 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4902 */ // Label 323: @4902
     /* 4902 */ GIM_Reject,
     /* 4903 */ // Label 47: @4903
     /* 4903 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(4914), // Rule ID 190 //
     /* 4908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4911 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 4911 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4914 */ // Label 324: @4914
     /* 4914 */ GIM_Reject,
     /* 4915 */ // Label 48: @4915
     /* 4915 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(4926), // Rule ID 183 //
     /* 4920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 4923 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 4923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 4926 */ // Label 325: @4926
     /* 4926 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(4937), // Rule ID 185 //
     /* 4931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 4934 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 4934 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 4937 */ // Label 326: @4937
     /* 4937 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(4948), // Rule ID 317 //
     /* 4942 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 4945 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 4945 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4948 */ // Label 327: @4948
     /* 4948 */ GIM_Reject,
     /* 4949 */ // Label 49: @4949
     /* 4949 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(4960), // Rule ID 184 //
     /* 4954 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 4957 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 4957 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 4960 */ // Label 328: @4960
     /* 4960 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(4971), // Rule ID 186 //
     /* 4965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 4968 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 4968 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 4971 */ // Label 329: @4971
     /* 4971 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(4982), // Rule ID 318 //
     /* 4976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 4979 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 4979 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4982 */ // Label 330: @4982
     /* 4982 */ GIM_Reject,
     /* 4983 */ // Label 50: @4983
     /* 4983 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(4994), // Rule ID 261 //
     /* 4988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 4991 */   // Combiner Rule #173: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 4991 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 4994 */ // Label 331: @4994
     /* 4994 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5005), // Rule ID 319 //
     /* 4999 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5002 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5002 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5005 */ // Label 332: @5005
     /* 5005 */ GIM_Reject,
     /* 5006 */ // Label 51: @5006
     /* 5006 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5017), // Rule ID 320 //
     /* 5011 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5014 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5017 */ // Label 333: @5017
     /* 5017 */ GIM_Reject,
     /* 5018 */ // Label 52: @5018
     /* 5018 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5029), // Rule ID 321 //
     /* 5023 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5026 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5026 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5029 */ // Label 334: @5029
     /* 5029 */ GIM_Reject,
     /* 5030 */ // Label 53: @5030
     /* 5030 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5041), // Rule ID 322 //
     /* 5035 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5038 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5038 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5041 */ // Label 335: @5041
     /* 5041 */ GIM_Reject,
     /* 5042 */ // Label 54: @5042
     /* 5042 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5053), // Rule ID 202 //
     /* 5047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 5050 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5053 */ // Label 336: @5053
     /* 5053 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5064), // Rule ID 206 //
     /* 5058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5061 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5064 */ // Label 337: @5064
     /* 5064 */ GIM_Reject,
     /* 5065 */ // Label 55: @5065
     /* 5065 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5076), // Rule ID 201 //
     /* 5070 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 5073 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5073 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5076 */ // Label 338: @5076
     /* 5076 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5087), // Rule ID 207 //
     /* 5081 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5084 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5084 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5087 */ // Label 339: @5087
     /* 5087 */ GIM_Reject,
     /* 5088 */ // Label 56: @5088
     /* 5088 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5099), // Rule ID 323 //
     /* 5093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5096 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5096 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5099 */ // Label 340: @5099
     /* 5099 */ GIM_Reject,
     /* 5100 */ // Label 57: @5100
     /* 5100 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5111), // Rule ID 324 //
     /* 5105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5108 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5111 */ // Label 341: @5111
     /* 5111 */ GIM_Reject,
     /* 5112 */ // Label 58: @5112
     /* 5112 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5123), // Rule ID 325 //
     /* 5117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5120 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5120 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5123 */ // Label 342: @5123
     /* 5123 */ GIM_Reject,
     /* 5124 */ // Label 59: @5124
     /* 5124 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5135), // Rule ID 326 //
     /* 5129 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5132 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5135 */ // Label 343: @5135
     /* 5135 */ GIM_Reject,
     /* 5136 */ // Label 60: @5136
     /* 5136 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5147), // Rule ID 247 //
     /* 5141 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5144 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5144 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5147 */ // Label 344: @5147
     /* 5147 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5158), // Rule ID 262 //
     /* 5152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5155 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5158 */ // Label 345: @5158
     /* 5158 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5169), // Rule ID 269 //
     /* 5163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5166 */   // Combiner Rule #176: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5166 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 5169 */ // Label 346: @5169
     /* 5169 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5180), // Rule ID 270 //
     /* 5174 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 5177 */   // Combiner Rule #177: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5177 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5180 */ // Label 347: @5180
     /* 5180 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5191), // Rule ID 271 //
     /* 5185 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5188 */   // Combiner Rule #178: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5191 */ // Label 348: @5191
     /* 5191 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5202), // Rule ID 272 //
     /* 5196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5199 */   // Combiner Rule #179: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5202 */ // Label 349: @5202
     /* 5202 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5213), // Rule ID 295 //
     /* 5207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5210 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5213 */ // Label 350: @5213
     /* 5213 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5224), // Rule ID 327 //
     /* 5218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5221 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5224 */ // Label 351: @5224
     /* 5224 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5247), // Rule ID 137 //
     /* 5229 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5232 */   // MIs[0] dst
     /* 5232 */   // No operand predicates
     /* 5232 */   // MIs[0] x
     /* 5232 */   // No operand predicates
     /* 5232 */   // MIs[0] y
     /* 5232 */   // No operand predicates
     /* 5232 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5236 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5241 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 5241 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5246 */   GIR_EraseRootFromParent_Done,
     /* 5247 */ // Label 352: @5247
     /* 5247 */ GIM_Reject,
     /* 5248 */ // Label 61: @5248
     /* 5248 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5259), // Rule ID 248 //
     /* 5253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5256 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5256 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5259 */ // Label 353: @5259
     /* 5259 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5270), // Rule ID 263 //
     /* 5264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5267 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5267 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5270 */ // Label 354: @5270
     /* 5270 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5281), // Rule ID 273 //
     /* 5275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5278 */   // Combiner Rule #180: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5281 */ // Label 355: @5281
     /* 5281 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5292), // Rule ID 274 //
     /* 5286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5289 */   // Combiner Rule #181: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5289 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5292 */ // Label 356: @5292
     /* 5292 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5303), // Rule ID 275 //
     /* 5297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5300 */   // Combiner Rule #182: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5303 */ // Label 357: @5303
     /* 5303 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5314), // Rule ID 276 //
     /* 5308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5311 */   // Combiner Rule #183: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5314 */ // Label 358: @5314
     /* 5314 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5325), // Rule ID 296 //
     /* 5319 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5322 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5322 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5325 */ // Label 359: @5325
     /* 5325 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5336), // Rule ID 305 //
     /* 5330 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 5333 */   // Combiner Rule #187: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5333 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5336 */ // Label 360: @5336
     /* 5336 */ GIM_Reject,
     /* 5337 */ // Label 62: @5337
     /* 5337 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5348), // Rule ID 249 //
     /* 5342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5345 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5348 */ // Label 361: @5348
     /* 5348 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5359), // Rule ID 264 //
     /* 5353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5356 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5359 */ // Label 362: @5359
     /* 5359 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5370), // Rule ID 294 //
     /* 5364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5367 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5367 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5370 */ // Label 363: @5370
     /* 5370 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5381), // Rule ID 328 //
     /* 5375 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5378 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5378 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5381 */ // Label 364: @5381
     /* 5381 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5402), // Rule ID 359 //
     /* 5386 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5389 */   // MIs[0] dst
     /* 5389 */   // No operand predicates
     /* 5389 */   // MIs[0] x
     /* 5389 */   // No operand predicates
     /* 5389 */   // MIs[0] select
     /* 5389 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 5397 */   // MIs[1] y
     /* 5397 */   // No operand predicates
     /* 5397 */   // MIs[1] A
     /* 5397 */   // No operand predicates
     /* 5397 */   // MIs[1] B
     /* 5397 */   // No operand predicates
     /* 5397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5399 */   // Combiner Rule #212: combine_fmul_with_select_to_fldexp
     /* 5399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5402 */ // Label 365: @5402
     /* 5402 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5425), // Rule ID 128 //
     /* 5407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 5410 */   // MIs[0] dst
     /* 5410 */   // No operand predicates
     /* 5410 */   // MIs[0] x
     /* 5410 */   // No operand predicates
     /* 5410 */   // MIs[0] y
     /* 5410 */   // No operand predicates
     /* 5410 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5414 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5419 */   // Combiner Rule #92: right_identity_one_fp
     /* 5419 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5424 */   GIR_EraseRootFromParent_Done,
     /* 5425 */ // Label 366: @5425
     /* 5425 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5445), // Rule ID 138 //
     /* 5430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5433 */   // MIs[0] dst
     /* 5433 */   // No operand predicates
     /* 5433 */   // MIs[0] x
     /* 5433 */   // No operand predicates
     /* 5433 */   // MIs[0] y
     /* 5433 */   // No operand predicates
     /* 5433 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5437 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 5437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5440 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5442 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5444 */   GIR_EraseRootFromParent_Done,
     /* 5445 */ // Label 367: @5445
     /* 5445 */ GIM_Reject,
     /* 5446 */ // Label 63: @5446
     /* 5446 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5457), // Rule ID 252 //
     /* 5451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5454 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5457 */ // Label 368: @5457
     /* 5457 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5468), // Rule ID 267 //
     /* 5462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5465 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5468 */ // Label 369: @5468
     /* 5468 */ GIM_Reject,
     /* 5469 */ // Label 64: @5469
     /* 5469 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5480), // Rule ID 251 //
     /* 5474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5477 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5480 */ // Label 370: @5480
     /* 5480 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5491), // Rule ID 266 //
     /* 5485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5488 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5491 */ // Label 371: @5491
     /* 5491 */ GIM_Reject,
     /* 5492 */ // Label 65: @5492
     /* 5492 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5503), // Rule ID 250 //
     /* 5497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 5500 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5500 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5503 */ // Label 372: @5503
     /* 5503 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5514), // Rule ID 265 //
     /* 5508 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5511 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5514 */ // Label 373: @5514
     /* 5514 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5525), // Rule ID 297 //
     /* 5519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5522 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5525 */ // Label 374: @5525
     /* 5525 */ GIM_Reject,
     /* 5526 */ // Label 66: @5526
     /* 5526 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5537), // Rule ID 298 //
     /* 5531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5534 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5537 */ // Label 375: @5537
     /* 5537 */ GIM_Reject,
     /* 5538 */ // Label 67: @5538
     /* 5538 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5559), // Rule ID 195 //
     /* 5543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5546 */   // MIs[0] dst
     /* 5546 */   // No operand predicates
     /* 5546 */   // MIs[0] float
     /* 5546 */   // No operand predicates
     /* 5546 */   // MIs[0] int
     /* 5546 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5554 */   // MIs[1] imm
     /* 5554 */   // No operand predicates
     /* 5554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5556 */   // Combiner Rule #145: expand_const_fpowi
     /* 5556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5559 */ // Label 376: @5559
     /* 5559 */ GIM_Reject,
     /* 5560 */ // Label 68: @5560
     /* 5560 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5581), // Rule ID 177 //
     /* 5565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 5568 */   // MIs[0] dst
     /* 5568 */   // No operand predicates
     /* 5568 */   // MIs[0] src0
     /* 5568 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5576 */   // MIs[1] cst
     /* 5576 */   // No operand predicates
     /* 5576 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5578 */   // Combiner Rule #135: constant_fold_flog2
     /* 5578 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5581 */ // Label 377: @5581
     /* 5581 */ GIM_Reject,
     /* 5582 */ // Label 69: @5582
     /* 5582 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5593), // Rule ID 361 //
     /* 5587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5590 */   // Combiner Rule #214: foldable_fneg; wip_match_opcode 'G_FNEG'
     /* 5590 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 5593 */ // Label 378: @5593
     /* 5593 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5614), // Rule ID 174 //
     /* 5598 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 5601 */   // MIs[0] dst
     /* 5601 */   // No operand predicates
     /* 5601 */   // MIs[0] src0
     /* 5601 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5609 */   // MIs[1] cst
     /* 5609 */   // No operand predicates
     /* 5609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5611 */   // Combiner Rule #132: constant_fold_fneg
     /* 5611 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5614 */ // Label 379: @5614
     /* 5614 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5643), // Rule ID 126 //
     /* 5619 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 5622 */   // MIs[0] dst
     /* 5622 */   // No operand predicates
     /* 5622 */   // MIs[0] t
     /* 5622 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5630 */   // MIs[1] src
     /* 5630 */   // No operand predicates
     /* 5630 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5637 */   // Combiner Rule #90: fneg_fneg_fold
     /* 5637 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5642 */   GIR_EraseRootFromParent_Done,
     /* 5643 */ // Label 380: @5643
     /* 5643 */ GIM_Reject,
     /* 5644 */ // Label 70: @5644
     /* 5644 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5665), // Rule ID 178 //
     /* 5649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 5652 */   // MIs[0] dst
     /* 5652 */   // No operand predicates
     /* 5652 */   // MIs[0] src0
     /* 5652 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5660 */   // MIs[1] cst
     /* 5660 */   // No operand predicates
     /* 5660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5662 */   // Combiner Rule #136: constant_fold_fptrunc
     /* 5662 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5665 */ // Label 381: @5665
     /* 5665 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5686), // Rule ID 136 //
     /* 5670 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 5673 */   // MIs[0] dst
     /* 5673 */   // No operand predicates
     /* 5673 */   // MIs[0] src1
     /* 5673 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5681 */   // MIs[1] src0
     /* 5681 */   // No operand predicates
     /* 5681 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5683 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 5683 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 5686 */ // Label 382: @5686
     /* 5686 */ GIM_Reject,
     /* 5687 */ // Label 71: @5687
     /* 5687 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5708), // Rule ID 91 //
     /* 5692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5695 */   // MIs[0] dst
     /* 5695 */   // No operand predicates
     /* 5695 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5695 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5705 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5705 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5708 */ // Label 383: @5708
     /* 5708 */ GIM_Reject,
     /* 5709 */ // Label 72: @5709
     /* 5709 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5730), // Rule ID 92 //
     /* 5714 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5717 */   // MIs[0] dst
     /* 5717 */   // No operand predicates
     /* 5717 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5717 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5727 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5727 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5730 */ // Label 384: @5730
     /* 5730 */ GIM_Reject,
     /* 5731 */ // Label 73: @5731
     /* 5731 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5742), // Rule ID 75 //
     /* 5736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5739 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5739 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5742 */ // Label 385: @5742
     /* 5742 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5757), // Rule ID 179 //
     /* 5747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5750 */   // MIs[0] dst
     /* 5750 */   // No operand predicates
     /* 5750 */   // MIs[0] Operand 1
     /* 5750 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5754 */   // Combiner Rule #137: itof_const_zero_fold_si
     /* 5754 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5757 */ // Label 386: @5757
     /* 5757 */ GIM_Reject,
     /* 5758 */ // Label 74: @5758
     /* 5758 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5769), // Rule ID 74 //
     /* 5763 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5766 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 5766 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5769 */ // Label 387: @5769
     /* 5769 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5784), // Rule ID 180 //
     /* 5774 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5777 */   // MIs[0] dst
     /* 5777 */   // No operand predicates
     /* 5777 */   // MIs[0] Operand 1
     /* 5777 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5781 */   // Combiner Rule #138: itof_const_zero_fold_ui
     /* 5781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5784 */ // Label 388: @5784
     /* 5784 */ GIM_Reject,
     /* 5785 */ // Label 75: @5785
     /* 5785 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5814), // Rule ID 19 //
     /* 5790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5793 */   // MIs[0] dst
     /* 5793 */   // No operand predicates
     /* 5793 */   // MIs[0] src
     /* 5793 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5801 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5801 */   // No operand predicates
     /* 5801 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5808 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 5808 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5813 */   GIR_EraseRootFromParent_Done,
     /* 5814 */ // Label 389: @5814
     /* 5814 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5835), // Rule ID 175 //
     /* 5819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 5822 */   // MIs[0] dst
     /* 5822 */   // No operand predicates
     /* 5822 */   // MIs[0] src0
     /* 5822 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5830 */   // MIs[1] cst
     /* 5830 */   // No operand predicates
     /* 5830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5832 */   // Combiner Rule #133: constant_fold_fabs
     /* 5832 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5835 */ // Label 390: @5835
     /* 5835 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5863), // Rule ID 256 //
     /* 5840 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5843 */   // MIs[0] dst
     /* 5843 */   // No operand predicates
     /* 5843 */   // MIs[0] tmp
     /* 5843 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5851 */   // MIs[1] x
     /* 5851 */   // No operand predicates
     /* 5851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5853 */   // Combiner Rule #168: fabs_fneg_fold
     /* 5853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5856 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5858 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 5862 */   GIR_EraseRootFromParent_Done,
     /* 5863 */ // Label 391: @5863
     /* 5863 */ GIM_Reject,
     /* 5864 */ // Label 76: @5864
     /* 5864 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5893), // Rule ID 20 //
     /* 5869 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5872 */   // MIs[0] dst
     /* 5872 */   // No operand predicates
     /* 5872 */   // MIs[0] src
     /* 5872 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5876 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 5880 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5880 */   // No operand predicates
     /* 5880 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5887 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 5887 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5892 */   GIR_EraseRootFromParent_Done,
     /* 5893 */ // Label 392: @5893
     /* 5893 */ GIM_Reject,
     /* 5894 */ // Label 77: @5894
     /* 5894 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(5905), // Rule ID 191 //
     /* 5899 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5902 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 5902 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5905 */ // Label 393: @5905
     /* 5905 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(5916), // Rule ID 299 //
     /* 5910 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5913 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 5913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5916 */ // Label 394: @5916
     /* 5916 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(5927), // Rule ID 329 //
     /* 5921 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5924 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 5924 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5927 */ // Label 395: @5927
     /* 5927 */ GIM_Reject,
     /* 5928 */ // Label 78: @5928
     /* 5928 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(5939), // Rule ID 192 //
     /* 5933 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5936 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 5936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5939 */ // Label 396: @5939
     /* 5939 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(5950), // Rule ID 300 //
     /* 5944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5947 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 5947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5950 */ // Label 397: @5950
     /* 5950 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(5961), // Rule ID 330 //
     /* 5955 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5958 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 5958 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5961 */ // Label 398: @5961
     /* 5961 */ GIM_Reject,
     /* 5962 */ // Label 79: @5962
     /* 5962 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(5973), // Rule ID 331 //
     /* 5967 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5970 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 5970 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5973 */ // Label 399: @5973
     /* 5973 */ GIM_Reject,
     /* 5974 */ // Label 80: @5974
     /* 5974 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(5985), // Rule ID 332 //
     /* 5979 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5982 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 5982 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5985 */ // Label 400: @5985
     /* 5985 */ GIM_Reject,
     /* 5986 */ // Label 81: @5986
     /* 5986 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(5997), // Rule ID 193 //
     /* 5991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5994 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 5994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5997 */ // Label 401: @5997
     /* 5997 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6008), // Rule ID 301 //
     /* 6002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6005 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6008 */ // Label 402: @6008
     /* 6008 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6019), // Rule ID 333 //
     /* 6013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6016 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6019 */ // Label 403: @6019
     /* 6019 */ GIM_Reject,
     /* 6020 */ // Label 82: @6020
     /* 6020 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6031), // Rule ID 194 //
     /* 6025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 6028 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6031 */ // Label 404: @6031
     /* 6031 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6042), // Rule ID 302 //
     /* 6036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6039 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6042 */ // Label 405: @6042
     /* 6042 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6053), // Rule ID 334 //
     /* 6047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6050 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6053 */ // Label 406: @6053
     /* 6053 */ GIM_Reject,
     /* 6054 */ // Label 83: @6054
     /* 6054 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6065), // Rule ID 147 //
     /* 6059 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 6062 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6062 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 6065 */ // Label 407: @6065
     /* 6065 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6076), // Rule ID 149 //
     /* 6070 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 6073 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6073 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 6076 */ // Label 408: @6076
     /* 6076 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6087), // Rule ID 181 //
     /* 6081 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6084 */   // Combiner Rule #139: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6084 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6087 */ // Label 409: @6087
     /* 6087 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6098), // Rule ID 197 //
     /* 6092 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 6095 */   // Combiner Rule #147: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6095 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 6098 */ // Label 410: @6098
     /* 6098 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6109), // Rule ID 230 //
     /* 6103 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6106 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6106 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6109 */ // Label 411: @6109
     /* 6109 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6120), // Rule ID 279 //
     /* 6114 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6117 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6117 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6120 */ // Label 412: @6120
     /* 6120 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6143), // Rule ID 110 //
     /* 6125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 6128 */   // MIs[0] dst
     /* 6128 */   // No operand predicates
     /* 6128 */   // MIs[0] lhs
     /* 6128 */   // No operand predicates
     /* 6128 */   // MIs[0] Operand 2
     /* 6128 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6132 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6137 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6137 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6142 */   GIR_EraseRootFromParent_Done,
     /* 6143 */ // Label 413: @6143
     /* 6143 */ GIM_Reject,
     /* 6144 */ // Label 84: @6144
     /* 6144 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6155), // Rule ID 243 //
     /* 6149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6152 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6155 */ // Label 414: @6155
     /* 6155 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6166), // Rule ID 290 //
     /* 6160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6163 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6166 */ // Label 415: @6166
     /* 6166 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6177), // Rule ID 311 //
     /* 6171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6174 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6174 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6177 */ // Label 416: @6177
     /* 6177 */ GIM_Reject,
     /* 6178 */ // Label 85: @6178
     /* 6178 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6189), // Rule ID 244 //
     /* 6183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6186 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6186 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6189 */ // Label 417: @6189
     /* 6189 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6200), // Rule ID 291 //
     /* 6194 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6197 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6197 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6200 */ // Label 418: @6200
     /* 6200 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6211), // Rule ID 312 //
     /* 6205 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6208 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6208 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6211 */ // Label 419: @6211
     /* 6211 */ GIM_Reject,
     /* 6212 */ // Label 86: @6212
     /* 6212 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6223), // Rule ID 245 //
     /* 6217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6220 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6220 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6223 */ // Label 420: @6223
     /* 6223 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6234), // Rule ID 292 //
     /* 6228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6231 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6234 */ // Label 421: @6234
     /* 6234 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6245), // Rule ID 313 //
     /* 6239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6242 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6242 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6245 */ // Label 422: @6245
     /* 6245 */ GIM_Reject,
     /* 6246 */ // Label 87: @6246
     /* 6246 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6257), // Rule ID 246 //
     /* 6251 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 6254 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6257 */ // Label 423: @6257
     /* 6257 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6268), // Rule ID 293 //
     /* 6262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 6265 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6268 */ // Label 424: @6268
     /* 6268 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6279), // Rule ID 314 //
     /* 6273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 6276 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6279 */ // Label 425: @6279
     /* 6279 */ GIM_Reject,
     /* 6280 */ // Label 88: @6280
     /* 6280 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6291), // Rule ID 85 //
     /* 6285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 6288 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 6291 */ // Label 426: @6291
     /* 6291 */ GIM_Reject,
     /* 6292 */ // Label 89: @6292
     /* 6292 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6303), // Rule ID 173 //
     /* 6297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 6300 */   // Combiner Rule #131: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 6303 */ // Label 427: @6303
     /* 6303 */ GIM_Reject,
     /* 6304 */ // Label 90: @6304
     /* 6304 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6315), // Rule ID 26 //
     /* 6309 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6312 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6312 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6315 */ // Label 428: @6315
     /* 6315 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6326), // Rule ID 66 //
     /* 6320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 6323 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 6326 */ // Label 429: @6326
     /* 6326 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6337), // Rule ID 100 //
     /* 6331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6334 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6337 */ // Label 430: @6337
     /* 6337 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6376), // Rule ID 38 //
     /* 6342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6345 */   // MIs[0] root
     /* 6345 */   // No operand predicates
     /* 6345 */   // MIs[0] src
     /* 6345 */   // No operand predicates
     /* 6345 */   // MIs[0] elt
     /* 6345 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6353 */   // MIs[1] src
     /* 6353 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6358 */   // MIs[1] idx
     /* 6358 */   // No operand predicates
     /* 6358 */   // MIs[0] idx
     /* 6358 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6363 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6370 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6370 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6375 */   GIR_EraseRootFromParent_Done,
     /* 6376 */ // Label 431: @6376
     /* 6376 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6409), // Rule ID 24 //
     /* 6381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6384 */   // MIs[0] root
     /* 6384 */   // No operand predicates
     /* 6384 */   // MIs[0] src
     /* 6384 */   // No operand predicates
     /* 6384 */   // MIs[0] elt
     /* 6384 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6392 */   // MIs[0] idx
     /* 6392 */   // No operand predicates
     /* 6392 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6396 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6403 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6403 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6408 */   GIR_EraseRootFromParent_Done,
     /* 6409 */ // Label 432: @6409
     /* 6409 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6433), // Rule ID 23 //
     /* 6414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6417 */   // MIs[0] root
     /* 6417 */   // No operand predicates
     /* 6417 */   // MIs[0] src
     /* 6417 */   // No operand predicates
     /* 6417 */   // MIs[0] elt
     /* 6417 */   // No operand predicates
     /* 6417 */   // MIs[0] idx
     /* 6417 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6427 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6430 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6432 */   GIR_EraseRootFromParent_Done,
     /* 6433 */ // Label 433: @6433
     /* 6433 */ GIM_Reject,
     /* 6434 */ // Label 91: @6434
     /* 6434 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6445), // Rule ID 25 //
     /* 6439 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6442 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6442 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6445 */ // Label 434: @6445
     /* 6445 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6456), // Rule ID 67 //
     /* 6450 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6453 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6453 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6456 */ // Label 435: @6456
     /* 6456 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6467), // Rule ID 73 //
     /* 6461 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 6464 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6464 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 6467 */ // Label 436: @6467
     /* 6467 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6478), // Rule ID 101 //
     /* 6472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6475 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6478 */ // Label 437: @6478
     /* 6478 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6502), // Rule ID 36 //
     /* 6483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6486 */   // MIs[0] root
     /* 6486 */   // No operand predicates
     /* 6486 */   // MIs[0] src
     /* 6486 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6494 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6497 */   // MIs[1] x
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] y
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] z
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] a
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] b
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] c
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] d
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[1] e
     /* 6497 */   // No operand predicates
     /* 6497 */   // MIs[0] idx
     /* 6497 */   // No operand predicates
     /* 6497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6499 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6502 */ // Label 438: @6502
     /* 6502 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6526), // Rule ID 35 //
     /* 6507 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6510 */   // MIs[0] root
     /* 6510 */   // No operand predicates
     /* 6510 */   // MIs[0] src
     /* 6510 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6518 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6521 */   // MIs[1] x
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[1] y
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[1] z
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[1] a
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[1] b
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[1] c
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[1] d
     /* 6521 */   // No operand predicates
     /* 6521 */   // MIs[0] idx
     /* 6521 */   // No operand predicates
     /* 6521 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6523 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6523 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6526 */ // Label 439: @6526
     /* 6526 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6550), // Rule ID 34 //
     /* 6531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6534 */   // MIs[0] root
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[0] src
     /* 6534 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6542 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6545 */   // MIs[1] x
     /* 6545 */   // No operand predicates
     /* 6545 */   // MIs[1] y
     /* 6545 */   // No operand predicates
     /* 6545 */   // MIs[1] z
     /* 6545 */   // No operand predicates
     /* 6545 */   // MIs[1] a
     /* 6545 */   // No operand predicates
     /* 6545 */   // MIs[1] b
     /* 6545 */   // No operand predicates
     /* 6545 */   // MIs[1] c
     /* 6545 */   // No operand predicates
     /* 6545 */   // MIs[0] idx
     /* 6545 */   // No operand predicates
     /* 6545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6547 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6550 */ // Label 440: @6550
     /* 6550 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6574), // Rule ID 33 //
     /* 6555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6558 */   // MIs[0] root
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[0] src
     /* 6558 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6566 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6569 */   // MIs[1] x
     /* 6569 */   // No operand predicates
     /* 6569 */   // MIs[1] y
     /* 6569 */   // No operand predicates
     /* 6569 */   // MIs[1] z
     /* 6569 */   // No operand predicates
     /* 6569 */   // MIs[1] a
     /* 6569 */   // No operand predicates
     /* 6569 */   // MIs[1] b
     /* 6569 */   // No operand predicates
     /* 6569 */   // MIs[0] idx
     /* 6569 */   // No operand predicates
     /* 6569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6571 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6574 */ // Label 441: @6574
     /* 6574 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6598), // Rule ID 32 //
     /* 6579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6582 */   // MIs[0] root
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[0] src
     /* 6582 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6590 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6593 */   // MIs[1] x
     /* 6593 */   // No operand predicates
     /* 6593 */   // MIs[1] y
     /* 6593 */   // No operand predicates
     /* 6593 */   // MIs[1] z
     /* 6593 */   // No operand predicates
     /* 6593 */   // MIs[1] a
     /* 6593 */   // No operand predicates
     /* 6593 */   // MIs[0] idx
     /* 6593 */   // No operand predicates
     /* 6593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6595 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6598 */ // Label 442: @6598
     /* 6598 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6622), // Rule ID 31 //
     /* 6603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6606 */   // MIs[0] root
     /* 6606 */   // No operand predicates
     /* 6606 */   // MIs[0] src
     /* 6606 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6614 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6617 */   // MIs[1] x
     /* 6617 */   // No operand predicates
     /* 6617 */   // MIs[1] y
     /* 6617 */   // No operand predicates
     /* 6617 */   // MIs[1] z
     /* 6617 */   // No operand predicates
     /* 6617 */   // MIs[0] idx
     /* 6617 */   // No operand predicates
     /* 6617 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6619 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6619 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6622 */ // Label 443: @6622
     /* 6622 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6656), // Rule ID 27 //
     /* 6627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6630 */   // MIs[0] root
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[0] src
     /* 6630 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6638 */   // MIs[1] x
     /* 6638 */   // No operand predicates
     /* 6638 */   // MIs[1] value
     /* 6638 */   // No operand predicates
     /* 6638 */   // MIs[1] idx
     /* 6638 */   // No operand predicates
     /* 6638 */   // MIs[0] idx
     /* 6638 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6643 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6650 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6650 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6655 */   GIR_EraseRootFromParent_Done,
     /* 6656 */ // Label 444: @6656
     /* 6656 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6677), // Rule ID 28 //
     /* 6661 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6664 */   // MIs[0] root
     /* 6664 */   // No operand predicates
     /* 6664 */   // MIs[0] src
     /* 6664 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6672 */   // MIs[1] x
     /* 6672 */   // No operand predicates
     /* 6672 */   // MIs[1] value
     /* 6672 */   // No operand predicates
     /* 6672 */   // MIs[1] idx2
     /* 6672 */   // No operand predicates
     /* 6672 */   // MIs[0] idx1
     /* 6672 */   // No operand predicates
     /* 6672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6674 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6677 */ // Label 445: @6677
     /* 6677 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6706), // Rule ID 37 //
     /* 6682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6685 */   // MIs[0] root
     /* 6685 */   // No operand predicates
     /* 6685 */   // MIs[0] src
     /* 6685 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6693 */   // MIs[1] src1
     /* 6693 */   // No operand predicates
     /* 6693 */   // MIs[1] src2
     /* 6693 */   // No operand predicates
     /* 6693 */   // MIs[1] mask
     /* 6693 */   // No operand predicates
     /* 6693 */   // MIs[0] idx
     /* 6693 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6697 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6701 */   // MIs[2] imm
     /* 6701 */   // No operand predicates
     /* 6701 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6703 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6706 */ // Label 446: @6706
     /* 6706 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6730), // Rule ID 30 //
     /* 6711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6714 */   // MIs[0] root
     /* 6714 */   // No operand predicates
     /* 6714 */   // MIs[0] src
     /* 6714 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6722 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6725 */   // MIs[1] x
     /* 6725 */   // No operand predicates
     /* 6725 */   // MIs[1] y
     /* 6725 */   // No operand predicates
     /* 6725 */   // MIs[0] idx
     /* 6725 */   // No operand predicates
     /* 6725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6727 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6727 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6730 */ // Label 447: @6730
     /* 6730 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6762), // Rule ID 29 //
     /* 6735 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6738 */   // MIs[0] root
     /* 6738 */   // No operand predicates
     /* 6738 */   // MIs[0] src
     /* 6738 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6746 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6749 */   // MIs[1] unused
     /* 6749 */   // No operand predicates
     /* 6749 */   // MIs[0] idx
     /* 6749 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6753 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6757 */   // MIs[2] imm
     /* 6757 */   // No operand predicates
     /* 6757 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6759 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 6759 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 6762 */ // Label 448: @6762
     /* 6762 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6786), // Rule ID 21 //
     /* 6767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 6770 */   // MIs[0] root
     /* 6770 */   // No operand predicates
     /* 6770 */   // MIs[0] vector
     /* 6770 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6778 */   // MIs[0] idx
     /* 6778 */   // No operand predicates
     /* 6778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6780 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 6780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6783 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6785 */   GIR_EraseRootFromParent_Done,
     /* 6786 */ // Label 449: @6786
     /* 6786 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6810), // Rule ID 22 //
     /* 6791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 6794 */   // MIs[0] root
     /* 6794 */   // No operand predicates
     /* 6794 */   // MIs[0] vector
     /* 6794 */   // No operand predicates
     /* 6794 */   // MIs[0] idx
     /* 6794 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6804 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 6804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6807 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6809 */   GIR_EraseRootFromParent_Done,
     /* 6810 */ // Label 450: @6810
     /* 6810 */ GIM_Reject,
     /* 6811 */ // Label 92: @6811
     /* 6811 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6822), // Rule ID 96 //
     /* 6816 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 6819 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6819 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 6822 */ // Label 451: @6822
     /* 6822 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6833), // Rule ID 98 //
     /* 6827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 6830 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 6833 */ // Label 452: @6833
     /* 6833 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6844), // Rule ID 342 //
     /* 6838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 6841 */   // Combiner Rule #197: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 6844 */ // Label 453: @6844
     /* 6844 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6855), // Rule ID 344 //
     /* 6849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 6852 */   // Combiner Rule #199: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6852 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 6855 */ // Label 454: @6855
     /* 6855 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(6876), // Rule ID 343 //
     /* 6860 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 6863 */   // MIs[0] root
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[0] src1
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[0] undef
     /* 6863 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6871 */   // MIs[0] mask
     /* 6871 */   // No operand predicates
     /* 6871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6873 */   // Combiner Rule #198: combine_shuffle_undef_rhs
     /* 6873 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 6876 */ // Label 455: @6876
     /* 6876 */ GIM_Reject,
     /* 6877 */ // Label 93: @6877
     /* 6877 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(6921), // Rule ID 221 //
     /* 6882 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 6885 */   // MIs[0] d
     /* 6885 */   // No operand predicates
     /* 6885 */   // MIs[0] src
     /* 6885 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6889 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6893 */   // MIs[1] rev
     /* 6893 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6897 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6901 */   // MIs[2] val
     /* 6901 */   // No operand predicates
     /* 6901 */   // MIs[1] amt
     /* 6901 */   // No operand predicates
     /* 6901 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 6905 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6907 */   // Combiner Rule #158: bitreverse_lshr
     /* 6907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6910 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6912 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6916 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6920 */   GIR_EraseRootFromParent_Done,
     /* 6921 */ // Label 456: @6921
     /* 6921 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(6965), // Rule ID 220 //
     /* 6926 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 6929 */   // MIs[0] d
     /* 6929 */   // No operand predicates
     /* 6929 */   // MIs[0] src
     /* 6929 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6937 */   // MIs[1] rev
     /* 6937 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6941 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6945 */   // MIs[2] val
     /* 6945 */   // No operand predicates
     /* 6945 */   // MIs[1] amt
     /* 6945 */   // No operand predicates
     /* 6945 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 6949 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6951 */   // Combiner Rule #157: bitreverse_shl
     /* 6951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6954 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6956 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6960 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6964 */   GIR_EraseRootFromParent_Done,
     /* 6965 */ // Label 457: @6965
     /* 6965 */ GIM_Reject,
     /* 6966 */ // Label 94: @6966
     /* 6966 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(6987), // Rule ID 176 //
     /* 6971 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 6974 */   // MIs[0] dst
     /* 6974 */   // No operand predicates
     /* 6974 */   // MIs[0] src0
     /* 6974 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6982 */   // MIs[1] cst
     /* 6982 */   // No operand predicates
     /* 6982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6984 */   // Combiner Rule #134: constant_fold_fsqrt
     /* 6984 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6987 */ // Label 458: @6987
     /* 6987 */ GIM_Reject,
     /* 6988 */ // Label 95: @6988
     /* 6988 */ GIM_Reject,
     /* 6989 */ }; // Size: 6989 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

