/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(304), /*)*//*default:*//*Label 78*/ GIMT_Encode4(130906),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1014),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10341),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13585),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15289),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15385), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15481),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18661),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24470), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26165), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26552), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35564),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35860), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 12*/ GIMT_Encode4(36123), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 13*/ GIMT_Encode4(36286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 14*/ GIMT_Encode4(36307),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 15*/ GIMT_Encode4(91479), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 16*/ GIMT_Encode4(99141),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 17*/ GIMT_Encode4(99299),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 18*/ GIMT_Encode4(99457),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 19*/ GIMT_Encode4(99778), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 20*/ GIMT_Encode4(99874),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 21*/ GIMT_Encode4(100032),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 22*/ GIMT_Encode4(100637),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 23*/ GIMT_Encode4(100795),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 24*/ GIMT_Encode4(101011),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 25*/ GIMT_Encode4(101119), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 26*/ GIMT_Encode4(101392), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 27*/ GIMT_Encode4(101724),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 28*/ GIMT_Encode4(101972),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 29*/ GIMT_Encode4(102341),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 30*/ GIMT_Encode4(102986),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 31*/ GIMT_Encode4(104286),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 32*/ GIMT_Encode4(104931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 33*/ GIMT_Encode4(105951),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 34*/ GIMT_Encode4(108304),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 35*/ GIMT_Encode4(109981),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 36*/ GIMT_Encode4(110962), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 37*/ GIMT_Encode4(113053), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 38*/ GIMT_Encode4(113218),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 39*/ GIMT_Encode4(114749),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 40*/ GIMT_Encode4(114985),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 41*/ GIMT_Encode4(115257),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 42*/ GIMT_Encode4(116591),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 43*/ GIMT_Encode4(117925),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 44*/ GIMT_Encode4(118577), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 45*/ GIMT_Encode4(119229), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 46*/ GIMT_Encode4(120005),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 47*/ GIMT_Encode4(120597), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(121189),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(121923),
     /*    654 */ /*TargetOpcode::G_GET_FPENV*//*Label 50*/ GIMT_Encode4(122657),
     /*    658 */ /*TargetOpcode::G_SET_FPENV*//*Label 51*/ GIMT_Encode4(122690),
     /*    662 */ /*TargetOpcode::G_RESET_FPENV*//*Label 52*/ GIMT_Encode4(122726),
     /*    666 */ /*TargetOpcode::G_GET_FPMODE*//*Label 53*/ GIMT_Encode4(122855), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(122888),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(123431),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(123974),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(124895),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(125816), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(126287), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 60*/ GIMT_Encode4(126360),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126660), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 62*/ GIMT_Encode4(126717), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 63*/ GIMT_Encode4(127278),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 64*/ GIMT_Encode4(127386),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 65*/ GIMT_Encode4(127676),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 66*/ GIMT_Encode4(128108), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(128371),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 68*/ GIMT_Encode4(128509),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 69*/ GIMT_Encode4(128772),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 70*/ GIMT_Encode4(129068), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 71*/ GIMT_Encode4(129206),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 72*/ GIMT_Encode4(129252), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 73*/ GIMT_Encode4(129339), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 74*/ GIMT_Encode4(129760),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 75*/ GIMT_Encode4(130040),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 76*/ GIMT_Encode4(130329),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 77*/ GIMT_Encode4(130610),
     /*   1014 */ // Label 0: @1014
     /*   1014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 88*/ GIMT_Encode4(10340),
     /*   1025 */ /*GILLT_s32*//*Label 79*/ GIMT_Encode4(1085),
     /*   1029 */ /*GILLT_s64*//*Label 80*/ GIMT_Encode4(6861), GIMT_Encode4(0),
     /*   1037 */ /*GILLT_v2s32*//*Label 81*/ GIMT_Encode4(6908),
     /*   1041 */ /*GILLT_v2s64*//*Label 82*/ GIMT_Encode4(7093), GIMT_Encode4(0),
     /*   1049 */ /*GILLT_v4s16*//*Label 83*/ GIMT_Encode4(7804),
     /*   1053 */ /*GILLT_v4s32*//*Label 84*/ GIMT_Encode4(7989), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v8s8*//*Label 85*/ GIMT_Encode4(8945),
     /*   1069 */ /*GILLT_v8s16*//*Label 86*/ GIMT_Encode4(9130), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v16s8*//*Label 87*/ GIMT_Encode4(10086),
     /*   1085 */ // Label 79: @1085
     /*   1085 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(6860),
     /*   1090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1096 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1171), // Rule ID 5650 //
     /*   1101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1129 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1146 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1169 */     GIR_RootConstrainSelectedInstOperands,
     /*   1170 */     // GIR_Coverage, 5650,
     /*   1170 */     GIR_EraseRootFromParent_Done,
     /*   1171 */   // Label 90: @1171
     /*   1171 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1246), // Rule ID 5651 //
     /*   1176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1204 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1221 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1244 */     GIR_RootConstrainSelectedInstOperands,
     /*   1245 */     // GIR_Coverage, 5651,
     /*   1245 */     GIR_EraseRootFromParent_Done,
     /*   1246 */   // Label 91: @1246
     /*   1246 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1321), // Rule ID 5685 //
     /*   1251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1279 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1296 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1319 */     GIR_RootConstrainSelectedInstOperands,
     /*   1320 */     // GIR_Coverage, 5685,
     /*   1320 */     GIR_EraseRootFromParent_Done,
     /*   1321 */   // Label 92: @1321
     /*   1321 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1396), // Rule ID 5686 //
     /*   1326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1354 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1371 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1394 */     GIR_RootConstrainSelectedInstOperands,
     /*   1395 */     // GIR_Coverage, 5686,
     /*   1395 */     GIR_EraseRootFromParent_Done,
     /*   1396 */   // Label 93: @1396
     /*   1396 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1471), // Rule ID 1995 //
     /*   1401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1433 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1446 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1469 */     GIR_RootConstrainSelectedInstOperands,
     /*   1470 */     // GIR_Coverage, 1995,
     /*   1470 */     GIR_EraseRootFromParent_Done,
     /*   1471 */   // Label 94: @1471
     /*   1471 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1546), // Rule ID 1996 //
     /*   1476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1508 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1521 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1544 */     GIR_RootConstrainSelectedInstOperands,
     /*   1545 */     // GIR_Coverage, 1996,
     /*   1545 */     GIR_EraseRootFromParent_Done,
     /*   1546 */   // Label 95: @1546
     /*   1546 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1621), // Rule ID 2227 //
     /*   1551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1583 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1596 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1619 */     GIR_RootConstrainSelectedInstOperands,
     /*   1620 */     // GIR_Coverage, 2227,
     /*   1620 */     GIR_EraseRootFromParent_Done,
     /*   1621 */   // Label 96: @1621
     /*   1621 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1696), // Rule ID 2228 //
     /*   1626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1658 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1671 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1694 */     GIR_RootConstrainSelectedInstOperands,
     /*   1695 */     // GIR_Coverage, 2228,
     /*   1695 */     GIR_EraseRootFromParent_Done,
     /*   1696 */   // Label 97: @1696
     /*   1696 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1824), // Rule ID 5661 //
     /*   1701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1757 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1773 */     // MIs[4] Rm
     /*   1773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1778 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1782 */     // MIs[1] Operand 2
     /*   1782 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1797 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1799 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1822 */     GIR_RootConstrainSelectedInstOperands,
     /*   1823 */     // GIR_Coverage, 5661,
     /*   1823 */     GIR_EraseRootFromParent_Done,
     /*   1824 */   // Label 98: @1824
     /*   1824 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1952), // Rule ID 5662 //
     /*   1829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1885 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1901 */     // MIs[4] Rm
     /*   1901 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1906 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1910 */     // MIs[1] Operand 2
     /*   1910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1927 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1950 */     GIR_RootConstrainSelectedInstOperands,
     /*   1951 */     // GIR_Coverage, 5662,
     /*   1951 */     GIR_EraseRootFromParent_Done,
     /*   1952 */   // Label 99: @1952
     /*   1952 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2080), // Rule ID 2094 //
     /*   1957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2017 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2021 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2025 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2029 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2033 */     // MIs[4] Rm
     /*   2033 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2038 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2042 */     // MIs[1] Operand 2
     /*   2042 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2055 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2078 */     GIR_RootConstrainSelectedInstOperands,
     /*   2079 */     // GIR_Coverage, 2094,
     /*   2079 */     GIR_EraseRootFromParent_Done,
     /*   2080 */   // Label 100: @2080
     /*   2080 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2208), // Rule ID 5660 //
     /*   2085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2145 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2153 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2157 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2161 */     // MIs[4] Rm
     /*   2161 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2166 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2170 */     // MIs[1] Operand 2
     /*   2170 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2181 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2183 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2206 */     GIR_RootConstrainSelectedInstOperands,
     /*   2207 */     // GIR_Coverage, 5660,
     /*   2207 */     GIR_EraseRootFromParent_Done,
     /*   2208 */   // Label 101: @2208
     /*   2208 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2318), // Rule ID 5429 //
     /*   2213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2257 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2269 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2273 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2277 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2282 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2292 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2316 */     GIR_RootConstrainSelectedInstOperands,
     /*   2317 */     // GIR_Coverage, 5429,
     /*   2317 */     GIR_EraseRootFromParent_Done,
     /*   2318 */   // Label 102: @2318
     /*   2318 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2428), // Rule ID 5466 //
     /*   2323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2367 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2379 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2383 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2392 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2402 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2426 */     GIR_RootConstrainSelectedInstOperands,
     /*   2427 */     // GIR_Coverage, 5466,
     /*   2427 */     GIR_EraseRootFromParent_Done,
     /*   2428 */   // Label 103: @2428
     /*   2428 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2538), // Rule ID 192 //
     /*   2433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2497 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2501 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2506 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2512 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2536 */     GIR_RootConstrainSelectedInstOperands,
     /*   2537 */     // GIR_Coverage, 192,
     /*   2537 */     GIR_EraseRootFromParent_Done,
     /*   2538 */   // Label 104: @2538
     /*   2538 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2648), // Rule ID 521 //
     /*   2543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2591 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2616 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2622 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2646 */     GIR_RootConstrainSelectedInstOperands,
     /*   2647 */     // GIR_Coverage, 521,
     /*   2647 */     GIR_EraseRootFromParent_Done,
     /*   2648 */   // Label 105: @2648
     /*   2648 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2761), // Rule ID 5428 //
     /*   2653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2709 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2713 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2718 */     // MIs[3] Operand 2
     /*   2718 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2735 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2759 */     GIR_RootConstrainSelectedInstOperands,
     /*   2760 */     // GIR_Coverage, 5428,
     /*   2760 */     GIR_EraseRootFromParent_Done,
     /*   2761 */   // Label 106: @2761
     /*   2761 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2874), // Rule ID 5465 //
     /*   2766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2810 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2826 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2831 */     // MIs[3] Operand 2
     /*   2831 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2848 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2872 */     GIR_RootConstrainSelectedInstOperands,
     /*   2873 */     // GIR_Coverage, 5465,
     /*   2873 */     GIR_EraseRootFromParent_Done,
     /*   2874 */   // Label 107: @2874
     /*   2874 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2987), // Rule ID 5427 //
     /*   2879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2919 */     // MIs[2] Operand 2
     /*   2919 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2946 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2951 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2961 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2985 */     GIR_RootConstrainSelectedInstOperands,
     /*   2986 */     // GIR_Coverage, 5427,
     /*   2986 */     GIR_EraseRootFromParent_Done,
     /*   2987 */   // Label 108: @2987
     /*   2987 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3100), // Rule ID 5464 //
     /*   2992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3032 */     // MIs[2] Operand 2
     /*   3032 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3055 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3064 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3074 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3098 */     GIR_RootConstrainSelectedInstOperands,
     /*   3099 */     // GIR_Coverage, 5464,
     /*   3099 */     GIR_EraseRootFromParent_Done,
     /*   3100 */   // Label 109: @3100
     /*   3100 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3213), // Rule ID 191 //
     /*   3105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3153 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3169 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3174 */     // MIs[3] Operand 2
     /*   3174 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3187 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3211 */     GIR_RootConstrainSelectedInstOperands,
     /*   3212 */     // GIR_Coverage, 191,
     /*   3212 */     GIR_EraseRootFromParent_Done,
     /*   3213 */   // Label 110: @3213
     /*   3213 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3326), // Rule ID 520 //
     /*   3218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3266 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3287 */     // MIs[3] Operand 2
     /*   3287 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3300 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3324 */     GIR_RootConstrainSelectedInstOperands,
     /*   3325 */     // GIR_Coverage, 520,
     /*   3325 */     GIR_EraseRootFromParent_Done,
     /*   3326 */   // Label 111: @3326
     /*   3326 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3439), // Rule ID 190 //
     /*   3331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3375 */     // MIs[2] Operand 2
     /*   3375 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3402 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3407 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3413 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3437 */     GIR_RootConstrainSelectedInstOperands,
     /*   3438 */     // GIR_Coverage, 190,
     /*   3438 */     GIR_EraseRootFromParent_Done,
     /*   3439 */   // Label 112: @3439
     /*   3439 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3552), // Rule ID 519 //
     /*   3444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3488 */     // MIs[2] Operand 2
     /*   3488 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3507 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3511 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3515 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3520 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3526 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3550 */     GIR_RootConstrainSelectedInstOperands,
     /*   3551 */     // GIR_Coverage, 519,
     /*   3551 */     GIR_EraseRootFromParent_Done,
     /*   3552 */   // Label 113: @3552
     /*   3552 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3643), // Rule ID 5659 //
     /*   3557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3597 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3601 */     // MIs[1] Operand 2
     /*   3601 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3618 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3641 */     GIR_RootConstrainSelectedInstOperands,
     /*   3642 */     // GIR_Coverage, 5659,
     /*   3642 */     GIR_EraseRootFromParent_Done,
     /*   3643 */   // Label 114: @3643
     /*   3643 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3734), // Rule ID 2093 //
     /*   3648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3696 */     // MIs[1] Operand 2
     /*   3696 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3709 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3732 */     GIR_RootConstrainSelectedInstOperands,
     /*   3733 */     // GIR_Coverage, 2093,
     /*   3733 */     GIR_EraseRootFromParent_Done,
     /*   3734 */   // Label 115: @3734
     /*   3734 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3850), // Rule ID 5426 //
     /*   3739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3779 */     // MIs[2] Operand 2
     /*   3779 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3807 */     // MIs[3] Operand 2
     /*   3807 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3824 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3848 */     GIR_RootConstrainSelectedInstOperands,
     /*   3849 */     // GIR_Coverage, 5426,
     /*   3849 */     GIR_EraseRootFromParent_Done,
     /*   3850 */   // Label 116: @3850
     /*   3850 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3966), // Rule ID 5463 //
     /*   3855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3895 */     // MIs[2] Operand 2
     /*   3895 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3914 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3918 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3923 */     // MIs[3] Operand 2
     /*   3923 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3940 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3964 */     GIR_RootConstrainSelectedInstOperands,
     /*   3965 */     // GIR_Coverage, 5463,
     /*   3965 */     GIR_EraseRootFromParent_Done,
     /*   3966 */   // Label 117: @3966
     /*   3966 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(4082), // Rule ID 189 //
     /*   3971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4015 */     // MIs[2] Operand 2
     /*   4015 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4038 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4043 */     // MIs[3] Operand 2
     /*   4043 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4056 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4080 */     GIR_RootConstrainSelectedInstOperands,
     /*   4081 */     // GIR_Coverage, 189,
     /*   4081 */     GIR_EraseRootFromParent_Done,
     /*   4082 */   // Label 118: @4082
     /*   4082 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4198), // Rule ID 518 //
     /*   4087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4131 */     // MIs[2] Operand 2
     /*   4131 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4154 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4159 */     // MIs[3] Operand 2
     /*   4159 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4172 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4196 */     GIR_RootConstrainSelectedInstOperands,
     /*   4197 */     // GIR_Coverage, 518,
     /*   4197 */     GIR_EraseRootFromParent_Done,
     /*   4198 */   // Label 119: @4198
     /*   4198 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4286), // Rule ID 3228 //
     /*   4203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4254 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4284 */     GIR_RootConstrainSelectedInstOperands,
     /*   4285 */     // GIR_Coverage, 3228,
     /*   4285 */     GIR_EraseRootFromParent_Done,
     /*   4286 */   // Label 120: @4286
     /*   4286 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4374), // Rule ID 3229 //
     /*   4291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4342 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4347 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4372 */     GIR_RootConstrainSelectedInstOperands,
     /*   4373 */     // GIR_Coverage, 3229,
     /*   4373 */     GIR_EraseRootFromParent_Done,
     /*   4374 */   // Label 121: @4374
     /*   4374 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4462), // Rule ID 3232 //
     /*   4379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4430 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4460 */     GIR_RootConstrainSelectedInstOperands,
     /*   4461 */     // GIR_Coverage, 3232,
     /*   4461 */     GIR_EraseRootFromParent_Done,
     /*   4462 */   // Label 122: @4462
     /*   4462 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4550), // Rule ID 5930 //
     /*   4467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4518 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4548 */     GIR_RootConstrainSelectedInstOperands,
     /*   4549 */     // GIR_Coverage, 5930,
     /*   4549 */     GIR_EraseRootFromParent_Done,
     /*   4550 */   // Label 123: @4550
     /*   4550 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4638), // Rule ID 5931 //
     /*   4555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4606 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4636 */     GIR_RootConstrainSelectedInstOperands,
     /*   4637 */     // GIR_Coverage, 5931,
     /*   4637 */     GIR_EraseRootFromParent_Done,
     /*   4638 */   // Label 124: @4638
     /*   4638 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4726), // Rule ID 5934 //
     /*   4643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4694 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4724 */     GIR_RootConstrainSelectedInstOperands,
     /*   4725 */     // GIR_Coverage, 5934,
     /*   4725 */     GIR_EraseRootFromParent_Done,
     /*   4726 */   // Label 125: @4726
     /*   4726 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4783), // Rule ID 72 //
     /*   4731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4754 */     // MIs[1] Operand 1
     /*   4754 */     // No operand predicates
     /*   4754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4756 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4781 */     GIR_RootConstrainSelectedInstOperands,
     /*   4782 */     // GIR_Coverage, 72,
     /*   4782 */     GIR_EraseRootFromParent_Done,
     /*   4783 */   // Label 126: @4783
     /*   4783 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4840), // Rule ID 303 //
     /*   4788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4811 */     // MIs[1] Operand 1
     /*   4811 */     // No operand predicates
     /*   4811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4813 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4838 */     GIR_RootConstrainSelectedInstOperands,
     /*   4839 */     // GIR_Coverage, 303,
     /*   4839 */     GIR_EraseRootFromParent_Done,
     /*   4840 */   // Label 127: @4840
     /*   4840 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4897), // Rule ID 304 //
     /*   4845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4868 */     // MIs[1] Operand 1
     /*   4868 */     // No operand predicates
     /*   4868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4870 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4895 */     GIR_RootConstrainSelectedInstOperands,
     /*   4896 */     // GIR_Coverage, 304,
     /*   4896 */     GIR_EraseRootFromParent_Done,
     /*   4897 */   // Label 128: @4897
     /*   4897 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4954), // Rule ID 407 //
     /*   4902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4925 */     // MIs[1] Operand 1
     /*   4925 */     // No operand predicates
     /*   4925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4927 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4952 */     GIR_RootConstrainSelectedInstOperands,
     /*   4953 */     // GIR_Coverage, 407,
     /*   4953 */     GIR_EraseRootFromParent_Done,
     /*   4954 */   // Label 129: @4954
     /*   4954 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(5005), // Rule ID 408 //
     /*   4959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4982 */     // MIs[1] Operand 1
     /*   4982 */     // No operand predicates
     /*   4982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4984 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   4987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5003 */     GIR_RootConstrainSelectedInstOperands,
     /*   5004 */     // GIR_Coverage, 408,
     /*   5004 */     GIR_EraseRootFromParent_Done,
     /*   5005 */   // Label 130: @5005
     /*   5005 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5081), // Rule ID 171 //
     /*   5010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5049 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5079 */     GIR_RootConstrainSelectedInstOperands,
     /*   5080 */     // GIR_Coverage, 171,
     /*   5080 */     GIR_EraseRootFromParent_Done,
     /*   5081 */   // Label 131: @5081
     /*   5081 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5157), // Rule ID 172 //
     /*   5086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5125 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5155 */     GIR_RootConstrainSelectedInstOperands,
     /*   5156 */     // GIR_Coverage, 172,
     /*   5156 */     GIR_EraseRootFromParent_Done,
     /*   5157 */   // Label 132: @5157
     /*   5157 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5227), // Rule ID 503 //
     /*   5162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5201 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5225 */     GIR_RootConstrainSelectedInstOperands,
     /*   5226 */     // GIR_Coverage, 503,
     /*   5226 */     GIR_EraseRootFromParent_Done,
     /*   5227 */   // Label 133: @5227
     /*   5227 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5298), // Rule ID 5652 //
     /*   5232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5256 */     // MIs[1] Operand 2
     /*   5256 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5273 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5296 */     GIR_RootConstrainSelectedInstOperands,
     /*   5297 */     // GIR_Coverage, 5652,
     /*   5297 */     GIR_EraseRootFromParent_Done,
     /*   5298 */   // Label 134: @5298
     /*   5298 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5369), // Rule ID 5653 //
     /*   5303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5327 */     // MIs[1] Operand 2
     /*   5327 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5344 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5367 */     GIR_RootConstrainSelectedInstOperands,
     /*   5368 */     // GIR_Coverage, 5653,
     /*   5368 */     GIR_EraseRootFromParent_Done,
     /*   5369 */   // Label 135: @5369
     /*   5369 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5440), // Rule ID 5687 //
     /*   5374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5398 */     // MIs[1] Operand 2
     /*   5398 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5415 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5438 */     GIR_RootConstrainSelectedInstOperands,
     /*   5439 */     // GIR_Coverage, 5687,
     /*   5439 */     GIR_EraseRootFromParent_Done,
     /*   5440 */   // Label 136: @5440
     /*   5440 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5511), // Rule ID 5688 //
     /*   5445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5469 */     // MIs[1] Operand 2
     /*   5469 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5486 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5509 */     GIR_RootConstrainSelectedInstOperands,
     /*   5510 */     // GIR_Coverage, 5688,
     /*   5510 */     GIR_EraseRootFromParent_Done,
     /*   5511 */   // Label 137: @5511
     /*   5511 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5581), // Rule ID 180 //
     /*   5516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5555 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5579 */     GIR_RootConstrainSelectedInstOperands,
     /*   5580 */     // GIR_Coverage, 180,
     /*   5580 */     GIR_EraseRootFromParent_Done,
     /*   5581 */   // Label 138: @5581
     /*   5581 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5651), // Rule ID 509 //
     /*   5586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5625 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5649 */     GIR_RootConstrainSelectedInstOperands,
     /*   5650 */     // GIR_Coverage, 509,
     /*   5650 */     GIR_EraseRootFromParent_Done,
     /*   5651 */   // Label 139: @5651
     /*   5651 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5714), // Rule ID 3033 //
     /*   5656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5686 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5691 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5712 */     GIR_RootConstrainSelectedInstOperands,
     /*   5713 */     // GIR_Coverage, 3033,
     /*   5713 */     GIR_EraseRootFromParent_Done,
     /*   5714 */   // Label 140: @5714
     /*   5714 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5777), // Rule ID 3061 //
     /*   5719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5749 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5754 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5775 */     GIR_RootConstrainSelectedInstOperands,
     /*   5776 */     // GIR_Coverage, 3061,
     /*   5776 */     GIR_EraseRootFromParent_Done,
     /*   5777 */   // Label 141: @5777
     /*   5777 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5840), // Rule ID 3071 //
     /*   5782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5812 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5817 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5838 */     GIR_RootConstrainSelectedInstOperands,
     /*   5839 */     // GIR_Coverage, 3071,
     /*   5839 */     GIR_EraseRootFromParent_Done,
     /*   5840 */   // Label 142: @5840
     /*   5840 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5916), // Rule ID 5423 //
     /*   5845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5884 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5914 */     GIR_RootConstrainSelectedInstOperands,
     /*   5915 */     // GIR_Coverage, 5423,
     /*   5915 */     GIR_EraseRootFromParent_Done,
     /*   5916 */   // Label 143: @5916
     /*   5916 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5992), // Rule ID 5424 //
     /*   5921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5960 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5990 */     GIR_RootConstrainSelectedInstOperands,
     /*   5991 */     // GIR_Coverage, 5424,
     /*   5991 */     GIR_EraseRootFromParent_Done,
     /*   5992 */   // Label 144: @5992
     /*   5992 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6062), // Rule ID 5461 //
     /*   5997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6036 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6060 */     GIR_RootConstrainSelectedInstOperands,
     /*   6061 */     // GIR_Coverage, 5461,
     /*   6061 */     GIR_EraseRootFromParent_Done,
     /*   6062 */   // Label 145: @6062
     /*   6062 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6133), // Rule ID 1999 //
     /*   6067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6095 */     // MIs[1] Operand 2
     /*   6095 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6108 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6131 */     GIR_RootConstrainSelectedInstOperands,
     /*   6132 */     // GIR_Coverage, 1999,
     /*   6132 */     GIR_EraseRootFromParent_Done,
     /*   6133 */   // Label 146: @6133
     /*   6133 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6204), // Rule ID 2000 //
     /*   6138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6166 */     // MIs[1] Operand 2
     /*   6166 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6179 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6202 */     GIR_RootConstrainSelectedInstOperands,
     /*   6203 */     // GIR_Coverage, 2000,
     /*   6203 */     GIR_EraseRootFromParent_Done,
     /*   6204 */   // Label 147: @6204
     /*   6204 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6275), // Rule ID 2231 //
     /*   6209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6237 */     // MIs[1] Operand 2
     /*   6237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6250 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6273 */     GIR_RootConstrainSelectedInstOperands,
     /*   6274 */     // GIR_Coverage, 2231,
     /*   6274 */     GIR_EraseRootFromParent_Done,
     /*   6275 */   // Label 148: @6275
     /*   6275 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6346), // Rule ID 2232 //
     /*   6280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6308 */     // MIs[1] Operand 2
     /*   6308 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6321 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6344 */     GIR_RootConstrainSelectedInstOperands,
     /*   6345 */     // GIR_Coverage, 2232,
     /*   6345 */     GIR_EraseRootFromParent_Done,
     /*   6346 */   // Label 149: @6346
     /*   6346 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6416), // Rule ID 5425 //
     /*   6351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6390 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6414 */     GIR_RootConstrainSelectedInstOperands,
     /*   6415 */     // GIR_Coverage, 5425,
     /*   6415 */     GIR_EraseRootFromParent_Done,
     /*   6416 */   // Label 150: @6416
     /*   6416 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6486), // Rule ID 5462 //
     /*   6421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6460 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6484 */     GIR_RootConstrainSelectedInstOperands,
     /*   6485 */     // GIR_Coverage, 5462,
     /*   6485 */     GIR_EraseRootFromParent_Done,
     /*   6486 */   // Label 151: @6486
     /*   6486 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6549), // Rule ID 5906 //
     /*   6491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6521 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6526 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6547 */     GIR_RootConstrainSelectedInstOperands,
     /*   6548 */     // GIR_Coverage, 5906,
     /*   6548 */     GIR_EraseRootFromParent_Done,
     /*   6549 */   // Label 152: @6549
     /*   6549 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6612), // Rule ID 5920 //
     /*   6554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6584 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6589 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6610 */     GIR_RootConstrainSelectedInstOperands,
     /*   6611 */     // GIR_Coverage, 5920,
     /*   6611 */     GIR_EraseRootFromParent_Done,
     /*   6612 */   // Label 153: @6612
     /*   6612 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6675), // Rule ID 5925 //
     /*   6617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6647 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6652 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6673 */     GIR_RootConstrainSelectedInstOperands,
     /*   6674 */     // GIR_Coverage, 5925,
     /*   6674 */     GIR_EraseRootFromParent_Done,
     /*   6675 */   // Label 154: @6675
     /*   6675 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6721), // Rule ID 73 //
     /*   6680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6695 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6719 */     GIR_RootConstrainSelectedInstOperands,
     /*   6720 */     // GIR_Coverage, 73,
     /*   6720 */     GIR_EraseRootFromParent_Done,
     /*   6721 */   // Label 155: @6721
     /*   6721 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6767), // Rule ID 305 //
     /*   6726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6741 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6765 */     GIR_RootConstrainSelectedInstOperands,
     /*   6766 */     // GIR_Coverage, 305,
     /*   6766 */     GIR_EraseRootFromParent_Done,
     /*   6767 */   // Label 156: @6767
     /*   6767 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6813), // Rule ID 409 //
     /*   6772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6787 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6811 */     GIR_RootConstrainSelectedInstOperands,
     /*   6812 */     // GIR_Coverage, 409,
     /*   6812 */     GIR_EraseRootFromParent_Done,
     /*   6813 */   // Label 157: @6813
     /*   6813 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6859), // Rule ID 5443 //
     /*   6818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6833 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6857 */     GIR_RootConstrainSelectedInstOperands,
     /*   6858 */     // GIR_Coverage, 5443,
     /*   6858 */     GIR_EraseRootFromParent_Done,
     /*   6859 */   // Label 158: @6859
     /*   6859 */   GIM_Reject,
     /*   6860 */ // Label 89: @6860
     /*   6860 */ GIM_Reject,
     /*   6861 */ // Label 80: @6861
     /*   6861 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6907), // Rule ID 759 //
     /*   6866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6887 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6892 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6894 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6899 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6905 */   GIR_RootConstrainSelectedInstOperands,
     /*   6906 */   // GIR_Coverage, 759,
     /*   6906 */   GIR_EraseRootFromParent_Done,
     /*   6907 */ // Label 159: @6907
     /*   6907 */ GIM_Reject,
     /*   6908 */ // Label 81: @6908
     /*   6908 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(7092),
     /*   6913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6923 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(6989), // Rule ID 5512 //
     /*   6928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6963 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6987 */     GIR_RootConstrainSelectedInstOperands,
     /*   6988 */     // GIR_Coverage, 5512,
     /*   6988 */     GIR_EraseRootFromParent_Done,
     /*   6989 */   // Label 161: @6989
     /*   6989 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7055), // Rule ID 886 //
     /*   6994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7029 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7053 */     GIR_RootConstrainSelectedInstOperands,
     /*   7054 */     // GIR_Coverage, 886,
     /*   7054 */     GIR_EraseRootFromParent_Done,
     /*   7055 */   // Label 162: @7055
     /*   7055 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7091), // Rule ID 755 //
     /*   7060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7071 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7089 */     GIR_RootConstrainSelectedInstOperands,
     /*   7090 */     // GIR_Coverage, 755,
     /*   7090 */     GIR_EraseRootFromParent_Done,
     /*   7091 */   // Label 163: @7091
     /*   7091 */   GIM_Reject,
     /*   7092 */ // Label 160: @7092
     /*   7092 */ GIM_Reject,
     /*   7093 */ // Label 82: @7093
     /*   7093 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7803),
     /*   7098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7108 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7176), // Rule ID 779 //
     /*   7113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7152 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7174 */     GIR_RootConstrainSelectedInstOperands,
     /*   7175 */     // GIR_Coverage, 779,
     /*   7175 */     GIR_EraseRootFromParent_Done,
     /*   7176 */   // Label 165: @7176
     /*   7176 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7244), // Rule ID 778 //
     /*   7181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7220 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7242 */     GIR_RootConstrainSelectedInstOperands,
     /*   7243 */     // GIR_Coverage, 778,
     /*   7243 */     GIR_EraseRootFromParent_Done,
     /*   7244 */   // Label 166: @7244
     /*   7244 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7312), // Rule ID 767 //
     /*   7249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7288 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7310 */     GIR_RootConstrainSelectedInstOperands,
     /*   7311 */     // GIR_Coverage, 767,
     /*   7311 */     GIR_EraseRootFromParent_Done,
     /*   7312 */   // Label 167: @7312
     /*   7312 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7380), // Rule ID 777 //
     /*   7317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7356 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7378 */     GIR_RootConstrainSelectedInstOperands,
     /*   7379 */     // GIR_Coverage, 777,
     /*   7379 */     GIR_EraseRootFromParent_Done,
     /*   7380 */   // Label 168: @7380
     /*   7380 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7448), // Rule ID 776 //
     /*   7385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7424 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7446 */     GIR_RootConstrainSelectedInstOperands,
     /*   7447 */     // GIR_Coverage, 776,
     /*   7447 */     GIR_EraseRootFromParent_Done,
     /*   7448 */   // Label 169: @7448
     /*   7448 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7501), // Rule ID 5491 //
     /*   7453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7479 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7499 */     GIR_RootConstrainSelectedInstOperands,
     /*   7500 */     // GIR_Coverage, 5491,
     /*   7500 */     GIR_EraseRootFromParent_Done,
     /*   7501 */   // Label 170: @7501
     /*   7501 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7554), // Rule ID 5485 //
     /*   7506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7532 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7552 */     GIR_RootConstrainSelectedInstOperands,
     /*   7553 */     // GIR_Coverage, 5485,
     /*   7553 */     GIR_EraseRootFromParent_Done,
     /*   7554 */   // Label 171: @7554
     /*   7554 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7607), // Rule ID 5490 //
     /*   7559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7585 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7605 */     GIR_RootConstrainSelectedInstOperands,
     /*   7606 */     // GIR_Coverage, 5490,
     /*   7606 */     GIR_EraseRootFromParent_Done,
     /*   7607 */   // Label 172: @7607
     /*   7607 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7660), // Rule ID 788 //
     /*   7612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7638 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7658 */     GIR_RootConstrainSelectedInstOperands,
     /*   7659 */     // GIR_Coverage, 788,
     /*   7659 */     GIR_EraseRootFromParent_Done,
     /*   7660 */   // Label 173: @7660
     /*   7660 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7713), // Rule ID 782 //
     /*   7665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7691 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7711 */     GIR_RootConstrainSelectedInstOperands,
     /*   7712 */     // GIR_Coverage, 782,
     /*   7712 */     GIR_EraseRootFromParent_Done,
     /*   7713 */   // Label 174: @7713
     /*   7713 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7766), // Rule ID 787 //
     /*   7718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7744 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7764 */     GIR_RootConstrainSelectedInstOperands,
     /*   7765 */     // GIR_Coverage, 787,
     /*   7765 */     GIR_EraseRootFromParent_Done,
     /*   7766 */   // Label 175: @7766
     /*   7766 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7802), // Rule ID 760 //
     /*   7771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7782 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7800 */     GIR_RootConstrainSelectedInstOperands,
     /*   7801 */     // GIR_Coverage, 760,
     /*   7801 */     GIR_EraseRootFromParent_Done,
     /*   7802 */   // Label 176: @7802
     /*   7802 */   GIM_Reject,
     /*   7803 */ // Label 164: @7803
     /*   7803 */ GIM_Reject,
     /*   7804 */ // Label 83: @7804
     /*   7804 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7988),
     /*   7809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7819 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(7885), // Rule ID 5511 //
     /*   7824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7859 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7883 */     GIR_RootConstrainSelectedInstOperands,
     /*   7884 */     // GIR_Coverage, 5511,
     /*   7884 */     GIR_EraseRootFromParent_Done,
     /*   7885 */   // Label 178: @7885
     /*   7885 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7951), // Rule ID 885 //
     /*   7890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7925 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7949 */     GIR_RootConstrainSelectedInstOperands,
     /*   7950 */     // GIR_Coverage, 885,
     /*   7950 */     GIR_EraseRootFromParent_Done,
     /*   7951 */   // Label 179: @7951
     /*   7951 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7987), // Rule ID 754 //
     /*   7956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7967 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7985 */     GIR_RootConstrainSelectedInstOperands,
     /*   7986 */     // GIR_Coverage, 754,
     /*   7986 */     GIR_EraseRootFromParent_Done,
     /*   7987 */   // Label 180: @7987
     /*   7987 */   GIM_Reject,
     /*   7988 */ // Label 177: @7988
     /*   7988 */ GIM_Reject,
     /*   7989 */ // Label 84: @7989
     /*   7989 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8944),
     /*   7994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8000 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8072), // Rule ID 775 //
     /*   8005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8048 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8070 */     GIR_RootConstrainSelectedInstOperands,
     /*   8071 */     // GIR_Coverage, 775,
     /*   8071 */     GIR_EraseRootFromParent_Done,
     /*   8072 */   // Label 182: @8072
     /*   8072 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8144), // Rule ID 774 //
     /*   8077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8120 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8142 */     GIR_RootConstrainSelectedInstOperands,
     /*   8143 */     // GIR_Coverage, 774,
     /*   8143 */     GIR_EraseRootFromParent_Done,
     /*   8144 */   // Label 183: @8144
     /*   8144 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8216), // Rule ID 766 //
     /*   8149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8192 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8214 */     GIR_RootConstrainSelectedInstOperands,
     /*   8215 */     // GIR_Coverage, 766,
     /*   8215 */     GIR_EraseRootFromParent_Done,
     /*   8216 */   // Label 184: @8216
     /*   8216 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8288), // Rule ID 773 //
     /*   8221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8264 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8286 */     GIR_RootConstrainSelectedInstOperands,
     /*   8287 */     // GIR_Coverage, 773,
     /*   8287 */     GIR_EraseRootFromParent_Done,
     /*   8288 */   // Label 185: @8288
     /*   8288 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8360), // Rule ID 772 //
     /*   8293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8336 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8358 */     GIR_RootConstrainSelectedInstOperands,
     /*   8359 */     // GIR_Coverage, 772,
     /*   8359 */     GIR_EraseRootFromParent_Done,
     /*   8360 */   // Label 186: @8360
     /*   8360 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8430), // Rule ID 5515 //
     /*   8365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8404 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8428 */     GIR_RootConstrainSelectedInstOperands,
     /*   8429 */     // GIR_Coverage, 5515,
     /*   8429 */     GIR_EraseRootFromParent_Done,
     /*   8430 */   // Label 187: @8430
     /*   8430 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8487), // Rule ID 5489 //
     /*   8435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8465 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8485 */     GIR_RootConstrainSelectedInstOperands,
     /*   8486 */     // GIR_Coverage, 5489,
     /*   8486 */     GIR_EraseRootFromParent_Done,
     /*   8487 */   // Label 188: @8487
     /*   8487 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8544), // Rule ID 5484 //
     /*   8492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8522 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8542 */     GIR_RootConstrainSelectedInstOperands,
     /*   8543 */     // GIR_Coverage, 5484,
     /*   8543 */     GIR_EraseRootFromParent_Done,
     /*   8544 */   // Label 189: @8544
     /*   8544 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8601), // Rule ID 5488 //
     /*   8549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8579 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8599 */     GIR_RootConstrainSelectedInstOperands,
     /*   8600 */     // GIR_Coverage, 5488,
     /*   8600 */     GIR_EraseRootFromParent_Done,
     /*   8601 */   // Label 190: @8601
     /*   8601 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8671), // Rule ID 889 //
     /*   8606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8645 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8669 */     GIR_RootConstrainSelectedInstOperands,
     /*   8670 */     // GIR_Coverage, 889,
     /*   8670 */     GIR_EraseRootFromParent_Done,
     /*   8671 */   // Label 191: @8671
     /*   8671 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8728), // Rule ID 786 //
     /*   8676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8706 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8726 */     GIR_RootConstrainSelectedInstOperands,
     /*   8727 */     // GIR_Coverage, 786,
     /*   8727 */     GIR_EraseRootFromParent_Done,
     /*   8728 */   // Label 192: @8728
     /*   8728 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8785), // Rule ID 781 //
     /*   8733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8763 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8783 */     GIR_RootConstrainSelectedInstOperands,
     /*   8784 */     // GIR_Coverage, 781,
     /*   8784 */     GIR_EraseRootFromParent_Done,
     /*   8785 */   // Label 193: @8785
     /*   8785 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8842), // Rule ID 785 //
     /*   8790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8820 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8840 */     GIR_RootConstrainSelectedInstOperands,
     /*   8841 */     // GIR_Coverage, 785,
     /*   8841 */     GIR_EraseRootFromParent_Done,
     /*   8842 */   // Label 194: @8842
     /*   8842 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8882), // Rule ID 758 //
     /*   8847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8862 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8880 */     GIR_RootConstrainSelectedInstOperands,
     /*   8881 */     // GIR_Coverage, 758,
     /*   8881 */     GIR_EraseRootFromParent_Done,
     /*   8882 */   // Label 195: @8882
     /*   8882 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8943), // Rule ID 3476 //
     /*   8887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8902 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8941 */     GIR_RootConstrainSelectedInstOperands,
     /*   8942 */     // GIR_Coverage, 3476,
     /*   8942 */     GIR_EraseRootFromParent_Done,
     /*   8943 */   // Label 196: @8943
     /*   8943 */   GIM_Reject,
     /*   8944 */ // Label 181: @8944
     /*   8944 */ GIM_Reject,
     /*   8945 */ // Label 85: @8945
     /*   8945 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(9129),
     /*   8950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8960 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9026), // Rule ID 5510 //
     /*   8965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9000 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9024 */     GIR_RootConstrainSelectedInstOperands,
     /*   9025 */     // GIR_Coverage, 5510,
     /*   9025 */     GIR_EraseRootFromParent_Done,
     /*   9026 */   // Label 198: @9026
     /*   9026 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9092), // Rule ID 884 //
     /*   9031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9066 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9071 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9090 */     GIR_RootConstrainSelectedInstOperands,
     /*   9091 */     // GIR_Coverage, 884,
     /*   9091 */     GIR_EraseRootFromParent_Done,
     /*   9092 */   // Label 199: @9092
     /*   9092 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9128), // Rule ID 753 //
     /*   9097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9108 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9126 */     GIR_RootConstrainSelectedInstOperands,
     /*   9127 */     // GIR_Coverage, 753,
     /*   9127 */     GIR_EraseRootFromParent_Done,
     /*   9128 */   // Label 200: @9128
     /*   9128 */   GIM_Reject,
     /*   9129 */ // Label 197: @9129
     /*   9129 */ GIM_Reject,
     /*   9130 */ // Label 86: @9130
     /*   9130 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(10085),
     /*   9135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9141 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(9213), // Rule ID 771 //
     /*   9146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9189 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9211 */     GIR_RootConstrainSelectedInstOperands,
     /*   9212 */     // GIR_Coverage, 771,
     /*   9212 */     GIR_EraseRootFromParent_Done,
     /*   9213 */   // Label 202: @9213
     /*   9213 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9285), // Rule ID 770 //
     /*   9218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9261 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9283 */     GIR_RootConstrainSelectedInstOperands,
     /*   9284 */     // GIR_Coverage, 770,
     /*   9284 */     GIR_EraseRootFromParent_Done,
     /*   9285 */   // Label 203: @9285
     /*   9285 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9357), // Rule ID 765 //
     /*   9290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9333 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9355 */     GIR_RootConstrainSelectedInstOperands,
     /*   9356 */     // GIR_Coverage, 765,
     /*   9356 */     GIR_EraseRootFromParent_Done,
     /*   9357 */   // Label 204: @9357
     /*   9357 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9429), // Rule ID 769 //
     /*   9362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9405 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9421 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9427 */     GIR_RootConstrainSelectedInstOperands,
     /*   9428 */     // GIR_Coverage, 769,
     /*   9428 */     GIR_EraseRootFromParent_Done,
     /*   9429 */   // Label 205: @9429
     /*   9429 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9501), // Rule ID 768 //
     /*   9434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9477 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9499 */     GIR_RootConstrainSelectedInstOperands,
     /*   9500 */     // GIR_Coverage, 768,
     /*   9500 */     GIR_EraseRootFromParent_Done,
     /*   9501 */   // Label 206: @9501
     /*   9501 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9571), // Rule ID 5514 //
     /*   9506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9545 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9550 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9569 */     GIR_RootConstrainSelectedInstOperands,
     /*   9570 */     // GIR_Coverage, 5514,
     /*   9570 */     GIR_EraseRootFromParent_Done,
     /*   9571 */   // Label 207: @9571
     /*   9571 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9628), // Rule ID 5487 //
     /*   9576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9606 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9626 */     GIR_RootConstrainSelectedInstOperands,
     /*   9627 */     // GIR_Coverage, 5487,
     /*   9627 */     GIR_EraseRootFromParent_Done,
     /*   9628 */   // Label 208: @9628
     /*   9628 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9685), // Rule ID 5483 //
     /*   9633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9663 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9683 */     GIR_RootConstrainSelectedInstOperands,
     /*   9684 */     // GIR_Coverage, 5483,
     /*   9684 */     GIR_EraseRootFromParent_Done,
     /*   9685 */   // Label 209: @9685
     /*   9685 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9742), // Rule ID 5486 //
     /*   9690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9720 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9740 */     GIR_RootConstrainSelectedInstOperands,
     /*   9741 */     // GIR_Coverage, 5486,
     /*   9741 */     GIR_EraseRootFromParent_Done,
     /*   9742 */   // Label 210: @9742
     /*   9742 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9812), // Rule ID 888 //
     /*   9747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9786 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9810 */     GIR_RootConstrainSelectedInstOperands,
     /*   9811 */     // GIR_Coverage, 888,
     /*   9811 */     GIR_EraseRootFromParent_Done,
     /*   9812 */   // Label 211: @9812
     /*   9812 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9869), // Rule ID 784 //
     /*   9817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9847 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9867 */     GIR_RootConstrainSelectedInstOperands,
     /*   9868 */     // GIR_Coverage, 784,
     /*   9868 */     GIR_EraseRootFromParent_Done,
     /*   9869 */   // Label 212: @9869
     /*   9869 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9926), // Rule ID 780 //
     /*   9874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9904 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9924 */     GIR_RootConstrainSelectedInstOperands,
     /*   9925 */     // GIR_Coverage, 780,
     /*   9925 */     GIR_EraseRootFromParent_Done,
     /*   9926 */   // Label 213: @9926
     /*   9926 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9983), // Rule ID 783 //
     /*   9931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9961 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9981 */     GIR_RootConstrainSelectedInstOperands,
     /*   9982 */     // GIR_Coverage, 783,
     /*   9982 */     GIR_EraseRootFromParent_Done,
     /*   9983 */   // Label 214: @9983
     /*   9983 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(10023), // Rule ID 757 //
     /*   9988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10003 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10021 */     GIR_RootConstrainSelectedInstOperands,
     /*  10022 */     // GIR_Coverage, 757,
     /*  10022 */     GIR_EraseRootFromParent_Done,
     /*  10023 */   // Label 215: @10023
     /*  10023 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10084), // Rule ID 3472 //
     /*  10028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10043 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10082 */     GIR_RootConstrainSelectedInstOperands,
     /*  10083 */     // GIR_Coverage, 3472,
     /*  10083 */     GIR_EraseRootFromParent_Done,
     /*  10084 */   // Label 216: @10084
     /*  10084 */   GIM_Reject,
     /*  10085 */ // Label 201: @10085
     /*  10085 */ GIM_Reject,
     /*  10086 */ // Label 87: @10086
     /*  10086 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10339),
     /*  10091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10097 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10167), // Rule ID 5513 //
     /*  10102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10141 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10165 */     GIR_RootConstrainSelectedInstOperands,
     /*  10166 */     // GIR_Coverage, 5513,
     /*  10166 */     GIR_EraseRootFromParent_Done,
     /*  10167 */   // Label 218: @10167
     /*  10167 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10237), // Rule ID 887 //
     /*  10172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10211 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10235 */     GIR_RootConstrainSelectedInstOperands,
     /*  10236 */     // GIR_Coverage, 887,
     /*  10236 */     GIR_EraseRootFromParent_Done,
     /*  10237 */   // Label 219: @10237
     /*  10237 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10277), // Rule ID 756 //
     /*  10242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10257 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10275 */     GIR_RootConstrainSelectedInstOperands,
     /*  10276 */     // GIR_Coverage, 756,
     /*  10276 */     GIR_EraseRootFromParent_Done,
     /*  10277 */   // Label 220: @10277
     /*  10277 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10338), // Rule ID 3468 //
     /*  10282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10297 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10336 */     GIR_RootConstrainSelectedInstOperands,
     /*  10337 */     // GIR_Coverage, 3468,
     /*  10337 */     GIR_EraseRootFromParent_Done,
     /*  10338 */   // Label 221: @10338
     /*  10338 */   GIM_Reject,
     /*  10339 */ // Label 217: @10339
     /*  10339 */ GIM_Reject,
     /*  10340 */ // Label 88: @10340
     /*  10340 */ GIM_Reject,
     /*  10341 */ // Label 1: @10341
     /*  10341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 231*/ GIMT_Encode4(13584),
     /*  10352 */ /*GILLT_s32*//*Label 222*/ GIMT_Encode4(10412),
     /*  10356 */ /*GILLT_s64*//*Label 223*/ GIMT_Encode4(11026), GIMT_Encode4(0),
     /*  10364 */ /*GILLT_v2s32*//*Label 224*/ GIMT_Encode4(11073),
     /*  10368 */ /*GILLT_v2s64*//*Label 225*/ GIMT_Encode4(11188), GIMT_Encode4(0),
     /*  10376 */ /*GILLT_v4s16*//*Label 226*/ GIMT_Encode4(11740),
     /*  10380 */ /*GILLT_v4s32*//*Label 227*/ GIMT_Encode4(11855), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v8s8*//*Label 228*/ GIMT_Encode4(12570),
     /*  10396 */ /*GILLT_v8s16*//*Label 229*/ GIMT_Encode4(12685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v16s8*//*Label 230*/ GIMT_Encode4(13400),
     /*  10412 */ // Label 222: @10412
     /*  10412 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(11025),
     /*  10417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10423 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10467), // Rule ID 330 //
     /*  10428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10443 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10465 */     GIR_RootConstrainSelectedInstOperands,
     /*  10466 */     // GIR_Coverage, 330,
     /*  10466 */     GIR_EraseRootFromParent_Done,
     /*  10467 */   // Label 233: @10467
     /*  10467 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10524), // Rule ID 96 //
     /*  10472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10491 */     // MIs[1] Operand 1
     /*  10491 */     // No operand predicates
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10497 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10522 */     GIR_RootConstrainSelectedInstOperands,
     /*  10523 */     // GIR_Coverage, 96,
     /*  10523 */     GIR_EraseRootFromParent_Done,
     /*  10524 */   // Label 234: @10524
     /*  10524 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10581), // Rule ID 427 //
     /*  10529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10548 */     // MIs[1] Operand 1
     /*  10548 */     // No operand predicates
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10554 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10579 */     GIR_RootConstrainSelectedInstOperands,
     /*  10580 */     // GIR_Coverage, 427,
     /*  10580 */     GIR_EraseRootFromParent_Done,
     /*  10581 */   // Label 235: @10581
     /*  10581 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10638), // Rule ID 76 //
     /*  10586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10609 */     // MIs[1] Operand 1
     /*  10609 */     // No operand predicates
     /*  10609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10611 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10636 */     GIR_RootConstrainSelectedInstOperands,
     /*  10637 */     // GIR_Coverage, 76,
     /*  10637 */     GIR_EraseRootFromParent_Done,
     /*  10638 */   // Label 236: @10638
     /*  10638 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10695), // Rule ID 411 //
     /*  10643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10666 */     // MIs[1] Operand 1
     /*  10666 */     // No operand predicates
     /*  10666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10668 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10693 */     GIR_RootConstrainSelectedInstOperands,
     /*  10694 */     // GIR_Coverage, 411,
     /*  10694 */     GIR_EraseRootFromParent_Done,
     /*  10695 */   // Label 237: @10695
     /*  10695 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10746), // Rule ID 412 //
     /*  10700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10723 */     // MIs[1] Operand 1
     /*  10723 */     // No operand predicates
     /*  10723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10725 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10744 */     GIR_RootConstrainSelectedInstOperands,
     /*  10745 */     // GIR_Coverage, 412,
     /*  10745 */     GIR_EraseRootFromParent_Done,
     /*  10746 */   // Label 238: @10746
     /*  10746 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10816), // Rule ID 173 //
     /*  10751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10790 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10814 */     GIR_RootConstrainSelectedInstOperands,
     /*  10815 */     // GIR_Coverage, 173,
     /*  10815 */     GIR_EraseRootFromParent_Done,
     /*  10816 */   // Label 239: @10816
     /*  10816 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10886), // Rule ID 504 //
     /*  10821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10860 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10884 */     GIR_RootConstrainSelectedInstOperands,
     /*  10885 */     // GIR_Coverage, 504,
     /*  10885 */     GIR_EraseRootFromParent_Done,
     /*  10886 */   // Label 240: @10886
     /*  10886 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10932), // Rule ID 77 //
     /*  10891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10906 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10930 */     GIR_RootConstrainSelectedInstOperands,
     /*  10931 */     // GIR_Coverage, 77,
     /*  10931 */     GIR_EraseRootFromParent_Done,
     /*  10932 */   // Label 241: @10932
     /*  10932 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10978), // Rule ID 333 //
     /*  10937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10952 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10976 */     GIR_RootConstrainSelectedInstOperands,
     /*  10977 */     // GIR_Coverage, 333,
     /*  10977 */     GIR_EraseRootFromParent_Done,
     /*  10978 */   // Label 242: @10978
     /*  10978 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(11024), // Rule ID 413 //
     /*  10983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10998 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  10998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11022 */     GIR_RootConstrainSelectedInstOperands,
     /*  11023 */     // GIR_Coverage, 413,
     /*  11023 */     GIR_EraseRootFromParent_Done,
     /*  11024 */   // Label 243: @11024
     /*  11024 */   GIM_Reject,
     /*  11025 */ // Label 232: @11025
     /*  11025 */ GIM_Reject,
     /*  11026 */ // Label 223: @11026
     /*  11026 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11072), // Rule ID 963 //
     /*  11031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11052 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11057 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11059 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11064 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11070 */   GIR_RootConstrainSelectedInstOperands,
     /*  11071 */   // GIR_Coverage, 963,
     /*  11071 */   GIR_EraseRootFromParent_Done,
     /*  11072 */ // Label 244: @11072
     /*  11072 */ GIM_Reject,
     /*  11073 */ // Label 224: @11073
     /*  11073 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11187),
     /*  11078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11092 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11154), // Rule ID 914 //
     /*  11097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11128 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11152 */     GIR_RootConstrainSelectedInstOperands,
     /*  11153 */     // GIR_Coverage, 914,
     /*  11153 */     GIR_EraseRootFromParent_Done,
     /*  11154 */   // Label 246: @11154
     /*  11154 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11186), // Rule ID 959 //
     /*  11159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11166 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11184 */     GIR_RootConstrainSelectedInstOperands,
     /*  11185 */     // GIR_Coverage, 959,
     /*  11185 */     GIR_EraseRootFromParent_Done,
     /*  11186 */   // Label 247: @11186
     /*  11186 */   GIM_Reject,
     /*  11187 */ // Label 245: @11187
     /*  11187 */ GIM_Reject,
     /*  11188 */ // Label 225: @11188
     /*  11188 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11739),
     /*  11193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11203 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11271), // Rule ID 983 //
     /*  11208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11247 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11269 */     GIR_RootConstrainSelectedInstOperands,
     /*  11270 */     // GIR_Coverage, 983,
     /*  11270 */     GIR_EraseRootFromParent_Done,
     /*  11271 */   // Label 249: @11271
     /*  11271 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11339), // Rule ID 982 //
     /*  11276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11315 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11337 */     GIR_RootConstrainSelectedInstOperands,
     /*  11338 */     // GIR_Coverage, 982,
     /*  11338 */     GIR_EraseRootFromParent_Done,
     /*  11339 */   // Label 250: @11339
     /*  11339 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11407), // Rule ID 971 //
     /*  11344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11383 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11405 */     GIR_RootConstrainSelectedInstOperands,
     /*  11406 */     // GIR_Coverage, 971,
     /*  11406 */     GIR_EraseRootFromParent_Done,
     /*  11407 */   // Label 251: @11407
     /*  11407 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11475), // Rule ID 981 //
     /*  11412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11451 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11473 */     GIR_RootConstrainSelectedInstOperands,
     /*  11474 */     // GIR_Coverage, 981,
     /*  11474 */     GIR_EraseRootFromParent_Done,
     /*  11475 */   // Label 252: @11475
     /*  11475 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11543), // Rule ID 980 //
     /*  11480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11519 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11541 */     GIR_RootConstrainSelectedInstOperands,
     /*  11542 */     // GIR_Coverage, 980,
     /*  11542 */     GIR_EraseRootFromParent_Done,
     /*  11543 */   // Label 253: @11543
     /*  11543 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11596), // Rule ID 992 //
     /*  11548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11574 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11594 */     GIR_RootConstrainSelectedInstOperands,
     /*  11595 */     // GIR_Coverage, 992,
     /*  11595 */     GIR_EraseRootFromParent_Done,
     /*  11596 */   // Label 254: @11596
     /*  11596 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11649), // Rule ID 986 //
     /*  11601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11627 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11647 */     GIR_RootConstrainSelectedInstOperands,
     /*  11648 */     // GIR_Coverage, 986,
     /*  11648 */     GIR_EraseRootFromParent_Done,
     /*  11649 */   // Label 255: @11649
     /*  11649 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11702), // Rule ID 991 //
     /*  11654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11680 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11700 */     GIR_RootConstrainSelectedInstOperands,
     /*  11701 */     // GIR_Coverage, 991,
     /*  11701 */     GIR_EraseRootFromParent_Done,
     /*  11702 */   // Label 256: @11702
     /*  11702 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11738), // Rule ID 964 //
     /*  11707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11718 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11736 */     GIR_RootConstrainSelectedInstOperands,
     /*  11737 */     // GIR_Coverage, 964,
     /*  11737 */     GIR_EraseRootFromParent_Done,
     /*  11738 */   // Label 257: @11738
     /*  11738 */   GIM_Reject,
     /*  11739 */ // Label 248: @11739
     /*  11739 */ GIM_Reject,
     /*  11740 */ // Label 226: @11740
     /*  11740 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11854),
     /*  11745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11759 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11821), // Rule ID 913 //
     /*  11764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11795 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11819 */     GIR_RootConstrainSelectedInstOperands,
     /*  11820 */     // GIR_Coverage, 913,
     /*  11820 */     GIR_EraseRootFromParent_Done,
     /*  11821 */   // Label 259: @11821
     /*  11821 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11853), // Rule ID 958 //
     /*  11826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11833 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11851 */     GIR_RootConstrainSelectedInstOperands,
     /*  11852 */     // GIR_Coverage, 958,
     /*  11852 */     GIR_EraseRootFromParent_Done,
     /*  11853 */   // Label 260: @11853
     /*  11853 */   GIM_Reject,
     /*  11854 */ // Label 258: @11854
     /*  11854 */ GIM_Reject,
     /*  11855 */ // Label 227: @11855
     /*  11855 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(12569),
     /*  11860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11866 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11938), // Rule ID 979 //
     /*  11871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11914 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11936 */     GIR_RootConstrainSelectedInstOperands,
     /*  11937 */     // GIR_Coverage, 979,
     /*  11937 */     GIR_EraseRootFromParent_Done,
     /*  11938 */   // Label 262: @11938
     /*  11938 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12010), // Rule ID 978 //
     /*  11943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11986 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12008 */     GIR_RootConstrainSelectedInstOperands,
     /*  12009 */     // GIR_Coverage, 978,
     /*  12009 */     GIR_EraseRootFromParent_Done,
     /*  12010 */   // Label 263: @12010
     /*  12010 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12082), // Rule ID 970 //
     /*  12015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12058 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12080 */     GIR_RootConstrainSelectedInstOperands,
     /*  12081 */     // GIR_Coverage, 970,
     /*  12081 */     GIR_EraseRootFromParent_Done,
     /*  12082 */   // Label 264: @12082
     /*  12082 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12154), // Rule ID 977 //
     /*  12087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12130 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12152 */     GIR_RootConstrainSelectedInstOperands,
     /*  12153 */     // GIR_Coverage, 977,
     /*  12153 */     GIR_EraseRootFromParent_Done,
     /*  12154 */   // Label 265: @12154
     /*  12154 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12226), // Rule ID 976 //
     /*  12159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12202 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12224 */     GIR_RootConstrainSelectedInstOperands,
     /*  12225 */     // GIR_Coverage, 976,
     /*  12225 */     GIR_EraseRootFromParent_Done,
     /*  12226 */   // Label 266: @12226
     /*  12226 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12296), // Rule ID 917 //
     /*  12231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12270 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12294 */     GIR_RootConstrainSelectedInstOperands,
     /*  12295 */     // GIR_Coverage, 917,
     /*  12295 */     GIR_EraseRootFromParent_Done,
     /*  12296 */   // Label 267: @12296
     /*  12296 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12353), // Rule ID 990 //
     /*  12301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12331 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12351 */     GIR_RootConstrainSelectedInstOperands,
     /*  12352 */     // GIR_Coverage, 990,
     /*  12352 */     GIR_EraseRootFromParent_Done,
     /*  12353 */   // Label 268: @12353
     /*  12353 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12410), // Rule ID 985 //
     /*  12358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12388 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12408 */     GIR_RootConstrainSelectedInstOperands,
     /*  12409 */     // GIR_Coverage, 985,
     /*  12409 */     GIR_EraseRootFromParent_Done,
     /*  12410 */   // Label 269: @12410
     /*  12410 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12467), // Rule ID 989 //
     /*  12415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12445 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12465 */     GIR_RootConstrainSelectedInstOperands,
     /*  12466 */     // GIR_Coverage, 989,
     /*  12466 */     GIR_EraseRootFromParent_Done,
     /*  12467 */   // Label 270: @12467
     /*  12467 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12507), // Rule ID 962 //
     /*  12472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12487 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12505 */     GIR_RootConstrainSelectedInstOperands,
     /*  12506 */     // GIR_Coverage, 962,
     /*  12506 */     GIR_EraseRootFromParent_Done,
     /*  12507 */   // Label 271: @12507
     /*  12507 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12568), // Rule ID 3488 //
     /*  12512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12527 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12566 */     GIR_RootConstrainSelectedInstOperands,
     /*  12567 */     // GIR_Coverage, 3488,
     /*  12567 */     GIR_EraseRootFromParent_Done,
     /*  12568 */   // Label 272: @12568
     /*  12568 */   GIM_Reject,
     /*  12569 */ // Label 261: @12569
     /*  12569 */ GIM_Reject,
     /*  12570 */ // Label 228: @12570
     /*  12570 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12684),
     /*  12575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12589 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12651), // Rule ID 912 //
     /*  12594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12625 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12649 */     GIR_RootConstrainSelectedInstOperands,
     /*  12650 */     // GIR_Coverage, 912,
     /*  12650 */     GIR_EraseRootFromParent_Done,
     /*  12651 */   // Label 274: @12651
     /*  12651 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12683), // Rule ID 957 //
     /*  12656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12663 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12681 */     GIR_RootConstrainSelectedInstOperands,
     /*  12682 */     // GIR_Coverage, 957,
     /*  12682 */     GIR_EraseRootFromParent_Done,
     /*  12683 */   // Label 275: @12683
     /*  12683 */   GIM_Reject,
     /*  12684 */ // Label 273: @12684
     /*  12684 */ GIM_Reject,
     /*  12685 */ // Label 229: @12685
     /*  12685 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13399),
     /*  12690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12696 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(12768), // Rule ID 975 //
     /*  12701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12744 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12766 */     GIR_RootConstrainSelectedInstOperands,
     /*  12767 */     // GIR_Coverage, 975,
     /*  12767 */     GIR_EraseRootFromParent_Done,
     /*  12768 */   // Label 277: @12768
     /*  12768 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12840), // Rule ID 974 //
     /*  12773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12816 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12838 */     GIR_RootConstrainSelectedInstOperands,
     /*  12839 */     // GIR_Coverage, 974,
     /*  12839 */     GIR_EraseRootFromParent_Done,
     /*  12840 */   // Label 278: @12840
     /*  12840 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12912), // Rule ID 969 //
     /*  12845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12888 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12910 */     GIR_RootConstrainSelectedInstOperands,
     /*  12911 */     // GIR_Coverage, 969,
     /*  12911 */     GIR_EraseRootFromParent_Done,
     /*  12912 */   // Label 279: @12912
     /*  12912 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12984), // Rule ID 973 //
     /*  12917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12960 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12982 */     GIR_RootConstrainSelectedInstOperands,
     /*  12983 */     // GIR_Coverage, 973,
     /*  12983 */     GIR_EraseRootFromParent_Done,
     /*  12984 */   // Label 280: @12984
     /*  12984 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13056), // Rule ID 972 //
     /*  12989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13032 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13054 */     GIR_RootConstrainSelectedInstOperands,
     /*  13055 */     // GIR_Coverage, 972,
     /*  13055 */     GIR_EraseRootFromParent_Done,
     /*  13056 */   // Label 281: @13056
     /*  13056 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13126), // Rule ID 916 //
     /*  13061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13100 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13124 */     GIR_RootConstrainSelectedInstOperands,
     /*  13125 */     // GIR_Coverage, 916,
     /*  13125 */     GIR_EraseRootFromParent_Done,
     /*  13126 */   // Label 282: @13126
     /*  13126 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13183), // Rule ID 988 //
     /*  13131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13161 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13181 */     GIR_RootConstrainSelectedInstOperands,
     /*  13182 */     // GIR_Coverage, 988,
     /*  13182 */     GIR_EraseRootFromParent_Done,
     /*  13183 */   // Label 283: @13183
     /*  13183 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13240), // Rule ID 984 //
     /*  13188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13218 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13238 */     GIR_RootConstrainSelectedInstOperands,
     /*  13239 */     // GIR_Coverage, 984,
     /*  13239 */     GIR_EraseRootFromParent_Done,
     /*  13240 */   // Label 284: @13240
     /*  13240 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13297), // Rule ID 987 //
     /*  13245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13275 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13295 */     GIR_RootConstrainSelectedInstOperands,
     /*  13296 */     // GIR_Coverage, 987,
     /*  13296 */     GIR_EraseRootFromParent_Done,
     /*  13297 */   // Label 285: @13297
     /*  13297 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13337), // Rule ID 961 //
     /*  13302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13317 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13335 */     GIR_RootConstrainSelectedInstOperands,
     /*  13336 */     // GIR_Coverage, 961,
     /*  13336 */     GIR_EraseRootFromParent_Done,
     /*  13337 */   // Label 286: @13337
     /*  13337 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13398), // Rule ID 3484 //
     /*  13342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13357 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13396 */     GIR_RootConstrainSelectedInstOperands,
     /*  13397 */     // GIR_Coverage, 3484,
     /*  13397 */     GIR_EraseRootFromParent_Done,
     /*  13398 */   // Label 287: @13398
     /*  13398 */   GIM_Reject,
     /*  13399 */ // Label 276: @13399
     /*  13399 */ GIM_Reject,
     /*  13400 */ // Label 230: @13400
     /*  13400 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13583),
     /*  13405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13411 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13481), // Rule ID 915 //
     /*  13416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13455 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13479 */     GIR_RootConstrainSelectedInstOperands,
     /*  13480 */     // GIR_Coverage, 915,
     /*  13480 */     GIR_EraseRootFromParent_Done,
     /*  13481 */   // Label 289: @13481
     /*  13481 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13521), // Rule ID 960 //
     /*  13486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13501 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13519 */     GIR_RootConstrainSelectedInstOperands,
     /*  13520 */     // GIR_Coverage, 960,
     /*  13520 */     GIR_EraseRootFromParent_Done,
     /*  13521 */   // Label 290: @13521
     /*  13521 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13582), // Rule ID 3480 //
     /*  13526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13541 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13580 */     GIR_RootConstrainSelectedInstOperands,
     /*  13581 */     // GIR_Coverage, 3480,
     /*  13581 */     GIR_EraseRootFromParent_Done,
     /*  13582 */   // Label 291: @13582
     /*  13582 */   GIM_Reject,
     /*  13583 */ // Label 288: @13583
     /*  13583 */ GIM_Reject,
     /*  13584 */ // Label 231: @13584
     /*  13584 */ GIM_Reject,
     /*  13585 */ // Label 2: @13585
     /*  13585 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 299*/ GIMT_Encode4(15288),
     /*  13596 */ /*GILLT_s32*//*Label 292*/ GIMT_Encode4(13656), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13608 */ /*GILLT_v2s32*//*Label 293*/ GIMT_Encode4(14575), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13620 */ /*GILLT_v4s16*//*Label 294*/ GIMT_Encode4(14622),
     /*  13624 */ /*GILLT_v4s32*//*Label 295*/ GIMT_Encode4(14669), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v8s8*//*Label 296*/ GIMT_Encode4(14898),
     /*  13640 */ /*GILLT_v8s16*//*Label 297*/ GIMT_Encode4(14945), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v16s8*//*Label 298*/ GIMT_Encode4(15174),
     /*  13656 */ // Label 292: @13656
     /*  13656 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(14574),
     /*  13661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13667 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(13755), // Rule ID 186 //
     /*  13672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13700 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13725 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13731 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13753 */     GIR_RootConstrainSelectedInstOperands,
     /*  13754 */     // GIR_Coverage, 186,
     /*  13754 */     GIR_EraseRootFromParent_Done,
     /*  13755 */   // Label 301: @13755
     /*  13755 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13843), // Rule ID 515 //
     /*  13760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13788 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13813 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13819 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13841 */     GIR_RootConstrainSelectedInstOperands,
     /*  13842 */     // GIR_Coverage, 515,
     /*  13842 */     GIR_EraseRootFromParent_Done,
     /*  13843 */   // Label 302: @13843
     /*  13843 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13934), // Rule ID 185 //
     /*  13848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13897 */     // MIs[2] Operand 2
     /*  13897 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13910 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13932 */     GIR_RootConstrainSelectedInstOperands,
     /*  13933 */     // GIR_Coverage, 185,
     /*  13933 */     GIR_EraseRootFromParent_Done,
     /*  13934 */   // Label 303: @13934
     /*  13934 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(14025), // Rule ID 514 //
     /*  13939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13967 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13988 */     // MIs[2] Operand 2
     /*  13988 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14001 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14023 */     GIR_RootConstrainSelectedInstOperands,
     /*  14024 */     // GIR_Coverage, 514,
     /*  14024 */     GIR_EraseRootFromParent_Done,
     /*  14025 */   // Label 304: @14025
     /*  14025 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14116), // Rule ID 184 //
     /*  14030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14054 */     // MIs[1] Operand 2
     /*  14054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14086 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14092 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14114 */     GIR_RootConstrainSelectedInstOperands,
     /*  14115 */     // GIR_Coverage, 184,
     /*  14115 */     GIR_EraseRootFromParent_Done,
     /*  14116 */   // Label 305: @14116
     /*  14116 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14207), // Rule ID 513 //
     /*  14121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14145 */     // MIs[1] Operand 2
     /*  14145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14177 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14183 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14205 */     GIR_RootConstrainSelectedInstOperands,
     /*  14206 */     // GIR_Coverage, 513,
     /*  14206 */     GIR_EraseRootFromParent_Done,
     /*  14207 */   // Label 306: @14207
     /*  14207 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14301), // Rule ID 183 //
     /*  14212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14236 */     // MIs[1] Operand 2
     /*  14236 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14264 */     // MIs[2] Operand 2
     /*  14264 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14277 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14299 */     GIR_RootConstrainSelectedInstOperands,
     /*  14300 */     // GIR_Coverage, 183,
     /*  14300 */     GIR_EraseRootFromParent_Done,
     /*  14301 */   // Label 307: @14301
     /*  14301 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14395), // Rule ID 512 //
     /*  14306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14330 */     // MIs[1] Operand 2
     /*  14330 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14358 */     // MIs[2] Operand 2
     /*  14358 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14371 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14393 */     GIR_RootConstrainSelectedInstOperands,
     /*  14394 */     // GIR_Coverage, 512,
     /*  14394 */     GIR_EraseRootFromParent_Done,
     /*  14395 */   // Label 308: @14395
     /*  14395 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14441), // Rule ID 169 //
     /*  14400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14415 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14439 */     GIR_RootConstrainSelectedInstOperands,
     /*  14440 */     // GIR_Coverage, 169,
     /*  14440 */     GIR_EraseRootFromParent_Done,
     /*  14441 */   // Label 309: @14441
     /*  14441 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14487), // Rule ID 170 //
     /*  14446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14461 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14485 */     GIR_RootConstrainSelectedInstOperands,
     /*  14486 */     // GIR_Coverage, 170,
     /*  14486 */     GIR_EraseRootFromParent_Done,
     /*  14487 */   // Label 310: @14487
     /*  14487 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14533), // Rule ID 323 //
     /*  14492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14507 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14531 */     GIR_RootConstrainSelectedInstOperands,
     /*  14532 */     // GIR_Coverage, 323,
     /*  14532 */     GIR_EraseRootFromParent_Done,
     /*  14533 */   // Label 311: @14533
     /*  14533 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14573), // Rule ID 502 //
     /*  14538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14553 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14571 */     GIR_RootConstrainSelectedInstOperands,
     /*  14572 */     // GIR_Coverage, 502,
     /*  14572 */     GIR_EraseRootFromParent_Done,
     /*  14573 */   // Label 312: @14573
     /*  14573 */   GIM_Reject,
     /*  14574 */ // Label 300: @14574
     /*  14574 */ GIM_Reject,
     /*  14575 */ // Label 293: @14575
     /*  14575 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14621), // Rule ID 834 //
     /*  14580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14601 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14606 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14608 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14613 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14619 */   GIR_RootConstrainSelectedInstOperands,
     /*  14620 */   // GIR_Coverage, 834,
     /*  14620 */   GIR_EraseRootFromParent_Done,
     /*  14621 */ // Label 313: @14621
     /*  14621 */ GIM_Reject,
     /*  14622 */ // Label 294: @14622
     /*  14622 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14668), // Rule ID 833 //
     /*  14627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14648 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14653 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14655 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14660 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14666 */   GIR_RootConstrainSelectedInstOperands,
     /*  14667 */   // GIR_Coverage, 833,
     /*  14667 */   GIR_EraseRootFromParent_Done,
     /*  14668 */ // Label 314: @14668
     /*  14668 */ GIM_Reject,
     /*  14669 */ // Label 295: @14669
     /*  14669 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14897),
     /*  14674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14680 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14795), // Rule ID 4401 //
     /*  14685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14709 */     // MIs[1] Operand 2
     /*  14709 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14737 */     // MIs[2] Operand 2
     /*  14737 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14750 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14793 */     GIR_RootConstrainSelectedInstOperands,
     /*  14794 */     // GIR_Coverage, 4401,
     /*  14794 */     GIR_EraseRootFromParent_Done,
     /*  14795 */   // Label 316: @14795
     /*  14795 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14835), // Rule ID 837 //
     /*  14800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14815 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14833 */     GIR_RootConstrainSelectedInstOperands,
     /*  14834 */     // GIR_Coverage, 837,
     /*  14834 */     GIR_EraseRootFromParent_Done,
     /*  14835 */   // Label 317: @14835
     /*  14835 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14896), // Rule ID 3446 //
     /*  14840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14855 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14894 */     GIR_RootConstrainSelectedInstOperands,
     /*  14895 */     // GIR_Coverage, 3446,
     /*  14895 */     GIR_EraseRootFromParent_Done,
     /*  14896 */   // Label 318: @14896
     /*  14896 */   GIM_Reject,
     /*  14897 */ // Label 315: @14897
     /*  14897 */ GIM_Reject,
     /*  14898 */ // Label 296: @14898
     /*  14898 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14944), // Rule ID 832 //
     /*  14903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14924 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14929 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14931 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14936 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14942 */   GIR_RootConstrainSelectedInstOperands,
     /*  14943 */   // GIR_Coverage, 832,
     /*  14943 */   GIR_EraseRootFromParent_Done,
     /*  14944 */ // Label 319: @14944
     /*  14944 */ GIM_Reject,
     /*  14945 */ // Label 297: @14945
     /*  14945 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(15173),
     /*  14950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14956 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15071), // Rule ID 4406 //
     /*  14961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14985 */     // MIs[1] Operand 2
     /*  14985 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  14996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15013 */     // MIs[2] Operand 2
     /*  15013 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15026 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15069 */     GIR_RootConstrainSelectedInstOperands,
     /*  15070 */     // GIR_Coverage, 4406,
     /*  15070 */     GIR_EraseRootFromParent_Done,
     /*  15071 */   // Label 321: @15071
     /*  15071 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15111), // Rule ID 836 //
     /*  15076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15091 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15109 */     GIR_RootConstrainSelectedInstOperands,
     /*  15110 */     // GIR_Coverage, 836,
     /*  15110 */     GIR_EraseRootFromParent_Done,
     /*  15111 */   // Label 322: @15111
     /*  15111 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15172), // Rule ID 3442 //
     /*  15116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15131 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15170 */     GIR_RootConstrainSelectedInstOperands,
     /*  15171 */     // GIR_Coverage, 3442,
     /*  15171 */     GIR_EraseRootFromParent_Done,
     /*  15172 */   // Label 323: @15172
     /*  15172 */   GIM_Reject,
     /*  15173 */ // Label 320: @15173
     /*  15173 */ GIM_Reject,
     /*  15174 */ // Label 298: @15174
     /*  15174 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15287),
     /*  15179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15185 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15225), // Rule ID 835 //
     /*  15190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15205 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15223 */     GIR_RootConstrainSelectedInstOperands,
     /*  15224 */     // GIR_Coverage, 835,
     /*  15224 */     GIR_EraseRootFromParent_Done,
     /*  15225 */   // Label 325: @15225
     /*  15225 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15286), // Rule ID 3438 //
     /*  15230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15245 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15284 */     GIR_RootConstrainSelectedInstOperands,
     /*  15285 */     // GIR_Coverage, 3438,
     /*  15285 */     GIR_EraseRootFromParent_Done,
     /*  15286 */   // Label 326: @15286
     /*  15286 */   GIM_Reject,
     /*  15287 */ // Label 324: @15287
     /*  15287 */ GIM_Reject,
     /*  15288 */ // Label 299: @15288
     /*  15288 */ GIM_Reject,
     /*  15289 */ // Label 3: @15289
     /*  15289 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15384),
     /*  15294 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15303 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15343), // Rule ID 195 //
     /*  15308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15323 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15341 */     GIR_RootConstrainSelectedInstOperands,
     /*  15342 */     // GIR_Coverage, 195,
     /*  15342 */     GIR_EraseRootFromParent_Done,
     /*  15343 */   // Label 328: @15343
     /*  15343 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15383), // Rule ID 532 //
     /*  15348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15363 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15381 */     GIR_RootConstrainSelectedInstOperands,
     /*  15382 */     // GIR_Coverage, 532,
     /*  15382 */     GIR_EraseRootFromParent_Done,
     /*  15383 */   // Label 329: @15383
     /*  15383 */   GIM_Reject,
     /*  15384 */ // Label 327: @15384
     /*  15384 */ GIM_Reject,
     /*  15385 */ // Label 4: @15385
     /*  15385 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15480),
     /*  15390 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15399 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15439), // Rule ID 196 //
     /*  15404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15419 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15437 */     GIR_RootConstrainSelectedInstOperands,
     /*  15438 */     // GIR_Coverage, 196,
     /*  15438 */     GIR_EraseRootFromParent_Done,
     /*  15439 */   // Label 331: @15439
     /*  15439 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15479), // Rule ID 533 //
     /*  15444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15459 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15477 */     GIR_RootConstrainSelectedInstOperands,
     /*  15478 */     // GIR_Coverage, 533,
     /*  15478 */     GIR_EraseRootFromParent_Done,
     /*  15479 */   // Label 332: @15479
     /*  15479 */   GIM_Reject,
     /*  15480 */ // Label 330: @15480
     /*  15480 */ GIM_Reject,
     /*  15481 */ // Label 5: @15481
     /*  15481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 346*/ GIMT_Encode4(18660),
     /*  15492 */ /*GILLT_s32*//*Label 333*/ GIMT_Encode4(15552),
     /*  15496 */ /*GILLT_s64*//*Label 334*/ GIMT_Encode4(17544),
     /*  15500 */ /*GILLT_v2s1*//*Label 335*/ GIMT_Encode4(17591),
     /*  15504 */ /*GILLT_v2s32*//*Label 336*/ GIMT_Encode4(17709),
     /*  15508 */ /*GILLT_v2s64*//*Label 337*/ GIMT_Encode4(17756),
     /*  15512 */ /*GILLT_v4s1*//*Label 338*/ GIMT_Encode4(17870),
     /*  15516 */ /*GILLT_v4s16*//*Label 339*/ GIMT_Encode4(17988),
     /*  15520 */ /*GILLT_v4s32*//*Label 340*/ GIMT_Encode4(18035), GIMT_Encode4(0),
     /*  15528 */ /*GILLT_v8s1*//*Label 341*/ GIMT_Encode4(18149),
     /*  15532 */ /*GILLT_v8s8*//*Label 342*/ GIMT_Encode4(18267),
     /*  15536 */ /*GILLT_v8s16*//*Label 343*/ GIMT_Encode4(18314), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v16s1*//*Label 344*/ GIMT_Encode4(18428),
     /*  15548 */ /*GILLT_v16s8*//*Label 345*/ GIMT_Encode4(18546),
     /*  15552 */ // Label 333: @15552
     /*  15552 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17543),
     /*  15557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15563 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(15636), // Rule ID 1852 //
     /*  15568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15600 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15613 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15634 */     GIR_RootConstrainSelectedInstOperands,
     /*  15635 */     // GIR_Coverage, 1852,
     /*  15635 */     GIR_EraseRootFromParent_Done,
     /*  15636 */   // Label 348: @15636
     /*  15636 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15709), // Rule ID 2100 //
     /*  15641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15669 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15673 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15686 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15707 */     GIR_RootConstrainSelectedInstOperands,
     /*  15708 */     // GIR_Coverage, 2100,
     /*  15708 */     GIR_EraseRootFromParent_Done,
     /*  15709 */   // Label 349: @15709
     /*  15709 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15757), // Rule ID 1992 //
     /*  15714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15725 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15736 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15755 */     GIR_RootConstrainSelectedInstOperands,
     /*  15756 */     // GIR_Coverage, 1992,
     /*  15756 */     GIR_EraseRootFromParent_Done,
     /*  15757 */   // Label 350: @15757
     /*  15757 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15805), // Rule ID 1993 //
     /*  15762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15773 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15784 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15803 */     GIR_RootConstrainSelectedInstOperands,
     /*  15804 */     // GIR_Coverage, 1993,
     /*  15804 */     GIR_EraseRootFromParent_Done,
     /*  15805 */   // Label 351: @15805
     /*  15805 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15853), // Rule ID 1994 //
     /*  15810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15821 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15832 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15851 */     GIR_RootConstrainSelectedInstOperands,
     /*  15852 */     // GIR_Coverage, 1994,
     /*  15852 */     GIR_EraseRootFromParent_Done,
     /*  15853 */   // Label 352: @15853
     /*  15853 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15901), // Rule ID 2224 //
     /*  15858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15869 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15880 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15899 */     GIR_RootConstrainSelectedInstOperands,
     /*  15900 */     // GIR_Coverage, 2224,
     /*  15900 */     GIR_EraseRootFromParent_Done,
     /*  15901 */   // Label 353: @15901
     /*  15901 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15949), // Rule ID 2225 //
     /*  15906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15917 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15928 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15947 */     GIR_RootConstrainSelectedInstOperands,
     /*  15948 */     // GIR_Coverage, 2225,
     /*  15948 */     GIR_EraseRootFromParent_Done,
     /*  15949 */   // Label 354: @15949
     /*  15949 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15997), // Rule ID 2226 //
     /*  15954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15965 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15976 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15995 */     GIR_RootConstrainSelectedInstOperands,
     /*  15996 */     // GIR_Coverage, 2226,
     /*  15996 */     GIR_EraseRootFromParent_Done,
     /*  15997 */   // Label 355: @15997
     /*  15997 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16074), // Rule ID 5419 //
     /*  16002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16041 */     // MIs[2] Operand 1
     /*  16041 */     // No operand predicates
     /*  16041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16047 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16072 */     GIR_RootConstrainSelectedInstOperands,
     /*  16073 */     // GIR_Coverage, 5419,
     /*  16073 */     GIR_EraseRootFromParent_Done,
     /*  16074 */   // Label 356: @16074
     /*  16074 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16151), // Rule ID 5452 //
     /*  16079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16118 */     // MIs[2] Operand 1
     /*  16118 */     // No operand predicates
     /*  16118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16124 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16149 */     GIR_RootConstrainSelectedInstOperands,
     /*  16150 */     // GIR_Coverage, 5452,
     /*  16150 */     GIR_EraseRootFromParent_Done,
     /*  16151 */   // Label 357: @16151
     /*  16151 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16228), // Rule ID 5418 //
     /*  16156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16187 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16191 */     // MIs[2] Operand 1
     /*  16191 */     // No operand predicates
     /*  16191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16201 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16226 */     GIR_RootConstrainSelectedInstOperands,
     /*  16227 */     // GIR_Coverage, 5418,
     /*  16227 */     GIR_EraseRootFromParent_Done,
     /*  16228 */   // Label 358: @16228
     /*  16228 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16305), // Rule ID 5451 //
     /*  16233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16268 */     // MIs[2] Operand 1
     /*  16268 */     // No operand predicates
     /*  16268 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16278 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16303 */     GIR_RootConstrainSelectedInstOperands,
     /*  16304 */     // GIR_Coverage, 5451,
     /*  16304 */     GIR_EraseRootFromParent_Done,
     /*  16305 */   // Label 359: @16305
     /*  16305 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16382), // Rule ID 5417 //
     /*  16310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16337 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16349 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16353 */     // MIs[2] Operand 1
     /*  16353 */     // No operand predicates
     /*  16353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16355 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16380 */     GIR_RootConstrainSelectedInstOperands,
     /*  16381 */     // GIR_Coverage, 5417,
     /*  16381 */     GIR_EraseRootFromParent_Done,
     /*  16382 */   // Label 360: @16382
     /*  16382 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16459), // Rule ID 5450 //
     /*  16387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16414 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16430 */     // MIs[2] Operand 1
     /*  16430 */     // No operand predicates
     /*  16430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16432 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16457 */     GIR_RootConstrainSelectedInstOperands,
     /*  16458 */     // GIR_Coverage, 5450,
     /*  16458 */     GIR_EraseRootFromParent_Done,
     /*  16459 */   // Label 361: @16459
     /*  16459 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16536), // Rule ID 159 //
     /*  16464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16499 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16503 */     // MIs[2] Operand 1
     /*  16503 */     // No operand predicates
     /*  16503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16509 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16534 */     GIR_RootConstrainSelectedInstOperands,
     /*  16535 */     // GIR_Coverage, 159,
     /*  16535 */     GIR_EraseRootFromParent_Done,
     /*  16536 */   // Label 362: @16536
     /*  16536 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16613), // Rule ID 490 //
     /*  16541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16580 */     // MIs[2] Operand 1
     /*  16580 */     // No operand predicates
     /*  16580 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16586 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16611 */     GIR_RootConstrainSelectedInstOperands,
     /*  16612 */     // GIR_Coverage, 490,
     /*  16612 */     GIR_EraseRootFromParent_Done,
     /*  16613 */   // Label 363: @16613
     /*  16613 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16684), // Rule ID 5420 //
     /*  16618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16646 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16656 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16682 */     GIR_RootConstrainSelectedInstOperands,
     /*  16683 */     // GIR_Coverage, 5420,
     /*  16683 */     GIR_EraseRootFromParent_Done,
     /*  16684 */   // Label 364: @16684
     /*  16684 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16755), // Rule ID 5441 //
     /*  16689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16717 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16727 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16753 */     GIR_RootConstrainSelectedInstOperands,
     /*  16754 */     // GIR_Coverage, 5441,
     /*  16754 */     GIR_EraseRootFromParent_Done,
     /*  16755 */   // Label 365: @16755
     /*  16755 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16826), // Rule ID 5453 //
     /*  16760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16788 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16798 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16824 */     GIR_RootConstrainSelectedInstOperands,
     /*  16825 */     // GIR_Coverage, 5453,
     /*  16825 */     GIR_EraseRootFromParent_Done,
     /*  16826 */   // Label 366: @16826
     /*  16826 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16897), // Rule ID 160 //
     /*  16831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16869 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16895 */     GIR_RootConstrainSelectedInstOperands,
     /*  16896 */     // GIR_Coverage, 160,
     /*  16896 */     GIR_EraseRootFromParent_Done,
     /*  16897 */   // Label 367: @16897
     /*  16897 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16968), // Rule ID 313 //
     /*  16902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16934 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16940 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16966 */     GIR_RootConstrainSelectedInstOperands,
     /*  16967 */     // GIR_Coverage, 313,
     /*  16967 */     GIR_EraseRootFromParent_Done,
     /*  16968 */   // Label 368: @16968
     /*  16968 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(17039), // Rule ID 491 //
     /*  16973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17005 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17011 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17037 */     GIR_RootConstrainSelectedInstOperands,
     /*  17038 */     // GIR_Coverage, 491,
     /*  17038 */     GIR_EraseRootFromParent_Done,
     /*  17039 */   // Label 369: @17039
     /*  17039 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17084), // Rule ID 345 //
     /*  17044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17055 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17066 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17082 */     GIR_RootConstrainSelectedInstOperands,
     /*  17083 */     // GIR_Coverage, 345,
     /*  17083 */     GIR_EraseRootFromParent_Done,
     /*  17084 */   // Label 370: @17084
     /*  17084 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17129), // Rule ID 346 //
     /*  17089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17100 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17111 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17127 */     GIR_RootConstrainSelectedInstOperands,
     /*  17128 */     // GIR_Coverage, 346,
     /*  17128 */     GIR_EraseRootFromParent_Done,
     /*  17129 */   // Label 371: @17129
     /*  17129 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17188), // Rule ID 1891 //
     /*  17134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17157 */     // MIs[1] Operand 1
     /*  17157 */     // No operand predicates
     /*  17157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17159 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17166 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17186 */     GIR_RootConstrainSelectedInstOperands,
     /*  17187 */     // GIR_Coverage, 1891,
     /*  17187 */     GIR_EraseRootFromParent_Done,
     /*  17188 */   // Label 372: @17188
     /*  17188 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17245), // Rule ID 147 //
     /*  17193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17216 */     // MIs[1] Operand 1
     /*  17216 */     // No operand predicates
     /*  17216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17218 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17243 */     GIR_RootConstrainSelectedInstOperands,
     /*  17244 */     // GIR_Coverage, 147,
     /*  17244 */     GIR_EraseRootFromParent_Done,
     /*  17245 */   // Label 373: @17245
     /*  17245 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17302), // Rule ID 481 //
     /*  17250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17273 */     // MIs[1] Operand 1
     /*  17273 */     // No operand predicates
     /*  17273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17275 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17300 */     GIR_RootConstrainSelectedInstOperands,
     /*  17301 */     // GIR_Coverage, 481,
     /*  17301 */     GIR_EraseRootFromParent_Done,
     /*  17302 */   // Label 374: @17302
     /*  17302 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17353), // Rule ID 163 //
     /*  17307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17326 */     // MIs[1] Operand 1
     /*  17326 */     // No operand predicates
     /*  17326 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17332 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17351 */     GIR_RootConstrainSelectedInstOperands,
     /*  17352 */     // GIR_Coverage, 163,
     /*  17352 */     GIR_EraseRootFromParent_Done,
     /*  17353 */   // Label 375: @17353
     /*  17353 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17404), // Rule ID 493 //
     /*  17358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17377 */     // MIs[1] Operand 1
     /*  17377 */     // No operand predicates
     /*  17377 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17383 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17388 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17402 */     GIR_RootConstrainSelectedInstOperands,
     /*  17403 */     // GIR_Coverage, 493,
     /*  17403 */     GIR_EraseRootFromParent_Done,
     /*  17404 */   // Label 376: @17404
     /*  17404 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17450), // Rule ID 148 //
     /*  17409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17424 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17448 */     GIR_RootConstrainSelectedInstOperands,
     /*  17449 */     // GIR_Coverage, 148,
     /*  17449 */     GIR_EraseRootFromParent_Done,
     /*  17450 */   // Label 377: @17450
     /*  17450 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17496), // Rule ID 310 //
     /*  17455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17470 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17494 */     GIR_RootConstrainSelectedInstOperands,
     /*  17495 */     // GIR_Coverage, 310,
     /*  17495 */     GIR_EraseRootFromParent_Done,
     /*  17496 */   // Label 378: @17496
     /*  17496 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17542), // Rule ID 482 //
     /*  17501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17516 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17540 */     GIR_RootConstrainSelectedInstOperands,
     /*  17541 */     // GIR_Coverage, 482,
     /*  17541 */     GIR_EraseRootFromParent_Done,
     /*  17542 */   // Label 379: @17542
     /*  17542 */   GIM_Reject,
     /*  17543 */ // Label 347: @17543
     /*  17543 */ GIM_Reject,
     /*  17544 */ // Label 334: @17544
     /*  17544 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17590), // Rule ID 2506 //
     /*  17549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17570 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17575 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17577 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17582 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17588 */   GIR_RootConstrainSelectedInstOperands,
     /*  17589 */   // GIR_Coverage, 2506,
     /*  17589 */   GIR_EraseRootFromParent_Done,
     /*  17590 */ // Label 380: @17590
     /*  17590 */ GIM_Reject,
     /*  17591 */ // Label 335: @17591
     /*  17591 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17708), // Rule ID 1823 //
     /*  17596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17617 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17617 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17620 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17624 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17629 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17633 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17638 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17641 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17645 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17650 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17654 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17671 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17674 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17677 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17680 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17686 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17702 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17707 */   // GIR_Coverage, 1823,
     /*  17707 */   GIR_EraseRootFromParent_Done,
     /*  17708 */ // Label 381: @17708
     /*  17708 */ GIM_Reject,
     /*  17709 */ // Label 336: @17709
     /*  17709 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17755), // Rule ID 1130 //
     /*  17714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17735 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17740 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17742 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17753 */   GIR_RootConstrainSelectedInstOperands,
     /*  17754 */   // GIR_Coverage, 1130,
     /*  17754 */   GIR_EraseRootFromParent_Done,
     /*  17755 */ // Label 382: @17755
     /*  17755 */ GIM_Reject,
     /*  17756 */ // Label 337: @17756
     /*  17756 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17869),
     /*  17761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17767 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17807), // Rule ID 2509 //
     /*  17772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17787 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17792 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17794 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17805 */     GIR_RootConstrainSelectedInstOperands,
     /*  17806 */     // GIR_Coverage, 2509,
     /*  17806 */     GIR_EraseRootFromParent_Done,
     /*  17807 */   // Label 384: @17807
     /*  17807 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17868), // Rule ID 3350 //
     /*  17812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17827 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17866 */     GIR_RootConstrainSelectedInstOperands,
     /*  17867 */     // GIR_Coverage, 3350,
     /*  17867 */     GIR_EraseRootFromParent_Done,
     /*  17868 */   // Label 385: @17868
     /*  17868 */   GIM_Reject,
     /*  17869 */ // Label 383: @17869
     /*  17869 */ GIM_Reject,
     /*  17870 */ // Label 338: @17870
     /*  17870 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17987), // Rule ID 1824 //
     /*  17875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17896 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17896 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17899 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17903 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17908 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17912 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17917 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17920 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17924 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17929 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17933 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17938 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17941 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17945 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17950 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17953 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17956 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17959 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17965 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17986 */   // GIR_Coverage, 1824,
     /*  17986 */   GIR_EraseRootFromParent_Done,
     /*  17987 */ // Label 386: @17987
     /*  17987 */ GIM_Reject,
     /*  17988 */ // Label 339: @17988
     /*  17988 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18034), // Rule ID 2505 //
     /*  17993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  17999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18014 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18019 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18021 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18026 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18032 */   GIR_RootConstrainSelectedInstOperands,
     /*  18033 */   // GIR_Coverage, 2505,
     /*  18033 */   GIR_EraseRootFromParent_Done,
     /*  18034 */ // Label 387: @18034
     /*  18034 */ GIM_Reject,
     /*  18035 */ // Label 340: @18035
     /*  18035 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18148),
     /*  18040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18046 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18086), // Rule ID 1131 //
     /*  18051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18066 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18084 */     GIR_RootConstrainSelectedInstOperands,
     /*  18085 */     // GIR_Coverage, 1131,
     /*  18085 */     GIR_EraseRootFromParent_Done,
     /*  18086 */   // Label 389: @18086
     /*  18086 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18147), // Rule ID 3346 //
     /*  18091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18106 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18145 */     GIR_RootConstrainSelectedInstOperands,
     /*  18146 */     // GIR_Coverage, 3346,
     /*  18146 */     GIR_EraseRootFromParent_Done,
     /*  18147 */   // Label 390: @18147
     /*  18147 */   GIM_Reject,
     /*  18148 */ // Label 388: @18148
     /*  18148 */ GIM_Reject,
     /*  18149 */ // Label 341: @18149
     /*  18149 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18266), // Rule ID 1825 //
     /*  18154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18175 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18175 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18178 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18182 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18187 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18191 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18196 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18199 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18203 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18208 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18212 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18232 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18235 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18238 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18244 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18265 */   // GIR_Coverage, 1825,
     /*  18265 */   GIR_EraseRootFromParent_Done,
     /*  18266 */ // Label 391: @18266
     /*  18266 */ GIM_Reject,
     /*  18267 */ // Label 342: @18267
     /*  18267 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18313), // Rule ID 2504 //
     /*  18272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18293 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18298 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18300 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18305 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18311 */   GIR_RootConstrainSelectedInstOperands,
     /*  18312 */   // GIR_Coverage, 2504,
     /*  18312 */   GIR_EraseRootFromParent_Done,
     /*  18313 */ // Label 392: @18313
     /*  18313 */ GIM_Reject,
     /*  18314 */ // Label 343: @18314
     /*  18314 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18427),
     /*  18319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18325 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18365), // Rule ID 2508 //
     /*  18330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18345 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18350 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18352 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18363 */     GIR_RootConstrainSelectedInstOperands,
     /*  18364 */     // GIR_Coverage, 2508,
     /*  18364 */     GIR_EraseRootFromParent_Done,
     /*  18365 */   // Label 394: @18365
     /*  18365 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18426), // Rule ID 3342 //
     /*  18370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18385 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18424 */     GIR_RootConstrainSelectedInstOperands,
     /*  18425 */     // GIR_Coverage, 3342,
     /*  18425 */     GIR_EraseRootFromParent_Done,
     /*  18426 */   // Label 395: @18426
     /*  18426 */   GIM_Reject,
     /*  18427 */ // Label 393: @18427
     /*  18427 */ GIM_Reject,
     /*  18428 */ // Label 344: @18428
     /*  18428 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18545), // Rule ID 1826 //
     /*  18433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18454 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18454 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18457 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18461 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18466 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18470 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18475 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18478 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18482 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18487 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18491 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18508 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18511 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18514 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18517 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18523 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18544 */   // GIR_Coverage, 1826,
     /*  18544 */   GIR_EraseRootFromParent_Done,
     /*  18545 */ // Label 396: @18545
     /*  18545 */ GIM_Reject,
     /*  18546 */ // Label 345: @18546
     /*  18546 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18659),
     /*  18551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18557 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18597), // Rule ID 2507 //
     /*  18562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18577 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18582 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18584 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18595 */     GIR_RootConstrainSelectedInstOperands,
     /*  18596 */     // GIR_Coverage, 2507,
     /*  18596 */     GIR_EraseRootFromParent_Done,
     /*  18597 */   // Label 398: @18597
     /*  18597 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18658), // Rule ID 3338 //
     /*  18602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18617 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18656 */     GIR_RootConstrainSelectedInstOperands,
     /*  18657 */     // GIR_Coverage, 3338,
     /*  18657 */     GIR_EraseRootFromParent_Done,
     /*  18658 */   // Label 399: @18658
     /*  18658 */   GIM_Reject,
     /*  18659 */ // Label 397: @18659
     /*  18659 */ GIM_Reject,
     /*  18660 */ // Label 346: @18660
     /*  18660 */ GIM_Reject,
     /*  18661 */ // Label 6: @18661
     /*  18661 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 413*/ GIMT_Encode4(24469),
     /*  18672 */ /*GILLT_s32*//*Label 400*/ GIMT_Encode4(18732),
     /*  18676 */ /*GILLT_s64*//*Label 401*/ GIMT_Encode4(23353),
     /*  18680 */ /*GILLT_v2s1*//*Label 402*/ GIMT_Encode4(23400),
     /*  18684 */ /*GILLT_v2s32*//*Label 403*/ GIMT_Encode4(23518),
     /*  18688 */ /*GILLT_v2s64*//*Label 404*/ GIMT_Encode4(23565),
     /*  18692 */ /*GILLT_v4s1*//*Label 405*/ GIMT_Encode4(23679),
     /*  18696 */ /*GILLT_v4s16*//*Label 406*/ GIMT_Encode4(23797),
     /*  18700 */ /*GILLT_v4s32*//*Label 407*/ GIMT_Encode4(23844), GIMT_Encode4(0),
     /*  18708 */ /*GILLT_v8s1*//*Label 408*/ GIMT_Encode4(23958),
     /*  18712 */ /*GILLT_v8s8*//*Label 409*/ GIMT_Encode4(24076),
     /*  18716 */ /*GILLT_v8s16*//*Label 410*/ GIMT_Encode4(24123), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v16s1*//*Label 411*/ GIMT_Encode4(24237),
     /*  18728 */ /*GILLT_v16s8*//*Label 412*/ GIMT_Encode4(24355),
     /*  18732 */ // Label 400: @18732
     /*  18732 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(23352),
     /*  18737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18743 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(18870), // Rule ID 5635 //
     /*  18748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18796 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18819 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18827 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18831 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18835 */     // MIs[4] Rm
     /*  18835 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18840 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18844 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18850 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18868 */     GIR_RootConstrainSelectedInstOperands,
     /*  18869 */     // GIR_Coverage, 5635,
     /*  18869 */     GIR_EraseRootFromParent_Done,
     /*  18870 */   // Label 415: @18870
     /*  18870 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18997), // Rule ID 5677 //
     /*  18875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18919 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18923 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18946 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18958 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18962 */     // MIs[4] Rm
     /*  18962 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18967 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18971 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18977 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18995 */     GIR_RootConstrainSelectedInstOperands,
     /*  18996 */     // GIR_Coverage, 5677,
     /*  18996 */     GIR_EraseRootFromParent_Done,
     /*  18997 */   // Label 416: @18997
     /*  18997 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19124), // Rule ID 1911 //
     /*  19002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19046 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19050 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19074 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19078 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19082 */     // MIs[4] Rm
     /*  19082 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19087 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19122 */     GIR_RootConstrainSelectedInstOperands,
     /*  19123 */     // GIR_Coverage, 1911,
     /*  19123 */     GIR_EraseRootFromParent_Done,
     /*  19124 */   // Label 417: @19124
     /*  19124 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19251), // Rule ID 2184 //
     /*  19129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19173 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19177 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19193 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19201 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19205 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19209 */     // MIs[4] Rm
     /*  19209 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19214 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19218 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19229 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19231 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19249 */     GIR_RootConstrainSelectedInstOperands,
     /*  19250 */     // GIR_Coverage, 2184,
     /*  19250 */     GIR_EraseRootFromParent_Done,
     /*  19251 */   // Label 418: @19251
     /*  19251 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19384), // Rule ID 5433 //
     /*  19256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19308 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19312 */     // MIs[3] Operand 1
     /*  19312 */     // No operand predicates
     /*  19312 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19323 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19327 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19331 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19335 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19339 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19344 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19357 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19382 */     GIR_RootConstrainSelectedInstOperands,
     /*  19383 */     // GIR_Coverage, 5433,
     /*  19383 */     GIR_EraseRootFromParent_Done,
     /*  19384 */   // Label 419: @19384
     /*  19384 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19517), // Rule ID 5470 //
     /*  19389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19445 */     // MIs[3] Operand 1
     /*  19445 */     // No operand predicates
     /*  19445 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19468 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19472 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19477 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19490 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19515 */     GIR_RootConstrainSelectedInstOperands,
     /*  19516 */     // GIR_Coverage, 5470,
     /*  19516 */     GIR_EraseRootFromParent_Done,
     /*  19517 */   // Label 420: @19517
     /*  19517 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19650), // Rule ID 5640 //
     /*  19522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19578 */     // MIs[3] Operand 1
     /*  19578 */     // No operand predicates
     /*  19578 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19593 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19597 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19601 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19605 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19610 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19621 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19623 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19648 */     GIR_RootConstrainSelectedInstOperands,
     /*  19649 */     // GIR_Coverage, 5640,
     /*  19649 */     GIR_EraseRootFromParent_Done,
     /*  19650 */   // Label 421: @19650
     /*  19650 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19783), // Rule ID 5682 //
     /*  19655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19707 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19711 */     // MIs[3] Operand 1
     /*  19711 */     // No operand predicates
     /*  19711 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19730 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19734 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19738 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19743 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19754 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19756 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19781 */     GIR_RootConstrainSelectedInstOperands,
     /*  19782 */     // GIR_Coverage, 5682,
     /*  19782 */     GIR_EraseRootFromParent_Done,
     /*  19783 */   // Label 422: @19783
     /*  19783 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19916), // Rule ID 5432 //
     /*  19788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19844 */     // MIs[3] Operand 1
     /*  19844 */     // No operand predicates
     /*  19844 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19855 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19859 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19863 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19867 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19871 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19876 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19887 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19889 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19914 */     GIR_RootConstrainSelectedInstOperands,
     /*  19915 */     // GIR_Coverage, 5432,
     /*  19915 */     GIR_EraseRootFromParent_Done,
     /*  19916 */   // Label 423: @19916
     /*  19916 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20049), // Rule ID 5469 //
     /*  19921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19973 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19977 */     // MIs[3] Operand 1
     /*  19977 */     // No operand predicates
     /*  19977 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19996 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20000 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20004 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20009 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20022 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20047 */     GIR_RootConstrainSelectedInstOperands,
     /*  20048 */     // GIR_Coverage, 5469,
     /*  20048 */     GIR_EraseRootFromParent_Done,
     /*  20049 */   // Label 424: @20049
     /*  20049 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20182), // Rule ID 203 //
     /*  20054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20082 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20117 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20138 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20142 */     // MIs[4] Operand 1
     /*  20142 */     // No operand predicates
     /*  20142 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20153 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20155 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20180 */     GIR_RootConstrainSelectedInstOperands,
     /*  20181 */     // GIR_Coverage, 203,
     /*  20181 */     GIR_EraseRootFromParent_Done,
     /*  20182 */   // Label 425: @20182
     /*  20182 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20315), // Rule ID 540 //
     /*  20187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20215 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20250 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20263 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20267 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20271 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20275 */     // MIs[4] Operand 1
     /*  20275 */     // No operand predicates
     /*  20275 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20286 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20288 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20313 */     GIR_RootConstrainSelectedInstOperands,
     /*  20314 */     // GIR_Coverage, 540,
     /*  20314 */     GIR_EraseRootFromParent_Done,
     /*  20315 */   // Label 426: @20315
     /*  20315 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20448), // Rule ID 1916 //
     /*  20320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20348 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20404 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20408 */     // MIs[4] Operand 1
     /*  20408 */     // No operand predicates
     /*  20408 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20419 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20421 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20446 */     GIR_RootConstrainSelectedInstOperands,
     /*  20447 */     // GIR_Coverage, 1916,
     /*  20447 */     GIR_EraseRootFromParent_Done,
     /*  20448 */   // Label 427: @20448
     /*  20448 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20581), // Rule ID 2189 //
     /*  20453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20481 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20533 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20537 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20541 */     // MIs[4] Operand 1
     /*  20541 */     // No operand predicates
     /*  20541 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20552 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20554 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20579 */     GIR_RootConstrainSelectedInstOperands,
     /*  20580 */     // GIR_Coverage, 2189,
     /*  20580 */     GIR_EraseRootFromParent_Done,
     /*  20581 */   // Label 428: @20581
     /*  20581 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20714), // Rule ID 202 //
     /*  20586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20614 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20670 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20674 */     // MIs[4] Operand 1
     /*  20674 */     // No operand predicates
     /*  20674 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20687 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20712 */     GIR_RootConstrainSelectedInstOperands,
     /*  20713 */     // GIR_Coverage, 202,
     /*  20713 */     GIR_EraseRootFromParent_Done,
     /*  20714 */   // Label 429: @20714
     /*  20714 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20847), // Rule ID 539 //
     /*  20719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20747 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20795 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20799 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20803 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20807 */     // MIs[4] Operand 1
     /*  20807 */     // No operand predicates
     /*  20807 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20818 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20820 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20845 */     GIR_RootConstrainSelectedInstOperands,
     /*  20846 */     // GIR_Coverage, 539,
     /*  20846 */     GIR_EraseRootFromParent_Done,
     /*  20847 */   // Label 430: @20847
     /*  20847 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20952), // Rule ID 1912 //
     /*  20852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20880 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20912 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20925 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20950 */     GIR_RootConstrainSelectedInstOperands,
     /*  20951 */     // GIR_Coverage, 1912,
     /*  20951 */     GIR_EraseRootFromParent_Done,
     /*  20952 */   // Label 431: @20952
     /*  20952 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21057), // Rule ID 2185 //
     /*  20957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20985 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21017 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21030 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21055 */     GIR_RootConstrainSelectedInstOperands,
     /*  21056 */     // GIR_Coverage, 2185,
     /*  21056 */     GIR_EraseRootFromParent_Done,
     /*  21057 */   // Label 432: @21057
     /*  21057 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21162), // Rule ID 5636 //
     /*  21062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21090 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21122 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21135 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21160 */     GIR_RootConstrainSelectedInstOperands,
     /*  21161 */     // GIR_Coverage, 5636,
     /*  21161 */     GIR_EraseRootFromParent_Done,
     /*  21162 */   // Label 433: @21162
     /*  21162 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21267), // Rule ID 5678 //
     /*  21167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21195 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21227 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21240 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21265 */     GIR_RootConstrainSelectedInstOperands,
     /*  21266 */     // GIR_Coverage, 5678,
     /*  21266 */     GIR_EraseRootFromParent_Done,
     /*  21267 */   // Label 434: @21267
     /*  21267 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21373), // Rule ID 1915 //
     /*  21272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21300 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21340 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21344 */     // MIs[3] Operand 1
     /*  21344 */     // No operand predicates
     /*  21344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21346 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21371 */     GIR_RootConstrainSelectedInstOperands,
     /*  21372 */     // GIR_Coverage, 1915,
     /*  21372 */     GIR_EraseRootFromParent_Done,
     /*  21373 */   // Label 435: @21373
     /*  21373 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21479), // Rule ID 2188 //
     /*  21378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21406 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21446 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21450 */     // MIs[3] Operand 1
     /*  21450 */     // No operand predicates
     /*  21450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21452 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21477 */     GIR_RootConstrainSelectedInstOperands,
     /*  21478 */     // GIR_Coverage, 2188,
     /*  21478 */     GIR_EraseRootFromParent_Done,
     /*  21479 */   // Label 436: @21479
     /*  21479 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21585), // Rule ID 1914 //
     /*  21484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21512 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21552 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21556 */     // MIs[3] Operand 1
     /*  21556 */     // No operand predicates
     /*  21556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21558 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21583 */     GIR_RootConstrainSelectedInstOperands,
     /*  21584 */     // GIR_Coverage, 1914,
     /*  21584 */     GIR_EraseRootFromParent_Done,
     /*  21585 */   // Label 437: @21585
     /*  21585 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21691), // Rule ID 2187 //
     /*  21590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21618 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21658 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21662 */     // MIs[3] Operand 1
     /*  21662 */     // No operand predicates
     /*  21662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21664 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21689 */     GIR_RootConstrainSelectedInstOperands,
     /*  21690 */     // GIR_Coverage, 2187,
     /*  21690 */     GIR_EraseRootFromParent_Done,
     /*  21691 */   // Label 438: @21691
     /*  21691 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21797), // Rule ID 1913 //
     /*  21696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21724 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21764 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21768 */     // MIs[3] Operand 1
     /*  21768 */     // No operand predicates
     /*  21768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21770 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21795 */     GIR_RootConstrainSelectedInstOperands,
     /*  21796 */     // GIR_Coverage, 1913,
     /*  21796 */     GIR_EraseRootFromParent_Done,
     /*  21797 */   // Label 439: @21797
     /*  21797 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21903), // Rule ID 2186 //
     /*  21802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21830 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21874 */     // MIs[3] Operand 1
     /*  21874 */     // No operand predicates
     /*  21874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21876 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21901 */     GIR_RootConstrainSelectedInstOperands,
     /*  21902 */     // GIR_Coverage, 2186,
     /*  21902 */     GIR_EraseRootFromParent_Done,
     /*  21903 */   // Label 440: @21903
     /*  21903 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22009), // Rule ID 5639 //
     /*  21908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21944 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21948 */     // MIs[2] Operand 1
     /*  21948 */     // No operand predicates
     /*  21948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21960 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21964 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21969 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21982 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  21991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  21998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22007 */     GIR_RootConstrainSelectedInstOperands,
     /*  22008 */     // GIR_Coverage, 5639,
     /*  22008 */     GIR_EraseRootFromParent_Done,
     /*  22009 */   // Label 441: @22009
     /*  22009 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22115), // Rule ID 5681 //
     /*  22014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22054 */     // MIs[2] Operand 1
     /*  22054 */     // No operand predicates
     /*  22054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22075 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22088 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22113 */     GIR_RootConstrainSelectedInstOperands,
     /*  22114 */     // GIR_Coverage, 5681,
     /*  22114 */     GIR_EraseRootFromParent_Done,
     /*  22115 */   // Label 442: @22115
     /*  22115 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22221), // Rule ID 5638 //
     /*  22120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22160 */     // MIs[2] Operand 1
     /*  22160 */     // No operand predicates
     /*  22160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22176 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22181 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22194 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22219 */     GIR_RootConstrainSelectedInstOperands,
     /*  22220 */     // GIR_Coverage, 5638,
     /*  22220 */     GIR_EraseRootFromParent_Done,
     /*  22221 */   // Label 443: @22221
     /*  22221 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22327), // Rule ID 5680 //
     /*  22226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22262 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22266 */     // MIs[2] Operand 1
     /*  22266 */     // No operand predicates
     /*  22266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22287 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22300 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22325 */     GIR_RootConstrainSelectedInstOperands,
     /*  22326 */     // GIR_Coverage, 5680,
     /*  22326 */     GIR_EraseRootFromParent_Done,
     /*  22327 */   // Label 444: @22327
     /*  22327 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22433), // Rule ID 5637 //
     /*  22332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22372 */     // MIs[2] Operand 1
     /*  22372 */     // No operand predicates
     /*  22372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22388 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22393 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22406 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22431 */     GIR_RootConstrainSelectedInstOperands,
     /*  22432 */     // GIR_Coverage, 5637,
     /*  22432 */     GIR_EraseRootFromParent_Done,
     /*  22433 */   // Label 445: @22433
     /*  22433 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22539), // Rule ID 5679 //
     /*  22438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22478 */     // MIs[2] Operand 1
     /*  22478 */     // No operand predicates
     /*  22478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22494 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22499 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22512 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22537 */     GIR_RootConstrainSelectedInstOperands,
     /*  22538 */     // GIR_Coverage, 5679,
     /*  22538 */     GIR_EraseRootFromParent_Done,
     /*  22539 */   // Label 446: @22539
     /*  22539 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22616), // Rule ID 5457 //
     /*  22544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22583 */     // MIs[2] Operand 1
     /*  22583 */     // No operand predicates
     /*  22583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22589 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22614 */     GIR_RootConstrainSelectedInstOperands,
     /*  22615 */     // GIR_Coverage, 5457,
     /*  22615 */     GIR_EraseRootFromParent_Done,
     /*  22616 */   // Label 447: @22616
     /*  22616 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22693), // Rule ID 5456 //
     /*  22621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22656 */     // MIs[2] Operand 1
     /*  22656 */     // No operand predicates
     /*  22656 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22666 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22691 */     GIR_RootConstrainSelectedInstOperands,
     /*  22692 */     // GIR_Coverage, 5456,
     /*  22692 */     GIR_EraseRootFromParent_Done,
     /*  22693 */   // Label 448: @22693
     /*  22693 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22770), // Rule ID 5455 //
     /*  22698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22741 */     // MIs[2] Operand 1
     /*  22741 */     // No operand predicates
     /*  22741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22743 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22768 */     GIR_RootConstrainSelectedInstOperands,
     /*  22769 */     // GIR_Coverage, 5455,
     /*  22769 */     GIR_EraseRootFromParent_Done,
     /*  22770 */   // Label 449: @22770
     /*  22770 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22847), // Rule ID 496 //
     /*  22775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22814 */     // MIs[2] Operand 1
     /*  22814 */     // No operand predicates
     /*  22814 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22820 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22845 */     GIR_RootConstrainSelectedInstOperands,
     /*  22846 */     // GIR_Coverage, 496,
     /*  22846 */     GIR_EraseRootFromParent_Done,
     /*  22847 */   // Label 450: @22847
     /*  22847 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22918), // Rule ID 5458 //
     /*  22852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22880 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22890 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22916 */     GIR_RootConstrainSelectedInstOperands,
     /*  22917 */     // GIR_Coverage, 5458,
     /*  22917 */     GIR_EraseRootFromParent_Done,
     /*  22918 */   // Label 451: @22918
     /*  22918 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22989), // Rule ID 497 //
     /*  22923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22955 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22961 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22987 */     GIR_RootConstrainSelectedInstOperands,
     /*  22988 */     // GIR_Coverage, 497,
     /*  22988 */     GIR_EraseRootFromParent_Done,
     /*  22989 */   // Label 452: @22989
     /*  22989 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23044), // Rule ID 1845 //
     /*  22994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  22997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23005 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23016 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23023 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23042 */     GIR_RootConstrainSelectedInstOperands,
     /*  23043 */     // GIR_Coverage, 1845,
     /*  23043 */     GIR_EraseRootFromParent_Done,
     /*  23044 */   // Label 453: @23044
     /*  23044 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23099), // Rule ID 2082 //
     /*  23049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23060 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23071 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23078 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23097 */     GIR_RootConstrainSelectedInstOperands,
     /*  23098 */     // GIR_Coverage, 2082,
     /*  23098 */     GIR_EraseRootFromParent_Done,
     /*  23099 */   // Label 454: @23099
     /*  23099 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23156), // Rule ID 151 //
     /*  23104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23127 */     // MIs[1] Operand 1
     /*  23127 */     // No operand predicates
     /*  23127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23129 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23154 */     GIR_RootConstrainSelectedInstOperands,
     /*  23155 */     // GIR_Coverage, 151,
     /*  23155 */     GIR_EraseRootFromParent_Done,
     /*  23156 */   // Label 455: @23156
     /*  23156 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23213), // Rule ID 484 //
     /*  23161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23184 */     // MIs[1] Operand 1
     /*  23184 */     // No operand predicates
     /*  23184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23186 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23211 */     GIR_RootConstrainSelectedInstOperands,
     /*  23212 */     // GIR_Coverage, 484,
     /*  23212 */     GIR_EraseRootFromParent_Done,
     /*  23213 */   // Label 456: @23213
     /*  23213 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23259), // Rule ID 152 //
     /*  23218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23233 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23257 */     GIR_RootConstrainSelectedInstOperands,
     /*  23258 */     // GIR_Coverage, 152,
     /*  23258 */     GIR_EraseRootFromParent_Done,
     /*  23259 */   // Label 457: @23259
     /*  23259 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23305), // Rule ID 325 //
     /*  23264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23279 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23303 */     GIR_RootConstrainSelectedInstOperands,
     /*  23304 */     // GIR_Coverage, 325,
     /*  23304 */     GIR_EraseRootFromParent_Done,
     /*  23305 */   // Label 458: @23305
     /*  23305 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23351), // Rule ID 485 //
     /*  23310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23325 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23349 */     GIR_RootConstrainSelectedInstOperands,
     /*  23350 */     // GIR_Coverage, 485,
     /*  23350 */     GIR_EraseRootFromParent_Done,
     /*  23351 */   // Label 459: @23351
     /*  23351 */   GIM_Reject,
     /*  23352 */ // Label 414: @23352
     /*  23352 */ GIM_Reject,
     /*  23353 */ // Label 401: @23353
     /*  23353 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23399), // Rule ID 2512 //
     /*  23358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23379 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23384 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23386 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23391 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23397 */   GIR_RootConstrainSelectedInstOperands,
     /*  23398 */   // GIR_Coverage, 2512,
     /*  23398 */   GIR_EraseRootFromParent_Done,
     /*  23399 */ // Label 460: @23399
     /*  23399 */ GIM_Reject,
     /*  23400 */ // Label 402: @23400
     /*  23400 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23517), // Rule ID 1831 //
     /*  23405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23426 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23426 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23429 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23433 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23438 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23442 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23447 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23450 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23454 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23459 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23463 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23480 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23483 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23486 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23489 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23495 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23516 */   // GIR_Coverage, 1831,
     /*  23516 */   GIR_EraseRootFromParent_Done,
     /*  23517 */ // Label 461: @23517
     /*  23517 */ GIM_Reject,
     /*  23518 */ // Label 403: @23518
     /*  23518 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23564), // Rule ID 1134 //
     /*  23523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23544 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23551 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23556 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23562 */   GIR_RootConstrainSelectedInstOperands,
     /*  23563 */   // GIR_Coverage, 1134,
     /*  23563 */   GIR_EraseRootFromParent_Done,
     /*  23564 */ // Label 462: @23564
     /*  23564 */ GIM_Reject,
     /*  23565 */ // Label 404: @23565
     /*  23565 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23678),
     /*  23570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23576 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23616), // Rule ID 2515 //
     /*  23581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23596 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23601 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23603 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23614 */     GIR_RootConstrainSelectedInstOperands,
     /*  23615 */     // GIR_Coverage, 2515,
     /*  23615 */     GIR_EraseRootFromParent_Done,
     /*  23616 */   // Label 464: @23616
     /*  23616 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23677), // Rule ID 3364 //
     /*  23621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23636 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23675 */     GIR_RootConstrainSelectedInstOperands,
     /*  23676 */     // GIR_Coverage, 3364,
     /*  23676 */     GIR_EraseRootFromParent_Done,
     /*  23677 */   // Label 465: @23677
     /*  23677 */   GIM_Reject,
     /*  23678 */ // Label 463: @23678
     /*  23678 */ GIM_Reject,
     /*  23679 */ // Label 405: @23679
     /*  23679 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23796), // Rule ID 1832 //
     /*  23684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23705 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23705 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23708 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23712 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23717 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23721 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23726 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23729 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23733 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23738 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23742 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23759 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23762 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23765 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23768 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23774 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23795 */   // GIR_Coverage, 1832,
     /*  23795 */   GIR_EraseRootFromParent_Done,
     /*  23796 */ // Label 466: @23796
     /*  23796 */ GIM_Reject,
     /*  23797 */ // Label 406: @23797
     /*  23797 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23843), // Rule ID 2511 //
     /*  23802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23823 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23828 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23830 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23835 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23841 */   GIR_RootConstrainSelectedInstOperands,
     /*  23842 */   // GIR_Coverage, 2511,
     /*  23842 */   GIR_EraseRootFromParent_Done,
     /*  23843 */ // Label 467: @23843
     /*  23843 */ GIM_Reject,
     /*  23844 */ // Label 407: @23844
     /*  23844 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23957),
     /*  23849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23855 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23895), // Rule ID 1135 //
     /*  23860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23875 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23893 */     GIR_RootConstrainSelectedInstOperands,
     /*  23894 */     // GIR_Coverage, 1135,
     /*  23894 */     GIR_EraseRootFromParent_Done,
     /*  23895 */   // Label 469: @23895
     /*  23895 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23956), // Rule ID 3360 //
     /*  23900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23915 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23954 */     GIR_RootConstrainSelectedInstOperands,
     /*  23955 */     // GIR_Coverage, 3360,
     /*  23955 */     GIR_EraseRootFromParent_Done,
     /*  23956 */   // Label 470: @23956
     /*  23956 */   GIM_Reject,
     /*  23957 */ // Label 468: @23957
     /*  23957 */ GIM_Reject,
     /*  23958 */ // Label 408: @23958
     /*  23958 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24075), // Rule ID 1833 //
     /*  23963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23984 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23984 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23987 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23991 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23996 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24000 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24005 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24008 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24012 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24017 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24021 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24038 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24041 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24044 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24047 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24053 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24074 */   // GIR_Coverage, 1833,
     /*  24074 */   GIR_EraseRootFromParent_Done,
     /*  24075 */ // Label 471: @24075
     /*  24075 */ GIM_Reject,
     /*  24076 */ // Label 409: @24076
     /*  24076 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24122), // Rule ID 2510 //
     /*  24081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24102 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24107 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24109 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24114 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24120 */   GIR_RootConstrainSelectedInstOperands,
     /*  24121 */   // GIR_Coverage, 2510,
     /*  24121 */   GIR_EraseRootFromParent_Done,
     /*  24122 */ // Label 472: @24122
     /*  24122 */ GIM_Reject,
     /*  24123 */ // Label 410: @24123
     /*  24123 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24236),
     /*  24128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24134 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24174), // Rule ID 2514 //
     /*  24139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24154 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24159 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24161 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24172 */     GIR_RootConstrainSelectedInstOperands,
     /*  24173 */     // GIR_Coverage, 2514,
     /*  24173 */     GIR_EraseRootFromParent_Done,
     /*  24174 */   // Label 474: @24174
     /*  24174 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24235), // Rule ID 3356 //
     /*  24179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24194 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24233 */     GIR_RootConstrainSelectedInstOperands,
     /*  24234 */     // GIR_Coverage, 3356,
     /*  24234 */     GIR_EraseRootFromParent_Done,
     /*  24235 */   // Label 475: @24235
     /*  24235 */   GIM_Reject,
     /*  24236 */ // Label 473: @24236
     /*  24236 */ GIM_Reject,
     /*  24237 */ // Label 411: @24237
     /*  24237 */ GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24354), // Rule ID 1834 //
     /*  24242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24263 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24263 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24266 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24270 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24275 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24279 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24284 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24287 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24291 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24296 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24300 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24317 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24320 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24323 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24326 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24332 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24353 */   // GIR_Coverage, 1834,
     /*  24353 */   GIR_EraseRootFromParent_Done,
     /*  24354 */ // Label 476: @24354
     /*  24354 */ GIM_Reject,
     /*  24355 */ // Label 412: @24355
     /*  24355 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24468),
     /*  24360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24366 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24406), // Rule ID 2513 //
     /*  24371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24386 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24391 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24393 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24404 */     GIR_RootConstrainSelectedInstOperands,
     /*  24405 */     // GIR_Coverage, 2513,
     /*  24405 */     GIR_EraseRootFromParent_Done,
     /*  24406 */   // Label 478: @24406
     /*  24406 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24467), // Rule ID 3352 //
     /*  24411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24426 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24465 */     GIR_RootConstrainSelectedInstOperands,
     /*  24466 */     // GIR_Coverage, 3352,
     /*  24466 */     GIR_EraseRootFromParent_Done,
     /*  24467 */   // Label 479: @24467
     /*  24467 */   GIM_Reject,
     /*  24468 */ // Label 477: @24468
     /*  24468 */ GIM_Reject,
     /*  24469 */ // Label 413: @24469
     /*  24469 */ GIM_Reject,
     /*  24470 */ // Label 7: @24470
     /*  24470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 493*/ GIMT_Encode4(26164),
     /*  24481 */ /*GILLT_s32*//*Label 480*/ GIMT_Encode4(24541),
     /*  24485 */ /*GILLT_s64*//*Label 481*/ GIMT_Encode4(25048),
     /*  24489 */ /*GILLT_v2s1*//*Label 482*/ GIMT_Encode4(25095),
     /*  24493 */ /*GILLT_v2s32*//*Label 483*/ GIMT_Encode4(25213),
     /*  24497 */ /*GILLT_v2s64*//*Label 484*/ GIMT_Encode4(25260),
     /*  24501 */ /*GILLT_v4s1*//*Label 485*/ GIMT_Encode4(25374),
     /*  24505 */ /*GILLT_v4s16*//*Label 486*/ GIMT_Encode4(25492),
     /*  24509 */ /*GILLT_v4s32*//*Label 487*/ GIMT_Encode4(25539), GIMT_Encode4(0),
     /*  24517 */ /*GILLT_v8s1*//*Label 488*/ GIMT_Encode4(25653),
     /*  24521 */ /*GILLT_v8s8*//*Label 489*/ GIMT_Encode4(25771),
     /*  24525 */ /*GILLT_v8s16*//*Label 490*/ GIMT_Encode4(25818), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v16s1*//*Label 491*/ GIMT_Encode4(25932),
     /*  24537 */ /*GILLT_v16s8*//*Label 492*/ GIMT_Encode4(26050),
     /*  24541 */ // Label 480: @24541
     /*  24541 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(25047),
     /*  24546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24552 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(24607), // Rule ID 5460 //
     /*  24557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24580 */     // MIs[1] Operand 1
     /*  24580 */     // No operand predicates
     /*  24580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24582 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24605 */     GIR_RootConstrainSelectedInstOperands,
     /*  24606 */     // GIR_Coverage, 5460,
     /*  24606 */     GIR_EraseRootFromParent_Done,
     /*  24607 */   // Label 495: @24607
     /*  24607 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24662), // Rule ID 499 //
     /*  24612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24631 */     // MIs[1] Operand 1
     /*  24631 */     // No operand predicates
     /*  24631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24637 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24660 */     GIR_RootConstrainSelectedInstOperands,
     /*  24661 */     // GIR_Coverage, 499,
     /*  24661 */     GIR_EraseRootFromParent_Done,
     /*  24662 */   // Label 496: @24662
     /*  24662 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24706), // Rule ID 500 //
     /*  24667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24682 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24704 */     GIR_RootConstrainSelectedInstOperands,
     /*  24705 */     // GIR_Coverage, 500,
     /*  24705 */     GIR_EraseRootFromParent_Done,
     /*  24706 */   // Label 497: @24706
     /*  24706 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24750), // Rule ID 165 //
     /*  24711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24726 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24748 */     GIR_RootConstrainSelectedInstOperands,
     /*  24749 */     // GIR_Coverage, 165,
     /*  24749 */     GIR_EraseRootFromParent_Done,
     /*  24750 */   // Label 498: @24750
     /*  24750 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24794), // Rule ID 324 //
     /*  24755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24770 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24792 */     GIR_RootConstrainSelectedInstOperands,
     /*  24793 */     // GIR_Coverage, 324,
     /*  24793 */     GIR_EraseRootFromParent_Done,
     /*  24794 */   // Label 499: @24794
     /*  24794 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24851), // Rule ID 155 //
     /*  24799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24822 */     // MIs[1] Operand 1
     /*  24822 */     // No operand predicates
     /*  24822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24824 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24849 */     GIR_RootConstrainSelectedInstOperands,
     /*  24850 */     // GIR_Coverage, 155,
     /*  24850 */     GIR_EraseRootFromParent_Done,
     /*  24851 */   // Label 500: @24851
     /*  24851 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24908), // Rule ID 487 //
     /*  24856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24879 */     // MIs[1] Operand 1
     /*  24879 */     // No operand predicates
     /*  24879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24881 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24906 */     GIR_RootConstrainSelectedInstOperands,
     /*  24907 */     // GIR_Coverage, 487,
     /*  24907 */     GIR_EraseRootFromParent_Done,
     /*  24908 */   // Label 501: @24908
     /*  24908 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24954), // Rule ID 156 //
     /*  24913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24928 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24952 */     GIR_RootConstrainSelectedInstOperands,
     /*  24953 */     // GIR_Coverage, 156,
     /*  24953 */     GIR_EraseRootFromParent_Done,
     /*  24954 */   // Label 502: @24954
     /*  24954 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(25000), // Rule ID 317 //
     /*  24959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24974 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24998 */     GIR_RootConstrainSelectedInstOperands,
     /*  24999 */     // GIR_Coverage, 317,
     /*  24999 */     GIR_EraseRootFromParent_Done,
     /*  25000 */   // Label 503: @25000
     /*  25000 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25046), // Rule ID 488 //
     /*  25005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25020 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25044 */     GIR_RootConstrainSelectedInstOperands,
     /*  25045 */     // GIR_Coverage, 488,
     /*  25045 */     GIR_EraseRootFromParent_Done,
     /*  25046 */   // Label 504: @25046
     /*  25046 */   GIM_Reject,
     /*  25047 */ // Label 494: @25047
     /*  25047 */ GIM_Reject,
     /*  25048 */ // Label 481: @25048
     /*  25048 */ GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25094), // Rule ID 2518 //
     /*  25053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25074 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25079 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25081 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25086 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25092 */   GIR_RootConstrainSelectedInstOperands,
     /*  25093 */   // GIR_Coverage, 2518,
     /*  25093 */   GIR_EraseRootFromParent_Done,
     /*  25094 */ // Label 505: @25094
     /*  25094 */ GIM_Reject,
     /*  25095 */ // Label 482: @25095
     /*  25095 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25212), // Rule ID 1827 //
     /*  25100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25121 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25121 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25124 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25128 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25133 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25137 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25158 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25175 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25178 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25181 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25184 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25190 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25211 */   // GIR_Coverage, 1827,
     /*  25211 */   GIR_EraseRootFromParent_Done,
     /*  25212 */ // Label 506: @25212
     /*  25212 */ GIM_Reject,
     /*  25213 */ // Label 483: @25213
     /*  25213 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25259), // Rule ID 1132 //
     /*  25218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25239 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25244 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25246 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25257 */   GIR_RootConstrainSelectedInstOperands,
     /*  25258 */   // GIR_Coverage, 1132,
     /*  25258 */   GIR_EraseRootFromParent_Done,
     /*  25259 */ // Label 507: @25259
     /*  25259 */ GIM_Reject,
     /*  25260 */ // Label 484: @25260
     /*  25260 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25373),
     /*  25265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25271 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25311), // Rule ID 2521 //
     /*  25276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25291 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25296 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25298 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25309 */     GIR_RootConstrainSelectedInstOperands,
     /*  25310 */     // GIR_Coverage, 2521,
     /*  25310 */     GIR_EraseRootFromParent_Done,
     /*  25311 */   // Label 509: @25311
     /*  25311 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25372), // Rule ID 3378 //
     /*  25316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25331 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25370 */     GIR_RootConstrainSelectedInstOperands,
     /*  25371 */     // GIR_Coverage, 3378,
     /*  25371 */     GIR_EraseRootFromParent_Done,
     /*  25372 */   // Label 510: @25372
     /*  25372 */   GIM_Reject,
     /*  25373 */ // Label 508: @25373
     /*  25373 */ GIM_Reject,
     /*  25374 */ // Label 485: @25374
     /*  25374 */ GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25491), // Rule ID 1828 //
     /*  25379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25400 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25400 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25403 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25407 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25412 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25416 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25421 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25424 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25428 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25433 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25437 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25454 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25460 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25463 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25469 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25490 */   // GIR_Coverage, 1828,
     /*  25490 */   GIR_EraseRootFromParent_Done,
     /*  25491 */ // Label 511: @25491
     /*  25491 */ GIM_Reject,
     /*  25492 */ // Label 486: @25492
     /*  25492 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25538), // Rule ID 2517 //
     /*  25497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25518 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25523 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25525 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25530 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25536 */   GIR_RootConstrainSelectedInstOperands,
     /*  25537 */   // GIR_Coverage, 2517,
     /*  25537 */   GIR_EraseRootFromParent_Done,
     /*  25538 */ // Label 512: @25538
     /*  25538 */ GIM_Reject,
     /*  25539 */ // Label 487: @25539
     /*  25539 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25652),
     /*  25544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25550 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25590), // Rule ID 1133 //
     /*  25555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25570 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25588 */     GIR_RootConstrainSelectedInstOperands,
     /*  25589 */     // GIR_Coverage, 1133,
     /*  25589 */     GIR_EraseRootFromParent_Done,
     /*  25590 */   // Label 514: @25590
     /*  25590 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25651), // Rule ID 3374 //
     /*  25595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25610 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25649 */     GIR_RootConstrainSelectedInstOperands,
     /*  25650 */     // GIR_Coverage, 3374,
     /*  25650 */     GIR_EraseRootFromParent_Done,
     /*  25651 */   // Label 515: @25651
     /*  25651 */   GIM_Reject,
     /*  25652 */ // Label 513: @25652
     /*  25652 */ GIM_Reject,
     /*  25653 */ // Label 488: @25653
     /*  25653 */ GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25770), // Rule ID 1829 //
     /*  25658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25679 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25679 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25682 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25686 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25691 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25695 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25700 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25703 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25707 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25712 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25716 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25733 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25736 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25739 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25742 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25748 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25769 */   // GIR_Coverage, 1829,
     /*  25769 */   GIR_EraseRootFromParent_Done,
     /*  25770 */ // Label 516: @25770
     /*  25770 */ GIM_Reject,
     /*  25771 */ // Label 489: @25771
     /*  25771 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25817), // Rule ID 2516 //
     /*  25776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25797 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25802 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25804 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25809 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25815 */   GIR_RootConstrainSelectedInstOperands,
     /*  25816 */   // GIR_Coverage, 2516,
     /*  25816 */   GIR_EraseRootFromParent_Done,
     /*  25817 */ // Label 517: @25817
     /*  25817 */ GIM_Reject,
     /*  25818 */ // Label 490: @25818
     /*  25818 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25931),
     /*  25823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25829 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25869), // Rule ID 2520 //
     /*  25834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25849 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25854 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25856 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25867 */     GIR_RootConstrainSelectedInstOperands,
     /*  25868 */     // GIR_Coverage, 2520,
     /*  25868 */     GIR_EraseRootFromParent_Done,
     /*  25869 */   // Label 519: @25869
     /*  25869 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25930), // Rule ID 3370 //
     /*  25874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25889 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25928 */     GIR_RootConstrainSelectedInstOperands,
     /*  25929 */     // GIR_Coverage, 3370,
     /*  25929 */     GIR_EraseRootFromParent_Done,
     /*  25930 */   // Label 520: @25930
     /*  25930 */   GIM_Reject,
     /*  25931 */ // Label 518: @25931
     /*  25931 */ GIM_Reject,
     /*  25932 */ // Label 491: @25932
     /*  25932 */ GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(26049), // Rule ID 1830 //
     /*  25937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25958 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25958 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25961 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25965 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25970 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25974 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25979 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25982 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25986 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25991 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25995 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26021 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26027 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26048 */   // GIR_Coverage, 1830,
     /*  26048 */   GIR_EraseRootFromParent_Done,
     /*  26049 */ // Label 521: @26049
     /*  26049 */ GIM_Reject,
     /*  26050 */ // Label 492: @26050
     /*  26050 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26163),
     /*  26055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26061 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26101), // Rule ID 2519 //
     /*  26066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26081 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26086 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26088 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26099 */     GIR_RootConstrainSelectedInstOperands,
     /*  26100 */     // GIR_Coverage, 2519,
     /*  26100 */     GIR_EraseRootFromParent_Done,
     /*  26101 */   // Label 523: @26101
     /*  26101 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26162), // Rule ID 3366 //
     /*  26106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26121 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26160 */     GIR_RootConstrainSelectedInstOperands,
     /*  26161 */     // GIR_Coverage, 3366,
     /*  26161 */     GIR_EraseRootFromParent_Done,
     /*  26162 */   // Label 524: @26162
     /*  26162 */   GIM_Reject,
     /*  26163 */ // Label 522: @26163
     /*  26163 */ GIM_Reject,
     /*  26164 */ // Label 493: @26164
     /*  26164 */ GIM_Reject,
     /*  26165 */ // Label 8: @26165
     /*  26165 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26551),
     /*  26170 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26173 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 530*/ GIMT_Encode4(26550),
     /*  26184 */   /*GILLT_v2s64*//*Label 526*/ GIMT_Encode4(26228), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26196 */   /*GILLT_v4s32*//*Label 527*/ GIMT_Encode4(26286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v8s16*//*Label 528*/ GIMT_Encode4(26389), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26224 */   /*GILLT_v16s8*//*Label 529*/ GIMT_Encode4(26492),
     /*  26228 */   // Label 526: @26228
     /*  26228 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(26285), // Rule ID 3004 //
     /*  26233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26236 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26254 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26261 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26266 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26284 */     // GIR_Coverage, 3004,
     /*  26284 */     GIR_EraseRootFromParent_Done,
     /*  26285 */   // Label 531: @26285
     /*  26285 */   GIM_Reject,
     /*  26286 */   // Label 527: @26286
     /*  26286 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26388),
     /*  26291 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26309 */     GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26348), // Rule ID 3005 //
     /*  26314 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26317 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26317 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26320 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26322 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26324 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26327 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26329 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26332 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26337 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26342 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26347 */       // GIR_Coverage, 3005,
     /*  26347 */       GIR_EraseRootFromParent_Done,
     /*  26348 */     // Label 533: @26348
     /*  26348 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26387), // Rule ID 3008 //
     /*  26353 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26356 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26356 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26359 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26361 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26363 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26366 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26368 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26376 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26381 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26386 */       // GIR_Coverage, 3008,
     /*  26386 */       GIR_EraseRootFromParent_Done,
     /*  26387 */     // Label 534: @26387
     /*  26387 */     GIM_Reject,
     /*  26388 */   // Label 532: @26388
     /*  26388 */   GIM_Reject,
     /*  26389 */   // Label 528: @26389
     /*  26389 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26491),
     /*  26394 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26412 */     GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26451), // Rule ID 3006 //
     /*  26417 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26420 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26420 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26423 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26425 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26427 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26430 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26432 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26435 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26440 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26445 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26450 */       // GIR_Coverage, 3006,
     /*  26450 */       GIR_EraseRootFromParent_Done,
     /*  26451 */     // Label 536: @26451
     /*  26451 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26490), // Rule ID 3009 //
     /*  26456 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26459 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26464 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26466 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26469 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26471 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26474 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26479 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26484 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26489 */       // GIR_Coverage, 3009,
     /*  26489 */       GIR_EraseRootFromParent_Done,
     /*  26490 */     // Label 537: @26490
     /*  26490 */     GIM_Reject,
     /*  26491 */   // Label 535: @26491
     /*  26491 */   GIM_Reject,
     /*  26492 */   // Label 529: @26492
     /*  26492 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26549), // Rule ID 3007 //
     /*  26497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26500 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26518 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26525 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26530 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26548 */     // GIR_Coverage, 3007,
     /*  26548 */     GIR_EraseRootFromParent_Done,
     /*  26549 */   // Label 538: @26549
     /*  26549 */   GIM_Reject,
     /*  26550 */   // Label 530: @26550
     /*  26550 */   GIM_Reject,
     /*  26551 */ // Label 525: @26551
     /*  26551 */ GIM_Reject,
     /*  26552 */ // Label 9: @26552
     /*  26552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 548*/ GIMT_Encode4(35563),
     /*  26563 */ /*GILLT_s32*//*Label 539*/ GIMT_Encode4(26623),
     /*  26567 */ /*GILLT_s64*//*Label 540*/ GIMT_Encode4(26771), GIMT_Encode4(0),
     /*  26575 */ /*GILLT_v2s32*//*Label 541*/ GIMT_Encode4(27526),
     /*  26579 */ /*GILLT_v2s64*//*Label 542*/ GIMT_Encode4(28281), GIMT_Encode4(0),
     /*  26587 */ /*GILLT_v4s16*//*Label 543*/ GIMT_Encode4(30000),
     /*  26591 */ /*GILLT_v4s32*//*Label 544*/ GIMT_Encode4(30755), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v8s8*//*Label 545*/ GIMT_Encode4(32474),
     /*  26607 */ /*GILLT_v8s16*//*Label 546*/ GIMT_Encode4(32889), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v16s8*//*Label 547*/ GIMT_Encode4(34608),
     /*  26623 */ // Label 539: @26623
     /*  26623 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(26770),
     /*  26628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26631 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26665), // Rule ID 689 //
     /*  26636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26647 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26663 */     GIR_RootConstrainSelectedInstOperands,
     /*  26664 */     // GIR_Coverage, 689,
     /*  26664 */     GIR_EraseRootFromParent_Done,
     /*  26665 */   // Label 550: @26665
     /*  26665 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26699), // Rule ID 690 //
     /*  26670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26681 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26697 */     GIR_RootConstrainSelectedInstOperands,
     /*  26698 */     // GIR_Coverage, 690,
     /*  26698 */     GIR_EraseRootFromParent_Done,
     /*  26699 */   // Label 551: @26699
     /*  26699 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26769), // Rule ID 2698 //
     /*  26704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26715 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26738 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26751 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26768 */     // GIR_Coverage, 2698,
     /*  26768 */     GIR_EraseRootFromParent_Done,
     /*  26769 */   // Label 552: @26769
     /*  26769 */   GIM_Reject,
     /*  26770 */ // Label 549: @26770
     /*  26770 */ GIM_Reject,
     /*  26771 */ // Label 540: @26771
     /*  26771 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26803), // Rule ID 2700 //
     /*  26776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26790 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   // GIR_Coverage, 2700,
     /*  26802 */   GIR_EraseRootFromParent_Done,
     /*  26803 */ // Label 553: @26803
     /*  26803 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26835), // Rule ID 2701 //
     /*  26808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26822 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   // GIR_Coverage, 2701,
     /*  26834 */   GIR_EraseRootFromParent_Done,
     /*  26835 */ // Label 554: @26835
     /*  26835 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26867), // Rule ID 2712 //
     /*  26840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26854 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   // GIR_Coverage, 2712,
     /*  26866 */   GIR_EraseRootFromParent_Done,
     /*  26867 */ // Label 555: @26867
     /*  26867 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26899), // Rule ID 2713 //
     /*  26872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26886 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   // GIR_Coverage, 2713,
     /*  26898 */   GIR_EraseRootFromParent_Done,
     /*  26899 */ // Label 556: @26899
     /*  26899 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26931), // Rule ID 2714 //
     /*  26904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26918 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   // GIR_Coverage, 2714,
     /*  26930 */   GIR_EraseRootFromParent_Done,
     /*  26931 */ // Label 557: @26931
     /*  26931 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26963), // Rule ID 2715 //
     /*  26936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26950 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   // GIR_Coverage, 2715,
     /*  26962 */   GIR_EraseRootFromParent_Done,
     /*  26963 */ // Label 558: @26963
     /*  26963 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26995), // Rule ID 2716 //
     /*  26968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26982 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   // GIR_Coverage, 2716,
     /*  26994 */   GIR_EraseRootFromParent_Done,
     /*  26995 */ // Label 559: @26995
     /*  26995 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27027), // Rule ID 2717 //
     /*  27000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27014 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   // GIR_Coverage, 2717,
     /*  27026 */   GIR_EraseRootFromParent_Done,
     /*  27027 */ // Label 560: @27027
     /*  27027 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27059), // Rule ID 2718 //
     /*  27032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27046 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   // GIR_Coverage, 2718,
     /*  27058 */   GIR_EraseRootFromParent_Done,
     /*  27059 */ // Label 561: @27059
     /*  27059 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27091), // Rule ID 2719 //
     /*  27064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27078 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   // GIR_Coverage, 2719,
     /*  27090 */   GIR_EraseRootFromParent_Done,
     /*  27091 */ // Label 562: @27091
     /*  27091 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27123), // Rule ID 2720 //
     /*  27096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27110 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   // GIR_Coverage, 2720,
     /*  27122 */   GIR_EraseRootFromParent_Done,
     /*  27123 */ // Label 563: @27123
     /*  27123 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27155), // Rule ID 2721 //
     /*  27128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27142 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   // GIR_Coverage, 2721,
     /*  27154 */   GIR_EraseRootFromParent_Done,
     /*  27155 */ // Label 564: @27155
     /*  27155 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27192), // Rule ID 2784 //
     /*  27160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27174 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27190 */   GIR_RootConstrainSelectedInstOperands,
     /*  27191 */   // GIR_Coverage, 2784,
     /*  27191 */   GIR_EraseRootFromParent_Done,
     /*  27192 */ // Label 565: @27192
     /*  27192 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27229), // Rule ID 2785 //
     /*  27197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27211 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27227 */   GIR_RootConstrainSelectedInstOperands,
     /*  27228 */   // GIR_Coverage, 2785,
     /*  27228 */   GIR_EraseRootFromParent_Done,
     /*  27229 */ // Label 566: @27229
     /*  27229 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27266), // Rule ID 2786 //
     /*  27234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27248 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27264 */   GIR_RootConstrainSelectedInstOperands,
     /*  27265 */   // GIR_Coverage, 2786,
     /*  27265 */   GIR_EraseRootFromParent_Done,
     /*  27266 */ // Label 567: @27266
     /*  27266 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27303), // Rule ID 2787 //
     /*  27271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27285 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27301 */   GIR_RootConstrainSelectedInstOperands,
     /*  27302 */   // GIR_Coverage, 2787,
     /*  27302 */   GIR_EraseRootFromParent_Done,
     /*  27303 */ // Label 568: @27303
     /*  27303 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27340), // Rule ID 2788 //
     /*  27308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27322 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27338 */   GIR_RootConstrainSelectedInstOperands,
     /*  27339 */   // GIR_Coverage, 2788,
     /*  27339 */   GIR_EraseRootFromParent_Done,
     /*  27340 */ // Label 569: @27340
     /*  27340 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27377), // Rule ID 2789 //
     /*  27345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27359 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27375 */   GIR_RootConstrainSelectedInstOperands,
     /*  27376 */   // GIR_Coverage, 2789,
     /*  27376 */   GIR_EraseRootFromParent_Done,
     /*  27377 */ // Label 570: @27377
     /*  27377 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27414), // Rule ID 2790 //
     /*  27382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27396 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27412 */   GIR_RootConstrainSelectedInstOperands,
     /*  27413 */   // GIR_Coverage, 2790,
     /*  27413 */   GIR_EraseRootFromParent_Done,
     /*  27414 */ // Label 571: @27414
     /*  27414 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27451), // Rule ID 2791 //
     /*  27419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27433 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27449 */   GIR_RootConstrainSelectedInstOperands,
     /*  27450 */   // GIR_Coverage, 2791,
     /*  27450 */   GIR_EraseRootFromParent_Done,
     /*  27451 */ // Label 572: @27451
     /*  27451 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27488), // Rule ID 2792 //
     /*  27456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27470 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27486 */   GIR_RootConstrainSelectedInstOperands,
     /*  27487 */   // GIR_Coverage, 2792,
     /*  27487 */   GIR_EraseRootFromParent_Done,
     /*  27488 */ // Label 573: @27488
     /*  27488 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27525), // Rule ID 2793 //
     /*  27493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27507 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27523 */   GIR_RootConstrainSelectedInstOperands,
     /*  27524 */   // GIR_Coverage, 2793,
     /*  27524 */   GIR_EraseRootFromParent_Done,
     /*  27525 */ // Label 574: @27525
     /*  27525 */ GIM_Reject,
     /*  27526 */ // Label 541: @27526
     /*  27526 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27558), // Rule ID 2702 //
     /*  27531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27545 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   // GIR_Coverage, 2702,
     /*  27557 */   GIR_EraseRootFromParent_Done,
     /*  27558 */ // Label 575: @27558
     /*  27558 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27590), // Rule ID 2703 //
     /*  27563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27577 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27580 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27582 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27584 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   // GIR_Coverage, 2703,
     /*  27589 */   GIR_EraseRootFromParent_Done,
     /*  27590 */ // Label 576: @27590
     /*  27590 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27622), // Rule ID 2722 //
     /*  27595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27609 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   // GIR_Coverage, 2722,
     /*  27621 */   GIR_EraseRootFromParent_Done,
     /*  27622 */ // Label 577: @27622
     /*  27622 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27654), // Rule ID 2723 //
     /*  27627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27641 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   // GIR_Coverage, 2723,
     /*  27653 */   GIR_EraseRootFromParent_Done,
     /*  27654 */ // Label 578: @27654
     /*  27654 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27686), // Rule ID 2724 //
     /*  27659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27673 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   // GIR_Coverage, 2724,
     /*  27685 */   GIR_EraseRootFromParent_Done,
     /*  27686 */ // Label 579: @27686
     /*  27686 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27718), // Rule ID 2725 //
     /*  27691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27705 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   // GIR_Coverage, 2725,
     /*  27717 */   GIR_EraseRootFromParent_Done,
     /*  27718 */ // Label 580: @27718
     /*  27718 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27750), // Rule ID 2726 //
     /*  27723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27737 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   // GIR_Coverage, 2726,
     /*  27749 */   GIR_EraseRootFromParent_Done,
     /*  27750 */ // Label 581: @27750
     /*  27750 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27782), // Rule ID 2727 //
     /*  27755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27769 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   // GIR_Coverage, 2727,
     /*  27781 */   GIR_EraseRootFromParent_Done,
     /*  27782 */ // Label 582: @27782
     /*  27782 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27814), // Rule ID 2728 //
     /*  27787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27801 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   // GIR_Coverage, 2728,
     /*  27813 */   GIR_EraseRootFromParent_Done,
     /*  27814 */ // Label 583: @27814
     /*  27814 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27846), // Rule ID 2729 //
     /*  27819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27833 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27836 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   // GIR_Coverage, 2729,
     /*  27845 */   GIR_EraseRootFromParent_Done,
     /*  27846 */ // Label 584: @27846
     /*  27846 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27878), // Rule ID 2730 //
     /*  27851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27865 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   // GIR_Coverage, 2730,
     /*  27877 */   GIR_EraseRootFromParent_Done,
     /*  27878 */ // Label 585: @27878
     /*  27878 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27910), // Rule ID 2731 //
     /*  27883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27897 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27900 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   // GIR_Coverage, 2731,
     /*  27909 */   GIR_EraseRootFromParent_Done,
     /*  27910 */ // Label 586: @27910
     /*  27910 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27947), // Rule ID 2794 //
     /*  27915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27929 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27939 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27945 */   GIR_RootConstrainSelectedInstOperands,
     /*  27946 */   // GIR_Coverage, 2794,
     /*  27946 */   GIR_EraseRootFromParent_Done,
     /*  27947 */ // Label 587: @27947
     /*  27947 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27984), // Rule ID 2795 //
     /*  27952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27966 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27976 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27982 */   GIR_RootConstrainSelectedInstOperands,
     /*  27983 */   // GIR_Coverage, 2795,
     /*  27983 */   GIR_EraseRootFromParent_Done,
     /*  27984 */ // Label 588: @27984
     /*  27984 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28021), // Rule ID 2796 //
     /*  27989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28003 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28008 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28013 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28019 */   GIR_RootConstrainSelectedInstOperands,
     /*  28020 */   // GIR_Coverage, 2796,
     /*  28020 */   GIR_EraseRootFromParent_Done,
     /*  28021 */ // Label 589: @28021
     /*  28021 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28058), // Rule ID 2797 //
     /*  28026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28040 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28050 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28056 */   GIR_RootConstrainSelectedInstOperands,
     /*  28057 */   // GIR_Coverage, 2797,
     /*  28057 */   GIR_EraseRootFromParent_Done,
     /*  28058 */ // Label 590: @28058
     /*  28058 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28095), // Rule ID 2798 //
     /*  28063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28077 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28093 */   GIR_RootConstrainSelectedInstOperands,
     /*  28094 */   // GIR_Coverage, 2798,
     /*  28094 */   GIR_EraseRootFromParent_Done,
     /*  28095 */ // Label 591: @28095
     /*  28095 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28132), // Rule ID 2799 //
     /*  28100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28114 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28130 */   GIR_RootConstrainSelectedInstOperands,
     /*  28131 */   // GIR_Coverage, 2799,
     /*  28131 */   GIR_EraseRootFromParent_Done,
     /*  28132 */ // Label 592: @28132
     /*  28132 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28169), // Rule ID 2800 //
     /*  28137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28151 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28161 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28167 */   GIR_RootConstrainSelectedInstOperands,
     /*  28168 */   // GIR_Coverage, 2800,
     /*  28168 */   GIR_EraseRootFromParent_Done,
     /*  28169 */ // Label 593: @28169
     /*  28169 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28206), // Rule ID 2801 //
     /*  28174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28188 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28193 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28198 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28204 */   GIR_RootConstrainSelectedInstOperands,
     /*  28205 */   // GIR_Coverage, 2801,
     /*  28205 */   GIR_EraseRootFromParent_Done,
     /*  28206 */ // Label 594: @28206
     /*  28206 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28243), // Rule ID 2802 //
     /*  28211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28225 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28235 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28241 */   GIR_RootConstrainSelectedInstOperands,
     /*  28242 */   // GIR_Coverage, 2802,
     /*  28242 */   GIR_EraseRootFromParent_Done,
     /*  28243 */ // Label 595: @28243
     /*  28243 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28280), // Rule ID 2803 //
     /*  28248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28262 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28272 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28278 */   GIR_RootConstrainSelectedInstOperands,
     /*  28279 */   // GIR_Coverage, 2803,
     /*  28279 */   GIR_EraseRootFromParent_Done,
     /*  28280 */ // Label 596: @28280
     /*  28280 */ GIM_Reject,
     /*  28281 */ // Label 542: @28281
     /*  28281 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28313), // Rule ID 2706 //
     /*  28286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28300 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28303 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28305 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   // GIR_Coverage, 2706,
     /*  28312 */   GIR_EraseRootFromParent_Done,
     /*  28313 */ // Label 597: @28313
     /*  28313 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28345), // Rule ID 2707 //
     /*  28318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28332 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28335 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28337 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28339 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   // GIR_Coverage, 2707,
     /*  28344 */   GIR_EraseRootFromParent_Done,
     /*  28345 */ // Label 598: @28345
     /*  28345 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28377), // Rule ID 2748 //
     /*  28350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28364 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28367 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   // GIR_Coverage, 2748,
     /*  28376 */   GIR_EraseRootFromParent_Done,
     /*  28377 */ // Label 599: @28377
     /*  28377 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28409), // Rule ID 2749 //
     /*  28382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28396 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28399 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   // GIR_Coverage, 2749,
     /*  28408 */   GIR_EraseRootFromParent_Done,
     /*  28409 */ // Label 600: @28409
     /*  28409 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28441), // Rule ID 2750 //
     /*  28414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28428 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28431 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28433 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28435 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   // GIR_Coverage, 2750,
     /*  28440 */   GIR_EraseRootFromParent_Done,
     /*  28441 */ // Label 601: @28441
     /*  28441 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28473), // Rule ID 2751 //
     /*  28446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28460 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28463 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28465 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   // GIR_Coverage, 2751,
     /*  28472 */   GIR_EraseRootFromParent_Done,
     /*  28473 */ // Label 602: @28473
     /*  28473 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28505), // Rule ID 2752 //
     /*  28478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28492 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28495 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28497 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28499 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   // GIR_Coverage, 2752,
     /*  28504 */   GIR_EraseRootFromParent_Done,
     /*  28505 */ // Label 603: @28505
     /*  28505 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28537), // Rule ID 2753 //
     /*  28510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28524 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28527 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   // GIR_Coverage, 2753,
     /*  28536 */   GIR_EraseRootFromParent_Done,
     /*  28537 */ // Label 604: @28537
     /*  28537 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28569), // Rule ID 2754 //
     /*  28542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28556 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28559 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28561 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   // GIR_Coverage, 2754,
     /*  28568 */   GIR_EraseRootFromParent_Done,
     /*  28569 */ // Label 605: @28569
     /*  28569 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28601), // Rule ID 2755 //
     /*  28574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28588 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28591 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   // GIR_Coverage, 2755,
     /*  28600 */   GIR_EraseRootFromParent_Done,
     /*  28601 */ // Label 606: @28601
     /*  28601 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28633), // Rule ID 2756 //
     /*  28606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28620 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28623 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28625 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   // GIR_Coverage, 2756,
     /*  28632 */   GIR_EraseRootFromParent_Done,
     /*  28633 */ // Label 607: @28633
     /*  28633 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28665), // Rule ID 2757 //
     /*  28638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28652 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28655 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28657 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28659 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   // GIR_Coverage, 2757,
     /*  28664 */   GIR_EraseRootFromParent_Done,
     /*  28665 */ // Label 608: @28665
     /*  28665 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28702), // Rule ID 2820 //
     /*  28670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28684 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28700 */   GIR_RootConstrainSelectedInstOperands,
     /*  28701 */   // GIR_Coverage, 2820,
     /*  28701 */   GIR_EraseRootFromParent_Done,
     /*  28702 */ // Label 609: @28702
     /*  28702 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28739), // Rule ID 2821 //
     /*  28707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28721 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28731 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28737 */   GIR_RootConstrainSelectedInstOperands,
     /*  28738 */   // GIR_Coverage, 2821,
     /*  28738 */   GIR_EraseRootFromParent_Done,
     /*  28739 */ // Label 610: @28739
     /*  28739 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28776), // Rule ID 2822 //
     /*  28744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28758 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28763 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28768 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28774 */   GIR_RootConstrainSelectedInstOperands,
     /*  28775 */   // GIR_Coverage, 2822,
     /*  28775 */   GIR_EraseRootFromParent_Done,
     /*  28776 */ // Label 611: @28776
     /*  28776 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28813), // Rule ID 2823 //
     /*  28781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28795 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28805 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28811 */   GIR_RootConstrainSelectedInstOperands,
     /*  28812 */   // GIR_Coverage, 2823,
     /*  28812 */   GIR_EraseRootFromParent_Done,
     /*  28813 */ // Label 612: @28813
     /*  28813 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28850), // Rule ID 2824 //
     /*  28818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28832 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28842 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28848 */   GIR_RootConstrainSelectedInstOperands,
     /*  28849 */   // GIR_Coverage, 2824,
     /*  28849 */   GIR_EraseRootFromParent_Done,
     /*  28850 */ // Label 613: @28850
     /*  28850 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28887), // Rule ID 2825 //
     /*  28855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28869 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28874 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28879 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28885 */   GIR_RootConstrainSelectedInstOperands,
     /*  28886 */   // GIR_Coverage, 2825,
     /*  28886 */   GIR_EraseRootFromParent_Done,
     /*  28887 */ // Label 614: @28887
     /*  28887 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28924), // Rule ID 2826 //
     /*  28892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28906 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28911 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28916 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28922 */   GIR_RootConstrainSelectedInstOperands,
     /*  28923 */   // GIR_Coverage, 2826,
     /*  28923 */   GIR_EraseRootFromParent_Done,
     /*  28924 */ // Label 615: @28924
     /*  28924 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28961), // Rule ID 2827 //
     /*  28929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28943 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28948 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28953 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28959 */   GIR_RootConstrainSelectedInstOperands,
     /*  28960 */   // GIR_Coverage, 2827,
     /*  28960 */   GIR_EraseRootFromParent_Done,
     /*  28961 */ // Label 616: @28961
     /*  28961 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28998), // Rule ID 2828 //
     /*  28966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28980 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28990 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28996 */   GIR_RootConstrainSelectedInstOperands,
     /*  28997 */   // GIR_Coverage, 2828,
     /*  28997 */   GIR_EraseRootFromParent_Done,
     /*  28998 */ // Label 617: @28998
     /*  28998 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29035), // Rule ID 2829 //
     /*  29003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29017 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29027 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29033 */   GIR_RootConstrainSelectedInstOperands,
     /*  29034 */   // GIR_Coverage, 2829,
     /*  29034 */   GIR_EraseRootFromParent_Done,
     /*  29035 */ // Label 618: @29035
     /*  29035 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29067), // Rule ID 5263 //
     /*  29040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29054 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29057 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29059 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   // GIR_Coverage, 5263,
     /*  29066 */   GIR_EraseRootFromParent_Done,
     /*  29067 */ // Label 619: @29067
     /*  29067 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29099), // Rule ID 5264 //
     /*  29072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29086 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29089 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29091 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29093 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   // GIR_Coverage, 5264,
     /*  29098 */   GIR_EraseRootFromParent_Done,
     /*  29099 */ // Label 620: @29099
     /*  29099 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29131), // Rule ID 5269 //
     /*  29104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29118 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   // GIR_Coverage, 5269,
     /*  29130 */   GIR_EraseRootFromParent_Done,
     /*  29131 */ // Label 621: @29131
     /*  29131 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29163), // Rule ID 5270 //
     /*  29136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29150 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29153 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   // GIR_Coverage, 5270,
     /*  29162 */   GIR_EraseRootFromParent_Done,
     /*  29163 */ // Label 622: @29163
     /*  29163 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29195), // Rule ID 5271 //
     /*  29168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29182 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29185 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   // GIR_Coverage, 5271,
     /*  29194 */   GIR_EraseRootFromParent_Done,
     /*  29195 */ // Label 623: @29195
     /*  29195 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29227), // Rule ID 5272 //
     /*  29200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29214 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29217 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29219 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   // GIR_Coverage, 5272,
     /*  29226 */   GIR_EraseRootFromParent_Done,
     /*  29227 */ // Label 624: @29227
     /*  29227 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29259), // Rule ID 5273 //
     /*  29232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29246 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29249 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29251 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   // GIR_Coverage, 5273,
     /*  29258 */   GIR_EraseRootFromParent_Done,
     /*  29259 */ // Label 625: @29259
     /*  29259 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29291), // Rule ID 5274 //
     /*  29264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29278 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29281 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   // GIR_Coverage, 5274,
     /*  29290 */   GIR_EraseRootFromParent_Done,
     /*  29291 */ // Label 626: @29291
     /*  29291 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29323), // Rule ID 5275 //
     /*  29296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29310 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29313 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29315 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   // GIR_Coverage, 5275,
     /*  29322 */   GIR_EraseRootFromParent_Done,
     /*  29323 */ // Label 627: @29323
     /*  29323 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29355), // Rule ID 5276 //
     /*  29328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29342 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29345 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29347 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   // GIR_Coverage, 5276,
     /*  29354 */   GIR_EraseRootFromParent_Done,
     /*  29355 */ // Label 628: @29355
     /*  29355 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29387), // Rule ID 5277 //
     /*  29360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29374 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29377 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29379 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   // GIR_Coverage, 5277,
     /*  29386 */   GIR_EraseRootFromParent_Done,
     /*  29387 */ // Label 629: @29387
     /*  29387 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29419), // Rule ID 5278 //
     /*  29392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29406 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29409 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29411 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   // GIR_Coverage, 5278,
     /*  29418 */   GIR_EraseRootFromParent_Done,
     /*  29419 */ // Label 630: @29419
     /*  29419 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29477), // Rule ID 5305 //
     /*  29424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29438 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29460 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29472 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29475 */   GIR_RootConstrainSelectedInstOperands,
     /*  29476 */   // GIR_Coverage, 5305,
     /*  29476 */   GIR_EraseRootFromParent_Done,
     /*  29477 */ // Label 631: @29477
     /*  29477 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29535), // Rule ID 5306 //
     /*  29482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29496 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29518 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29524 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29533 */   GIR_RootConstrainSelectedInstOperands,
     /*  29534 */   // GIR_Coverage, 5306,
     /*  29534 */   GIR_EraseRootFromParent_Done,
     /*  29535 */ // Label 632: @29535
     /*  29535 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29593), // Rule ID 5307 //
     /*  29540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29554 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29571 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29576 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29582 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29591 */   GIR_RootConstrainSelectedInstOperands,
     /*  29592 */   // GIR_Coverage, 5307,
     /*  29592 */   GIR_EraseRootFromParent_Done,
     /*  29593 */ // Label 633: @29593
     /*  29593 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29651), // Rule ID 5308 //
     /*  29598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29612 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29634 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29640 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29649 */   GIR_RootConstrainSelectedInstOperands,
     /*  29650 */   // GIR_Coverage, 5308,
     /*  29650 */   GIR_EraseRootFromParent_Done,
     /*  29651 */ // Label 634: @29651
     /*  29651 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29709), // Rule ID 5309 //
     /*  29656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29670 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29692 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29698 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29707 */   GIR_RootConstrainSelectedInstOperands,
     /*  29708 */   // GIR_Coverage, 5309,
     /*  29708 */   GIR_EraseRootFromParent_Done,
     /*  29709 */ // Label 635: @29709
     /*  29709 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29767), // Rule ID 5310 //
     /*  29714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29728 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29750 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29756 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29765 */   GIR_RootConstrainSelectedInstOperands,
     /*  29766 */   // GIR_Coverage, 5310,
     /*  29766 */   GIR_EraseRootFromParent_Done,
     /*  29767 */ // Label 636: @29767
     /*  29767 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29825), // Rule ID 5311 //
     /*  29772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29786 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29808 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29814 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29823 */   GIR_RootConstrainSelectedInstOperands,
     /*  29824 */   // GIR_Coverage, 5311,
     /*  29824 */   GIR_EraseRootFromParent_Done,
     /*  29825 */ // Label 637: @29825
     /*  29825 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29883), // Rule ID 5312 //
     /*  29830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29844 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29861 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29872 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29881 */   GIR_RootConstrainSelectedInstOperands,
     /*  29882 */   // GIR_Coverage, 5312,
     /*  29882 */   GIR_EraseRootFromParent_Done,
     /*  29883 */ // Label 638: @29883
     /*  29883 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29941), // Rule ID 5313 //
     /*  29888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29902 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29924 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29930 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29939 */   GIR_RootConstrainSelectedInstOperands,
     /*  29940 */   // GIR_Coverage, 5313,
     /*  29940 */   GIR_EraseRootFromParent_Done,
     /*  29941 */ // Label 639: @29941
     /*  29941 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29999), // Rule ID 5314 //
     /*  29946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29960 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29982 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29988 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29997 */   GIR_RootConstrainSelectedInstOperands,
     /*  29998 */   // GIR_Coverage, 5314,
     /*  29998 */   GIR_EraseRootFromParent_Done,
     /*  29999 */ // Label 640: @29999
     /*  29999 */ GIM_Reject,
     /*  30000 */ // Label 543: @30000
     /*  30000 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30032), // Rule ID 2704 //
     /*  30005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30019 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30022 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   // GIR_Coverage, 2704,
     /*  30031 */   GIR_EraseRootFromParent_Done,
     /*  30032 */ // Label 641: @30032
     /*  30032 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30064), // Rule ID 2705 //
     /*  30037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30051 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30054 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30056 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   // GIR_Coverage, 2705,
     /*  30063 */   GIR_EraseRootFromParent_Done,
     /*  30064 */ // Label 642: @30064
     /*  30064 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30096), // Rule ID 2732 //
     /*  30069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30083 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30086 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30088 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   // GIR_Coverage, 2732,
     /*  30095 */   GIR_EraseRootFromParent_Done,
     /*  30096 */ // Label 643: @30096
     /*  30096 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30128), // Rule ID 2733 //
     /*  30101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30115 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30118 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30120 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30122 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   // GIR_Coverage, 2733,
     /*  30127 */   GIR_EraseRootFromParent_Done,
     /*  30128 */ // Label 644: @30128
     /*  30128 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30160), // Rule ID 2734 //
     /*  30133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30147 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30150 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30152 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   // GIR_Coverage, 2734,
     /*  30159 */   GIR_EraseRootFromParent_Done,
     /*  30160 */ // Label 645: @30160
     /*  30160 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30192), // Rule ID 2735 //
     /*  30165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30179 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30182 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30184 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   // GIR_Coverage, 2735,
     /*  30191 */   GIR_EraseRootFromParent_Done,
     /*  30192 */ // Label 646: @30192
     /*  30192 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30224), // Rule ID 2736 //
     /*  30197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30211 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30214 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30218 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   // GIR_Coverage, 2736,
     /*  30223 */   GIR_EraseRootFromParent_Done,
     /*  30224 */ // Label 647: @30224
     /*  30224 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30256), // Rule ID 2737 //
     /*  30229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30243 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30246 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30248 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30250 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   // GIR_Coverage, 2737,
     /*  30255 */   GIR_EraseRootFromParent_Done,
     /*  30256 */ // Label 648: @30256
     /*  30256 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30288), // Rule ID 2738 //
     /*  30261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30275 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30278 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30280 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   // GIR_Coverage, 2738,
     /*  30287 */   GIR_EraseRootFromParent_Done,
     /*  30288 */ // Label 649: @30288
     /*  30288 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30320), // Rule ID 2739 //
     /*  30293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30307 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30310 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30312 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   // GIR_Coverage, 2739,
     /*  30319 */   GIR_EraseRootFromParent_Done,
     /*  30320 */ // Label 650: @30320
     /*  30320 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30352), // Rule ID 2740 //
     /*  30325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30339 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30342 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30344 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30346 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   // GIR_Coverage, 2740,
     /*  30351 */   GIR_EraseRootFromParent_Done,
     /*  30352 */ // Label 651: @30352
     /*  30352 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30384), // Rule ID 2741 //
     /*  30357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30371 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30374 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   // GIR_Coverage, 2741,
     /*  30383 */   GIR_EraseRootFromParent_Done,
     /*  30384 */ // Label 652: @30384
     /*  30384 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30421), // Rule ID 2804 //
     /*  30389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30403 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30419 */   GIR_RootConstrainSelectedInstOperands,
     /*  30420 */   // GIR_Coverage, 2804,
     /*  30420 */   GIR_EraseRootFromParent_Done,
     /*  30421 */ // Label 653: @30421
     /*  30421 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30458), // Rule ID 2805 //
     /*  30426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30440 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30445 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30450 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30456 */   GIR_RootConstrainSelectedInstOperands,
     /*  30457 */   // GIR_Coverage, 2805,
     /*  30457 */   GIR_EraseRootFromParent_Done,
     /*  30458 */ // Label 654: @30458
     /*  30458 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30495), // Rule ID 2806 //
     /*  30463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30477 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30482 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30487 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30493 */   GIR_RootConstrainSelectedInstOperands,
     /*  30494 */   // GIR_Coverage, 2806,
     /*  30494 */   GIR_EraseRootFromParent_Done,
     /*  30495 */ // Label 655: @30495
     /*  30495 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30532), // Rule ID 2807 //
     /*  30500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30514 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30519 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30524 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30530 */   GIR_RootConstrainSelectedInstOperands,
     /*  30531 */   // GIR_Coverage, 2807,
     /*  30531 */   GIR_EraseRootFromParent_Done,
     /*  30532 */ // Label 656: @30532
     /*  30532 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30569), // Rule ID 2808 //
     /*  30537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30551 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30567 */   GIR_RootConstrainSelectedInstOperands,
     /*  30568 */   // GIR_Coverage, 2808,
     /*  30568 */   GIR_EraseRootFromParent_Done,
     /*  30569 */ // Label 657: @30569
     /*  30569 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30606), // Rule ID 2809 //
     /*  30574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30588 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30604 */   GIR_RootConstrainSelectedInstOperands,
     /*  30605 */   // GIR_Coverage, 2809,
     /*  30605 */   GIR_EraseRootFromParent_Done,
     /*  30606 */ // Label 658: @30606
     /*  30606 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30643), // Rule ID 2810 //
     /*  30611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30625 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30635 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30641 */   GIR_RootConstrainSelectedInstOperands,
     /*  30642 */   // GIR_Coverage, 2810,
     /*  30642 */   GIR_EraseRootFromParent_Done,
     /*  30643 */ // Label 659: @30643
     /*  30643 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30680), // Rule ID 2811 //
     /*  30648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30662 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30678 */   GIR_RootConstrainSelectedInstOperands,
     /*  30679 */   // GIR_Coverage, 2811,
     /*  30679 */   GIR_EraseRootFromParent_Done,
     /*  30680 */ // Label 660: @30680
     /*  30680 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30717), // Rule ID 2812 //
     /*  30685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30699 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30709 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30715 */   GIR_RootConstrainSelectedInstOperands,
     /*  30716 */   // GIR_Coverage, 2812,
     /*  30716 */   GIR_EraseRootFromParent_Done,
     /*  30717 */ // Label 661: @30717
     /*  30717 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30754), // Rule ID 2813 //
     /*  30722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30736 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30746 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30752 */   GIR_RootConstrainSelectedInstOperands,
     /*  30753 */   // GIR_Coverage, 2813,
     /*  30753 */   GIR_EraseRootFromParent_Done,
     /*  30754 */ // Label 662: @30754
     /*  30754 */ GIM_Reject,
     /*  30755 */ // Label 544: @30755
     /*  30755 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30787), // Rule ID 2708 //
     /*  30760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30774 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   // GIR_Coverage, 2708,
     /*  30786 */   GIR_EraseRootFromParent_Done,
     /*  30787 */ // Label 663: @30787
     /*  30787 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30819), // Rule ID 2709 //
     /*  30792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30806 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   // GIR_Coverage, 2709,
     /*  30818 */   GIR_EraseRootFromParent_Done,
     /*  30819 */ // Label 664: @30819
     /*  30819 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30851), // Rule ID 2758 //
     /*  30824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30838 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   // GIR_Coverage, 2758,
     /*  30850 */   GIR_EraseRootFromParent_Done,
     /*  30851 */ // Label 665: @30851
     /*  30851 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30883), // Rule ID 2759 //
     /*  30856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30870 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   // GIR_Coverage, 2759,
     /*  30882 */   GIR_EraseRootFromParent_Done,
     /*  30883 */ // Label 666: @30883
     /*  30883 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30915), // Rule ID 2760 //
     /*  30888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30902 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   // GIR_Coverage, 2760,
     /*  30914 */   GIR_EraseRootFromParent_Done,
     /*  30915 */ // Label 667: @30915
     /*  30915 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30947), // Rule ID 2761 //
     /*  30920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30934 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   // GIR_Coverage, 2761,
     /*  30946 */   GIR_EraseRootFromParent_Done,
     /*  30947 */ // Label 668: @30947
     /*  30947 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30979), // Rule ID 2762 //
     /*  30952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30966 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   // GIR_Coverage, 2762,
     /*  30978 */   GIR_EraseRootFromParent_Done,
     /*  30979 */ // Label 669: @30979
     /*  30979 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(31011), // Rule ID 2763 //
     /*  30984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30998 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   // GIR_Coverage, 2763,
     /*  31010 */   GIR_EraseRootFromParent_Done,
     /*  31011 */ // Label 670: @31011
     /*  31011 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31043), // Rule ID 2764 //
     /*  31016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31030 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   // GIR_Coverage, 2764,
     /*  31042 */   GIR_EraseRootFromParent_Done,
     /*  31043 */ // Label 671: @31043
     /*  31043 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31075), // Rule ID 2765 //
     /*  31048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31062 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   // GIR_Coverage, 2765,
     /*  31074 */   GIR_EraseRootFromParent_Done,
     /*  31075 */ // Label 672: @31075
     /*  31075 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31107), // Rule ID 2766 //
     /*  31080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31094 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   // GIR_Coverage, 2766,
     /*  31106 */   GIR_EraseRootFromParent_Done,
     /*  31107 */ // Label 673: @31107
     /*  31107 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31139), // Rule ID 2767 //
     /*  31112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31126 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   // GIR_Coverage, 2767,
     /*  31138 */   GIR_EraseRootFromParent_Done,
     /*  31139 */ // Label 674: @31139
     /*  31139 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31176), // Rule ID 2830 //
     /*  31144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31158 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31168 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31174 */   GIR_RootConstrainSelectedInstOperands,
     /*  31175 */   // GIR_Coverage, 2830,
     /*  31175 */   GIR_EraseRootFromParent_Done,
     /*  31176 */ // Label 675: @31176
     /*  31176 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31213), // Rule ID 2831 //
     /*  31181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31195 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31205 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31211 */   GIR_RootConstrainSelectedInstOperands,
     /*  31212 */   // GIR_Coverage, 2831,
     /*  31212 */   GIR_EraseRootFromParent_Done,
     /*  31213 */ // Label 676: @31213
     /*  31213 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31250), // Rule ID 2832 //
     /*  31218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31232 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31237 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31242 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31248 */   GIR_RootConstrainSelectedInstOperands,
     /*  31249 */   // GIR_Coverage, 2832,
     /*  31249 */   GIR_EraseRootFromParent_Done,
     /*  31250 */ // Label 677: @31250
     /*  31250 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31287), // Rule ID 2833 //
     /*  31255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31269 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31274 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31279 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31285 */   GIR_RootConstrainSelectedInstOperands,
     /*  31286 */   // GIR_Coverage, 2833,
     /*  31286 */   GIR_EraseRootFromParent_Done,
     /*  31287 */ // Label 678: @31287
     /*  31287 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31324), // Rule ID 2834 //
     /*  31292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31306 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31322 */   GIR_RootConstrainSelectedInstOperands,
     /*  31323 */   // GIR_Coverage, 2834,
     /*  31323 */   GIR_EraseRootFromParent_Done,
     /*  31324 */ // Label 679: @31324
     /*  31324 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31361), // Rule ID 2835 //
     /*  31329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31343 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31348 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31353 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31359 */   GIR_RootConstrainSelectedInstOperands,
     /*  31360 */   // GIR_Coverage, 2835,
     /*  31360 */   GIR_EraseRootFromParent_Done,
     /*  31361 */ // Label 680: @31361
     /*  31361 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31398), // Rule ID 2836 //
     /*  31366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31380 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31390 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31396 */   GIR_RootConstrainSelectedInstOperands,
     /*  31397 */   // GIR_Coverage, 2836,
     /*  31397 */   GIR_EraseRootFromParent_Done,
     /*  31398 */ // Label 681: @31398
     /*  31398 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31435), // Rule ID 2837 //
     /*  31403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31417 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31422 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31427 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31433 */   GIR_RootConstrainSelectedInstOperands,
     /*  31434 */   // GIR_Coverage, 2837,
     /*  31434 */   GIR_EraseRootFromParent_Done,
     /*  31435 */ // Label 682: @31435
     /*  31435 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31472), // Rule ID 2838 //
     /*  31440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31454 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31470 */   GIR_RootConstrainSelectedInstOperands,
     /*  31471 */   // GIR_Coverage, 2838,
     /*  31471 */   GIR_EraseRootFromParent_Done,
     /*  31472 */ // Label 683: @31472
     /*  31472 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31509), // Rule ID 2839 //
     /*  31477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31491 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31496 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31507 */   GIR_RootConstrainSelectedInstOperands,
     /*  31508 */   // GIR_Coverage, 2839,
     /*  31508 */   GIR_EraseRootFromParent_Done,
     /*  31509 */ // Label 684: @31509
     /*  31509 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31541), // Rule ID 5265 //
     /*  31514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31528 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   // GIR_Coverage, 5265,
     /*  31540 */   GIR_EraseRootFromParent_Done,
     /*  31541 */ // Label 685: @31541
     /*  31541 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31573), // Rule ID 5266 //
     /*  31546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31560 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31563 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31565 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   // GIR_Coverage, 5266,
     /*  31572 */   GIR_EraseRootFromParent_Done,
     /*  31573 */ // Label 686: @31573
     /*  31573 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31605), // Rule ID 5279 //
     /*  31578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31592 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31595 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31597 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   // GIR_Coverage, 5279,
     /*  31604 */   GIR_EraseRootFromParent_Done,
     /*  31605 */ // Label 687: @31605
     /*  31605 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31637), // Rule ID 5280 //
     /*  31610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31624 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31627 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   // GIR_Coverage, 5280,
     /*  31636 */   GIR_EraseRootFromParent_Done,
     /*  31637 */ // Label 688: @31637
     /*  31637 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31669), // Rule ID 5281 //
     /*  31642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31656 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31659 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   // GIR_Coverage, 5281,
     /*  31668 */   GIR_EraseRootFromParent_Done,
     /*  31669 */ // Label 689: @31669
     /*  31669 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31701), // Rule ID 5282 //
     /*  31674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31688 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31691 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31693 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   // GIR_Coverage, 5282,
     /*  31700 */   GIR_EraseRootFromParent_Done,
     /*  31701 */ // Label 690: @31701
     /*  31701 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31733), // Rule ID 5283 //
     /*  31706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31720 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31723 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31725 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   // GIR_Coverage, 5283,
     /*  31732 */   GIR_EraseRootFromParent_Done,
     /*  31733 */ // Label 691: @31733
     /*  31733 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31765), // Rule ID 5284 //
     /*  31738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31752 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31755 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   // GIR_Coverage, 5284,
     /*  31764 */   GIR_EraseRootFromParent_Done,
     /*  31765 */ // Label 692: @31765
     /*  31765 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31797), // Rule ID 5285 //
     /*  31770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31784 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31787 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31789 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   // GIR_Coverage, 5285,
     /*  31796 */   GIR_EraseRootFromParent_Done,
     /*  31797 */ // Label 693: @31797
     /*  31797 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31829), // Rule ID 5286 //
     /*  31802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31816 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31819 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31821 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   // GIR_Coverage, 5286,
     /*  31828 */   GIR_EraseRootFromParent_Done,
     /*  31829 */ // Label 694: @31829
     /*  31829 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31861), // Rule ID 5287 //
     /*  31834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31848 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31851 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   // GIR_Coverage, 5287,
     /*  31860 */   GIR_EraseRootFromParent_Done,
     /*  31861 */ // Label 695: @31861
     /*  31861 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31893), // Rule ID 5288 //
     /*  31866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31880 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31883 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31885 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   // GIR_Coverage, 5288,
     /*  31892 */   GIR_EraseRootFromParent_Done,
     /*  31893 */ // Label 696: @31893
     /*  31893 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31951), // Rule ID 5315 //
     /*  31898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31912 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31934 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31949 */   GIR_RootConstrainSelectedInstOperands,
     /*  31950 */   // GIR_Coverage, 5315,
     /*  31950 */   GIR_EraseRootFromParent_Done,
     /*  31951 */ // Label 697: @31951
     /*  31951 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(32009), // Rule ID 5316 //
     /*  31956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31970 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32007 */   GIR_RootConstrainSelectedInstOperands,
     /*  32008 */   // GIR_Coverage, 5316,
     /*  32008 */   GIR_EraseRootFromParent_Done,
     /*  32009 */ // Label 698: @32009
     /*  32009 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32067), // Rule ID 5317 //
     /*  32014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32028 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32050 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32056 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32065 */   GIR_RootConstrainSelectedInstOperands,
     /*  32066 */   // GIR_Coverage, 5317,
     /*  32066 */   GIR_EraseRootFromParent_Done,
     /*  32067 */ // Label 699: @32067
     /*  32067 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32125), // Rule ID 5318 //
     /*  32072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32086 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32108 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32114 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32123 */   GIR_RootConstrainSelectedInstOperands,
     /*  32124 */   // GIR_Coverage, 5318,
     /*  32124 */   GIR_EraseRootFromParent_Done,
     /*  32125 */ // Label 700: @32125
     /*  32125 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32183), // Rule ID 5319 //
     /*  32130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32144 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32161 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32166 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32172 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32181 */   GIR_RootConstrainSelectedInstOperands,
     /*  32182 */   // GIR_Coverage, 5319,
     /*  32182 */   GIR_EraseRootFromParent_Done,
     /*  32183 */ // Label 701: @32183
     /*  32183 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32241), // Rule ID 5320 //
     /*  32188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32202 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32219 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32224 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32230 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32239 */   GIR_RootConstrainSelectedInstOperands,
     /*  32240 */   // GIR_Coverage, 5320,
     /*  32240 */   GIR_EraseRootFromParent_Done,
     /*  32241 */ // Label 702: @32241
     /*  32241 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32299), // Rule ID 5321 //
     /*  32246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32260 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32277 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32282 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32297 */   GIR_RootConstrainSelectedInstOperands,
     /*  32298 */   // GIR_Coverage, 5321,
     /*  32298 */   GIR_EraseRootFromParent_Done,
     /*  32299 */ // Label 703: @32299
     /*  32299 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32357), // Rule ID 5322 //
     /*  32304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32318 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32335 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32340 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32346 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32355 */   GIR_RootConstrainSelectedInstOperands,
     /*  32356 */   // GIR_Coverage, 5322,
     /*  32356 */   GIR_EraseRootFromParent_Done,
     /*  32357 */ // Label 704: @32357
     /*  32357 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32415), // Rule ID 5323 //
     /*  32362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32376 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32398 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32404 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32413 */   GIR_RootConstrainSelectedInstOperands,
     /*  32414 */   // GIR_Coverage, 5323,
     /*  32414 */   GIR_EraseRootFromParent_Done,
     /*  32415 */ // Label 705: @32415
     /*  32415 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32473), // Rule ID 5324 //
     /*  32420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32434 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32456 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32462 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32471 */   GIR_RootConstrainSelectedInstOperands,
     /*  32472 */   // GIR_Coverage, 5324,
     /*  32472 */   GIR_EraseRootFromParent_Done,
     /*  32473 */ // Label 706: @32473
     /*  32473 */ GIM_Reject,
     /*  32474 */ // Label 545: @32474
     /*  32474 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32506), // Rule ID 2742 //
     /*  32479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32493 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32496 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   // GIR_Coverage, 2742,
     /*  32505 */   GIR_EraseRootFromParent_Done,
     /*  32506 */ // Label 707: @32506
     /*  32506 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32538), // Rule ID 2743 //
     /*  32511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32525 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32528 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32530 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   // GIR_Coverage, 2743,
     /*  32537 */   GIR_EraseRootFromParent_Done,
     /*  32538 */ // Label 708: @32538
     /*  32538 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32570), // Rule ID 2744 //
     /*  32543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32557 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32560 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32562 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   // GIR_Coverage, 2744,
     /*  32569 */   GIR_EraseRootFromParent_Done,
     /*  32570 */ // Label 709: @32570
     /*  32570 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32602), // Rule ID 2745 //
     /*  32575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32589 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32592 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32594 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   // GIR_Coverage, 2745,
     /*  32601 */   GIR_EraseRootFromParent_Done,
     /*  32602 */ // Label 710: @32602
     /*  32602 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32634), // Rule ID 2746 //
     /*  32607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32621 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32624 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32626 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   // GIR_Coverage, 2746,
     /*  32633 */   GIR_EraseRootFromParent_Done,
     /*  32634 */ // Label 711: @32634
     /*  32634 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32666), // Rule ID 2747 //
     /*  32639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32653 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32656 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32658 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   // GIR_Coverage, 2747,
     /*  32665 */   GIR_EraseRootFromParent_Done,
     /*  32666 */ // Label 712: @32666
     /*  32666 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32703), // Rule ID 2814 //
     /*  32671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32685 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32690 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32695 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32701 */   GIR_RootConstrainSelectedInstOperands,
     /*  32702 */   // GIR_Coverage, 2814,
     /*  32702 */   GIR_EraseRootFromParent_Done,
     /*  32703 */ // Label 713: @32703
     /*  32703 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32740), // Rule ID 2815 //
     /*  32708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32722 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32727 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32732 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32738 */   GIR_RootConstrainSelectedInstOperands,
     /*  32739 */   // GIR_Coverage, 2815,
     /*  32739 */   GIR_EraseRootFromParent_Done,
     /*  32740 */ // Label 714: @32740
     /*  32740 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32777), // Rule ID 2816 //
     /*  32745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32759 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32764 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32769 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32775 */   GIR_RootConstrainSelectedInstOperands,
     /*  32776 */   // GIR_Coverage, 2816,
     /*  32776 */   GIR_EraseRootFromParent_Done,
     /*  32777 */ // Label 715: @32777
     /*  32777 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32814), // Rule ID 2817 //
     /*  32782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32796 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32801 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32806 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32812 */   GIR_RootConstrainSelectedInstOperands,
     /*  32813 */   // GIR_Coverage, 2817,
     /*  32813 */   GIR_EraseRootFromParent_Done,
     /*  32814 */ // Label 716: @32814
     /*  32814 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32851), // Rule ID 2818 //
     /*  32819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32833 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32843 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32849 */   GIR_RootConstrainSelectedInstOperands,
     /*  32850 */   // GIR_Coverage, 2818,
     /*  32850 */   GIR_EraseRootFromParent_Done,
     /*  32851 */ // Label 717: @32851
     /*  32851 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32888), // Rule ID 2819 //
     /*  32856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32870 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32880 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32886 */   GIR_RootConstrainSelectedInstOperands,
     /*  32887 */   // GIR_Coverage, 2819,
     /*  32887 */   GIR_EraseRootFromParent_Done,
     /*  32888 */ // Label 718: @32888
     /*  32888 */ GIM_Reject,
     /*  32889 */ // Label 546: @32889
     /*  32889 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32921), // Rule ID 2710 //
     /*  32894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32908 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   // GIR_Coverage, 2710,
     /*  32920 */   GIR_EraseRootFromParent_Done,
     /*  32921 */ // Label 719: @32921
     /*  32921 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32953), // Rule ID 2711 //
     /*  32926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32940 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   // GIR_Coverage, 2711,
     /*  32952 */   GIR_EraseRootFromParent_Done,
     /*  32953 */ // Label 720: @32953
     /*  32953 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32985), // Rule ID 2768 //
     /*  32958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32972 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   // GIR_Coverage, 2768,
     /*  32984 */   GIR_EraseRootFromParent_Done,
     /*  32985 */ // Label 721: @32985
     /*  32985 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33017), // Rule ID 2769 //
     /*  32990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33004 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   // GIR_Coverage, 2769,
     /*  33016 */   GIR_EraseRootFromParent_Done,
     /*  33017 */ // Label 722: @33017
     /*  33017 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33049), // Rule ID 2770 //
     /*  33022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33036 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33039 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   // GIR_Coverage, 2770,
     /*  33048 */   GIR_EraseRootFromParent_Done,
     /*  33049 */ // Label 723: @33049
     /*  33049 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33081), // Rule ID 2771 //
     /*  33054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33068 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33071 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   // GIR_Coverage, 2771,
     /*  33080 */   GIR_EraseRootFromParent_Done,
     /*  33081 */ // Label 724: @33081
     /*  33081 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33113), // Rule ID 2772 //
     /*  33086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33100 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33103 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33105 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   // GIR_Coverage, 2772,
     /*  33112 */   GIR_EraseRootFromParent_Done,
     /*  33113 */ // Label 725: @33113
     /*  33113 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33145), // Rule ID 2773 //
     /*  33118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33132 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33135 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   // GIR_Coverage, 2773,
     /*  33144 */   GIR_EraseRootFromParent_Done,
     /*  33145 */ // Label 726: @33145
     /*  33145 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33177), // Rule ID 2774 //
     /*  33150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33164 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33167 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33169 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   // GIR_Coverage, 2774,
     /*  33176 */   GIR_EraseRootFromParent_Done,
     /*  33177 */ // Label 727: @33177
     /*  33177 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33209), // Rule ID 2775 //
     /*  33182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33196 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33199 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   // GIR_Coverage, 2775,
     /*  33208 */   GIR_EraseRootFromParent_Done,
     /*  33209 */ // Label 728: @33209
     /*  33209 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33241), // Rule ID 2776 //
     /*  33214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33228 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33231 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33233 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   // GIR_Coverage, 2776,
     /*  33240 */   GIR_EraseRootFromParent_Done,
     /*  33241 */ // Label 729: @33241
     /*  33241 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33273), // Rule ID 2777 //
     /*  33246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33260 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33263 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   // GIR_Coverage, 2777,
     /*  33272 */   GIR_EraseRootFromParent_Done,
     /*  33273 */ // Label 730: @33273
     /*  33273 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33310), // Rule ID 2840 //
     /*  33278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33292 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33302 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33308 */   GIR_RootConstrainSelectedInstOperands,
     /*  33309 */   // GIR_Coverage, 2840,
     /*  33309 */   GIR_EraseRootFromParent_Done,
     /*  33310 */ // Label 731: @33310
     /*  33310 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33347), // Rule ID 2841 //
     /*  33315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33329 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33334 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33339 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33345 */   GIR_RootConstrainSelectedInstOperands,
     /*  33346 */   // GIR_Coverage, 2841,
     /*  33346 */   GIR_EraseRootFromParent_Done,
     /*  33347 */ // Label 732: @33347
     /*  33347 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33384), // Rule ID 2842 //
     /*  33352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33366 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33376 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33382 */   GIR_RootConstrainSelectedInstOperands,
     /*  33383 */   // GIR_Coverage, 2842,
     /*  33383 */   GIR_EraseRootFromParent_Done,
     /*  33384 */ // Label 733: @33384
     /*  33384 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33421), // Rule ID 2843 //
     /*  33389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33403 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33419 */   GIR_RootConstrainSelectedInstOperands,
     /*  33420 */   // GIR_Coverage, 2843,
     /*  33420 */   GIR_EraseRootFromParent_Done,
     /*  33421 */ // Label 734: @33421
     /*  33421 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33458), // Rule ID 2844 //
     /*  33426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33440 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33445 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33450 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33456 */   GIR_RootConstrainSelectedInstOperands,
     /*  33457 */   // GIR_Coverage, 2844,
     /*  33457 */   GIR_EraseRootFromParent_Done,
     /*  33458 */ // Label 735: @33458
     /*  33458 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33495), // Rule ID 2845 //
     /*  33463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33477 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33482 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33487 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33493 */   GIR_RootConstrainSelectedInstOperands,
     /*  33494 */   // GIR_Coverage, 2845,
     /*  33494 */   GIR_EraseRootFromParent_Done,
     /*  33495 */ // Label 736: @33495
     /*  33495 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33532), // Rule ID 2846 //
     /*  33500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33514 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33519 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33524 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33530 */   GIR_RootConstrainSelectedInstOperands,
     /*  33531 */   // GIR_Coverage, 2846,
     /*  33531 */   GIR_EraseRootFromParent_Done,
     /*  33532 */ // Label 737: @33532
     /*  33532 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33569), // Rule ID 2847 //
     /*  33537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33551 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33567 */   GIR_RootConstrainSelectedInstOperands,
     /*  33568 */   // GIR_Coverage, 2847,
     /*  33568 */   GIR_EraseRootFromParent_Done,
     /*  33569 */ // Label 738: @33569
     /*  33569 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33606), // Rule ID 2848 //
     /*  33574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33588 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33604 */   GIR_RootConstrainSelectedInstOperands,
     /*  33605 */   // GIR_Coverage, 2848,
     /*  33605 */   GIR_EraseRootFromParent_Done,
     /*  33606 */ // Label 739: @33606
     /*  33606 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33643), // Rule ID 2849 //
     /*  33611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33625 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33635 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33641 */   GIR_RootConstrainSelectedInstOperands,
     /*  33642 */   // GIR_Coverage, 2849,
     /*  33642 */   GIR_EraseRootFromParent_Done,
     /*  33643 */ // Label 740: @33643
     /*  33643 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33675), // Rule ID 5267 //
     /*  33648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33662 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33665 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   // GIR_Coverage, 5267,
     /*  33674 */   GIR_EraseRootFromParent_Done,
     /*  33675 */ // Label 741: @33675
     /*  33675 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33707), // Rule ID 5268 //
     /*  33680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33694 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33697 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33699 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   // GIR_Coverage, 5268,
     /*  33706 */   GIR_EraseRootFromParent_Done,
     /*  33707 */ // Label 742: @33707
     /*  33707 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33739), // Rule ID 5289 //
     /*  33712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33726 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33729 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33731 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   // GIR_Coverage, 5289,
     /*  33738 */   GIR_EraseRootFromParent_Done,
     /*  33739 */ // Label 743: @33739
     /*  33739 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33771), // Rule ID 5290 //
     /*  33744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33758 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33761 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33763 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   // GIR_Coverage, 5290,
     /*  33770 */   GIR_EraseRootFromParent_Done,
     /*  33771 */ // Label 744: @33771
     /*  33771 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33803), // Rule ID 5291 //
     /*  33776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33790 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   // GIR_Coverage, 5291,
     /*  33802 */   GIR_EraseRootFromParent_Done,
     /*  33803 */ // Label 745: @33803
     /*  33803 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33835), // Rule ID 5292 //
     /*  33808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33822 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   // GIR_Coverage, 5292,
     /*  33834 */   GIR_EraseRootFromParent_Done,
     /*  33835 */ // Label 746: @33835
     /*  33835 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33867), // Rule ID 5293 //
     /*  33840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33854 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   // GIR_Coverage, 5293,
     /*  33866 */   GIR_EraseRootFromParent_Done,
     /*  33867 */ // Label 747: @33867
     /*  33867 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33899), // Rule ID 5294 //
     /*  33872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33886 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   // GIR_Coverage, 5294,
     /*  33898 */   GIR_EraseRootFromParent_Done,
     /*  33899 */ // Label 748: @33899
     /*  33899 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33931), // Rule ID 5295 //
     /*  33904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33918 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   // GIR_Coverage, 5295,
     /*  33930 */   GIR_EraseRootFromParent_Done,
     /*  33931 */ // Label 749: @33931
     /*  33931 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33963), // Rule ID 5296 //
     /*  33936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33950 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   // GIR_Coverage, 5296,
     /*  33962 */   GIR_EraseRootFromParent_Done,
     /*  33963 */ // Label 750: @33963
     /*  33963 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33995), // Rule ID 5297 //
     /*  33968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33982 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   // GIR_Coverage, 5297,
     /*  33994 */   GIR_EraseRootFromParent_Done,
     /*  33995 */ // Label 751: @33995
     /*  33995 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34027), // Rule ID 5298 //
     /*  34000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34014 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   // GIR_Coverage, 5298,
     /*  34026 */   GIR_EraseRootFromParent_Done,
     /*  34027 */ // Label 752: @34027
     /*  34027 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34085), // Rule ID 5325 //
     /*  34032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34046 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34068 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34074 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34083 */   GIR_RootConstrainSelectedInstOperands,
     /*  34084 */   // GIR_Coverage, 5325,
     /*  34084 */   GIR_EraseRootFromParent_Done,
     /*  34085 */ // Label 753: @34085
     /*  34085 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34143), // Rule ID 5326 //
     /*  34090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34104 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34132 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34141 */   GIR_RootConstrainSelectedInstOperands,
     /*  34142 */   // GIR_Coverage, 5326,
     /*  34142 */   GIR_EraseRootFromParent_Done,
     /*  34143 */ // Label 754: @34143
     /*  34143 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34201), // Rule ID 5327 //
     /*  34148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34162 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34190 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34199 */   GIR_RootConstrainSelectedInstOperands,
     /*  34200 */   // GIR_Coverage, 5327,
     /*  34200 */   GIR_EraseRootFromParent_Done,
     /*  34201 */ // Label 755: @34201
     /*  34201 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34259), // Rule ID 5328 //
     /*  34206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34220 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34237 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34242 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34248 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34257 */   GIR_RootConstrainSelectedInstOperands,
     /*  34258 */   // GIR_Coverage, 5328,
     /*  34258 */   GIR_EraseRootFromParent_Done,
     /*  34259 */ // Label 756: @34259
     /*  34259 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34317), // Rule ID 5329 //
     /*  34264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34278 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34300 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34306 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34315 */   GIR_RootConstrainSelectedInstOperands,
     /*  34316 */   // GIR_Coverage, 5329,
     /*  34316 */   GIR_EraseRootFromParent_Done,
     /*  34317 */ // Label 757: @34317
     /*  34317 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34375), // Rule ID 5330 //
     /*  34322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34336 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34358 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34364 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34373 */   GIR_RootConstrainSelectedInstOperands,
     /*  34374 */   // GIR_Coverage, 5330,
     /*  34374 */   GIR_EraseRootFromParent_Done,
     /*  34375 */ // Label 758: @34375
     /*  34375 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34433), // Rule ID 5331 //
     /*  34380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34394 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34411 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34416 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34431 */   GIR_RootConstrainSelectedInstOperands,
     /*  34432 */   // GIR_Coverage, 5331,
     /*  34432 */   GIR_EraseRootFromParent_Done,
     /*  34433 */ // Label 759: @34433
     /*  34433 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34491), // Rule ID 5332 //
     /*  34438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34452 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34469 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34474 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34489 */   GIR_RootConstrainSelectedInstOperands,
     /*  34490 */   // GIR_Coverage, 5332,
     /*  34490 */   GIR_EraseRootFromParent_Done,
     /*  34491 */ // Label 760: @34491
     /*  34491 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34549), // Rule ID 5333 //
     /*  34496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34510 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34527 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34538 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34547 */   GIR_RootConstrainSelectedInstOperands,
     /*  34548 */   // GIR_Coverage, 5333,
     /*  34548 */   GIR_EraseRootFromParent_Done,
     /*  34549 */ // Label 761: @34549
     /*  34549 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34607), // Rule ID 5334 //
     /*  34554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34568 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34590 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34596 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34605 */   GIR_RootConstrainSelectedInstOperands,
     /*  34606 */   // GIR_Coverage, 5334,
     /*  34606 */   GIR_EraseRootFromParent_Done,
     /*  34607 */ // Label 762: @34607
     /*  34607 */ GIM_Reject,
     /*  34608 */ // Label 547: @34608
     /*  34608 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34640), // Rule ID 2778 //
     /*  34613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34627 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34630 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34632 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34634 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   // GIR_Coverage, 2778,
     /*  34639 */   GIR_EraseRootFromParent_Done,
     /*  34640 */ // Label 763: @34640
     /*  34640 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34672), // Rule ID 2779 //
     /*  34645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34659 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34662 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34664 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   // GIR_Coverage, 2779,
     /*  34671 */   GIR_EraseRootFromParent_Done,
     /*  34672 */ // Label 764: @34672
     /*  34672 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34704), // Rule ID 2780 //
     /*  34677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34691 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34694 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34696 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   // GIR_Coverage, 2780,
     /*  34703 */   GIR_EraseRootFromParent_Done,
     /*  34704 */ // Label 765: @34704
     /*  34704 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34736), // Rule ID 2781 //
     /*  34709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34723 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34726 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34728 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   // GIR_Coverage, 2781,
     /*  34735 */   GIR_EraseRootFromParent_Done,
     /*  34736 */ // Label 766: @34736
     /*  34736 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34768), // Rule ID 2782 //
     /*  34741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34755 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34758 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   // GIR_Coverage, 2782,
     /*  34767 */   GIR_EraseRootFromParent_Done,
     /*  34768 */ // Label 767: @34768
     /*  34768 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34800), // Rule ID 2783 //
     /*  34773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34787 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34790 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34792 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   // GIR_Coverage, 2783,
     /*  34799 */   GIR_EraseRootFromParent_Done,
     /*  34800 */ // Label 768: @34800
     /*  34800 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34837), // Rule ID 2850 //
     /*  34805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34819 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34824 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34829 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34835 */   GIR_RootConstrainSelectedInstOperands,
     /*  34836 */   // GIR_Coverage, 2850,
     /*  34836 */   GIR_EraseRootFromParent_Done,
     /*  34837 */ // Label 769: @34837
     /*  34837 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34874), // Rule ID 2851 //
     /*  34842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34856 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34861 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34872 */   GIR_RootConstrainSelectedInstOperands,
     /*  34873 */   // GIR_Coverage, 2851,
     /*  34873 */   GIR_EraseRootFromParent_Done,
     /*  34874 */ // Label 770: @34874
     /*  34874 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34911), // Rule ID 2852 //
     /*  34879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34893 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34898 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34903 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34909 */   GIR_RootConstrainSelectedInstOperands,
     /*  34910 */   // GIR_Coverage, 2852,
     /*  34910 */   GIR_EraseRootFromParent_Done,
     /*  34911 */ // Label 771: @34911
     /*  34911 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34948), // Rule ID 2853 //
     /*  34916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34930 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34946 */   GIR_RootConstrainSelectedInstOperands,
     /*  34947 */   // GIR_Coverage, 2853,
     /*  34947 */   GIR_EraseRootFromParent_Done,
     /*  34948 */ // Label 772: @34948
     /*  34948 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34985), // Rule ID 2854 //
     /*  34953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34967 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34977 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34983 */   GIR_RootConstrainSelectedInstOperands,
     /*  34984 */   // GIR_Coverage, 2854,
     /*  34984 */   GIR_EraseRootFromParent_Done,
     /*  34985 */ // Label 773: @34985
     /*  34985 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35022), // Rule ID 2855 //
     /*  34990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35004 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35020 */   GIR_RootConstrainSelectedInstOperands,
     /*  35021 */   // GIR_Coverage, 2855,
     /*  35021 */   GIR_EraseRootFromParent_Done,
     /*  35022 */ // Label 774: @35022
     /*  35022 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35054), // Rule ID 5299 //
     /*  35027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35041 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35044 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35046 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   // GIR_Coverage, 5299,
     /*  35053 */   GIR_EraseRootFromParent_Done,
     /*  35054 */ // Label 775: @35054
     /*  35054 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35086), // Rule ID 5300 //
     /*  35059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35073 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35076 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35078 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   // GIR_Coverage, 5300,
     /*  35085 */   GIR_EraseRootFromParent_Done,
     /*  35086 */ // Label 776: @35086
     /*  35086 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35118), // Rule ID 5301 //
     /*  35091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35105 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35108 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35110 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35112 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   // GIR_Coverage, 5301,
     /*  35117 */   GIR_EraseRootFromParent_Done,
     /*  35118 */ // Label 777: @35118
     /*  35118 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35150), // Rule ID 5302 //
     /*  35123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35137 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35140 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35142 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   // GIR_Coverage, 5302,
     /*  35149 */   GIR_EraseRootFromParent_Done,
     /*  35150 */ // Label 778: @35150
     /*  35150 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35182), // Rule ID 5303 //
     /*  35155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35169 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35172 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35174 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   // GIR_Coverage, 5303,
     /*  35181 */   GIR_EraseRootFromParent_Done,
     /*  35182 */ // Label 779: @35182
     /*  35182 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35214), // Rule ID 5304 //
     /*  35187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35201 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35204 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35206 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   // GIR_Coverage, 5304,
     /*  35213 */   GIR_EraseRootFromParent_Done,
     /*  35214 */ // Label 780: @35214
     /*  35214 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35272), // Rule ID 5335 //
     /*  35219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35233 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35250 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35255 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35261 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35270 */   GIR_RootConstrainSelectedInstOperands,
     /*  35271 */   // GIR_Coverage, 5335,
     /*  35271 */   GIR_EraseRootFromParent_Done,
     /*  35272 */ // Label 781: @35272
     /*  35272 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35330), // Rule ID 5336 //
     /*  35277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35291 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35308 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35313 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35319 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35328 */   GIR_RootConstrainSelectedInstOperands,
     /*  35329 */   // GIR_Coverage, 5336,
     /*  35329 */   GIR_EraseRootFromParent_Done,
     /*  35330 */ // Label 782: @35330
     /*  35330 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35388), // Rule ID 5337 //
     /*  35335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35349 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35366 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35371 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35377 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35386 */   GIR_RootConstrainSelectedInstOperands,
     /*  35387 */   // GIR_Coverage, 5337,
     /*  35387 */   GIR_EraseRootFromParent_Done,
     /*  35388 */ // Label 783: @35388
     /*  35388 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35446), // Rule ID 5338 //
     /*  35393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35407 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35435 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35444 */   GIR_RootConstrainSelectedInstOperands,
     /*  35445 */   // GIR_Coverage, 5338,
     /*  35445 */   GIR_EraseRootFromParent_Done,
     /*  35446 */ // Label 784: @35446
     /*  35446 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35504), // Rule ID 5339 //
     /*  35451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35465 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35482 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35487 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35493 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35502 */   GIR_RootConstrainSelectedInstOperands,
     /*  35503 */   // GIR_Coverage, 5339,
     /*  35503 */   GIR_EraseRootFromParent_Done,
     /*  35504 */ // Label 785: @35504
     /*  35504 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35562), // Rule ID 5340 //
     /*  35509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35523 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35540 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35545 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35551 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35560 */   GIR_RootConstrainSelectedInstOperands,
     /*  35561 */   // GIR_Coverage, 5340,
     /*  35561 */   GIR_EraseRootFromParent_Done,
     /*  35562 */ // Label 786: @35562
     /*  35562 */ GIM_Reject,
     /*  35563 */ // Label 548: @35563
     /*  35563 */ GIM_Reject,
     /*  35564 */ // Label 10: @35564
     /*  35564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 792*/ GIMT_Encode4(35859),
     /*  35575 */ /*GILLT_s16*//*Label 787*/ GIMT_Encode4(35627),
     /*  35579 */ /*GILLT_s32*//*Label 788*/ GIMT_Encode4(35665),
     /*  35583 */ /*GILLT_s64*//*Label 789*/ GIMT_Encode4(35703), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35607 */ /*GILLT_v4s32*//*Label 790*/ GIMT_Encode4(35741), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v8s16*//*Label 791*/ GIMT_Encode4(35800),
     /*  35627 */ // Label 787: @35627
     /*  35627 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(35664), // Rule ID 665 //
     /*  35632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35646 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35651 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35662 */   GIR_RootConstrainSelectedInstOperands,
     /*  35663 */   // GIR_Coverage, 665,
     /*  35663 */   GIR_EraseRootFromParent_Done,
     /*  35664 */ // Label 793: @35664
     /*  35664 */ GIM_Reject,
     /*  35665 */ // Label 788: @35665
     /*  35665 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35702), // Rule ID 666 //
     /*  35670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35684 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35689 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35700 */   GIR_RootConstrainSelectedInstOperands,
     /*  35701 */   // GIR_Coverage, 666,
     /*  35701 */   GIR_EraseRootFromParent_Done,
     /*  35702 */ // Label 794: @35702
     /*  35702 */ GIM_Reject,
     /*  35703 */ // Label 789: @35703
     /*  35703 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35740), // Rule ID 667 //
     /*  35708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35722 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35727 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35732 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35738 */   GIR_RootConstrainSelectedInstOperands,
     /*  35739 */   // GIR_Coverage, 667,
     /*  35739 */   GIR_EraseRootFromParent_Done,
     /*  35740 */ // Label 795: @35740
     /*  35740 */ GIM_Reject,
     /*  35741 */ // Label 790: @35741
     /*  35741 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35799), // Rule ID 3962 //
     /*  35746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35760 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35777 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35782 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35788 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35797 */   GIR_RootConstrainSelectedInstOperands,
     /*  35798 */   // GIR_Coverage, 3962,
     /*  35798 */   GIR_EraseRootFromParent_Done,
     /*  35799 */ // Label 796: @35799
     /*  35799 */ GIM_Reject,
     /*  35800 */ // Label 791: @35800
     /*  35800 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35858), // Rule ID 3950 //
     /*  35805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35819 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35836 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35841 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35847 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35856 */   GIR_RootConstrainSelectedInstOperands,
     /*  35857 */   // GIR_Coverage, 3950,
     /*  35857 */   GIR_EraseRootFromParent_Done,
     /*  35858 */ // Label 797: @35858
     /*  35858 */ GIM_Reject,
     /*  35859 */ // Label 792: @35859
     /*  35859 */ GIM_Reject,
     /*  35860 */ // Label 11: @35860
     /*  35860 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 803*/ GIMT_Encode4(36122),
     /*  35871 */ /*GILLT_s16*//*Label 798*/ GIMT_Encode4(35923),
     /*  35875 */ /*GILLT_s32*//*Label 799*/ GIMT_Encode4(35950),
     /*  35879 */ /*GILLT_s64*//*Label 800*/ GIMT_Encode4(35977), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35903 */ /*GILLT_v4s32*//*Label 801*/ GIMT_Encode4(36004), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35919 */ /*GILLT_v8s16*//*Label 802*/ GIMT_Encode4(36063),
     /*  35923 */ // Label 798: @35923
     /*  35923 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(35949), // Rule ID 674 //
     /*  35928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35942 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35947 */   GIR_RootConstrainSelectedInstOperands,
     /*  35948 */   // GIR_Coverage, 674,
     /*  35948 */   GIR_Done,
     /*  35949 */ // Label 804: @35949
     /*  35949 */ GIM_Reject,
     /*  35950 */ // Label 799: @35950
     /*  35950 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35976), // Rule ID 675 //
     /*  35955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35969 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35974 */   GIR_RootConstrainSelectedInstOperands,
     /*  35975 */   // GIR_Coverage, 675,
     /*  35975 */   GIR_Done,
     /*  35976 */ // Label 805: @35976
     /*  35976 */ GIM_Reject,
     /*  35977 */ // Label 800: @35977
     /*  35977 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(36003), // Rule ID 676 //
     /*  35982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35996 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36001 */   GIR_RootConstrainSelectedInstOperands,
     /*  36002 */   // GIR_Coverage, 676,
     /*  36002 */   GIR_Done,
     /*  36003 */ // Label 806: @36003
     /*  36003 */ GIM_Reject,
     /*  36004 */ // Label 801: @36004
     /*  36004 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(36062), // Rule ID 3960 //
     /*  36009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36023 */   // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36040 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36045 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36051 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36060 */   GIR_RootConstrainSelectedInstOperands,
     /*  36061 */   // GIR_Coverage, 3960,
     /*  36061 */   GIR_EraseRootFromParent_Done,
     /*  36062 */ // Label 807: @36062
     /*  36062 */ GIM_Reject,
     /*  36063 */ // Label 802: @36063
     /*  36063 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(36121), // Rule ID 3948 //
     /*  36068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36082 */   // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36099 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36104 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36110 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36119 */   GIR_RootConstrainSelectedInstOperands,
     /*  36120 */   // GIR_Coverage, 3948,
     /*  36120 */   GIR_EraseRootFromParent_Done,
     /*  36121 */ // Label 808: @36121
     /*  36121 */ GIM_Reject,
     /*  36122 */ // Label 803: @36122
     /*  36122 */ GIM_Reject,
     /*  36123 */ // Label 12: @36123
     /*  36123 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36285),
     /*  36128 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36131 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36134 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(36209), // Rule ID 2045 //
     /*  36139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36153 */     // MIs[0] Rn
     /*  36153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36161 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36173 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36185 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36207 */     GIR_RootConstrainSelectedInstOperands,
     /*  36208 */     // GIR_Coverage, 2045,
     /*  36208 */     GIR_EraseRootFromParent_Done,
     /*  36209 */   // Label 810: @36209
     /*  36209 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(36284), // Rule ID 2046 //
     /*  36214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36217 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36228 */     // MIs[0] Rn
     /*  36228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36236 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36248 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36282 */     GIR_RootConstrainSelectedInstOperands,
     /*  36283 */     // GIR_Coverage, 2046,
     /*  36283 */     GIR_EraseRootFromParent_Done,
     /*  36284 */   // Label 811: @36284
     /*  36284 */   GIM_Reject,
     /*  36285 */ // Label 809: @36285
     /*  36285 */ GIM_Reject,
     /*  36286 */ // Label 13: @36286
     /*  36286 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(36306), // Rule ID 5401 //
     /*  36291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36294 */   // MIs[0] Operand 0
     /*  36294 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36297 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36301 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36304 */   GIR_RootConstrainSelectedInstOperands,
     /*  36305 */   // GIR_Coverage, 5401,
     /*  36305 */   GIR_EraseRootFromParent_Done,
     /*  36306 */ // Label 812: @36306
     /*  36306 */ GIM_Reject,
     /*  36307 */ // Label 14: @36307
     /*  36307 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(42122),
     /*  36312 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36315 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(36363), // Rule ID 1853 //
     /*  36320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36342 */     // (intrinsic_wo_chain:{ *:[i32] } 3821:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36361 */     GIR_RootConstrainSelectedInstOperands,
     /*  36362 */     // GIR_Coverage, 1853,
     /*  36362 */     GIR_EraseRootFromParent_Done,
     /*  36363 */   // Label 814: @36363
     /*  36363 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36411), // Rule ID 2098 //
     /*  36368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36390 */     // (intrinsic_wo_chain:{ *:[i32] } 3821:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36409 */     GIR_RootConstrainSelectedInstOperands,
     /*  36410 */     // GIR_Coverage, 2098,
     /*  36410 */     GIR_EraseRootFromParent_Done,
     /*  36411 */   // Label 815: @36411
     /*  36411 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36447), // Rule ID 677 //
     /*  36416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36438 */     // (intrinsic_wo_chain:{ *:[f16] } 3707:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36445 */     GIR_RootConstrainSelectedInstOperands,
     /*  36446 */     // GIR_Coverage, 677,
     /*  36446 */     GIR_EraseRootFromParent_Done,
     /*  36447 */   // Label 816: @36447
     /*  36447 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36483), // Rule ID 678 //
     /*  36452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36474 */     // (intrinsic_wo_chain:{ *:[f32] } 3707:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36481 */     GIR_RootConstrainSelectedInstOperands,
     /*  36482 */     // GIR_Coverage, 678,
     /*  36482 */     GIR_EraseRootFromParent_Done,
     /*  36483 */   // Label 817: @36483
     /*  36483 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36519), // Rule ID 679 //
     /*  36488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36510 */     // (intrinsic_wo_chain:{ *:[f64] } 3707:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36517 */     GIR_RootConstrainSelectedInstOperands,
     /*  36518 */     // GIR_Coverage, 679,
     /*  36518 */     GIR_EraseRootFromParent_Done,
     /*  36519 */   // Label 818: @36519
     /*  36519 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36564), // Rule ID 693 //
     /*  36524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36546 */     // (intrinsic_wo_chain:{ *:[f32] } 3822:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36562 */     GIR_RootConstrainSelectedInstOperands,
     /*  36563 */     // GIR_Coverage, 693,
     /*  36563 */     GIR_EraseRootFromParent_Done,
     /*  36564 */   // Label 819: @36564
     /*  36564 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36609), // Rule ID 694 //
     /*  36569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36591 */     // (intrinsic_wo_chain:{ *:[f32] } 3822:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36607 */     GIR_RootConstrainSelectedInstOperands,
     /*  36608 */     // GIR_Coverage, 694,
     /*  36608 */     GIR_EraseRootFromParent_Done,
     /*  36609 */   // Label 820: @36609
     /*  36609 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36654), // Rule ID 695 //
     /*  36614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36636 */     // (intrinsic_wo_chain:{ *:[f32] } 3823:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  36639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36652 */     GIR_RootConstrainSelectedInstOperands,
     /*  36653 */     // GIR_Coverage, 695,
     /*  36653 */     GIR_EraseRootFromParent_Done,
     /*  36654 */   // Label 821: @36654
     /*  36654 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36699), // Rule ID 696 //
     /*  36659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36681 */     // (intrinsic_wo_chain:{ *:[f32] } 3823:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  36684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36697 */     GIR_RootConstrainSelectedInstOperands,
     /*  36698 */     // GIR_Coverage, 696,
     /*  36698 */     GIR_EraseRootFromParent_Done,
     /*  36699 */   // Label 822: @36699
     /*  36699 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36744), // Rule ID 1239 //
     /*  36704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36726 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3673:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  36726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  36729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36742 */     GIR_RootConstrainSelectedInstOperands,
     /*  36743 */     // GIR_Coverage, 1239,
     /*  36743 */     GIR_EraseRootFromParent_Done,
     /*  36744 */   // Label 823: @36744
     /*  36744 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36789), // Rule ID 1240 //
     /*  36749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  36760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  36763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36771 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3673:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  36771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  36774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36787 */     GIR_RootConstrainSelectedInstOperands,
     /*  36788 */     // GIR_Coverage, 1240,
     /*  36788 */     GIR_EraseRootFromParent_Done,
     /*  36789 */   // Label 824: @36789
     /*  36789 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36834), // Rule ID 1241 //
     /*  36794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  36808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36816 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3673:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  36816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  36819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36832 */     GIR_RootConstrainSelectedInstOperands,
     /*  36833 */     // GIR_Coverage, 1241,
     /*  36833 */     GIR_EraseRootFromParent_Done,
     /*  36834 */   // Label 825: @36834
     /*  36834 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36879), // Rule ID 1242 //
     /*  36839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  36850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36861 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  36861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  36864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36877 */     GIR_RootConstrainSelectedInstOperands,
     /*  36878 */     // GIR_Coverage, 1242,
     /*  36878 */     GIR_EraseRootFromParent_Done,
     /*  36879 */   // Label 826: @36879
     /*  36879 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36924), // Rule ID 1243 //
     /*  36884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  36895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  36898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36906 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3673:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  36906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  36909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36922 */     GIR_RootConstrainSelectedInstOperands,
     /*  36923 */     // GIR_Coverage, 1243,
     /*  36923 */     GIR_EraseRootFromParent_Done,
     /*  36924 */   // Label 827: @36924
     /*  36924 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36969), // Rule ID 1244 //
     /*  36929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  36940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36951 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3673:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  36951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  36954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36967 */     GIR_RootConstrainSelectedInstOperands,
     /*  36968 */     // GIR_Coverage, 1244,
     /*  36968 */     GIR_EraseRootFromParent_Done,
     /*  36969 */   // Label 828: @36969
     /*  36969 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(37014), // Rule ID 1245 //
     /*  36974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  36982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36996 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3674:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  36996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  36999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37012 */     GIR_RootConstrainSelectedInstOperands,
     /*  37013 */     // GIR_Coverage, 1245,
     /*  37013 */     GIR_EraseRootFromParent_Done,
     /*  37014 */   // Label 829: @37014
     /*  37014 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(37059), // Rule ID 1246 //
     /*  37019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37041 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3674:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37057 */     GIR_RootConstrainSelectedInstOperands,
     /*  37058 */     // GIR_Coverage, 1246,
     /*  37058 */     GIR_EraseRootFromParent_Done,
     /*  37059 */   // Label 830: @37059
     /*  37059 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(37104), // Rule ID 1247 //
     /*  37064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37086 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3674:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37102 */     GIR_RootConstrainSelectedInstOperands,
     /*  37103 */     // GIR_Coverage, 1247,
     /*  37103 */     GIR_EraseRootFromParent_Done,
     /*  37104 */   // Label 831: @37104
     /*  37104 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(37149), // Rule ID 1248 //
     /*  37109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37131 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3674:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37147 */     GIR_RootConstrainSelectedInstOperands,
     /*  37148 */     // GIR_Coverage, 1248,
     /*  37148 */     GIR_EraseRootFromParent_Done,
     /*  37149 */   // Label 832: @37149
     /*  37149 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(37194), // Rule ID 1249 //
     /*  37154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37176 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3674:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37192 */     GIR_RootConstrainSelectedInstOperands,
     /*  37193 */     // GIR_Coverage, 1249,
     /*  37193 */     GIR_EraseRootFromParent_Done,
     /*  37194 */   // Label 833: @37194
     /*  37194 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(37239), // Rule ID 1250 //
     /*  37199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37221 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3674:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37237 */     GIR_RootConstrainSelectedInstOperands,
     /*  37238 */     // GIR_Coverage, 1250,
     /*  37238 */     GIR_EraseRootFromParent_Done,
     /*  37239 */   // Label 834: @37239
     /*  37239 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(37284), // Rule ID 1279 //
     /*  37244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37266 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3701:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37282 */     GIR_RootConstrainSelectedInstOperands,
     /*  37283 */     // GIR_Coverage, 1279,
     /*  37283 */     GIR_EraseRootFromParent_Done,
     /*  37284 */   // Label 835: @37284
     /*  37284 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(37329), // Rule ID 1280 //
     /*  37289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37311 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37327 */     GIR_RootConstrainSelectedInstOperands,
     /*  37328 */     // GIR_Coverage, 1280,
     /*  37328 */     GIR_EraseRootFromParent_Done,
     /*  37329 */   // Label 836: @37329
     /*  37329 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(37374), // Rule ID 1281 //
     /*  37334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37356 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3701:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37372 */     GIR_RootConstrainSelectedInstOperands,
     /*  37373 */     // GIR_Coverage, 1281,
     /*  37373 */     GIR_EraseRootFromParent_Done,
     /*  37374 */   // Label 837: @37374
     /*  37374 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(37419), // Rule ID 1282 //
     /*  37379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37401 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3701:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37417 */     GIR_RootConstrainSelectedInstOperands,
     /*  37418 */     // GIR_Coverage, 1282,
     /*  37418 */     GIR_EraseRootFromParent_Done,
     /*  37419 */   // Label 838: @37419
     /*  37419 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(37464), // Rule ID 1283 //
     /*  37424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37446 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3701:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37462 */     GIR_RootConstrainSelectedInstOperands,
     /*  37463 */     // GIR_Coverage, 1283,
     /*  37463 */     GIR_EraseRootFromParent_Done,
     /*  37464 */   // Label 839: @37464
     /*  37464 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37509), // Rule ID 1284 //
     /*  37469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37491 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3701:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37507 */     GIR_RootConstrainSelectedInstOperands,
     /*  37508 */     // GIR_Coverage, 1284,
     /*  37508 */     GIR_EraseRootFromParent_Done,
     /*  37509 */   // Label 840: @37509
     /*  37509 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37554), // Rule ID 1289 //
     /*  37514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37536 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3714:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37552 */     GIR_RootConstrainSelectedInstOperands,
     /*  37553 */     // GIR_Coverage, 1289,
     /*  37553 */     GIR_EraseRootFromParent_Done,
     /*  37554 */   // Label 841: @37554
     /*  37554 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37599), // Rule ID 1290 //
     /*  37559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3714:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37597 */     GIR_RootConstrainSelectedInstOperands,
     /*  37598 */     // GIR_Coverage, 1290,
     /*  37598 */     GIR_EraseRootFromParent_Done,
     /*  37599 */   // Label 842: @37599
     /*  37599 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37644), // Rule ID 1291 //
     /*  37604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37626 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3714:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  37629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37642 */     GIR_RootConstrainSelectedInstOperands,
     /*  37643 */     // GIR_Coverage, 1291,
     /*  37643 */     GIR_EraseRootFromParent_Done,
     /*  37644 */   // Label 843: @37644
     /*  37644 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37689), // Rule ID 1292 //
     /*  37649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37671 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3714:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  37674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37687 */     GIR_RootConstrainSelectedInstOperands,
     /*  37688 */     // GIR_Coverage, 1292,
     /*  37688 */     GIR_EraseRootFromParent_Done,
     /*  37689 */   // Label 844: @37689
     /*  37689 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37734), // Rule ID 1293 //
     /*  37694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37716 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3714:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  37719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37732 */     GIR_RootConstrainSelectedInstOperands,
     /*  37733 */     // GIR_Coverage, 1293,
     /*  37733 */     GIR_EraseRootFromParent_Done,
     /*  37734 */   // Label 845: @37734
     /*  37734 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37779), // Rule ID 1294 //
     /*  37739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37761 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3714:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  37764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37777 */     GIR_RootConstrainSelectedInstOperands,
     /*  37778 */     // GIR_Coverage, 1294,
     /*  37778 */     GIR_EraseRootFromParent_Done,
     /*  37779 */   // Label 846: @37779
     /*  37779 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37824), // Rule ID 1515 //
     /*  37784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  37795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37806 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3679:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  37806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  37809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37822 */     GIR_RootConstrainSelectedInstOperands,
     /*  37823 */     // GIR_Coverage, 1515,
     /*  37823 */     GIR_EraseRootFromParent_Done,
     /*  37824 */   // Label 847: @37824
     /*  37824 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37869), // Rule ID 1516 //
     /*  37829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37851 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3679:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  37851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  37854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37867 */     GIR_RootConstrainSelectedInstOperands,
     /*  37868 */     // GIR_Coverage, 1516,
     /*  37868 */     GIR_EraseRootFromParent_Done,
     /*  37869 */   // Label 848: @37869
     /*  37869 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37914), // Rule ID 1517 //
     /*  37874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37896 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3679:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  37899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37912 */     GIR_RootConstrainSelectedInstOperands,
     /*  37913 */     // GIR_Coverage, 1517,
     /*  37913 */     GIR_EraseRootFromParent_Done,
     /*  37914 */   // Label 849: @37914
     /*  37914 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37959), // Rule ID 1518 //
     /*  37919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  37930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37941 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  37941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  37944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37957 */     GIR_RootConstrainSelectedInstOperands,
     /*  37958 */     // GIR_Coverage, 1518,
     /*  37958 */     GIR_EraseRootFromParent_Done,
     /*  37959 */   // Label 850: @37959
     /*  37959 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(38004), // Rule ID 1519 //
     /*  37964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37986 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  37986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  37989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38002 */     GIR_RootConstrainSelectedInstOperands,
     /*  38003 */     // GIR_Coverage, 1519,
     /*  38003 */     GIR_EraseRootFromParent_Done,
     /*  38004 */   // Label 851: @38004
     /*  38004 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(38049), // Rule ID 1520 //
     /*  38009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38031 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38047 */     GIR_RootConstrainSelectedInstOperands,
     /*  38048 */     // GIR_Coverage, 1520,
     /*  38048 */     GIR_EraseRootFromParent_Done,
     /*  38049 */   // Label 852: @38049
     /*  38049 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(38094), // Rule ID 1531 //
     /*  38054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38076 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3685:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38092 */     GIR_RootConstrainSelectedInstOperands,
     /*  38093 */     // GIR_Coverage, 1531,
     /*  38093 */     GIR_EraseRootFromParent_Done,
     /*  38094 */   // Label 853: @38094
     /*  38094 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(38139), // Rule ID 1532 //
     /*  38099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38121 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3685:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38137 */     GIR_RootConstrainSelectedInstOperands,
     /*  38138 */     // GIR_Coverage, 1532,
     /*  38138 */     GIR_EraseRootFromParent_Done,
     /*  38139 */   // Label 854: @38139
     /*  38139 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(38184), // Rule ID 1533 //
     /*  38144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38166 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3685:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38182 */     GIR_RootConstrainSelectedInstOperands,
     /*  38183 */     // GIR_Coverage, 1533,
     /*  38183 */     GIR_EraseRootFromParent_Done,
     /*  38184 */   // Label 855: @38184
     /*  38184 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(38229), // Rule ID 1534 //
     /*  38189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38211 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38227 */     GIR_RootConstrainSelectedInstOperands,
     /*  38228 */     // GIR_Coverage, 1534,
     /*  38228 */     GIR_EraseRootFromParent_Done,
     /*  38229 */   // Label 856: @38229
     /*  38229 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(38274), // Rule ID 1535 //
     /*  38234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38256 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38272 */     GIR_RootConstrainSelectedInstOperands,
     /*  38273 */     // GIR_Coverage, 1535,
     /*  38273 */     GIR_EraseRootFromParent_Done,
     /*  38274 */   // Label 857: @38274
     /*  38274 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(38319), // Rule ID 1536 //
     /*  38279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38301 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3685:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38317 */     GIR_RootConstrainSelectedInstOperands,
     /*  38318 */     // GIR_Coverage, 1536,
     /*  38318 */     GIR_EraseRootFromParent_Done,
     /*  38319 */   // Label 858: @38319
     /*  38319 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(38364), // Rule ID 1537 //
     /*  38324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38346 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3626:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38362 */     GIR_RootConstrainSelectedInstOperands,
     /*  38363 */     // GIR_Coverage, 1537,
     /*  38363 */     GIR_EraseRootFromParent_Done,
     /*  38364 */   // Label 859: @38364
     /*  38364 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(38409), // Rule ID 1538 //
     /*  38369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38391 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3626:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38407 */     GIR_RootConstrainSelectedInstOperands,
     /*  38408 */     // GIR_Coverage, 1538,
     /*  38408 */     GIR_EraseRootFromParent_Done,
     /*  38409 */   // Label 860: @38409
     /*  38409 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(38454), // Rule ID 1539 //
     /*  38414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38436 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3626:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38452 */     GIR_RootConstrainSelectedInstOperands,
     /*  38453 */     // GIR_Coverage, 1539,
     /*  38453 */     GIR_EraseRootFromParent_Done,
     /*  38454 */   // Label 861: @38454
     /*  38454 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(38499), // Rule ID 1540 //
     /*  38459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38481 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3626:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38497 */     GIR_RootConstrainSelectedInstOperands,
     /*  38498 */     // GIR_Coverage, 1540,
     /*  38498 */     GIR_EraseRootFromParent_Done,
     /*  38499 */   // Label 862: @38499
     /*  38499 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38544), // Rule ID 1541 //
     /*  38504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38526 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3626:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38542 */     GIR_RootConstrainSelectedInstOperands,
     /*  38543 */     // GIR_Coverage, 1541,
     /*  38543 */     GIR_EraseRootFromParent_Done,
     /*  38544 */   // Label 863: @38544
     /*  38544 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38589), // Rule ID 1542 //
     /*  38549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3626:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38587 */     GIR_RootConstrainSelectedInstOperands,
     /*  38588 */     // GIR_Coverage, 1542,
     /*  38588 */     GIR_EraseRootFromParent_Done,
     /*  38589 */   // Label 864: @38589
     /*  38589 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38634), // Rule ID 1586 //
     /*  38594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38616 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3682:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  38619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38632 */     GIR_RootConstrainSelectedInstOperands,
     /*  38633 */     // GIR_Coverage, 1586,
     /*  38633 */     GIR_EraseRootFromParent_Done,
     /*  38634 */   // Label 865: @38634
     /*  38634 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38679), // Rule ID 1587 //
     /*  38639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38661 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3682:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  38664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38677 */     GIR_RootConstrainSelectedInstOperands,
     /*  38678 */     // GIR_Coverage, 1587,
     /*  38678 */     GIR_EraseRootFromParent_Done,
     /*  38679 */   // Label 866: @38679
     /*  38679 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38724), // Rule ID 1588 //
     /*  38684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3682:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  38709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38722 */     GIR_RootConstrainSelectedInstOperands,
     /*  38723 */     // GIR_Coverage, 1588,
     /*  38723 */     GIR_EraseRootFromParent_Done,
     /*  38724 */   // Label 867: @38724
     /*  38724 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38769), // Rule ID 1589 //
     /*  38729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38751 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3684:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  38754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38767 */     GIR_RootConstrainSelectedInstOperands,
     /*  38768 */     // GIR_Coverage, 1589,
     /*  38768 */     GIR_EraseRootFromParent_Done,
     /*  38769 */   // Label 868: @38769
     /*  38769 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38814), // Rule ID 1590 //
     /*  38774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38796 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3684:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  38799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38812 */     GIR_RootConstrainSelectedInstOperands,
     /*  38813 */     // GIR_Coverage, 1590,
     /*  38813 */     GIR_EraseRootFromParent_Done,
     /*  38814 */   // Label 869: @38814
     /*  38814 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38859), // Rule ID 1591 //
     /*  38819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38841 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3684:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  38844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38857 */     GIR_RootConstrainSelectedInstOperands,
     /*  38858 */     // GIR_Coverage, 1591,
     /*  38858 */     GIR_EraseRootFromParent_Done,
     /*  38859 */   // Label 870: @38859
     /*  38859 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38904), // Rule ID 1592 //
     /*  38864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38886 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3683:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  38889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38902 */     GIR_RootConstrainSelectedInstOperands,
     /*  38903 */     // GIR_Coverage, 1592,
     /*  38903 */     GIR_EraseRootFromParent_Done,
     /*  38904 */   // Label 871: @38904
     /*  38904 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38949), // Rule ID 1593 //
     /*  38909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38931 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3683:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  38934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38947 */     GIR_RootConstrainSelectedInstOperands,
     /*  38948 */     // GIR_Coverage, 1593,
     /*  38948 */     GIR_EraseRootFromParent_Done,
     /*  38949 */   // Label 872: @38949
     /*  38949 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38994), // Rule ID 1594 //
     /*  38954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38976 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3683:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  38979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38992 */     GIR_RootConstrainSelectedInstOperands,
     /*  38993 */     // GIR_Coverage, 1594,
     /*  38993 */     GIR_EraseRootFromParent_Done,
     /*  38994 */   // Label 873: @38994
     /*  38994 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(39030), // Rule ID 1617 //
     /*  38999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39021 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3627:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39028 */     GIR_RootConstrainSelectedInstOperands,
     /*  39029 */     // GIR_Coverage, 1617,
     /*  39029 */     GIR_EraseRootFromParent_Done,
     /*  39030 */   // Label 874: @39030
     /*  39030 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(39066), // Rule ID 1618 //
     /*  39035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39057 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39064 */     GIR_RootConstrainSelectedInstOperands,
     /*  39065 */     // GIR_Coverage, 1618,
     /*  39065 */     GIR_EraseRootFromParent_Done,
     /*  39066 */   // Label 875: @39066
     /*  39066 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(39102), // Rule ID 1619 //
     /*  39071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39093 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3628:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39100 */     GIR_RootConstrainSelectedInstOperands,
     /*  39101 */     // GIR_Coverage, 1619,
     /*  39101 */     GIR_EraseRootFromParent_Done,
     /*  39102 */   // Label 876: @39102
     /*  39102 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(39138), // Rule ID 1620 //
     /*  39107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3628:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39136 */     GIR_RootConstrainSelectedInstOperands,
     /*  39137 */     // GIR_Coverage, 1620,
     /*  39137 */     GIR_EraseRootFromParent_Done,
     /*  39138 */   // Label 877: @39138
     /*  39138 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(39174), // Rule ID 1621 //
     /*  39143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39165 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3627:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39172 */     GIR_RootConstrainSelectedInstOperands,
     /*  39173 */     // GIR_Coverage, 1621,
     /*  39173 */     GIR_EraseRootFromParent_Done,
     /*  39174 */   // Label 878: @39174
     /*  39174 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(39210), // Rule ID 1622 //
     /*  39179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39201 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39208 */     GIR_RootConstrainSelectedInstOperands,
     /*  39209 */     // GIR_Coverage, 1622,
     /*  39209 */     GIR_EraseRootFromParent_Done,
     /*  39210 */   // Label 879: @39210
     /*  39210 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(39246), // Rule ID 1623 //
     /*  39215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39237 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3628:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39244 */     GIR_RootConstrainSelectedInstOperands,
     /*  39245 */     // GIR_Coverage, 1623,
     /*  39245 */     GIR_EraseRootFromParent_Done,
     /*  39246 */   // Label 880: @39246
     /*  39246 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(39282), // Rule ID 1624 //
     /*  39251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39273 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3628:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39280 */     GIR_RootConstrainSelectedInstOperands,
     /*  39281 */     // GIR_Coverage, 1624,
     /*  39281 */     GIR_EraseRootFromParent_Done,
     /*  39282 */   // Label 881: @39282
     /*  39282 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(39318), // Rule ID 1625 //
     /*  39287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39309 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3639:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39316 */     GIR_RootConstrainSelectedInstOperands,
     /*  39317 */     // GIR_Coverage, 1625,
     /*  39317 */     GIR_EraseRootFromParent_Done,
     /*  39318 */   // Label 882: @39318
     /*  39318 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(39354), // Rule ID 1626 //
     /*  39323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39345 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39352 */     GIR_RootConstrainSelectedInstOperands,
     /*  39353 */     // GIR_Coverage, 1626,
     /*  39353 */     GIR_EraseRootFromParent_Done,
     /*  39354 */   // Label 883: @39354
     /*  39354 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(39390), // Rule ID 1627 //
     /*  39359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39381 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3640:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39388 */     GIR_RootConstrainSelectedInstOperands,
     /*  39389 */     // GIR_Coverage, 1627,
     /*  39389 */     GIR_EraseRootFromParent_Done,
     /*  39390 */   // Label 884: @39390
     /*  39390 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39426), // Rule ID 1628 //
     /*  39395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39417 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39424 */     GIR_RootConstrainSelectedInstOperands,
     /*  39425 */     // GIR_Coverage, 1628,
     /*  39425 */     GIR_EraseRootFromParent_Done,
     /*  39426 */   // Label 885: @39426
     /*  39426 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39462), // Rule ID 1629 //
     /*  39431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39453 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3639:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39460 */     GIR_RootConstrainSelectedInstOperands,
     /*  39461 */     // GIR_Coverage, 1629,
     /*  39461 */     GIR_EraseRootFromParent_Done,
     /*  39462 */   // Label 886: @39462
     /*  39462 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39498), // Rule ID 1630 //
     /*  39467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39489 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3639:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39496 */     GIR_RootConstrainSelectedInstOperands,
     /*  39497 */     // GIR_Coverage, 1630,
     /*  39497 */     GIR_EraseRootFromParent_Done,
     /*  39498 */   // Label 887: @39498
     /*  39498 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39534), // Rule ID 1631 //
     /*  39503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39525 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3640:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39532 */     GIR_RootConstrainSelectedInstOperands,
     /*  39533 */     // GIR_Coverage, 1631,
     /*  39533 */     GIR_EraseRootFromParent_Done,
     /*  39534 */   // Label 888: @39534
     /*  39534 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39570), // Rule ID 1632 //
     /*  39539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39561 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39568 */     GIR_RootConstrainSelectedInstOperands,
     /*  39569 */     // GIR_Coverage, 1632,
     /*  39569 */     GIR_EraseRootFromParent_Done,
     /*  39570 */   // Label 889: @39570
     /*  39570 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39606), // Rule ID 1633 //
     /*  39575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39597 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3641:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39604 */     GIR_RootConstrainSelectedInstOperands,
     /*  39605 */     // GIR_Coverage, 1633,
     /*  39605 */     GIR_EraseRootFromParent_Done,
     /*  39606 */   // Label 890: @39606
     /*  39606 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39642), // Rule ID 1634 //
     /*  39611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3641:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  39636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39640 */     GIR_RootConstrainSelectedInstOperands,
     /*  39641 */     // GIR_Coverage, 1634,
     /*  39641 */     GIR_EraseRootFromParent_Done,
     /*  39642 */   // Label 891: @39642
     /*  39642 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39678), // Rule ID 1635 //
     /*  39647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39669 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3642:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  39672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39676 */     GIR_RootConstrainSelectedInstOperands,
     /*  39677 */     // GIR_Coverage, 1635,
     /*  39677 */     GIR_EraseRootFromParent_Done,
     /*  39678 */   // Label 892: @39678
     /*  39678 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39714), // Rule ID 1636 //
     /*  39683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39705 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  39708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39712 */     GIR_RootConstrainSelectedInstOperands,
     /*  39713 */     // GIR_Coverage, 1636,
     /*  39713 */     GIR_EraseRootFromParent_Done,
     /*  39714 */   // Label 893: @39714
     /*  39714 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39750), // Rule ID 1637 //
     /*  39719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39741 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3641:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  39744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39748 */     GIR_RootConstrainSelectedInstOperands,
     /*  39749 */     // GIR_Coverage, 1637,
     /*  39749 */     GIR_EraseRootFromParent_Done,
     /*  39750 */   // Label 894: @39750
     /*  39750 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39786), // Rule ID 1638 //
     /*  39755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39777 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39784 */     GIR_RootConstrainSelectedInstOperands,
     /*  39785 */     // GIR_Coverage, 1638,
     /*  39785 */     GIR_EraseRootFromParent_Done,
     /*  39786 */   // Label 895: @39786
     /*  39786 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39822), // Rule ID 1639 //
     /*  39791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39813 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3642:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  39816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39820 */     GIR_RootConstrainSelectedInstOperands,
     /*  39821 */     // GIR_Coverage, 1639,
     /*  39821 */     GIR_EraseRootFromParent_Done,
     /*  39822 */   // Label 896: @39822
     /*  39822 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39858), // Rule ID 1640 //
     /*  39827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39849 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  39852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39856 */     GIR_RootConstrainSelectedInstOperands,
     /*  39857 */     // GIR_Coverage, 1640,
     /*  39857 */     GIR_EraseRootFromParent_Done,
     /*  39858 */   // Label 897: @39858
     /*  39858 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39894), // Rule ID 1641 //
     /*  39863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39885 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3637:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  39888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39892 */     GIR_RootConstrainSelectedInstOperands,
     /*  39893 */     // GIR_Coverage, 1641,
     /*  39893 */     GIR_EraseRootFromParent_Done,
     /*  39894 */   // Label 898: @39894
     /*  39894 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39930), // Rule ID 1642 //
     /*  39899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39921 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3637:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  39924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39928 */     GIR_RootConstrainSelectedInstOperands,
     /*  39929 */     // GIR_Coverage, 1642,
     /*  39929 */     GIR_EraseRootFromParent_Done,
     /*  39930 */   // Label 899: @39930
     /*  39930 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39966), // Rule ID 1643 //
     /*  39935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  39943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39957 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3638:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  39960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39964 */     GIR_RootConstrainSelectedInstOperands,
     /*  39965 */     // GIR_Coverage, 1643,
     /*  39965 */     GIR_EraseRootFromParent_Done,
     /*  39966 */   // Label 900: @39966
     /*  39966 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(40002), // Rule ID 1644 //
     /*  39971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  39979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39993 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  39996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40000 */     GIR_RootConstrainSelectedInstOperands,
     /*  40001 */     // GIR_Coverage, 1644,
     /*  40001 */     GIR_EraseRootFromParent_Done,
     /*  40002 */   // Label 901: @40002
     /*  40002 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(40038), // Rule ID 1645 //
     /*  40007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40029 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3637:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40036 */     GIR_RootConstrainSelectedInstOperands,
     /*  40037 */     // GIR_Coverage, 1645,
     /*  40037 */     GIR_EraseRootFromParent_Done,
     /*  40038 */   // Label 902: @40038
     /*  40038 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(40074), // Rule ID 1646 //
     /*  40043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40065 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3637:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40072 */     GIR_RootConstrainSelectedInstOperands,
     /*  40073 */     // GIR_Coverage, 1646,
     /*  40073 */     GIR_EraseRootFromParent_Done,
     /*  40074 */   // Label 903: @40074
     /*  40074 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(40110), // Rule ID 1647 //
     /*  40079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40101 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3638:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40108 */     GIR_RootConstrainSelectedInstOperands,
     /*  40109 */     // GIR_Coverage, 1647,
     /*  40109 */     GIR_EraseRootFromParent_Done,
     /*  40110 */   // Label 904: @40110
     /*  40110 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(40146), // Rule ID 1648 //
     /*  40115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40137 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40144 */     GIR_RootConstrainSelectedInstOperands,
     /*  40145 */     // GIR_Coverage, 1648,
     /*  40145 */     GIR_EraseRootFromParent_Done,
     /*  40146 */   // Label 905: @40146
     /*  40146 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(40191), // Rule ID 1665 //
     /*  40151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40173 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3633:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40189 */     GIR_RootConstrainSelectedInstOperands,
     /*  40190 */     // GIR_Coverage, 1665,
     /*  40190 */     GIR_EraseRootFromParent_Done,
     /*  40191 */   // Label 906: @40191
     /*  40191 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(40236), // Rule ID 1666 //
     /*  40196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40218 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3636:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40234 */     GIR_RootConstrainSelectedInstOperands,
     /*  40235 */     // GIR_Coverage, 1666,
     /*  40235 */     GIR_EraseRootFromParent_Done,
     /*  40236 */   // Label 907: @40236
     /*  40236 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(40272), // Rule ID 1688 //
     /*  40241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40263 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3707:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40270 */     GIR_RootConstrainSelectedInstOperands,
     /*  40271 */     // GIR_Coverage, 1688,
     /*  40271 */     GIR_EraseRootFromParent_Done,
     /*  40272 */   // Label 908: @40272
     /*  40272 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(40308), // Rule ID 1689 //
     /*  40277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40299 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3707:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40306 */     GIR_RootConstrainSelectedInstOperands,
     /*  40307 */     // GIR_Coverage, 1689,
     /*  40307 */     GIR_EraseRootFromParent_Done,
     /*  40308 */   // Label 909: @40308
     /*  40308 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(40344), // Rule ID 1690 //
     /*  40313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40335 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3707:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40342 */     GIR_RootConstrainSelectedInstOperands,
     /*  40343 */     // GIR_Coverage, 1690,
     /*  40343 */     GIR_EraseRootFromParent_Done,
     /*  40344 */   // Label 910: @40344
     /*  40344 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40380), // Rule ID 1691 //
     /*  40349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40371 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3707:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40378 */     GIR_RootConstrainSelectedInstOperands,
     /*  40379 */     // GIR_Coverage, 1691,
     /*  40379 */     GIR_EraseRootFromParent_Done,
     /*  40380 */   // Label 911: @40380
     /*  40380 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40416), // Rule ID 1692 //
     /*  40385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40407 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3709:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40414 */     GIR_RootConstrainSelectedInstOperands,
     /*  40415 */     // GIR_Coverage, 1692,
     /*  40415 */     GIR_EraseRootFromParent_Done,
     /*  40416 */   // Label 912: @40416
     /*  40416 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40452), // Rule ID 1693 //
     /*  40421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40443 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3709:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40450 */     GIR_RootConstrainSelectedInstOperands,
     /*  40451 */     // GIR_Coverage, 1693,
     /*  40451 */     GIR_EraseRootFromParent_Done,
     /*  40452 */   // Label 913: @40452
     /*  40452 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40488), // Rule ID 1694 //
     /*  40457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40479 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3709:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40486 */     GIR_RootConstrainSelectedInstOperands,
     /*  40487 */     // GIR_Coverage, 1694,
     /*  40487 */     GIR_EraseRootFromParent_Done,
     /*  40488 */   // Label 914: @40488
     /*  40488 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40524), // Rule ID 1695 //
     /*  40493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40515 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3709:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40522 */     GIR_RootConstrainSelectedInstOperands,
     /*  40523 */     // GIR_Coverage, 1695,
     /*  40523 */     GIR_EraseRootFromParent_Done,
     /*  40524 */   // Label 915: @40524
     /*  40524 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40560), // Rule ID 1696 //
     /*  40529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40551 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3705:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  40554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40558 */     GIR_RootConstrainSelectedInstOperands,
     /*  40559 */     // GIR_Coverage, 1696,
     /*  40559 */     GIR_EraseRootFromParent_Done,
     /*  40560 */   // Label 916: @40560
     /*  40560 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40596), // Rule ID 1697 //
     /*  40565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40587 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3705:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  40590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40594 */     GIR_RootConstrainSelectedInstOperands,
     /*  40595 */     // GIR_Coverage, 1697,
     /*  40595 */     GIR_EraseRootFromParent_Done,
     /*  40596 */   // Label 917: @40596
     /*  40596 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40632), // Rule ID 1698 //
     /*  40601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40623 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3705:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  40626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40630 */     GIR_RootConstrainSelectedInstOperands,
     /*  40631 */     // GIR_Coverage, 1698,
     /*  40631 */     GIR_EraseRootFromParent_Done,
     /*  40632 */   // Label 918: @40632
     /*  40632 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40668), // Rule ID 1699 //
     /*  40637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40659 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3705:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  40662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40666 */     GIR_RootConstrainSelectedInstOperands,
     /*  40667 */     // GIR_Coverage, 1699,
     /*  40667 */     GIR_EraseRootFromParent_Done,
     /*  40668 */   // Label 919: @40668
     /*  40668 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40704), // Rule ID 1700 //
     /*  40673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40695 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3710:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40702 */     GIR_RootConstrainSelectedInstOperands,
     /*  40703 */     // GIR_Coverage, 1700,
     /*  40703 */     GIR_EraseRootFromParent_Done,
     /*  40704 */   // Label 920: @40704
     /*  40704 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40740), // Rule ID 1701 //
     /*  40709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40731 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3710:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  40734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40738 */     GIR_RootConstrainSelectedInstOperands,
     /*  40739 */     // GIR_Coverage, 1701,
     /*  40739 */     GIR_EraseRootFromParent_Done,
     /*  40740 */   // Label 921: @40740
     /*  40740 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40776), // Rule ID 1702 //
     /*  40745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40767 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3710:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  40770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40774 */     GIR_RootConstrainSelectedInstOperands,
     /*  40775 */     // GIR_Coverage, 1702,
     /*  40775 */     GIR_EraseRootFromParent_Done,
     /*  40776 */   // Label 922: @40776
     /*  40776 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40812), // Rule ID 1703 //
     /*  40781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40803 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3710:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  40806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40810 */     GIR_RootConstrainSelectedInstOperands,
     /*  40811 */     // GIR_Coverage, 1703,
     /*  40811 */     GIR_EraseRootFromParent_Done,
     /*  40812 */   // Label 923: @40812
     /*  40812 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40848), // Rule ID 1704 //
     /*  40817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40839 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3706:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /*  40842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40846 */     GIR_RootConstrainSelectedInstOperands,
     /*  40847 */     // GIR_Coverage, 1704,
     /*  40847 */     GIR_EraseRootFromParent_Done,
     /*  40848 */   // Label 924: @40848
     /*  40848 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40884), // Rule ID 1705 //
     /*  40853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40875 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3706:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /*  40878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40882 */     GIR_RootConstrainSelectedInstOperands,
     /*  40883 */     // GIR_Coverage, 1705,
     /*  40883 */     GIR_EraseRootFromParent_Done,
     /*  40884 */   // Label 925: @40884
     /*  40884 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40920), // Rule ID 1706 //
     /*  40889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40911 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3706:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /*  40914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40918 */     GIR_RootConstrainSelectedInstOperands,
     /*  40919 */     // GIR_Coverage, 1706,
     /*  40919 */     GIR_EraseRootFromParent_Done,
     /*  40920 */   // Label 926: @40920
     /*  40920 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40956), // Rule ID 1707 //
     /*  40925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40947 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3706:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /*  40950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40954 */     GIR_RootConstrainSelectedInstOperands,
     /*  40955 */     // GIR_Coverage, 1707,
     /*  40955 */     GIR_EraseRootFromParent_Done,
     /*  40956 */   // Label 927: @40956
     /*  40956 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40992), // Rule ID 1708 //
     /*  40961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  40969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40983 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3708:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  40986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40990 */     GIR_RootConstrainSelectedInstOperands,
     /*  40991 */     // GIR_Coverage, 1708,
     /*  40991 */     GIR_EraseRootFromParent_Done,
     /*  40992 */   // Label 928: @40992
     /*  40992 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(41028), // Rule ID 1709 //
     /*  40997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41019 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3708:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41026 */     GIR_RootConstrainSelectedInstOperands,
     /*  41027 */     // GIR_Coverage, 1709,
     /*  41027 */     GIR_EraseRootFromParent_Done,
     /*  41028 */   // Label 929: @41028
     /*  41028 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(41064), // Rule ID 1710 //
     /*  41033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41055 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3708:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41062 */     GIR_RootConstrainSelectedInstOperands,
     /*  41063 */     // GIR_Coverage, 1710,
     /*  41063 */     GIR_EraseRootFromParent_Done,
     /*  41064 */   // Label 930: @41064
     /*  41064 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(41100), // Rule ID 1711 //
     /*  41069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41091 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3708:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41098 */     GIR_RootConstrainSelectedInstOperands,
     /*  41099 */     // GIR_Coverage, 1711,
     /*  41099 */     GIR_EraseRootFromParent_Done,
     /*  41100 */   // Label 931: @41100
     /*  41100 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(41136), // Rule ID 1714 //
     /*  41105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41127 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3596:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41134 */     GIR_RootConstrainSelectedInstOperands,
     /*  41135 */     // GIR_Coverage, 1714,
     /*  41135 */     GIR_EraseRootFromParent_Done,
     /*  41136 */   // Label 932: @41136
     /*  41136 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(41172), // Rule ID 1715 //
     /*  41141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41163 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3597:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41170 */     GIR_RootConstrainSelectedInstOperands,
     /*  41171 */     // GIR_Coverage, 1715,
     /*  41171 */     GIR_EraseRootFromParent_Done,
     /*  41172 */   // Label 933: @41172
     /*  41172 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(41220), // Rule ID 1848 //
     /*  41177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41199 */     // (intrinsic_wo_chain:{ *:[i32] } 3796:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41218 */     GIR_RootConstrainSelectedInstOperands,
     /*  41219 */     // GIR_Coverage, 1848,
     /*  41219 */     GIR_EraseRootFromParent_Done,
     /*  41220 */   // Label 934: @41220
     /*  41220 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(41268), // Rule ID 2087 //
     /*  41225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41247 */     // (intrinsic_wo_chain:{ *:[i32] } 3796:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41266 */     GIR_RootConstrainSelectedInstOperands,
     /*  41267 */     // GIR_Coverage, 2087,
     /*  41267 */     GIR_EraseRootFromParent_Done,
     /*  41268 */   // Label 935: @41268
     /*  41268 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(41334), // Rule ID 3628 //
     /*  41273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41295 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3478:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41312 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41332 */     GIR_RootConstrainSelectedInstOperands,
     /*  41333 */     // GIR_Coverage, 3628,
     /*  41333 */     GIR_EraseRootFromParent_Done,
     /*  41334 */   // Label 936: @41334
     /*  41334 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(41400), // Rule ID 3630 //
     /*  41339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41361 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3478:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41378 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41398 */     GIR_RootConstrainSelectedInstOperands,
     /*  41399 */     // GIR_Coverage, 3630,
     /*  41399 */     GIR_EraseRootFromParent_Done,
     /*  41400 */   // Label 937: @41400
     /*  41400 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41466), // Rule ID 3632 //
     /*  41405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3478:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41444 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41464 */     GIR_RootConstrainSelectedInstOperands,
     /*  41465 */     // GIR_Coverage, 3632,
     /*  41465 */     GIR_EraseRootFromParent_Done,
     /*  41466 */   // Label 938: @41466
     /*  41466 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41532), // Rule ID 3944 //
     /*  41471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41493 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3560:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  41493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  41508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41510 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41530 */     GIR_RootConstrainSelectedInstOperands,
     /*  41531 */     // GIR_Coverage, 3944,
     /*  41531 */     GIR_EraseRootFromParent_Done,
     /*  41532 */   // Label 939: @41532
     /*  41532 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41598), // Rule ID 3956 //
     /*  41537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41559 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3560:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  41559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  41574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41576 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41596 */     GIR_RootConstrainSelectedInstOperands,
     /*  41597 */     // GIR_Coverage, 3956,
     /*  41597 */     GIR_EraseRootFromParent_Done,
     /*  41598 */   // Label 940: @41598
     /*  41598 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41649), // Rule ID 4844 //
     /*  41603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41625 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3486:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41647 */     GIR_RootConstrainSelectedInstOperands,
     /*  41648 */     // GIR_Coverage, 4844,
     /*  41648 */     GIR_EraseRootFromParent_Done,
     /*  41649 */   // Label 941: @41649
     /*  41649 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41700), // Rule ID 4846 //
     /*  41654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41676 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3483:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41698 */     GIR_RootConstrainSelectedInstOperands,
     /*  41699 */     // GIR_Coverage, 4846,
     /*  41699 */     GIR_EraseRootFromParent_Done,
     /*  41700 */   // Label 942: @41700
     /*  41700 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41751), // Rule ID 4848 //
     /*  41705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41727 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3484:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41749 */     GIR_RootConstrainSelectedInstOperands,
     /*  41750 */     // GIR_Coverage, 4848,
     /*  41750 */     GIR_EraseRootFromParent_Done,
     /*  41751 */   // Label 943: @41751
     /*  41751 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41802), // Rule ID 4850 //
     /*  41756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41778 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3485:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41800 */     GIR_RootConstrainSelectedInstOperands,
     /*  41801 */     // GIR_Coverage, 4850,
     /*  41801 */     GIR_EraseRootFromParent_Done,
     /*  41802 */   // Label 944: @41802
     /*  41802 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41848), // Rule ID 600 //
     /*  41807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41822 */     // MIs[0] Rn
     /*  41822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41830 */     // (intrinsic_wo_chain:{ *:[i32] } 3368:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41846 */     GIR_RootConstrainSelectedInstOperands,
     /*  41847 */     // GIR_Coverage, 600,
     /*  41847 */     GIR_EraseRootFromParent_Done,
     /*  41848 */   // Label 945: @41848
     /*  41848 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41894), // Rule ID 601 //
     /*  41853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41868 */     // MIs[0] Rn
     /*  41868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41876 */     // (intrinsic_wo_chain:{ *:[i32] } 3371:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41892 */     GIR_RootConstrainSelectedInstOperands,
     /*  41893 */     // GIR_Coverage, 601,
     /*  41893 */     GIR_EraseRootFromParent_Done,
     /*  41894 */   // Label 946: @41894
     /*  41894 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41940), // Rule ID 602 //
     /*  41899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41914 */     // MIs[0] Rn
     /*  41914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41922 */     // (intrinsic_wo_chain:{ *:[i32] } 3369:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41938 */     GIR_RootConstrainSelectedInstOperands,
     /*  41939 */     // GIR_Coverage, 602,
     /*  41939 */     GIR_EraseRootFromParent_Done,
     /*  41940 */   // Label 947: @41940
     /*  41940 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41986), // Rule ID 603 //
     /*  41945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41960 */     // MIs[0] Rn
     /*  41960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41968 */     // (intrinsic_wo_chain:{ *:[i32] } 3370:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41984 */     GIR_RootConstrainSelectedInstOperands,
     /*  41985 */     // GIR_Coverage, 603,
     /*  41985 */     GIR_EraseRootFromParent_Done,
     /*  41986 */   // Label 948: @41986
     /*  41986 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(42121), // Rule ID 2673 //
     /*  41991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  41999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  42009 */     // (intrinsic_wo_chain:{ *:[i32] } 3604:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  42009 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  42012 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42016 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42021 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  42025 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42030 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42033 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42037 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42042 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42045 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42048 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42051 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42056 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42073 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42090 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42120 */     // GIR_Coverage, 2673,
     /*  42120 */     GIR_EraseRootFromParent_Done,
     /*  42121 */   // Label 949: @42121
     /*  42121 */   GIM_Reject,
     /*  42122 */ // Label 813: @42122
     /*  42122 */ GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(62676),
     /*  42127 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42130 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(42187), // Rule ID 2105 //
     /*  42135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42164 */     // (intrinsic_wo_chain:{ *:[i32] } 3820:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42185 */     GIR_RootConstrainSelectedInstOperands,
     /*  42186 */     // GIR_Coverage, 2105,
     /*  42186 */     GIR_EraseRootFromParent_Done,
     /*  42187 */   // Label 951: @42187
     /*  42187 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(42286), // Rule ID 1885 //
     /*  42192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42246 */     // MIs[2] Operand 1
     /*  42246 */     // No operand predicates
     /*  42246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42254 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42258 */     // MIs[3] Operand 1
     /*  42258 */     // No operand predicates
     /*  42258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42260 */     // (intrinsic_wo_chain:{ *:[i32] } 3815:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42284 */     GIR_RootConstrainSelectedInstOperands,
     /*  42285 */     // GIR_Coverage, 1885,
     /*  42285 */     GIR_EraseRootFromParent_Done,
     /*  42286 */   // Label 952: @42286
     /*  42286 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(42385), // Rule ID 2142 //
     /*  42291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42345 */     // MIs[2] Operand 1
     /*  42345 */     // No operand predicates
     /*  42345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42353 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42357 */     // MIs[3] Operand 1
     /*  42357 */     // No operand predicates
     /*  42357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42359 */     // (intrinsic_wo_chain:{ *:[i32] } 3815:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42383 */     GIR_RootConstrainSelectedInstOperands,
     /*  42384 */     // GIR_Coverage, 2142,
     /*  42384 */     GIR_EraseRootFromParent_Done,
     /*  42385 */   // Label 953: @42385
     /*  42385 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(42469), // Rule ID 5410 //
     /*  42390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42419 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42422 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42436 */     // MIs[1] Rn
     /*  42436 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42447 */     // (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42467 */     GIR_RootConstrainSelectedInstOperands,
     /*  42468 */     // GIR_Coverage, 5410,
     /*  42468 */     GIR_EraseRootFromParent_Done,
     /*  42469 */   // Label 954: @42469
     /*  42469 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(42553), // Rule ID 5667 //
     /*  42474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42503 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42506 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42520 */     // MIs[1] Rn
     /*  42520 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42531 */     // (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42551 */     GIR_RootConstrainSelectedInstOperands,
     /*  42552 */     // GIR_Coverage, 5667,
     /*  42552 */     GIR_EraseRootFromParent_Done,
     /*  42553 */   // Label 955: @42553
     /*  42553 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(42637), // Rule ID 109 //
     /*  42558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42591 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42594 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42608 */     // MIs[1] Rn
     /*  42608 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42615 */     // (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42635 */     GIR_RootConstrainSelectedInstOperands,
     /*  42636 */     // GIR_Coverage, 109,
     /*  42636 */     GIR_EraseRootFromParent_Done,
     /*  42637 */   // Label 956: @42637
     /*  42637 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42721), // Rule ID 110 //
     /*  42642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42692 */     // MIs[1] Rn
     /*  42692 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42699 */     // (intrinsic_wo_chain:{ *:[i32] } 3743:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42719 */     GIR_RootConstrainSelectedInstOperands,
     /*  42720 */     // GIR_Coverage, 110,
     /*  42720 */     GIR_EraseRootFromParent_Done,
     /*  42721 */   // Label 957: @42721
     /*  42721 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(42805), // Rule ID 2120 //
     /*  42726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42759 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42762 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42776 */     // MIs[1] Rn
     /*  42776 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42783 */     // (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42803 */     GIR_RootConstrainSelectedInstOperands,
     /*  42804 */     // GIR_Coverage, 2120,
     /*  42804 */     GIR_EraseRootFromParent_Done,
     /*  42805 */   // Label 958: @42805
     /*  42805 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42889), // Rule ID 2121 //
     /*  42810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42843 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42846 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42860 */     // MIs[1] Rn
     /*  42860 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42867 */     // (intrinsic_wo_chain:{ *:[i32] } 3743:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42887 */     GIR_RootConstrainSelectedInstOperands,
     /*  42888 */     // GIR_Coverage, 2121,
     /*  42888 */     GIR_EraseRootFromParent_Done,
     /*  42889 */   // Label 959: @42889
     /*  42889 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(42962), // Rule ID 4038 //
     /*  42894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42923 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3494:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42940 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42960 */     GIR_RootConstrainSelectedInstOperands,
     /*  42961 */     // GIR_Coverage, 4038,
     /*  42961 */     GIR_EraseRootFromParent_Done,
     /*  42962 */   // Label 960: @42962
     /*  42962 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(43035), // Rule ID 4040 //
     /*  42967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3498:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  43011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43013 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43033 */     GIR_RootConstrainSelectedInstOperands,
     /*  43034 */     // GIR_Coverage, 4040,
     /*  43034 */     GIR_EraseRootFromParent_Done,
     /*  43035 */   // Label 961: @43035
     /*  43035 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(43108), // Rule ID 4042 //
     /*  43040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43069 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3500:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43086 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43106 */     GIR_RootConstrainSelectedInstOperands,
     /*  43107 */     // GIR_Coverage, 4042,
     /*  43107 */     GIR_EraseRootFromParent_Done,
     /*  43108 */   // Label 962: @43108
     /*  43108 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(43181), // Rule ID 4044 //
     /*  43113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43142 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3496:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43159 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43179 */     GIR_RootConstrainSelectedInstOperands,
     /*  43180 */     // GIR_Coverage, 4044,
     /*  43180 */     GIR_EraseRootFromParent_Done,
     /*  43181 */   // Label 963: @43181
     /*  43181 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(43254), // Rule ID 4046 //
     /*  43186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43215 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3494:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43232 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43252 */     GIR_RootConstrainSelectedInstOperands,
     /*  43253 */     // GIR_Coverage, 4046,
     /*  43253 */     GIR_EraseRootFromParent_Done,
     /*  43254 */   // Label 964: @43254
     /*  43254 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(43327), // Rule ID 4048 //
     /*  43259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43288 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3498:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43305 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43325 */     GIR_RootConstrainSelectedInstOperands,
     /*  43326 */     // GIR_Coverage, 4048,
     /*  43326 */     GIR_EraseRootFromParent_Done,
     /*  43327 */   // Label 965: @43327
     /*  43327 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(43400), // Rule ID 4050 //
     /*  43332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43361 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3500:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43378 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43398 */     GIR_RootConstrainSelectedInstOperands,
     /*  43399 */     // GIR_Coverage, 4050,
     /*  43399 */     GIR_EraseRootFromParent_Done,
     /*  43400 */   // Label 966: @43400
     /*  43400 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(43473), // Rule ID 4052 //
     /*  43405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3496:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43451 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43471 */     GIR_RootConstrainSelectedInstOperands,
     /*  43472 */     // GIR_Coverage, 4052,
     /*  43472 */     GIR_EraseRootFromParent_Done,
     /*  43473 */   // Label 967: @43473
     /*  43473 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(43546), // Rule ID 4054 //
     /*  43478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43507 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3494:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43524 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43544 */     GIR_RootConstrainSelectedInstOperands,
     /*  43545 */     // GIR_Coverage, 4054,
     /*  43545 */     GIR_EraseRootFromParent_Done,
     /*  43546 */   // Label 968: @43546
     /*  43546 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43619), // Rule ID 4056 //
     /*  43551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43580 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3498:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43597 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43617 */     GIR_RootConstrainSelectedInstOperands,
     /*  43618 */     // GIR_Coverage, 4056,
     /*  43618 */     GIR_EraseRootFromParent_Done,
     /*  43619 */   // Label 969: @43619
     /*  43619 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43692), // Rule ID 4058 //
     /*  43624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43653 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3500:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43670 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43690 */     GIR_RootConstrainSelectedInstOperands,
     /*  43691 */     // GIR_Coverage, 4058,
     /*  43691 */     GIR_EraseRootFromParent_Done,
     /*  43692 */   // Label 970: @43692
     /*  43692 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43765), // Rule ID 4060 //
     /*  43697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43726 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3496:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43743 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43763 */     GIR_RootConstrainSelectedInstOperands,
     /*  43764 */     // GIR_Coverage, 4060,
     /*  43764 */     GIR_EraseRootFromParent_Done,
     /*  43765 */   // Label 971: @43765
     /*  43765 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43838), // Rule ID 4062 //
     /*  43770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43799 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3494:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43816 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43836 */     GIR_RootConstrainSelectedInstOperands,
     /*  43837 */     // GIR_Coverage, 4062,
     /*  43837 */     GIR_EraseRootFromParent_Done,
     /*  43838 */   // Label 972: @43838
     /*  43838 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43911), // Rule ID 4064 //
     /*  43843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43872 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3498:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43889 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43909 */     GIR_RootConstrainSelectedInstOperands,
     /*  43910 */     // GIR_Coverage, 4064,
     /*  43910 */     GIR_EraseRootFromParent_Done,
     /*  43911 */   // Label 973: @43911
     /*  43911 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43984), // Rule ID 4066 //
     /*  43916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3500:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43962 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43982 */     GIR_RootConstrainSelectedInstOperands,
     /*  43983 */     // GIR_Coverage, 4066,
     /*  43983 */     GIR_EraseRootFromParent_Done,
     /*  43984 */   // Label 974: @43984
     /*  43984 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(44057), // Rule ID 4068 //
     /*  43989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3496:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44035 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44055 */     GIR_RootConstrainSelectedInstOperands,
     /*  44056 */     // GIR_Coverage, 4068,
     /*  44056 */     GIR_EraseRootFromParent_Done,
     /*  44057 */   // Label 975: @44057
     /*  44057 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(44130), // Rule ID 4512 //
     /*  44062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44091 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3492:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44128 */     GIR_RootConstrainSelectedInstOperands,
     /*  44129 */     // GIR_Coverage, 4512,
     /*  44129 */     GIR_EraseRootFromParent_Done,
     /*  44130 */   // Label 976: @44130
     /*  44130 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(44203), // Rule ID 4518 //
     /*  44135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44164 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3492:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44201 */     GIR_RootConstrainSelectedInstOperands,
     /*  44202 */     // GIR_Coverage, 4518,
     /*  44202 */     GIR_EraseRootFromParent_Done,
     /*  44203 */   // Label 977: @44203
     /*  44203 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(44271), // Rule ID 1878 //
     /*  44208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44245 */     // MIs[1] Operand 1
     /*  44245 */     // No operand predicates
     /*  44245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44247 */     // (intrinsic_wo_chain:{ *:[i32] } 3815:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44255 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44269 */     GIR_RootConstrainSelectedInstOperands,
     /*  44270 */     // GIR_Coverage, 1878,
     /*  44270 */     GIR_EraseRootFromParent_Done,
     /*  44271 */   // Label 978: @44271
     /*  44271 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(44336), // Rule ID 1882 //
     /*  44276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44313 */     // MIs[1] Operand 1
     /*  44313 */     // No operand predicates
     /*  44313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44315 */     // (intrinsic_wo_chain:{ *:[i32] } 3816:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44323 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44334 */     GIR_RootConstrainSelectedInstOperands,
     /*  44335 */     // GIR_Coverage, 1882,
     /*  44335 */     GIR_EraseRootFromParent_Done,
     /*  44336 */   // Label 979: @44336
     /*  44336 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(44404), // Rule ID 2137 //
     /*  44341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44378 */     // MIs[1] Operand 1
     /*  44378 */     // No operand predicates
     /*  44378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44380 */     // (intrinsic_wo_chain:{ *:[i32] } 3815:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44388 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44402 */     GIR_RootConstrainSelectedInstOperands,
     /*  44403 */     // GIR_Coverage, 2137,
     /*  44403 */     GIR_EraseRootFromParent_Done,
     /*  44404 */   // Label 980: @44404
     /*  44404 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(44469), // Rule ID 2139 //
     /*  44409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44446 */     // MIs[1] Operand 1
     /*  44446 */     // No operand predicates
     /*  44446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44448 */     // (intrinsic_wo_chain:{ *:[i32] } 3816:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44456 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44467 */     GIR_RootConstrainSelectedInstOperands,
     /*  44468 */     // GIR_Coverage, 2139,
     /*  44468 */     GIR_EraseRootFromParent_Done,
     /*  44469 */   // Label 981: @44469
     /*  44469 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(44552), // Rule ID 3908 //
     /*  44474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44508 */     // MIs[1] Operand 1
     /*  44508 */     // No operand predicates
     /*  44508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44510 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3553:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44550 */     GIR_RootConstrainSelectedInstOperands,
     /*  44551 */     // GIR_Coverage, 3908,
     /*  44551 */     GIR_EraseRootFromParent_Done,
     /*  44552 */   // Label 982: @44552
     /*  44552 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44635), // Rule ID 3910 //
     /*  44557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44591 */     // MIs[1] Operand 1
     /*  44591 */     // No operand predicates
     /*  44591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44593 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3553:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44633 */     GIR_RootConstrainSelectedInstOperands,
     /*  44634 */     // GIR_Coverage, 3910,
     /*  44634 */     GIR_EraseRootFromParent_Done,
     /*  44635 */   // Label 983: @44635
     /*  44635 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44718), // Rule ID 3912 //
     /*  44640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44674 */     // MIs[1] Operand 1
     /*  44674 */     // No operand predicates
     /*  44674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44676 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3553:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44716 */     GIR_RootConstrainSelectedInstOperands,
     /*  44717 */     // GIR_Coverage, 3912,
     /*  44717 */     GIR_EraseRootFromParent_Done,
     /*  44718 */   // Label 984: @44718
     /*  44718 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44779), // Rule ID 1649 //
     /*  44723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44756 */     // MIs[1] Operand 1
     /*  44756 */     // No operand predicates
     /*  44756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44758 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3631:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44777 */     GIR_RootConstrainSelectedInstOperands,
     /*  44778 */     // GIR_Coverage, 1649,
     /*  44778 */     GIR_EraseRootFromParent_Done,
     /*  44779 */   // Label 985: @44779
     /*  44779 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44840), // Rule ID 1650 //
     /*  44784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44817 */     // MIs[1] Operand 1
     /*  44817 */     // No operand predicates
     /*  44817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44819 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3632:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44838 */     GIR_RootConstrainSelectedInstOperands,
     /*  44839 */     // GIR_Coverage, 1650,
     /*  44839 */     GIR_EraseRootFromParent_Done,
     /*  44840 */   // Label 986: @44840
     /*  44840 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44901), // Rule ID 1651 //
     /*  44845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44878 */     // MIs[1] Operand 1
     /*  44878 */     // No operand predicates
     /*  44878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44880 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3634:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44899 */     GIR_RootConstrainSelectedInstOperands,
     /*  44900 */     // GIR_Coverage, 1651,
     /*  44900 */     GIR_EraseRootFromParent_Done,
     /*  44901 */   // Label 987: @44901
     /*  44901 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44962), // Rule ID 1652 //
     /*  44906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44939 */     // MIs[1] Operand 1
     /*  44939 */     // No operand predicates
     /*  44939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44941 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3635:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44960 */     GIR_RootConstrainSelectedInstOperands,
     /*  44961 */     // GIR_Coverage, 1652,
     /*  44961 */     GIR_EraseRootFromParent_Done,
     /*  44962 */   // Label 988: @44962
     /*  44962 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(45023), // Rule ID 1653 //
     /*  44967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45000 */     // MIs[1] Operand 1
     /*  45000 */     // No operand predicates
     /*  45000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45002 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3631:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  45005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45021 */     GIR_RootConstrainSelectedInstOperands,
     /*  45022 */     // GIR_Coverage, 1653,
     /*  45022 */     GIR_EraseRootFromParent_Done,
     /*  45023 */   // Label 989: @45023
     /*  45023 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(45084), // Rule ID 1654 //
     /*  45028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45061 */     // MIs[1] Operand 1
     /*  45061 */     // No operand predicates
     /*  45061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45063 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3632:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45082 */     GIR_RootConstrainSelectedInstOperands,
     /*  45083 */     // GIR_Coverage, 1654,
     /*  45083 */     GIR_EraseRootFromParent_Done,
     /*  45084 */   // Label 990: @45084
     /*  45084 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(45145), // Rule ID 1655 //
     /*  45089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45122 */     // MIs[1] Operand 1
     /*  45122 */     // No operand predicates
     /*  45122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45124 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3634:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45143 */     GIR_RootConstrainSelectedInstOperands,
     /*  45144 */     // GIR_Coverage, 1655,
     /*  45144 */     GIR_EraseRootFromParent_Done,
     /*  45145 */   // Label 991: @45145
     /*  45145 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(45206), // Rule ID 1656 //
     /*  45150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45183 */     // MIs[1] Operand 1
     /*  45183 */     // No operand predicates
     /*  45183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45185 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3635:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45204 */     GIR_RootConstrainSelectedInstOperands,
     /*  45205 */     // GIR_Coverage, 1656,
     /*  45205 */     GIR_EraseRootFromParent_Done,
     /*  45206 */   // Label 992: @45206
     /*  45206 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(45267), // Rule ID 1657 //
     /*  45211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45244 */     // MIs[1] Operand 1
     /*  45244 */     // No operand predicates
     /*  45244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45246 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45265 */     GIR_RootConstrainSelectedInstOperands,
     /*  45266 */     // GIR_Coverage, 1657,
     /*  45266 */     GIR_EraseRootFromParent_Done,
     /*  45267 */   // Label 993: @45267
     /*  45267 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(45328), // Rule ID 1658 //
     /*  45272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45305 */     // MIs[1] Operand 1
     /*  45305 */     // No operand predicates
     /*  45305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45307 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45326 */     GIR_RootConstrainSelectedInstOperands,
     /*  45327 */     // GIR_Coverage, 1658,
     /*  45327 */     GIR_EraseRootFromParent_Done,
     /*  45328 */   // Label 994: @45328
     /*  45328 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(45389), // Rule ID 1659 //
     /*  45333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45366 */     // MIs[1] Operand 1
     /*  45366 */     // No operand predicates
     /*  45366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45368 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3634:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45387 */     GIR_RootConstrainSelectedInstOperands,
     /*  45388 */     // GIR_Coverage, 1659,
     /*  45388 */     GIR_EraseRootFromParent_Done,
     /*  45389 */   // Label 995: @45389
     /*  45389 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(45450), // Rule ID 1660 //
     /*  45394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45427 */     // MIs[1] Operand 1
     /*  45427 */     // No operand predicates
     /*  45427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45429 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3635:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45448 */     GIR_RootConstrainSelectedInstOperands,
     /*  45449 */     // GIR_Coverage, 1660,
     /*  45449 */     GIR_EraseRootFromParent_Done,
     /*  45450 */   // Label 996: @45450
     /*  45450 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(45511), // Rule ID 1661 //
     /*  45455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45488 */     // MIs[1] Operand 1
     /*  45488 */     // No operand predicates
     /*  45488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45490 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45509 */     GIR_RootConstrainSelectedInstOperands,
     /*  45510 */     // GIR_Coverage, 1661,
     /*  45510 */     GIR_EraseRootFromParent_Done,
     /*  45511 */   // Label 997: @45511
     /*  45511 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45572), // Rule ID 1662 //
     /*  45516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45549 */     // MIs[1] Operand 1
     /*  45549 */     // No operand predicates
     /*  45549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45551 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45570 */     GIR_RootConstrainSelectedInstOperands,
     /*  45571 */     // GIR_Coverage, 1662,
     /*  45571 */     GIR_EraseRootFromParent_Done,
     /*  45572 */   // Label 998: @45572
     /*  45572 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45633), // Rule ID 1663 //
     /*  45577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45610 */     // MIs[1] Operand 1
     /*  45610 */     // No operand predicates
     /*  45610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45612 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3634:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45631 */     GIR_RootConstrainSelectedInstOperands,
     /*  45632 */     // GIR_Coverage, 1663,
     /*  45632 */     GIR_EraseRootFromParent_Done,
     /*  45633 */   // Label 999: @45633
     /*  45633 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45694), // Rule ID 1664 //
     /*  45638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45671 */     // MIs[1] Operand 1
     /*  45671 */     // No operand predicates
     /*  45671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45673 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3635:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45692 */     GIR_RootConstrainSelectedInstOperands,
     /*  45693 */     // GIR_Coverage, 1664,
     /*  45693 */     GIR_EraseRootFromParent_Done,
     /*  45694 */   // Label 1000: @45694
     /*  45694 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45755), // Rule ID 1722 //
     /*  45699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45732 */     // MIs[1] Operand 1
     /*  45732 */     // No operand predicates
     /*  45732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45734 */     // (intrinsic_wo_chain:{ *:[i32] } 3458:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45739 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45753 */     GIR_RootConstrainSelectedInstOperands,
     /*  45754 */     // GIR_Coverage, 1722,
     /*  45754 */     GIR_EraseRootFromParent_Done,
     /*  45755 */   // Label 1001: @45755
     /*  45755 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45816), // Rule ID 1723 //
     /*  45760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45793 */     // MIs[1] Operand 1
     /*  45793 */     // No operand predicates
     /*  45793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45795 */     // (intrinsic_wo_chain:{ *:[i32] } 3460:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45800 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45814 */     GIR_RootConstrainSelectedInstOperands,
     /*  45815 */     // GIR_Coverage, 1723,
     /*  45815 */     GIR_EraseRootFromParent_Done,
     /*  45816 */   // Label 1002: @45816
     /*  45816 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45877), // Rule ID 1724 //
     /*  45821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45854 */     // MIs[1] Operand 1
     /*  45854 */     // No operand predicates
     /*  45854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45856 */     // (intrinsic_wo_chain:{ *:[i32] } 3465:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45861 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45875 */     GIR_RootConstrainSelectedInstOperands,
     /*  45876 */     // GIR_Coverage, 1724,
     /*  45876 */     GIR_EraseRootFromParent_Done,
     /*  45877 */   // Label 1003: @45877
     /*  45877 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45938), // Rule ID 1725 //
     /*  45882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45915 */     // MIs[1] Operand 1
     /*  45915 */     // No operand predicates
     /*  45915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45917 */     // (intrinsic_wo_chain:{ *:[i32] } 3467:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45922 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45936 */     GIR_RootConstrainSelectedInstOperands,
     /*  45937 */     // GIR_Coverage, 1725,
     /*  45937 */     GIR_EraseRootFromParent_Done,
     /*  45938 */   // Label 1004: @45938
     /*  45938 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45992), // Rule ID 105 //
     /*  45943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45972 */     // (intrinsic_wo_chain:{ *:[i32] } 3740:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45990 */     GIR_RootConstrainSelectedInstOperands,
     /*  45991 */     // GIR_Coverage, 105,
     /*  45991 */     GIR_EraseRootFromParent_Done,
     /*  45992 */   // Label 1005: @45992
     /*  45992 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(46046), // Rule ID 106 //
     /*  45997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  46005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46026 */     // (intrinsic_wo_chain:{ *:[i32] } 3739:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46044 */     GIR_RootConstrainSelectedInstOperands,
     /*  46045 */     // GIR_Coverage, 106,
     /*  46045 */     GIR_EraseRootFromParent_Done,
     /*  46046 */   // Label 1006: @46046
     /*  46046 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(46100), // Rule ID 107 //
     /*  46051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46080 */     // (intrinsic_wo_chain:{ *:[i32] } 3744:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46098 */     GIR_RootConstrainSelectedInstOperands,
     /*  46099 */     // GIR_Coverage, 107,
     /*  46099 */     GIR_EraseRootFromParent_Done,
     /*  46100 */   // Label 1007: @46100
     /*  46100 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(46154), // Rule ID 108 //
     /*  46105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46134 */     // (intrinsic_wo_chain:{ *:[i32] } 3745:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46152 */     GIR_RootConstrainSelectedInstOperands,
     /*  46153 */     // GIR_Coverage, 108,
     /*  46153 */     GIR_EraseRootFromParent_Done,
     /*  46154 */   // Label 1008: @46154
     /*  46154 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(46208), // Rule ID 111 //
     /*  46159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46188 */     // (intrinsic_wo_chain:{ *:[i32] } 3743:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46206 */     GIR_RootConstrainSelectedInstOperands,
     /*  46207 */     // GIR_Coverage, 111,
     /*  46207 */     GIR_EraseRootFromParent_Done,
     /*  46208 */   // Label 1009: @46208
     /*  46208 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(46262), // Rule ID 112 //
     /*  46213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46242 */     // (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46260 */     GIR_RootConstrainSelectedInstOperands,
     /*  46261 */     // GIR_Coverage, 112,
     /*  46261 */     GIR_EraseRootFromParent_Done,
     /*  46262 */   // Label 1010: @46262
     /*  46262 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(46316), // Rule ID 113 //
     /*  46267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46296 */     // (intrinsic_wo_chain:{ *:[i32] } 3807:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46314 */     GIR_RootConstrainSelectedInstOperands,
     /*  46315 */     // GIR_Coverage, 113,
     /*  46315 */     GIR_EraseRootFromParent_Done,
     /*  46316 */   // Label 1011: @46316
     /*  46316 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(46370), // Rule ID 114 //
     /*  46321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46350 */     // (intrinsic_wo_chain:{ *:[i32] } 3808:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46368 */     GIR_RootConstrainSelectedInstOperands,
     /*  46369 */     // GIR_Coverage, 114,
     /*  46369 */     GIR_EraseRootFromParent_Done,
     /*  46370 */   // Label 1012: @46370
     /*  46370 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(46424), // Rule ID 115 //
     /*  46375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46404 */     // (intrinsic_wo_chain:{ *:[i32] } 3811:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46422 */     GIR_RootConstrainSelectedInstOperands,
     /*  46423 */     // GIR_Coverage, 115,
     /*  46423 */     GIR_EraseRootFromParent_Done,
     /*  46424 */   // Label 1013: @46424
     /*  46424 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(46478), // Rule ID 116 //
     /*  46429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46458 */     // (intrinsic_wo_chain:{ *:[i32] } 3812:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46476 */     GIR_RootConstrainSelectedInstOperands,
     /*  46477 */     // GIR_Coverage, 116,
     /*  46477 */     GIR_EraseRootFromParent_Done,
     /*  46478 */   // Label 1014: @46478
     /*  46478 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46532), // Rule ID 117 //
     /*  46483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46512 */     // (intrinsic_wo_chain:{ *:[i32] } 3741:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46530 */     GIR_RootConstrainSelectedInstOperands,
     /*  46531 */     // GIR_Coverage, 117,
     /*  46531 */     GIR_EraseRootFromParent_Done,
     /*  46532 */   // Label 1015: @46532
     /*  46532 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46586), // Rule ID 118 //
     /*  46537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46566 */     // (intrinsic_wo_chain:{ *:[i32] } 3742:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46584 */     GIR_RootConstrainSelectedInstOperands,
     /*  46585 */     // GIR_Coverage, 118,
     /*  46585 */     GIR_EraseRootFromParent_Done,
     /*  46586 */   // Label 1016: @46586
     /*  46586 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46640), // Rule ID 119 //
     /*  46591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46620 */     // (intrinsic_wo_chain:{ *:[i32] } 3809:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46638 */     GIR_RootConstrainSelectedInstOperands,
     /*  46639 */     // GIR_Coverage, 119,
     /*  46639 */     GIR_EraseRootFromParent_Done,
     /*  46640 */   // Label 1017: @46640
     /*  46640 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46694), // Rule ID 120 //
     /*  46645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46674 */     // (intrinsic_wo_chain:{ *:[i32] } 3810:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46692 */     GIR_RootConstrainSelectedInstOperands,
     /*  46693 */     // GIR_Coverage, 120,
     /*  46693 */     GIR_EraseRootFromParent_Done,
     /*  46694 */   // Label 1018: @46694
     /*  46694 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46748), // Rule ID 133 //
     /*  46699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46728 */     // (intrinsic_wo_chain:{ *:[i32] } 3753:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46746 */     GIR_RootConstrainSelectedInstOperands,
     /*  46747 */     // GIR_Coverage, 133,
     /*  46747 */     GIR_EraseRootFromParent_Done,
     /*  46748 */   // Label 1019: @46748
     /*  46748 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46802), // Rule ID 134 //
     /*  46753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46782 */     // (intrinsic_wo_chain:{ *:[i32] } 3751:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46800 */     GIR_RootConstrainSelectedInstOperands,
     /*  46801 */     // GIR_Coverage, 134,
     /*  46801 */     GIR_EraseRootFromParent_Done,
     /*  46802 */   // Label 1020: @46802
     /*  46802 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46856), // Rule ID 135 //
     /*  46807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46836 */     // (intrinsic_wo_chain:{ *:[i32] } 3752:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46854 */     GIR_RootConstrainSelectedInstOperands,
     /*  46855 */     // GIR_Coverage, 135,
     /*  46855 */     GIR_EraseRootFromParent_Done,
     /*  46856 */   // Label 1021: @46856
     /*  46856 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46910), // Rule ID 136 //
     /*  46861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46890 */     // (intrinsic_wo_chain:{ *:[i32] } 3754:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46908 */     GIR_RootConstrainSelectedInstOperands,
     /*  46909 */     // GIR_Coverage, 136,
     /*  46909 */     GIR_EraseRootFromParent_Done,
     /*  46910 */   // Label 1022: @46910
     /*  46910 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46964), // Rule ID 137 //
     /*  46915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46944 */     // (intrinsic_wo_chain:{ *:[i32] } 3755:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46962 */     GIR_RootConstrainSelectedInstOperands,
     /*  46963 */     // GIR_Coverage, 137,
     /*  46963 */     GIR_EraseRootFromParent_Done,
     /*  46964 */   // Label 1023: @46964
     /*  46964 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(47018), // Rule ID 138 //
     /*  46969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46998 */     // (intrinsic_wo_chain:{ *:[i32] } 3756:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  47001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47016 */     GIR_RootConstrainSelectedInstOperands,
     /*  47017 */     // GIR_Coverage, 138,
     /*  47017 */     GIR_EraseRootFromParent_Done,
     /*  47018 */   // Label 1024: @47018
     /*  47018 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(47072), // Rule ID 139 //
     /*  47023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47052 */     // (intrinsic_wo_chain:{ *:[i32] } 3802:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47070 */     GIR_RootConstrainSelectedInstOperands,
     /*  47071 */     // GIR_Coverage, 139,
     /*  47071 */     GIR_EraseRootFromParent_Done,
     /*  47072 */   // Label 1025: @47072
     /*  47072 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(47126), // Rule ID 140 //
     /*  47077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47106 */     // (intrinsic_wo_chain:{ *:[i32] } 3800:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47124 */     GIR_RootConstrainSelectedInstOperands,
     /*  47125 */     // GIR_Coverage, 140,
     /*  47125 */     GIR_EraseRootFromParent_Done,
     /*  47126 */   // Label 1026: @47126
     /*  47126 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(47180), // Rule ID 141 //
     /*  47131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47160 */     // (intrinsic_wo_chain:{ *:[i32] } 3801:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47178 */     GIR_RootConstrainSelectedInstOperands,
     /*  47179 */     // GIR_Coverage, 141,
     /*  47179 */     GIR_EraseRootFromParent_Done,
     /*  47180 */   // Label 1027: @47180
     /*  47180 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(47234), // Rule ID 142 //
     /*  47185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47214 */     // (intrinsic_wo_chain:{ *:[i32] } 3803:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47232 */     GIR_RootConstrainSelectedInstOperands,
     /*  47233 */     // GIR_Coverage, 142,
     /*  47233 */     GIR_EraseRootFromParent_Done,
     /*  47234 */   // Label 1028: @47234
     /*  47234 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(47288), // Rule ID 143 //
     /*  47239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47268 */     // (intrinsic_wo_chain:{ *:[i32] } 3804:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47286 */     GIR_RootConstrainSelectedInstOperands,
     /*  47287 */     // GIR_Coverage, 143,
     /*  47287 */     GIR_EraseRootFromParent_Done,
     /*  47288 */   // Label 1029: @47288
     /*  47288 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(47342), // Rule ID 144 //
     /*  47293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47322 */     // (intrinsic_wo_chain:{ *:[i32] } 3805:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47340 */     GIR_RootConstrainSelectedInstOperands,
     /*  47341 */     // GIR_Coverage, 144,
     /*  47341 */     GIR_EraseRootFromParent_Done,
     /*  47342 */   // Label 1030: @47342
     /*  47342 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(47396), // Rule ID 145 //
     /*  47347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47376 */     // (intrinsic_wo_chain:{ *:[i32] } 3813:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47394 */     GIR_RootConstrainSelectedInstOperands,
     /*  47395 */     // GIR_Coverage, 145,
     /*  47395 */     GIR_EraseRootFromParent_Done,
     /*  47396 */   // Label 1031: @47396
     /*  47396 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(47441), // Rule ID 204 //
     /*  47401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47430 */     // (intrinsic_wo_chain:{ *:[i32] } 3372:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47439 */     GIR_RootConstrainSelectedInstOperands,
     /*  47440 */     // GIR_Coverage, 204,
     /*  47440 */     GIR_EraseRootFromParent_Done,
     /*  47441 */   // Label 1032: @47441
     /*  47441 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47486), // Rule ID 205 //
     /*  47446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47475 */     // (intrinsic_wo_chain:{ *:[i32] } 3373:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47484 */     GIR_RootConstrainSelectedInstOperands,
     /*  47485 */     // GIR_Coverage, 205,
     /*  47485 */     GIR_EraseRootFromParent_Done,
     /*  47486 */   // Label 1033: @47486
     /*  47486 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47531), // Rule ID 206 //
     /*  47491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47520 */     // (intrinsic_wo_chain:{ *:[i32] } 3376:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47529 */     GIR_RootConstrainSelectedInstOperands,
     /*  47530 */     // GIR_Coverage, 206,
     /*  47530 */     GIR_EraseRootFromParent_Done,
     /*  47531 */   // Label 1034: @47531
     /*  47531 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47576), // Rule ID 207 //
     /*  47536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47565 */     // (intrinsic_wo_chain:{ *:[i32] } 3374:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47574 */     GIR_RootConstrainSelectedInstOperands,
     /*  47575 */     // GIR_Coverage, 207,
     /*  47575 */     GIR_EraseRootFromParent_Done,
     /*  47576 */   // Label 1035: @47576
     /*  47576 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47621), // Rule ID 208 //
     /*  47581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47610 */     // (intrinsic_wo_chain:{ *:[i32] } 3377:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47619 */     GIR_RootConstrainSelectedInstOperands,
     /*  47620 */     // GIR_Coverage, 208,
     /*  47620 */     GIR_EraseRootFromParent_Done,
     /*  47621 */   // Label 1036: @47621
     /*  47621 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47666), // Rule ID 209 //
     /*  47626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47655 */     // (intrinsic_wo_chain:{ *:[i32] } 3375:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47664 */     GIR_RootConstrainSelectedInstOperands,
     /*  47665 */     // GIR_Coverage, 209,
     /*  47665 */     GIR_EraseRootFromParent_Done,
     /*  47666 */   // Label 1037: @47666
     /*  47666 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47720), // Rule ID 432 //
     /*  47671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47700 */     // (intrinsic_wo_chain:{ *:[i32] } 3739:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47718 */     GIR_RootConstrainSelectedInstOperands,
     /*  47719 */     // GIR_Coverage, 432,
     /*  47719 */     GIR_EraseRootFromParent_Done,
     /*  47720 */   // Label 1038: @47720
     /*  47720 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47774), // Rule ID 433 //
     /*  47725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47754 */     // (intrinsic_wo_chain:{ *:[i32] } 3740:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47772 */     GIR_RootConstrainSelectedInstOperands,
     /*  47773 */     // GIR_Coverage, 433,
     /*  47773 */     GIR_EraseRootFromParent_Done,
     /*  47774 */   // Label 1039: @47774
     /*  47774 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47828), // Rule ID 434 //
     /*  47779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47808 */     // (intrinsic_wo_chain:{ *:[i32] } 3741:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47826 */     GIR_RootConstrainSelectedInstOperands,
     /*  47827 */     // GIR_Coverage, 434,
     /*  47827 */     GIR_EraseRootFromParent_Done,
     /*  47828 */   // Label 1040: @47828
     /*  47828 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47882), // Rule ID 435 //
     /*  47833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47862 */     // (intrinsic_wo_chain:{ *:[i32] } 3812:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47880 */     GIR_RootConstrainSelectedInstOperands,
     /*  47881 */     // GIR_Coverage, 435,
     /*  47881 */     GIR_EraseRootFromParent_Done,
     /*  47882 */   // Label 1041: @47882
     /*  47882 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47936), // Rule ID 436 //
     /*  47887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47916 */     // (intrinsic_wo_chain:{ *:[i32] } 3742:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47934 */     GIR_RootConstrainSelectedInstOperands,
     /*  47935 */     // GIR_Coverage, 436,
     /*  47935 */     GIR_EraseRootFromParent_Done,
     /*  47936 */   // Label 1042: @47936
     /*  47936 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47990), // Rule ID 437 //
     /*  47941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47970 */     // (intrinsic_wo_chain:{ *:[i32] } 3744:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47988 */     GIR_RootConstrainSelectedInstOperands,
     /*  47989 */     // GIR_Coverage, 437,
     /*  47989 */     GIR_EraseRootFromParent_Done,
     /*  47990 */   // Label 1043: @47990
     /*  47990 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(48044), // Rule ID 438 //
     /*  47995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  48003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48024 */     // (intrinsic_wo_chain:{ *:[i32] } 3745:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  48027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48042 */     GIR_RootConstrainSelectedInstOperands,
     /*  48043 */     // GIR_Coverage, 438,
     /*  48043 */     GIR_EraseRootFromParent_Done,
     /*  48044 */   // Label 1044: @48044
     /*  48044 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(48098), // Rule ID 439 //
     /*  48049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48078 */     // (intrinsic_wo_chain:{ *:[i32] } 3807:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48096 */     GIR_RootConstrainSelectedInstOperands,
     /*  48097 */     // GIR_Coverage, 439,
     /*  48097 */     GIR_EraseRootFromParent_Done,
     /*  48098 */   // Label 1045: @48098
     /*  48098 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(48152), // Rule ID 440 //
     /*  48103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48132 */     // (intrinsic_wo_chain:{ *:[i32] } 3808:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48150 */     GIR_RootConstrainSelectedInstOperands,
     /*  48151 */     // GIR_Coverage, 440,
     /*  48151 */     GIR_EraseRootFromParent_Done,
     /*  48152 */   // Label 1046: @48152
     /*  48152 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(48206), // Rule ID 441 //
     /*  48157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48186 */     // (intrinsic_wo_chain:{ *:[i32] } 3809:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48204 */     GIR_RootConstrainSelectedInstOperands,
     /*  48205 */     // GIR_Coverage, 441,
     /*  48205 */     GIR_EraseRootFromParent_Done,
     /*  48206 */   // Label 1047: @48206
     /*  48206 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(48260), // Rule ID 442 //
     /*  48211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48240 */     // (intrinsic_wo_chain:{ *:[i32] } 3810:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48258 */     GIR_RootConstrainSelectedInstOperands,
     /*  48259 */     // GIR_Coverage, 442,
     /*  48259 */     GIR_EraseRootFromParent_Done,
     /*  48260 */   // Label 1048: @48260
     /*  48260 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(48314), // Rule ID 443 //
     /*  48265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48294 */     // (intrinsic_wo_chain:{ *:[i32] } 3811:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48312 */     GIR_RootConstrainSelectedInstOperands,
     /*  48313 */     // GIR_Coverage, 443,
     /*  48313 */     GIR_EraseRootFromParent_Done,
     /*  48314 */   // Label 1049: @48314
     /*  48314 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(48368), // Rule ID 456 //
     /*  48319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48348 */     // (intrinsic_wo_chain:{ *:[i32] } 3753:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48366 */     GIR_RootConstrainSelectedInstOperands,
     /*  48367 */     // GIR_Coverage, 456,
     /*  48367 */     GIR_EraseRootFromParent_Done,
     /*  48368 */   // Label 1050: @48368
     /*  48368 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(48422), // Rule ID 457 //
     /*  48373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48402 */     // (intrinsic_wo_chain:{ *:[i32] } 3751:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48420 */     GIR_RootConstrainSelectedInstOperands,
     /*  48421 */     // GIR_Coverage, 457,
     /*  48421 */     GIR_EraseRootFromParent_Done,
     /*  48422 */   // Label 1051: @48422
     /*  48422 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(48476), // Rule ID 458 //
     /*  48427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48456 */     // (intrinsic_wo_chain:{ *:[i32] } 3752:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48474 */     GIR_RootConstrainSelectedInstOperands,
     /*  48475 */     // GIR_Coverage, 458,
     /*  48475 */     GIR_EraseRootFromParent_Done,
     /*  48476 */   // Label 1052: @48476
     /*  48476 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48530), // Rule ID 459 //
     /*  48481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48510 */     // (intrinsic_wo_chain:{ *:[i32] } 3754:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48528 */     GIR_RootConstrainSelectedInstOperands,
     /*  48529 */     // GIR_Coverage, 459,
     /*  48529 */     GIR_EraseRootFromParent_Done,
     /*  48530 */   // Label 1053: @48530
     /*  48530 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48584), // Rule ID 460 //
     /*  48535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48564 */     // (intrinsic_wo_chain:{ *:[i32] } 3755:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48582 */     GIR_RootConstrainSelectedInstOperands,
     /*  48583 */     // GIR_Coverage, 460,
     /*  48583 */     GIR_EraseRootFromParent_Done,
     /*  48584 */   // Label 1054: @48584
     /*  48584 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48638), // Rule ID 461 //
     /*  48589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48618 */     // (intrinsic_wo_chain:{ *:[i32] } 3756:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48636 */     GIR_RootConstrainSelectedInstOperands,
     /*  48637 */     // GIR_Coverage, 461,
     /*  48637 */     GIR_EraseRootFromParent_Done,
     /*  48638 */   // Label 1055: @48638
     /*  48638 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48692), // Rule ID 462 //
     /*  48643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48672 */     // (intrinsic_wo_chain:{ *:[i32] } 3802:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48690 */     GIR_RootConstrainSelectedInstOperands,
     /*  48691 */     // GIR_Coverage, 462,
     /*  48691 */     GIR_EraseRootFromParent_Done,
     /*  48692 */   // Label 1056: @48692
     /*  48692 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48746), // Rule ID 463 //
     /*  48697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48726 */     // (intrinsic_wo_chain:{ *:[i32] } 3800:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48744 */     GIR_RootConstrainSelectedInstOperands,
     /*  48745 */     // GIR_Coverage, 463,
     /*  48745 */     GIR_EraseRootFromParent_Done,
     /*  48746 */   // Label 1057: @48746
     /*  48746 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48800), // Rule ID 464 //
     /*  48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48780 */     // (intrinsic_wo_chain:{ *:[i32] } 3801:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48798 */     GIR_RootConstrainSelectedInstOperands,
     /*  48799 */     // GIR_Coverage, 464,
     /*  48799 */     GIR_EraseRootFromParent_Done,
     /*  48800 */   // Label 1058: @48800
     /*  48800 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48854), // Rule ID 465 //
     /*  48805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48834 */     // (intrinsic_wo_chain:{ *:[i32] } 3803:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48852 */     GIR_RootConstrainSelectedInstOperands,
     /*  48853 */     // GIR_Coverage, 465,
     /*  48853 */     GIR_EraseRootFromParent_Done,
     /*  48854 */   // Label 1059: @48854
     /*  48854 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48908), // Rule ID 466 //
     /*  48859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48888 */     // (intrinsic_wo_chain:{ *:[i32] } 3804:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48906 */     GIR_RootConstrainSelectedInstOperands,
     /*  48907 */     // GIR_Coverage, 466,
     /*  48907 */     GIR_EraseRootFromParent_Done,
     /*  48908 */   // Label 1060: @48908
     /*  48908 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48962), // Rule ID 467 //
     /*  48913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48942 */     // (intrinsic_wo_chain:{ *:[i32] } 3805:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48960 */     GIR_RootConstrainSelectedInstOperands,
     /*  48961 */     // GIR_Coverage, 467,
     /*  48961 */     GIR_EraseRootFromParent_Done,
     /*  48962 */   // Label 1061: @48962
     /*  48962 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(49016), // Rule ID 468 //
     /*  48967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48996 */     // (intrinsic_wo_chain:{ *:[i32] } 3813:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  48999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49014 */     GIR_RootConstrainSelectedInstOperands,
     /*  49015 */     // GIR_Coverage, 468,
     /*  49015 */     GIR_EraseRootFromParent_Done,
     /*  49016 */   // Label 1062: @49016
     /*  49016 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(49070), // Rule ID 524 //
     /*  49021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49050 */     // (intrinsic_wo_chain:{ *:[i32] } 3771:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49068 */     GIR_RootConstrainSelectedInstOperands,
     /*  49069 */     // GIR_Coverage, 524,
     /*  49069 */     GIR_EraseRootFromParent_Done,
     /*  49070 */   // Label 1063: @49070
     /*  49070 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(49124), // Rule ID 525 //
     /*  49075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49104 */     // (intrinsic_wo_chain:{ *:[i32] } 3772:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49122 */     GIR_RootConstrainSelectedInstOperands,
     /*  49123 */     // GIR_Coverage, 525,
     /*  49123 */     GIR_EraseRootFromParent_Done,
     /*  49124 */   // Label 1064: @49124
     /*  49124 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(49178), // Rule ID 526 //
     /*  49129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49158 */     // (intrinsic_wo_chain:{ *:[i32] } 3779:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49176 */     GIR_RootConstrainSelectedInstOperands,
     /*  49177 */     // GIR_Coverage, 526,
     /*  49177 */     GIR_EraseRootFromParent_Done,
     /*  49178 */   // Label 1065: @49178
     /*  49178 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(49232), // Rule ID 527 //
     /*  49183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49212 */     // (intrinsic_wo_chain:{ *:[i32] } 3780:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49230 */     GIR_RootConstrainSelectedInstOperands,
     /*  49231 */     // GIR_Coverage, 527,
     /*  49231 */     GIR_EraseRootFromParent_Done,
     /*  49232 */   // Label 1066: @49232
     /*  49232 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(49277), // Rule ID 541 //
     /*  49237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49266 */     // (intrinsic_wo_chain:{ *:[i32] } 3372:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49275 */     GIR_RootConstrainSelectedInstOperands,
     /*  49276 */     // GIR_Coverage, 541,
     /*  49276 */     GIR_EraseRootFromParent_Done,
     /*  49277 */   // Label 1067: @49277
     /*  49277 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(49322), // Rule ID 542 //
     /*  49282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49311 */     // (intrinsic_wo_chain:{ *:[i32] } 3373:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49320 */     GIR_RootConstrainSelectedInstOperands,
     /*  49321 */     // GIR_Coverage, 542,
     /*  49321 */     GIR_EraseRootFromParent_Done,
     /*  49322 */   // Label 1068: @49322
     /*  49322 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(49367), // Rule ID 543 //
     /*  49327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49356 */     // (intrinsic_wo_chain:{ *:[i32] } 3376:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49365 */     GIR_RootConstrainSelectedInstOperands,
     /*  49366 */     // GIR_Coverage, 543,
     /*  49366 */     GIR_EraseRootFromParent_Done,
     /*  49367 */   // Label 1069: @49367
     /*  49367 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(49412), // Rule ID 544 //
     /*  49372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49401 */     // (intrinsic_wo_chain:{ *:[i32] } 3374:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49410 */     GIR_RootConstrainSelectedInstOperands,
     /*  49411 */     // GIR_Coverage, 544,
     /*  49411 */     GIR_EraseRootFromParent_Done,
     /*  49412 */   // Label 1070: @49412
     /*  49412 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49457), // Rule ID 545 //
     /*  49417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49446 */     // (intrinsic_wo_chain:{ *:[i32] } 3377:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49455 */     GIR_RootConstrainSelectedInstOperands,
     /*  49456 */     // GIR_Coverage, 545,
     /*  49456 */     GIR_EraseRootFromParent_Done,
     /*  49457 */   // Label 1071: @49457
     /*  49457 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49502), // Rule ID 546 //
     /*  49462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49491 */     // (intrinsic_wo_chain:{ *:[i32] } 3375:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49500 */     GIR_RootConstrainSelectedInstOperands,
     /*  49501 */     // GIR_Coverage, 546,
     /*  49501 */     GIR_EraseRootFromParent_Done,
     /*  49502 */   // Label 1072: @49502
     /*  49502 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49556), // Rule ID 789 //
     /*  49507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3643:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49554 */     GIR_RootConstrainSelectedInstOperands,
     /*  49555 */     // GIR_Coverage, 789,
     /*  49555 */     GIR_EraseRootFromParent_Done,
     /*  49556 */   // Label 1073: @49556
     /*  49556 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49610), // Rule ID 790 //
     /*  49561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49590 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3643:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49608 */     GIR_RootConstrainSelectedInstOperands,
     /*  49609 */     // GIR_Coverage, 790,
     /*  49609 */     GIR_EraseRootFromParent_Done,
     /*  49610 */   // Label 1074: @49610
     /*  49610 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49664), // Rule ID 791 //
     /*  49615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49644 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3643:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49662 */     GIR_RootConstrainSelectedInstOperands,
     /*  49663 */     // GIR_Coverage, 791,
     /*  49663 */     GIR_EraseRootFromParent_Done,
     /*  49664 */   // Label 1075: @49664
     /*  49664 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49718), // Rule ID 792 //
     /*  49669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3643:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49716 */     GIR_RootConstrainSelectedInstOperands,
     /*  49717 */     // GIR_Coverage, 792,
     /*  49717 */     GIR_EraseRootFromParent_Done,
     /*  49718 */   // Label 1076: @49718
     /*  49718 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49772), // Rule ID 793 //
     /*  49723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49752 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3643:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49770 */     GIR_RootConstrainSelectedInstOperands,
     /*  49771 */     // GIR_Coverage, 793,
     /*  49771 */     GIR_EraseRootFromParent_Done,
     /*  49772 */   // Label 1077: @49772
     /*  49772 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49826), // Rule ID 794 //
     /*  49777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3643:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49824 */     GIR_RootConstrainSelectedInstOperands,
     /*  49825 */     // GIR_Coverage, 794,
     /*  49825 */     GIR_EraseRootFromParent_Done,
     /*  49826 */   // Label 1078: @49826
     /*  49826 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49880), // Rule ID 795 //
     /*  49831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49860 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3644:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49878 */     GIR_RootConstrainSelectedInstOperands,
     /*  49879 */     // GIR_Coverage, 795,
     /*  49879 */     GIR_EraseRootFromParent_Done,
     /*  49880 */   // Label 1079: @49880
     /*  49880 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49934), // Rule ID 796 //
     /*  49885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49914 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3644:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49932 */     GIR_RootConstrainSelectedInstOperands,
     /*  49933 */     // GIR_Coverage, 796,
     /*  49933 */     GIR_EraseRootFromParent_Done,
     /*  49934 */   // Label 1080: @49934
     /*  49934 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49988), // Rule ID 797 //
     /*  49939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49968 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3644:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49986 */     GIR_RootConstrainSelectedInstOperands,
     /*  49987 */     // GIR_Coverage, 797,
     /*  49987 */     GIR_EraseRootFromParent_Done,
     /*  49988 */   // Label 1081: @49988
     /*  49988 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(50042), // Rule ID 798 //
     /*  49993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50022 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3644:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  50025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50040 */     GIR_RootConstrainSelectedInstOperands,
     /*  50041 */     // GIR_Coverage, 798,
     /*  50041 */     GIR_EraseRootFromParent_Done,
     /*  50042 */   // Label 1082: @50042
     /*  50042 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(50096), // Rule ID 799 //
     /*  50047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50076 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3644:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50094 */     GIR_RootConstrainSelectedInstOperands,
     /*  50095 */     // GIR_Coverage, 799,
     /*  50095 */     GIR_EraseRootFromParent_Done,
     /*  50096 */   // Label 1083: @50096
     /*  50096 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(50150), // Rule ID 800 //
     /*  50101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50130 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3644:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50148 */     GIR_RootConstrainSelectedInstOperands,
     /*  50149 */     // GIR_Coverage, 800,
     /*  50149 */     GIR_EraseRootFromParent_Done,
     /*  50150 */   // Label 1084: @50150
     /*  50150 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(50204), // Rule ID 801 //
     /*  50155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50184 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3703:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50202 */     GIR_RootConstrainSelectedInstOperands,
     /*  50203 */     // GIR_Coverage, 801,
     /*  50203 */     GIR_EraseRootFromParent_Done,
     /*  50204 */   // Label 1085: @50204
     /*  50204 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(50258), // Rule ID 802 //
     /*  50209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50238 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3703:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50256 */     GIR_RootConstrainSelectedInstOperands,
     /*  50257 */     // GIR_Coverage, 802,
     /*  50257 */     GIR_EraseRootFromParent_Done,
     /*  50258 */   // Label 1086: @50258
     /*  50258 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(50312), // Rule ID 803 //
     /*  50263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50292 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50310 */     GIR_RootConstrainSelectedInstOperands,
     /*  50311 */     // GIR_Coverage, 803,
     /*  50311 */     GIR_EraseRootFromParent_Done,
     /*  50312 */   // Label 1087: @50312
     /*  50312 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(50366), // Rule ID 804 //
     /*  50317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3703:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50364 */     GIR_RootConstrainSelectedInstOperands,
     /*  50365 */     // GIR_Coverage, 804,
     /*  50365 */     GIR_EraseRootFromParent_Done,
     /*  50366 */   // Label 1088: @50366
     /*  50366 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(50420), // Rule ID 805 //
     /*  50371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50400 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3703:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50418 */     GIR_RootConstrainSelectedInstOperands,
     /*  50419 */     // GIR_Coverage, 805,
     /*  50419 */     GIR_EraseRootFromParent_Done,
     /*  50420 */   // Label 1089: @50420
     /*  50420 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(50474), // Rule ID 806 //
     /*  50425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50454 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50472 */     GIR_RootConstrainSelectedInstOperands,
     /*  50473 */     // GIR_Coverage, 806,
     /*  50473 */     GIR_EraseRootFromParent_Done,
     /*  50474 */   // Label 1090: @50474
     /*  50474 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50528), // Rule ID 807 //
     /*  50479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50508 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3704:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50526 */     GIR_RootConstrainSelectedInstOperands,
     /*  50527 */     // GIR_Coverage, 807,
     /*  50527 */     GIR_EraseRootFromParent_Done,
     /*  50528 */   // Label 1091: @50528
     /*  50528 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50582), // Rule ID 808 //
     /*  50533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50562 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3704:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50580 */     GIR_RootConstrainSelectedInstOperands,
     /*  50581 */     // GIR_Coverage, 808,
     /*  50581 */     GIR_EraseRootFromParent_Done,
     /*  50582 */   // Label 1092: @50582
     /*  50582 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50636), // Rule ID 809 //
     /*  50587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50616 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50634 */     GIR_RootConstrainSelectedInstOperands,
     /*  50635 */     // GIR_Coverage, 809,
     /*  50635 */     GIR_EraseRootFromParent_Done,
     /*  50636 */   // Label 1093: @50636
     /*  50636 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50690), // Rule ID 810 //
     /*  50641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50688 */     GIR_RootConstrainSelectedInstOperands,
     /*  50689 */     // GIR_Coverage, 810,
     /*  50689 */     GIR_EraseRootFromParent_Done,
     /*  50690 */   // Label 1094: @50690
     /*  50690 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50744), // Rule ID 811 //
     /*  50695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50724 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3704:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50742 */     GIR_RootConstrainSelectedInstOperands,
     /*  50743 */     // GIR_Coverage, 811,
     /*  50743 */     GIR_EraseRootFromParent_Done,
     /*  50744 */   // Label 1095: @50744
     /*  50744 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50798), // Rule ID 812 //
     /*  50749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50778 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50796 */     GIR_RootConstrainSelectedInstOperands,
     /*  50797 */     // GIR_Coverage, 812,
     /*  50797 */     GIR_EraseRootFromParent_Done,
     /*  50798 */   // Label 1096: @50798
     /*  50798 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50852), // Rule ID 829 //
     /*  50803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50832 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3700:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50850 */     GIR_RootConstrainSelectedInstOperands,
     /*  50851 */     // GIR_Coverage, 829,
     /*  50851 */     GIR_EraseRootFromParent_Done,
     /*  50852 */   // Label 1097: @50852
     /*  50852 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50906), // Rule ID 830 //
     /*  50857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50886 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3700:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50904 */     GIR_RootConstrainSelectedInstOperands,
     /*  50905 */     // GIR_Coverage, 830,
     /*  50905 */     GIR_EraseRootFromParent_Done,
     /*  50906 */   // Label 1098: @50906
     /*  50906 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50960), // Rule ID 831 //
     /*  50911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50940 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3700:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50958 */     GIR_RootConstrainSelectedInstOperands,
     /*  50959 */     // GIR_Coverage, 831,
     /*  50959 */     GIR_EraseRootFromParent_Done,
     /*  50960 */   // Label 1099: @50960
     /*  50960 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(51014), // Rule ID 838 //
     /*  50965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50994 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3669:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  50997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51012 */     GIR_RootConstrainSelectedInstOperands,
     /*  51013 */     // GIR_Coverage, 838,
     /*  51013 */     GIR_EraseRootFromParent_Done,
     /*  51014 */   // Label 1100: @51014
     /*  51014 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(51068), // Rule ID 839 //
     /*  51019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51066 */     GIR_RootConstrainSelectedInstOperands,
     /*  51067 */     // GIR_Coverage, 839,
     /*  51067 */     GIR_EraseRootFromParent_Done,
     /*  51068 */   // Label 1101: @51068
     /*  51068 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(51122), // Rule ID 852 //
     /*  51073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51102 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3680:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51120 */     GIR_RootConstrainSelectedInstOperands,
     /*  51121 */     // GIR_Coverage, 852,
     /*  51121 */     GIR_EraseRootFromParent_Done,
     /*  51122 */   // Label 1102: @51122
     /*  51122 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(51176), // Rule ID 853 //
     /*  51127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51156 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3680:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51174 */     GIR_RootConstrainSelectedInstOperands,
     /*  51175 */     // GIR_Coverage, 853,
     /*  51175 */     GIR_EraseRootFromParent_Done,
     /*  51176 */   // Label 1103: @51176
     /*  51176 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(51230), // Rule ID 854 //
     /*  51181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51210 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51228 */     GIR_RootConstrainSelectedInstOperands,
     /*  51229 */     // GIR_Coverage, 854,
     /*  51229 */     GIR_EraseRootFromParent_Done,
     /*  51230 */   // Label 1104: @51230
     /*  51230 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(51284), // Rule ID 855 //
     /*  51235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51282 */     GIR_RootConstrainSelectedInstOperands,
     /*  51283 */     // GIR_Coverage, 855,
     /*  51283 */     GIR_EraseRootFromParent_Done,
     /*  51284 */   // Label 1105: @51284
     /*  51284 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(51338), // Rule ID 860 //
     /*  51289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51318 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3688:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51336 */     GIR_RootConstrainSelectedInstOperands,
     /*  51337 */     // GIR_Coverage, 860,
     /*  51337 */     GIR_EraseRootFromParent_Done,
     /*  51338 */   // Label 1106: @51338
     /*  51338 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(51392), // Rule ID 861 //
     /*  51343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51372 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3688:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51390 */     GIR_RootConstrainSelectedInstOperands,
     /*  51391 */     // GIR_Coverage, 861,
     /*  51391 */     GIR_EraseRootFromParent_Done,
     /*  51392 */   // Label 1107: @51392
     /*  51392 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(51446), // Rule ID 862 //
     /*  51397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51426 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3688:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51444 */     GIR_RootConstrainSelectedInstOperands,
     /*  51445 */     // GIR_Coverage, 862,
     /*  51445 */     GIR_EraseRootFromParent_Done,
     /*  51446 */   // Label 1108: @51446
     /*  51446 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51500), // Rule ID 863 //
     /*  51451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51480 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3688:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51498 */     GIR_RootConstrainSelectedInstOperands,
     /*  51499 */     // GIR_Coverage, 863,
     /*  51499 */     GIR_EraseRootFromParent_Done,
     /*  51500 */   // Label 1109: @51500
     /*  51500 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51554), // Rule ID 874 //
     /*  51505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51534 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51552 */     GIR_RootConstrainSelectedInstOperands,
     /*  51553 */     // GIR_Coverage, 874,
     /*  51553 */     GIR_EraseRootFromParent_Done,
     /*  51554 */   // Label 1110: @51554
     /*  51554 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51599), // Rule ID 875 //
     /*  51559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51588 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51597 */     GIR_RootConstrainSelectedInstOperands,
     /*  51598 */     // GIR_Coverage, 875,
     /*  51598 */     GIR_EraseRootFromParent_Done,
     /*  51599 */   // Label 1111: @51599
     /*  51599 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51653), // Rule ID 880 //
     /*  51604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51651 */     GIR_RootConstrainSelectedInstOperands,
     /*  51652 */     // GIR_Coverage, 880,
     /*  51652 */     GIR_EraseRootFromParent_Done,
     /*  51653 */   // Label 1112: @51653
     /*  51653 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51707), // Rule ID 881 //
     /*  51658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51687 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3681:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51705 */     GIR_RootConstrainSelectedInstOperands,
     /*  51706 */     // GIR_Coverage, 881,
     /*  51706 */     GIR_EraseRootFromParent_Done,
     /*  51707 */   // Label 1113: @51707
     /*  51707 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51761), // Rule ID 993 //
     /*  51712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51741 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3645:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51759 */     GIR_RootConstrainSelectedInstOperands,
     /*  51760 */     // GIR_Coverage, 993,
     /*  51760 */     GIR_EraseRootFromParent_Done,
     /*  51761 */   // Label 1114: @51761
     /*  51761 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51815), // Rule ID 994 //
     /*  51766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51795 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3645:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51813 */     GIR_RootConstrainSelectedInstOperands,
     /*  51814 */     // GIR_Coverage, 994,
     /*  51814 */     GIR_EraseRootFromParent_Done,
     /*  51815 */   // Label 1115: @51815
     /*  51815 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51869), // Rule ID 995 //
     /*  51820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51849 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51867 */     GIR_RootConstrainSelectedInstOperands,
     /*  51868 */     // GIR_Coverage, 995,
     /*  51868 */     GIR_EraseRootFromParent_Done,
     /*  51869 */   // Label 1116: @51869
     /*  51869 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51923), // Rule ID 996 //
     /*  51874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51903 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51921 */     GIR_RootConstrainSelectedInstOperands,
     /*  51922 */     // GIR_Coverage, 996,
     /*  51922 */     GIR_EraseRootFromParent_Done,
     /*  51923 */   // Label 1117: @51923
     /*  51923 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51977), // Rule ID 997 //
     /*  51928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51957 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3645:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51975 */     GIR_RootConstrainSelectedInstOperands,
     /*  51976 */     // GIR_Coverage, 997,
     /*  51976 */     GIR_EraseRootFromParent_Done,
     /*  51977 */   // Label 1118: @51977
     /*  51977 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(52031), // Rule ID 998 //
     /*  51982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52011 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3645:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  52014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52029 */     GIR_RootConstrainSelectedInstOperands,
     /*  52030 */     // GIR_Coverage, 998,
     /*  52030 */     GIR_EraseRootFromParent_Done,
     /*  52031 */   // Label 1119: @52031
     /*  52031 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(52085), // Rule ID 999 //
     /*  52036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52065 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3646:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52083 */     GIR_RootConstrainSelectedInstOperands,
     /*  52084 */     // GIR_Coverage, 999,
     /*  52084 */     GIR_EraseRootFromParent_Done,
     /*  52085 */   // Label 1120: @52085
     /*  52085 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(52139), // Rule ID 1000 //
     /*  52090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52119 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3646:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52137 */     GIR_RootConstrainSelectedInstOperands,
     /*  52138 */     // GIR_Coverage, 1000,
     /*  52138 */     GIR_EraseRootFromParent_Done,
     /*  52139 */   // Label 1121: @52139
     /*  52139 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(52193), // Rule ID 1001 //
     /*  52144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52173 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3646:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52191 */     GIR_RootConstrainSelectedInstOperands,
     /*  52192 */     // GIR_Coverage, 1001,
     /*  52192 */     GIR_EraseRootFromParent_Done,
     /*  52193 */   // Label 1122: @52193
     /*  52193 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(52247), // Rule ID 1002 //
     /*  52198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3646:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52245 */     GIR_RootConstrainSelectedInstOperands,
     /*  52246 */     // GIR_Coverage, 1002,
     /*  52246 */     GIR_EraseRootFromParent_Done,
     /*  52247 */   // Label 1123: @52247
     /*  52247 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(52301), // Rule ID 1003 //
     /*  52252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52281 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3646:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52299 */     GIR_RootConstrainSelectedInstOperands,
     /*  52300 */     // GIR_Coverage, 1003,
     /*  52300 */     GIR_EraseRootFromParent_Done,
     /*  52301 */   // Label 1124: @52301
     /*  52301 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(52355), // Rule ID 1004 //
     /*  52306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52335 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3646:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52353 */     GIR_RootConstrainSelectedInstOperands,
     /*  52354 */     // GIR_Coverage, 1004,
     /*  52354 */     GIR_EraseRootFromParent_Done,
     /*  52355 */   // Label 1125: @52355
     /*  52355 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(52409), // Rule ID 1021 //
     /*  52360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52389 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3716:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52407 */     GIR_RootConstrainSelectedInstOperands,
     /*  52408 */     // GIR_Coverage, 1021,
     /*  52408 */     GIR_EraseRootFromParent_Done,
     /*  52409 */   // Label 1126: @52409
     /*  52409 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(52463), // Rule ID 1022 //
     /*  52414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52443 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3716:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52461 */     GIR_RootConstrainSelectedInstOperands,
     /*  52462 */     // GIR_Coverage, 1022,
     /*  52462 */     GIR_EraseRootFromParent_Done,
     /*  52463 */   // Label 1127: @52463
     /*  52463 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52517), // Rule ID 1023 //
     /*  52468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52497 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3716:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52515 */     GIR_RootConstrainSelectedInstOperands,
     /*  52516 */     // GIR_Coverage, 1023,
     /*  52516 */     GIR_EraseRootFromParent_Done,
     /*  52517 */   // Label 1128: @52517
     /*  52517 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52571), // Rule ID 1116 //
     /*  52522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52551 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3621:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52569 */     GIR_RootConstrainSelectedInstOperands,
     /*  52570 */     // GIR_Coverage, 1116,
     /*  52570 */     GIR_EraseRootFromParent_Done,
     /*  52571 */   // Label 1129: @52571
     /*  52571 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52625), // Rule ID 1117 //
     /*  52576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52605 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3621:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52623 */     GIR_RootConstrainSelectedInstOperands,
     /*  52624 */     // GIR_Coverage, 1117,
     /*  52624 */     GIR_EraseRootFromParent_Done,
     /*  52625 */   // Label 1130: @52625
     /*  52625 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52679), // Rule ID 1118 //
     /*  52630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52659 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3621:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52677 */     GIR_RootConstrainSelectedInstOperands,
     /*  52678 */     // GIR_Coverage, 1118,
     /*  52678 */     GIR_EraseRootFromParent_Done,
     /*  52679 */   // Label 1131: @52679
     /*  52679 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52733), // Rule ID 1119 //
     /*  52684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52713 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3621:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52731 */     GIR_RootConstrainSelectedInstOperands,
     /*  52732 */     // GIR_Coverage, 1119,
     /*  52732 */     GIR_EraseRootFromParent_Done,
     /*  52733 */   // Label 1132: @52733
     /*  52733 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52787), // Rule ID 1120 //
     /*  52738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52767 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3622:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52785 */     GIR_RootConstrainSelectedInstOperands,
     /*  52786 */     // GIR_Coverage, 1120,
     /*  52786 */     GIR_EraseRootFromParent_Done,
     /*  52787 */   // Label 1133: @52787
     /*  52787 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52841), // Rule ID 1121 //
     /*  52792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52821 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3622:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52839 */     GIR_RootConstrainSelectedInstOperands,
     /*  52840 */     // GIR_Coverage, 1121,
     /*  52840 */     GIR_EraseRootFromParent_Done,
     /*  52841 */   // Label 1134: @52841
     /*  52841 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52895), // Rule ID 1122 //
     /*  52846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52875 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3622:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52893 */     GIR_RootConstrainSelectedInstOperands,
     /*  52894 */     // GIR_Coverage, 1122,
     /*  52894 */     GIR_EraseRootFromParent_Done,
     /*  52895 */   // Label 1135: @52895
     /*  52895 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52949), // Rule ID 1123 //
     /*  52900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52929 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3622:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52947 */     GIR_RootConstrainSelectedInstOperands,
     /*  52948 */     // GIR_Coverage, 1123,
     /*  52948 */     GIR_EraseRootFromParent_Done,
     /*  52949 */   // Label 1136: @52949
     /*  52949 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(53003), // Rule ID 1166 //
     /*  52954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52983 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3618:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53001 */     GIR_RootConstrainSelectedInstOperands,
     /*  53002 */     // GIR_Coverage, 1166,
     /*  53002 */     GIR_EraseRootFromParent_Done,
     /*  53003 */   // Label 1137: @53003
     /*  53003 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(53057), // Rule ID 1167 //
     /*  53008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53037 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3618:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53055 */     GIR_RootConstrainSelectedInstOperands,
     /*  53056 */     // GIR_Coverage, 1167,
     /*  53056 */     GIR_EraseRootFromParent_Done,
     /*  53057 */   // Label 1138: @53057
     /*  53057 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(53111), // Rule ID 1168 //
     /*  53062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53091 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3618:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53109 */     GIR_RootConstrainSelectedInstOperands,
     /*  53110 */     // GIR_Coverage, 1168,
     /*  53110 */     GIR_EraseRootFromParent_Done,
     /*  53111 */   // Label 1139: @53111
     /*  53111 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(53165), // Rule ID 1169 //
     /*  53116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53145 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3618:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53163 */     GIR_RootConstrainSelectedInstOperands,
     /*  53164 */     // GIR_Coverage, 1169,
     /*  53164 */     GIR_EraseRootFromParent_Done,
     /*  53165 */   // Label 1140: @53165
     /*  53165 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(53219), // Rule ID 1234 //
     /*  53170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53199 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3672:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53217 */     GIR_RootConstrainSelectedInstOperands,
     /*  53218 */     // GIR_Coverage, 1234,
     /*  53218 */     GIR_EraseRootFromParent_Done,
     /*  53219 */   // Label 1141: @53219
     /*  53219 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(53273), // Rule ID 1235 //
     /*  53224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53253 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3672:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53271 */     GIR_RootConstrainSelectedInstOperands,
     /*  53272 */     // GIR_Coverage, 1235,
     /*  53272 */     GIR_EraseRootFromParent_Done,
     /*  53273 */   // Label 1142: @53273
     /*  53273 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(53327), // Rule ID 1236 //
     /*  53278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53307 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3672:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53325 */     GIR_RootConstrainSelectedInstOperands,
     /*  53326 */     // GIR_Coverage, 1236,
     /*  53326 */     GIR_EraseRootFromParent_Done,
     /*  53327 */   // Label 1143: @53327
     /*  53327 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(53381), // Rule ID 1237 //
     /*  53332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53361 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3672:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53379 */     GIR_RootConstrainSelectedInstOperands,
     /*  53380 */     // GIR_Coverage, 1237,
     /*  53380 */     GIR_EraseRootFromParent_Done,
     /*  53381 */   // Label 1144: @53381
     /*  53381 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(53435), // Rule ID 1238 //
     /*  53386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53415 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3672:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53433 */     GIR_RootConstrainSelectedInstOperands,
     /*  53434 */     // GIR_Coverage, 1238,
     /*  53434 */     GIR_EraseRootFromParent_Done,
     /*  53435 */   // Label 1145: @53435
     /*  53435 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(53489), // Rule ID 1251 //
     /*  53440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53469 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3670:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53487 */     GIR_RootConstrainSelectedInstOperands,
     /*  53488 */     // GIR_Coverage, 1251,
     /*  53488 */     GIR_EraseRootFromParent_Done,
     /*  53489 */   // Label 1146: @53489
     /*  53489 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53543), // Rule ID 1252 //
     /*  53494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53523 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3670:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53541 */     GIR_RootConstrainSelectedInstOperands,
     /*  53542 */     // GIR_Coverage, 1252,
     /*  53542 */     GIR_EraseRootFromParent_Done,
     /*  53543 */   // Label 1147: @53543
     /*  53543 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53597), // Rule ID 1253 //
     /*  53548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53577 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3670:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53595 */     GIR_RootConstrainSelectedInstOperands,
     /*  53596 */     // GIR_Coverage, 1253,
     /*  53596 */     GIR_EraseRootFromParent_Done,
     /*  53597 */   // Label 1148: @53597
     /*  53597 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53651), // Rule ID 1254 //
     /*  53602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53631 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3670:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53649 */     GIR_RootConstrainSelectedInstOperands,
     /*  53650 */     // GIR_Coverage, 1254,
     /*  53650 */     GIR_EraseRootFromParent_Done,
     /*  53651 */   // Label 1149: @53651
     /*  53651 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53705), // Rule ID 1255 //
     /*  53656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53685 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3670:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53690 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53703 */     GIR_RootConstrainSelectedInstOperands,
     /*  53704 */     // GIR_Coverage, 1255,
     /*  53704 */     GIR_EraseRootFromParent_Done,
     /*  53705 */   // Label 1150: @53705
     /*  53705 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53759), // Rule ID 1256 //
     /*  53710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53739 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3670:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53757 */     GIR_RootConstrainSelectedInstOperands,
     /*  53758 */     // GIR_Coverage, 1256,
     /*  53758 */     GIR_EraseRootFromParent_Done,
     /*  53759 */   // Label 1151: @53759
     /*  53759 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53813), // Rule ID 1257 //
     /*  53764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53793 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3671:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53811 */     GIR_RootConstrainSelectedInstOperands,
     /*  53812 */     // GIR_Coverage, 1257,
     /*  53812 */     GIR_EraseRootFromParent_Done,
     /*  53813 */   // Label 1152: @53813
     /*  53813 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53867), // Rule ID 1258 //
     /*  53818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53847 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3671:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53865 */     GIR_RootConstrainSelectedInstOperands,
     /*  53866 */     // GIR_Coverage, 1258,
     /*  53866 */     GIR_EraseRootFromParent_Done,
     /*  53867 */   // Label 1153: @53867
     /*  53867 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53921), // Rule ID 1259 //
     /*  53872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53901 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3671:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53919 */     GIR_RootConstrainSelectedInstOperands,
     /*  53920 */     // GIR_Coverage, 1259,
     /*  53920 */     GIR_EraseRootFromParent_Done,
     /*  53921 */   // Label 1154: @53921
     /*  53921 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53975), // Rule ID 1260 //
     /*  53926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53955 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53973 */     GIR_RootConstrainSelectedInstOperands,
     /*  53974 */     // GIR_Coverage, 1260,
     /*  53974 */     GIR_EraseRootFromParent_Done,
     /*  53975 */   // Label 1155: @53975
     /*  53975 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(54029), // Rule ID 1261 //
     /*  53980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  54009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  54012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54027 */     GIR_RootConstrainSelectedInstOperands,
     /*  54028 */     // GIR_Coverage, 1261,
     /*  54028 */     GIR_EraseRootFromParent_Done,
     /*  54029 */   // Label 1156: @54029
     /*  54029 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(54083), // Rule ID 1262 //
     /*  54034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54063 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3671:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54081 */     GIR_RootConstrainSelectedInstOperands,
     /*  54082 */     // GIR_Coverage, 1262,
     /*  54082 */     GIR_EraseRootFromParent_Done,
     /*  54083 */   // Label 1157: @54083
     /*  54083 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(54137), // Rule ID 1263 //
     /*  54088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54117 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3675:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54135 */     GIR_RootConstrainSelectedInstOperands,
     /*  54136 */     // GIR_Coverage, 1263,
     /*  54136 */     GIR_EraseRootFromParent_Done,
     /*  54137 */   // Label 1158: @54137
     /*  54137 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(54191), // Rule ID 1264 //
     /*  54142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54171 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3675:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54189 */     GIR_RootConstrainSelectedInstOperands,
     /*  54190 */     // GIR_Coverage, 1264,
     /*  54190 */     GIR_EraseRootFromParent_Done,
     /*  54191 */   // Label 1159: @54191
     /*  54191 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(54245), // Rule ID 1265 //
     /*  54196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54225 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3675:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54243 */     GIR_RootConstrainSelectedInstOperands,
     /*  54244 */     // GIR_Coverage, 1265,
     /*  54244 */     GIR_EraseRootFromParent_Done,
     /*  54245 */   // Label 1160: @54245
     /*  54245 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(54299), // Rule ID 1266 //
     /*  54250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54279 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3676:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54297 */     GIR_RootConstrainSelectedInstOperands,
     /*  54298 */     // GIR_Coverage, 1266,
     /*  54298 */     GIR_EraseRootFromParent_Done,
     /*  54299 */   // Label 1161: @54299
     /*  54299 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(54353), // Rule ID 1267 //
     /*  54304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54333 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3676:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54351 */     GIR_RootConstrainSelectedInstOperands,
     /*  54352 */     // GIR_Coverage, 1267,
     /*  54352 */     GIR_EraseRootFromParent_Done,
     /*  54353 */   // Label 1162: @54353
     /*  54353 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(54407), // Rule ID 1268 //
     /*  54358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54387 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3676:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54405 */     GIR_RootConstrainSelectedInstOperands,
     /*  54406 */     // GIR_Coverage, 1268,
     /*  54406 */     GIR_EraseRootFromParent_Done,
     /*  54407 */   // Label 1163: @54407
     /*  54407 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(54461), // Rule ID 1269 //
     /*  54412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54441 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3675:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54459 */     GIR_RootConstrainSelectedInstOperands,
     /*  54460 */     // GIR_Coverage, 1269,
     /*  54460 */     GIR_EraseRootFromParent_Done,
     /*  54461 */   // Label 1164: @54461
     /*  54461 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54515), // Rule ID 1270 //
     /*  54466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54495 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3675:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54513 */     GIR_RootConstrainSelectedInstOperands,
     /*  54514 */     // GIR_Coverage, 1270,
     /*  54514 */     GIR_EraseRootFromParent_Done,
     /*  54515 */   // Label 1165: @54515
     /*  54515 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54569), // Rule ID 1271 //
     /*  54520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54549 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3677:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54567 */     GIR_RootConstrainSelectedInstOperands,
     /*  54568 */     // GIR_Coverage, 1271,
     /*  54568 */     GIR_EraseRootFromParent_Done,
     /*  54569 */   // Label 1166: @54569
     /*  54569 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54623), // Rule ID 1272 //
     /*  54574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54603 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3677:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54621 */     GIR_RootConstrainSelectedInstOperands,
     /*  54622 */     // GIR_Coverage, 1272,
     /*  54622 */     GIR_EraseRootFromParent_Done,
     /*  54623 */   // Label 1167: @54623
     /*  54623 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54677), // Rule ID 1273 //
     /*  54628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54657 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3677:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54675 */     GIR_RootConstrainSelectedInstOperands,
     /*  54676 */     // GIR_Coverage, 1273,
     /*  54676 */     GIR_EraseRootFromParent_Done,
     /*  54677 */   // Label 1168: @54677
     /*  54677 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54731), // Rule ID 1274 //
     /*  54682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54711 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3678:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54729 */     GIR_RootConstrainSelectedInstOperands,
     /*  54730 */     // GIR_Coverage, 1274,
     /*  54730 */     GIR_EraseRootFromParent_Done,
     /*  54731 */   // Label 1169: @54731
     /*  54731 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54785), // Rule ID 1275 //
     /*  54736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54765 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3678:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54783 */     GIR_RootConstrainSelectedInstOperands,
     /*  54784 */     // GIR_Coverage, 1275,
     /*  54784 */     GIR_EraseRootFromParent_Done,
     /*  54785 */   // Label 1170: @54785
     /*  54785 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54839), // Rule ID 1276 //
     /*  54790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54819 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3678:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54837 */     GIR_RootConstrainSelectedInstOperands,
     /*  54838 */     // GIR_Coverage, 1276,
     /*  54838 */     GIR_EraseRootFromParent_Done,
     /*  54839 */   // Label 1171: @54839
     /*  54839 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54893), // Rule ID 1277 //
     /*  54844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54873 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3677:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54891 */     GIR_RootConstrainSelectedInstOperands,
     /*  54892 */     // GIR_Coverage, 1277,
     /*  54892 */     GIR_EraseRootFromParent_Done,
     /*  54893 */   // Label 1172: @54893
     /*  54893 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54947), // Rule ID 1278 //
     /*  54898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54927 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3677:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54945 */     GIR_RootConstrainSelectedInstOperands,
     /*  54946 */     // GIR_Coverage, 1278,
     /*  54946 */     GIR_EraseRootFromParent_Done,
     /*  54947 */   // Label 1173: @54947
     /*  54947 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(55001), // Rule ID 1285 //
     /*  54952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54981 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3702:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54999 */     GIR_RootConstrainSelectedInstOperands,
     /*  55000 */     // GIR_Coverage, 1285,
     /*  55000 */     GIR_EraseRootFromParent_Done,
     /*  55001 */   // Label 1174: @55001
     /*  55001 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(55055), // Rule ID 1286 //
     /*  55006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55035 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3702:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55053 */     GIR_RootConstrainSelectedInstOperands,
     /*  55054 */     // GIR_Coverage, 1286,
     /*  55054 */     GIR_EraseRootFromParent_Done,
     /*  55055 */   // Label 1175: @55055
     /*  55055 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(55109), // Rule ID 1287 //
     /*  55060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55089 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3702:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55107 */     GIR_RootConstrainSelectedInstOperands,
     /*  55108 */     // GIR_Coverage, 1287,
     /*  55108 */     GIR_EraseRootFromParent_Done,
     /*  55109 */   // Label 1176: @55109
     /*  55109 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(55163), // Rule ID 1288 //
     /*  55114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55143 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3702:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55161 */     GIR_RootConstrainSelectedInstOperands,
     /*  55162 */     // GIR_Coverage, 1288,
     /*  55162 */     GIR_EraseRootFromParent_Done,
     /*  55163 */   // Label 1177: @55163
     /*  55163 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(55217), // Rule ID 1295 //
     /*  55168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55197 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3715:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55215 */     GIR_RootConstrainSelectedInstOperands,
     /*  55216 */     // GIR_Coverage, 1295,
     /*  55216 */     GIR_EraseRootFromParent_Done,
     /*  55217 */   // Label 1178: @55217
     /*  55217 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(55271), // Rule ID 1296 //
     /*  55222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55251 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3715:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55269 */     GIR_RootConstrainSelectedInstOperands,
     /*  55270 */     // GIR_Coverage, 1296,
     /*  55270 */     GIR_EraseRootFromParent_Done,
     /*  55271 */   // Label 1179: @55271
     /*  55271 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(55325), // Rule ID 1297 //
     /*  55276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55305 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3715:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55323 */     GIR_RootConstrainSelectedInstOperands,
     /*  55324 */     // GIR_Coverage, 1297,
     /*  55324 */     GIR_EraseRootFromParent_Done,
     /*  55325 */   // Label 1180: @55325
     /*  55325 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(55379), // Rule ID 1298 //
     /*  55330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55359 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3715:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55377 */     GIR_RootConstrainSelectedInstOperands,
     /*  55378 */     // GIR_Coverage, 1298,
     /*  55378 */     GIR_EraseRootFromParent_Done,
     /*  55379 */   // Label 1181: @55379
     /*  55379 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(55433), // Rule ID 1299 //
     /*  55384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55413 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3718:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55431 */     GIR_RootConstrainSelectedInstOperands,
     /*  55432 */     // GIR_Coverage, 1299,
     /*  55432 */     GIR_EraseRootFromParent_Done,
     /*  55433 */   // Label 1182: @55433
     /*  55433 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(55487), // Rule ID 1300 //
     /*  55438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55467 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3718:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55485 */     GIR_RootConstrainSelectedInstOperands,
     /*  55486 */     // GIR_Coverage, 1300,
     /*  55486 */     GIR_EraseRootFromParent_Done,
     /*  55487 */   // Label 1183: @55487
     /*  55487 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55541), // Rule ID 1301 //
     /*  55492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55521 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3718:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55539 */     GIR_RootConstrainSelectedInstOperands,
     /*  55540 */     // GIR_Coverage, 1301,
     /*  55540 */     GIR_EraseRootFromParent_Done,
     /*  55541 */   // Label 1184: @55541
     /*  55541 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55595), // Rule ID 1302 //
     /*  55546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55575 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55593 */     GIR_RootConstrainSelectedInstOperands,
     /*  55594 */     // GIR_Coverage, 1302,
     /*  55594 */     GIR_EraseRootFromParent_Done,
     /*  55595 */   // Label 1185: @55595
     /*  55595 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55649), // Rule ID 1303 //
     /*  55600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55629 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3718:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55647 */     GIR_RootConstrainSelectedInstOperands,
     /*  55648 */     // GIR_Coverage, 1303,
     /*  55648 */     GIR_EraseRootFromParent_Done,
     /*  55649 */   // Label 1186: @55649
     /*  55649 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55703), // Rule ID 1304 //
     /*  55654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55683 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3718:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55701 */     GIR_RootConstrainSelectedInstOperands,
     /*  55702 */     // GIR_Coverage, 1304,
     /*  55702 */     GIR_EraseRootFromParent_Done,
     /*  55703 */   // Label 1187: @55703
     /*  55703 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55757), // Rule ID 1305 //
     /*  55708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55737 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3718:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55755 */     GIR_RootConstrainSelectedInstOperands,
     /*  55756 */     // GIR_Coverage, 1305,
     /*  55756 */     GIR_EraseRootFromParent_Done,
     /*  55757 */   // Label 1188: @55757
     /*  55757 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55811), // Rule ID 1306 //
     /*  55762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55791 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3718:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55809 */     GIR_RootConstrainSelectedInstOperands,
     /*  55810 */     // GIR_Coverage, 1306,
     /*  55810 */     GIR_EraseRootFromParent_Done,
     /*  55811 */   // Label 1189: @55811
     /*  55811 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55865), // Rule ID 1307 //
     /*  55816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55845 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3719:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55863 */     GIR_RootConstrainSelectedInstOperands,
     /*  55864 */     // GIR_Coverage, 1307,
     /*  55864 */     GIR_EraseRootFromParent_Done,
     /*  55865 */   // Label 1190: @55865
     /*  55865 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55919), // Rule ID 1308 //
     /*  55870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55899 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3719:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55917 */     GIR_RootConstrainSelectedInstOperands,
     /*  55918 */     // GIR_Coverage, 1308,
     /*  55918 */     GIR_EraseRootFromParent_Done,
     /*  55919 */   // Label 1191: @55919
     /*  55919 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55973), // Rule ID 1309 //
     /*  55924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55953 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3719:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55971 */     GIR_RootConstrainSelectedInstOperands,
     /*  55972 */     // GIR_Coverage, 1309,
     /*  55972 */     GIR_EraseRootFromParent_Done,
     /*  55973 */   // Label 1192: @55973
     /*  55973 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(56027), // Rule ID 1310 //
     /*  55978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3719:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  56010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56025 */     GIR_RootConstrainSelectedInstOperands,
     /*  56026 */     // GIR_Coverage, 1310,
     /*  56026 */     GIR_EraseRootFromParent_Done,
     /*  56027 */   // Label 1193: @56027
     /*  56027 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(56081), // Rule ID 1311 //
     /*  56032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56061 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3719:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56079 */     GIR_RootConstrainSelectedInstOperands,
     /*  56080 */     // GIR_Coverage, 1311,
     /*  56080 */     GIR_EraseRootFromParent_Done,
     /*  56081 */   // Label 1194: @56081
     /*  56081 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(56135), // Rule ID 1312 //
     /*  56086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56115 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3719:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56133 */     GIR_RootConstrainSelectedInstOperands,
     /*  56134 */     // GIR_Coverage, 1312,
     /*  56134 */     GIR_EraseRootFromParent_Done,
     /*  56135 */   // Label 1195: @56135
     /*  56135 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(56189), // Rule ID 1313 //
     /*  56140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56169 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3719:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56187 */     GIR_RootConstrainSelectedInstOperands,
     /*  56188 */     // GIR_Coverage, 1313,
     /*  56188 */     GIR_EraseRootFromParent_Done,
     /*  56189 */   // Label 1196: @56189
     /*  56189 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(56243), // Rule ID 1314 //
     /*  56194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56223 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3719:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56241 */     GIR_RootConstrainSelectedInstOperands,
     /*  56242 */     // GIR_Coverage, 1314,
     /*  56242 */     GIR_EraseRootFromParent_Done,
     /*  56243 */   // Label 1197: @56243
     /*  56243 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(56297), // Rule ID 1348 //
     /*  56248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56277 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3712:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56295 */     GIR_RootConstrainSelectedInstOperands,
     /*  56296 */     // GIR_Coverage, 1348,
     /*  56296 */     GIR_EraseRootFromParent_Done,
     /*  56297 */   // Label 1198: @56297
     /*  56297 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(56351), // Rule ID 1349 //
     /*  56302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56331 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3712:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56349 */     GIR_RootConstrainSelectedInstOperands,
     /*  56350 */     // GIR_Coverage, 1349,
     /*  56350 */     GIR_EraseRootFromParent_Done,
     /*  56351 */   // Label 1199: @56351
     /*  56351 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(56405), // Rule ID 1350 //
     /*  56356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56385 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56403 */     GIR_RootConstrainSelectedInstOperands,
     /*  56404 */     // GIR_Coverage, 1350,
     /*  56404 */     GIR_EraseRootFromParent_Done,
     /*  56405 */   // Label 1200: @56405
     /*  56405 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(56459), // Rule ID 1351 //
     /*  56410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56439 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3712:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56457 */     GIR_RootConstrainSelectedInstOperands,
     /*  56458 */     // GIR_Coverage, 1351,
     /*  56458 */     GIR_EraseRootFromParent_Done,
     /*  56459 */   // Label 1201: @56459
     /*  56459 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56513), // Rule ID 1352 //
     /*  56464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56493 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3712:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56511 */     GIR_RootConstrainSelectedInstOperands,
     /*  56512 */     // GIR_Coverage, 1352,
     /*  56512 */     GIR_EraseRootFromParent_Done,
     /*  56513 */   // Label 1202: @56513
     /*  56513 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56567), // Rule ID 1353 //
     /*  56518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56547 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56565 */     GIR_RootConstrainSelectedInstOperands,
     /*  56566 */     // GIR_Coverage, 1353,
     /*  56566 */     GIR_EraseRootFromParent_Done,
     /*  56567 */   // Label 1203: @56567
     /*  56567 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56621), // Rule ID 1354 //
     /*  56572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56601 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3712:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56619 */     GIR_RootConstrainSelectedInstOperands,
     /*  56620 */     // GIR_Coverage, 1354,
     /*  56620 */     GIR_EraseRootFromParent_Done,
     /*  56621 */   // Label 1204: @56621
     /*  56621 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56675), // Rule ID 1355 //
     /*  56626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56655 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3712:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56673 */     GIR_RootConstrainSelectedInstOperands,
     /*  56674 */     // GIR_Coverage, 1355,
     /*  56674 */     GIR_EraseRootFromParent_Done,
     /*  56675 */   // Label 1205: @56675
     /*  56675 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56729), // Rule ID 1356 //
     /*  56680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56709 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3713:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56727 */     GIR_RootConstrainSelectedInstOperands,
     /*  56728 */     // GIR_Coverage, 1356,
     /*  56728 */     GIR_EraseRootFromParent_Done,
     /*  56729 */   // Label 1206: @56729
     /*  56729 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56783), // Rule ID 1357 //
     /*  56734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56763 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3713:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56781 */     GIR_RootConstrainSelectedInstOperands,
     /*  56782 */     // GIR_Coverage, 1357,
     /*  56782 */     GIR_EraseRootFromParent_Done,
     /*  56783 */   // Label 1207: @56783
     /*  56783 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56837), // Rule ID 1358 //
     /*  56788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56817 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56835 */     GIR_RootConstrainSelectedInstOperands,
     /*  56836 */     // GIR_Coverage, 1358,
     /*  56836 */     GIR_EraseRootFromParent_Done,
     /*  56837 */   // Label 1208: @56837
     /*  56837 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56891), // Rule ID 1359 //
     /*  56842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3713:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56889 */     GIR_RootConstrainSelectedInstOperands,
     /*  56890 */     // GIR_Coverage, 1359,
     /*  56890 */     GIR_EraseRootFromParent_Done,
     /*  56891 */   // Label 1209: @56891
     /*  56891 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56945), // Rule ID 1360 //
     /*  56896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56925 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3713:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56943 */     GIR_RootConstrainSelectedInstOperands,
     /*  56944 */     // GIR_Coverage, 1360,
     /*  56944 */     GIR_EraseRootFromParent_Done,
     /*  56945 */   // Label 1210: @56945
     /*  56945 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56999), // Rule ID 1361 //
     /*  56950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56979 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56997 */     GIR_RootConstrainSelectedInstOperands,
     /*  56998 */     // GIR_Coverage, 1361,
     /*  56998 */     GIR_EraseRootFromParent_Done,
     /*  56999 */   // Label 1211: @56999
     /*  56999 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(57053), // Rule ID 1362 //
     /*  57004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57033 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3713:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57051 */     GIR_RootConstrainSelectedInstOperands,
     /*  57052 */     // GIR_Coverage, 1362,
     /*  57052 */     GIR_EraseRootFromParent_Done,
     /*  57053 */   // Label 1212: @57053
     /*  57053 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(57107), // Rule ID 1363 //
     /*  57058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57087 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3713:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57105 */     GIR_RootConstrainSelectedInstOperands,
     /*  57106 */     // GIR_Coverage, 1363,
     /*  57106 */     GIR_EraseRootFromParent_Done,
     /*  57107 */   // Label 1213: @57107
     /*  57107 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(57161), // Rule ID 1383 //
     /*  57112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57141 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3697:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57159 */     GIR_RootConstrainSelectedInstOperands,
     /*  57160 */     // GIR_Coverage, 1383,
     /*  57160 */     GIR_EraseRootFromParent_Done,
     /*  57161 */   // Label 1214: @57161
     /*  57161 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(57215), // Rule ID 1384 //
     /*  57166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57195 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3697:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57213 */     GIR_RootConstrainSelectedInstOperands,
     /*  57214 */     // GIR_Coverage, 1384,
     /*  57214 */     GIR_EraseRootFromParent_Done,
     /*  57215 */   // Label 1215: @57215
     /*  57215 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(57269), // Rule ID 1385 //
     /*  57220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57249 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57267 */     GIR_RootConstrainSelectedInstOperands,
     /*  57268 */     // GIR_Coverage, 1385,
     /*  57268 */     GIR_EraseRootFromParent_Done,
     /*  57269 */   // Label 1216: @57269
     /*  57269 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(57323), // Rule ID 1386 //
     /*  57274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57303 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57321 */     GIR_RootConstrainSelectedInstOperands,
     /*  57322 */     // GIR_Coverage, 1386,
     /*  57322 */     GIR_EraseRootFromParent_Done,
     /*  57323 */   // Label 1217: @57323
     /*  57323 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(57377), // Rule ID 1387 //
     /*  57328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57357 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3697:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57375 */     GIR_RootConstrainSelectedInstOperands,
     /*  57376 */     // GIR_Coverage, 1387,
     /*  57376 */     GIR_EraseRootFromParent_Done,
     /*  57377 */   // Label 1218: @57377
     /*  57377 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(57431), // Rule ID 1388 //
     /*  57382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57411 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57429 */     GIR_RootConstrainSelectedInstOperands,
     /*  57430 */     // GIR_Coverage, 1388,
     /*  57430 */     GIR_EraseRootFromParent_Done,
     /*  57431 */   // Label 1219: @57431
     /*  57431 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(57485), // Rule ID 1389 //
     /*  57436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57465 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3697:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57483 */     GIR_RootConstrainSelectedInstOperands,
     /*  57484 */     // GIR_Coverage, 1389,
     /*  57484 */     GIR_EraseRootFromParent_Done,
     /*  57485 */   // Label 1220: @57485
     /*  57485 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57539), // Rule ID 1390 //
     /*  57490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57519 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3697:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57537 */     GIR_RootConstrainSelectedInstOperands,
     /*  57538 */     // GIR_Coverage, 1390,
     /*  57538 */     GIR_EraseRootFromParent_Done,
     /*  57539 */   // Label 1221: @57539
     /*  57539 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57593), // Rule ID 1391 //
     /*  57544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57573 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3699:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57591 */     GIR_RootConstrainSelectedInstOperands,
     /*  57592 */     // GIR_Coverage, 1391,
     /*  57592 */     GIR_EraseRootFromParent_Done,
     /*  57593 */   // Label 1222: @57593
     /*  57593 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57647), // Rule ID 1392 //
     /*  57598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57627 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3699:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57645 */     GIR_RootConstrainSelectedInstOperands,
     /*  57646 */     // GIR_Coverage, 1392,
     /*  57646 */     GIR_EraseRootFromParent_Done,
     /*  57647 */   // Label 1223: @57647
     /*  57647 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57701), // Rule ID 1393 //
     /*  57652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57681 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3699:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57699 */     GIR_RootConstrainSelectedInstOperands,
     /*  57700 */     // GIR_Coverage, 1393,
     /*  57700 */     GIR_EraseRootFromParent_Done,
     /*  57701 */   // Label 1224: @57701
     /*  57701 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57755), // Rule ID 1394 //
     /*  57706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3699:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57753 */     GIR_RootConstrainSelectedInstOperands,
     /*  57754 */     // GIR_Coverage, 1394,
     /*  57754 */     GIR_EraseRootFromParent_Done,
     /*  57755 */   // Label 1225: @57755
     /*  57755 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57809), // Rule ID 1395 //
     /*  57760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57789 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3699:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57807 */     GIR_RootConstrainSelectedInstOperands,
     /*  57808 */     // GIR_Coverage, 1395,
     /*  57808 */     GIR_EraseRootFromParent_Done,
     /*  57809 */   // Label 1226: @57809
     /*  57809 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57863), // Rule ID 1396 //
     /*  57814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57843 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3699:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57861 */     GIR_RootConstrainSelectedInstOperands,
     /*  57862 */     // GIR_Coverage, 1396,
     /*  57862 */     GIR_EraseRootFromParent_Done,
     /*  57863 */   // Label 1227: @57863
     /*  57863 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57917), // Rule ID 1397 //
     /*  57868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57897 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3699:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57915 */     GIR_RootConstrainSelectedInstOperands,
     /*  57916 */     // GIR_Coverage, 1397,
     /*  57916 */     GIR_EraseRootFromParent_Done,
     /*  57917 */   // Label 1228: @57917
     /*  57917 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57971), // Rule ID 1398 //
     /*  57922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57951 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3699:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57969 */     GIR_RootConstrainSelectedInstOperands,
     /*  57970 */     // GIR_Coverage, 1398,
     /*  57970 */     GIR_EraseRootFromParent_Done,
     /*  57971 */   // Label 1229: @57971
     /*  57971 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(58025), // Rule ID 1432 //
     /*  57976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58005 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3692:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  58008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58023 */     GIR_RootConstrainSelectedInstOperands,
     /*  58024 */     // GIR_Coverage, 1432,
     /*  58024 */     GIR_EraseRootFromParent_Done,
     /*  58025 */   // Label 1230: @58025
     /*  58025 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(58079), // Rule ID 1433 //
     /*  58030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58059 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3692:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 1433,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 1231: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(58133), // Rule ID 1434 //
     /*  58084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58113 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3692:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58131 */     GIR_RootConstrainSelectedInstOperands,
     /*  58132 */     // GIR_Coverage, 1434,
     /*  58132 */     GIR_EraseRootFromParent_Done,
     /*  58133 */   // Label 1232: @58133
     /*  58133 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(58187), // Rule ID 1435 //
     /*  58138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58167 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3692:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58185 */     GIR_RootConstrainSelectedInstOperands,
     /*  58186 */     // GIR_Coverage, 1435,
     /*  58186 */     GIR_EraseRootFromParent_Done,
     /*  58187 */   // Label 1233: @58187
     /*  58187 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(58241), // Rule ID 1436 //
     /*  58192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58221 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3692:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58239 */     GIR_RootConstrainSelectedInstOperands,
     /*  58240 */     // GIR_Coverage, 1436,
     /*  58240 */     GIR_EraseRootFromParent_Done,
     /*  58241 */   // Label 1234: @58241
     /*  58241 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(58295), // Rule ID 1437 //
     /*  58246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58275 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3692:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58293 */     GIR_RootConstrainSelectedInstOperands,
     /*  58294 */     // GIR_Coverage, 1437,
     /*  58294 */     GIR_EraseRootFromParent_Done,
     /*  58295 */   // Label 1235: @58295
     /*  58295 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(58349), // Rule ID 1438 //
     /*  58300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58329 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3692:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58347 */     GIR_RootConstrainSelectedInstOperands,
     /*  58348 */     // GIR_Coverage, 1438,
     /*  58348 */     GIR_EraseRootFromParent_Done,
     /*  58349 */   // Label 1236: @58349
     /*  58349 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(58403), // Rule ID 1439 //
     /*  58354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58383 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3692:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58401 */     GIR_RootConstrainSelectedInstOperands,
     /*  58402 */     // GIR_Coverage, 1439,
     /*  58402 */     GIR_EraseRootFromParent_Done,
     /*  58403 */   // Label 1237: @58403
     /*  58403 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(58457), // Rule ID 1440 //
     /*  58408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58437 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3693:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58455 */     GIR_RootConstrainSelectedInstOperands,
     /*  58456 */     // GIR_Coverage, 1440,
     /*  58456 */     GIR_EraseRootFromParent_Done,
     /*  58457 */   // Label 1238: @58457
     /*  58457 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58511), // Rule ID 1441 //
     /*  58462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58491 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3693:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58509 */     GIR_RootConstrainSelectedInstOperands,
     /*  58510 */     // GIR_Coverage, 1441,
     /*  58510 */     GIR_EraseRootFromParent_Done,
     /*  58511 */   // Label 1239: @58511
     /*  58511 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58565), // Rule ID 1442 //
     /*  58516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3693:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58563 */     GIR_RootConstrainSelectedInstOperands,
     /*  58564 */     // GIR_Coverage, 1442,
     /*  58564 */     GIR_EraseRootFromParent_Done,
     /*  58565 */   // Label 1240: @58565
     /*  58565 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58619), // Rule ID 1443 //
     /*  58570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58599 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3693:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58617 */     GIR_RootConstrainSelectedInstOperands,
     /*  58618 */     // GIR_Coverage, 1443,
     /*  58618 */     GIR_EraseRootFromParent_Done,
     /*  58619 */   // Label 1241: @58619
     /*  58619 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58673), // Rule ID 1444 //
     /*  58624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58653 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3693:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58671 */     GIR_RootConstrainSelectedInstOperands,
     /*  58672 */     // GIR_Coverage, 1444,
     /*  58672 */     GIR_EraseRootFromParent_Done,
     /*  58673 */   // Label 1242: @58673
     /*  58673 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58727), // Rule ID 1445 //
     /*  58678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58707 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3693:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58725 */     GIR_RootConstrainSelectedInstOperands,
     /*  58726 */     // GIR_Coverage, 1445,
     /*  58726 */     GIR_EraseRootFromParent_Done,
     /*  58727 */   // Label 1243: @58727
     /*  58727 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58781), // Rule ID 1446 //
     /*  58732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58761 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3693:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58779 */     GIR_RootConstrainSelectedInstOperands,
     /*  58780 */     // GIR_Coverage, 1446,
     /*  58780 */     GIR_EraseRootFromParent_Done,
     /*  58781 */   // Label 1244: @58781
     /*  58781 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58835), // Rule ID 1447 //
     /*  58786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58815 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3693:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58833 */     GIR_RootConstrainSelectedInstOperands,
     /*  58834 */     // GIR_Coverage, 1447,
     /*  58834 */     GIR_EraseRootFromParent_Done,
     /*  58835 */   // Label 1245: @58835
     /*  58835 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58880), // Rule ID 1712 //
     /*  58840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58869 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3594:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58878 */     GIR_RootConstrainSelectedInstOperands,
     /*  58879 */     // GIR_Coverage, 1712,
     /*  58879 */     GIR_EraseRootFromParent_Done,
     /*  58880 */   // Label 1246: @58880
     /*  58880 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58925), // Rule ID 1713 //
     /*  58885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58914 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3595:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58923 */     GIR_RootConstrainSelectedInstOperands,
     /*  58924 */     // GIR_Coverage, 1713,
     /*  58924 */     GIR_EraseRootFromParent_Done,
     /*  58925 */   // Label 1247: @58925
     /*  58925 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58970), // Rule ID 1716 //
     /*  58930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58959 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3608:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58968 */     GIR_RootConstrainSelectedInstOperands,
     /*  58969 */     // GIR_Coverage, 1716,
     /*  58969 */     GIR_EraseRootFromParent_Done,
     /*  58970 */   // Label 1248: @58970
     /*  58970 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(59015), // Rule ID 1717 //
     /*  58975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  59007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59013 */     GIR_RootConstrainSelectedInstOperands,
     /*  59014 */     // GIR_Coverage, 1717,
     /*  59014 */     GIR_EraseRootFromParent_Done,
     /*  59015 */   // Label 1249: @59015
     /*  59015 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(59069), // Rule ID 1726 //
     /*  59020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  59028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59049 */     // (intrinsic_wo_chain:{ *:[i32] } 3456:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59054 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59067 */     GIR_RootConstrainSelectedInstOperands,
     /*  59068 */     // GIR_Coverage, 1726,
     /*  59068 */     GIR_EraseRootFromParent_Done,
     /*  59069 */   // Label 1250: @59069
     /*  59069 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(59123), // Rule ID 1727 //
     /*  59074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59103 */     // (intrinsic_wo_chain:{ *:[i32] } 3463:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59108 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59121 */     GIR_RootConstrainSelectedInstOperands,
     /*  59122 */     // GIR_Coverage, 1727,
     /*  59122 */     GIR_EraseRootFromParent_Done,
     /*  59123 */   // Label 1251: @59123
     /*  59123 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(59180), // Rule ID 1850 //
     /*  59128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59157 */     // (intrinsic_wo_chain:{ *:[i32] } 3795:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59162 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59164 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59178 */     GIR_RootConstrainSelectedInstOperands,
     /*  59179 */     // GIR_Coverage, 1850,
     /*  59179 */     GIR_EraseRootFromParent_Done,
     /*  59180 */   // Label 1252: @59180
     /*  59180 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(59237), // Rule ID 1857 //
     /*  59185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59214 */     // (intrinsic_wo_chain:{ *:[i32] } 3820:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59219 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59221 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59235 */     GIR_RootConstrainSelectedInstOperands,
     /*  59236 */     // GIR_Coverage, 1857,
     /*  59236 */     GIR_EraseRootFromParent_Done,
     /*  59237 */   // Label 1253: @59237
     /*  59237 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(59291), // Rule ID 1904 //
     /*  59242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59271 */     // (intrinsic_wo_chain:{ *:[i32] } 3771:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59289 */     GIR_RootConstrainSelectedInstOperands,
     /*  59290 */     // GIR_Coverage, 1904,
     /*  59290 */     GIR_EraseRootFromParent_Done,
     /*  59291 */   // Label 1254: @59291
     /*  59291 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(59345), // Rule ID 1905 //
     /*  59296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59325 */     // (intrinsic_wo_chain:{ *:[i32] } 3772:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59343 */     GIR_RootConstrainSelectedInstOperands,
     /*  59344 */     // GIR_Coverage, 1905,
     /*  59344 */     GIR_EraseRootFromParent_Done,
     /*  59345 */   // Label 1255: @59345
     /*  59345 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(59399), // Rule ID 1906 //
     /*  59350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59379 */     // (intrinsic_wo_chain:{ *:[i32] } 3779:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59397 */     GIR_RootConstrainSelectedInstOperands,
     /*  59398 */     // GIR_Coverage, 1906,
     /*  59398 */     GIR_EraseRootFromParent_Done,
     /*  59399 */   // Label 1256: @59399
     /*  59399 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(59453), // Rule ID 1907 //
     /*  59404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59433 */     // (intrinsic_wo_chain:{ *:[i32] } 3780:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59451 */     GIR_RootConstrainSelectedInstOperands,
     /*  59452 */     // GIR_Coverage, 1907,
     /*  59452 */     GIR_EraseRootFromParent_Done,
     /*  59453 */   // Label 1257: @59453
     /*  59453 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59507), // Rule ID 1979 //
     /*  59458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59487 */     // (intrinsic_wo_chain:{ *:[i32] } 3773:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59492 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59494 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59505 */     GIR_RootConstrainSelectedInstOperands,
     /*  59506 */     // GIR_Coverage, 1979,
     /*  59506 */     GIR_EraseRootFromParent_Done,
     /*  59507 */   // Label 1258: @59507
     /*  59507 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59561), // Rule ID 1980 //
     /*  59512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59541 */     // (intrinsic_wo_chain:{ *:[i32] } 3774:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59546 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59548 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59559 */     GIR_RootConstrainSelectedInstOperands,
     /*  59560 */     // GIR_Coverage, 1980,
     /*  59560 */     GIR_EraseRootFromParent_Done,
     /*  59561 */   // Label 1259: @59561
     /*  59561 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59615), // Rule ID 1981 //
     /*  59566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59595 */     // (intrinsic_wo_chain:{ *:[i32] } 3775:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59600 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59602 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59613 */     GIR_RootConstrainSelectedInstOperands,
     /*  59614 */     // GIR_Coverage, 1981,
     /*  59614 */     GIR_EraseRootFromParent_Done,
     /*  59615 */   // Label 1260: @59615
     /*  59615 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59669), // Rule ID 1982 //
     /*  59620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59649 */     // (intrinsic_wo_chain:{ *:[i32] } 3776:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59654 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59656 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59667 */     GIR_RootConstrainSelectedInstOperands,
     /*  59668 */     // GIR_Coverage, 1982,
     /*  59668 */     GIR_EraseRootFromParent_Done,
     /*  59669 */   // Label 1261: @59669
     /*  59669 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59723), // Rule ID 1983 //
     /*  59674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59703 */     // (intrinsic_wo_chain:{ *:[i32] } 3777:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59708 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59710 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59721 */     GIR_RootConstrainSelectedInstOperands,
     /*  59722 */     // GIR_Coverage, 1983,
     /*  59722 */     GIR_EraseRootFromParent_Done,
     /*  59723 */   // Label 1262: @59723
     /*  59723 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59777), // Rule ID 1984 //
     /*  59728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59757 */     // (intrinsic_wo_chain:{ *:[i32] } 3778:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59762 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59764 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59775 */     GIR_RootConstrainSelectedInstOperands,
     /*  59776 */     // GIR_Coverage, 1984,
     /*  59776 */     GIR_EraseRootFromParent_Done,
     /*  59777 */   // Label 1263: @59777
     /*  59777 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59834), // Rule ID 2088 //
     /*  59782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59811 */     // (intrinsic_wo_chain:{ *:[i32] } 3795:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59832 */     GIR_RootConstrainSelectedInstOperands,
     /*  59833 */     // GIR_Coverage, 2088,
     /*  59833 */     GIR_EraseRootFromParent_Done,
     /*  59834 */   // Label 1264: @59834
     /*  59834 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59888), // Rule ID 2118 //
     /*  59839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59868 */     // (intrinsic_wo_chain:{ *:[i32] } 3738:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59886 */     GIR_RootConstrainSelectedInstOperands,
     /*  59887 */     // GIR_Coverage, 2118,
     /*  59887 */     GIR_EraseRootFromParent_Done,
     /*  59888 */   // Label 1265: @59888
     /*  59888 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59942), // Rule ID 2119 //
     /*  59893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59922 */     // (intrinsic_wo_chain:{ *:[i32] } 3743:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59940 */     GIR_RootConstrainSelectedInstOperands,
     /*  59941 */     // GIR_Coverage, 2119,
     /*  59941 */     GIR_EraseRootFromParent_Done,
     /*  59942 */   // Label 1266: @59942
     /*  59942 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59996), // Rule ID 2159 //
     /*  59947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59976 */     // (intrinsic_wo_chain:{ *:[i32] } 3773:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59994 */     GIR_RootConstrainSelectedInstOperands,
     /*  59995 */     // GIR_Coverage, 2159,
     /*  59995 */     GIR_EraseRootFromParent_Done,
     /*  59996 */   // Label 1267: @59996
     /*  59996 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(60050), // Rule ID 2160 //
     /*  60001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  60009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60030 */     // (intrinsic_wo_chain:{ *:[i32] } 3774:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60048 */     GIR_RootConstrainSelectedInstOperands,
     /*  60049 */     // GIR_Coverage, 2160,
     /*  60049 */     GIR_EraseRootFromParent_Done,
     /*  60050 */   // Label 1268: @60050
     /*  60050 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(60104), // Rule ID 2161 //
     /*  60055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60084 */     // (intrinsic_wo_chain:{ *:[i32] } 3775:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60102 */     GIR_RootConstrainSelectedInstOperands,
     /*  60103 */     // GIR_Coverage, 2161,
     /*  60103 */     GIR_EraseRootFromParent_Done,
     /*  60104 */   // Label 1269: @60104
     /*  60104 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(60158), // Rule ID 2162 //
     /*  60109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60138 */     // (intrinsic_wo_chain:{ *:[i32] } 3776:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60156 */     GIR_RootConstrainSelectedInstOperands,
     /*  60157 */     // GIR_Coverage, 2162,
     /*  60157 */     GIR_EraseRootFromParent_Done,
     /*  60158 */   // Label 1270: @60158
     /*  60158 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(60212), // Rule ID 2163 //
     /*  60163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60192 */     // (intrinsic_wo_chain:{ *:[i32] } 3777:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60210 */     GIR_RootConstrainSelectedInstOperands,
     /*  60211 */     // GIR_Coverage, 2163,
     /*  60211 */     GIR_EraseRootFromParent_Done,
     /*  60212 */   // Label 1271: @60212
     /*  60212 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(60266), // Rule ID 2164 //
     /*  60217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60246 */     // (intrinsic_wo_chain:{ *:[i32] } 3778:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60264 */     GIR_RootConstrainSelectedInstOperands,
     /*  60265 */     // GIR_Coverage, 2164,
     /*  60265 */     GIR_EraseRootFromParent_Done,
     /*  60266 */   // Label 1272: @60266
     /*  60266 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(60314), // Rule ID 2493 //
     /*  60271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60300 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3625:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60312 */     GIR_RootConstrainSelectedInstOperands,
     /*  60313 */     // GIR_Coverage, 2493,
     /*  60313 */     GIR_EraseRootFromParent_Done,
     /*  60314 */   // Label 1273: @60314
     /*  60314 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(60362), // Rule ID 2494 //
     /*  60319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60348 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3624:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60360 */     GIR_RootConstrainSelectedInstOperands,
     /*  60361 */     // GIR_Coverage, 2494,
     /*  60361 */     GIR_EraseRootFromParent_Done,
     /*  60362 */   // Label 1274: @60362
     /*  60362 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(60410), // Rule ID 2495 //
     /*  60367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60396 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3625:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60408 */     GIR_RootConstrainSelectedInstOperands,
     /*  60409 */     // GIR_Coverage, 2495,
     /*  60409 */     GIR_EraseRootFromParent_Done,
     /*  60410 */   // Label 1275: @60410
     /*  60410 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(60458), // Rule ID 2496 //
     /*  60415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60444 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3624:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60456 */     GIR_RootConstrainSelectedInstOperands,
     /*  60457 */     // GIR_Coverage, 2496,
     /*  60457 */     GIR_EraseRootFromParent_Done,
     /*  60458 */   // Label 1276: @60458
     /*  60458 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60506), // Rule ID 2497 //
     /*  60463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60492 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3625:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60504 */     GIR_RootConstrainSelectedInstOperands,
     /*  60505 */     // GIR_Coverage, 2497,
     /*  60505 */     GIR_EraseRootFromParent_Done,
     /*  60506 */   // Label 1277: @60506
     /*  60506 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60554), // Rule ID 2498 //
     /*  60511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60540 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3624:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60552 */     GIR_RootConstrainSelectedInstOperands,
     /*  60553 */     // GIR_Coverage, 2498,
     /*  60553 */     GIR_EraseRootFromParent_Done,
     /*  60554 */   // Label 1278: @60554
     /*  60554 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60602), // Rule ID 2499 //
     /*  60559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60588 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3625:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60600 */     GIR_RootConstrainSelectedInstOperands,
     /*  60601 */     // GIR_Coverage, 2499,
     /*  60601 */     GIR_EraseRootFromParent_Done,
     /*  60602 */   // Label 1279: @60602
     /*  60602 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60650), // Rule ID 2500 //
     /*  60607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60636 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3624:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60648 */     GIR_RootConstrainSelectedInstOperands,
     /*  60649 */     // GIR_Coverage, 2500,
     /*  60649 */     GIR_EraseRootFromParent_Done,
     /*  60650 */   // Label 1280: @60650
     /*  60650 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60755), // Rule ID 3085 //
     /*  60655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60684 */     // (intrinsic_wo_chain:{ *:[f32] } 3432:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60717 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60727 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60733 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60754 */     // GIR_Coverage, 3085,
     /*  60754 */     GIR_EraseRootFromParent_Done,
     /*  60755 */   // Label 1281: @60755
     /*  60755 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60860), // Rule ID 3087 //
     /*  60760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60789 */     // (intrinsic_wo_chain:{ *:[f16] } 3432:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60801 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60832 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60838 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60859 */     // GIR_Coverage, 3087,
     /*  60859 */     GIR_EraseRootFromParent_Done,
     /*  60860 */   // Label 1282: @60860
     /*  60860 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60965), // Rule ID 3089 //
     /*  60865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60894 */     // (intrinsic_wo_chain:{ *:[f32] } 3423:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60927 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60937 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60943 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60964 */     // GIR_Coverage, 3089,
     /*  60964 */     GIR_EraseRootFromParent_Done,
     /*  60965 */   // Label 1283: @60965
     /*  60965 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(61070), // Rule ID 3091 //
     /*  60970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60999 */     // (intrinsic_wo_chain:{ *:[f16] } 3423:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  61027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61042 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61048 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61069 */     // GIR_Coverage, 3091,
     /*  61069 */     GIR_EraseRootFromParent_Done,
     /*  61070 */   // Label 1284: @61070
     /*  61070 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(61175), // Rule ID 3093 //
     /*  61075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61104 */     // (intrinsic_wo_chain:{ *:[f32] } 3430:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61107 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61111 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61137 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61144 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61153 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61174 */     // GIR_Coverage, 3093,
     /*  61174 */     GIR_EraseRootFromParent_Done,
     /*  61175 */   // Label 1285: @61175
     /*  61175 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(61280), // Rule ID 3095 //
     /*  61180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61209 */     // (intrinsic_wo_chain:{ *:[f16] } 3430:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61252 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61258 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61279 */     // GIR_Coverage, 3095,
     /*  61279 */     GIR_EraseRootFromParent_Done,
     /*  61280 */   // Label 1286: @61280
     /*  61280 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(61385), // Rule ID 3097 //
     /*  61285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61314 */     // (intrinsic_wo_chain:{ *:[f32] } 3421:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61357 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61363 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61384 */     // GIR_Coverage, 3097,
     /*  61384 */     GIR_EraseRootFromParent_Done,
     /*  61385 */   // Label 1287: @61385
     /*  61385 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(61490), // Rule ID 3099 //
     /*  61390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61419 */     // (intrinsic_wo_chain:{ *:[f16] } 3421:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61419 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61422 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61426 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61431 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61435 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61452 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61462 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61468 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61489 */     // GIR_Coverage, 3099,
     /*  61489 */     GIR_EraseRootFromParent_Done,
     /*  61490 */   // Label 1288: @61490
     /*  61490 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(61550), // Rule ID 3149 //
     /*  61495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61524 */     // (intrinsic_wo_chain:{ *:[i32] } 3428:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61529 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61531 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61548 */     GIR_RootConstrainSelectedInstOperands,
     /*  61549 */     // GIR_Coverage, 3149,
     /*  61549 */     GIR_EraseRootFromParent_Done,
     /*  61550 */   // Label 1289: @61550
     /*  61550 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(61610), // Rule ID 3151 //
     /*  61555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61584 */     // (intrinsic_wo_chain:{ *:[i32] } 3428:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61589 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61591 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61608 */     GIR_RootConstrainSelectedInstOperands,
     /*  61609 */     // GIR_Coverage, 3151,
     /*  61609 */     GIR_EraseRootFromParent_Done,
     /*  61610 */   // Label 1290: @61610
     /*  61610 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(61670), // Rule ID 3153 //
     /*  61615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61644 */     // (intrinsic_wo_chain:{ *:[i32] } 3428:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61651 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61668 */     GIR_RootConstrainSelectedInstOperands,
     /*  61669 */     // GIR_Coverage, 3153,
     /*  61669 */     GIR_EraseRootFromParent_Done,
     /*  61670 */   // Label 1291: @61670
     /*  61670 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61730), // Rule ID 3155 //
     /*  61675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61704 */     // (intrinsic_wo_chain:{ *:[i32] } 3419:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61709 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61711 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61728 */     GIR_RootConstrainSelectedInstOperands,
     /*  61729 */     // GIR_Coverage, 3155,
     /*  61729 */     GIR_EraseRootFromParent_Done,
     /*  61730 */   // Label 1292: @61730
     /*  61730 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61790), // Rule ID 3157 //
     /*  61735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61764 */     // (intrinsic_wo_chain:{ *:[i32] } 3419:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61769 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61771 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61788 */     GIR_RootConstrainSelectedInstOperands,
     /*  61789 */     // GIR_Coverage, 3157,
     /*  61789 */     GIR_EraseRootFromParent_Done,
     /*  61790 */   // Label 1293: @61790
     /*  61790 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61850), // Rule ID 3159 //
     /*  61795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61824 */     // (intrinsic_wo_chain:{ *:[i32] } 3419:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61829 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61831 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61848 */     GIR_RootConstrainSelectedInstOperands,
     /*  61849 */     // GIR_Coverage, 3159,
     /*  61849 */     GIR_EraseRootFromParent_Done,
     /*  61850 */   // Label 1294: @61850
     /*  61850 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61925), // Rule ID 3450 //
     /*  61855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61884 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3541:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61923 */     GIR_RootConstrainSelectedInstOperands,
     /*  61924 */     // GIR_Coverage, 3450,
     /*  61924 */     GIR_EraseRootFromParent_Done,
     /*  61925 */   // Label 1295: @61925
     /*  61925 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(62000), // Rule ID 3457 //
     /*  61930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61959 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3541:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61998 */     GIR_RootConstrainSelectedInstOperands,
     /*  61999 */     // GIR_Coverage, 3457,
     /*  61999 */     GIR_EraseRootFromParent_Done,
     /*  62000 */   // Label 1296: @62000
     /*  62000 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(62075), // Rule ID 3461 //
     /*  62005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62034 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3541:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62073 */     GIR_RootConstrainSelectedInstOperands,
     /*  62074 */     // GIR_Coverage, 3461,
     /*  62074 */     GIR_EraseRootFromParent_Done,
     /*  62075 */   // Label 1297: @62075
     /*  62075 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(62150), // Rule ID 3463 //
     /*  62080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62109 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3550:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62148 */     GIR_RootConstrainSelectedInstOperands,
     /*  62149 */     // GIR_Coverage, 3463,
     /*  62149 */     GIR_EraseRootFromParent_Done,
     /*  62150 */   // Label 1298: @62150
     /*  62150 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(62225), // Rule ID 3465 //
     /*  62155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62184 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3550:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62223 */     GIR_RootConstrainSelectedInstOperands,
     /*  62224 */     // GIR_Coverage, 3465,
     /*  62224 */     GIR_EraseRootFromParent_Done,
     /*  62225 */   // Label 1299: @62225
     /*  62225 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(62300), // Rule ID 3467 //
     /*  62230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62259 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3550:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62298 */     GIR_RootConstrainSelectedInstOperands,
     /*  62299 */     // GIR_Coverage, 3467,
     /*  62299 */     GIR_EraseRootFromParent_Done,
     /*  62300 */   // Label 1300: @62300
     /*  62300 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(62375), // Rule ID 4735 //
     /*  62305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62334 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3474:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62373 */     GIR_RootConstrainSelectedInstOperands,
     /*  62374 */     // GIR_Coverage, 4735,
     /*  62374 */     GIR_EraseRootFromParent_Done,
     /*  62375 */   // Label 1301: @62375
     /*  62375 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(62450), // Rule ID 4740 //
     /*  62380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62409 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3474:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62448 */     GIR_RootConstrainSelectedInstOperands,
     /*  62449 */     // GIR_Coverage, 4740,
     /*  62449 */     GIR_EraseRootFromParent_Done,
     /*  62450 */   // Label 1302: @62450
     /*  62450 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(62525), // Rule ID 4742 //
     /*  62455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62484 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3474:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62523 */     GIR_RootConstrainSelectedInstOperands,
     /*  62524 */     // GIR_Coverage, 4742,
     /*  62524 */     GIR_EraseRootFromParent_Done,
     /*  62525 */   // Label 1303: @62525
     /*  62525 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(62600), // Rule ID 4744 //
     /*  62530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62559 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3474:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62598 */     GIR_RootConstrainSelectedInstOperands,
     /*  62599 */     // GIR_Coverage, 4744,
     /*  62599 */     GIR_EraseRootFromParent_Done,
     /*  62600 */   // Label 1304: @62600
     /*  62600 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62675), // Rule ID 4746 //
     /*  62605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62634 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3474:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62673 */     GIR_RootConstrainSelectedInstOperands,
     /*  62674 */     // GIR_Coverage, 4746,
     /*  62674 */     GIR_EraseRootFromParent_Done,
     /*  62675 */   // Label 1305: @62675
     /*  62675 */   GIM_Reject,
     /*  62676 */ // Label 950: @62676
     /*  62676 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(73599),
     /*  62681 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62684 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62774), // Rule ID 3896 //
     /*  62689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62726 */     // MIs[1] Operand 1
     /*  62726 */     // No operand predicates
     /*  62726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62732 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3551:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62772 */     GIR_RootConstrainSelectedInstOperands,
     /*  62773 */     // GIR_Coverage, 3896,
     /*  62773 */     GIR_EraseRootFromParent_Done,
     /*  62774 */   // Label 1307: @62774
     /*  62774 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62864), // Rule ID 3898 //
     /*  62779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62816 */     // MIs[1] Operand 1
     /*  62816 */     // No operand predicates
     /*  62816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3551:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62839 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62862 */     GIR_RootConstrainSelectedInstOperands,
     /*  62863 */     // GIR_Coverage, 3898,
     /*  62863 */     GIR_EraseRootFromParent_Done,
     /*  62864 */   // Label 1308: @62864
     /*  62864 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62954), // Rule ID 3900 //
     /*  62869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62906 */     // MIs[1] Operand 1
     /*  62906 */     // No operand predicates
     /*  62906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62912 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3551:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62952 */     GIR_RootConstrainSelectedInstOperands,
     /*  62953 */     // GIR_Coverage, 3900,
     /*  62953 */     GIR_EraseRootFromParent_Done,
     /*  62954 */   // Label 1309: @62954
     /*  62954 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(63044), // Rule ID 3902 //
     /*  62959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62996 */     // MIs[1] Operand 1
     /*  62996 */     // No operand predicates
     /*  62996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63002 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3551:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  63017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63042 */     GIR_RootConstrainSelectedInstOperands,
     /*  63043 */     // GIR_Coverage, 3902,
     /*  63043 */     GIR_EraseRootFromParent_Done,
     /*  63044 */   // Label 1310: @63044
     /*  63044 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(63134), // Rule ID 3904 //
     /*  63049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63086 */     // MIs[1] Operand 1
     /*  63086 */     // No operand predicates
     /*  63086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3551:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63109 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63132 */     GIR_RootConstrainSelectedInstOperands,
     /*  63133 */     // GIR_Coverage, 3904,
     /*  63133 */     GIR_EraseRootFromParent_Done,
     /*  63134 */   // Label 1311: @63134
     /*  63134 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(63224), // Rule ID 3906 //
     /*  63139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63176 */     // MIs[1] Operand 1
     /*  63176 */     // No operand predicates
     /*  63176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63182 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3551:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63222 */     GIR_RootConstrainSelectedInstOperands,
     /*  63223 */     // GIR_Coverage, 3906,
     /*  63223 */     GIR_EraseRootFromParent_Done,
     /*  63224 */   // Label 1312: @63224
     /*  63224 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(63314), // Rule ID 3914 //
     /*  63229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63266 */     // MIs[1] Operand 1
     /*  63266 */     // No operand predicates
     /*  63266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63272 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3568:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63312 */     GIR_RootConstrainSelectedInstOperands,
     /*  63313 */     // GIR_Coverage, 3914,
     /*  63313 */     GIR_EraseRootFromParent_Done,
     /*  63314 */   // Label 1313: @63314
     /*  63314 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(63404), // Rule ID 3916 //
     /*  63319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63356 */     // MIs[1] Operand 1
     /*  63356 */     // No operand predicates
     /*  63356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63362 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3568:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63379 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63402 */     GIR_RootConstrainSelectedInstOperands,
     /*  63403 */     // GIR_Coverage, 3916,
     /*  63403 */     GIR_EraseRootFromParent_Done,
     /*  63404 */   // Label 1314: @63404
     /*  63404 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(63494), // Rule ID 3918 //
     /*  63409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63446 */     // MIs[1] Operand 1
     /*  63446 */     // No operand predicates
     /*  63446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63452 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63492 */     GIR_RootConstrainSelectedInstOperands,
     /*  63493 */     // GIR_Coverage, 3918,
     /*  63493 */     GIR_EraseRootFromParent_Done,
     /*  63494 */   // Label 1315: @63494
     /*  63494 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(63584), // Rule ID 3920 //
     /*  63499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63536 */     // MIs[1] Operand 1
     /*  63536 */     // No operand predicates
     /*  63536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63542 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63582 */     GIR_RootConstrainSelectedInstOperands,
     /*  63583 */     // GIR_Coverage, 3920,
     /*  63583 */     GIR_EraseRootFromParent_Done,
     /*  63584 */   // Label 1316: @63584
     /*  63584 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(63674), // Rule ID 3922 //
     /*  63589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63626 */     // MIs[1] Operand 1
     /*  63626 */     // No operand predicates
     /*  63626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63632 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63672 */     GIR_RootConstrainSelectedInstOperands,
     /*  63673 */     // GIR_Coverage, 3922,
     /*  63673 */     GIR_EraseRootFromParent_Done,
     /*  63674 */   // Label 1317: @63674
     /*  63674 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63764), // Rule ID 3924 //
     /*  63679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63716 */     // MIs[1] Operand 1
     /*  63716 */     // No operand predicates
     /*  63716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63722 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63762 */     GIR_RootConstrainSelectedInstOperands,
     /*  63763 */     // GIR_Coverage, 3924,
     /*  63763 */     GIR_EraseRootFromParent_Done,
     /*  63764 */   // Label 1318: @63764
     /*  63764 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63853), // Rule ID 4022 //
     /*  63769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63809 */     // MIs[1] Operand 1
     /*  63809 */     // No operand predicates
     /*  63809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63811 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3487:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63851 */     GIR_RootConstrainSelectedInstOperands,
     /*  63852 */     // GIR_Coverage, 4022,
     /*  63852 */     GIR_EraseRootFromParent_Done,
     /*  63853 */   // Label 1319: @63853
     /*  63853 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63942), // Rule ID 4024 //
     /*  63858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63898 */     // MIs[1] Operand 1
     /*  63898 */     // No operand predicates
     /*  63898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63900 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3487:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63940 */     GIR_RootConstrainSelectedInstOperands,
     /*  63941 */     // GIR_Coverage, 4024,
     /*  63941 */     GIR_EraseRootFromParent_Done,
     /*  63942 */   // Label 1320: @63942
     /*  63942 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(64031), // Rule ID 4026 //
     /*  63947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63987 */     // MIs[1] Operand 1
     /*  63987 */     // No operand predicates
     /*  63987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63989 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3487:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  64004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64029 */     GIR_RootConstrainSelectedInstOperands,
     /*  64030 */     // GIR_Coverage, 4026,
     /*  64030 */     GIR_EraseRootFromParent_Done,
     /*  64031 */   // Label 1321: @64031
     /*  64031 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(64120), // Rule ID 4028 //
     /*  64036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64076 */     // MIs[1] Operand 1
     /*  64076 */     // No operand predicates
     /*  64076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64078 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3487:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64118 */     GIR_RootConstrainSelectedInstOperands,
     /*  64119 */     // GIR_Coverage, 4028,
     /*  64119 */     GIR_EraseRootFromParent_Done,
     /*  64120 */   // Label 1322: @64120
     /*  64120 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(64209), // Rule ID 4030 //
     /*  64125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64165 */     // MIs[1] Operand 1
     /*  64165 */     // No operand predicates
     /*  64165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64167 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3487:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64207 */     GIR_RootConstrainSelectedInstOperands,
     /*  64208 */     // GIR_Coverage, 4030,
     /*  64208 */     GIR_EraseRootFromParent_Done,
     /*  64209 */   // Label 1323: @64209
     /*  64209 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(64298), // Rule ID 4032 //
     /*  64214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64254 */     // MIs[1] Operand 1
     /*  64254 */     // No operand predicates
     /*  64254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3487:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64296 */     GIR_RootConstrainSelectedInstOperands,
     /*  64297 */     // GIR_Coverage, 4032,
     /*  64297 */     GIR_EraseRootFromParent_Done,
     /*  64298 */   // Label 1324: @64298
     /*  64298 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(64387), // Rule ID 4034 //
     /*  64303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64343 */     // MIs[1] Operand 1
     /*  64343 */     // No operand predicates
     /*  64343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64345 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3487:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64385 */     GIR_RootConstrainSelectedInstOperands,
     /*  64386 */     // GIR_Coverage, 4034,
     /*  64386 */     GIR_EraseRootFromParent_Done,
     /*  64387 */   // Label 1325: @64387
     /*  64387 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(64476), // Rule ID 4036 //
     /*  64392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64432 */     // MIs[1] Operand 1
     /*  64432 */     // No operand predicates
     /*  64432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3487:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64474 */     GIR_RootConstrainSelectedInstOperands,
     /*  64475 */     // GIR_Coverage, 4036,
     /*  64475 */     GIR_EraseRootFromParent_Done,
     /*  64476 */   // Label 1326: @64476
     /*  64476 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(64543), // Rule ID 3101 //
     /*  64481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64517 */     // (intrinsic_wo_chain:{ *:[i32] } 3434:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64522 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64524 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64541 */     GIR_RootConstrainSelectedInstOperands,
     /*  64542 */     // GIR_Coverage, 3101,
     /*  64542 */     GIR_EraseRootFromParent_Done,
     /*  64543 */   // Label 1327: @64543
     /*  64543 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(64610), // Rule ID 3103 //
     /*  64548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64584 */     // (intrinsic_wo_chain:{ *:[i32] } 3434:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64589 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64591 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64608 */     GIR_RootConstrainSelectedInstOperands,
     /*  64609 */     // GIR_Coverage, 3103,
     /*  64609 */     GIR_EraseRootFromParent_Done,
     /*  64610 */   // Label 1328: @64610
     /*  64610 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64677), // Rule ID 3105 //
     /*  64615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64651 */     // (intrinsic_wo_chain:{ *:[i32] } 3434:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64656 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64658 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64675 */     GIR_RootConstrainSelectedInstOperands,
     /*  64676 */     // GIR_Coverage, 3105,
     /*  64676 */     GIR_EraseRootFromParent_Done,
     /*  64677 */   // Label 1329: @64677
     /*  64677 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64744), // Rule ID 3107 //
     /*  64682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64718 */     // (intrinsic_wo_chain:{ *:[i32] } 3434:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64723 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64725 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64742 */     GIR_RootConstrainSelectedInstOperands,
     /*  64743 */     // GIR_Coverage, 3107,
     /*  64743 */     GIR_EraseRootFromParent_Done,
     /*  64744 */   // Label 1330: @64744
     /*  64744 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64811), // Rule ID 3109 //
     /*  64749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64785 */     // (intrinsic_wo_chain:{ *:[i32] } 3434:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64790 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64792 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64809 */     GIR_RootConstrainSelectedInstOperands,
     /*  64810 */     // GIR_Coverage, 3109,
     /*  64810 */     GIR_EraseRootFromParent_Done,
     /*  64811 */   // Label 1331: @64811
     /*  64811 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64878), // Rule ID 3111 //
     /*  64816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64852 */     // (intrinsic_wo_chain:{ *:[i32] } 3434:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64857 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64859 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64876 */     GIR_RootConstrainSelectedInstOperands,
     /*  64877 */     // GIR_Coverage, 3111,
     /*  64877 */     GIR_EraseRootFromParent_Done,
     /*  64878 */   // Label 1332: @64878
     /*  64878 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64945), // Rule ID 3113 //
     /*  64883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64919 */     // (intrinsic_wo_chain:{ *:[i32] } 3425:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64924 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64926 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64943 */     GIR_RootConstrainSelectedInstOperands,
     /*  64944 */     // GIR_Coverage, 3113,
     /*  64944 */     GIR_EraseRootFromParent_Done,
     /*  64945 */   // Label 1333: @64945
     /*  64945 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(65012), // Rule ID 3115 //
     /*  64950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64986 */     // (intrinsic_wo_chain:{ *:[i32] } 3425:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64991 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64993 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65010 */     GIR_RootConstrainSelectedInstOperands,
     /*  65011 */     // GIR_Coverage, 3115,
     /*  65011 */     GIR_EraseRootFromParent_Done,
     /*  65012 */   // Label 1334: @65012
     /*  65012 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(65079), // Rule ID 3117 //
     /*  65017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65053 */     // (intrinsic_wo_chain:{ *:[i32] } 3425:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65058 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65060 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65077 */     GIR_RootConstrainSelectedInstOperands,
     /*  65078 */     // GIR_Coverage, 3117,
     /*  65078 */     GIR_EraseRootFromParent_Done,
     /*  65079 */   // Label 1335: @65079
     /*  65079 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(65146), // Rule ID 3119 //
     /*  65084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65120 */     // (intrinsic_wo_chain:{ *:[i32] } 3425:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65125 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65127 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65144 */     GIR_RootConstrainSelectedInstOperands,
     /*  65145 */     // GIR_Coverage, 3119,
     /*  65145 */     GIR_EraseRootFromParent_Done,
     /*  65146 */   // Label 1336: @65146
     /*  65146 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(65213), // Rule ID 3121 //
     /*  65151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65187 */     // (intrinsic_wo_chain:{ *:[i32] } 3425:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65192 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65194 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65211 */     GIR_RootConstrainSelectedInstOperands,
     /*  65212 */     // GIR_Coverage, 3121,
     /*  65212 */     GIR_EraseRootFromParent_Done,
     /*  65213 */   // Label 1337: @65213
     /*  65213 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(65280), // Rule ID 3123 //
     /*  65218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65254 */     // (intrinsic_wo_chain:{ *:[i32] } 3425:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65259 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65261 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65278 */     GIR_RootConstrainSelectedInstOperands,
     /*  65279 */     // GIR_Coverage, 3123,
     /*  65279 */     GIR_EraseRootFromParent_Done,
     /*  65280 */   // Label 1338: @65280
     /*  65280 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(65362), // Rule ID 3528 //
     /*  65285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65321 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3471:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65360 */     GIR_RootConstrainSelectedInstOperands,
     /*  65361 */     // GIR_Coverage, 3528,
     /*  65361 */     GIR_EraseRootFromParent_Done,
     /*  65362 */   // Label 1339: @65362
     /*  65362 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(65444), // Rule ID 3535 //
     /*  65367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65403 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3471:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65442 */     GIR_RootConstrainSelectedInstOperands,
     /*  65443 */     // GIR_Coverage, 3535,
     /*  65443 */     GIR_EraseRootFromParent_Done,
     /*  65444 */   // Label 1340: @65444
     /*  65444 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(65526), // Rule ID 3539 //
     /*  65449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65485 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3471:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65524 */     GIR_RootConstrainSelectedInstOperands,
     /*  65525 */     // GIR_Coverage, 3539,
     /*  65525 */     GIR_EraseRootFromParent_Done,
     /*  65526 */   // Label 1341: @65526
     /*  65526 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(65608), // Rule ID 3543 //
     /*  65531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65567 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3471:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65606 */     GIR_RootConstrainSelectedInstOperands,
     /*  65607 */     // GIR_Coverage, 3543,
     /*  65607 */     GIR_EraseRootFromParent_Done,
     /*  65608 */   // Label 1342: @65608
     /*  65608 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65690), // Rule ID 3547 //
     /*  65613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65649 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3471:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65688 */     GIR_RootConstrainSelectedInstOperands,
     /*  65689 */     // GIR_Coverage, 3547,
     /*  65689 */     GIR_EraseRootFromParent_Done,
     /*  65690 */   // Label 1343: @65690
     /*  65690 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65772), // Rule ID 3551 //
     /*  65695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3471:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65770 */     GIR_RootConstrainSelectedInstOperands,
     /*  65771 */     // GIR_Coverage, 3551,
     /*  65771 */     GIR_EraseRootFromParent_Done,
     /*  65772 */   // Label 1344: @65772
     /*  65772 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65854), // Rule ID 3552 //
     /*  65777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65813 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3557:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65852 */     GIR_RootConstrainSelectedInstOperands,
     /*  65853 */     // GIR_Coverage, 3552,
     /*  65853 */     GIR_EraseRootFromParent_Done,
     /*  65854 */   // Label 1345: @65854
     /*  65854 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65936), // Rule ID 3559 //
     /*  65859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65895 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3557:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65934 */     GIR_RootConstrainSelectedInstOperands,
     /*  65935 */     // GIR_Coverage, 3559,
     /*  65935 */     GIR_EraseRootFromParent_Done,
     /*  65936 */   // Label 1346: @65936
     /*  65936 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(66018), // Rule ID 3563 //
     /*  65941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65977 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3557:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66016 */     GIR_RootConstrainSelectedInstOperands,
     /*  66017 */     // GIR_Coverage, 3563,
     /*  66017 */     GIR_EraseRootFromParent_Done,
     /*  66018 */   // Label 1347: @66018
     /*  66018 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(66100), // Rule ID 3567 //
     /*  66023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66059 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3557:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66098 */     GIR_RootConstrainSelectedInstOperands,
     /*  66099 */     // GIR_Coverage, 3567,
     /*  66099 */     GIR_EraseRootFromParent_Done,
     /*  66100 */   // Label 1348: @66100
     /*  66100 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(66182), // Rule ID 3571 //
     /*  66105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66141 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3557:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66180 */     GIR_RootConstrainSelectedInstOperands,
     /*  66181 */     // GIR_Coverage, 3571,
     /*  66181 */     GIR_EraseRootFromParent_Done,
     /*  66182 */   // Label 1349: @66182
     /*  66182 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(66264), // Rule ID 3575 //
     /*  66187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66223 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3557:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66262 */     GIR_RootConstrainSelectedInstOperands,
     /*  66263 */     // GIR_Coverage, 3575,
     /*  66263 */     GIR_EraseRootFromParent_Done,
     /*  66264 */   // Label 1350: @66264
     /*  66264 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(66346), // Rule ID 3576 //
     /*  66269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66305 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3506:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66344 */     GIR_RootConstrainSelectedInstOperands,
     /*  66345 */     // GIR_Coverage, 3576,
     /*  66345 */     GIR_EraseRootFromParent_Done,
     /*  66346 */   // Label 1351: @66346
     /*  66346 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(66428), // Rule ID 3583 //
     /*  66351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66387 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3506:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66426 */     GIR_RootConstrainSelectedInstOperands,
     /*  66427 */     // GIR_Coverage, 3583,
     /*  66427 */     GIR_EraseRootFromParent_Done,
     /*  66428 */   // Label 1352: @66428
     /*  66428 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(66510), // Rule ID 3587 //
     /*  66433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66469 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3506:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66508 */     GIR_RootConstrainSelectedInstOperands,
     /*  66509 */     // GIR_Coverage, 3587,
     /*  66509 */     GIR_EraseRootFromParent_Done,
     /*  66510 */   // Label 1353: @66510
     /*  66510 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(66592), // Rule ID 3591 //
     /*  66515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66551 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3506:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66590 */     GIR_RootConstrainSelectedInstOperands,
     /*  66591 */     // GIR_Coverage, 3591,
     /*  66591 */     GIR_EraseRootFromParent_Done,
     /*  66592 */   // Label 1354: @66592
     /*  66592 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66674), // Rule ID 3595 //
     /*  66597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66633 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3506:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66672 */     GIR_RootConstrainSelectedInstOperands,
     /*  66673 */     // GIR_Coverage, 3595,
     /*  66673 */     GIR_EraseRootFromParent_Done,
     /*  66674 */   // Label 1355: @66674
     /*  66674 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66756), // Rule ID 3599 //
     /*  66679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66715 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3506:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66754 */     GIR_RootConstrainSelectedInstOperands,
     /*  66755 */     // GIR_Coverage, 3599,
     /*  66755 */     GIR_EraseRootFromParent_Done,
     /*  66756 */   // Label 1356: @66756
     /*  66756 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66838), // Rule ID 3600 //
     /*  66761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66797 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3507:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66836 */     GIR_RootConstrainSelectedInstOperands,
     /*  66837 */     // GIR_Coverage, 3600,
     /*  66837 */     GIR_EraseRootFromParent_Done,
     /*  66838 */   // Label 1357: @66838
     /*  66838 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66920), // Rule ID 3603 //
     /*  66843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66879 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3507:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66918 */     GIR_RootConstrainSelectedInstOperands,
     /*  66919 */     // GIR_Coverage, 3603,
     /*  66919 */     GIR_EraseRootFromParent_Done,
     /*  66920 */   // Label 1358: @66920
     /*  66920 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(67002), // Rule ID 3606 //
     /*  66925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3507:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67000 */     GIR_RootConstrainSelectedInstOperands,
     /*  67001 */     // GIR_Coverage, 3606,
     /*  67001 */     GIR_EraseRootFromParent_Done,
     /*  67002 */   // Label 1359: @67002
     /*  67002 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(67084), // Rule ID 3609 //
     /*  67007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67043 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3507:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67082 */     GIR_RootConstrainSelectedInstOperands,
     /*  67083 */     // GIR_Coverage, 3609,
     /*  67083 */     GIR_EraseRootFromParent_Done,
     /*  67084 */   // Label 1360: @67084
     /*  67084 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(67166), // Rule ID 3612 //
     /*  67089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67125 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3507:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67164 */     GIR_RootConstrainSelectedInstOperands,
     /*  67165 */     // GIR_Coverage, 3612,
     /*  67165 */     GIR_EraseRootFromParent_Done,
     /*  67166 */   // Label 1361: @67166
     /*  67166 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(67248), // Rule ID 3615 //
     /*  67171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67207 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3507:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67246 */     GIR_RootConstrainSelectedInstOperands,
     /*  67247 */     // GIR_Coverage, 3615,
     /*  67247 */     GIR_EraseRootFromParent_Done,
     /*  67248 */   // Label 1362: @67248
     /*  67248 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(67330), // Rule ID 4016 //
     /*  67253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67289 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3471:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67328 */     GIR_RootConstrainSelectedInstOperands,
     /*  67329 */     // GIR_Coverage, 4016,
     /*  67329 */     GIR_EraseRootFromParent_Done,
     /*  67330 */   // Label 1363: @67330
     /*  67330 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(67412), // Rule ID 4018 //
     /*  67335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67371 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3471:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67410 */     GIR_RootConstrainSelectedInstOperands,
     /*  67411 */     // GIR_Coverage, 4018,
     /*  67411 */     GIR_EraseRootFromParent_Done,
     /*  67412 */   // Label 1364: @67412
     /*  67412 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(67494), // Rule ID 4391 //
     /*  67417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67453 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3534:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67492 */     GIR_RootConstrainSelectedInstOperands,
     /*  67493 */     // GIR_Coverage, 4391,
     /*  67493 */     GIR_EraseRootFromParent_Done,
     /*  67494 */   // Label 1365: @67494
     /*  67494 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(67576), // Rule ID 4393 //
     /*  67499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67535 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3534:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67574 */     GIR_RootConstrainSelectedInstOperands,
     /*  67575 */     // GIR_Coverage, 4393,
     /*  67575 */     GIR_EraseRootFromParent_Done,
     /*  67576 */   // Label 1366: @67576
     /*  67576 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(67658), // Rule ID 4395 //
     /*  67581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67617 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3534:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67656 */     GIR_RootConstrainSelectedInstOperands,
     /*  67657 */     // GIR_Coverage, 4395,
     /*  67657 */     GIR_EraseRootFromParent_Done,
     /*  67658 */   // Label 1367: @67658
     /*  67658 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67740), // Rule ID 4397 //
     /*  67663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67699 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3534:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67738 */     GIR_RootConstrainSelectedInstOperands,
     /*  67739 */     // GIR_Coverage, 4397,
     /*  67739 */     GIR_EraseRootFromParent_Done,
     /*  67740 */   // Label 1368: @67740
     /*  67740 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67822), // Rule ID 4424 //
     /*  67745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67781 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3532:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67820 */     GIR_RootConstrainSelectedInstOperands,
     /*  67821 */     // GIR_Coverage, 4424,
     /*  67821 */     GIR_EraseRootFromParent_Done,
     /*  67822 */   // Label 1369: @67822
     /*  67822 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67904), // Rule ID 4431 //
     /*  67827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67863 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3532:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67902 */     GIR_RootConstrainSelectedInstOperands,
     /*  67903 */     // GIR_Coverage, 4431,
     /*  67903 */     GIR_EraseRootFromParent_Done,
     /*  67904 */   // Label 1370: @67904
     /*  67904 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67986), // Rule ID 4435 //
     /*  67909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3532:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67984 */     GIR_RootConstrainSelectedInstOperands,
     /*  67985 */     // GIR_Coverage, 4435,
     /*  67985 */     GIR_EraseRootFromParent_Done,
     /*  67986 */   // Label 1371: @67986
     /*  67986 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(68068), // Rule ID 4439 //
     /*  67991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68027 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3532:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68066 */     GIR_RootConstrainSelectedInstOperands,
     /*  68067 */     // GIR_Coverage, 4439,
     /*  68067 */     GIR_EraseRootFromParent_Done,
     /*  68068 */   // Label 1372: @68068
     /*  68068 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(68150), // Rule ID 4443 //
     /*  68073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68109 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3532:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68148 */     GIR_RootConstrainSelectedInstOperands,
     /*  68149 */     // GIR_Coverage, 4443,
     /*  68149 */     GIR_EraseRootFromParent_Done,
     /*  68150 */   // Label 1373: @68150
     /*  68150 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(68232), // Rule ID 4447 //
     /*  68155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68191 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3532:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68230 */     GIR_RootConstrainSelectedInstOperands,
     /*  68231 */     // GIR_Coverage, 4447,
     /*  68231 */     GIR_EraseRootFromParent_Done,
     /*  68232 */   // Label 1374: @68232
     /*  68232 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(68314), // Rule ID 4448 //
     /*  68237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68273 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3567:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68312 */     GIR_RootConstrainSelectedInstOperands,
     /*  68313 */     // GIR_Coverage, 4448,
     /*  68313 */     GIR_EraseRootFromParent_Done,
     /*  68314 */   // Label 1375: @68314
     /*  68314 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(68396), // Rule ID 4450 //
     /*  68319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68355 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3567:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68394 */     GIR_RootConstrainSelectedInstOperands,
     /*  68395 */     // GIR_Coverage, 4450,
     /*  68395 */     GIR_EraseRootFromParent_Done,
     /*  68396 */   // Label 1376: @68396
     /*  68396 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(68478), // Rule ID 4452 //
     /*  68401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68437 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3567:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68476 */     GIR_RootConstrainSelectedInstOperands,
     /*  68477 */     // GIR_Coverage, 4452,
     /*  68477 */     GIR_EraseRootFromParent_Done,
     /*  68478 */   // Label 1377: @68478
     /*  68478 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(68560), // Rule ID 4454 //
     /*  68483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68519 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3567:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68558 */     GIR_RootConstrainSelectedInstOperands,
     /*  68559 */     // GIR_Coverage, 4454,
     /*  68559 */     GIR_EraseRootFromParent_Done,
     /*  68560 */   // Label 1378: @68560
     /*  68560 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(68642), // Rule ID 4456 //
     /*  68565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68601 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3567:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68640 */     GIR_RootConstrainSelectedInstOperands,
     /*  68641 */     // GIR_Coverage, 4456,
     /*  68641 */     GIR_EraseRootFromParent_Done,
     /*  68642 */   // Label 1379: @68642
     /*  68642 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68724), // Rule ID 4458 //
     /*  68647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68683 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3567:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68722 */     GIR_RootConstrainSelectedInstOperands,
     /*  68723 */     // GIR_Coverage, 4458,
     /*  68723 */     GIR_EraseRootFromParent_Done,
     /*  68724 */   // Label 1380: @68724
     /*  68724 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68791), // Rule ID 4509 //
     /*  68729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68765 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3490:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68789 */     GIR_RootConstrainSelectedInstOperands,
     /*  68790 */     // GIR_Coverage, 4509,
     /*  68790 */     GIR_EraseRootFromParent_Done,
     /*  68791 */   // Label 1381: @68791
     /*  68791 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68858), // Rule ID 4515 //
     /*  68796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68832 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3490:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68856 */     GIR_RootConstrainSelectedInstOperands,
     /*  68857 */     // GIR_Coverage, 4515,
     /*  68857 */     GIR_EraseRootFromParent_Done,
     /*  68858 */   // Label 1382: @68858
     /*  68858 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68940), // Rule ID 4533 //
     /*  68863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68899 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3542:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68938 */     GIR_RootConstrainSelectedInstOperands,
     /*  68939 */     // GIR_Coverage, 4533,
     /*  68939 */     GIR_EraseRootFromParent_Done,
     /*  68940 */   // Label 1383: @68940
     /*  68940 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(69022), // Rule ID 4535 //
     /*  68945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68981 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3542:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69020 */     GIR_RootConstrainSelectedInstOperands,
     /*  69021 */     // GIR_Coverage, 4535,
     /*  69021 */     GIR_EraseRootFromParent_Done,
     /*  69022 */   // Label 1384: @69022
     /*  69022 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(69104), // Rule ID 4537 //
     /*  69027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69063 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3542:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69102 */     GIR_RootConstrainSelectedInstOperands,
     /*  69103 */     // GIR_Coverage, 4537,
     /*  69103 */     GIR_EraseRootFromParent_Done,
     /*  69104 */   // Label 1385: @69104
     /*  69104 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(69186), // Rule ID 4539 //
     /*  69109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69145 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3542:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69184 */     GIR_RootConstrainSelectedInstOperands,
     /*  69185 */     // GIR_Coverage, 4539,
     /*  69185 */     GIR_EraseRootFromParent_Done,
     /*  69186 */   // Label 1386: @69186
     /*  69186 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(69263), // Rule ID 3884 //
     /*  69191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69232 */     // MIs[1] Operand 1
     /*  69232 */     // No operand predicates
     /*  69232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69234 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3582:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69239 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69261 */     GIR_RootConstrainSelectedInstOperands,
     /*  69262 */     // GIR_Coverage, 3884,
     /*  69262 */     GIR_EraseRootFromParent_Done,
     /*  69263 */   // Label 1387: @69263
     /*  69263 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(69340), // Rule ID 3886 //
     /*  69268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69309 */     // MIs[1] Operand 1
     /*  69309 */     // No operand predicates
     /*  69309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69311 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3582:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69316 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69338 */     GIR_RootConstrainSelectedInstOperands,
     /*  69339 */     // GIR_Coverage, 3886,
     /*  69339 */     GIR_EraseRootFromParent_Done,
     /*  69340 */   // Label 1388: @69340
     /*  69340 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(69417), // Rule ID 3888 //
     /*  69345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69386 */     // MIs[1] Operand 1
     /*  69386 */     // No operand predicates
     /*  69386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69388 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3582:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69393 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69415 */     GIR_RootConstrainSelectedInstOperands,
     /*  69416 */     // GIR_Coverage, 3888,
     /*  69416 */     GIR_EraseRootFromParent_Done,
     /*  69417 */   // Label 1389: @69417
     /*  69417 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(69494), // Rule ID 3890 //
     /*  69422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69463 */     // MIs[1] Operand 1
     /*  69463 */     // No operand predicates
     /*  69463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69465 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3584:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69470 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69492 */     GIR_RootConstrainSelectedInstOperands,
     /*  69493 */     // GIR_Coverage, 3890,
     /*  69493 */     GIR_EraseRootFromParent_Done,
     /*  69494 */   // Label 1390: @69494
     /*  69494 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(69571), // Rule ID 3892 //
     /*  69499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69540 */     // MIs[1] Operand 1
     /*  69540 */     // No operand predicates
     /*  69540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69542 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3584:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69547 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69569 */     GIR_RootConstrainSelectedInstOperands,
     /*  69570 */     // GIR_Coverage, 3892,
     /*  69570 */     GIR_EraseRootFromParent_Done,
     /*  69571 */   // Label 1391: @69571
     /*  69571 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69648), // Rule ID 3894 //
     /*  69576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69617 */     // MIs[1] Operand 1
     /*  69617 */     // No operand predicates
     /*  69617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69619 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3584:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69624 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69646 */     GIR_RootConstrainSelectedInstOperands,
     /*  69647 */     // GIR_Coverage, 3894,
     /*  69647 */     GIR_EraseRootFromParent_Done,
     /*  69648 */   // Label 1392: @69648
     /*  69648 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69739), // Rule ID 4363 //
     /*  69653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69685 */     // MIs[1] Operand 1
     /*  69685 */     // No operand predicates
     /*  69685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69695 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3481:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69737 */     GIR_RootConstrainSelectedInstOperands,
     /*  69738 */     // GIR_Coverage, 4363,
     /*  69738 */     GIR_EraseRootFromParent_Done,
     /*  69739 */   // Label 1393: @69739
     /*  69739 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69830), // Rule ID 4365 //
     /*  69744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69776 */     // MIs[1] Operand 1
     /*  69776 */     // No operand predicates
     /*  69776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69786 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3481:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69828 */     GIR_RootConstrainSelectedInstOperands,
     /*  69829 */     // GIR_Coverage, 4365,
     /*  69829 */     GIR_EraseRootFromParent_Done,
     /*  69830 */   // Label 1394: @69830
     /*  69830 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69893), // Rule ID 146 //
     /*  69835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69871 */     // (intrinsic_wo_chain:{ *:[i32] } 3814:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69891 */     GIR_RootConstrainSelectedInstOperands,
     /*  69892 */     // GIR_Coverage, 146,
     /*  69892 */     GIR_EraseRootFromParent_Done,
     /*  69893 */   // Label 1395: @69893
     /*  69893 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69956), // Rule ID 469 //
     /*  69898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69934 */     // (intrinsic_wo_chain:{ *:[i32] } 3814:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69954 */     GIR_RootConstrainSelectedInstOperands,
     /*  69955 */     // GIR_Coverage, 469,
     /*  69955 */     GIR_EraseRootFromParent_Done,
     /*  69956 */   // Label 1396: @69956
     /*  69956 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(70019), // Rule ID 528 //
     /*  69961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69997 */     // (intrinsic_wo_chain:{ *:[i32] } 3759:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  70000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70017 */     GIR_RootConstrainSelectedInstOperands,
     /*  70018 */     // GIR_Coverage, 528,
     /*  70018 */     GIR_EraseRootFromParent_Done,
     /*  70019 */   // Label 1397: @70019
     /*  70019 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(70082), // Rule ID 529 //
     /*  70024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70060 */     // (intrinsic_wo_chain:{ *:[i32] } 3760:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70080 */     GIR_RootConstrainSelectedInstOperands,
     /*  70081 */     // GIR_Coverage, 529,
     /*  70081 */     GIR_EraseRootFromParent_Done,
     /*  70082 */   // Label 1398: @70082
     /*  70082 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(70145), // Rule ID 530 //
     /*  70087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70123 */     // (intrinsic_wo_chain:{ *:[i32] } 3767:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70143 */     GIR_RootConstrainSelectedInstOperands,
     /*  70144 */     // GIR_Coverage, 530,
     /*  70144 */     GIR_EraseRootFromParent_Done,
     /*  70145 */   // Label 1399: @70145
     /*  70145 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(70208), // Rule ID 531 //
     /*  70150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70186 */     // (intrinsic_wo_chain:{ *:[i32] } 3768:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70206 */     GIR_RootConstrainSelectedInstOperands,
     /*  70207 */     // GIR_Coverage, 531,
     /*  70207 */     GIR_EraseRootFromParent_Done,
     /*  70208 */   // Label 1400: @70208
     /*  70208 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(70262), // Rule ID 948 //
     /*  70213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70249 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3614:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70260 */     GIR_RootConstrainSelectedInstOperands,
     /*  70261 */     // GIR_Coverage, 948,
     /*  70261 */     GIR_EraseRootFromParent_Done,
     /*  70262 */   // Label 1401: @70262
     /*  70262 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(70316), // Rule ID 949 //
     /*  70267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70303 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3602:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70314 */     GIR_RootConstrainSelectedInstOperands,
     /*  70315 */     // GIR_Coverage, 949,
     /*  70315 */     GIR_EraseRootFromParent_Done,
     /*  70316 */   // Label 1402: @70316
     /*  70316 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(70370), // Rule ID 950 //
     /*  70321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70357 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3614:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70368 */     GIR_RootConstrainSelectedInstOperands,
     /*  70369 */     // GIR_Coverage, 950,
     /*  70369 */     GIR_EraseRootFromParent_Done,
     /*  70370 */   // Label 1403: @70370
     /*  70370 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(70424), // Rule ID 951 //
     /*  70375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70411 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3602:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70422 */     GIR_RootConstrainSelectedInstOperands,
     /*  70423 */     // GIR_Coverage, 951,
     /*  70423 */     GIR_EraseRootFromParent_Done,
     /*  70424 */   // Label 1404: @70424
     /*  70424 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(70478), // Rule ID 952 //
     /*  70429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70465 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3613:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70476 */     GIR_RootConstrainSelectedInstOperands,
     /*  70477 */     // GIR_Coverage, 952,
     /*  70477 */     GIR_EraseRootFromParent_Done,
     /*  70478 */   // Label 1405: @70478
     /*  70478 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70532), // Rule ID 953 //
     /*  70483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70519 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70530 */     GIR_RootConstrainSelectedInstOperands,
     /*  70531 */     // GIR_Coverage, 953,
     /*  70531 */     GIR_EraseRootFromParent_Done,
     /*  70532 */   // Label 1406: @70532
     /*  70532 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70586), // Rule ID 954 //
     /*  70537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70573 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3617:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70584 */     GIR_RootConstrainSelectedInstOperands,
     /*  70585 */     // GIR_Coverage, 954,
     /*  70585 */     GIR_EraseRootFromParent_Done,
     /*  70586 */   // Label 1407: @70586
     /*  70586 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70640), // Rule ID 955 //
     /*  70591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70627 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3616:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70638 */     GIR_RootConstrainSelectedInstOperands,
     /*  70639 */     // GIR_Coverage, 955,
     /*  70639 */     GIR_EraseRootFromParent_Done,
     /*  70640 */   // Label 1408: @70640
     /*  70640 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70694), // Rule ID 956 //
     /*  70645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70681 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70692 */     GIR_RootConstrainSelectedInstOperands,
     /*  70693 */     // GIR_Coverage, 956,
     /*  70693 */     GIR_EraseRootFromParent_Done,
     /*  70694 */   // Label 1409: @70694
     /*  70694 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70757), // Rule ID 1687 //
     /*  70699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70735 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3734:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70740 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70755 */     GIR_RootConstrainSelectedInstOperands,
     /*  70756 */     // GIR_Coverage, 1687,
     /*  70756 */     GIR_EraseRootFromParent_Done,
     /*  70757 */   // Label 1410: @70757
     /*  70757 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70811), // Rule ID 1718 //
     /*  70762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3607:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70809 */     GIR_RootConstrainSelectedInstOperands,
     /*  70810 */     // GIR_Coverage, 1718,
     /*  70810 */     GIR_EraseRootFromParent_Done,
     /*  70811 */   // Label 1411: @70811
     /*  70811 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70865), // Rule ID 1719 //
     /*  70816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70852 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3609:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70863 */     GIR_RootConstrainSelectedInstOperands,
     /*  70864 */     // GIR_Coverage, 1719,
     /*  70864 */     GIR_EraseRootFromParent_Done,
     /*  70865 */   // Label 1412: @70865
     /*  70865 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70919), // Rule ID 1720 //
     /*  70870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70906 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3610:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70917 */     GIR_RootConstrainSelectedInstOperands,
     /*  70918 */     // GIR_Coverage, 1720,
     /*  70918 */     GIR_EraseRootFromParent_Done,
     /*  70919 */   // Label 1413: @70919
     /*  70919 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70973), // Rule ID 1721 //
     /*  70924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70960 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3612:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70971 */     GIR_RootConstrainSelectedInstOperands,
     /*  70972 */     // GIR_Coverage, 1721,
     /*  70972 */     GIR_EraseRootFromParent_Done,
     /*  70973 */   // Label 1414: @70973
     /*  70973 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(71036), // Rule ID 1896 //
     /*  70978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71014 */     // (intrinsic_wo_chain:{ *:[i32] } 3759:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  71017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71034 */     GIR_RootConstrainSelectedInstOperands,
     /*  71035 */     // GIR_Coverage, 1896,
     /*  71035 */     GIR_EraseRootFromParent_Done,
     /*  71036 */   // Label 1415: @71036
     /*  71036 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(71099), // Rule ID 1897 //
     /*  71041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71077 */     // (intrinsic_wo_chain:{ *:[i32] } 3760:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71097 */     GIR_RootConstrainSelectedInstOperands,
     /*  71098 */     // GIR_Coverage, 1897,
     /*  71098 */     GIR_EraseRootFromParent_Done,
     /*  71099 */   // Label 1416: @71099
     /*  71099 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(71162), // Rule ID 1898 //
     /*  71104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71140 */     // (intrinsic_wo_chain:{ *:[i32] } 3767:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71160 */     GIR_RootConstrainSelectedInstOperands,
     /*  71161 */     // GIR_Coverage, 1898,
     /*  71161 */     GIR_EraseRootFromParent_Done,
     /*  71162 */   // Label 1417: @71162
     /*  71162 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(71225), // Rule ID 1899 //
     /*  71167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71203 */     // (intrinsic_wo_chain:{ *:[i32] } 3768:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71223 */     GIR_RootConstrainSelectedInstOperands,
     /*  71224 */     // GIR_Coverage, 1899,
     /*  71224 */     GIR_EraseRootFromParent_Done,
     /*  71225 */   // Label 1418: @71225
     /*  71225 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(71288), // Rule ID 1985 //
     /*  71230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71266 */     // (intrinsic_wo_chain:{ *:[i32] } 3757:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71271 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71273 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71275 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71286 */     GIR_RootConstrainSelectedInstOperands,
     /*  71287 */     // GIR_Coverage, 1985,
     /*  71287 */     GIR_EraseRootFromParent_Done,
     /*  71288 */   // Label 1419: @71288
     /*  71288 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(71351), // Rule ID 1986 //
     /*  71293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71329 */     // (intrinsic_wo_chain:{ *:[i32] } 3758:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71334 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71336 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71338 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71349 */     GIR_RootConstrainSelectedInstOperands,
     /*  71350 */     // GIR_Coverage, 1986,
     /*  71350 */     GIR_EraseRootFromParent_Done,
     /*  71351 */   // Label 1420: @71351
     /*  71351 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(71414), // Rule ID 1987 //
     /*  71356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71392 */     // (intrinsic_wo_chain:{ *:[i32] } 3763:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71397 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71399 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71401 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71412 */     GIR_RootConstrainSelectedInstOperands,
     /*  71413 */     // GIR_Coverage, 1987,
     /*  71413 */     GIR_EraseRootFromParent_Done,
     /*  71414 */   // Label 1421: @71414
     /*  71414 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(71477), // Rule ID 1988 //
     /*  71419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71455 */     // (intrinsic_wo_chain:{ *:[i32] } 3764:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71460 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71462 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71464 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71475 */     GIR_RootConstrainSelectedInstOperands,
     /*  71476 */     // GIR_Coverage, 1988,
     /*  71476 */     GIR_EraseRootFromParent_Done,
     /*  71477 */   // Label 1422: @71477
     /*  71477 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(71540), // Rule ID 1989 //
     /*  71482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71518 */     // (intrinsic_wo_chain:{ *:[i32] } 3765:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71523 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71525 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71527 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71538 */     GIR_RootConstrainSelectedInstOperands,
     /*  71539 */     // GIR_Coverage, 1989,
     /*  71539 */     GIR_EraseRootFromParent_Done,
     /*  71540 */   // Label 1423: @71540
     /*  71540 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71603), // Rule ID 1990 //
     /*  71545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71581 */     // (intrinsic_wo_chain:{ *:[i32] } 3766:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71586 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71588 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71590 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71601 */     GIR_RootConstrainSelectedInstOperands,
     /*  71602 */     // GIR_Coverage, 1990,
     /*  71602 */     GIR_EraseRootFromParent_Done,
     /*  71603 */   // Label 1424: @71603
     /*  71603 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71666), // Rule ID 2169 //
     /*  71608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71644 */     // (intrinsic_wo_chain:{ *:[i32] } 3757:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71649 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71651 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71653 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71664 */     GIR_RootConstrainSelectedInstOperands,
     /*  71665 */     // GIR_Coverage, 2169,
     /*  71665 */     GIR_EraseRootFromParent_Done,
     /*  71666 */   // Label 1425: @71666
     /*  71666 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71729), // Rule ID 2170 //
     /*  71671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71707 */     // (intrinsic_wo_chain:{ *:[i32] } 3758:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71712 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71714 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71716 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71727 */     GIR_RootConstrainSelectedInstOperands,
     /*  71728 */     // GIR_Coverage, 2170,
     /*  71728 */     GIR_EraseRootFromParent_Done,
     /*  71729 */   // Label 1426: @71729
     /*  71729 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71792), // Rule ID 2171 //
     /*  71734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71770 */     // (intrinsic_wo_chain:{ *:[i32] } 3763:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71775 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71777 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71779 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71790 */     GIR_RootConstrainSelectedInstOperands,
     /*  71791 */     // GIR_Coverage, 2171,
     /*  71791 */     GIR_EraseRootFromParent_Done,
     /*  71792 */   // Label 1427: @71792
     /*  71792 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71855), // Rule ID 2172 //
     /*  71797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71833 */     // (intrinsic_wo_chain:{ *:[i32] } 3764:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71838 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71840 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71842 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71853 */     GIR_RootConstrainSelectedInstOperands,
     /*  71854 */     // GIR_Coverage, 2172,
     /*  71854 */     GIR_EraseRootFromParent_Done,
     /*  71855 */   // Label 1428: @71855
     /*  71855 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71918), // Rule ID 2173 //
     /*  71860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71896 */     // (intrinsic_wo_chain:{ *:[i32] } 3765:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71901 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71903 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71905 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71916 */     GIR_RootConstrainSelectedInstOperands,
     /*  71917 */     // GIR_Coverage, 2173,
     /*  71917 */     GIR_EraseRootFromParent_Done,
     /*  71918 */   // Label 1429: @71918
     /*  71918 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71981), // Rule ID 2174 //
     /*  71923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71959 */     // (intrinsic_wo_chain:{ *:[i32] } 3766:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71964 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71966 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71968 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71979 */     GIR_RootConstrainSelectedInstOperands,
     /*  71980 */     // GIR_Coverage, 2174,
     /*  71980 */     GIR_EraseRootFromParent_Done,
     /*  71981 */   // Label 1430: @71981
     /*  71981 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(72044), // Rule ID 2452 //
     /*  71986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72022 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3686:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  72025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72027 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72042 */     GIR_RootConstrainSelectedInstOperands,
     /*  72043 */     // GIR_Coverage, 2452,
     /*  72043 */     GIR_EraseRootFromParent_Done,
     /*  72044 */   // Label 1431: @72044
     /*  72044 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(72107), // Rule ID 2453 //
     /*  72049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72085 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3686:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72090 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72105 */     GIR_RootConstrainSelectedInstOperands,
     /*  72106 */     // GIR_Coverage, 2453,
     /*  72106 */     GIR_EraseRootFromParent_Done,
     /*  72107 */   // Label 1432: @72107
     /*  72107 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(72170), // Rule ID 2454 //
     /*  72112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72148 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3686:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72168 */     GIR_RootConstrainSelectedInstOperands,
     /*  72169 */     // GIR_Coverage, 2454,
     /*  72169 */     GIR_EraseRootFromParent_Done,
     /*  72170 */   // Label 1433: @72170
     /*  72170 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(72233), // Rule ID 2455 //
     /*  72175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72211 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3686:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72231 */     GIR_RootConstrainSelectedInstOperands,
     /*  72232 */     // GIR_Coverage, 2455,
     /*  72232 */     GIR_EraseRootFromParent_Done,
     /*  72233 */   // Label 1434: @72233
     /*  72233 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(72296), // Rule ID 2460 //
     /*  72238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72274 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3687:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72294 */     GIR_RootConstrainSelectedInstOperands,
     /*  72295 */     // GIR_Coverage, 2460,
     /*  72295 */     GIR_EraseRootFromParent_Done,
     /*  72296 */   // Label 1435: @72296
     /*  72296 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(72359), // Rule ID 2461 //
     /*  72301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72337 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3687:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72342 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72357 */     GIR_RootConstrainSelectedInstOperands,
     /*  72358 */     // GIR_Coverage, 2461,
     /*  72358 */     GIR_EraseRootFromParent_Done,
     /*  72359 */   // Label 1436: @72359
     /*  72359 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(72422), // Rule ID 2462 //
     /*  72364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72400 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3687:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72405 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72420 */     GIR_RootConstrainSelectedInstOperands,
     /*  72421 */     // GIR_Coverage, 2462,
     /*  72421 */     GIR_EraseRootFromParent_Done,
     /*  72422 */   // Label 1437: @72422
     /*  72422 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(72485), // Rule ID 2463 //
     /*  72427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72463 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 2463,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1438: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(72554), // Rule ID 4820 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72526 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3537:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72531 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72533 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72535 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72552 */     GIR_RootConstrainSelectedInstOperands,
     /*  72553 */     // GIR_Coverage, 4820,
     /*  72553 */     GIR_EraseRootFromParent_Done,
     /*  72554 */   // Label 1439: @72554
     /*  72554 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72623), // Rule ID 4822 //
     /*  72559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72595 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3537:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72600 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72602 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72604 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72621 */     GIR_RootConstrainSelectedInstOperands,
     /*  72622 */     // GIR_Coverage, 4822,
     /*  72622 */     GIR_EraseRootFromParent_Done,
     /*  72623 */   // Label 1440: @72623
     /*  72623 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72692), // Rule ID 4824 //
     /*  72628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72664 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3537:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72669 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72671 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72673 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72690 */     GIR_RootConstrainSelectedInstOperands,
     /*  72691 */     // GIR_Coverage, 4824,
     /*  72691 */     GIR_EraseRootFromParent_Done,
     /*  72692 */   // Label 1441: @72692
     /*  72692 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72761), // Rule ID 4826 //
     /*  72697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72733 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3546:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72738 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72740 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72742 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72759 */     GIR_RootConstrainSelectedInstOperands,
     /*  72760 */     // GIR_Coverage, 4826,
     /*  72760 */     GIR_EraseRootFromParent_Done,
     /*  72761 */   // Label 1442: @72761
     /*  72761 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72830), // Rule ID 4828 //
     /*  72766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72802 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3546:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72807 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72809 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72811 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72828 */     GIR_RootConstrainSelectedInstOperands,
     /*  72829 */     // GIR_Coverage, 4828,
     /*  72829 */     GIR_EraseRootFromParent_Done,
     /*  72830 */   // Label 1443: @72830
     /*  72830 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72899), // Rule ID 4830 //
     /*  72835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3546:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72876 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72878 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72880 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72897 */     GIR_RootConstrainSelectedInstOperands,
     /*  72898 */     // GIR_Coverage, 4830,
     /*  72898 */     GIR_EraseRootFromParent_Done,
     /*  72899 */   // Label 1444: @72899
     /*  72899 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72968), // Rule ID 4832 //
     /*  72904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72940 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3539:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72945 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72947 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72949 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72966 */     GIR_RootConstrainSelectedInstOperands,
     /*  72967 */     // GIR_Coverage, 4832,
     /*  72967 */     GIR_EraseRootFromParent_Done,
     /*  72968 */   // Label 1445: @72968
     /*  72968 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(73037), // Rule ID 4834 //
     /*  72973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73009 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3539:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  73012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73014 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73016 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73018 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73035 */     GIR_RootConstrainSelectedInstOperands,
     /*  73036 */     // GIR_Coverage, 4834,
     /*  73036 */     GIR_EraseRootFromParent_Done,
     /*  73037 */   // Label 1446: @73037
     /*  73037 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(73106), // Rule ID 4836 //
     /*  73042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73078 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3539:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73083 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73085 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73087 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73104 */     GIR_RootConstrainSelectedInstOperands,
     /*  73105 */     // GIR_Coverage, 4836,
     /*  73105 */     GIR_EraseRootFromParent_Done,
     /*  73106 */   // Label 1447: @73106
     /*  73106 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(73175), // Rule ID 4838 //
     /*  73111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73147 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3548:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73152 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73154 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73156 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73173 */     GIR_RootConstrainSelectedInstOperands,
     /*  73174 */     // GIR_Coverage, 4838,
     /*  73174 */     GIR_EraseRootFromParent_Done,
     /*  73175 */   // Label 1448: @73175
     /*  73175 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(73244), // Rule ID 4840 //
     /*  73180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73216 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3548:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73221 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73223 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73225 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73242 */     GIR_RootConstrainSelectedInstOperands,
     /*  73243 */     // GIR_Coverage, 4840,
     /*  73243 */     GIR_EraseRootFromParent_Done,
     /*  73244 */   // Label 1449: @73244
     /*  73244 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(73313), // Rule ID 4842 //
     /*  73249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73285 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3548:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73290 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73292 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73294 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73311 */     GIR_RootConstrainSelectedInstOperands,
     /*  73312 */     // GIR_Coverage, 4842,
     /*  73312 */     GIR_EraseRootFromParent_Done,
     /*  73313 */   // Label 1450: @73313
     /*  73313 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(73408), // Rule ID 2674 //
     /*  73318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73342 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73399 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73404 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73406 */     GIR_RootConstrainSelectedInstOperands,
     /*  73407 */     // GIR_Coverage, 2674,
     /*  73407 */     GIR_EraseRootFromParent_Done,
     /*  73408 */   // Label 1451: @73408
     /*  73408 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(73503), // Rule ID 2675 //
     /*  73413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73437 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73437 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73440 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73444 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73449 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73453 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73494 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73499 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73501 */     GIR_RootConstrainSelectedInstOperands,
     /*  73502 */     // GIR_Coverage, 2675,
     /*  73502 */     GIR_EraseRootFromParent_Done,
     /*  73503 */   // Label 1452: @73503
     /*  73503 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(73598), // Rule ID 2676 //
     /*  73508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3606:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73544 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73568 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73589 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73594 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73596 */     GIR_RootConstrainSelectedInstOperands,
     /*  73597 */     // GIR_Coverage, 2676,
     /*  73597 */     GIR_EraseRootFromParent_Done,
     /*  73598 */   // Label 1453: @73598
     /*  73598 */   GIM_Reject,
     /*  73599 */ // Label 1306: @73599
     /*  73599 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(76985),
     /*  73604 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73607 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73691), // Rule ID 3707 //
     /*  73612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3578:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73689 */     GIR_RootConstrainSelectedInstOperands,
     /*  73690 */     // GIR_Coverage, 3707,
     /*  73690 */     GIR_EraseRootFromParent_Done,
     /*  73691 */   // Label 1455: @73691
     /*  73691 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73775), // Rule ID 3711 //
     /*  73696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73736 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3578:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73773 */     GIR_RootConstrainSelectedInstOperands,
     /*  73774 */     // GIR_Coverage, 3711,
     /*  73774 */     GIR_EraseRootFromParent_Done,
     /*  73775 */   // Label 1456: @73775
     /*  73775 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73859), // Rule ID 3715 //
     /*  73780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73820 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3578:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73857 */     GIR_RootConstrainSelectedInstOperands,
     /*  73858 */     // GIR_Coverage, 3715,
     /*  73858 */     GIR_EraseRootFromParent_Done,
     /*  73859 */   // Label 1457: @73859
     /*  73859 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73943), // Rule ID 3719 //
     /*  73864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3578:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73941 */     GIR_RootConstrainSelectedInstOperands,
     /*  73942 */     // GIR_Coverage, 3719,
     /*  73942 */     GIR_EraseRootFromParent_Done,
     /*  73943 */   // Label 1458: @73943
     /*  73943 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(74027), // Rule ID 3723 //
     /*  73948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73988 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3578:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  74003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74025 */     GIR_RootConstrainSelectedInstOperands,
     /*  74026 */     // GIR_Coverage, 3723,
     /*  74026 */     GIR_EraseRootFromParent_Done,
     /*  74027 */   // Label 1459: @74027
     /*  74027 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(74111), // Rule ID 3727 //
     /*  74032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74072 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3578:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74109 */     GIR_RootConstrainSelectedInstOperands,
     /*  74110 */     // GIR_Coverage, 3727,
     /*  74110 */     GIR_EraseRootFromParent_Done,
     /*  74111 */   // Label 1460: @74111
     /*  74111 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(74195), // Rule ID 3731 //
     /*  74116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74156 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3578:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74193 */     GIR_RootConstrainSelectedInstOperands,
     /*  74194 */     // GIR_Coverage, 3731,
     /*  74194 */     GIR_EraseRootFromParent_Done,
     /*  74195 */   // Label 1461: @74195
     /*  74195 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(74279), // Rule ID 3735 //
     /*  74200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74240 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3578:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74277 */     GIR_RootConstrainSelectedInstOperands,
     /*  74278 */     // GIR_Coverage, 3735,
     /*  74278 */     GIR_EraseRootFromParent_Done,
     /*  74279 */   // Label 1462: @74279
     /*  74279 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(74368), // Rule ID 4367 //
     /*  74284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74327 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3533:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74366 */     GIR_RootConstrainSelectedInstOperands,
     /*  74367 */     // GIR_Coverage, 4367,
     /*  74367 */     GIR_EraseRootFromParent_Done,
     /*  74368 */   // Label 1463: @74368
     /*  74368 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(74457), // Rule ID 4369 //
     /*  74373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3533:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74455 */     GIR_RootConstrainSelectedInstOperands,
     /*  74456 */     // GIR_Coverage, 4369,
     /*  74456 */     GIR_EraseRootFromParent_Done,
     /*  74457 */   // Label 1464: @74457
     /*  74457 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(74546), // Rule ID 4371 //
     /*  74462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74505 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3533:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74544 */     GIR_RootConstrainSelectedInstOperands,
     /*  74545 */     // GIR_Coverage, 4371,
     /*  74545 */     GIR_EraseRootFromParent_Done,
     /*  74546 */   // Label 1465: @74546
     /*  74546 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(74635), // Rule ID 4373 //
     /*  74551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74594 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3533:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 4373,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1466: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74724), // Rule ID 4375 //
     /*  74640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74683 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3533:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74722 */     GIR_RootConstrainSelectedInstOperands,
     /*  74723 */     // GIR_Coverage, 4375,
     /*  74723 */     GIR_EraseRootFromParent_Done,
     /*  74724 */   // Label 1467: @74724
     /*  74724 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74813), // Rule ID 4377 //
     /*  74729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74772 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3533:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74811 */     GIR_RootConstrainSelectedInstOperands,
     /*  74812 */     // GIR_Coverage, 4377,
     /*  74812 */     GIR_EraseRootFromParent_Done,
     /*  74813 */   // Label 1468: @74813
     /*  74813 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74902), // Rule ID 4379 //
     /*  74818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74861 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3533:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74900 */     GIR_RootConstrainSelectedInstOperands,
     /*  74901 */     // GIR_Coverage, 4379,
     /*  74901 */     GIR_EraseRootFromParent_Done,
     /*  74902 */   // Label 1469: @74902
     /*  74902 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74991), // Rule ID 4381 //
     /*  74907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74950 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3533:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74989 */     GIR_RootConstrainSelectedInstOperands,
     /*  74990 */     // GIR_Coverage, 4381,
     /*  74990 */     GIR_EraseRootFromParent_Done,
     /*  74991 */   // Label 1470: @74991
     /*  74991 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(75080), // Rule ID 4383 //
     /*  74996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3533:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75078 */     GIR_RootConstrainSelectedInstOperands,
     /*  75079 */     // GIR_Coverage, 4383,
     /*  75079 */     GIR_EraseRootFromParent_Done,
     /*  75080 */   // Label 1471: @75080
     /*  75080 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(75169), // Rule ID 4385 //
     /*  75085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3533:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75167 */     GIR_RootConstrainSelectedInstOperands,
     /*  75168 */     // GIR_Coverage, 4385,
     /*  75168 */     GIR_EraseRootFromParent_Done,
     /*  75169 */   // Label 1472: @75169
     /*  75169 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(75258), // Rule ID 4387 //
     /*  75174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75217 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3533:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75256 */     GIR_RootConstrainSelectedInstOperands,
     /*  75257 */     // GIR_Coverage, 4387,
     /*  75257 */     GIR_EraseRootFromParent_Done,
     /*  75258 */   // Label 1473: @75258
     /*  75258 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(75347), // Rule ID 4389 //
     /*  75263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75306 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3533:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75345 */     GIR_RootConstrainSelectedInstOperands,
     /*  75346 */     // GIR_Coverage, 4389,
     /*  75346 */     GIR_EraseRootFromParent_Done,
     /*  75347 */   // Label 1474: @75347
     /*  75347 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(75445), // Rule ID 4012 //
     /*  75352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75391 */     // MIs[1] Operand 1
     /*  75391 */     // No operand predicates
     /*  75391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75401 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3476:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75420 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 4012,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 1475: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(75543), // Rule ID 4014 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75489 */     // MIs[1] Operand 1
     /*  75489 */     // No operand predicates
     /*  75489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75499 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3476:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75518 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75541 */     GIR_RootConstrainSelectedInstOperands,
     /*  75542 */     // GIR_Coverage, 4014,
     /*  75542 */     GIR_EraseRootFromParent_Done,
     /*  75543 */   // Label 1476: @75543
     /*  75543 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(75641), // Rule ID 4521 //
     /*  75548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75587 */     // MIs[1] Operand 1
     /*  75587 */     // No operand predicates
     /*  75587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75597 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3476:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75639 */     GIR_RootConstrainSelectedInstOperands,
     /*  75640 */     // GIR_Coverage, 4521,
     /*  75640 */     GIR_EraseRootFromParent_Done,
     /*  75641 */   // Label 1477: @75641
     /*  75641 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(75739), // Rule ID 4523 //
     /*  75646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75685 */     // MIs[1] Operand 1
     /*  75685 */     // No operand predicates
     /*  75685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3476:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75737 */     GIR_RootConstrainSelectedInstOperands,
     /*  75738 */     // GIR_Coverage, 4523,
     /*  75738 */     GIR_EraseRootFromParent_Done,
     /*  75739 */   // Label 1478: @75739
     /*  75739 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75837), // Rule ID 4525 //
     /*  75744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75783 */     // MIs[1] Operand 1
     /*  75783 */     // No operand predicates
     /*  75783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75793 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3476:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75812 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75835 */     GIR_RootConstrainSelectedInstOperands,
     /*  75836 */     // GIR_Coverage, 4525,
     /*  75836 */     GIR_EraseRootFromParent_Done,
     /*  75837 */   // Label 1479: @75837
     /*  75837 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75935), // Rule ID 4527 //
     /*  75842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75881 */     // MIs[1] Operand 1
     /*  75881 */     // No operand predicates
     /*  75881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75891 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3476:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75910 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75933 */     GIR_RootConstrainSelectedInstOperands,
     /*  75934 */     // GIR_Coverage, 4527,
     /*  75934 */     GIR_EraseRootFromParent_Done,
     /*  75935 */   // Label 1480: @75935
     /*  75935 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(76033), // Rule ID 4529 //
     /*  75940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75979 */     // MIs[1] Operand 1
     /*  75979 */     // No operand predicates
     /*  75979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75989 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3476:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  76004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76008 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76031 */     GIR_RootConstrainSelectedInstOperands,
     /*  76032 */     // GIR_Coverage, 4529,
     /*  76032 */     GIR_EraseRootFromParent_Done,
     /*  76033 */   // Label 1481: @76033
     /*  76033 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(76131), // Rule ID 4531 //
     /*  76038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76077 */     // MIs[1] Operand 1
     /*  76077 */     // No operand predicates
     /*  76077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76087 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3476:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76106 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76129 */     GIR_RootConstrainSelectedInstOperands,
     /*  76130 */     // GIR_Coverage, 4531,
     /*  76130 */     GIR_EraseRootFromParent_Done,
     /*  76131 */   // Label 1482: @76131
     /*  76131 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(76207), // Rule ID 3017 //
     /*  76136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76179 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76188 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76205 */     GIR_RootConstrainSelectedInstOperands,
     /*  76206 */     // GIR_Coverage, 3017,
     /*  76206 */     GIR_EraseRootFromParent_Done,
     /*  76207 */   // Label 1483: @76207
     /*  76207 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(76283), // Rule ID 3019 //
     /*  76212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76255 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76264 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76281 */     GIR_RootConstrainSelectedInstOperands,
     /*  76282 */     // GIR_Coverage, 3019,
     /*  76282 */     GIR_EraseRootFromParent_Done,
     /*  76283 */   // Label 1484: @76283
     /*  76283 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(76359), // Rule ID 3021 //
     /*  76288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76331 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76340 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76357 */     GIR_RootConstrainSelectedInstOperands,
     /*  76358 */     // GIR_Coverage, 3021,
     /*  76358 */     GIR_EraseRootFromParent_Done,
     /*  76359 */   // Label 1485: @76359
     /*  76359 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(76435), // Rule ID 3023 //
     /*  76364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76407 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76416 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76421 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76433 */     GIR_RootConstrainSelectedInstOperands,
     /*  76434 */     // GIR_Coverage, 3023,
     /*  76434 */     GIR_EraseRootFromParent_Done,
     /*  76435 */   // Label 1486: @76435
     /*  76435 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(76511), // Rule ID 3025 //
     /*  76440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76483 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76492 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76509 */     GIR_RootConstrainSelectedInstOperands,
     /*  76510 */     // GIR_Coverage, 3025,
     /*  76510 */     GIR_EraseRootFromParent_Done,
     /*  76511 */   // Label 1487: @76511
     /*  76511 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(76587), // Rule ID 3027 //
     /*  76516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76559 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76585 */     GIR_RootConstrainSelectedInstOperands,
     /*  76586 */     // GIR_Coverage, 3027,
     /*  76586 */     GIR_EraseRootFromParent_Done,
     /*  76587 */   // Label 1488: @76587
     /*  76587 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(76672), // Rule ID 3976 //
     /*  76592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76627 */     // MIs[1] Operand 1
     /*  76627 */     // No operand predicates
     /*  76627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76641 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3479:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76650 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76670 */     GIR_RootConstrainSelectedInstOperands,
     /*  76671 */     // GIR_Coverage, 3976,
     /*  76671 */     GIR_EraseRootFromParent_Done,
     /*  76672 */   // Label 1489: @76672
     /*  76672 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76757), // Rule ID 3979 //
     /*  76677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76712 */     // MIs[1] Operand 1
     /*  76712 */     // No operand predicates
     /*  76712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76726 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3479:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76755 */     GIR_RootConstrainSelectedInstOperands,
     /*  76756 */     // GIR_Coverage, 3979,
     /*  76756 */     GIR_EraseRootFromParent_Done,
     /*  76757 */   // Label 1490: @76757
     /*  76757 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76853), // Rule ID 2668 //
     /*  76762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76789 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3735:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76805 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76812 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76835 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76840 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76851 */     GIR_RootConstrainSelectedInstOperands,
     /*  76852 */     // GIR_Coverage, 2668,
     /*  76852 */     GIR_EraseRootFromParent_Done,
     /*  76853 */   // Label 1491: @76853
     /*  76853 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76984), // Rule ID 2669 //
     /*  76858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76885 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3732:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76885 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76888 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76892 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76915 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76922 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76929 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76932 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76935 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76971 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76982 */     GIR_RootConstrainSelectedInstOperands,
     /*  76983 */     // GIR_Coverage, 2669,
     /*  76983 */     GIR_EraseRootFromParent_Done,
     /*  76984 */   // Label 1492: @76984
     /*  76984 */   GIM_Reject,
     /*  76985 */ // Label 1454: @76985
     /*  76985 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(82291),
     /*  76990 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76993 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(77086), // Rule ID 3818 //
     /*  76998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77045 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77062 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77064 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77084 */     GIR_RootConstrainSelectedInstOperands,
     /*  77085 */     // GIR_Coverage, 3818,
     /*  77085 */     GIR_EraseRootFromParent_Done,
     /*  77086 */   // Label 1494: @77086
     /*  77086 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(77179), // Rule ID 3820 //
     /*  77091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77138 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77155 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77157 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77177 */     GIR_RootConstrainSelectedInstOperands,
     /*  77178 */     // GIR_Coverage, 3820,
     /*  77178 */     GIR_EraseRootFromParent_Done,
     /*  77179 */   // Label 1495: @77179
     /*  77179 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(77272), // Rule ID 3822 //
     /*  77184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77231 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77248 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77250 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77270 */     GIR_RootConstrainSelectedInstOperands,
     /*  77271 */     // GIR_Coverage, 3822,
     /*  77271 */     GIR_EraseRootFromParent_Done,
     /*  77272 */   // Label 1496: @77272
     /*  77272 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(77365), // Rule ID 3824 //
     /*  77277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77324 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77341 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77343 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77363 */     GIR_RootConstrainSelectedInstOperands,
     /*  77364 */     // GIR_Coverage, 3824,
     /*  77364 */     GIR_EraseRootFromParent_Done,
     /*  77365 */   // Label 1497: @77365
     /*  77365 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(77458), // Rule ID 3826 //
     /*  77370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77417 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77434 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77436 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77456 */     GIR_RootConstrainSelectedInstOperands,
     /*  77457 */     // GIR_Coverage, 3826,
     /*  77457 */     GIR_EraseRootFromParent_Done,
     /*  77458 */   // Label 1498: @77458
     /*  77458 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(77551), // Rule ID 3828 //
     /*  77463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77527 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77529 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77549 */     GIR_RootConstrainSelectedInstOperands,
     /*  77550 */     // GIR_Coverage, 3828,
     /*  77550 */     GIR_EraseRootFromParent_Done,
     /*  77551 */   // Label 1499: @77551
     /*  77551 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(77644), // Rule ID 3830 //
     /*  77556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77603 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77620 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77622 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77642 */     GIR_RootConstrainSelectedInstOperands,
     /*  77643 */     // GIR_Coverage, 3830,
     /*  77643 */     GIR_EraseRootFromParent_Done,
     /*  77644 */   // Label 1500: @77644
     /*  77644 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(77737), // Rule ID 3832 //
     /*  77649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77696 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77713 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77715 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77735 */     GIR_RootConstrainSelectedInstOperands,
     /*  77736 */     // GIR_Coverage, 3832,
     /*  77736 */     GIR_EraseRootFromParent_Done,
     /*  77737 */   // Label 1501: @77737
     /*  77737 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77830), // Rule ID 3834 //
     /*  77742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77789 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77806 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77808 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77828 */     GIR_RootConstrainSelectedInstOperands,
     /*  77829 */     // GIR_Coverage, 3834,
     /*  77829 */     GIR_EraseRootFromParent_Done,
     /*  77830 */   // Label 1502: @77830
     /*  77830 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(77923), // Rule ID 3836 //
     /*  77835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77882 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77899 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77901 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77921 */     GIR_RootConstrainSelectedInstOperands,
     /*  77922 */     // GIR_Coverage, 3836,
     /*  77922 */     GIR_EraseRootFromParent_Done,
     /*  77923 */   // Label 1503: @77923
     /*  77923 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(78016), // Rule ID 3838 //
     /*  77928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77975 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77992 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77994 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78014 */     GIR_RootConstrainSelectedInstOperands,
     /*  78015 */     // GIR_Coverage, 3838,
     /*  78015 */     GIR_EraseRootFromParent_Done,
     /*  78016 */   // Label 1504: @78016
     /*  78016 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(78109), // Rule ID 3840 //
     /*  78021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78068 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78085 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78087 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78107 */     GIR_RootConstrainSelectedInstOperands,
     /*  78108 */     // GIR_Coverage, 3840,
     /*  78108 */     GIR_EraseRootFromParent_Done,
     /*  78109 */   // Label 1505: @78109
     /*  78109 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(78202), // Rule ID 3842 //
     /*  78114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78178 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78180 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78200 */     GIR_RootConstrainSelectedInstOperands,
     /*  78201 */     // GIR_Coverage, 3842,
     /*  78201 */     GIR_EraseRootFromParent_Done,
     /*  78202 */   // Label 1506: @78202
     /*  78202 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(78295), // Rule ID 3844 //
     /*  78207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78254 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78271 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78273 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78293 */     GIR_RootConstrainSelectedInstOperands,
     /*  78294 */     // GIR_Coverage, 3844,
     /*  78294 */     GIR_EraseRootFromParent_Done,
     /*  78295 */   // Label 1507: @78295
     /*  78295 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(78388), // Rule ID 3846 //
     /*  78300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78347 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78364 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78366 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78386 */     GIR_RootConstrainSelectedInstOperands,
     /*  78387 */     // GIR_Coverage, 3846,
     /*  78387 */     GIR_EraseRootFromParent_Done,
     /*  78388 */   // Label 1508: @78388
     /*  78388 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(78481), // Rule ID 3848 //
     /*  78393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78440 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78457 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78459 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78479 */     GIR_RootConstrainSelectedInstOperands,
     /*  78480 */     // GIR_Coverage, 3848,
     /*  78480 */     GIR_EraseRootFromParent_Done,
     /*  78481 */   // Label 1509: @78481
     /*  78481 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(78574), // Rule ID 3850 //
     /*  78486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78533 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78550 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78552 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78572 */     GIR_RootConstrainSelectedInstOperands,
     /*  78573 */     // GIR_Coverage, 3850,
     /*  78573 */     GIR_EraseRootFromParent_Done,
     /*  78574 */   // Label 1510: @78574
     /*  78574 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(78667), // Rule ID 3852 //
     /*  78579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78626 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78643 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78645 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78665 */     GIR_RootConstrainSelectedInstOperands,
     /*  78666 */     // GIR_Coverage, 3852,
     /*  78666 */     GIR_EraseRootFromParent_Done,
     /*  78667 */   // Label 1511: @78667
     /*  78667 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(78760), // Rule ID 3854 //
     /*  78672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78719 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78736 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78738 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78758 */     GIR_RootConstrainSelectedInstOperands,
     /*  78759 */     // GIR_Coverage, 3854,
     /*  78759 */     GIR_EraseRootFromParent_Done,
     /*  78760 */   // Label 1512: @78760
     /*  78760 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78853), // Rule ID 3856 //
     /*  78765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78812 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78829 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78831 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78851 */     GIR_RootConstrainSelectedInstOperands,
     /*  78852 */     // GIR_Coverage, 3856,
     /*  78852 */     GIR_EraseRootFromParent_Done,
     /*  78853 */   // Label 1513: @78853
     /*  78853 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78946), // Rule ID 3858 //
     /*  78858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78905 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78922 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78924 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78944 */     GIR_RootConstrainSelectedInstOperands,
     /*  78945 */     // GIR_Coverage, 3858,
     /*  78945 */     GIR_EraseRootFromParent_Done,
     /*  78946 */   // Label 1514: @78946
     /*  78946 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(79039), // Rule ID 3860 //
     /*  78951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78998 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3574:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  79013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79015 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79017 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79037 */     GIR_RootConstrainSelectedInstOperands,
     /*  79038 */     // GIR_Coverage, 3860,
     /*  79038 */     GIR_EraseRootFromParent_Done,
     /*  79039 */   // Label 1515: @79039
     /*  79039 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(79132), // Rule ID 3862 //
     /*  79044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79091 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3574:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79108 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79110 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79130 */     GIR_RootConstrainSelectedInstOperands,
     /*  79131 */     // GIR_Coverage, 3862,
     /*  79131 */     GIR_EraseRootFromParent_Done,
     /*  79132 */   // Label 1516: @79132
     /*  79132 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(79225), // Rule ID 3864 //
     /*  79137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3574:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79201 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79203 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79223 */     GIR_RootConstrainSelectedInstOperands,
     /*  79224 */     // GIR_Coverage, 3864,
     /*  79224 */     GIR_EraseRootFromParent_Done,
     /*  79225 */   // Label 1517: @79225
     /*  79225 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(79303), // Rule ID 4469 //
     /*  79230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79277 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3544:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79301 */     GIR_RootConstrainSelectedInstOperands,
     /*  79302 */     // GIR_Coverage, 4469,
     /*  79302 */     GIR_EraseRootFromParent_Done,
     /*  79303 */   // Label 1518: @79303
     /*  79303 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(79381), // Rule ID 4471 //
     /*  79308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79355 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3544:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79379 */     GIR_RootConstrainSelectedInstOperands,
     /*  79380 */     // GIR_Coverage, 4471,
     /*  79380 */     GIR_EraseRootFromParent_Done,
     /*  79381 */   // Label 1519: @79381
     /*  79381 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(79459), // Rule ID 4473 //
     /*  79386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79433 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3544:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79457 */     GIR_RootConstrainSelectedInstOperands,
     /*  79458 */     // GIR_Coverage, 4473,
     /*  79458 */     GIR_EraseRootFromParent_Done,
     /*  79459 */   // Label 1520: @79459
     /*  79459 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(79537), // Rule ID 4475 //
     /*  79464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79511 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3544:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79535 */     GIR_RootConstrainSelectedInstOperands,
     /*  79536 */     // GIR_Coverage, 4475,
     /*  79536 */     GIR_EraseRootFromParent_Done,
     /*  79537 */   // Label 1521: @79537
     /*  79537 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(79615), // Rule ID 4477 //
     /*  79542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79589 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3544:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79613 */     GIR_RootConstrainSelectedInstOperands,
     /*  79614 */     // GIR_Coverage, 4477,
     /*  79614 */     GIR_EraseRootFromParent_Done,
     /*  79615 */   // Label 1522: @79615
     /*  79615 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79693), // Rule ID 4479 //
     /*  79620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79667 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3544:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79691 */     GIR_RootConstrainSelectedInstOperands,
     /*  79692 */     // GIR_Coverage, 4479,
     /*  79692 */     GIR_EraseRootFromParent_Done,
     /*  79693 */   // Label 1523: @79693
     /*  79693 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79771), // Rule ID 4481 //
     /*  79698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79745 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3544:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79769 */     GIR_RootConstrainSelectedInstOperands,
     /*  79770 */     // GIR_Coverage, 4481,
     /*  79770 */     GIR_EraseRootFromParent_Done,
     /*  79771 */   // Label 1524: @79771
     /*  79771 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79849), // Rule ID 4483 //
     /*  79776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79823 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3544:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79847 */     GIR_RootConstrainSelectedInstOperands,
     /*  79848 */     // GIR_Coverage, 4483,
     /*  79848 */     GIR_EraseRootFromParent_Done,
     /*  79849 */   // Label 1525: @79849
     /*  79849 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79927), // Rule ID 4485 //
     /*  79854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79901 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3544:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79925 */     GIR_RootConstrainSelectedInstOperands,
     /*  79926 */     // GIR_Coverage, 4485,
     /*  79926 */     GIR_EraseRootFromParent_Done,
     /*  79927 */   // Label 1526: @79927
     /*  79927 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(80005), // Rule ID 4487 //
     /*  79932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79979 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3544:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80003 */     GIR_RootConstrainSelectedInstOperands,
     /*  80004 */     // GIR_Coverage, 4487,
     /*  80004 */     GIR_EraseRootFromParent_Done,
     /*  80005 */   // Label 1527: @80005
     /*  80005 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(80083), // Rule ID 4489 //
     /*  80010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80057 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3544:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80081 */     GIR_RootConstrainSelectedInstOperands,
     /*  80082 */     // GIR_Coverage, 4489,
     /*  80082 */     GIR_EraseRootFromParent_Done,
     /*  80083 */   // Label 1528: @80083
     /*  80083 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(80161), // Rule ID 4491 //
     /*  80088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80135 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3544:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80159 */     GIR_RootConstrainSelectedInstOperands,
     /*  80160 */     // GIR_Coverage, 4491,
     /*  80160 */     GIR_EraseRootFromParent_Done,
     /*  80161 */   // Label 1529: @80161
     /*  80161 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(80239), // Rule ID 4681 //
     /*  80166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80213 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80218 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80220 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80237 */     GIR_RootConstrainSelectedInstOperands,
     /*  80238 */     // GIR_Coverage, 4681,
     /*  80238 */     GIR_EraseRootFromParent_Done,
     /*  80239 */   // Label 1530: @80239
     /*  80239 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(80317), // Rule ID 4683 //
     /*  80244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80291 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80296 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80298 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80315 */     GIR_RootConstrainSelectedInstOperands,
     /*  80316 */     // GIR_Coverage, 4683,
     /*  80316 */     GIR_EraseRootFromParent_Done,
     /*  80317 */   // Label 1531: @80317
     /*  80317 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(80395), // Rule ID 4685 //
     /*  80322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80374 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80376 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80393 */     GIR_RootConstrainSelectedInstOperands,
     /*  80394 */     // GIR_Coverage, 4685,
     /*  80394 */     GIR_EraseRootFromParent_Done,
     /*  80395 */   // Label 1532: @80395
     /*  80395 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(80473), // Rule ID 4687 //
     /*  80400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80447 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80452 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80454 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80471 */     GIR_RootConstrainSelectedInstOperands,
     /*  80472 */     // GIR_Coverage, 4687,
     /*  80472 */     GIR_EraseRootFromParent_Done,
     /*  80473 */   // Label 1533: @80473
     /*  80473 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(80551), // Rule ID 4689 //
     /*  80478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80525 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80530 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80532 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80549 */     GIR_RootConstrainSelectedInstOperands,
     /*  80550 */     // GIR_Coverage, 4689,
     /*  80550 */     GIR_EraseRootFromParent_Done,
     /*  80551 */   // Label 1534: @80551
     /*  80551 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(80629), // Rule ID 4691 //
     /*  80556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80603 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80608 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80610 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80627 */     GIR_RootConstrainSelectedInstOperands,
     /*  80628 */     // GIR_Coverage, 4691,
     /*  80628 */     GIR_EraseRootFromParent_Done,
     /*  80629 */   // Label 1535: @80629
     /*  80629 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80707), // Rule ID 4693 //
     /*  80634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80681 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80686 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80688 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80705 */     GIR_RootConstrainSelectedInstOperands,
     /*  80706 */     // GIR_Coverage, 4693,
     /*  80706 */     GIR_EraseRootFromParent_Done,
     /*  80707 */   // Label 1536: @80707
     /*  80707 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80785), // Rule ID 4695 //
     /*  80712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80759 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80764 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80766 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80783 */     GIR_RootConstrainSelectedInstOperands,
     /*  80784 */     // GIR_Coverage, 4695,
     /*  80784 */     GIR_EraseRootFromParent_Done,
     /*  80785 */   // Label 1537: @80785
     /*  80785 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80863), // Rule ID 4697 //
     /*  80790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80837 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80842 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80844 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80861 */     GIR_RootConstrainSelectedInstOperands,
     /*  80862 */     // GIR_Coverage, 4697,
     /*  80862 */     GIR_EraseRootFromParent_Done,
     /*  80863 */   // Label 1538: @80863
     /*  80863 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80941), // Rule ID 4699 //
     /*  80868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80915 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80920 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80922 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80939 */     GIR_RootConstrainSelectedInstOperands,
     /*  80940 */     // GIR_Coverage, 4699,
     /*  80940 */     GIR_EraseRootFromParent_Done,
     /*  80941 */   // Label 1539: @80941
     /*  80941 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(81019), // Rule ID 4701 //
     /*  80946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80993 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80998 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81000 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81017 */     GIR_RootConstrainSelectedInstOperands,
     /*  81018 */     // GIR_Coverage, 4701,
     /*  81018 */     GIR_EraseRootFromParent_Done,
     /*  81019 */   // Label 1540: @81019
     /*  81019 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(81097), // Rule ID 4703 //
     /*  81024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81071 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81076 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81078 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81095 */     GIR_RootConstrainSelectedInstOperands,
     /*  81096 */     // GIR_Coverage, 4703,
     /*  81096 */     GIR_EraseRootFromParent_Done,
     /*  81097 */   // Label 1541: @81097
     /*  81097 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(81175), // Rule ID 4705 //
     /*  81102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81149 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81154 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81156 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81173 */     GIR_RootConstrainSelectedInstOperands,
     /*  81174 */     // GIR_Coverage, 4705,
     /*  81174 */     GIR_EraseRootFromParent_Done,
     /*  81175 */   // Label 1542: @81175
     /*  81175 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(81253), // Rule ID 4707 //
     /*  81180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81227 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81232 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81234 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81251 */     GIR_RootConstrainSelectedInstOperands,
     /*  81252 */     // GIR_Coverage, 4707,
     /*  81252 */     GIR_EraseRootFromParent_Done,
     /*  81253 */   // Label 1543: @81253
     /*  81253 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(81331), // Rule ID 4709 //
     /*  81258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81305 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81310 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81312 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81329 */     GIR_RootConstrainSelectedInstOperands,
     /*  81330 */     // GIR_Coverage, 4709,
     /*  81330 */     GIR_EraseRootFromParent_Done,
     /*  81331 */   // Label 1544: @81331
     /*  81331 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(81409), // Rule ID 4711 //
     /*  81336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81383 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81388 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81390 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81407 */     GIR_RootConstrainSelectedInstOperands,
     /*  81408 */     // GIR_Coverage, 4711,
     /*  81408 */     GIR_EraseRootFromParent_Done,
     /*  81409 */   // Label 1545: @81409
     /*  81409 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(81487), // Rule ID 4713 //
     /*  81414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81466 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81468 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81485 */     GIR_RootConstrainSelectedInstOperands,
     /*  81486 */     // GIR_Coverage, 4713,
     /*  81486 */     GIR_EraseRootFromParent_Done,
     /*  81487 */   // Label 1546: @81487
     /*  81487 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(81565), // Rule ID 4715 //
     /*  81492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81539 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81544 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81546 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81563 */     GIR_RootConstrainSelectedInstOperands,
     /*  81564 */     // GIR_Coverage, 4715,
     /*  81564 */     GIR_EraseRootFromParent_Done,
     /*  81565 */   // Label 1547: @81565
     /*  81565 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81643), // Rule ID 4717 //
     /*  81570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81617 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81622 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81624 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81641 */     GIR_RootConstrainSelectedInstOperands,
     /*  81642 */     // GIR_Coverage, 4717,
     /*  81642 */     GIR_EraseRootFromParent_Done,
     /*  81643 */   // Label 1548: @81643
     /*  81643 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81721), // Rule ID 4719 //
     /*  81648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81700 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81702 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81719 */     GIR_RootConstrainSelectedInstOperands,
     /*  81720 */     // GIR_Coverage, 4719,
     /*  81720 */     GIR_EraseRootFromParent_Done,
     /*  81721 */   // Label 1549: @81721
     /*  81721 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81799), // Rule ID 4721 //
     /*  81726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81773 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81778 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81780 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81797 */     GIR_RootConstrainSelectedInstOperands,
     /*  81798 */     // GIR_Coverage, 4721,
     /*  81798 */     GIR_EraseRootFromParent_Done,
     /*  81799 */   // Label 1550: @81799
     /*  81799 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81877), // Rule ID 4723 //
     /*  81804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3572:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81856 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81858 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81875 */     GIR_RootConstrainSelectedInstOperands,
     /*  81876 */     // GIR_Coverage, 4723,
     /*  81876 */     GIR_EraseRootFromParent_Done,
     /*  81877 */   // Label 1551: @81877
     /*  81877 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81955), // Rule ID 4725 //
     /*  81882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81929 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3572:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81934 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81936 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81953 */     GIR_RootConstrainSelectedInstOperands,
     /*  81954 */     // GIR_Coverage, 4725,
     /*  81954 */     GIR_EraseRootFromParent_Done,
     /*  81955 */   // Label 1552: @81955
     /*  81955 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(82033), // Rule ID 4727 //
     /*  81960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3572:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  82010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82012 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82014 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82031 */     GIR_RootConstrainSelectedInstOperands,
     /*  82032 */     // GIR_Coverage, 4727,
     /*  82032 */     GIR_EraseRootFromParent_Done,
     /*  82033 */   // Label 1553: @82033
     /*  82033 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(82169), // Rule ID 2670 //
     /*  82038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82068 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3736:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82098 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82105 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82112 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82118 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82151 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82156 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82167 */     GIR_RootConstrainSelectedInstOperands,
     /*  82168 */     // GIR_Coverage, 2670,
     /*  82168 */     GIR_EraseRootFromParent_Done,
     /*  82169 */   // Label 1554: @82169
     /*  82169 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(82290), // Rule ID 2671 //
     /*  82174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82204 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3733:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82220 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82227 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82234 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82241 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82277 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82288 */     GIR_RootConstrainSelectedInstOperands,
     /*  82289 */     // GIR_Coverage, 2671,
     /*  82289 */     GIR_EraseRootFromParent_Done,
     /*  82290 */   // Label 1555: @82290
     /*  82290 */   GIM_Reject,
     /*  82291 */ // Label 1493: @82291
     /*  82291 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(87184),
     /*  82296 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82299 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(82387), // Rule ID 3161 //
     /*  82304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82353 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82357 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82361 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82366 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82368 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82385 */     GIR_RootConstrainSelectedInstOperands,
     /*  82386 */     // GIR_Coverage, 3161,
     /*  82386 */     GIR_EraseRootFromParent_Done,
     /*  82387 */   // Label 1557: @82387
     /*  82387 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(82475), // Rule ID 3165 //
     /*  82392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82441 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82445 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82449 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82454 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82456 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82473 */     GIR_RootConstrainSelectedInstOperands,
     /*  82474 */     // GIR_Coverage, 3165,
     /*  82474 */     GIR_EraseRootFromParent_Done,
     /*  82475 */   // Label 1558: @82475
     /*  82475 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(82563), // Rule ID 3169 //
     /*  82480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82529 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82533 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82537 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82542 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82544 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82561 */     GIR_RootConstrainSelectedInstOperands,
     /*  82562 */     // GIR_Coverage, 3169,
     /*  82562 */     GIR_EraseRootFromParent_Done,
     /*  82563 */   // Label 1559: @82563
     /*  82563 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(82651), // Rule ID 3173 //
     /*  82568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82617 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82621 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82625 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82630 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82632 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82649 */     GIR_RootConstrainSelectedInstOperands,
     /*  82650 */     // GIR_Coverage, 3173,
     /*  82650 */     GIR_EraseRootFromParent_Done,
     /*  82651 */   // Label 1560: @82651
     /*  82651 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82739), // Rule ID 3177 //
     /*  82656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82705 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82709 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82713 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82718 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82720 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82737 */     GIR_RootConstrainSelectedInstOperands,
     /*  82738 */     // GIR_Coverage, 3177,
     /*  82738 */     GIR_EraseRootFromParent_Done,
     /*  82739 */   // Label 1561: @82739
     /*  82739 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(82827), // Rule ID 3181 //
     /*  82744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82793 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82797 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82801 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82806 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82808 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82825 */     GIR_RootConstrainSelectedInstOperands,
     /*  82826 */     // GIR_Coverage, 3181,
     /*  82826 */     GIR_EraseRootFromParent_Done,
     /*  82827 */   // Label 1562: @82827
     /*  82827 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82915), // Rule ID 3185 //
     /*  82832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82881 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82885 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82889 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82894 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82896 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82913 */     GIR_RootConstrainSelectedInstOperands,
     /*  82914 */     // GIR_Coverage, 3185,
     /*  82914 */     GIR_EraseRootFromParent_Done,
     /*  82915 */   // Label 1563: @82915
     /*  82915 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(83003), // Rule ID 3189 //
     /*  82920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82969 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82973 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82977 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82982 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82984 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83001 */     GIR_RootConstrainSelectedInstOperands,
     /*  83002 */     // GIR_Coverage, 3189,
     /*  83002 */     GIR_EraseRootFromParent_Done,
     /*  83003 */   // Label 1564: @83003
     /*  83003 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(83091), // Rule ID 3193 //
     /*  83008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83057 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83061 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83065 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83070 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83072 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83089 */     GIR_RootConstrainSelectedInstOperands,
     /*  83090 */     // GIR_Coverage, 3193,
     /*  83090 */     GIR_EraseRootFromParent_Done,
     /*  83091 */   // Label 1565: @83091
     /*  83091 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(83179), // Rule ID 3197 //
     /*  83096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83145 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83149 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83153 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83158 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83160 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83177 */     GIR_RootConstrainSelectedInstOperands,
     /*  83178 */     // GIR_Coverage, 3197,
     /*  83178 */     GIR_EraseRootFromParent_Done,
     /*  83179 */   // Label 1566: @83179
     /*  83179 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(83267), // Rule ID 3201 //
     /*  83184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83233 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83237 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83241 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83246 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83248 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83265 */     GIR_RootConstrainSelectedInstOperands,
     /*  83266 */     // GIR_Coverage, 3201,
     /*  83266 */     GIR_EraseRootFromParent_Done,
     /*  83267 */   // Label 1567: @83267
     /*  83267 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(83355), // Rule ID 3205 //
     /*  83272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83321 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83325 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83329 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83334 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83336 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83353 */     GIR_RootConstrainSelectedInstOperands,
     /*  83354 */     // GIR_Coverage, 3205,
     /*  83354 */     GIR_EraseRootFromParent_Done,
     /*  83355 */   // Label 1568: @83355
     /*  83355 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(83443), // Rule ID 3209 //
     /*  83360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83409 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83413 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83417 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83422 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83424 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83441 */     GIR_RootConstrainSelectedInstOperands,
     /*  83442 */     // GIR_Coverage, 3209,
     /*  83442 */     GIR_EraseRootFromParent_Done,
     /*  83443 */   // Label 1569: @83443
     /*  83443 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(83531), // Rule ID 3213 //
     /*  83448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83497 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83501 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83505 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83510 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83512 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83529 */     GIR_RootConstrainSelectedInstOperands,
     /*  83530 */     // GIR_Coverage, 3213,
     /*  83530 */     GIR_EraseRootFromParent_Done,
     /*  83531 */   // Label 1570: @83531
     /*  83531 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(83619), // Rule ID 3217 //
     /*  83536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83585 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83589 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83593 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83598 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83600 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83617 */     GIR_RootConstrainSelectedInstOperands,
     /*  83618 */     // GIR_Coverage, 3217,
     /*  83618 */     GIR_EraseRootFromParent_Done,
     /*  83619 */   // Label 1571: @83619
     /*  83619 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(83709), // Rule ID 3163 //
     /*  83624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83673 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83677 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83681 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83686 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83688 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83690 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83707 */     GIR_RootConstrainSelectedInstOperands,
     /*  83708 */     // GIR_Coverage, 3163,
     /*  83708 */     GIR_EraseRootFromParent_Done,
     /*  83709 */   // Label 1572: @83709
     /*  83709 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83799), // Rule ID 3167 //
     /*  83714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83763 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83767 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83771 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83776 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83778 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83780 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83797 */     GIR_RootConstrainSelectedInstOperands,
     /*  83798 */     // GIR_Coverage, 3167,
     /*  83798 */     GIR_EraseRootFromParent_Done,
     /*  83799 */   // Label 1573: @83799
     /*  83799 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83889), // Rule ID 3171 //
     /*  83804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83853 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83857 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83861 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83866 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83868 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83870 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83887 */     GIR_RootConstrainSelectedInstOperands,
     /*  83888 */     // GIR_Coverage, 3171,
     /*  83888 */     GIR_EraseRootFromParent_Done,
     /*  83889 */   // Label 1574: @83889
     /*  83889 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83979), // Rule ID 3175 //
     /*  83894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83943 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83947 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83951 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83956 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83958 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83960 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83977 */     GIR_RootConstrainSelectedInstOperands,
     /*  83978 */     // GIR_Coverage, 3175,
     /*  83978 */     GIR_EraseRootFromParent_Done,
     /*  83979 */   // Label 1575: @83979
     /*  83979 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(84069), // Rule ID 3179 //
     /*  83984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84033 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84037 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84041 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84046 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84048 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84050 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84067 */     GIR_RootConstrainSelectedInstOperands,
     /*  84068 */     // GIR_Coverage, 3179,
     /*  84068 */     GIR_EraseRootFromParent_Done,
     /*  84069 */   // Label 1576: @84069
     /*  84069 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(84159), // Rule ID 3183 //
     /*  84074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84123 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84127 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84131 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84136 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84138 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84140 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84157 */     GIR_RootConstrainSelectedInstOperands,
     /*  84158 */     // GIR_Coverage, 3183,
     /*  84158 */     GIR_EraseRootFromParent_Done,
     /*  84159 */   // Label 1577: @84159
     /*  84159 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(84249), // Rule ID 3187 //
     /*  84164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84213 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84217 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84221 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84226 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84228 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84230 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 3187,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1578: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(84339), // Rule ID 3191 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84303 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84307 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84311 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84316 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84318 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84320 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84337 */     GIR_RootConstrainSelectedInstOperands,
     /*  84338 */     // GIR_Coverage, 3191,
     /*  84338 */     GIR_EraseRootFromParent_Done,
     /*  84339 */   // Label 1579: @84339
     /*  84339 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(84429), // Rule ID 3195 //
     /*  84344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84393 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84397 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84401 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84406 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84408 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84410 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84421 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84427 */     GIR_RootConstrainSelectedInstOperands,
     /*  84428 */     // GIR_Coverage, 3195,
     /*  84428 */     GIR_EraseRootFromParent_Done,
     /*  84429 */   // Label 1580: @84429
     /*  84429 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(84519), // Rule ID 3199 //
     /*  84434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84483 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84487 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84491 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84496 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84498 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84500 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84517 */     GIR_RootConstrainSelectedInstOperands,
     /*  84518 */     // GIR_Coverage, 3199,
     /*  84518 */     GIR_EraseRootFromParent_Done,
     /*  84519 */   // Label 1581: @84519
     /*  84519 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(84609), // Rule ID 3203 //
     /*  84524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84573 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84577 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84581 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84586 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84588 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84590 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84607 */     GIR_RootConstrainSelectedInstOperands,
     /*  84608 */     // GIR_Coverage, 3203,
     /*  84608 */     GIR_EraseRootFromParent_Done,
     /*  84609 */   // Label 1582: @84609
     /*  84609 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(84699), // Rule ID 3207 //
     /*  84614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84663 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84667 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84671 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84676 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84678 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84680 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84697 */     GIR_RootConstrainSelectedInstOperands,
     /*  84698 */     // GIR_Coverage, 3207,
     /*  84698 */     GIR_EraseRootFromParent_Done,
     /*  84699 */   // Label 1583: @84699
     /*  84699 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84789), // Rule ID 3211 //
     /*  84704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84753 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84757 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84761 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84766 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84768 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84770 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84787 */     GIR_RootConstrainSelectedInstOperands,
     /*  84788 */     // GIR_Coverage, 3211,
     /*  84788 */     GIR_EraseRootFromParent_Done,
     /*  84789 */   // Label 1584: @84789
     /*  84789 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84879), // Rule ID 3215 //
     /*  84794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84843 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84847 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84851 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84856 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84858 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84860 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84877 */     GIR_RootConstrainSelectedInstOperands,
     /*  84878 */     // GIR_Coverage, 3215,
     /*  84878 */     GIR_EraseRootFromParent_Done,
     /*  84879 */   // Label 1585: @84879
     /*  84879 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84969), // Rule ID 3219 //
     /*  84884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84933 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84937 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84941 */     // (intrinsic_wo_chain:{ *:[i32] } 3526:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84946 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84948 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84950 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84967 */     GIR_RootConstrainSelectedInstOperands,
     /*  84968 */     // GIR_Coverage, 3219,
     /*  84968 */     GIR_EraseRootFromParent_Done,
     /*  84969 */   // Label 1586: @84969
     /*  84969 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(85056), // Rule ID 4315 //
     /*  84974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85028 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85033 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85035 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85037 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85054 */     GIR_RootConstrainSelectedInstOperands,
     /*  85055 */     // GIR_Coverage, 4315,
     /*  85055 */     GIR_EraseRootFromParent_Done,
     /*  85056 */   // Label 1587: @85056
     /*  85056 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(85143), // Rule ID 4317 //
     /*  85061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85115 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85120 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85122 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85124 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85141 */     GIR_RootConstrainSelectedInstOperands,
     /*  85142 */     // GIR_Coverage, 4317,
     /*  85142 */     GIR_EraseRootFromParent_Done,
     /*  85143 */   // Label 1588: @85143
     /*  85143 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(85230), // Rule ID 4319 //
     /*  85148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85202 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85207 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85209 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85211 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85228 */     GIR_RootConstrainSelectedInstOperands,
     /*  85229 */     // GIR_Coverage, 4319,
     /*  85229 */     GIR_EraseRootFromParent_Done,
     /*  85230 */   // Label 1589: @85230
     /*  85230 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(85317), // Rule ID 4321 //
     /*  85235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85289 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85294 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85296 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85298 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85315 */     GIR_RootConstrainSelectedInstOperands,
     /*  85316 */     // GIR_Coverage, 4321,
     /*  85316 */     GIR_EraseRootFromParent_Done,
     /*  85317 */   // Label 1590: @85317
     /*  85317 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(85404), // Rule ID 4323 //
     /*  85322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85376 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85381 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85383 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85385 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85402 */     GIR_RootConstrainSelectedInstOperands,
     /*  85403 */     // GIR_Coverage, 4323,
     /*  85403 */     GIR_EraseRootFromParent_Done,
     /*  85404 */   // Label 1591: @85404
     /*  85404 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(85491), // Rule ID 4325 //
     /*  85409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85463 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85468 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85470 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85472 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85489 */     GIR_RootConstrainSelectedInstOperands,
     /*  85490 */     // GIR_Coverage, 4325,
     /*  85490 */     GIR_EraseRootFromParent_Done,
     /*  85491 */   // Label 1592: @85491
     /*  85491 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(85578), // Rule ID 4327 //
     /*  85496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85550 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85555 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85557 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85559 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85576 */     GIR_RootConstrainSelectedInstOperands,
     /*  85577 */     // GIR_Coverage, 4327,
     /*  85577 */     GIR_EraseRootFromParent_Done,
     /*  85578 */   // Label 1593: @85578
     /*  85578 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(85665), // Rule ID 4329 //
     /*  85583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85637 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85642 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85644 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85646 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85663 */     GIR_RootConstrainSelectedInstOperands,
     /*  85664 */     // GIR_Coverage, 4329,
     /*  85664 */     GIR_EraseRootFromParent_Done,
     /*  85665 */   // Label 1594: @85665
     /*  85665 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85752), // Rule ID 4331 //
     /*  85670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85729 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85731 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85733 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85750 */     GIR_RootConstrainSelectedInstOperands,
     /*  85751 */     // GIR_Coverage, 4331,
     /*  85751 */     GIR_EraseRootFromParent_Done,
     /*  85752 */   // Label 1595: @85752
     /*  85752 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85839), // Rule ID 4333 //
     /*  85757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85811 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85816 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85818 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85820 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85837 */     GIR_RootConstrainSelectedInstOperands,
     /*  85838 */     // GIR_Coverage, 4333,
     /*  85838 */     GIR_EraseRootFromParent_Done,
     /*  85839 */   // Label 1596: @85839
     /*  85839 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85926), // Rule ID 4335 //
     /*  85844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85903 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85905 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85907 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85924 */     GIR_RootConstrainSelectedInstOperands,
     /*  85925 */     // GIR_Coverage, 4335,
     /*  85925 */     GIR_EraseRootFromParent_Done,
     /*  85926 */   // Label 1597: @85926
     /*  85926 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(86013), // Rule ID 4337 //
     /*  85931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85985 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85990 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85992 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85994 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86011 */     GIR_RootConstrainSelectedInstOperands,
     /*  86012 */     // GIR_Coverage, 4337,
     /*  86012 */     GIR_EraseRootFromParent_Done,
     /*  86013 */   // Label 1598: @86013
     /*  86013 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(86100), // Rule ID 4339 //
     /*  86018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86072 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86077 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86079 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86081 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86098 */     GIR_RootConstrainSelectedInstOperands,
     /*  86099 */     // GIR_Coverage, 4339,
     /*  86099 */     GIR_EraseRootFromParent_Done,
     /*  86100 */   // Label 1599: @86100
     /*  86100 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(86187), // Rule ID 4341 //
     /*  86105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86159 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86164 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86166 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86168 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86185 */     GIR_RootConstrainSelectedInstOperands,
     /*  86186 */     // GIR_Coverage, 4341,
     /*  86186 */     GIR_EraseRootFromParent_Done,
     /*  86187 */   // Label 1600: @86187
     /*  86187 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(86274), // Rule ID 4343 //
     /*  86192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86246 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86251 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86253 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86255 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86272 */     GIR_RootConstrainSelectedInstOperands,
     /*  86273 */     // GIR_Coverage, 4343,
     /*  86273 */     GIR_EraseRootFromParent_Done,
     /*  86274 */   // Label 1601: @86274
     /*  86274 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(86361), // Rule ID 4345 //
     /*  86279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86338 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86340 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86342 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86359 */     GIR_RootConstrainSelectedInstOperands,
     /*  86360 */     // GIR_Coverage, 4345,
     /*  86360 */     GIR_EraseRootFromParent_Done,
     /*  86361 */   // Label 1602: @86361
     /*  86361 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(86448), // Rule ID 4347 //
     /*  86366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86420 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86425 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86427 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86429 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86446 */     GIR_RootConstrainSelectedInstOperands,
     /*  86447 */     // GIR_Coverage, 4347,
     /*  86447 */     GIR_EraseRootFromParent_Done,
     /*  86448 */   // Label 1603: @86448
     /*  86448 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(86535), // Rule ID 4349 //
     /*  86453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86507 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86512 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86514 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86516 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86533 */     GIR_RootConstrainSelectedInstOperands,
     /*  86534 */     // GIR_Coverage, 4349,
     /*  86534 */     GIR_EraseRootFromParent_Done,
     /*  86535 */   // Label 1604: @86535
     /*  86535 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(86622), // Rule ID 4351 //
     /*  86540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86594 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86599 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86601 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86603 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86620 */     GIR_RootConstrainSelectedInstOperands,
     /*  86621 */     // GIR_Coverage, 4351,
     /*  86621 */     GIR_EraseRootFromParent_Done,
     /*  86622 */   // Label 1605: @86622
     /*  86622 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(86709), // Rule ID 4353 //
     /*  86627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86681 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86686 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86688 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86690 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86707 */     GIR_RootConstrainSelectedInstOperands,
     /*  86708 */     // GIR_Coverage, 4353,
     /*  86708 */     GIR_EraseRootFromParent_Done,
     /*  86709 */   // Label 1606: @86709
     /*  86709 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86796), // Rule ID 4355 //
     /*  86714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86773 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86775 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86777 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86794 */     GIR_RootConstrainSelectedInstOperands,
     /*  86795 */     // GIR_Coverage, 4355,
     /*  86795 */     GIR_EraseRootFromParent_Done,
     /*  86796 */   // Label 1607: @86796
     /*  86796 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86883), // Rule ID 4357 //
     /*  86801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86855 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3535:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86860 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86862 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86864 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86881 */     GIR_RootConstrainSelectedInstOperands,
     /*  86882 */     // GIR_Coverage, 4357,
     /*  86882 */     GIR_EraseRootFromParent_Done,
     /*  86883 */   // Label 1608: @86883
     /*  86883 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86970), // Rule ID 4359 //
     /*  86888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86942 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3535:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86947 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86949 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86951 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86968 */     GIR_RootConstrainSelectedInstOperands,
     /*  86969 */     // GIR_Coverage, 4359,
     /*  86969 */     GIR_EraseRootFromParent_Done,
     /*  86970 */   // Label 1609: @86970
     /*  86970 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(87057), // Rule ID 4361 //
     /*  86975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87029 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3535:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87034 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87036 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87038 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87055 */     GIR_RootConstrainSelectedInstOperands,
     /*  87056 */     // GIR_Coverage, 4361,
     /*  87056 */     GIR_EraseRootFromParent_Done,
     /*  87057 */   // Label 1610: @87057
     /*  87057 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(87183), // Rule ID 2672 //
     /*  87062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87095 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3737:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87111 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87118 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87125 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87132 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87165 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87170 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87181 */     GIR_RootConstrainSelectedInstOperands,
     /*  87182 */     // GIR_Coverage, 2672,
     /*  87182 */     GIR_EraseRootFromParent_Done,
     /*  87183 */   // Label 1611: @87183
     /*  87183 */   GIM_Reject,
     /*  87184 */ // Label 1556: @87184
     /*  87184 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(91478),
     /*  87189 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87192 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87197 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(87304), // Rule ID 3738 //
     /*  87202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87223 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87226 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87253 */     // MIs[1] Operand 1
     /*  87253 */     // No operand predicates
     /*  87253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87275 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87280 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87302 */     GIR_RootConstrainSelectedInstOperands,
     /*  87303 */     // GIR_Coverage, 3738,
     /*  87303 */     GIR_EraseRootFromParent_Done,
     /*  87304 */   // Label 1613: @87304
     /*  87304 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(87411), // Rule ID 3740 //
     /*  87309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87330 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87333 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87360 */     // MIs[1] Operand 1
     /*  87360 */     // No operand predicates
     /*  87360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87382 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87387 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87409 */     GIR_RootConstrainSelectedInstOperands,
     /*  87410 */     // GIR_Coverage, 3740,
     /*  87410 */     GIR_EraseRootFromParent_Done,
     /*  87411 */   // Label 1614: @87411
     /*  87411 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(87518), // Rule ID 3742 //
     /*  87416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87437 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87440 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87467 */     // MIs[1] Operand 1
     /*  87467 */     // No operand predicates
     /*  87467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87489 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87494 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87516 */     GIR_RootConstrainSelectedInstOperands,
     /*  87517 */     // GIR_Coverage, 3742,
     /*  87517 */     GIR_EraseRootFromParent_Done,
     /*  87518 */   // Label 1615: @87518
     /*  87518 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(87625), // Rule ID 3744 //
     /*  87523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87544 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87547 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87574 */     // MIs[1] Operand 1
     /*  87574 */     // No operand predicates
     /*  87574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87596 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87601 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87623 */     GIR_RootConstrainSelectedInstOperands,
     /*  87624 */     // GIR_Coverage, 3744,
     /*  87624 */     GIR_EraseRootFromParent_Done,
     /*  87625 */   // Label 1616: @87625
     /*  87625 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(87732), // Rule ID 3746 //
     /*  87630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87651 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87654 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87681 */     // MIs[1] Operand 1
     /*  87681 */     // No operand predicates
     /*  87681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87703 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87708 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87730 */     GIR_RootConstrainSelectedInstOperands,
     /*  87731 */     // GIR_Coverage, 3746,
     /*  87731 */     GIR_EraseRootFromParent_Done,
     /*  87732 */   // Label 1617: @87732
     /*  87732 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(87839), // Rule ID 3748 //
     /*  87737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87758 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87761 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87788 */     // MIs[1] Operand 1
     /*  87788 */     // No operand predicates
     /*  87788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87810 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87815 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87837 */     GIR_RootConstrainSelectedInstOperands,
     /*  87838 */     // GIR_Coverage, 3748,
     /*  87838 */     GIR_EraseRootFromParent_Done,
     /*  87839 */   // Label 1618: @87839
     /*  87839 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87946), // Rule ID 3750 //
     /*  87844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87865 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87868 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87895 */     // MIs[1] Operand 1
     /*  87895 */     // No operand predicates
     /*  87895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87917 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87922 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87944 */     GIR_RootConstrainSelectedInstOperands,
     /*  87945 */     // GIR_Coverage, 3750,
     /*  87945 */     GIR_EraseRootFromParent_Done,
     /*  87946 */   // Label 1619: @87946
     /*  87946 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(88053), // Rule ID 3752 //
     /*  87951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87972 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87975 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88002 */     // MIs[1] Operand 1
     /*  88002 */     // No operand predicates
     /*  88002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88024 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  88027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88029 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88051 */     GIR_RootConstrainSelectedInstOperands,
     /*  88052 */     // GIR_Coverage, 3752,
     /*  88052 */     GIR_EraseRootFromParent_Done,
     /*  88053 */   // Label 1620: @88053
     /*  88053 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(88160), // Rule ID 3754 //
     /*  88058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88079 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88082 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88109 */     // MIs[1] Operand 1
     /*  88109 */     // No operand predicates
     /*  88109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88131 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88136 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88158 */     GIR_RootConstrainSelectedInstOperands,
     /*  88159 */     // GIR_Coverage, 3754,
     /*  88159 */     GIR_EraseRootFromParent_Done,
     /*  88160 */   // Label 1621: @88160
     /*  88160 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(88267), // Rule ID 3756 //
     /*  88165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88186 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88189 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88216 */     // MIs[1] Operand 1
     /*  88216 */     // No operand predicates
     /*  88216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88238 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88243 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88265 */     GIR_RootConstrainSelectedInstOperands,
     /*  88266 */     // GIR_Coverage, 3756,
     /*  88266 */     GIR_EraseRootFromParent_Done,
     /*  88267 */   // Label 1622: @88267
     /*  88267 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(88374), // Rule ID 3758 //
     /*  88272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88293 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88296 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88323 */     // MIs[1] Operand 1
     /*  88323 */     // No operand predicates
     /*  88323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88345 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88350 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88372 */     GIR_RootConstrainSelectedInstOperands,
     /*  88373 */     // GIR_Coverage, 3758,
     /*  88373 */     GIR_EraseRootFromParent_Done,
     /*  88374 */   // Label 1623: @88374
     /*  88374 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(88481), // Rule ID 3760 //
     /*  88379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88400 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88403 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88430 */     // MIs[1] Operand 1
     /*  88430 */     // No operand predicates
     /*  88430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88452 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88457 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88479 */     GIR_RootConstrainSelectedInstOperands,
     /*  88480 */     // GIR_Coverage, 3760,
     /*  88480 */     GIR_EraseRootFromParent_Done,
     /*  88481 */   // Label 1624: @88481
     /*  88481 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(88588), // Rule ID 3762 //
     /*  88486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88507 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88510 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88537 */     // MIs[1] Operand 1
     /*  88537 */     // No operand predicates
     /*  88537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88559 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88564 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88586 */     GIR_RootConstrainSelectedInstOperands,
     /*  88587 */     // GIR_Coverage, 3762,
     /*  88587 */     GIR_EraseRootFromParent_Done,
     /*  88588 */   // Label 1625: @88588
     /*  88588 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(88695), // Rule ID 3764 //
     /*  88593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88614 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88617 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88644 */     // MIs[1] Operand 1
     /*  88644 */     // No operand predicates
     /*  88644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88666 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88671 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88693 */     GIR_RootConstrainSelectedInstOperands,
     /*  88694 */     // GIR_Coverage, 3764,
     /*  88694 */     GIR_EraseRootFromParent_Done,
     /*  88695 */   // Label 1626: @88695
     /*  88695 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(88802), // Rule ID 3766 //
     /*  88700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88721 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88724 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88751 */     // MIs[1] Operand 1
     /*  88751 */     // No operand predicates
     /*  88751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88773 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88778 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88800 */     GIR_RootConstrainSelectedInstOperands,
     /*  88801 */     // GIR_Coverage, 3766,
     /*  88801 */     GIR_EraseRootFromParent_Done,
     /*  88802 */   // Label 1627: @88802
     /*  88802 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(88909), // Rule ID 3768 //
     /*  88807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88828 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88831 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88858 */     // MIs[1] Operand 1
     /*  88858 */     // No operand predicates
     /*  88858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88880 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88885 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88907 */     GIR_RootConstrainSelectedInstOperands,
     /*  88908 */     // GIR_Coverage, 3768,
     /*  88908 */     GIR_EraseRootFromParent_Done,
     /*  88909 */   // Label 1628: @88909
     /*  88909 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(89016), // Rule ID 3770 //
     /*  88914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88935 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88938 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88965 */     // MIs[1] Operand 1
     /*  88965 */     // No operand predicates
     /*  88965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88987 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88992 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89014 */     GIR_RootConstrainSelectedInstOperands,
     /*  89015 */     // GIR_Coverage, 3770,
     /*  89015 */     GIR_EraseRootFromParent_Done,
     /*  89016 */   // Label 1629: @89016
     /*  89016 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(89123), // Rule ID 3772 //
     /*  89021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89042 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89045 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89072 */     // MIs[1] Operand 1
     /*  89072 */     // No operand predicates
     /*  89072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89094 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89099 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89121 */     GIR_RootConstrainSelectedInstOperands,
     /*  89122 */     // GIR_Coverage, 3772,
     /*  89122 */     GIR_EraseRootFromParent_Done,
     /*  89123 */   // Label 1630: @89123
     /*  89123 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(89230), // Rule ID 3774 //
     /*  89128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89149 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89152 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89179 */     // MIs[1] Operand 1
     /*  89179 */     // No operand predicates
     /*  89179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89201 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89206 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89228 */     GIR_RootConstrainSelectedInstOperands,
     /*  89229 */     // GIR_Coverage, 3774,
     /*  89229 */     GIR_EraseRootFromParent_Done,
     /*  89230 */   // Label 1631: @89230
     /*  89230 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(89337), // Rule ID 3776 //
     /*  89235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89256 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89259 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89286 */     // MIs[1] Operand 1
     /*  89286 */     // No operand predicates
     /*  89286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89308 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89313 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89335 */     GIR_RootConstrainSelectedInstOperands,
     /*  89336 */     // GIR_Coverage, 3776,
     /*  89336 */     GIR_EraseRootFromParent_Done,
     /*  89337 */   // Label 1632: @89337
     /*  89337 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(89444), // Rule ID 3778 //
     /*  89342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89363 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89366 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89393 */     // MIs[1] Operand 1
     /*  89393 */     // No operand predicates
     /*  89393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89415 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89420 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89442 */     GIR_RootConstrainSelectedInstOperands,
     /*  89443 */     // GIR_Coverage, 3778,
     /*  89443 */     GIR_EraseRootFromParent_Done,
     /*  89444 */   // Label 1633: @89444
     /*  89444 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(89551), // Rule ID 3780 //
     /*  89449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89470 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89473 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89500 */     // MIs[1] Operand 1
     /*  89500 */     // No operand predicates
     /*  89500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89527 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89549 */     GIR_RootConstrainSelectedInstOperands,
     /*  89550 */     // GIR_Coverage, 3780,
     /*  89550 */     GIR_EraseRootFromParent_Done,
     /*  89551 */   // Label 1634: @89551
     /*  89551 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(89658), // Rule ID 3782 //
     /*  89556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89577 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89580 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89607 */     // MIs[1] Operand 1
     /*  89607 */     // No operand predicates
     /*  89607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89629 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89634 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89656 */     GIR_RootConstrainSelectedInstOperands,
     /*  89657 */     // GIR_Coverage, 3782,
     /*  89657 */     GIR_EraseRootFromParent_Done,
     /*  89658 */   // Label 1635: @89658
     /*  89658 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(89765), // Rule ID 3784 //
     /*  89663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89684 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89687 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89714 */     // MIs[1] Operand 1
     /*  89714 */     // No operand predicates
     /*  89714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89736 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89741 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89763 */     GIR_RootConstrainSelectedInstOperands,
     /*  89764 */     // GIR_Coverage, 3784,
     /*  89764 */     GIR_EraseRootFromParent_Done,
     /*  89765 */   // Label 1636: @89765
     /*  89765 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(89872), // Rule ID 3786 //
     /*  89770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89791 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89794 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89821 */     // MIs[1] Operand 1
     /*  89821 */     // No operand predicates
     /*  89821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89843 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89848 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89870 */     GIR_RootConstrainSelectedInstOperands,
     /*  89871 */     // GIR_Coverage, 3786,
     /*  89871 */     GIR_EraseRootFromParent_Done,
     /*  89872 */   // Label 1637: @89872
     /*  89872 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89979), // Rule ID 3788 //
     /*  89877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89898 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89901 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89928 */     // MIs[1] Operand 1
     /*  89928 */     // No operand predicates
     /*  89928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89950 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89955 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89977 */     GIR_RootConstrainSelectedInstOperands,
     /*  89978 */     // GIR_Coverage, 3788,
     /*  89978 */     GIR_EraseRootFromParent_Done,
     /*  89979 */   // Label 1638: @89979
     /*  89979 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90086), // Rule ID 3790 //
     /*  89984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90005 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90008 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90035 */     // MIs[1] Operand 1
     /*  90035 */     // No operand predicates
     /*  90035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90057 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90062 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90084 */     GIR_RootConstrainSelectedInstOperands,
     /*  90085 */     // GIR_Coverage, 3790,
     /*  90085 */     GIR_EraseRootFromParent_Done,
     /*  90086 */   // Label 1639: @90086
     /*  90086 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90193), // Rule ID 3792 //
     /*  90091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90112 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90115 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90142 */     // MIs[1] Operand 1
     /*  90142 */     // No operand predicates
     /*  90142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90164 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90169 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90191 */     GIR_RootConstrainSelectedInstOperands,
     /*  90192 */     // GIR_Coverage, 3792,
     /*  90192 */     GIR_EraseRootFromParent_Done,
     /*  90193 */   // Label 1640: @90193
     /*  90193 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90300), // Rule ID 3794 //
     /*  90198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90219 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90222 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90249 */     // MIs[1] Operand 1
     /*  90249 */     // No operand predicates
     /*  90249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90271 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90276 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90298 */     GIR_RootConstrainSelectedInstOperands,
     /*  90299 */     // GIR_Coverage, 3794,
     /*  90299 */     GIR_EraseRootFromParent_Done,
     /*  90300 */   // Label 1641: @90300
     /*  90300 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90407), // Rule ID 3796 //
     /*  90305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90326 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90329 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90356 */     // MIs[1] Operand 1
     /*  90356 */     // No operand predicates
     /*  90356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90378 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90383 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90405 */     GIR_RootConstrainSelectedInstOperands,
     /*  90406 */     // GIR_Coverage, 3796,
     /*  90406 */     GIR_EraseRootFromParent_Done,
     /*  90407 */   // Label 1642: @90407
     /*  90407 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(90514), // Rule ID 3798 //
     /*  90412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90433 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90436 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90463 */     // MIs[1] Operand 1
     /*  90463 */     // No operand predicates
     /*  90463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90485 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90490 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90512 */     GIR_RootConstrainSelectedInstOperands,
     /*  90513 */     // GIR_Coverage, 3798,
     /*  90513 */     GIR_EraseRootFromParent_Done,
     /*  90514 */   // Label 1643: @90514
     /*  90514 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(90621), // Rule ID 3800 //
     /*  90519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90540 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90543 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90570 */     // MIs[1] Operand 1
     /*  90570 */     // No operand predicates
     /*  90570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90597 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90619 */     GIR_RootConstrainSelectedInstOperands,
     /*  90620 */     // GIR_Coverage, 3800,
     /*  90620 */     GIR_EraseRootFromParent_Done,
     /*  90621 */   // Label 1644: @90621
     /*  90621 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(90728), // Rule ID 3802 //
     /*  90626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90647 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90650 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90677 */     // MIs[1] Operand 1
     /*  90677 */     // No operand predicates
     /*  90677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90699 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90704 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90726 */     GIR_RootConstrainSelectedInstOperands,
     /*  90727 */     // GIR_Coverage, 3802,
     /*  90727 */     GIR_EraseRootFromParent_Done,
     /*  90728 */   // Label 1645: @90728
     /*  90728 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90835), // Rule ID 3804 //
     /*  90733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90754 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90757 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90784 */     // MIs[1] Operand 1
     /*  90784 */     // No operand predicates
     /*  90784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90811 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90833 */     GIR_RootConstrainSelectedInstOperands,
     /*  90834 */     // GIR_Coverage, 3804,
     /*  90834 */     GIR_EraseRootFromParent_Done,
     /*  90835 */   // Label 1646: @90835
     /*  90835 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90942), // Rule ID 3806 //
     /*  90840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90861 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90864 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90891 */     // MIs[1] Operand 1
     /*  90891 */     // No operand predicates
     /*  90891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90913 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90918 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90940 */     GIR_RootConstrainSelectedInstOperands,
     /*  90941 */     // GIR_Coverage, 3806,
     /*  90941 */     GIR_EraseRootFromParent_Done,
     /*  90942 */   // Label 1647: @90942
     /*  90942 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91049), // Rule ID 3808 //
     /*  90947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90968 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90971 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90998 */     // MIs[1] Operand 1
     /*  90998 */     // No operand predicates
     /*  90998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91020 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  91023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91025 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91047 */     GIR_RootConstrainSelectedInstOperands,
     /*  91048 */     // GIR_Coverage, 3808,
     /*  91048 */     GIR_EraseRootFromParent_Done,
     /*  91049 */   // Label 1648: @91049
     /*  91049 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91156), // Rule ID 3810 //
     /*  91054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91075 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91078 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91105 */     // MIs[1] Operand 1
     /*  91105 */     // No operand predicates
     /*  91105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91127 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91132 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91154 */     GIR_RootConstrainSelectedInstOperands,
     /*  91155 */     // GIR_Coverage, 3810,
     /*  91155 */     GIR_EraseRootFromParent_Done,
     /*  91156 */   // Label 1649: @91156
     /*  91156 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91263), // Rule ID 3812 //
     /*  91161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91182 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91185 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91212 */     // MIs[1] Operand 1
     /*  91212 */     // No operand predicates
     /*  91212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91234 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3580:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91239 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91261 */     GIR_RootConstrainSelectedInstOperands,
     /*  91262 */     // GIR_Coverage, 3812,
     /*  91262 */     GIR_EraseRootFromParent_Done,
     /*  91263 */   // Label 1650: @91263
     /*  91263 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91370), // Rule ID 3814 //
     /*  91268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91289 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91292 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91319 */     // MIs[1] Operand 1
     /*  91319 */     // No operand predicates
     /*  91319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91341 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91346 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91368 */     GIR_RootConstrainSelectedInstOperands,
     /*  91369 */     // GIR_Coverage, 3814,
     /*  91369 */     GIR_EraseRootFromParent_Done,
     /*  91370 */   // Label 1651: @91370
     /*  91370 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91477), // Rule ID 3816 //
     /*  91375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91396 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91399 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91426 */     // MIs[1] Operand 1
     /*  91426 */     // No operand predicates
     /*  91426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91448 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3580:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91453 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91475 */     GIR_RootConstrainSelectedInstOperands,
     /*  91476 */     // GIR_Coverage, 3816,
     /*  91476 */     GIR_EraseRootFromParent_Done,
     /*  91477 */   // Label 1652: @91477
     /*  91477 */   GIM_Reject,
     /*  91478 */ // Label 1612: @91478
     /*  91478 */ GIM_Reject,
     /*  91479 */ // Label 15: @91479
     /*  91479 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91536),
     /*  91484 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91487 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91492 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91509), // Rule ID 245 //
     /*  91497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91500 */     // (intrinsic_void 3365:{ *:[iPTR] })  =>  (CLREX)
     /*  91500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91507 */     GIR_RootConstrainSelectedInstOperands,
     /*  91508 */     // GIR_Coverage, 245,
     /*  91508 */     GIR_EraseRootFromParent_Done,
     /*  91509 */   // Label 1654: @91509
     /*  91509 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91535), // Rule ID 574 //
     /*  91514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91517 */     // (intrinsic_void 3365:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91533 */     GIR_RootConstrainSelectedInstOperands,
     /*  91534 */     // GIR_Coverage, 574,
     /*  91534 */     GIR_EraseRootFromParent_Done,
     /*  91535 */   // Label 1655: @91535
     /*  91535 */   GIM_Reject,
     /*  91536 */ // Label 1653: @91536
     /*  91536 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(92338),
     /*  91541 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91544 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91580), // Rule ID 344 //
     /*  91549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91557 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91560 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91571 */     // (intrinsic_void 3806:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91578 */     GIR_RootConstrainSelectedInstOperands,
     /*  91579 */     // GIR_Coverage, 344,
     /*  91579 */     GIR_EraseRootFromParent_Done,
     /*  91580 */   // Label 1657: @91580
     /*  91580 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91632), // Rule ID 2 //
     /*  91585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91593 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91608 */     // MIs[1] Operand 1
     /*  91608 */     // No operand predicates
     /*  91608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91610 */     // (intrinsic_void 3383:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91630 */     GIR_RootConstrainSelectedInstOperands,
     /*  91631 */     // GIR_Coverage, 2,
     /*  91631 */     GIR_EraseRootFromParent_Done,
     /*  91632 */   // Label 1658: @91632
     /*  91632 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91684), // Rule ID 10 //
     /*  91637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91645 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91660 */     // MIs[1] Operand 1
     /*  91660 */     // No operand predicates
     /*  91660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91662 */     // (intrinsic_void 3378:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91682 */     GIR_RootConstrainSelectedInstOperands,
     /*  91683 */     // GIR_Coverage, 10,
     /*  91683 */     GIR_EraseRootFromParent_Done,
     /*  91684 */   // Label 1659: @91684
     /*  91684 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91727), // Rule ID 11 //
     /*  91689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91697 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91712 */     // MIs[1] Operand 1
     /*  91712 */     // No operand predicates
     /*  91712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91714 */     // (intrinsic_void 3806:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91725 */     GIR_RootConstrainSelectedInstOperands,
     /*  91726 */     // GIR_Coverage, 11,
     /*  91726 */     GIR_EraseRootFromParent_Done,
     /*  91727 */   // Label 1660: @91727
     /*  91727 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91770), // Rule ID 228 //
     /*  91732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91740 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91755 */     // MIs[1] Operand 1
     /*  91755 */     // No operand predicates
     /*  91755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91757 */     // (intrinsic_void 3379:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91768 */     GIR_RootConstrainSelectedInstOperands,
     /*  91769 */     // GIR_Coverage, 228,
     /*  91769 */     GIR_EraseRootFromParent_Done,
     /*  91770 */   // Label 1661: @91770
     /*  91770 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91813), // Rule ID 229 //
     /*  91775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91783 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91798 */     // MIs[1] Operand 1
     /*  91798 */     // No operand predicates
     /*  91798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91800 */     // (intrinsic_void 3380:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91811 */     GIR_RootConstrainSelectedInstOperands,
     /*  91812 */     // GIR_Coverage, 229,
     /*  91812 */     GIR_EraseRootFromParent_Done,
     /*  91813 */   // Label 1662: @91813
     /*  91813 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91856), // Rule ID 230 //
     /*  91818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91826 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91841 */     // MIs[1] Operand 1
     /*  91841 */     // No operand predicates
     /*  91841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91843 */     // (intrinsic_void 3384:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91854 */     GIR_RootConstrainSelectedInstOperands,
     /*  91855 */     // GIR_Coverage, 230,
     /*  91855 */     GIR_EraseRootFromParent_Done,
     /*  91856 */   // Label 1663: @91856
     /*  91856 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91908), // Rule ID 276 //
     /*  91861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91869 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91884 */     // MIs[1] Operand 1
     /*  91884 */     // No operand predicates
     /*  91884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91886 */     // (intrinsic_void 3383:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91906 */     GIR_RootConstrainSelectedInstOperands,
     /*  91907 */     // GIR_Coverage, 276,
     /*  91907 */     GIR_EraseRootFromParent_Done,
     /*  91908 */   // Label 1664: @91908
     /*  91908 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91951), // Rule ID 343 //
     /*  91913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91921 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91936 */     // MIs[1] Operand 1
     /*  91936 */     // No operand predicates
     /*  91936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91938 */     // (intrinsic_void 3806:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91949 */     GIR_RootConstrainSelectedInstOperands,
     /*  91950 */     // GIR_Coverage, 343,
     /*  91950 */     GIR_EraseRootFromParent_Done,
     /*  91951 */   // Label 1665: @91951
     /*  91951 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91994), // Rule ID 494 //
     /*  91956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91964 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91979 */     // MIs[1] Operand 1
     /*  91979 */     // No operand predicates
     /*  91979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91981 */     // (intrinsic_void 3806:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91992 */     GIR_RootConstrainSelectedInstOperands,
     /*  91993 */     // GIR_Coverage, 494,
     /*  91993 */     GIR_EraseRootFromParent_Done,
     /*  91994 */   // Label 1666: @91994
     /*  91994 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(92046), // Rule ID 559 //
     /*  91999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  92007 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92022 */     // MIs[1] Operand 1
     /*  92022 */     // No operand predicates
     /*  92022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92024 */     // (intrinsic_void 3379:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  92024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  92027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92044 */     GIR_RootConstrainSelectedInstOperands,
     /*  92045 */     // GIR_Coverage, 559,
     /*  92045 */     GIR_EraseRootFromParent_Done,
     /*  92046 */   // Label 1667: @92046
     /*  92046 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(92098), // Rule ID 560 //
     /*  92051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92059 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92074 */     // MIs[1] Operand 1
     /*  92074 */     // No operand predicates
     /*  92074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92076 */     // (intrinsic_void 3380:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92096 */     GIR_RootConstrainSelectedInstOperands,
     /*  92097 */     // GIR_Coverage, 560,
     /*  92097 */     GIR_EraseRootFromParent_Done,
     /*  92098 */   // Label 1668: @92098
     /*  92098 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(92150), // Rule ID 561 //
     /*  92103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92111 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92126 */     // MIs[1] Operand 1
     /*  92126 */     // No operand predicates
     /*  92126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92128 */     // (intrinsic_void 3384:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92148 */     GIR_RootConstrainSelectedInstOperands,
     /*  92149 */     // GIR_Coverage, 561,
     /*  92149 */     GIR_EraseRootFromParent_Done,
     /*  92150 */   // Label 1669: @92150
     /*  92150 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(92202), // Rule ID 579 //
     /*  92155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92163 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92178 */     // MIs[1] Operand 1
     /*  92178 */     // No operand predicates
     /*  92178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92180 */     // (intrinsic_void 3383:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92200 */     GIR_RootConstrainSelectedInstOperands,
     /*  92201 */     // GIR_Coverage, 579,
     /*  92201 */     GIR_EraseRootFromParent_Done,
     /*  92202 */   // Label 1670: @92202
     /*  92202 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(92254), // Rule ID 580 //
     /*  92207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92215 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92230 */     // MIs[1] Operand 1
     /*  92230 */     // No operand predicates
     /*  92230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92232 */     // (intrinsic_void 3378:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92252 */     GIR_RootConstrainSelectedInstOperands,
     /*  92253 */     // GIR_Coverage, 580,
     /*  92253 */     GIR_EraseRootFromParent_Done,
     /*  92254 */   // Label 1671: @92254
     /*  92254 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(92294), // Rule ID 722 //
     /*  92259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92274 */     // (intrinsic_w_chain:{ *:[i32] } 3381:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92292 */     GIR_RootConstrainSelectedInstOperands,
     /*  92293 */     // GIR_Coverage, 722,
     /*  92293 */     GIR_EraseRootFromParent_Done,
     /*  92294 */   // Label 1672: @92294
     /*  92294 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(92337), // Rule ID 723 //
     /*  92299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92314 */     // (intrinsic_void 3750:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR GPRnopc:{ *:[i32] }:$Rt)
     /*  92314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92335 */     GIR_RootConstrainSelectedInstOperands,
     /*  92336 */     // GIR_Coverage, 723,
     /*  92336 */     GIR_EraseRootFromParent_Done,
     /*  92337 */   // Label 1673: @92337
     /*  92337 */   GIM_Reject,
     /*  92338 */ // Label 1656: @92338
     /*  92338 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92381), // Rule ID 604 //
     /*  92343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92346 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92349 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92354 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92368 */   // (intrinsic_w_chain:{ *:[i32] } 344:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92373 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92379 */   GIR_RootConstrainSelectedInstOperands,
     /*  92380 */   // GIR_Coverage, 604,
     /*  92380 */   GIR_EraseRootFromParent_Done,
     /*  92381 */ // Label 1674: @92381
     /*  92381 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94372),
     /*  92386 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92389 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92443), // Rule ID 5031 //
     /*  92394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92424 */     // MIs[1] Operand 1
     /*  92424 */     // No operand predicates
     /*  92424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92426 */     // (intrinsic_w_chain:{ *:[v4i32] } 3514:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92431 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92441 */     GIR_RootConstrainSelectedInstOperands,
     /*  92442 */     // GIR_Coverage, 5031,
     /*  92442 */     GIR_EraseRootFromParent_Done,
     /*  92443 */   // Label 1676: @92443
     /*  92443 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92497), // Rule ID 5037 //
     /*  92448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92478 */     // MIs[1] Operand 1
     /*  92478 */     // No operand predicates
     /*  92478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92480 */     // (intrinsic_w_chain:{ *:[v4f32] } 3514:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92485 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92495 */     GIR_RootConstrainSelectedInstOperands,
     /*  92496 */     // GIR_Coverage, 5037,
     /*  92496 */     GIR_EraseRootFromParent_Done,
     /*  92497 */   // Label 1677: @92497
     /*  92497 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92551), // Rule ID 5039 //
     /*  92502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92532 */     // MIs[1] Operand 1
     /*  92532 */     // No operand predicates
     /*  92532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92534 */     // (intrinsic_w_chain:{ *:[v2i64] } 3514:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92539 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92549 */     GIR_RootConstrainSelectedInstOperands,
     /*  92550 */     // GIR_Coverage, 5039,
     /*  92550 */     GIR_EraseRootFromParent_Done,
     /*  92551 */   // Label 1678: @92551
     /*  92551 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92605), // Rule ID 5041 //
     /*  92556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92586 */     // MIs[1] Operand 1
     /*  92586 */     // No operand predicates
     /*  92586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92588 */     // (intrinsic_w_chain:{ *:[v2f64] } 3514:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92593 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92603 */     GIR_RootConstrainSelectedInstOperands,
     /*  92604 */     // GIR_Coverage, 5041,
     /*  92604 */     GIR_EraseRootFromParent_Done,
     /*  92605 */   // Label 1679: @92605
     /*  92605 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92647), // Rule ID 1738 //
     /*  92610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92625 */     // MIs[0] size
     /*  92625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92632 */     // (intrinsic_w_chain:{ *:[i32] } 3781:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92637 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92645 */     GIR_RootConstrainSelectedInstOperands,
     /*  92646 */     // GIR_Coverage, 1738,
     /*  92646 */     GIR_EraseRootFromParent_Done,
     /*  92647 */   // Label 1680: @92647
     /*  92647 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92701), // Rule ID 5033 //
     /*  92652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92657 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92678 */     // MIs[1] Operand 1
     /*  92678 */     // No operand predicates
     /*  92678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92684 */     // (intrinsic_void 3588:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92687 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92689 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92699 */     GIR_RootConstrainSelectedInstOperands,
     /*  92700 */     // GIR_Coverage, 5033,
     /*  92700 */     GIR_EraseRootFromParent_Done,
     /*  92701 */   // Label 1681: @92701
     /*  92701 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92755), // Rule ID 5043 //
     /*  92706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92711 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92732 */     // MIs[1] Operand 1
     /*  92732 */     // No operand predicates
     /*  92732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92738 */     // (intrinsic_void 3588:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92741 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92743 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92753 */     GIR_RootConstrainSelectedInstOperands,
     /*  92754 */     // GIR_Coverage, 5043,
     /*  92754 */     GIR_EraseRootFromParent_Done,
     /*  92755 */   // Label 1682: @92755
     /*  92755 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92809), // Rule ID 5047 //
     /*  92760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92765 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92786 */     // MIs[1] Operand 1
     /*  92786 */     // No operand predicates
     /*  92786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92792 */     // (intrinsic_void 3588:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92795 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92797 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92807 */     GIR_RootConstrainSelectedInstOperands,
     /*  92808 */     // GIR_Coverage, 5047,
     /*  92808 */     GIR_EraseRootFromParent_Done,
     /*  92809 */   // Label 1683: @92809
     /*  92809 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92863), // Rule ID 5051 //
     /*  92814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92819 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92840 */     // MIs[1] Operand 1
     /*  92840 */     // No operand predicates
     /*  92840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92846 */     // (intrinsic_void 3588:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92849 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92851 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92861 */     GIR_RootConstrainSelectedInstOperands,
     /*  92862 */     // GIR_Coverage, 5051,
     /*  92862 */     GIR_EraseRootFromParent_Done,
     /*  92863 */   // Label 1684: @92863
     /*  92863 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92921), // Rule ID 3 //
     /*  92868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92897 */     // (intrinsic_w_chain:{ *:[i32] } 3749:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92919 */     GIR_RootConstrainSelectedInstOperands,
     /*  92920 */     // GIR_Coverage, 3,
     /*  92920 */     GIR_EraseRootFromParent_Done,
     /*  92921 */   // Label 1685: @92921
     /*  92921 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92979), // Rule ID 121 //
     /*  92926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92955 */     // (intrinsic_w_chain:{ *:[i32] } 3748:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92977 */     GIR_RootConstrainSelectedInstOperands,
     /*  92978 */     // GIR_Coverage, 121,
     /*  92978 */     GIR_EraseRootFromParent_Done,
     /*  92979 */   // Label 1686: @92979
     /*  92979 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(93037), // Rule ID 122 //
     /*  92984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93013 */     // (intrinsic_w_chain:{ *:[i32] } 3746:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  93016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93035 */     GIR_RootConstrainSelectedInstOperands,
     /*  93036 */     // GIR_Coverage, 122,
     /*  93036 */     GIR_EraseRootFromParent_Done,
     /*  93037 */   // Label 1687: @93037
     /*  93037 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(93095), // Rule ID 123 //
     /*  93042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93071 */     // (intrinsic_w_chain:{ *:[i32] } 3747:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93093 */     GIR_RootConstrainSelectedInstOperands,
     /*  93094 */     // GIR_Coverage, 123,
     /*  93094 */     GIR_EraseRootFromParent_Done,
     /*  93095 */   // Label 1688: @93095
     /*  93095 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(93153), // Rule ID 124 //
     /*  93100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93129 */     // (intrinsic_w_chain:{ *:[i32] } 3784:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93151 */     GIR_RootConstrainSelectedInstOperands,
     /*  93152 */     // GIR_Coverage, 124,
     /*  93152 */     GIR_EraseRootFromParent_Done,
     /*  93153 */   // Label 1689: @93153
     /*  93153 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(93211), // Rule ID 125 //
     /*  93158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93187 */     // (intrinsic_w_chain:{ *:[i32] } 3785:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93209 */     GIR_RootConstrainSelectedInstOperands,
     /*  93210 */     // GIR_Coverage, 125,
     /*  93210 */     GIR_EraseRootFromParent_Done,
     /*  93211 */   // Label 1690: @93211
     /*  93211 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(93269), // Rule ID 126 //
     /*  93216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93245 */     // (intrinsic_w_chain:{ *:[i32] } 3786:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93267 */     GIR_RootConstrainSelectedInstOperands,
     /*  93268 */     // GIR_Coverage, 126,
     /*  93268 */     GIR_EraseRootFromParent_Done,
     /*  93269 */   // Label 1691: @93269
     /*  93269 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(93327), // Rule ID 127 //
     /*  93274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93303 */     // (intrinsic_w_chain:{ *:[i32] } 3799:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93325 */     GIR_RootConstrainSelectedInstOperands,
     /*  93326 */     // GIR_Coverage, 127,
     /*  93326 */     GIR_EraseRootFromParent_Done,
     /*  93327 */   // Label 1692: @93327
     /*  93327 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(93385), // Rule ID 128 //
     /*  93332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93361 */     // (intrinsic_w_chain:{ *:[i32] } 3797:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93383 */     GIR_RootConstrainSelectedInstOperands,
     /*  93384 */     // GIR_Coverage, 128,
     /*  93384 */     GIR_EraseRootFromParent_Done,
     /*  93385 */   // Label 1693: @93385
     /*  93385 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(93443), // Rule ID 129 //
     /*  93390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93419 */     // (intrinsic_w_chain:{ *:[i32] } 3798:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93441 */     GIR_RootConstrainSelectedInstOperands,
     /*  93442 */     // GIR_Coverage, 129,
     /*  93442 */     GIR_EraseRootFromParent_Done,
     /*  93443 */   // Label 1694: @93443
     /*  93443 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(93501), // Rule ID 130 //
     /*  93448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93477 */     // (intrinsic_w_chain:{ *:[i32] } 3817:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93499 */     GIR_RootConstrainSelectedInstOperands,
     /*  93500 */     // GIR_Coverage, 130,
     /*  93500 */     GIR_EraseRootFromParent_Done,
     /*  93501 */   // Label 1695: @93501
     /*  93501 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93559), // Rule ID 131 //
     /*  93506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93535 */     // (intrinsic_w_chain:{ *:[i32] } 3818:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93557 */     GIR_RootConstrainSelectedInstOperands,
     /*  93558 */     // GIR_Coverage, 131,
     /*  93558 */     GIR_EraseRootFromParent_Done,
     /*  93559 */   // Label 1696: @93559
     /*  93559 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93617), // Rule ID 132 //
     /*  93564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93593 */     // (intrinsic_w_chain:{ *:[i32] } 3819:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93615 */     GIR_RootConstrainSelectedInstOperands,
     /*  93616 */     // GIR_Coverage, 132,
     /*  93616 */     GIR_EraseRootFromParent_Done,
     /*  93617 */   // Label 1697: @93617
     /*  93617 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93675), // Rule ID 431 //
     /*  93622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93651 */     // (intrinsic_w_chain:{ *:[i32] } 3749:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93673 */     GIR_RootConstrainSelectedInstOperands,
     /*  93674 */     // GIR_Coverage, 431,
     /*  93674 */     GIR_EraseRootFromParent_Done,
     /*  93675 */   // Label 1698: @93675
     /*  93675 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93733), // Rule ID 444 //
     /*  93680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93709 */     // (intrinsic_w_chain:{ *:[i32] } 3748:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93731 */     GIR_RootConstrainSelectedInstOperands,
     /*  93732 */     // GIR_Coverage, 444,
     /*  93732 */     GIR_EraseRootFromParent_Done,
     /*  93733 */   // Label 1699: @93733
     /*  93733 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93791), // Rule ID 445 //
     /*  93738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93767 */     // (intrinsic_w_chain:{ *:[i32] } 3746:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93789 */     GIR_RootConstrainSelectedInstOperands,
     /*  93790 */     // GIR_Coverage, 445,
     /*  93790 */     GIR_EraseRootFromParent_Done,
     /*  93791 */   // Label 1700: @93791
     /*  93791 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93849), // Rule ID 446 //
     /*  93796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93825 */     // (intrinsic_w_chain:{ *:[i32] } 3747:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93847 */     GIR_RootConstrainSelectedInstOperands,
     /*  93848 */     // GIR_Coverage, 446,
     /*  93848 */     GIR_EraseRootFromParent_Done,
     /*  93849 */   // Label 1701: @93849
     /*  93849 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93907), // Rule ID 447 //
     /*  93854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93883 */     // (intrinsic_w_chain:{ *:[i32] } 3784:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93905 */     GIR_RootConstrainSelectedInstOperands,
     /*  93906 */     // GIR_Coverage, 447,
     /*  93906 */     GIR_EraseRootFromParent_Done,
     /*  93907 */   // Label 1702: @93907
     /*  93907 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93965), // Rule ID 448 //
     /*  93912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93941 */     // (intrinsic_w_chain:{ *:[i32] } 3785:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93963 */     GIR_RootConstrainSelectedInstOperands,
     /*  93964 */     // GIR_Coverage, 448,
     /*  93964 */     GIR_EraseRootFromParent_Done,
     /*  93965 */   // Label 1703: @93965
     /*  93965 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(94023), // Rule ID 449 //
     /*  93970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93999 */     // (intrinsic_w_chain:{ *:[i32] } 3786:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  94002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94021 */     GIR_RootConstrainSelectedInstOperands,
     /*  94022 */     // GIR_Coverage, 449,
     /*  94022 */     GIR_EraseRootFromParent_Done,
     /*  94023 */   // Label 1704: @94023
     /*  94023 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(94081), // Rule ID 450 //
     /*  94028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94057 */     // (intrinsic_w_chain:{ *:[i32] } 3799:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94079 */     GIR_RootConstrainSelectedInstOperands,
     /*  94080 */     // GIR_Coverage, 450,
     /*  94080 */     GIR_EraseRootFromParent_Done,
     /*  94081 */   // Label 1705: @94081
     /*  94081 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(94139), // Rule ID 451 //
     /*  94086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94115 */     // (intrinsic_w_chain:{ *:[i32] } 3797:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94137 */     GIR_RootConstrainSelectedInstOperands,
     /*  94138 */     // GIR_Coverage, 451,
     /*  94138 */     GIR_EraseRootFromParent_Done,
     /*  94139 */   // Label 1706: @94139
     /*  94139 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(94197), // Rule ID 452 //
     /*  94144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94173 */     // (intrinsic_w_chain:{ *:[i32] } 3798:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94195 */     GIR_RootConstrainSelectedInstOperands,
     /*  94196 */     // GIR_Coverage, 452,
     /*  94196 */     GIR_EraseRootFromParent_Done,
     /*  94197 */   // Label 1707: @94197
     /*  94197 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(94255), // Rule ID 453 //
     /*  94202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94231 */     // (intrinsic_w_chain:{ *:[i32] } 3817:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94253 */     GIR_RootConstrainSelectedInstOperands,
     /*  94254 */     // GIR_Coverage, 453,
     /*  94254 */     GIR_EraseRootFromParent_Done,
     /*  94255 */   // Label 1708: @94255
     /*  94255 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(94313), // Rule ID 454 //
     /*  94260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94289 */     // (intrinsic_w_chain:{ *:[i32] } 3818:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94311 */     GIR_RootConstrainSelectedInstOperands,
     /*  94312 */     // GIR_Coverage, 454,
     /*  94312 */     GIR_EraseRootFromParent_Done,
     /*  94313 */   // Label 1709: @94313
     /*  94313 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(94371), // Rule ID 455 //
     /*  94318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94347 */     // (intrinsic_w_chain:{ *:[i32] } 3819:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94369 */     GIR_RootConstrainSelectedInstOperands,
     /*  94370 */     // GIR_Coverage, 455,
     /*  94370 */     GIR_EraseRootFromParent_Done,
     /*  94371 */   // Label 1710: @94371
     /*  94371 */   GIM_Reject,
     /*  94372 */ // Label 1675: @94372
     /*  94372 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(94618),
     /*  94377 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94380 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94385 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(94443), // Rule ID 5035 //
     /*  94390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94418 */     // MIs[1] Operand 1
     /*  94418 */     // No operand predicates
     /*  94418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94424 */     // (intrinsic_w_chain:{ *:[v4i32] } 3590:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94429 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94431 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94441 */     GIR_RootConstrainSelectedInstOperands,
     /*  94442 */     // GIR_Coverage, 5035,
     /*  94442 */     GIR_EraseRootFromParent_Done,
     /*  94443 */   // Label 1712: @94443
     /*  94443 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94501), // Rule ID 5045 //
     /*  94448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94476 */     // MIs[1] Operand 1
     /*  94476 */     // No operand predicates
     /*  94476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94482 */     // (intrinsic_w_chain:{ *:[v4i32] } 3590:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94487 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94489 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94499 */     GIR_RootConstrainSelectedInstOperands,
     /*  94500 */     // GIR_Coverage, 5045,
     /*  94500 */     GIR_EraseRootFromParent_Done,
     /*  94501 */   // Label 1713: @94501
     /*  94501 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94559), // Rule ID 5049 //
     /*  94506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94534 */     // MIs[1] Operand 1
     /*  94534 */     // No operand predicates
     /*  94534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94540 */     // (intrinsic_w_chain:{ *:[v2i64] } 3590:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94545 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94547 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94557 */     GIR_RootConstrainSelectedInstOperands,
     /*  94558 */     // GIR_Coverage, 5049,
     /*  94558 */     GIR_EraseRootFromParent_Done,
     /*  94559 */   // Label 1714: @94559
     /*  94559 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94617), // Rule ID 5053 //
     /*  94564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94592 */     // MIs[1] Operand 1
     /*  94592 */     // No operand predicates
     /*  94592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94598 */     // (intrinsic_w_chain:{ *:[v2i64] } 3590:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94603 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94605 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94615 */     GIR_RootConstrainSelectedInstOperands,
     /*  94616 */     // GIR_Coverage, 5053,
     /*  94616 */     GIR_EraseRootFromParent_Done,
     /*  94617 */   // Label 1715: @94617
     /*  94617 */   GIM_Reject,
     /*  94618 */ // Label 1711: @94618
     /*  94618 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(95789),
     /*  94623 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94626 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94687), // Rule ID 4923 //
     /*  94631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94648 */     // MIs[0] base
     /*  94648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94672 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94675 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94677 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94679 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94685 */     GIR_RootConstrainSelectedInstOperands,
     /*  94686 */     // GIR_Coverage, 4923,
     /*  94686 */     GIR_EraseRootFromParent_Done,
     /*  94687 */   // Label 1717: @94687
     /*  94687 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94748), // Rule ID 4924 //
     /*  94692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94709 */     // MIs[0] base
     /*  94709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94733 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94736 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94738 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94740 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94746 */     GIR_RootConstrainSelectedInstOperands,
     /*  94747 */     // GIR_Coverage, 4924,
     /*  94747 */     GIR_EraseRootFromParent_Done,
     /*  94748 */   // Label 1718: @94748
     /*  94748 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94809), // Rule ID 4927 //
     /*  94753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94770 */     // MIs[0] base
     /*  94770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94794 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94797 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94799 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94801 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94807 */     GIR_RootConstrainSelectedInstOperands,
     /*  94808 */     // GIR_Coverage, 4927,
     /*  94808 */     GIR_EraseRootFromParent_Done,
     /*  94809 */   // Label 1719: @94809
     /*  94809 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94870), // Rule ID 5007 //
     /*  94814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94831 */     // MIs[0] base
     /*  94831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94855 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94858 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94860 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94862 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94868 */     GIR_RootConstrainSelectedInstOperands,
     /*  94869 */     // GIR_Coverage, 5007,
     /*  94869 */     GIR_EraseRootFromParent_Done,
     /*  94870 */   // Label 1720: @94870
     /*  94870 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94931), // Rule ID 5009 //
     /*  94875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94892 */     // MIs[0] base
     /*  94892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94916 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94919 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94921 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94923 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94929 */     GIR_RootConstrainSelectedInstOperands,
     /*  94930 */     // GIR_Coverage, 5009,
     /*  94930 */     GIR_EraseRootFromParent_Done,
     /*  94931 */   // Label 1721: @94931
     /*  94931 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94992), // Rule ID 5011 //
     /*  94936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94953 */     // MIs[0] base
     /*  94953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94977 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94980 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94982 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94984 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94990 */     GIR_RootConstrainSelectedInstOperands,
     /*  94991 */     // GIR_Coverage, 5011,
     /*  94991 */     GIR_EraseRootFromParent_Done,
     /*  94992 */   // Label 1722: @94992
     /*  94992 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(95053), // Rule ID 5012 //
     /*  94997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95014 */     // MIs[0] base
     /*  95014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95038 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95041 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95043 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95045 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95051 */     GIR_RootConstrainSelectedInstOperands,
     /*  95052 */     // GIR_Coverage, 5012,
     /*  95052 */     GIR_EraseRootFromParent_Done,
     /*  95053 */   // Label 1723: @95053
     /*  95053 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(95114), // Rule ID 5015 //
     /*  95058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95075 */     // MIs[0] base
     /*  95075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95099 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95102 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95104 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95106 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95112 */     GIR_RootConstrainSelectedInstOperands,
     /*  95113 */     // GIR_Coverage, 5015,
     /*  95113 */     GIR_EraseRootFromParent_Done,
     /*  95114 */   // Label 1724: @95114
     /*  95114 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(95175), // Rule ID 5016 //
     /*  95119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95136 */     // MIs[0] base
     /*  95136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95160 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95163 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95165 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95167 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95173 */     GIR_RootConstrainSelectedInstOperands,
     /*  95174 */     // GIR_Coverage, 5016,
     /*  95174 */     GIR_EraseRootFromParent_Done,
     /*  95175 */   // Label 1725: @95175
     /*  95175 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95236), // Rule ID 5019 //
     /*  95180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95197 */     // MIs[0] base
     /*  95197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95221 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95224 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95226 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95228 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95234 */     GIR_RootConstrainSelectedInstOperands,
     /*  95235 */     // GIR_Coverage, 5019,
     /*  95235 */     GIR_EraseRootFromParent_Done,
     /*  95236 */   // Label 1726: @95236
     /*  95236 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(95297), // Rule ID 5020 //
     /*  95241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95258 */     // MIs[0] base
     /*  95258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95282 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95285 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95287 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95289 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95295 */     GIR_RootConstrainSelectedInstOperands,
     /*  95296 */     // GIR_Coverage, 5020,
     /*  95296 */     GIR_EraseRootFromParent_Done,
     /*  95297 */   // Label 1727: @95297
     /*  95297 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(95358), // Rule ID 5023 //
     /*  95302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95319 */     // MIs[0] base
     /*  95319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95343 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95346 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95348 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95350 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95356 */     GIR_RootConstrainSelectedInstOperands,
     /*  95357 */     // GIR_Coverage, 5023,
     /*  95357 */     GIR_EraseRootFromParent_Done,
     /*  95358 */   // Label 1728: @95358
     /*  95358 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(95419), // Rule ID 5024 //
     /*  95363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95380 */     // MIs[0] base
     /*  95380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95404 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95407 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95409 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95411 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95417 */     GIR_RootConstrainSelectedInstOperands,
     /*  95418 */     // GIR_Coverage, 5024,
     /*  95418 */     GIR_EraseRootFromParent_Done,
     /*  95419 */   // Label 1729: @95419
     /*  95419 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95480), // Rule ID 5027 //
     /*  95424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95441 */     // MIs[0] base
     /*  95441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95465 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95468 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95470 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95472 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95478 */     GIR_RootConstrainSelectedInstOperands,
     /*  95479 */     // GIR_Coverage, 5027,
     /*  95479 */     GIR_EraseRootFromParent_Done,
     /*  95480 */   // Label 1730: @95480
     /*  95480 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95541), // Rule ID 5028 //
     /*  95485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95502 */     // MIs[0] base
     /*  95502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95526 */     // (intrinsic_void 3592:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95529 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95531 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95533 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95539 */     GIR_RootConstrainSelectedInstOperands,
     /*  95540 */     // GIR_Coverage, 5028,
     /*  95540 */     GIR_EraseRootFromParent_Done,
     /*  95541 */   // Label 1731: @95541
     /*  95541 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95605), // Rule ID 258 //
     /*  95546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95560 */     // MIs[0] cop
     /*  95560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95563 */     // MIs[0] opc1
     /*  95563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95574 */     // MIs[0] CRm
     /*  95574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95577 */     // (intrinsic_void 3395:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95580 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95582 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95588 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95603 */     GIR_RootConstrainSelectedInstOperands,
     /*  95604 */     // GIR_Coverage, 258,
     /*  95604 */     GIR_EraseRootFromParent_Done,
     /*  95605 */   // Label 1732: @95605
     /*  95605 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95660), // Rule ID 259 //
     /*  95610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95624 */     // MIs[0] cop
     /*  95624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95627 */     // MIs[0] opc1
     /*  95627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95638 */     // MIs[0] CRm
     /*  95638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95641 */     // (intrinsic_void 3396:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95644 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95646 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95652 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95658 */     GIR_RootConstrainSelectedInstOperands,
     /*  95659 */     // GIR_Coverage, 259,
     /*  95659 */     GIR_EraseRootFromParent_Done,
     /*  95660 */   // Label 1733: @95660
     /*  95660 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95724), // Rule ID 596 //
     /*  95665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95679 */     // MIs[0] cop
     /*  95679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95682 */     // MIs[0] opc1
     /*  95682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95693 */     // MIs[0] CRm
     /*  95693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95696 */     // (intrinsic_void 3395:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95699 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95701 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95707 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95722 */     GIR_RootConstrainSelectedInstOperands,
     /*  95723 */     // GIR_Coverage, 596,
     /*  95723 */     GIR_EraseRootFromParent_Done,
     /*  95724 */   // Label 1734: @95724
     /*  95724 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95788), // Rule ID 597 //
     /*  95729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95743 */     // MIs[0] cop
     /*  95743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95746 */     // MIs[0] opc1
     /*  95746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95757 */     // MIs[0] CRm
     /*  95757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95760 */     // (intrinsic_void 3396:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95763 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95765 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95771 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95786 */     GIR_RootConstrainSelectedInstOperands,
     /*  95787 */     // GIR_Coverage, 597,
     /*  95787 */     GIR_EraseRootFromParent_Done,
     /*  95788 */   // Label 1735: @95788
     /*  95788 */   GIM_Reject,
     /*  95789 */ // Label 1716: @95789
     /*  95789 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(99140),
     /*  95794 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95797 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95858), // Rule ID 246 //
     /*  95802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95810 */     // MIs[0] cop
     /*  95810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95813 */     // MIs[0] opc1
     /*  95813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95816 */     // MIs[0] CRd
     /*  95816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95819 */     // MIs[0] CRn
     /*  95819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95822 */     // MIs[0] CRm
     /*  95822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95825 */     // MIs[0] opc2
     /*  95825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95828 */     // (intrinsic_void 3363:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95831 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95833 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95835 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95837 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95839 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95841 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95856 */     GIR_RootConstrainSelectedInstOperands,
     /*  95857 */     // GIR_Coverage, 246,
     /*  95857 */     GIR_EraseRootFromParent_Done,
     /*  95858 */   // Label 1737: @95858
     /*  95858 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95910), // Rule ID 247 //
     /*  95863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95871 */     // MIs[0] cop
     /*  95871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95874 */     // MIs[0] opc1
     /*  95874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95877 */     // MIs[0] CRd
     /*  95877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95880 */     // MIs[0] CRn
     /*  95880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95883 */     // MIs[0] CRm
     /*  95883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95886 */     // MIs[0] opc2
     /*  95886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95889 */     // (intrinsic_void 3364:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95892 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95894 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95896 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95898 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95900 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95902 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95908 */     GIR_RootConstrainSelectedInstOperands,
     /*  95909 */     // GIR_Coverage, 247,
     /*  95909 */     GIR_EraseRootFromParent_Done,
     /*  95910 */   // Label 1738: @95910
     /*  95910 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95971), // Rule ID 598 //
     /*  95915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95923 */     // MIs[0] cop
     /*  95923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95926 */     // MIs[0] opc1
     /*  95926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95929 */     // MIs[0] CRd
     /*  95929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95932 */     // MIs[0] CRn
     /*  95932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95935 */     // MIs[0] CRm
     /*  95935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95938 */     // MIs[0] opc2
     /*  95938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95941 */     // (intrinsic_void 3363:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95944 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95946 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95948 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95950 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95952 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95954 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95969 */     GIR_RootConstrainSelectedInstOperands,
     /*  95970 */     // GIR_Coverage, 598,
     /*  95970 */     GIR_EraseRootFromParent_Done,
     /*  95971 */   // Label 1739: @95971
     /*  95971 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96032), // Rule ID 599 //
     /*  95976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95984 */     // MIs[0] cop
     /*  95984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95987 */     // MIs[0] opc1
     /*  95987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95990 */     // MIs[0] CRd
     /*  95990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95993 */     // MIs[0] CRn
     /*  95993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95996 */     // MIs[0] CRm
     /*  95996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95999 */     // MIs[0] opc2
     /*  95999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96002 */     // (intrinsic_void 3364:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  96005 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96007 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96009 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96011 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96013 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96015 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96030 */     GIR_RootConstrainSelectedInstOperands,
     /*  96031 */     // GIR_Coverage, 599,
     /*  96031 */     GIR_EraseRootFromParent_Done,
     /*  96032 */   // Label 1740: @96032
     /*  96032 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(96100), // Rule ID 4917 //
     /*  96037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96061 */     // MIs[0] base
     /*  96061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96085 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96090 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96092 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96098 */     GIR_RootConstrainSelectedInstOperands,
     /*  96099 */     // GIR_Coverage, 4917,
     /*  96099 */     GIR_EraseRootFromParent_Done,
     /*  96100 */   // Label 1741: @96100
     /*  96100 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(96168), // Rule ID 4918 //
     /*  96105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96129 */     // MIs[0] base
     /*  96129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96153 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96158 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96160 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96166 */     GIR_RootConstrainSelectedInstOperands,
     /*  96167 */     // GIR_Coverage, 4918,
     /*  96167 */     GIR_EraseRootFromParent_Done,
     /*  96168 */   // Label 1742: @96168
     /*  96168 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(96236), // Rule ID 4921 //
     /*  96173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96197 */     // MIs[0] base
     /*  96197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96221 */     // (intrinsic_w_chain:{ *:[v16i8] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96226 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96228 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96234 */     GIR_RootConstrainSelectedInstOperands,
     /*  96235 */     // GIR_Coverage, 4921,
     /*  96235 */     GIR_EraseRootFromParent_Done,
     /*  96236 */   // Label 1743: @96236
     /*  96236 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(96304), // Rule ID 4929 //
     /*  96241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96265 */     // MIs[0] base
     /*  96265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96289 */     // (intrinsic_w_chain:{ *:[v16i8] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96294 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96296 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96302 */     GIR_RootConstrainSelectedInstOperands,
     /*  96303 */     // GIR_Coverage, 4929,
     /*  96303 */     GIR_EraseRootFromParent_Done,
     /*  96304 */   // Label 1744: @96304
     /*  96304 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(96372), // Rule ID 4931 //
     /*  96309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96333 */     // MIs[0] base
     /*  96333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96357 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96362 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96364 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96370 */     GIR_RootConstrainSelectedInstOperands,
     /*  96371 */     // GIR_Coverage, 4931,
     /*  96371 */     GIR_EraseRootFromParent_Done,
     /*  96372 */   // Label 1745: @96372
     /*  96372 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(96440), // Rule ID 4933 //
     /*  96377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96401 */     // MIs[0] base
     /*  96401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96425 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96430 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96432 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96438 */     GIR_RootConstrainSelectedInstOperands,
     /*  96439 */     // GIR_Coverage, 4933,
     /*  96439 */     GIR_EraseRootFromParent_Done,
     /*  96440 */   // Label 1746: @96440
     /*  96440 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(96508), // Rule ID 4935 //
     /*  96445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96469 */     // MIs[0] base
     /*  96469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96493 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96498 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96500 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96506 */     GIR_RootConstrainSelectedInstOperands,
     /*  96507 */     // GIR_Coverage, 4935,
     /*  96507 */     GIR_EraseRootFromParent_Done,
     /*  96508 */   // Label 1747: @96508
     /*  96508 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96576), // Rule ID 4937 //
     /*  96513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96537 */     // MIs[0] base
     /*  96537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96561 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96566 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96568 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96574 */     GIR_RootConstrainSelectedInstOperands,
     /*  96575 */     // GIR_Coverage, 4937,
     /*  96575 */     GIR_EraseRootFromParent_Done,
     /*  96576 */   // Label 1748: @96576
     /*  96576 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96644), // Rule ID 4939 //
     /*  96581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96605 */     // MIs[0] base
     /*  96605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96629 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96634 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96636 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96642 */     GIR_RootConstrainSelectedInstOperands,
     /*  96643 */     // GIR_Coverage, 4939,
     /*  96643 */     GIR_EraseRootFromParent_Done,
     /*  96644 */   // Label 1749: @96644
     /*  96644 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96712), // Rule ID 4940 //
     /*  96649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96673 */     // MIs[0] base
     /*  96673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96697 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96702 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96704 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96710 */     GIR_RootConstrainSelectedInstOperands,
     /*  96711 */     // GIR_Coverage, 4940,
     /*  96711 */     GIR_EraseRootFromParent_Done,
     /*  96712 */   // Label 1750: @96712
     /*  96712 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96780), // Rule ID 4943 //
     /*  96717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96741 */     // MIs[0] base
     /*  96741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96765 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96770 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96772 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96778 */     GIR_RootConstrainSelectedInstOperands,
     /*  96779 */     // GIR_Coverage, 4943,
     /*  96779 */     GIR_EraseRootFromParent_Done,
     /*  96780 */   // Label 1751: @96780
     /*  96780 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96848), // Rule ID 4944 //
     /*  96785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96809 */     // MIs[0] base
     /*  96809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96833 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96838 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96840 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96846 */     GIR_RootConstrainSelectedInstOperands,
     /*  96847 */     // GIR_Coverage, 4944,
     /*  96847 */     GIR_EraseRootFromParent_Done,
     /*  96848 */   // Label 1752: @96848
     /*  96848 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96916), // Rule ID 4947 //
     /*  96853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96877 */     // MIs[0] base
     /*  96877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96901 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96906 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96908 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96914 */     GIR_RootConstrainSelectedInstOperands,
     /*  96915 */     // GIR_Coverage, 4947,
     /*  96915 */     GIR_EraseRootFromParent_Done,
     /*  96916 */   // Label 1753: @96916
     /*  96916 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96984), // Rule ID 4948 //
     /*  96921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96945 */     // MIs[0] base
     /*  96945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96969 */     // (intrinsic_w_chain:{ *:[v8i16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96974 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96976 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96982 */     GIR_RootConstrainSelectedInstOperands,
     /*  96983 */     // GIR_Coverage, 4948,
     /*  96983 */     GIR_EraseRootFromParent_Done,
     /*  96984 */   // Label 1754: @96984
     /*  96984 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(97052), // Rule ID 4951 //
     /*  96989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97013 */     // MIs[0] base
     /*  97013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97037 */     // (intrinsic_w_chain:{ *:[v8f16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97042 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97044 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97050 */     GIR_RootConstrainSelectedInstOperands,
     /*  97051 */     // GIR_Coverage, 4951,
     /*  97051 */     GIR_EraseRootFromParent_Done,
     /*  97052 */   // Label 1755: @97052
     /*  97052 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(97120), // Rule ID 4952 //
     /*  97057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97081 */     // MIs[0] base
     /*  97081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97105 */     // (intrinsic_w_chain:{ *:[v8f16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97110 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97112 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97118 */     GIR_RootConstrainSelectedInstOperands,
     /*  97119 */     // GIR_Coverage, 4952,
     /*  97119 */     GIR_EraseRootFromParent_Done,
     /*  97120 */   // Label 1756: @97120
     /*  97120 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(97188), // Rule ID 4955 //
     /*  97125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97149 */     // MIs[0] base
     /*  97149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97173 */     // (intrinsic_w_chain:{ *:[v8f16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97178 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97180 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97186 */     GIR_RootConstrainSelectedInstOperands,
     /*  97187 */     // GIR_Coverage, 4955,
     /*  97187 */     GIR_EraseRootFromParent_Done,
     /*  97188 */   // Label 1757: @97188
     /*  97188 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97256), // Rule ID 4956 //
     /*  97193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97217 */     // MIs[0] base
     /*  97217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97241 */     // (intrinsic_w_chain:{ *:[v8f16] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97246 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97248 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97254 */     GIR_RootConstrainSelectedInstOperands,
     /*  97255 */     // GIR_Coverage, 4956,
     /*  97255 */     GIR_EraseRootFromParent_Done,
     /*  97256 */   // Label 1758: @97256
     /*  97256 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97324), // Rule ID 4959 //
     /*  97261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97285 */     // MIs[0] base
     /*  97285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97309 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97314 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97316 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97322 */     GIR_RootConstrainSelectedInstOperands,
     /*  97323 */     // GIR_Coverage, 4959,
     /*  97323 */     GIR_EraseRootFromParent_Done,
     /*  97324 */   // Label 1759: @97324
     /*  97324 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97392), // Rule ID 4960 //
     /*  97329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97353 */     // MIs[0] base
     /*  97353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97377 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97382 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97384 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97390 */     GIR_RootConstrainSelectedInstOperands,
     /*  97391 */     // GIR_Coverage, 4960,
     /*  97391 */     GIR_EraseRootFromParent_Done,
     /*  97392 */   // Label 1760: @97392
     /*  97392 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97460), // Rule ID 4963 //
     /*  97397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97421 */     // MIs[0] base
     /*  97421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97445 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97450 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97452 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97458 */     GIR_RootConstrainSelectedInstOperands,
     /*  97459 */     // GIR_Coverage, 4963,
     /*  97459 */     GIR_EraseRootFromParent_Done,
     /*  97460 */   // Label 1761: @97460
     /*  97460 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97528), // Rule ID 4964 //
     /*  97465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97489 */     // MIs[0] base
     /*  97489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97513 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97518 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97520 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97526 */     GIR_RootConstrainSelectedInstOperands,
     /*  97527 */     // GIR_Coverage, 4964,
     /*  97527 */     GIR_EraseRootFromParent_Done,
     /*  97528 */   // Label 1762: @97528
     /*  97528 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97596), // Rule ID 4967 //
     /*  97533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97557 */     // MIs[0] base
     /*  97557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97581 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97586 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97588 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97594 */     GIR_RootConstrainSelectedInstOperands,
     /*  97595 */     // GIR_Coverage, 4967,
     /*  97595 */     GIR_EraseRootFromParent_Done,
     /*  97596 */   // Label 1763: @97596
     /*  97596 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97664), // Rule ID 4968 //
     /*  97601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97625 */     // MIs[0] base
     /*  97625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97649 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97654 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97656 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97662 */     GIR_RootConstrainSelectedInstOperands,
     /*  97663 */     // GIR_Coverage, 4968,
     /*  97663 */     GIR_EraseRootFromParent_Done,
     /*  97664 */   // Label 1764: @97664
     /*  97664 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97732), // Rule ID 4971 //
     /*  97669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97693 */     // MIs[0] base
     /*  97693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97717 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97722 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97724 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97730 */     GIR_RootConstrainSelectedInstOperands,
     /*  97731 */     // GIR_Coverage, 4971,
     /*  97731 */     GIR_EraseRootFromParent_Done,
     /*  97732 */   // Label 1765: @97732
     /*  97732 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97800), // Rule ID 4972 //
     /*  97737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97761 */     // MIs[0] base
     /*  97761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97785 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97790 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97792 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97798 */     GIR_RootConstrainSelectedInstOperands,
     /*  97799 */     // GIR_Coverage, 4972,
     /*  97799 */     GIR_EraseRootFromParent_Done,
     /*  97800 */   // Label 1766: @97800
     /*  97800 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97868), // Rule ID 4975 //
     /*  97805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97829 */     // MIs[0] base
     /*  97829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97853 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97858 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97860 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97866 */     GIR_RootConstrainSelectedInstOperands,
     /*  97867 */     // GIR_Coverage, 4975,
     /*  97867 */     GIR_EraseRootFromParent_Done,
     /*  97868 */   // Label 1767: @97868
     /*  97868 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97936), // Rule ID 4976 //
     /*  97873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97897 */     // MIs[0] base
     /*  97897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97921 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97926 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97928 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97934 */     GIR_RootConstrainSelectedInstOperands,
     /*  97935 */     // GIR_Coverage, 4976,
     /*  97935 */     GIR_EraseRootFromParent_Done,
     /*  97936 */   // Label 1768: @97936
     /*  97936 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(98004), // Rule ID 4979 //
     /*  97941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97965 */     // MIs[0] base
     /*  97965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97989 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97994 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97996 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98002 */     GIR_RootConstrainSelectedInstOperands,
     /*  98003 */     // GIR_Coverage, 4979,
     /*  98003 */     GIR_EraseRootFromParent_Done,
     /*  98004 */   // Label 1769: @98004
     /*  98004 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(98072), // Rule ID 4980 //
     /*  98009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98033 */     // MIs[0] base
     /*  98033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98057 */     // (intrinsic_w_chain:{ *:[v4i32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98062 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98064 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98070 */     GIR_RootConstrainSelectedInstOperands,
     /*  98071 */     // GIR_Coverage, 4980,
     /*  98071 */     GIR_EraseRootFromParent_Done,
     /*  98072 */   // Label 1770: @98072
     /*  98072 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(98140), // Rule ID 4983 //
     /*  98077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98101 */     // MIs[0] base
     /*  98101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98125 */     // (intrinsic_w_chain:{ *:[v4f32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98130 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98132 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98138 */     GIR_RootConstrainSelectedInstOperands,
     /*  98139 */     // GIR_Coverage, 4983,
     /*  98139 */     GIR_EraseRootFromParent_Done,
     /*  98140 */   // Label 1771: @98140
     /*  98140 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(98208), // Rule ID 4984 //
     /*  98145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98169 */     // MIs[0] base
     /*  98169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98193 */     // (intrinsic_w_chain:{ *:[v4f32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98198 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98200 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98206 */     GIR_RootConstrainSelectedInstOperands,
     /*  98207 */     // GIR_Coverage, 4984,
     /*  98207 */     GIR_EraseRootFromParent_Done,
     /*  98208 */   // Label 1772: @98208
     /*  98208 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(98276), // Rule ID 4987 //
     /*  98213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98237 */     // MIs[0] base
     /*  98237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98261 */     // (intrinsic_w_chain:{ *:[v4f32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98266 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98268 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98274 */     GIR_RootConstrainSelectedInstOperands,
     /*  98275 */     // GIR_Coverage, 4987,
     /*  98275 */     GIR_EraseRootFromParent_Done,
     /*  98276 */   // Label 1773: @98276
     /*  98276 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(98344), // Rule ID 4988 //
     /*  98281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98305 */     // MIs[0] base
     /*  98305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98329 */     // (intrinsic_w_chain:{ *:[v4f32] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98334 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98336 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98342 */     GIR_RootConstrainSelectedInstOperands,
     /*  98343 */     // GIR_Coverage, 4988,
     /*  98343 */     GIR_EraseRootFromParent_Done,
     /*  98344 */   // Label 1774: @98344
     /*  98344 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(98412), // Rule ID 4991 //
     /*  98349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98373 */     // MIs[0] base
     /*  98373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98397 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98402 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98404 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98410 */     GIR_RootConstrainSelectedInstOperands,
     /*  98411 */     // GIR_Coverage, 4991,
     /*  98411 */     GIR_EraseRootFromParent_Done,
     /*  98412 */   // Label 1775: @98412
     /*  98412 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(98480), // Rule ID 4992 //
     /*  98417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98441 */     // MIs[0] base
     /*  98441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98465 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98470 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98472 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98478 */     GIR_RootConstrainSelectedInstOperands,
     /*  98479 */     // GIR_Coverage, 4992,
     /*  98479 */     GIR_EraseRootFromParent_Done,
     /*  98480 */   // Label 1776: @98480
     /*  98480 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98548), // Rule ID 4995 //
     /*  98485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98509 */     // MIs[0] base
     /*  98509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98533 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98538 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98540 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98546 */     GIR_RootConstrainSelectedInstOperands,
     /*  98547 */     // GIR_Coverage, 4995,
     /*  98547 */     GIR_EraseRootFromParent_Done,
     /*  98548 */   // Label 1777: @98548
     /*  98548 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98616), // Rule ID 4996 //
     /*  98553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98577 */     // MIs[0] base
     /*  98577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98601 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98606 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98608 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98614 */     GIR_RootConstrainSelectedInstOperands,
     /*  98615 */     // GIR_Coverage, 4996,
     /*  98615 */     GIR_EraseRootFromParent_Done,
     /*  98616 */   // Label 1778: @98616
     /*  98616 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98684), // Rule ID 4999 //
     /*  98621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98645 */     // MIs[0] base
     /*  98645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98669 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98674 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98676 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98682 */     GIR_RootConstrainSelectedInstOperands,
     /*  98683 */     // GIR_Coverage, 4999,
     /*  98683 */     GIR_EraseRootFromParent_Done,
     /*  98684 */   // Label 1779: @98684
     /*  98684 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98752), // Rule ID 5000 //
     /*  98689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98713 */     // MIs[0] base
     /*  98713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98737 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98742 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98744 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98750 */     GIR_RootConstrainSelectedInstOperands,
     /*  98751 */     // GIR_Coverage, 5000,
     /*  98751 */     GIR_EraseRootFromParent_Done,
     /*  98752 */   // Label 1780: @98752
     /*  98752 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98820), // Rule ID 5003 //
     /*  98757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98781 */     // MIs[0] base
     /*  98781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98805 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98810 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98812 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98818 */     GIR_RootConstrainSelectedInstOperands,
     /*  98819 */     // GIR_Coverage, 5003,
     /*  98819 */     GIR_EraseRootFromParent_Done,
     /*  98820 */   // Label 1781: @98820
     /*  98820 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98888), // Rule ID 5004 //
     /*  98825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98849 */     // MIs[0] base
     /*  98849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98873 */     // (intrinsic_w_chain:{ *:[v2i64] } 3518:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98878 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98880 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98886 */     GIR_RootConstrainSelectedInstOperands,
     /*  98887 */     // GIR_Coverage, 5004,
     /*  98887 */     GIR_EraseRootFromParent_Done,
     /*  98888 */   // Label 1782: @98888
     /*  98888 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98953), // Rule ID 256 //
     /*  98893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98904 */     // MIs[0] cop
     /*  98904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98907 */     // MIs[0] opc1
     /*  98907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98914 */     // MIs[0] CRn
     /*  98914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98917 */     // MIs[0] CRm
     /*  98917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98920 */     // MIs[0] opc2
     /*  98920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98923 */     // (intrinsic_void 3393:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98926 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98928 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98932 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98934 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98936 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98951 */     GIR_RootConstrainSelectedInstOperands,
     /*  98952 */     // GIR_Coverage, 256,
     /*  98952 */     GIR_EraseRootFromParent_Done,
     /*  98953 */   // Label 1783: @98953
     /*  98953 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(99009), // Rule ID 257 //
     /*  98958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98969 */     // MIs[0] cop
     /*  98969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98972 */     // MIs[0] opc1
     /*  98972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98979 */     // MIs[0] CRn
     /*  98979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98982 */     // MIs[0] CRm
     /*  98982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98985 */     // MIs[0] opc2
     /*  98985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98988 */     // (intrinsic_void 3394:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98991 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98993 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98997 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98999 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99001 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99007 */     GIR_RootConstrainSelectedInstOperands,
     /*  99008 */     // GIR_Coverage, 257,
     /*  99008 */     GIR_EraseRootFromParent_Done,
     /*  99009 */   // Label 1784: @99009
     /*  99009 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(99074), // Rule ID 594 //
     /*  99014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99025 */     // MIs[0] cop
     /*  99025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99028 */     // MIs[0] opc1
     /*  99028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99035 */     // MIs[0] CRn
     /*  99035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99038 */     // MIs[0] CRm
     /*  99038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99041 */     // MIs[0] opc2
     /*  99041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99044 */     // (intrinsic_void 3393:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99047 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99049 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99053 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99055 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99057 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99072 */     GIR_RootConstrainSelectedInstOperands,
     /*  99073 */     // GIR_Coverage, 594,
     /*  99073 */     GIR_EraseRootFromParent_Done,
     /*  99074 */   // Label 1785: @99074
     /*  99074 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(99139), // Rule ID 595 //
     /*  99079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99090 */     // MIs[0] cop
     /*  99090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99093 */     // MIs[0] opc1
     /*  99093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99100 */     // MIs[0] CRn
     /*  99100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99103 */     // MIs[0] CRm
     /*  99103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99106 */     // MIs[0] opc2
     /*  99106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99109 */     // (intrinsic_void 3394:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99112 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99114 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99118 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99120 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99122 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99137 */     GIR_RootConstrainSelectedInstOperands,
     /*  99138 */     // GIR_Coverage, 595,
     /*  99138 */     GIR_EraseRootFromParent_Done,
     /*  99139 */   // Label 1786: @99139
     /*  99139 */   GIM_Reject,
     /*  99140 */ // Label 1736: @99140
     /*  99140 */ GIM_Reject,
     /*  99141 */ // Label 16: @99141
     /*  99141 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1790*/ GIMT_Encode4(99298),
     /*  99152 */ /*GILLT_v2s64*//*Label 1787*/ GIMT_Encode4(99184), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99164 */ /*GILLT_v4s32*//*Label 1788*/ GIMT_Encode4(99222), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99180 */ /*GILLT_v8s16*//*Label 1789*/ GIMT_Encode4(99260),
     /*  99184 */ // Label 1787: @99184
     /*  99184 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(99221), // Rule ID 2648 //
     /*  99189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99203 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99208 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99213 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99219 */   GIR_RootConstrainSelectedInstOperands,
     /*  99220 */   // GIR_Coverage, 2648,
     /*  99220 */   GIR_EraseRootFromParent_Done,
     /*  99221 */ // Label 1791: @99221
     /*  99221 */ GIM_Reject,
     /*  99222 */ // Label 1788: @99222
     /*  99222 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(99259), // Rule ID 2647 //
     /*  99227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99241 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99246 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99257 */   GIR_RootConstrainSelectedInstOperands,
     /*  99258 */   // GIR_Coverage, 2647,
     /*  99258 */   GIR_EraseRootFromParent_Done,
     /*  99259 */ // Label 1792: @99259
     /*  99259 */ GIM_Reject,
     /*  99260 */ // Label 1789: @99260
     /*  99260 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(99297), // Rule ID 2646 //
     /*  99265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99279 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99284 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99289 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99295 */   GIR_RootConstrainSelectedInstOperands,
     /*  99296 */   // GIR_Coverage, 2646,
     /*  99296 */   GIR_EraseRootFromParent_Done,
     /*  99297 */ // Label 1793: @99297
     /*  99297 */ GIM_Reject,
     /*  99298 */ // Label 1790: @99298
     /*  99298 */ GIM_Reject,
     /*  99299 */ // Label 17: @99299
     /*  99299 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(99456),
     /*  99310 */ /*GILLT_v2s32*//*Label 1794*/ GIMT_Encode4(99342), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99322 */ /*GILLT_v4s16*//*Label 1795*/ GIMT_Encode4(99380), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99338 */ /*GILLT_v8s8*//*Label 1796*/ GIMT_Encode4(99418),
     /*  99342 */ // Label 1794: @99342
     /*  99342 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(99379), // Rule ID 1585 //
     /*  99347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99361 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99366 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99371 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99377 */   GIR_RootConstrainSelectedInstOperands,
     /*  99378 */   // GIR_Coverage, 1585,
     /*  99378 */   GIR_EraseRootFromParent_Done,
     /*  99379 */ // Label 1798: @99379
     /*  99379 */ GIM_Reject,
     /*  99380 */ // Label 1795: @99380
     /*  99380 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(99417), // Rule ID 1584 //
     /*  99385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99399 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99404 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99409 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99415 */   GIR_RootConstrainSelectedInstOperands,
     /*  99416 */   // GIR_Coverage, 1584,
     /*  99416 */   GIR_EraseRootFromParent_Done,
     /*  99417 */ // Label 1799: @99417
     /*  99417 */ GIM_Reject,
     /*  99418 */ // Label 1796: @99418
     /*  99418 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(99455), // Rule ID 1583 //
     /*  99423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99437 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99442 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99447 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99453 */   GIR_RootConstrainSelectedInstOperands,
     /*  99454 */   // GIR_Coverage, 1583,
     /*  99454 */   GIR_EraseRootFromParent_Done,
     /*  99455 */ // Label 1800: @99455
     /*  99455 */ GIM_Reject,
     /*  99456 */ // Label 1797: @99456
     /*  99456 */ GIM_Reject,
     /*  99457 */ // Label 18: @99457
     /*  99457 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99777),
     /*  99462 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99465 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(99506), // Rule ID 404 //
     /*  99470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99473 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99481 */     // MIs[0] Operand 1
     /*  99481 */     // No operand predicates
     /*  99481 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99504 */     GIR_RootConstrainSelectedInstOperands,
     /*  99505 */     // GIR_Coverage, 404,
     /*  99505 */     GIR_EraseRootFromParent_Done,
     /*  99506 */   // Label 1802: @99506
     /*  99506 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(99547), // Rule ID 57 //
     /*  99511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99514 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99522 */     // MIs[0] Operand 1
     /*  99522 */     // No operand predicates
     /*  99522 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99545 */     GIR_RootConstrainSelectedInstOperands,
     /*  99546 */     // GIR_Coverage, 57,
     /*  99546 */     GIR_EraseRootFromParent_Done,
     /*  99547 */   // Label 1803: @99547
     /*  99547 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(99582), // Rule ID 58 //
     /*  99552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99555 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99563 */     // MIs[0] Operand 1
     /*  99563 */     // No operand predicates
     /*  99563 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99580 */     GIR_RootConstrainSelectedInstOperands,
     /*  99581 */     // GIR_Coverage, 58,
     /*  99581 */     GIR_EraseRootFromParent_Done,
     /*  99582 */   // Label 1804: @99582
     /*  99582 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(99625), // Rule ID 168 //
     /*  99587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99590 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99598 */     // MIs[0] Operand 1
     /*  99598 */     // No operand predicates
     /*  99598 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99603 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99623 */     GIR_RootConstrainSelectedInstOperands,
     /*  99624 */     // GIR_Coverage, 168,
     /*  99624 */     GIR_EraseRootFromParent_Done,
     /*  99625 */   // Label 1805: @99625
     /*  99625 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(99651), // Rule ID 268 //
     /*  99630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99633 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99641 */     // MIs[0] Operand 1
     /*  99641 */     // No operand predicates
     /*  99641 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99649 */     GIR_RootConstrainSelectedInstOperands,
     /*  99650 */     // GIR_Coverage, 268,
     /*  99650 */     GIR_EraseRootFromParent_Done,
     /*  99651 */   // Label 1806: @99651
     /*  99651 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(99692), // Rule ID 322 //
     /*  99656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99659 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99667 */     // MIs[0] Operand 1
     /*  99667 */     // No operand predicates
     /*  99667 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99690 */     GIR_RootConstrainSelectedInstOperands,
     /*  99691 */     // GIR_Coverage, 322,
     /*  99691 */     GIR_EraseRootFromParent_Done,
     /*  99692 */   // Label 1807: @99692
     /*  99692 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99727), // Rule ID 405 //
     /*  99697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99700 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99708 */     // MIs[0] Operand 1
     /*  99708 */     // No operand predicates
     /*  99708 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99725 */     GIR_RootConstrainSelectedInstOperands,
     /*  99726 */     // GIR_Coverage, 405,
     /*  99726 */     GIR_EraseRootFromParent_Done,
     /*  99727 */   // Label 1808: @99727
     /*  99727 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99776),
     /*  99732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99736 */     GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99757), // Rule ID 353 //
     /*  99741 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99744 */       // MIs[0] Operand 1
     /*  99744 */       // No operand predicates
     /*  99744 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99744 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99747 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99749 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99752 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99755 */       GIR_RootConstrainSelectedInstOperands,
     /*  99756 */       // GIR_Coverage, 353,
     /*  99756 */       GIR_EraseRootFromParent_Done,
     /*  99757 */     // Label 1810: @99757
     /*  99757 */     GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99775), // Rule ID 582 //
     /*  99762 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99765 */       // MIs[0] Operand 1
     /*  99765 */       // No operand predicates
     /*  99765 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99765 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99768 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99770 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99773 */       GIR_RootConstrainSelectedInstOperands,
     /*  99774 */       // GIR_Coverage, 582,
     /*  99774 */       GIR_EraseRootFromParent_Done,
     /*  99775 */     // Label 1811: @99775
     /*  99775 */     GIM_Reject,
     /*  99776 */   // Label 1809: @99776
     /*  99776 */   GIM_Reject,
     /*  99777 */ // Label 1801: @99777
     /*  99777 */ GIM_Reject,
     /*  99778 */ // Label 19: @99778
     /*  99778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1814*/ GIMT_Encode4(99873),
     /*  99789 */ /*GILLT_s32*//*Label 1812*/ GIMT_Encode4(99797),
     /*  99793 */ /*GILLT_s64*//*Label 1813*/ GIMT_Encode4(99835),
     /*  99797 */ // Label 1812: @99797
     /*  99797 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99834), // Rule ID 725 //
     /*  99802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99809 */   // MIs[0] Operand 1
     /*  99809 */   // No operand predicates
     /*  99809 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99813 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99818 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99826 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99832 */   GIR_RootConstrainSelectedInstOperands,
     /*  99833 */   // GIR_Coverage, 725,
     /*  99833 */   GIR_EraseRootFromParent_Done,
     /*  99834 */ // Label 1815: @99834
     /*  99834 */ GIM_Reject,
     /*  99835 */ // Label 1813: @99835
     /*  99835 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99872), // Rule ID 724 //
     /*  99840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99847 */   // MIs[0] Operand 1
     /*  99847 */   // No operand predicates
     /*  99847 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99851 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99856 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99864 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99870 */   GIR_RootConstrainSelectedInstOperands,
     /*  99871 */   // GIR_Coverage, 724,
     /*  99871 */   GIR_EraseRootFromParent_Done,
     /*  99872 */ // Label 1816: @99872
     /*  99872 */ GIM_Reject,
     /*  99873 */ // Label 1814: @99873
     /*  99873 */ GIM_Reject,
     /*  99874 */ // Label 20: @99874
     /*  99874 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1820*/ GIMT_Encode4(100031),
     /*  99885 */ /*GILLT_v2s64*//*Label 1817*/ GIMT_Encode4(99917), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99897 */ /*GILLT_v4s32*//*Label 1818*/ GIMT_Encode4(99955), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99913 */ /*GILLT_v8s16*//*Label 1819*/ GIMT_Encode4(99993),
     /*  99917 */ // Label 1817: @99917
     /*  99917 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99954), // Rule ID 1597 //
     /*  99922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99936 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99941 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99952 */   GIR_RootConstrainSelectedInstOperands,
     /*  99953 */   // GIR_Coverage, 1597,
     /*  99953 */   GIR_EraseRootFromParent_Done,
     /*  99954 */ // Label 1821: @99954
     /*  99954 */ GIM_Reject,
     /*  99955 */ // Label 1818: @99955
     /*  99955 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99992), // Rule ID 1596 //
     /*  99960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99974 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99979 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99984 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99990 */   GIR_RootConstrainSelectedInstOperands,
     /*  99991 */   // GIR_Coverage, 1596,
     /*  99991 */   GIR_EraseRootFromParent_Done,
     /*  99992 */ // Label 1822: @99992
     /*  99992 */ GIM_Reject,
     /*  99993 */ // Label 1819: @99993
     /*  99993 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(100030), // Rule ID 1595 //
     /*  99998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100012 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /* 100015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100017 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100022 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100028 */   GIR_RootConstrainSelectedInstOperands,
     /* 100029 */   // GIR_Coverage, 1595,
     /* 100029 */   GIR_EraseRootFromParent_Done,
     /* 100030 */ // Label 1823: @100030
     /* 100030 */ GIM_Reject,
     /* 100031 */ // Label 1820: @100031
     /* 100031 */ GIM_Reject,
     /* 100032 */ // Label 21: @100032
     /* 100032 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1827*/ GIMT_Encode4(100636),
     /* 100043 */ /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(100091), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100071 */ /*GILLT_v4s32*//*Label 1825*/ GIMT_Encode4(100383), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100087 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(100566),
     /* 100091 */ // Label 1824: @100091
     /* 100091 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(100382),
     /* 100096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100099 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(100144), // Rule ID 340 //
     /* 100104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100115 */     // MIs[0] Operand 2
     /* 100115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100126 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100142 */     GIR_RootConstrainSelectedInstOperands,
     /* 100143 */     // GIR_Coverage, 340,
     /* 100143 */     GIR_EraseRootFromParent_Done,
     /* 100144 */   // Label 1829: @100144
     /* 100144 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(100189), // Rule ID 341 //
     /* 100149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100160 */     // MIs[0] Operand 2
     /* 100160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100171 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100187 */     GIR_RootConstrainSelectedInstOperands,
     /* 100188 */     // GIR_Coverage, 341,
     /* 100188 */     GIR_EraseRootFromParent_Done,
     /* 100189 */   // Label 1830: @100189
     /* 100189 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(100237), // Rule ID 1997 //
     /* 100194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100205 */     // MIs[0] Operand 2
     /* 100205 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100216 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100235 */     GIR_RootConstrainSelectedInstOperands,
     /* 100236 */     // GIR_Coverage, 1997,
     /* 100236 */     GIR_EraseRootFromParent_Done,
     /* 100237 */   // Label 1831: @100237
     /* 100237 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(100285), // Rule ID 1998 //
     /* 100242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100253 */     // MIs[0] Operand 2
     /* 100253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100264 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100283 */     GIR_RootConstrainSelectedInstOperands,
     /* 100284 */     // GIR_Coverage, 1998,
     /* 100284 */     GIR_EraseRootFromParent_Done,
     /* 100285 */   // Label 1832: @100285
     /* 100285 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(100333), // Rule ID 2229 //
     /* 100290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100301 */     // MIs[0] Operand 2
     /* 100301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100312 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100331 */     GIR_RootConstrainSelectedInstOperands,
     /* 100332 */     // GIR_Coverage, 2229,
     /* 100332 */     GIR_EraseRootFromParent_Done,
     /* 100333 */   // Label 1833: @100333
     /* 100333 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(100381), // Rule ID 2230 //
     /* 100338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100349 */     // MIs[0] Operand 2
     /* 100349 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100360 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100379 */     GIR_RootConstrainSelectedInstOperands,
     /* 100380 */     // GIR_Coverage, 2230,
     /* 100380 */     GIR_EraseRootFromParent_Done,
     /* 100381 */   // Label 1834: @100381
     /* 100381 */   GIM_Reject,
     /* 100382 */ // Label 1828: @100382
     /* 100382 */ GIM_Reject,
     /* 100383 */ // Label 1825: @100383
     /* 100383 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(100565),
     /* 100388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100399 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(100457), // Rule ID 3693 //
     /* 100404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100407 */     // MIs[0] Operand 2
     /* 100407 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100418 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100435 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100455 */     GIR_RootConstrainSelectedInstOperands,
     /* 100456 */     // GIR_Coverage, 3693,
     /* 100456 */     GIR_EraseRootFromParent_Done,
     /* 100457 */   // Label 1836: @100457
     /* 100457 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(100564), // Rule ID 3695 //
     /* 100462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100465 */     // MIs[0] Operand 2
     /* 100465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100476 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100488 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100491 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100495 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100516 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100519 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100525 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100531 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100562 */     GIR_RootConstrainSelectedInstOperands,
     /* 100563 */     // GIR_Coverage, 3695,
     /* 100563 */     GIR_EraseRootFromParent_Done,
     /* 100564 */   // Label 1837: @100564
     /* 100564 */   GIM_Reject,
     /* 100565 */ // Label 1835: @100565
     /* 100565 */ GIM_Reject,
     /* 100566 */ // Label 1826: @100566
     /* 100566 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100635), // Rule ID 3694 //
     /* 100571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100585 */   // MIs[0] Operand 2
     /* 100585 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100596 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100618 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100624 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100633 */   GIR_RootConstrainSelectedInstOperands,
     /* 100634 */   // GIR_Coverage, 3694,
     /* 100634 */   GIR_EraseRootFromParent_Done,
     /* 100635 */ // Label 1838: @100635
     /* 100635 */ GIM_Reject,
     /* 100636 */ // Label 1827: @100636
     /* 100636 */ GIM_Reject,
     /* 100637 */ // Label 22: @100637
     /* 100637 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1842*/ GIMT_Encode4(100794),
     /* 100648 */ /*GILLT_v2s64*//*Label 1839*/ GIMT_Encode4(100680), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100660 */ /*GILLT_v4s32*//*Label 1840*/ GIMT_Encode4(100718), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100676 */ /*GILLT_v8s16*//*Label 1841*/ GIMT_Encode4(100756),
     /* 100680 */ // Label 1839: @100680
     /* 100680 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100717), // Rule ID 1600 //
     /* 100685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100699 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100704 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100709 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100715 */   GIR_RootConstrainSelectedInstOperands,
     /* 100716 */   // GIR_Coverage, 1600,
     /* 100716 */   GIR_EraseRootFromParent_Done,
     /* 100717 */ // Label 1843: @100717
     /* 100717 */ GIM_Reject,
     /* 100718 */ // Label 1840: @100718
     /* 100718 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100755), // Rule ID 1599 //
     /* 100723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100737 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100742 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100753 */   GIR_RootConstrainSelectedInstOperands,
     /* 100754 */   // GIR_Coverage, 1599,
     /* 100754 */   GIR_EraseRootFromParent_Done,
     /* 100755 */ // Label 1844: @100755
     /* 100755 */ GIM_Reject,
     /* 100756 */ // Label 1841: @100756
     /* 100756 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100793), // Rule ID 1598 //
     /* 100761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100775 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100780 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100791 */   GIR_RootConstrainSelectedInstOperands,
     /* 100792 */   // GIR_Coverage, 1598,
     /* 100792 */   GIR_EraseRootFromParent_Done,
     /* 100793 */ // Label 1845: @100793
     /* 100793 */ GIM_Reject,
     /* 100794 */ // Label 1842: @100794
     /* 100794 */ GIM_Reject,
     /* 100795 */ // Label 23: @100795
     /* 100795 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(101010),
     /* 100800 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100809 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(100866), // Rule ID 470 //
     /* 100814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100837 */     // MIs[1] Operand 1
     /* 100837 */     // No operand predicates
     /* 100837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100839 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100864 */     GIR_RootConstrainSelectedInstOperands,
     /* 100865 */     // GIR_Coverage, 470,
     /* 100865 */     GIR_EraseRootFromParent_Done,
     /* 100866 */   // Label 1847: @100866
     /* 100866 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(100963),
     /* 100871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100879 */     GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(100924), // Rule ID 318 //
     /* 100884 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100887 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100891 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100895 */       // MIs[1] Operand 1
     /* 100895 */       // No operand predicates
     /* 100895 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100897 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100897 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100900 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100902 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100908 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100910 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100913 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100916 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100922 */       GIR_RootConstrainSelectedInstOperands,
     /* 100923 */       // GIR_Coverage, 318,
     /* 100923 */       GIR_EraseRootFromParent_Done,
     /* 100924 */     // Label 1849: @100924
     /* 100924 */     GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100962), // Rule ID 319 //
     /* 100929 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100932 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100936 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100941 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100947 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100949 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100951 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100954 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100960 */       GIR_RootConstrainSelectedInstOperands,
     /* 100961 */       // GIR_Coverage, 319,
     /* 100961 */       GIR_EraseRootFromParent_Done,
     /* 100962 */     // Label 1850: @100962
     /* 100962 */     GIM_Reject,
     /* 100963 */   // Label 1848: @100963
     /* 100963 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(101009), // Rule ID 471 //
     /* 100968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100983 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101007 */     GIR_RootConstrainSelectedInstOperands,
     /* 101008 */     // GIR_Coverage, 471,
     /* 101008 */     GIR_EraseRootFromParent_Done,
     /* 101009 */   // Label 1851: @101009
     /* 101009 */   GIM_Reject,
     /* 101010 */ // Label 1846: @101010
     /* 101010 */ GIM_Reject,
     /* 101011 */ // Label 24: @101011
     /* 101011 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(101118),
     /* 101016 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101025 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(101071), // Rule ID 321 //
     /* 101030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101045 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101069 */     GIR_RootConstrainSelectedInstOperands,
     /* 101070 */     // GIR_Coverage, 321,
     /* 101070 */     GIR_EraseRootFromParent_Done,
     /* 101071 */   // Label 1853: @101071
     /* 101071 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(101117), // Rule ID 473 //
     /* 101076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101091 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101115 */     GIR_RootConstrainSelectedInstOperands,
     /* 101116 */     // GIR_Coverage, 473,
     /* 101116 */     GIR_EraseRootFromParent_Done,
     /* 101117 */   // Label 1854: @101117
     /* 101117 */   GIM_Reject,
     /* 101118 */ // Label 1852: @101118
     /* 101118 */ GIM_Reject,
     /* 101119 */ // Label 25: @101119
     /* 101119 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(101391),
     /* 101124 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101133 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(101188), // Rule ID 201 //
     /* 101138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101168 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101186 */     GIR_RootConstrainSelectedInstOperands,
     /* 101187 */     // GIR_Coverage, 201,
     /* 101187 */     GIR_EraseRootFromParent_Done,
     /* 101188 */   // Label 1856: @101188
     /* 101188 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(101243), // Rule ID 328 //
     /* 101193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101223 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101241 */     GIR_RootConstrainSelectedInstOperands,
     /* 101242 */     // GIR_Coverage, 328,
     /* 101242 */     GIR_EraseRootFromParent_Done,
     /* 101243 */   // Label 1857: @101243
     /* 101243 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(101298), // Rule ID 538 //
     /* 101248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101278 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101296 */     GIR_RootConstrainSelectedInstOperands,
     /* 101297 */     // GIR_Coverage, 538,
     /* 101297 */     GIR_EraseRootFromParent_Done,
     /* 101298 */   // Label 1858: @101298
     /* 101298 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(101344), // Rule ID 312 //
     /* 101303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101318 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101342 */     GIR_RootConstrainSelectedInstOperands,
     /* 101343 */     // GIR_Coverage, 312,
     /* 101343 */     GIR_EraseRootFromParent_Done,
     /* 101344 */   // Label 1859: @101344
     /* 101344 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(101390), // Rule ID 475 //
     /* 101349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101364 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101388 */     GIR_RootConstrainSelectedInstOperands,
     /* 101389 */     // GIR_Coverage, 475,
     /* 101389 */     GIR_EraseRootFromParent_Done,
     /* 101390 */   // Label 1860: @101390
     /* 101390 */   GIM_Reject,
     /* 101391 */ // Label 1855: @101391
     /* 101391 */ GIM_Reject,
     /* 101392 */ // Label 26: @101392
     /* 101392 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101723),
     /* 101397 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101406 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101461), // Rule ID 200 //
     /* 101411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101441 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101459 */     GIR_RootConstrainSelectedInstOperands,
     /* 101460 */     // GIR_Coverage, 200,
     /* 101460 */     GIR_EraseRootFromParent_Done,
     /* 101461 */   // Label 1862: @101461
     /* 101461 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101516), // Rule ID 327 //
     /* 101466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101496 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101514 */     GIR_RootConstrainSelectedInstOperands,
     /* 101515 */     // GIR_Coverage, 327,
     /* 101515 */     GIR_EraseRootFromParent_Done,
     /* 101516 */   // Label 1863: @101516
     /* 101516 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101630),
     /* 101521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101525 */     GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101576), // Rule ID 537 //
     /* 101530 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101533 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101537 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101541 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101545 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101550 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101554 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101556 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101556 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101559 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101561 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101565 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101568 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101574 */       GIR_RootConstrainSelectedInstOperands,
     /* 101575 */       // GIR_Coverage, 537,
     /* 101575 */       GIR_EraseRootFromParent_Done,
     /* 101576 */     // Label 1865: @101576
     /* 101576 */     GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101629), // Rule ID 476 //
     /* 101581 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101584 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101588 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101592 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101596 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101600 */       // MIs[1] Operand 1
     /* 101600 */       // No operand predicates
     /* 101600 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101602 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101602 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101605 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101607 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101609 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101612 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101615 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101621 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101627 */       GIR_RootConstrainSelectedInstOperands,
     /* 101628 */       // GIR_Coverage, 476,
     /* 101628 */       GIR_EraseRootFromParent_Done,
     /* 101629 */     // Label 1866: @101629
     /* 101629 */     GIM_Reject,
     /* 101630 */   // Label 1864: @101630
     /* 101630 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101676), // Rule ID 329 //
     /* 101635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101650 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101674 */     GIR_RootConstrainSelectedInstOperands,
     /* 101675 */     // GIR_Coverage, 329,
     /* 101675 */     GIR_EraseRootFromParent_Done,
     /* 101676 */   // Label 1867: @101676
     /* 101676 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101722), // Rule ID 477 //
     /* 101681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101696 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101720 */     GIR_RootConstrainSelectedInstOperands,
     /* 101721 */     // GIR_Coverage, 477,
     /* 101721 */     GIR_EraseRootFromParent_Done,
     /* 101722 */   // Label 1868: @101722
     /* 101722 */   GIM_Reject,
     /* 101723 */ // Label 1861: @101723
     /* 101723 */ GIM_Reject,
     /* 101724 */ // Label 27: @101724
     /* 101724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(101971),
     /* 101735 */ /*GILLT_v4s32*//*Label 1869*/ GIMT_Encode4(101767), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101751 */ /*GILLT_v8s16*//*Label 1870*/ GIMT_Encode4(101835), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101763 */ /*GILLT_v16s8*//*Label 1871*/ GIMT_Encode4(101903),
     /* 101767 */ // Label 1869: @101767
     /* 101767 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101834), // Rule ID 4444 //
     /* 101772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101793 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101810 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101812 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101817 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101823 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101832 */   GIR_RootConstrainSelectedInstOperands,
     /* 101833 */   // GIR_Coverage, 4444,
     /* 101833 */   GIR_EraseRootFromParent_Done,
     /* 101834 */ // Label 1873: @101834
     /* 101834 */ GIM_Reject,
     /* 101835 */ // Label 1870: @101835
     /* 101835 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101902), // Rule ID 4440 //
     /* 101840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101861 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101878 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101880 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101885 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101891 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101900 */   GIR_RootConstrainSelectedInstOperands,
     /* 101901 */   // GIR_Coverage, 4440,
     /* 101901 */   GIR_EraseRootFromParent_Done,
     /* 101902 */ // Label 1874: @101902
     /* 101902 */ GIM_Reject,
     /* 101903 */ // Label 1871: @101903
     /* 101903 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101970), // Rule ID 4436 //
     /* 101908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101929 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101946 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101948 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101953 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101959 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101968 */   GIR_RootConstrainSelectedInstOperands,
     /* 101969 */   // GIR_Coverage, 4436,
     /* 101969 */   GIR_EraseRootFromParent_Done,
     /* 101970 */ // Label 1875: @101970
     /* 101970 */ GIM_Reject,
     /* 101971 */ // Label 1872: @101971
     /* 101971 */ GIM_Reject,
     /* 101972 */ // Label 28: @101972
     /* 101972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1880*/ GIMT_Encode4(102340),
     /* 101983 */ /*GILLT_s32*//*Label 1876*/ GIMT_Encode4(102043), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102011 */ /*GILLT_v4s32*//*Label 1877*/ GIMT_Encode4(102136), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102027 */ /*GILLT_v8s16*//*Label 1878*/ GIMT_Encode4(102204), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102039 */ /*GILLT_v16s8*//*Label 1879*/ GIMT_Encode4(102272),
     /* 102043 */ // Label 1876: @102043
     /* 102043 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(102135),
     /* 102048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102054 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(102094), // Rule ID 178 //
     /* 102059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102074 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102092 */     GIR_RootConstrainSelectedInstOperands,
     /* 102093 */     // GIR_Coverage, 178,
     /* 102093 */     GIR_EraseRootFromParent_Done,
     /* 102094 */   // Label 1882: @102094
     /* 102094 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(102134), // Rule ID 507 //
     /* 102099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102114 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102132 */     GIR_RootConstrainSelectedInstOperands,
     /* 102133 */     // GIR_Coverage, 507,
     /* 102133 */     GIR_EraseRootFromParent_Done,
     /* 102134 */   // Label 1883: @102134
     /* 102134 */   GIM_Reject,
     /* 102135 */ // Label 1881: @102135
     /* 102135 */ GIM_Reject,
     /* 102136 */ // Label 1877: @102136
     /* 102136 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(102203), // Rule ID 4432 //
     /* 102141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102162 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102179 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102181 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102192 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102201 */   GIR_RootConstrainSelectedInstOperands,
     /* 102202 */   // GIR_Coverage, 4432,
     /* 102202 */   GIR_EraseRootFromParent_Done,
     /* 102203 */ // Label 1884: @102203
     /* 102203 */ GIM_Reject,
     /* 102204 */ // Label 1878: @102204
     /* 102204 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(102271), // Rule ID 4428 //
     /* 102209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102230 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102247 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102249 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102254 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102260 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102269 */   GIR_RootConstrainSelectedInstOperands,
     /* 102270 */   // GIR_Coverage, 4428,
     /* 102270 */   GIR_EraseRootFromParent_Done,
     /* 102271 */ // Label 1885: @102271
     /* 102271 */ GIM_Reject,
     /* 102272 */ // Label 1879: @102272
     /* 102272 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(102339), // Rule ID 4425 //
     /* 102277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102298 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102315 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102317 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102328 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102337 */   GIR_RootConstrainSelectedInstOperands,
     /* 102338 */   // GIR_Coverage, 4425,
     /* 102338 */   GIR_EraseRootFromParent_Done,
     /* 102339 */ // Label 1886: @102339
     /* 102339 */ GIM_Reject,
     /* 102340 */ // Label 1880: @102340
     /* 102340 */ GIM_Reject,
     /* 102341 */ // Label 29: @102341
     /* 102341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1895*/ GIMT_Encode4(102985),
     /* 102352 */ /*GILLT_s64*//*Label 1887*/ GIMT_Encode4(102408), GIMT_Encode4(0),
     /* 102360 */ /*GILLT_v2s32*//*Label 1888*/ GIMT_Encode4(102455),
     /* 102364 */ /*GILLT_v2s64*//*Label 1889*/ GIMT_Encode4(102502), GIMT_Encode4(0),
     /* 102372 */ /*GILLT_v4s16*//*Label 1890*/ GIMT_Encode4(102549),
     /* 102376 */ /*GILLT_v4s32*//*Label 1891*/ GIMT_Encode4(102596), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102388 */ /*GILLT_v8s8*//*Label 1892*/ GIMT_Encode4(102710),
     /* 102392 */ /*GILLT_v8s16*//*Label 1893*/ GIMT_Encode4(102757), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102404 */ /*GILLT_v16s8*//*Label 1894*/ GIMT_Encode4(102871),
     /* 102408 */ // Label 1887: @102408
     /* 102408 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102454), // Rule ID 827 //
     /* 102413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102434 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102439 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102441 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102446 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102452 */   GIR_RootConstrainSelectedInstOperands,
     /* 102453 */   // GIR_Coverage, 827,
     /* 102453 */   GIR_EraseRootFromParent_Done,
     /* 102454 */ // Label 1896: @102454
     /* 102454 */ GIM_Reject,
     /* 102455 */ // Label 1888: @102455
     /* 102455 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(102501), // Rule ID 822 //
     /* 102460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102481 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102486 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102488 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102493 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102499 */   GIR_RootConstrainSelectedInstOperands,
     /* 102500 */   // GIR_Coverage, 822,
     /* 102500 */   GIR_EraseRootFromParent_Done,
     /* 102501 */ // Label 1897: @102501
     /* 102501 */ GIM_Reject,
     /* 102502 */ // Label 1889: @102502
     /* 102502 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(102548), // Rule ID 828 //
     /* 102507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102528 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102533 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102535 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102546 */   GIR_RootConstrainSelectedInstOperands,
     /* 102547 */   // GIR_Coverage, 828,
     /* 102547 */   GIR_EraseRootFromParent_Done,
     /* 102548 */ // Label 1898: @102548
     /* 102548 */ GIM_Reject,
     /* 102549 */ // Label 1890: @102549
     /* 102549 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(102595), // Rule ID 821 //
     /* 102554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102575 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102580 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102582 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102587 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102593 */   GIR_RootConstrainSelectedInstOperands,
     /* 102594 */   // GIR_Coverage, 821,
     /* 102594 */   GIR_EraseRootFromParent_Done,
     /* 102595 */ // Label 1899: @102595
     /* 102595 */ GIM_Reject,
     /* 102596 */ // Label 1891: @102596
     /* 102596 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102709),
     /* 102601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102607 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102647), // Rule ID 824 //
     /* 102612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102627 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102645 */     GIR_RootConstrainSelectedInstOperands,
     /* 102646 */     // GIR_Coverage, 824,
     /* 102646 */     GIR_EraseRootFromParent_Done,
     /* 102647 */   // Label 1901: @102647
     /* 102647 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102708), // Rule ID 3507 //
     /* 102652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102667 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102706 */     GIR_RootConstrainSelectedInstOperands,
     /* 102707 */     // GIR_Coverage, 3507,
     /* 102707 */     GIR_EraseRootFromParent_Done,
     /* 102708 */   // Label 1902: @102708
     /* 102708 */   GIM_Reject,
     /* 102709 */ // Label 1900: @102709
     /* 102709 */ GIM_Reject,
     /* 102710 */ // Label 1892: @102710
     /* 102710 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102756), // Rule ID 825 //
     /* 102715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102736 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102741 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102743 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102754 */   GIR_RootConstrainSelectedInstOperands,
     /* 102755 */   // GIR_Coverage, 825,
     /* 102755 */   GIR_EraseRootFromParent_Done,
     /* 102756 */ // Label 1903: @102756
     /* 102756 */ GIM_Reject,
     /* 102757 */ // Label 1893: @102757
     /* 102757 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102870),
     /* 102762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102768 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102808), // Rule ID 823 //
     /* 102773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102788 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102806 */     GIR_RootConstrainSelectedInstOperands,
     /* 102807 */     // GIR_Coverage, 823,
     /* 102807 */     GIR_EraseRootFromParent_Done,
     /* 102808 */   // Label 1905: @102808
     /* 102808 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102869), // Rule ID 3504 //
     /* 102813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102828 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102867 */     GIR_RootConstrainSelectedInstOperands,
     /* 102868 */     // GIR_Coverage, 3504,
     /* 102868 */     GIR_EraseRootFromParent_Done,
     /* 102869 */   // Label 1906: @102869
     /* 102869 */   GIM_Reject,
     /* 102870 */ // Label 1904: @102870
     /* 102870 */ GIM_Reject,
     /* 102871 */ // Label 1894: @102871
     /* 102871 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102984),
     /* 102876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102882 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102922), // Rule ID 826 //
     /* 102887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102902 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102920 */     GIR_RootConstrainSelectedInstOperands,
     /* 102921 */     // GIR_Coverage, 826,
     /* 102921 */     GIR_EraseRootFromParent_Done,
     /* 102922 */   // Label 1908: @102922
     /* 102922 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102983), // Rule ID 3501 //
     /* 102927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102942 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102981 */     GIR_RootConstrainSelectedInstOperands,
     /* 102982 */     // GIR_Coverage, 3501,
     /* 102982 */     GIR_EraseRootFromParent_Done,
     /* 102983 */   // Label 1909: @102983
     /* 102983 */   GIM_Reject,
     /* 102984 */ // Label 1907: @102984
     /* 102984 */ GIM_Reject,
     /* 102985 */ // Label 1895: @102985
     /* 102985 */ GIM_Reject,
     /* 102986 */ // Label 30: @102986
     /* 102986 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1919*/ GIMT_Encode4(104285),
     /* 102997 */ /*GILLT_s32*//*Label 1910*/ GIMT_Encode4(103057),
     /* 103001 */ /*GILLT_s64*//*Label 1911*/ GIMT_Encode4(103398), GIMT_Encode4(0),
     /* 103009 */ /*GILLT_v2s32*//*Label 1912*/ GIMT_Encode4(103445),
     /* 103013 */ /*GILLT_v2s64*//*Label 1913*/ GIMT_Encode4(103492), GIMT_Encode4(0),
     /* 103021 */ /*GILLT_v4s16*//*Label 1914*/ GIMT_Encode4(103693),
     /* 103025 */ /*GILLT_v4s32*//*Label 1915*/ GIMT_Encode4(103740), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103037 */ /*GILLT_v8s8*//*Label 1916*/ GIMT_Encode4(104010),
     /* 103041 */ /*GILLT_v8s16*//*Label 1917*/ GIMT_Encode4(104057), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103053 */ /*GILLT_v16s8*//*Label 1918*/ GIMT_Encode4(104171),
     /* 103057 */ // Label 1910: @103057
     /* 103057 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103397),
     /* 103062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103068 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103130), // Rule ID 5634 //
     /* 103073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103097 */     // MIs[1] Rn
     /* 103097 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103108 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103128 */     GIR_RootConstrainSelectedInstOperands,
     /* 103129 */     // GIR_Coverage, 5634,
     /* 103129 */     GIR_EraseRootFromParent_Done,
     /* 103130 */   // Label 1921: @103130
     /* 103130 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103192), // Rule ID 5668 //
     /* 103135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103159 */     // MIs[1] Rn
     /* 103159 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103170 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103190 */     GIR_RootConstrainSelectedInstOperands,
     /* 103191 */     // GIR_Coverage, 5668,
     /* 103191 */     GIR_EraseRootFromParent_Done,
     /* 103192 */   // Label 1922: @103192
     /* 103192 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103254), // Rule ID 1867 //
     /* 103197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103225 */     // MIs[1] Rn
     /* 103225 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103232 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103252 */     GIR_RootConstrainSelectedInstOperands,
     /* 103253 */     // GIR_Coverage, 1867,
     /* 103253 */     GIR_EraseRootFromParent_Done,
     /* 103254 */   // Label 1923: @103254
     /* 103254 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103316), // Rule ID 2124 //
     /* 103259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103287 */     // MIs[1] Rn
     /* 103287 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103294 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103314 */     GIR_RootConstrainSelectedInstOperands,
     /* 103315 */     // GIR_Coverage, 2124,
     /* 103315 */     GIR_EraseRootFromParent_Done,
     /* 103316 */   // Label 1924: @103316
     /* 103316 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103356), // Rule ID 1865 //
     /* 103321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103336 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103341 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103343 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103354 */     GIR_RootConstrainSelectedInstOperands,
     /* 103355 */     // GIR_Coverage, 1865,
     /* 103355 */     GIR_EraseRootFromParent_Done,
     /* 103356 */   // Label 1925: @103356
     /* 103356 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103396), // Rule ID 2122 //
     /* 103361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103376 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103394 */     GIR_RootConstrainSelectedInstOperands,
     /* 103395 */     // GIR_Coverage, 2122,
     /* 103395 */     GIR_EraseRootFromParent_Done,
     /* 103396 */   // Label 1926: @103396
     /* 103396 */   GIM_Reject,
     /* 103397 */ // Label 1920: @103397
     /* 103397 */ GIM_Reject,
     /* 103398 */ // Label 1911: @103398
     /* 103398 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103444), // Rule ID 819 //
     /* 103403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103424 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103429 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103431 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103436 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103442 */   GIR_RootConstrainSelectedInstOperands,
     /* 103443 */   // GIR_Coverage, 819,
     /* 103443 */   GIR_EraseRootFromParent_Done,
     /* 103444 */ // Label 1927: @103444
     /* 103444 */ GIM_Reject,
     /* 103445 */ // Label 1912: @103445
     /* 103445 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103491), // Rule ID 814 //
     /* 103450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103471 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103476 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103478 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103483 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103489 */   GIR_RootConstrainSelectedInstOperands,
     /* 103490 */   // GIR_Coverage, 814,
     /* 103490 */   GIR_EraseRootFromParent_Done,
     /* 103491 */ // Label 1928: @103491
     /* 103491 */ GIM_Reject,
     /* 103492 */ // Label 1913: @103492
     /* 103492 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103692),
     /* 103497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103507 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103581), // Rule ID 5725 //
     /* 103512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103523 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103526 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103535 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103555 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3681:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103579 */     GIR_RootConstrainSelectedInstOperands,
     /* 103580 */     // GIR_Coverage, 5725,
     /* 103580 */     GIR_EraseRootFromParent_Done,
     /* 103581 */   // Label 1930: @103581
     /* 103581 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103655), // Rule ID 2469 //
     /* 103586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103601 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103604 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103613 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103629 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3681:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103653 */     GIR_RootConstrainSelectedInstOperands,
     /* 103654 */     // GIR_Coverage, 2469,
     /* 103654 */     GIR_EraseRootFromParent_Done,
     /* 103655 */   // Label 1931: @103655
     /* 103655 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103691), // Rule ID 820 //
     /* 103660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103671 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103689 */     GIR_RootConstrainSelectedInstOperands,
     /* 103690 */     // GIR_Coverage, 820,
     /* 103690 */     GIR_EraseRootFromParent_Done,
     /* 103691 */   // Label 1932: @103691
     /* 103691 */   GIM_Reject,
     /* 103692 */ // Label 1929: @103692
     /* 103692 */ GIM_Reject,
     /* 103693 */ // Label 1914: @103693
     /* 103693 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103739), // Rule ID 813 //
     /* 103698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103719 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103724 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103726 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103731 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103737 */   GIR_RootConstrainSelectedInstOperands,
     /* 103738 */   // GIR_Coverage, 813,
     /* 103738 */   GIR_EraseRootFromParent_Done,
     /* 103739 */ // Label 1933: @103739
     /* 103739 */ GIM_Reject,
     /* 103740 */ // Label 1915: @103740
     /* 103740 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104009),
     /* 103745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103751 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103829), // Rule ID 5724 //
     /* 103756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103771 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103774 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103783 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103803 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103827 */     GIR_RootConstrainSelectedInstOperands,
     /* 103828 */     // GIR_Coverage, 5724,
     /* 103828 */     GIR_EraseRootFromParent_Done,
     /* 103829 */   // Label 1935: @103829
     /* 103829 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103907), // Rule ID 2468 //
     /* 103834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103853 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103856 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103865 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103881 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103905 */     GIR_RootConstrainSelectedInstOperands,
     /* 103906 */     // GIR_Coverage, 2468,
     /* 103906 */     GIR_EraseRootFromParent_Done,
     /* 103907 */   // Label 1936: @103907
     /* 103907 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103947), // Rule ID 816 //
     /* 103912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103927 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103945 */     GIR_RootConstrainSelectedInstOperands,
     /* 103946 */     // GIR_Coverage, 816,
     /* 103946 */     GIR_EraseRootFromParent_Done,
     /* 103947 */   // Label 1937: @103947
     /* 103947 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104008), // Rule ID 3498 //
     /* 103952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103967 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104006 */     GIR_RootConstrainSelectedInstOperands,
     /* 104007 */     // GIR_Coverage, 3498,
     /* 104007 */     GIR_EraseRootFromParent_Done,
     /* 104008 */   // Label 1938: @104008
     /* 104008 */   GIM_Reject,
     /* 104009 */ // Label 1934: @104009
     /* 104009 */ GIM_Reject,
     /* 104010 */ // Label 1916: @104010
     /* 104010 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104056), // Rule ID 817 //
     /* 104015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104036 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104041 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104043 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104048 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104054 */   GIR_RootConstrainSelectedInstOperands,
     /* 104055 */   // GIR_Coverage, 817,
     /* 104055 */   GIR_EraseRootFromParent_Done,
     /* 104056 */ // Label 1939: @104056
     /* 104056 */ GIM_Reject,
     /* 104057 */ // Label 1917: @104057
     /* 104057 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104170),
     /* 104062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104068 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104108), // Rule ID 815 //
     /* 104073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104088 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104106 */     GIR_RootConstrainSelectedInstOperands,
     /* 104107 */     // GIR_Coverage, 815,
     /* 104107 */     GIR_EraseRootFromParent_Done,
     /* 104108 */   // Label 1941: @104108
     /* 104108 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104169), // Rule ID 3495 //
     /* 104113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104128 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104167 */     GIR_RootConstrainSelectedInstOperands,
     /* 104168 */     // GIR_Coverage, 3495,
     /* 104168 */     GIR_EraseRootFromParent_Done,
     /* 104169 */   // Label 1942: @104169
     /* 104169 */   GIM_Reject,
     /* 104170 */ // Label 1940: @104170
     /* 104170 */ GIM_Reject,
     /* 104171 */ // Label 1918: @104171
     /* 104171 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104284),
     /* 104176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104182 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104222), // Rule ID 818 //
     /* 104187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104202 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104220 */     GIR_RootConstrainSelectedInstOperands,
     /* 104221 */     // GIR_Coverage, 818,
     /* 104221 */     GIR_EraseRootFromParent_Done,
     /* 104222 */   // Label 1944: @104222
     /* 104222 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104283), // Rule ID 3492 //
     /* 104227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104242 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104281 */     GIR_RootConstrainSelectedInstOperands,
     /* 104282 */     // GIR_Coverage, 3492,
     /* 104282 */     GIR_EraseRootFromParent_Done,
     /* 104283 */   // Label 1945: @104283
     /* 104283 */   GIM_Reject,
     /* 104284 */ // Label 1943: @104284
     /* 104284 */ GIM_Reject,
     /* 104285 */ // Label 1919: @104285
     /* 104285 */ GIM_Reject,
     /* 104286 */ // Label 31: @104286
     /* 104286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1954*/ GIMT_Encode4(104930),
     /* 104297 */ /*GILLT_s64*//*Label 1946*/ GIMT_Encode4(104353), GIMT_Encode4(0),
     /* 104305 */ /*GILLT_v2s32*//*Label 1947*/ GIMT_Encode4(104400),
     /* 104309 */ /*GILLT_v2s64*//*Label 1948*/ GIMT_Encode4(104447), GIMT_Encode4(0),
     /* 104317 */ /*GILLT_v4s16*//*Label 1949*/ GIMT_Encode4(104494),
     /* 104321 */ /*GILLT_v4s32*//*Label 1950*/ GIMT_Encode4(104541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104333 */ /*GILLT_v8s8*//*Label 1951*/ GIMT_Encode4(104655),
     /* 104337 */ /*GILLT_v8s16*//*Label 1952*/ GIMT_Encode4(104702), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104349 */ /*GILLT_v16s8*//*Label 1953*/ GIMT_Encode4(104816),
     /* 104353 */ // Label 1946: @104353
     /* 104353 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104399), // Rule ID 1019 //
     /* 104358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104379 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104384 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104386 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104391 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104397 */   GIR_RootConstrainSelectedInstOperands,
     /* 104398 */   // GIR_Coverage, 1019,
     /* 104398 */   GIR_EraseRootFromParent_Done,
     /* 104399 */ // Label 1955: @104399
     /* 104399 */ GIM_Reject,
     /* 104400 */ // Label 1947: @104400
     /* 104400 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(104446), // Rule ID 1014 //
     /* 104405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104426 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104431 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104433 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104444 */   GIR_RootConstrainSelectedInstOperands,
     /* 104445 */   // GIR_Coverage, 1014,
     /* 104445 */   GIR_EraseRootFromParent_Done,
     /* 104446 */ // Label 1956: @104446
     /* 104446 */ GIM_Reject,
     /* 104447 */ // Label 1948: @104447
     /* 104447 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(104493), // Rule ID 1020 //
     /* 104452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104473 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104478 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104480 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104485 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104491 */   GIR_RootConstrainSelectedInstOperands,
     /* 104492 */   // GIR_Coverage, 1020,
     /* 104492 */   GIR_EraseRootFromParent_Done,
     /* 104493 */ // Label 1957: @104493
     /* 104493 */ GIM_Reject,
     /* 104494 */ // Label 1949: @104494
     /* 104494 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(104540), // Rule ID 1013 //
     /* 104499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104520 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104525 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104527 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104538 */   GIR_RootConstrainSelectedInstOperands,
     /* 104539 */   // GIR_Coverage, 1013,
     /* 104539 */   GIR_EraseRootFromParent_Done,
     /* 104540 */ // Label 1958: @104540
     /* 104540 */ GIM_Reject,
     /* 104541 */ // Label 1950: @104541
     /* 104541 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(104654),
     /* 104546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104552 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(104592), // Rule ID 1016 //
     /* 104557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104572 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104590 */     GIR_RootConstrainSelectedInstOperands,
     /* 104591 */     // GIR_Coverage, 1016,
     /* 104591 */     GIR_EraseRootFromParent_Done,
     /* 104592 */   // Label 1960: @104592
     /* 104592 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(104653), // Rule ID 3525 //
     /* 104597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104612 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104651 */     GIR_RootConstrainSelectedInstOperands,
     /* 104652 */     // GIR_Coverage, 3525,
     /* 104652 */     GIR_EraseRootFromParent_Done,
     /* 104653 */   // Label 1961: @104653
     /* 104653 */   GIM_Reject,
     /* 104654 */ // Label 1959: @104654
     /* 104654 */ GIM_Reject,
     /* 104655 */ // Label 1951: @104655
     /* 104655 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(104701), // Rule ID 1017 //
     /* 104660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104681 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104686 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104688 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104693 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104699 */   GIR_RootConstrainSelectedInstOperands,
     /* 104700 */   // GIR_Coverage, 1017,
     /* 104700 */   GIR_EraseRootFromParent_Done,
     /* 104701 */ // Label 1962: @104701
     /* 104701 */ GIM_Reject,
     /* 104702 */ // Label 1952: @104702
     /* 104702 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104815),
     /* 104707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104713 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104753), // Rule ID 1015 //
     /* 104718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104733 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104751 */     GIR_RootConstrainSelectedInstOperands,
     /* 104752 */     // GIR_Coverage, 1015,
     /* 104752 */     GIR_EraseRootFromParent_Done,
     /* 104753 */   // Label 1964: @104753
     /* 104753 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104814), // Rule ID 3522 //
     /* 104758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104773 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104812 */     GIR_RootConstrainSelectedInstOperands,
     /* 104813 */     // GIR_Coverage, 3522,
     /* 104813 */     GIR_EraseRootFromParent_Done,
     /* 104814 */   // Label 1965: @104814
     /* 104814 */   GIM_Reject,
     /* 104815 */ // Label 1963: @104815
     /* 104815 */ GIM_Reject,
     /* 104816 */ // Label 1953: @104816
     /* 104816 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104929),
     /* 104821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104827 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104867), // Rule ID 1018 //
     /* 104832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104847 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104865 */     GIR_RootConstrainSelectedInstOperands,
     /* 104866 */     // GIR_Coverage, 1018,
     /* 104866 */     GIR_EraseRootFromParent_Done,
     /* 104867 */   // Label 1967: @104867
     /* 104867 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104928), // Rule ID 3519 //
     /* 104872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104887 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104926 */     GIR_RootConstrainSelectedInstOperands,
     /* 104927 */     // GIR_Coverage, 3519,
     /* 104927 */     GIR_EraseRootFromParent_Done,
     /* 104928 */   // Label 1968: @104928
     /* 104928 */   GIM_Reject,
     /* 104929 */ // Label 1966: @104929
     /* 104929 */ GIM_Reject,
     /* 104930 */ // Label 1954: @104930
     /* 104930 */ GIM_Reject,
     /* 104931 */ // Label 32: @104931
     /* 104931 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1978*/ GIMT_Encode4(105950),
     /* 104942 */ /*GILLT_s32*//*Label 1969*/ GIMT_Encode4(105002),
     /* 104946 */ /*GILLT_s64*//*Label 1970*/ GIMT_Encode4(105219), GIMT_Encode4(0),
     /* 104954 */ /*GILLT_v2s32*//*Label 1971*/ GIMT_Encode4(105266),
     /* 104958 */ /*GILLT_v2s64*//*Label 1972*/ GIMT_Encode4(105313), GIMT_Encode4(0),
     /* 104966 */ /*GILLT_v4s16*//*Label 1973*/ GIMT_Encode4(105436),
     /* 104970 */ /*GILLT_v4s32*//*Label 1974*/ GIMT_Encode4(105483), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104982 */ /*GILLT_v8s8*//*Label 1975*/ GIMT_Encode4(105675),
     /* 104986 */ /*GILLT_v8s16*//*Label 1976*/ GIMT_Encode4(105722), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104998 */ /*GILLT_v16s8*//*Label 1977*/ GIMT_Encode4(105836),
     /* 105002 */ // Label 1969: @105002
     /* 105002 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105218),
     /* 105007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105013 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105075), // Rule ID 1868 //
     /* 105018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105046 */     // MIs[1] Rn
     /* 105046 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105053 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105073 */     GIR_RootConstrainSelectedInstOperands,
     /* 105074 */     // GIR_Coverage, 1868,
     /* 105074 */     GIR_EraseRootFromParent_Done,
     /* 105075 */   // Label 1980: @105075
     /* 105075 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(105137), // Rule ID 2125 //
     /* 105080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105108 */     // MIs[1] Rn
     /* 105108 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105115 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105135 */     GIR_RootConstrainSelectedInstOperands,
     /* 105136 */     // GIR_Coverage, 2125,
     /* 105136 */     GIR_EraseRootFromParent_Done,
     /* 105137 */   // Label 1981: @105137
     /* 105137 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(105177), // Rule ID 1866 //
     /* 105142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105157 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105162 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105164 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105175 */     GIR_RootConstrainSelectedInstOperands,
     /* 105176 */     // GIR_Coverage, 1866,
     /* 105176 */     GIR_EraseRootFromParent_Done,
     /* 105177 */   // Label 1982: @105177
     /* 105177 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(105217), // Rule ID 2123 //
     /* 105182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105197 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105215 */     GIR_RootConstrainSelectedInstOperands,
     /* 105216 */     // GIR_Coverage, 2123,
     /* 105216 */     GIR_EraseRootFromParent_Done,
     /* 105217 */   // Label 1983: @105217
     /* 105217 */   GIM_Reject,
     /* 105218 */ // Label 1979: @105218
     /* 105218 */ GIM_Reject,
     /* 105219 */ // Label 1970: @105219
     /* 105219 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(105265), // Rule ID 1011 //
     /* 105224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105245 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105250 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105252 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105257 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105263 */   GIR_RootConstrainSelectedInstOperands,
     /* 105264 */   // GIR_Coverage, 1011,
     /* 105264 */   GIR_EraseRootFromParent_Done,
     /* 105265 */ // Label 1984: @105265
     /* 105265 */ GIM_Reject,
     /* 105266 */ // Label 1971: @105266
     /* 105266 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105312), // Rule ID 1006 //
     /* 105271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105292 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105299 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105310 */   GIR_RootConstrainSelectedInstOperands,
     /* 105311 */   // GIR_Coverage, 1006,
     /* 105311 */   GIR_EraseRootFromParent_Done,
     /* 105312 */ // Label 1985: @105312
     /* 105312 */ GIM_Reject,
     /* 105313 */ // Label 1972: @105313
     /* 105313 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(105435),
     /* 105318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105332 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(105402), // Rule ID 2476 //
     /* 105337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105348 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105351 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105376 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3681:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105400 */     GIR_RootConstrainSelectedInstOperands,
     /* 105401 */     // GIR_Coverage, 2476,
     /* 105401 */     GIR_EraseRootFromParent_Done,
     /* 105402 */   // Label 1987: @105402
     /* 105402 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105434), // Rule ID 1012 //
     /* 105407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105414 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105432 */     GIR_RootConstrainSelectedInstOperands,
     /* 105433 */     // GIR_Coverage, 1012,
     /* 105433 */     GIR_EraseRootFromParent_Done,
     /* 105434 */   // Label 1988: @105434
     /* 105434 */   GIM_Reject,
     /* 105435 */ // Label 1986: @105435
     /* 105435 */ GIM_Reject,
     /* 105436 */ // Label 1973: @105436
     /* 105436 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105482), // Rule ID 1005 //
     /* 105441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105462 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105467 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105469 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105474 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105480 */   GIR_RootConstrainSelectedInstOperands,
     /* 105481 */   // GIR_Coverage, 1005,
     /* 105481 */   GIR_EraseRootFromParent_Done,
     /* 105482 */ // Label 1989: @105482
     /* 105482 */ GIM_Reject,
     /* 105483 */ // Label 1974: @105483
     /* 105483 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105674),
     /* 105488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105494 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105572), // Rule ID 2475 //
     /* 105499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105518 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105521 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105530 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105546 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105570 */     GIR_RootConstrainSelectedInstOperands,
     /* 105571 */     // GIR_Coverage, 2475,
     /* 105571 */     GIR_EraseRootFromParent_Done,
     /* 105572 */   // Label 1991: @105572
     /* 105572 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105612), // Rule ID 1008 //
     /* 105577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105592 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105610 */     GIR_RootConstrainSelectedInstOperands,
     /* 105611 */     // GIR_Coverage, 1008,
     /* 105611 */     GIR_EraseRootFromParent_Done,
     /* 105612 */   // Label 1992: @105612
     /* 105612 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105673), // Rule ID 3516 //
     /* 105617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105632 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105671 */     GIR_RootConstrainSelectedInstOperands,
     /* 105672 */     // GIR_Coverage, 3516,
     /* 105672 */     GIR_EraseRootFromParent_Done,
     /* 105673 */   // Label 1993: @105673
     /* 105673 */   GIM_Reject,
     /* 105674 */ // Label 1990: @105674
     /* 105674 */ GIM_Reject,
     /* 105675 */ // Label 1975: @105675
     /* 105675 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105721), // Rule ID 1009 //
     /* 105680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105701 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105706 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105708 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105713 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105719 */   GIR_RootConstrainSelectedInstOperands,
     /* 105720 */   // GIR_Coverage, 1009,
     /* 105720 */   GIR_EraseRootFromParent_Done,
     /* 105721 */ // Label 1994: @105721
     /* 105721 */ GIM_Reject,
     /* 105722 */ // Label 1976: @105722
     /* 105722 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105835),
     /* 105727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105733 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105773), // Rule ID 1007 //
     /* 105738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105753 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105771 */     GIR_RootConstrainSelectedInstOperands,
     /* 105772 */     // GIR_Coverage, 1007,
     /* 105772 */     GIR_EraseRootFromParent_Done,
     /* 105773 */   // Label 1996: @105773
     /* 105773 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105834), // Rule ID 3513 //
     /* 105778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105793 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105832 */     GIR_RootConstrainSelectedInstOperands,
     /* 105833 */     // GIR_Coverage, 3513,
     /* 105833 */     GIR_EraseRootFromParent_Done,
     /* 105834 */   // Label 1997: @105834
     /* 105834 */   GIM_Reject,
     /* 105835 */ // Label 1995: @105835
     /* 105835 */ GIM_Reject,
     /* 105836 */ // Label 1977: @105836
     /* 105836 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105949),
     /* 105841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105847 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105887), // Rule ID 1010 //
     /* 105852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105867 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105885 */     GIR_RootConstrainSelectedInstOperands,
     /* 105886 */     // GIR_Coverage, 1010,
     /* 105886 */     GIR_EraseRootFromParent_Done,
     /* 105887 */   // Label 1999: @105887
     /* 105887 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105948), // Rule ID 3510 //
     /* 105892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105907 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105946 */     GIR_RootConstrainSelectedInstOperands,
     /* 105947 */     // GIR_Coverage, 3510,
     /* 105947 */     GIR_EraseRootFromParent_Done,
     /* 105948 */   // Label 2000: @105948
     /* 105948 */   GIM_Reject,
     /* 105949 */ // Label 1998: @105949
     /* 105949 */ GIM_Reject,
     /* 105950 */ // Label 1978: @105950
     /* 105950 */ GIM_Reject,
     /* 105951 */ // Label 33: @105951
     /* 105951 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2008*/ GIMT_Encode4(108303),
     /* 105962 */ /*GILLT_s16*//*Label 2001*/ GIMT_Encode4(106014),
     /* 105966 */ /*GILLT_s32*//*Label 2002*/ GIMT_Encode4(106061),
     /* 105970 */ /*GILLT_s64*//*Label 2003*/ GIMT_Encode4(107656), GIMT_Encode4(0),
     /* 105978 */ /*GILLT_v2s32*//*Label 2004*/ GIMT_Encode4(107703), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105990 */ /*GILLT_v4s16*//*Label 2005*/ GIMT_Encode4(107750),
     /* 105994 */ /*GILLT_v4s32*//*Label 2006*/ GIMT_Encode4(107935), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106010 */ /*GILLT_v8s16*//*Label 2007*/ GIMT_Encode4(108049),
     /* 106014 */ // Label 2001: @106014
     /* 106014 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106060), // Rule ID 614 //
     /* 106019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 106022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 106025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 106028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106040 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106045 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106047 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106052 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106058 */   GIR_RootConstrainSelectedInstOperands,
     /* 106059 */   // GIR_Coverage, 614,
     /* 106059 */   GIR_EraseRootFromParent_Done,
     /* 106060 */ // Label 2009: @106060
     /* 106060 */ GIM_Reject,
     /* 106061 */ // Label 2002: @106061
     /* 106061 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107655),
     /* 106066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106076 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106404), // Rule ID 5901 //
     /* 106081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106116 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106116 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106119 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106123 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106130 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106133 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106137 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106142 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106145 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106150 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106153 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106157 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106162 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106165 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106169 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106172 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106177 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106182 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106187 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106190 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106194 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106201 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106204 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106208 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106213 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106216 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106221 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106224 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106228 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106233 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106236 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106240 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106243 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106248 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106253 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106258 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106261 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106265 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106272 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106275 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106279 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106284 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106287 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106292 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106295 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106299 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106304 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106307 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106311 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106314 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106319 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106324 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106341 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106347 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106350 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106353 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106386 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106403 */     // GIR_Coverage, 5901,
     /* 106403 */     GIR_EraseRootFromParent_Done,
     /* 106404 */   // Label 2011: @106404
     /* 106404 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(106732), // Rule ID 5902 //
     /* 106409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106444 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106444 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106447 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106451 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106458 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106461 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106465 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106470 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106473 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106478 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106481 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106485 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106490 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106493 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106497 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106500 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106505 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106510 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106515 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106518 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106522 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106529 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106532 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106536 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106541 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106544 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106549 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106552 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106556 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106561 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106564 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106568 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106571 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106576 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106581 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106586 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106589 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106593 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106600 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106603 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106607 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106612 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106615 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106632 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106635 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106639 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106642 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106647 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106652 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106669 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106681 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106701 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106714 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106731 */     // GIR_Coverage, 5902,
     /* 106731 */     GIR_EraseRootFromParent_Done,
     /* 106732 */   // Label 2012: @106732
     /* 106732 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107060), // Rule ID 2680 //
     /* 106737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106772 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106772 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106775 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106779 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106786 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106789 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106793 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106798 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106801 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106806 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106809 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106813 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106818 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106821 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106825 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106828 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106833 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106838 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106843 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106846 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106850 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106857 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106860 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106864 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106869 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106872 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106877 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106880 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106884 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106889 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106892 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106896 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106899 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106904 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106909 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106914 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106917 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106921 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106928 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106931 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106935 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106940 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106943 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106948 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106951 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106955 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106960 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106963 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106967 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106970 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106975 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106980 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106997 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107000 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107003 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107006 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107009 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107029 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107042 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107059 */     // GIR_Coverage, 2680,
     /* 107059 */     GIR_EraseRootFromParent_Done,
     /* 107060 */   // Label 2013: @107060
     /* 107060 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107388), // Rule ID 2682 //
     /* 107065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107100 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107100 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107103 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107107 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107114 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107117 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107121 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107126 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107129 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107134 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107137 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107141 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107146 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107149 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107153 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107156 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107161 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107166 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107171 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107174 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107178 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107185 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107188 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107192 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107197 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107200 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107205 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107208 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107212 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107217 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107220 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107224 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107227 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107232 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107237 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107242 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107245 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107249 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107256 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107259 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107263 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107268 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107271 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107276 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107279 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107283 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107288 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107291 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107295 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107298 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107303 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107308 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107325 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107328 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107331 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107334 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107337 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107370 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107387 */     // GIR_Coverage, 2682,
     /* 107387 */     GIR_EraseRootFromParent_Done,
     /* 107388 */   // Label 2014: @107388
     /* 107388 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107424), // Rule ID 613 //
     /* 107393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107404 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107422 */     GIR_RootConstrainSelectedInstOperands,
     /* 107423 */     // GIR_Coverage, 613,
     /* 107423 */     GIR_EraseRootFromParent_Done,
     /* 107424 */   // Label 2015: @107424
     /* 107424 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107654), // Rule ID 2677 //
     /* 107429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107440 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107440 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107443 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107447 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107454 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107457 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107461 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107466 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107469 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107474 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107477 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107481 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107486 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107489 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107493 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107496 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107501 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107506 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107511 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107514 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107518 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107525 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107528 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107532 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107537 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107540 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107557 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107560 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107564 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107567 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107572 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107577 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107594 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107597 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107600 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107603 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107623 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107636 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107653 */     // GIR_Coverage, 2677,
     /* 107653 */     GIR_EraseRootFromParent_Done,
     /* 107654 */   // Label 2016: @107654
     /* 107654 */   GIM_Reject,
     /* 107655 */ // Label 2010: @107655
     /* 107655 */ GIM_Reject,
     /* 107656 */ // Label 2003: @107656
     /* 107656 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107702), // Rule ID 612 //
     /* 107661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107682 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107687 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107689 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107700 */   GIR_RootConstrainSelectedInstOperands,
     /* 107701 */   // GIR_Coverage, 612,
     /* 107701 */   GIR_EraseRootFromParent_Done,
     /* 107702 */ // Label 2017: @107702
     /* 107702 */ GIM_Reject,
     /* 107703 */ // Label 2004: @107703
     /* 107703 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107749), // Rule ID 761 //
     /* 107708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107729 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107734 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107736 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107741 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107747 */   GIR_RootConstrainSelectedInstOperands,
     /* 107748 */   // GIR_Coverage, 761,
     /* 107748 */   GIR_EraseRootFromParent_Done,
     /* 107749 */ // Label 2018: @107749
     /* 107749 */ GIM_Reject,
     /* 107750 */ // Label 2005: @107750
     /* 107750 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107934),
     /* 107755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107765 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107831), // Rule ID 5564 //
     /* 107770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107805 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107829 */     GIR_RootConstrainSelectedInstOperands,
     /* 107830 */     // GIR_Coverage, 5564,
     /* 107830 */     GIR_EraseRootFromParent_Done,
     /* 107831 */   // Label 2020: @107831
     /* 107831 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107897), // Rule ID 942 //
     /* 107836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107871 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107876 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107895 */     GIR_RootConstrainSelectedInstOperands,
     /* 107896 */     // GIR_Coverage, 942,
     /* 107896 */     GIR_EraseRootFromParent_Done,
     /* 107897 */   // Label 2021: @107897
     /* 107897 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107933), // Rule ID 763 //
     /* 107902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107913 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107931 */     GIR_RootConstrainSelectedInstOperands,
     /* 107932 */     // GIR_Coverage, 763,
     /* 107932 */     GIR_EraseRootFromParent_Done,
     /* 107933 */   // Label 2022: @107933
     /* 107933 */   GIM_Reject,
     /* 107934 */ // Label 2019: @107934
     /* 107934 */ GIM_Reject,
     /* 107935 */ // Label 2006: @107935
     /* 107935 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(108048),
     /* 107940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107946 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107986), // Rule ID 762 //
     /* 107951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107966 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107984 */     GIR_RootConstrainSelectedInstOperands,
     /* 107985 */     // GIR_Coverage, 762,
     /* 107985 */     GIR_EraseRootFromParent_Done,
     /* 107986 */   // Label 2024: @107986
     /* 107986 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(108047), // Rule ID 3996 //
     /* 107991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108006 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 108006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 108021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108045 */     GIR_RootConstrainSelectedInstOperands,
     /* 108046 */     // GIR_Coverage, 3996,
     /* 108046 */     GIR_EraseRootFromParent_Done,
     /* 108047 */   // Label 2025: @108047
     /* 108047 */   GIM_Reject,
     /* 108048 */ // Label 2023: @108048
     /* 108048 */ GIM_Reject,
     /* 108049 */ // Label 2007: @108049
     /* 108049 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(108302),
     /* 108054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108060 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108130), // Rule ID 5565 //
     /* 108065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108104 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108109 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108128 */     GIR_RootConstrainSelectedInstOperands,
     /* 108129 */     // GIR_Coverage, 5565,
     /* 108129 */     GIR_EraseRootFromParent_Done,
     /* 108130 */   // Label 2027: @108130
     /* 108130 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(108200), // Rule ID 943 //
     /* 108135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108174 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108198 */     GIR_RootConstrainSelectedInstOperands,
     /* 108199 */     // GIR_Coverage, 943,
     /* 108199 */     GIR_EraseRootFromParent_Done,
     /* 108200 */   // Label 2028: @108200
     /* 108200 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108240), // Rule ID 764 //
     /* 108205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108220 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108238 */     GIR_RootConstrainSelectedInstOperands,
     /* 108239 */     // GIR_Coverage, 764,
     /* 108239 */     GIR_EraseRootFromParent_Done,
     /* 108240 */   // Label 2029: @108240
     /* 108240 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(108301), // Rule ID 4000 //
     /* 108245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108260 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108299 */     GIR_RootConstrainSelectedInstOperands,
     /* 108300 */     // GIR_Coverage, 4000,
     /* 108300 */     GIR_EraseRootFromParent_Done,
     /* 108301 */   // Label 2030: @108301
     /* 108301 */   GIM_Reject,
     /* 108302 */ // Label 2026: @108302
     /* 108302 */ GIM_Reject,
     /* 108303 */ // Label 2008: @108303
     /* 108303 */ GIM_Reject,
     /* 108304 */ // Label 34: @108304
     /* 108304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2038*/ GIMT_Encode4(109980),
     /* 108315 */ /*GILLT_s16*//*Label 2031*/ GIMT_Encode4(108367),
     /* 108319 */ /*GILLT_s32*//*Label 2032*/ GIMT_Encode4(108414),
     /* 108323 */ /*GILLT_s64*//*Label 2033*/ GIMT_Encode4(109341), GIMT_Encode4(0),
     /* 108331 */ /*GILLT_v2s32*//*Label 2034*/ GIMT_Encode4(109388), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108343 */ /*GILLT_v4s16*//*Label 2035*/ GIMT_Encode4(109435),
     /* 108347 */ /*GILLT_v4s32*//*Label 2036*/ GIMT_Encode4(109612), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108363 */ /*GILLT_v8s16*//*Label 2037*/ GIMT_Encode4(109726),
     /* 108367 */ // Label 2031: @108367
     /* 108367 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108413), // Rule ID 617 //
     /* 108372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108393 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108398 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108400 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108405 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108411 */   GIR_RootConstrainSelectedInstOperands,
     /* 108412 */   // GIR_Coverage, 617,
     /* 108412 */   GIR_EraseRootFromParent_Done,
     /* 108413 */ // Label 2039: @108413
     /* 108413 */ GIM_Reject,
     /* 108414 */ // Label 2032: @108414
     /* 108414 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(109340),
     /* 108419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108433 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108757), // Rule ID 2681 //
     /* 108438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108469 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108469 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108472 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108476 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108483 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108486 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108490 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108495 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108498 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108503 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108506 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108510 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108515 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108518 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108522 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108525 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108530 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108535 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108540 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108543 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108547 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108554 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108557 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108561 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108566 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108569 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108574 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108577 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108581 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108586 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108589 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108593 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108596 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108601 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108606 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108611 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108614 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108618 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108625 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108628 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108632 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108637 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108640 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108657 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108660 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108664 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108667 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108672 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108677 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108694 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108697 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108700 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108703 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108706 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108756 */     // GIR_Coverage, 2681,
     /* 108756 */     GIR_EraseRootFromParent_Done,
     /* 108757 */   // Label 2041: @108757
     /* 108757 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(109081), // Rule ID 2683 //
     /* 108762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108793 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108793 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108796 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108800 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108807 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108810 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108814 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108819 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108822 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108827 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108830 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108834 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108839 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108842 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108846 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108849 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108854 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108859 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108864 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108867 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108871 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108878 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108881 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108885 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108890 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108893 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108898 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108901 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108905 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108910 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108913 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108917 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108920 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108925 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108930 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108935 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108938 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108942 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108949 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108952 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108956 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108961 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108964 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108969 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108972 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108976 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108981 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108984 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108988 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108991 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108996 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109001 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 109013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109018 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109021 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109024 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 109027 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109030 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109050 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109063 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109080 */     // GIR_Coverage, 2683,
     /* 109080 */     GIR_EraseRootFromParent_Done,
     /* 109081 */   // Label 2042: @109081
     /* 109081 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(109113), // Rule ID 616 //
     /* 109086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109093 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109111 */     GIR_RootConstrainSelectedInstOperands,
     /* 109112 */     // GIR_Coverage, 616,
     /* 109112 */     GIR_EraseRootFromParent_Done,
     /* 109113 */   // Label 2043: @109113
     /* 109113 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(109339), // Rule ID 2678 //
     /* 109118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109125 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109125 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109128 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109132 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109139 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109142 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109146 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109151 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109154 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109159 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109162 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109166 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109171 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109174 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109178 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109181 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109186 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109191 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109196 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109199 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109203 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109210 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109213 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109217 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109222 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109225 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109230 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109233 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109237 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109242 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109245 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109249 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109252 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109257 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109262 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109279 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109282 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109285 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109288 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109338 */     // GIR_Coverage, 2678,
     /* 109338 */     GIR_EraseRootFromParent_Done,
     /* 109339 */   // Label 2044: @109339
     /* 109339 */   GIM_Reject,
     /* 109340 */ // Label 2040: @109340
     /* 109340 */ GIM_Reject,
     /* 109341 */ // Label 2033: @109341
     /* 109341 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(109387), // Rule ID 615 //
     /* 109346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109367 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109372 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109374 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109379 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109385 */   GIR_RootConstrainSelectedInstOperands,
     /* 109386 */   // GIR_Coverage, 615,
     /* 109386 */   GIR_EraseRootFromParent_Done,
     /* 109387 */ // Label 2045: @109387
     /* 109387 */ GIM_Reject,
     /* 109388 */ // Label 2034: @109388
     /* 109388 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109434), // Rule ID 965 //
     /* 109393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109414 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109419 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109421 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109426 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109432 */   GIR_RootConstrainSelectedInstOperands,
     /* 109433 */   // GIR_Coverage, 965,
     /* 109433 */   GIR_EraseRootFromParent_Done,
     /* 109434 */ // Label 2046: @109434
     /* 109434 */ GIM_Reject,
     /* 109435 */ // Label 2035: @109435
     /* 109435 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109611),
     /* 109440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109454 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109516), // Rule ID 920 //
     /* 109459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109490 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109514 */     GIR_RootConstrainSelectedInstOperands,
     /* 109515 */     // GIR_Coverage, 920,
     /* 109515 */     GIR_EraseRootFromParent_Done,
     /* 109516 */   // Label 2048: @109516
     /* 109516 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109578), // Rule ID 946 //
     /* 109521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109552 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109576 */     GIR_RootConstrainSelectedInstOperands,
     /* 109577 */     // GIR_Coverage, 946,
     /* 109577 */     GIR_EraseRootFromParent_Done,
     /* 109578 */   // Label 2049: @109578
     /* 109578 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109610), // Rule ID 967 //
     /* 109583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109590 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109608 */     GIR_RootConstrainSelectedInstOperands,
     /* 109609 */     // GIR_Coverage, 967,
     /* 109609 */     GIR_EraseRootFromParent_Done,
     /* 109610 */   // Label 2050: @109610
     /* 109610 */   GIM_Reject,
     /* 109611 */ // Label 2047: @109611
     /* 109611 */ GIM_Reject,
     /* 109612 */ // Label 2036: @109612
     /* 109612 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109725),
     /* 109617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109623 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109663), // Rule ID 966 //
     /* 109628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109643 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109661 */     GIR_RootConstrainSelectedInstOperands,
     /* 109662 */     // GIR_Coverage, 966,
     /* 109662 */     GIR_EraseRootFromParent_Done,
     /* 109663 */   // Label 2052: @109663
     /* 109663 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109724), // Rule ID 4004 //
     /* 109668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109683 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109722 */     GIR_RootConstrainSelectedInstOperands,
     /* 109723 */     // GIR_Coverage, 4004,
     /* 109723 */     GIR_EraseRootFromParent_Done,
     /* 109724 */   // Label 2053: @109724
     /* 109724 */   GIM_Reject,
     /* 109725 */ // Label 2051: @109725
     /* 109725 */ GIM_Reject,
     /* 109726 */ // Label 2037: @109726
     /* 109726 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109979),
     /* 109731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109737 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109807), // Rule ID 921 //
     /* 109742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109781 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109805 */     GIR_RootConstrainSelectedInstOperands,
     /* 109806 */     // GIR_Coverage, 921,
     /* 109806 */     GIR_EraseRootFromParent_Done,
     /* 109807 */   // Label 2055: @109807
     /* 109807 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109877), // Rule ID 947 //
     /* 109812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109851 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109875 */     GIR_RootConstrainSelectedInstOperands,
     /* 109876 */     // GIR_Coverage, 947,
     /* 109876 */     GIR_EraseRootFromParent_Done,
     /* 109877 */   // Label 2056: @109877
     /* 109877 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109917), // Rule ID 968 //
     /* 109882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109897 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109915 */     GIR_RootConstrainSelectedInstOperands,
     /* 109916 */     // GIR_Coverage, 968,
     /* 109916 */     GIR_EraseRootFromParent_Done,
     /* 109917 */   // Label 2057: @109917
     /* 109917 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109978), // Rule ID 4008 //
     /* 109922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109937 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109976 */     GIR_RootConstrainSelectedInstOperands,
     /* 109977 */     // GIR_Coverage, 4008,
     /* 109977 */     GIR_EraseRootFromParent_Done,
     /* 109978 */   // Label 2058: @109978
     /* 109978 */   GIM_Reject,
     /* 109979 */ // Label 2054: @109979
     /* 109979 */ GIM_Reject,
     /* 109980 */ // Label 2038: @109980
     /* 109980 */ GIM_Reject,
     /* 109981 */ // Label 35: @109981
     /* 109981 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2066*/ GIMT_Encode4(110961),
     /* 109992 */ /*GILLT_s16*//*Label 2059*/ GIMT_Encode4(110044),
     /* 109996 */ /*GILLT_s32*//*Label 2060*/ GIMT_Encode4(110091),
     /* 110000 */ /*GILLT_s64*//*Label 2061*/ GIMT_Encode4(110480), GIMT_Encode4(0),
     /* 110008 */ /*GILLT_v2s32*//*Label 2062*/ GIMT_Encode4(110639), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110020 */ /*GILLT_v4s16*//*Label 2063*/ GIMT_Encode4(110686),
     /* 110024 */ /*GILLT_v4s32*//*Label 2064*/ GIMT_Encode4(110733), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110040 */ /*GILLT_v8s16*//*Label 2065*/ GIMT_Encode4(110847),
     /* 110044 */ // Label 2059: @110044
     /* 110044 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110090), // Rule ID 623 //
     /* 110049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110070 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110075 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110077 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110082 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110088 */   GIR_RootConstrainSelectedInstOperands,
     /* 110089 */   // GIR_Coverage, 623,
     /* 110089 */   GIR_EraseRootFromParent_Done,
     /* 110090 */ // Label 2067: @110090
     /* 110090 */ GIM_Reject,
     /* 110091 */ // Label 2060: @110091
     /* 110091 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110479),
     /* 110096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110106 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(110159), // Rule ID 2282 //
     /* 110111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110137 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110146 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110157 */     GIR_RootConstrainSelectedInstOperands,
     /* 110158 */     // GIR_Coverage, 2282,
     /* 110158 */     GIR_EraseRootFromParent_Done,
     /* 110159 */   // Label 2069: @110159
     /* 110159 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(110212), // Rule ID 5691 //
     /* 110164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110190 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110199 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110210 */     GIR_RootConstrainSelectedInstOperands,
     /* 110211 */     // GIR_Coverage, 5691,
     /* 110211 */     GIR_EraseRootFromParent_Done,
     /* 110212 */   // Label 2070: @110212
     /* 110212 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(110248), // Rule ID 622 //
     /* 110217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110228 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110246 */     GIR_RootConstrainSelectedInstOperands,
     /* 110247 */     // GIR_Coverage, 622,
     /* 110247 */     GIR_EraseRootFromParent_Done,
     /* 110248 */   // Label 2071: @110248
     /* 110248 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(110478), // Rule ID 2679 //
     /* 110253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110264 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110264 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110267 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110271 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110278 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110281 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110285 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110290 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110293 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110298 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110301 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110305 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110310 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110313 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110317 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110320 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110325 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110330 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110335 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110338 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110342 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110349 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110352 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110356 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110361 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110364 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110369 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110372 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110376 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110381 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110384 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110388 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110391 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110396 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110401 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110418 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110421 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110424 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110427 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110460 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110477 */     // GIR_Coverage, 2679,
     /* 110477 */     GIR_EraseRootFromParent_Done,
     /* 110478 */   // Label 2072: @110478
     /* 110478 */   GIM_Reject,
     /* 110479 */ // Label 2068: @110479
     /* 110479 */ GIM_Reject,
     /* 110480 */ // Label 2061: @110480
     /* 110480 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110638),
     /* 110485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110495 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110548), // Rule ID 2281 //
     /* 110500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110526 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110535 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110546 */     GIR_RootConstrainSelectedInstOperands,
     /* 110547 */     // GIR_Coverage, 2281,
     /* 110547 */     GIR_EraseRootFromParent_Done,
     /* 110548 */   // Label 2074: @110548
     /* 110548 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110601), // Rule ID 5690 //
     /* 110553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110579 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110588 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110599 */     GIR_RootConstrainSelectedInstOperands,
     /* 110600 */     // GIR_Coverage, 5690,
     /* 110600 */     GIR_EraseRootFromParent_Done,
     /* 110601 */   // Label 2075: @110601
     /* 110601 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110637), // Rule ID 621 //
     /* 110606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110617 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110635 */     GIR_RootConstrainSelectedInstOperands,
     /* 110636 */     // GIR_Coverage, 621,
     /* 110636 */     GIR_EraseRootFromParent_Done,
     /* 110637 */   // Label 2076: @110637
     /* 110637 */   GIM_Reject,
     /* 110638 */ // Label 2073: @110638
     /* 110638 */ GIM_Reject,
     /* 110639 */ // Label 2062: @110639
     /* 110639 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110685), // Rule ID 840 //
     /* 110644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110665 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110670 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110672 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110677 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110683 */   GIR_RootConstrainSelectedInstOperands,
     /* 110684 */   // GIR_Coverage, 840,
     /* 110684 */   GIR_EraseRootFromParent_Done,
     /* 110685 */ // Label 2077: @110685
     /* 110685 */ GIM_Reject,
     /* 110686 */ // Label 2063: @110686
     /* 110686 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110732), // Rule ID 842 //
     /* 110691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110712 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110717 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110719 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110724 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110730 */   GIR_RootConstrainSelectedInstOperands,
     /* 110731 */   // GIR_Coverage, 842,
     /* 110731 */   GIR_EraseRootFromParent_Done,
     /* 110732 */ // Label 2078: @110732
     /* 110732 */ GIM_Reject,
     /* 110733 */ // Label 2064: @110733
     /* 110733 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110846),
     /* 110738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110744 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110784), // Rule ID 841 //
     /* 110749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110764 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110782 */     GIR_RootConstrainSelectedInstOperands,
     /* 110783 */     // GIR_Coverage, 841,
     /* 110783 */     GIR_EraseRootFromParent_Done,
     /* 110784 */   // Label 2080: @110784
     /* 110784 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110845), // Rule ID 3968 //
     /* 110789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110804 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110843 */     GIR_RootConstrainSelectedInstOperands,
     /* 110844 */     // GIR_Coverage, 3968,
     /* 110844 */     GIR_EraseRootFromParent_Done,
     /* 110845 */   // Label 2081: @110845
     /* 110845 */   GIM_Reject,
     /* 110846 */ // Label 2079: @110846
     /* 110846 */ GIM_Reject,
     /* 110847 */ // Label 2065: @110847
     /* 110847 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110960),
     /* 110852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110858 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110898), // Rule ID 843 //
     /* 110863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110878 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110896 */     GIR_RootConstrainSelectedInstOperands,
     /* 110897 */     // GIR_Coverage, 843,
     /* 110897 */     GIR_EraseRootFromParent_Done,
     /* 110898 */   // Label 2083: @110898
     /* 110898 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110959), // Rule ID 3972 //
     /* 110903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110918 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110957 */     GIR_RootConstrainSelectedInstOperands,
     /* 110958 */     // GIR_Coverage, 3972,
     /* 110958 */     GIR_EraseRootFromParent_Done,
     /* 110959 */   // Label 2084: @110959
     /* 110959 */   GIM_Reject,
     /* 110960 */ // Label 2082: @110960
     /* 110960 */ GIM_Reject,
     /* 110961 */ // Label 2066: @110961
     /* 110961 */ GIM_Reject,
     /* 110962 */ // Label 36: @110962
     /* 110962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2092*/ GIMT_Encode4(113052),
     /* 110973 */ /*GILLT_s16*//*Label 2085*/ GIMT_Encode4(111025),
     /* 110977 */ /*GILLT_s32*//*Label 2086*/ GIMT_Encode4(111412),
     /* 110981 */ /*GILLT_s64*//*Label 2087*/ GIMT_Encode4(111799), GIMT_Encode4(0),
     /* 110989 */ /*GILLT_v2s32*//*Label 2088*/ GIMT_Encode4(112186), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111001 */ /*GILLT_v4s16*//*Label 2089*/ GIMT_Encode4(112366),
     /* 111005 */ /*GILLT_v4s32*//*Label 2090*/ GIMT_Encode4(112422), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111021 */ /*GILLT_v8s16*//*Label 2091*/ GIMT_Encode4(112800),
     /* 111025 */ // Label 2085: @111025
     /* 111025 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111411),
     /* 111030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111043 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111117), // Rule ID 2386 //
     /* 111048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111091 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111115 */     GIR_RootConstrainSelectedInstOperands,
     /* 111116 */     // GIR_Coverage, 2386,
     /* 111116 */     GIR_EraseRootFromParent_Done,
     /* 111117 */   // Label 2094: @111117
     /* 111117 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111191), // Rule ID 5699 //
     /* 111122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111165 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111189 */     GIR_RootConstrainSelectedInstOperands,
     /* 111190 */     // GIR_Coverage, 5699,
     /* 111190 */     GIR_EraseRootFromParent_Done,
     /* 111191 */   // Label 2095: @111191
     /* 111191 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111250), // Rule ID 2378 //
     /* 111196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111226 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111248 */     GIR_RootConstrainSelectedInstOperands,
     /* 111249 */     // GIR_Coverage, 2378,
     /* 111249 */     GIR_EraseRootFromParent_Done,
     /* 111250 */   // Label 2096: @111250
     /* 111250 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111309), // Rule ID 5696 //
     /* 111255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111285 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111307 */     GIR_RootConstrainSelectedInstOperands,
     /* 111308 */     // GIR_Coverage, 5696,
     /* 111308 */     GIR_EraseRootFromParent_Done,
     /* 111309 */   // Label 2097: @111309
     /* 111309 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111368), // Rule ID 2391 //
     /* 111314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111344 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111366 */     GIR_RootConstrainSelectedInstOperands,
     /* 111367 */     // GIR_Coverage, 2391,
     /* 111367 */     GIR_EraseRootFromParent_Done,
     /* 111368 */   // Label 2098: @111368
     /* 111368 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111410), // Rule ID 2372 //
     /* 111373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111388 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111408 */     GIR_RootConstrainSelectedInstOperands,
     /* 111409 */     // GIR_Coverage, 2372,
     /* 111409 */     GIR_EraseRootFromParent_Done,
     /* 111410 */   // Label 2099: @111410
     /* 111410 */   GIM_Reject,
     /* 111411 */ // Label 2093: @111411
     /* 111411 */ GIM_Reject,
     /* 111412 */ // Label 2086: @111412
     /* 111412 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111798),
     /* 111417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111430 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111504), // Rule ID 2385 //
     /* 111435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111478 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111502 */     GIR_RootConstrainSelectedInstOperands,
     /* 111503 */     // GIR_Coverage, 2385,
     /* 111503 */     GIR_EraseRootFromParent_Done,
     /* 111504 */   // Label 2101: @111504
     /* 111504 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111578), // Rule ID 5698 //
     /* 111509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111552 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111576 */     GIR_RootConstrainSelectedInstOperands,
     /* 111577 */     // GIR_Coverage, 5698,
     /* 111577 */     GIR_EraseRootFromParent_Done,
     /* 111578 */   // Label 2102: @111578
     /* 111578 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111637), // Rule ID 2377 //
     /* 111583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111613 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111635 */     GIR_RootConstrainSelectedInstOperands,
     /* 111636 */     // GIR_Coverage, 2377,
     /* 111636 */     GIR_EraseRootFromParent_Done,
     /* 111637 */   // Label 2103: @111637
     /* 111637 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111696), // Rule ID 5695 //
     /* 111642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111672 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111694 */     GIR_RootConstrainSelectedInstOperands,
     /* 111695 */     // GIR_Coverage, 5695,
     /* 111695 */     GIR_EraseRootFromParent_Done,
     /* 111696 */   // Label 2104: @111696
     /* 111696 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111755), // Rule ID 2390 //
     /* 111701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111731 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111753 */     GIR_RootConstrainSelectedInstOperands,
     /* 111754 */     // GIR_Coverage, 2390,
     /* 111754 */     GIR_EraseRootFromParent_Done,
     /* 111755 */   // Label 2105: @111755
     /* 111755 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111797), // Rule ID 2371 //
     /* 111760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111775 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111795 */     GIR_RootConstrainSelectedInstOperands,
     /* 111796 */     // GIR_Coverage, 2371,
     /* 111796 */     GIR_EraseRootFromParent_Done,
     /* 111797 */   // Label 2106: @111797
     /* 111797 */   GIM_Reject,
     /* 111798 */ // Label 2100: @111798
     /* 111798 */ GIM_Reject,
     /* 111799 */ // Label 2087: @111799
     /* 111799 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(112185),
     /* 111804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111817 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111891), // Rule ID 2384 //
     /* 111822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111865 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111889 */     GIR_RootConstrainSelectedInstOperands,
     /* 111890 */     // GIR_Coverage, 2384,
     /* 111890 */     GIR_EraseRootFromParent_Done,
     /* 111891 */   // Label 2108: @111891
     /* 111891 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111965), // Rule ID 5697 //
     /* 111896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111939 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111963 */     GIR_RootConstrainSelectedInstOperands,
     /* 111964 */     // GIR_Coverage, 5697,
     /* 111964 */     GIR_EraseRootFromParent_Done,
     /* 111965 */   // Label 2109: @111965
     /* 111965 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(112024), // Rule ID 2376 //
     /* 111970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112000 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112022 */     GIR_RootConstrainSelectedInstOperands,
     /* 112023 */     // GIR_Coverage, 2376,
     /* 112023 */     GIR_EraseRootFromParent_Done,
     /* 112024 */   // Label 2110: @112024
     /* 112024 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(112083), // Rule ID 5694 //
     /* 112029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112059 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112081 */     GIR_RootConstrainSelectedInstOperands,
     /* 112082 */     // GIR_Coverage, 5694,
     /* 112082 */     GIR_EraseRootFromParent_Done,
     /* 112083 */   // Label 2111: @112083
     /* 112083 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(112142), // Rule ID 2389 //
     /* 112088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112118 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112140 */     GIR_RootConstrainSelectedInstOperands,
     /* 112141 */     // GIR_Coverage, 2389,
     /* 112141 */     GIR_EraseRootFromParent_Done,
     /* 112142 */   // Label 2112: @112142
     /* 112142 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(112184), // Rule ID 2370 //
     /* 112147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112162 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112182 */     GIR_RootConstrainSelectedInstOperands,
     /* 112183 */     // GIR_Coverage, 2370,
     /* 112183 */     GIR_EraseRootFromParent_Done,
     /* 112184 */   // Label 2113: @112184
     /* 112184 */   GIM_Reject,
     /* 112185 */ // Label 2107: @112185
     /* 112185 */ GIM_Reject,
     /* 112186 */ // Label 2088: @112186
     /* 112186 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(112365),
     /* 112191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112204 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(112263), // Rule ID 2483 //
     /* 112209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112239 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112244 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112261 */     GIR_RootConstrainSelectedInstOperands,
     /* 112262 */     // GIR_Coverage, 2483,
     /* 112262 */     GIR_EraseRootFromParent_Done,
     /* 112263 */   // Label 2115: @112263
     /* 112263 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(112322), // Rule ID 5737 //
     /* 112268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112298 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112303 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112320 */     GIR_RootConstrainSelectedInstOperands,
     /* 112321 */     // GIR_Coverage, 5737,
     /* 112321 */     GIR_EraseRootFromParent_Done,
     /* 112322 */   // Label 2116: @112322
     /* 112322 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112364), // Rule ID 2481 //
     /* 112327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112342 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112347 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112362 */     GIR_RootConstrainSelectedInstOperands,
     /* 112363 */     // GIR_Coverage, 2481,
     /* 112363 */     GIR_EraseRootFromParent_Done,
     /* 112364 */   // Label 2117: @112364
     /* 112364 */   GIM_Reject,
     /* 112365 */ // Label 2114: @112365
     /* 112365 */ GIM_Reject,
     /* 112366 */ // Label 2089: @112366
     /* 112366 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112421), // Rule ID 2479 //
     /* 112371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112399 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112404 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112406 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112408 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112419 */   GIR_RootConstrainSelectedInstOperands,
     /* 112420 */   // GIR_Coverage, 2479,
     /* 112420 */   GIR_EraseRootFromParent_Done,
     /* 112421 */ // Label 2118: @112421
     /* 112421 */ GIM_Reject,
     /* 112422 */ // Label 2090: @112422
     /* 112422 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112799),
     /* 112427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112436 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112499), // Rule ID 2484 //
     /* 112441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112475 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112480 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112497 */     GIR_RootConstrainSelectedInstOperands,
     /* 112498 */     // GIR_Coverage, 2484,
     /* 112498 */     GIR_EraseRootFromParent_Done,
     /* 112499 */   // Label 2120: @112499
     /* 112499 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112568), // Rule ID 3982 //
     /* 112504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112538 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112543 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112549 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112566 */     GIR_RootConstrainSelectedInstOperands,
     /* 112567 */     // GIR_Coverage, 3982,
     /* 112567 */     GIR_EraseRootFromParent_Done,
     /* 112568 */   // Label 2121: @112568
     /* 112568 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112631), // Rule ID 5738 //
     /* 112573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112607 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112612 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112629 */     GIR_RootConstrainSelectedInstOperands,
     /* 112630 */     // GIR_Coverage, 5738,
     /* 112630 */     GIR_EraseRootFromParent_Done,
     /* 112631 */   // Label 2122: @112631
     /* 112631 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112700), // Rule ID 6018 //
     /* 112636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112670 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112675 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112681 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112698 */     GIR_RootConstrainSelectedInstOperands,
     /* 112699 */     // GIR_Coverage, 6018,
     /* 112699 */     GIR_EraseRootFromParent_Done,
     /* 112700 */   // Label 2123: @112700
     /* 112700 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112746), // Rule ID 2482 //
     /* 112705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112724 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112729 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112744 */     GIR_RootConstrainSelectedInstOperands,
     /* 112745 */     // GIR_Coverage, 2482,
     /* 112745 */     GIR_EraseRootFromParent_Done,
     /* 112746 */   // Label 2124: @112746
     /* 112746 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112798), // Rule ID 3986 //
     /* 112751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112770 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112775 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112777 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112779 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112796 */     GIR_RootConstrainSelectedInstOperands,
     /* 112797 */     // GIR_Coverage, 3986,
     /* 112797 */     GIR_EraseRootFromParent_Done,
     /* 112798 */   // Label 2125: @112798
     /* 112798 */   GIM_Reject,
     /* 112799 */ // Label 2119: @112799
     /* 112799 */ GIM_Reject,
     /* 112800 */ // Label 2091: @112800
     /* 112800 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(113051),
     /* 112805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112814 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112883), // Rule ID 3992 //
     /* 112819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112853 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112858 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112864 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112881 */     GIR_RootConstrainSelectedInstOperands,
     /* 112882 */     // GIR_Coverage, 3992,
     /* 112882 */     GIR_EraseRootFromParent_Done,
     /* 112883 */   // Label 2127: @112883
     /* 112883 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112952), // Rule ID 6020 //
     /* 112888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112922 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112927 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112933 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112950 */     GIR_RootConstrainSelectedInstOperands,
     /* 112951 */     // GIR_Coverage, 6020,
     /* 112951 */     GIR_EraseRootFromParent_Done,
     /* 112952 */   // Label 2128: @112952
     /* 112952 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112998), // Rule ID 2480 //
     /* 112957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112976 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112981 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112996 */     GIR_RootConstrainSelectedInstOperands,
     /* 112997 */     // GIR_Coverage, 2480,
     /* 112997 */     GIR_EraseRootFromParent_Done,
     /* 112998 */   // Label 2129: @112998
     /* 112998 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(113050), // Rule ID 3989 //
     /* 113003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113022 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 113025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113027 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113029 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113031 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113048 */     GIR_RootConstrainSelectedInstOperands,
     /* 113049 */     // GIR_Coverage, 3989,
     /* 113049 */     GIR_EraseRootFromParent_Done,
     /* 113050 */   // Label 2130: @113050
     /* 113050 */   GIM_Reject,
     /* 113051 */ // Label 2126: @113051
     /* 113051 */ GIM_Reject,
     /* 113052 */ // Label 2092: @113052
     /* 113052 */ GIM_Reject,
     /* 113053 */ // Label 37: @113053
     /* 113053 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2134*/ GIMT_Encode4(113217),
     /* 113064 */ /*GILLT_s16*//*Label 2131*/ GIMT_Encode4(113076),
     /* 113068 */ /*GILLT_s32*//*Label 2132*/ GIMT_Encode4(113123),
     /* 113072 */ /*GILLT_s64*//*Label 2133*/ GIMT_Encode4(113170),
     /* 113076 */ // Label 2131: @113076
     /* 113076 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(113122), // Rule ID 620 //
     /* 113081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113102 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113107 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113109 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113114 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113120 */   GIR_RootConstrainSelectedInstOperands,
     /* 113121 */   // GIR_Coverage, 620,
     /* 113121 */   GIR_EraseRootFromParent_Done,
     /* 113122 */ // Label 2135: @113122
     /* 113122 */ GIM_Reject,
     /* 113123 */ // Label 2132: @113123
     /* 113123 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113169), // Rule ID 619 //
     /* 113128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113149 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113154 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113156 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113161 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113167 */   GIR_RootConstrainSelectedInstOperands,
     /* 113168 */   // GIR_Coverage, 619,
     /* 113168 */   GIR_EraseRootFromParent_Done,
     /* 113169 */ // Label 2136: @113169
     /* 113169 */ GIM_Reject,
     /* 113170 */ // Label 2133: @113170
     /* 113170 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113216), // Rule ID 618 //
     /* 113175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113196 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113201 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113203 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113208 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113214 */   GIR_RootConstrainSelectedInstOperands,
     /* 113215 */   // GIR_Coverage, 618,
     /* 113215 */   GIR_EraseRootFromParent_Done,
     /* 113216 */ // Label 2137: @113216
     /* 113216 */ GIM_Reject,
     /* 113217 */ // Label 2134: @113217
     /* 113217 */ GIM_Reject,
     /* 113218 */ // Label 38: @113218
     /* 113218 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2145*/ GIMT_Encode4(114748),
     /* 113229 */ /*GILLT_s16*//*Label 2138*/ GIMT_Encode4(113281),
     /* 113233 */ /*GILLT_s32*//*Label 2139*/ GIMT_Encode4(113628),
     /* 113237 */ /*GILLT_s64*//*Label 2140*/ GIMT_Encode4(114127), GIMT_Encode4(0),
     /* 113245 */ /*GILLT_v2s32*//*Label 2141*/ GIMT_Encode4(114474), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113257 */ /*GILLT_v4s16*//*Label 2142*/ GIMT_Encode4(114512),
     /* 113261 */ /*GILLT_v4s32*//*Label 2143*/ GIMT_Encode4(114550), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113277 */ /*GILLT_v8s16*//*Label 2144*/ GIMT_Encode4(114649),
     /* 113281 */ // Label 2138: @113281
     /* 113281 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113627),
     /* 113286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113293 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113378), // Rule ID 2394 //
     /* 113298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113317 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113350 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113376 */     GIR_RootConstrainSelectedInstOperands,
     /* 113377 */     // GIR_Coverage, 2394,
     /* 113377 */     GIR_EraseRootFromParent_Done,
     /* 113378 */   // Label 2147: @113378
     /* 113378 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113463), // Rule ID 5702 //
     /* 113383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113435 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113461 */     GIR_RootConstrainSelectedInstOperands,
     /* 113462 */     // GIR_Coverage, 5702,
     /* 113462 */     GIR_EraseRootFromParent_Done,
     /* 113463 */   // Label 2148: @113463
     /* 113463 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113536), // Rule ID 2383 //
     /* 113468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113508 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113534 */     GIR_RootConstrainSelectedInstOperands,
     /* 113535 */     // GIR_Coverage, 2383,
     /* 113535 */     GIR_EraseRootFromParent_Done,
     /* 113536 */   // Label 2149: @113536
     /* 113536 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113596), // Rule ID 626 //
     /* 113541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113572 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113594 */     GIR_RootConstrainSelectedInstOperands,
     /* 113595 */     // GIR_Coverage, 626,
     /* 113595 */     GIR_EraseRootFromParent_Done,
     /* 113596 */   // Label 2150: @113596
     /* 113596 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113626), // Rule ID 664 //
     /* 113601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113608 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113624 */     GIR_RootConstrainSelectedInstOperands,
     /* 113625 */     // GIR_Coverage, 664,
     /* 113625 */     GIR_EraseRootFromParent_Done,
     /* 113626 */   // Label 2151: @113626
     /* 113626 */   GIM_Reject,
     /* 113627 */ // Label 2146: @113627
     /* 113627 */ GIM_Reject,
     /* 113628 */ // Label 2139: @113628
     /* 113628 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114126),
     /* 113633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113640 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113725), // Rule ID 2393 //
     /* 113645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113697 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113723 */     GIR_RootConstrainSelectedInstOperands,
     /* 113724 */     // GIR_Coverage, 2393,
     /* 113724 */     GIR_EraseRootFromParent_Done,
     /* 113725 */   // Label 2153: @113725
     /* 113725 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113810), // Rule ID 5701 //
     /* 113730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113782 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113808 */     GIR_RootConstrainSelectedInstOperands,
     /* 113809 */     // GIR_Coverage, 5701,
     /* 113809 */     GIR_EraseRootFromParent_Done,
     /* 113810 */   // Label 2154: @113810
     /* 113810 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113883), // Rule ID 2382 //
     /* 113815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113834 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113855 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113881 */     GIR_RootConstrainSelectedInstOperands,
     /* 113882 */     // GIR_Coverage, 2382,
     /* 113882 */     GIR_EraseRootFromParent_Done,
     /* 113883 */   // Label 2155: @113883
     /* 113883 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113943), // Rule ID 625 //
     /* 113888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113919 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113941 */     GIR_RootConstrainSelectedInstOperands,
     /* 113942 */     // GIR_Coverage, 625,
     /* 113942 */     GIR_EraseRootFromParent_Done,
     /* 113943 */   // Label 2156: @113943
     /* 113943 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113973), // Rule ID 663 //
     /* 113948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113955 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113971 */     GIR_RootConstrainSelectedInstOperands,
     /* 113972 */     // GIR_Coverage, 663,
     /* 113972 */     GIR_EraseRootFromParent_Done,
     /* 113973 */   // Label 2157: @113973
     /* 113973 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114125), // Rule ID 2685 //
     /* 113978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113985 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113985 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113988 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113992 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 113999 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 114002 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114006 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114011 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 114014 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114019 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 114022 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 114026 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114031 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114034 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114038 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114041 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114046 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114051 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114068 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114071 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114074 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114094 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114107 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114124 */     // GIR_Coverage, 2685,
     /* 114124 */     GIR_EraseRootFromParent_Done,
     /* 114125 */   // Label 2158: @114125
     /* 114125 */   GIM_Reject,
     /* 114126 */ // Label 2152: @114126
     /* 114126 */ GIM_Reject,
     /* 114127 */ // Label 2140: @114127
     /* 114127 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114473),
     /* 114132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114139 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114224), // Rule ID 2392 //
     /* 114144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114163 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114196 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114222 */     GIR_RootConstrainSelectedInstOperands,
     /* 114223 */     // GIR_Coverage, 2392,
     /* 114223 */     GIR_EraseRootFromParent_Done,
     /* 114224 */   // Label 2160: @114224
     /* 114224 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114309), // Rule ID 5700 //
     /* 114229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114281 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114307 */     GIR_RootConstrainSelectedInstOperands,
     /* 114308 */     // GIR_Coverage, 5700,
     /* 114308 */     GIR_EraseRootFromParent_Done,
     /* 114309 */   // Label 2161: @114309
     /* 114309 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114382), // Rule ID 2381 //
     /* 114314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114354 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114380 */     GIR_RootConstrainSelectedInstOperands,
     /* 114381 */     // GIR_Coverage, 2381,
     /* 114381 */     GIR_EraseRootFromParent_Done,
     /* 114382 */   // Label 2162: @114382
     /* 114382 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(114442), // Rule ID 624 //
     /* 114387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114418 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114440 */     GIR_RootConstrainSelectedInstOperands,
     /* 114441 */     // GIR_Coverage, 624,
     /* 114441 */     GIR_EraseRootFromParent_Done,
     /* 114442 */   // Label 2163: @114442
     /* 114442 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(114472), // Rule ID 662 //
     /* 114447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114454 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114470 */     GIR_RootConstrainSelectedInstOperands,
     /* 114471 */     // GIR_Coverage, 662,
     /* 114471 */     GIR_EraseRootFromParent_Done,
     /* 114472 */   // Label 2164: @114472
     /* 114472 */   GIM_Reject,
     /* 114473 */ // Label 2159: @114473
     /* 114473 */ GIM_Reject,
     /* 114474 */ // Label 2141: @114474
     /* 114474 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114511), // Rule ID 1527 //
     /* 114479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114493 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114498 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114509 */   GIR_RootConstrainSelectedInstOperands,
     /* 114510 */   // GIR_Coverage, 1527,
     /* 114510 */   GIR_EraseRootFromParent_Done,
     /* 114511 */ // Label 2165: @114511
     /* 114511 */ GIM_Reject,
     /* 114512 */ // Label 2142: @114512
     /* 114512 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114549), // Rule ID 1529 //
     /* 114517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114531 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114536 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114541 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114547 */   GIR_RootConstrainSelectedInstOperands,
     /* 114548 */   // GIR_Coverage, 1529,
     /* 114548 */   GIR_EraseRootFromParent_Done,
     /* 114549 */ // Label 2166: @114549
     /* 114549 */ GIM_Reject,
     /* 114550 */ // Label 2143: @114550
     /* 114550 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114648),
     /* 114555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114558 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114592), // Rule ID 1528 //
     /* 114563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114574 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114590 */     GIR_RootConstrainSelectedInstOperands,
     /* 114591 */     // GIR_Coverage, 1528,
     /* 114591 */     GIR_EraseRootFromParent_Done,
     /* 114592 */   // Label 2168: @114592
     /* 114592 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114647), // Rule ID 4096 //
     /* 114597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114608 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114625 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114645 */     GIR_RootConstrainSelectedInstOperands,
     /* 114646 */     // GIR_Coverage, 4096,
     /* 114646 */     GIR_EraseRootFromParent_Done,
     /* 114647 */   // Label 2169: @114647
     /* 114647 */   GIM_Reject,
     /* 114648 */ // Label 2167: @114648
     /* 114648 */ GIM_Reject,
     /* 114649 */ // Label 2144: @114649
     /* 114649 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114747),
     /* 114654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114657 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114691), // Rule ID 1530 //
     /* 114662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114673 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114689 */     GIR_RootConstrainSelectedInstOperands,
     /* 114690 */     // GIR_Coverage, 1530,
     /* 114690 */     GIR_EraseRootFromParent_Done,
     /* 114691 */   // Label 2171: @114691
     /* 114691 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114746), // Rule ID 4094 //
     /* 114696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114707 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114724 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114744 */     GIR_RootConstrainSelectedInstOperands,
     /* 114745 */     // GIR_Coverage, 4094,
     /* 114745 */     GIR_EraseRootFromParent_Done,
     /* 114746 */   // Label 2172: @114746
     /* 114746 */   GIM_Reject,
     /* 114747 */ // Label 2170: @114747
     /* 114747 */ GIM_Reject,
     /* 114748 */ // Label 2145: @114748
     /* 114748 */ GIM_Reject,
     /* 114749 */ // Label 39: @114749
     /* 114749 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2176*/ GIMT_Encode4(114984),
     /* 114760 */ /*GILLT_s32*//*Label 2173*/ GIMT_Encode4(114792),
     /* 114764 */ /*GILLT_s64*//*Label 2174*/ GIMT_Encode4(114852), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114788 */ /*GILLT_v4s32*//*Label 2175*/ GIMT_Encode4(114949),
     /* 114792 */ // Label 2173: @114792
     /* 114792 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114851), // Rule ID 2283 //
     /* 114797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114811 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114843 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114849 */   GIR_RootConstrainSelectedInstOperands,
     /* 114850 */   // GIR_Coverage, 2283,
     /* 114850 */   GIR_EraseRootFromParent_Done,
     /* 114851 */ // Label 2177: @114851
     /* 114851 */ GIM_Reject,
     /* 114852 */ // Label 2174: @114852
     /* 114852 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114889), // Rule ID 660 //
     /* 114857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114871 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114876 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114881 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114887 */   GIR_RootConstrainSelectedInstOperands,
     /* 114888 */   // GIR_Coverage, 660,
     /* 114888 */   GIR_EraseRootFromParent_Done,
     /* 114889 */ // Label 2178: @114889
     /* 114889 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114948), // Rule ID 2293 //
     /* 114894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114908 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114920 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114946 */   GIR_RootConstrainSelectedInstOperands,
     /* 114947 */   // GIR_Coverage, 2293,
     /* 114947 */   GIR_EraseRootFromParent_Done,
     /* 114948 */ // Label 2179: @114948
     /* 114948 */ GIM_Reject,
     /* 114949 */ // Label 2175: @114949
     /* 114949 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114983), // Rule ID 2650 //
     /* 114954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114965 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114970 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114975 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114981 */   GIR_RootConstrainSelectedInstOperands,
     /* 114982 */   // GIR_Coverage, 2650,
     /* 114982 */   GIR_EraseRootFromParent_Done,
     /* 114983 */ // Label 2180: @114983
     /* 114983 */ GIM_Reject,
     /* 114984 */ // Label 2176: @114984
     /* 114984 */ GIM_Reject,
     /* 114985 */ // Label 40: @114985
     /* 114985 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2184*/ GIMT_Encode4(115256),
     /* 114996 */ /*GILLT_s16*//*Label 2181*/ GIMT_Encode4(115028),
     /* 115000 */ /*GILLT_s32*//*Label 2182*/ GIMT_Encode4(115183), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115024 */ /*GILLT_v4s16*//*Label 2183*/ GIMT_Encode4(115221),
     /* 115028 */ // Label 2181: @115028
     /* 115028 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115105), // Rule ID 2285 //
     /* 115033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115047 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115047 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115050 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115054 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115073 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115076 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115080 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115083 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115104 */   // GIR_Coverage, 2285,
     /* 115104 */   GIR_EraseRootFromParent_Done,
     /* 115105 */ // Label 2185: @115105
     /* 115105 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115182), // Rule ID 2295 //
     /* 115110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115124 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115124 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115127 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115131 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115150 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115153 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115157 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115160 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115181 */   // GIR_Coverage, 2295,
     /* 115181 */   GIR_EraseRootFromParent_Done,
     /* 115182 */ // Label 2186: @115182
     /* 115182 */ GIM_Reject,
     /* 115183 */ // Label 2182: @115183
     /* 115183 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115220), // Rule ID 661 //
     /* 115188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115202 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115207 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115212 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115218 */   GIR_RootConstrainSelectedInstOperands,
     /* 115219 */   // GIR_Coverage, 661,
     /* 115219 */   GIR_EraseRootFromParent_Done,
     /* 115220 */ // Label 2187: @115220
     /* 115220 */ GIM_Reject,
     /* 115221 */ // Label 2183: @115221
     /* 115221 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115255), // Rule ID 2649 //
     /* 115226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115237 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115247 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115253 */   GIR_RootConstrainSelectedInstOperands,
     /* 115254 */   // GIR_Coverage, 2649,
     /* 115254 */   GIR_EraseRootFromParent_Done,
     /* 115255 */ // Label 2188: @115255
     /* 115255 */ GIM_Reject,
     /* 115256 */ // Label 2184: @115256
     /* 115256 */ GIM_Reject,
     /* 115257 */ // Label 41: @115257
     /* 115257 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2196*/ GIMT_Encode4(116590),
     /* 115268 */ /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(115316), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115280 */ /*GILLT_v2s32*//*Label 2190*/ GIMT_Encode4(116210), GIMT_Encode4(0),
     /* 115288 */ /*GILLT_v4s1*//*Label 2191*/ GIMT_Encode4(116248),
     /* 115292 */ /*GILLT_v4s16*//*Label 2192*/ GIMT_Encode4(116301),
     /* 115296 */ /*GILLT_v4s32*//*Label 2193*/ GIMT_Encode4(116339), GIMT_Encode4(0),
     /* 115304 */ /*GILLT_v8s1*//*Label 2194*/ GIMT_Encode4(116438), GIMT_Encode4(0),
     /* 115312 */ /*GILLT_v8s16*//*Label 2195*/ GIMT_Encode4(116491),
     /* 115316 */ // Label 2189: @115316
     /* 115316 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(115382), // Rule ID 2303 //
     /* 115321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115343 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115350 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115381 */   // GIR_Coverage, 2303,
     /* 115381 */   GIR_EraseRootFromParent_Done,
     /* 115382 */ // Label 2197: @115382
     /* 115382 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(115448), // Rule ID 2305 //
     /* 115387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115405 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115409 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115416 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115428 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115447 */   // GIR_Coverage, 2305,
     /* 115447 */   GIR_EraseRootFromParent_Done,
     /* 115448 */ // Label 2198: @115448
     /* 115448 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(115514), // Rule ID 2307 //
     /* 115453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115482 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115513 */   // GIR_Coverage, 2307,
     /* 115513 */   GIR_EraseRootFromParent_Done,
     /* 115514 */ // Label 2199: @115514
     /* 115514 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(115580), // Rule ID 2309 //
     /* 115519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115529 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115537 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115548 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115579 */   // GIR_Coverage, 2309,
     /* 115579 */   GIR_EraseRootFromParent_Done,
     /* 115580 */ // Label 2200: @115580
     /* 115580 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(115646), // Rule ID 2311 //
     /* 115585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115603 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115614 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115626 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115645 */   // GIR_Coverage, 2311,
     /* 115645 */   GIR_EraseRootFromParent_Done,
     /* 115646 */ // Label 2201: @115646
     /* 115646 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(115712), // Rule ID 2313 //
     /* 115651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115669 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115680 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115692 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115711 */   // GIR_Coverage, 2313,
     /* 115711 */   GIR_EraseRootFromParent_Done,
     /* 115712 */ // Label 2202: @115712
     /* 115712 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(115778), // Rule ID 2297 //
     /* 115717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115739 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115746 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115758 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115777 */   // GIR_Coverage, 2297,
     /* 115777 */   GIR_EraseRootFromParent_Done,
     /* 115778 */ // Label 2203: @115778
     /* 115778 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(115844), // Rule ID 2299 //
     /* 115783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115810 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115812 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115824 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115843 */   // GIR_Coverage, 2299,
     /* 115843 */   GIR_EraseRootFromParent_Done,
     /* 115844 */ // Label 2204: @115844
     /* 115844 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115910), // Rule ID 2301 //
     /* 115849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115867 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115871 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115876 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115878 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115909 */   // GIR_Coverage, 2301,
     /* 115909 */   GIR_EraseRootFromParent_Done,
     /* 115910 */ // Label 2205: @115910
     /* 115910 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115970), // Rule ID 2332 //
     /* 115915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115929 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115945 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115948 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115969 */   // GIR_Coverage, 2332,
     /* 115969 */   GIR_EraseRootFromParent_Done,
     /* 115970 */ // Label 2206: @115970
     /* 115970 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(116030), // Rule ID 2336 //
     /* 115975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115989 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116005 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116008 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116029 */   // GIR_Coverage, 2336,
     /* 116029 */   GIR_EraseRootFromParent_Done,
     /* 116030 */ // Label 2207: @116030
     /* 116030 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(116090), // Rule ID 2340 //
     /* 116035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116049 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116061 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116065 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116068 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116089 */   // GIR_Coverage, 2340,
     /* 116089 */   GIR_EraseRootFromParent_Done,
     /* 116090 */ // Label 2208: @116090
     /* 116090 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(116209), // Rule ID 2690 //
     /* 116095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116109 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116109 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116112 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116116 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116123 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116126 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116130 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116135 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116138 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116142 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116145 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116150 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116155 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116172 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116175 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116178 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116191 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116208 */   // GIR_Coverage, 2690,
     /* 116208 */   GIR_EraseRootFromParent_Done,
     /* 116209 */ // Label 2209: @116209
     /* 116209 */ GIM_Reject,
     /* 116210 */ // Label 2190: @116210
     /* 116210 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(116247), // Rule ID 1601 //
     /* 116215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116229 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116234 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116239 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116245 */   GIR_RootConstrainSelectedInstOperands,
     /* 116246 */   // GIR_Coverage, 1601,
     /* 116246 */   GIR_EraseRootFromParent_Done,
     /* 116247 */ // Label 2210: @116247
     /* 116247 */ GIM_Reject,
     /* 116248 */ // Label 2191: @116248
     /* 116248 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(116300), // Rule ID 5085 //
     /* 116253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116267 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116272 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116286 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116292 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116298 */   GIR_RootConstrainSelectedInstOperands,
     /* 116299 */   // GIR_Coverage, 5085,
     /* 116299 */   GIR_EraseRootFromParent_Done,
     /* 116300 */ // Label 2211: @116300
     /* 116300 */ GIM_Reject,
     /* 116301 */ // Label 2192: @116301
     /* 116301 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(116338), // Rule ID 1609 //
     /* 116306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116320 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116336 */   GIR_RootConstrainSelectedInstOperands,
     /* 116337 */   // GIR_Coverage, 1609,
     /* 116337 */   GIR_EraseRootFromParent_Done,
     /* 116338 */ // Label 2212: @116338
     /* 116338 */ GIM_Reject,
     /* 116339 */ // Label 2193: @116339
     /* 116339 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(116437),
     /* 116344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116347 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(116381), // Rule ID 1605 //
     /* 116352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116363 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116379 */     GIR_RootConstrainSelectedInstOperands,
     /* 116380 */     // GIR_Coverage, 1605,
     /* 116380 */     GIR_EraseRootFromParent_Done,
     /* 116381 */   // Label 2214: @116381
     /* 116381 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116436), // Rule ID 4074 //
     /* 116386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116397 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116434 */     GIR_RootConstrainSelectedInstOperands,
     /* 116435 */     // GIR_Coverage, 4074,
     /* 116435 */     GIR_EraseRootFromParent_Done,
     /* 116436 */   // Label 2215: @116436
     /* 116436 */   GIM_Reject,
     /* 116437 */ // Label 2213: @116437
     /* 116437 */ GIM_Reject,
     /* 116438 */ // Label 2194: @116438
     /* 116438 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116490), // Rule ID 5086 //
     /* 116443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116457 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116462 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116488 */   GIR_RootConstrainSelectedInstOperands,
     /* 116489 */   // GIR_Coverage, 5086,
     /* 116489 */   GIR_EraseRootFromParent_Done,
     /* 116490 */ // Label 2216: @116490
     /* 116490 */ GIM_Reject,
     /* 116491 */ // Label 2195: @116491
     /* 116491 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116589),
     /* 116496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116499 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116533), // Rule ID 1613 //
     /* 116504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116515 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116531 */     GIR_RootConstrainSelectedInstOperands,
     /* 116532 */     // GIR_Coverage, 1613,
     /* 116532 */     GIR_EraseRootFromParent_Done,
     /* 116533 */   // Label 2218: @116533
     /* 116533 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116588), // Rule ID 4070 //
     /* 116538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116549 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116586 */     GIR_RootConstrainSelectedInstOperands,
     /* 116587 */     // GIR_Coverage, 4070,
     /* 116587 */     GIR_EraseRootFromParent_Done,
     /* 116588 */   // Label 2219: @116588
     /* 116588 */   GIM_Reject,
     /* 116589 */ // Label 2217: @116589
     /* 116589 */ GIM_Reject,
     /* 116590 */ // Label 2196: @116590
     /* 116590 */ GIM_Reject,
     /* 116591 */ // Label 42: @116591
     /* 116591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2227*/ GIMT_Encode4(117924),
     /* 116602 */ /*GILLT_s32*//*Label 2220*/ GIMT_Encode4(116650), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116614 */ /*GILLT_v2s32*//*Label 2221*/ GIMT_Encode4(117544), GIMT_Encode4(0),
     /* 116622 */ /*GILLT_v4s1*//*Label 2222*/ GIMT_Encode4(117582),
     /* 116626 */ /*GILLT_v4s16*//*Label 2223*/ GIMT_Encode4(117635),
     /* 116630 */ /*GILLT_v4s32*//*Label 2224*/ GIMT_Encode4(117673), GIMT_Encode4(0),
     /* 116638 */ /*GILLT_v8s1*//*Label 2225*/ GIMT_Encode4(117772), GIMT_Encode4(0),
     /* 116646 */ /*GILLT_v8s16*//*Label 2226*/ GIMT_Encode4(117825),
     /* 116650 */ // Label 2220: @116650
     /* 116650 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(116716), // Rule ID 2304 //
     /* 116655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116665 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116669 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116673 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116677 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116684 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116696 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116715 */   // GIR_Coverage, 2304,
     /* 116715 */   GIR_EraseRootFromParent_Done,
     /* 116716 */ // Label 2228: @116716
     /* 116716 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(116782), // Rule ID 2306 //
     /* 116721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116739 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116750 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116762 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116781 */   // GIR_Coverage, 2306,
     /* 116781 */   GIR_EraseRootFromParent_Done,
     /* 116782 */ // Label 2229: @116782
     /* 116782 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(116848), // Rule ID 2308 //
     /* 116787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116805 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116809 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116816 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116828 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116847 */   // GIR_Coverage, 2308,
     /* 116847 */   GIR_EraseRootFromParent_Done,
     /* 116848 */ // Label 2230: @116848
     /* 116848 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(116914), // Rule ID 2310 //
     /* 116853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116871 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116875 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116882 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116894 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116913 */   // GIR_Coverage, 2310,
     /* 116913 */   GIR_EraseRootFromParent_Done,
     /* 116914 */ // Label 2231: @116914
     /* 116914 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(116980), // Rule ID 2312 //
     /* 116919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116937 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116941 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116948 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116960 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116979 */   // GIR_Coverage, 2312,
     /* 116979 */   GIR_EraseRootFromParent_Done,
     /* 116980 */ // Label 2232: @116980
     /* 116980 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(117046), // Rule ID 2314 //
     /* 116985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117003 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117014 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 117021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117026 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117045 */   // GIR_Coverage, 2314,
     /* 117045 */   GIR_EraseRootFromParent_Done,
     /* 117046 */ // Label 2233: @117046
     /* 117046 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(117112), // Rule ID 2298 //
     /* 117051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117069 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117073 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117080 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117092 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117111 */   // GIR_Coverage, 2298,
     /* 117111 */   GIR_EraseRootFromParent_Done,
     /* 117112 */ // Label 2234: @117112
     /* 117112 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(117178), // Rule ID 2300 //
     /* 117117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117139 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117146 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117158 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117177 */   // GIR_Coverage, 2300,
     /* 117177 */   GIR_EraseRootFromParent_Done,
     /* 117178 */ // Label 2235: @117178
     /* 117178 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(117244), // Rule ID 2302 //
     /* 117183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117201 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117205 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117212 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117224 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117243 */   // GIR_Coverage, 2302,
     /* 117243 */   GIR_EraseRootFromParent_Done,
     /* 117244 */ // Label 2236: @117244
     /* 117244 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(117304), // Rule ID 2342 //
     /* 117249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117263 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117279 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117282 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117303 */   // GIR_Coverage, 2342,
     /* 117303 */   GIR_EraseRootFromParent_Done,
     /* 117304 */ // Label 2237: @117304
     /* 117304 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(117364), // Rule ID 2346 //
     /* 117309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117323 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117335 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117363 */   // GIR_Coverage, 2346,
     /* 117363 */   GIR_EraseRootFromParent_Done,
     /* 117364 */ // Label 2238: @117364
     /* 117364 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(117424), // Rule ID 2350 //
     /* 117369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117383 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117395 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117399 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117402 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117423 */   // GIR_Coverage, 2350,
     /* 117423 */   GIR_EraseRootFromParent_Done,
     /* 117424 */ // Label 2239: @117424
     /* 117424 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(117543), // Rule ID 2691 //
     /* 117429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117443 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117443 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117446 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117450 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117457 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117460 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117464 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117469 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117472 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117476 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117484 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117509 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117512 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117525 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117542 */   // GIR_Coverage, 2691,
     /* 117542 */   GIR_EraseRootFromParent_Done,
     /* 117543 */ // Label 2240: @117543
     /* 117543 */ GIM_Reject,
     /* 117544 */ // Label 2221: @117544
     /* 117544 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117581), // Rule ID 1602 //
     /* 117549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117563 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117568 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117573 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117579 */   GIR_RootConstrainSelectedInstOperands,
     /* 117580 */   // GIR_Coverage, 1602,
     /* 117580 */   GIR_EraseRootFromParent_Done,
     /* 117581 */ // Label 2241: @117581
     /* 117581 */ GIM_Reject,
     /* 117582 */ // Label 2222: @117582
     /* 117582 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117634), // Rule ID 5083 //
     /* 117587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117601 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117606 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117608 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117620 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117626 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117632 */   GIR_RootConstrainSelectedInstOperands,
     /* 117633 */   // GIR_Coverage, 5083,
     /* 117633 */   GIR_EraseRootFromParent_Done,
     /* 117634 */ // Label 2242: @117634
     /* 117634 */ GIM_Reject,
     /* 117635 */ // Label 2223: @117635
     /* 117635 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117672), // Rule ID 1610 //
     /* 117640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117654 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117659 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117664 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117670 */   GIR_RootConstrainSelectedInstOperands,
     /* 117671 */   // GIR_Coverage, 1610,
     /* 117671 */   GIR_EraseRootFromParent_Done,
     /* 117672 */ // Label 2243: @117672
     /* 117672 */ GIM_Reject,
     /* 117673 */ // Label 2224: @117673
     /* 117673 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117771),
     /* 117678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117681 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117715), // Rule ID 1606 //
     /* 117686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117697 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117713 */     GIR_RootConstrainSelectedInstOperands,
     /* 117714 */     // GIR_Coverage, 1606,
     /* 117714 */     GIR_EraseRootFromParent_Done,
     /* 117715 */   // Label 2245: @117715
     /* 117715 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117770), // Rule ID 4076 //
     /* 117720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117731 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117768 */     GIR_RootConstrainSelectedInstOperands,
     /* 117769 */     // GIR_Coverage, 4076,
     /* 117769 */     GIR_EraseRootFromParent_Done,
     /* 117770 */   // Label 2246: @117770
     /* 117770 */   GIM_Reject,
     /* 117771 */ // Label 2244: @117771
     /* 117771 */ GIM_Reject,
     /* 117772 */ // Label 2225: @117772
     /* 117772 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117824), // Rule ID 5084 //
     /* 117777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117791 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117796 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117810 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117816 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117822 */   GIR_RootConstrainSelectedInstOperands,
     /* 117823 */   // GIR_Coverage, 5084,
     /* 117823 */   GIR_EraseRootFromParent_Done,
     /* 117824 */ // Label 2247: @117824
     /* 117824 */ GIM_Reject,
     /* 117825 */ // Label 2226: @117825
     /* 117825 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117923),
     /* 117830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117833 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117867), // Rule ID 1614 //
     /* 117838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117849 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117865 */     GIR_RootConstrainSelectedInstOperands,
     /* 117866 */     // GIR_Coverage, 1614,
     /* 117866 */     GIR_EraseRootFromParent_Done,
     /* 117867 */   // Label 2249: @117867
     /* 117867 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117922), // Rule ID 4072 //
     /* 117872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117883 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117920 */     GIR_RootConstrainSelectedInstOperands,
     /* 117921 */     // GIR_Coverage, 4072,
     /* 117921 */     GIR_EraseRootFromParent_Done,
     /* 117922 */   // Label 2250: @117922
     /* 117922 */   GIM_Reject,
     /* 117923 */ // Label 2248: @117923
     /* 117923 */ GIM_Reject,
     /* 117924 */ // Label 2227: @117924
     /* 117924 */ GIM_Reject,
     /* 117925 */ // Label 43: @117925
     /* 117925 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2258*/ GIMT_Encode4(118576),
     /* 117936 */ /*GILLT_s16*//*Label 2251*/ GIMT_Encode4(117988),
     /* 117940 */ /*GILLT_s32*//*Label 2252*/ GIMT_Encode4(118048),
     /* 117944 */ /*GILLT_s64*//*Label 2253*/ GIMT_Encode4(118242), GIMT_Encode4(0),
     /* 117952 */ /*GILLT_v2s32*//*Label 2254*/ GIMT_Encode4(118302), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117964 */ /*GILLT_v4s16*//*Label 2255*/ GIMT_Encode4(118340),
     /* 117968 */ /*GILLT_v4s32*//*Label 2256*/ GIMT_Encode4(118378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117984 */ /*GILLT_v8s16*//*Label 2257*/ GIMT_Encode4(118477),
     /* 117988 */ // Label 2251: @117988
     /* 117988 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(118047), // Rule ID 2326 //
     /* 117993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118007 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118039 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118045 */   GIR_RootConstrainSelectedInstOperands,
     /* 118046 */   // GIR_Coverage, 2326,
     /* 118046 */   GIR_EraseRootFromParent_Done,
     /* 118047 */ // Label 2259: @118047
     /* 118047 */ GIM_Reject,
     /* 118048 */ // Label 2252: @118048
     /* 118048 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(118241),
     /* 118053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118064 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(118112), // Rule ID 2324 //
     /* 118069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118072 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118110 */     GIR_RootConstrainSelectedInstOperands,
     /* 118111 */     // GIR_Coverage, 2324,
     /* 118111 */     GIR_EraseRootFromParent_Done,
     /* 118112 */   // Label 2261: @118112
     /* 118112 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(118240), // Rule ID 2692 //
     /* 118117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118120 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118120 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118123 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118127 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118132 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118136 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118141 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118144 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118148 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118155 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118158 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118162 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118167 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118170 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118209 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118222 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118239 */     // GIR_Coverage, 2692,
     /* 118239 */     GIR_EraseRootFromParent_Done,
     /* 118240 */   // Label 2262: @118240
     /* 118240 */   GIM_Reject,
     /* 118241 */ // Label 2260: @118241
     /* 118241 */ GIM_Reject,
     /* 118242 */ // Label 2253: @118242
     /* 118242 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(118301), // Rule ID 2322 //
     /* 118247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118261 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118273 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118293 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118299 */   GIR_RootConstrainSelectedInstOperands,
     /* 118300 */   // GIR_Coverage, 2322,
     /* 118300 */   GIR_EraseRootFromParent_Done,
     /* 118301 */ // Label 2263: @118301
     /* 118301 */ GIM_Reject,
     /* 118302 */ // Label 2254: @118302
     /* 118302 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(118339), // Rule ID 1603 //
     /* 118307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118321 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118326 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118331 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118337 */   GIR_RootConstrainSelectedInstOperands,
     /* 118338 */   // GIR_Coverage, 1603,
     /* 118338 */   GIR_EraseRootFromParent_Done,
     /* 118339 */ // Label 2264: @118339
     /* 118339 */ GIM_Reject,
     /* 118340 */ // Label 2255: @118340
     /* 118340 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(118377), // Rule ID 1611 //
     /* 118345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118359 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118364 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118375 */   GIR_RootConstrainSelectedInstOperands,
     /* 118376 */   // GIR_Coverage, 1611,
     /* 118376 */   GIR_EraseRootFromParent_Done,
     /* 118377 */ // Label 2265: @118377
     /* 118377 */ GIM_Reject,
     /* 118378 */ // Label 2256: @118378
     /* 118378 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(118476),
     /* 118383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118386 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(118420), // Rule ID 1607 //
     /* 118391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118402 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118418 */     GIR_RootConstrainSelectedInstOperands,
     /* 118419 */     // GIR_Coverage, 1607,
     /* 118419 */     GIR_EraseRootFromParent_Done,
     /* 118420 */   // Label 2267: @118420
     /* 118420 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118475), // Rule ID 4082 //
     /* 118425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118436 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118473 */     GIR_RootConstrainSelectedInstOperands,
     /* 118474 */     // GIR_Coverage, 4082,
     /* 118474 */     GIR_EraseRootFromParent_Done,
     /* 118475 */   // Label 2268: @118475
     /* 118475 */   GIM_Reject,
     /* 118476 */ // Label 2266: @118476
     /* 118476 */ GIM_Reject,
     /* 118477 */ // Label 2257: @118477
     /* 118477 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118575),
     /* 118482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118485 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118519), // Rule ID 1615 //
     /* 118490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118501 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118517 */     GIR_RootConstrainSelectedInstOperands,
     /* 118518 */     // GIR_Coverage, 1615,
     /* 118518 */     GIR_EraseRootFromParent_Done,
     /* 118519 */   // Label 2270: @118519
     /* 118519 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118574), // Rule ID 4078 //
     /* 118524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118535 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118572 */     GIR_RootConstrainSelectedInstOperands,
     /* 118573 */     // GIR_Coverage, 4078,
     /* 118573 */     GIR_EraseRootFromParent_Done,
     /* 118574 */   // Label 2271: @118574
     /* 118574 */   GIM_Reject,
     /* 118575 */ // Label 2269: @118575
     /* 118575 */ GIM_Reject,
     /* 118576 */ // Label 2258: @118576
     /* 118576 */ GIM_Reject,
     /* 118577 */ // Label 44: @118577
     /* 118577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2279*/ GIMT_Encode4(119228),
     /* 118588 */ /*GILLT_s16*//*Label 2272*/ GIMT_Encode4(118640),
     /* 118592 */ /*GILLT_s32*//*Label 2273*/ GIMT_Encode4(118700),
     /* 118596 */ /*GILLT_s64*//*Label 2274*/ GIMT_Encode4(118894), GIMT_Encode4(0),
     /* 118604 */ /*GILLT_v2s32*//*Label 2275*/ GIMT_Encode4(118954), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118616 */ /*GILLT_v4s16*//*Label 2276*/ GIMT_Encode4(118992),
     /* 118620 */ /*GILLT_v4s32*//*Label 2277*/ GIMT_Encode4(119030), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118636 */ /*GILLT_v8s16*//*Label 2278*/ GIMT_Encode4(119129),
     /* 118640 */ // Label 2272: @118640
     /* 118640 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(118699), // Rule ID 2331 //
     /* 118645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118659 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118691 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118697 */   GIR_RootConstrainSelectedInstOperands,
     /* 118698 */   // GIR_Coverage, 2331,
     /* 118698 */   GIR_EraseRootFromParent_Done,
     /* 118699 */ // Label 2280: @118699
     /* 118699 */ GIM_Reject,
     /* 118700 */ // Label 2273: @118700
     /* 118700 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(118893),
     /* 118705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118716 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(118764), // Rule ID 2329 //
     /* 118721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118724 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118762 */     GIR_RootConstrainSelectedInstOperands,
     /* 118763 */     // GIR_Coverage, 2329,
     /* 118763 */     GIR_EraseRootFromParent_Done,
     /* 118764 */   // Label 2282: @118764
     /* 118764 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(118892), // Rule ID 2693 //
     /* 118769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118772 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118772 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118775 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118779 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118784 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118788 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118793 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118796 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118800 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118819 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118825 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118828 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118833 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118838 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118855 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118861 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118874 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118891 */     // GIR_Coverage, 2693,
     /* 118891 */     GIR_EraseRootFromParent_Done,
     /* 118892 */   // Label 2283: @118892
     /* 118892 */   GIM_Reject,
     /* 118893 */ // Label 2281: @118893
     /* 118893 */ GIM_Reject,
     /* 118894 */ // Label 2274: @118894
     /* 118894 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(118953), // Rule ID 2327 //
     /* 118899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118913 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118945 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118951 */   GIR_RootConstrainSelectedInstOperands,
     /* 118952 */   // GIR_Coverage, 2327,
     /* 118952 */   GIR_EraseRootFromParent_Done,
     /* 118953 */ // Label 2284: @118953
     /* 118953 */ GIM_Reject,
     /* 118954 */ // Label 2275: @118954
     /* 118954 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(118991), // Rule ID 1604 //
     /* 118959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118973 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118978 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118983 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118989 */   GIR_RootConstrainSelectedInstOperands,
     /* 118990 */   // GIR_Coverage, 1604,
     /* 118990 */   GIR_EraseRootFromParent_Done,
     /* 118991 */ // Label 2285: @118991
     /* 118991 */ GIM_Reject,
     /* 118992 */ // Label 2276: @118992
     /* 118992 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(119029), // Rule ID 1612 //
     /* 118997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119011 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 119011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 119014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119016 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119021 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119027 */   GIR_RootConstrainSelectedInstOperands,
     /* 119028 */   // GIR_Coverage, 1612,
     /* 119028 */   GIR_EraseRootFromParent_Done,
     /* 119029 */ // Label 2286: @119029
     /* 119029 */ GIM_Reject,
     /* 119030 */ // Label 2277: @119030
     /* 119030 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(119128),
     /* 119035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119038 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(119072), // Rule ID 1608 //
     /* 119043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119054 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119070 */     GIR_RootConstrainSelectedInstOperands,
     /* 119071 */     // GIR_Coverage, 1608,
     /* 119071 */     GIR_EraseRootFromParent_Done,
     /* 119072 */   // Label 2288: @119072
     /* 119072 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(119127), // Rule ID 4084 //
     /* 119077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119088 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119125 */     GIR_RootConstrainSelectedInstOperands,
     /* 119126 */     // GIR_Coverage, 4084,
     /* 119126 */     GIR_EraseRootFromParent_Done,
     /* 119127 */   // Label 2289: @119127
     /* 119127 */   GIM_Reject,
     /* 119128 */ // Label 2287: @119128
     /* 119128 */ GIM_Reject,
     /* 119129 */ // Label 2278: @119129
     /* 119129 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(119227),
     /* 119134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119137 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(119171), // Rule ID 1616 //
     /* 119142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119153 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119169 */     GIR_RootConstrainSelectedInstOperands,
     /* 119170 */     // GIR_Coverage, 1616,
     /* 119170 */     GIR_EraseRootFromParent_Done,
     /* 119171 */   // Label 2291: @119171
     /* 119171 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(119226), // Rule ID 4080 //
     /* 119176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119187 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119224 */     GIR_RootConstrainSelectedInstOperands,
     /* 119225 */     // GIR_Coverage, 4080,
     /* 119225 */     GIR_EraseRootFromParent_Done,
     /* 119226 */   // Label 2292: @119226
     /* 119226 */   GIM_Reject,
     /* 119227 */ // Label 2290: @119227
     /* 119227 */ GIM_Reject,
     /* 119228 */ // Label 2279: @119228
     /* 119228 */ GIM_Reject,
     /* 119229 */ // Label 45: @119229
     /* 119229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2300*/ GIMT_Encode4(120004),
     /* 119240 */ /*GILLT_s16*//*Label 2293*/ GIMT_Encode4(119292),
     /* 119244 */ /*GILLT_s32*//*Label 2294*/ GIMT_Encode4(119330),
     /* 119248 */ /*GILLT_s64*//*Label 2295*/ GIMT_Encode4(119522), GIMT_Encode4(0),
     /* 119256 */ /*GILLT_v2s32*//*Label 2296*/ GIMT_Encode4(119560), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119268 */ /*GILLT_v4s16*//*Label 2297*/ GIMT_Encode4(119598),
     /* 119272 */ /*GILLT_v4s32*//*Label 2298*/ GIMT_Encode4(119636), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119288 */ /*GILLT_v8s16*//*Label 2299*/ GIMT_Encode4(119820),
     /* 119292 */ // Label 2293: @119292
     /* 119292 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(119329), // Rule ID 653 //
     /* 119297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119311 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119316 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119327 */   GIR_RootConstrainSelectedInstOperands,
     /* 119328 */   // GIR_Coverage, 653,
     /* 119328 */   GIR_EraseRootFromParent_Done,
     /* 119329 */ // Label 2301: @119329
     /* 119329 */ GIM_Reject,
     /* 119330 */ // Label 2294: @119330
     /* 119330 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(119521),
     /* 119335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119346 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(119372), // Rule ID 652 //
     /* 119351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119354 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119370 */     GIR_RootConstrainSelectedInstOperands,
     /* 119371 */     // GIR_Coverage, 652,
     /* 119371 */     GIR_EraseRootFromParent_Done,
     /* 119372 */   // Label 2303: @119372
     /* 119372 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(119520), // Rule ID 2684 //
     /* 119377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119380 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119380 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119383 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119387 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119394 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119397 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119401 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119406 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119409 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119414 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119417 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119421 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119426 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119429 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119433 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119436 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119441 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119446 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119463 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119466 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119469 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119502 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119519 */     // GIR_Coverage, 2684,
     /* 119519 */     GIR_EraseRootFromParent_Done,
     /* 119520 */   // Label 2304: @119520
     /* 119520 */   GIM_Reject,
     /* 119521 */ // Label 2302: @119521
     /* 119521 */ GIM_Reject,
     /* 119522 */ // Label 2295: @119522
     /* 119522 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(119559), // Rule ID 651 //
     /* 119527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119541 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119546 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119551 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119557 */   GIR_RootConstrainSelectedInstOperands,
     /* 119558 */   // GIR_Coverage, 651,
     /* 119558 */   GIR_EraseRootFromParent_Done,
     /* 119559 */ // Label 2305: @119559
     /* 119559 */ GIM_Reject,
     /* 119560 */ // Label 2296: @119560
     /* 119560 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(119597), // Rule ID 1511 //
     /* 119565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119579 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119589 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119595 */   GIR_RootConstrainSelectedInstOperands,
     /* 119596 */   // GIR_Coverage, 1511,
     /* 119596 */   GIR_EraseRootFromParent_Done,
     /* 119597 */ // Label 2306: @119597
     /* 119597 */ GIM_Reject,
     /* 119598 */ // Label 2297: @119598
     /* 119598 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(119635), // Rule ID 1513 //
     /* 119603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119617 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119627 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119633 */   GIR_RootConstrainSelectedInstOperands,
     /* 119634 */   // GIR_Coverage, 1513,
     /* 119634 */   GIR_EraseRootFromParent_Done,
     /* 119635 */ // Label 2307: @119635
     /* 119635 */ GIM_Reject,
     /* 119636 */ // Label 2298: @119636
     /* 119636 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(119819),
     /* 119641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119644 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119729), // Rule ID 4021 //
     /* 119649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119684 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119727 */     GIR_RootConstrainSelectedInstOperands,
     /* 119728 */     // GIR_Coverage, 4021,
     /* 119728 */     GIR_EraseRootFromParent_Done,
     /* 119729 */   // Label 2309: @119729
     /* 119729 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(119763), // Rule ID 1512 //
     /* 119734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119745 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119761 */     GIR_RootConstrainSelectedInstOperands,
     /* 119762 */     // GIR_Coverage, 1512,
     /* 119762 */     GIR_EraseRootFromParent_Done,
     /* 119763 */   // Label 2310: @119763
     /* 119763 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119818), // Rule ID 4092 //
     /* 119768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119779 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119796 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119816 */     GIR_RootConstrainSelectedInstOperands,
     /* 119817 */     // GIR_Coverage, 4092,
     /* 119817 */     GIR_EraseRootFromParent_Done,
     /* 119818 */   // Label 2311: @119818
     /* 119818 */   GIM_Reject,
     /* 119819 */ // Label 2308: @119819
     /* 119819 */ GIM_Reject,
     /* 119820 */ // Label 2299: @119820
     /* 119820 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(120003),
     /* 119825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119828 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119913), // Rule ID 4020 //
     /* 119833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119868 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119911 */     GIR_RootConstrainSelectedInstOperands,
     /* 119912 */     // GIR_Coverage, 4020,
     /* 119912 */     GIR_EraseRootFromParent_Done,
     /* 119913 */   // Label 2313: @119913
     /* 119913 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119947), // Rule ID 1514 //
     /* 119918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119929 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119945 */     GIR_RootConstrainSelectedInstOperands,
     /* 119946 */     // GIR_Coverage, 1514,
     /* 119946 */     GIR_EraseRootFromParent_Done,
     /* 119947 */   // Label 2314: @119947
     /* 119947 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(120002), // Rule ID 4090 //
     /* 119952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119963 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119980 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120000 */     GIR_RootConstrainSelectedInstOperands,
     /* 120001 */     // GIR_Coverage, 4090,
     /* 120001 */     GIR_EraseRootFromParent_Done,
     /* 120002 */   // Label 2315: @120002
     /* 120002 */   GIM_Reject,
     /* 120003 */ // Label 2312: @120003
     /* 120003 */ GIM_Reject,
     /* 120004 */ // Label 2300: @120004
     /* 120004 */ GIM_Reject,
     /* 120005 */ // Label 46: @120005
     /* 120005 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2323*/ GIMT_Encode4(120596),
     /* 120016 */ /*GILLT_s16*//*Label 2316*/ GIMT_Encode4(120068),
     /* 120020 */ /*GILLT_s32*//*Label 2317*/ GIMT_Encode4(120102),
     /* 120024 */ /*GILLT_s64*//*Label 2318*/ GIMT_Encode4(120136), GIMT_Encode4(0),
     /* 120032 */ /*GILLT_v2s32*//*Label 2319*/ GIMT_Encode4(120170), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120044 */ /*GILLT_v4s16*//*Label 2320*/ GIMT_Encode4(120204),
     /* 120048 */ /*GILLT_v4s32*//*Label 2321*/ GIMT_Encode4(120238), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120064 */ /*GILLT_v8s16*//*Label 2322*/ GIMT_Encode4(120417),
     /* 120068 */ // Label 2316: @120068
     /* 120068 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(120101), // Rule ID 642 //
     /* 120073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120094 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120099 */   GIR_RootConstrainSelectedInstOperands,
     /* 120100 */   // GIR_Coverage, 642,
     /* 120100 */   GIR_Done,
     /* 120101 */ // Label 2324: @120101
     /* 120101 */ GIM_Reject,
     /* 120102 */ // Label 2317: @120102
     /* 120102 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(120135), // Rule ID 643 //
     /* 120107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120128 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120133 */   GIR_RootConstrainSelectedInstOperands,
     /* 120134 */   // GIR_Coverage, 643,
     /* 120134 */   GIR_Done,
     /* 120135 */ // Label 2325: @120135
     /* 120135 */ GIM_Reject,
     /* 120136 */ // Label 2318: @120136
     /* 120136 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(120169), // Rule ID 644 //
     /* 120141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120162 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120167 */   GIR_RootConstrainSelectedInstOperands,
     /* 120168 */   // GIR_Coverage, 644,
     /* 120168 */   GIR_Done,
     /* 120169 */ // Label 2326: @120169
     /* 120169 */ GIM_Reject,
     /* 120170 */ // Label 2319: @120170
     /* 120170 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(120203), // Rule ID 1230 //
     /* 120175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120196 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120201 */   GIR_RootConstrainSelectedInstOperands,
     /* 120202 */   // GIR_Coverage, 1230,
     /* 120202 */   GIR_Done,
     /* 120203 */ // Label 2327: @120203
     /* 120203 */ GIM_Reject,
     /* 120204 */ // Label 2320: @120204
     /* 120204 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(120237), // Rule ID 1232 //
     /* 120209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120230 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120235 */   GIR_RootConstrainSelectedInstOperands,
     /* 120236 */   // GIR_Coverage, 1232,
     /* 120236 */   GIR_Done,
     /* 120237 */ // Label 2328: @120237
     /* 120237 */ GIM_Reject,
     /* 120238 */ // Label 2321: @120238
     /* 120238 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(120416),
     /* 120243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120249 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(120327), // Rule ID 4102 //
     /* 120254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120297 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120325 */     GIR_RootConstrainSelectedInstOperands,
     /* 120326 */     // GIR_Coverage, 4102,
     /* 120326 */     GIR_EraseRootFromParent_Done,
     /* 120327 */   // Label 2330: @120327
     /* 120327 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(120354), // Rule ID 1231 //
     /* 120332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120347 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120352 */     GIR_RootConstrainSelectedInstOperands,
     /* 120353 */     // GIR_Coverage, 1231,
     /* 120353 */     GIR_Done,
     /* 120354 */   // Label 2331: @120354
     /* 120354 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(120415), // Rule ID 3268 //
     /* 120359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120374 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120413 */     GIR_RootConstrainSelectedInstOperands,
     /* 120414 */     // GIR_Coverage, 3268,
     /* 120414 */     GIR_EraseRootFromParent_Done,
     /* 120415 */   // Label 2332: @120415
     /* 120415 */   GIM_Reject,
     /* 120416 */ // Label 2329: @120416
     /* 120416 */ GIM_Reject,
     /* 120417 */ // Label 2322: @120417
     /* 120417 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(120595),
     /* 120422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120428 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120506), // Rule ID 4104 //
     /* 120433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120476 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120504 */     GIR_RootConstrainSelectedInstOperands,
     /* 120505 */     // GIR_Coverage, 4104,
     /* 120505 */     GIR_EraseRootFromParent_Done,
     /* 120506 */   // Label 2334: @120506
     /* 120506 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120533), // Rule ID 1233 //
     /* 120511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120526 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120531 */     GIR_RootConstrainSelectedInstOperands,
     /* 120532 */     // GIR_Coverage, 1233,
     /* 120532 */     GIR_Done,
     /* 120533 */   // Label 2335: @120533
     /* 120533 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120594), // Rule ID 3271 //
     /* 120538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120553 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120592 */     GIR_RootConstrainSelectedInstOperands,
     /* 120593 */     // GIR_Coverage, 3271,
     /* 120593 */     GIR_EraseRootFromParent_Done,
     /* 120594 */   // Label 2336: @120594
     /* 120594 */   GIM_Reject,
     /* 120595 */ // Label 2333: @120595
     /* 120595 */ GIM_Reject,
     /* 120596 */ // Label 2323: @120596
     /* 120596 */ GIM_Reject,
     /* 120597 */ // Label 47: @120597
     /* 120597 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2344*/ GIMT_Encode4(121188),
     /* 120608 */ /*GILLT_s16*//*Label 2337*/ GIMT_Encode4(120660),
     /* 120612 */ /*GILLT_s32*//*Label 2338*/ GIMT_Encode4(120694),
     /* 120616 */ /*GILLT_s64*//*Label 2339*/ GIMT_Encode4(120728), GIMT_Encode4(0),
     /* 120624 */ /*GILLT_v2s32*//*Label 2340*/ GIMT_Encode4(120762), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120636 */ /*GILLT_v4s16*//*Label 2341*/ GIMT_Encode4(120796),
     /* 120640 */ /*GILLT_v4s32*//*Label 2342*/ GIMT_Encode4(120830), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120656 */ /*GILLT_v8s16*//*Label 2343*/ GIMT_Encode4(121009),
     /* 120660 */ // Label 2337: @120660
     /* 120660 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(120693), // Rule ID 639 //
     /* 120665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120686 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120691 */   GIR_RootConstrainSelectedInstOperands,
     /* 120692 */   // GIR_Coverage, 639,
     /* 120692 */   GIR_Done,
     /* 120693 */ // Label 2345: @120693
     /* 120693 */ GIM_Reject,
     /* 120694 */ // Label 2338: @120694
     /* 120694 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(120727), // Rule ID 640 //
     /* 120699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120720 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120725 */   GIR_RootConstrainSelectedInstOperands,
     /* 120726 */   // GIR_Coverage, 640,
     /* 120726 */   GIR_Done,
     /* 120727 */ // Label 2346: @120727
     /* 120727 */ GIM_Reject,
     /* 120728 */ // Label 2339: @120728
     /* 120728 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(120761), // Rule ID 641 //
     /* 120733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120754 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120759 */   GIR_RootConstrainSelectedInstOperands,
     /* 120760 */   // GIR_Coverage, 641,
     /* 120760 */   GIR_Done,
     /* 120761 */ // Label 2347: @120761
     /* 120761 */ GIM_Reject,
     /* 120762 */ // Label 2340: @120762
     /* 120762 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(120795), // Rule ID 1210 //
     /* 120767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120788 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120793 */   GIR_RootConstrainSelectedInstOperands,
     /* 120794 */   // GIR_Coverage, 1210,
     /* 120794 */   GIR_Done,
     /* 120795 */ // Label 2348: @120795
     /* 120795 */ GIM_Reject,
     /* 120796 */ // Label 2341: @120796
     /* 120796 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(120829), // Rule ID 1212 //
     /* 120801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120822 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120827 */   GIR_RootConstrainSelectedInstOperands,
     /* 120828 */   // GIR_Coverage, 1212,
     /* 120828 */   GIR_Done,
     /* 120829 */ // Label 2349: @120829
     /* 120829 */ GIM_Reject,
     /* 120830 */ // Label 2342: @120830
     /* 120830 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(121008),
     /* 120835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120841 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(120919), // Rule ID 4098 //
     /* 120846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120889 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120917 */     GIR_RootConstrainSelectedInstOperands,
     /* 120918 */     // GIR_Coverage, 4098,
     /* 120918 */     GIR_EraseRootFromParent_Done,
     /* 120919 */   // Label 2351: @120919
     /* 120919 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120946), // Rule ID 1211 //
     /* 120924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120939 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120944 */     GIR_RootConstrainSelectedInstOperands,
     /* 120945 */     // GIR_Coverage, 1211,
     /* 120945 */     GIR_Done,
     /* 120946 */   // Label 2352: @120946
     /* 120946 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(121007), // Rule ID 3010 //
     /* 120951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120966 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121005 */     GIR_RootConstrainSelectedInstOperands,
     /* 121006 */     // GIR_Coverage, 3010,
     /* 121006 */     GIR_EraseRootFromParent_Done,
     /* 121007 */   // Label 2353: @121007
     /* 121007 */   GIM_Reject,
     /* 121008 */ // Label 2350: @121008
     /* 121008 */ GIM_Reject,
     /* 121009 */ // Label 2343: @121009
     /* 121009 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(121187),
     /* 121014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121020 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(121098), // Rule ID 4100 //
     /* 121025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 121028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121068 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121096 */     GIR_RootConstrainSelectedInstOperands,
     /* 121097 */     // GIR_Coverage, 4100,
     /* 121097 */     GIR_EraseRootFromParent_Done,
     /* 121098 */   // Label 2355: @121098
     /* 121098 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(121125), // Rule ID 1213 //
     /* 121103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121118 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121123 */     GIR_RootConstrainSelectedInstOperands,
     /* 121124 */     // GIR_Coverage, 1213,
     /* 121124 */     GIR_Done,
     /* 121125 */   // Label 2356: @121125
     /* 121125 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(121186), // Rule ID 3265 //
     /* 121130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121145 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121184 */     GIR_RootConstrainSelectedInstOperands,
     /* 121185 */     // GIR_Coverage, 3265,
     /* 121185 */     GIR_EraseRootFromParent_Done,
     /* 121186 */   // Label 2357: @121186
     /* 121186 */   GIM_Reject,
     /* 121187 */ // Label 2354: @121187
     /* 121187 */ GIM_Reject,
     /* 121188 */ // Label 2344: @121188
     /* 121188 */ GIM_Reject,
     /* 121189 */ // Label 48: @121189
     /* 121189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2364*/ GIMT_Encode4(121922),
     /* 121200 */ /*GILLT_s16*//*Label 2358*/ GIMT_Encode4(121252),
     /* 121204 */ /*GILLT_s32*//*Label 2359*/ GIMT_Encode4(121493), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121216 */ /*GILLT_v2s32*//*Label 2360*/ GIMT_Encode4(121734), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121228 */ /*GILLT_v4s16*//*Label 2361*/ GIMT_Encode4(121781),
     /* 121232 */ /*GILLT_v4s32*//*Label 2362*/ GIMT_Encode4(121828), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121248 */ /*GILLT_v8s16*//*Label 2363*/ GIMT_Encode4(121875),
     /* 121252 */ // Label 2358: @121252
     /* 121252 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(121492), // Rule ID 2687 //
     /* 121257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121278 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121278 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121281 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121285 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121292 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121295 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121299 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121304 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121307 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121312 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121315 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121319 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121324 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121327 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121331 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121334 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121339 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121344 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121349 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121352 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121356 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121363 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121366 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121370 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121375 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121378 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121383 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121386 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121390 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121395 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121398 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121402 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121405 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121410 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121415 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121420 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121423 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121427 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121432 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121435 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121438 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121441 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121461 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121464 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121474 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121491 */   // GIR_Coverage, 2687,
     /* 121491 */   GIR_EraseRootFromParent_Done,
     /* 121492 */ // Label 2365: @121492
     /* 121492 */ GIM_Reject,
     /* 121493 */ // Label 2359: @121493
     /* 121493 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(121733), // Rule ID 2689 //
     /* 121498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121519 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121519 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121522 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121526 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121533 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121536 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121540 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121545 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121548 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121553 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121556 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121560 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121565 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121568 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121572 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121575 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121580 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121585 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121590 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121593 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121597 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121604 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121607 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121611 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121616 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121619 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121624 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121627 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121631 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121636 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121639 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121643 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121646 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121651 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121656 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121661 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121664 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121668 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121673 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121676 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121679 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121682 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121702 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121715 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121732 */   // GIR_Coverage, 2689,
     /* 121732 */   GIR_EraseRootFromParent_Done,
     /* 121733 */ // Label 2366: @121733
     /* 121733 */ GIM_Reject,
     /* 121734 */ // Label 2360: @121734
     /* 121734 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(121780), // Rule ID 1226 //
     /* 121739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121760 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121765 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121767 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121778 */   GIR_RootConstrainSelectedInstOperands,
     /* 121779 */   // GIR_Coverage, 1226,
     /* 121779 */   GIR_EraseRootFromParent_Done,
     /* 121780 */ // Label 2367: @121780
     /* 121780 */ GIM_Reject,
     /* 121781 */ // Label 2361: @121781
     /* 121781 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(121827), // Rule ID 1228 //
     /* 121786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121807 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121812 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121814 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121819 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121825 */   GIR_RootConstrainSelectedInstOperands,
     /* 121826 */   // GIR_Coverage, 1228,
     /* 121826 */   GIR_EraseRootFromParent_Done,
     /* 121827 */ // Label 2368: @121827
     /* 121827 */ GIM_Reject,
     /* 121828 */ // Label 2362: @121828
     /* 121828 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(121874), // Rule ID 1227 //
     /* 121833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121854 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121859 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121861 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121872 */   GIR_RootConstrainSelectedInstOperands,
     /* 121873 */   // GIR_Coverage, 1227,
     /* 121873 */   GIR_EraseRootFromParent_Done,
     /* 121874 */ // Label 2369: @121874
     /* 121874 */ GIM_Reject,
     /* 121875 */ // Label 2363: @121875
     /* 121875 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(121921), // Rule ID 1229 //
     /* 121880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121901 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121906 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121908 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121913 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121919 */   GIR_RootConstrainSelectedInstOperands,
     /* 121920 */   // GIR_Coverage, 1229,
     /* 121920 */   GIR_EraseRootFromParent_Done,
     /* 121921 */ // Label 2370: @121921
     /* 121921 */ GIM_Reject,
     /* 121922 */ // Label 2364: @121922
     /* 121922 */ GIM_Reject,
     /* 121923 */ // Label 49: @121923
     /* 121923 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2377*/ GIMT_Encode4(122656),
     /* 121934 */ /*GILLT_s16*//*Label 2371*/ GIMT_Encode4(121986),
     /* 121938 */ /*GILLT_s32*//*Label 2372*/ GIMT_Encode4(122227), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121950 */ /*GILLT_v2s32*//*Label 2373*/ GIMT_Encode4(122468), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121962 */ /*GILLT_v4s16*//*Label 2374*/ GIMT_Encode4(122515),
     /* 121966 */ /*GILLT_v4s32*//*Label 2375*/ GIMT_Encode4(122562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121982 */ /*GILLT_v8s16*//*Label 2376*/ GIMT_Encode4(122609),
     /* 121986 */ // Label 2371: @121986
     /* 121986 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(122226), // Rule ID 2686 //
     /* 121991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 122000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122012 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122012 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 122015 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122019 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122026 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122029 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122033 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122038 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122041 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122046 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122049 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122053 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122058 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122061 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122065 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122068 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122073 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122078 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122083 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122086 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122090 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122097 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122100 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122104 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122109 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122112 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122117 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122120 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122124 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122129 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122132 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122136 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122139 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122144 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122149 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122154 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122157 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122161 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122166 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122169 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122172 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122175 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122195 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122198 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122208 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122215 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122220 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122225 */   // GIR_Coverage, 2686,
     /* 122225 */   GIR_EraseRootFromParent_Done,
     /* 122226 */ // Label 2378: @122226
     /* 122226 */ GIM_Reject,
     /* 122227 */ // Label 2372: @122227
     /* 122227 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(122467), // Rule ID 2688 //
     /* 122232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122253 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122253 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122256 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122260 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122267 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122270 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122274 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122279 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122282 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122287 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122290 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122294 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122299 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122302 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122306 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122309 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122314 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122319 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122324 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122327 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122331 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122338 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122341 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122345 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122350 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122353 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122358 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122361 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122365 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122370 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122373 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122377 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122380 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122385 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122390 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122395 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122398 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122402 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122407 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122410 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122413 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122416 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122436 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122439 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122449 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122466 */   // GIR_Coverage, 2688,
     /* 122466 */   GIR_EraseRootFromParent_Done,
     /* 122467 */ // Label 2379: @122467
     /* 122467 */ GIM_Reject,
     /* 122468 */ // Label 2373: @122468
     /* 122468 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(122514), // Rule ID 1206 //
     /* 122473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122494 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122499 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122501 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122506 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122512 */   GIR_RootConstrainSelectedInstOperands,
     /* 122513 */   // GIR_Coverage, 1206,
     /* 122513 */   GIR_EraseRootFromParent_Done,
     /* 122514 */ // Label 2380: @122514
     /* 122514 */ GIM_Reject,
     /* 122515 */ // Label 2374: @122515
     /* 122515 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(122561), // Rule ID 1208 //
     /* 122520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122541 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122546 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122548 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122553 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122559 */   GIR_RootConstrainSelectedInstOperands,
     /* 122560 */   // GIR_Coverage, 1208,
     /* 122560 */   GIR_EraseRootFromParent_Done,
     /* 122561 */ // Label 2381: @122561
     /* 122561 */ GIM_Reject,
     /* 122562 */ // Label 2375: @122562
     /* 122562 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(122608), // Rule ID 1207 //
     /* 122567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122588 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122593 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122595 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122600 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122606 */   GIR_RootConstrainSelectedInstOperands,
     /* 122607 */   // GIR_Coverage, 1207,
     /* 122607 */   GIR_EraseRootFromParent_Done,
     /* 122608 */ // Label 2382: @122608
     /* 122608 */ GIM_Reject,
     /* 122609 */ // Label 2376: @122609
     /* 122609 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(122655), // Rule ID 1209 //
     /* 122614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122635 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122640 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122642 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122647 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122653 */   GIR_RootConstrainSelectedInstOperands,
     /* 122654 */   // GIR_Coverage, 1209,
     /* 122654 */   GIR_EraseRootFromParent_Done,
     /* 122655 */ // Label 2383: @122655
     /* 122655 */ GIM_Reject,
     /* 122656 */ // Label 2377: @122656
     /* 122656 */ GIM_Reject,
     /* 122657 */ // Label 50: @122657
     /* 122657 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(122689), // Rule ID 2399 //
     /* 122662 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122669 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122677 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122687 */   GIR_RootConstrainSelectedInstOperands,
     /* 122688 */   // GIR_Coverage, 2399,
     /* 122688 */   GIR_EraseRootFromParent_Done,
     /* 122689 */ // Label 2384: @122689
     /* 122689 */ GIM_Reject,
     /* 122690 */ // Label 51: @122690
     /* 122690 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(122725), // Rule ID 2400 //
     /* 122695 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122702 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR GPRnopc:{ *:[i32] }:$Rt)
     /* 122702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122705 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122716 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122719 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122723 */   GIR_RootConstrainSelectedInstOperands,
     /* 122724 */   // GIR_Coverage, 2400,
     /* 122724 */   GIR_EraseRootFromParent_Done,
     /* 122725 */ // Label 2385: @122725
     /* 122725 */ GIM_Reject,
     /* 122726 */ // Label 52: @122726
     /* 122726 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(122790), // Rule ID 2401 //
     /* 122731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122734 */   // (reset_fpenv)  =>  (VMSR (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122746 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122749 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122752 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122775 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122781 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122784 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122788 */   GIR_RootConstrainSelectedInstOperands,
     /* 122789 */   // GIR_Coverage, 2401,
     /* 122789 */   GIR_EraseRootFromParent_Done,
     /* 122790 */ // Label 2386: @122790
     /* 122790 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122854), // Rule ID 2402 //
     /* 122795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122798 */   // (reset_fpenv)  =>  (VMSR (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122810 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122816 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122819 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122822 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122839 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122845 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122852 */   GIR_RootConstrainSelectedInstOperands,
     /* 122853 */   // GIR_Coverage, 2402,
     /* 122853 */   GIR_EraseRootFromParent_Done,
     /* 122854 */ // Label 2387: @122854
     /* 122854 */ GIM_Reject,
     /* 122855 */ // Label 53: @122855
     /* 122855 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122887), // Rule ID 2403 //
     /* 122860 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122867 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122875 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122885 */   GIR_RootConstrainSelectedInstOperands,
     /* 122886 */   // GIR_Coverage, 2403,
     /* 122886 */   GIR_EraseRootFromParent_Done,
     /* 122887 */ // Label 2388: @122887
     /* 122887 */ GIM_Reject,
     /* 122888 */ // Label 54: @122888
     /* 122888 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2395*/ GIMT_Encode4(123430),
     /* 122899 */ /*GILLT_v2s32*//*Label 2389*/ GIMT_Encode4(122947), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122911 */ /*GILLT_v4s16*//*Label 2390*/ GIMT_Encode4(122994),
     /* 122915 */ /*GILLT_v4s32*//*Label 2391*/ GIMT_Encode4(123041), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122927 */ /*GILLT_v8s8*//*Label 2392*/ GIMT_Encode4(123155),
     /* 122931 */ /*GILLT_v8s16*//*Label 2393*/ GIMT_Encode4(123202), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122943 */ /*GILLT_v16s8*//*Label 2394*/ GIMT_Encode4(123316),
     /* 122947 */ // Label 2389: @122947
     /* 122947 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(122993), // Rule ID 1215 //
     /* 122952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122973 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122978 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122980 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122991 */   GIR_RootConstrainSelectedInstOperands,
     /* 122992 */   // GIR_Coverage, 1215,
     /* 122992 */   GIR_EraseRootFromParent_Done,
     /* 122993 */ // Label 2396: @122993
     /* 122993 */ GIM_Reject,
     /* 122994 */ // Label 2390: @122994
     /* 122994 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(123040), // Rule ID 1214 //
     /* 122999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123020 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 123023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123027 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123032 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123038 */   GIR_RootConstrainSelectedInstOperands,
     /* 123039 */   // GIR_Coverage, 1214,
     /* 123039 */   GIR_EraseRootFromParent_Done,
     /* 123040 */ // Label 2397: @123040
     /* 123040 */ GIM_Reject,
     /* 123041 */ // Label 2391: @123041
     /* 123041 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(123154),
     /* 123046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123052 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(123092), // Rule ID 1217 //
     /* 123057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123072 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123090 */     GIR_RootConstrainSelectedInstOperands,
     /* 123091 */     // GIR_Coverage, 1217,
     /* 123091 */     GIR_EraseRootFromParent_Done,
     /* 123092 */   // Label 2399: @123092
     /* 123092 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(123153), // Rule ID 3280 //
     /* 123097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123112 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123151 */     GIR_RootConstrainSelectedInstOperands,
     /* 123152 */     // GIR_Coverage, 3280,
     /* 123152 */     GIR_EraseRootFromParent_Done,
     /* 123153 */   // Label 2400: @123153
     /* 123153 */   GIM_Reject,
     /* 123154 */ // Label 2398: @123154
     /* 123154 */ GIM_Reject,
     /* 123155 */ // Label 2392: @123155
     /* 123155 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(123201), // Rule ID 1218 //
     /* 123160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123181 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123186 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123188 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123193 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123199 */   GIR_RootConstrainSelectedInstOperands,
     /* 123200 */   // GIR_Coverage, 1218,
     /* 123200 */   GIR_EraseRootFromParent_Done,
     /* 123201 */ // Label 2401: @123201
     /* 123201 */ GIM_Reject,
     /* 123202 */ // Label 2393: @123202
     /* 123202 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(123315),
     /* 123207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123213 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(123253), // Rule ID 1216 //
     /* 123218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123233 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123251 */     GIR_RootConstrainSelectedInstOperands,
     /* 123252 */     // GIR_Coverage, 1216,
     /* 123252 */     GIR_EraseRootFromParent_Done,
     /* 123253 */   // Label 2403: @123253
     /* 123253 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(123314), // Rule ID 3277 //
     /* 123258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123273 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123312 */     GIR_RootConstrainSelectedInstOperands,
     /* 123313 */     // GIR_Coverage, 3277,
     /* 123313 */     GIR_EraseRootFromParent_Done,
     /* 123314 */   // Label 2404: @123314
     /* 123314 */   GIM_Reject,
     /* 123315 */ // Label 2402: @123315
     /* 123315 */ GIM_Reject,
     /* 123316 */ // Label 2394: @123316
     /* 123316 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(123429),
     /* 123321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123327 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(123367), // Rule ID 1219 //
     /* 123332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123347 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123365 */     GIR_RootConstrainSelectedInstOperands,
     /* 123366 */     // GIR_Coverage, 1219,
     /* 123366 */     GIR_EraseRootFromParent_Done,
     /* 123367 */   // Label 2406: @123367
     /* 123367 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123428), // Rule ID 3274 //
     /* 123372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123387 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123426 */     GIR_RootConstrainSelectedInstOperands,
     /* 123427 */     // GIR_Coverage, 3274,
     /* 123427 */     GIR_EraseRootFromParent_Done,
     /* 123428 */   // Label 2407: @123428
     /* 123428 */   GIM_Reject,
     /* 123429 */ // Label 2405: @123429
     /* 123429 */ GIM_Reject,
     /* 123430 */ // Label 2395: @123430
     /* 123430 */ GIM_Reject,
     /* 123431 */ // Label 55: @123431
     /* 123431 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2414*/ GIMT_Encode4(123973),
     /* 123442 */ /*GILLT_v2s32*//*Label 2408*/ GIMT_Encode4(123490), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123454 */ /*GILLT_v4s16*//*Label 2409*/ GIMT_Encode4(123537),
     /* 123458 */ /*GILLT_v4s32*//*Label 2410*/ GIMT_Encode4(123584), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123470 */ /*GILLT_v8s8*//*Label 2411*/ GIMT_Encode4(123698),
     /* 123474 */ /*GILLT_v8s16*//*Label 2412*/ GIMT_Encode4(123745), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123486 */ /*GILLT_v16s8*//*Label 2413*/ GIMT_Encode4(123859),
     /* 123490 */ // Label 2408: @123490
     /* 123490 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123536), // Rule ID 1195 //
     /* 123495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123516 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123521 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123523 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123528 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123534 */   GIR_RootConstrainSelectedInstOperands,
     /* 123535 */   // GIR_Coverage, 1195,
     /* 123535 */   GIR_EraseRootFromParent_Done,
     /* 123536 */ // Label 2415: @123536
     /* 123536 */ GIM_Reject,
     /* 123537 */ // Label 2409: @123537
     /* 123537 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(123583), // Rule ID 1194 //
     /* 123542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123563 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123568 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123570 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123575 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123581 */   GIR_RootConstrainSelectedInstOperands,
     /* 123582 */   // GIR_Coverage, 1194,
     /* 123582 */   GIR_EraseRootFromParent_Done,
     /* 123583 */ // Label 2416: @123583
     /* 123583 */ GIM_Reject,
     /* 123584 */ // Label 2410: @123584
     /* 123584 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(123697),
     /* 123589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123595 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(123635), // Rule ID 1197 //
     /* 123600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123615 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123633 */     GIR_RootConstrainSelectedInstOperands,
     /* 123634 */     // GIR_Coverage, 1197,
     /* 123634 */     GIR_EraseRootFromParent_Done,
     /* 123635 */   // Label 2418: @123635
     /* 123635 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(123696), // Rule ID 3298 //
     /* 123640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123655 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123694 */     GIR_RootConstrainSelectedInstOperands,
     /* 123695 */     // GIR_Coverage, 3298,
     /* 123695 */     GIR_EraseRootFromParent_Done,
     /* 123696 */   // Label 2419: @123696
     /* 123696 */   GIM_Reject,
     /* 123697 */ // Label 2417: @123697
     /* 123697 */ GIM_Reject,
     /* 123698 */ // Label 2411: @123698
     /* 123698 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(123744), // Rule ID 1198 //
     /* 123703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123724 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123729 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123731 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123736 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123742 */   GIR_RootConstrainSelectedInstOperands,
     /* 123743 */   // GIR_Coverage, 1198,
     /* 123743 */   GIR_EraseRootFromParent_Done,
     /* 123744 */ // Label 2420: @123744
     /* 123744 */ GIM_Reject,
     /* 123745 */ // Label 2412: @123745
     /* 123745 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(123858),
     /* 123750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123756 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123796), // Rule ID 1196 //
     /* 123761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123776 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123794 */     GIR_RootConstrainSelectedInstOperands,
     /* 123795 */     // GIR_Coverage, 1196,
     /* 123795 */     GIR_EraseRootFromParent_Done,
     /* 123796 */   // Label 2422: @123796
     /* 123796 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123857), // Rule ID 3295 //
     /* 123801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123816 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123855 */     GIR_RootConstrainSelectedInstOperands,
     /* 123856 */     // GIR_Coverage, 3295,
     /* 123856 */     GIR_EraseRootFromParent_Done,
     /* 123857 */   // Label 2423: @123857
     /* 123857 */   GIM_Reject,
     /* 123858 */ // Label 2421: @123858
     /* 123858 */ GIM_Reject,
     /* 123859 */ // Label 2413: @123859
     /* 123859 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123972),
     /* 123864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123870 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123910), // Rule ID 1199 //
     /* 123875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123890 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123908 */     GIR_RootConstrainSelectedInstOperands,
     /* 123909 */     // GIR_Coverage, 1199,
     /* 123909 */     GIR_EraseRootFromParent_Done,
     /* 123910 */   // Label 2425: @123910
     /* 123910 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123971), // Rule ID 3292 //
     /* 123915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123930 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123969 */     GIR_RootConstrainSelectedInstOperands,
     /* 123970 */     // GIR_Coverage, 3292,
     /* 123970 */     GIR_EraseRootFromParent_Done,
     /* 123971 */   // Label 2426: @123971
     /* 123971 */   GIM_Reject,
     /* 123972 */ // Label 2424: @123972
     /* 123972 */ GIM_Reject,
     /* 123973 */ // Label 2414: @123973
     /* 123973 */ GIM_Reject,
     /* 123974 */ // Label 56: @123974
     /* 123974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2433*/ GIMT_Encode4(124894),
     /* 123985 */ /*GILLT_v2s32*//*Label 2427*/ GIMT_Encode4(124033), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123997 */ /*GILLT_v4s16*//*Label 2428*/ GIMT_Encode4(124080),
     /* 124001 */ /*GILLT_v4s32*//*Label 2429*/ GIMT_Encode4(124127), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124013 */ /*GILLT_v8s8*//*Label 2430*/ GIMT_Encode4(124367),
     /* 124017 */ /*GILLT_v8s16*//*Label 2431*/ GIMT_Encode4(124414), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124029 */ /*GILLT_v16s8*//*Label 2432*/ GIMT_Encode4(124654),
     /* 124033 */ // Label 2427: @124033
     /* 124033 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(124079), // Rule ID 1221 //
     /* 124038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124059 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124064 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124066 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124071 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124077 */   GIR_RootConstrainSelectedInstOperands,
     /* 124078 */   // GIR_Coverage, 1221,
     /* 124078 */   GIR_EraseRootFromParent_Done,
     /* 124079 */ // Label 2434: @124079
     /* 124079 */ GIM_Reject,
     /* 124080 */ // Label 2428: @124080
     /* 124080 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(124126), // Rule ID 1220 //
     /* 124085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124106 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124111 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124113 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124118 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124124 */   GIR_RootConstrainSelectedInstOperands,
     /* 124125 */   // GIR_Coverage, 1220,
     /* 124125 */   GIR_EraseRootFromParent_Done,
     /* 124126 */ // Label 2435: @124126
     /* 124126 */ GIM_Reject,
     /* 124127 */ // Label 2429: @124127
     /* 124127 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(124366),
     /* 124132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124138 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(124201), // Rule ID 6007 //
     /* 124143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124173 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124199 */     GIR_RootConstrainSelectedInstOperands,
     /* 124200 */     // GIR_Coverage, 6007,
     /* 124200 */     GIR_EraseRootFromParent_Done,
     /* 124201 */   // Label 2437: @124201
     /* 124201 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(124264), // Rule ID 3677 //
     /* 124206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124236 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124262 */     GIR_RootConstrainSelectedInstOperands,
     /* 124263 */     // GIR_Coverage, 3677,
     /* 124263 */     GIR_EraseRootFromParent_Done,
     /* 124264 */   // Label 2438: @124264
     /* 124264 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(124304), // Rule ID 1223 //
     /* 124269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124284 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124302 */     GIR_RootConstrainSelectedInstOperands,
     /* 124303 */     // GIR_Coverage, 1223,
     /* 124303 */     GIR_EraseRootFromParent_Done,
     /* 124304 */   // Label 2439: @124304
     /* 124304 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(124365), // Rule ID 3289 //
     /* 124309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124324 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124363 */     GIR_RootConstrainSelectedInstOperands,
     /* 124364 */     // GIR_Coverage, 3289,
     /* 124364 */     GIR_EraseRootFromParent_Done,
     /* 124365 */   // Label 2440: @124365
     /* 124365 */   GIM_Reject,
     /* 124366 */ // Label 2436: @124366
     /* 124366 */ GIM_Reject,
     /* 124367 */ // Label 2430: @124367
     /* 124367 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(124413), // Rule ID 1224 //
     /* 124372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124393 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124398 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124400 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124405 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124411 */   GIR_RootConstrainSelectedInstOperands,
     /* 124412 */   // GIR_Coverage, 1224,
     /* 124412 */   GIR_EraseRootFromParent_Done,
     /* 124413 */ // Label 2441: @124413
     /* 124413 */ GIM_Reject,
     /* 124414 */ // Label 2431: @124414
     /* 124414 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(124653),
     /* 124419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124425 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(124488), // Rule ID 6006 //
     /* 124430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124460 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124486 */     GIR_RootConstrainSelectedInstOperands,
     /* 124487 */     // GIR_Coverage, 6006,
     /* 124487 */     GIR_EraseRootFromParent_Done,
     /* 124488 */   // Label 2443: @124488
     /* 124488 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124551), // Rule ID 3675 //
     /* 124493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124523 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124549 */     GIR_RootConstrainSelectedInstOperands,
     /* 124550 */     // GIR_Coverage, 3675,
     /* 124550 */     GIR_EraseRootFromParent_Done,
     /* 124551 */   // Label 2444: @124551
     /* 124551 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124591), // Rule ID 1222 //
     /* 124556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124571 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124589 */     GIR_RootConstrainSelectedInstOperands,
     /* 124590 */     // GIR_Coverage, 1222,
     /* 124590 */     GIR_EraseRootFromParent_Done,
     /* 124591 */   // Label 2445: @124591
     /* 124591 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124652), // Rule ID 3286 //
     /* 124596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124611 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124650 */     GIR_RootConstrainSelectedInstOperands,
     /* 124651 */     // GIR_Coverage, 3286,
     /* 124651 */     GIR_EraseRootFromParent_Done,
     /* 124652 */   // Label 2446: @124652
     /* 124652 */   GIM_Reject,
     /* 124653 */ // Label 2442: @124653
     /* 124653 */ GIM_Reject,
     /* 124654 */ // Label 2432: @124654
     /* 124654 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124893),
     /* 124659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124665 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124728), // Rule ID 6005 //
     /* 124670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124700 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124726 */     GIR_RootConstrainSelectedInstOperands,
     /* 124727 */     // GIR_Coverage, 6005,
     /* 124727 */     GIR_EraseRootFromParent_Done,
     /* 124728 */   // Label 2448: @124728
     /* 124728 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124791), // Rule ID 3673 //
     /* 124733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124763 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124789 */     GIR_RootConstrainSelectedInstOperands,
     /* 124790 */     // GIR_Coverage, 3673,
     /* 124790 */     GIR_EraseRootFromParent_Done,
     /* 124791 */   // Label 2449: @124791
     /* 124791 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124831), // Rule ID 1225 //
     /* 124796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124811 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124829 */     GIR_RootConstrainSelectedInstOperands,
     /* 124830 */     // GIR_Coverage, 1225,
     /* 124830 */     GIR_EraseRootFromParent_Done,
     /* 124831 */   // Label 2450: @124831
     /* 124831 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124892), // Rule ID 3283 //
     /* 124836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124851 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124890 */     GIR_RootConstrainSelectedInstOperands,
     /* 124891 */     // GIR_Coverage, 3283,
     /* 124891 */     GIR_EraseRootFromParent_Done,
     /* 124892 */   // Label 2451: @124892
     /* 124892 */   GIM_Reject,
     /* 124893 */ // Label 2447: @124893
     /* 124893 */ GIM_Reject,
     /* 124894 */ // Label 2433: @124894
     /* 124894 */ GIM_Reject,
     /* 124895 */ // Label 57: @124895
     /* 124895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2458*/ GIMT_Encode4(125815),
     /* 124906 */ /*GILLT_v2s32*//*Label 2452*/ GIMT_Encode4(124954), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124918 */ /*GILLT_v4s16*//*Label 2453*/ GIMT_Encode4(125001),
     /* 124922 */ /*GILLT_v4s32*//*Label 2454*/ GIMT_Encode4(125048), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124934 */ /*GILLT_v8s8*//*Label 2455*/ GIMT_Encode4(125288),
     /* 124938 */ /*GILLT_v8s16*//*Label 2456*/ GIMT_Encode4(125335), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124950 */ /*GILLT_v16s8*//*Label 2457*/ GIMT_Encode4(125575),
     /* 124954 */ // Label 2452: @124954
     /* 124954 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(125000), // Rule ID 1201 //
     /* 124959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124980 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124985 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124987 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124998 */   GIR_RootConstrainSelectedInstOperands,
     /* 124999 */   // GIR_Coverage, 1201,
     /* 124999 */   GIR_EraseRootFromParent_Done,
     /* 125000 */ // Label 2459: @125000
     /* 125000 */ GIM_Reject,
     /* 125001 */ // Label 2453: @125001
     /* 125001 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(125047), // Rule ID 1200 //
     /* 125006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 125015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125027 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 125027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125032 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125034 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125039 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125045 */   GIR_RootConstrainSelectedInstOperands,
     /* 125046 */   // GIR_Coverage, 1200,
     /* 125046 */   GIR_EraseRootFromParent_Done,
     /* 125047 */ // Label 2460: @125047
     /* 125047 */ GIM_Reject,
     /* 125048 */ // Label 2454: @125048
     /* 125048 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(125287),
     /* 125053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125059 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(125122), // Rule ID 6010 //
     /* 125064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125094 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125120 */     GIR_RootConstrainSelectedInstOperands,
     /* 125121 */     // GIR_Coverage, 6010,
     /* 125121 */     GIR_EraseRootFromParent_Done,
     /* 125122 */   // Label 2462: @125122
     /* 125122 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(125185), // Rule ID 3683 //
     /* 125127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125157 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125183 */     GIR_RootConstrainSelectedInstOperands,
     /* 125184 */     // GIR_Coverage, 3683,
     /* 125184 */     GIR_EraseRootFromParent_Done,
     /* 125185 */   // Label 2463: @125185
     /* 125185 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(125225), // Rule ID 1203 //
     /* 125190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125205 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125223 */     GIR_RootConstrainSelectedInstOperands,
     /* 125224 */     // GIR_Coverage, 1203,
     /* 125224 */     GIR_EraseRootFromParent_Done,
     /* 125225 */   // Label 2464: @125225
     /* 125225 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(125286), // Rule ID 3307 //
     /* 125230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125245 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125284 */     GIR_RootConstrainSelectedInstOperands,
     /* 125285 */     // GIR_Coverage, 3307,
     /* 125285 */     GIR_EraseRootFromParent_Done,
     /* 125286 */   // Label 2465: @125286
     /* 125286 */   GIM_Reject,
     /* 125287 */ // Label 2461: @125287
     /* 125287 */ GIM_Reject,
     /* 125288 */ // Label 2455: @125288
     /* 125288 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(125334), // Rule ID 1204 //
     /* 125293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125314 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125319 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125321 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125326 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125332 */   GIR_RootConstrainSelectedInstOperands,
     /* 125333 */   // GIR_Coverage, 1204,
     /* 125333 */   GIR_EraseRootFromParent_Done,
     /* 125334 */ // Label 2466: @125334
     /* 125334 */ GIM_Reject,
     /* 125335 */ // Label 2456: @125335
     /* 125335 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(125574),
     /* 125340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125346 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(125409), // Rule ID 6009 //
     /* 125351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125381 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125407 */     GIR_RootConstrainSelectedInstOperands,
     /* 125408 */     // GIR_Coverage, 6009,
     /* 125408 */     GIR_EraseRootFromParent_Done,
     /* 125409 */   // Label 2468: @125409
     /* 125409 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125472), // Rule ID 3681 //
     /* 125414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125444 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125470 */     GIR_RootConstrainSelectedInstOperands,
     /* 125471 */     // GIR_Coverage, 3681,
     /* 125471 */     GIR_EraseRootFromParent_Done,
     /* 125472 */   // Label 2469: @125472
     /* 125472 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125512), // Rule ID 1202 //
     /* 125477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125492 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125510 */     GIR_RootConstrainSelectedInstOperands,
     /* 125511 */     // GIR_Coverage, 1202,
     /* 125511 */     GIR_EraseRootFromParent_Done,
     /* 125512 */   // Label 2470: @125512
     /* 125512 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125573), // Rule ID 3304 //
     /* 125517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125532 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125571 */     GIR_RootConstrainSelectedInstOperands,
     /* 125572 */     // GIR_Coverage, 3304,
     /* 125572 */     GIR_EraseRootFromParent_Done,
     /* 125573 */   // Label 2471: @125573
     /* 125573 */   GIM_Reject,
     /* 125574 */ // Label 2467: @125574
     /* 125574 */ GIM_Reject,
     /* 125575 */ // Label 2457: @125575
     /* 125575 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125814),
     /* 125580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125586 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125649), // Rule ID 6008 //
     /* 125591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125621 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125647 */     GIR_RootConstrainSelectedInstOperands,
     /* 125648 */     // GIR_Coverage, 6008,
     /* 125648 */     GIR_EraseRootFromParent_Done,
     /* 125649 */   // Label 2473: @125649
     /* 125649 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125712), // Rule ID 3679 //
     /* 125654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125684 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125710 */     GIR_RootConstrainSelectedInstOperands,
     /* 125711 */     // GIR_Coverage, 3679,
     /* 125711 */     GIR_EraseRootFromParent_Done,
     /* 125712 */   // Label 2474: @125712
     /* 125712 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125752), // Rule ID 1205 //
     /* 125717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125732 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125750 */     GIR_RootConstrainSelectedInstOperands,
     /* 125751 */     // GIR_Coverage, 1205,
     /* 125751 */     GIR_EraseRootFromParent_Done,
     /* 125752 */   // Label 2475: @125752
     /* 125752 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125813), // Rule ID 3301 //
     /* 125757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125772 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125811 */     GIR_RootConstrainSelectedInstOperands,
     /* 125812 */     // GIR_Coverage, 3301,
     /* 125812 */     GIR_EraseRootFromParent_Done,
     /* 125813 */   // Label 2476: @125813
     /* 125813 */   GIM_Reject,
     /* 125814 */ // Label 2472: @125814
     /* 125814 */ GIM_Reject,
     /* 125815 */ // Label 2458: @125815
     /* 125815 */ GIM_Reject,
     /* 125816 */ // Label 58: @125816
     /* 125816 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2483*/ GIMT_Encode4(126286),
     /* 125827 */ /*GILLT_v2s32*//*Label 2477*/ GIMT_Encode4(125875), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125839 */ /*GILLT_v4s16*//*Label 2478*/ GIMT_Encode4(125913),
     /* 125843 */ /*GILLT_v4s32*//*Label 2479*/ GIMT_Encode4(125951), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125855 */ /*GILLT_v8s8*//*Label 2480*/ GIMT_Encode4(126050),
     /* 125859 */ /*GILLT_v8s16*//*Label 2481*/ GIMT_Encode4(126088), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125871 */ /*GILLT_v16s8*//*Label 2482*/ GIMT_Encode4(126187),
     /* 125875 */ // Label 2477: @125875
     /* 125875 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125912), // Rule ID 1507 //
     /* 125880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125894 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125899 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125904 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125910 */   GIR_RootConstrainSelectedInstOperands,
     /* 125911 */   // GIR_Coverage, 1507,
     /* 125911 */   GIR_EraseRootFromParent_Done,
     /* 125912 */ // Label 2484: @125912
     /* 125912 */ GIM_Reject,
     /* 125913 */ // Label 2478: @125913
     /* 125913 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(125950), // Rule ID 1506 //
     /* 125918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125932 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125937 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125942 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125948 */   GIR_RootConstrainSelectedInstOperands,
     /* 125949 */   // GIR_Coverage, 1506,
     /* 125949 */   GIR_EraseRootFromParent_Done,
     /* 125950 */ // Label 2485: @125950
     /* 125950 */ GIM_Reject,
     /* 125951 */ // Label 2479: @125951
     /* 125951 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(126049),
     /* 125956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125959 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(125993), // Rule ID 1510 //
     /* 125964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125975 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125991 */     GIR_RootConstrainSelectedInstOperands,
     /* 125992 */     // GIR_Coverage, 1510,
     /* 125992 */     GIR_EraseRootFromParent_Done,
     /* 125993 */   // Label 2487: @125993
     /* 125993 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(126048), // Rule ID 3652 //
     /* 125998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126009 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 126009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 126024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126026 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126046 */     GIR_RootConstrainSelectedInstOperands,
     /* 126047 */     // GIR_Coverage, 3652,
     /* 126047 */     GIR_EraseRootFromParent_Done,
     /* 126048 */   // Label 2488: @126048
     /* 126048 */   GIM_Reject,
     /* 126049 */ // Label 2486: @126049
     /* 126049 */ GIM_Reject,
     /* 126050 */ // Label 2480: @126050
     /* 126050 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(126087), // Rule ID 1505 //
     /* 126055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126069 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126074 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126079 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126085 */   GIR_RootConstrainSelectedInstOperands,
     /* 126086 */   // GIR_Coverage, 1505,
     /* 126086 */   GIR_EraseRootFromParent_Done,
     /* 126087 */ // Label 2489: @126087
     /* 126087 */ GIM_Reject,
     /* 126088 */ // Label 2481: @126088
     /* 126088 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(126186),
     /* 126093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126096 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(126130), // Rule ID 1509 //
     /* 126101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126112 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126128 */     GIR_RootConstrainSelectedInstOperands,
     /* 126129 */     // GIR_Coverage, 1509,
     /* 126129 */     GIR_EraseRootFromParent_Done,
     /* 126130 */   // Label 2491: @126130
     /* 126130 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(126185), // Rule ID 3646 //
     /* 126135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126146 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126163 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126183 */     GIR_RootConstrainSelectedInstOperands,
     /* 126184 */     // GIR_Coverage, 3646,
     /* 126184 */     GIR_EraseRootFromParent_Done,
     /* 126185 */   // Label 2492: @126185
     /* 126185 */   GIM_Reject,
     /* 126186 */ // Label 2490: @126186
     /* 126186 */ GIM_Reject,
     /* 126187 */ // Label 2482: @126187
     /* 126187 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(126285),
     /* 126192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126195 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(126229), // Rule ID 1508 //
     /* 126200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126211 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126227 */     GIR_RootConstrainSelectedInstOperands,
     /* 126228 */     // GIR_Coverage, 1508,
     /* 126228 */     GIR_EraseRootFromParent_Done,
     /* 126229 */   // Label 2494: @126229
     /* 126229 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(126284), // Rule ID 3640 //
     /* 126234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126245 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126262 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126282 */     GIR_RootConstrainSelectedInstOperands,
     /* 126283 */     // GIR_Coverage, 3640,
     /* 126283 */     GIR_EraseRootFromParent_Done,
     /* 126284 */   // Label 2495: @126284
     /* 126284 */   GIM_Reject,
     /* 126285 */ // Label 2493: @126285
     /* 126285 */ GIM_Reject,
     /* 126286 */ // Label 2483: @126286
     /* 126286 */ GIM_Reject,
     /* 126287 */ // Label 59: @126287
     /* 126287 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126359),
     /* 126292 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126295 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(126310), // Rule ID 32 //
     /* 126300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126303 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126308 */     GIR_RootConstrainSelectedInstOperands,
     /* 126309 */     // GIR_Coverage, 32,
     /* 126309 */     GIR_Done,
     /* 126310 */   // Label 2497: @126310
     /* 126310 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126334), // Rule ID 283 //
     /* 126315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126318 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126321 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126332 */     GIR_RootConstrainSelectedInstOperands,
     /* 126333 */     // GIR_Coverage, 283,
     /* 126333 */     GIR_EraseRootFromParent_Done,
     /* 126334 */   // Label 2498: @126334
     /* 126334 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126358), // Rule ID 577 //
     /* 126339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126342 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126345 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126356 */     GIR_RootConstrainSelectedInstOperands,
     /* 126357 */     // GIR_Coverage, 577,
     /* 126357 */     GIR_EraseRootFromParent_Done,
     /* 126358 */   // Label 2499: @126358
     /* 126358 */   GIM_Reject,
     /* 126359 */ // Label 2496: @126359
     /* 126359 */ GIM_Reject,
     /* 126360 */ // Label 60: @126360
     /* 126360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2504*/ GIMT_Encode4(126659),
     /* 126371 */ /*GILLT_v4s16*//*Label 2500*/ GIMT_Encode4(126407), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126387 */ /*GILLT_v8s8*//*Label 2501*/ GIMT_Encode4(126470),
     /* 126391 */ /*GILLT_v8s16*//*Label 2502*/ GIMT_Encode4(126533), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126403 */ /*GILLT_v16s8*//*Label 2503*/ GIMT_Encode4(126596),
     /* 126407 */ // Label 2500: @126407
     /* 126407 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126469), // Rule ID 1569 //
     /* 126412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126444 */   // MIs[1] Operand 1
     /* 126444 */   // No operand predicates
     /* 126444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126446 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126453 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126455 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126461 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126467 */   GIR_RootConstrainSelectedInstOperands,
     /* 126468 */   // GIR_Coverage, 1569,
     /* 126468 */   GIR_EraseRootFromParent_Done,
     /* 126469 */ // Label 2505: @126469
     /* 126469 */ GIM_Reject,
     /* 126470 */ // Label 2501: @126470
     /* 126470 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126532), // Rule ID 1568 //
     /* 126475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126507 */   // MIs[1] Operand 1
     /* 126507 */   // No operand predicates
     /* 126507 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126509 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126516 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126518 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126524 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126530 */   GIR_RootConstrainSelectedInstOperands,
     /* 126531 */   // GIR_Coverage, 1568,
     /* 126531 */   GIR_EraseRootFromParent_Done,
     /* 126532 */ // Label 2506: @126532
     /* 126532 */ GIM_Reject,
     /* 126533 */ // Label 2502: @126533
     /* 126533 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126595), // Rule ID 3416 //
     /* 126538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126570 */   // MIs[1] Operand 1
     /* 126570 */   // No operand predicates
     /* 126570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126572 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126579 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126581 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126587 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126593 */   GIR_RootConstrainSelectedInstOperands,
     /* 126594 */   // GIR_Coverage, 3416,
     /* 126594 */   GIR_EraseRootFromParent_Done,
     /* 126595 */ // Label 2507: @126595
     /* 126595 */ GIM_Reject,
     /* 126596 */ // Label 2503: @126596
     /* 126596 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(126658), // Rule ID 3415 //
     /* 126601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126633 */   // MIs[1] Operand 1
     /* 126633 */   // No operand predicates
     /* 126633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126635 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126640 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126642 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126656 */   GIR_RootConstrainSelectedInstOperands,
     /* 126657 */   // GIR_Coverage, 3415,
     /* 126657 */   GIR_EraseRootFromParent_Done,
     /* 126658 */ // Label 2508: @126658
     /* 126658 */ GIM_Reject,
     /* 126659 */ // Label 2504: @126659
     /* 126659 */ GIM_Reject,
     /* 126660 */ // Label 61: @126660
     /* 126660 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(126716), // Rule ID 1567 //
     /* 126665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126668 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126693 */   // MIs[1] Operand 1
     /* 126693 */   // No operand predicates
     /* 126693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126695 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126700 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126702 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126714 */   GIR_RootConstrainSelectedInstOperands,
     /* 126715 */   // GIR_Coverage, 1567,
     /* 126715 */   GIR_EraseRootFromParent_Done,
     /* 126716 */ // Label 2509: @126716
     /* 126716 */ GIM_Reject,
     /* 126717 */ // Label 62: @126717
     /* 126717 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2517*/ GIMT_Encode4(127277),
     /* 126728 */ /*GILLT_s32*//*Label 2510*/ GIMT_Encode4(126788), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126740 */ /*GILLT_v2s32*//*Label 2511*/ GIMT_Encode4(126866), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126752 */ /*GILLT_v4s16*//*Label 2512*/ GIMT_Encode4(126904),
     /* 126756 */ /*GILLT_v4s32*//*Label 2513*/ GIMT_Encode4(126942), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126768 */ /*GILLT_v8s8*//*Label 2514*/ GIMT_Encode4(127041),
     /* 126772 */ /*GILLT_v8s16*//*Label 2515*/ GIMT_Encode4(127079), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126784 */ /*GILLT_v16s8*//*Label 2516*/ GIMT_Encode4(127178),
     /* 126788 */ // Label 2510: @126788
     /* 126788 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(126865),
     /* 126793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126796 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(126830), // Rule ID 197 //
     /* 126801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126812 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126828 */     GIR_RootConstrainSelectedInstOperands,
     /* 126829 */     // GIR_Coverage, 197,
     /* 126829 */     GIR_EraseRootFromParent_Done,
     /* 126830 */   // Label 2519: @126830
     /* 126830 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(126864), // Rule ID 534 //
     /* 126835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126846 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126862 */     GIR_RootConstrainSelectedInstOperands,
     /* 126863 */     // GIR_Coverage, 534,
     /* 126863 */     GIR_EraseRootFromParent_Done,
     /* 126864 */   // Label 2520: @126864
     /* 126864 */   GIM_Reject,
     /* 126865 */ // Label 2518: @126865
     /* 126865 */ GIM_Reject,
     /* 126866 */ // Label 2511: @126866
     /* 126866 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(126903), // Rule ID 1545 //
     /* 126871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126885 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126890 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126901 */   GIR_RootConstrainSelectedInstOperands,
     /* 126902 */   // GIR_Coverage, 1545,
     /* 126902 */   GIR_EraseRootFromParent_Done,
     /* 126903 */ // Label 2521: @126903
     /* 126903 */ GIM_Reject,
     /* 126904 */ // Label 2512: @126904
     /* 126904 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(126941), // Rule ID 1544 //
     /* 126909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126923 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126928 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126933 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126939 */   GIR_RootConstrainSelectedInstOperands,
     /* 126940 */   // GIR_Coverage, 1544,
     /* 126940 */   GIR_EraseRootFromParent_Done,
     /* 126941 */ // Label 2522: @126941
     /* 126941 */ GIM_Reject,
     /* 126942 */ // Label 2513: @126942
     /* 126942 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(127040),
     /* 126947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126950 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(126984), // Rule ID 1548 //
     /* 126955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126966 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126982 */     GIR_RootConstrainSelectedInstOperands,
     /* 126983 */     // GIR_Coverage, 1548,
     /* 126983 */     GIR_EraseRootFromParent_Done,
     /* 126984 */   // Label 2524: @126984
     /* 126984 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(127039), // Rule ID 3638 //
     /* 126989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127000 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 127000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 127015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127017 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127037 */     GIR_RootConstrainSelectedInstOperands,
     /* 127038 */     // GIR_Coverage, 3638,
     /* 127038 */     GIR_EraseRootFromParent_Done,
     /* 127039 */   // Label 2525: @127039
     /* 127039 */   GIM_Reject,
     /* 127040 */ // Label 2523: @127040
     /* 127040 */ GIM_Reject,
     /* 127041 */ // Label 2514: @127041
     /* 127041 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(127078), // Rule ID 1543 //
     /* 127046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127060 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127065 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127070 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127076 */   GIR_RootConstrainSelectedInstOperands,
     /* 127077 */   // GIR_Coverage, 1543,
     /* 127077 */   GIR_EraseRootFromParent_Done,
     /* 127078 */ // Label 2526: @127078
     /* 127078 */ GIM_Reject,
     /* 127079 */ // Label 2515: @127079
     /* 127079 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(127177),
     /* 127084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127087 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(127121), // Rule ID 1547 //
     /* 127092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127103 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127119 */     GIR_RootConstrainSelectedInstOperands,
     /* 127120 */     // GIR_Coverage, 1547,
     /* 127120 */     GIR_EraseRootFromParent_Done,
     /* 127121 */   // Label 2528: @127121
     /* 127121 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(127176), // Rule ID 3636 //
     /* 127126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127137 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127154 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127174 */     GIR_RootConstrainSelectedInstOperands,
     /* 127175 */     // GIR_Coverage, 3636,
     /* 127175 */     GIR_EraseRootFromParent_Done,
     /* 127176 */   // Label 2529: @127176
     /* 127176 */   GIM_Reject,
     /* 127177 */ // Label 2527: @127177
     /* 127177 */ GIM_Reject,
     /* 127178 */ // Label 2516: @127178
     /* 127178 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(127276),
     /* 127183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127186 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(127220), // Rule ID 1546 //
     /* 127191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127202 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127218 */     GIR_RootConstrainSelectedInstOperands,
     /* 127219 */     // GIR_Coverage, 1546,
     /* 127219 */     GIR_EraseRootFromParent_Done,
     /* 127220 */   // Label 2531: @127220
     /* 127220 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(127275), // Rule ID 3634 //
     /* 127225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127236 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127253 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127273 */     GIR_RootConstrainSelectedInstOperands,
     /* 127274 */     // GIR_Coverage, 3634,
     /* 127274 */     GIR_EraseRootFromParent_Done,
     /* 127275 */   // Label 2532: @127275
     /* 127275 */   GIM_Reject,
     /* 127276 */ // Label 2530: @127276
     /* 127276 */ GIM_Reject,
     /* 127277 */ // Label 2517: @127277
     /* 127277 */ GIM_Reject,
     /* 127278 */ // Label 63: @127278
     /* 127278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2535*/ GIMT_Encode4(127385),
     /* 127289 */ /*GILLT_v8s8*//*Label 2533*/ GIMT_Encode4(127309), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127305 */ /*GILLT_v16s8*//*Label 2534*/ GIMT_Encode4(127347),
     /* 127309 */ // Label 2533: @127309
     /* 127309 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127346), // Rule ID 1549 //
     /* 127314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127328 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127333 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127338 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127344 */   GIR_RootConstrainSelectedInstOperands,
     /* 127345 */   // GIR_Coverage, 1549,
     /* 127345 */   GIR_EraseRootFromParent_Done,
     /* 127346 */ // Label 2536: @127346
     /* 127346 */ GIM_Reject,
     /* 127347 */ // Label 2534: @127347
     /* 127347 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127384), // Rule ID 1550 //
     /* 127352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127366 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127371 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127376 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127382 */   GIR_RootConstrainSelectedInstOperands,
     /* 127383 */   // GIR_Coverage, 1550,
     /* 127383 */   GIR_EraseRootFromParent_Done,
     /* 127384 */ // Label 2537: @127384
     /* 127384 */ GIM_Reject,
     /* 127385 */ // Label 2535: @127385
     /* 127385 */ GIM_Reject,
     /* 127386 */ // Label 64: @127386
     /* 127386 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2541*/ GIMT_Encode4(127675),
     /* 127397 */ /*GILLT_s32*//*Label 2538*/ GIMT_Encode4(127445), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127425 */ /*GILLT_v4s32*//*Label 2539*/ GIMT_Encode4(127557), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127441 */ /*GILLT_v8s16*//*Label 2540*/ GIMT_Encode4(127616),
     /* 127445 */ // Label 2538: @127445
     /* 127445 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127556),
     /* 127450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127453 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(127487), // Rule ID 199 //
     /* 127458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127469 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127485 */     GIR_RootConstrainSelectedInstOperands,
     /* 127486 */     // GIR_Coverage, 199,
     /* 127486 */     GIR_EraseRootFromParent_Done,
     /* 127487 */   // Label 2543: @127487
     /* 127487 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(127521), // Rule ID 326 //
     /* 127492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127503 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127519 */     GIR_RootConstrainSelectedInstOperands,
     /* 127520 */     // GIR_Coverage, 326,
     /* 127520 */     GIR_EraseRootFromParent_Done,
     /* 127521 */   // Label 2544: @127521
     /* 127521 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(127555), // Rule ID 536 //
     /* 127526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127537 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127553 */     GIR_RootConstrainSelectedInstOperands,
     /* 127554 */     // GIR_Coverage, 536,
     /* 127554 */     GIR_EraseRootFromParent_Done,
     /* 127555 */   // Label 2545: @127555
     /* 127555 */   GIM_Reject,
     /* 127556 */ // Label 2542: @127556
     /* 127556 */ GIM_Reject,
     /* 127557 */ // Label 2539: @127557
     /* 127557 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(127615), // Rule ID 3311 //
     /* 127562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127576 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127604 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127613 */   GIR_RootConstrainSelectedInstOperands,
     /* 127614 */   // GIR_Coverage, 3311,
     /* 127614 */   GIR_EraseRootFromParent_Done,
     /* 127615 */ // Label 2546: @127615
     /* 127615 */ GIM_Reject,
     /* 127616 */ // Label 2540: @127616
     /* 127616 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(127674), // Rule ID 3310 //
     /* 127621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127635 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127652 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127657 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127663 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127672 */   GIR_RootConstrainSelectedInstOperands,
     /* 127673 */   // GIR_Coverage, 3310,
     /* 127673 */   GIR_EraseRootFromParent_Done,
     /* 127674 */ // Label 2547: @127674
     /* 127674 */ GIM_Reject,
     /* 127675 */ // Label 2541: @127675
     /* 127675 */ GIM_Reject,
     /* 127676 */ // Label 65: @127676
     /* 127676 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2552*/ GIMT_Encode4(128107),
     /* 127687 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(127747), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127715 */ /*GILLT_v4s32*//*Label 2549*/ GIMT_Encode4(127825), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127731 */ /*GILLT_v8s16*//*Label 2550*/ GIMT_Encode4(127919), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127743 */ /*GILLT_v16s8*//*Label 2551*/ GIMT_Encode4(128013),
     /* 127747 */ // Label 2548: @127747
     /* 127747 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127824),
     /* 127752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127755 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127789), // Rule ID 198 //
     /* 127760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127771 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127787 */     GIR_RootConstrainSelectedInstOperands,
     /* 127788 */     // GIR_Coverage, 198,
     /* 127788 */     GIR_EraseRootFromParent_Done,
     /* 127789 */   // Label 2554: @127789
     /* 127789 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127823), // Rule ID 535 //
     /* 127794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127805 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127821 */     GIR_RootConstrainSelectedInstOperands,
     /* 127822 */     // GIR_Coverage, 535,
     /* 127822 */     GIR_EraseRootFromParent_Done,
     /* 127823 */   // Label 2555: @127823
     /* 127823 */   GIM_Reject,
     /* 127824 */ // Label 2553: @127824
     /* 127824 */ GIM_Reject,
     /* 127825 */ // Label 2549: @127825
     /* 127825 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(127918), // Rule ID 4738 //
     /* 127830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127844 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127844 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127847 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127851 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127868 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127871 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127874 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127880 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127893 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127901 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127916 */   GIR_RootConstrainSelectedInstOperands,
     /* 127917 */   // GIR_Coverage, 4738,
     /* 127917 */   GIR_EraseRootFromParent_Done,
     /* 127918 */ // Label 2556: @127918
     /* 127918 */ GIM_Reject,
     /* 127919 */ // Label 2550: @127919
     /* 127919 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(128012), // Rule ID 4739 //
     /* 127924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127938 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127938 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127941 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127945 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127962 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127965 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127968 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127974 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127987 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127995 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128001 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128007 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128010 */   GIR_RootConstrainSelectedInstOperands,
     /* 128011 */   // GIR_Coverage, 4739,
     /* 128011 */   GIR_EraseRootFromParent_Done,
     /* 128012 */ // Label 2557: @128012
     /* 128012 */ GIM_Reject,
     /* 128013 */ // Label 2551: @128013
     /* 128013 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(128106), // Rule ID 4737 //
     /* 128018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 128024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128032 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128032 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128035 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128039 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128056 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128059 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128062 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128068 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128081 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128089 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128095 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128104 */   GIR_RootConstrainSelectedInstOperands,
     /* 128105 */   // GIR_Coverage, 4737,
     /* 128105 */   GIR_EraseRootFromParent_Done,
     /* 128106 */ // Label 2558: @128106
     /* 128106 */ GIM_Reject,
     /* 128107 */ // Label 2552: @128107
     /* 128107 */ GIM_Reject,
     /* 128108 */ // Label 66: @128108
     /* 128108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2564*/ GIMT_Encode4(128370),
     /* 128119 */ /*GILLT_s16*//*Label 2559*/ GIMT_Encode4(128171),
     /* 128123 */ /*GILLT_s32*//*Label 2560*/ GIMT_Encode4(128198),
     /* 128127 */ /*GILLT_s64*//*Label 2561*/ GIMT_Encode4(128225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128151 */ /*GILLT_v4s32*//*Label 2562*/ GIMT_Encode4(128252), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128167 */ /*GILLT_v8s16*//*Label 2563*/ GIMT_Encode4(128311),
     /* 128171 */ // Label 2559: @128171
     /* 128171 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(128197), // Rule ID 680 //
     /* 128176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128190 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128195 */   GIR_RootConstrainSelectedInstOperands,
     /* 128196 */   // GIR_Coverage, 680,
     /* 128196 */   GIR_Done,
     /* 128197 */ // Label 2565: @128197
     /* 128197 */ GIM_Reject,
     /* 128198 */ // Label 2560: @128198
     /* 128198 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(128224), // Rule ID 681 //
     /* 128203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128217 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128222 */   GIR_RootConstrainSelectedInstOperands,
     /* 128223 */   // GIR_Coverage, 681,
     /* 128223 */   GIR_Done,
     /* 128224 */ // Label 2566: @128224
     /* 128224 */ GIM_Reject,
     /* 128225 */ // Label 2561: @128225
     /* 128225 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(128251), // Rule ID 682 //
     /* 128230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128244 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128249 */   GIR_RootConstrainSelectedInstOperands,
     /* 128250 */   // GIR_Coverage, 682,
     /* 128250 */   GIR_Done,
     /* 128251 */ // Label 2567: @128251
     /* 128251 */ GIM_Reject,
     /* 128252 */ // Label 2562: @128252
     /* 128252 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(128310), // Rule ID 3966 //
     /* 128257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128271 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128288 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128293 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128299 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128308 */   GIR_RootConstrainSelectedInstOperands,
     /* 128309 */   // GIR_Coverage, 3966,
     /* 128309 */   GIR_EraseRootFromParent_Done,
     /* 128310 */ // Label 2568: @128310
     /* 128310 */ GIM_Reject,
     /* 128311 */ // Label 2563: @128311
     /* 128311 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(128369), // Rule ID 3954 //
     /* 128316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128330 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128347 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128352 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128358 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128367 */   GIR_RootConstrainSelectedInstOperands,
     /* 128368 */   // GIR_Coverage, 3954,
     /* 128368 */   GIR_EraseRootFromParent_Done,
     /* 128369 */ // Label 2569: @128369
     /* 128369 */ GIM_Reject,
     /* 128370 */ // Label 2564: @128370
     /* 128370 */ GIM_Reject,
     /* 128371 */ // Label 67: @128371
     /* 128371 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2573*/ GIMT_Encode4(128508),
     /* 128382 */ /*GILLT_s16*//*Label 2570*/ GIMT_Encode4(128394),
     /* 128386 */ /*GILLT_s32*//*Label 2571*/ GIMT_Encode4(128432),
     /* 128390 */ /*GILLT_s64*//*Label 2572*/ GIMT_Encode4(128470),
     /* 128394 */ // Label 2570: @128394
     /* 128394 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(128431), // Rule ID 688 //
     /* 128399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128413 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128418 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128423 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128429 */   GIR_RootConstrainSelectedInstOperands,
     /* 128430 */   // GIR_Coverage, 688,
     /* 128430 */   GIR_EraseRootFromParent_Done,
     /* 128431 */ // Label 2574: @128431
     /* 128431 */ GIM_Reject,
     /* 128432 */ // Label 2571: @128432
     /* 128432 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128469), // Rule ID 687 //
     /* 128437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128451 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128456 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128461 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128467 */   GIR_RootConstrainSelectedInstOperands,
     /* 128468 */   // GIR_Coverage, 687,
     /* 128468 */   GIR_EraseRootFromParent_Done,
     /* 128469 */ // Label 2575: @128469
     /* 128469 */ GIM_Reject,
     /* 128470 */ // Label 2572: @128470
     /* 128470 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128507), // Rule ID 686 //
     /* 128475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128489 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128494 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128499 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128505 */   GIR_RootConstrainSelectedInstOperands,
     /* 128506 */   // GIR_Coverage, 686,
     /* 128506 */   GIR_EraseRootFromParent_Done,
     /* 128507 */ // Label 2576: @128507
     /* 128507 */ GIM_Reject,
     /* 128508 */ // Label 2573: @128508
     /* 128508 */ GIM_Reject,
     /* 128509 */ // Label 68: @128509
     /* 128509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2582*/ GIMT_Encode4(128771),
     /* 128520 */ /*GILLT_s16*//*Label 2577*/ GIMT_Encode4(128572),
     /* 128524 */ /*GILLT_s32*//*Label 2578*/ GIMT_Encode4(128599),
     /* 128528 */ /*GILLT_s64*//*Label 2579*/ GIMT_Encode4(128626), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128552 */ /*GILLT_v4s32*//*Label 2580*/ GIMT_Encode4(128653), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128568 */ /*GILLT_v8s16*//*Label 2581*/ GIMT_Encode4(128712),
     /* 128572 */ // Label 2577: @128572
     /* 128572 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(128598), // Rule ID 683 //
     /* 128577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128591 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128596 */   GIR_RootConstrainSelectedInstOperands,
     /* 128597 */   // GIR_Coverage, 683,
     /* 128597 */   GIR_Done,
     /* 128598 */ // Label 2583: @128598
     /* 128598 */ GIM_Reject,
     /* 128599 */ // Label 2578: @128599
     /* 128599 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128625), // Rule ID 684 //
     /* 128604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128618 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128623 */   GIR_RootConstrainSelectedInstOperands,
     /* 128624 */   // GIR_Coverage, 684,
     /* 128624 */   GIR_Done,
     /* 128625 */ // Label 2584: @128625
     /* 128625 */ GIM_Reject,
     /* 128626 */ // Label 2579: @128626
     /* 128626 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(128652), // Rule ID 685 //
     /* 128631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128645 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128650 */   GIR_RootConstrainSelectedInstOperands,
     /* 128651 */   // GIR_Coverage, 685,
     /* 128651 */   GIR_Done,
     /* 128652 */ // Label 2585: @128652
     /* 128652 */ GIM_Reject,
     /* 128653 */ // Label 2580: @128653
     /* 128653 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(128711), // Rule ID 3964 //
     /* 128658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128672 */   // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128689 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128700 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128709 */   GIR_RootConstrainSelectedInstOperands,
     /* 128710 */   // GIR_Coverage, 3964,
     /* 128710 */   GIR_EraseRootFromParent_Done,
     /* 128711 */ // Label 2586: @128711
     /* 128711 */ GIM_Reject,
     /* 128712 */ // Label 2581: @128712
     /* 128712 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(128770), // Rule ID 3952 //
     /* 128717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128731 */   // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128748 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128753 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128759 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128768 */   GIR_RootConstrainSelectedInstOperands,
     /* 128769 */   // GIR_Coverage, 3952,
     /* 128769 */   GIR_EraseRootFromParent_Done,
     /* 128770 */ // Label 2587: @128770
     /* 128770 */ GIM_Reject,
     /* 128771 */ // Label 2582: @128771
     /* 128771 */ GIM_Reject,
     /* 128772 */ // Label 69: @128772
     /* 128772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2593*/ GIMT_Encode4(129067),
     /* 128783 */ /*GILLT_s16*//*Label 2588*/ GIMT_Encode4(128835),
     /* 128787 */ /*GILLT_s32*//*Label 2589*/ GIMT_Encode4(128873),
     /* 128791 */ /*GILLT_s64*//*Label 2590*/ GIMT_Encode4(128911), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128815 */ /*GILLT_v4s32*//*Label 2591*/ GIMT_Encode4(128949), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128831 */ /*GILLT_v8s16*//*Label 2592*/ GIMT_Encode4(129008),
     /* 128835 */ // Label 2588: @128835
     /* 128835 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128872), // Rule ID 671 //
     /* 128840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128854 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128859 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128864 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128870 */   GIR_RootConstrainSelectedInstOperands,
     /* 128871 */   // GIR_Coverage, 671,
     /* 128871 */   GIR_EraseRootFromParent_Done,
     /* 128872 */ // Label 2594: @128872
     /* 128872 */ GIM_Reject,
     /* 128873 */ // Label 2589: @128873
     /* 128873 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128910), // Rule ID 672 //
     /* 128878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128892 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128897 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128902 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128908 */   GIR_RootConstrainSelectedInstOperands,
     /* 128909 */   // GIR_Coverage, 672,
     /* 128909 */   GIR_EraseRootFromParent_Done,
     /* 128910 */ // Label 2595: @128910
     /* 128910 */ GIM_Reject,
     /* 128911 */ // Label 2590: @128911
     /* 128911 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(128948), // Rule ID 673 //
     /* 128916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128930 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128935 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128946 */   GIR_RootConstrainSelectedInstOperands,
     /* 128947 */   // GIR_Coverage, 673,
     /* 128947 */   GIR_EraseRootFromParent_Done,
     /* 128948 */ // Label 2596: @128948
     /* 128948 */ GIM_Reject,
     /* 128949 */ // Label 2591: @128949
     /* 128949 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(129007), // Rule ID 3958 //
     /* 128954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128968 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 128983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128985 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128990 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128996 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129005 */   GIR_RootConstrainSelectedInstOperands,
     /* 129006 */   // GIR_Coverage, 3958,
     /* 129006 */   GIR_EraseRootFromParent_Done,
     /* 129007 */ // Label 2597: @129007
     /* 129007 */ GIM_Reject,
     /* 129008 */ // Label 2592: @129008
     /* 129008 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(129066), // Rule ID 3946 //
     /* 129013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129027 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129044 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129049 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129064 */   GIR_RootConstrainSelectedInstOperands,
     /* 129065 */   // GIR_Coverage, 3946,
     /* 129065 */   GIR_EraseRootFromParent_Done,
     /* 129066 */ // Label 2598: @129066
     /* 129066 */ GIM_Reject,
     /* 129067 */ // Label 2593: @129067
     /* 129067 */ GIM_Reject,
     /* 129068 */ // Label 70: @129068
     /* 129068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(129205),
     /* 129079 */ /*GILLT_s16*//*Label 2599*/ GIMT_Encode4(129091),
     /* 129083 */ /*GILLT_s32*//*Label 2600*/ GIMT_Encode4(129129),
     /* 129087 */ /*GILLT_s64*//*Label 2601*/ GIMT_Encode4(129167),
     /* 129091 */ // Label 2599: @129091
     /* 129091 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(129128), // Rule ID 668 //
     /* 129096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129110 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129120 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129126 */   GIR_RootConstrainSelectedInstOperands,
     /* 129127 */   // GIR_Coverage, 668,
     /* 129127 */   GIR_EraseRootFromParent_Done,
     /* 129128 */ // Label 2603: @129128
     /* 129128 */ GIM_Reject,
     /* 129129 */ // Label 2600: @129129
     /* 129129 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(129166), // Rule ID 669 //
     /* 129134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129148 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129153 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129158 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129164 */   GIR_RootConstrainSelectedInstOperands,
     /* 129165 */   // GIR_Coverage, 669,
     /* 129165 */   GIR_EraseRootFromParent_Done,
     /* 129166 */ // Label 2604: @129166
     /* 129166 */ GIM_Reject,
     /* 129167 */ // Label 2601: @129167
     /* 129167 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(129204), // Rule ID 670 //
     /* 129172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129186 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129191 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129196 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129202 */   GIR_RootConstrainSelectedInstOperands,
     /* 129203 */   // GIR_Coverage, 670,
     /* 129203 */   GIR_EraseRootFromParent_Done,
     /* 129204 */ // Label 2605: @129204
     /* 129204 */ GIM_Reject,
     /* 129205 */ // Label 2602: @129205
     /* 129205 */ GIM_Reject,
     /* 129206 */ // Label 71: @129206
     /* 129206 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(129221), // Rule ID 12 //
     /* 129211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129214 */   // (trap)  =>  (TRAPNaCl)
     /* 129214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129219 */   GIR_RootConstrainSelectedInstOperands,
     /* 129220 */   // GIR_Coverage, 12,
     /* 129220 */   GIR_Done,
     /* 129221 */ // Label 2606: @129221
     /* 129221 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(129236), // Rule ID 13 //
     /* 129226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129229 */   // (trap)  =>  (TRAP)
     /* 129229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129234 */   GIR_RootConstrainSelectedInstOperands,
     /* 129235 */   // GIR_Coverage, 13,
     /* 129235 */   GIR_Done,
     /* 129236 */ // Label 2607: @129236
     /* 129236 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(129251), // Rule ID 285 //
     /* 129241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129244 */   // (trap)  =>  (tTRAP)
     /* 129244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129249 */   GIR_RootConstrainSelectedInstOperands,
     /* 129250 */   // GIR_Coverage, 285,
     /* 129250 */   GIR_Done,
     /* 129251 */ // Label 2608: @129251
     /* 129251 */ GIM_Reject,
     /* 129252 */ // Label 72: @129252
     /* 129252 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(129268), // Rule ID 1835 //
     /* 129257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129260 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129266 */   GIR_RootConstrainSelectedInstOperands,
     /* 129267 */   // GIR_Coverage, 1835,
     /* 129267 */   GIR_EraseRootFromParent_Done,
     /* 129268 */ // Label 2609: @129268
     /* 129268 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(129295), // Rule ID 1836 //
     /* 129273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129276 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129279 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129293 */   GIR_RootConstrainSelectedInstOperands,
     /* 129294 */   // GIR_Coverage, 1836,
     /* 129294 */   GIR_EraseRootFromParent_Done,
     /* 129295 */ // Label 2610: @129295
     /* 129295 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(129311), // Rule ID 2016 //
     /* 129300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129303 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129309 */   GIR_RootConstrainSelectedInstOperands,
     /* 129310 */   // GIR_Coverage, 2016,
     /* 129310 */   GIR_EraseRootFromParent_Done,
     /* 129311 */ // Label 2611: @129311
     /* 129311 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(129338), // Rule ID 2017 //
     /* 129316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129319 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129322 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129336 */   GIR_RootConstrainSelectedInstOperands,
     /* 129337 */   // GIR_Coverage, 2017,
     /* 129337 */   GIR_EraseRootFromParent_Done,
     /* 129338 */ // Label 2612: @129338
     /* 129338 */ GIM_Reject,
     /* 129339 */ // Label 73: @129339
     /* 129339 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(129759),
     /* 129344 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129347 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(129645),
     /* 129358 */   /*GILLT_v4s32*//*Label 2614*/ GIMT_Encode4(129390), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129374 */   /*GILLT_v8s16*//*Label 2615*/ GIMT_Encode4(129461), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129386 */   /*GILLT_v16s8*//*Label 2616*/ GIMT_Encode4(129532),
     /* 129390 */   // Label 2614: @129390
     /* 129390 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(129460), // Rule ID 3221 //
     /* 129395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129430 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129458 */     GIR_RootConstrainSelectedInstOperands,
     /* 129459 */     // GIR_Coverage, 3221,
     /* 129459 */     GIR_EraseRootFromParent_Done,
     /* 129460 */   // Label 2618: @129460
     /* 129460 */   GIM_Reject,
     /* 129461 */   // Label 2615: @129461
     /* 129461 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129531), // Rule ID 3222 //
     /* 129466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129501 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129529 */     GIR_RootConstrainSelectedInstOperands,
     /* 129530 */     // GIR_Coverage, 3222,
     /* 129530 */     GIR_EraseRootFromParent_Done,
     /* 129531 */   // Label 2619: @129531
     /* 129531 */   GIM_Reject,
     /* 129532 */   // Label 2616: @129532
     /* 129532 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129644),
     /* 129537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129541 */     GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129607), // Rule ID 3225 //
     /* 129546 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129549 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129553 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129557 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129561 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129565 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129570 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129575 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129577 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129577 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129580 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129582 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129586 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129590 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129593 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129599 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129605 */       GIR_RootConstrainSelectedInstOperands,
     /* 129606 */       // GIR_Coverage, 3225,
     /* 129606 */       GIR_EraseRootFromParent_Done,
     /* 129607 */     // Label 2621: @129607
     /* 129607 */     GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(129643), // Rule ID 3029 //
     /* 129612 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129615 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129619 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129619 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129622 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129624 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129626 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129629 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129635 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129641 */       GIR_RootConstrainSelectedInstOperands,
     /* 129642 */       // GIR_Coverage, 3029,
     /* 129642 */       GIR_EraseRootFromParent_Done,
     /* 129643 */     // Label 2622: @129643
     /* 129643 */     GIM_Reject,
     /* 129644 */   // Label 2620: @129644
     /* 129644 */   GIM_Reject,
     /* 129645 */   // Label 2617: @129645
     /* 129645 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2625*/ GIMT_Encode4(129758),
     /* 129656 */   /*GILLT_v4s32*//*Label 2623*/ GIMT_Encode4(129676), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129672 */   /*GILLT_v8s16*//*Label 2624*/ GIMT_Encode4(129717),
     /* 129676 */   // Label 2623: @129676
     /* 129676 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129716), // Rule ID 3067 //
     /* 129681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129692 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129697 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129714 */     GIR_RootConstrainSelectedInstOperands,
     /* 129715 */     // GIR_Coverage, 3067,
     /* 129715 */     GIR_EraseRootFromParent_Done,
     /* 129716 */   // Label 2626: @129716
     /* 129716 */   GIM_Reject,
     /* 129717 */   // Label 2624: @129717
     /* 129717 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129757), // Rule ID 3057 //
     /* 129722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129733 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129738 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129755 */     GIR_RootConstrainSelectedInstOperands,
     /* 129756 */     // GIR_Coverage, 3057,
     /* 129756 */     GIR_EraseRootFromParent_Done,
     /* 129757 */   // Label 2627: @129757
     /* 129757 */   GIM_Reject,
     /* 129758 */   // Label 2625: @129758
     /* 129758 */   GIM_Reject,
     /* 129759 */ // Label 2613: @129759
     /* 129759 */ GIM_Reject,
     /* 129760 */ // Label 74: @129760
     /* 129760 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(130039),
     /* 129765 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129768 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2632*/ GIMT_Encode4(130038),
     /* 129779 */   /*GILLT_v4s32*//*Label 2629*/ GIMT_Encode4(129811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129795 */   /*GILLT_v8s16*//*Label 2630*/ GIMT_Encode4(129894), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129807 */   /*GILLT_v16s8*//*Label 2631*/ GIMT_Encode4(129962),
     /* 129811 */   // Label 2629: @129811
     /* 129811 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(129893), // Rule ID 3127 //
     /* 129816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129827 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129839 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129852 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129891 */     GIR_RootConstrainSelectedInstOperands,
     /* 129892 */     // GIR_Coverage, 3127,
     /* 129892 */     GIR_EraseRootFromParent_Done,
     /* 129893 */   // Label 2633: @129893
     /* 129893 */   GIM_Reject,
     /* 129894 */   // Label 2630: @129894
     /* 129894 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129961), // Rule ID 3126 //
     /* 129899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129910 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129922 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129959 */     GIR_RootConstrainSelectedInstOperands,
     /* 129960 */     // GIR_Coverage, 3126,
     /* 129960 */     GIR_EraseRootFromParent_Done,
     /* 129961 */   // Label 2634: @129961
     /* 129961 */   GIM_Reject,
     /* 129962 */   // Label 2631: @129962
     /* 129962 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(130037), // Rule ID 3125 //
     /* 129967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129978 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 129978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 129985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 129993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129996 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130002 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130018 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130035 */     GIR_RootConstrainSelectedInstOperands,
     /* 130036 */     // GIR_Coverage, 3125,
     /* 130036 */     GIR_EraseRootFromParent_Done,
     /* 130037 */   // Label 2635: @130037
     /* 130037 */   GIM_Reject,
     /* 130038 */   // Label 2632: @130038
     /* 130038 */   GIM_Reject,
     /* 130039 */ // Label 2628: @130039
     /* 130039 */ GIM_Reject,
     /* 130040 */ // Label 75: @130040
     /* 130040 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(130328),
     /* 130045 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130048 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2640*/ GIMT_Encode4(130327),
     /* 130059 */   /*GILLT_v4s32*//*Label 2637*/ GIMT_Encode4(130091), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130075 */   /*GILLT_v8s16*//*Label 2638*/ GIMT_Encode4(130174), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130087 */   /*GILLT_v16s8*//*Label 2639*/ GIMT_Encode4(130251),
     /* 130091 */   // Label 2637: @130091
     /* 130091 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(130173), // Rule ID 3133 //
     /* 130096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130107 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130119 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130129 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130132 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130138 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130171 */     GIR_RootConstrainSelectedInstOperands,
     /* 130172 */     // GIR_Coverage, 3133,
     /* 130172 */     GIR_EraseRootFromParent_Done,
     /* 130173 */   // Label 2641: @130173
     /* 130173 */   GIM_Reject,
     /* 130174 */   // Label 2638: @130174
     /* 130174 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(130250), // Rule ID 3132 //
     /* 130179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130190 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130202 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130215 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130248 */     GIR_RootConstrainSelectedInstOperands,
     /* 130249 */     // GIR_Coverage, 3132,
     /* 130249 */     GIR_EraseRootFromParent_Done,
     /* 130250 */   // Label 2642: @130250
     /* 130250 */   GIM_Reject,
     /* 130251 */   // Label 2639: @130251
     /* 130251 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(130326), // Rule ID 3131 //
     /* 130256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130267 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130279 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130282 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130285 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130291 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130324 */     GIR_RootConstrainSelectedInstOperands,
     /* 130325 */     // GIR_Coverage, 3131,
     /* 130325 */     GIR_EraseRootFromParent_Done,
     /* 130326 */   // Label 2643: @130326
     /* 130326 */   GIM_Reject,
     /* 130327 */   // Label 2640: @130327
     /* 130327 */   GIM_Reject,
     /* 130328 */ // Label 2636: @130328
     /* 130328 */ GIM_Reject,
     /* 130329 */ // Label 76: @130329
     /* 130329 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(130609),
     /* 130334 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130337 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2648*/ GIMT_Encode4(130608),
     /* 130348 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(130380), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130364 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(130456), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130376 */   /*GILLT_v16s8*//*Label 2647*/ GIMT_Encode4(130532),
     /* 130380 */   // Label 2645: @130380
     /* 130380 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(130455), // Rule ID 3130 //
     /* 130385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130396 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130411 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130414 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130420 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130453 */     GIR_RootConstrainSelectedInstOperands,
     /* 130454 */     // GIR_Coverage, 3130,
     /* 130454 */     GIR_EraseRootFromParent_Done,
     /* 130455 */   // Label 2649: @130455
     /* 130455 */   GIM_Reject,
     /* 130456 */   // Label 2646: @130456
     /* 130456 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(130531), // Rule ID 3129 //
     /* 130461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130472 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130490 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130496 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130529 */     GIR_RootConstrainSelectedInstOperands,
     /* 130530 */     // GIR_Coverage, 3129,
     /* 130530 */     GIR_EraseRootFromParent_Done,
     /* 130531 */   // Label 2650: @130531
     /* 130531 */   GIM_Reject,
     /* 130532 */   // Label 2647: @130532
     /* 130532 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(130607), // Rule ID 3128 //
     /* 130537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130548 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130566 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130588 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130605 */     GIR_RootConstrainSelectedInstOperands,
     /* 130606 */     // GIR_Coverage, 3128,
     /* 130606 */     GIR_EraseRootFromParent_Done,
     /* 130607 */   // Label 2651: @130607
     /* 130607 */   GIM_Reject,
     /* 130608 */   // Label 2648: @130608
     /* 130608 */   GIM_Reject,
     /* 130609 */ // Label 2644: @130609
     /* 130609 */ GIM_Reject,
     /* 130610 */ // Label 77: @130610
     /* 130610 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(130905),
     /* 130615 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130618 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(130904),
     /* 130629 */   /*GILLT_v4s32*//*Label 2653*/ GIMT_Encode4(130661), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130645 */   /*GILLT_v8s16*//*Label 2654*/ GIMT_Encode4(130744), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130657 */   /*GILLT_v16s8*//*Label 2655*/ GIMT_Encode4(130821),
     /* 130661 */   // Label 2653: @130661
     /* 130661 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(130743), // Rule ID 3136 //
     /* 130666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130677 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130689 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130702 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130708 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130741 */     GIR_RootConstrainSelectedInstOperands,
     /* 130742 */     // GIR_Coverage, 3136,
     /* 130742 */     GIR_EraseRootFromParent_Done,
     /* 130743 */   // Label 2657: @130743
     /* 130743 */   GIM_Reject,
     /* 130744 */   // Label 2654: @130744
     /* 130744 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(130820), // Rule ID 3135 //
     /* 130749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130760 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130772 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130785 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130818 */     GIR_RootConstrainSelectedInstOperands,
     /* 130819 */     // GIR_Coverage, 3135,
     /* 130819 */     GIR_EraseRootFromParent_Done,
     /* 130820 */   // Label 2658: @130820
     /* 130820 */   GIM_Reject,
     /* 130821 */   // Label 2655: @130821
     /* 130821 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(130903), // Rule ID 3134 //
     /* 130826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130837 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130849 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130862 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130901 */     GIR_RootConstrainSelectedInstOperands,
     /* 130902 */     // GIR_Coverage, 3134,
     /* 130902 */     GIR_EraseRootFromParent_Done,
     /* 130903 */   // Label 2659: @130903
     /* 130903 */   GIM_Reject,
     /* 130904 */   // Label 2656: @130904
     /* 130904 */   GIM_Reject,
     /* 130905 */ // Label 2652: @130905
     /* 130905 */ GIM_Reject,
     /* 130906 */ // Label 78: @130906
     /* 130906 */ GIM_Reject,
     /* 130907 */ }; // Size: 130907 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
