/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the Mips target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 44;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(MipsInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(MipsInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static MipsInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static MipsInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s64,
  GILLT_v4s8,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 9;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 8),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasMips2Bit = 7,
  Feature_HasMips3Bit = 17,
  Feature_HasMips4_32Bit = 27,
  Feature_NotMips4_32Bit = 28,
  Feature_HasMips4_32r2Bit = 18,
  Feature_HasMips32Bit = 3,
  Feature_HasMips32r2Bit = 6,
  Feature_HasMips32r6Bit = 29,
  Feature_NotMips32r6Bit = 4,
  Feature_IsGP64bitBit = 22,
  Feature_IsPTR64bitBit = 24,
  Feature_HasMips64Bit = 25,
  Feature_HasMips64r2Bit = 23,
  Feature_HasMips64r6Bit = 30,
  Feature_NotMips64r6Bit = 5,
  Feature_InMips16ModeBit = 31,
  Feature_NotInMips16ModeBit = 0,
  Feature_HasCnMipsBit = 26,
  Feature_NotCnMipsBit = 8,
  Feature_IsSym32Bit = 38,
  Feature_IsSym64Bit = 39,
  Feature_IsN64Bit = 40,
  Feature_RelocNotPICBit = 9,
  Feature_RelocPICBit = 37,
  Feature_NoNaNsFPMathBit = 21,
  Feature_UseAbsBit = 14,
  Feature_HasStdEncBit = 1,
  Feature_NotDSPBit = 11,
  Feature_InMicroMipsBit = 35,
  Feature_NotInMicroMipsBit = 2,
  Feature_IsLEBit = 42,
  Feature_IsBEBit = 43,
  Feature_IsNotNaClBit = 19,
  Feature_HasEVABit = 36,
  Feature_HasMSABit = 34,
  Feature_HasMadd4Bit = 20,
  Feature_UseIndirectJumpsHazardBit = 12,
  Feature_NoIndirectJumpGuardsBit = 10,
  Feature_AllowFPOpFusionBit = 41,
  Feature_IsFP64bitBit = 16,
  Feature_NotFP64bitBit = 15,
  Feature_IsNotSoftFloatBit = 13,
  Feature_HasDSPBit = 32,
  Feature_HasDSPR2Bit = 33,
};

PredicateBitset MipsInstructionSelector::
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasMips2())
    Features.set(Feature_HasMips2Bit);
  if (Subtarget->hasMips3())
    Features.set(Feature_HasMips3Bit);
  if (Subtarget->hasMips4_32())
    Features.set(Feature_HasMips4_32Bit);
  if (!Subtarget->hasMips4_32())
    Features.set(Feature_NotMips4_32Bit);
  if (Subtarget->hasMips4_32r2())
    Features.set(Feature_HasMips4_32r2Bit);
  if (Subtarget->hasMips32())
    Features.set(Feature_HasMips32Bit);
  if (Subtarget->hasMips32r2())
    Features.set(Feature_HasMips32r2Bit);
  if (Subtarget->hasMips32r6())
    Features.set(Feature_HasMips32r6Bit);
  if (!Subtarget->hasMips32r6())
    Features.set(Feature_NotMips32r6Bit);
  if (Subtarget->isGP64bit())
    Features.set(Feature_IsGP64bitBit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsPTR64bitBit);
  if (Subtarget->hasMips64())
    Features.set(Feature_HasMips64Bit);
  if (Subtarget->hasMips64r2())
    Features.set(Feature_HasMips64r2Bit);
  if (Subtarget->hasMips64r6())
    Features.set(Feature_HasMips64r6Bit);
  if (!Subtarget->hasMips64r6())
    Features.set(Feature_NotMips64r6Bit);
  if (Subtarget->inMips16Mode())
    Features.set(Feature_InMips16ModeBit);
  if (!Subtarget->inMips16Mode())
    Features.set(Feature_NotInMips16ModeBit);
  if (Subtarget->hasCnMips())
    Features.set(Feature_HasCnMipsBit);
  if (!Subtarget->hasCnMips())
    Features.set(Feature_NotCnMipsBit);
  if (Subtarget->hasSym32())
    Features.set(Feature_IsSym32Bit);
  if (!Subtarget->hasSym32())
    Features.set(Feature_IsSym64Bit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsN64Bit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_RelocNotPICBit);
  if (TM.isPositionIndependent())
    Features.set(Feature_RelocPICBit);
  if (TM.Options.NoNaNsFPMath)
    Features.set(Feature_NoNaNsFPMathBit);
  if (Subtarget->inAbs2008Mode() ||TM.Options.NoNaNsFPMath)
    Features.set(Feature_UseAbsBit);
  if (Subtarget->hasStandardEncoding())
    Features.set(Feature_HasStdEncBit);
  if (!Subtarget->hasDSP())
    Features.set(Feature_NotDSPBit);
  if (Subtarget->inMicroMipsMode())
    Features.set(Feature_InMicroMipsBit);
  if (!Subtarget->inMicroMipsMode())
    Features.set(Feature_NotInMicroMipsBit);
  if (Subtarget->isLittle())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittle())
    Features.set(Feature_IsBEBit);
  if (!Subtarget->isTargetNaCl())
    Features.set(Feature_IsNotNaClBit);
  if (Subtarget->hasEVA())
    Features.set(Feature_HasEVABit);
  if (Subtarget->hasMSA())
    Features.set(Feature_HasMSABit);
  if (!Subtarget->disableMadd4())
    Features.set(Feature_HasMadd4Bit);
  if (Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_UseIndirectJumpsHazardBit);
  if (!Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_NoIndirectJumpGuardsBit);
  if (TM.Options.AllowFPOpFusion == FPOpFusion::Fast)
    Features.set(Feature_AllowFPOpFusionBit);
  if (Subtarget->isFP64bit())
    Features.set(Feature_IsFP64bitBit);
  if (!Subtarget->isFP64bit())
    Features.set(Feature_NotFP64bitBit);
  if (!Subtarget->useSoftFloat())
    Features.set(Feature_IsNotSoftFloatBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDSPR2())
    Features.set(Feature_HasDSPR2Bit);
  return Features;
}

void MipsInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const MipsSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset MipsInstructionSelector::
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasCnMips,
  GIFBS_HasDSP,
  GIFBS_HasDSPR2,
  GIFBS_HasMSA,
  GIFBS_InMicroMips,
  GIFBS_InMips16Mode,
  GIFBS_IsFP64bit,
  GIFBS_NotFP64bit,
  GIFBS_NotInMips16Mode,
  GIFBS_HasDSP_InMicroMips,
  GIFBS_HasDSP_NotInMicroMips,
  GIFBS_HasDSPR2_InMicroMips,
  GIFBS_HasMSA_HasStdEnc,
  GIFBS_HasMSA_IsBE,
  GIFBS_HasMSA_IsLE,
  GIFBS_HasMips32r6_HasStdEnc,
  GIFBS_HasMips32r6_InMicroMips,
  GIFBS_HasMips64r2_HasStdEnc,
  GIFBS_HasMips64r6_HasStdEnc,
  GIFBS_HasStdEnc_IsNotSoftFloat,
  GIFBS_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_NotMips4_32,
  GIFBS_InMicroMips_IsFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat,
  GIFBS_InMicroMips_NotFP64bit,
  GIFBS_InMicroMips_NotMips32r6,
  GIFBS_IsGP64bit_NotInMips16Mode,
  GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc,
  GIFBS_HasMSA_HasMips64_HasStdEnc,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit,
  GIFBS_HasMips3_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r2_HasStdEnc_IsGP64bit,
  GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat,
  GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC,
  GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat,
  GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat_UseAbs,
  GIFBS_InMicroMips_NotFP64bit_NotMips32r6,
  GIFBS_InMicroMips_NotMips32r6_RelocNotPIC,
  GIFBS_InMicroMips_NotMips32r6_RelocPIC,
  GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode,
  GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs,
  GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasCnMipsBit, },
  {Feature_HasDSPBit, },
  {Feature_HasDSPR2Bit, },
  {Feature_HasMSABit, },
  {Feature_InMicroMipsBit, },
  {Feature_InMips16ModeBit, },
  {Feature_IsFP64bitBit, },
  {Feature_NotFP64bitBit, },
  {Feature_NotInMips16ModeBit, },
  {Feature_HasDSPBit, Feature_InMicroMipsBit, },
  {Feature_HasDSPBit, Feature_NotInMicroMipsBit, },
  {Feature_HasDSPR2Bit, Feature_InMicroMipsBit, },
  {Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_IsBEBit, },
  {Feature_HasMSABit, Feature_IsLEBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotMips4_32Bit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, },
  {Feature_IsGP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_AllowFPOpFusionBit, Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_HasMips64Bit, Feature_HasStdEncBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_UseAbsBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocPICBit, },
  {Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMips16ModeBit, },
  {Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips64r6Bit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

MipsInstructionSelector::ComplexMatcherMemFn
MipsInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool MipsInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_immLi16 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_immSExt6,
  GICXXPred_I64_Predicate_immSExt10,
  GICXXPred_I64_Predicate_immSExtAddiur2,
  GICXXPred_I64_Predicate_immSExtAddius5,
  GICXXPred_I64_Predicate_immZExt1,
  GICXXPred_I64_Predicate_immZExt1Ptr,
  GICXXPred_I64_Predicate_immZExt2,
  GICXXPred_I64_Predicate_immZExt2Lsa,
  GICXXPred_I64_Predicate_immZExt2Ptr,
  GICXXPred_I64_Predicate_immZExt2Shift,
  GICXXPred_I64_Predicate_immZExt3,
  GICXXPred_I64_Predicate_immZExt3Ptr,
  GICXXPred_I64_Predicate_immZExt4,
  GICXXPred_I64_Predicate_immZExt4Ptr,
  GICXXPred_I64_Predicate_immZExt5,
  GICXXPred_I64_Predicate_immZExt5_64,
  GICXXPred_I64_Predicate_immZExt6,
  GICXXPred_I64_Predicate_immZExt8,
  GICXXPred_I64_Predicate_immZExt10,
  GICXXPred_I64_Predicate_immZExtAndi16,
  GICXXPred_I64_Predicate_immi32Cst7,
  GICXXPred_I64_Predicate_immi32Cst15,
  GICXXPred_I64_Predicate_immi32Cst31,
  GICXXPred_I64_Predicate_timmSExt6,
  GICXXPred_I64_Predicate_timmZExt1,
  GICXXPred_I64_Predicate_timmZExt1Ptr,
  GICXXPred_I64_Predicate_timmZExt2,
  GICXXPred_I64_Predicate_timmZExt2Ptr,
  GICXXPred_I64_Predicate_timmZExt3,
  GICXXPred_I64_Predicate_timmZExt3Ptr,
  GICXXPred_I64_Predicate_timmZExt4,
  GICXXPred_I64_Predicate_timmZExt4Ptr,
  GICXXPred_I64_Predicate_timmZExt5,
  GICXXPred_I64_Predicate_timmZExt6,
  GICXXPred_I64_Predicate_timmZExt8,
  GICXXPred_I64_Predicate_timmZExt10,
};
bool MipsInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_immLi16: {
    return Imm >= -1 && Imm <= 126;
  }
  case GICXXPred_I64_Predicate_immSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExt10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExtAddiur2: {
    return Imm == 1 || Imm == -1 ||
                                               ((Imm % 4 == 0) &&
                                                Imm < 28 && Imm > 0);
  }
  case GICXXPred_I64_Predicate_immSExtAddius5: {
    return Imm >= -8 && Imm <= 7;
  }
  case GICXXPred_I64_Predicate_immZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Lsa: {
    return isUInt<2>(Imm - 1);
  }
  case GICXXPred_I64_Predicate_immZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Shift: {
    return Imm >= 1 && Imm <= 8;
  }
  case GICXXPred_I64_Predicate_immZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_immZExt5_64: {
     return Imm == (Imm & 0x1f); 
  }
  case GICXXPred_I64_Predicate_immZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_immZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExtAndi16: {
    return (Imm == 128 || (Imm >= 1 && Imm <= 4) || Imm == 7 || Imm == 8 ||
                Imm == 15 || Imm == 16 || Imm == 31 || Imm == 32 || Imm == 63 ||
                Imm == 64 || Imm == 255 || Imm == 32768 || Imm == 65535 );
  }
  case GICXXPred_I64_Predicate_immi32Cst7: {
    return isUInt<32>(Imm) && Imm == 7;
  }
  case GICXXPred_I64_Predicate_immi32Cst15: {
    return isUInt<32>(Imm) && Imm == 15;
  }
  case GICXXPred_I64_Predicate_immi32Cst31: {
    return isUInt<32>(Imm) && Imm == 31;
  }
  case GICXXPred_I64_Predicate_timmSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_timmZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_timmZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt10: {
    return isUInt<10>(Imm);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool MipsInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_imm32SExt16 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_imm32ZExt16,
};
bool MipsInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_imm32SExt16: {
     return isInt<16>(Imm.getSExtValue()); 
  }
  case GICXXPred_APInt_Predicate_imm32ZExt16: {
    
      return (uint32_t)Imm.getZExtValue() == (unsigned short)Imm.getZExtValue();
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool MipsInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("MipsInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
MipsInstructionSelector::CustomRendererFn
MipsInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool MipsInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool MipsInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("MipsInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *MipsInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(285), /*)*//*default:*//*Label 77*/ GIMT_Encode4(69617),
     /*    10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(938),
     /*    14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(2236),
     /*    18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(2927),
     /*    22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(3408),
     /*    26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(3677),
     /*    30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(3946),
     /*    34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(4215), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(4484),
     /*    50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5040),
     /*    54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(5444), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 10*/ GIMT_Encode4(6336),
     /*   106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 11*/ GIMT_Encode4(6409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   126 */ /*TargetOpcode::G_BITCAST*//*Label 12*/ GIMT_Encode4(6750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   170 */ /*TargetOpcode::G_LOAD*//*Label 13*/ GIMT_Encode4(11061),
     /*   174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 14*/ GIMT_Encode4(11126),
     /*   178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 15*/ GIMT_Encode4(11194), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 16*/ GIMT_Encode4(11262),
     /*   210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 17*/ GIMT_Encode4(11454),
     /*   214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 18*/ GIMT_Encode4(11624),
     /*   218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 19*/ GIMT_Encode4(11794),
     /*   222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 20*/ GIMT_Encode4(11964),
     /*   226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 21*/ GIMT_Encode4(12134),
     /*   230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 22*/ GIMT_Encode4(12304),
     /*   234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 23*/ GIMT_Encode4(12474),
     /*   238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 24*/ GIMT_Encode4(12644),
     /*   242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 25*/ GIMT_Encode4(12814),
     /*   246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 26*/ GIMT_Encode4(12984),
     /*   250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 27*/ GIMT_Encode4(13154), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   294 */ /*TargetOpcode::G_BRCOND*//*Label 28*/ GIMT_Encode4(13324), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   306 */ /*TargetOpcode::G_INTRINSIC*//*Label 29*/ GIMT_Encode4(18045),
     /*   310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 30*/ GIMT_Encode4(32310), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   322 */ /*TargetOpcode::G_ANYEXT*//*Label 31*/ GIMT_Encode4(37404),
     /*   326 */ /*TargetOpcode::G_TRUNC*//*Label 32*/ GIMT_Encode4(37470),
     /*   330 */ /*TargetOpcode::G_CONSTANT*//*Label 33*/ GIMT_Encode4(37534), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   346 */ /*TargetOpcode::G_SEXT*//*Label 34*/ GIMT_Encode4(37595),
     /*   350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 35*/ GIMT_Encode4(39059),
     /*   354 */ /*TargetOpcode::G_ZEXT*//*Label 36*/ GIMT_Encode4(39407),
     /*   358 */ /*TargetOpcode::G_SHL*//*Label 37*/ GIMT_Encode4(39608),
     /*   362 */ /*TargetOpcode::G_LSHR*//*Label 38*/ GIMT_Encode4(41405),
     /*   366 */ /*TargetOpcode::G_ASHR*//*Label 39*/ GIMT_Encode4(43202), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   378 */ /*TargetOpcode::G_ROTR*//*Label 40*/ GIMT_Encode4(44957), GIMT_Encode4(0),
     /*   386 */ /*TargetOpcode::G_ICMP*//*Label 41*/ GIMT_Encode4(45245),
     /*   390 */ /*TargetOpcode::G_FCMP*//*Label 42*/ GIMT_Encode4(47776), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   402 */ /*TargetOpcode::G_SELECT*//*Label 43*/ GIMT_Encode4(49482), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   446 */ /*TargetOpcode::G_UMULH*//*Label 44*/ GIMT_Encode4(61520),
     /*   450 */ /*TargetOpcode::G_SMULH*//*Label 45*/ GIMT_Encode4(61629), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   510 */ /*TargetOpcode::G_FADD*//*Label 46*/ GIMT_Encode4(61738),
     /*   514 */ /*TargetOpcode::G_FSUB*//*Label 47*/ GIMT_Encode4(62651),
     /*   518 */ /*TargetOpcode::G_FMUL*//*Label 48*/ GIMT_Encode4(63263),
     /*   522 */ /*TargetOpcode::G_FMA*//*Label 49*/ GIMT_Encode4(63750), GIMT_Encode4(0),
     /*   530 */ /*TargetOpcode::G_FDIV*//*Label 50*/ GIMT_Encode4(63856), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   550 */ /*TargetOpcode::G_FEXP2*//*Label 51*/ GIMT_Encode4(64155), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   562 */ /*TargetOpcode::G_FLOG2*//*Label 52*/ GIMT_Encode4(64233), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   578 */ /*TargetOpcode::G_FNEG*//*Label 53*/ GIMT_Encode4(64311),
     /*   582 */ /*TargetOpcode::G_FPEXT*//*Label 54*/ GIMT_Encode4(65680),
     /*   586 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(65858),
     /*   590 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(66021),
     /*   594 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(66099),
     /*   598 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(66177),
     /*   602 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(66430), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   614 */ /*TargetOpcode::G_FABS*//*Label 60*/ GIMT_Encode4(66508), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 61*/ GIMT_Encode4(66748), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 62*/ GIMT_Encode4(66822),
     /*   642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 63*/ GIMT_Encode4(66894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   686 */ /*TargetOpcode::G_SMIN*//*Label 64*/ GIMT_Encode4(66966),
     /*   690 */ /*TargetOpcode::G_SMAX*//*Label 65*/ GIMT_Encode4(67134),
     /*   694 */ /*TargetOpcode::G_UMIN*//*Label 66*/ GIMT_Encode4(67302),
     /*   698 */ /*TargetOpcode::G_UMAX*//*Label 67*/ GIMT_Encode4(67470), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   714 */ /*TargetOpcode::G_BR*//*Label 68*/ GIMT_Encode4(67638), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 69*/ GIMT_Encode4(67762),
     /*   738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 70*/ GIMT_Encode4(68326), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   766 */ /*TargetOpcode::G_CTLZ*//*Label 71*/ GIMT_Encode4(68378), GIMT_Encode4(0),
     /*   774 */ /*TargetOpcode::G_CTPOP*//*Label 72*/ GIMT_Encode4(68883),
     /*   778 */ /*TargetOpcode::G_BSWAP*//*Label 73*/ GIMT_Encode4(69089), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   834 */ /*TargetOpcode::G_FSQRT*//*Label 74*/ GIMT_Encode4(69253), GIMT_Encode4(0),
     /*   842 */ /*TargetOpcode::G_FRINT*//*Label 75*/ GIMT_Encode4(69493), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   934 */ /*TargetOpcode::G_TRAP*//*Label 76*/ GIMT_Encode4(69571),
     /*   938 */ // Label 0: @938
     /*   938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 86*/ GIMT_Encode4(2235),
     /*   949 */ /*GILLT_s32*//*Label 78*/ GIMT_Encode4(981),
     /*   953 */ /*GILLT_s64*//*Label 79*/ GIMT_Encode4(1389),
     /*   957 */ /*GILLT_v2s16*//*Label 80*/ GIMT_Encode4(1555),
     /*   961 */ /*GILLT_v2s64*//*Label 81*/ GIMT_Encode4(1587),
     /*   965 */ /*GILLT_v4s8*//*Label 82*/ GIMT_Encode4(1741),
     /*   969 */ /*GILLT_v4s32*//*Label 83*/ GIMT_Encode4(1773),
     /*   973 */ /*GILLT_v8s16*//*Label 84*/ GIMT_Encode4(1927),
     /*   977 */ /*GILLT_v16s8*//*Label 85*/ GIMT_Encode4(2081),
     /*   981 */ // Label 78: @981
     /*   981 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1388),
     /*   986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   992 */   GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1059), // Rule ID 2389 //
     /*   997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1037 */     // MIs[2] Operand 1
     /*  1037 */     // No operand predicates
     /*  1037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1043 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR32Opnd:{ *:[i32] }:$rt)  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1057 */     GIR_RootConstrainSelectedInstOperands,
     /*  1058 */     // GIR_Coverage, 2389,
     /*  1058 */     GIR_EraseRootFromParent_Done,
     /*  1059 */   // Label 88: @1059
     /*  1059 */   GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1126), // Rule ID 834 //
     /*  1064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1108 */     // MIs[2] Operand 1
     /*  1108 */     // No operand predicates
     /*  1108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1110 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1124 */     GIR_RootConstrainSelectedInstOperands,
     /*  1125 */     // GIR_Coverage, 834,
     /*  1125 */     GIR_EraseRootFromParent_Done,
     /*  1126 */   // Label 89: @1126
     /*  1126 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1168), // Rule ID 40 //
     /*  1131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1150 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32SExt16),
     /*  1154 */     // MIs[1] Operand 1
     /*  1154 */     // No operand predicates
     /*  1154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1156 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm16)  =>  (ADDiu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  1156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDiu),
     /*  1159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  1161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  1163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  1166 */     GIR_RootConstrainSelectedInstOperands,
     /*  1167 */     // GIR_Coverage, 40,
     /*  1167 */     GIR_EraseRootFromParent_Done,
     /*  1168 */   // Label 90: @1168
     /*  1168 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1210), // Rule ID 2158 //
     /*  1173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddiur2),
     /*  1196 */     // MIs[1] Operand 1
     /*  1196 */     // No operand predicates
     /*  1196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1198 */     // (add:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)  =>  (ADDIUR2_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)
     /*  1198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUR2_MM),
     /*  1201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1208 */     GIR_RootConstrainSelectedInstOperands,
     /*  1209 */     // GIR_Coverage, 2158,
     /*  1209 */     GIR_EraseRootFromParent_Done,
     /*  1210 */   // Label 91: @1210
     /*  1210 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1252), // Rule ID 2159 //
     /*  1215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddius5),
     /*  1238 */     // MIs[1] Operand 1
     /*  1238 */     // No operand predicates
     /*  1238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1240 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)  =>  (ADDIUS5_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)
     /*  1240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUS5_MM),
     /*  1243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1250 */     GIR_RootConstrainSelectedInstOperands,
     /*  1251 */     // GIR_Coverage, 2159,
     /*  1251 */     GIR_EraseRootFromParent_Done,
     /*  1252 */   // Label 92: @1252
     /*  1252 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1279), // Rule ID 1208 //
     /*  1257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  1260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1272 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MMR6),
     /*  1277 */     GIR_RootConstrainSelectedInstOperands,
     /*  1278 */     // GIR_Coverage, 1208,
     /*  1278 */     GIR_Done,
     /*  1279 */   // Label 93: @1279
     /*  1279 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1306), // Rule ID 46 //
     /*  1284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1299 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /*  1304 */     GIR_RootConstrainSelectedInstOperands,
     /*  1305 */     // GIR_Coverage, 46,
     /*  1305 */     GIR_Done,
     /*  1306 */   // Label 94: @1306
     /*  1306 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1333), // Rule ID 1060 //
     /*  1311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1326 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MM),
     /*  1331 */     GIR_RootConstrainSelectedInstOperands,
     /*  1332 */     // GIR_Coverage, 1060,
     /*  1332 */     GIR_Done,
     /*  1333 */   // Label 95: @1333
     /*  1333 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1360), // Rule ID 1072 //
     /*  1338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1353 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu_MM),
     /*  1358 */     GIR_RootConstrainSelectedInstOperands,
     /*  1359 */     // GIR_Coverage, 1072,
     /*  1359 */     GIR_Done,
     /*  1360 */   // Label 96: @1360
     /*  1360 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1387), // Rule ID 1818 //
     /*  1365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  1368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1380 */     // (add:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AdduRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  1380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AdduRxRyRz16),
     /*  1385 */     GIR_RootConstrainSelectedInstOperands,
     /*  1386 */     // GIR_Coverage, 1818,
     /*  1386 */     GIR_Done,
     /*  1387 */   // Label 97: @1387
     /*  1387 */   GIM_Reject,
     /*  1388 */ // Label 87: @1388
     /*  1388 */ GIM_Reject,
     /*  1389 */ // Label 79: @1389
     /*  1389 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1554),
     /*  1394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  1397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  1400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1404 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1467), // Rule ID 2390 //
     /*  1409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1445 */     // MIs[2] Operand 1
     /*  1445 */     // No operand predicates
     /*  1445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1451 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR64Opnd:{ *:[i64] }:$rt)  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1465 */     GIR_RootConstrainSelectedInstOperands,
     /*  1466 */     // GIR_Coverage, 2390,
     /*  1466 */     GIR_EraseRootFromParent_Done,
     /*  1467 */   // Label 99: @1467
     /*  1467 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1530), // Rule ID 835 //
     /*  1472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1508 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1512 */     // MIs[2] Operand 1
     /*  1512 */     // No operand predicates
     /*  1512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1514 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1528 */     GIR_RootConstrainSelectedInstOperands,
     /*  1529 */     // GIR_Coverage, 835,
     /*  1529 */     GIR_EraseRootFromParent_Done,
     /*  1530 */   // Label 100: @1530
     /*  1530 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1553), // Rule ID 202 //
     /*  1535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  1538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1546 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  1546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DADDu),
     /*  1551 */     GIR_RootConstrainSelectedInstOperands,
     /*  1552 */     // GIR_Coverage, 202,
     /*  1552 */     GIR_Done,
     /*  1553 */   // Label 101: @1553
     /*  1553 */   GIM_Reject,
     /*  1554 */ // Label 98: @1554
     /*  1554 */ GIM_Reject,
     /*  1555 */ // Label 80: @1555
     /*  1555 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1586), // Rule ID 1917 //
     /*  1560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  1566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  1569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1573 */   // (add:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  1573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /*  1578 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1584 */   GIR_RootConstrainSelectedInstOperands,
     /*  1585 */   // GIR_Coverage, 1917,
     /*  1585 */   GIR_Done,
     /*  1586 */ // Label 102: @1586
     /*  1586 */ GIM_Reject,
     /*  1587 */ // Label 81: @1587
     /*  1587 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1740),
     /*  1592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1602 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1659), // Rule ID 2394 //
     /*  1607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1642 */     // (add:{ *:[v2i64] } (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt), MSA128DOpnd:{ *:[v2i64] }:$wd_in)  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1647 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1657 */     GIR_RootConstrainSelectedInstOperands,
     /*  1658 */     // GIR_Coverage, 2394,
     /*  1658 */     GIR_EraseRootFromParent_Done,
     /*  1659 */   // Label 104: @1659
     /*  1659 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1716), // Rule ID 843 //
     /*  1664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1699 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1704 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1714 */     GIR_RootConstrainSelectedInstOperands,
     /*  1715 */     // GIR_Coverage, 843,
     /*  1715 */     GIR_EraseRootFromParent_Done,
     /*  1716 */   // Label 105: @1716
     /*  1716 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1739), // Rule ID 510 //
     /*  1721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1732 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_D),
     /*  1737 */     GIR_RootConstrainSelectedInstOperands,
     /*  1738 */     // GIR_Coverage, 510,
     /*  1738 */     GIR_Done,
     /*  1739 */   // Label 106: @1739
     /*  1739 */   GIM_Reject,
     /*  1740 */ // Label 103: @1740
     /*  1740 */ GIM_Reject,
     /*  1741 */ // Label 82: @1741
     /*  1741 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1772), // Rule ID 1923 //
     /*  1746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  1752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  1755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1759 */   // (add:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  1759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /*  1764 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1770 */   GIR_RootConstrainSelectedInstOperands,
     /*  1771 */   // GIR_Coverage, 1923,
     /*  1771 */   GIR_Done,
     /*  1772 */ // Label 107: @1772
     /*  1772 */ GIM_Reject,
     /*  1773 */ // Label 83: @1773
     /*  1773 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1926),
     /*  1778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1788 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1845), // Rule ID 2393 //
     /*  1793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1828 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt), MSA128WOpnd:{ *:[v4i32] }:$wd_in)  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1833 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1843 */     GIR_RootConstrainSelectedInstOperands,
     /*  1844 */     // GIR_Coverage, 2393,
     /*  1844 */     GIR_EraseRootFromParent_Done,
     /*  1845 */   // Label 109: @1845
     /*  1845 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1902), // Rule ID 842 //
     /*  1850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1885 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1890 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1900 */     GIR_RootConstrainSelectedInstOperands,
     /*  1901 */     // GIR_Coverage, 842,
     /*  1901 */     GIR_EraseRootFromParent_Done,
     /*  1902 */   // Label 110: @1902
     /*  1902 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1925), // Rule ID 509 //
     /*  1907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1918 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_W),
     /*  1923 */     GIR_RootConstrainSelectedInstOperands,
     /*  1924 */     // GIR_Coverage, 509,
     /*  1924 */     GIR_Done,
     /*  1925 */   // Label 111: @1925
     /*  1925 */   GIM_Reject,
     /*  1926 */ // Label 108: @1926
     /*  1926 */ GIM_Reject,
     /*  1927 */ // Label 84: @1927
     /*  1927 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(2080),
     /*  1932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1942 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1999), // Rule ID 2392 //
     /*  1947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1982 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt), MSA128HOpnd:{ *:[v8i16] }:$wd_in)  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  1982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  1985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1987 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1997 */     GIR_RootConstrainSelectedInstOperands,
     /*  1998 */     // GIR_Coverage, 2392,
     /*  1998 */     GIR_EraseRootFromParent_Done,
     /*  1999 */   // Label 113: @1999
     /*  1999 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2056), // Rule ID 841 //
     /*  2004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2039 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  2042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2044 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2054 */     GIR_RootConstrainSelectedInstOperands,
     /*  2055 */     // GIR_Coverage, 841,
     /*  2055 */     GIR_EraseRootFromParent_Done,
     /*  2056 */   // Label 114: @2056
     /*  2056 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2079), // Rule ID 508 //
     /*  2061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2072 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_H),
     /*  2077 */     GIR_RootConstrainSelectedInstOperands,
     /*  2078 */     // GIR_Coverage, 508,
     /*  2078 */     GIR_Done,
     /*  2079 */   // Label 115: @2079
     /*  2079 */   GIM_Reject,
     /*  2080 */ // Label 112: @2080
     /*  2080 */ GIM_Reject,
     /*  2081 */ // Label 85: @2081
     /*  2081 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2234),
     /*  2086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2096 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2153), // Rule ID 2391 //
     /*  2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2136 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt), MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2141 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  2143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2151 */     GIR_RootConstrainSelectedInstOperands,
     /*  2152 */     // GIR_Coverage, 2391,
     /*  2152 */     GIR_EraseRootFromParent_Done,
     /*  2153 */   // Label 117: @2153
     /*  2153 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2210), // Rule ID 840 //
     /*  2158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2193 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2198 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2208 */     GIR_RootConstrainSelectedInstOperands,
     /*  2209 */     // GIR_Coverage, 840,
     /*  2209 */     GIR_EraseRootFromParent_Done,
     /*  2210 */   // Label 118: @2210
     /*  2210 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2233), // Rule ID 507 //
     /*  2215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2226 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_B),
     /*  2231 */     GIR_RootConstrainSelectedInstOperands,
     /*  2232 */     // GIR_Coverage, 507,
     /*  2232 */     GIR_Done,
     /*  2233 */   // Label 119: @2233
     /*  2233 */   GIM_Reject,
     /*  2234 */ // Label 116: @2234
     /*  2234 */ GIM_Reject,
     /*  2235 */ // Label 86: @2235
     /*  2235 */ GIM_Reject,
     /*  2236 */ // Label 1: @2236
     /*  2236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 128*/ GIMT_Encode4(2926),
     /*  2247 */ /*GILLT_s32*//*Label 120*/ GIMT_Encode4(2279),
     /*  2251 */ /*GILLT_s64*//*Label 121*/ GIMT_Encode4(2456),
     /*  2255 */ /*GILLT_v2s16*//*Label 122*/ GIMT_Encode4(2490),
     /*  2259 */ /*GILLT_v2s64*//*Label 123*/ GIMT_Encode4(2522),
     /*  2263 */ /*GILLT_v4s8*//*Label 124*/ GIMT_Encode4(2615),
     /*  2267 */ /*GILLT_v4s32*//*Label 125*/ GIMT_Encode4(2647),
     /*  2271 */ /*GILLT_v8s16*//*Label 126*/ GIMT_Encode4(2740),
     /*  2275 */ /*GILLT_v16s8*//*Label 127*/ GIMT_Encode4(2833),
     /*  2279 */ // Label 120: @2279
     /*  2279 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2455),
     /*  2284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2290 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2319), // Rule ID 1817 //
     /*  2295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  2306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2310 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, CPU16Regs:{ *:[i32] }:$r)  =>  (NegRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  2310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NegRxRy16),
     /*  2313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  2315 */     GIR_RootToRootCopy, /*OpIdx*/2, // r
     /*  2317 */     GIR_RootConstrainSelectedInstOperands,
     /*  2318 */     // GIR_Coverage, 1817,
     /*  2318 */     GIR_EraseRootFromParent_Done,
     /*  2319 */   // Label 130: @2319
     /*  2319 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2346), // Rule ID 1210 //
     /*  2324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  2327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2339 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MMR6),
     /*  2344 */     GIR_RootConstrainSelectedInstOperands,
     /*  2345 */     // GIR_Coverage, 1210,
     /*  2345 */     GIR_Done,
     /*  2346 */   // Label 131: @2346
     /*  2346 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2373), // Rule ID 47 //
     /*  2351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  2354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2366 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /*  2371 */     GIR_RootConstrainSelectedInstOperands,
     /*  2372 */     // GIR_Coverage, 47,
     /*  2372 */     GIR_Done,
     /*  2373 */   // Label 132: @2373
     /*  2373 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2400), // Rule ID 1064 //
     /*  2378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2393 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MM),
     /*  2398 */     GIR_RootConstrainSelectedInstOperands,
     /*  2399 */     // GIR_Coverage, 1064,
     /*  2399 */     GIR_Done,
     /*  2400 */   // Label 133: @2400
     /*  2400 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2427), // Rule ID 1073 //
     /*  2405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2420 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu_MM),
     /*  2425 */     GIR_RootConstrainSelectedInstOperands,
     /*  2426 */     // GIR_Coverage, 1073,
     /*  2426 */     GIR_Done,
     /*  2427 */   // Label 134: @2427
     /*  2427 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2454), // Rule ID 1822 //
     /*  2432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2447 */     // (sub:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (SubuRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  2447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SubuRxRyRz16),
     /*  2452 */     GIR_RootConstrainSelectedInstOperands,
     /*  2453 */     // GIR_Coverage, 1822,
     /*  2453 */     GIR_Done,
     /*  2454 */   // Label 135: @2454
     /*  2454 */   GIM_Reject,
     /*  2455 */ // Label 129: @2455
     /*  2455 */ GIM_Reject,
     /*  2456 */ // Label 121: @2456
     /*  2456 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2489), // Rule ID 203 //
     /*  2461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  2464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  2467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  2470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2482 */   // (sub:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DSUBu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  2482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSUBu),
     /*  2487 */   GIR_RootConstrainSelectedInstOperands,
     /*  2488 */   // GIR_Coverage, 203,
     /*  2488 */   GIR_Done,
     /*  2489 */ // Label 136: @2489
     /*  2489 */ GIM_Reject,
     /*  2490 */ // Label 122: @2490
     /*  2490 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2521), // Rule ID 1919 //
     /*  2495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  2501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  2504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2508 */   // (sub:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  2508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /*  2513 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2519 */   GIR_RootConstrainSelectedInstOperands,
     /*  2520 */   // GIR_Coverage, 1919,
     /*  2520 */   GIR_Done,
     /*  2521 */ // Label 137: @2521
     /*  2521 */ GIM_Reject,
     /*  2522 */ // Label 123: @2522
     /*  2522 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2614),
     /*  2527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2541 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2594), // Rule ID 899 //
     /*  2546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2577 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MSUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_D),
     /*  2580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2582 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2592 */     GIR_RootConstrainSelectedInstOperands,
     /*  2593 */     // GIR_Coverage, 899,
     /*  2593 */     GIR_EraseRootFromParent_Done,
     /*  2594 */   // Label 139: @2594
     /*  2594 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2613), // Rule ID 1028 //
     /*  2599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2606 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_D),
     /*  2611 */     GIR_RootConstrainSelectedInstOperands,
     /*  2612 */     // GIR_Coverage, 1028,
     /*  2612 */     GIR_Done,
     /*  2613 */   // Label 140: @2613
     /*  2613 */   GIM_Reject,
     /*  2614 */ // Label 138: @2614
     /*  2614 */ GIM_Reject,
     /*  2615 */ // Label 124: @2615
     /*  2615 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2646), // Rule ID 1925 //
     /*  2620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  2626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  2629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2633 */   // (sub:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  2633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /*  2638 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2644 */   GIR_RootConstrainSelectedInstOperands,
     /*  2645 */   // GIR_Coverage, 1925,
     /*  2645 */   GIR_Done,
     /*  2646 */ // Label 141: @2646
     /*  2646 */ GIM_Reject,
     /*  2647 */ // Label 125: @2647
     /*  2647 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2739),
     /*  2652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2666 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2719), // Rule ID 898 //
     /*  2671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2702 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MSUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_W),
     /*  2705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2707 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2717 */     GIR_RootConstrainSelectedInstOperands,
     /*  2718 */     // GIR_Coverage, 898,
     /*  2718 */     GIR_EraseRootFromParent_Done,
     /*  2719 */   // Label 143: @2719
     /*  2719 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2738), // Rule ID 1027 //
     /*  2724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2731 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_W),
     /*  2736 */     GIR_RootConstrainSelectedInstOperands,
     /*  2737 */     // GIR_Coverage, 1027,
     /*  2737 */     GIR_Done,
     /*  2738 */   // Label 144: @2738
     /*  2738 */   GIM_Reject,
     /*  2739 */ // Label 142: @2739
     /*  2739 */ GIM_Reject,
     /*  2740 */ // Label 126: @2740
     /*  2740 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2832),
     /*  2745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2759 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2812), // Rule ID 897 //
     /*  2764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2795 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MSUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_H),
     /*  2798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2800 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2810 */     GIR_RootConstrainSelectedInstOperands,
     /*  2811 */     // GIR_Coverage, 897,
     /*  2811 */     GIR_EraseRootFromParent_Done,
     /*  2812 */   // Label 146: @2812
     /*  2812 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2831), // Rule ID 1026 //
     /*  2817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2824 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_H),
     /*  2829 */     GIR_RootConstrainSelectedInstOperands,
     /*  2830 */     // GIR_Coverage, 1026,
     /*  2830 */     GIR_Done,
     /*  2831 */   // Label 147: @2831
     /*  2831 */   GIM_Reject,
     /*  2832 */ // Label 145: @2832
     /*  2832 */ GIM_Reject,
     /*  2833 */ // Label 127: @2833
     /*  2833 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2925),
     /*  2838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2852 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2905), // Rule ID 896 //
     /*  2857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2888 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MSUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_B),
     /*  2891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2893 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2903 */     GIR_RootConstrainSelectedInstOperands,
     /*  2904 */     // GIR_Coverage, 896,
     /*  2904 */     GIR_EraseRootFromParent_Done,
     /*  2905 */   // Label 149: @2905
     /*  2905 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2924), // Rule ID 1025 //
     /*  2910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2917 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_B),
     /*  2922 */     GIR_RootConstrainSelectedInstOperands,
     /*  2923 */     // GIR_Coverage, 1025,
     /*  2923 */     GIR_Done,
     /*  2924 */   // Label 150: @2924
     /*  2924 */   GIM_Reject,
     /*  2925 */ // Label 148: @2925
     /*  2925 */ GIM_Reject,
     /*  2926 */ // Label 128: @2926
     /*  2926 */ GIM_Reject,
     /*  2927 */ // Label 2: @2927
     /*  2927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 158*/ GIMT_Encode4(3407),
     /*  2938 */ /*GILLT_s32*//*Label 151*/ GIMT_Encode4(2970),
     /*  2942 */ /*GILLT_s64*//*Label 152*/ GIMT_Encode4(3154),
     /*  2946 */ /*GILLT_v2s16*//*Label 153*/ GIMT_Encode4(3239),
     /*  2950 */ /*GILLT_v2s64*//*Label 154*/ GIMT_Encode4(3271), GIMT_Encode4(0),
     /*  2958 */ /*GILLT_v4s32*//*Label 155*/ GIMT_Encode4(3305),
     /*  2962 */ /*GILLT_v8s16*//*Label 156*/ GIMT_Encode4(3339),
     /*  2966 */ /*GILLT_v16s8*//*Label 157*/ GIMT_Encode4(3373),
     /*  2970 */ // Label 151: @2970
     /*  2970 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3153),
     /*  2975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2981 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3020), // Rule ID 48 //
     /*  2986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /*  2989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3001 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /*  3006 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3012 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3018 */     GIR_RootConstrainSelectedInstOperands,
     /*  3019 */     // GIR_Coverage, 48,
     /*  3019 */     GIR_Done,
     /*  3020 */   // Label 160: @3020
     /*  3020 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3047), // Rule ID 332 //
     /*  3025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3040 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /*  3045 */     GIR_RootConstrainSelectedInstOperands,
     /*  3046 */     // GIR_Coverage, 332,
     /*  3046 */     GIR_Done,
     /*  3047 */   // Label 161: @3047
     /*  3047 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3086), // Rule ID 1074 //
     /*  3052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  3055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3067 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MM:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MM),
     /*  3072 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3078 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3084 */     GIR_RootConstrainSelectedInstOperands,
     /*  3085 */     // GIR_Coverage, 1074,
     /*  3085 */     GIR_Done,
     /*  3086 */   // Label 162: @3086
     /*  3086 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3113), // Rule ID 1179 //
     /*  3091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3106 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MMR6),
     /*  3111 */     GIR_RootConstrainSelectedInstOperands,
     /*  3112 */     // GIR_Coverage, 1179,
     /*  3112 */     GIR_Done,
     /*  3113 */   // Label 163: @3113
     /*  3113 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3152), // Rule ID 1820 //
     /*  3118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  3121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3133 */     // (mul:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (MultRxRyRz16:{ *:[i32] }:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  3133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MultRxRyRz16),
     /*  3138 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3144 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3150 */     GIR_RootConstrainSelectedInstOperands,
     /*  3151 */     // GIR_Coverage, 1820,
     /*  3151 */     GIR_Done,
     /*  3152 */   // Label 164: @3152
     /*  3152 */   GIM_Reject,
     /*  3153 */ // Label 159: @3153
     /*  3153 */ GIM_Reject,
     /*  3154 */ // Label 152: @3154
     /*  3154 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3238),
     /*  3159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3177 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3222), // Rule ID 274 //
     /*  3182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  3185 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL:{ *:[i64] }:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL),
     /*  3190 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3196 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3202 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P0), GIMT_Encode2(RegState::Dead),
     /*  3208 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P1), GIMT_Encode2(RegState::Dead),
     /*  3214 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P2), GIMT_Encode2(RegState::Dead),
     /*  3220 */     GIR_RootConstrainSelectedInstOperands,
     /*  3221 */     // GIR_Coverage, 274,
     /*  3221 */     GIR_Done,
     /*  3222 */   // Label 166: @3222
     /*  3222 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3237), // Rule ID 347 //
     /*  3227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3230 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL_R6),
     /*  3235 */     GIR_RootConstrainSelectedInstOperands,
     /*  3236 */     // GIR_Coverage, 347,
     /*  3236 */     GIR_Done,
     /*  3237 */   // Label 167: @3237
     /*  3237 */   GIM_Reject,
     /*  3238 */ // Label 165: @3238
     /*  3238 */ GIM_Reject,
     /*  3239 */ // Label 153: @3239
     /*  3239 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(3270), // Rule ID 1921 //
     /*  3244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /*  3247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  3250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  3253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  3257 */   // (mul:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  3257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /*  3262 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag21), GIMT_Encode2(RegState::Dead),
     /*  3268 */   GIR_RootConstrainSelectedInstOperands,
     /*  3269 */   // GIR_Coverage, 1921,
     /*  3269 */   GIR_Done,
     /*  3270 */ // Label 168: @3270
     /*  3270 */ GIM_Reject,
     /*  3271 */ // Label 154: @3271
     /*  3271 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(3304), // Rule ID 907 //
     /*  3276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3297 */   // (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MULV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_D),
     /*  3302 */   GIR_RootConstrainSelectedInstOperands,
     /*  3303 */   // GIR_Coverage, 907,
     /*  3303 */   GIR_Done,
     /*  3304 */ // Label 169: @3304
     /*  3304 */ GIM_Reject,
     /*  3305 */ // Label 155: @3305
     /*  3305 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3338), // Rule ID 906 //
     /*  3310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3331 */   // (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_W),
     /*  3336 */   GIR_RootConstrainSelectedInstOperands,
     /*  3337 */   // GIR_Coverage, 906,
     /*  3337 */   GIR_Done,
     /*  3338 */ // Label 170: @3338
     /*  3338 */ GIM_Reject,
     /*  3339 */ // Label 156: @3339
     /*  3339 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3372), // Rule ID 905 //
     /*  3344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3365 */   // (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_H),
     /*  3370 */   GIR_RootConstrainSelectedInstOperands,
     /*  3371 */   // GIR_Coverage, 905,
     /*  3371 */   GIR_Done,
     /*  3372 */ // Label 171: @3372
     /*  3372 */ GIM_Reject,
     /*  3373 */ // Label 157: @3373
     /*  3373 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3406), // Rule ID 904 //
     /*  3378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3399 */   // (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MULV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_B),
     /*  3404 */   GIR_RootConstrainSelectedInstOperands,
     /*  3405 */   // GIR_Coverage, 904,
     /*  3405 */   GIR_Done,
     /*  3406 */ // Label 172: @3406
     /*  3406 */ GIM_Reject,
     /*  3407 */ // Label 158: @3407
     /*  3407 */ GIM_Reject,
     /*  3408 */ // Label 3: @3408
     /*  3408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 179*/ GIMT_Encode4(3676),
     /*  3419 */ /*GILLT_s32*//*Label 173*/ GIMT_Encode4(3451),
     /*  3423 */ /*GILLT_s64*//*Label 174*/ GIMT_Encode4(3506), GIMT_Encode4(0),
     /*  3431 */ /*GILLT_v2s64*//*Label 175*/ GIMT_Encode4(3540), GIMT_Encode4(0),
     /*  3439 */ /*GILLT_v4s32*//*Label 176*/ GIMT_Encode4(3574),
     /*  3443 */ /*GILLT_v8s16*//*Label 177*/ GIMT_Encode4(3608),
     /*  3447 */ /*GILLT_v16s8*//*Label 178*/ GIMT_Encode4(3642),
     /*  3451 */ // Label 173: @3451
     /*  3451 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(3505),
     /*  3456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3474 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(3489), // Rule ID 326 //
     /*  3479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3482 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /*  3487 */     GIR_RootConstrainSelectedInstOperands,
     /*  3488 */     // GIR_Coverage, 326,
     /*  3488 */     GIR_Done,
     /*  3489 */   // Label 181: @3489
     /*  3489 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3504), // Rule ID 1172 //
     /*  3494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3497 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_MMR6),
     /*  3502 */     GIR_RootConstrainSelectedInstOperands,
     /*  3503 */     // GIR_Coverage, 1172,
     /*  3503 */     GIR_Done,
     /*  3504 */   // Label 182: @3504
     /*  3504 */   GIM_Reject,
     /*  3505 */ // Label 180: @3505
     /*  3505 */ GIM_Reject,
     /*  3506 */ // Label 174: @3506
     /*  3506 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3539), // Rule ID 341 //
     /*  3511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3532 */   // (sdiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIV),
     /*  3537 */   GIR_RootConstrainSelectedInstOperands,
     /*  3538 */   // GIR_Coverage, 341,
     /*  3538 */   GIR_Done,
     /*  3539 */ // Label 183: @3539
     /*  3539 */ GIM_Reject,
     /*  3540 */ // Label 175: @3540
     /*  3540 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3573), // Rule ID 647 //
     /*  3545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3566 */   // (sdiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_D),
     /*  3571 */   GIR_RootConstrainSelectedInstOperands,
     /*  3572 */   // GIR_Coverage, 647,
     /*  3572 */   GIR_Done,
     /*  3573 */ // Label 184: @3573
     /*  3573 */ GIM_Reject,
     /*  3574 */ // Label 176: @3574
     /*  3574 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3607), // Rule ID 646 //
     /*  3579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3600 */   // (sdiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_W),
     /*  3605 */   GIR_RootConstrainSelectedInstOperands,
     /*  3606 */   // GIR_Coverage, 646,
     /*  3606 */   GIR_Done,
     /*  3607 */ // Label 185: @3607
     /*  3607 */ GIM_Reject,
     /*  3608 */ // Label 177: @3608
     /*  3608 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3641), // Rule ID 645 //
     /*  3613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3634 */   // (sdiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_H),
     /*  3639 */   GIR_RootConstrainSelectedInstOperands,
     /*  3640 */   // GIR_Coverage, 645,
     /*  3640 */   GIR_Done,
     /*  3641 */ // Label 186: @3641
     /*  3641 */ GIM_Reject,
     /*  3642 */ // Label 178: @3642
     /*  3642 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3675), // Rule ID 644 //
     /*  3647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3668 */   // (sdiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_B),
     /*  3673 */   GIR_RootConstrainSelectedInstOperands,
     /*  3674 */   // GIR_Coverage, 644,
     /*  3674 */   GIR_Done,
     /*  3675 */ // Label 187: @3675
     /*  3675 */ GIM_Reject,
     /*  3676 */ // Label 179: @3676
     /*  3676 */ GIM_Reject,
     /*  3677 */ // Label 4: @3677
     /*  3677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 194*/ GIMT_Encode4(3945),
     /*  3688 */ /*GILLT_s32*//*Label 188*/ GIMT_Encode4(3720),
     /*  3692 */ /*GILLT_s64*//*Label 189*/ GIMT_Encode4(3775), GIMT_Encode4(0),
     /*  3700 */ /*GILLT_v2s64*//*Label 190*/ GIMT_Encode4(3809), GIMT_Encode4(0),
     /*  3708 */ /*GILLT_v4s32*//*Label 191*/ GIMT_Encode4(3843),
     /*  3712 */ /*GILLT_v8s16*//*Label 192*/ GIMT_Encode4(3877),
     /*  3716 */ /*GILLT_v16s8*//*Label 193*/ GIMT_Encode4(3911),
     /*  3720 */ // Label 188: @3720
     /*  3720 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3774),
     /*  3725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3743 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3758), // Rule ID 327 //
     /*  3748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3751 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /*  3756 */     GIR_RootConstrainSelectedInstOperands,
     /*  3757 */     // GIR_Coverage, 327,
     /*  3757 */     GIR_Done,
     /*  3758 */   // Label 196: @3758
     /*  3758 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3773), // Rule ID 1173 //
     /*  3763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3766 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU_MMR6),
     /*  3771 */     GIR_RootConstrainSelectedInstOperands,
     /*  3772 */     // GIR_Coverage, 1173,
     /*  3772 */     GIR_Done,
     /*  3773 */   // Label 197: @3773
     /*  3773 */   GIM_Reject,
     /*  3774 */ // Label 195: @3774
     /*  3774 */ GIM_Reject,
     /*  3775 */ // Label 189: @3775
     /*  3775 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3808), // Rule ID 342 //
     /*  3780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3801 */   // (udiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIVU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIVU),
     /*  3806 */   GIR_RootConstrainSelectedInstOperands,
     /*  3807 */   // GIR_Coverage, 342,
     /*  3807 */   GIR_Done,
     /*  3808 */ // Label 198: @3808
     /*  3808 */ GIM_Reject,
     /*  3809 */ // Label 190: @3809
     /*  3809 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3842), // Rule ID 651 //
     /*  3814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3835 */   // (udiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_D),
     /*  3840 */   GIR_RootConstrainSelectedInstOperands,
     /*  3841 */   // GIR_Coverage, 651,
     /*  3841 */   GIR_Done,
     /*  3842 */ // Label 199: @3842
     /*  3842 */ GIM_Reject,
     /*  3843 */ // Label 191: @3843
     /*  3843 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3876), // Rule ID 650 //
     /*  3848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3869 */   // (udiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_W),
     /*  3874 */   GIR_RootConstrainSelectedInstOperands,
     /*  3875 */   // GIR_Coverage, 650,
     /*  3875 */   GIR_Done,
     /*  3876 */ // Label 200: @3876
     /*  3876 */ GIM_Reject,
     /*  3877 */ // Label 192: @3877
     /*  3877 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3910), // Rule ID 649 //
     /*  3882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3903 */   // (udiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_H),
     /*  3908 */   GIR_RootConstrainSelectedInstOperands,
     /*  3909 */   // GIR_Coverage, 649,
     /*  3909 */   GIR_Done,
     /*  3910 */ // Label 201: @3910
     /*  3910 */ GIM_Reject,
     /*  3911 */ // Label 193: @3911
     /*  3911 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3944), // Rule ID 648 //
     /*  3916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3937 */   // (udiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_B),
     /*  3942 */   GIR_RootConstrainSelectedInstOperands,
     /*  3943 */   // GIR_Coverage, 648,
     /*  3943 */   GIR_Done,
     /*  3944 */ // Label 202: @3944
     /*  3944 */ GIM_Reject,
     /*  3945 */ // Label 194: @3945
     /*  3945 */ GIM_Reject,
     /*  3946 */ // Label 5: @3946
     /*  3946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 209*/ GIMT_Encode4(4214),
     /*  3957 */ /*GILLT_s32*//*Label 203*/ GIMT_Encode4(3989),
     /*  3961 */ /*GILLT_s64*//*Label 204*/ GIMT_Encode4(4044), GIMT_Encode4(0),
     /*  3969 */ /*GILLT_v2s64*//*Label 205*/ GIMT_Encode4(4078), GIMT_Encode4(0),
     /*  3977 */ /*GILLT_v4s32*//*Label 206*/ GIMT_Encode4(4112),
     /*  3981 */ /*GILLT_v8s16*//*Label 207*/ GIMT_Encode4(4146),
     /*  3985 */ /*GILLT_v16s8*//*Label 208*/ GIMT_Encode4(4180),
     /*  3989 */ // Label 203: @3989
     /*  3989 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(4043),
     /*  3994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4012 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4027), // Rule ID 328 //
     /*  4017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4020 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /*  4025 */     GIR_RootConstrainSelectedInstOperands,
     /*  4026 */     // GIR_Coverage, 328,
     /*  4026 */     GIR_Done,
     /*  4027 */   // Label 211: @4027
     /*  4027 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4042), // Rule ID 1177 //
     /*  4032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4035 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_MMR6),
     /*  4040 */     GIR_RootConstrainSelectedInstOperands,
     /*  4041 */     // GIR_Coverage, 1177,
     /*  4041 */     GIR_Done,
     /*  4042 */   // Label 212: @4042
     /*  4042 */   GIM_Reject,
     /*  4043 */ // Label 210: @4043
     /*  4043 */ GIM_Reject,
     /*  4044 */ // Label 204: @4044
     /*  4044 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4077), // Rule ID 343 //
     /*  4049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4070 */   // (srem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMOD:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMOD),
     /*  4075 */   GIR_RootConstrainSelectedInstOperands,
     /*  4076 */   // GIR_Coverage, 343,
     /*  4076 */   GIR_Done,
     /*  4077 */ // Label 213: @4077
     /*  4077 */ GIM_Reject,
     /*  4078 */ // Label 205: @4078
     /*  4078 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4111), // Rule ID 887 //
     /*  4083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4104 */   // (srem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_D),
     /*  4109 */   GIR_RootConstrainSelectedInstOperands,
     /*  4110 */   // GIR_Coverage, 887,
     /*  4110 */   GIR_Done,
     /*  4111 */ // Label 214: @4111
     /*  4111 */ GIM_Reject,
     /*  4112 */ // Label 206: @4112
     /*  4112 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4145), // Rule ID 886 //
     /*  4117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4138 */   // (srem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_W),
     /*  4143 */   GIR_RootConstrainSelectedInstOperands,
     /*  4144 */   // GIR_Coverage, 886,
     /*  4144 */   GIR_Done,
     /*  4145 */ // Label 215: @4145
     /*  4145 */ GIM_Reject,
     /*  4146 */ // Label 207: @4146
     /*  4146 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4179), // Rule ID 885 //
     /*  4151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4172 */   // (srem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_H),
     /*  4177 */   GIR_RootConstrainSelectedInstOperands,
     /*  4178 */   // GIR_Coverage, 885,
     /*  4178 */   GIR_Done,
     /*  4179 */ // Label 216: @4179
     /*  4179 */ GIM_Reject,
     /*  4180 */ // Label 208: @4180
     /*  4180 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(4213), // Rule ID 884 //
     /*  4185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4206 */   // (srem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_B),
     /*  4211 */   GIR_RootConstrainSelectedInstOperands,
     /*  4212 */   // GIR_Coverage, 884,
     /*  4212 */   GIR_Done,
     /*  4213 */ // Label 217: @4213
     /*  4213 */ GIM_Reject,
     /*  4214 */ // Label 209: @4214
     /*  4214 */ GIM_Reject,
     /*  4215 */ // Label 6: @4215
     /*  4215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 224*/ GIMT_Encode4(4483),
     /*  4226 */ /*GILLT_s32*//*Label 218*/ GIMT_Encode4(4258),
     /*  4230 */ /*GILLT_s64*//*Label 219*/ GIMT_Encode4(4313), GIMT_Encode4(0),
     /*  4238 */ /*GILLT_v2s64*//*Label 220*/ GIMT_Encode4(4347), GIMT_Encode4(0),
     /*  4246 */ /*GILLT_v4s32*//*Label 221*/ GIMT_Encode4(4381),
     /*  4250 */ /*GILLT_v8s16*//*Label 222*/ GIMT_Encode4(4415),
     /*  4254 */ /*GILLT_v16s8*//*Label 223*/ GIMT_Encode4(4449),
     /*  4258 */ // Label 218: @4258
     /*  4258 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4312),
     /*  4263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4281 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4296), // Rule ID 329 //
     /*  4286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4289 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /*  4294 */     GIR_RootConstrainSelectedInstOperands,
     /*  4295 */     // GIR_Coverage, 329,
     /*  4295 */     GIR_Done,
     /*  4296 */   // Label 226: @4296
     /*  4296 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4311), // Rule ID 1178 //
     /*  4301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4304 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU_MMR6),
     /*  4309 */     GIR_RootConstrainSelectedInstOperands,
     /*  4310 */     // GIR_Coverage, 1178,
     /*  4310 */     GIR_Done,
     /*  4311 */   // Label 227: @4311
     /*  4311 */   GIM_Reject,
     /*  4312 */ // Label 225: @4312
     /*  4312 */ GIM_Reject,
     /*  4313 */ // Label 219: @4313
     /*  4313 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4346), // Rule ID 344 //
     /*  4318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4339 */   // (urem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMODU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMODU),
     /*  4344 */   GIR_RootConstrainSelectedInstOperands,
     /*  4345 */   // GIR_Coverage, 344,
     /*  4345 */   GIR_Done,
     /*  4346 */ // Label 228: @4346
     /*  4346 */ GIM_Reject,
     /*  4347 */ // Label 220: @4347
     /*  4347 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4380), // Rule ID 891 //
     /*  4352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4373 */   // (urem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_D),
     /*  4378 */   GIR_RootConstrainSelectedInstOperands,
     /*  4379 */   // GIR_Coverage, 891,
     /*  4379 */   GIR_Done,
     /*  4380 */ // Label 229: @4380
     /*  4380 */ GIM_Reject,
     /*  4381 */ // Label 221: @4381
     /*  4381 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4414), // Rule ID 890 //
     /*  4386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4407 */   // (urem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_W),
     /*  4412 */   GIR_RootConstrainSelectedInstOperands,
     /*  4413 */   // GIR_Coverage, 890,
     /*  4413 */   GIR_Done,
     /*  4414 */ // Label 230: @4414
     /*  4414 */ GIM_Reject,
     /*  4415 */ // Label 222: @4415
     /*  4415 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4448), // Rule ID 889 //
     /*  4420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4441 */   // (urem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_H),
     /*  4446 */   GIR_RootConstrainSelectedInstOperands,
     /*  4447 */   // GIR_Coverage, 889,
     /*  4447 */   GIR_Done,
     /*  4448 */ // Label 231: @4448
     /*  4448 */ GIM_Reject,
     /*  4449 */ // Label 223: @4449
     /*  4449 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4482), // Rule ID 888 //
     /*  4454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4475 */   // (urem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_B),
     /*  4480 */   GIR_RootConstrainSelectedInstOperands,
     /*  4481 */   // GIR_Coverage, 888,
     /*  4481 */   GIR_Done,
     /*  4482 */ // Label 232: @4482
     /*  4482 */ GIM_Reject,
     /*  4483 */ // Label 224: @4483
     /*  4483 */ GIM_Reject,
     /*  4484 */ // Label 7: @4484
     /*  4484 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 239*/ GIMT_Encode4(5039),
     /*  4495 */ /*GILLT_s32*//*Label 233*/ GIMT_Encode4(4527),
     /*  4499 */ /*GILLT_s64*//*Label 234*/ GIMT_Encode4(4801), GIMT_Encode4(0),
     /*  4507 */ /*GILLT_v2s64*//*Label 235*/ GIMT_Encode4(4903), GIMT_Encode4(0),
     /*  4515 */ /*GILLT_v4s32*//*Label 236*/ GIMT_Encode4(4937),
     /*  4519 */ /*GILLT_v8s16*//*Label 237*/ GIMT_Encode4(4971),
     /*  4523 */ /*GILLT_v16s8*//*Label 238*/ GIMT_Encode4(5005),
     /*  4527 */ // Label 233: @4527
     /*  4527 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(4800),
     /*  4532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4538 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(4580), // Rule ID 41 //
     /*  4543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4562 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  4566 */     // MIs[1] Operand 1
     /*  4566 */     // No operand predicates
     /*  4566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4568 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ANDi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  4568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDi),
     /*  4571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  4573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  4575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  4578 */     GIR_RootConstrainSelectedInstOperands,
     /*  4579 */     // GIR_Coverage, 41,
     /*  4579 */     GIR_EraseRootFromParent_Done,
     /*  4580 */   // Label 241: @4580
     /*  4580 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(4622), // Rule ID 2161 //
     /*  4585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  4588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4608 */     // MIs[1] Operand 1
     /*  4608 */     // No operand predicates
     /*  4608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4610 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MM),
     /*  4613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4620 */     GIR_RootConstrainSelectedInstOperands,
     /*  4621 */     // GIR_Coverage, 2161,
     /*  4621 */     GIR_EraseRootFromParent_Done,
     /*  4622 */   // Label 242: @4622
     /*  4622 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(4664), // Rule ID 2320 //
     /*  4627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4650 */     // MIs[1] Operand 1
     /*  4650 */     // No operand predicates
     /*  4650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4652 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MMR6),
     /*  4655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4662 */     GIR_RootConstrainSelectedInstOperands,
     /*  4663 */     // GIR_Coverage, 2320,
     /*  4663 */     GIR_EraseRootFromParent_Done,
     /*  4664 */   // Label 243: @4664
     /*  4664 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(4691), // Rule ID 51 //
     /*  4669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4684 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND),
     /*  4689 */     GIR_RootConstrainSelectedInstOperands,
     /*  4690 */     // GIR_Coverage, 51,
     /*  4690 */     GIR_Done,
     /*  4691 */   // Label 244: @4691
     /*  4691 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(4718), // Rule ID 1061 //
     /*  4696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4711 */     // (and:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (AND16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  4711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND16_MM),
     /*  4716 */     GIR_RootConstrainSelectedInstOperands,
     /*  4717 */     // GIR_Coverage, 1061,
     /*  4717 */     GIR_Done,
     /*  4718 */   // Label 245: @4718
     /*  4718 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(4745), // Rule ID 1077 //
     /*  4723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4738 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MM),
     /*  4743 */     GIR_RootConstrainSelectedInstOperands,
     /*  4744 */     // GIR_Coverage, 1077,
     /*  4744 */     GIR_Done,
     /*  4745 */   // Label 246: @4745
     /*  4745 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(4772), // Rule ID 1170 //
     /*  4750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4765 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MMR6),
     /*  4770 */     GIR_RootConstrainSelectedInstOperands,
     /*  4771 */     // GIR_Coverage, 1170,
     /*  4771 */     GIR_Done,
     /*  4772 */   // Label 247: @4772
     /*  4772 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(4799), // Rule ID 1819 //
     /*  4777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  4780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4792 */     // (and:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AndRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  4792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AndRxRxRy16),
     /*  4797 */     GIR_RootConstrainSelectedInstOperands,
     /*  4798 */     // GIR_Coverage, 1819,
     /*  4798 */     GIR_Done,
     /*  4799 */   // Label 248: @4799
     /*  4799 */   GIM_Reject,
     /*  4800 */ // Label 240: @4800
     /*  4800 */ GIM_Reject,
     /*  4801 */ // Label 234: @4801
     /*  4801 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4902),
     /*  4806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4816 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4878), // Rule ID 269 //
     /*  4821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  4824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  4828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  4832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  4836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  4840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4850 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  4861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4863 */     // (and:{ *:[i64] } (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), 255:{ *:[i64] })  =>  (BADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BADDu),
     /*  4866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  4872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  4876 */     GIR_RootConstrainSelectedInstOperands,
     /*  4877 */     // GIR_Coverage, 269,
     /*  4877 */     GIR_EraseRootFromParent_Done,
     /*  4878 */   // Label 250: @4878
     /*  4878 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4901), // Rule ID 206 //
     /*  4883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  4886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4894 */     // (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (AND64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND64),
     /*  4899 */     GIR_RootConstrainSelectedInstOperands,
     /*  4900 */     // GIR_Coverage, 206,
     /*  4900 */     GIR_Done,
     /*  4901 */   // Label 251: @4901
     /*  4901 */   GIM_Reject,
     /*  4902 */ // Label 249: @4902
     /*  4902 */ GIM_Reject,
     /*  4903 */ // Label 235: @4903
     /*  4903 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4936), // Rule ID 518 //
     /*  4908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4929 */   // (and:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AND_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_D_PSEUDO),
     /*  4934 */   GIR_RootConstrainSelectedInstOperands,
     /*  4935 */   // GIR_Coverage, 518,
     /*  4935 */   GIR_Done,
     /*  4936 */ // Label 252: @4936
     /*  4936 */ GIM_Reject,
     /*  4937 */ // Label 236: @4937
     /*  4937 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4970), // Rule ID 517 //
     /*  4942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4963 */   // (and:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AND_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_W_PSEUDO),
     /*  4968 */   GIR_RootConstrainSelectedInstOperands,
     /*  4969 */   // GIR_Coverage, 517,
     /*  4969 */   GIR_Done,
     /*  4970 */ // Label 253: @4970
     /*  4970 */ GIM_Reject,
     /*  4971 */ // Label 237: @4971
     /*  4971 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5004), // Rule ID 516 //
     /*  4976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4997 */   // (and:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AND_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_H_PSEUDO),
     /*  5002 */   GIR_RootConstrainSelectedInstOperands,
     /*  5003 */   // GIR_Coverage, 516,
     /*  5003 */   GIR_Done,
     /*  5004 */ // Label 254: @5004
     /*  5004 */ GIM_Reject,
     /*  5005 */ // Label 238: @5005
     /*  5005 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5038), // Rule ID 515 //
     /*  5010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5031 */   // (and:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AND_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V),
     /*  5036 */   GIR_RootConstrainSelectedInstOperands,
     /*  5037 */   // GIR_Coverage, 515,
     /*  5037 */   GIR_Done,
     /*  5038 */ // Label 255: @5038
     /*  5038 */ GIM_Reject,
     /*  5039 */ // Label 239: @5039
     /*  5039 */ GIM_Reject,
     /*  5040 */ // Label 8: @5040
     /*  5040 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 262*/ GIMT_Encode4(5443),
     /*  5051 */ /*GILLT_s32*//*Label 256*/ GIMT_Encode4(5083),
     /*  5055 */ /*GILLT_s64*//*Label 257*/ GIMT_Encode4(5273), GIMT_Encode4(0),
     /*  5063 */ /*GILLT_v2s64*//*Label 258*/ GIMT_Encode4(5307), GIMT_Encode4(0),
     /*  5071 */ /*GILLT_v4s32*//*Label 259*/ GIMT_Encode4(5341),
     /*  5075 */ /*GILLT_v8s16*//*Label 260*/ GIMT_Encode4(5375),
     /*  5079 */ /*GILLT_v16s8*//*Label 261*/ GIMT_Encode4(5409),
     /*  5083 */ // Label 256: @5083
     /*  5083 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5272),
     /*  5088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5094 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(5136), // Rule ID 42 //
     /*  5099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5118 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5122 */     // MIs[1] Operand 1
     /*  5122 */     // No operand predicates
     /*  5122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5124 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ORi),
     /*  5127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5134 */     GIR_RootConstrainSelectedInstOperands,
     /*  5135 */     // GIR_Coverage, 42,
     /*  5135 */     GIR_EraseRootFromParent_Done,
     /*  5136 */   // Label 264: @5136
     /*  5136 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5163), // Rule ID 52 //
     /*  5141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5156 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR),
     /*  5161 */     GIR_RootConstrainSelectedInstOperands,
     /*  5162 */     // GIR_Coverage, 52,
     /*  5162 */     GIR_Done,
     /*  5163 */   // Label 265: @5163
     /*  5163 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5190), // Rule ID 1063 //
     /*  5168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5183 */     // (or:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (OR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  5183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR16_MM),
     /*  5188 */     GIR_RootConstrainSelectedInstOperands,
     /*  5189 */     // GIR_Coverage, 1063,
     /*  5189 */     GIR_Done,
     /*  5190 */   // Label 266: @5190
     /*  5190 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(5217), // Rule ID 1078 //
     /*  5195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5210 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /*  5215 */     GIR_RootConstrainSelectedInstOperands,
     /*  5216 */     // GIR_Coverage, 1078,
     /*  5216 */     GIR_Done,
     /*  5217 */   // Label 267: @5217
     /*  5217 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(5244), // Rule ID 1183 //
     /*  5222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5237 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MMR6),
     /*  5242 */     GIR_RootConstrainSelectedInstOperands,
     /*  5243 */     // GIR_Coverage, 1183,
     /*  5243 */     GIR_Done,
     /*  5244 */   // Label 268: @5244
     /*  5244 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(5271), // Rule ID 1821 //
     /*  5249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5264 */     // (or:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (OrRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  5264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OrRxRxRy16),
     /*  5269 */     GIR_RootConstrainSelectedInstOperands,
     /*  5270 */     // GIR_Coverage, 1821,
     /*  5270 */     GIR_Done,
     /*  5271 */   // Label 269: @5271
     /*  5271 */   GIM_Reject,
     /*  5272 */ // Label 263: @5272
     /*  5272 */ GIM_Reject,
     /*  5273 */ // Label 257: @5273
     /*  5273 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(5306), // Rule ID 207 //
     /*  5278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  5281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  5284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  5287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5299 */   // (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (OR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  5299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /*  5304 */   GIR_RootConstrainSelectedInstOperands,
     /*  5305 */   // GIR_Coverage, 207,
     /*  5305 */   GIR_Done,
     /*  5306 */ // Label 270: @5306
     /*  5306 */ GIM_Reject,
     /*  5307 */ // Label 258: @5307
     /*  5307 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(5340), // Rule ID 924 //
     /*  5312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  5318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  5321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5333 */   // (or:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (OR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  5333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_D_PSEUDO),
     /*  5338 */   GIR_RootConstrainSelectedInstOperands,
     /*  5339 */   // GIR_Coverage, 924,
     /*  5339 */   GIR_Done,
     /*  5340 */ // Label 271: @5340
     /*  5340 */ GIM_Reject,
     /*  5341 */ // Label 259: @5341
     /*  5341 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(5374), // Rule ID 923 //
     /*  5346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  5352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  5355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5367 */   // (or:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (OR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  5367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_W_PSEUDO),
     /*  5372 */   GIR_RootConstrainSelectedInstOperands,
     /*  5373 */   // GIR_Coverage, 923,
     /*  5373 */   GIR_Done,
     /*  5374 */ // Label 272: @5374
     /*  5374 */ GIM_Reject,
     /*  5375 */ // Label 260: @5375
     /*  5375 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(5408), // Rule ID 922 //
     /*  5380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  5386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  5389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5401 */   // (or:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (OR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_H_PSEUDO),
     /*  5406 */   GIR_RootConstrainSelectedInstOperands,
     /*  5407 */   // GIR_Coverage, 922,
     /*  5407 */   GIR_Done,
     /*  5408 */ // Label 273: @5408
     /*  5408 */ GIM_Reject,
     /*  5409 */ // Label 261: @5409
     /*  5409 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(5442), // Rule ID 921 //
     /*  5414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5435 */   // (or:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (OR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V),
     /*  5440 */   GIR_RootConstrainSelectedInstOperands,
     /*  5441 */   // GIR_Coverage, 921,
     /*  5441 */   GIR_Done,
     /*  5442 */ // Label 274: @5442
     /*  5442 */ GIM_Reject,
     /*  5443 */ // Label 262: @5443
     /*  5443 */ GIM_Reject,
     /*  5444 */ // Label 9: @5444
     /*  5444 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 281*/ GIMT_Encode4(6335),
     /*  5455 */ /*GILLT_s32*//*Label 275*/ GIMT_Encode4(5487),
     /*  5459 */ /*GILLT_s64*//*Label 276*/ GIMT_Encode4(6104), GIMT_Encode4(0),
     /*  5467 */ /*GILLT_v2s64*//*Label 277*/ GIMT_Encode4(6199), GIMT_Encode4(0),
     /*  5475 */ /*GILLT_v4s32*//*Label 278*/ GIMT_Encode4(6233),
     /*  5479 */ /*GILLT_v8s16*//*Label 279*/ GIMT_Encode4(6267),
     /*  5483 */ /*GILLT_v16s8*//*Label 280*/ GIMT_Encode4(6301),
     /*  5487 */ // Label 275: @5487
     /*  5487 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(6103),
     /*  5492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5498 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(5557), // Rule ID 54 //
     /*  5503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5542 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5555 */     GIR_RootConstrainSelectedInstOperands,
     /*  5556 */     // GIR_Coverage, 54,
     /*  5556 */     GIR_EraseRootFromParent_Done,
     /*  5557 */   // Label 283: @5557
     /*  5557 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(5616), // Rule ID 1080 //
     /*  5562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5601 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5614 */     GIR_RootConstrainSelectedInstOperands,
     /*  5615 */     // GIR_Coverage, 1080,
     /*  5615 */     GIR_EraseRootFromParent_Done,
     /*  5616 */   // Label 284: @5616
     /*  5616 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(5675), // Rule ID 1182 //
     /*  5621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5660 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5673 */     GIR_RootConstrainSelectedInstOperands,
     /*  5674 */     // GIR_Coverage, 1182,
     /*  5674 */     GIR_EraseRootFromParent_Done,
     /*  5675 */   // Label 285: @5675
     /*  5675 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(5704), // Rule ID 1209 //
     /*  5680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5695 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5702 */     GIR_RootConstrainSelectedInstOperands,
     /*  5703 */     // GIR_Coverage, 1209,
     /*  5703 */     GIR_EraseRootFromParent_Done,
     /*  5704 */   // Label 286: @5704
     /*  5704 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(5733), // Rule ID 1062 //
     /*  5709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5724 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5731 */     GIR_RootConstrainSelectedInstOperands,
     /*  5732 */     // GIR_Coverage, 1062,
     /*  5732 */     GIR_EraseRootFromParent_Done,
     /*  5733 */   // Label 287: @5733
     /*  5733 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(5768), // Rule ID 1397 //
     /*  5738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5753 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5758 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5766 */     GIR_RootConstrainSelectedInstOperands,
     /*  5767 */     // GIR_Coverage, 1397,
     /*  5767 */     GIR_EraseRootFromParent_Done,
     /*  5768 */   // Label 288: @5768
     /*  5768 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(5797), // Rule ID 1816 //
     /*  5773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5788 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, -1:{ *:[i32] })  =>  (NotRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  5788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NotRxRy16),
     /*  5791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  5793 */     GIR_RootToRootCopy, /*OpIdx*/1, // r
     /*  5795 */     GIR_RootConstrainSelectedInstOperands,
     /*  5796 */     // GIR_Coverage, 1816,
     /*  5796 */     GIR_EraseRootFromParent_Done,
     /*  5797 */   // Label 289: @5797
     /*  5797 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(5826), // Rule ID 2156 //
     /*  5802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5817 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5822 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5824 */     GIR_RootConstrainSelectedInstOperands,
     /*  5825 */     // GIR_Coverage, 2156,
     /*  5825 */     GIR_EraseRootFromParent_Done,
     /*  5826 */   // Label 290: @5826
     /*  5826 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(5861), // Rule ID 2157 //
     /*  5831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5846 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5851 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5859 */     GIR_RootConstrainSelectedInstOperands,
     /*  5860 */     // GIR_Coverage, 2157,
     /*  5860 */     GIR_EraseRootFromParent_Done,
     /*  5861 */   // Label 291: @5861
     /*  5861 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(5890), // Rule ID 2323 //
     /*  5866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5881 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5886 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5888 */     GIR_RootConstrainSelectedInstOperands,
     /*  5889 */     // GIR_Coverage, 2323,
     /*  5889 */     GIR_EraseRootFromParent_Done,
     /*  5890 */   // Label 292: @5890
     /*  5890 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(5925), // Rule ID 2324 //
     /*  5895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5910 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5915 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5923 */     GIR_RootConstrainSelectedInstOperands,
     /*  5924 */     // GIR_Coverage, 2324,
     /*  5924 */     GIR_EraseRootFromParent_Done,
     /*  5925 */   // Label 293: @5925
     /*  5925 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(5967), // Rule ID 43 //
     /*  5930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5949 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5953 */     // MIs[1] Operand 1
     /*  5953 */     // No operand predicates
     /*  5953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5955 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (XORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /*  5958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5965 */     GIR_RootConstrainSelectedInstOperands,
     /*  5966 */     // GIR_Coverage, 43,
     /*  5966 */     GIR_EraseRootFromParent_Done,
     /*  5967 */   // Label 294: @5967
     /*  5967 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(5994), // Rule ID 53 //
     /*  5972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5987 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /*  5992 */     GIR_RootConstrainSelectedInstOperands,
     /*  5993 */     // GIR_Coverage, 53,
     /*  5993 */     GIR_Done,
     /*  5994 */   // Label 295: @5994
     /*  5994 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(6021), // Rule ID 1065 //
     /*  5999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6014 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (XOR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  6014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR16_MM),
     /*  6019 */     GIR_RootConstrainSelectedInstOperands,
     /*  6020 */     // GIR_Coverage, 1065,
     /*  6020 */     GIR_Done,
     /*  6021 */   // Label 296: @6021
     /*  6021 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(6048), // Rule ID 1079 //
     /*  6026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6041 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /*  6046 */     GIR_RootConstrainSelectedInstOperands,
     /*  6047 */     // GIR_Coverage, 1079,
     /*  6047 */     GIR_Done,
     /*  6048 */   // Label 297: @6048
     /*  6048 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(6075), // Rule ID 1186 //
     /*  6053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  6056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6068 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MMR6),
     /*  6073 */     GIR_RootConstrainSelectedInstOperands,
     /*  6074 */     // GIR_Coverage, 1186,
     /*  6074 */     GIR_Done,
     /*  6075 */   // Label 298: @6075
     /*  6075 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(6102), // Rule ID 1823 //
     /*  6080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  6083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6095 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  6095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /*  6100 */     GIR_RootConstrainSelectedInstOperands,
     /*  6101 */     // GIR_Coverage, 1823,
     /*  6101 */     GIR_Done,
     /*  6102 */   // Label 299: @6102
     /*  6102 */   GIM_Reject,
     /*  6103 */ // Label 282: @6103
     /*  6103 */ GIM_Reject,
     /*  6104 */ // Label 276: @6104
     /*  6104 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(6198),
     /*  6109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  6115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6119 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(6174), // Rule ID 209 //
     /*  6124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  6135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  6139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  6143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  6157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6159 */     // (xor:{ *:[i64] } (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), -1:{ *:[i64] })  =>  (NOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR64),
     /*  6162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  6164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  6168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  6172 */     GIR_RootConstrainSelectedInstOperands,
     /*  6173 */     // GIR_Coverage, 209,
     /*  6173 */     GIR_EraseRootFromParent_Done,
     /*  6174 */   // Label 301: @6174
     /*  6174 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(6197), // Rule ID 208 //
     /*  6179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6190 */     // (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (XOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /*  6195 */     GIR_RootConstrainSelectedInstOperands,
     /*  6196 */     // GIR_Coverage, 208,
     /*  6196 */     GIR_Done,
     /*  6197 */   // Label 302: @6197
     /*  6197 */   GIM_Reject,
     /*  6198 */ // Label 300: @6198
     /*  6198 */ GIM_Reject,
     /*  6199 */ // Label 277: @6199
     /*  6199 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(6232), // Rule ID 1040 //
     /*  6204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  6210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  6213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6225 */   // (xor:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (XOR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  6225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_D_PSEUDO),
     /*  6230 */   GIR_RootConstrainSelectedInstOperands,
     /*  6231 */   // GIR_Coverage, 1040,
     /*  6231 */   GIR_Done,
     /*  6232 */ // Label 303: @6232
     /*  6232 */ GIM_Reject,
     /*  6233 */ // Label 278: @6233
     /*  6233 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(6266), // Rule ID 1039 //
     /*  6238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  6244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  6247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6259 */   // (xor:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (XOR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  6259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_W_PSEUDO),
     /*  6264 */   GIR_RootConstrainSelectedInstOperands,
     /*  6265 */   // GIR_Coverage, 1039,
     /*  6265 */   GIR_Done,
     /*  6266 */ // Label 304: @6266
     /*  6266 */ GIM_Reject,
     /*  6267 */ // Label 279: @6267
     /*  6267 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(6300), // Rule ID 1038 //
     /*  6272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  6278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  6281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6293 */   // (xor:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (XOR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  6293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_H_PSEUDO),
     /*  6298 */   GIR_RootConstrainSelectedInstOperands,
     /*  6299 */   // GIR_Coverage, 1038,
     /*  6299 */   GIR_Done,
     /*  6300 */ // Label 305: @6300
     /*  6300 */ GIM_Reject,
     /*  6301 */ // Label 280: @6301
     /*  6301 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(6334), // Rule ID 1037 //
     /*  6306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  6312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  6315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6327 */   // (xor:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (XOR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  6327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V),
     /*  6332 */   GIR_RootConstrainSelectedInstOperands,
     /*  6333 */   // GIR_Coverage, 1037,
     /*  6333 */   GIR_Done,
     /*  6334 */ // Label 306: @6334
     /*  6334 */ GIM_Reject,
     /*  6335 */ // Label 281: @6335
     /*  6335 */ GIM_Reject,
     /*  6336 */ // Label 10: @6336
     /*  6336 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(6408),
     /*  6341 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6344 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  6347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  6353 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(6380), // Rule ID 180 //
     /*  6358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode),
     /*  6361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /*  6365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6373 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64),
     /*  6378 */     GIR_RootConstrainSelectedInstOperands,
     /*  6379 */     // GIR_Coverage, 180,
     /*  6379 */     GIR_Done,
     /*  6380 */   // Label 308: @6380
     /*  6380 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(6407), // Rule ID 181 //
     /*  6385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode),
     /*  6388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6400 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64_64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64_64),
     /*  6405 */     GIR_RootConstrainSelectedInstOperands,
     /*  6406 */     // GIR_Coverage, 181,
     /*  6406 */     GIR_Done,
     /*  6407 */   // Label 309: @6407
     /*  6407 */   GIM_Reject,
     /*  6408 */ // Label 307: @6408
     /*  6408 */ GIM_Reject,
     /*  6409 */ // Label 11: @6409
     /*  6409 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(6480),
     /*  6414 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6417 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  6420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6427 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(6453), // Rule ID 719 //
     /*  6432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  6435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6439 */     // MIs[0] rs
     /*  6439 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6444 */     // (build_vector:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rs)  =>  (FILL_D:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /*  6444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_D),
     /*  6447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6451 */     GIR_RootConstrainSelectedInstOperands,
     /*  6452 */     // GIR_Coverage, 719,
     /*  6452 */     GIR_EraseRootFromParent_Done,
     /*  6453 */   // Label 311: @6453
     /*  6453 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(6479), // Rule ID 721 //
     /*  6458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6465 */     // MIs[0] fs
     /*  6465 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6470 */     // (build_vector:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs, FGR64:{ *:[f64] }:$fs)  =>  (FILL_FD_PSEUDO:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs)
     /*  6470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FD_PSEUDO),
     /*  6473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6475 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6477 */     GIR_RootConstrainSelectedInstOperands,
     /*  6478 */     // GIR_Coverage, 721,
     /*  6478 */     GIR_EraseRootFromParent_Done,
     /*  6479 */   // Label 312: @6479
     /*  6479 */   GIM_Reject,
     /*  6480 */ // Label 310: @6480
     /*  6480 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(6571),
     /*  6485 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  6488 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  6491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6498 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(6534), // Rule ID 718 //
     /*  6503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6510 */     // MIs[0] rs
     /*  6510 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6515 */     // MIs[0] rs
     /*  6515 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6520 */     // MIs[0] rs
     /*  6520 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6525 */     // (build_vector:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_W:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_W),
     /*  6528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6532 */     GIR_RootConstrainSelectedInstOperands,
     /*  6533 */     // GIR_Coverage, 718,
     /*  6533 */     GIR_EraseRootFromParent_Done,
     /*  6534 */   // Label 314: @6534
     /*  6534 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(6570), // Rule ID 720 //
     /*  6539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6546 */     // MIs[0] fs
     /*  6546 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6551 */     // MIs[0] fs
     /*  6551 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6556 */     // MIs[0] fs
     /*  6556 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6561 */     // (build_vector:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs)  =>  (FILL_FW_PSEUDO:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs)
     /*  6561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FW_PSEUDO),
     /*  6564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6566 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6568 */     GIR_RootConstrainSelectedInstOperands,
     /*  6569 */     // GIR_Coverage, 720,
     /*  6569 */     GIR_EraseRootFromParent_Done,
     /*  6570 */   // Label 315: @6570
     /*  6570 */   GIM_Reject,
     /*  6571 */ // Label 313: @6571
     /*  6571 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(6640), // Rule ID 717 //
     /*  6576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6579 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /*  6582 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  6585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6596 */   // MIs[0] rs
     /*  6596 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6601 */   // MIs[0] rs
     /*  6601 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6606 */   // MIs[0] rs
     /*  6606 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6611 */   // MIs[0] rs
     /*  6611 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6616 */   // MIs[0] rs
     /*  6616 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6621 */   // MIs[0] rs
     /*  6621 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6626 */   // MIs[0] rs
     /*  6626 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6631 */   // (build_vector:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_H:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_H),
     /*  6634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6636 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6638 */   GIR_RootConstrainSelectedInstOperands,
     /*  6639 */   // GIR_Coverage, 717,
     /*  6639 */   GIR_EraseRootFromParent_Done,
     /*  6640 */ // Label 316: @6640
     /*  6640 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(6749), // Rule ID 716 //
     /*  6645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6648 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  6651 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  6654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6665 */   // MIs[0] rs
     /*  6665 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6670 */   // MIs[0] rs
     /*  6670 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6675 */   // MIs[0] rs
     /*  6675 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6680 */   // MIs[0] rs
     /*  6680 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6685 */   // MIs[0] rs
     /*  6685 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6690 */   // MIs[0] rs
     /*  6690 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6695 */   // MIs[0] rs
     /*  6695 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6700 */   // MIs[0] rs
     /*  6700 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6705 */   // MIs[0] rs
     /*  6705 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6710 */   // MIs[0] rs
     /*  6710 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6715 */   // MIs[0] rs
     /*  6715 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6720 */   // MIs[0] rs
     /*  6720 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6725 */   // MIs[0] rs
     /*  6725 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6730 */   // MIs[0] rs
     /*  6730 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6735 */   // MIs[0] rs
     /*  6735 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6740 */   // (build_vector:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_B:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_B),
     /*  6743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6747 */   GIR_RootConstrainSelectedInstOperands,
     /*  6748 */   // GIR_Coverage, 716,
     /*  6748 */   GIR_EraseRootFromParent_Done,
     /*  6749 */ // Label 317: @6749
     /*  6749 */ GIM_Reject,
     /*  6750 */ // Label 12: @6750
     /*  6750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 326*/ GIMT_Encode4(11060),
     /*  6761 */ /*GILLT_s32*//*Label 318*/ GIMT_Encode4(6793),
     /*  6765 */ /*GILLT_s64*//*Label 319*/ GIMT_Encode4(7070),
     /*  6769 */ /*GILLT_v2s16*//*Label 320*/ GIMT_Encode4(7126),
     /*  6773 */ /*GILLT_v2s64*//*Label 321*/ GIMT_Encode4(7186),
     /*  6777 */ /*GILLT_v4s8*//*Label 322*/ GIMT_Encode4(8321),
     /*  6781 */ /*GILLT_v4s32*//*Label 323*/ GIMT_Encode4(8381),
     /*  6785 */ /*GILLT_v8s16*//*Label 324*/ GIMT_Encode4(9450),
     /*  6789 */ /*GILLT_v16s8*//*Label 325*/ GIMT_Encode4(10375),
     /*  6793 */ // Label 318: @6793
     /*  6793 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(6819), // Rule ID 135 //
     /*  6798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6812 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1),
     /*  6817 */   GIR_RootConstrainSelectedInstOperands,
     /*  6818 */   // GIR_Coverage, 135,
     /*  6818 */   GIR_Done,
     /*  6819 */ // Label 327: @6819
     /*  6819 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(6845), // Rule ID 136 //
     /*  6824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6838 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1),
     /*  6843 */   GIR_RootConstrainSelectedInstOperands,
     /*  6844 */   // GIR_Coverage, 136,
     /*  6844 */   GIR_Done,
     /*  6845 */ // Label 328: @6845
     /*  6845 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(6871), // Rule ID 1160 //
     /*  6850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6864 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MM:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MM),
     /*  6869 */   GIR_RootConstrainSelectedInstOperands,
     /*  6870 */   // GIR_Coverage, 1160,
     /*  6870 */   GIR_Done,
     /*  6871 */ // Label 329: @6871
     /*  6871 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(6897), // Rule ID 1161 //
     /*  6876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6890 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MM:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MM),
     /*  6895 */   GIR_RootConstrainSelectedInstOperands,
     /*  6896 */   // GIR_Coverage, 1161,
     /*  6896 */   GIR_Done,
     /*  6897 */ // Label 330: @6897
     /*  6897 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(6923), // Rule ID 1175 //
     /*  6902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6916 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MMR6:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MMR6),
     /*  6921 */   GIR_RootConstrainSelectedInstOperands,
     /*  6922 */   // GIR_Coverage, 1175,
     /*  6922 */   GIR_Done,
     /*  6923 */ // Label 331: @6923
     /*  6923 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(6949), // Rule ID 1176 //
     /*  6928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6942 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MMR6),
     /*  6947 */   GIR_RootConstrainSelectedInstOperands,
     /*  6948 */   // GIR_Coverage, 1176,
     /*  6948 */   GIR_Done,
     /*  6949 */ // Label 332: @6949
     /*  6949 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(6979), // Rule ID 1904 //
     /*  6954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  6957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  6960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  6968 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v2i16] }:$src, GPR32:{ *:[i32] })
     /*  6968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6978 */   // GIR_Coverage, 1904,
     /*  6978 */   GIR_Done,
     /*  6979 */ // Label 333: @6979
     /*  6979 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(7009), // Rule ID 1905 //
     /*  6984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  6987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  6990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  6998 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v4i8] }:$src, GPR32:{ *:[i32] })
     /*  6998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7008 */   // GIR_Coverage, 1905,
     /*  7008 */   GIR_Done,
     /*  7009 */ // Label 334: @7009
     /*  7009 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(7039), // Rule ID 1908 //
     /*  7014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  7020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7028 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v2i16] }:$src, FGR32:{ *:[i32] })
     /*  7028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7033 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7038 */   // GIR_Coverage, 1908,
     /*  7038 */   GIR_Done,
     /*  7039 */ // Label 335: @7039
     /*  7039 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(7069), // Rule ID 1909 //
     /*  7044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  7050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7058 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v4i8] }:$src, FGR32:{ *:[i32] })
     /*  7058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7068 */   // GIR_Coverage, 1909,
     /*  7068 */   GIR_Done,
     /*  7069 */ // Label 336: @7069
     /*  7069 */ GIM_Reject,
     /*  7070 */ // Label 319: @7070
     /*  7070 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(7125),
     /*  7075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  7078 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(7101), // Rule ID 137 //
     /*  7083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7094 */     // (bitconvert:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMTC1:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)
     /*  7094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMTC1),
     /*  7099 */     GIR_RootConstrainSelectedInstOperands,
     /*  7100 */     // GIR_Coverage, 137,
     /*  7100 */     GIR_Done,
     /*  7101 */   // Label 338: @7101
     /*  7101 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(7124), // Rule ID 138 //
     /*  7106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7117 */     // (bitconvert:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (DMFC1:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)
     /*  7117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMFC1),
     /*  7122 */     GIR_RootConstrainSelectedInstOperands,
     /*  7123 */     // GIR_Coverage, 138,
     /*  7123 */     GIR_Done,
     /*  7124 */   // Label 339: @7124
     /*  7124 */   GIM_Reject,
     /*  7125 */ // Label 337: @7125
     /*  7125 */ GIM_Reject,
     /*  7126 */ // Label 320: @7126
     /*  7126 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(7185),
     /*  7131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  7134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7138 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(7161), // Rule ID 1906 //
     /*  7143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7150 */     // (bitconvert:{ *:[v2i16] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  7150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7160 */     // GIR_Coverage, 1906,
     /*  7160 */     GIR_Done,
     /*  7161 */   // Label 341: @7161
     /*  7161 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(7184), // Rule ID 1910 //
     /*  7166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7173 */     // (bitconvert:{ *:[v2i16] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  7173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7183 */     // GIR_Coverage, 1910,
     /*  7183 */     GIR_Done,
     /*  7184 */   // Label 342: @7184
     /*  7184 */   GIM_Reject,
     /*  7185 */ // Label 340: @7185
     /*  7185 */ GIM_Reject,
     /*  7186 */ // Label 321: @7186
     /*  7186 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(7212), // Rule ID 1991 //
     /*  7191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7201 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src, MSA128D:{ *:[i32] })
     /*  7201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7211 */   // GIR_Coverage, 1991,
     /*  7211 */   GIR_Done,
     /*  7212 */ // Label 343: @7212
     /*  7212 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(7238), // Rule ID 1994 //
     /*  7217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7227 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src, MSA128D:{ *:[i32] })
     /*  7227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7237 */   // GIR_Coverage, 1994,
     /*  7237 */   GIR_Done,
     /*  7238 */ // Label 344: @7238
     /*  7238 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(7264), // Rule ID 2011 //
     /*  7243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7253 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7263 */   // GIR_Coverage, 2011,
     /*  7263 */   GIR_Done,
     /*  7264 */ // Label 345: @7264
     /*  7264 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(7290), // Rule ID 2012 //
     /*  7269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7279 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7289 */   // GIR_Coverage, 2012,
     /*  7289 */   GIR_Done,
     /*  7290 */ // Label 346: @7290
     /*  7290 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(7316), // Rule ID 2013 //
     /*  7295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7305 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7310 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7315 */   // GIR_Coverage, 2013,
     /*  7315 */   GIR_Done,
     /*  7316 */ // Label 347: @7316
     /*  7316 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(7342), // Rule ID 2014 //
     /*  7321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7331 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7341 */   // GIR_Coverage, 2014,
     /*  7341 */   GIR_Done,
     /*  7342 */ // Label 348: @7342
     /*  7342 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(7368), // Rule ID 2015 //
     /*  7347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7357 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7367 */   // GIR_Coverage, 2015,
     /*  7367 */   GIR_Done,
     /*  7368 */ // Label 349: @7368
     /*  7368 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(7394), // Rule ID 2021 //
     /*  7373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7383 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7393 */   // GIR_Coverage, 2021,
     /*  7393 */   GIR_Done,
     /*  7394 */ // Label 350: @7394
     /*  7394 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(7420), // Rule ID 2022 //
     /*  7399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7409 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7419 */   // GIR_Coverage, 2022,
     /*  7419 */   GIR_Done,
     /*  7420 */ // Label 351: @7420
     /*  7420 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(7446), // Rule ID 2023 //
     /*  7425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7435 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7445 */   // GIR_Coverage, 2023,
     /*  7445 */   GIR_Done,
     /*  7446 */ // Label 352: @7446
     /*  7446 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(7472), // Rule ID 2024 //
     /*  7451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7461 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7471 */   // GIR_Coverage, 2024,
     /*  7471 */   GIR_Done,
     /*  7472 */ // Label 353: @7472
     /*  7472 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(7498), // Rule ID 2025 //
     /*  7477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7487 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7497 */   // GIR_Coverage, 2025,
     /*  7497 */   GIR_Done,
     /*  7498 */ // Label 354: @7498
     /*  7498 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(7615), // Rule ID 2030 //
     /*  7503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7513 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7513 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7516 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7520 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7525 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7529 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7534 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7537 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7541 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7546 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7549 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7566 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7569 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7589 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7614 */   // GIR_Coverage, 2030,
     /*  7614 */   GIR_EraseRootFromParent_Done,
     /*  7615 */ // Label 355: @7615
     /*  7615 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(7732), // Rule ID 2031 //
     /*  7620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7630 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7630 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7633 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7637 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7642 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7646 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7651 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7654 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7658 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7663 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7666 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7683 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7686 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7703 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7706 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7731 */   // GIR_Coverage, 2031,
     /*  7731 */   GIR_EraseRootFromParent_Done,
     /*  7732 */ // Label 356: @7732
     /*  7732 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(7802), // Rule ID 2035 //
     /*  7737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7747 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7759 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7763 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7780 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7783 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7801 */   // GIR_Coverage, 2035,
     /*  7801 */   GIR_EraseRootFromParent_Done,
     /*  7802 */ // Label 357: @7802
     /*  7802 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(7872), // Rule ID 2036 //
     /*  7807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7817 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7817 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7820 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7824 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7829 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7833 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7850 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7853 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7871 */   // GIR_Coverage, 2036,
     /*  7871 */   GIR_EraseRootFromParent_Done,
     /*  7872 */ // Label 358: @7872
     /*  7872 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(7942), // Rule ID 2040 //
     /*  7877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7887 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7887 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7890 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7894 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7899 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7903 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7920 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7923 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7941 */   // GIR_Coverage, 2040,
     /*  7941 */   GIR_EraseRootFromParent_Done,
     /*  7942 */ // Label 359: @7942
     /*  7942 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(8012), // Rule ID 2041 //
     /*  7947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7957 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7957 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7960 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7964 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7969 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7973 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7990 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7993 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8011 */   // GIR_Coverage, 2041,
     /*  8011 */   GIR_EraseRootFromParent_Done,
     /*  8012 */ // Label 360: @8012
     /*  8012 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(8089), // Rule ID 2045 //
     /*  8017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8027 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8027 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8030 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8034 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8039 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8043 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8060 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8063 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8088 */   // GIR_Coverage, 2045,
     /*  8088 */   GIR_EraseRootFromParent_Done,
     /*  8089 */ // Label 361: @8089
     /*  8089 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(8166), // Rule ID 2046 //
     /*  8094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8104 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8104 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8107 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8111 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8116 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8120 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8140 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8157 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8165 */   // GIR_Coverage, 2046,
     /*  8165 */   GIR_EraseRootFromParent_Done,
     /*  8166 */ // Label 362: @8166
     /*  8166 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(8243), // Rule ID 2050 //
     /*  8171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8181 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8181 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8184 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8188 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8193 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8197 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8214 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8217 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8242 */   // GIR_Coverage, 2050,
     /*  8242 */   GIR_EraseRootFromParent_Done,
     /*  8243 */ // Label 363: @8243
     /*  8243 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(8320), // Rule ID 2051 //
     /*  8248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8258 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8258 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8261 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8265 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8270 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8274 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8294 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8319 */   // GIR_Coverage, 2051,
     /*  8319 */   GIR_EraseRootFromParent_Done,
     /*  8320 */ // Label 364: @8320
     /*  8320 */ GIM_Reject,
     /*  8321 */ // Label 322: @8321
     /*  8321 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(8380),
     /*  8326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  8329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8333 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(8356), // Rule ID 1907 //
     /*  8338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  8345 */     // (bitconvert:{ *:[v4i8] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  8345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8355 */     // GIR_Coverage, 1907,
     /*  8355 */     GIR_Done,
     /*  8356 */   // Label 366: @8356
     /*  8356 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(8379), // Rule ID 1911 //
     /*  8361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  8368 */     // (bitconvert:{ *:[v4i8] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  8368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8378 */     // GIR_Coverage, 1911,
     /*  8378 */     GIR_Done,
     /*  8379 */   // Label 367: @8379
     /*  8379 */   GIM_Reject,
     /*  8380 */ // Label 365: @8380
     /*  8380 */ GIM_Reject,
     /*  8381 */ // Label 323: @8381
     /*  8381 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(8407), // Rule ID 1990 //
     /*  8386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8396 */   // (bitconvert:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] })
     /*  8396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8406 */   // GIR_Coverage, 1990,
     /*  8406 */   GIR_Done,
     /*  8407 */ // Label 368: @8407
     /*  8407 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(8433), // Rule ID 1993 //
     /*  8412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8422 */   // (bitconvert:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] })
     /*  8422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8432 */   // GIR_Coverage, 1993,
     /*  8432 */   GIR_Done,
     /*  8433 */ // Label 369: @8433
     /*  8433 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(8459), // Rule ID 2006 //
     /*  8438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8448 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8458 */   // GIR_Coverage, 2006,
     /*  8458 */   GIR_Done,
     /*  8459 */ // Label 370: @8459
     /*  8459 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(8485), // Rule ID 2007 //
     /*  8464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8474 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8484 */   // GIR_Coverage, 2007,
     /*  8484 */   GIR_Done,
     /*  8485 */ // Label 371: @8485
     /*  8485 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(8511), // Rule ID 2008 //
     /*  8490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8500 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8510 */   // GIR_Coverage, 2008,
     /*  8510 */   GIR_Done,
     /*  8511 */ // Label 372: @8511
     /*  8511 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(8537), // Rule ID 2009 //
     /*  8516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8526 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8536 */   // GIR_Coverage, 2009,
     /*  8536 */   GIR_Done,
     /*  8537 */ // Label 373: @8537
     /*  8537 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(8563), // Rule ID 2010 //
     /*  8542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8552 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8562 */   // GIR_Coverage, 2010,
     /*  8562 */   GIR_Done,
     /*  8563 */ // Label 374: @8563
     /*  8563 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(8589), // Rule ID 2016 //
     /*  8568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8578 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8588 */   // GIR_Coverage, 2016,
     /*  8588 */   GIR_Done,
     /*  8589 */ // Label 375: @8589
     /*  8589 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(8615), // Rule ID 2017 //
     /*  8594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8604 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8614 */   // GIR_Coverage, 2017,
     /*  8614 */   GIR_Done,
     /*  8615 */ // Label 376: @8615
     /*  8615 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(8641), // Rule ID 2018 //
     /*  8620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8630 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8640 */   // GIR_Coverage, 2018,
     /*  8640 */   GIR_Done,
     /*  8641 */ // Label 377: @8641
     /*  8641 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(8667), // Rule ID 2019 //
     /*  8646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8656 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8666 */   // GIR_Coverage, 2019,
     /*  8666 */   GIR_Done,
     /*  8667 */ // Label 378: @8667
     /*  8667 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(8693), // Rule ID 2020 //
     /*  8672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8682 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8692 */   // GIR_Coverage, 2020,
     /*  8692 */   GIR_Done,
     /*  8693 */ // Label 379: @8693
     /*  8693 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(8763), // Rule ID 2028 //
     /*  8698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8708 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8708 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8711 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8715 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8720 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8724 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8741 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8744 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8762 */   // GIR_Coverage, 2028,
     /*  8762 */   GIR_EraseRootFromParent_Done,
     /*  8763 */ // Label 380: @8763
     /*  8763 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(8833), // Rule ID 2029 //
     /*  8768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8778 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8790 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8794 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8811 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8814 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8832 */   // GIR_Coverage, 2029,
     /*  8832 */   GIR_EraseRootFromParent_Done,
     /*  8833 */ // Label 381: @8833
     /*  8833 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(8910), // Rule ID 2033 //
     /*  8838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8848 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8848 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8851 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8855 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8860 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8864 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8881 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8884 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8909 */   // GIR_Coverage, 2033,
     /*  8909 */   GIR_EraseRootFromParent_Done,
     /*  8910 */ // Label 382: @8910
     /*  8910 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(8987), // Rule ID 2034 //
     /*  8915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8925 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8937 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8941 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8958 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8961 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8986 */   // GIR_Coverage, 2034,
     /*  8986 */   GIR_EraseRootFromParent_Done,
     /*  8987 */ // Label 383: @8987
     /*  8987 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(9064), // Rule ID 2038 //
     /*  8992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9002 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9002 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9005 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9009 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9014 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9018 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9035 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9038 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9063 */   // GIR_Coverage, 2038,
     /*  9063 */   GIR_EraseRootFromParent_Done,
     /*  9064 */ // Label 384: @9064
     /*  9064 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(9141), // Rule ID 2039 //
     /*  9069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9079 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9079 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9082 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9086 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9091 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9095 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9100 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9103 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9107 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9112 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9115 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9140 */   // GIR_Coverage, 2039,
     /*  9140 */   GIR_EraseRootFromParent_Done,
     /*  9141 */ // Label 385: @9141
     /*  9141 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(9218), // Rule ID 2055 //
     /*  9146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9156 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9156 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9159 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9163 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9168 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9172 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9189 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9192 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9217 */   // GIR_Coverage, 2055,
     /*  9217 */   GIR_EraseRootFromParent_Done,
     /*  9218 */ // Label 386: @9218
     /*  9218 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(9295), // Rule ID 2056 //
     /*  9223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9233 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9233 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9236 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9240 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9245 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9249 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9266 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9269 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9294 */   // GIR_Coverage, 2056,
     /*  9294 */   GIR_EraseRootFromParent_Done,
     /*  9295 */ // Label 387: @9295
     /*  9295 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(9372), // Rule ID 2060 //
     /*  9300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9310 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9326 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9343 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9346 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9371 */   // GIR_Coverage, 2060,
     /*  9371 */   GIR_EraseRootFromParent_Done,
     /*  9372 */ // Label 388: @9372
     /*  9372 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(9449), // Rule ID 2061 //
     /*  9377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9387 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9387 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9390 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9394 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9399 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9403 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9420 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9423 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9448 */   // GIR_Coverage, 2061,
     /*  9448 */   GIR_EraseRootFromParent_Done,
     /*  9449 */ // Label 389: @9449
     /*  9449 */ GIM_Reject,
     /*  9450 */ // Label 324: @9450
     /*  9450 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(9476), // Rule ID 1989 //
     /*  9455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9465 */   // (bitconvert:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] })
     /*  9465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9475 */   // GIR_Coverage, 1989,
     /*  9475 */   GIR_Done,
     /*  9476 */ // Label 390: @9476
     /*  9476 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(9502), // Rule ID 1992 //
     /*  9481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9491 */   // (bitconvert:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] })
     /*  9491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9496 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9501 */   // GIR_Coverage, 1992,
     /*  9501 */   GIR_Done,
     /*  9502 */ // Label 391: @9502
     /*  9502 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(9528), // Rule ID 2001 //
     /*  9507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9517 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src, MSA128H:{ *:[i32] })
     /*  9517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9527 */   // GIR_Coverage, 2001,
     /*  9527 */   GIR_Done,
     /*  9528 */ // Label 392: @9528
     /*  9528 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(9554), // Rule ID 2002 //
     /*  9533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9543 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] })
     /*  9543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9553 */   // GIR_Coverage, 2002,
     /*  9553 */   GIR_Done,
     /*  9554 */ // Label 393: @9554
     /*  9554 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(9580), // Rule ID 2003 //
     /*  9559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9569 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] })
     /*  9569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9579 */   // GIR_Coverage, 2003,
     /*  9579 */   GIR_Done,
     /*  9580 */ // Label 394: @9580
     /*  9580 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(9606), // Rule ID 2004 //
     /*  9585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9595 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] })
     /*  9595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9605 */   // GIR_Coverage, 2004,
     /*  9605 */   GIR_Done,
     /*  9606 */ // Label 395: @9606
     /*  9606 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(9632), // Rule ID 2005 //
     /*  9611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9621 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] })
     /*  9621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9626 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9631 */   // GIR_Coverage, 2005,
     /*  9631 */   GIR_Done,
     /*  9632 */ // Label 396: @9632
     /*  9632 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(9709), // Rule ID 2026 //
     /*  9637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9647 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9647 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9650 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9654 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9659 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9663 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9680 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9683 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9708 */   // GIR_Coverage, 2026,
     /*  9708 */   GIR_EraseRootFromParent_Done,
     /*  9709 */ // Label 397: @9709
     /*  9709 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(9786), // Rule ID 2027 //
     /*  9714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9724 */   // (bitconvert:{ *:[v8f16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9724 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9727 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9731 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9736 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9740 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9757 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9760 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9785 */   // GIR_Coverage, 2027,
     /*  9785 */   GIR_EraseRootFromParent_Done,
     /*  9786 */ // Label 398: @9786
     /*  9786 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(9863), // Rule ID 2043 //
     /*  9791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9801 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9801 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9804 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9808 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9813 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9817 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9834 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9837 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9862 */   // GIR_Coverage, 2043,
     /*  9862 */   GIR_EraseRootFromParent_Done,
     /*  9863 */ // Label 399: @9863
     /*  9863 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(9940), // Rule ID 2044 //
     /*  9868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9878 */   // (bitconvert:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9878 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9881 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9885 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9890 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9894 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9911 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9914 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9939 */   // GIR_Coverage, 2044,
     /*  9939 */   GIR_EraseRootFromParent_Done,
     /*  9940 */ // Label 400: @9940
     /*  9940 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(10017), // Rule ID 2048 //
     /*  9945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9955 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9955 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9958 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9962 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9967 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9971 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9988 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9991 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10016 */   // GIR_Coverage, 2048,
     /* 10016 */   GIR_EraseRootFromParent_Done,
     /* 10017 */ // Label 401: @10017
     /* 10017 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(10094), // Rule ID 2049 //
     /* 10022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10032 */   // (bitconvert:{ *:[v8f16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10032 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10035 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10039 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10044 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10048 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10065 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10068 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10093 */   // GIR_Coverage, 2049,
     /* 10093 */   GIR_EraseRootFromParent_Done,
     /* 10094 */ // Label 402: @10094
     /* 10094 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(10164), // Rule ID 2053 //
     /* 10099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10109 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10109 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10112 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10116 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10121 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10125 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10142 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10145 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10163 */   // GIR_Coverage, 2053,
     /* 10163 */   GIR_EraseRootFromParent_Done,
     /* 10164 */ // Label 403: @10164
     /* 10164 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(10234), // Rule ID 2054 //
     /* 10169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10179 */   // (bitconvert:{ *:[v8f16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10179 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10182 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10186 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10191 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10195 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10212 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10215 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10233 */   // GIR_Coverage, 2054,
     /* 10233 */   GIR_EraseRootFromParent_Done,
     /* 10234 */ // Label 404: @10234
     /* 10234 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(10304), // Rule ID 2058 //
     /* 10239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10249 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10249 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10252 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10256 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10261 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10265 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10282 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10285 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10303 */   // GIR_Coverage, 2058,
     /* 10303 */   GIR_EraseRootFromParent_Done,
     /* 10304 */ // Label 405: @10304
     /* 10304 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(10374), // Rule ID 2059 //
     /* 10309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10319 */   // (bitconvert:{ *:[v8f16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10331 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10335 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10352 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10355 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10373 */   // GIR_Coverage, 2059,
     /* 10373 */   GIR_EraseRootFromParent_Done,
     /* 10374 */ // Label 406: @10374
     /* 10374 */ GIM_Reject,
     /* 10375 */ // Label 325: @10375
     /* 10375 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(10401), // Rule ID 1995 //
     /* 10380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10390 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] })
     /* 10390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10400 */   // GIR_Coverage, 1995,
     /* 10400 */   GIR_Done,
     /* 10401 */ // Label 407: @10401
     /* 10401 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(10427), // Rule ID 1996 //
     /* 10406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10416 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] })
     /* 10416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10426 */   // GIR_Coverage, 1996,
     /* 10426 */   GIR_Done,
     /* 10427 */ // Label 408: @10427
     /* 10427 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(10453), // Rule ID 1997 //
     /* 10432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10442 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] })
     /* 10442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10452 */   // GIR_Coverage, 1997,
     /* 10452 */   GIR_Done,
     /* 10453 */ // Label 409: @10453
     /* 10453 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(10479), // Rule ID 1998 //
     /* 10458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10468 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] })
     /* 10468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10478 */   // GIR_Coverage, 1998,
     /* 10478 */   GIR_Done,
     /* 10479 */ // Label 410: @10479
     /* 10479 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(10505), // Rule ID 1999 //
     /* 10484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10494 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] })
     /* 10494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10499 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10504 */   // GIR_Coverage, 1999,
     /* 10504 */   GIR_Done,
     /* 10505 */ // Label 411: @10505
     /* 10505 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(10531), // Rule ID 2000 //
     /* 10510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10520 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] })
     /* 10520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10525 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10530 */   // GIR_Coverage, 2000,
     /* 10530 */   GIR_Done,
     /* 10531 */ // Label 412: @10531
     /* 10531 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(10608), // Rule ID 2032 //
     /* 10536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10546 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10558 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10562 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10579 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10582 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10607 */   // GIR_Coverage, 2032,
     /* 10607 */   GIR_EraseRootFromParent_Done,
     /* 10608 */ // Label 413: @10608
     /* 10608 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(10685), // Rule ID 2037 //
     /* 10613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10623 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10623 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10626 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10630 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10635 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10639 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10656 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10659 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10684 */   // GIR_Coverage, 2037,
     /* 10684 */   GIR_EraseRootFromParent_Done,
     /* 10685 */ // Label 414: @10685
     /* 10685 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(10755), // Rule ID 2042 //
     /* 10690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10700 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10700 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10703 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10707 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10712 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10716 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10733 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10754 */   // GIR_Coverage, 2042,
     /* 10754 */   GIR_EraseRootFromParent_Done,
     /* 10755 */ // Label 415: @10755
     /* 10755 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(10825), // Rule ID 2047 //
     /* 10760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10770 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10770 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10773 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10777 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10782 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10786 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10803 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10806 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10824 */   // GIR_Coverage, 2047,
     /* 10824 */   GIR_EraseRootFromParent_Done,
     /* 10825 */ // Label 416: @10825
     /* 10825 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(10942), // Rule ID 2052 //
     /* 10830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10840 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10840 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10843 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10847 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10852 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10856 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10861 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10864 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10868 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10873 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 10876 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 10879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 10881 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 10884 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10888 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10893 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 10896 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 10901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 10904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 10908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10913 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10916 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10941 */   // GIR_Coverage, 2052,
     /* 10941 */   GIR_EraseRootFromParent_Done,
     /* 10942 */ // Label 417: @10942
     /* 10942 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(11059), // Rule ID 2057 //
     /* 10947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10957 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10957 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10960 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10964 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10969 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10973 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10978 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10981 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10985 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10990 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 10993 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 10996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 10998 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 11001 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11005 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11010 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 11013 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 11018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 11021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 11025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11030 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 11033 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 11043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 11045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 11053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 11058 */   // GIR_Coverage, 2057,
     /* 11058 */   GIR_EraseRootFromParent_Done,
     /* 11059 */ // Label 418: @11059
     /* 11059 */ GIM_Reject,
     /* 11060 */ // Label 326: @11060
     /* 11060 */ GIM_Reject,
     /* 11061 */ // Label 13: @11061
     /* 11061 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(11125), // Rule ID 1980 //
     /* 11066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11069 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 11079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11083 */   // MIs[0] Operand 1
     /* 11083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11095 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11099 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11105 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LWX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 11108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11110 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11114 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11123 */   GIR_RootConstrainSelectedInstOperands,
     /* 11124 */   // GIR_Coverage, 1980,
     /* 11124 */   GIR_EraseRootFromParent_Done,
     /* 11125 */ // Label 419: @11125
     /* 11125 */ GIM_Reject,
     /* 11126 */ // Label 14: @11126
     /* 11126 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(11193), // Rule ID 1979 //
     /* 11131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11134 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11151 */   // MIs[0] Operand 1
     /* 11151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11163 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11173 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LHX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 11176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11178 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11182 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11191 */   GIR_RootConstrainSelectedInstOperands,
     /* 11192 */   // GIR_Coverage, 1979,
     /* 11192 */   GIR_EraseRootFromParent_Done,
     /* 11193 */ // Label 420: @11193
     /* 11193 */ GIM_Reject,
     /* 11194 */ // Label 15: @11194
     /* 11194 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(11261), // Rule ID 1978 //
     /* 11199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11202 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11208 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11219 */   // MIs[0] Operand 1
     /* 11219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11241 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBUX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 11244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11246 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11250 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11259 */   GIR_RootConstrainSelectedInstOperands,
     /* 11260 */   // GIR_Coverage, 1978,
     /* 11260 */   GIR_EraseRootFromParent_Done,
     /* 11261 */ // Label 421: @11261
     /* 11261 */ GIM_Reject,
     /* 11262 */ // Label 16: @11262
     /* 11262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 424*/ GIMT_Encode4(11453),
     /* 11273 */ /*GILLT_s32*//*Label 422*/ GIMT_Encode4(11281),
     /* 11277 */ /*GILLT_s64*//*Label 423*/ GIMT_Encode4(11408),
     /* 11281 */ // Label 422: @11281
     /* 11281 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(11407),
     /* 11286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11289 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 11292 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(11330), // Rule ID 25 //
     /* 11297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11311 */     // MIs[0] ptr
     /* 11311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11323 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (ATOMIC_CMP_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I8),
     /* 11328 */     GIR_RootConstrainSelectedInstOperands,
     /* 11329 */     // GIR_Coverage, 25,
     /* 11329 */     GIR_Done,
     /* 11330 */   // Label 426: @11330
     /* 11330 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(11368), // Rule ID 26 //
     /* 11335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11349 */     // MIs[0] ptr
     /* 11349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11361 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (ATOMIC_CMP_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I16),
     /* 11366 */     GIR_RootConstrainSelectedInstOperands,
     /* 11367 */     // GIR_Coverage, 26,
     /* 11367 */     GIR_Done,
     /* 11368 */   // Label 427: @11368
     /* 11368 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(11406), // Rule ID 27 //
     /* 11373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11387 */     // MIs[0] ptr
     /* 11387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11399 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (ATOMIC_CMP_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I32),
     /* 11404 */     GIR_RootConstrainSelectedInstOperands,
     /* 11405 */     // GIR_Coverage, 27,
     /* 11405 */     GIR_Done,
     /* 11406 */   // Label 428: @11406
     /* 11406 */   GIM_Reject,
     /* 11407 */ // Label 425: @11407
     /* 11407 */ GIM_Reject,
     /* 11408 */ // Label 423: @11408
     /* 11408 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(11452), // Rule ID 191 //
     /* 11413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 11422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11433 */   // MIs[0] ptr
     /* 11433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11445 */   // (atomic_cmp_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (ATOMIC_CMP_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)
     /* 11445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I64),
     /* 11450 */   GIR_RootConstrainSelectedInstOperands,
     /* 11451 */   // GIR_Coverage, 191,
     /* 11451 */   GIR_Done,
     /* 11452 */ // Label 429: @11452
     /* 11452 */ GIM_Reject,
     /* 11453 */ // Label 424: @11453
     /* 11453 */ GIM_Reject,
     /* 11454 */ // Label 17: @11454
     /* 11454 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 432*/ GIMT_Encode4(11623),
     /* 11465 */ /*GILLT_s32*//*Label 430*/ GIMT_Encode4(11473),
     /* 11469 */ /*GILLT_s64*//*Label 431*/ GIMT_Encode4(11585),
     /* 11473 */ // Label 430: @11473
     /* 11473 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(11584),
     /* 11478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11481 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(11515), // Rule ID 22 //
     /* 11486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11500 */     // MIs[0] ptr
     /* 11500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11508 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i8>>  =>  (ATOMIC_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I8),
     /* 11513 */     GIR_RootConstrainSelectedInstOperands,
     /* 11514 */     // GIR_Coverage, 22,
     /* 11514 */     GIR_Done,
     /* 11515 */   // Label 434: @11515
     /* 11515 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(11549), // Rule ID 23 //
     /* 11520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11534 */     // MIs[0] ptr
     /* 11534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11542 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i16>>  =>  (ATOMIC_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I16),
     /* 11547 */     GIR_RootConstrainSelectedInstOperands,
     /* 11548 */     // GIR_Coverage, 23,
     /* 11548 */     GIR_Done,
     /* 11549 */   // Label 435: @11549
     /* 11549 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(11583), // Rule ID 24 //
     /* 11554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11568 */     // MIs[0] ptr
     /* 11568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11576 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i32>>  =>  (ATOMIC_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I32),
     /* 11581 */     GIR_RootConstrainSelectedInstOperands,
     /* 11582 */     // GIR_Coverage, 24,
     /* 11582 */     GIR_Done,
     /* 11583 */   // Label 436: @11583
     /* 11583 */   GIM_Reject,
     /* 11584 */ // Label 433: @11584
     /* 11584 */ GIM_Reject,
     /* 11585 */ // Label 431: @11585
     /* 11585 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(11622), // Rule ID 190 //
     /* 11590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11596 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11607 */   // MIs[0] ptr
     /* 11607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11615 */   // (atomic_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_swap_i64>>  =>  (ATOMIC_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I64),
     /* 11620 */   GIR_RootConstrainSelectedInstOperands,
     /* 11621 */   // GIR_Coverage, 190,
     /* 11621 */   GIR_Done,
     /* 11622 */ // Label 437: @11622
     /* 11622 */ GIM_Reject,
     /* 11623 */ // Label 432: @11623
     /* 11623 */ GIM_Reject,
     /* 11624 */ // Label 18: @11624
     /* 11624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 440*/ GIMT_Encode4(11793),
     /* 11635 */ /*GILLT_s32*//*Label 438*/ GIMT_Encode4(11643),
     /* 11639 */ /*GILLT_s64*//*Label 439*/ GIMT_Encode4(11755),
     /* 11643 */ // Label 438: @11643
     /* 11643 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(11754),
     /* 11648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11651 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(11685), // Rule ID 4 //
     /* 11656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11670 */     // MIs[0] ptr
     /* 11670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11678 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i8>>  =>  (ATOMIC_LOAD_ADD_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I8),
     /* 11683 */     GIR_RootConstrainSelectedInstOperands,
     /* 11684 */     // GIR_Coverage, 4,
     /* 11684 */     GIR_Done,
     /* 11685 */   // Label 442: @11685
     /* 11685 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(11719), // Rule ID 5 //
     /* 11690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11704 */     // MIs[0] ptr
     /* 11704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11712 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i16>>  =>  (ATOMIC_LOAD_ADD_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I16),
     /* 11717 */     GIR_RootConstrainSelectedInstOperands,
     /* 11718 */     // GIR_Coverage, 5,
     /* 11718 */     GIR_Done,
     /* 11719 */   // Label 443: @11719
     /* 11719 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(11753), // Rule ID 6 //
     /* 11724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11738 */     // MIs[0] ptr
     /* 11738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11746 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i32>>  =>  (ATOMIC_LOAD_ADD_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I32),
     /* 11751 */     GIR_RootConstrainSelectedInstOperands,
     /* 11752 */     // GIR_Coverage, 6,
     /* 11752 */     GIR_Done,
     /* 11753 */   // Label 444: @11753
     /* 11753 */   GIM_Reject,
     /* 11754 */ // Label 441: @11754
     /* 11754 */ GIM_Reject,
     /* 11755 */ // Label 439: @11755
     /* 11755 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(11792), // Rule ID 184 //
     /* 11760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11766 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11777 */   // MIs[0] ptr
     /* 11777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11785 */   // (atomic_load_add:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_add_i64>>  =>  (ATOMIC_LOAD_ADD_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I64),
     /* 11790 */   GIR_RootConstrainSelectedInstOperands,
     /* 11791 */   // GIR_Coverage, 184,
     /* 11791 */   GIR_Done,
     /* 11792 */ // Label 445: @11792
     /* 11792 */ GIM_Reject,
     /* 11793 */ // Label 440: @11793
     /* 11793 */ GIM_Reject,
     /* 11794 */ // Label 19: @11794
     /* 11794 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 448*/ GIMT_Encode4(11963),
     /* 11805 */ /*GILLT_s32*//*Label 446*/ GIMT_Encode4(11813),
     /* 11809 */ /*GILLT_s64*//*Label 447*/ GIMT_Encode4(11925),
     /* 11813 */ // Label 446: @11813
     /* 11813 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(11924),
     /* 11818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11821 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(11855), // Rule ID 7 //
     /* 11826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11840 */     // MIs[0] ptr
     /* 11840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11848 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i8>>  =>  (ATOMIC_LOAD_SUB_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I8),
     /* 11853 */     GIR_RootConstrainSelectedInstOperands,
     /* 11854 */     // GIR_Coverage, 7,
     /* 11854 */     GIR_Done,
     /* 11855 */   // Label 450: @11855
     /* 11855 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(11889), // Rule ID 8 //
     /* 11860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11874 */     // MIs[0] ptr
     /* 11874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11882 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i16>>  =>  (ATOMIC_LOAD_SUB_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I16),
     /* 11887 */     GIR_RootConstrainSelectedInstOperands,
     /* 11888 */     // GIR_Coverage, 8,
     /* 11888 */     GIR_Done,
     /* 11889 */   // Label 451: @11889
     /* 11889 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(11923), // Rule ID 9 //
     /* 11894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11908 */     // MIs[0] ptr
     /* 11908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11916 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i32>>  =>  (ATOMIC_LOAD_SUB_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I32),
     /* 11921 */     GIR_RootConstrainSelectedInstOperands,
     /* 11922 */     // GIR_Coverage, 9,
     /* 11922 */     GIR_Done,
     /* 11923 */   // Label 452: @11923
     /* 11923 */   GIM_Reject,
     /* 11924 */ // Label 449: @11924
     /* 11924 */ GIM_Reject,
     /* 11925 */ // Label 447: @11925
     /* 11925 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(11962), // Rule ID 185 //
     /* 11930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11936 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11947 */   // MIs[0] ptr
     /* 11947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11955 */   // (atomic_load_sub:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_sub_i64>>  =>  (ATOMIC_LOAD_SUB_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I64),
     /* 11960 */   GIR_RootConstrainSelectedInstOperands,
     /* 11961 */   // GIR_Coverage, 185,
     /* 11961 */   GIR_Done,
     /* 11962 */ // Label 453: @11962
     /* 11962 */ GIM_Reject,
     /* 11963 */ // Label 448: @11963
     /* 11963 */ GIM_Reject,
     /* 11964 */ // Label 20: @11964
     /* 11964 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 456*/ GIMT_Encode4(12133),
     /* 11975 */ /*GILLT_s32*//*Label 454*/ GIMT_Encode4(11983),
     /* 11979 */ /*GILLT_s64*//*Label 455*/ GIMT_Encode4(12095),
     /* 11983 */ // Label 454: @11983
     /* 11983 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(12094),
     /* 11988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11991 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(12025), // Rule ID 10 //
     /* 11996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12010 */     // MIs[0] ptr
     /* 12010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12018 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i8>>  =>  (ATOMIC_LOAD_AND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I8),
     /* 12023 */     GIR_RootConstrainSelectedInstOperands,
     /* 12024 */     // GIR_Coverage, 10,
     /* 12024 */     GIR_Done,
     /* 12025 */   // Label 458: @12025
     /* 12025 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(12059), // Rule ID 11 //
     /* 12030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12044 */     // MIs[0] ptr
     /* 12044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12052 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i16>>  =>  (ATOMIC_LOAD_AND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I16),
     /* 12057 */     GIR_RootConstrainSelectedInstOperands,
     /* 12058 */     // GIR_Coverage, 11,
     /* 12058 */     GIR_Done,
     /* 12059 */   // Label 459: @12059
     /* 12059 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(12093), // Rule ID 12 //
     /* 12064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12078 */     // MIs[0] ptr
     /* 12078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12086 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i32>>  =>  (ATOMIC_LOAD_AND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I32),
     /* 12091 */     GIR_RootConstrainSelectedInstOperands,
     /* 12092 */     // GIR_Coverage, 12,
     /* 12092 */     GIR_Done,
     /* 12093 */   // Label 460: @12093
     /* 12093 */   GIM_Reject,
     /* 12094 */ // Label 457: @12094
     /* 12094 */ GIM_Reject,
     /* 12095 */ // Label 455: @12095
     /* 12095 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(12132), // Rule ID 186 //
     /* 12100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12106 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12117 */   // MIs[0] ptr
     /* 12117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12125 */   // (atomic_load_and:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_and_i64>>  =>  (ATOMIC_LOAD_AND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I64),
     /* 12130 */   GIR_RootConstrainSelectedInstOperands,
     /* 12131 */   // GIR_Coverage, 186,
     /* 12131 */   GIR_Done,
     /* 12132 */ // Label 461: @12132
     /* 12132 */ GIM_Reject,
     /* 12133 */ // Label 456: @12133
     /* 12133 */ GIM_Reject,
     /* 12134 */ // Label 21: @12134
     /* 12134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 464*/ GIMT_Encode4(12303),
     /* 12145 */ /*GILLT_s32*//*Label 462*/ GIMT_Encode4(12153),
     /* 12149 */ /*GILLT_s64*//*Label 463*/ GIMT_Encode4(12265),
     /* 12153 */ // Label 462: @12153
     /* 12153 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(12264),
     /* 12158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12161 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(12195), // Rule ID 19 //
     /* 12166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12180 */     // MIs[0] ptr
     /* 12180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12188 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i8>>  =>  (ATOMIC_LOAD_NAND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I8),
     /* 12193 */     GIR_RootConstrainSelectedInstOperands,
     /* 12194 */     // GIR_Coverage, 19,
     /* 12194 */     GIR_Done,
     /* 12195 */   // Label 466: @12195
     /* 12195 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(12229), // Rule ID 20 //
     /* 12200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12214 */     // MIs[0] ptr
     /* 12214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12222 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i16>>  =>  (ATOMIC_LOAD_NAND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I16),
     /* 12227 */     GIR_RootConstrainSelectedInstOperands,
     /* 12228 */     // GIR_Coverage, 20,
     /* 12228 */     GIR_Done,
     /* 12229 */   // Label 467: @12229
     /* 12229 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(12263), // Rule ID 21 //
     /* 12234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12248 */     // MIs[0] ptr
     /* 12248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12256 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>>  =>  (ATOMIC_LOAD_NAND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I32),
     /* 12261 */     GIR_RootConstrainSelectedInstOperands,
     /* 12262 */     // GIR_Coverage, 21,
     /* 12262 */     GIR_Done,
     /* 12263 */   // Label 468: @12263
     /* 12263 */   GIM_Reject,
     /* 12264 */ // Label 465: @12264
     /* 12264 */ GIM_Reject,
     /* 12265 */ // Label 463: @12265
     /* 12265 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(12302), // Rule ID 189 //
     /* 12270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12287 */   // MIs[0] ptr
     /* 12287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12295 */   // (atomic_load_nand:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>>  =>  (ATOMIC_LOAD_NAND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I64),
     /* 12300 */   GIR_RootConstrainSelectedInstOperands,
     /* 12301 */   // GIR_Coverage, 189,
     /* 12301 */   GIR_Done,
     /* 12302 */ // Label 469: @12302
     /* 12302 */ GIM_Reject,
     /* 12303 */ // Label 464: @12303
     /* 12303 */ GIM_Reject,
     /* 12304 */ // Label 22: @12304
     /* 12304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 472*/ GIMT_Encode4(12473),
     /* 12315 */ /*GILLT_s32*//*Label 470*/ GIMT_Encode4(12323),
     /* 12319 */ /*GILLT_s64*//*Label 471*/ GIMT_Encode4(12435),
     /* 12323 */ // Label 470: @12323
     /* 12323 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(12434),
     /* 12328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12331 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(12365), // Rule ID 13 //
     /* 12336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12350 */     // MIs[0] ptr
     /* 12350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12358 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i8>>  =>  (ATOMIC_LOAD_OR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I8),
     /* 12363 */     GIR_RootConstrainSelectedInstOperands,
     /* 12364 */     // GIR_Coverage, 13,
     /* 12364 */     GIR_Done,
     /* 12365 */   // Label 474: @12365
     /* 12365 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(12399), // Rule ID 14 //
     /* 12370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12384 */     // MIs[0] ptr
     /* 12384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12392 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i16>>  =>  (ATOMIC_LOAD_OR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I16),
     /* 12397 */     GIR_RootConstrainSelectedInstOperands,
     /* 12398 */     // GIR_Coverage, 14,
     /* 12398 */     GIR_Done,
     /* 12399 */   // Label 475: @12399
     /* 12399 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(12433), // Rule ID 15 //
     /* 12404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12407 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12418 */     // MIs[0] ptr
     /* 12418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12426 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i32>>  =>  (ATOMIC_LOAD_OR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I32),
     /* 12431 */     GIR_RootConstrainSelectedInstOperands,
     /* 12432 */     // GIR_Coverage, 15,
     /* 12432 */     GIR_Done,
     /* 12433 */   // Label 476: @12433
     /* 12433 */   GIM_Reject,
     /* 12434 */ // Label 473: @12434
     /* 12434 */ GIM_Reject,
     /* 12435 */ // Label 471: @12435
     /* 12435 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(12472), // Rule ID 187 //
     /* 12440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12457 */   // MIs[0] ptr
     /* 12457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12465 */   // (atomic_load_or:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_or_i64>>  =>  (ATOMIC_LOAD_OR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I64),
     /* 12470 */   GIR_RootConstrainSelectedInstOperands,
     /* 12471 */   // GIR_Coverage, 187,
     /* 12471 */   GIR_Done,
     /* 12472 */ // Label 477: @12472
     /* 12472 */ GIM_Reject,
     /* 12473 */ // Label 472: @12473
     /* 12473 */ GIM_Reject,
     /* 12474 */ // Label 23: @12474
     /* 12474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 480*/ GIMT_Encode4(12643),
     /* 12485 */ /*GILLT_s32*//*Label 478*/ GIMT_Encode4(12493),
     /* 12489 */ /*GILLT_s64*//*Label 479*/ GIMT_Encode4(12605),
     /* 12493 */ // Label 478: @12493
     /* 12493 */ GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(12604),
     /* 12498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12501 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(12535), // Rule ID 16 //
     /* 12506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12520 */     // MIs[0] ptr
     /* 12520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12528 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i8>>  =>  (ATOMIC_LOAD_XOR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I8),
     /* 12533 */     GIR_RootConstrainSelectedInstOperands,
     /* 12534 */     // GIR_Coverage, 16,
     /* 12534 */     GIR_Done,
     /* 12535 */   // Label 482: @12535
     /* 12535 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(12569), // Rule ID 17 //
     /* 12540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12554 */     // MIs[0] ptr
     /* 12554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12562 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i16>>  =>  (ATOMIC_LOAD_XOR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I16),
     /* 12567 */     GIR_RootConstrainSelectedInstOperands,
     /* 12568 */     // GIR_Coverage, 17,
     /* 12568 */     GIR_Done,
     /* 12569 */   // Label 483: @12569
     /* 12569 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(12603), // Rule ID 18 //
     /* 12574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12577 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12588 */     // MIs[0] ptr
     /* 12588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12596 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i32>>  =>  (ATOMIC_LOAD_XOR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I32),
     /* 12601 */     GIR_RootConstrainSelectedInstOperands,
     /* 12602 */     // GIR_Coverage, 18,
     /* 12602 */     GIR_Done,
     /* 12603 */   // Label 484: @12603
     /* 12603 */   GIM_Reject,
     /* 12604 */ // Label 481: @12604
     /* 12604 */ GIM_Reject,
     /* 12605 */ // Label 479: @12605
     /* 12605 */ GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(12642), // Rule ID 188 //
     /* 12610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12627 */   // MIs[0] ptr
     /* 12627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12635 */   // (atomic_load_xor:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_xor_i64>>  =>  (ATOMIC_LOAD_XOR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I64),
     /* 12640 */   GIR_RootConstrainSelectedInstOperands,
     /* 12641 */   // GIR_Coverage, 188,
     /* 12641 */   GIR_Done,
     /* 12642 */ // Label 485: @12642
     /* 12642 */ GIM_Reject,
     /* 12643 */ // Label 480: @12643
     /* 12643 */ GIM_Reject,
     /* 12644 */ // Label 24: @12644
     /* 12644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 488*/ GIMT_Encode4(12813),
     /* 12655 */ /*GILLT_s32*//*Label 486*/ GIMT_Encode4(12663),
     /* 12659 */ /*GILLT_s64*//*Label 487*/ GIMT_Encode4(12775),
     /* 12663 */ // Label 486: @12663
     /* 12663 */ GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(12774),
     /* 12668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12671 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(12705), // Rule ID 31 //
     /* 12676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12690 */     // MIs[0] ptr
     /* 12690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12698 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i8>>  =>  (ATOMIC_LOAD_MAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I8),
     /* 12703 */     GIR_RootConstrainSelectedInstOperands,
     /* 12704 */     // GIR_Coverage, 31,
     /* 12704 */     GIR_Done,
     /* 12705 */   // Label 490: @12705
     /* 12705 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(12739), // Rule ID 32 //
     /* 12710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12724 */     // MIs[0] ptr
     /* 12724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12732 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i16>>  =>  (ATOMIC_LOAD_MAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I16),
     /* 12737 */     GIR_RootConstrainSelectedInstOperands,
     /* 12738 */     // GIR_Coverage, 32,
     /* 12738 */     GIR_Done,
     /* 12739 */   // Label 491: @12739
     /* 12739 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(12773), // Rule ID 33 //
     /* 12744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12758 */     // MIs[0] ptr
     /* 12758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12766 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i32>>  =>  (ATOMIC_LOAD_MAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I32),
     /* 12771 */     GIR_RootConstrainSelectedInstOperands,
     /* 12772 */     // GIR_Coverage, 33,
     /* 12772 */     GIR_Done,
     /* 12773 */   // Label 492: @12773
     /* 12773 */   GIM_Reject,
     /* 12774 */ // Label 489: @12774
     /* 12774 */ GIM_Reject,
     /* 12775 */ // Label 487: @12775
     /* 12775 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(12812), // Rule ID 193 //
     /* 12780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12797 */   // MIs[0] ptr
     /* 12797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12805 */   // (atomic_load_max:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_max_i64>>  =>  (ATOMIC_LOAD_MAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I64),
     /* 12810 */   GIR_RootConstrainSelectedInstOperands,
     /* 12811 */   // GIR_Coverage, 193,
     /* 12811 */   GIR_Done,
     /* 12812 */ // Label 493: @12812
     /* 12812 */ GIM_Reject,
     /* 12813 */ // Label 488: @12813
     /* 12813 */ GIM_Reject,
     /* 12814 */ // Label 25: @12814
     /* 12814 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 496*/ GIMT_Encode4(12983),
     /* 12825 */ /*GILLT_s32*//*Label 494*/ GIMT_Encode4(12833),
     /* 12829 */ /*GILLT_s64*//*Label 495*/ GIMT_Encode4(12945),
     /* 12833 */ // Label 494: @12833
     /* 12833 */ GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(12944),
     /* 12838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12841 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(12875), // Rule ID 28 //
     /* 12846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12860 */     // MIs[0] ptr
     /* 12860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12868 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i8>>  =>  (ATOMIC_LOAD_MIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I8),
     /* 12873 */     GIR_RootConstrainSelectedInstOperands,
     /* 12874 */     // GIR_Coverage, 28,
     /* 12874 */     GIR_Done,
     /* 12875 */   // Label 498: @12875
     /* 12875 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(12909), // Rule ID 29 //
     /* 12880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12894 */     // MIs[0] ptr
     /* 12894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12902 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i16>>  =>  (ATOMIC_LOAD_MIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I16),
     /* 12907 */     GIR_RootConstrainSelectedInstOperands,
     /* 12908 */     // GIR_Coverage, 29,
     /* 12908 */     GIR_Done,
     /* 12909 */   // Label 499: @12909
     /* 12909 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(12943), // Rule ID 30 //
     /* 12914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12928 */     // MIs[0] ptr
     /* 12928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12936 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i32>>  =>  (ATOMIC_LOAD_MIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I32),
     /* 12941 */     GIR_RootConstrainSelectedInstOperands,
     /* 12942 */     // GIR_Coverage, 30,
     /* 12942 */     GIR_Done,
     /* 12943 */   // Label 500: @12943
     /* 12943 */   GIM_Reject,
     /* 12944 */ // Label 497: @12944
     /* 12944 */ GIM_Reject,
     /* 12945 */ // Label 495: @12945
     /* 12945 */ GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(12982), // Rule ID 192 //
     /* 12950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12956 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12967 */   // MIs[0] ptr
     /* 12967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12975 */   // (atomic_load_min:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_min_i64>>  =>  (ATOMIC_LOAD_MIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I64),
     /* 12980 */   GIR_RootConstrainSelectedInstOperands,
     /* 12981 */   // GIR_Coverage, 192,
     /* 12981 */   GIR_Done,
     /* 12982 */ // Label 501: @12982
     /* 12982 */ GIM_Reject,
     /* 12983 */ // Label 496: @12983
     /* 12983 */ GIM_Reject,
     /* 12984 */ // Label 26: @12984
     /* 12984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 504*/ GIMT_Encode4(13153),
     /* 12995 */ /*GILLT_s32*//*Label 502*/ GIMT_Encode4(13003),
     /* 12999 */ /*GILLT_s64*//*Label 503*/ GIMT_Encode4(13115),
     /* 13003 */ // Label 502: @13003
     /* 13003 */ GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(13114),
     /* 13008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13011 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(13045), // Rule ID 37 //
     /* 13016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13030 */     // MIs[0] ptr
     /* 13030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13038 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i8>>  =>  (ATOMIC_LOAD_UMAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I8),
     /* 13043 */     GIR_RootConstrainSelectedInstOperands,
     /* 13044 */     // GIR_Coverage, 37,
     /* 13044 */     GIR_Done,
     /* 13045 */   // Label 506: @13045
     /* 13045 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(13079), // Rule ID 38 //
     /* 13050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13053 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13064 */     // MIs[0] ptr
     /* 13064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13072 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i16>>  =>  (ATOMIC_LOAD_UMAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I16),
     /* 13077 */     GIR_RootConstrainSelectedInstOperands,
     /* 13078 */     // GIR_Coverage, 38,
     /* 13078 */     GIR_Done,
     /* 13079 */   // Label 507: @13079
     /* 13079 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(13113), // Rule ID 39 //
     /* 13084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13098 */     // MIs[0] ptr
     /* 13098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13106 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i32>>  =>  (ATOMIC_LOAD_UMAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I32),
     /* 13111 */     GIR_RootConstrainSelectedInstOperands,
     /* 13112 */     // GIR_Coverage, 39,
     /* 13112 */     GIR_Done,
     /* 13113 */   // Label 508: @13113
     /* 13113 */   GIM_Reject,
     /* 13114 */ // Label 505: @13114
     /* 13114 */ GIM_Reject,
     /* 13115 */ // Label 503: @13115
     /* 13115 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(13152), // Rule ID 195 //
     /* 13120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13126 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13137 */   // MIs[0] ptr
     /* 13137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13145 */   // (atomic_load_umax:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umax_i64>>  =>  (ATOMIC_LOAD_UMAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I64),
     /* 13150 */   GIR_RootConstrainSelectedInstOperands,
     /* 13151 */   // GIR_Coverage, 195,
     /* 13151 */   GIR_Done,
     /* 13152 */ // Label 509: @13152
     /* 13152 */ GIM_Reject,
     /* 13153 */ // Label 504: @13153
     /* 13153 */ GIM_Reject,
     /* 13154 */ // Label 27: @13154
     /* 13154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 512*/ GIMT_Encode4(13323),
     /* 13165 */ /*GILLT_s32*//*Label 510*/ GIMT_Encode4(13173),
     /* 13169 */ /*GILLT_s64*//*Label 511*/ GIMT_Encode4(13285),
     /* 13173 */ // Label 510: @13173
     /* 13173 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(13284),
     /* 13178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13181 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(13215), // Rule ID 34 //
     /* 13186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13200 */     // MIs[0] ptr
     /* 13200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13208 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i8>>  =>  (ATOMIC_LOAD_UMIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I8),
     /* 13213 */     GIR_RootConstrainSelectedInstOperands,
     /* 13214 */     // GIR_Coverage, 34,
     /* 13214 */     GIR_Done,
     /* 13215 */   // Label 514: @13215
     /* 13215 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(13249), // Rule ID 35 //
     /* 13220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13234 */     // MIs[0] ptr
     /* 13234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13242 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i16>>  =>  (ATOMIC_LOAD_UMIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I16),
     /* 13247 */     GIR_RootConstrainSelectedInstOperands,
     /* 13248 */     // GIR_Coverage, 35,
     /* 13248 */     GIR_Done,
     /* 13249 */   // Label 515: @13249
     /* 13249 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(13283), // Rule ID 36 //
     /* 13254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13257 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13268 */     // MIs[0] ptr
     /* 13268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13276 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i32>>  =>  (ATOMIC_LOAD_UMIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I32),
     /* 13281 */     GIR_RootConstrainSelectedInstOperands,
     /* 13282 */     // GIR_Coverage, 36,
     /* 13282 */     GIR_Done,
     /* 13283 */   // Label 516: @13283
     /* 13283 */   GIM_Reject,
     /* 13284 */ // Label 513: @13284
     /* 13284 */ GIM_Reject,
     /* 13285 */ // Label 511: @13285
     /* 13285 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(13322), // Rule ID 194 //
     /* 13290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13307 */   // MIs[0] ptr
     /* 13307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13315 */   // (atomic_load_umin:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umin_i64>>  =>  (ATOMIC_LOAD_UMIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I64),
     /* 13320 */   GIR_RootConstrainSelectedInstOperands,
     /* 13321 */   // GIR_Coverage, 194,
     /* 13321 */   GIR_Done,
     /* 13322 */ // Label 517: @13322
     /* 13322 */ GIM_Reject,
     /* 13323 */ // Label 512: @13323
     /* 13323 */ GIM_Reject,
     /* 13324 */ // Label 28: @13324
     /* 13324 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 520*/ GIMT_Encode4(18044),
     /* 13335 */ /*GILLT_s32*//*Label 518*/ GIMT_Encode4(13343),
     /* 13339 */ /*GILLT_s64*//*Label 519*/ GIMT_Encode4(18010),
     /* 13343 */ // Label 518: @13343
     /* 13343 */ GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(13451), // Rule ID 2354 //
     /* 13348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13359 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13363 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13367 */   // MIs[1] Operand 1
     /* 13367 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13372 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13376 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13380 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13384 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13388 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13392 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13396 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13400 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13404 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13408 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13412 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13416 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13420 */   // MIs[4] Operand 1
     /* 13420 */   // No operand predicates
     /* 13420 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13425 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13429 */   // MIs[0] offset
     /* 13429 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13432 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13434 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13437 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13441 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13444 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13446 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13449 */   GIR_RootConstrainSelectedInstOperands,
     /* 13450 */   // GIR_Coverage, 2354,
     /* 13450 */   GIR_EraseRootFromParent_Done,
     /* 13451 */ // Label 521: @13451
     /* 13451 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(13566), // Rule ID 2355 //
     /* 13456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13467 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13471 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13475 */   // MIs[1] Operand 1
     /* 13475 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13480 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13484 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13488 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13492 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13496 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13500 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13504 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13508 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13512 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13523 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13527 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13531 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13535 */   // MIs[4] Operand 1
     /* 13535 */   // No operand predicates
     /* 13535 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13540 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13544 */   // MIs[0] offset
     /* 13544 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13547 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13549 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 13552 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13556 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13559 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13561 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13564 */   GIR_RootConstrainSelectedInstOperands,
     /* 13565 */   // GIR_Coverage, 2355,
     /* 13565 */   GIR_EraseRootFromParent_Done,
     /* 13566 */ // Label 522: @13566
     /* 13566 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(13674), // Rule ID 2356 //
     /* 13571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13586 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13590 */   // MIs[1] Operand 1
     /* 13590 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13595 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13599 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13603 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13607 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13611 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13615 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13619 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13623 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13627 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13631 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13635 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13639 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13643 */   // MIs[4] Operand 1
     /* 13643 */   // No operand predicates
     /* 13643 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13648 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13652 */   // MIs[0] offset
     /* 13652 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13655 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13657 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 13660 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13664 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13667 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13669 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13672 */   GIR_RootConstrainSelectedInstOperands,
     /* 13673 */   // GIR_Coverage, 2356,
     /* 13673 */   GIR_EraseRootFromParent_Done,
     /* 13674 */ // Label 523: @13674
     /* 13674 */ GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(13789), // Rule ID 2357 //
     /* 13679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13694 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13698 */   // MIs[1] Operand 1
     /* 13698 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13703 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13707 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13711 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13715 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13719 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13723 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13727 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13731 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13735 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13746 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13750 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13754 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13758 */   // MIs[4] Operand 1
     /* 13758 */   // No operand predicates
     /* 13758 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13763 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13767 */   // MIs[0] offset
     /* 13767 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13770 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13772 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 13775 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13779 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13782 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13784 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13787 */   GIR_RootConstrainSelectedInstOperands,
     /* 13788 */   // GIR_Coverage, 2357,
     /* 13788 */   GIR_EraseRootFromParent_Done,
     /* 13789 */ // Label 524: @13789
     /* 13789 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(13897), // Rule ID 270 //
     /* 13794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13809 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13813 */   // MIs[1] Operand 1
     /* 13813 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13818 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13822 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13826 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13830 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13834 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13839 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13843 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13847 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13851 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13855 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13859 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13863 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13867 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13871 */   // MIs[4] Operand 1
     /* 13871 */   // No operand predicates
     /* 13871 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13875 */   // MIs[0] offset
     /* 13875 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13878 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13880 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13883 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 13887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13890 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13892 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13895 */   GIR_RootConstrainSelectedInstOperands,
     /* 13896 */   // GIR_Coverage, 270,
     /* 13896 */   GIR_EraseRootFromParent_Done,
     /* 13897 */ // Label 525: @13897
     /* 13897 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(14012), // Rule ID 271 //
     /* 13902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13905 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13913 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13917 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13921 */   // MIs[1] Operand 1
     /* 13921 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13926 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13930 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13934 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13938 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13942 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13947 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13951 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13955 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13959 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13963 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13974 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13978 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13982 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13986 */   // MIs[4] Operand 1
     /* 13986 */   // No operand predicates
     /* 13986 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13990 */   // MIs[0] offset
     /* 13990 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13993 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13995 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 13998 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14002 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14005 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14007 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14010 */   GIR_RootConstrainSelectedInstOperands,
     /* 14011 */   // GIR_Coverage, 271,
     /* 14011 */   GIR_EraseRootFromParent_Done,
     /* 14012 */ // Label 526: @14012
     /* 14012 */ GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(14120), // Rule ID 272 //
     /* 14017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14028 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14032 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14036 */   // MIs[1] Operand 1
     /* 14036 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14041 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14045 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14049 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14053 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14057 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14062 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14066 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14070 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14074 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14078 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 14082 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14086 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14090 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14094 */   // MIs[4] Operand 1
     /* 14094 */   // No operand predicates
     /* 14094 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14098 */   // MIs[0] offset
     /* 14098 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14101 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14103 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 14106 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14110 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14113 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14115 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14118 */   GIR_RootConstrainSelectedInstOperands,
     /* 14119 */   // GIR_Coverage, 272,
     /* 14119 */   GIR_EraseRootFromParent_Done,
     /* 14120 */ // Label 527: @14120
     /* 14120 */ GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(14235), // Rule ID 273 //
     /* 14125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14136 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14140 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14144 */   // MIs[1] Operand 1
     /* 14144 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14149 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14153 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14157 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14161 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14165 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14170 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14174 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14178 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14182 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14186 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 14197 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14201 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14205 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14209 */   // MIs[4] Operand 1
     /* 14209 */   // No operand predicates
     /* 14209 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14213 */   // MIs[0] offset
     /* 14213 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14216 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14218 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 14221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14225 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14228 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14230 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14233 */   GIR_RootConstrainSelectedInstOperands,
     /* 14234 */   // GIR_Coverage, 273,
     /* 14234 */   GIR_EraseRootFromParent_Done,
     /* 14235 */ // Label 528: @14235
     /* 14235 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(14292), // Rule ID 94 //
     /* 14240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14243 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14255 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14259 */   // MIs[1] Operand 1
     /* 14259 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14264 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14269 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14273 */   // MIs[0] offset
     /* 14273 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14278 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 14281 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14285 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14287 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14290 */   GIR_RootConstrainSelectedInstOperands,
     /* 14291 */   // GIR_Coverage, 94,
     /* 14291 */   GIR_EraseRootFromParent_Done,
     /* 14292 */ // Label 529: @14292
     /* 14292 */ GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(14349), // Rule ID 95 //
     /* 14297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14308 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14312 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14316 */   // MIs[1] Operand 1
     /* 14316 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14321 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14326 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14330 */   // MIs[0] offset
     /* 14330 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14335 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ),
     /* 14338 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14342 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14344 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14347 */   GIR_RootConstrainSelectedInstOperands,
     /* 14348 */   // GIR_Coverage, 95,
     /* 14348 */   GIR_EraseRootFromParent_Done,
     /* 14349 */ // Label 530: @14349
     /* 14349 */ GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(14406), // Rule ID 96 //
     /* 14354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14369 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14373 */   // MIs[1] Operand 1
     /* 14373 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14383 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14387 */   // MIs[0] offset
     /* 14387 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14392 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 14395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14399 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14401 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14404 */   GIR_RootConstrainSelectedInstOperands,
     /* 14405 */   // GIR_Coverage, 96,
     /* 14405 */   GIR_EraseRootFromParent_Done,
     /* 14406 */ // Label 531: @14406
     /* 14406 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(14463), // Rule ID 97 //
     /* 14411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14426 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14430 */   // MIs[1] Operand 1
     /* 14430 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14435 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14440 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14444 */   // MIs[0] offset
     /* 14444 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14449 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ),
     /* 14452 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14456 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14458 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14461 */   GIR_RootConstrainSelectedInstOperands,
     /* 14462 */   // GIR_Coverage, 97,
     /* 14462 */   GIR_EraseRootFromParent_Done,
     /* 14463 */ // Label 532: @14463
     /* 14463 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(14520), // Rule ID 245 //
     /* 14468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14479 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14483 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14487 */   // MIs[1] Operand 1
     /* 14487 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14492 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14497 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14501 */   // MIs[0] offset
     /* 14501 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14506 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 14509 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14513 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14515 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14518 */   GIR_RootConstrainSelectedInstOperands,
     /* 14519 */   // GIR_Coverage, 245,
     /* 14519 */   GIR_EraseRootFromParent_Done,
     /* 14520 */ // Label 533: @14520
     /* 14520 */ GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(14577), // Rule ID 246 //
     /* 14525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14536 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14540 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14544 */   // MIs[1] Operand 1
     /* 14544 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14554 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14558 */   // MIs[0] offset
     /* 14558 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14563 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ64),
     /* 14566 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14570 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14572 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14575 */   GIR_RootConstrainSelectedInstOperands,
     /* 14576 */   // GIR_Coverage, 246,
     /* 14576 */   GIR_EraseRootFromParent_Done,
     /* 14577 */ // Label 534: @14577
     /* 14577 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(14634), // Rule ID 247 //
     /* 14582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14593 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14597 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14601 */   // MIs[1] Operand 1
     /* 14601 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14606 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14611 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14615 */   // MIs[0] offset
     /* 14615 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14620 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 14623 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14627 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14629 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14632 */   GIR_RootConstrainSelectedInstOperands,
     /* 14633 */   // GIR_Coverage, 247,
     /* 14633 */   GIR_EraseRootFromParent_Done,
     /* 14634 */ // Label 535: @14634
     /* 14634 */ GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(14691), // Rule ID 248 //
     /* 14639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14650 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14654 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14658 */   // MIs[1] Operand 1
     /* 14658 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14663 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14668 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14672 */   // MIs[0] offset
     /* 14672 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14677 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ64),
     /* 14680 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14684 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14686 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14689 */   GIR_RootConstrainSelectedInstOperands,
     /* 14690 */   // GIR_Coverage, 248,
     /* 14690 */   GIR_EraseRootFromParent_Done,
     /* 14691 */ // Label 536: @14691
     /* 14691 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(14748), // Rule ID 1109 //
     /* 14696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14699 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14703 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14707 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14711 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14715 */   // MIs[1] Operand 1
     /* 14715 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14729 */   // MIs[0] offset
     /* 14729 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14734 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 14737 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14741 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14743 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14746 */   GIR_RootConstrainSelectedInstOperands,
     /* 14747 */   // GIR_Coverage, 1109,
     /* 14747 */   GIR_EraseRootFromParent_Done,
     /* 14748 */ // Label 537: @14748
     /* 14748 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(14805), // Rule ID 1110 //
     /* 14753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14768 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14772 */   // MIs[1] Operand 1
     /* 14772 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14782 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14786 */   // MIs[0] offset
     /* 14786 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14791 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ_MM),
     /* 14794 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14798 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14800 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14803 */   GIR_RootConstrainSelectedInstOperands,
     /* 14804 */   // GIR_Coverage, 1110,
     /* 14804 */   GIR_EraseRootFromParent_Done,
     /* 14805 */ // Label 538: @14805
     /* 14805 */ GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(14862), // Rule ID 1111 //
     /* 14810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14821 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14825 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14829 */   // MIs[1] Operand 1
     /* 14829 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14834 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14839 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14843 */   // MIs[0] offset
     /* 14843 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14848 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 14851 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14855 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14857 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14860 */   GIR_RootConstrainSelectedInstOperands,
     /* 14861 */   // GIR_Coverage, 1111,
     /* 14861 */   GIR_EraseRootFromParent_Done,
     /* 14862 */ // Label 539: @14862
     /* 14862 */ GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(14919), // Rule ID 1112 //
     /* 14867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14870 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14878 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14882 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14886 */   // MIs[1] Operand 1
     /* 14886 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14896 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14900 */   // MIs[0] offset
     /* 14900 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14903 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14905 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ_MM),
     /* 14908 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14912 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14914 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14917 */   GIR_RootConstrainSelectedInstOperands,
     /* 14918 */   // GIR_Coverage, 1112,
     /* 14918 */   GIR_EraseRootFromParent_Done,
     /* 14919 */ // Label 540: @14919
     /* 14919 */ GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(14982), // Rule ID 1402 //
     /* 14924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14939 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14943 */   // MIs[1] Operand 1
     /* 14943 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14948 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14953 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14957 */   // MIs[0] dst
     /* 14957 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14960 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14962 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 14962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 14965 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 14969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 14975 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 14977 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14980 */   GIR_RootConstrainSelectedInstOperands,
     /* 14981 */   // GIR_Coverage, 1402,
     /* 14981 */   GIR_EraseRootFromParent_Done,
     /* 14982 */ // Label 541: @14982
     /* 14982 */ GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(15045), // Rule ID 1403 //
     /* 14987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14990 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14998 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15002 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15006 */   // MIs[1] Operand 1
     /* 15006 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15011 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15016 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15020 */   // MIs[0] dst
     /* 15020 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15023 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15025 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15032 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15038 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15040 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15043 */   GIR_RootConstrainSelectedInstOperands,
     /* 15044 */   // GIR_Coverage, 1403,
     /* 15044 */   GIR_EraseRootFromParent_Done,
     /* 15045 */ // Label 542: @15045
     /* 15045 */ GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(15108), // Rule ID 1546 //
     /* 15050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15061 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15065 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15069 */   // MIs[1] Operand 1
     /* 15069 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15074 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15079 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15083 */   // MIs[0] dst
     /* 15083 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15088 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 15091 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15095 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15101 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15103 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15106 */   GIR_RootConstrainSelectedInstOperands,
     /* 15107 */   // GIR_Coverage, 1546,
     /* 15107 */   GIR_EraseRootFromParent_Done,
     /* 15108 */ // Label 543: @15108
     /* 15108 */ GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(15171), // Rule ID 1547 //
     /* 15113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15128 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15132 */   // MIs[1] Operand 1
     /* 15132 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15137 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15142 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15146 */   // MIs[0] dst
     /* 15146 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15151 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 15154 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15158 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15164 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15166 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15169 */   GIR_RootConstrainSelectedInstOperands,
     /* 15170 */   // GIR_Coverage, 1547,
     /* 15170 */   GIR_EraseRootFromParent_Done,
     /* 15171 */ // Label 544: @15171
     /* 15171 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(15225), // Rule ID 1847 //
     /* 15176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15187 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15191 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15195 */   // MIs[1] Operand 1
     /* 15195 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15200 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15205 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15209 */   // MIs[0] targ16
     /* 15209 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15214 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BeqzRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BeqzRxImm16),
     /* 15217 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15221 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15223 */   GIR_RootConstrainSelectedInstOperands,
     /* 15224 */   // GIR_Coverage, 1847,
     /* 15224 */   GIR_EraseRootFromParent_Done,
     /* 15225 */ // Label 545: @15225
     /* 15225 */ GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(15279), // Rule ID 1856 //
     /* 15230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15241 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15245 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15249 */   // MIs[1] Operand 1
     /* 15249 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15254 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15259 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15263 */   // MIs[0] targ16
     /* 15263 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15268 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 15271 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15275 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15277 */   GIR_RootConstrainSelectedInstOperands,
     /* 15278 */   // GIR_Coverage, 1856,
     /* 15278 */   GIR_EraseRootFromParent_Done,
     /* 15279 */ // Label 546: @15279
     /* 15279 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(15342), // Rule ID 2184 //
     /* 15284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15287 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15299 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15303 */   // MIs[1] Operand 1
     /* 15303 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15308 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15313 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15317 */   // MIs[0] dst
     /* 15317 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15320 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15322 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 15325 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15335 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15337 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15340 */   GIR_RootConstrainSelectedInstOperands,
     /* 15341 */   // GIR_Coverage, 2184,
     /* 15341 */   GIR_EraseRootFromParent_Done,
     /* 15342 */ // Label 547: @15342
     /* 15342 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(15405), // Rule ID 2185 //
     /* 15347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15350 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15354 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15362 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15366 */   // MIs[1] Operand 1
     /* 15366 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15371 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15376 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15380 */   // MIs[0] dst
     /* 15380 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15385 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 15388 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15398 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15400 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15403 */   GIR_RootConstrainSelectedInstOperands,
     /* 15404 */   // GIR_Coverage, 2185,
     /* 15404 */   GIR_EraseRootFromParent_Done,
     /* 15405 */ // Label 548: @15405
     /* 15405 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(15462), // Rule ID 2331 //
     /* 15410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15421 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15425 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15429 */   // MIs[1] Operand 1
     /* 15429 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15434 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15439 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15443 */   // MIs[0] dst
     /* 15443 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15448 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 15451 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15455 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15457 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15460 */   GIR_RootConstrainSelectedInstOperands,
     /* 15461 */   // GIR_Coverage, 2331,
     /* 15461 */   GIR_EraseRootFromParent_Done,
     /* 15462 */ // Label 549: @15462
     /* 15462 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(15519), // Rule ID 2332 //
     /* 15467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15482 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15486 */   // MIs[1] Operand 1
     /* 15486 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15491 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15496 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15500 */   // MIs[0] dst
     /* 15500 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15505 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 15508 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15512 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15514 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15517 */   GIR_RootConstrainSelectedInstOperands,
     /* 15518 */   // GIR_Coverage, 2332,
     /* 15518 */   GIR_EraseRootFromParent_Done,
     /* 15519 */ // Label 550: @15519
     /* 15519 */ GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(15571), // Rule ID 1413 //
     /* 15524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15535 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15539 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15543 */   // MIs[1] Operand 1
     /* 15543 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15548 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15552 */   // MIs[0] dst
     /* 15552 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15557 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 15560 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15564 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15566 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15569 */   GIR_RootConstrainSelectedInstOperands,
     /* 15570 */   // GIR_Coverage, 1413,
     /* 15570 */   GIR_EraseRootFromParent_Done,
     /* 15571 */ // Label 551: @15571
     /* 15571 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(15623), // Rule ID 1414 //
     /* 15576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15591 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15595 */   // MIs[1] Operand 1
     /* 15595 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15600 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15604 */   // MIs[0] dst
     /* 15604 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15609 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 15612 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15616 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15618 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15621 */   GIR_RootConstrainSelectedInstOperands,
     /* 15622 */   // GIR_Coverage, 1414,
     /* 15622 */   GIR_EraseRootFromParent_Done,
     /* 15623 */ // Label 552: @15623
     /* 15623 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(15675), // Rule ID 1557 //
     /* 15628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15639 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15643 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15647 */   // MIs[1] Operand 1
     /* 15647 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15652 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15656 */   // MIs[0] dst
     /* 15656 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15661 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, 1:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 15664 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15668 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15670 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15673 */   GIR_RootConstrainSelectedInstOperands,
     /* 15674 */   // GIR_Coverage, 1557,
     /* 15674 */   GIR_EraseRootFromParent_Done,
     /* 15675 */ // Label 553: @15675
     /* 15675 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(15727), // Rule ID 1558 //
     /* 15680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15691 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15695 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15699 */   // MIs[1] Operand 1
     /* 15699 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15704 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15708 */   // MIs[0] dst
     /* 15708 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15713 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, -1:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 15716 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15720 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15722 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15725 */   GIR_RootConstrainSelectedInstOperands,
     /* 15726 */   // GIR_Coverage, 1558,
     /* 15726 */   GIR_EraseRootFromParent_Done,
     /* 15727 */ // Label 554: @15727
     /* 15727 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(15779), // Rule ID 2195 //
     /* 15732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15743 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15747 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15751 */   // MIs[1] Operand 1
     /* 15751 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15756 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15760 */   // MIs[0] dst
     /* 15760 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15765 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 15768 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15772 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15774 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15777 */   GIR_RootConstrainSelectedInstOperands,
     /* 15778 */   // GIR_Coverage, 2195,
     /* 15778 */   GIR_EraseRootFromParent_Done,
     /* 15779 */ // Label 555: @15779
     /* 15779 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(15831), // Rule ID 2196 //
     /* 15784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15795 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15799 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15803 */   // MIs[1] Operand 1
     /* 15803 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15808 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15812 */   // MIs[0] dst
     /* 15812 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15817 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 15820 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15824 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15826 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15829 */   GIR_RootConstrainSelectedInstOperands,
     /* 15830 */   // GIR_Coverage, 2196,
     /* 15830 */   GIR_EraseRootFromParent_Done,
     /* 15831 */ // Label 556: @15831
     /* 15831 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(15893), // Rule ID 92 //
     /* 15836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15847 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15851 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15855 */   // MIs[1] Operand 1
     /* 15855 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15860 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15865 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15870 */   // MIs[0] offset
     /* 15870 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15875 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15878 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15886 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15888 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15891 */   GIR_RootConstrainSelectedInstOperands,
     /* 15892 */   // GIR_Coverage, 92,
     /* 15892 */   GIR_EraseRootFromParent_Done,
     /* 15893 */ // Label 557: @15893
     /* 15893 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(15955), // Rule ID 93 //
     /* 15898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15909 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15913 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15917 */   // MIs[1] Operand 1
     /* 15917 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15922 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15927 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15932 */   // MIs[0] offset
     /* 15932 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15937 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 15940 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15944 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15948 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15950 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15953 */   GIR_RootConstrainSelectedInstOperands,
     /* 15954 */   // GIR_Coverage, 93,
     /* 15954 */   GIR_EraseRootFromParent_Done,
     /* 15955 */ // Label 558: @15955
     /* 15955 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(16017), // Rule ID 243 //
     /* 15960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 15963 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15971 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15975 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15979 */   // MIs[1] Operand 1
     /* 15979 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15984 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15994 */   // MIs[0] offset
     /* 15994 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15999 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 16002 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16006 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16010 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16012 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16015 */   GIR_RootConstrainSelectedInstOperands,
     /* 16016 */   // GIR_Coverage, 243,
     /* 16016 */   GIR_EraseRootFromParent_Done,
     /* 16017 */ // Label 559: @16017
     /* 16017 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(16079), // Rule ID 244 //
     /* 16022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 16025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16037 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16041 */   // MIs[1] Operand 1
     /* 16041 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16056 */   // MIs[0] offset
     /* 16056 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16061 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 16064 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16068 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16072 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16074 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16077 */   GIR_RootConstrainSelectedInstOperands,
     /* 16078 */   // GIR_Coverage, 244,
     /* 16078 */   GIR_EraseRootFromParent_Done,
     /* 16079 */ // Label 560: @16079
     /* 16079 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(16141), // Rule ID 1107 //
     /* 16084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16099 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16103 */   // MIs[1] Operand 1
     /* 16103 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16108 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16113 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16118 */   // MIs[0] offset
     /* 16118 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16123 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 16126 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16130 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16134 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16136 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16139 */   GIR_RootConstrainSelectedInstOperands,
     /* 16140 */   // GIR_Coverage, 1107,
     /* 16140 */   GIR_EraseRootFromParent_Done,
     /* 16141 */ // Label 561: @16141
     /* 16141 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(16203), // Rule ID 1108 //
     /* 16146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16157 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16161 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16165 */   // MIs[1] Operand 1
     /* 16165 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16170 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16175 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16180 */   // MIs[0] offset
     /* 16180 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16185 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 16188 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16192 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16196 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16198 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16201 */   GIR_RootConstrainSelectedInstOperands,
     /* 16202 */   // GIR_Coverage, 1108,
     /* 16202 */   GIR_EraseRootFromParent_Done,
     /* 16203 */ // Label 562: @16203
     /* 16203 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(16288), // Rule ID 1404 //
     /* 16208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16219 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16223 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16227 */   // MIs[1] Operand 1
     /* 16227 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16232 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16237 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16242 */   // MIs[0] dst
     /* 16242 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16247 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16275 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16281 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16283 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16286 */   GIR_RootConstrainSelectedInstOperands,
     /* 16287 */   // GIR_Coverage, 1404,
     /* 16287 */   GIR_EraseRootFromParent_Done,
     /* 16288 */ // Label 563: @16288
     /* 16288 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(16373), // Rule ID 1405 //
     /* 16293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16304 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16308 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16312 */   // MIs[1] Operand 1
     /* 16312 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16317 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16322 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16327 */   // MIs[0] dst
     /* 16327 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16332 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16344 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16348 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16360 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16366 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16368 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16371 */   GIR_RootConstrainSelectedInstOperands,
     /* 16372 */   // GIR_Coverage, 1405,
     /* 16372 */   GIR_EraseRootFromParent_Done,
     /* 16373 */ // Label 564: @16373
     /* 16373 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(16458), // Rule ID 1410 //
     /* 16378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16389 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16393 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16397 */   // MIs[1] Operand 1
     /* 16397 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16402 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16407 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16412 */   // MIs[0] dst
     /* 16412 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16417 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16429 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16433 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16451 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16453 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16456 */   GIR_RootConstrainSelectedInstOperands,
     /* 16457 */   // GIR_Coverage, 1410,
     /* 16457 */   GIR_EraseRootFromParent_Done,
     /* 16458 */ // Label 565: @16458
     /* 16458 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(16543), // Rule ID 1411 //
     /* 16463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16474 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16478 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16482 */   // MIs[1] Operand 1
     /* 16482 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16492 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16497 */   // MIs[0] dst
     /* 16497 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16502 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16530 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16536 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16538 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16541 */   GIR_RootConstrainSelectedInstOperands,
     /* 16542 */   // GIR_Coverage, 1411,
     /* 16542 */   GIR_EraseRootFromParent_Done,
     /* 16543 */ // Label 566: @16543
     /* 16543 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(16628), // Rule ID 1548 //
     /* 16548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16563 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16567 */   // MIs[1] Operand 1
     /* 16567 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16572 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16577 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16582 */   // MIs[0] dst
     /* 16582 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16587 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16615 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16621 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16623 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16626 */   GIR_RootConstrainSelectedInstOperands,
     /* 16627 */   // GIR_Coverage, 1548,
     /* 16627 */   GIR_EraseRootFromParent_Done,
     /* 16628 */ // Label 567: @16628
     /* 16628 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(16713), // Rule ID 1549 //
     /* 16633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16644 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16648 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16652 */   // MIs[1] Operand 1
     /* 16652 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16657 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16662 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16667 */   // MIs[0] dst
     /* 16667 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16672 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16684 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16688 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16700 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16706 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16708 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16711 */   GIR_RootConstrainSelectedInstOperands,
     /* 16712 */   // GIR_Coverage, 1549,
     /* 16712 */   GIR_EraseRootFromParent_Done,
     /* 16713 */ // Label 568: @16713
     /* 16713 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(16798), // Rule ID 1554 //
     /* 16718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16729 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16733 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16737 */   // MIs[1] Operand 1
     /* 16737 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16742 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16747 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16752 */   // MIs[0] dst
     /* 16752 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16757 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16773 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16791 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16793 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16796 */   GIR_RootConstrainSelectedInstOperands,
     /* 16797 */   // GIR_Coverage, 1554,
     /* 16797 */   GIR_EraseRootFromParent_Done,
     /* 16798 */ // Label 569: @16798
     /* 16798 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(16883), // Rule ID 1555 //
     /* 16803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16814 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16818 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16822 */   // MIs[1] Operand 1
     /* 16822 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16827 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16832 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16837 */   // MIs[0] dst
     /* 16837 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16842 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16854 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16858 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16870 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16876 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16878 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16881 */   GIR_RootConstrainSelectedInstOperands,
     /* 16882 */   // GIR_Coverage, 1555,
     /* 16882 */   GIR_EraseRootFromParent_Done,
     /* 16883 */ // Label 570: @16883
     /* 16883 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(16942), // Rule ID 1845 //
     /* 16888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16899 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16903 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16907 */   // MIs[1] Operand 1
     /* 16907 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16912 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16917 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16922 */   // MIs[0] imm16
     /* 16922 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16927 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 16927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8CmpX16),
     /* 16930 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 16934 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 16938 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 16940 */   GIR_RootConstrainSelectedInstOperands,
     /* 16941 */   // GIR_Coverage, 1845,
     /* 16941 */   GIR_EraseRootFromParent_Done,
     /* 16942 */ // Label 571: @16942
     /* 16942 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(17001), // Rule ID 1848 //
     /* 16947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16962 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16966 */   // MIs[1] Operand 1
     /* 16966 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 16971 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16976 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16981 */   // MIs[0] imm16
     /* 16981 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16986 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 16986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 16989 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 16993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 16997 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 16999 */   GIR_RootConstrainSelectedInstOperands,
     /* 17000 */   // GIR_Coverage, 1848,
     /* 17000 */   GIR_EraseRootFromParent_Done,
     /* 17001 */ // Label 572: @17001
     /* 17001 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(17060), // Rule ID 1849 //
     /* 17006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17017 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17021 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17025 */   // MIs[1] Operand 1
     /* 17025 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17030 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17035 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17040 */   // MIs[0] imm16
     /* 17040 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17045 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17048 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17052 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17056 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17058 */   GIR_RootConstrainSelectedInstOperands,
     /* 17059 */   // GIR_Coverage, 1849,
     /* 17059 */   GIR_EraseRootFromParent_Done,
     /* 17060 */ // Label 573: @17060
     /* 17060 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(17119), // Rule ID 1851 //
     /* 17065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17076 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17080 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17084 */   // MIs[1] Operand 1
     /* 17084 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 17089 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17094 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17099 */   // MIs[0] imm16
     /* 17099 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17104 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 17107 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17111 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17115 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17117 */   GIR_RootConstrainSelectedInstOperands,
     /* 17118 */   // GIR_Coverage, 1851,
     /* 17118 */   GIR_EraseRootFromParent_Done,
     /* 17119 */ // Label 574: @17119
     /* 17119 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(17178), // Rule ID 1853 //
     /* 17124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17135 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17139 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17143 */   // MIs[1] Operand 1
     /* 17143 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17148 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17153 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17158 */   // MIs[0] imm16
     /* 17158 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17163 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 17163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17166 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17170 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17174 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17176 */   GIR_RootConstrainSelectedInstOperands,
     /* 17177 */   // GIR_Coverage, 1853,
     /* 17177 */   GIR_EraseRootFromParent_Done,
     /* 17178 */ // Label 575: @17178
     /* 17178 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(17237), // Rule ID 1854 //
     /* 17183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17194 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17198 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17202 */   // MIs[1] Operand 1
     /* 17202 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 17207 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17212 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17217 */   // MIs[0] imm16
     /* 17217 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17222 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8CmpX16),
     /* 17225 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17229 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17233 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17235 */   GIR_RootConstrainSelectedInstOperands,
     /* 17236 */   // GIR_Coverage, 1854,
     /* 17236 */   GIR_EraseRootFromParent_Done,
     /* 17237 */ // Label 576: @17237
     /* 17237 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(17322), // Rule ID 2186 //
     /* 17242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17257 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17261 */   // MIs[1] Operand 1
     /* 17261 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17271 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17276 */   // MIs[0] dst
     /* 17276 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17281 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17293 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17297 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17309 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17315 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17317 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17320 */   GIR_RootConstrainSelectedInstOperands,
     /* 17321 */   // GIR_Coverage, 2186,
     /* 17321 */   GIR_EraseRootFromParent_Done,
     /* 17322 */ // Label 577: @17322
     /* 17322 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(17407), // Rule ID 2187 //
     /* 17327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17342 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17346 */   // MIs[1] Operand 1
     /* 17346 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17351 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17361 */   // MIs[0] dst
     /* 17361 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17364 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17366 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17378 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17394 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17400 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17402 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17405 */   GIR_RootConstrainSelectedInstOperands,
     /* 17406 */   // GIR_Coverage, 2187,
     /* 17406 */   GIR_EraseRootFromParent_Done,
     /* 17407 */ // Label 578: @17407
     /* 17407 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(17492), // Rule ID 2192 //
     /* 17412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17427 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17431 */   // MIs[1] Operand 1
     /* 17431 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17436 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17441 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17446 */   // MIs[0] dst
     /* 17446 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17451 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17463 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17467 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17479 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17485 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17487 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17490 */   GIR_RootConstrainSelectedInstOperands,
     /* 17491 */   // GIR_Coverage, 2192,
     /* 17491 */   GIR_EraseRootFromParent_Done,
     /* 17492 */ // Label 579: @17492
     /* 17492 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17577), // Rule ID 2193 //
     /* 17497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17508 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17512 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17516 */   // MIs[1] Operand 1
     /* 17516 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17531 */   // MIs[0] dst
     /* 17531 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17536 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17548 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17552 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17564 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17570 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17572 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17575 */   GIR_RootConstrainSelectedInstOperands,
     /* 17576 */   // GIR_Coverage, 2193,
     /* 17576 */   GIR_EraseRootFromParent_Done,
     /* 17577 */ // Label 580: @17577
     /* 17577 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(17656), // Rule ID 2333 //
     /* 17582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17593 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17597 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17601 */   // MIs[1] Operand 1
     /* 17601 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17606 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17611 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17616 */   // MIs[0] dst
     /* 17616 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17621 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17633 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17637 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17649 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17651 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17654 */   GIR_RootConstrainSelectedInstOperands,
     /* 17655 */   // GIR_Coverage, 2333,
     /* 17655 */   GIR_EraseRootFromParent_Done,
     /* 17656 */ // Label 581: @17656
     /* 17656 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(17735), // Rule ID 2334 //
     /* 17661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17672 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17676 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17680 */   // MIs[1] Operand 1
     /* 17680 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17690 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17695 */   // MIs[0] dst
     /* 17695 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17700 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17716 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17728 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17730 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17733 */   GIR_RootConstrainSelectedInstOperands,
     /* 17734 */   // GIR_Coverage, 2334,
     /* 17734 */   GIR_EraseRootFromParent_Done,
     /* 17735 */ // Label 582: @17735
     /* 17735 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17814), // Rule ID 2339 //
     /* 17740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17751 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17755 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17759 */   // MIs[1] Operand 1
     /* 17759 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17764 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17769 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17774 */   // MIs[0] dst
     /* 17774 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17779 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17807 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17809 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17812 */   GIR_RootConstrainSelectedInstOperands,
     /* 17813 */   // GIR_Coverage, 2339,
     /* 17813 */   GIR_EraseRootFromParent_Done,
     /* 17814 */ // Label 583: @17814
     /* 17814 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(17893), // Rule ID 2340 //
     /* 17819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17834 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17838 */   // MIs[1] Operand 1
     /* 17838 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17843 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17848 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17853 */   // MIs[0] dst
     /* 17853 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17858 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17870 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17886 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17888 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17891 */   GIR_RootConstrainSelectedInstOperands,
     /* 17892 */   // GIR_Coverage, 2340,
     /* 17892 */   GIR_EraseRootFromParent_Done,
     /* 17893 */ // Label 584: @17893
     /* 17893 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(17926), // Rule ID 1412 //
     /* 17898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 17901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17905 */   // MIs[0] dst
     /* 17905 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17908 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 17911 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17913 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17919 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17921 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17924 */   GIR_RootConstrainSelectedInstOperands,
     /* 17925 */   // GIR_Coverage, 1412,
     /* 17925 */   GIR_EraseRootFromParent_Done,
     /* 17926 */ // Label 585: @17926
     /* 17926 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(17948), // Rule ID 1857 //
     /* 17931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17938 */   // MIs[0] targ16
     /* 17938 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17941 */   // (brcond CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 17941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 17946 */   GIR_RootConstrainSelectedInstOperands,
     /* 17947 */   // GIR_Coverage, 1857,
     /* 17947 */   GIR_Done,
     /* 17948 */ // Label 586: @17948
     /* 17948 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(17981), // Rule ID 2194 //
     /* 17953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17960 */   // MIs[0] dst
     /* 17960 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17963 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 17966 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17968 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17974 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17976 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17979 */   GIR_RootConstrainSelectedInstOperands,
     /* 17980 */   // GIR_Coverage, 2194,
     /* 17980 */   GIR_EraseRootFromParent_Done,
     /* 17981 */ // Label 587: @17981
     /* 17981 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(18009), // Rule ID 2341 //
     /* 17986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17993 */   // MIs[0] dst
     /* 17993 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17996 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)
     /* 17996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 18001 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 18007 */   GIR_RootConstrainSelectedInstOperands,
     /* 18008 */   // GIR_Coverage, 2341,
     /* 18008 */   GIR_Done,
     /* 18009 */ // Label 588: @18009
     /* 18009 */ GIM_Reject,
     /* 18010 */ // Label 519: @18010
     /* 18010 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(18043), // Rule ID 1556 //
     /* 18015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 18022 */   // MIs[0] dst
     /* 18022 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18025 */   // (brcond GPR64:{ *:[i64] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$cond, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 18025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 18028 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 18030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 18036 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 18038 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 18041 */   GIR_RootConstrainSelectedInstOperands,
     /* 18042 */   // GIR_Coverage, 1556,
     /* 18042 */   GIR_EraseRootFromParent_Done,
     /* 18043 */ // Label 589: @18043
     /* 18043 */ GIM_Reject,
     /* 18044 */ // Label 520: @18044
     /* 18044 */ GIM_Reject,
     /* 18045 */ // Label 29: @18045
     /* 18045 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(20042),
     /* 18050 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 18053 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(18100), // Rule ID 428 //
     /* 18058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18088 */     // MIs[1] Operand 1
     /* 18088 */     // No operand predicates
     /* 18088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18090 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7997:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB),
     /* 18093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18098 */     GIR_RootConstrainSelectedInstOperands,
     /* 18099 */     // GIR_Coverage, 428,
     /* 18099 */     GIR_EraseRootFromParent_Done,
     /* 18100 */   // Label 591: @18100
     /* 18100 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(18147), // Rule ID 429 //
     /* 18105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18135 */     // MIs[1] Operand 1
     /* 18135 */     // No operand predicates
     /* 18135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18137 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7996:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH),
     /* 18140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18145 */     GIR_RootConstrainSelectedInstOperands,
     /* 18146 */     // GIR_Coverage, 429,
     /* 18146 */     GIR_EraseRootFromParent_Done,
     /* 18147 */   // Label 592: @18147
     /* 18147 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(18194), // Rule ID 1288 //
     /* 18152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18182 */     // MIs[1] Operand 1
     /* 18182 */     // No operand predicates
     /* 18182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18184 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7996:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH_MM:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH_MM),
     /* 18187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18192 */     GIR_RootConstrainSelectedInstOperands,
     /* 18193 */     // GIR_Coverage, 1288,
     /* 18193 */     GIR_EraseRootFromParent_Done,
     /* 18194 */   // Label 593: @18194
     /* 18194 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(18241), // Rule ID 1289 //
     /* 18199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18229 */     // MIs[1] Operand 1
     /* 18229 */     // No operand predicates
     /* 18229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18231 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7997:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB_MM:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB_MM),
     /* 18234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 18236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18239 */     GIR_RootConstrainSelectedInstOperands,
     /* 18240 */     // GIR_Coverage, 1289,
     /* 18240 */     GIR_EraseRootFromParent_Done,
     /* 18241 */   // Label 594: @18241
     /* 18241 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(18277), // Rule ID 362 //
     /* 18246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 18254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18268 */     // (intrinsic_wo_chain:{ *:[i32] } 7994:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 18268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB),
     /* 18271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 18275 */     GIR_RootConstrainSelectedInstOperands,
     /* 18276 */     // GIR_Coverage, 362,
     /* 18276 */     GIR_EraseRootFromParent_Done,
     /* 18277 */   // Label 595: @18277
     /* 18277 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(18313), // Rule ID 369 //
     /* 18282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 18290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18304 */     // (intrinsic_wo_chain:{ *:[i32] } 7976:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL),
     /* 18307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18311 */     GIR_RootConstrainSelectedInstOperands,
     /* 18312 */     // GIR_Coverage, 369,
     /* 18312 */     GIR_EraseRootFromParent_Done,
     /* 18313 */   // Label 596: @18313
     /* 18313 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(18349), // Rule ID 370 //
     /* 18318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 18326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18340 */     // (intrinsic_wo_chain:{ *:[i32] } 7977:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR),
     /* 18343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18347 */     GIR_RootConstrainSelectedInstOperands,
     /* 18348 */     // GIR_Coverage, 370,
     /* 18348 */     GIR_EraseRootFromParent_Done,
     /* 18349 */   // Label 597: @18349
     /* 18349 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(18385), // Rule ID 371 //
     /* 18354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 18362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18376 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7978:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL),
     /* 18379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18383 */     GIR_RootConstrainSelectedInstOperands,
     /* 18384 */     // GIR_Coverage, 371,
     /* 18384 */     GIR_EraseRootFromParent_Done,
     /* 18385 */   // Label 598: @18385
     /* 18385 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(18421), // Rule ID 372 //
     /* 18390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 18398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18412 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7980:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR),
     /* 18415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18419 */     GIR_RootConstrainSelectedInstOperands,
     /* 18420 */     // GIR_Coverage, 372,
     /* 18420 */     GIR_EraseRootFromParent_Done,
     /* 18421 */   // Label 599: @18421
     /* 18421 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(18457), // Rule ID 373 //
     /* 18426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 18434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18448 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7979:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA),
     /* 18451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18455 */     GIR_RootConstrainSelectedInstOperands,
     /* 18456 */     // GIR_Coverage, 373,
     /* 18456 */     GIR_EraseRootFromParent_Done,
     /* 18457 */   // Label 600: @18457
     /* 18457 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(18493), // Rule ID 374 //
     /* 18462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 18470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18484 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7981:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA),
     /* 18487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18491 */     GIR_RootConstrainSelectedInstOperands,
     /* 18492 */     // GIR_Coverage, 374,
     /* 18492 */     GIR_EraseRootFromParent_Done,
     /* 18493 */   // Label 601: @18493
     /* 18493 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(18529), // Rule ID 375 //
     /* 18498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 18506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18520 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7982:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL),
     /* 18523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18527 */     GIR_RootConstrainSelectedInstOperands,
     /* 18528 */     // GIR_Coverage, 375,
     /* 18528 */     GIR_EraseRootFromParent_Done,
     /* 18529 */   // Label 602: @18529
     /* 18529 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(18565), // Rule ID 376 //
     /* 18534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 18542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18556 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7984:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR),
     /* 18559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18563 */     GIR_RootConstrainSelectedInstOperands,
     /* 18564 */     // GIR_Coverage, 376,
     /* 18564 */     GIR_EraseRootFromParent_Done,
     /* 18565 */   // Label 603: @18565
     /* 18565 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(18601), // Rule ID 377 //
     /* 18570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 18578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18592 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7983:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA),
     /* 18595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18599 */     GIR_RootConstrainSelectedInstOperands,
     /* 18600 */     // GIR_Coverage, 377,
     /* 18600 */     GIR_EraseRootFromParent_Done,
     /* 18601 */   // Label 604: @18601
     /* 18601 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(18637), // Rule ID 378 //
     /* 18606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 18614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18628 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7985:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA),
     /* 18631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18635 */     GIR_RootConstrainSelectedInstOperands,
     /* 18636 */     // GIR_Coverage, 378,
     /* 18636 */     GIR_EraseRootFromParent_Done,
     /* 18637 */   // Label 605: @18637
     /* 18637 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(18673), // Rule ID 426 //
     /* 18642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 18650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18664 */     // (intrinsic_wo_chain:{ *:[i32] } 7550:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (BITREV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV),
     /* 18667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18671 */     GIR_RootConstrainSelectedInstOperands,
     /* 18672 */     // GIR_Coverage, 426,
     /* 18672 */     GIR_EraseRootFromParent_Done,
     /* 18673 */   // Label 606: @18673
     /* 18673 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(18709), // Rule ID 430 //
     /* 18678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18700 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7997:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_QB:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB),
     /* 18703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18707 */     GIR_RootConstrainSelectedInstOperands,
     /* 18708 */     // GIR_Coverage, 430,
     /* 18708 */     GIR_EraseRootFromParent_Done,
     /* 18709 */   // Label 607: @18709
     /* 18709 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(18745), // Rule ID 431 //
     /* 18714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18736 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7996:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_PH:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH),
     /* 18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18743 */     GIR_RootConstrainSelectedInstOperands,
     /* 18744 */     // GIR_Coverage, 431,
     /* 18744 */     GIR_EraseRootFromParent_Done,
     /* 18745 */   // Label 608: @18745
     /* 18745 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18781), // Rule ID 680 //
     /* 18750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_w),
     /* 18758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7702:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FCLASS_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_W),
     /* 18775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18777 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18779 */     GIR_RootConstrainSelectedInstOperands,
     /* 18780 */     // GIR_Coverage, 680,
     /* 18780 */     GIR_EraseRootFromParent_Done,
     /* 18781 */   // Label 609: @18781
     /* 18781 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18817), // Rule ID 681 //
     /* 18786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_d),
     /* 18794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 18800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18808 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7701:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FCLASS_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 18808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_D),
     /* 18811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18813 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18815 */     GIR_RootConstrainSelectedInstOperands,
     /* 18816 */     // GIR_Coverage, 681,
     /* 18816 */     GIR_EraseRootFromParent_Done,
     /* 18817 */   // Label 610: @18817
     /* 18817 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18853), // Rule ID 704 //
     /* 18822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_w),
     /* 18830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18844 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7728:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_W),
     /* 18847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18849 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18851 */     GIR_RootConstrainSelectedInstOperands,
     /* 18852 */     // GIR_Coverage, 704,
     /* 18852 */     GIR_EraseRootFromParent_Done,
     /* 18853 */   // Label 611: @18853
     /* 18853 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18889), // Rule ID 705 //
     /* 18858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_d),
     /* 18866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18880 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7727:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_D),
     /* 18883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18885 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18887 */     GIR_RootConstrainSelectedInstOperands,
     /* 18888 */     // GIR_Coverage, 705,
     /* 18888 */     GIR_EraseRootFromParent_Done,
     /* 18889 */   // Label 612: @18889
     /* 18889 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18925), // Rule ID 706 //
     /* 18894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_w),
     /* 18902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18916 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7730:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_W),
     /* 18919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18921 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18923 */     GIR_RootConstrainSelectedInstOperands,
     /* 18924 */     // GIR_Coverage, 706,
     /* 18924 */     GIR_EraseRootFromParent_Done,
     /* 18925 */   // Label 613: @18925
     /* 18925 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18961), // Rule ID 707 //
     /* 18930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_d),
     /* 18938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18952 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7729:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_D),
     /* 18955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18957 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18959 */     GIR_RootConstrainSelectedInstOperands,
     /* 18960 */     // GIR_Coverage, 707,
     /* 18960 */     GIR_EraseRootFromParent_Done,
     /* 18961 */   // Label 614: @18961
     /* 18961 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(18997), // Rule ID 712 //
     /* 18966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_w),
     /* 18974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18988 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7736:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 18988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_W),
     /* 18991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18993 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18995 */     GIR_RootConstrainSelectedInstOperands,
     /* 18996 */     // GIR_Coverage, 712,
     /* 18996 */     GIR_EraseRootFromParent_Done,
     /* 18997 */   // Label 615: @18997
     /* 18997 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(19033), // Rule ID 713 //
     /* 19002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_d),
     /* 19010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19024 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7735:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_D),
     /* 19027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19029 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19031 */     GIR_RootConstrainSelectedInstOperands,
     /* 19032 */     // GIR_Coverage, 713,
     /* 19032 */     GIR_EraseRootFromParent_Done,
     /* 19033 */   // Label 616: @19033
     /* 19033 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(19069), // Rule ID 714 //
     /* 19038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_w),
     /* 19046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19060 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7738:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_W),
     /* 19063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19065 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19067 */     GIR_RootConstrainSelectedInstOperands,
     /* 19068 */     // GIR_Coverage, 714,
     /* 19068 */     GIR_EraseRootFromParent_Done,
     /* 19069 */   // Label 617: @19069
     /* 19069 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(19105), // Rule ID 715 //
     /* 19074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_d),
     /* 19082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19096 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7737:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_D),
     /* 19099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19101 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19103 */     GIR_RootConstrainSelectedInstOperands,
     /* 19104 */     // GIR_Coverage, 715,
     /* 19104 */     GIR_EraseRootFromParent_Done,
     /* 19105 */   // Label 618: @19105
     /* 19105 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(19141), // Rule ID 740 //
     /* 19110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_w),
     /* 19118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19132 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7760:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRCP_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_W),
     /* 19135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19137 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19139 */     GIR_RootConstrainSelectedInstOperands,
     /* 19140 */     // GIR_Coverage, 740,
     /* 19140 */     GIR_EraseRootFromParent_Done,
     /* 19141 */   // Label 619: @19141
     /* 19141 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(19177), // Rule ID 741 //
     /* 19146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_d),
     /* 19154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19168 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7759:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRCP_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_D),
     /* 19171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19173 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19175 */     GIR_RootConstrainSelectedInstOperands,
     /* 19176 */     // GIR_Coverage, 741,
     /* 19176 */     GIR_EraseRootFromParent_Done,
     /* 19177 */   // Label 620: @19177
     /* 19177 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(19213), // Rule ID 742 //
     /* 19182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_w),
     /* 19190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19204 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7764:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_W),
     /* 19207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19209 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19211 */     GIR_RootConstrainSelectedInstOperands,
     /* 19212 */     // GIR_Coverage, 742,
     /* 19212 */     GIR_EraseRootFromParent_Done,
     /* 19213 */   // Label 621: @19213
     /* 19213 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(19249), // Rule ID 743 //
     /* 19218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_d),
     /* 19226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19240 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7763:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_D),
     /* 19243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19245 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19247 */     GIR_RootConstrainSelectedInstOperands,
     /* 19248 */     // GIR_Coverage, 743,
     /* 19248 */     GIR_EraseRootFromParent_Done,
     /* 19249 */   // Label 622: @19249
     /* 19249 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(19285), // Rule ID 770 //
     /* 19254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_w),
     /* 19262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7792:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_W),
     /* 19279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19281 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19283 */     GIR_RootConstrainSelectedInstOperands,
     /* 19284 */     // GIR_Coverage, 770,
     /* 19284 */     GIR_EraseRootFromParent_Done,
     /* 19285 */   // Label 623: @19285
     /* 19285 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(19321), // Rule ID 771 //
     /* 19290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_d),
     /* 19298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19312 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7791:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_D),
     /* 19315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19317 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19319 */     GIR_RootConstrainSelectedInstOperands,
     /* 19320 */     // GIR_Coverage, 771,
     /* 19320 */     GIR_EraseRootFromParent_Done,
     /* 19321 */   // Label 624: @19321
     /* 19321 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(19357), // Rule ID 772 //
     /* 19326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_w),
     /* 19334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7794:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_W),
     /* 19351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19353 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19355 */     GIR_RootConstrainSelectedInstOperands,
     /* 19356 */     // GIR_Coverage, 772,
     /* 19356 */     GIR_EraseRootFromParent_Done,
     /* 19357 */   // Label 625: @19357
     /* 19357 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(19393), // Rule ID 773 //
     /* 19362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_d),
     /* 19370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19384 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7793:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_D),
     /* 19387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19389 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19391 */     GIR_RootConstrainSelectedInstOperands,
     /* 19392 */     // GIR_Coverage, 773,
     /* 19392 */     GIR_EraseRootFromParent_Done,
     /* 19393 */   // Label 626: @19393
     /* 19393 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(19429), // Rule ID 908 //
     /* 19398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_b),
     /* 19406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 19409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 19412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19420 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7949:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLOC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 19420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_B),
     /* 19423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19425 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19427 */     GIR_RootConstrainSelectedInstOperands,
     /* 19428 */     // GIR_Coverage, 908,
     /* 19428 */     GIR_EraseRootFromParent_Done,
     /* 19429 */   // Label 627: @19429
     /* 19429 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19465), // Rule ID 909 //
     /* 19434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_h),
     /* 19442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 19445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7951:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLOC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_H),
     /* 19459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19461 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19463 */     GIR_RootConstrainSelectedInstOperands,
     /* 19464 */     // GIR_Coverage, 909,
     /* 19464 */     GIR_EraseRootFromParent_Done,
     /* 19465 */   // Label 628: @19465
     /* 19465 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(19501), // Rule ID 910 //
     /* 19470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_w),
     /* 19478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7952:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLOC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_W),
     /* 19495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19497 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19499 */     GIR_RootConstrainSelectedInstOperands,
     /* 19500 */     // GIR_Coverage, 910,
     /* 19500 */     GIR_EraseRootFromParent_Done,
     /* 19501 */   // Label 629: @19501
     /* 19501 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19537), // Rule ID 911 //
     /* 19506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_d),
     /* 19514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19528 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7950:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLOC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 19528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_D),
     /* 19531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19533 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19535 */     GIR_RootConstrainSelectedInstOperands,
     /* 19536 */     // GIR_Coverage, 911,
     /* 19536 */     GIR_EraseRootFromParent_Done,
     /* 19537 */   // Label 630: @19537
     /* 19537 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19573), // Rule ID 1251 //
     /* 19542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 19550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19564 */     // (intrinsic_wo_chain:{ *:[i32] } 7976:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL_MM),
     /* 19567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19571 */     GIR_RootConstrainSelectedInstOperands,
     /* 19572 */     // GIR_Coverage, 1251,
     /* 19572 */     GIR_EraseRootFromParent_Done,
     /* 19573 */   // Label 631: @19573
     /* 19573 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19609), // Rule ID 1252 //
     /* 19578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 19586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19600 */     // (intrinsic_wo_chain:{ *:[i32] } 7977:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR_MM),
     /* 19603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19607 */     GIR_RootConstrainSelectedInstOperands,
     /* 19608 */     // GIR_Coverage, 1252,
     /* 19608 */     GIR_EraseRootFromParent_Done,
     /* 19609 */   // Label 632: @19609
     /* 19609 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19645), // Rule ID 1253 //
     /* 19614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 19622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19636 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7978:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL_MM),
     /* 19639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19643 */     GIR_RootConstrainSelectedInstOperands,
     /* 19644 */     // GIR_Coverage, 1253,
     /* 19644 */     GIR_EraseRootFromParent_Done,
     /* 19645 */   // Label 633: @19645
     /* 19645 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19681), // Rule ID 1254 //
     /* 19650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 19658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19672 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7979:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA_MM),
     /* 19675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19679 */     GIR_RootConstrainSelectedInstOperands,
     /* 19680 */     // GIR_Coverage, 1254,
     /* 19680 */     GIR_EraseRootFromParent_Done,
     /* 19681 */   // Label 634: @19681
     /* 19681 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19717), // Rule ID 1255 //
     /* 19686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 19694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19708 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7980:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR_MM),
     /* 19711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19715 */     GIR_RootConstrainSelectedInstOperands,
     /* 19716 */     // GIR_Coverage, 1255,
     /* 19716 */     GIR_EraseRootFromParent_Done,
     /* 19717 */   // Label 635: @19717
     /* 19717 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19753), // Rule ID 1256 //
     /* 19722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 19730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19744 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7981:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA_MM),
     /* 19747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19751 */     GIR_RootConstrainSelectedInstOperands,
     /* 19752 */     // GIR_Coverage, 1256,
     /* 19752 */     GIR_EraseRootFromParent_Done,
     /* 19753 */   // Label 636: @19753
     /* 19753 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19789), // Rule ID 1257 //
     /* 19758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 19766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19780 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7982:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL_MM),
     /* 19783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19787 */     GIR_RootConstrainSelectedInstOperands,
     /* 19788 */     // GIR_Coverage, 1257,
     /* 19788 */     GIR_EraseRootFromParent_Done,
     /* 19789 */   // Label 637: @19789
     /* 19789 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19825), // Rule ID 1258 //
     /* 19794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 19802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19816 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7983:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA_MM),
     /* 19819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19823 */     GIR_RootConstrainSelectedInstOperands,
     /* 19824 */     // GIR_Coverage, 1258,
     /* 19824 */     GIR_EraseRootFromParent_Done,
     /* 19825 */   // Label 638: @19825
     /* 19825 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(19861), // Rule ID 1259 //
     /* 19830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 19838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19852 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7984:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR_MM),
     /* 19855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19859 */     GIR_RootConstrainSelectedInstOperands,
     /* 19860 */     // GIR_Coverage, 1259,
     /* 19860 */     GIR_EraseRootFromParent_Done,
     /* 19861 */   // Label 639: @19861
     /* 19861 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(19897), // Rule ID 1260 //
     /* 19866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 19874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19888 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7985:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA_MM),
     /* 19891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19895 */     GIR_RootConstrainSelectedInstOperands,
     /* 19896 */     // GIR_Coverage, 1260,
     /* 19896 */     GIR_EraseRootFromParent_Done,
     /* 19897 */   // Label 640: @19897
     /* 19897 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(19933), // Rule ID 1286 //
     /* 19902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 19910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19924 */     // (intrinsic_wo_chain:{ *:[i32] } 7994:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB_MM),
     /* 19927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19931 */     GIR_RootConstrainSelectedInstOperands,
     /* 19932 */     // GIR_Coverage, 1286,
     /* 19932 */     GIR_EraseRootFromParent_Done,
     /* 19933 */   // Label 641: @19933
     /* 19933 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(19969), // Rule ID 1290 //
     /* 19938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 19946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 19952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19960 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7996:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_PH_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 19960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH_MM),
     /* 19963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19967 */     GIR_RootConstrainSelectedInstOperands,
     /* 19968 */     // GIR_Coverage, 1290,
     /* 19968 */     GIR_EraseRootFromParent_Done,
     /* 19969 */   // Label 642: @19969
     /* 19969 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(20005), // Rule ID 1291 //
     /* 19974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 19982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 19985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 19988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19996 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7997:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_QB_MM:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 19996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB_MM),
     /* 19999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20003 */     GIR_RootConstrainSelectedInstOperands,
     /* 20004 */     // GIR_Coverage, 1291,
     /* 20004 */     GIR_EraseRootFromParent_Done,
     /* 20005 */   // Label 643: @20005
     /* 20005 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(20041), // Rule ID 1301 //
     /* 20010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 20018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20032 */     // (intrinsic_wo_chain:{ *:[i32] } 7550:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (BITREV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV_MM),
     /* 20035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20039 */     GIR_RootConstrainSelectedInstOperands,
     /* 20040 */     // GIR_Coverage, 1301,
     /* 20040 */     GIR_EraseRootFromParent_Done,
     /* 20041 */   // Label 644: @20041
     /* 20041 */   GIM_Reject,
     /* 20042 */ // Label 590: @20042
     /* 20042 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(29795),
     /* 20047 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 20050 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(20096), // Rule ID 938 //
     /* 20055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_b),
     /* 20063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20077 */     // MIs[0] m
     /* 20077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20085 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7998:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_B),
     /* 20088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20090 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20092 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20094 */     GIR_RootConstrainSelectedInstOperands,
     /* 20095 */     // GIR_Coverage, 938,
     /* 20095 */     GIR_EraseRootFromParent_Done,
     /* 20096 */   // Label 646: @20096
     /* 20096 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(20142), // Rule ID 939 //
     /* 20101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_h),
     /* 20109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20123 */     // MIs[0] m
     /* 20123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20131 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8000:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_H),
     /* 20134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20136 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20138 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20140 */     GIR_RootConstrainSelectedInstOperands,
     /* 20141 */     // GIR_Coverage, 939,
     /* 20141 */     GIR_EraseRootFromParent_Done,
     /* 20142 */   // Label 647: @20142
     /* 20142 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(20188), // Rule ID 940 //
     /* 20147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_w),
     /* 20155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20169 */     // MIs[0] m
     /* 20169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20177 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8001:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_W),
     /* 20180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20182 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20184 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20186 */     GIR_RootConstrainSelectedInstOperands,
     /* 20187 */     // GIR_Coverage, 940,
     /* 20187 */     GIR_EraseRootFromParent_Done,
     /* 20188 */   // Label 648: @20188
     /* 20188 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(20234), // Rule ID 941 //
     /* 20193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_d),
     /* 20201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20215 */     // MIs[0] m
     /* 20215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20223 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7999:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_D),
     /* 20226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20228 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20230 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20232 */     GIR_RootConstrainSelectedInstOperands,
     /* 20233 */     // GIR_Coverage, 941,
     /* 20233 */     GIR_EraseRootFromParent_Done,
     /* 20234 */   // Label 649: @20234
     /* 20234 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(20280), // Rule ID 942 //
     /* 20239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_b),
     /* 20247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20261 */     // MIs[0] m
     /* 20261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20269 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8002:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_B),
     /* 20272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20274 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20276 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20278 */     GIR_RootConstrainSelectedInstOperands,
     /* 20279 */     // GIR_Coverage, 942,
     /* 20279 */     GIR_EraseRootFromParent_Done,
     /* 20280 */   // Label 650: @20280
     /* 20280 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(20326), // Rule ID 943 //
     /* 20285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_h),
     /* 20293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20307 */     // MIs[0] m
     /* 20307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20315 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8004:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_H),
     /* 20318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20320 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20322 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20324 */     GIR_RootConstrainSelectedInstOperands,
     /* 20325 */     // GIR_Coverage, 943,
     /* 20325 */     GIR_EraseRootFromParent_Done,
     /* 20326 */   // Label 651: @20326
     /* 20326 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(20372), // Rule ID 944 //
     /* 20331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_w),
     /* 20339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20353 */     // MIs[0] m
     /* 20353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20361 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8005:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_W),
     /* 20364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20366 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20368 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20370 */     GIR_RootConstrainSelectedInstOperands,
     /* 20371 */     // GIR_Coverage, 944,
     /* 20371 */     GIR_EraseRootFromParent_Done,
     /* 20372 */   // Label 652: @20372
     /* 20372 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(20418), // Rule ID 945 //
     /* 20377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_d),
     /* 20385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20399 */     // MIs[0] m
     /* 20399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20407 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8003:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_D),
     /* 20410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20412 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20414 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20416 */     GIR_RootConstrainSelectedInstOperands,
     /* 20417 */     // GIR_Coverage, 945,
     /* 20417 */     GIR_EraseRootFromParent_Done,
     /* 20418 */   // Label 653: @20418
     /* 20418 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(20464), // Rule ID 985 //
     /* 20423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_b),
     /* 20431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20445 */     // MIs[0] m
     /* 20445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20453 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8057:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRARI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_B),
     /* 20456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20458 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20460 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20462 */     GIR_RootConstrainSelectedInstOperands,
     /* 20463 */     // GIR_Coverage, 985,
     /* 20463 */     GIR_EraseRootFromParent_Done,
     /* 20464 */   // Label 654: @20464
     /* 20464 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(20510), // Rule ID 986 //
     /* 20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_h),
     /* 20477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20491 */     // MIs[0] m
     /* 20491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20499 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8059:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRARI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_H),
     /* 20502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20504 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20506 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20508 */     GIR_RootConstrainSelectedInstOperands,
     /* 20509 */     // GIR_Coverage, 986,
     /* 20509 */     GIR_EraseRootFromParent_Done,
     /* 20510 */   // Label 655: @20510
     /* 20510 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(20556), // Rule ID 987 //
     /* 20515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_w),
     /* 20523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20537 */     // MIs[0] m
     /* 20537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8060:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRARI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_W),
     /* 20548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20550 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20552 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20554 */     GIR_RootConstrainSelectedInstOperands,
     /* 20555 */     // GIR_Coverage, 987,
     /* 20555 */     GIR_EraseRootFromParent_Done,
     /* 20556 */   // Label 656: @20556
     /* 20556 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(20602), // Rule ID 988 //
     /* 20561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_d),
     /* 20569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20583 */     // MIs[0] m
     /* 20583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20591 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8058:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRARI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_D),
     /* 20594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20596 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20598 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20600 */     GIR_RootConstrainSelectedInstOperands,
     /* 20601 */     // GIR_Coverage, 988,
     /* 20601 */     GIR_EraseRootFromParent_Done,
     /* 20602 */   // Label 657: @20602
     /* 20602 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(20648), // Rule ID 1001 //
     /* 20607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_b),
     /* 20615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20629 */     // MIs[0] m
     /* 20629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20637 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8073:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRLRI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_B),
     /* 20640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20642 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20644 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20646 */     GIR_RootConstrainSelectedInstOperands,
     /* 20647 */     // GIR_Coverage, 1001,
     /* 20647 */     GIR_EraseRootFromParent_Done,
     /* 20648 */   // Label 658: @20648
     /* 20648 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(20694), // Rule ID 1002 //
     /* 20653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_h),
     /* 20661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20675 */     // MIs[0] m
     /* 20675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20683 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8075:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRLRI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_H),
     /* 20686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20688 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20690 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20692 */     GIR_RootConstrainSelectedInstOperands,
     /* 20693 */     // GIR_Coverage, 1002,
     /* 20693 */     GIR_EraseRootFromParent_Done,
     /* 20694 */   // Label 659: @20694
     /* 20694 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(20740), // Rule ID 1003 //
     /* 20699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_w),
     /* 20707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20721 */     // MIs[0] m
     /* 20721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20729 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8076:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRLRI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_W),
     /* 20732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20734 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20736 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20738 */     GIR_RootConstrainSelectedInstOperands,
     /* 20739 */     // GIR_Coverage, 1003,
     /* 20739 */     GIR_EraseRootFromParent_Done,
     /* 20740 */   // Label 660: @20740
     /* 20740 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(20786), // Rule ID 1004 //
     /* 20745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_d),
     /* 20753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20767 */     // MIs[0] m
     /* 20767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8074:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRLRI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_D),
     /* 20778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20780 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20782 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20784 */     GIR_RootConstrainSelectedInstOperands,
     /* 20785 */     // GIR_Coverage, 1004,
     /* 20785 */     GIR_EraseRootFromParent_Done,
     /* 20786 */   // Label 661: @20786
     /* 20786 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(20842), // Rule ID 385 //
     /* 20791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 20828 */     // MIs[1] Operand 1
     /* 20828 */     // No operand predicates
     /* 20828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20830 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8016:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHRA_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH),
     /* 20833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20840 */     GIR_RootConstrainSelectedInstOperands,
     /* 20841 */     // GIR_Coverage, 385,
     /* 20841 */     GIR_EraseRootFromParent_Done,
     /* 20842 */   // Label 662: @20842
     /* 20842 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(20898), // Rule ID 389 //
     /* 20847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 20855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 20884 */     // MIs[1] Operand 1
     /* 20884 */     // No operand predicates
     /* 20884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20886 */     // (intrinsic_wo_chain:{ *:[i32] } 8018:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHRA_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W),
     /* 20889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20896 */     GIR_RootConstrainSelectedInstOperands,
     /* 20897 */     // GIR_Coverage, 389,
     /* 20897 */     GIR_EraseRootFromParent_Done,
     /* 20898 */   // Label 663: @20898
     /* 20898 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(20954), // Rule ID 480 //
     /* 20903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 20906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 20911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 20914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 20917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 20940 */     // MIs[1] Operand 1
     /* 20940 */     // No operand predicates
     /* 20940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20942 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8017:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$rs_sa)  =>  (SHRA_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB),
     /* 20945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20952 */     GIR_RootConstrainSelectedInstOperands,
     /* 20953 */     // GIR_Coverage, 480,
     /* 20953 */     GIR_EraseRootFromParent_Done,
     /* 20954 */   // Label 664: @20954
     /* 20954 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(21010), // Rule ID 1245 //
     /* 20959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 20996 */     // MIs[1] Operand 1
     /* 20996 */     // No operand predicates
     /* 20996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20998 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8016:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHRA_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 20998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH_MM),
     /* 21001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21008 */     GIR_RootConstrainSelectedInstOperands,
     /* 21009 */     // GIR_Coverage, 1245,
     /* 21009 */     GIR_EraseRootFromParent_Done,
     /* 21010 */   // Label 665: @21010
     /* 21010 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(21066), // Rule ID 1249 //
     /* 21015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 21018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 21052 */     // MIs[1] Operand 1
     /* 21052 */     // No operand predicates
     /* 21052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21054 */     // (intrinsic_wo_chain:{ *:[i32] } 8018:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHRA_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W_MM),
     /* 21057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21064 */     GIR_RootConstrainSelectedInstOperands,
     /* 21065 */     // GIR_Coverage, 1249,
     /* 21065 */     GIR_EraseRootFromParent_Done,
     /* 21066 */   // Label 666: @21066
     /* 21066 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(21122), // Rule ID 1324 //
     /* 21071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 21074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 21079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21108 */     // MIs[1] Operand 1
     /* 21108 */     // No operand predicates
     /* 21108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21110 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8017:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$sa)  =>  (SHRA_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB_MMR2),
     /* 21113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21120 */     GIR_RootConstrainSelectedInstOperands,
     /* 21121 */     // GIR_Coverage, 1324,
     /* 21121 */     GIR_EraseRootFromParent_Done,
     /* 21122 */   // Label 667: @21122
     /* 21122 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(21174), // Rule ID 1934 //
     /* 21127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21160 */     // MIs[1] Operand 1
     /* 21160 */     // No operand predicates
     /* 21160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21162 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8014:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRA_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_PH),
     /* 21165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21167 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21172 */     GIR_RootConstrainSelectedInstOperands,
     /* 21173 */     // GIR_Coverage, 1934,
     /* 21173 */     GIR_EraseRootFromParent_Done,
     /* 21174 */   // Label 668: @21174
     /* 21174 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(21226), // Rule ID 1935 //
     /* 21179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 21187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21212 */     // MIs[1] Operand 1
     /* 21212 */     // No operand predicates
     /* 21212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21214 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8019:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_PH),
     /* 21217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21219 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21224 */     GIR_RootConstrainSelectedInstOperands,
     /* 21225 */     // GIR_Coverage, 1935,
     /* 21225 */     GIR_EraseRootFromParent_Done,
     /* 21226 */   // Label 669: @21226
     /* 21226 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(21278), // Rule ID 1940 //
     /* 21231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 21239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21264 */     // MIs[1] Operand 1
     /* 21264 */     // No operand predicates
     /* 21264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21266 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8015:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRA_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_QB),
     /* 21269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21271 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21276 */     GIR_RootConstrainSelectedInstOperands,
     /* 21277 */     // GIR_Coverage, 1940,
     /* 21277 */     GIR_EraseRootFromParent_Done,
     /* 21278 */   // Label 670: @21278
     /* 21278 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(21330), // Rule ID 1941 //
     /* 21283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21316 */     // MIs[1] Operand 1
     /* 21316 */     // No operand predicates
     /* 21316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21318 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8020:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_QB),
     /* 21321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21323 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21328 */     GIR_RootConstrainSelectedInstOperands,
     /* 21329 */     // GIR_Coverage, 1941,
     /* 21329 */     GIR_EraseRootFromParent_Done,
     /* 21330 */   // Label 671: @21330
     /* 21330 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(21378), // Rule ID 355 //
     /* 21335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 21343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21364 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7486:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB),
     /* 21367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21376 */     GIR_RootConstrainSelectedInstOperands,
     /* 21377 */     // GIR_Coverage, 355,
     /* 21377 */     GIR_EraseRootFromParent_Done,
     /* 21378 */   // Label 672: @21378
     /* 21378 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(21426), // Rule ID 356 //
     /* 21383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 21391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21412 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8109:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB),
     /* 21415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21424 */     GIR_RootConstrainSelectedInstOperands,
     /* 21425 */     // GIR_Coverage, 356,
     /* 21425 */     GIR_EraseRootFromParent_Done,
     /* 21426 */   // Label 673: @21426
     /* 21426 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(21474), // Rule ID 357 //
     /* 21431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 21439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21460 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7464:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH),
     /* 21463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21472 */     GIR_RootConstrainSelectedInstOperands,
     /* 21473 */     // GIR_Coverage, 357,
     /* 21473 */     GIR_EraseRootFromParent_Done,
     /* 21474 */   // Label 674: @21474
     /* 21474 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(21522), // Rule ID 358 //
     /* 21479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 21487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21508 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8084:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH),
     /* 21511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21520 */     GIR_RootConstrainSelectedInstOperands,
     /* 21521 */     // GIR_Coverage, 358,
     /* 21521 */     GIR_EraseRootFromParent_Done,
     /* 21522 */   // Label 675: @21522
     /* 21522 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(21567), // Rule ID 361 //
     /* 21527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 21535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21556 */     // (intrinsic_wo_chain:{ *:[i32] } 7914:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB),
     /* 21559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21565 */     GIR_RootConstrainSelectedInstOperands,
     /* 21566 */     // GIR_Coverage, 361,
     /* 21566 */     GIR_EraseRootFromParent_Done,
     /* 21567 */   // Label 676: @21567
     /* 21567 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(21612), // Rule ID 365 //
     /* 21572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 21580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21601 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7990:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH),
     /* 21604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21610 */     GIR_RootConstrainSelectedInstOperands,
     /* 21611 */     // GIR_Coverage, 365,
     /* 21611 */     GIR_EraseRootFromParent_Done,
     /* 21612 */   // Label 677: @21612
     /* 21612 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(21657), // Rule ID 366 //
     /* 21617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 21625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21646 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7989:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W),
     /* 21649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21655 */     GIR_RootConstrainSelectedInstOperands,
     /* 21656 */     // GIR_Coverage, 366,
     /* 21656 */     GIR_EraseRootFromParent_Done,
     /* 21657 */   // Label 678: @21657
     /* 21657 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(21702), // Rule ID 380 //
     /* 21662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21691 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8020:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB),
     /* 21694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21700 */     GIR_RootConstrainSelectedInstOperands,
     /* 21701 */     // GIR_Coverage, 380,
     /* 21701 */     GIR_EraseRootFromParent_Done,
     /* 21702 */   // Label 679: @21702
     /* 21702 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(21747), // Rule ID 384 //
     /* 21707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21736 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8014:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH),
     /* 21739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21745 */     GIR_RootConstrainSelectedInstOperands,
     /* 21746 */     // GIR_Coverage, 384,
     /* 21746 */     GIR_EraseRootFromParent_Done,
     /* 21747 */   // Label 680: @21747
     /* 21747 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(21792), // Rule ID 386 //
     /* 21752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 21760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21781 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8016:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH),
     /* 21784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21790 */     GIR_RootConstrainSelectedInstOperands,
     /* 21791 */     // GIR_Coverage, 386,
     /* 21791 */     GIR_EraseRootFromParent_Done,
     /* 21792 */   // Label 681: @21792
     /* 21792 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(21837), // Rule ID 390 //
     /* 21797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21826 */     // (intrinsic_wo_chain:{ *:[i32] } 8018:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W),
     /* 21829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21835 */     GIR_RootConstrainSelectedInstOperands,
     /* 21836 */     // GIR_Coverage, 390,
     /* 21836 */     GIR_EraseRootFromParent_Done,
     /* 21837 */   // Label 682: @21837
     /* 21837 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(21882), // Rule ID 427 //
     /* 21842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 21850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21871 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7961:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH),
     /* 21874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21880 */     GIR_RootConstrainSelectedInstOperands,
     /* 21881 */     // GIR_Coverage, 427,
     /* 21881 */     GIR_EraseRootFromParent_Done,
     /* 21882 */   // Label 683: @21882
     /* 21882 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(21927), // Rule ID 451 //
     /* 21887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 21895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21916 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7487:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB),
     /* 21919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21925 */     GIR_RootConstrainSelectedInstOperands,
     /* 21926 */     // GIR_Coverage, 451,
     /* 21926 */     GIR_EraseRootFromParent_Done,
     /* 21927 */   // Label 684: @21927
     /* 21927 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(21972), // Rule ID 452 //
     /* 21932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 21940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21961 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7488:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB),
     /* 21964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21970 */     GIR_RootConstrainSelectedInstOperands,
     /* 21971 */     // GIR_Coverage, 452,
     /* 21971 */     GIR_EraseRootFromParent_Done,
     /* 21972 */   // Label 685: @21972
     /* 21972 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(22017), // Rule ID 453 //
     /* 21977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 21985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22006 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8110:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB),
     /* 22009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22015 */     GIR_RootConstrainSelectedInstOperands,
     /* 22016 */     // GIR_Coverage, 453,
     /* 22016 */     GIR_EraseRootFromParent_Done,
     /* 22017 */   // Label 686: @22017
     /* 22017 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(22062), // Rule ID 454 //
     /* 22022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 22030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22051 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB),
     /* 22054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22060 */     GIR_RootConstrainSelectedInstOperands,
     /* 22061 */     // GIR_Coverage, 454,
     /* 22061 */     GIR_EraseRootFromParent_Done,
     /* 22062 */   // Label 687: @22062
     /* 22062 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(22107), // Rule ID 455 //
     /* 22067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 22075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22096 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7466:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH),
     /* 22099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22105 */     GIR_RootConstrainSelectedInstOperands,
     /* 22106 */     // GIR_Coverage, 455,
     /* 22106 */     GIR_EraseRootFromParent_Done,
     /* 22107 */   // Label 688: @22107
     /* 22107 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(22152), // Rule ID 456 //
     /* 22112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 22120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22141 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7467:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH),
     /* 22144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22150 */     GIR_RootConstrainSelectedInstOperands,
     /* 22151 */     // GIR_Coverage, 456,
     /* 22151 */     GIR_EraseRootFromParent_Done,
     /* 22152 */   // Label 689: @22152
     /* 22152 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(22197), // Rule ID 457 //
     /* 22157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 22165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22186 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8086:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH),
     /* 22189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22195 */     GIR_RootConstrainSelectedInstOperands,
     /* 22196 */     // GIR_Coverage, 457,
     /* 22196 */     GIR_EraseRootFromParent_Done,
     /* 22197 */   // Label 690: @22197
     /* 22197 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(22242), // Rule ID 458 //
     /* 22202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 22210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22231 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8087:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH),
     /* 22234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22240 */     GIR_RootConstrainSelectedInstOperands,
     /* 22241 */     // GIR_Coverage, 458,
     /* 22241 */     GIR_EraseRootFromParent_Done,
     /* 22242 */   // Label 691: @22242
     /* 22242 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(22287), // Rule ID 459 //
     /* 22247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 22255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22276 */     // (intrinsic_wo_chain:{ *:[i32] } 7469:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W),
     /* 22279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22285 */     GIR_RootConstrainSelectedInstOperands,
     /* 22286 */     // GIR_Coverage, 459,
     /* 22286 */     GIR_EraseRootFromParent_Done,
     /* 22287 */   // Label 692: @22287
     /* 22287 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(22332), // Rule ID 460 //
     /* 22292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 22300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22321 */     // (intrinsic_wo_chain:{ *:[i32] } 7468:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W),
     /* 22324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22330 */     GIR_RootConstrainSelectedInstOperands,
     /* 22331 */     // GIR_Coverage, 460,
     /* 22331 */     GIR_EraseRootFromParent_Done,
     /* 22332 */   // Label 693: @22332
     /* 22332 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(22377), // Rule ID 461 //
     /* 22337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 22345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22366 */     // (intrinsic_wo_chain:{ *:[i32] } 8089:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W),
     /* 22369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22375 */     GIR_RootConstrainSelectedInstOperands,
     /* 22376 */     // GIR_Coverage, 461,
     /* 22376 */     GIR_EraseRootFromParent_Done,
     /* 22377 */   // Label 694: @22377
     /* 22377 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(22422), // Rule ID 462 //
     /* 22382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 22390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22411 */     // (intrinsic_wo_chain:{ *:[i32] } 8088:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W),
     /* 22414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22420 */     GIR_RootConstrainSelectedInstOperands,
     /* 22421 */     // GIR_Coverage, 462,
     /* 22421 */     GIR_EraseRootFromParent_Done,
     /* 22422 */   // Label 695: @22422
     /* 22422 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(22467), // Rule ID 479 //
     /* 22427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 22435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22456 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8015:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB),
     /* 22459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22465 */     GIR_RootConstrainSelectedInstOperands,
     /* 22466 */     // GIR_Coverage, 479,
     /* 22466 */     GIR_EraseRootFromParent_Done,
     /* 22467 */   // Label 696: @22467
     /* 22467 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(22512), // Rule ID 481 //
     /* 22472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 22480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22501 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8017:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB),
     /* 22504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22510 */     GIR_RootConstrainSelectedInstOperands,
     /* 22511 */     // GIR_Coverage, 481,
     /* 22511 */     GIR_EraseRootFromParent_Done,
     /* 22512 */   // Label 697: @22512
     /* 22512 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(22557), // Rule ID 482 //
     /* 22517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 22525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22546 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8019:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH),
     /* 22549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22555 */     GIR_RootConstrainSelectedInstOperands,
     /* 22556 */     // GIR_Coverage, 482,
     /* 22556 */     GIR_EraseRootFromParent_Done,
     /* 22557 */   // Label 698: @22557
     /* 22557 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(22602), // Rule ID 491 //
     /* 22562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_b),
     /* 22570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22591 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7459:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADD_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_B),
     /* 22594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22596 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22598 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22600 */     GIR_RootConstrainSelectedInstOperands,
     /* 22601 */     // GIR_Coverage, 491,
     /* 22601 */     GIR_EraseRootFromParent_Done,
     /* 22602 */   // Label 699: @22602
     /* 22602 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(22647), // Rule ID 492 //
     /* 22607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_h),
     /* 22615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7461:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADD_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_H),
     /* 22639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22641 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22643 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22645 */     GIR_RootConstrainSelectedInstOperands,
     /* 22646 */     // GIR_Coverage, 492,
     /* 22646 */     GIR_EraseRootFromParent_Done,
     /* 22647 */   // Label 700: @22647
     /* 22647 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(22692), // Rule ID 493 //
     /* 22652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_w),
     /* 22660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22681 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7462:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADD_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_W),
     /* 22684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22686 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22688 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22690 */     GIR_RootConstrainSelectedInstOperands,
     /* 22691 */     // GIR_Coverage, 493,
     /* 22691 */     GIR_EraseRootFromParent_Done,
     /* 22692 */   // Label 701: @22692
     /* 22692 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(22737), // Rule ID 494 //
     /* 22697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_d),
     /* 22705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22726 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7460:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADD_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_D),
     /* 22729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22731 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22733 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22735 */     GIR_RootConstrainSelectedInstOperands,
     /* 22736 */     // GIR_Coverage, 494,
     /* 22736 */     GIR_EraseRootFromParent_Done,
     /* 22737 */   // Label 702: @22737
     /* 22737 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(22782), // Rule ID 495 //
     /* 22742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_b),
     /* 22750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22771 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7470:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_B),
     /* 22774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22776 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22778 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22780 */     GIR_RootConstrainSelectedInstOperands,
     /* 22781 */     // GIR_Coverage, 495,
     /* 22781 */     GIR_EraseRootFromParent_Done,
     /* 22782 */   // Label 703: @22782
     /* 22782 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(22827), // Rule ID 496 //
     /* 22787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_h),
     /* 22795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22816 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7472:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_H),
     /* 22819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22821 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22823 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22825 */     GIR_RootConstrainSelectedInstOperands,
     /* 22826 */     // GIR_Coverage, 496,
     /* 22826 */     GIR_EraseRootFromParent_Done,
     /* 22827 */   // Label 704: @22827
     /* 22827 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(22872), // Rule ID 497 //
     /* 22832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_w),
     /* 22840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22861 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7473:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_W),
     /* 22864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22866 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22868 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22870 */     GIR_RootConstrainSelectedInstOperands,
     /* 22871 */     // GIR_Coverage, 497,
     /* 22871 */     GIR_EraseRootFromParent_Done,
     /* 22872 */   // Label 705: @22872
     /* 22872 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(22917), // Rule ID 498 //
     /* 22877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_d),
     /* 22885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22906 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7471:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_D),
     /* 22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22913 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22915 */     GIR_RootConstrainSelectedInstOperands,
     /* 22916 */     // GIR_Coverage, 498,
     /* 22916 */     GIR_EraseRootFromParent_Done,
     /* 22917 */   // Label 706: @22917
     /* 22917 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(22962), // Rule ID 499 //
     /* 22922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_b),
     /* 22930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22951 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7474:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_B),
     /* 22954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22956 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22958 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22960 */     GIR_RootConstrainSelectedInstOperands,
     /* 22961 */     // GIR_Coverage, 499,
     /* 22961 */     GIR_EraseRootFromParent_Done,
     /* 22962 */   // Label 707: @22962
     /* 22962 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(23007), // Rule ID 500 //
     /* 22967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_h),
     /* 22975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7476:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_H),
     /* 22999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23001 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23003 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23005 */     GIR_RootConstrainSelectedInstOperands,
     /* 23006 */     // GIR_Coverage, 500,
     /* 23006 */     GIR_EraseRootFromParent_Done,
     /* 23007 */   // Label 708: @23007
     /* 23007 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(23052), // Rule ID 501 //
     /* 23012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_w),
     /* 23020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23041 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7477:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_W),
     /* 23044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23046 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23048 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23050 */     GIR_RootConstrainSelectedInstOperands,
     /* 23051 */     // GIR_Coverage, 501,
     /* 23051 */     GIR_EraseRootFromParent_Done,
     /* 23052 */   // Label 709: @23052
     /* 23052 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(23097), // Rule ID 502 //
     /* 23057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_d),
     /* 23065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23086 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7475:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_D),
     /* 23089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23091 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23093 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23095 */     GIR_RootConstrainSelectedInstOperands,
     /* 23096 */     // GIR_Coverage, 502,
     /* 23096 */     GIR_EraseRootFromParent_Done,
     /* 23097 */   // Label 710: @23097
     /* 23097 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(23142), // Rule ID 503 //
     /* 23102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_b),
     /* 23110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23131 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7478:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_B),
     /* 23134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23136 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23138 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23140 */     GIR_RootConstrainSelectedInstOperands,
     /* 23141 */     // GIR_Coverage, 503,
     /* 23141 */     GIR_EraseRootFromParent_Done,
     /* 23142 */   // Label 711: @23142
     /* 23142 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(23187), // Rule ID 504 //
     /* 23147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_h),
     /* 23155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23176 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7480:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_H),
     /* 23179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23181 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23183 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23185 */     GIR_RootConstrainSelectedInstOperands,
     /* 23186 */     // GIR_Coverage, 504,
     /* 23186 */     GIR_EraseRootFromParent_Done,
     /* 23187 */   // Label 712: @23187
     /* 23187 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(23232), // Rule ID 505 //
     /* 23192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_w),
     /* 23200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23221 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7481:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_W),
     /* 23224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23226 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23228 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23230 */     GIR_RootConstrainSelectedInstOperands,
     /* 23231 */     // GIR_Coverage, 505,
     /* 23231 */     GIR_EraseRootFromParent_Done,
     /* 23232 */   // Label 713: @23232
     /* 23232 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(23277), // Rule ID 506 //
     /* 23237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_d),
     /* 23245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23266 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7479:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_D),
     /* 23269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23271 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23273 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23275 */     GIR_RootConstrainSelectedInstOperands,
     /* 23276 */     // GIR_Coverage, 506,
     /* 23276 */     GIR_EraseRootFromParent_Done,
     /* 23277 */   // Label 714: @23277
     /* 23277 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(23322), // Rule ID 520 //
     /* 23282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_b),
     /* 23290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23311 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7501:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_B),
     /* 23314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23316 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23318 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23320 */     GIR_RootConstrainSelectedInstOperands,
     /* 23321 */     // GIR_Coverage, 520,
     /* 23321 */     GIR_EraseRootFromParent_Done,
     /* 23322 */   // Label 715: @23322
     /* 23322 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(23367), // Rule ID 521 //
     /* 23327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_h),
     /* 23335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23356 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7503:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_H),
     /* 23359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23361 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23363 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23365 */     GIR_RootConstrainSelectedInstOperands,
     /* 23366 */     // GIR_Coverage, 521,
     /* 23366 */     GIR_EraseRootFromParent_Done,
     /* 23367 */   // Label 716: @23367
     /* 23367 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(23412), // Rule ID 522 //
     /* 23372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_w),
     /* 23380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23401 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7504:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_W),
     /* 23404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23406 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23408 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23410 */     GIR_RootConstrainSelectedInstOperands,
     /* 23411 */     // GIR_Coverage, 522,
     /* 23411 */     GIR_EraseRootFromParent_Done,
     /* 23412 */   // Label 717: @23412
     /* 23412 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(23457), // Rule ID 523 //
     /* 23417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_d),
     /* 23425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23446 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7502:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_D),
     /* 23449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23451 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23453 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23455 */     GIR_RootConstrainSelectedInstOperands,
     /* 23456 */     // GIR_Coverage, 523,
     /* 23456 */     GIR_EraseRootFromParent_Done,
     /* 23457 */   // Label 718: @23457
     /* 23457 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(23502), // Rule ID 524 //
     /* 23462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_b),
     /* 23470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23491 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7505:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_B),
     /* 23494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23496 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23498 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23500 */     GIR_RootConstrainSelectedInstOperands,
     /* 23501 */     // GIR_Coverage, 524,
     /* 23501 */     GIR_EraseRootFromParent_Done,
     /* 23502 */   // Label 719: @23502
     /* 23502 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(23547), // Rule ID 525 //
     /* 23507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_h),
     /* 23515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23536 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7507:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_H),
     /* 23539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23541 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23543 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23545 */     GIR_RootConstrainSelectedInstOperands,
     /* 23546 */     // GIR_Coverage, 525,
     /* 23546 */     GIR_EraseRootFromParent_Done,
     /* 23547 */   // Label 720: @23547
     /* 23547 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(23592), // Rule ID 526 //
     /* 23552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_w),
     /* 23560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7508:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_W),
     /* 23584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23586 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23588 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23590 */     GIR_RootConstrainSelectedInstOperands,
     /* 23591 */     // GIR_Coverage, 526,
     /* 23591 */     GIR_EraseRootFromParent_Done,
     /* 23592 */   // Label 721: @23592
     /* 23592 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(23637), // Rule ID 527 //
     /* 23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_d),
     /* 23605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23626 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7506:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_D),
     /* 23629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23631 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23633 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23635 */     GIR_RootConstrainSelectedInstOperands,
     /* 23636 */     // GIR_Coverage, 527,
     /* 23636 */     GIR_EraseRootFromParent_Done,
     /* 23637 */   // Label 722: @23637
     /* 23637 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(23682), // Rule ID 528 //
     /* 23642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_b),
     /* 23650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23671 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7509:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_B),
     /* 23674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23676 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23678 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23680 */     GIR_RootConstrainSelectedInstOperands,
     /* 23681 */     // GIR_Coverage, 528,
     /* 23681 */     GIR_EraseRootFromParent_Done,
     /* 23682 */   // Label 723: @23682
     /* 23682 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(23727), // Rule ID 529 //
     /* 23687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_h),
     /* 23695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7511:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_H),
     /* 23719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23721 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23723 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23725 */     GIR_RootConstrainSelectedInstOperands,
     /* 23726 */     // GIR_Coverage, 529,
     /* 23726 */     GIR_EraseRootFromParent_Done,
     /* 23727 */   // Label 724: @23727
     /* 23727 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(23772), // Rule ID 530 //
     /* 23732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_w),
     /* 23740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23761 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7512:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_W),
     /* 23764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23766 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23768 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23770 */     GIR_RootConstrainSelectedInstOperands,
     /* 23771 */     // GIR_Coverage, 530,
     /* 23771 */     GIR_EraseRootFromParent_Done,
     /* 23772 */   // Label 725: @23772
     /* 23772 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(23817), // Rule ID 531 //
     /* 23777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_d),
     /* 23785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23806 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7510:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_D),
     /* 23809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23811 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23813 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23815 */     GIR_RootConstrainSelectedInstOperands,
     /* 23816 */     // GIR_Coverage, 531,
     /* 23816 */     GIR_EraseRootFromParent_Done,
     /* 23817 */   // Label 726: @23817
     /* 23817 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(23862), // Rule ID 532 //
     /* 23822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_b),
     /* 23830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7513:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_B),
     /* 23854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23856 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23858 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23860 */     GIR_RootConstrainSelectedInstOperands,
     /* 23861 */     // GIR_Coverage, 532,
     /* 23861 */     GIR_EraseRootFromParent_Done,
     /* 23862 */   // Label 727: @23862
     /* 23862 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(23907), // Rule ID 533 //
     /* 23867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_h),
     /* 23875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23896 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7515:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_H),
     /* 23899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23901 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23903 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23905 */     GIR_RootConstrainSelectedInstOperands,
     /* 23906 */     // GIR_Coverage, 533,
     /* 23906 */     GIR_EraseRootFromParent_Done,
     /* 23907 */   // Label 728: @23907
     /* 23907 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(23952), // Rule ID 534 //
     /* 23912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_w),
     /* 23920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23941 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7516:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_W),
     /* 23944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23946 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23948 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23950 */     GIR_RootConstrainSelectedInstOperands,
     /* 23951 */     // GIR_Coverage, 534,
     /* 23951 */     GIR_EraseRootFromParent_Done,
     /* 23952 */   // Label 729: @23952
     /* 23952 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(23997), // Rule ID 535 //
     /* 23957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_d),
     /* 23965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23986 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7514:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_D),
     /* 23989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23991 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23993 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23995 */     GIR_RootConstrainSelectedInstOperands,
     /* 23996 */     // GIR_Coverage, 535,
     /* 23996 */     GIR_EraseRootFromParent_Done,
     /* 23997 */   // Label 730: @23997
     /* 23997 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(24042), // Rule ID 536 //
     /* 24002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_b),
     /* 24010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24031 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7517:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_B),
     /* 24034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24036 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24038 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24040 */     GIR_RootConstrainSelectedInstOperands,
     /* 24041 */     // GIR_Coverage, 536,
     /* 24041 */     GIR_EraseRootFromParent_Done,
     /* 24042 */   // Label 731: @24042
     /* 24042 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(24087), // Rule ID 537 //
     /* 24047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_h),
     /* 24055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7519:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_H),
     /* 24079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24081 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24083 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24085 */     GIR_RootConstrainSelectedInstOperands,
     /* 24086 */     // GIR_Coverage, 537,
     /* 24086 */     GIR_EraseRootFromParent_Done,
     /* 24087 */   // Label 732: @24087
     /* 24087 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(24132), // Rule ID 538 //
     /* 24092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_w),
     /* 24100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24121 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7520:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_W),
     /* 24124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24126 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24128 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24130 */     GIR_RootConstrainSelectedInstOperands,
     /* 24131 */     // GIR_Coverage, 538,
     /* 24131 */     GIR_EraseRootFromParent_Done,
     /* 24132 */   // Label 733: @24132
     /* 24132 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(24177), // Rule ID 539 //
     /* 24137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_d),
     /* 24145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24166 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7518:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_D),
     /* 24169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24171 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24173 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24175 */     GIR_RootConstrainSelectedInstOperands,
     /* 24176 */     // GIR_Coverage, 539,
     /* 24176 */     GIR_EraseRootFromParent_Done,
     /* 24177 */   // Label 734: @24177
     /* 24177 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(24222), // Rule ID 540 //
     /* 24182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_b),
     /* 24190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24211 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7521:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_B),
     /* 24214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24216 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24218 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24220 */     GIR_RootConstrainSelectedInstOperands,
     /* 24221 */     // GIR_Coverage, 540,
     /* 24221 */     GIR_EraseRootFromParent_Done,
     /* 24222 */   // Label 735: @24222
     /* 24222 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(24267), // Rule ID 541 //
     /* 24227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_h),
     /* 24235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24256 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7523:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_H),
     /* 24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24261 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24263 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24265 */     GIR_RootConstrainSelectedInstOperands,
     /* 24266 */     // GIR_Coverage, 541,
     /* 24266 */     GIR_EraseRootFromParent_Done,
     /* 24267 */   // Label 736: @24267
     /* 24267 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(24312), // Rule ID 542 //
     /* 24272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_w),
     /* 24280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24301 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7524:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_W),
     /* 24304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24306 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24308 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24310 */     GIR_RootConstrainSelectedInstOperands,
     /* 24311 */     // GIR_Coverage, 542,
     /* 24311 */     GIR_EraseRootFromParent_Done,
     /* 24312 */   // Label 737: @24312
     /* 24312 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(24357), // Rule ID 543 //
     /* 24317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_d),
     /* 24325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24346 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7522:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_D),
     /* 24349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24351 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24353 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24355 */     GIR_RootConstrainSelectedInstOperands,
     /* 24356 */     // GIR_Coverage, 543,
     /* 24356 */     GIR_EraseRootFromParent_Done,
     /* 24357 */   // Label 738: @24357
     /* 24357 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(24402), // Rule ID 652 //
     /* 24362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_h),
     /* 24370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24391 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7656:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_H),
     /* 24394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24396 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24398 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24400 */     GIR_RootConstrainSelectedInstOperands,
     /* 24401 */     // GIR_Coverage, 652,
     /* 24401 */     GIR_EraseRootFromParent_Done,
     /* 24402 */   // Label 739: @24402
     /* 24402 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(24447), // Rule ID 653 //
     /* 24407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_w),
     /* 24415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24436 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7657:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_W),
     /* 24439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24441 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24443 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24445 */     GIR_RootConstrainSelectedInstOperands,
     /* 24446 */     // GIR_Coverage, 653,
     /* 24446 */     GIR_EraseRootFromParent_Done,
     /* 24447 */   // Label 740: @24447
     /* 24447 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(24492), // Rule ID 654 //
     /* 24452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_d),
     /* 24460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24481 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7655:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_D),
     /* 24484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24486 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24488 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24490 */     GIR_RootConstrainSelectedInstOperands,
     /* 24491 */     // GIR_Coverage, 654,
     /* 24491 */     GIR_EraseRootFromParent_Done,
     /* 24492 */   // Label 741: @24492
     /* 24492 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(24537), // Rule ID 655 //
     /* 24497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_h),
     /* 24505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24526 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7659:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_H),
     /* 24529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24531 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24533 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24535 */     GIR_RootConstrainSelectedInstOperands,
     /* 24536 */     // GIR_Coverage, 655,
     /* 24536 */     GIR_EraseRootFromParent_Done,
     /* 24537 */   // Label 742: @24537
     /* 24537 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(24582), // Rule ID 656 //
     /* 24542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_w),
     /* 24550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7660:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_W),
     /* 24574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24576 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24578 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24580 */     GIR_RootConstrainSelectedInstOperands,
     /* 24581 */     // GIR_Coverage, 656,
     /* 24581 */     GIR_EraseRootFromParent_Done,
     /* 24582 */   // Label 743: @24582
     /* 24582 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(24627), // Rule ID 657 //
     /* 24587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_d),
     /* 24595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24616 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7658:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_D),
     /* 24619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24621 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24623 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24625 */     GIR_RootConstrainSelectedInstOperands,
     /* 24626 */     // GIR_Coverage, 657,
     /* 24626 */     GIR_EraseRootFromParent_Done,
     /* 24627 */   // Label 744: @24627
     /* 24627 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(24672), // Rule ID 672 //
     /* 24632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_w),
     /* 24640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24661 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7698:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FCAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_W),
     /* 24664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24666 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24668 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24670 */     GIR_RootConstrainSelectedInstOperands,
     /* 24671 */     // GIR_Coverage, 672,
     /* 24671 */     GIR_EraseRootFromParent_Done,
     /* 24672 */   // Label 745: @24672
     /* 24672 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(24717), // Rule ID 673 //
     /* 24677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_d),
     /* 24685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24706 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7697:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FCAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_D),
     /* 24709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24711 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24713 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24715 */     GIR_RootConstrainSelectedInstOperands,
     /* 24716 */     // GIR_Coverage, 673,
     /* 24716 */     GIR_EraseRootFromParent_Done,
     /* 24717 */   // Label 746: @24717
     /* 24717 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(24762), // Rule ID 698 //
     /* 24722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_h),
     /* 24730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24751 */     // (intrinsic_wo_chain:{ *:[v8f16] } 7723:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FEXDO_H:{ *:[v8f16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_H),
     /* 24754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24756 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24758 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24760 */     GIR_RootConstrainSelectedInstOperands,
     /* 24761 */     // GIR_Coverage, 698,
     /* 24761 */     GIR_EraseRootFromParent_Done,
     /* 24762 */   // Label 747: @24762
     /* 24762 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(24807), // Rule ID 699 //
     /* 24767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_w),
     /* 24775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24796 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7724:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FEXDO_W:{ *:[v4f32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_W),
     /* 24799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24801 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24803 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24805 */     GIR_RootConstrainSelectedInstOperands,
     /* 24806 */     // GIR_Coverage, 699,
     /* 24806 */     GIR_EraseRootFromParent_Done,
     /* 24807 */   // Label 748: @24807
     /* 24807 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(24852), // Rule ID 726 //
     /* 24812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_w),
     /* 24820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24841 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7750:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_W),
     /* 24844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24846 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24848 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24850 */     GIR_RootConstrainSelectedInstOperands,
     /* 24851 */     // GIR_Coverage, 726,
     /* 24851 */     GIR_EraseRootFromParent_Done,
     /* 24852 */   // Label 749: @24852
     /* 24852 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(24897), // Rule ID 727 //
     /* 24857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_d),
     /* 24865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24886 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7749:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_D),
     /* 24889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24891 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24893 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24895 */     GIR_RootConstrainSelectedInstOperands,
     /* 24896 */     // GIR_Coverage, 727,
     /* 24896 */     GIR_EraseRootFromParent_Done,
     /* 24897 */   // Label 750: @24897
     /* 24897 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(24942), // Rule ID 728 //
     /* 24902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_w),
     /* 24910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24931 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7748:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_W),
     /* 24934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24936 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24938 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24940 */     GIR_RootConstrainSelectedInstOperands,
     /* 24941 */     // GIR_Coverage, 728,
     /* 24941 */     GIR_EraseRootFromParent_Done,
     /* 24942 */   // Label 751: @24942
     /* 24942 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(24987), // Rule ID 729 //
     /* 24947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_d),
     /* 24955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24976 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7747:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_D),
     /* 24979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24981 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24983 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24985 */     GIR_RootConstrainSelectedInstOperands,
     /* 24986 */     // GIR_Coverage, 729,
     /* 24986 */     GIR_EraseRootFromParent_Done,
     /* 24987 */   // Label 752: @24987
     /* 24987 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(25032), // Rule ID 730 //
     /* 24992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_w),
     /* 25000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25021 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7754:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_W),
     /* 25024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25026 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25028 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25030 */     GIR_RootConstrainSelectedInstOperands,
     /* 25031 */     // GIR_Coverage, 730,
     /* 25031 */     GIR_EraseRootFromParent_Done,
     /* 25032 */   // Label 753: @25032
     /* 25032 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(25077), // Rule ID 731 //
     /* 25037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_d),
     /* 25045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25066 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7753:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_D),
     /* 25069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25071 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25073 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25075 */     GIR_RootConstrainSelectedInstOperands,
     /* 25076 */     // GIR_Coverage, 731,
     /* 25076 */     GIR_EraseRootFromParent_Done,
     /* 25077 */   // Label 754: @25077
     /* 25077 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(25122), // Rule ID 732 //
     /* 25082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_w),
     /* 25090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25111 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7752:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_W),
     /* 25114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25116 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25118 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25120 */     GIR_RootConstrainSelectedInstOperands,
     /* 25121 */     // GIR_Coverage, 732,
     /* 25121 */     GIR_EraseRootFromParent_Done,
     /* 25122 */   // Label 755: @25122
     /* 25122 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(25167), // Rule ID 733 //
     /* 25127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_d),
     /* 25135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25156 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7751:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_D),
     /* 25159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25161 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25163 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25165 */     GIR_RootConstrainSelectedInstOperands,
     /* 25166 */     // GIR_Coverage, 733,
     /* 25166 */     GIR_EraseRootFromParent_Done,
     /* 25167 */   // Label 756: @25167
     /* 25167 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(25212), // Rule ID 744 //
     /* 25172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_w),
     /* 25180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25201 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7766:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_W),
     /* 25204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25206 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25208 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25210 */     GIR_RootConstrainSelectedInstOperands,
     /* 25211 */     // GIR_Coverage, 744,
     /* 25211 */     GIR_EraseRootFromParent_Done,
     /* 25212 */   // Label 757: @25212
     /* 25212 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(25257), // Rule ID 745 //
     /* 25217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_d),
     /* 25225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25246 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7765:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_D),
     /* 25249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25251 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25253 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25255 */     GIR_RootConstrainSelectedInstOperands,
     /* 25256 */     // GIR_Coverage, 745,
     /* 25256 */     GIR_EraseRootFromParent_Done,
     /* 25257 */   // Label 758: @25257
     /* 25257 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(25302), // Rule ID 746 //
     /* 25262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_w),
     /* 25270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7768:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_W),
     /* 25294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25296 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25298 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25300 */     GIR_RootConstrainSelectedInstOperands,
     /* 25301 */     // GIR_Coverage, 746,
     /* 25301 */     GIR_EraseRootFromParent_Done,
     /* 25302 */   // Label 759: @25302
     /* 25302 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(25347), // Rule ID 747 //
     /* 25307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_d),
     /* 25315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25336 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7767:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_D),
     /* 25339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25341 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25343 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25345 */     GIR_RootConstrainSelectedInstOperands,
     /* 25346 */     // GIR_Coverage, 747,
     /* 25346 */     GIR_EraseRootFromParent_Done,
     /* 25347 */   // Label 760: @25347
     /* 25347 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(25392), // Rule ID 748 //
     /* 25352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_w),
     /* 25360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25381 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7770:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_W),
     /* 25384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25386 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25388 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25390 */     GIR_RootConstrainSelectedInstOperands,
     /* 25391 */     // GIR_Coverage, 748,
     /* 25391 */     GIR_EraseRootFromParent_Done,
     /* 25392 */   // Label 761: @25392
     /* 25392 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(25437), // Rule ID 749 //
     /* 25397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_d),
     /* 25405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25426 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7769:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_D),
     /* 25429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25431 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25433 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25435 */     GIR_RootConstrainSelectedInstOperands,
     /* 25436 */     // GIR_Coverage, 749,
     /* 25436 */     GIR_EraseRootFromParent_Done,
     /* 25437 */   // Label 762: @25437
     /* 25437 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(25482), // Rule ID 750 //
     /* 25442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_w),
     /* 25450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7772:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_W),
     /* 25474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25476 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25478 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25480 */     GIR_RootConstrainSelectedInstOperands,
     /* 25481 */     // GIR_Coverage, 750,
     /* 25481 */     GIR_EraseRootFromParent_Done,
     /* 25482 */   // Label 763: @25482
     /* 25482 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(25527), // Rule ID 751 //
     /* 25487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_d),
     /* 25495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25516 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7771:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_D),
     /* 25519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25521 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25523 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25525 */     GIR_RootConstrainSelectedInstOperands,
     /* 25526 */     // GIR_Coverage, 751,
     /* 25526 */     GIR_EraseRootFromParent_Done,
     /* 25527 */   // Label 764: @25527
     /* 25527 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(25572), // Rule ID 752 //
     /* 25532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_w),
     /* 25540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25561 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7774:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_W),
     /* 25564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25566 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25568 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25570 */     GIR_RootConstrainSelectedInstOperands,
     /* 25571 */     // GIR_Coverage, 752,
     /* 25571 */     GIR_EraseRootFromParent_Done,
     /* 25572 */   // Label 765: @25572
     /* 25572 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(25617), // Rule ID 753 //
     /* 25577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_d),
     /* 25585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25606 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7773:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_D),
     /* 25609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25611 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25613 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25615 */     GIR_RootConstrainSelectedInstOperands,
     /* 25616 */     // GIR_Coverage, 753,
     /* 25616 */     GIR_EraseRootFromParent_Done,
     /* 25617 */   // Label 766: @25617
     /* 25617 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(25662), // Rule ID 754 //
     /* 25622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_w),
     /* 25630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25651 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7776:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSOR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_W),
     /* 25654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25656 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25658 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25660 */     GIR_RootConstrainSelectedInstOperands,
     /* 25661 */     // GIR_Coverage, 754,
     /* 25661 */     GIR_EraseRootFromParent_Done,
     /* 25662 */   // Label 767: @25662
     /* 25662 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(25707), // Rule ID 755 //
     /* 25667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_d),
     /* 25675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25696 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7775:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSOR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_D),
     /* 25699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25701 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25703 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25705 */     GIR_RootConstrainSelectedInstOperands,
     /* 25706 */     // GIR_Coverage, 755,
     /* 25706 */     GIR_EraseRootFromParent_Done,
     /* 25707 */   // Label 768: @25707
     /* 25707 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(25752), // Rule ID 760 //
     /* 25712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_w),
     /* 25720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25741 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7782:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_W),
     /* 25744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25746 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25748 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25750 */     GIR_RootConstrainSelectedInstOperands,
     /* 25751 */     // GIR_Coverage, 760,
     /* 25751 */     GIR_EraseRootFromParent_Done,
     /* 25752 */   // Label 769: @25752
     /* 25752 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(25797), // Rule ID 761 //
     /* 25757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_d),
     /* 25765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25786 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7781:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_D),
     /* 25789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25791 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25793 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25795 */     GIR_RootConstrainSelectedInstOperands,
     /* 25796 */     // GIR_Coverage, 761,
     /* 25796 */     GIR_EraseRootFromParent_Done,
     /* 25797 */   // Label 770: @25797
     /* 25797 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(25842), // Rule ID 762 //
     /* 25802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_w),
     /* 25810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25831 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7784:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_W),
     /* 25834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25836 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25838 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25840 */     GIR_RootConstrainSelectedInstOperands,
     /* 25841 */     // GIR_Coverage, 762,
     /* 25841 */     GIR_EraseRootFromParent_Done,
     /* 25842 */   // Label 771: @25842
     /* 25842 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(25887), // Rule ID 763 //
     /* 25847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_d),
     /* 25855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25876 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7783:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_D),
     /* 25879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25881 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25883 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25885 */     GIR_RootConstrainSelectedInstOperands,
     /* 25886 */     // GIR_Coverage, 763,
     /* 25886 */     GIR_EraseRootFromParent_Done,
     /* 25887 */   // Label 772: @25887
     /* 25887 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(25932), // Rule ID 764 //
     /* 25892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_w),
     /* 25900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25921 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7786:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_W),
     /* 25924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25926 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25928 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25930 */     GIR_RootConstrainSelectedInstOperands,
     /* 25931 */     // GIR_Coverage, 764,
     /* 25931 */     GIR_EraseRootFromParent_Done,
     /* 25932 */   // Label 773: @25932
     /* 25932 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(25977), // Rule ID 765 //
     /* 25937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_d),
     /* 25945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25966 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7785:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_D),
     /* 25969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25971 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25973 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25975 */     GIR_RootConstrainSelectedInstOperands,
     /* 25976 */     // GIR_Coverage, 765,
     /* 25976 */     GIR_EraseRootFromParent_Done,
     /* 25977 */   // Label 774: @25977
     /* 25977 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(26022), // Rule ID 766 //
     /* 25982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_w),
     /* 25990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26011 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7788:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUN_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_W),
     /* 26014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26016 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26018 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26020 */     GIR_RootConstrainSelectedInstOperands,
     /* 26021 */     // GIR_Coverage, 766,
     /* 26021 */     GIR_EraseRootFromParent_Done,
     /* 26022 */   // Label 775: @26022
     /* 26022 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(26067), // Rule ID 767 //
     /* 26027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_d),
     /* 26035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26056 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7787:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUN_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_D),
     /* 26059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26061 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26063 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26065 */     GIR_RootConstrainSelectedInstOperands,
     /* 26066 */     // GIR_Coverage, 767,
     /* 26066 */     GIR_EraseRootFromParent_Done,
     /* 26067 */   // Label 776: @26067
     /* 26067 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(26112), // Rule ID 768 //
     /* 26072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_w),
     /* 26080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26101 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7790:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_W),
     /* 26104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26106 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26108 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26110 */     GIR_RootConstrainSelectedInstOperands,
     /* 26111 */     // GIR_Coverage, 768,
     /* 26111 */     GIR_EraseRootFromParent_Done,
     /* 26112 */   // Label 777: @26112
     /* 26112 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(26157), // Rule ID 769 //
     /* 26117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_d),
     /* 26125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26146 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7789:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_D),
     /* 26149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26151 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26153 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26155 */     GIR_RootConstrainSelectedInstOperands,
     /* 26156 */     // GIR_Coverage, 769,
     /* 26156 */     GIR_EraseRootFromParent_Done,
     /* 26157 */   // Label 778: @26157
     /* 26157 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(26202), // Rule ID 774 //
     /* 26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_h),
     /* 26170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26191 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7795:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FTQ_H:{ *:[v8i16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_H),
     /* 26194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26196 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26198 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26200 */     GIR_RootConstrainSelectedInstOperands,
     /* 26201 */     // GIR_Coverage, 774,
     /* 26201 */     GIR_EraseRootFromParent_Done,
     /* 26202 */   // Label 779: @26202
     /* 26202 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(26247), // Rule ID 775 //
     /* 26207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_w),
     /* 26215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26236 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7796:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FTQ_W:{ *:[v4i32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_W),
     /* 26239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26241 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26243 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26245 */     GIR_RootConstrainSelectedInstOperands,
     /* 26246 */     // GIR_Coverage, 775,
     /* 26246 */     GIR_EraseRootFromParent_Done,
     /* 26247 */   // Label 780: @26247
     /* 26247 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(26292), // Rule ID 780 //
     /* 26252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_h),
     /* 26260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26281 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7802:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_H),
     /* 26284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26286 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26288 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26290 */     GIR_RootConstrainSelectedInstOperands,
     /* 26291 */     // GIR_Coverage, 780,
     /* 26291 */     GIR_EraseRootFromParent_Done,
     /* 26292 */   // Label 781: @26292
     /* 26292 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(26337), // Rule ID 781 //
     /* 26297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_w),
     /* 26305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26326 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7803:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_W),
     /* 26329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26331 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26333 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26335 */     GIR_RootConstrainSelectedInstOperands,
     /* 26336 */     // GIR_Coverage, 781,
     /* 26336 */     GIR_EraseRootFromParent_Done,
     /* 26337 */   // Label 782: @26337
     /* 26337 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(26382), // Rule ID 782 //
     /* 26342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_d),
     /* 26350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26371 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7801:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_D),
     /* 26374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26376 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26378 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26380 */     GIR_RootConstrainSelectedInstOperands,
     /* 26381 */     // GIR_Coverage, 782,
     /* 26381 */     GIR_EraseRootFromParent_Done,
     /* 26382 */   // Label 783: @26382
     /* 26382 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(26427), // Rule ID 783 //
     /* 26387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_h),
     /* 26395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7805:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_H),
     /* 26419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26421 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26423 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26425 */     GIR_RootConstrainSelectedInstOperands,
     /* 26426 */     // GIR_Coverage, 783,
     /* 26426 */     GIR_EraseRootFromParent_Done,
     /* 26427 */   // Label 784: @26427
     /* 26427 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(26472), // Rule ID 784 //
     /* 26432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_w),
     /* 26440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26461 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7806:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_W),
     /* 26464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26466 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26468 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26470 */     GIR_RootConstrainSelectedInstOperands,
     /* 26471 */     // GIR_Coverage, 784,
     /* 26471 */     GIR_EraseRootFromParent_Done,
     /* 26472 */   // Label 785: @26472
     /* 26472 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(26517), // Rule ID 785 //
     /* 26477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_d),
     /* 26485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26506 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7804:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_D),
     /* 26509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26511 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26513 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26515 */     GIR_RootConstrainSelectedInstOperands,
     /* 26516 */     // GIR_Coverage, 785,
     /* 26516 */     GIR_EraseRootFromParent_Done,
     /* 26517 */   // Label 786: @26517
     /* 26517 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(26562), // Rule ID 786 //
     /* 26522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_h),
     /* 26530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26551 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7808:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_H),
     /* 26554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26556 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26558 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26560 */     GIR_RootConstrainSelectedInstOperands,
     /* 26561 */     // GIR_Coverage, 786,
     /* 26561 */     GIR_EraseRootFromParent_Done,
     /* 26562 */   // Label 787: @26562
     /* 26562 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(26607), // Rule ID 787 //
     /* 26567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_w),
     /* 26575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26596 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7809:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_W),
     /* 26599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26601 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26603 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26605 */     GIR_RootConstrainSelectedInstOperands,
     /* 26606 */     // GIR_Coverage, 787,
     /* 26606 */     GIR_EraseRootFromParent_Done,
     /* 26607 */   // Label 788: @26607
     /* 26607 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(26652), // Rule ID 788 //
     /* 26612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_d),
     /* 26620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26641 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7807:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_D),
     /* 26644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26646 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26648 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26650 */     GIR_RootConstrainSelectedInstOperands,
     /* 26651 */     // GIR_Coverage, 788,
     /* 26651 */     GIR_EraseRootFromParent_Done,
     /* 26652 */   // Label 789: @26652
     /* 26652 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(26697), // Rule ID 789 //
     /* 26657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_h),
     /* 26665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26686 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7811:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_H),
     /* 26689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26691 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26693 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26695 */     GIR_RootConstrainSelectedInstOperands,
     /* 26696 */     // GIR_Coverage, 789,
     /* 26696 */     GIR_EraseRootFromParent_Done,
     /* 26697 */   // Label 790: @26697
     /* 26697 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(26742), // Rule ID 790 //
     /* 26702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_w),
     /* 26710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7812:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_W),
     /* 26734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26736 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26738 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26740 */     GIR_RootConstrainSelectedInstOperands,
     /* 26741 */     // GIR_Coverage, 790,
     /* 26741 */     GIR_EraseRootFromParent_Done,
     /* 26742 */   // Label 791: @26742
     /* 26742 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(26787), // Rule ID 791 //
     /* 26747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_d),
     /* 26755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26776 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7810:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_D),
     /* 26779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26781 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26783 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26785 */     GIR_RootConstrainSelectedInstOperands,
     /* 26786 */     // GIR_Coverage, 791,
     /* 26786 */     GIR_EraseRootFromParent_Done,
     /* 26787 */   // Label 792: @26787
     /* 26787 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(26832), // Rule ID 844 //
     /* 26792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_b),
     /* 26800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26821 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7866:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_B),
     /* 26824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26826 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26828 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26830 */     GIR_RootConstrainSelectedInstOperands,
     /* 26831 */     // GIR_Coverage, 844,
     /* 26831 */     GIR_EraseRootFromParent_Done,
     /* 26832 */   // Label 793: @26832
     /* 26832 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(26877), // Rule ID 845 //
     /* 26837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_h),
     /* 26845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7868:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_H),
     /* 26869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26871 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26873 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26875 */     GIR_RootConstrainSelectedInstOperands,
     /* 26876 */     // GIR_Coverage, 845,
     /* 26876 */     GIR_EraseRootFromParent_Done,
     /* 26877 */   // Label 794: @26877
     /* 26877 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(26922), // Rule ID 846 //
     /* 26882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_w),
     /* 26890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26911 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7869:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_W),
     /* 26914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26916 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26918 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26920 */     GIR_RootConstrainSelectedInstOperands,
     /* 26921 */     // GIR_Coverage, 846,
     /* 26921 */     GIR_EraseRootFromParent_Done,
     /* 26922 */   // Label 795: @26922
     /* 26922 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(26967), // Rule ID 847 //
     /* 26927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_d),
     /* 26935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26956 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7867:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 26956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_D),
     /* 26959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26961 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26963 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26965 */     GIR_RootConstrainSelectedInstOperands,
     /* 26966 */     // GIR_Coverage, 847,
     /* 26966 */     GIR_EraseRootFromParent_Done,
     /* 26967 */   // Label 796: @26967
     /* 26967 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(27012), // Rule ID 864 //
     /* 26972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_b),
     /* 26980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27001 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7886:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_B),
     /* 27004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27006 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27008 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27010 */     GIR_RootConstrainSelectedInstOperands,
     /* 27011 */     // GIR_Coverage, 864,
     /* 27011 */     GIR_EraseRootFromParent_Done,
     /* 27012 */   // Label 797: @27012
     /* 27012 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(27057), // Rule ID 865 //
     /* 27017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_h),
     /* 27025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27046 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7888:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_H),
     /* 27049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27051 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27053 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27055 */     GIR_RootConstrainSelectedInstOperands,
     /* 27056 */     // GIR_Coverage, 865,
     /* 27056 */     GIR_EraseRootFromParent_Done,
     /* 27057 */   // Label 798: @27057
     /* 27057 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(27102), // Rule ID 866 //
     /* 27062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_w),
     /* 27070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7889:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_W),
     /* 27094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27096 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27098 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27100 */     GIR_RootConstrainSelectedInstOperands,
     /* 27101 */     // GIR_Coverage, 866,
     /* 27101 */     GIR_EraseRootFromParent_Done,
     /* 27102 */   // Label 799: @27102
     /* 27102 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(27147), // Rule ID 867 //
     /* 27107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_d),
     /* 27115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27136 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7887:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_D),
     /* 27139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27141 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27143 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27145 */     GIR_RootConstrainSelectedInstOperands,
     /* 27146 */     // GIR_Coverage, 867,
     /* 27146 */     GIR_EraseRootFromParent_Done,
     /* 27147 */   // Label 800: @27147
     /* 27147 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(27192), // Rule ID 900 //
     /* 27152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_h),
     /* 27160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27181 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7928:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MUL_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_H),
     /* 27184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27186 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27188 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27190 */     GIR_RootConstrainSelectedInstOperands,
     /* 27191 */     // GIR_Coverage, 900,
     /* 27191 */     GIR_EraseRootFromParent_Done,
     /* 27192 */   // Label 801: @27192
     /* 27192 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(27237), // Rule ID 901 //
     /* 27197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_w),
     /* 27205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27226 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7929:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MUL_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_W),
     /* 27229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27231 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27233 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27235 */     GIR_RootConstrainSelectedInstOperands,
     /* 27236 */     // GIR_Coverage, 901,
     /* 27236 */     GIR_EraseRootFromParent_Done,
     /* 27237 */   // Label 802: @27237
     /* 27237 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(27282), // Rule ID 902 //
     /* 27242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_h),
     /* 27250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27271 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7939:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_H),
     /* 27274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27276 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27278 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27280 */     GIR_RootConstrainSelectedInstOperands,
     /* 27281 */     // GIR_Coverage, 902,
     /* 27281 */     GIR_EraseRootFromParent_Done,
     /* 27282 */   // Label 803: @27282
     /* 27282 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(27327), // Rule ID 903 //
     /* 27287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_w),
     /* 27295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27316 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7940:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_W),
     /* 27319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27321 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27323 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27325 */     GIR_RootConstrainSelectedInstOperands,
     /* 27326 */     // GIR_Coverage, 903,
     /* 27326 */     GIR_EraseRootFromParent_Done,
     /* 27327 */   // Label 804: @27327
     /* 27327 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(27372), // Rule ID 981 //
     /* 27332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_b),
     /* 27340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27361 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8053:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRAR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_B),
     /* 27364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27366 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27368 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27370 */     GIR_RootConstrainSelectedInstOperands,
     /* 27371 */     // GIR_Coverage, 981,
     /* 27371 */     GIR_EraseRootFromParent_Done,
     /* 27372 */   // Label 805: @27372
     /* 27372 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(27417), // Rule ID 982 //
     /* 27377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_h),
     /* 27385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8055:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRAR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_H),
     /* 27409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27411 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27413 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27415 */     GIR_RootConstrainSelectedInstOperands,
     /* 27416 */     // GIR_Coverage, 982,
     /* 27416 */     GIR_EraseRootFromParent_Done,
     /* 27417 */   // Label 806: @27417
     /* 27417 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(27462), // Rule ID 983 //
     /* 27422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_w),
     /* 27430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27451 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8056:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRAR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_W),
     /* 27454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27456 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27458 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27460 */     GIR_RootConstrainSelectedInstOperands,
     /* 27461 */     // GIR_Coverage, 983,
     /* 27461 */     GIR_EraseRootFromParent_Done,
     /* 27462 */   // Label 807: @27462
     /* 27462 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(27507), // Rule ID 984 //
     /* 27467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_d),
     /* 27475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27496 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8054:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRAR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_D),
     /* 27499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27501 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27503 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27505 */     GIR_RootConstrainSelectedInstOperands,
     /* 27506 */     // GIR_Coverage, 984,
     /* 27506 */     GIR_EraseRootFromParent_Done,
     /* 27507 */   // Label 808: @27507
     /* 27507 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(27552), // Rule ID 997 //
     /* 27512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_b),
     /* 27520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27541 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8069:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRLR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_B),
     /* 27544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27546 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27548 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27550 */     GIR_RootConstrainSelectedInstOperands,
     /* 27551 */     // GIR_Coverage, 997,
     /* 27551 */     GIR_EraseRootFromParent_Done,
     /* 27552 */   // Label 809: @27552
     /* 27552 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(27597), // Rule ID 998 //
     /* 27557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_h),
     /* 27565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27586 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8071:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRLR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_H),
     /* 27589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27591 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27593 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27595 */     GIR_RootConstrainSelectedInstOperands,
     /* 27596 */     // GIR_Coverage, 998,
     /* 27596 */     GIR_EraseRootFromParent_Done,
     /* 27597 */   // Label 810: @27597
     /* 27597 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(27642), // Rule ID 999 //
     /* 27602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_w),
     /* 27610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27631 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8072:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRLR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_W),
     /* 27634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27636 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27638 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27640 */     GIR_RootConstrainSelectedInstOperands,
     /* 27641 */     // GIR_Coverage, 999,
     /* 27641 */     GIR_EraseRootFromParent_Done,
     /* 27642 */   // Label 811: @27642
     /* 27642 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(27687), // Rule ID 1000 //
     /* 27647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_d),
     /* 27655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27676 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8070:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRLR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_D),
     /* 27679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27681 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27683 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27685 */     GIR_RootConstrainSelectedInstOperands,
     /* 27686 */     // GIR_Coverage, 1000,
     /* 27686 */     GIR_EraseRootFromParent_Done,
     /* 27687 */   // Label 812: @27687
     /* 27687 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(27732), // Rule ID 1009 //
     /* 27692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_b),
     /* 27700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27721 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8090:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_B),
     /* 27724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27726 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27728 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27730 */     GIR_RootConstrainSelectedInstOperands,
     /* 27731 */     // GIR_Coverage, 1009,
     /* 27731 */     GIR_EraseRootFromParent_Done,
     /* 27732 */   // Label 813: @27732
     /* 27732 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(27777), // Rule ID 1010 //
     /* 27737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_h),
     /* 27745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27766 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8092:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_H),
     /* 27769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27771 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27773 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27775 */     GIR_RootConstrainSelectedInstOperands,
     /* 27776 */     // GIR_Coverage, 1010,
     /* 27776 */     GIR_EraseRootFromParent_Done,
     /* 27777 */   // Label 814: @27777
     /* 27777 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(27822), // Rule ID 1011 //
     /* 27782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_w),
     /* 27790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27811 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8093:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_W),
     /* 27814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27816 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27818 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27820 */     GIR_RootConstrainSelectedInstOperands,
     /* 27821 */     // GIR_Coverage, 1011,
     /* 27821 */     GIR_EraseRootFromParent_Done,
     /* 27822 */   // Label 815: @27822
     /* 27822 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(27867), // Rule ID 1012 //
     /* 27827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_d),
     /* 27835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27856 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8091:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_D),
     /* 27859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27861 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27863 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27865 */     GIR_RootConstrainSelectedInstOperands,
     /* 27866 */     // GIR_Coverage, 1012,
     /* 27866 */     GIR_EraseRootFromParent_Done,
     /* 27867 */   // Label 816: @27867
     /* 27867 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(27912), // Rule ID 1013 //
     /* 27872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_b),
     /* 27880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27901 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8094:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_B),
     /* 27904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27906 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27908 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27910 */     GIR_RootConstrainSelectedInstOperands,
     /* 27911 */     // GIR_Coverage, 1013,
     /* 27911 */     GIR_EraseRootFromParent_Done,
     /* 27912 */   // Label 817: @27912
     /* 27912 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(27957), // Rule ID 1014 //
     /* 27917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_h),
     /* 27925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27946 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8096:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_H),
     /* 27949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27951 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27953 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27955 */     GIR_RootConstrainSelectedInstOperands,
     /* 27956 */     // GIR_Coverage, 1014,
     /* 27956 */     GIR_EraseRootFromParent_Done,
     /* 27957 */   // Label 818: @27957
     /* 27957 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(28002), // Rule ID 1015 //
     /* 27962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_w),
     /* 27970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27991 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8097:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_W),
     /* 27994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27996 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27998 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28000 */     GIR_RootConstrainSelectedInstOperands,
     /* 28001 */     // GIR_Coverage, 1015,
     /* 28001 */     GIR_EraseRootFromParent_Done,
     /* 28002 */   // Label 819: @28002
     /* 28002 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(28047), // Rule ID 1016 //
     /* 28007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_d),
     /* 28015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28036 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8095:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_D),
     /* 28039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28041 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28043 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28045 */     GIR_RootConstrainSelectedInstOperands,
     /* 28046 */     // GIR_Coverage, 1016,
     /* 28046 */     GIR_EraseRootFromParent_Done,
     /* 28047 */   // Label 820: @28047
     /* 28047 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(28092), // Rule ID 1017 //
     /* 28052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_b),
     /* 28060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28081 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8098:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_B),
     /* 28084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28086 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28088 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28090 */     GIR_RootConstrainSelectedInstOperands,
     /* 28091 */     // GIR_Coverage, 1017,
     /* 28091 */     GIR_EraseRootFromParent_Done,
     /* 28092 */   // Label 821: @28092
     /* 28092 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(28137), // Rule ID 1018 //
     /* 28097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_h),
     /* 28105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28126 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8100:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_H),
     /* 28129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28131 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28133 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28135 */     GIR_RootConstrainSelectedInstOperands,
     /* 28136 */     // GIR_Coverage, 1018,
     /* 28136 */     GIR_EraseRootFromParent_Done,
     /* 28137 */   // Label 822: @28137
     /* 28137 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(28182), // Rule ID 1019 //
     /* 28142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_w),
     /* 28150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28171 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8101:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_W),
     /* 28174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28176 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28178 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28180 */     GIR_RootConstrainSelectedInstOperands,
     /* 28181 */     // GIR_Coverage, 1019,
     /* 28181 */     GIR_EraseRootFromParent_Done,
     /* 28182 */   // Label 823: @28182
     /* 28182 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(28227), // Rule ID 1020 //
     /* 28187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_d),
     /* 28195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8099:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_D),
     /* 28219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28221 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28223 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28225 */     GIR_RootConstrainSelectedInstOperands,
     /* 28226 */     // GIR_Coverage, 1020,
     /* 28226 */     GIR_EraseRootFromParent_Done,
     /* 28227 */   // Label 824: @28227
     /* 28227 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(28272), // Rule ID 1021 //
     /* 28232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_b),
     /* 28240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28261 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8102:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUU_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_B),
     /* 28264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28266 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28268 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28270 */     GIR_RootConstrainSelectedInstOperands,
     /* 28271 */     // GIR_Coverage, 1021,
     /* 28271 */     GIR_EraseRootFromParent_Done,
     /* 28272 */   // Label 825: @28272
     /* 28272 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(28317), // Rule ID 1022 //
     /* 28277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_h),
     /* 28285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28306 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8104:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUU_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_H),
     /* 28309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28311 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28313 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28315 */     GIR_RootConstrainSelectedInstOperands,
     /* 28316 */     // GIR_Coverage, 1022,
     /* 28316 */     GIR_EraseRootFromParent_Done,
     /* 28317 */   // Label 826: @28317
     /* 28317 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(28362), // Rule ID 1023 //
     /* 28322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_w),
     /* 28330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28351 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8105:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUU_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_W),
     /* 28354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28356 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28358 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28360 */     GIR_RootConstrainSelectedInstOperands,
     /* 28361 */     // GIR_Coverage, 1023,
     /* 28361 */     GIR_EraseRootFromParent_Done,
     /* 28362 */   // Label 827: @28362
     /* 28362 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(28407), // Rule ID 1024 //
     /* 28367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_d),
     /* 28375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28396 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8103:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUU_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_D),
     /* 28399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28401 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28403 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28405 */     GIR_RootConstrainSelectedInstOperands,
     /* 28406 */     // GIR_Coverage, 1024,
     /* 28406 */     GIR_EraseRootFromParent_Done,
     /* 28407 */   // Label 828: @28407
     /* 28407 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(28455), // Rule ID 1223 //
     /* 28412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 28420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28441 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7464:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH_MM),
     /* 28444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28453 */     GIR_RootConstrainSelectedInstOperands,
     /* 28454 */     // GIR_Coverage, 1223,
     /* 28454 */     GIR_EraseRootFromParent_Done,
     /* 28455 */   // Label 829: @28455
     /* 28455 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(28503), // Rule ID 1225 //
     /* 28460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 28468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28489 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7486:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB_MM),
     /* 28492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28501 */     GIR_RootConstrainSelectedInstOperands,
     /* 28502 */     // GIR_Coverage, 1225,
     /* 28502 */     GIR_EraseRootFromParent_Done,
     /* 28503 */   // Label 830: @28503
     /* 28503 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(28548), // Rule ID 1246 //
     /* 28508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 28516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28537 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8014:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH_MM),
     /* 28540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28546 */     GIR_RootConstrainSelectedInstOperands,
     /* 28547 */     // GIR_Coverage, 1246,
     /* 28547 */     GIR_EraseRootFromParent_Done,
     /* 28548 */   // Label 831: @28548
     /* 28548 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(28593), // Rule ID 1247 //
     /* 28553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 28561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28582 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8016:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH_MM),
     /* 28585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28591 */     GIR_RootConstrainSelectedInstOperands,
     /* 28592 */     // GIR_Coverage, 1247,
     /* 28592 */     GIR_EraseRootFromParent_Done,
     /* 28593 */   // Label 832: @28593
     /* 28593 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(28638), // Rule ID 1248 //
     /* 28598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 28606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28627 */     // (intrinsic_wo_chain:{ *:[i32] } 8018:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W_MM),
     /* 28630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28636 */     GIR_RootConstrainSelectedInstOperands,
     /* 28637 */     // GIR_Coverage, 1248,
     /* 28637 */     GIR_EraseRootFromParent_Done,
     /* 28638 */   // Label 833: @28638
     /* 28638 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(28683), // Rule ID 1250 //
     /* 28643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 28651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28672 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8020:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB_MM),
     /* 28675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28681 */     GIR_RootConstrainSelectedInstOperands,
     /* 28682 */     // GIR_Coverage, 1250,
     /* 28682 */     GIR_EraseRootFromParent_Done,
     /* 28683 */   // Label 834: @28683
     /* 28683 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(28731), // Rule ID 1261 //
     /* 28688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 28696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28717 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8084:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH_MM),
     /* 28720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28729 */     GIR_RootConstrainSelectedInstOperands,
     /* 28730 */     // GIR_Coverage, 1261,
     /* 28730 */     GIR_EraseRootFromParent_Done,
     /* 28731 */   // Label 835: @28731
     /* 28731 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(28779), // Rule ID 1263 //
     /* 28736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 28744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28765 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8109:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB_MM),
     /* 28768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28777 */     GIR_RootConstrainSelectedInstOperands,
     /* 28778 */     // GIR_Coverage, 1263,
     /* 28778 */     GIR_EraseRootFromParent_Done,
     /* 28779 */   // Label 836: @28779
     /* 28779 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(28824), // Rule ID 1273 //
     /* 28784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 28792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28813 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7989:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W_MM),
     /* 28816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28822 */     GIR_RootConstrainSelectedInstOperands,
     /* 28823 */     // GIR_Coverage, 1273,
     /* 28823 */     GIR_EraseRootFromParent_Done,
     /* 28824 */   // Label 837: @28824
     /* 28824 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(28869), // Rule ID 1274 //
     /* 28829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 28837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28858 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7990:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH_MM),
     /* 28861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28867 */     GIR_RootConstrainSelectedInstOperands,
     /* 28868 */     // GIR_Coverage, 1274,
     /* 28868 */     GIR_EraseRootFromParent_Done,
     /* 28869 */   // Label 838: @28869
     /* 28869 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(28914), // Rule ID 1293 //
     /* 28874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 28882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28903 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7961:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH_MM),
     /* 28906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28912 */     GIR_RootConstrainSelectedInstOperands,
     /* 28913 */     // GIR_Coverage, 1293,
     /* 28913 */     GIR_EraseRootFromParent_Done,
     /* 28914 */   // Label 839: @28914
     /* 28914 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(28959), // Rule ID 1299 //
     /* 28919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 28927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28948 */     // (intrinsic_wo_chain:{ *:[i32] } 7914:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB_MM),
     /* 28951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28957 */     GIR_RootConstrainSelectedInstOperands,
     /* 28958 */     // GIR_Coverage, 1299,
     /* 28958 */     GIR_EraseRootFromParent_Done,
     /* 28959 */   // Label 840: @28959
     /* 28959 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(29004), // Rule ID 1312 //
     /* 28964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 28967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 28972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28993 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7466:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH_MMR2),
     /* 28996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29002 */     GIR_RootConstrainSelectedInstOperands,
     /* 29003 */     // GIR_Coverage, 1312,
     /* 29003 */     GIR_EraseRootFromParent_Done,
     /* 29004 */   // Label 841: @29004
     /* 29004 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(29049), // Rule ID 1313 //
     /* 29009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 29017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29038 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7467:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH_MMR2),
     /* 29041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29047 */     GIR_RootConstrainSelectedInstOperands,
     /* 29048 */     // GIR_Coverage, 1313,
     /* 29048 */     GIR_EraseRootFromParent_Done,
     /* 29049 */   // Label 842: @29049
     /* 29049 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(29094), // Rule ID 1314 //
     /* 29054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 29062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29083 */     // (intrinsic_wo_chain:{ *:[i32] } 7469:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W_MMR2),
     /* 29086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29092 */     GIR_RootConstrainSelectedInstOperands,
     /* 29093 */     // GIR_Coverage, 1314,
     /* 29093 */     GIR_EraseRootFromParent_Done,
     /* 29094 */   // Label 843: @29094
     /* 29094 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(29139), // Rule ID 1315 //
     /* 29099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 29107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29128 */     // (intrinsic_wo_chain:{ *:[i32] } 7468:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W_MMR2),
     /* 29131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29137 */     GIR_RootConstrainSelectedInstOperands,
     /* 29138 */     // GIR_Coverage, 1315,
     /* 29138 */     GIR_EraseRootFromParent_Done,
     /* 29139 */   // Label 844: @29139
     /* 29139 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(29184), // Rule ID 1318 //
     /* 29144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 29152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29173 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7487:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB_MMR2),
     /* 29176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29182 */     GIR_RootConstrainSelectedInstOperands,
     /* 29183 */     // GIR_Coverage, 1318,
     /* 29183 */     GIR_EraseRootFromParent_Done,
     /* 29184 */   // Label 845: @29184
     /* 29184 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(29229), // Rule ID 1319 //
     /* 29189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 29197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29218 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7488:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB_MMR2),
     /* 29221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29227 */     GIR_RootConstrainSelectedInstOperands,
     /* 29228 */     // GIR_Coverage, 1319,
     /* 29228 */     GIR_EraseRootFromParent_Done,
     /* 29229 */   // Label 846: @29229
     /* 29229 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(29274), // Rule ID 1325 //
     /* 29234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 29242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29263 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8015:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB_MMR2),
     /* 29266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29272 */     GIR_RootConstrainSelectedInstOperands,
     /* 29273 */     // GIR_Coverage, 1325,
     /* 29273 */     GIR_EraseRootFromParent_Done,
     /* 29274 */   // Label 847: @29274
     /* 29274 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(29319), // Rule ID 1326 //
     /* 29279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 29287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29308 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8017:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB_MMR2),
     /* 29311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29317 */     GIR_RootConstrainSelectedInstOperands,
     /* 29318 */     // GIR_Coverage, 1326,
     /* 29318 */     GIR_EraseRootFromParent_Done,
     /* 29319 */   // Label 848: @29319
     /* 29319 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(29364), // Rule ID 1331 //
     /* 29324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 29332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29353 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8019:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH_MMR2),
     /* 29356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29362 */     GIR_RootConstrainSelectedInstOperands,
     /* 29363 */     // GIR_Coverage, 1331,
     /* 29363 */     GIR_EraseRootFromParent_Done,
     /* 29364 */   // Label 849: @29364
     /* 29364 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(29409), // Rule ID 1332 //
     /* 29369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 29377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29398 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8086:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH_MMR2),
     /* 29401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29407 */     GIR_RootConstrainSelectedInstOperands,
     /* 29408 */     // GIR_Coverage, 1332,
     /* 29408 */     GIR_EraseRootFromParent_Done,
     /* 29409 */   // Label 850: @29409
     /* 29409 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(29454), // Rule ID 1333 //
     /* 29414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 29422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29443 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8087:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH_MMR2),
     /* 29446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29452 */     GIR_RootConstrainSelectedInstOperands,
     /* 29453 */     // GIR_Coverage, 1333,
     /* 29453 */     GIR_EraseRootFromParent_Done,
     /* 29454 */   // Label 851: @29454
     /* 29454 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(29499), // Rule ID 1334 //
     /* 29459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 29467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29488 */     // (intrinsic_wo_chain:{ *:[i32] } 8089:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W_MMR2),
     /* 29491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29497 */     GIR_RootConstrainSelectedInstOperands,
     /* 29498 */     // GIR_Coverage, 1334,
     /* 29498 */     GIR_EraseRootFromParent_Done,
     /* 29499 */   // Label 852: @29499
     /* 29499 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(29544), // Rule ID 1335 //
     /* 29504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 29512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29533 */     // (intrinsic_wo_chain:{ *:[i32] } 8088:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W_MMR2),
     /* 29536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29542 */     GIR_RootConstrainSelectedInstOperands,
     /* 29543 */     // GIR_Coverage, 1335,
     /* 29543 */     GIR_EraseRootFromParent_Done,
     /* 29544 */   // Label 853: @29544
     /* 29544 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(29589), // Rule ID 1338 //
     /* 29549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 29557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29578 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8110:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB_MMR2),
     /* 29581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29587 */     GIR_RootConstrainSelectedInstOperands,
     /* 29588 */     // GIR_Coverage, 1338,
     /* 29588 */     GIR_EraseRootFromParent_Done,
     /* 29589 */   // Label 854: @29589
     /* 29589 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(29634), // Rule ID 1339 //
     /* 29594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 29602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29623 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB_MMR2),
     /* 29626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29632 */     GIR_RootConstrainSelectedInstOperands,
     /* 29633 */     // GIR_Coverage, 1339,
     /* 29633 */     GIR_EraseRootFromParent_Done,
     /* 29634 */   // Label 855: @29634
     /* 29634 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(29674), // Rule ID 1916 //
     /* 29639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_ph),
     /* 29647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29660 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7463:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /* 29663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29665 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29667 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29672 */     GIR_RootConstrainSelectedInstOperands,
     /* 29673 */     // GIR_Coverage, 1916,
     /* 29673 */     GIR_EraseRootFromParent_Done,
     /* 29674 */   // Label 856: @29674
     /* 29674 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(29714), // Rule ID 1918 //
     /* 29679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_ph),
     /* 29687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29700 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8083:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /* 29703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29705 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29707 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29712 */     GIR_RootConstrainSelectedInstOperands,
     /* 29713 */     // GIR_Coverage, 1918,
     /* 29713 */     GIR_EraseRootFromParent_Done,
     /* 29714 */   // Label 857: @29714
     /* 29714 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(29754), // Rule ID 1922 //
     /* 29719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_qb),
     /* 29727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29740 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7484:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /* 29743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29745 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29747 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29752 */     GIR_RootConstrainSelectedInstOperands,
     /* 29753 */     // GIR_Coverage, 1922,
     /* 29753 */     GIR_EraseRootFromParent_Done,
     /* 29754 */   // Label 858: @29754
     /* 29754 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(29794), // Rule ID 1924 //
     /* 29759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_qb),
     /* 29767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29780 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8107:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /* 29783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29785 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29787 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29792 */     GIR_RootConstrainSelectedInstOperands,
     /* 29793 */     // GIR_Coverage, 1924,
     /* 29793 */     GIR_EraseRootFromParent_Done,
     /* 29794 */   // Label 859: @29794
     /* 29794 */   GIM_Reject,
     /* 29795 */ // Label 645: @29795
     /* 29795 */ GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(32309),
     /* 29800 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 29803 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(29858), // Rule ID 477 //
     /* 29808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 29816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29837 */     // MIs[0] sa
     /* 29837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29845 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7987:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W),
     /* 29848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29852 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29856 */     GIR_RootConstrainSelectedInstOperands,
     /* 29857 */     // GIR_Coverage, 477,
     /* 29857 */     GIR_EraseRootFromParent_Done,
     /* 29858 */   // Label 861: @29858
     /* 29858 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(29913), // Rule ID 478 //
     /* 29863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 29871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29892 */     // MIs[0] sa
     /* 29892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29900 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7988:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W),
     /* 29903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29907 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29911 */     GIR_RootConstrainSelectedInstOperands,
     /* 29912 */     // GIR_Coverage, 478,
     /* 29912 */     GIR_EraseRootFromParent_Done,
     /* 29913 */   // Label 862: @29913
     /* 29913 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(29968), // Rule ID 483 //
     /* 29918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 29926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29947 */     // MIs[0] sa
     /* 29947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29955 */     // (intrinsic_wo_chain:{ *:[i32] } 7500:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND),
     /* 29958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29962 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29966 */     GIR_RootConstrainSelectedInstOperands,
     /* 29967 */     // GIR_Coverage, 483,
     /* 29967 */     GIR_EraseRootFromParent_Done,
     /* 29968 */   // Label 863: @29968
     /* 29968 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(30023), // Rule ID 484 //
     /* 29973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 29981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30002 */     // MIs[0] sa
     /* 30002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30010 */     // (intrinsic_wo_chain:{ *:[i32] } 7525:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$sa)  =>  (BALIGN:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN),
     /* 30013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30017 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30021 */     GIR_RootConstrainSelectedInstOperands,
     /* 30022 */     // GIR_Coverage, 484,
     /* 30022 */     GIR_EraseRootFromParent_Done,
     /* 30023 */   // Label 864: @30023
     /* 30023 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(30078), // Rule ID 485 //
     /* 30028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 30031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30057 */     // MIs[0] sa
     /* 30057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30065 */     // (intrinsic_wo_chain:{ *:[i32] } 7993:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND),
     /* 30068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30072 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30076 */     GIR_RootConstrainSelectedInstOperands,
     /* 30077 */     // GIR_Coverage, 485,
     /* 30077 */     GIR_EraseRootFromParent_Done,
     /* 30078 */   // Label 865: @30078
     /* 30078 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(30133), // Rule ID 953 //
     /* 30083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_b),
     /* 30091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30112 */     // MIs[0] n
     /* 30112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 30120 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8025:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$n)  =>  (SLDI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_B),
     /* 30123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30125 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30127 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30129 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30131 */     GIR_RootConstrainSelectedInstOperands,
     /* 30132 */     // GIR_Coverage, 953,
     /* 30132 */     GIR_EraseRootFromParent_Done,
     /* 30133 */   // Label 866: @30133
     /* 30133 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(30188), // Rule ID 954 //
     /* 30138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_h),
     /* 30146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30167 */     // MIs[0] n
     /* 30167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 30175 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8027:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$n)  =>  (SLDI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_H),
     /* 30178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30180 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30182 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30184 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30186 */     GIR_RootConstrainSelectedInstOperands,
     /* 30187 */     // GIR_Coverage, 954,
     /* 30187 */     GIR_EraseRootFromParent_Done,
     /* 30188 */   // Label 867: @30188
     /* 30188 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(30243), // Rule ID 955 //
     /* 30193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_w),
     /* 30201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30222 */     // MIs[0] n
     /* 30222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30230 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8028:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$n)  =>  (SLDI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_W),
     /* 30233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30235 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30237 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30239 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30241 */     GIR_RootConstrainSelectedInstOperands,
     /* 30242 */     // GIR_Coverage, 955,
     /* 30242 */     GIR_EraseRootFromParent_Done,
     /* 30243 */   // Label 868: @30243
     /* 30243 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(30298), // Rule ID 956 //
     /* 30248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_d),
     /* 30256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30277 */     // MIs[0] n
     /* 30277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt1),
     /* 30285 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8026:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt1>>:$n)  =>  (SLDI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_D),
     /* 30288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30290 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30292 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30294 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30296 */     GIR_RootConstrainSelectedInstOperands,
     /* 30297 */     // GIR_Coverage, 956,
     /* 30297 */     GIR_EraseRootFromParent_Done,
     /* 30298 */   // Label 869: @30298
     /* 30298 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(30353), // Rule ID 1349 //
     /* 30303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 30311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30332 */     // MIs[0] sa
     /* 30332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30340 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7987:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W_MMR2),
     /* 30343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30347 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30351 */     GIR_RootConstrainSelectedInstOperands,
     /* 30352 */     // GIR_Coverage, 1349,
     /* 30352 */     GIR_EraseRootFromParent_Done,
     /* 30353 */   // Label 870: @30353
     /* 30353 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(30408), // Rule ID 1350 //
     /* 30358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 30366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30387 */     // MIs[0] sa
     /* 30387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30395 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7988:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W_MMR2),
     /* 30398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30402 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30406 */     GIR_RootConstrainSelectedInstOperands,
     /* 30407 */     // GIR_Coverage, 1350,
     /* 30407 */     GIR_EraseRootFromParent_Done,
     /* 30408 */   // Label 871: @30408
     /* 30408 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(30463), // Rule ID 1351 //
     /* 30413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30442 */     // MIs[0] sa
     /* 30442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30450 */     // (intrinsic_wo_chain:{ *:[i32] } 7993:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND_MMR2),
     /* 30453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30457 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30461 */     GIR_RootConstrainSelectedInstOperands,
     /* 30462 */     // GIR_Coverage, 1351,
     /* 30462 */     GIR_EraseRootFromParent_Done,
     /* 30463 */   // Label 872: @30463
     /* 30463 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(30518), // Rule ID 1352 //
     /* 30468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 30476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30497 */     // MIs[0] sa
     /* 30497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30505 */     // (intrinsic_wo_chain:{ *:[i32] } 7500:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND_MMR2),
     /* 30508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30512 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30516 */     GIR_RootConstrainSelectedInstOperands,
     /* 30517 */     // GIR_Coverage, 1352,
     /* 30517 */     GIR_EraseRootFromParent_Done,
     /* 30518 */   // Label 873: @30518
     /* 30518 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(30580), // Rule ID 1327 //
     /* 30523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 30531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30552 */     // MIs[0] bp
     /* 30552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 30556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 30560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2),
     /* 30564 */     // MIs[1] Operand 1
     /* 30564 */     // No operand predicates
     /* 30564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 30566 */     // (intrinsic_wo_chain:{ *:[i32] } 7525:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2>>:$bp)  =>  (BALIGN_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$bp, GPR32Opnd:{ *:[i32] }:$src)
     /* 30566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN_MMR2),
     /* 30569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // bp
     /* 30576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30578 */     GIR_RootConstrainSelectedInstOperands,
     /* 30579 */     // GIR_Coverage, 1327,
     /* 30579 */     GIR_EraseRootFromParent_Done,
     /* 30580 */   // Label 874: @30580
     /* 30580 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(30634), // Rule ID 552 //
     /* 30585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_b),
     /* 30593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30621 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7534:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_B),
     /* 30624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30626 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30628 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30630 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30632 */     GIR_RootConstrainSelectedInstOperands,
     /* 30633 */     // GIR_Coverage, 552,
     /* 30633 */     GIR_EraseRootFromParent_Done,
     /* 30634 */   // Label 875: @30634
     /* 30634 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(30688), // Rule ID 553 //
     /* 30639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_h),
     /* 30647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30675 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7536:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_H),
     /* 30678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30680 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30682 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30684 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30686 */     GIR_RootConstrainSelectedInstOperands,
     /* 30687 */     // GIR_Coverage, 553,
     /* 30687 */     GIR_EraseRootFromParent_Done,
     /* 30688 */   // Label 876: @30688
     /* 30688 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(30742), // Rule ID 554 //
     /* 30693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_w),
     /* 30701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30729 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7537:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_W),
     /* 30732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30734 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30736 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30738 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30740 */     GIR_RootConstrainSelectedInstOperands,
     /* 30741 */     // GIR_Coverage, 554,
     /* 30741 */     GIR_EraseRootFromParent_Done,
     /* 30742 */   // Label 877: @30742
     /* 30742 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(30796), // Rule ID 555 //
     /* 30747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_d),
     /* 30755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30783 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7535:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 30783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_D),
     /* 30786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30788 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30790 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30792 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30794 */     GIR_RootConstrainSelectedInstOperands,
     /* 30795 */     // GIR_Coverage, 555,
     /* 30795 */     GIR_EraseRootFromParent_Done,
     /* 30796 */   // Label 878: @30796
     /* 30796 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(30850), // Rule ID 560 //
     /* 30801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_b),
     /* 30809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30837 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7542:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_B),
     /* 30840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30842 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30844 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30846 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30848 */     GIR_RootConstrainSelectedInstOperands,
     /* 30849 */     // GIR_Coverage, 560,
     /* 30849 */     GIR_EraseRootFromParent_Done,
     /* 30850 */   // Label 879: @30850
     /* 30850 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(30904), // Rule ID 561 //
     /* 30855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_h),
     /* 30863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30891 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7544:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_H),
     /* 30894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30896 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30898 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30900 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30902 */     GIR_RootConstrainSelectedInstOperands,
     /* 30903 */     // GIR_Coverage, 561,
     /* 30903 */     GIR_EraseRootFromParent_Done,
     /* 30904 */   // Label 880: @30904
     /* 30904 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(30958), // Rule ID 562 //
     /* 30909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_w),
     /* 30917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7545:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_W),
     /* 30948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30950 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30952 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30954 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30956 */     GIR_RootConstrainSelectedInstOperands,
     /* 30957 */     // GIR_Coverage, 562,
     /* 30957 */     GIR_EraseRootFromParent_Done,
     /* 30958 */   // Label 881: @30958
     /* 30958 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(31012), // Rule ID 563 //
     /* 30963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_d),
     /* 30971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30999 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7543:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 30999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_D),
     /* 31002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31004 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31006 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31008 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31010 */     GIR_RootConstrainSelectedInstOperands,
     /* 31011 */     // GIR_Coverage, 563,
     /* 31011 */     GIR_EraseRootFromParent_Done,
     /* 31012 */   // Label 882: @31012
     /* 31012 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(31066), // Rule ID 658 //
     /* 31017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_h),
     /* 31025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31053 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7663:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_H),
     /* 31056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31058 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31060 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31062 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31064 */     GIR_RootConstrainSelectedInstOperands,
     /* 31065 */     // GIR_Coverage, 658,
     /* 31065 */     GIR_EraseRootFromParent_Done,
     /* 31066 */   // Label 883: @31066
     /* 31066 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(31120), // Rule ID 659 //
     /* 31071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_w),
     /* 31079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31107 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7664:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_W),
     /* 31110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31112 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31114 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31116 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31118 */     GIR_RootConstrainSelectedInstOperands,
     /* 31119 */     // GIR_Coverage, 659,
     /* 31119 */     GIR_EraseRootFromParent_Done,
     /* 31120 */   // Label 884: @31120
     /* 31120 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(31174), // Rule ID 660 //
     /* 31125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_d),
     /* 31133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31161 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7662:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_D),
     /* 31164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31166 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31168 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31170 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31172 */     GIR_RootConstrainSelectedInstOperands,
     /* 31173 */     // GIR_Coverage, 660,
     /* 31173 */     GIR_EraseRootFromParent_Done,
     /* 31174 */   // Label 885: @31174
     /* 31174 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(31228), // Rule ID 661 //
     /* 31179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_h),
     /* 31187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31215 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7666:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_H),
     /* 31218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31220 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31222 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31224 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31226 */     GIR_RootConstrainSelectedInstOperands,
     /* 31227 */     // GIR_Coverage, 661,
     /* 31227 */     GIR_EraseRootFromParent_Done,
     /* 31228 */   // Label 886: @31228
     /* 31228 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(31282), // Rule ID 662 //
     /* 31233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_w),
     /* 31241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31269 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7667:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_W),
     /* 31272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31274 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31276 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31278 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31280 */     GIR_RootConstrainSelectedInstOperands,
     /* 31281 */     // GIR_Coverage, 662,
     /* 31281 */     GIR_EraseRootFromParent_Done,
     /* 31282 */   // Label 887: @31282
     /* 31282 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(31336), // Rule ID 663 //
     /* 31287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_d),
     /* 31295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31323 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7665:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_D),
     /* 31326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31328 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31330 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31332 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31334 */     GIR_RootConstrainSelectedInstOperands,
     /* 31335 */     // GIR_Coverage, 663,
     /* 31335 */     GIR_EraseRootFromParent_Done,
     /* 31336 */   // Label 888: @31336
     /* 31336 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(31390), // Rule ID 664 //
     /* 31341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_h),
     /* 31349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31377 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7683:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_H),
     /* 31380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31382 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31384 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31386 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31388 */     GIR_RootConstrainSelectedInstOperands,
     /* 31389 */     // GIR_Coverage, 664,
     /* 31389 */     GIR_EraseRootFromParent_Done,
     /* 31390 */   // Label 889: @31390
     /* 31390 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(31444), // Rule ID 665 //
     /* 31395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_w),
     /* 31403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31431 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7684:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_W),
     /* 31434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31436 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31438 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31440 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31442 */     GIR_RootConstrainSelectedInstOperands,
     /* 31443 */     // GIR_Coverage, 665,
     /* 31443 */     GIR_EraseRootFromParent_Done,
     /* 31444 */   // Label 890: @31444
     /* 31444 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(31498), // Rule ID 666 //
     /* 31449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_d),
     /* 31457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31485 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7682:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_D),
     /* 31488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31490 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31492 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31494 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31496 */     GIR_RootConstrainSelectedInstOperands,
     /* 31497 */     // GIR_Coverage, 666,
     /* 31497 */     GIR_EraseRootFromParent_Done,
     /* 31498 */   // Label 891: @31498
     /* 31498 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(31552), // Rule ID 667 //
     /* 31503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_h),
     /* 31511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31539 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7686:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_H),
     /* 31542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31544 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31546 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31548 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31550 */     GIR_RootConstrainSelectedInstOperands,
     /* 31551 */     // GIR_Coverage, 667,
     /* 31551 */     GIR_EraseRootFromParent_Done,
     /* 31552 */   // Label 892: @31552
     /* 31552 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(31606), // Rule ID 668 //
     /* 31557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_w),
     /* 31565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31593 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7687:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_W),
     /* 31596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31598 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31600 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31602 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31604 */     GIR_RootConstrainSelectedInstOperands,
     /* 31605 */     // GIR_Coverage, 668,
     /* 31605 */     GIR_EraseRootFromParent_Done,
     /* 31606 */   // Label 893: @31606
     /* 31606 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(31660), // Rule ID 669 //
     /* 31611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_d),
     /* 31619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31647 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7685:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_D),
     /* 31650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31652 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31654 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31656 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31658 */     GIR_RootConstrainSelectedInstOperands,
     /* 31659 */     // GIR_Coverage, 669,
     /* 31659 */     GIR_EraseRootFromParent_Done,
     /* 31660 */   // Label 894: @31660
     /* 31660 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(31714), // Rule ID 836 //
     /* 31665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_h),
     /* 31673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31701 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7853:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADD_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_H),
     /* 31704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31706 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31708 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31710 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31712 */     GIR_RootConstrainSelectedInstOperands,
     /* 31713 */     // GIR_Coverage, 836,
     /* 31713 */     GIR_EraseRootFromParent_Done,
     /* 31714 */   // Label 895: @31714
     /* 31714 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(31768), // Rule ID 837 //
     /* 31719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_w),
     /* 31727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31755 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7854:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADD_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_W),
     /* 31758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31760 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31762 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31764 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31766 */     GIR_RootConstrainSelectedInstOperands,
     /* 31767 */     // GIR_Coverage, 837,
     /* 31767 */     GIR_EraseRootFromParent_Done,
     /* 31768 */   // Label 896: @31768
     /* 31768 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(31822), // Rule ID 838 //
     /* 31773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_h),
     /* 31781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31809 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7855:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADDR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_H),
     /* 31812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31814 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31816 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31818 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31820 */     GIR_RootConstrainSelectedInstOperands,
     /* 31821 */     // GIR_Coverage, 838,
     /* 31821 */     GIR_EraseRootFromParent_Done,
     /* 31822 */   // Label 897: @31822
     /* 31822 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(31876), // Rule ID 839 //
     /* 31827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_w),
     /* 31835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31863 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7856:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADDR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_W),
     /* 31866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31868 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31870 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31872 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31874 */     GIR_RootConstrainSelectedInstOperands,
     /* 31875 */     // GIR_Coverage, 839,
     /* 31875 */     GIR_EraseRootFromParent_Done,
     /* 31876 */   // Label 898: @31876
     /* 31876 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(31930), // Rule ID 892 //
     /* 31881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_h),
     /* 31889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31917 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7917:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUB_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_H),
     /* 31920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31922 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31924 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31926 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31928 */     GIR_RootConstrainSelectedInstOperands,
     /* 31929 */     // GIR_Coverage, 892,
     /* 31929 */     GIR_EraseRootFromParent_Done,
     /* 31930 */   // Label 899: @31930
     /* 31930 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(31984), // Rule ID 893 //
     /* 31935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_w),
     /* 31943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31971 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7918:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUB_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_W),
     /* 31974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31976 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31978 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31980 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31982 */     GIR_RootConstrainSelectedInstOperands,
     /* 31983 */     // GIR_Coverage, 893,
     /* 31983 */     GIR_EraseRootFromParent_Done,
     /* 31984 */   // Label 900: @31984
     /* 31984 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(32038), // Rule ID 894 //
     /* 31989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_h),
     /* 31997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 32009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32025 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7919:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUBR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 32025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_H),
     /* 32028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32030 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32032 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32034 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32036 */     GIR_RootConstrainSelectedInstOperands,
     /* 32037 */     // GIR_Coverage, 894,
     /* 32037 */     GIR_EraseRootFromParent_Done,
     /* 32038 */   // Label 901: @32038
     /* 32038 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(32092), // Rule ID 895 //
     /* 32043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_w),
     /* 32051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 32063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32079 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7920:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUBR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 32079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_W),
     /* 32082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32084 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32086 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32088 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32090 */     GIR_RootConstrainSelectedInstOperands,
     /* 32091 */     // GIR_Coverage, 895,
     /* 32091 */     GIR_EraseRootFromParent_Done,
     /* 32092 */   // Label 902: @32092
     /* 32092 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(32146), // Rule ID 949 //
     /* 32097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_b),
     /* 32105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 32108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 32111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 32114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32133 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8021:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_B),
     /* 32136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32138 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32140 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32144 */     GIR_RootConstrainSelectedInstOperands,
     /* 32145 */     // GIR_Coverage, 949,
     /* 32145 */     GIR_EraseRootFromParent_Done,
     /* 32146 */   // Label 903: @32146
     /* 32146 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(32200), // Rule ID 950 //
     /* 32151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_h),
     /* 32159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32187 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8023:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_H),
     /* 32190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32192 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32194 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32198 */     GIR_RootConstrainSelectedInstOperands,
     /* 32199 */     // GIR_Coverage, 950,
     /* 32199 */     GIR_EraseRootFromParent_Done,
     /* 32200 */   // Label 904: @32200
     /* 32200 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(32254), // Rule ID 951 //
     /* 32205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_w),
     /* 32213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32241 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8024:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_W),
     /* 32244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32246 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32248 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32252 */     GIR_RootConstrainSelectedInstOperands,
     /* 32253 */     // GIR_Coverage, 951,
     /* 32253 */     GIR_EraseRootFromParent_Done,
     /* 32254 */   // Label 905: @32254
     /* 32254 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(32308), // Rule ID 952 //
     /* 32259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_d),
     /* 32267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32295 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8022:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_D),
     /* 32298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32300 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32302 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32306 */     GIR_RootConstrainSelectedInstOperands,
     /* 32307 */     // GIR_Coverage, 952,
     /* 32307 */     GIR_EraseRootFromParent_Done,
     /* 32308 */   // Label 906: @32308
     /* 32308 */   GIM_Reject,
     /* 32309 */ // Label 860: @32309
     /* 32309 */ GIM_Reject,
     /* 32310 */ // Label 30: @32310
     /* 32310 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(32341), // Rule ID 354 //
     /* 32315 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 32318 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bposge32),
     /* 32323 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32330 */   // (intrinsic_w_chain:{ *:[i32] } 7568:{ *:[iPTR] })  =>  (BPOSGE32_PSEUDO:{ *:[i32] })
     /* 32330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BPOSGE32_PSEUDO),
     /* 32333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32339 */   GIR_RootConstrainSelectedInstOperands,
     /* 32340 */   // GIR_Coverage, 354,
     /* 32340 */   GIR_EraseRootFromParent_Done,
     /* 32341 */ // Label 907: @32341
     /* 32341 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(33278),
     /* 32346 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 32349 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(32390), // Rule ID 441 //
     /* 32354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32369 */     // MIs[0] mask
     /* 32369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32377 */     // (intrinsic_w_chain:{ *:[i32] } 7995:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (RDDSP:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP),
     /* 32380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32382 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32388 */     GIR_RootConstrainSelectedInstOperands,
     /* 32389 */     // GIR_Coverage, 441,
     /* 32389 */     GIR_EraseRootFromParent_Done,
     /* 32390 */   // Label 909: @32390
     /* 32390 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(32426), // Rule ID 1287 //
     /* 32395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32410 */     // MIs[0] mask
     /* 32410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32413 */     // (intrinsic_w_chain:{ *:[i32] } 7995:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (RDDSP_MM:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP_MM),
     /* 32416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32418 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32424 */     GIR_RootConstrainSelectedInstOperands,
     /* 32425 */     // GIR_Coverage, 1287,
     /* 32425 */     GIR_EraseRootFromParent_Done,
     /* 32426 */   // Label 910: @32426
     /* 32426 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(32467), // Rule ID 442 //
     /* 32431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_NotInMicroMips),
     /* 32434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32439 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32446 */     // MIs[0] mask
     /* 32446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32454 */     // (intrinsic_void 8124:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (WRDSP GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$mask)
     /* 32454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP),
     /* 32457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32459 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32465 */     GIR_RootConstrainSelectedInstOperands,
     /* 32466 */     // GIR_Coverage, 442,
     /* 32466 */     GIR_EraseRootFromParent_Done,
     /* 32467 */   // Label 911: @32467
     /* 32467 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(32503), // Rule ID 1298 //
     /* 32472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32480 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32487 */     // MIs[0] mask
     /* 32487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32490 */     // (intrinsic_void 8124:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (WRDSP_MM GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] }):$mask)
     /* 32490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP_MM),
     /* 32493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 32495 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32501 */     GIR_RootConstrainSelectedInstOperands,
     /* 32502 */     // GIR_Coverage, 1298,
     /* 32502 */     GIR_EraseRootFromParent_Done,
     /* 32503 */   // Label 912: @32503
     /* 32503 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(32546), // Rule ID 363 //
     /* 32508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32530 */     // (intrinsic_w_chain:{ *:[v2i16] } 7456:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ABSQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH),
     /* 32533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32544 */     GIR_RootConstrainSelectedInstOperands,
     /* 32545 */     // GIR_Coverage, 363,
     /* 32545 */     GIR_EraseRootFromParent_Done,
     /* 32546 */   // Label 913: @32546
     /* 32546 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(32589), // Rule ID 364 //
     /* 32551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32573 */     // (intrinsic_w_chain:{ *:[i32] } 7458:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ABSQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 32573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W),
     /* 32576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32587 */     GIR_RootConstrainSelectedInstOperands,
     /* 32588 */     // GIR_Coverage, 364,
     /* 32588 */     GIR_EraseRootFromParent_Done,
     /* 32589 */   // Label 914: @32589
     /* 32589 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(32632), // Rule ID 450 //
     /* 32594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 32597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32616 */     // (intrinsic_w_chain:{ *:[v4i8] } 7457:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ABSQ_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB),
     /* 32619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32630 */     GIR_RootConstrainSelectedInstOperands,
     /* 32631 */     // GIR_Coverage, 450,
     /* 32631 */     GIR_EraseRootFromParent_Done,
     /* 32632 */   // Label 915: @32632
     /* 32632 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(32675), // Rule ID 1230 //
     /* 32637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32659 */     // (intrinsic_w_chain:{ *:[v2i16] } 7456:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (ABSQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 32659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH_MM),
     /* 32662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32673 */     GIR_RootConstrainSelectedInstOperands,
     /* 32674 */     // GIR_Coverage, 1230,
     /* 32674 */     GIR_EraseRootFromParent_Done,
     /* 32675 */   // Label 916: @32675
     /* 32675 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(32718), // Rule ID 1231 //
     /* 32680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32702 */     // (intrinsic_w_chain:{ *:[i32] } 7458:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ABSQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 32702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W_MM),
     /* 32705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32716 */     GIR_RootConstrainSelectedInstOperands,
     /* 32717 */     // GIR_Coverage, 1231,
     /* 32717 */     GIR_EraseRootFromParent_Done,
     /* 32718 */   // Label 917: @32718
     /* 32718 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(32761), // Rule ID 1311 //
     /* 32723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 32726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32745 */     // (intrinsic_w_chain:{ *:[v4i8] } 7457:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (ABSQ_S_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 32745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB_MMR2),
     /* 32748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32759 */     GIR_RootConstrainSelectedInstOperands,
     /* 32760 */     // GIR_Coverage, 1311,
     /* 32760 */     GIR_EraseRootFromParent_Done,
     /* 32761 */   // Label 918: @32761
     /* 32761 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(32804), // Rule ID 417 //
     /* 32766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 32774 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32788 */     // (intrinsic_void 7634:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB),
     /* 32791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32802 */     GIR_RootConstrainSelectedInstOperands,
     /* 32803 */     // GIR_Coverage, 417,
     /* 32803 */     GIR_EraseRootFromParent_Done,
     /* 32804 */   // Label 919: @32804
     /* 32804 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(32847), // Rule ID 418 //
     /* 32809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 32817 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32831 */     // (intrinsic_void 7636:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB),
     /* 32834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32845 */     GIR_RootConstrainSelectedInstOperands,
     /* 32846 */     // GIR_Coverage, 418,
     /* 32846 */     GIR_EraseRootFromParent_Done,
     /* 32847 */   // Label 920: @32847
     /* 32847 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(32890), // Rule ID 419 //
     /* 32852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 32860 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32874 */     // (intrinsic_void 7635:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB),
     /* 32877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32888 */     GIR_RootConstrainSelectedInstOperands,
     /* 32889 */     // GIR_Coverage, 419,
     /* 32889 */     GIR_EraseRootFromParent_Done,
     /* 32890 */   // Label 921: @32890
     /* 32890 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(32933), // Rule ID 423 //
     /* 32895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 32903 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32917 */     // (intrinsic_void 7625:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH),
     /* 32920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32931 */     GIR_RootConstrainSelectedInstOperands,
     /* 32932 */     // GIR_Coverage, 423,
     /* 32932 */     GIR_EraseRootFromParent_Done,
     /* 32933 */   // Label 922: @32933
     /* 32933 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(32976), // Rule ID 424 //
     /* 32938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 32946 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32960 */     // (intrinsic_void 7627:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH),
     /* 32963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32974 */     GIR_RootConstrainSelectedInstOperands,
     /* 32975 */     // GIR_Coverage, 424,
     /* 32975 */     GIR_EraseRootFromParent_Done,
     /* 32976 */   // Label 923: @32976
     /* 32976 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(33019), // Rule ID 425 //
     /* 32981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 32989 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33003 */     // (intrinsic_void 7626:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH),
     /* 33006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33017 */     GIR_RootConstrainSelectedInstOperands,
     /* 33018 */     // GIR_Coverage, 425,
     /* 33018 */     GIR_EraseRootFromParent_Done,
     /* 33019 */   // Label 924: @33019
     /* 33019 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(33062), // Rule ID 1302 //
     /* 33024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 33032 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33046 */     // (intrinsic_void 7625:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH_MM),
     /* 33049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33060 */     GIR_RootConstrainSelectedInstOperands,
     /* 33061 */     // GIR_Coverage, 1302,
     /* 33061 */     GIR_EraseRootFromParent_Done,
     /* 33062 */   // Label 925: @33062
     /* 33062 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(33105), // Rule ID 1303 //
     /* 33067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 33075 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33089 */     // (intrinsic_void 7627:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH_MM),
     /* 33092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33103 */     GIR_RootConstrainSelectedInstOperands,
     /* 33104 */     // GIR_Coverage, 1303,
     /* 33104 */     GIR_EraseRootFromParent_Done,
     /* 33105 */   // Label 926: @33105
     /* 33105 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(33148), // Rule ID 1304 //
     /* 33110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 33118 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33132 */     // (intrinsic_void 7626:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH_MM),
     /* 33135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33146 */     GIR_RootConstrainSelectedInstOperands,
     /* 33147 */     // GIR_Coverage, 1304,
     /* 33147 */     GIR_EraseRootFromParent_Done,
     /* 33148 */   // Label 927: @33148
     /* 33148 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(33191), // Rule ID 1308 //
     /* 33153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 33161 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33175 */     // (intrinsic_void 7634:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB_MM),
     /* 33178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33189 */     GIR_RootConstrainSelectedInstOperands,
     /* 33190 */     // GIR_Coverage, 1308,
     /* 33190 */     GIR_EraseRootFromParent_Done,
     /* 33191 */   // Label 928: @33191
     /* 33191 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(33234), // Rule ID 1309 //
     /* 33196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 33204 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33218 */     // (intrinsic_void 7636:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB_MM),
     /* 33221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33232 */     GIR_RootConstrainSelectedInstOperands,
     /* 33233 */     // GIR_Coverage, 1309,
     /* 33233 */     GIR_EraseRootFromParent_Done,
     /* 33234 */   // Label 929: @33234
     /* 33234 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(33277), // Rule ID 1310 //
     /* 33239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 33247 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33261 */     // (intrinsic_void 7635:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB_MM),
     /* 33264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33275 */     GIR_RootConstrainSelectedInstOperands,
     /* 33276 */     // GIR_Coverage, 1310,
     /* 33276 */     GIR_EraseRootFromParent_Done,
     /* 33277 */   // Label 930: @33277
     /* 33277 */   GIM_Reject,
     /* 33278 */ // Label 908: @33278
     /* 33278 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37403),
     /* 33283 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 33286 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(33350), // Rule ID 382 //
     /* 33291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33328 */     // MIs[1] Operand 1
     /* 33328 */     // No operand predicates
     /* 33328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33330 */     // (intrinsic_w_chain:{ *:[v2i16] } 8012:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHLL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH),
     /* 33333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33348 */     GIR_RootConstrainSelectedInstOperands,
     /* 33349 */     // GIR_Coverage, 382,
     /* 33349 */     GIR_EraseRootFromParent_Done,
     /* 33350 */   // Label 932: @33350
     /* 33350 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(33414), // Rule ID 387 //
     /* 33355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33392 */     // MIs[1] Operand 1
     /* 33392 */     // No operand predicates
     /* 33392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33394 */     // (intrinsic_w_chain:{ *:[i32] } 8013:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHLL_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W),
     /* 33397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33412 */     GIR_RootConstrainSelectedInstOperands,
     /* 33413 */     // GIR_Coverage, 387,
     /* 33413 */     GIR_EraseRootFromParent_Done,
     /* 33414 */   // Label 933: @33414
     /* 33414 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(33478), // Rule ID 1239 //
     /* 33419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33456 */     // MIs[1] Operand 1
     /* 33456 */     // No operand predicates
     /* 33456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33458 */     // (intrinsic_w_chain:{ *:[v2i16] } 8012:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHLL_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH_MM),
     /* 33461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33476 */     GIR_RootConstrainSelectedInstOperands,
     /* 33477 */     // GIR_Coverage, 1239,
     /* 33477 */     GIR_EraseRootFromParent_Done,
     /* 33478 */   // Label 934: @33478
     /* 33478 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(33542), // Rule ID 1244 //
     /* 33483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33520 */     // MIs[1] Operand 1
     /* 33520 */     // No operand predicates
     /* 33520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33522 */     // (intrinsic_w_chain:{ *:[i32] } 8013:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHLL_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W_MM),
     /* 33525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33540 */     GIR_RootConstrainSelectedInstOperands,
     /* 33541 */     // GIR_Coverage, 1244,
     /* 33541 */     GIR_EraseRootFromParent_Done,
     /* 33542 */   // Label 935: @33542
     /* 33542 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(33597), // Rule ID 1933 //
     /* 33547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33580 */     // MIs[1] Operand 1
     /* 33580 */     // No operand predicates
     /* 33580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33582 */     // (intrinsic_w_chain:{ *:[v2i16] } 8010:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHLL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 33582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_PH),
     /* 33585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33587 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33595 */     GIR_RootConstrainSelectedInstOperands,
     /* 33596 */     // GIR_Coverage, 1933,
     /* 33596 */     GIR_EraseRootFromParent_Done,
     /* 33597 */   // Label 936: @33597
     /* 33597 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(33652), // Rule ID 1939 //
     /* 33602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 33635 */     // MIs[1] Operand 1
     /* 33635 */     // No operand predicates
     /* 33635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33637 */     // (intrinsic_w_chain:{ *:[v4i8] } 8011:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHLL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 33637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_QB),
     /* 33640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33642 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33650 */     GIR_RootConstrainSelectedInstOperands,
     /* 33651 */     // GIR_Coverage, 1939,
     /* 33651 */     GIR_EraseRootFromParent_Done,
     /* 33652 */   // Label 937: @33652
     /* 33652 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(33704), // Rule ID 359 //
     /* 33657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 33665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33686 */     // (intrinsic_w_chain:{ *:[i32] } 7465:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W),
     /* 33689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33702 */     GIR_RootConstrainSelectedInstOperands,
     /* 33703 */     // GIR_Coverage, 359,
     /* 33703 */     GIR_EraseRootFromParent_Done,
     /* 33704 */   // Label 938: @33704
     /* 33704 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(33756), // Rule ID 360 //
     /* 33709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 33717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33738 */     // (intrinsic_w_chain:{ *:[i32] } 8085:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W),
     /* 33741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33754 */     GIR_RootConstrainSelectedInstOperands,
     /* 33755 */     // GIR_Coverage, 360,
     /* 33755 */     GIR_EraseRootFromParent_Done,
     /* 33756 */   // Label 939: @33756
     /* 33756 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(33808), // Rule ID 367 //
     /* 33761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 33769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33790 */     // (intrinsic_w_chain:{ *:[v2i16] } 7991:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W),
     /* 33793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33806 */     GIR_RootConstrainSelectedInstOperands,
     /* 33807 */     // GIR_Coverage, 367,
     /* 33807 */     GIR_EraseRootFromParent_Done,
     /* 33808 */   // Label 940: @33808
     /* 33808 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(33860), // Rule ID 368 //
     /* 33813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 33821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 33830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33842 */     // (intrinsic_w_chain:{ *:[v4i8] } 7992:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH),
     /* 33845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33858 */     GIR_RootConstrainSelectedInstOperands,
     /* 33859 */     // GIR_Coverage, 368,
     /* 33859 */     GIR_EraseRootFromParent_Done,
     /* 33860 */   // Label 941: @33860
     /* 33860 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(33912), // Rule ID 379 //
     /* 33865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33894 */     // (intrinsic_w_chain:{ *:[v4i8] } 8011:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB),
     /* 33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33910 */     GIR_RootConstrainSelectedInstOperands,
     /* 33911 */     // GIR_Coverage, 379,
     /* 33911 */     GIR_EraseRootFromParent_Done,
     /* 33912 */   // Label 942: @33912
     /* 33912 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(33964), // Rule ID 381 //
     /* 33917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33946 */     // (intrinsic_w_chain:{ *:[v2i16] } 8010:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH),
     /* 33949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33962 */     GIR_RootConstrainSelectedInstOperands,
     /* 33963 */     // GIR_Coverage, 381,
     /* 33963 */     GIR_EraseRootFromParent_Done,
     /* 33964 */   // Label 943: @33964
     /* 33964 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(34016), // Rule ID 383 //
     /* 33969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33998 */     // (intrinsic_w_chain:{ *:[v2i16] } 8012:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH),
     /* 34001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34014 */     GIR_RootConstrainSelectedInstOperands,
     /* 34015 */     // GIR_Coverage, 383,
     /* 34015 */     GIR_EraseRootFromParent_Done,
     /* 34016 */   // Label 944: @34016
     /* 34016 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(34068), // Rule ID 388 //
     /* 34021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 34029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34050 */     // (intrinsic_w_chain:{ *:[i32] } 8013:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W),
     /* 34053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34066 */     GIR_RootConstrainSelectedInstOperands,
     /* 34067 */     // GIR_Coverage, 388,
     /* 34067 */     GIR_EraseRootFromParent_Done,
     /* 34068 */   // Label 945: @34068
     /* 34068 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(34120), // Rule ID 391 //
     /* 34073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 34081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34102 */     // (intrinsic_w_chain:{ *:[v2i16] } 7933:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL),
     /* 34105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34118 */     GIR_RootConstrainSelectedInstOperands,
     /* 34119 */     // GIR_Coverage, 391,
     /* 34119 */     GIR_EraseRootFromParent_Done,
     /* 34120 */   // Label 946: @34120
     /* 34120 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(34172), // Rule ID 392 //
     /* 34125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 34133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34154 */     // (intrinsic_w_chain:{ *:[v2i16] } 7934:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR),
     /* 34157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34170 */     GIR_RootConstrainSelectedInstOperands,
     /* 34171 */     // GIR_Coverage, 392,
     /* 34171 */     GIR_EraseRootFromParent_Done,
     /* 34172 */   // Label 947: @34172
     /* 34172 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(34224), // Rule ID 393 //
     /* 34177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 34185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34206 */     // (intrinsic_w_chain:{ *:[i32] } 7931:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL),
     /* 34209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34222 */     GIR_RootConstrainSelectedInstOperands,
     /* 34223 */     // GIR_Coverage, 393,
     /* 34223 */     GIR_EraseRootFromParent_Done,
     /* 34224 */   // Label 948: @34224
     /* 34224 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(34276), // Rule ID 394 //
     /* 34229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 34237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34258 */     // (intrinsic_w_chain:{ *:[i32] } 7932:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR),
     /* 34261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34274 */     GIR_RootConstrainSelectedInstOperands,
     /* 34275 */     // GIR_Coverage, 394,
     /* 34275 */     GIR_EraseRootFromParent_Done,
     /* 34276 */   // Label 949: @34276
     /* 34276 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(34328), // Rule ID 395 //
     /* 34281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 34289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34310 */     // (intrinsic_w_chain:{ *:[v2i16] } 7935:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH),
     /* 34313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34326 */     GIR_RootConstrainSelectedInstOperands,
     /* 34327 */     // GIR_Coverage, 395,
     /* 34327 */     GIR_EraseRootFromParent_Done,
     /* 34328 */   // Label 950: @34328
     /* 34328 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(34377), // Rule ID 420 //
     /* 34333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 34341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34362 */     // (intrinsic_w_chain:{ *:[i32] } 7631:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB),
     /* 34365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34375 */     GIR_RootConstrainSelectedInstOperands,
     /* 34376 */     // GIR_Coverage, 420,
     /* 34376 */     GIR_EraseRootFromParent_Done,
     /* 34377 */   // Label 951: @34377
     /* 34377 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(34426), // Rule ID 421 //
     /* 34382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 34390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34411 */     // (intrinsic_w_chain:{ *:[i32] } 7633:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB),
     /* 34414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34424 */     GIR_RootConstrainSelectedInstOperands,
     /* 34425 */     // GIR_Coverage, 421,
     /* 34425 */     GIR_EraseRootFromParent_Done,
     /* 34426 */   // Label 952: @34426
     /* 34426 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(34475), // Rule ID 422 //
     /* 34431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 34439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34460 */     // (intrinsic_w_chain:{ *:[i32] } 7632:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB),
     /* 34463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34473 */     GIR_RootConstrainSelectedInstOperands,
     /* 34474 */     // GIR_Coverage, 422,
     /* 34474 */     GIR_EraseRootFromParent_Done,
     /* 34475 */   // Label 953: @34475
     /* 34475 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(34524), // Rule ID 432 //
     /* 34480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 34488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 34491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34509 */     // (intrinsic_w_chain:{ *:[v4i8] } 7975:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB),
     /* 34512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34522 */     GIR_RootConstrainSelectedInstOperands,
     /* 34523 */     // GIR_Coverage, 432,
     /* 34523 */     GIR_EraseRootFromParent_Done,
     /* 34524 */   // Label 954: @34524
     /* 34524 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(34573), // Rule ID 433 //
     /* 34529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 34537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34558 */     // (intrinsic_w_chain:{ *:[v2i16] } 7974:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH),
     /* 34561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34571 */     GIR_RootConstrainSelectedInstOperands,
     /* 34572 */     // GIR_Coverage, 433,
     /* 34572 */     GIR_EraseRootFromParent_Done,
     /* 34573 */   // Label 955: @34573
     /* 34573 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(34622), // Rule ID 437 //
     /* 34578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 34586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34607 */     // (intrinsic_w_chain:{ *:[i32] } 7833:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 34607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV),
     /* 34610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 34612 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 34614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 34616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34620 */     GIR_RootConstrainSelectedInstOperands,
     /* 34621 */     // GIR_Coverage, 437,
     /* 34621 */     GIR_EraseRootFromParent_Done,
     /* 34622 */   // Label 956: @34622
     /* 34622 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(34674), // Rule ID 443 //
     /* 34627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 34635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34656 */     // (intrinsic_w_chain:{ *:[v2i16] } 7483:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH),
     /* 34659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34672 */     GIR_RootConstrainSelectedInstOperands,
     /* 34673 */     // GIR_Coverage, 443,
     /* 34673 */     GIR_EraseRootFromParent_Done,
     /* 34674 */   // Label 957: @34674
     /* 34674 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(34726), // Rule ID 444 //
     /* 34679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 34687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34708 */     // (intrinsic_w_chain:{ *:[v2i16] } 7485:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH),
     /* 34711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34724 */     GIR_RootConstrainSelectedInstOperands,
     /* 34725 */     // GIR_Coverage, 444,
     /* 34725 */     GIR_EraseRootFromParent_Done,
     /* 34726 */   // Label 958: @34726
     /* 34726 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(34778), // Rule ID 445 //
     /* 34731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 34739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34760 */     // (intrinsic_w_chain:{ *:[v2i16] } 8106:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH),
     /* 34763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34776 */     GIR_RootConstrainSelectedInstOperands,
     /* 34777 */     // GIR_Coverage, 445,
     /* 34777 */     GIR_EraseRootFromParent_Done,
     /* 34778 */   // Label 959: @34778
     /* 34778 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(34830), // Rule ID 446 //
     /* 34783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 34791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34812 */     // (intrinsic_w_chain:{ *:[v2i16] } 8108:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH),
     /* 34815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34828 */     GIR_RootConstrainSelectedInstOperands,
     /* 34829 */     // GIR_Coverage, 446,
     /* 34829 */     GIR_EraseRootFromParent_Done,
     /* 34830 */   // Label 960: @34830
     /* 34830 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(34882), // Rule ID 447 //
     /* 34835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 34843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34864 */     // (intrinsic_w_chain:{ *:[i32] } 7628:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB),
     /* 34867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34880 */     GIR_RootConstrainSelectedInstOperands,
     /* 34881 */     // GIR_Coverage, 447,
     /* 34881 */     GIR_EraseRootFromParent_Done,
     /* 34882 */   // Label 961: @34882
     /* 34882 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(34934), // Rule ID 448 //
     /* 34887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 34895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34916 */     // (intrinsic_w_chain:{ *:[i32] } 7630:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB),
     /* 34919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34932 */     GIR_RootConstrainSelectedInstOperands,
     /* 34933 */     // GIR_Coverage, 448,
     /* 34933 */     GIR_EraseRootFromParent_Done,
     /* 34934 */   // Label 962: @34934
     /* 34934 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(34986), // Rule ID 449 //
     /* 34939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 34947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34968 */     // (intrinsic_w_chain:{ *:[i32] } 7629:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB),
     /* 34971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34984 */     GIR_RootConstrainSelectedInstOperands,
     /* 34985 */     // GIR_Coverage, 449,
     /* 34985 */     GIR_EraseRootFromParent_Done,
     /* 34986 */   // Label 963: @34986
     /* 34986 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(35038), // Rule ID 463 //
     /* 34991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 34999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35020 */     // (intrinsic_w_chain:{ *:[v2i16] } 7930:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH),
     /* 35023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35036 */     GIR_RootConstrainSelectedInstOperands,
     /* 35037 */     // GIR_Coverage, 463,
     /* 35037 */     GIR_EraseRootFromParent_Done,
     /* 35038 */   // Label 964: @35038
     /* 35038 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(35090), // Rule ID 464 //
     /* 35043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 35051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35072 */     // (intrinsic_w_chain:{ *:[i32] } 7938:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W),
     /* 35075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35088 */     GIR_RootConstrainSelectedInstOperands,
     /* 35089 */     // GIR_Coverage, 464,
     /* 35089 */     GIR_EraseRootFromParent_Done,
     /* 35090 */   // Label 965: @35090
     /* 35090 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(35142), // Rule ID 465 //
     /* 35095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 35103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35124 */     // (intrinsic_w_chain:{ *:[i32] } 7936:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W),
     /* 35127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35140 */     GIR_RootConstrainSelectedInstOperands,
     /* 35141 */     // GIR_Coverage, 465,
     /* 35141 */     GIR_EraseRootFromParent_Done,
     /* 35142 */   // Label 966: @35142
     /* 35142 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(35194), // Rule ID 466 //
     /* 35147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 35155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35176 */     // (intrinsic_w_chain:{ *:[v2i16] } 7937:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH),
     /* 35179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35192 */     GIR_RootConstrainSelectedInstOperands,
     /* 35193 */     // GIR_Coverage, 466,
     /* 35193 */     GIR_EraseRootFromParent_Done,
     /* 35194 */   // Label 967: @35194
     /* 35194 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(35243), // Rule ID 476 //
     /* 35199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 35207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35228 */     // (intrinsic_w_chain:{ *:[v4i8] } 7986:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH),
     /* 35231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35241 */     GIR_RootConstrainSelectedInstOperands,
     /* 35242 */     // GIR_Coverage, 476,
     /* 35242 */     GIR_EraseRootFromParent_Done,
     /* 35243 */   // Label 968: @35243
     /* 35243 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(35295), // Rule ID 1224 //
     /* 35248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 35256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35277 */     // (intrinsic_w_chain:{ *:[i32] } 7465:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W_MM),
     /* 35280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35293 */     GIR_RootConstrainSelectedInstOperands,
     /* 35294 */     // GIR_Coverage, 1224,
     /* 35294 */     GIR_EraseRootFromParent_Done,
     /* 35295 */   // Label 969: @35295
     /* 35295 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(35344), // Rule ID 1232 //
     /* 35300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 35308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35329 */     // (intrinsic_w_chain:{ *:[i32] } 7833:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV_MM),
     /* 35332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 35334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35342 */     GIR_RootConstrainSelectedInstOperands,
     /* 35343 */     // GIR_Coverage, 1232,
     /* 35343 */     GIR_EraseRootFromParent_Done,
     /* 35344 */   // Label 970: @35344
     /* 35344 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(35396), // Rule ID 1240 //
     /* 35349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 35357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35378 */     // (intrinsic_w_chain:{ *:[v2i16] } 8010:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH_MM),
     /* 35381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35394 */     GIR_RootConstrainSelectedInstOperands,
     /* 35395 */     // GIR_Coverage, 1240,
     /* 35395 */     GIR_EraseRootFromParent_Done,
     /* 35396 */   // Label 971: @35396
     /* 35396 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(35448), // Rule ID 1241 //
     /* 35401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 35409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35430 */     // (intrinsic_w_chain:{ *:[v2i16] } 8012:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH_MM),
     /* 35433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35446 */     GIR_RootConstrainSelectedInstOperands,
     /* 35447 */     // GIR_Coverage, 1241,
     /* 35447 */     GIR_EraseRootFromParent_Done,
     /* 35448 */   // Label 972: @35448
     /* 35448 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(35500), // Rule ID 1242 //
     /* 35453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 35461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35482 */     // (intrinsic_w_chain:{ *:[v4i8] } 8011:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB_MM),
     /* 35485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35498 */     GIR_RootConstrainSelectedInstOperands,
     /* 35499 */     // GIR_Coverage, 1242,
     /* 35499 */     GIR_EraseRootFromParent_Done,
     /* 35500 */   // Label 973: @35500
     /* 35500 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(35552), // Rule ID 1243 //
     /* 35505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 35513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35534 */     // (intrinsic_w_chain:{ *:[i32] } 8013:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W_MM),
     /* 35537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35550 */     GIR_RootConstrainSelectedInstOperands,
     /* 35551 */     // GIR_Coverage, 1243,
     /* 35551 */     GIR_EraseRootFromParent_Done,
     /* 35552 */   // Label 974: @35552
     /* 35552 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(35604), // Rule ID 1262 //
     /* 35557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 35565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35586 */     // (intrinsic_w_chain:{ *:[i32] } 8085:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W_MM),
     /* 35589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35602 */     GIR_RootConstrainSelectedInstOperands,
     /* 35603 */     // GIR_Coverage, 1262,
     /* 35603 */     GIR_EraseRootFromParent_Done,
     /* 35604 */   // Label 975: @35604
     /* 35604 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(35656), // Rule ID 1268 //
     /* 35609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 35617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35638 */     // (intrinsic_w_chain:{ *:[i32] } 7931:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL_MM),
     /* 35641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35654 */     GIR_RootConstrainSelectedInstOperands,
     /* 35655 */     // GIR_Coverage, 1268,
     /* 35655 */     GIR_EraseRootFromParent_Done,
     /* 35656 */   // Label 976: @35656
     /* 35656 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(35708), // Rule ID 1269 //
     /* 35661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 35669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35690 */     // (intrinsic_w_chain:{ *:[i32] } 7932:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR_MM),
     /* 35693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35706 */     GIR_RootConstrainSelectedInstOperands,
     /* 35707 */     // GIR_Coverage, 1269,
     /* 35707 */     GIR_EraseRootFromParent_Done,
     /* 35708 */   // Label 977: @35708
     /* 35708 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(35760), // Rule ID 1270 //
     /* 35713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 35721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35742 */     // (intrinsic_w_chain:{ *:[v2i16] } 7933:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL_MM),
     /* 35745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35758 */     GIR_RootConstrainSelectedInstOperands,
     /* 35759 */     // GIR_Coverage, 1270,
     /* 35759 */     GIR_EraseRootFromParent_Done,
     /* 35760 */   // Label 978: @35760
     /* 35760 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(35812), // Rule ID 1271 //
     /* 35765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 35773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35794 */     // (intrinsic_w_chain:{ *:[v2i16] } 7934:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR_MM),
     /* 35797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35810 */     GIR_RootConstrainSelectedInstOperands,
     /* 35811 */     // GIR_Coverage, 1271,
     /* 35811 */     GIR_EraseRootFromParent_Done,
     /* 35812 */   // Label 979: @35812
     /* 35812 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(35864), // Rule ID 1272 //
     /* 35817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 35825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35846 */     // (intrinsic_w_chain:{ *:[v2i16] } 7935:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH_MM),
     /* 35849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35862 */     GIR_RootConstrainSelectedInstOperands,
     /* 35863 */     // GIR_Coverage, 1272,
     /* 35863 */     GIR_EraseRootFromParent_Done,
     /* 35864 */   // Label 980: @35864
     /* 35864 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(35916), // Rule ID 1275 //
     /* 35869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 35877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35898 */     // (intrinsic_w_chain:{ *:[v4i8] } 7992:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH_MM),
     /* 35901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35914 */     GIR_RootConstrainSelectedInstOperands,
     /* 35915 */     // GIR_Coverage, 1275,
     /* 35915 */     GIR_EraseRootFromParent_Done,
     /* 35916 */   // Label 981: @35916
     /* 35916 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(35968), // Rule ID 1276 //
     /* 35921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 35929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35950 */     // (intrinsic_w_chain:{ *:[v2i16] } 7991:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W_MM),
     /* 35953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35966 */     GIR_RootConstrainSelectedInstOperands,
     /* 35967 */     // GIR_Coverage, 1276,
     /* 35967 */     GIR_EraseRootFromParent_Done,
     /* 35968 */   // Label 982: @35968
     /* 35968 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(36017), // Rule ID 1294 //
     /* 35973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 35981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36002 */     // (intrinsic_w_chain:{ *:[v2i16] } 7974:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH_MM),
     /* 36005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36015 */     GIR_RootConstrainSelectedInstOperands,
     /* 36016 */     // GIR_Coverage, 1294,
     /* 36016 */     GIR_EraseRootFromParent_Done,
     /* 36017 */   // Label 983: @36017
     /* 36017 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(36066), // Rule ID 1295 //
     /* 36022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 36030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36051 */     // (intrinsic_w_chain:{ *:[v4i8] } 7975:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB_MM),
     /* 36054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36064 */     GIR_RootConstrainSelectedInstOperands,
     /* 36065 */     // GIR_Coverage, 1295,
     /* 36065 */     GIR_EraseRootFromParent_Done,
     /* 36066 */   // Label 984: @36066
     /* 36066 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(36115), // Rule ID 1305 //
     /* 36071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 36079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36100 */     // (intrinsic_w_chain:{ *:[i32] } 7631:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB_MM),
     /* 36103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36113 */     GIR_RootConstrainSelectedInstOperands,
     /* 36114 */     // GIR_Coverage, 1305,
     /* 36114 */     GIR_EraseRootFromParent_Done,
     /* 36115 */   // Label 985: @36115
     /* 36115 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(36164), // Rule ID 1306 //
     /* 36120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 36128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36149 */     // (intrinsic_w_chain:{ *:[i32] } 7633:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB_MM),
     /* 36152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36162 */     GIR_RootConstrainSelectedInstOperands,
     /* 36163 */     // GIR_Coverage, 1306,
     /* 36163 */     GIR_EraseRootFromParent_Done,
     /* 36164 */   // Label 986: @36164
     /* 36164 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(36213), // Rule ID 1307 //
     /* 36169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 36177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36198 */     // (intrinsic_w_chain:{ *:[i32] } 7632:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB_MM),
     /* 36201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36211 */     GIR_RootConstrainSelectedInstOperands,
     /* 36212 */     // GIR_Coverage, 1307,
     /* 36212 */     GIR_EraseRootFromParent_Done,
     /* 36213 */   // Label 987: @36213
     /* 36213 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(36265), // Rule ID 1316 //
     /* 36218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 36226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36247 */     // (intrinsic_w_chain:{ *:[v2i16] } 7483:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH_MMR2),
     /* 36250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36263 */     GIR_RootConstrainSelectedInstOperands,
     /* 36264 */     // GIR_Coverage, 1316,
     /* 36264 */     GIR_EraseRootFromParent_Done,
     /* 36265 */   // Label 988: @36265
     /* 36265 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(36317), // Rule ID 1317 //
     /* 36270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 36278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36299 */     // (intrinsic_w_chain:{ *:[v2i16] } 7485:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH_MMR2),
     /* 36302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36315 */     GIR_RootConstrainSelectedInstOperands,
     /* 36316 */     // GIR_Coverage, 1317,
     /* 36316 */     GIR_EraseRootFromParent_Done,
     /* 36317 */   // Label 989: @36317
     /* 36317 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(36369), // Rule ID 1328 //
     /* 36322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 36330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36351 */     // (intrinsic_w_chain:{ *:[i32] } 7628:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB_MMR2),
     /* 36354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36367 */     GIR_RootConstrainSelectedInstOperands,
     /* 36368 */     // GIR_Coverage, 1328,
     /* 36368 */     GIR_EraseRootFromParent_Done,
     /* 36369 */   // Label 990: @36369
     /* 36369 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(36421), // Rule ID 1329 //
     /* 36374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 36382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36403 */     // (intrinsic_w_chain:{ *:[i32] } 7630:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB_MMR2),
     /* 36406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36419 */     GIR_RootConstrainSelectedInstOperands,
     /* 36420 */     // GIR_Coverage, 1329,
     /* 36420 */     GIR_EraseRootFromParent_Done,
     /* 36421 */   // Label 991: @36421
     /* 36421 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(36473), // Rule ID 1330 //
     /* 36426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 36434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36455 */     // (intrinsic_w_chain:{ *:[i32] } 7629:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB_MMR2),
     /* 36458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36471 */     GIR_RootConstrainSelectedInstOperands,
     /* 36472 */     // GIR_Coverage, 1330,
     /* 36472 */     GIR_EraseRootFromParent_Done,
     /* 36473 */   // Label 992: @36473
     /* 36473 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(36525), // Rule ID 1336 //
     /* 36478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 36486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36507 */     // (intrinsic_w_chain:{ *:[v2i16] } 8106:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH_MMR2),
     /* 36510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36523 */     GIR_RootConstrainSelectedInstOperands,
     /* 36524 */     // GIR_Coverage, 1336,
     /* 36524 */     GIR_EraseRootFromParent_Done,
     /* 36525 */   // Label 993: @36525
     /* 36525 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(36577), // Rule ID 1337 //
     /* 36530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 36538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36559 */     // (intrinsic_w_chain:{ *:[v2i16] } 8108:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH_MMR2),
     /* 36562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36575 */     GIR_RootConstrainSelectedInstOperands,
     /* 36576 */     // GIR_Coverage, 1337,
     /* 36576 */     GIR_EraseRootFromParent_Done,
     /* 36577 */   // Label 994: @36577
     /* 36577 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(36629), // Rule ID 1344 //
     /* 36582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 36590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36611 */     // (intrinsic_w_chain:{ *:[v2i16] } 7930:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH_MMR2),
     /* 36614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36627 */     GIR_RootConstrainSelectedInstOperands,
     /* 36628 */     // GIR_Coverage, 1344,
     /* 36628 */     GIR_EraseRootFromParent_Done,
     /* 36629 */   // Label 995: @36629
     /* 36629 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(36681), // Rule ID 1345 //
     /* 36634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 36642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36663 */     // (intrinsic_w_chain:{ *:[i32] } 7936:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W_MMR2),
     /* 36666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36679 */     GIR_RootConstrainSelectedInstOperands,
     /* 36680 */     // GIR_Coverage, 1345,
     /* 36680 */     GIR_EraseRootFromParent_Done,
     /* 36681 */   // Label 996: @36681
     /* 36681 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(36733), // Rule ID 1346 //
     /* 36686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 36694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36715 */     // (intrinsic_w_chain:{ *:[v2i16] } 7937:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH_MMR2),
     /* 36718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36731 */     GIR_RootConstrainSelectedInstOperands,
     /* 36732 */     // GIR_Coverage, 1346,
     /* 36732 */     GIR_EraseRootFromParent_Done,
     /* 36733 */   // Label 997: @36733
     /* 36733 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(36785), // Rule ID 1347 //
     /* 36738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 36746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36767 */     // (intrinsic_w_chain:{ *:[i32] } 7938:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W_MMR2),
     /* 36770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36783 */     GIR_RootConstrainSelectedInstOperands,
     /* 36784 */     // GIR_Coverage, 1347,
     /* 36784 */     GIR_EraseRootFromParent_Done,
     /* 36785 */   // Label 998: @36785
     /* 36785 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(36834), // Rule ID 1348 //
     /* 36790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 36798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36819 */     // (intrinsic_w_chain:{ *:[v4i8] } 7986:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH_MMR2),
     /* 36822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36832 */     GIR_RootConstrainSelectedInstOperands,
     /* 36833 */     // GIR_Coverage, 1348,
     /* 36833 */     GIR_EraseRootFromParent_Done,
     /* 36834 */   // Label 999: @36834
     /* 36834 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(36878), // Rule ID 1920 //
     /* 36839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 36842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_ph),
     /* 36847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36860 */     // (intrinsic_w_chain:{ *:[v2i16] } 7927:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 36860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /* 36863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36865 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36867 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36876 */     GIR_RootConstrainSelectedInstOperands,
     /* 36877 */     // GIR_Coverage, 1920,
     /* 36877 */     GIR_EraseRootFromParent_Done,
     /* 36878 */   // Label 1000: @36878
     /* 36878 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(36922), // Rule ID 1926 //
     /* 36883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addsc),
     /* 36891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36904 */     // (intrinsic_w_chain:{ *:[i32] } 7482:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDSC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDSC),
     /* 36907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36909 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36911 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCarry*/0,
     /* 36916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36920 */     GIR_RootConstrainSelectedInstOperands,
     /* 36921 */     // GIR_Coverage, 1926,
     /* 36921 */     GIR_EraseRootFromParent_Done,
     /* 36922 */   // Label 1001: @36922
     /* 36922 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(36966), // Rule ID 1928 //
     /* 36927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addwc),
     /* 36935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36948 */     // (intrinsic_w_chain:{ *:[i32] } 7497:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDWC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDWC),
     /* 36951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36953 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36955 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36964 */     GIR_RootConstrainSelectedInstOperands,
     /* 36965 */     // GIR_Coverage, 1928,
     /* 36965 */     GIR_EraseRootFromParent_Done,
     /* 36966 */   // Label 1002: @36966
     /* 36966 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(37012), // Rule ID 487 //
     /* 36971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 36974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_d),
     /* 36979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 36982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 36989 */     // MIs[0] ptr
     /* 36989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 36993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36997 */     // (intrinsic_w_chain:{ *:[v2i64] } 7847:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_D:{ *:[v2i64] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 36997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_D),
     /* 37000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37002 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37004 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37010 */     GIR_RootConstrainSelectedInstOperands,
     /* 37011 */     // GIR_Coverage, 487,
     /* 37011 */     GIR_EraseRootFromParent_Done,
     /* 37012 */   // Label 1003: @37012
     /* 37012 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(37058), // Rule ID 488 //
     /* 37017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_w),
     /* 37025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 37028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37035 */     // MIs[0] ptr
     /* 37035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37043 */     // (intrinsic_w_chain:{ *:[v4i32] } 7848:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_W:{ *:[v4i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_W),
     /* 37046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37048 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37050 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37056 */     GIR_RootConstrainSelectedInstOperands,
     /* 37057 */     // GIR_Coverage, 488,
     /* 37057 */     GIR_EraseRootFromParent_Done,
     /* 37058 */   // Label 1004: @37058
     /* 37058 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(37100), // Rule ID 434 //
     /* 37063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37081 */     // MIs[0] base
     /* 37081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37085 */     // (intrinsic_w_chain:{ *:[i32] } 7851:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 37088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37090 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37092 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37098 */     GIR_RootConstrainSelectedInstOperands,
     /* 37099 */     // GIR_Coverage, 434,
     /* 37099 */     GIR_EraseRootFromParent_Done,
     /* 37100 */   // Label 1005: @37100
     /* 37100 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(37142), // Rule ID 435 //
     /* 37105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37123 */     // MIs[0] base
     /* 37123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37127 */     // (intrinsic_w_chain:{ *:[i32] } 7849:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 37130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37132 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37134 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37140 */     GIR_RootConstrainSelectedInstOperands,
     /* 37141 */     // GIR_Coverage, 435,
     /* 37141 */     GIR_EraseRootFromParent_Done,
     /* 37142 */   // Label 1006: @37142
     /* 37142 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(37184), // Rule ID 436 //
     /* 37147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37165 */     // MIs[0] base
     /* 37165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37169 */     // (intrinsic_w_chain:{ *:[i32] } 7838:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 37172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37174 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37176 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37182 */     GIR_RootConstrainSelectedInstOperands,
     /* 37183 */     // GIR_Coverage, 436,
     /* 37183 */     GIR_EraseRootFromParent_Done,
     /* 37184 */   // Label 1007: @37184
     /* 37184 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(37226), // Rule ID 1277 //
     /* 37189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37207 */     // MIs[0] base
     /* 37207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37211 */     // (intrinsic_w_chain:{ *:[i32] } 7838:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX_MM),
     /* 37214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37216 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37218 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37224 */     GIR_RootConstrainSelectedInstOperands,
     /* 37225 */     // GIR_Coverage, 1277,
     /* 37225 */     GIR_EraseRootFromParent_Done,
     /* 37226 */   // Label 1008: @37226
     /* 37226 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(37268), // Rule ID 1278 //
     /* 37231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37249 */     // MIs[0] base
     /* 37249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37253 */     // (intrinsic_w_chain:{ *:[i32] } 7849:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX_MM),
     /* 37256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37258 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37260 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37266 */     GIR_RootConstrainSelectedInstOperands,
     /* 37267 */     // GIR_Coverage, 1278,
     /* 37267 */     GIR_EraseRootFromParent_Done,
     /* 37268 */   // Label 1009: @37268
     /* 37268 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(37310), // Rule ID 1279 //
     /* 37273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37291 */     // MIs[0] base
     /* 37291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37295 */     // (intrinsic_w_chain:{ *:[i32] } 7851:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX_MM),
     /* 37298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37300 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37302 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37308 */     GIR_RootConstrainSelectedInstOperands,
     /* 37309 */     // GIR_Coverage, 1279,
     /* 37309 */     GIR_EraseRootFromParent_Done,
     /* 37310 */   // Label 1010: @37310
     /* 37310 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(37356), // Rule ID 489 //
     /* 37315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_d),
     /* 37323 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 37326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 37333 */     // MIs[0] ptr
     /* 37333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37341 */     // (intrinsic_void 8081:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_D MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_D),
     /* 37344 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37346 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37348 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37354 */     GIR_RootConstrainSelectedInstOperands,
     /* 37355 */     // GIR_Coverage, 489,
     /* 37355 */     GIR_EraseRootFromParent_Done,
     /* 37356 */   // Label 1011: @37356
     /* 37356 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(37402), // Rule ID 490 //
     /* 37361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_w),
     /* 37369 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 37372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37379 */     // MIs[0] ptr
     /* 37379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37387 */     // (intrinsic_void 8082:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_W MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_W),
     /* 37390 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37392 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37394 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37400 */     GIR_RootConstrainSelectedInstOperands,
     /* 37401 */     // GIR_Coverage, 490,
     /* 37401 */     GIR_EraseRootFromParent_Done,
     /* 37402 */   // Label 1012: @37402
     /* 37402 */   GIM_Reject,
     /* 37403 */ // Label 931: @37403
     /* 37403 */ GIM_Reject,
     /* 37404 */ // Label 31: @37404
     /* 37404 */ GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(37469), // Rule ID 1580 //
     /* 37409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37412 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37426 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 37426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37448 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37468 */   // GIR_Coverage, 1580,
     /* 37468 */   GIR_EraseRootFromParent_Done,
     /* 37469 */ // Label 1013: @37469
     /* 37469 */ GIM_Reject,
     /* 37470 */ // Label 32: @37470
     /* 37470 */ GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(37533), // Rule ID 1573 //
     /* 37475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37478 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 37484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37492 */   // (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$src)  =>  (SLL:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i32] })
     /* 37492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37504 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 37510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 37515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 37531 */   GIR_RootConstrainSelectedInstOperands,
     /* 37532 */   // GIR_Coverage, 1573,
     /* 37532 */   GIR_EraseRootFromParent_Done,
     /* 37533 */ // Label 1014: @37533
     /* 37533 */ GIM_Reject,
     /* 37534 */ // Label 33: @37534
     /* 37534 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(37594),
     /* 37539 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37542 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(37568), // Rule ID 2151 //
     /* 37547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 37550 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immLi16),
     /* 37554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 37558 */     // MIs[0] Operand 1
     /* 37558 */     // No operand predicates
     /* 37558 */     // (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm  =>  (LI16_MM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm)
     /* 37558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LI16_MM),
     /* 37561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37566 */     GIR_RootConstrainSelectedInstOperands,
     /* 37567 */     // GIR_Coverage, 2151,
     /* 37567 */     GIR_EraseRootFromParent_Done,
     /* 37568 */   // Label 1016: @37568
     /* 37568 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(37593), // Rule ID 1844 //
     /* 37573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 37576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 37580 */     // MIs[0] Operand 1
     /* 37580 */     // No operand predicates
     /* 37580 */     // (imm:{ *:[i32] }):$imm  =>  (LwConstant32:{ *:[i32] } (imm:{ *:[i32] }):$imm, -1:{ *:[i32] })
     /* 37580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LwConstant32),
     /* 37583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 37585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 37591 */     GIR_RootConstrainSelectedInstOperands,
     /* 37592 */     // GIR_Coverage, 1844,
     /* 37592 */     GIR_EraseRootFromParent_Done,
     /* 37593 */   // Label 1017: @37593
     /* 37593 */   GIM_Reject,
     /* 37594 */ // Label 1015: @37594
     /* 37594 */ GIM_Reject,
     /* 37595 */ // Label 34: @37595
     /* 37595 */ GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(39058),
     /* 37600 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37610 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(37715), // Rule ID 1626 //
     /* 37615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 37623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37648 */     // MIs[2] Operand 1
     /* 37648 */     // No operand predicates
     /* 37648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37650 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRA:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 37657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37714 */     // GIR_Coverage, 1626,
     /* 37714 */     GIR_EraseRootFromParent_Done,
     /* 37715 */   // Label 1019: @37715
     /* 37715 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(37820), // Rule ID 1622 //
     /* 37720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 37728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37753 */     // MIs[2] Operand 1
     /* 37753 */     // No operand predicates
     /* 37753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37755 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 37762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37819 */     // GIR_Coverage, 1622,
     /* 37819 */     GIR_EraseRootFromParent_Done,
     /* 37820 */   // Label 1020: @37820
     /* 37820 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(37925), // Rule ID 1618 //
     /* 37825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 37833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37858 */     // MIs[2] Operand 1
     /* 37858 */     // No operand predicates
     /* 37858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37860 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37872 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37924 */     // GIR_Coverage, 1618,
     /* 37924 */     GIR_EraseRootFromParent_Done,
     /* 37925 */   // Label 1021: @37925
     /* 37925 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(38024), // Rule ID 1608 //
     /* 37930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 37938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37958 */     // (sext:{ *:[i64] } (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ADDu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 37958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /* 37965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 37978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38023 */     // GIR_Coverage, 1608,
     /* 38023 */     GIR_EraseRootFromParent_Done,
     /* 38024 */   // Label 1022: @38024
     /* 38024 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(38123), // Rule ID 1628 //
     /* 38029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 38037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38057 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRAV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38057 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38060 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 38064 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38069 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38073 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38122 */     // GIR_Coverage, 1628,
     /* 38122 */     GIR_EraseRootFromParent_Done,
     /* 38123 */   // Label 1023: @38123
     /* 38123 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(38222), // Rule ID 1624 //
     /* 38128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 38136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38156 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 38163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38168 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38172 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38221 */     // GIR_Coverage, 1624,
     /* 38221 */     GIR_EraseRootFromParent_Done,
     /* 38222 */   // Label 1024: @38222
     /* 38222 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(38330), // Rule ID 1612 //
     /* 38227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 38230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38258 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /* 38265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38274 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38278 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::HI0*/0,
     /* 38281 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::LO0*/1,
     /* 38284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38329 */     // GIR_Coverage, 1612,
     /* 38329 */     GIR_EraseRootFromParent_Done,
     /* 38330 */   // Label 1025: @38330
     /* 38330 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(38432), // Rule ID 1811 //
     /* 38335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38366 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL_R6:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /* 38373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38431 */     // GIR_Coverage, 1811,
     /* 38431 */     GIR_EraseRootFromParent_Done,
     /* 38432 */   // Label 1026: @38432
     /* 38432 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(38534), // Rule ID 1812 //
     /* 38437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SDIV),
     /* 38448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38468 */     // (sext:{ *:[i64] } (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38468 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38471 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /* 38475 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38480 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38484 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38533 */     // GIR_Coverage, 1812,
     /* 38533 */     GIR_EraseRootFromParent_Done,
     /* 38534 */   // Label 1027: @38534
     /* 38534 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(38633), // Rule ID 1620 //
     /* 38539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 38547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38567 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 38574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38579 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38632 */     // GIR_Coverage, 1620,
     /* 38632 */     GIR_EraseRootFromParent_Done,
     /* 38633 */   // Label 1028: @38633
     /* 38633 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(38735), // Rule ID 1814 //
     /* 38638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SREM),
     /* 38649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38669 */     // (sext:{ *:[i64] } (srem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MOD:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /* 38676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38685 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38734 */     // GIR_Coverage, 1814,
     /* 38734 */     GIR_EraseRootFromParent_Done,
     /* 38735 */   // Label 1029: @38735
     /* 38735 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(38834), // Rule ID 1610 //
     /* 38740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 38748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38768 */     // (sext:{ *:[i64] } (sub:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SUBu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /* 38775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38784 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38833 */     // GIR_Coverage, 1610,
     /* 38833 */     GIR_EraseRootFromParent_Done,
     /* 38834 */   // Label 1030: @38834
     /* 38834 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(38936), // Rule ID 1813 //
     /* 38839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UDIV),
     /* 38850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38870 */     // (sext:{ *:[i64] } (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIVU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /* 38877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38886 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38935 */     // GIR_Coverage, 1813,
     /* 38935 */     GIR_EraseRootFromParent_Done,
     /* 38936 */   // Label 1031: @38936
     /* 38936 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(39038), // Rule ID 1815 //
     /* 38941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UREM),
     /* 38952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38972 */     // (sext:{ *:[i64] } (urem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MODU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /* 38979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38988 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 39001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 39011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 39019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 39022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39037 */     // GIR_Coverage, 1815,
     /* 39037 */     GIR_EraseRootFromParent_Done,
     /* 39038 */   // Label 1032: @39038
     /* 39038 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(39057), // Rule ID 1583 //
     /* 39043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39050 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 39050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 39055 */     GIR_RootConstrainSelectedInstOperands,
     /* 39056 */     // GIR_Coverage, 1583,
     /* 39056 */     GIR_Done,
     /* 39057 */   // Label 1033: @39057
     /* 39057 */   GIM_Reject,
     /* 39058 */ // Label 1018: @39058
     /* 39058 */ GIM_Reject,
     /* 39059 */ // Label 35: @39059
     /* 39059 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1036*/ GIMT_Encode4(39406),
     /* 39070 */ /*GILLT_s32*//*Label 1034*/ GIMT_Encode4(39078),
     /* 39074 */ /*GILLT_s64*//*Label 1035*/ GIMT_Encode4(39304),
     /* 39078 */ // Label 1034: @39078
     /* 39078 */ GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(39303),
     /* 39083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39086 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(39122), // Rule ID 106 //
     /* 39091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39102 */     // MIs[0] Operand 2
     /* 39102 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39113 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB),
     /* 39116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39120 */     GIR_RootConstrainSelectedInstOperands,
     /* 39121 */     // GIR_Coverage, 106,
     /* 39121 */     GIR_EraseRootFromParent_Done,
     /* 39122 */   // Label 1038: @39122
     /* 39122 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(39158), // Rule ID 107 //
     /* 39127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39138 */     // MIs[0] Operand 2
     /* 39138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39149 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH),
     /* 39152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39156 */     GIR_RootConstrainSelectedInstOperands,
     /* 39157 */     // GIR_Coverage, 107,
     /* 39157 */     GIR_EraseRootFromParent_Done,
     /* 39158 */   // Label 1039: @39158
     /* 39158 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(39194), // Rule ID 1101 //
     /* 39163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39174 */     // MIs[0] Operand 2
     /* 39174 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39185 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB_MM),
     /* 39188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39192 */     GIR_RootConstrainSelectedInstOperands,
     /* 39193 */     // GIR_Coverage, 1101,
     /* 39193 */     GIR_EraseRootFromParent_Done,
     /* 39194 */   // Label 1040: @39194
     /* 39194 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(39230), // Rule ID 1102 //
     /* 39199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39210 */     // MIs[0] Operand 2
     /* 39210 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39221 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH_MM),
     /* 39224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39228 */     GIR_RootConstrainSelectedInstOperands,
     /* 39229 */     // GIR_Coverage, 1102,
     /* 39229 */     GIR_EraseRootFromParent_Done,
     /* 39230 */   // Label 1041: @39230
     /* 39230 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(39266), // Rule ID 1902 //
     /* 39235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39246 */     // MIs[0] Operand 2
     /* 39246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39257 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i8:{ *:[Other] })  =>  (SebRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SebRx16),
     /* 39260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39262 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39264 */     GIR_RootConstrainSelectedInstOperands,
     /* 39265 */     // GIR_Coverage, 1902,
     /* 39265 */     GIR_EraseRootFromParent_Done,
     /* 39266 */   // Label 1042: @39266
     /* 39266 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(39302), // Rule ID 1903 //
     /* 39271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39282 */     // MIs[0] Operand 2
     /* 39282 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39293 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i16:{ *:[Other] })  =>  (SehRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SehRx16),
     /* 39296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39298 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39300 */     GIR_RootConstrainSelectedInstOperands,
     /* 39301 */     // GIR_Coverage, 1903,
     /* 39301 */     GIR_EraseRootFromParent_Done,
     /* 39302 */   // Label 1043: @39302
     /* 39302 */   GIM_Reject,
     /* 39303 */ // Label 1037: @39303
     /* 39303 */ GIM_Reject,
     /* 39304 */ // Label 1035: @39304
     /* 39304 */ GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(39405),
     /* 39309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39320 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(39348), // Rule ID 261 //
     /* 39325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39328 */     // MIs[0] Operand 2
     /* 39328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39339 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i8:{ *:[Other] })  =>  (SEB64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB64),
     /* 39342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39346 */     GIR_RootConstrainSelectedInstOperands,
     /* 39347 */     // GIR_Coverage, 261,
     /* 39347 */     GIR_EraseRootFromParent_Done,
     /* 39348 */   // Label 1045: @39348
     /* 39348 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(39376), // Rule ID 262 //
     /* 39353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39356 */     // MIs[0] Operand 2
     /* 39356 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39367 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i16:{ *:[Other] })  =>  (SEH64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH64),
     /* 39370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39374 */     GIR_RootConstrainSelectedInstOperands,
     /* 39375 */     // GIR_Coverage, 262,
     /* 39375 */     GIR_EraseRootFromParent_Done,
     /* 39376 */   // Label 1046: @39376
     /* 39376 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(39404), // Rule ID 1586 //
     /* 39381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39384 */     // MIs[0] Operand 2
     /* 39384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 39395 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SLL64_64:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 39395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL64_64),
     /* 39398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39402 */     GIR_RootConstrainSelectedInstOperands,
     /* 39403 */     // GIR_Coverage, 1586,
     /* 39403 */     GIR_EraseRootFromParent_Done,
     /* 39404 */   // Label 1047: @39404
     /* 39404 */   GIM_Reject,
     /* 39405 */ // Label 1044: @39405
     /* 39405 */ GIM_Reject,
     /* 39406 */ // Label 1036: @39406
     /* 39406 */ GIM_Reject,
     /* 39407 */ // Label 36: @39407
     /* 39407 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(39607),
     /* 39412 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 39415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39422 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(39478), // Rule ID 280 //
     /* 39427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39442 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39446 */     // MIs[1] Operand 1
     /* 39446 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 39451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39463 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }))  =>  (SEQ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEQ),
     /* 39466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39476 */     GIR_RootConstrainSelectedInstOperands,
     /* 39477 */     // GIR_Coverage, 280,
     /* 39477 */     GIR_EraseRootFromParent_Done,
     /* 39478 */   // Label 1049: @39478
     /* 39478 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(39534), // Rule ID 282 //
     /* 39483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39498 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39502 */     // MIs[1] Operand 1
     /* 39502 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 39507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39519 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }))  =>  (SNE:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SNE),
     /* 39522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39532 */     GIR_RootConstrainSelectedInstOperands,
     /* 39533 */     // GIR_Coverage, 282,
     /* 39533 */     GIR_EraseRootFromParent_Done,
     /* 39534 */   // Label 1050: @39534
     /* 39534 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(39606),
     /* 39539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39543 */     GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(39582), // Rule ID 1581 //
     /* 39548 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39551 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DSRL:{ *:[i64] } (DSLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i32] })
     /* 39551 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39554 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSLL64_32),
     /* 39558 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39563 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 39567 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 39572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39574 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39577 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39580 */       GIR_RootConstrainSelectedInstOperands,
     /* 39581 */       // GIR_Coverage, 1581,
     /* 39581 */       GIR_EraseRootFromParent_Done,
     /* 39582 */     // Label 1052: @39582
     /* 39582 */     GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(39605), // Rule ID 1584 //
     /* 39587 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 39590 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DEXT64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src, 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 39590 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DEXT64_32),
     /* 39593 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 39595 */       GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39597 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 39600 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39603 */       GIR_RootConstrainSelectedInstOperands,
     /* 39604 */       // GIR_Coverage, 1584,
     /* 39604 */       GIR_EraseRootFromParent_Done,
     /* 39605 */     // Label 1053: @39605
     /* 39605 */     GIM_Reject,
     /* 39606 */   // Label 1051: @39606
     /* 39606 */   GIM_Reject,
     /* 39607 */ // Label 1048: @39607
     /* 39607 */ GIM_Reject,
     /* 39608 */ // Label 37: @39608
     /* 39608 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1060*/ GIMT_Encode4(41404),
     /* 39619 */ /*GILLT_s32*//*Label 1054*/ GIMT_Encode4(39651),
     /* 39623 */ /*GILLT_s64*//*Label 1055*/ GIMT_Encode4(39913), GIMT_Encode4(0),
     /* 39631 */ /*GILLT_v2s64*//*Label 1056*/ GIMT_Encode4(40054), GIMT_Encode4(0),
     /* 39639 */ /*GILLT_v4s32*//*Label 1057*/ GIMT_Encode4(40088),
     /* 39643 */ /*GILLT_v8s16*//*Label 1058*/ GIMT_Encode4(40356),
     /* 39647 */ /*GILLT_v16s8*//*Label 1059*/ GIMT_Encode4(40752),
     /* 39651 */ // Label 1054: @39651
     /* 39651 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(39912),
     /* 39656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39662 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(39704), // Rule ID 55 //
     /* 39667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39690 */     // MIs[1] Operand 1
     /* 39690 */     // No operand predicates
     /* 39690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39692 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SLL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 39695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39702 */     GIR_RootConstrainSelectedInstOperands,
     /* 39703 */     // GIR_Coverage, 55,
     /* 39703 */     GIR_EraseRootFromParent_Done,
     /* 39704 */   // Label 1062: @39704
     /* 39704 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(39746), // Rule ID 1826 //
     /* 39709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39732 */     // MIs[1] Operand 1
     /* 39732 */     // No operand predicates
     /* 39732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39734 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SllX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SllX16),
     /* 39737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39739 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 39741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39744 */     GIR_RootConstrainSelectedInstOperands,
     /* 39745 */     // GIR_Coverage, 1826,
     /* 39745 */     GIR_EraseRootFromParent_Done,
     /* 39746 */   // Label 1063: @39746
     /* 39746 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(39788), // Rule ID 2163 //
     /* 39751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 39774 */     // MIs[1] Operand 1
     /* 39774 */     // No operand predicates
     /* 39774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39776 */     // (shl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SLL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 39776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL16_MM),
     /* 39779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39786 */     GIR_RootConstrainSelectedInstOperands,
     /* 39787 */     // GIR_Coverage, 2163,
     /* 39787 */     GIR_EraseRootFromParent_Done,
     /* 39788 */   // Label 1064: @39788
     /* 39788 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(39830), // Rule ID 2164 //
     /* 39793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39816 */     // MIs[1] Operand 1
     /* 39816 */     // No operand predicates
     /* 39816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39818 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SLL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_MM),
     /* 39821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39828 */     GIR_RootConstrainSelectedInstOperands,
     /* 39829 */     // GIR_Coverage, 2164,
     /* 39829 */     GIR_EraseRootFromParent_Done,
     /* 39830 */   // Label 1065: @39830
     /* 39830 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(39857), // Rule ID 61 //
     /* 39835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39850 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SLLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 39850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 39855 */     GIR_RootConstrainSelectedInstOperands,
     /* 39856 */     // GIR_Coverage, 61,
     /* 39856 */     GIR_Done,
     /* 39857 */   // Label 1066: @39857
     /* 39857 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(39884), // Rule ID 1829 //
     /* 39862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39877 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SllvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 39877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SllvRxRy16),
     /* 39882 */     GIR_RootConstrainSelectedInstOperands,
     /* 39883 */     // GIR_Coverage, 1829,
     /* 39883 */     GIR_Done,
     /* 39884 */   // Label 1067: @39884
     /* 39884 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(39911), // Rule ID 2165 //
     /* 39889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39904 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SLLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 39904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV_MM),
     /* 39909 */     GIR_RootConstrainSelectedInstOperands,
     /* 39910 */     // GIR_Coverage, 2165,
     /* 39910 */     GIR_Done,
     /* 39911 */   // Label 1068: @39911
     /* 39911 */   GIM_Reject,
     /* 39912 */ // Label 1061: @39912
     /* 39912 */ GIM_Reject,
     /* 39913 */ // Label 1055: @39913
     /* 39913 */ GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(40053),
     /* 39918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39932 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(39966), // Rule ID 210 //
     /* 39937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 39940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 39952 */     // MIs[1] Operand 1
     /* 39952 */     // No operand predicates
     /* 39952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39954 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSLL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLL),
     /* 39957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39964 */     GIR_RootConstrainSelectedInstOperands,
     /* 39965 */     // GIR_Coverage, 210,
     /* 39965 */     GIR_EraseRootFromParent_Done,
     /* 39966 */   // Label 1070: @39966
     /* 39966 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(40033), // Rule ID 1574 //
     /* 39971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 39982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 39986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39993 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSLLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 39993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 40000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40005 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 40011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 40016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 40021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 40026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 40028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40031 */     GIR_RootConstrainSelectedInstOperands,
     /* 40032 */     // GIR_Coverage, 1574,
     /* 40032 */     GIR_EraseRootFromParent_Done,
     /* 40033 */   // Label 1071: @40033
     /* 40033 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(40052), // Rule ID 216 //
     /* 40038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 40041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 40045 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSLLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 40045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40050 */     GIR_RootConstrainSelectedInstOperands,
     /* 40051 */     // GIR_Coverage, 216,
     /* 40051 */     GIR_Done,
     /* 40052 */   // Label 1072: @40052
     /* 40052 */   GIM_Reject,
     /* 40053 */ // Label 1069: @40053
     /* 40053 */ GIM_Reject,
     /* 40054 */ // Label 1056: @40054
     /* 40054 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(40087), // Rule ID 960 //
     /* 40059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 40065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 40068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40080 */   // (shl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SLL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 40080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_D),
     /* 40085 */   GIR_RootConstrainSelectedInstOperands,
     /* 40086 */   // GIR_Coverage, 960,
     /* 40086 */   GIR_Done,
     /* 40087 */ // Label 1073: @40087
     /* 40087 */ GIM_Reject,
     /* 40088 */ // Label 1057: @40088
     /* 40088 */ GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(40355),
     /* 40093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40103 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(40217), // Rule ID 2455 //
     /* 40108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40135 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40146 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40150 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40162 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40166 */     // MIs[3] Operand 1
     /* 40166 */     // No operand predicates
     /* 40166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40174 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40178 */     // MIs[4] Operand 1
     /* 40178 */     // No operand predicates
     /* 40178 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40182 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40186 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40190 */     // MIs[5] Operand 1
     /* 40190 */     // No operand predicates
     /* 40190 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40194 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40198 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40202 */     // MIs[6] Operand 1
     /* 40202 */     // No operand predicates
     /* 40202 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40204 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40209 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40215 */     GIR_RootConstrainSelectedInstOperands,
     /* 40216 */     // GIR_Coverage, 2455,
     /* 40216 */     GIR_EraseRootFromParent_Done,
     /* 40217 */   // Label 1075: @40217
     /* 40217 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(40331), // Rule ID 2066 //
     /* 40222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40249 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40260 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40264 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40276 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40280 */     // MIs[3] Operand 1
     /* 40280 */     // No operand predicates
     /* 40280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40288 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40292 */     // MIs[4] Operand 1
     /* 40292 */     // No operand predicates
     /* 40292 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40296 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40300 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40304 */     // MIs[5] Operand 1
     /* 40304 */     // No operand predicates
     /* 40304 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40308 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40312 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40316 */     // MIs[6] Operand 1
     /* 40316 */     // No operand predicates
     /* 40316 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40318 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40323 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40329 */     GIR_RootConstrainSelectedInstOperands,
     /* 40330 */     // GIR_Coverage, 2066,
     /* 40330 */     GIR_EraseRootFromParent_Done,
     /* 40331 */   // Label 1076: @40331
     /* 40331 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(40354), // Rule ID 959 //
     /* 40336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40347 */     // (shl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SLL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 40347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40352 */     GIR_RootConstrainSelectedInstOperands,
     /* 40353 */     // GIR_Coverage, 959,
     /* 40353 */     GIR_Done,
     /* 40354 */   // Label 1077: @40354
     /* 40354 */   GIM_Reject,
     /* 40355 */ // Label 1074: @40355
     /* 40355 */ GIM_Reject,
     /* 40356 */ // Label 1058: @40356
     /* 40356 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(40751),
     /* 40361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40371 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(40549), // Rule ID 2454 //
     /* 40376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40403 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40414 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40418 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40422 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40426 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40430 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40434 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40446 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40450 */     // MIs[3] Operand 1
     /* 40450 */     // No operand predicates
     /* 40450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40454 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40458 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40462 */     // MIs[4] Operand 1
     /* 40462 */     // No operand predicates
     /* 40462 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40466 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40470 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40474 */     // MIs[5] Operand 1
     /* 40474 */     // No operand predicates
     /* 40474 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40478 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40482 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40486 */     // MIs[6] Operand 1
     /* 40486 */     // No operand predicates
     /* 40486 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40490 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40494 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40498 */     // MIs[7] Operand 1
     /* 40498 */     // No operand predicates
     /* 40498 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40502 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40506 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40510 */     // MIs[8] Operand 1
     /* 40510 */     // No operand predicates
     /* 40510 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40514 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40518 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40522 */     // MIs[9] Operand 1
     /* 40522 */     // No operand predicates
     /* 40522 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40526 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40530 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40534 */     // MIs[10] Operand 1
     /* 40534 */     // No operand predicates
     /* 40534 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40536 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40541 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40547 */     GIR_RootConstrainSelectedInstOperands,
     /* 40548 */     // GIR_Coverage, 2454,
     /* 40548 */     GIR_EraseRootFromParent_Done,
     /* 40549 */   // Label 1079: @40549
     /* 40549 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(40727), // Rule ID 2065 //
     /* 40554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40581 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40592 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40596 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40600 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40604 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40608 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40612 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40624 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40628 */     // MIs[3] Operand 1
     /* 40628 */     // No operand predicates
     /* 40628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40636 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40640 */     // MIs[4] Operand 1
     /* 40640 */     // No operand predicates
     /* 40640 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40644 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40648 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40652 */     // MIs[5] Operand 1
     /* 40652 */     // No operand predicates
     /* 40652 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40656 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40660 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40664 */     // MIs[6] Operand 1
     /* 40664 */     // No operand predicates
     /* 40664 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40668 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40672 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40676 */     // MIs[7] Operand 1
     /* 40676 */     // No operand predicates
     /* 40676 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40680 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40684 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40688 */     // MIs[8] Operand 1
     /* 40688 */     // No operand predicates
     /* 40688 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40692 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40696 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40700 */     // MIs[9] Operand 1
     /* 40700 */     // No operand predicates
     /* 40700 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40704 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40708 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40712 */     // MIs[10] Operand 1
     /* 40712 */     // No operand predicates
     /* 40712 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40714 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40719 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40725 */     GIR_RootConstrainSelectedInstOperands,
     /* 40726 */     // GIR_Coverage, 2065,
     /* 40726 */     GIR_EraseRootFromParent_Done,
     /* 40727 */   // Label 1080: @40727
     /* 40727 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(40750), // Rule ID 958 //
     /* 40732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40743 */     // (shl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SLL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 40743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40748 */     GIR_RootConstrainSelectedInstOperands,
     /* 40749 */     // GIR_Coverage, 958,
     /* 40749 */     GIR_Done,
     /* 40750 */   // Label 1081: @40750
     /* 40750 */   GIM_Reject,
     /* 40751 */ // Label 1078: @40751
     /* 40751 */ GIM_Reject,
     /* 40752 */ // Label 1059: @40752
     /* 40752 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(41403),
     /* 40757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 40767 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(41073), // Rule ID 2453 //
     /* 40772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40799 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 40802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40810 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40814 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40818 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40822 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40826 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40830 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40834 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 40838 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 40842 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 40846 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 40850 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 40854 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 40858 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 40862 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 40866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40874 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40878 */     // MIs[3] Operand 1
     /* 40878 */     // No operand predicates
     /* 40878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40886 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40890 */     // MIs[4] Operand 1
     /* 40890 */     // No operand predicates
     /* 40890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40898 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40902 */     // MIs[5] Operand 1
     /* 40902 */     // No operand predicates
     /* 40902 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40906 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40910 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40914 */     // MIs[6] Operand 1
     /* 40914 */     // No operand predicates
     /* 40914 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40918 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40922 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40926 */     // MIs[7] Operand 1
     /* 40926 */     // No operand predicates
     /* 40926 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40930 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40934 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40938 */     // MIs[8] Operand 1
     /* 40938 */     // No operand predicates
     /* 40938 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40942 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40946 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40950 */     // MIs[9] Operand 1
     /* 40950 */     // No operand predicates
     /* 40950 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40954 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40958 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40962 */     // MIs[10] Operand 1
     /* 40962 */     // No operand predicates
     /* 40962 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 40966 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40970 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40974 */     // MIs[11] Operand 1
     /* 40974 */     // No operand predicates
     /* 40974 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 40978 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40982 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40986 */     // MIs[12] Operand 1
     /* 40986 */     // No operand predicates
     /* 40986 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 40990 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40994 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40998 */     // MIs[13] Operand 1
     /* 40998 */     // No operand predicates
     /* 40998 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41002 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41006 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41010 */     // MIs[14] Operand 1
     /* 41010 */     // No operand predicates
     /* 41010 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41014 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41018 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41022 */     // MIs[15] Operand 1
     /* 41022 */     // No operand predicates
     /* 41022 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41026 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41030 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41034 */     // MIs[16] Operand 1
     /* 41034 */     // No operand predicates
     /* 41034 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41038 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41042 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41046 */     // MIs[17] Operand 1
     /* 41046 */     // No operand predicates
     /* 41046 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41050 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41054 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41058 */     // MIs[18] Operand 1
     /* 41058 */     // No operand predicates
     /* 41058 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41060 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41065 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 41071 */     GIR_RootConstrainSelectedInstOperands,
     /* 41072 */     // GIR_Coverage, 2453,
     /* 41072 */     GIR_EraseRootFromParent_Done,
     /* 41073 */   // Label 1083: @41073
     /* 41073 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(41379), // Rule ID 2064 //
     /* 41078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 41097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41105 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 41108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41116 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41120 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41124 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 41128 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 41132 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 41136 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 41140 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 41144 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 41148 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 41152 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 41156 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 41160 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 41164 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 41168 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 41172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41184 */     // MIs[3] Operand 1
     /* 41184 */     // No operand predicates
     /* 41184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41188 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41192 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41196 */     // MIs[4] Operand 1
     /* 41196 */     // No operand predicates
     /* 41196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41204 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41208 */     // MIs[5] Operand 1
     /* 41208 */     // No operand predicates
     /* 41208 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 41212 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41216 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41220 */     // MIs[6] Operand 1
     /* 41220 */     // No operand predicates
     /* 41220 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 41224 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41228 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41232 */     // MIs[7] Operand 1
     /* 41232 */     // No operand predicates
     /* 41232 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 41236 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41240 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41244 */     // MIs[8] Operand 1
     /* 41244 */     // No operand predicates
     /* 41244 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 41248 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41252 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41256 */     // MIs[9] Operand 1
     /* 41256 */     // No operand predicates
     /* 41256 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 41260 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41264 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41268 */     // MIs[10] Operand 1
     /* 41268 */     // No operand predicates
     /* 41268 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 41272 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41276 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41280 */     // MIs[11] Operand 1
     /* 41280 */     // No operand predicates
     /* 41280 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 41284 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41288 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41292 */     // MIs[12] Operand 1
     /* 41292 */     // No operand predicates
     /* 41292 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 41296 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41300 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41304 */     // MIs[13] Operand 1
     /* 41304 */     // No operand predicates
     /* 41304 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41308 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41312 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41316 */     // MIs[14] Operand 1
     /* 41316 */     // No operand predicates
     /* 41316 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41320 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41324 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41328 */     // MIs[15] Operand 1
     /* 41328 */     // No operand predicates
     /* 41328 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41332 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41336 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41340 */     // MIs[16] Operand 1
     /* 41340 */     // No operand predicates
     /* 41340 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41344 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41348 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41352 */     // MIs[17] Operand 1
     /* 41352 */     // No operand predicates
     /* 41352 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41356 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41360 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41364 */     // MIs[18] Operand 1
     /* 41364 */     // No operand predicates
     /* 41364 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41366 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41371 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 41377 */     GIR_RootConstrainSelectedInstOperands,
     /* 41378 */     // GIR_Coverage, 2064,
     /* 41378 */     GIR_EraseRootFromParent_Done,
     /* 41379 */   // Label 1084: @41379
     /* 41379 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(41402), // Rule ID 957 //
     /* 41384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41395 */     // (shl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SLL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 41395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41400 */     GIR_RootConstrainSelectedInstOperands,
     /* 41401 */     // GIR_Coverage, 957,
     /* 41401 */     GIR_Done,
     /* 41402 */   // Label 1085: @41402
     /* 41402 */   GIM_Reject,
     /* 41403 */ // Label 1082: @41403
     /* 41403 */ GIM_Reject,
     /* 41404 */ // Label 1060: @41404
     /* 41404 */ GIM_Reject,
     /* 41405 */ // Label 38: @41405
     /* 41405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1092*/ GIMT_Encode4(43201),
     /* 41416 */ /*GILLT_s32*//*Label 1086*/ GIMT_Encode4(41448),
     /* 41420 */ /*GILLT_s64*//*Label 1087*/ GIMT_Encode4(41710), GIMT_Encode4(0),
     /* 41428 */ /*GILLT_v2s64*//*Label 1088*/ GIMT_Encode4(41851), GIMT_Encode4(0),
     /* 41436 */ /*GILLT_v4s32*//*Label 1089*/ GIMT_Encode4(41885),
     /* 41440 */ /*GILLT_v8s16*//*Label 1090*/ GIMT_Encode4(42153),
     /* 41444 */ /*GILLT_v16s8*//*Label 1091*/ GIMT_Encode4(42549),
     /* 41448 */ // Label 1086: @41448
     /* 41448 */ GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(41709),
     /* 41453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41459 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(41501), // Rule ID 57 //
     /* 41464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41487 */     // MIs[1] Operand 1
     /* 41487 */     // No operand predicates
     /* 41487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41489 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 41492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41499 */     GIR_RootConstrainSelectedInstOperands,
     /* 41500 */     // GIR_Coverage, 57,
     /* 41500 */     GIR_EraseRootFromParent_Done,
     /* 41501 */   // Label 1094: @41501
     /* 41501 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(41543), // Rule ID 1827 //
     /* 41506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41529 */     // MIs[1] Operand 1
     /* 41529 */     // No operand predicates
     /* 41529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41531 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SrlX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SrlX16),
     /* 41534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 41536 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 41538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41541 */     GIR_RootConstrainSelectedInstOperands,
     /* 41542 */     // GIR_Coverage, 1827,
     /* 41542 */     GIR_EraseRootFromParent_Done,
     /* 41543 */   // Label 1095: @41543
     /* 41543 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(41585), // Rule ID 2166 //
     /* 41548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 41571 */     // MIs[1] Operand 1
     /* 41571 */     // No operand predicates
     /* 41571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41573 */     // (srl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SRL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 41573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL16_MM),
     /* 41576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41583 */     GIR_RootConstrainSelectedInstOperands,
     /* 41584 */     // GIR_Coverage, 2166,
     /* 41584 */     GIR_EraseRootFromParent_Done,
     /* 41585 */   // Label 1096: @41585
     /* 41585 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(41627), // Rule ID 2167 //
     /* 41590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41613 */     // MIs[1] Operand 1
     /* 41613 */     // No operand predicates
     /* 41613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41615 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_MM),
     /* 41618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41625 */     GIR_RootConstrainSelectedInstOperands,
     /* 41626 */     // GIR_Coverage, 2167,
     /* 41626 */     GIR_EraseRootFromParent_Done,
     /* 41627 */   // Label 1097: @41627
     /* 41627 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(41654), // Rule ID 63 //
     /* 41632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41647 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 41652 */     GIR_RootConstrainSelectedInstOperands,
     /* 41653 */     // GIR_Coverage, 63,
     /* 41653 */     GIR_Done,
     /* 41654 */   // Label 1098: @41654
     /* 41654 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(41681), // Rule ID 1831 //
     /* 41659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41674 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SrlvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 41674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SrlvRxRy16),
     /* 41679 */     GIR_RootConstrainSelectedInstOperands,
     /* 41680 */     // GIR_Coverage, 1831,
     /* 41680 */     GIR_Done,
     /* 41681 */   // Label 1099: @41681
     /* 41681 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(41708), // Rule ID 2168 //
     /* 41686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41701 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 41701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV_MM),
     /* 41706 */     GIR_RootConstrainSelectedInstOperands,
     /* 41707 */     // GIR_Coverage, 2168,
     /* 41707 */     GIR_Done,
     /* 41708 */   // Label 1100: @41708
     /* 41708 */   GIM_Reject,
     /* 41709 */ // Label 1093: @41709
     /* 41709 */ GIM_Reject,
     /* 41710 */ // Label 1087: @41710
     /* 41710 */ GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(41850),
     /* 41715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 41718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41729 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(41763), // Rule ID 212 //
     /* 41734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 41749 */     // MIs[1] Operand 1
     /* 41749 */     // No operand predicates
     /* 41749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41751 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 41754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41761 */     GIR_RootConstrainSelectedInstOperands,
     /* 41762 */     // GIR_Coverage, 212,
     /* 41762 */     GIR_EraseRootFromParent_Done,
     /* 41763 */   // Label 1102: @41763
     /* 41763 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(41830), // Rule ID 1575 //
     /* 41768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 41771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 41779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 41783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41790 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 41790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 41808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 41813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41828 */     GIR_RootConstrainSelectedInstOperands,
     /* 41829 */     // GIR_Coverage, 1575,
     /* 41829 */     GIR_EraseRootFromParent_Done,
     /* 41830 */   // Label 1103: @41830
     /* 41830 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(41849), // Rule ID 220 //
     /* 41835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41842 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41847 */     GIR_RootConstrainSelectedInstOperands,
     /* 41848 */     // GIR_Coverage, 220,
     /* 41848 */     GIR_Done,
     /* 41849 */   // Label 1104: @41849
     /* 41849 */   GIM_Reject,
     /* 41850 */ // Label 1101: @41850
     /* 41850 */ GIM_Reject,
     /* 41851 */ // Label 1088: @41851
     /* 41851 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(41884), // Rule ID 992 //
     /* 41856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 41862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 41865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41877 */   // (srl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 41877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_D),
     /* 41882 */   GIR_RootConstrainSelectedInstOperands,
     /* 41883 */   // GIR_Coverage, 992,
     /* 41883 */   GIR_Done,
     /* 41884 */ // Label 1105: @41884
     /* 41884 */ GIM_Reject,
     /* 41885 */ // Label 1089: @41885
     /* 41885 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(42152),
     /* 41890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 41900 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(42014), // Rule ID 2471 //
     /* 41905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 41928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41932 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 41935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41943 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41947 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41963 */     // MIs[3] Operand 1
     /* 41963 */     // No operand predicates
     /* 41963 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41967 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41971 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41975 */     // MIs[4] Operand 1
     /* 41975 */     // No operand predicates
     /* 41975 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41979 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41983 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41987 */     // MIs[5] Operand 1
     /* 41987 */     // No operand predicates
     /* 41987 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 41991 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41995 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41999 */     // MIs[6] Operand 1
     /* 41999 */     // No operand predicates
     /* 41999 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42001 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42006 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42012 */     GIR_RootConstrainSelectedInstOperands,
     /* 42013 */     // GIR_Coverage, 2471,
     /* 42013 */     GIR_EraseRootFromParent_Done,
     /* 42014 */   // Label 1107: @42014
     /* 42014 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(42128), // Rule ID 2074 //
     /* 42019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 42034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 42038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42046 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 42049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42057 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42061 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42077 */     // MIs[3] Operand 1
     /* 42077 */     // No operand predicates
     /* 42077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42085 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42089 */     // MIs[4] Operand 1
     /* 42089 */     // No operand predicates
     /* 42089 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42093 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42097 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42101 */     // MIs[5] Operand 1
     /* 42101 */     // No operand predicates
     /* 42101 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42105 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42109 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42113 */     // MIs[6] Operand 1
     /* 42113 */     // No operand predicates
     /* 42113 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42115 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42120 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42126 */     GIR_RootConstrainSelectedInstOperands,
     /* 42127 */     // GIR_Coverage, 2074,
     /* 42127 */     GIR_EraseRootFromParent_Done,
     /* 42128 */   // Label 1108: @42128
     /* 42128 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(42151), // Rule ID 991 //
     /* 42133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42144 */     // (srl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 42144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42149 */     GIR_RootConstrainSelectedInstOperands,
     /* 42150 */     // GIR_Coverage, 991,
     /* 42150 */     GIR_Done,
     /* 42151 */   // Label 1109: @42151
     /* 42151 */   GIM_Reject,
     /* 42152 */ // Label 1106: @42152
     /* 42152 */ GIM_Reject,
     /* 42153 */ // Label 1090: @42153
     /* 42153 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(42548),
     /* 42158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42168 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(42346), // Rule ID 2470 //
     /* 42173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42200 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42211 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42215 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42219 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42223 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42227 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42231 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42243 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42247 */     // MIs[3] Operand 1
     /* 42247 */     // No operand predicates
     /* 42247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42255 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42259 */     // MIs[4] Operand 1
     /* 42259 */     // No operand predicates
     /* 42259 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42263 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42267 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42271 */     // MIs[5] Operand 1
     /* 42271 */     // No operand predicates
     /* 42271 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42275 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42279 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42283 */     // MIs[6] Operand 1
     /* 42283 */     // No operand predicates
     /* 42283 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42287 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42291 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42295 */     // MIs[7] Operand 1
     /* 42295 */     // No operand predicates
     /* 42295 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42299 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42303 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42307 */     // MIs[8] Operand 1
     /* 42307 */     // No operand predicates
     /* 42307 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42311 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42315 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42319 */     // MIs[9] Operand 1
     /* 42319 */     // No operand predicates
     /* 42319 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42323 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42327 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42331 */     // MIs[10] Operand 1
     /* 42331 */     // No operand predicates
     /* 42331 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42333 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42338 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42344 */     GIR_RootConstrainSelectedInstOperands,
     /* 42345 */     // GIR_Coverage, 2470,
     /* 42345 */     GIR_EraseRootFromParent_Done,
     /* 42346 */   // Label 1111: @42346
     /* 42346 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(42524), // Rule ID 2073 //
     /* 42351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42378 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42389 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42393 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42397 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42401 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42405 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42409 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42421 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42425 */     // MIs[3] Operand 1
     /* 42425 */     // No operand predicates
     /* 42425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42433 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42437 */     // MIs[4] Operand 1
     /* 42437 */     // No operand predicates
     /* 42437 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42441 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42445 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42449 */     // MIs[5] Operand 1
     /* 42449 */     // No operand predicates
     /* 42449 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42453 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42457 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42461 */     // MIs[6] Operand 1
     /* 42461 */     // No operand predicates
     /* 42461 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42465 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42469 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42473 */     // MIs[7] Operand 1
     /* 42473 */     // No operand predicates
     /* 42473 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42477 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42481 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42485 */     // MIs[8] Operand 1
     /* 42485 */     // No operand predicates
     /* 42485 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42489 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42493 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42497 */     // MIs[9] Operand 1
     /* 42497 */     // No operand predicates
     /* 42497 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42501 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42505 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42509 */     // MIs[10] Operand 1
     /* 42509 */     // No operand predicates
     /* 42509 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42511 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42516 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42522 */     GIR_RootConstrainSelectedInstOperands,
     /* 42523 */     // GIR_Coverage, 2073,
     /* 42523 */     GIR_EraseRootFromParent_Done,
     /* 42524 */   // Label 1112: @42524
     /* 42524 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(42547), // Rule ID 990 //
     /* 42529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42540 */     // (srl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 42540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42545 */     GIR_RootConstrainSelectedInstOperands,
     /* 42546 */     // GIR_Coverage, 990,
     /* 42546 */     GIR_Done,
     /* 42547 */   // Label 1113: @42547
     /* 42547 */   GIM_Reject,
     /* 42548 */ // Label 1110: @42548
     /* 42548 */ GIM_Reject,
     /* 42549 */ // Label 1091: @42549
     /* 42549 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(43200),
     /* 42554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 42564 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(42870), // Rule ID 2469 //
     /* 42569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42596 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42607 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42611 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42615 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42619 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42623 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42627 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42631 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42635 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42639 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42643 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42647 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42651 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42655 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42659 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42671 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42675 */     // MIs[3] Operand 1
     /* 42675 */     // No operand predicates
     /* 42675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42679 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42683 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42687 */     // MIs[4] Operand 1
     /* 42687 */     // No operand predicates
     /* 42687 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42691 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42695 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42699 */     // MIs[5] Operand 1
     /* 42699 */     // No operand predicates
     /* 42699 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42703 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42707 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42711 */     // MIs[6] Operand 1
     /* 42711 */     // No operand predicates
     /* 42711 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42715 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42719 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42723 */     // MIs[7] Operand 1
     /* 42723 */     // No operand predicates
     /* 42723 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42727 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42731 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42735 */     // MIs[8] Operand 1
     /* 42735 */     // No operand predicates
     /* 42735 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42739 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42743 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42747 */     // MIs[9] Operand 1
     /* 42747 */     // No operand predicates
     /* 42747 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42751 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42755 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42759 */     // MIs[10] Operand 1
     /* 42759 */     // No operand predicates
     /* 42759 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 42763 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42767 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42771 */     // MIs[11] Operand 1
     /* 42771 */     // No operand predicates
     /* 42771 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 42775 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42779 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42783 */     // MIs[12] Operand 1
     /* 42783 */     // No operand predicates
     /* 42783 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 42787 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42791 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42795 */     // MIs[13] Operand 1
     /* 42795 */     // No operand predicates
     /* 42795 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 42799 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42803 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42807 */     // MIs[14] Operand 1
     /* 42807 */     // No operand predicates
     /* 42807 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 42811 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42815 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42819 */     // MIs[15] Operand 1
     /* 42819 */     // No operand predicates
     /* 42819 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 42823 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42827 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42831 */     // MIs[16] Operand 1
     /* 42831 */     // No operand predicates
     /* 42831 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 42835 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42839 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42843 */     // MIs[17] Operand 1
     /* 42843 */     // No operand predicates
     /* 42843 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 42847 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42851 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42855 */     // MIs[18] Operand 1
     /* 42855 */     // No operand predicates
     /* 42855 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 42857 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 42857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 42860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42862 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42868 */     GIR_RootConstrainSelectedInstOperands,
     /* 42869 */     // GIR_Coverage, 2469,
     /* 42869 */     GIR_EraseRootFromParent_Done,
     /* 42870 */   // Label 1115: @42870
     /* 42870 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(43176), // Rule ID 2072 //
     /* 42875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42902 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42913 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42917 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42921 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42925 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42929 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42933 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42937 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42941 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42945 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42949 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42953 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42957 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42961 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42965 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42977 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42981 */     // MIs[3] Operand 1
     /* 42981 */     // No operand predicates
     /* 42981 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42985 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42989 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42993 */     // MIs[4] Operand 1
     /* 42993 */     // No operand predicates
     /* 42993 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42997 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43001 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43005 */     // MIs[5] Operand 1
     /* 43005 */     // No operand predicates
     /* 43005 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43009 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43013 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43017 */     // MIs[6] Operand 1
     /* 43017 */     // No operand predicates
     /* 43017 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 43021 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43025 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43029 */     // MIs[7] Operand 1
     /* 43029 */     // No operand predicates
     /* 43029 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 43033 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43037 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43041 */     // MIs[8] Operand 1
     /* 43041 */     // No operand predicates
     /* 43041 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 43045 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43049 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43053 */     // MIs[9] Operand 1
     /* 43053 */     // No operand predicates
     /* 43053 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 43057 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43061 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43065 */     // MIs[10] Operand 1
     /* 43065 */     // No operand predicates
     /* 43065 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 43069 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43073 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43077 */     // MIs[11] Operand 1
     /* 43077 */     // No operand predicates
     /* 43077 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 43081 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43085 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43089 */     // MIs[12] Operand 1
     /* 43089 */     // No operand predicates
     /* 43089 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 43093 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43097 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43101 */     // MIs[13] Operand 1
     /* 43101 */     // No operand predicates
     /* 43101 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 43105 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43109 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43113 */     // MIs[14] Operand 1
     /* 43113 */     // No operand predicates
     /* 43113 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 43117 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43121 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43125 */     // MIs[15] Operand 1
     /* 43125 */     // No operand predicates
     /* 43125 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 43129 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43133 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43137 */     // MIs[16] Operand 1
     /* 43137 */     // No operand predicates
     /* 43137 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 43141 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43145 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43149 */     // MIs[17] Operand 1
     /* 43149 */     // No operand predicates
     /* 43149 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 43153 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43157 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43161 */     // MIs[18] Operand 1
     /* 43161 */     // No operand predicates
     /* 43161 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 43163 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 43163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43168 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43174 */     GIR_RootConstrainSelectedInstOperands,
     /* 43175 */     // GIR_Coverage, 2072,
     /* 43175 */     GIR_EraseRootFromParent_Done,
     /* 43176 */   // Label 1116: @43176
     /* 43176 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(43199), // Rule ID 989 //
     /* 43181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43192 */     // (srl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 43192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43197 */     GIR_RootConstrainSelectedInstOperands,
     /* 43198 */     // GIR_Coverage, 989,
     /* 43198 */     GIR_Done,
     /* 43199 */   // Label 1117: @43199
     /* 43199 */   GIM_Reject,
     /* 43200 */ // Label 1114: @43200
     /* 43200 */ GIM_Reject,
     /* 43201 */ // Label 1092: @43201
     /* 43201 */ GIM_Reject,
     /* 43202 */ // Label 39: @43202
     /* 43202 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1124*/ GIMT_Encode4(44956),
     /* 43213 */ /*GILLT_s32*//*Label 1118*/ GIMT_Encode4(43245),
     /* 43217 */ /*GILLT_s64*//*Label 1119*/ GIMT_Encode4(43465), GIMT_Encode4(0),
     /* 43225 */ /*GILLT_v2s64*//*Label 1120*/ GIMT_Encode4(43606), GIMT_Encode4(0),
     /* 43233 */ /*GILLT_v4s32*//*Label 1121*/ GIMT_Encode4(43640),
     /* 43237 */ /*GILLT_v8s16*//*Label 1122*/ GIMT_Encode4(43908),
     /* 43241 */ /*GILLT_v16s8*//*Label 1123*/ GIMT_Encode4(44304),
     /* 43245 */ // Label 1118: @43245
     /* 43245 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(43464),
     /* 43250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 43253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43256 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(43298), // Rule ID 59 //
     /* 43261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43284 */     // MIs[1] Operand 1
     /* 43284 */     // No operand predicates
     /* 43284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43286 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 43289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43296 */     GIR_RootConstrainSelectedInstOperands,
     /* 43297 */     // GIR_Coverage, 59,
     /* 43297 */     GIR_EraseRootFromParent_Done,
     /* 43298 */   // Label 1126: @43298
     /* 43298 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(43340), // Rule ID 1828 //
     /* 43303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43326 */     // MIs[1] Operand 1
     /* 43326 */     // No operand predicates
     /* 43326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43328 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SraX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SraX16),
     /* 43331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 43333 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 43335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43338 */     GIR_RootConstrainSelectedInstOperands,
     /* 43339 */     // GIR_Coverage, 1828,
     /* 43339 */     GIR_EraseRootFromParent_Done,
     /* 43340 */   // Label 1127: @43340
     /* 43340 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(43382), // Rule ID 2169 //
     /* 43345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43368 */     // MIs[1] Operand 1
     /* 43368 */     // No operand predicates
     /* 43368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43370 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRA_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_MM),
     /* 43373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 43377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43380 */     GIR_RootConstrainSelectedInstOperands,
     /* 43381 */     // GIR_Coverage, 2169,
     /* 43381 */     GIR_EraseRootFromParent_Done,
     /* 43382 */   // Label 1128: @43382
     /* 43382 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(43409), // Rule ID 65 //
     /* 43387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43402 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRAV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 43407 */     GIR_RootConstrainSelectedInstOperands,
     /* 43408 */     // GIR_Coverage, 65,
     /* 43408 */     GIR_Done,
     /* 43409 */   // Label 1129: @43409
     /* 43409 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(43436), // Rule ID 1830 //
     /* 43414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43429 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SravRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 43429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SravRxRy16),
     /* 43434 */     GIR_RootConstrainSelectedInstOperands,
     /* 43435 */     // GIR_Coverage, 1830,
     /* 43435 */     GIR_Done,
     /* 43436 */   // Label 1130: @43436
     /* 43436 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(43463), // Rule ID 2170 //
     /* 43441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43456 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRAV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 43456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV_MM),
     /* 43461 */     GIR_RootConstrainSelectedInstOperands,
     /* 43462 */     // GIR_Coverage, 2170,
     /* 43462 */     GIR_Done,
     /* 43463 */   // Label 1131: @43463
     /* 43463 */   GIM_Reject,
     /* 43464 */ // Label 1125: @43464
     /* 43464 */ GIM_Reject,
     /* 43465 */ // Label 1119: @43465
     /* 43465 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(43605),
     /* 43470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 43473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43484 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(43518), // Rule ID 214 //
     /* 43489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 43504 */     // MIs[1] Operand 1
     /* 43504 */     // No operand predicates
     /* 43504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43506 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRA),
     /* 43509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43516 */     GIR_RootConstrainSelectedInstOperands,
     /* 43517 */     // GIR_Coverage, 214,
     /* 43517 */     GIR_EraseRootFromParent_Done,
     /* 43518 */   // Label 1133: @43518
     /* 43518 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(43585), // Rule ID 1576 //
     /* 43523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 43526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 43534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 43538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43545 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRAV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 43545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43557 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 43563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 43568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43583 */     GIR_RootConstrainSelectedInstOperands,
     /* 43584 */     // GIR_Coverage, 1576,
     /* 43584 */     GIR_EraseRootFromParent_Done,
     /* 43585 */   // Label 1134: @43585
     /* 43585 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(43604), // Rule ID 218 //
     /* 43590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43597 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRAV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43602 */     GIR_RootConstrainSelectedInstOperands,
     /* 43603 */     // GIR_Coverage, 218,
     /* 43603 */     GIR_Done,
     /* 43604 */   // Label 1135: @43604
     /* 43604 */   GIM_Reject,
     /* 43605 */ // Label 1132: @43605
     /* 43605 */ GIM_Reject,
     /* 43606 */ // Label 1120: @43606
     /* 43606 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(43639), // Rule ID 976 //
     /* 43611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 43617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 43620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43632 */   // (sra:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRA_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 43632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_D),
     /* 43637 */   GIR_RootConstrainSelectedInstOperands,
     /* 43638 */   // GIR_Coverage, 976,
     /* 43638 */   GIR_Done,
     /* 43639 */ // Label 1136: @43639
     /* 43639 */ GIM_Reject,
     /* 43640 */ // Label 1121: @43640
     /* 43640 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(43907),
     /* 43645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43655 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(43769), // Rule ID 2475 //
     /* 43660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43687 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43698 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43702 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43714 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43718 */     // MIs[3] Operand 1
     /* 43718 */     // No operand predicates
     /* 43718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43722 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43726 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43730 */     // MIs[4] Operand 1
     /* 43730 */     // No operand predicates
     /* 43730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43738 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43742 */     // MIs[5] Operand 1
     /* 43742 */     // No operand predicates
     /* 43742 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43746 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43750 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43754 */     // MIs[6] Operand 1
     /* 43754 */     // No operand predicates
     /* 43754 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43756 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43761 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 43767 */     GIR_RootConstrainSelectedInstOperands,
     /* 43768 */     // GIR_Coverage, 2475,
     /* 43768 */     GIR_EraseRootFromParent_Done,
     /* 43769 */   // Label 1138: @43769
     /* 43769 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(43883), // Rule ID 2078 //
     /* 43774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 43797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43801 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43812 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43816 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43832 */     // MIs[3] Operand 1
     /* 43832 */     // No operand predicates
     /* 43832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43836 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43840 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43844 */     // MIs[4] Operand 1
     /* 43844 */     // No operand predicates
     /* 43844 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43848 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43852 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43856 */     // MIs[5] Operand 1
     /* 43856 */     // No operand predicates
     /* 43856 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43860 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43864 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43868 */     // MIs[6] Operand 1
     /* 43868 */     // No operand predicates
     /* 43868 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43870 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43875 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43881 */     GIR_RootConstrainSelectedInstOperands,
     /* 43882 */     // GIR_Coverage, 2078,
     /* 43882 */     GIR_EraseRootFromParent_Done,
     /* 43883 */   // Label 1139: @43883
     /* 43883 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(43906), // Rule ID 975 //
     /* 43888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43899 */     // (sra:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRA_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 43899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43904 */     GIR_RootConstrainSelectedInstOperands,
     /* 43905 */     // GIR_Coverage, 975,
     /* 43905 */     GIR_Done,
     /* 43906 */   // Label 1140: @43906
     /* 43906 */   GIM_Reject,
     /* 43907 */ // Label 1137: @43907
     /* 43907 */ GIM_Reject,
     /* 43908 */ // Label 1122: @43908
     /* 43908 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(44303),
     /* 43913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 43923 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(44101), // Rule ID 2474 //
     /* 43928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43955 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 43958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43966 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43970 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43974 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 43978 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 43982 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 43986 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 43990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43998 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44002 */     // MIs[3] Operand 1
     /* 44002 */     // No operand predicates
     /* 44002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44006 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44010 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44014 */     // MIs[4] Operand 1
     /* 44014 */     // No operand predicates
     /* 44014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44022 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44026 */     // MIs[5] Operand 1
     /* 44026 */     // No operand predicates
     /* 44026 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44030 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44034 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44038 */     // MIs[6] Operand 1
     /* 44038 */     // No operand predicates
     /* 44038 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44042 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44046 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44050 */     // MIs[7] Operand 1
     /* 44050 */     // No operand predicates
     /* 44050 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44054 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44058 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44062 */     // MIs[8] Operand 1
     /* 44062 */     // No operand predicates
     /* 44062 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44066 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44070 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44074 */     // MIs[9] Operand 1
     /* 44074 */     // No operand predicates
     /* 44074 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44078 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44082 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44086 */     // MIs[10] Operand 1
     /* 44086 */     // No operand predicates
     /* 44086 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44088 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44093 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44099 */     GIR_RootConstrainSelectedInstOperands,
     /* 44100 */     // GIR_Coverage, 2474,
     /* 44100 */     GIR_EraseRootFromParent_Done,
     /* 44101 */   // Label 1142: @44101
     /* 44101 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(44279), // Rule ID 2077 //
     /* 44106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 44121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 44125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44133 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 44136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44144 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44148 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44152 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44156 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44160 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44164 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44176 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44180 */     // MIs[3] Operand 1
     /* 44180 */     // No operand predicates
     /* 44180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44184 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44188 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44192 */     // MIs[4] Operand 1
     /* 44192 */     // No operand predicates
     /* 44192 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44196 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44200 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44204 */     // MIs[5] Operand 1
     /* 44204 */     // No operand predicates
     /* 44204 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44208 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44212 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44216 */     // MIs[6] Operand 1
     /* 44216 */     // No operand predicates
     /* 44216 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44220 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44224 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44228 */     // MIs[7] Operand 1
     /* 44228 */     // No operand predicates
     /* 44228 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44232 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44236 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44240 */     // MIs[8] Operand 1
     /* 44240 */     // No operand predicates
     /* 44240 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44244 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44248 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44252 */     // MIs[9] Operand 1
     /* 44252 */     // No operand predicates
     /* 44252 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44256 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44260 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44264 */     // MIs[10] Operand 1
     /* 44264 */     // No operand predicates
     /* 44264 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44266 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44271 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44277 */     GIR_RootConstrainSelectedInstOperands,
     /* 44278 */     // GIR_Coverage, 2077,
     /* 44278 */     GIR_EraseRootFromParent_Done,
     /* 44279 */   // Label 1143: @44279
     /* 44279 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(44302), // Rule ID 974 //
     /* 44284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44295 */     // (sra:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRA_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 44295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44300 */     GIR_RootConstrainSelectedInstOperands,
     /* 44301 */     // GIR_Coverage, 974,
     /* 44301 */     GIR_Done,
     /* 44302 */   // Label 1144: @44302
     /* 44302 */   GIM_Reject,
     /* 44303 */ // Label 1141: @44303
     /* 44303 */ GIM_Reject,
     /* 44304 */ // Label 1123: @44304
     /* 44304 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(44955),
     /* 44309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44319 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(44625), // Rule ID 2473 //
     /* 44324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 44347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44351 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44362 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44366 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44370 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44374 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44378 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44382 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44386 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44390 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44394 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44398 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44402 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44406 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44410 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44414 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44430 */     // MIs[3] Operand 1
     /* 44430 */     // No operand predicates
     /* 44430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44438 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44442 */     // MIs[4] Operand 1
     /* 44442 */     // No operand predicates
     /* 44442 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44446 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44450 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44454 */     // MIs[5] Operand 1
     /* 44454 */     // No operand predicates
     /* 44454 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44458 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44462 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44466 */     // MIs[6] Operand 1
     /* 44466 */     // No operand predicates
     /* 44466 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44470 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44474 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44478 */     // MIs[7] Operand 1
     /* 44478 */     // No operand predicates
     /* 44478 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44482 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44486 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44490 */     // MIs[8] Operand 1
     /* 44490 */     // No operand predicates
     /* 44490 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44494 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44498 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44502 */     // MIs[9] Operand 1
     /* 44502 */     // No operand predicates
     /* 44502 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44506 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44510 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44514 */     // MIs[10] Operand 1
     /* 44514 */     // No operand predicates
     /* 44514 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44518 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44522 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44526 */     // MIs[11] Operand 1
     /* 44526 */     // No operand predicates
     /* 44526 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44530 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44534 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44538 */     // MIs[12] Operand 1
     /* 44538 */     // No operand predicates
     /* 44538 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44542 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44546 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44550 */     // MIs[13] Operand 1
     /* 44550 */     // No operand predicates
     /* 44550 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44554 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44558 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44562 */     // MIs[14] Operand 1
     /* 44562 */     // No operand predicates
     /* 44562 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44566 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44570 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44574 */     // MIs[15] Operand 1
     /* 44574 */     // No operand predicates
     /* 44574 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44578 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44582 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44586 */     // MIs[16] Operand 1
     /* 44586 */     // No operand predicates
     /* 44586 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44590 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44594 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44598 */     // MIs[17] Operand 1
     /* 44598 */     // No operand predicates
     /* 44598 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44602 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44606 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44610 */     // MIs[18] Operand 1
     /* 44610 */     // No operand predicates
     /* 44610 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44612 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44617 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44623 */     GIR_RootConstrainSelectedInstOperands,
     /* 44624 */     // GIR_Coverage, 2473,
     /* 44624 */     GIR_EraseRootFromParent_Done,
     /* 44625 */   // Label 1146: @44625
     /* 44625 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(44931), // Rule ID 2076 //
     /* 44630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44657 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44668 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44672 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44676 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44680 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44684 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44688 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44692 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44696 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44700 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44704 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44708 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44712 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44716 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44720 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44732 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44736 */     // MIs[3] Operand 1
     /* 44736 */     // No operand predicates
     /* 44736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44744 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44748 */     // MIs[4] Operand 1
     /* 44748 */     // No operand predicates
     /* 44748 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44752 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44756 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44760 */     // MIs[5] Operand 1
     /* 44760 */     // No operand predicates
     /* 44760 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44764 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44768 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44772 */     // MIs[6] Operand 1
     /* 44772 */     // No operand predicates
     /* 44772 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44776 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44780 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44784 */     // MIs[7] Operand 1
     /* 44784 */     // No operand predicates
     /* 44784 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44788 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44792 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44796 */     // MIs[8] Operand 1
     /* 44796 */     // No operand predicates
     /* 44796 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44800 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44804 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44808 */     // MIs[9] Operand 1
     /* 44808 */     // No operand predicates
     /* 44808 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44812 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44816 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44820 */     // MIs[10] Operand 1
     /* 44820 */     // No operand predicates
     /* 44820 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44824 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44828 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44832 */     // MIs[11] Operand 1
     /* 44832 */     // No operand predicates
     /* 44832 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44836 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44840 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44844 */     // MIs[12] Operand 1
     /* 44844 */     // No operand predicates
     /* 44844 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44848 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44852 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44856 */     // MIs[13] Operand 1
     /* 44856 */     // No operand predicates
     /* 44856 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44860 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44864 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44868 */     // MIs[14] Operand 1
     /* 44868 */     // No operand predicates
     /* 44868 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44872 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44876 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44880 */     // MIs[15] Operand 1
     /* 44880 */     // No operand predicates
     /* 44880 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44884 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44888 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44892 */     // MIs[16] Operand 1
     /* 44892 */     // No operand predicates
     /* 44892 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44896 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44900 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44904 */     // MIs[17] Operand 1
     /* 44904 */     // No operand predicates
     /* 44904 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44908 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44912 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44916 */     // MIs[18] Operand 1
     /* 44916 */     // No operand predicates
     /* 44916 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44918 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44923 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44929 */     GIR_RootConstrainSelectedInstOperands,
     /* 44930 */     // GIR_Coverage, 2076,
     /* 44930 */     GIR_EraseRootFromParent_Done,
     /* 44931 */   // Label 1147: @44931
     /* 44931 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(44954), // Rule ID 973 //
     /* 44936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44947 */     // (sra:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRA_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 44947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44952 */     GIR_RootConstrainSelectedInstOperands,
     /* 44953 */     // GIR_Coverage, 973,
     /* 44953 */     GIR_Done,
     /* 44954 */   // Label 1148: @44954
     /* 44954 */   GIM_Reject,
     /* 44955 */ // Label 1145: @44955
     /* 44955 */ GIM_Reject,
     /* 44956 */ // Label 1124: @44956
     /* 44956 */ GIM_Reject,
     /* 44957 */ // Label 40: @44957
     /* 44957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1151*/ GIMT_Encode4(45244),
     /* 44968 */ /*GILLT_s32*//*Label 1149*/ GIMT_Encode4(44976),
     /* 44972 */ /*GILLT_s64*//*Label 1150*/ GIMT_Encode4(45103),
     /* 44976 */ // Label 1149: @44976
     /* 44976 */ GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(45102),
     /* 44981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 44984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 44987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 44991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 44995 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(45029), // Rule ID 67 //
     /* 45000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45015 */     // MIs[1] Operand 1
     /* 45015 */     // No operand predicates
     /* 45015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45017 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 45020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45027 */     GIR_RootConstrainSelectedInstOperands,
     /* 45028 */     // GIR_Coverage, 67,
     /* 45028 */     GIR_EraseRootFromParent_Done,
     /* 45029 */   // Label 1153: @45029
     /* 45029 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(45063), // Rule ID 1081 //
     /* 45034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45049 */     // MIs[1] Operand 1
     /* 45049 */     // No operand predicates
     /* 45049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45051 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 45054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45061 */     GIR_RootConstrainSelectedInstOperands,
     /* 45062 */     // GIR_Coverage, 1081,
     /* 45062 */     GIR_EraseRootFromParent_Done,
     /* 45063 */   // Label 1154: @45063
     /* 45063 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(45082), // Rule ID 68 //
     /* 45068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45075 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV),
     /* 45080 */     GIR_RootConstrainSelectedInstOperands,
     /* 45081 */     // GIR_Coverage, 68,
     /* 45081 */     GIR_Done,
     /* 45082 */   // Label 1155: @45082
     /* 45082 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(45101), // Rule ID 1082 //
     /* 45087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45094 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV_MM),
     /* 45099 */     GIR_RootConstrainSelectedInstOperands,
     /* 45100 */     // GIR_Coverage, 1082,
     /* 45100 */     GIR_Done,
     /* 45101 */   // Label 1156: @45101
     /* 45101 */   GIM_Reject,
     /* 45102 */ // Label 1152: @45102
     /* 45102 */ GIM_Reject,
     /* 45103 */ // Label 1150: @45103
     /* 45103 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(45243),
     /* 45108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45122 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(45156), // Rule ID 222 //
     /* 45127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 45142 */     // MIs[1] Operand 1
     /* 45142 */     // No operand predicates
     /* 45142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45144 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DROTR:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTR),
     /* 45147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45154 */     GIR_RootConstrainSelectedInstOperands,
     /* 45155 */     // GIR_Coverage, 222,
     /* 45155 */     GIR_EraseRootFromParent_Done,
     /* 45156 */   // Label 1158: @45156
     /* 45156 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(45223), // Rule ID 1577 //
     /* 45161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 45164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 45172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 45176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45183 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DROTRV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 45183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45195 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 45201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 45206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45221 */     GIR_RootConstrainSelectedInstOperands,
     /* 45222 */     // GIR_Coverage, 1577,
     /* 45222 */     GIR_EraseRootFromParent_Done,
     /* 45223 */   // Label 1159: @45223
     /* 45223 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(45242), // Rule ID 223 //
     /* 45228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45235 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DROTRV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45240 */     GIR_RootConstrainSelectedInstOperands,
     /* 45241 */     // GIR_Coverage, 223,
     /* 45241 */     GIR_Done,
     /* 45242 */   // Label 1160: @45242
     /* 45242 */   GIM_Reject,
     /* 45243 */ // Label 1157: @45243
     /* 45243 */ GIM_Reject,
     /* 45244 */ // Label 1151: @45244
     /* 45244 */ GIM_Reject,
     /* 45245 */ // Label 41: @45245
     /* 45245 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(47775),
     /* 45250 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 45253 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1164*/ GIMT_Encode4(45438),
     /* 45264 */   /*GILLT_s32*//*Label 1162*/ GIMT_Encode4(45272),
     /* 45268 */   /*GILLT_s64*//*Label 1163*/ GIMT_Encode4(45355),
     /* 45272 */   // Label 1162: @45272
     /* 45272 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(45354),
     /* 45277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45284 */     GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(45317), // Rule ID 1415 //
     /* 45289 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45292 */       // MIs[0] Operand 1
     /* 45292 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45297 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45301 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45305 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45305 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45308 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45310 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45312 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45315 */       GIR_RootConstrainSelectedInstOperands,
     /* 45316 */       // GIR_Coverage, 1415,
     /* 45316 */       GIR_EraseRootFromParent_Done,
     /* 45317 */     // Label 1166: @45317
     /* 45317 */     GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(45353), // Rule ID 1416 //
     /* 45322 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45325 */       // MIs[0] Operand 1
     /* 45325 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45330 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45334 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45338 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45338 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45341 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45343 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45349 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45351 */       GIR_RootConstrainSelectedInstOperands,
     /* 45352 */       // GIR_Coverage, 1416,
     /* 45352 */       GIR_EraseRootFromParent_Done,
     /* 45353 */     // Label 1167: @45353
     /* 45353 */     GIM_Reject,
     /* 45354 */   // Label 1165: @45354
     /* 45354 */   GIM_Reject,
     /* 45355 */   // Label 1163: @45355
     /* 45355 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(45437),
     /* 45360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45367 */     GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(45400), // Rule ID 1559 //
     /* 45372 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45375 */       // MIs[0] Operand 1
     /* 45375 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45380 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45384 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45388 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 1:{ *:[i64] })
     /* 45388 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 45391 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45393 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45395 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45398 */       GIR_RootConstrainSelectedInstOperands,
     /* 45399 */       // GIR_Coverage, 1559,
     /* 45399 */       GIR_EraseRootFromParent_Done,
     /* 45400 */     // Label 1169: @45400
     /* 45400 */     GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(45436), // Rule ID 1560 //
     /* 45405 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45408 */       // MIs[0] Operand 1
     /* 45408 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45413 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45417 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45421 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, GPR64:{ *:[i64] }:$lhs)
     /* 45421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45426 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45432 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45434 */       GIR_RootConstrainSelectedInstOperands,
     /* 45435 */       // GIR_Coverage, 1560,
     /* 45435 */       GIR_EraseRootFromParent_Done,
     /* 45436 */     // Label 1170: @45436
     /* 45436 */     GIM_Reject,
     /* 45437 */   // Label 1168: @45437
     /* 45437 */   GIM_Reject,
     /* 45438 */   // Label 1164: @45438
     /* 45438 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1173*/ GIMT_Encode4(45821),
     /* 45449 */   /*GILLT_s32*//*Label 1171*/ GIMT_Encode4(45457),
     /* 45453 */   /*GILLT_s64*//*Label 1172*/ GIMT_Encode4(45743),
     /* 45457 */   // Label 1171: @45457
     /* 45457 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(45742),
     /* 45462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45465 */     GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(45502), // Rule ID 1878 //
     /* 45470 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45473 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45477 */       // MIs[0] Operand 1
     /* 45477 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45482 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45486 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45490 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45490 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 45493 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 45495 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45497 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45500 */       GIR_RootConstrainSelectedInstOperands,
     /* 45501 */       // GIR_Coverage, 1878,
     /* 45501 */       GIR_EraseRootFromParent_Done,
     /* 45502 */     // Label 1175: @45502
     /* 45502 */     GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(45592), // Rule ID 1880 //
     /* 45507 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45510 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45514 */       // MIs[0] Operand 1
     /* 45514 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 45519 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45523 */       GIM_CheckConstantInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-32769),
     /* 45534 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32769:{ *:[i32] }, SETGT:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltiCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32768:{ *:[i32] }), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 45534 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45537 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 45541 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45546 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 45549 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45551 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45554 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltiCCRxImmX16),
     /* 45558 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45563 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45567 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 45577 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 45582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 45584 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45587 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 45590 */       GIR_RootConstrainSelectedInstOperands,
     /* 45591 */       // GIR_Coverage, 1880,
     /* 45591 */       GIR_EraseRootFromParent_Done,
     /* 45592 */     // Label 1176: @45592
     /* 45592 */     GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(45629), // Rule ID 2197 //
     /* 45597 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45600 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45604 */       // MIs[0] Operand 1
     /* 45604 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45609 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45613 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45617 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45617 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 45620 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45622 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45624 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45627 */       GIR_RootConstrainSelectedInstOperands,
     /* 45628 */       // GIR_Coverage, 2197,
     /* 45628 */       GIR_EraseRootFromParent_Done,
     /* 45629 */     // Label 1177: @45629
     /* 45629 */     GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(45669), // Rule ID 2198 //
     /* 45634 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45637 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45641 */       // MIs[0] Operand 1
     /* 45641 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45646 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45650 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45654 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45654 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45657 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45659 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45665 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45667 */       GIR_RootConstrainSelectedInstOperands,
     /* 45668 */       // GIR_Coverage, 2198,
     /* 45668 */       GIR_EraseRootFromParent_Done,
     /* 45669 */     // Label 1178: @45669
     /* 45669 */     GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(45705), // Rule ID 49 //
     /* 45674 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45677 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45681 */       // MIs[0] Operand 1
     /* 45681 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45686 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45690 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45694 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45694 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 45697 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45699 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45701 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45703 */       GIR_RootConstrainSelectedInstOperands,
     /* 45704 */       // GIR_Coverage, 49,
     /* 45704 */       GIR_EraseRootFromParent_Done,
     /* 45705 */     // Label 1179: @45705
     /* 45705 */     GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(45741), // Rule ID 50 //
     /* 45710 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45713 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45717 */       // MIs[0] Operand 1
     /* 45717 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45722 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45726 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45730 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45730 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45733 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45735 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45737 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45739 */       GIR_RootConstrainSelectedInstOperands,
     /* 45740 */       // GIR_Coverage, 50,
     /* 45740 */       GIR_EraseRootFromParent_Done,
     /* 45741 */     // Label 1180: @45741
     /* 45741 */     GIM_Reject,
     /* 45742 */   // Label 1174: @45742
     /* 45742 */   GIM_Reject,
     /* 45743 */   // Label 1172: @45743
     /* 45743 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(45820),
     /* 45748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45755 */     GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(45787), // Rule ID 204 //
     /* 45760 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45763 */       // MIs[0] Operand 1
     /* 45763 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45768 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45772 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45776 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETLT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45776 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 45779 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45781 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45783 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45785 */       GIR_RootConstrainSelectedInstOperands,
     /* 45786 */       // GIR_Coverage, 204,
     /* 45786 */       GIR_EraseRootFromParent_Done,
     /* 45787 */     // Label 1182: @45787
     /* 45787 */     GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(45819), // Rule ID 205 //
     /* 45792 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45795 */       // MIs[0] Operand 1
     /* 45795 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45800 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45804 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45808 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45808 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45811 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45813 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45815 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45817 */       GIR_RootConstrainSelectedInstOperands,
     /* 45818 */       // GIR_Coverage, 205,
     /* 45818 */       GIR_EraseRootFromParent_Done,
     /* 45819 */     // Label 1183: @45819
     /* 45819 */     GIM_Reject,
     /* 45820 */   // Label 1181: @45820
     /* 45820 */   GIM_Reject,
     /* 45821 */   // Label 1173: @45821
     /* 45821 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1186*/ GIMT_Encode4(46738),
     /* 45832 */   /*GILLT_s32*//*Label 1184*/ GIMT_Encode4(45840),
     /* 45836 */   /*GILLT_s64*//*Label 1185*/ GIMT_Encode4(46321),
     /* 45840 */   // Label 1184: @45840
     /* 45840 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(46320),
     /* 45845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45852 */     GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(45884), // Rule ID 1075 //
     /* 45857 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45860 */       // MIs[0] Operand 1
     /* 45860 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45865 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45869 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45873 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 45876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45878 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45880 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45882 */       GIR_RootConstrainSelectedInstOperands,
     /* 45883 */       // GIR_Coverage, 1075,
     /* 45883 */       GIR_EraseRootFromParent_Done,
     /* 45884 */     // Label 1188: @45884
     /* 45884 */     GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(45916), // Rule ID 1076 //
     /* 45889 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45892 */       // MIs[0] Operand 1
     /* 45892 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45897 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45901 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45905 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45905 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45908 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45910 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45912 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45914 */       GIR_RootConstrainSelectedInstOperands,
     /* 45915 */       // GIR_Coverage, 1076,
     /* 45915 */       GIR_EraseRootFromParent_Done,
     /* 45916 */     // Label 1189: @45916
     /* 45916 */     GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(45972), // Rule ID 1417 //
     /* 45921 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45924 */       // MIs[0] Operand 1
     /* 45924 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45929 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45933 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45937 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 45937 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45940 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 45944 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45949 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45953 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 45957 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45959 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45962 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45964 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45967 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45970 */       GIR_RootConstrainSelectedInstOperands,
     /* 45971 */       // GIR_Coverage, 1417,
     /* 45971 */       GIR_EraseRootFromParent_Done,
     /* 45972 */     // Label 1190: @45972
     /* 45972 */     GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(46031), // Rule ID 1418 //
     /* 45977 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45980 */       // MIs[0] Operand 1
     /* 45980 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45985 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45989 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45993 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 45993 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45996 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 46000 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46005 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46009 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46013 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46015 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46018 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46020 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46026 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46029 */       GIR_RootConstrainSelectedInstOperands,
     /* 46030 */       // GIR_Coverage, 1418,
     /* 46030 */       GIR_EraseRootFromParent_Done,
     /* 46031 */     // Label 1191: @46031
     /* 46031 */     GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(46087), // Rule ID 1419 //
     /* 46036 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46039 */       // MIs[0] Operand 1
     /* 46039 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46044 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46048 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46052 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46052 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46055 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46059 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46064 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46068 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46072 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46074 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46077 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46079 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46082 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46085 */       GIR_RootConstrainSelectedInstOperands,
     /* 46086 */       // GIR_Coverage, 1419,
     /* 46086 */       GIR_EraseRootFromParent_Done,
     /* 46087 */     // Label 1192: @46087
     /* 46087 */     GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(46143), // Rule ID 1420 //
     /* 46092 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46095 */       // MIs[0] Operand 1
     /* 46095 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46100 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46104 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46108 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46108 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46111 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46115 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46120 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46128 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46130 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46133 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46135 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46138 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46141 */       GIR_RootConstrainSelectedInstOperands,
     /* 46142 */       // GIR_Coverage, 1420,
     /* 46142 */       GIR_EraseRootFromParent_Done,
     /* 46143 */     // Label 1193: @46143
     /* 46143 */     GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(46175), // Rule ID 1421 //
     /* 46148 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46151 */       // MIs[0] Operand 1
     /* 46151 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46156 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46160 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46164 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46164 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46167 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46169 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46171 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46173 */       GIR_RootConstrainSelectedInstOperands,
     /* 46174 */       // GIR_Coverage, 1421,
     /* 46174 */       GIR_EraseRootFromParent_Done,
     /* 46175 */     // Label 1194: @46175
     /* 46175 */     GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(46207), // Rule ID 1422 //
     /* 46180 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46183 */       // MIs[0] Operand 1
     /* 46183 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46188 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46192 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46196 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46196 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46199 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46201 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46203 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46205 */       GIR_RootConstrainSelectedInstOperands,
     /* 46206 */       // GIR_Coverage, 1422,
     /* 46206 */       GIR_EraseRootFromParent_Done,
     /* 46207 */     // Label 1195: @46207
     /* 46207 */     GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(46263), // Rule ID 1423 //
     /* 46212 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46215 */       // MIs[0] Operand 1
     /* 46215 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46220 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46224 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46228 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46228 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46231 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46235 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46240 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46244 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46248 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46250 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46253 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46255 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46258 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46261 */       GIR_RootConstrainSelectedInstOperands,
     /* 46262 */       // GIR_Coverage, 1423,
     /* 46262 */       GIR_EraseRootFromParent_Done,
     /* 46263 */     // Label 1196: @46263
     /* 46263 */     GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(46319), // Rule ID 1424 //
     /* 46268 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46271 */       // MIs[0] Operand 1
     /* 46271 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46276 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46280 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46284 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46284 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46287 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46291 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46296 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46300 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46306 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46309 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46311 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46314 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46317 */       GIR_RootConstrainSelectedInstOperands,
     /* 46318 */       // GIR_Coverage, 1424,
     /* 46318 */       GIR_EraseRootFromParent_Done,
     /* 46319 */     // Label 1197: @46319
     /* 46319 */     GIM_Reject,
     /* 46320 */   // Label 1187: @46320
     /* 46320 */   GIM_Reject,
     /* 46321 */   // Label 1185: @46321
     /* 46321 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(46737),
     /* 46326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 46329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46333 */     GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(46389), // Rule ID 1561 //
     /* 46338 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46341 */       // MIs[0] Operand 1
     /* 46341 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46346 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46350 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46354 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i64] })
     /* 46354 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46357 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46361 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46366 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46370 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46374 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46376 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 46379 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46381 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46384 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46387 */       GIR_RootConstrainSelectedInstOperands,
     /* 46388 */       // GIR_Coverage, 1561,
     /* 46388 */       GIR_EraseRootFromParent_Done,
     /* 46389 */     // Label 1199: @46389
     /* 46389 */     GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(46448), // Rule ID 1562 //
     /* 46394 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46397 */       // MIs[0] Operand 1
     /* 46397 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 46402 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46406 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46410 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs))
     /* 46410 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46413 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46417 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46422 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46426 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46430 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46432 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46435 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46437 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46443 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46446 */       GIR_RootConstrainSelectedInstOperands,
     /* 46447 */       // GIR_Coverage, 1562,
     /* 46447 */       GIR_EraseRootFromParent_Done,
     /* 46448 */     // Label 1200: @46448
     /* 46448 */     GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(46504), // Rule ID 1563 //
     /* 46453 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46456 */       // MIs[0] Operand 1
     /* 46456 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46461 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46465 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46469 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46469 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46472 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46476 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46481 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46485 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46489 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46491 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46494 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46496 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46499 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46502 */       GIR_RootConstrainSelectedInstOperands,
     /* 46503 */       // GIR_Coverage, 1563,
     /* 46503 */       GIR_EraseRootFromParent_Done,
     /* 46504 */     // Label 1201: @46504
     /* 46504 */     GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(46560), // Rule ID 1564 //
     /* 46509 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46512 */       // MIs[0] Operand 1
     /* 46512 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46517 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46521 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46525 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46525 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46528 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46532 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46537 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46541 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46545 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46547 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46550 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46552 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46555 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46558 */       GIR_RootConstrainSelectedInstOperands,
     /* 46559 */       // GIR_Coverage, 1564,
     /* 46559 */       GIR_EraseRootFromParent_Done,
     /* 46560 */     // Label 1202: @46560
     /* 46560 */     GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(46592), // Rule ID 1565 //
     /* 46565 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46568 */       // MIs[0] Operand 1
     /* 46568 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46573 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46577 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46581 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46581 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46584 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46586 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46588 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46590 */       GIR_RootConstrainSelectedInstOperands,
     /* 46591 */       // GIR_Coverage, 1565,
     /* 46591 */       GIR_EraseRootFromParent_Done,
     /* 46592 */     // Label 1203: @46592
     /* 46592 */     GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(46624), // Rule ID 1566 //
     /* 46597 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46600 */       // MIs[0] Operand 1
     /* 46600 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46605 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46609 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46613 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46613 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46616 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46618 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46620 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46622 */       GIR_RootConstrainSelectedInstOperands,
     /* 46623 */       // GIR_Coverage, 1566,
     /* 46623 */       GIR_EraseRootFromParent_Done,
     /* 46624 */     // Label 1204: @46624
     /* 46624 */     GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(46680), // Rule ID 1567 //
     /* 46629 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46632 */       // MIs[0] Operand 1
     /* 46632 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46637 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46641 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46645 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46645 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46648 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46652 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46657 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46661 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46665 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46667 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46670 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46672 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46675 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46678 */       GIR_RootConstrainSelectedInstOperands,
     /* 46679 */       // GIR_Coverage, 1567,
     /* 46679 */       GIR_EraseRootFromParent_Done,
     /* 46680 */     // Label 1205: @46680
     /* 46680 */     GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(46736), // Rule ID 1568 //
     /* 46685 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46688 */       // MIs[0] Operand 1
     /* 46688 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46693 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46697 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46701 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46701 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46704 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46708 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46713 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46717 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46721 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46723 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46726 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46728 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46731 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46734 */       GIR_RootConstrainSelectedInstOperands,
     /* 46735 */       // GIR_Coverage, 1568,
     /* 46735 */       GIR_EraseRootFromParent_Done,
     /* 46736 */     // Label 1206: @46736
     /* 46736 */     GIM_Reject,
     /* 46737 */   // Label 1198: @46737
     /* 46737 */   GIM_Reject,
     /* 46738 */   // Label 1186: @46738
     /* 46738 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(47774),
     /* 46743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 46746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 46749 */     GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(46809), // Rule ID 1877 //
     /* 46754 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46757 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46761 */       // MIs[0] Operand 1
     /* 46761 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46766 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46770 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46774 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46774 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46777 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46781 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46786 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46790 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46794 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46796 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 46799 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46801 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46804 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46807 */       GIR_RootConstrainSelectedInstOperands,
     /* 46808 */       // GIR_Coverage, 1877,
     /* 46808 */       GIR_EraseRootFromParent_Done,
     /* 46809 */     // Label 1208: @46809
     /* 46809 */     GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(46886), // Rule ID 1879 //
     /* 46814 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46817 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46821 */       // MIs[0] Operand 1
     /* 46821 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46826 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46830 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46834 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46834 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46837 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 46841 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46846 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46849 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46851 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46854 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46858 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46863 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46867 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46871 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 46878 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46881 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 46884 */       GIR_RootConstrainSelectedInstOperands,
     /* 46885 */       // GIR_Coverage, 1879,
     /* 46885 */       GIR_EraseRootFromParent_Done,
     /* 46886 */     // Label 1209: @46886
     /* 46886 */     GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(46922), // Rule ID 1881 //
     /* 46891 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46894 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46898 */       // MIs[0] Operand 1
     /* 46898 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46903 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46907 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46911 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 46911 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46914 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46916 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46918 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46920 */       GIR_RootConstrainSelectedInstOperands,
     /* 46921 */       // GIR_Coverage, 1881,
     /* 46921 */       GIR_EraseRootFromParent_Done,
     /* 46922 */     // Label 1210: @46922
     /* 46922 */     GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(46999), // Rule ID 1882 //
     /* 46927 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46930 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46934 */       // MIs[0] Operand 1
     /* 46934 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46939 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46943 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46947 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImm16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46947 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46950 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImm16),
     /* 46954 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46959 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46962 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46964 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46967 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46971 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46976 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46980 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46984 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46986 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46989 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 46991 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46994 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 46997 */       GIR_RootConstrainSelectedInstOperands,
     /* 46998 */       // GIR_Coverage, 1882,
     /* 46998 */       GIR_EraseRootFromParent_Done,
     /* 46999 */     // Label 1211: @46999
     /* 46999 */     GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(47035), // Rule ID 1883 //
     /* 47004 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47007 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47011 */       // MIs[0] Operand 1
     /* 47011 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 47016 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47020 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47024 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47024 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 47027 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47029 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47031 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47033 */       GIR_RootConstrainSelectedInstOperands,
     /* 47034 */       // GIR_Coverage, 1883,
     /* 47034 */       GIR_EraseRootFromParent_Done,
     /* 47035 */     // Label 1212: @47035
     /* 47035 */     GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(47112), // Rule ID 1885 //
     /* 47040 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47043 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47047 */       // MIs[0] Operand 1
     /* 47047 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47052 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47056 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47060 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } (LiRxImmX16:{ *:[i32] } 0:{ *:[i32] }), (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs))
     /* 47060 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47063 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47067 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47072 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47076 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47080 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47082 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47085 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47089 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47094 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 47097 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47104 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47107 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47110 */       GIR_RootConstrainSelectedInstOperands,
     /* 47111 */       // GIR_Coverage, 1885,
     /* 47111 */       GIR_EraseRootFromParent_Done,
     /* 47112 */     // Label 1213: @47112
     /* 47112 */     GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(47189), // Rule ID 1886 //
     /* 47117 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47120 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47124 */       // MIs[0] Operand 1
     /* 47124 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47129 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47133 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47137 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47137 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47140 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47144 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47149 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47152 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47154 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47157 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47161 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47166 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47170 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47174 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47176 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47179 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47181 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47184 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47187 */       GIR_RootConstrainSelectedInstOperands,
     /* 47188 */       // GIR_Coverage, 1886,
     /* 47188 */       GIR_EraseRootFromParent_Done,
     /* 47189 */     // Label 1214: @47189
     /* 47189 */     GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(47225), // Rule ID 1887 //
     /* 47194 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47197 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47201 */       // MIs[0] Operand 1
     /* 47201 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47206 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47210 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47214 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 47214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47219 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47221 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47223 */       GIR_RootConstrainSelectedInstOperands,
     /* 47224 */       // GIR_Coverage, 1887,
     /* 47224 */       GIR_EraseRootFromParent_Done,
     /* 47225 */     // Label 1215: @47225
     /* 47225 */     GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(47302), // Rule ID 1888 //
     /* 47230 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47233 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47237 */       // MIs[0] Operand 1
     /* 47237 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47242 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47246 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47250 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47250 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47253 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47257 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47262 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47265 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47267 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47270 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47274 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47279 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47283 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47287 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47289 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47292 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47294 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47297 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47300 */       GIR_RootConstrainSelectedInstOperands,
     /* 47301 */       // GIR_Coverage, 1888,
     /* 47301 */       GIR_EraseRootFromParent_Done,
     /* 47302 */     // Label 1216: @47302
     /* 47302 */     GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(47338), // Rule ID 1889 //
     /* 47307 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47310 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47314 */       // MIs[0] Operand 1
     /* 47314 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 47319 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47323 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47327 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETULT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47327 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47330 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47332 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47334 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47336 */       GIR_RootConstrainSelectedInstOperands,
     /* 47337 */       // GIR_Coverage, 1889,
     /* 47337 */       GIR_EraseRootFromParent_Done,
     /* 47338 */     // Label 1217: @47338
     /* 47338 */     GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(47398), // Rule ID 2199 //
     /* 47343 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47346 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47350 */       // MIs[0] Operand 1
     /* 47350 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 47355 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47359 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47363 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47363 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47366 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47370 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47375 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47379 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47383 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47385 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 47388 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47390 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47393 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47396 */       GIR_RootConstrainSelectedInstOperands,
     /* 47397 */       // GIR_Coverage, 2199,
     /* 47397 */       GIR_EraseRootFromParent_Done,
     /* 47398 */     // Label 1218: @47398
     /* 47398 */     GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(47461), // Rule ID 2200 //
     /* 47403 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47406 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47410 */       // MIs[0] Operand 1
     /* 47410 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47415 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47419 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47423 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 47423 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47426 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47430 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47435 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47439 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47443 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47445 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47448 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47450 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 47456 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47459 */       GIR_RootConstrainSelectedInstOperands,
     /* 47460 */       // GIR_Coverage, 2200,
     /* 47460 */       GIR_EraseRootFromParent_Done,
     /* 47461 */     // Label 1219: @47461
     /* 47461 */     GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(47521), // Rule ID 2201 //
     /* 47466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47469 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47473 */       // MIs[0] Operand 1
     /* 47473 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 47478 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47482 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47486 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47486 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47489 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47493 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47498 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47502 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47506 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47508 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47511 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47513 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47516 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47519 */       GIR_RootConstrainSelectedInstOperands,
     /* 47520 */       // GIR_Coverage, 2201,
     /* 47520 */       GIR_EraseRootFromParent_Done,
     /* 47521 */     // Label 1220: @47521
     /* 47521 */     GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(47581), // Rule ID 2202 //
     /* 47526 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47529 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47533 */       // MIs[0] Operand 1
     /* 47533 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47538 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47542 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47546 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47546 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47549 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47553 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47558 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47562 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47566 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47568 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47571 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47573 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47576 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47579 */       GIR_RootConstrainSelectedInstOperands,
     /* 47580 */       // GIR_Coverage, 2202,
     /* 47580 */       GIR_EraseRootFromParent_Done,
     /* 47581 */     // Label 1221: @47581
     /* 47581 */     GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(47617), // Rule ID 2203 //
     /* 47586 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47589 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47593 */       // MIs[0] Operand 1
     /* 47593 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 47598 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47602 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47606 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47606 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47609 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47611 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47613 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47615 */       GIR_RootConstrainSelectedInstOperands,
     /* 47616 */       // GIR_Coverage, 2203,
     /* 47616 */       GIR_EraseRootFromParent_Done,
     /* 47617 */     // Label 1222: @47617
     /* 47617 */     GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(47653), // Rule ID 2204 //
     /* 47622 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47625 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47629 */       // MIs[0] Operand 1
     /* 47629 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47634 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47638 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47642 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47647 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47649 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47651 */       GIR_RootConstrainSelectedInstOperands,
     /* 47652 */       // GIR_Coverage, 2204,
     /* 47652 */       GIR_EraseRootFromParent_Done,
     /* 47653 */     // Label 1223: @47653
     /* 47653 */     GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(47713), // Rule ID 2205 //
     /* 47658 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47661 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47665 */       // MIs[0] Operand 1
     /* 47665 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 47670 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47674 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47678 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47678 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47681 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47685 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47690 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47694 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47700 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47703 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47705 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47708 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47711 */       GIR_RootConstrainSelectedInstOperands,
     /* 47712 */       // GIR_Coverage, 2205,
     /* 47712 */       GIR_EraseRootFromParent_Done,
     /* 47713 */     // Label 1224: @47713
     /* 47713 */     GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(47773), // Rule ID 2206 //
     /* 47718 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47721 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47725 */       // MIs[0] Operand 1
     /* 47725 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47730 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47734 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47738 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47738 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47741 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47745 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47750 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47754 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47758 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47760 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47763 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47765 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47768 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47771 */       GIR_RootConstrainSelectedInstOperands,
     /* 47772 */       // GIR_Coverage, 2206,
     /* 47772 */       GIR_EraseRootFromParent_Done,
     /* 47773 */     // Label 1225: @47773
     /* 47773 */     GIM_Reject,
     /* 47774 */   // Label 1207: @47774
     /* 47774 */   GIM_Reject,
     /* 47775 */ // Label 1161: @47775
     /* 47775 */ GIM_Reject,
     /* 47776 */ // Label 42: @47776
     /* 47776 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(49481),
     /* 47781 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 47784 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1229*/ GIMT_Encode4(48279),
     /* 47795 */   /*GILLT_s32*//*Label 1227*/ GIMT_Encode4(47803),
     /* 47799 */   /*GILLT_s64*//*Label 1228*/ GIMT_Encode4(48041),
     /* 47803 */   // Label 1227: @47803
     /* 47803 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(48040),
     /* 47808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 47811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 47815 */     GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(47847), // Rule ID 312 //
     /* 47820 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47823 */       // MIs[0] Operand 1
     /* 47823 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 47828 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47832 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47836 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47836 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 47839 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47841 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47843 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47845 */       GIR_RootConstrainSelectedInstOperands,
     /* 47846 */       // GIR_Coverage, 312,
     /* 47846 */       GIR_EraseRootFromParent_Done,
     /* 47847 */     // Label 1231: @47847
     /* 47847 */     GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(47879), // Rule ID 313 //
     /* 47852 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47855 */       // MIs[0] Operand 1
     /* 47855 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 47860 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47864 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47868 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 47871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47873 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47875 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47877 */       GIR_RootConstrainSelectedInstOperands,
     /* 47878 */       // GIR_Coverage, 313,
     /* 47878 */       GIR_EraseRootFromParent_Done,
     /* 47879 */     // Label 1232: @47879
     /* 47879 */     GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(47911), // Rule ID 314 //
     /* 47884 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47887 */       // MIs[0] Operand 1
     /* 47887 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 47892 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47896 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47900 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47900 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 47903 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47905 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47907 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47909 */       GIR_RootConstrainSelectedInstOperands,
     /* 47910 */       // GIR_Coverage, 314,
     /* 47910 */       GIR_EraseRootFromParent_Done,
     /* 47911 */     // Label 1233: @47911
     /* 47911 */     GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(47943), // Rule ID 315 //
     /* 47916 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47919 */       // MIs[0] Operand 1
     /* 47919 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 47924 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47928 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47932 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47932 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S),
     /* 47935 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47937 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47939 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47941 */       GIR_RootConstrainSelectedInstOperands,
     /* 47942 */       // GIR_Coverage, 315,
     /* 47942 */       GIR_EraseRootFromParent_Done,
     /* 47943 */     // Label 1234: @47943
     /* 47943 */     GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(47975), // Rule ID 316 //
     /* 47948 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47951 */       // MIs[0] Operand 1
     /* 47951 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 47956 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47960 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47964 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47964 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S),
     /* 47967 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47969 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47971 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47973 */       GIR_RootConstrainSelectedInstOperands,
     /* 47974 */       // GIR_Coverage, 316,
     /* 47974 */       GIR_EraseRootFromParent_Done,
     /* 47975 */     // Label 1235: @47975
     /* 47975 */     GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(48007), // Rule ID 317 //
     /* 47980 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47983 */       // MIs[0] Operand 1
     /* 47983 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 47988 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47992 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47996 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47996 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S),
     /* 47999 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48001 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48003 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48005 */       GIR_RootConstrainSelectedInstOperands,
     /* 48006 */       // GIR_Coverage, 317,
     /* 48006 */       GIR_EraseRootFromParent_Done,
     /* 48007 */     // Label 1236: @48007
     /* 48007 */     GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(48039), // Rule ID 318 //
     /* 48012 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48015 */       // MIs[0] Operand 1
     /* 48015 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48020 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48024 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48028 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S),
     /* 48031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48033 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48035 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48037 */       GIR_RootConstrainSelectedInstOperands,
     /* 48038 */       // GIR_Coverage, 318,
     /* 48038 */       GIR_EraseRootFromParent_Done,
     /* 48039 */     // Label 1237: @48039
     /* 48039 */     GIM_Reject,
     /* 48040 */   // Label 1230: @48040
     /* 48040 */   GIM_Reject,
     /* 48041 */   // Label 1228: @48041
     /* 48041 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(48278),
     /* 48046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48053 */     GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(48085), // Rule ID 319 //
     /* 48058 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48061 */       // MIs[0] Operand 1
     /* 48061 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48066 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48070 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48074 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48074 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 48077 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48079 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48081 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48083 */       GIR_RootConstrainSelectedInstOperands,
     /* 48084 */       // GIR_Coverage, 319,
     /* 48084 */       GIR_EraseRootFromParent_Done,
     /* 48085 */     // Label 1239: @48085
     /* 48085 */     GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(48117), // Rule ID 320 //
     /* 48090 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48093 */       // MIs[0] Operand 1
     /* 48093 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48098 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48102 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48106 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48106 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 48109 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48111 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48113 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48115 */       GIR_RootConstrainSelectedInstOperands,
     /* 48116 */       // GIR_Coverage, 320,
     /* 48116 */       GIR_EraseRootFromParent_Done,
     /* 48117 */     // Label 1240: @48117
     /* 48117 */     GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(48149), // Rule ID 321 //
     /* 48122 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48125 */       // MIs[0] Operand 1
     /* 48125 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48130 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48134 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48138 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48138 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 48141 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48143 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48145 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48147 */       GIR_RootConstrainSelectedInstOperands,
     /* 48148 */       // GIR_Coverage, 321,
     /* 48148 */       GIR_EraseRootFromParent_Done,
     /* 48149 */     // Label 1241: @48149
     /* 48149 */     GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(48181), // Rule ID 322 //
     /* 48154 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48157 */       // MIs[0] Operand 1
     /* 48157 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48162 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48166 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48170 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48170 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D),
     /* 48173 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48175 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48177 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48179 */       GIR_RootConstrainSelectedInstOperands,
     /* 48180 */       // GIR_Coverage, 322,
     /* 48180 */       GIR_EraseRootFromParent_Done,
     /* 48181 */     // Label 1242: @48181
     /* 48181 */     GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(48213), // Rule ID 323 //
     /* 48186 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48189 */       // MIs[0] Operand 1
     /* 48189 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48194 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48198 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48202 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48202 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D),
     /* 48205 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48207 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48209 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48211 */       GIR_RootConstrainSelectedInstOperands,
     /* 48212 */       // GIR_Coverage, 323,
     /* 48212 */       GIR_EraseRootFromParent_Done,
     /* 48213 */     // Label 1243: @48213
     /* 48213 */     GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(48245), // Rule ID 324 //
     /* 48218 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48221 */       // MIs[0] Operand 1
     /* 48221 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48226 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48230 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48234 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48234 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D),
     /* 48237 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48239 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48241 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48243 */       GIR_RootConstrainSelectedInstOperands,
     /* 48244 */       // GIR_Coverage, 324,
     /* 48244 */       GIR_EraseRootFromParent_Done,
     /* 48245 */     // Label 1244: @48245
     /* 48245 */     GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(48277), // Rule ID 325 //
     /* 48250 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48253 */       // MIs[0] Operand 1
     /* 48253 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48258 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48262 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48266 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48266 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D),
     /* 48269 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48271 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48273 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48275 */       GIR_RootConstrainSelectedInstOperands,
     /* 48276 */       // GIR_Coverage, 325,
     /* 48276 */       GIR_EraseRootFromParent_Done,
     /* 48277 */     // Label 1245: @48277
     /* 48277 */     GIM_Reject,
     /* 48278 */   // Label 1238: @48278
     /* 48278 */   GIM_Reject,
     /* 48279 */   // Label 1229: @48279
     /* 48279 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1248*/ GIMT_Encode4(48774),
     /* 48290 */   /*GILLT_s32*//*Label 1246*/ GIMT_Encode4(48298),
     /* 48294 */   /*GILLT_s64*//*Label 1247*/ GIMT_Encode4(48536),
     /* 48298 */   // Label 1246: @48298
     /* 48298 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(48535),
     /* 48303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48310 */     GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(48342), // Rule ID 1193 //
     /* 48315 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48318 */       // MIs[0] Operand 1
     /* 48318 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48323 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48327 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48331 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48331 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 48334 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48336 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48338 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48340 */       GIR_RootConstrainSelectedInstOperands,
     /* 48341 */       // GIR_Coverage, 1193,
     /* 48341 */       GIR_EraseRootFromParent_Done,
     /* 48342 */     // Label 1250: @48342
     /* 48342 */     GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(48374), // Rule ID 1194 //
     /* 48347 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48350 */       // MIs[0] Operand 1
     /* 48350 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48355 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48359 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48363 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48363 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 48366 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48368 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48370 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48372 */       GIR_RootConstrainSelectedInstOperands,
     /* 48373 */       // GIR_Coverage, 1194,
     /* 48373 */       GIR_EraseRootFromParent_Done,
     /* 48374 */     // Label 1251: @48374
     /* 48374 */     GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(48406), // Rule ID 1195 //
     /* 48379 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48382 */       // MIs[0] Operand 1
     /* 48382 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48387 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48391 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48395 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48395 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 48398 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48400 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48402 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48404 */       GIR_RootConstrainSelectedInstOperands,
     /* 48405 */       // GIR_Coverage, 1195,
     /* 48405 */       GIR_EraseRootFromParent_Done,
     /* 48406 */     // Label 1252: @48406
     /* 48406 */     GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(48438), // Rule ID 1196 //
     /* 48411 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48414 */       // MIs[0] Operand 1
     /* 48414 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48419 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48423 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48427 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48427 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S_MMR6),
     /* 48430 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48432 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48434 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48436 */       GIR_RootConstrainSelectedInstOperands,
     /* 48437 */       // GIR_Coverage, 1196,
     /* 48437 */       GIR_EraseRootFromParent_Done,
     /* 48438 */     // Label 1253: @48438
     /* 48438 */     GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(48470), // Rule ID 1197 //
     /* 48443 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48446 */       // MIs[0] Operand 1
     /* 48446 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48451 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48455 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48459 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S_MMR6),
     /* 48462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48464 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48466 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48468 */       GIR_RootConstrainSelectedInstOperands,
     /* 48469 */       // GIR_Coverage, 1197,
     /* 48469 */       GIR_EraseRootFromParent_Done,
     /* 48470 */     // Label 1254: @48470
     /* 48470 */     GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(48502), // Rule ID 1198 //
     /* 48475 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48478 */       // MIs[0] Operand 1
     /* 48478 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48483 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48487 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48491 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48491 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S_MMR6),
     /* 48494 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48496 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48498 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48500 */       GIR_RootConstrainSelectedInstOperands,
     /* 48501 */       // GIR_Coverage, 1198,
     /* 48501 */       GIR_EraseRootFromParent_Done,
     /* 48502 */     // Label 1255: @48502
     /* 48502 */     GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(48534), // Rule ID 1199 //
     /* 48507 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48510 */       // MIs[0] Operand 1
     /* 48510 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48515 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48519 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48523 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48523 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S_MMR6),
     /* 48526 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48528 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48530 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48532 */       GIR_RootConstrainSelectedInstOperands,
     /* 48533 */       // GIR_Coverage, 1199,
     /* 48533 */       GIR_EraseRootFromParent_Done,
     /* 48534 */     // Label 1256: @48534
     /* 48534 */     GIM_Reject,
     /* 48535 */   // Label 1249: @48535
     /* 48535 */   GIM_Reject,
     /* 48536 */   // Label 1247: @48536
     /* 48536 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(48773),
     /* 48541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48548 */     GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(48580), // Rule ID 1200 //
     /* 48553 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48556 */       // MIs[0] Operand 1
     /* 48556 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48561 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48565 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48569 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 48572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48574 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48576 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48578 */       GIR_RootConstrainSelectedInstOperands,
     /* 48579 */       // GIR_Coverage, 1200,
     /* 48579 */       GIR_EraseRootFromParent_Done,
     /* 48580 */     // Label 1258: @48580
     /* 48580 */     GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(48612), // Rule ID 1201 //
     /* 48585 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48588 */       // MIs[0] Operand 1
     /* 48588 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48593 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48597 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48601 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48601 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 48604 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48606 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48608 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48610 */       GIR_RootConstrainSelectedInstOperands,
     /* 48611 */       // GIR_Coverage, 1201,
     /* 48611 */       GIR_EraseRootFromParent_Done,
     /* 48612 */     // Label 1259: @48612
     /* 48612 */     GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(48644), // Rule ID 1202 //
     /* 48617 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48620 */       // MIs[0] Operand 1
     /* 48620 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48625 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48629 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48633 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48633 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 48636 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48638 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48640 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48642 */       GIR_RootConstrainSelectedInstOperands,
     /* 48643 */       // GIR_Coverage, 1202,
     /* 48643 */       GIR_EraseRootFromParent_Done,
     /* 48644 */     // Label 1260: @48644
     /* 48644 */     GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(48676), // Rule ID 1203 //
     /* 48649 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48652 */       // MIs[0] Operand 1
     /* 48652 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48657 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48661 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48665 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48665 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D_MMR6),
     /* 48668 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48670 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48672 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48674 */       GIR_RootConstrainSelectedInstOperands,
     /* 48675 */       // GIR_Coverage, 1203,
     /* 48675 */       GIR_EraseRootFromParent_Done,
     /* 48676 */     // Label 1261: @48676
     /* 48676 */     GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(48708), // Rule ID 1204 //
     /* 48681 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48684 */       // MIs[0] Operand 1
     /* 48684 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48689 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48693 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48697 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48697 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D_MMR6),
     /* 48700 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48702 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48704 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48706 */       GIR_RootConstrainSelectedInstOperands,
     /* 48707 */       // GIR_Coverage, 1204,
     /* 48707 */       GIR_EraseRootFromParent_Done,
     /* 48708 */     // Label 1262: @48708
     /* 48708 */     GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(48740), // Rule ID 1205 //
     /* 48713 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48716 */       // MIs[0] Operand 1
     /* 48716 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48721 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48725 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48729 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48729 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D_MMR6),
     /* 48732 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48734 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48736 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48738 */       GIR_RootConstrainSelectedInstOperands,
     /* 48739 */       // GIR_Coverage, 1205,
     /* 48739 */       GIR_EraseRootFromParent_Done,
     /* 48740 */     // Label 1263: @48740
     /* 48740 */     GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(48772), // Rule ID 1206 //
     /* 48745 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48748 */       // MIs[0] Operand 1
     /* 48748 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48753 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48757 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48761 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48761 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D_MMR6),
     /* 48764 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48766 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48768 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48770 */       GIR_RootConstrainSelectedInstOperands,
     /* 48771 */       // GIR_Coverage, 1206,
     /* 48771 */       GIR_EraseRootFromParent_Done,
     /* 48772 */     // Label 1264: @48772
     /* 48772 */     GIM_Reject,
     /* 48773 */   // Label 1257: @48773
     /* 48773 */   GIM_Reject,
     /* 48774 */   // Label 1248: @48774
     /* 48774 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1267*/ GIMT_Encode4(49127),
     /* 48785 */   /*GILLT_s32*//*Label 1265*/ GIMT_Encode4(48793),
     /* 48789 */   /*GILLT_s64*//*Label 1266*/ GIMT_Encode4(48960),
     /* 48793 */   // Label 1265: @48793
     /* 48793 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(48959),
     /* 48798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48805 */     GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(48856), // Rule ID 1750 //
     /* 48810 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48813 */       // MIs[0] Operand 1
     /* 48813 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 48818 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48818 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48821 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 48825 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48830 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48834 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48838 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48840 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48843 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48845 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48848 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48854 */       GIR_RootConstrainSelectedInstOperands,
     /* 48855 */       // GIR_Coverage, 1750,
     /* 48855 */       GIR_EraseRootFromParent_Done,
     /* 48856 */     // Label 1269: @48856
     /* 48856 */     GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(48907), // Rule ID 1751 //
     /* 48861 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48864 */       // MIs[0] Operand 1
     /* 48864 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 48869 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48869 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48872 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 48876 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48881 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48885 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48889 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48891 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48894 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48896 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48899 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48905 */       GIR_RootConstrainSelectedInstOperands,
     /* 48906 */       // GIR_Coverage, 1751,
     /* 48906 */       GIR_EraseRootFromParent_Done,
     /* 48907 */     // Label 1270: @48907
     /* 48907 */     GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(48958), // Rule ID 1752 //
     /* 48912 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48915 */       // MIs[0] Operand 1
     /* 48915 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 48920 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48920 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48923 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 48927 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48932 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48936 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48940 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48942 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48945 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48947 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48950 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48956 */       GIR_RootConstrainSelectedInstOperands,
     /* 48957 */       // GIR_Coverage, 1752,
     /* 48957 */       GIR_EraseRootFromParent_Done,
     /* 48958 */     // Label 1271: @48958
     /* 48958 */     GIM_Reject,
     /* 48959 */   // Label 1268: @48959
     /* 48959 */   GIM_Reject,
     /* 48960 */   // Label 1266: @48960
     /* 48960 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(49126),
     /* 48965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48972 */     GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(49023), // Rule ID 1759 //
     /* 48977 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48980 */       // MIs[0] Operand 1
     /* 48980 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 48985 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 48985 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48988 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 48992 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48997 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49001 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49005 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49007 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49010 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49012 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49015 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49021 */       GIR_RootConstrainSelectedInstOperands,
     /* 49022 */       // GIR_Coverage, 1759,
     /* 49022 */       GIR_EraseRootFromParent_Done,
     /* 49023 */     // Label 1273: @49023
     /* 49023 */     GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(49074), // Rule ID 1760 //
     /* 49028 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49031 */       // MIs[0] Operand 1
     /* 49031 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49036 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49036 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49039 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 49043 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49048 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49052 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49058 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49061 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49063 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49066 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49072 */       GIR_RootConstrainSelectedInstOperands,
     /* 49073 */       // GIR_Coverage, 1760,
     /* 49073 */       GIR_EraseRootFromParent_Done,
     /* 49074 */     // Label 1274: @49074
     /* 49074 */     GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(49125), // Rule ID 1761 //
     /* 49079 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49082 */       // MIs[0] Operand 1
     /* 49082 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49087 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49087 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49090 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 49094 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49099 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49103 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49109 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49112 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49114 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49117 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49123 */       GIR_RootConstrainSelectedInstOperands,
     /* 49124 */       // GIR_Coverage, 1761,
     /* 49124 */       GIR_EraseRootFromParent_Done,
     /* 49125 */     // Label 1275: @49125
     /* 49125 */     GIM_Reject,
     /* 49126 */   // Label 1272: @49126
     /* 49126 */   GIM_Reject,
     /* 49127 */   // Label 1267: @49127
     /* 49127 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1278*/ GIMT_Encode4(49480),
     /* 49138 */   /*GILLT_s32*//*Label 1276*/ GIMT_Encode4(49146),
     /* 49142 */   /*GILLT_s64*//*Label 1277*/ GIMT_Encode4(49313),
     /* 49146 */   // Label 1276: @49146
     /* 49146 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(49312),
     /* 49151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49158 */     GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(49209), // Rule ID 2298 //
     /* 49163 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49166 */       // MIs[0] Operand 1
     /* 49166 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49171 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49171 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49174 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 49178 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49183 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49187 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49191 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49193 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49196 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49198 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49201 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49207 */       GIR_RootConstrainSelectedInstOperands,
     /* 49208 */       // GIR_Coverage, 2298,
     /* 49208 */       GIR_EraseRootFromParent_Done,
     /* 49209 */     // Label 1280: @49209
     /* 49209 */     GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(49260), // Rule ID 2299 //
     /* 49214 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49217 */       // MIs[0] Operand 1
     /* 49217 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49222 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49222 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49225 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 49229 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49234 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49238 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49242 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49244 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49247 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49249 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49252 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49258 */       GIR_RootConstrainSelectedInstOperands,
     /* 49259 */       // GIR_Coverage, 2299,
     /* 49259 */       GIR_EraseRootFromParent_Done,
     /* 49260 */     // Label 1281: @49260
     /* 49260 */     GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(49311), // Rule ID 2300 //
     /* 49265 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49268 */       // MIs[0] Operand 1
     /* 49268 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49273 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49273 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49276 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 49280 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49285 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49289 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49293 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49295 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49298 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49300 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49303 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49309 */       GIR_RootConstrainSelectedInstOperands,
     /* 49310 */       // GIR_Coverage, 2300,
     /* 49310 */       GIR_EraseRootFromParent_Done,
     /* 49311 */     // Label 1282: @49311
     /* 49311 */     GIM_Reject,
     /* 49312 */   // Label 1279: @49312
     /* 49312 */   GIM_Reject,
     /* 49313 */   // Label 1277: @49313
     /* 49313 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(49479),
     /* 49318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 49321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49325 */     GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(49376), // Rule ID 2307 //
     /* 49330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49333 */       // MIs[0] Operand 1
     /* 49333 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49338 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49338 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49341 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 49345 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49350 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49354 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49358 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49360 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49363 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49365 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49368 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49374 */       GIR_RootConstrainSelectedInstOperands,
     /* 49375 */       // GIR_Coverage, 2307,
     /* 49375 */       GIR_EraseRootFromParent_Done,
     /* 49376 */     // Label 1284: @49376
     /* 49376 */     GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(49427), // Rule ID 2308 //
     /* 49381 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49384 */       // MIs[0] Operand 1
     /* 49384 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49389 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49389 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49392 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 49396 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49401 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49405 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49409 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49411 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49414 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49416 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49419 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49425 */       GIR_RootConstrainSelectedInstOperands,
     /* 49426 */       // GIR_Coverage, 2308,
     /* 49426 */       GIR_EraseRootFromParent_Done,
     /* 49427 */     // Label 1285: @49427
     /* 49427 */     GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(49478), // Rule ID 2309 //
     /* 49432 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49435 */       // MIs[0] Operand 1
     /* 49435 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49440 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49440 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49443 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 49447 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49452 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49456 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49460 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49462 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49465 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49467 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49470 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49476 */       GIR_RootConstrainSelectedInstOperands,
     /* 49477 */       // GIR_Coverage, 2309,
     /* 49477 */       GIR_EraseRootFromParent_Done,
     /* 49478 */     // Label 1286: @49478
     /* 49478 */     GIM_Reject,
     /* 49479 */   // Label 1283: @49479
     /* 49479 */   GIM_Reject,
     /* 49480 */   // Label 1278: @49480
     /* 49480 */   GIM_Reject,
     /* 49481 */ // Label 1226: @49481
     /* 49481 */ GIM_Reject,
     /* 49482 */ // Label 43: @49482
     /* 49482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1293*/ GIMT_Encode4(61519),
     /* 49493 */ /*GILLT_s32*//*Label 1287*/ GIMT_Encode4(49525),
     /* 49497 */ /*GILLT_s64*//*Label 1288*/ GIMT_Encode4(56202), GIMT_Encode4(0),
     /* 49505 */ /*GILLT_v2s64*//*Label 1289*/ GIMT_Encode4(61229), GIMT_Encode4(0),
     /* 49513 */ /*GILLT_v4s32*//*Label 1290*/ GIMT_Encode4(61303),
     /* 49517 */ /*GILLT_v8s16*//*Label 1291*/ GIMT_Encode4(61377),
     /* 49521 */ /*GILLT_v16s8*//*Label 1292*/ GIMT_Encode4(61424),
     /* 49525 */ // Label 1287: @49525
     /* 49525 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(49601), // Rule ID 1638 //
     /* 49530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49558 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49562 */   // MIs[1] Operand 1
     /* 49562 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49572 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49580 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49584 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49586 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 49589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49591 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49593 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49597 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49599 */   GIR_RootConstrainSelectedInstOperands,
     /* 49600 */   // GIR_Coverage, 1638,
     /* 49600 */   GIR_EraseRootFromParent_Done,
     /* 49601 */ // Label 1294: @49601
     /* 49601 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(49677), // Rule ID 1642 //
     /* 49606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49622 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49634 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49638 */   // MIs[1] Operand 1
     /* 49638 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49643 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49648 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49662 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 49665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49667 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49669 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49673 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49675 */   GIR_RootConstrainSelectedInstOperands,
     /* 49676 */   // GIR_Coverage, 1642,
     /* 49676 */   GIR_EraseRootFromParent_Done,
     /* 49677 */ // Label 1295: @49677
     /* 49677 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(49753), // Rule ID 1670 //
     /* 49682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49706 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49710 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49714 */   // MIs[1] Operand 1
     /* 49714 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49719 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49724 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49732 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49736 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49738 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 49741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49743 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49745 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49749 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49751 */   GIR_RootConstrainSelectedInstOperands,
     /* 49752 */   // GIR_Coverage, 1670,
     /* 49752 */   GIR_EraseRootFromParent_Done,
     /* 49753 */ // Label 1296: @49753
     /* 49753 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(49829), // Rule ID 1681 //
     /* 49758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49782 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49786 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49790 */   // MIs[1] Operand 1
     /* 49790 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49795 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49800 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49814 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 49817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49819 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49821 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49825 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49827 */   GIR_RootConstrainSelectedInstOperands,
     /* 49828 */   // GIR_Coverage, 1681,
     /* 49828 */   GIR_EraseRootFromParent_Done,
     /* 49829 */ // Label 1297: @49829
     /* 49829 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(49905), // Rule ID 1694 //
     /* 49834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49858 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49862 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49866 */   // MIs[1] Operand 1
     /* 49866 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49871 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49876 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49890 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 49893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49895 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49897 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49901 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49903 */   GIR_RootConstrainSelectedInstOperands,
     /* 49904 */   // GIR_Coverage, 1694,
     /* 49904 */   GIR_EraseRootFromParent_Done,
     /* 49905 */ // Label 1298: @49905
     /* 49905 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(49981), // Rule ID 1697 //
     /* 49910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49938 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49942 */   // MIs[1] Operand 1
     /* 49942 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49952 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49966 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 49969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49971 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49973 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49977 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49979 */   GIR_RootConstrainSelectedInstOperands,
     /* 49980 */   // GIR_Coverage, 1697,
     /* 49980 */   GIR_EraseRootFromParent_Done,
     /* 49981 */ // Label 1299: @49981
     /* 49981 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(50057), // Rule ID 1707 //
     /* 49986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50010 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50014 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50018 */   // MIs[1] Operand 1
     /* 50018 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50028 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50040 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50042 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 50045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50047 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50049 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50053 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50055 */   GIR_RootConstrainSelectedInstOperands,
     /* 50056 */   // GIR_Coverage, 1707,
     /* 50056 */   GIR_EraseRootFromParent_Done,
     /* 50057 */ // Label 1300: @50057
     /* 50057 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(50133), // Rule ID 1710 //
     /* 50062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50078 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50082 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50086 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50090 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50094 */   // MIs[1] Operand 1
     /* 50094 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50099 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50104 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50112 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50118 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 50121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50123 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50125 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50129 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50131 */   GIR_RootConstrainSelectedInstOperands,
     /* 50132 */   // GIR_Coverage, 1710,
     /* 50132 */   GIR_EraseRootFromParent_Done,
     /* 50133 */ // Label 1301: @50133
     /* 50133 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(50209), // Rule ID 1871 //
     /* 50138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50162 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50166 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50170 */   // MIs[1] Operand 1
     /* 50170 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50175 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50180 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50194 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBeqZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBeqZ),
     /* 50197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50199 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50201 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50203 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50207 */   GIR_RootConstrainSelectedInstOperands,
     /* 50208 */   // GIR_Coverage, 1871,
     /* 50208 */   GIR_EraseRootFromParent_Done,
     /* 50209 */ // Label 1302: @50209
     /* 50209 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(50285), // Rule ID 1874 //
     /* 50214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50242 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50246 */   // MIs[1] Operand 1
     /* 50246 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50251 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50256 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50270 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 50273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50275 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50277 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50279 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50283 */   GIR_RootConstrainSelectedInstOperands,
     /* 50284 */   // GIR_Coverage, 1874,
     /* 50284 */   GIR_EraseRootFromParent_Done,
     /* 50285 */ // Label 1303: @50285
     /* 50285 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(50361), // Rule ID 2218 //
     /* 50290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50314 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50318 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50322 */   // MIs[1] Operand 1
     /* 50322 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50327 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50332 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50340 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50346 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50351 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50353 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50357 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50359 */   GIR_RootConstrainSelectedInstOperands,
     /* 50360 */   // GIR_Coverage, 2218,
     /* 50360 */   GIR_EraseRootFromParent_Done,
     /* 50361 */ // Label 1304: @50361
     /* 50361 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(50437), // Rule ID 2222 //
     /* 50366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 50369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50390 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50394 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50398 */   // MIs[1] Operand 1
     /* 50398 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50403 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50408 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50422 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50427 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50429 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50433 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50435 */   GIR_RootConstrainSelectedInstOperands,
     /* 50436 */   // GIR_Coverage, 2222,
     /* 50436 */   GIR_EraseRootFromParent_Done,
     /* 50437 */ // Label 1305: @50437
     /* 50437 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(50513), // Rule ID 2232 //
     /* 50442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50466 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50470 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50474 */   // MIs[1] Operand 1
     /* 50474 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50479 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50484 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50498 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50503 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50505 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50509 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50511 */   GIR_RootConstrainSelectedInstOperands,
     /* 50512 */   // GIR_Coverage, 2232,
     /* 50512 */   GIR_EraseRootFromParent_Done,
     /* 50513 */ // Label 1306: @50513
     /* 50513 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(50589), // Rule ID 2236 //
     /* 50518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50542 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50546 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50550 */   // MIs[1] Operand 1
     /* 50550 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50555 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50560 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50574 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50579 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50581 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50585 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50587 */   GIR_RootConstrainSelectedInstOperands,
     /* 50588 */   // GIR_Coverage, 2236,
     /* 50588 */   GIR_EraseRootFromParent_Done,
     /* 50589 */ // Label 1307: @50589
     /* 50589 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(50665), // Rule ID 2266 //
     /* 50594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50618 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50622 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50626 */   // MIs[1] Operand 1
     /* 50626 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50631 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50636 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50650 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 50653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50655 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50657 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50661 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50663 */   GIR_RootConstrainSelectedInstOperands,
     /* 50664 */   // GIR_Coverage, 2266,
     /* 50664 */   GIR_EraseRootFromParent_Done,
     /* 50665 */ // Label 1308: @50665
     /* 50665 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(50741), // Rule ID 2269 //
     /* 50670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50686 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50690 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50694 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50698 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50702 */   // MIs[1] Operand 1
     /* 50702 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50707 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50712 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50724 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50726 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 50729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50731 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50733 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50737 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50739 */   GIR_RootConstrainSelectedInstOperands,
     /* 50740 */   // GIR_Coverage, 2269,
     /* 50740 */   GIR_EraseRootFromParent_Done,
     /* 50741 */ // Label 1309: @50741
     /* 50741 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(50839), // Rule ID 1629 //
     /* 50746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50774 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50778 */   // MIs[1] Operand 1
     /* 50778 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 50783 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50788 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50797 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50803 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 50810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50830 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50835 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50837 */   GIR_RootConstrainSelectedInstOperands,
     /* 50838 */   // GIR_Coverage, 1629,
     /* 50838 */   GIR_EraseRootFromParent_Done,
     /* 50839 */ // Label 1310: @50839
     /* 50839 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(50937), // Rule ID 1630 //
     /* 50844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50868 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50872 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50876 */   // MIs[1] Operand 1
     /* 50876 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 50881 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50886 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50901 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 50908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50913 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50917 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50928 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50933 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50935 */   GIR_RootConstrainSelectedInstOperands,
     /* 50936 */   // GIR_Coverage, 1630,
     /* 50936 */   GIR_EraseRootFromParent_Done,
     /* 50937 */ // Label 1311: @50937
     /* 50937 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(51035), // Rule ID 1633 //
     /* 50942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50970 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50974 */   // MIs[1] Operand 1
     /* 50974 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 50979 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50984 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50999 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 50999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 51006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51026 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51031 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51033 */   GIR_RootConstrainSelectedInstOperands,
     /* 51034 */   // GIR_Coverage, 1633,
     /* 51034 */   GIR_EraseRootFromParent_Done,
     /* 51035 */ // Label 1312: @51035
     /* 51035 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(51133), // Rule ID 1634 //
     /* 51040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51064 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51068 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51072 */   // MIs[1] Operand 1
     /* 51072 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51077 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51097 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 51104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51113 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51124 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51129 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51131 */   GIR_RootConstrainSelectedInstOperands,
     /* 51132 */   // GIR_Coverage, 1634,
     /* 51132 */   GIR_EraseRootFromParent_Done,
     /* 51133 */ // Label 1313: @51133
     /* 51133 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(51231), // Rule ID 1637 //
     /* 51138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51162 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51166 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51170 */   // MIs[1] Operand 1
     /* 51170 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51175 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51180 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51195 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51222 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51227 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51229 */   GIR_RootConstrainSelectedInstOperands,
     /* 51230 */   // GIR_Coverage, 1637,
     /* 51230 */   GIR_EraseRootFromParent_Done,
     /* 51231 */ // Label 1314: @51231
     /* 51231 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(51329), // Rule ID 1640 //
     /* 51236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51264 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51268 */   // MIs[1] Operand 1
     /* 51268 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51273 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51287 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51293 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 51318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51320 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51325 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51327 */   GIR_RootConstrainSelectedInstOperands,
     /* 51328 */   // GIR_Coverage, 1640,
     /* 51328 */   GIR_EraseRootFromParent_Done,
     /* 51329 */ // Label 1315: @51329
     /* 51329 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(51427), // Rule ID 1651 //
     /* 51334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51350 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51354 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51362 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51366 */   // MIs[1] Operand 1
     /* 51366 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51371 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51391 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51407 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51418 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51423 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51425 */   GIR_RootConstrainSelectedInstOperands,
     /* 51426 */   // GIR_Coverage, 1651,
     /* 51426 */   GIR_EraseRootFromParent_Done,
     /* 51427 */ // Label 1316: @51427
     /* 51427 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(51525), // Rule ID 1652 //
     /* 51432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51456 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51460 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51464 */   // MIs[1] Operand 1
     /* 51464 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 51469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51474 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51489 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51505 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51516 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51521 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51523 */   GIR_RootConstrainSelectedInstOperands,
     /* 51524 */   // GIR_Coverage, 1652,
     /* 51524 */   GIR_EraseRootFromParent_Done,
     /* 51525 */ // Label 1317: @51525
     /* 51525 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(51623), // Rule ID 1655 //
     /* 51530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51558 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51562 */   // MIs[1] Operand 1
     /* 51562 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 51567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51572 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51581 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51587 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51614 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51619 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51621 */   GIR_RootConstrainSelectedInstOperands,
     /* 51622 */   // GIR_Coverage, 1655,
     /* 51622 */   GIR_EraseRootFromParent_Done,
     /* 51623 */ // Label 1318: @51623
     /* 51623 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(51721), // Rule ID 1656 //
     /* 51628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51652 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51656 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51660 */   // MIs[1] Operand 1
     /* 51660 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51670 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51685 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51697 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51701 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51712 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51717 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51719 */   GIR_RootConstrainSelectedInstOperands,
     /* 51720 */   // GIR_Coverage, 1656,
     /* 51720 */   GIR_EraseRootFromParent_Done,
     /* 51721 */ // Label 1319: @51721
     /* 51721 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(51819), // Rule ID 1669 //
     /* 51726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51754 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51758 */   // MIs[1] Operand 1
     /* 51758 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51763 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51768 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51783 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 51808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51810 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51815 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51817 */   GIR_RootConstrainSelectedInstOperands,
     /* 51818 */   // GIR_Coverage, 1669,
     /* 51818 */   GIR_EraseRootFromParent_Done,
     /* 51819 */ // Label 1320: @51819
     /* 51819 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(51917), // Rule ID 1679 //
     /* 51824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51848 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51852 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51856 */   // MIs[1] Operand 1
     /* 51856 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51861 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51866 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51881 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51897 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 51906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51908 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51913 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51915 */   GIR_RootConstrainSelectedInstOperands,
     /* 51916 */   // GIR_Coverage, 1679,
     /* 51916 */   GIR_EraseRootFromParent_Done,
     /* 51917 */ // Label 1321: @51917
     /* 51917 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(52015), // Rule ID 1685 //
     /* 51922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51950 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51954 */   // MIs[1] Operand 1
     /* 51954 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51959 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51964 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51979 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 51979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 51986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51991 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51995 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52006 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52011 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52013 */   GIR_RootConstrainSelectedInstOperands,
     /* 52014 */   // GIR_Coverage, 1685,
     /* 52014 */   GIR_EraseRootFromParent_Done,
     /* 52015 */ // Label 1322: @52015
     /* 52015 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(52113), // Rule ID 1686 //
     /* 52020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52044 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52048 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52052 */   // MIs[1] Operand 1
     /* 52052 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52057 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52071 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52077 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52093 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52104 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52109 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52111 */   GIR_RootConstrainSelectedInstOperands,
     /* 52112 */   // GIR_Coverage, 1686,
     /* 52112 */   GIR_EraseRootFromParent_Done,
     /* 52113 */ // Label 1323: @52113
     /* 52113 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(52211), // Rule ID 1689 //
     /* 52118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52127 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52142 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52146 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52150 */   // MIs[1] Operand 1
     /* 52150 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52155 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52160 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52175 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 52182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52187 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52191 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52202 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52207 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52209 */   GIR_RootConstrainSelectedInstOperands,
     /* 52210 */   // GIR_Coverage, 1689,
     /* 52210 */   GIR_EraseRootFromParent_Done,
     /* 52211 */ // Label 1324: @52211
     /* 52211 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(52309), // Rule ID 1690 //
     /* 52216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52240 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52244 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52248 */   // MIs[1] Operand 1
     /* 52248 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52253 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52273 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52285 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52289 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52300 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52305 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52307 */   GIR_RootConstrainSelectedInstOperands,
     /* 52308 */   // GIR_Coverage, 1690,
     /* 52308 */   GIR_EraseRootFromParent_Done,
     /* 52309 */ // Label 1325: @52309
     /* 52309 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(52407), // Rule ID 1693 //
     /* 52314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52342 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52346 */   // MIs[1] Operand 1
     /* 52346 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52351 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52371 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52383 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52387 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52398 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52403 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52405 */   GIR_RootConstrainSelectedInstOperands,
     /* 52406 */   // GIR_Coverage, 1693,
     /* 52406 */   GIR_EraseRootFromParent_Done,
     /* 52407 */ // Label 1326: @52407
     /* 52407 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(52505), // Rule ID 1695 //
     /* 52412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52436 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52440 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52444 */   // MIs[1] Operand 1
     /* 52444 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 52449 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52454 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52469 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 52494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52496 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52501 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52503 */   GIR_RootConstrainSelectedInstOperands,
     /* 52504 */   // GIR_Coverage, 1695,
     /* 52504 */   GIR_EraseRootFromParent_Done,
     /* 52505 */ // Label 1327: @52505
     /* 52505 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(52603), // Rule ID 1698 //
     /* 52510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52534 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52538 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52542 */   // MIs[1] Operand 1
     /* 52542 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 52547 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52552 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52567 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52579 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52583 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52594 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52599 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52601 */   GIR_RootConstrainSelectedInstOperands,
     /* 52602 */   // GIR_Coverage, 1698,
     /* 52602 */   GIR_EraseRootFromParent_Done,
     /* 52603 */ // Label 1328: @52603
     /* 52603 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(52701), // Rule ID 1699 //
     /* 52608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52632 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52636 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52640 */   // MIs[1] Operand 1
     /* 52640 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52645 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52650 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52659 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52665 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52677 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52681 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52692 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52697 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52699 */   GIR_RootConstrainSelectedInstOperands,
     /* 52700 */   // GIR_Coverage, 1699,
     /* 52700 */   GIR_EraseRootFromParent_Done,
     /* 52701 */ // Label 1329: @52701
     /* 52701 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(52799), // Rule ID 1702 //
     /* 52706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52730 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52734 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52738 */   // MIs[1] Operand 1
     /* 52738 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52757 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52763 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52775 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52779 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52790 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52795 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52797 */   GIR_RootConstrainSelectedInstOperands,
     /* 52798 */   // GIR_Coverage, 1702,
     /* 52798 */   GIR_EraseRootFromParent_Done,
     /* 52799 */ // Label 1330: @52799
     /* 52799 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(52897), // Rule ID 1703 //
     /* 52804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52832 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52836 */   // MIs[1] Operand 1
     /* 52836 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52841 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52855 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52861 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52873 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52888 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52893 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52895 */   GIR_RootConstrainSelectedInstOperands,
     /* 52896 */   // GIR_Coverage, 1703,
     /* 52896 */   GIR_EraseRootFromParent_Done,
     /* 52897 */ // Label 1331: @52897
     /* 52897 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(52995), // Rule ID 1706 //
     /* 52902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52930 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52934 */   // MIs[1] Operand 1
     /* 52934 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52939 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52944 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52959 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 52962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 52966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 52984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52986 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52991 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52993 */   GIR_RootConstrainSelectedInstOperands,
     /* 52994 */   // GIR_Coverage, 1706,
     /* 52994 */   GIR_EraseRootFromParent_Done,
     /* 52995 */ // Label 1332: @52995
     /* 52995 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(53093), // Rule ID 1708 //
     /* 53000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 53003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53024 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 53028 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 53032 */   // MIs[1] Operand 1
     /* 53032 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53037 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53042 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53051 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53055 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53057 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 53057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 53060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 53064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53069 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53073 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 53082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 53084 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53089 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53091 */   GIR_RootConstrainSelectedInstOperands,
     /* 53092 */   // GIR_Coverage, 1708,
     /* 53092 */   GIR_EraseRootFromParent_Done,
     /* 53093 */ // Label 1333: @53093
     /* 53093 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(53174), // Rule ID 1863 //
     /* 53098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53114 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53122 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53126 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53130 */   // MIs[1] Operand 1
     /* 53130 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53135 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53140 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53149 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53155 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53160 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53162 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53164 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53168 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53172 */   GIR_RootConstrainSelectedInstOperands,
     /* 53173 */   // GIR_Coverage, 1863,
     /* 53173 */   GIR_EraseRootFromParent_Done,
     /* 53174 */ // Label 1334: @53174
     /* 53174 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(53255), // Rule ID 1864 //
     /* 53179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53203 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53207 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53211 */   // MIs[1] Operand 1
     /* 53211 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 53216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53221 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53230 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53236 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSlt),
     /* 53239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53241 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53243 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53245 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53249 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53253 */   GIR_RootConstrainSelectedInstOperands,
     /* 53254 */   // GIR_Coverage, 1864,
     /* 53254 */   GIR_EraseRootFromParent_Done,
     /* 53255 */ // Label 1335: @53255
     /* 53255 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(53336), // Rule ID 1865 //
     /* 53260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53284 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53288 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53292 */   // MIs[1] Operand 1
     /* 53292 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53302 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53311 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53317 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53322 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53324 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53326 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53330 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53334 */   GIR_RootConstrainSelectedInstOperands,
     /* 53335 */   // GIR_Coverage, 1865,
     /* 53335 */   GIR_EraseRootFromParent_Done,
     /* 53336 */ // Label 1336: @53336
     /* 53336 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(53417), // Rule ID 1866 //
     /* 53341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53369 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53373 */   // MIs[1] Operand 1
     /* 53373 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 53378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53383 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53392 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53398 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSltu),
     /* 53401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53403 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53405 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53407 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53411 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53415 */   GIR_RootConstrainSelectedInstOperands,
     /* 53416 */   // GIR_Coverage, 1866,
     /* 53416 */   GIR_EraseRootFromParent_Done,
     /* 53417 */ // Label 1337: @53417
     /* 53417 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(53498), // Rule ID 1868 //
     /* 53422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53438 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53446 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53450 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53454 */   // MIs[1] Operand 1
     /* 53454 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53459 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53464 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53479 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETLE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53484 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53486 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53492 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53496 */   GIR_RootConstrainSelectedInstOperands,
     /* 53497 */   // GIR_Coverage, 1868,
     /* 53497 */   GIR_EraseRootFromParent_Done,
     /* 53498 */ // Label 1338: @53498
     /* 53498 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(53579), // Rule ID 1869 //
     /* 53503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53527 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53531 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53535 */   // MIs[1] Operand 1
     /* 53535 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 53540 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53545 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53554 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53560 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETULE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53565 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53567 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53569 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53573 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53577 */   GIR_RootConstrainSelectedInstOperands,
     /* 53578 */   // GIR_Coverage, 1869,
     /* 53578 */   GIR_EraseRootFromParent_Done,
     /* 53579 */ // Label 1339: @53579
     /* 53579 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(53660), // Rule ID 1870 //
     /* 53584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53612 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53616 */   // MIs[1] Operand 1
     /* 53616 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 53621 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53626 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53635 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53639 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53641 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZCmp),
     /* 53644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53646 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53648 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53650 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53654 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53658 */   GIR_RootConstrainSelectedInstOperands,
     /* 53659 */   // GIR_Coverage, 1870,
     /* 53659 */   GIR_EraseRootFromParent_Done,
     /* 53660 */ // Label 1340: @53660
     /* 53660 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(53741), // Rule ID 1873 //
     /* 53665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53693 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53697 */   // MIs[1] Operand 1
     /* 53697 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53702 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53707 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53716 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53722 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZCmp),
     /* 53725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53727 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53729 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53731 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53735 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53739 */   GIR_RootConstrainSelectedInstOperands,
     /* 53740 */   // GIR_Coverage, 1873,
     /* 53740 */   GIR_EraseRootFromParent_Done,
     /* 53741 */ // Label 1341: @53741
     /* 53741 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(53839), // Rule ID 2209 //
     /* 53746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53774 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53778 */   // MIs[1] Operand 1
     /* 53778 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53783 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53788 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53797 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53803 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 53810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53830 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53835 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53837 */   GIR_RootConstrainSelectedInstOperands,
     /* 53838 */   // GIR_Coverage, 2209,
     /* 53838 */   GIR_EraseRootFromParent_Done,
     /* 53839 */ // Label 1342: @53839
     /* 53839 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(53937), // Rule ID 2210 //
     /* 53844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53868 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53872 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53876 */   // MIs[1] Operand 1
     /* 53876 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53881 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53886 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53901 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 53908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53913 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53917 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53928 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53933 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53935 */   GIR_RootConstrainSelectedInstOperands,
     /* 53936 */   // GIR_Coverage, 2210,
     /* 53936 */   GIR_EraseRootFromParent_Done,
     /* 53937 */ // Label 1343: @53937
     /* 53937 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(54035), // Rule ID 2213 //
     /* 53942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53970 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53974 */   // MIs[1] Operand 1
     /* 53974 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53979 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53984 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53999 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 53999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54026 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54031 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54033 */   GIR_RootConstrainSelectedInstOperands,
     /* 54034 */   // GIR_Coverage, 2213,
     /* 54034 */   GIR_EraseRootFromParent_Done,
     /* 54035 */ // Label 1344: @54035
     /* 54035 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(54133), // Rule ID 2214 //
     /* 54040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54064 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54068 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54072 */   // MIs[1] Operand 1
     /* 54072 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54077 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54097 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54113 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54124 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54129 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54131 */   GIR_RootConstrainSelectedInstOperands,
     /* 54132 */   // GIR_Coverage, 2214,
     /* 54132 */   GIR_EraseRootFromParent_Done,
     /* 54133 */ // Label 1345: @54133
     /* 54133 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(54231), // Rule ID 2217 //
     /* 54138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54162 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54166 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54170 */   // MIs[1] Operand 1
     /* 54170 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54175 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54180 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54195 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54222 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54227 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54229 */   GIR_RootConstrainSelectedInstOperands,
     /* 54230 */   // GIR_Coverage, 2217,
     /* 54230 */   GIR_EraseRootFromParent_Done,
     /* 54231 */ // Label 1346: @54231
     /* 54231 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(54329), // Rule ID 2220 //
     /* 54236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 54239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54264 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54268 */   // MIs[1] Operand 1
     /* 54268 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54273 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54287 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54293 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54320 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54325 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54327 */   GIR_RootConstrainSelectedInstOperands,
     /* 54328 */   // GIR_Coverage, 2220,
     /* 54328 */   GIR_EraseRootFromParent_Done,
     /* 54329 */ // Label 1347: @54329
     /* 54329 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(54427), // Rule ID 2223 //
     /* 54334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54350 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54354 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54362 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54366 */   // MIs[1] Operand 1
     /* 54366 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54371 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54391 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54407 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54418 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54423 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54425 */   GIR_RootConstrainSelectedInstOperands,
     /* 54426 */   // GIR_Coverage, 2223,
     /* 54426 */   GIR_EraseRootFromParent_Done,
     /* 54427 */ // Label 1348: @54427
     /* 54427 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(54525), // Rule ID 2224 //
     /* 54432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54456 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54460 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54464 */   // MIs[1] Operand 1
     /* 54464 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 54469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54474 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54489 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54505 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54516 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54521 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54523 */   GIR_RootConstrainSelectedInstOperands,
     /* 54524 */   // GIR_Coverage, 2224,
     /* 54524 */   GIR_EraseRootFromParent_Done,
     /* 54525 */ // Label 1349: @54525
     /* 54525 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(54623), // Rule ID 2227 //
     /* 54530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54558 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54562 */   // MIs[1] Operand 1
     /* 54562 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 54567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54572 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54581 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54587 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54614 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54619 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54621 */   GIR_RootConstrainSelectedInstOperands,
     /* 54622 */   // GIR_Coverage, 2227,
     /* 54622 */   GIR_EraseRootFromParent_Done,
     /* 54623 */ // Label 1350: @54623
     /* 54623 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(54721), // Rule ID 2228 //
     /* 54628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54652 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54656 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54660 */   // MIs[1] Operand 1
     /* 54660 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54670 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54685 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54697 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54701 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54712 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54717 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54719 */   GIR_RootConstrainSelectedInstOperands,
     /* 54720 */   // GIR_Coverage, 2228,
     /* 54720 */   GIR_EraseRootFromParent_Done,
     /* 54721 */ // Label 1351: @54721
     /* 54721 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(54819), // Rule ID 2231 //
     /* 54726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54754 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54758 */   // MIs[1] Operand 1
     /* 54758 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54763 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54768 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54783 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54810 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54815 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54817 */   GIR_RootConstrainSelectedInstOperands,
     /* 54818 */   // GIR_Coverage, 2231,
     /* 54818 */   GIR_EraseRootFromParent_Done,
     /* 54819 */ // Label 1352: @54819
     /* 54819 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(54917), // Rule ID 2234 //
     /* 54824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54848 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54852 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54856 */   // MIs[1] Operand 1
     /* 54856 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54861 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54866 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54881 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54897 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54908 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54913 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54915 */   GIR_RootConstrainSelectedInstOperands,
     /* 54916 */   // GIR_Coverage, 2234,
     /* 54916 */   GIR_EraseRootFromParent_Done,
     /* 54917 */ // Label 1353: @54917
     /* 54917 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(55015), // Rule ID 2257 //
     /* 54922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54950 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54954 */   // MIs[1] Operand 1
     /* 54954 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54959 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54964 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54979 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 54979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54991 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54995 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55006 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55011 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55013 */   GIR_RootConstrainSelectedInstOperands,
     /* 55014 */   // GIR_Coverage, 2257,
     /* 55014 */   GIR_EraseRootFromParent_Done,
     /* 55015 */ // Label 1354: @55015
     /* 55015 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(55113), // Rule ID 2258 //
     /* 55020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55044 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55048 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55052 */   // MIs[1] Operand 1
     /* 55052 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 55057 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55071 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55077 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55093 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55104 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55109 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55111 */   GIR_RootConstrainSelectedInstOperands,
     /* 55112 */   // GIR_Coverage, 2258,
     /* 55112 */   GIR_EraseRootFromParent_Done,
     /* 55113 */ // Label 1355: @55113
     /* 55113 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(55211), // Rule ID 2261 //
     /* 55118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55127 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55142 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55146 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55150 */   // MIs[1] Operand 1
     /* 55150 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 55155 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55160 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55175 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 55182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55187 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55191 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55202 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55207 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55209 */   GIR_RootConstrainSelectedInstOperands,
     /* 55210 */   // GIR_Coverage, 2261,
     /* 55210 */   GIR_EraseRootFromParent_Done,
     /* 55211 */ // Label 1356: @55211
     /* 55211 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(55309), // Rule ID 2262 //
     /* 55216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55240 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55244 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55248 */   // MIs[1] Operand 1
     /* 55248 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 55253 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55273 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55285 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55289 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55300 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55305 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55307 */   GIR_RootConstrainSelectedInstOperands,
     /* 55308 */   // GIR_Coverage, 2262,
     /* 55308 */   GIR_EraseRootFromParent_Done,
     /* 55309 */ // Label 1357: @55309
     /* 55309 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(55407), // Rule ID 2265 //
     /* 55314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55342 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55346 */   // MIs[1] Operand 1
     /* 55346 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 55351 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55371 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55383 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55387 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55398 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55403 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55405 */   GIR_RootConstrainSelectedInstOperands,
     /* 55406 */   // GIR_Coverage, 2265,
     /* 55406 */   GIR_EraseRootFromParent_Done,
     /* 55407 */ // Label 1358: @55407
     /* 55407 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(55505), // Rule ID 2267 //
     /* 55412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55436 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55440 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55444 */   // MIs[1] Operand 1
     /* 55444 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 55449 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55454 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55469 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 55494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55496 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55501 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55503 */   GIR_RootConstrainSelectedInstOperands,
     /* 55504 */   // GIR_Coverage, 2267,
     /* 55504 */   GIR_EraseRootFromParent_Done,
     /* 55505 */ // Label 1359: @55505
     /* 55505 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(55545), // Rule ID 295 //
     /* 55510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55534 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55538 */   // (select:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)  =>  (PseudoSELECT_I:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)
     /* 55538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I),
     /* 55543 */   GIR_RootConstrainSelectedInstOperands,
     /* 55544 */   // GIR_Coverage, 295,
     /* 55544 */   GIR_Done,
     /* 55545 */ // Label 1360: @55545
     /* 55545 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(55585), // Rule ID 297 //
     /* 55550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55574 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55578 */   // (select:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)  =>  (PseudoSELECT_S:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)
     /* 55578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_S),
     /* 55583 */   GIR_RootConstrainSelectedInstOperands,
     /* 55584 */   // GIR_Coverage, 297,
     /* 55584 */   GIR_Done,
     /* 55585 */ // Label 1361: @55585
     /* 55585 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(55631), // Rule ID 334 //
     /* 55590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 55593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55614 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55618 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S),
     /* 55621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55623 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55625 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55627 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55629 */   GIR_RootConstrainSelectedInstOperands,
     /* 55630 */   // GIR_Coverage, 334,
     /* 55630 */   GIR_EraseRootFromParent_Done,
     /* 55631 */ // Label 1362: @55631
     /* 55631 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(55677), // Rule ID 1213 //
     /* 55636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 55639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55664 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S_MMR6:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S_MMR6),
     /* 55667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55669 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55671 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55673 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55675 */   GIR_RootConstrainSelectedInstOperands,
     /* 55676 */   // GIR_Coverage, 1213,
     /* 55676 */   GIR_EraseRootFromParent_Done,
     /* 55677 */ // Label 1363: @55677
     /* 55677 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(55723), // Rule ID 1641 //
     /* 55682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55706 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55710 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 55713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55715 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55717 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55719 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55721 */   GIR_RootConstrainSelectedInstOperands,
     /* 55722 */   // GIR_Coverage, 1641,
     /* 55722 */   GIR_EraseRootFromParent_Done,
     /* 55723 */ // Label 1364: @55723
     /* 55723 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(55769), // Rule ID 1680 //
     /* 55728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55756 */   // (select:{ *:[i32] } GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 55759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55761 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55763 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55765 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55767 */   GIR_RootConstrainSelectedInstOperands,
     /* 55768 */   // GIR_Coverage, 1680,
     /* 55768 */   GIR_EraseRootFromParent_Done,
     /* 55769 */ // Label 1365: @55769
     /* 55769 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(55815), // Rule ID 1696 //
     /* 55774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55798 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55802 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 55805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55807 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55809 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55811 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55813 */   GIR_RootConstrainSelectedInstOperands,
     /* 55814 */   // GIR_Coverage, 1696,
     /* 55814 */   GIR_EraseRootFromParent_Done,
     /* 55815 */ // Label 1366: @55815
     /* 55815 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(55861), // Rule ID 1709 //
     /* 55820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55829 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55848 */   // (select:{ *:[f32] } GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 55851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55853 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55855 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55857 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55859 */   GIR_RootConstrainSelectedInstOperands,
     /* 55860 */   // GIR_Coverage, 1709,
     /* 55860 */   GIR_EraseRootFromParent_Done,
     /* 55861 */ // Label 1367: @55861
     /* 55861 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(55907), // Rule ID 1875 //
     /* 55866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 55869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55890 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55894 */   // (select:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 55894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 55897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 55899 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 55901 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 55903 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 55905 */   GIR_RootConstrainSelectedInstOperands,
     /* 55906 */   // GIR_Coverage, 1875,
     /* 55906 */   GIR_EraseRootFromParent_Done,
     /* 55907 */ // Label 1368: @55907
     /* 55907 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(55953), // Rule ID 2221 //
     /* 55912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 55915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55936 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55940 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 55943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55945 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55947 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55949 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55951 */   GIR_RootConstrainSelectedInstOperands,
     /* 55952 */   // GIR_Coverage, 2221,
     /* 55952 */   GIR_EraseRootFromParent_Done,
     /* 55953 */ // Label 1369: @55953
     /* 55953 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(55999), // Rule ID 2235 //
     /* 55958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55986 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 55989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55991 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55993 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55995 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55997 */   GIR_RootConstrainSelectedInstOperands,
     /* 55998 */   // GIR_Coverage, 2235,
     /* 55998 */   GIR_EraseRootFromParent_Done,
     /* 55999 */ // Label 1370: @55999
     /* 55999 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(56045), // Rule ID 2268 //
     /* 56004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 56007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56032 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 56032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 56035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56037 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56039 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56041 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56043 */   GIR_RootConstrainSelectedInstOperands,
     /* 56044 */   // GIR_Coverage, 2268,
     /* 56044 */   GIR_EraseRootFromParent_Done,
     /* 56045 */ // Label 1371: @56045
     /* 56045 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56123), // Rule ID 1778 //
     /* 56050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 56053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56066 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR:{ *:[i32] } (SELNEZ:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56066 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56069 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ),
     /* 56073 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56078 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56082 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ),
     /* 56095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56100 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56104 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR),
     /* 56113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56121 */   GIR_RootConstrainSelectedInstOperands,
     /* 56122 */   // GIR_Coverage, 1778,
     /* 56122 */   GIR_EraseRootFromParent_Done,
     /* 56123 */ // Label 1372: @56123
     /* 56123 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56201), // Rule ID 2285 //
     /* 56128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 56131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56144 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR_MM:{ *:[i32] } (SELNEZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ_MMR6),
     /* 56151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56156 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56160 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ_MMR6),
     /* 56173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56178 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56182 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /* 56191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56199 */   GIR_RootConstrainSelectedInstOperands,
     /* 56200 */   // GIR_Coverage, 2285,
     /* 56200 */   GIR_EraseRootFromParent_Done,
     /* 56201 */ // Label 1373: @56201
     /* 56201 */ GIM_Reject,
     /* 56202 */ // Label 1288: @56202
     /* 56202 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56278), // Rule ID 1668 //
     /* 56207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56231 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56235 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56239 */   // MIs[1] Operand 1
     /* 56239 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56244 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56249 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56257 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56261 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56263 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 56266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56268 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56270 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56274 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56276 */   GIR_RootConstrainSelectedInstOperands,
     /* 56277 */   // GIR_Coverage, 1668,
     /* 56277 */   GIR_EraseRootFromParent_Done,
     /* 56278 */ // Label 1374: @56278
     /* 56278 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56354), // Rule ID 1672 //
     /* 56283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56307 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56311 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56315 */   // MIs[1] Operand 1
     /* 56315 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56325 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56339 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 56342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56344 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56346 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56350 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56352 */   GIR_RootConstrainSelectedInstOperands,
     /* 56353 */   // GIR_Coverage, 1672,
     /* 56353 */   GIR_EraseRootFromParent_Done,
     /* 56354 */ // Label 1375: @56354
     /* 56354 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56430), // Rule ID 1678 //
     /* 56359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56383 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56387 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56391 */   // MIs[1] Operand 1
     /* 56391 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56396 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56401 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56409 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56415 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 56418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56420 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56422 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56426 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56428 */   GIR_RootConstrainSelectedInstOperands,
     /* 56429 */   // GIR_Coverage, 1678,
     /* 56429 */   GIR_EraseRootFromParent_Done,
     /* 56430 */ // Label 1376: @56430
     /* 56430 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(56506), // Rule ID 1684 //
     /* 56435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56459 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56463 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56467 */   // MIs[1] Operand 1
     /* 56467 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56477 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56485 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56489 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56491 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 56494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56496 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56498 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56502 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56504 */   GIR_RootConstrainSelectedInstOperands,
     /* 56505 */   // GIR_Coverage, 1684,
     /* 56505 */   GIR_EraseRootFromParent_Done,
     /* 56506 */ // Label 1377: @56506
     /* 56506 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(56582), // Rule ID 1720 //
     /* 56511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56535 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56539 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56543 */   // MIs[1] Operand 1
     /* 56543 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56548 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56553 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56567 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 56570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56572 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56578 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56580 */   GIR_RootConstrainSelectedInstOperands,
     /* 56581 */   // GIR_Coverage, 1720,
     /* 56581 */   GIR_EraseRootFromParent_Done,
     /* 56582 */ // Label 1378: @56582
     /* 56582 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(56658), // Rule ID 1723 //
     /* 56587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56611 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56615 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56619 */   // MIs[1] Operand 1
     /* 56619 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56624 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56629 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56637 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56643 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 56646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56648 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56650 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56654 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56656 */   GIR_RootConstrainSelectedInstOperands,
     /* 56657 */   // GIR_Coverage, 1723,
     /* 56657 */   GIR_EraseRootFromParent_Done,
     /* 56658 */ // Label 1379: @56658
     /* 56658 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(56734), // Rule ID 1741 //
     /* 56663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56679 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56683 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56687 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56691 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56695 */   // MIs[1] Operand 1
     /* 56695 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56700 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56705 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56719 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 56722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56724 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56726 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56730 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56732 */   GIR_RootConstrainSelectedInstOperands,
     /* 56733 */   // GIR_Coverage, 1741,
     /* 56733 */   GIR_EraseRootFromParent_Done,
     /* 56734 */ // Label 1380: @56734
     /* 56734 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(56810), // Rule ID 1743 //
     /* 56739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56763 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56767 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56771 */   // MIs[1] Operand 1
     /* 56771 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56781 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56789 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56795 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 56798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56800 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56802 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56806 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56808 */   GIR_RootConstrainSelectedInstOperands,
     /* 56809 */   // GIR_Coverage, 1743,
     /* 56809 */   GIR_EraseRootFromParent_Done,
     /* 56810 */ // Label 1381: @56810
     /* 56810 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(56886), // Rule ID 1746 //
     /* 56815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56839 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56843 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56847 */   // MIs[1] Operand 1
     /* 56847 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56852 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56857 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56871 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 56874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56876 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56878 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56882 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56884 */   GIR_RootConstrainSelectedInstOperands,
     /* 56885 */   // GIR_Coverage, 1746,
     /* 56885 */   GIR_EraseRootFromParent_Done,
     /* 56886 */ // Label 1382: @56886
     /* 56886 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(56962), // Rule ID 1749 //
     /* 56891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56915 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56919 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56923 */   // MIs[1] Operand 1
     /* 56923 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56928 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56933 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56947 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 56950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56952 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56954 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56958 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56960 */   GIR_RootConstrainSelectedInstOperands,
     /* 56961 */   // GIR_Coverage, 1749,
     /* 56961 */   GIR_EraseRootFromParent_Done,
     /* 56962 */ // Label 1383: @56962
     /* 56962 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57038), // Rule ID 2279 //
     /* 56967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 56970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56991 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56995 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56999 */   // MIs[1] Operand 1
     /* 56999 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57004 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57009 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57017 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57023 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 57026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57028 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57030 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57034 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57036 */   GIR_RootConstrainSelectedInstOperands,
     /* 57037 */   // GIR_Coverage, 2279,
     /* 57037 */   GIR_EraseRootFromParent_Done,
     /* 57038 */ // Label 1384: @57038
     /* 57038 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57114), // Rule ID 2282 //
     /* 57043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 57046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57071 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57075 */   // MIs[1] Operand 1
     /* 57075 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 57080 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57085 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57093 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57097 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57099 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 57102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57104 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57106 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57110 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57112 */   GIR_RootConstrainSelectedInstOperands,
     /* 57113 */   // GIR_Coverage, 2282,
     /* 57113 */   GIR_EraseRootFromParent_Done,
     /* 57114 */ // Label 1385: @57114
     /* 57114 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57212), // Rule ID 1643 //
     /* 57119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57143 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57147 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57151 */   // MIs[1] Operand 1
     /* 57151 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57156 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57161 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57174 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57176 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57188 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57192 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57203 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57208 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57210 */   GIR_RootConstrainSelectedInstOperands,
     /* 57211 */   // GIR_Coverage, 1643,
     /* 57211 */   GIR_EraseRootFromParent_Done,
     /* 57212 */ // Label 1386: @57212
     /* 57212 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57310), // Rule ID 1644 //
     /* 57217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57241 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57245 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57249 */   // MIs[1] Operand 1
     /* 57249 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57254 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57259 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57268 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57274 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57286 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57290 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57301 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57306 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57308 */   GIR_RootConstrainSelectedInstOperands,
     /* 57309 */   // GIR_Coverage, 1644,
     /* 57309 */   GIR_EraseRootFromParent_Done,
     /* 57310 */ // Label 1387: @57310
     /* 57310 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57408), // Rule ID 1647 //
     /* 57315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57339 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57343 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57347 */   // MIs[1] Operand 1
     /* 57347 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57352 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57357 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57370 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57372 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57384 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57388 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57399 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57404 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57406 */   GIR_RootConstrainSelectedInstOperands,
     /* 57407 */   // GIR_Coverage, 1647,
     /* 57407 */   GIR_EraseRootFromParent_Done,
     /* 57408 */ // Label 1388: @57408
     /* 57408 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57506), // Rule ID 1648 //
     /* 57413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57422 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57429 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57437 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57441 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57445 */   // MIs[1] Operand 1
     /* 57445 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57450 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57455 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57470 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57497 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57502 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57504 */   GIR_RootConstrainSelectedInstOperands,
     /* 57505 */   // GIR_Coverage, 1648,
     /* 57505 */   GIR_EraseRootFromParent_Done,
     /* 57506 */ // Label 1389: @57506
     /* 57506 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57604), // Rule ID 1659 //
     /* 57511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57535 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57539 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57543 */   // MIs[1] Operand 1
     /* 57543 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57548 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57568 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57584 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57595 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57600 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57602 */   GIR_RootConstrainSelectedInstOperands,
     /* 57603 */   // GIR_Coverage, 1659,
     /* 57603 */   GIR_EraseRootFromParent_Done,
     /* 57604 */ // Label 1390: @57604
     /* 57604 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57702), // Rule ID 1660 //
     /* 57609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57633 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57637 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57641 */   // MIs[1] Operand 1
     /* 57641 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57646 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57651 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57666 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57682 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57693 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57698 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57700 */   GIR_RootConstrainSelectedInstOperands,
     /* 57701 */   // GIR_Coverage, 1660,
     /* 57701 */   GIR_EraseRootFromParent_Done,
     /* 57702 */ // Label 1391: @57702
     /* 57702 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57800), // Rule ID 1663 //
     /* 57707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57731 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57735 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57739 */   // MIs[1] Operand 1
     /* 57739 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57744 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57749 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57758 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57764 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57776 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57780 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57791 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57796 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57798 */   GIR_RootConstrainSelectedInstOperands,
     /* 57799 */   // GIR_Coverage, 1663,
     /* 57799 */   GIR_EraseRootFromParent_Done,
     /* 57800 */ // Label 1392: @57800
     /* 57800 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57898), // Rule ID 1664 //
     /* 57805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57814 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57829 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57833 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57837 */   // MIs[1] Operand 1
     /* 57837 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57847 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57862 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57878 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57889 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57894 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57896 */   GIR_RootConstrainSelectedInstOperands,
     /* 57897 */   // GIR_Coverage, 1664,
     /* 57897 */   GIR_EraseRootFromParent_Done,
     /* 57898 */ // Label 1393: @57898
     /* 57898 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57996), // Rule ID 1667 //
     /* 57903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57931 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57935 */   // MIs[1] Operand 1
     /* 57935 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57940 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57960 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 57967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57972 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57976 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57987 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57992 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57994 */   GIR_RootConstrainSelectedInstOperands,
     /* 57995 */   // GIR_Coverage, 1667,
     /* 57995 */   GIR_EraseRootFromParent_Done,
     /* 57996 */ // Label 1394: @57996
     /* 57996 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(58094), // Rule ID 1671 //
     /* 58001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58025 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58029 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58033 */   // MIs[1] Operand 1
     /* 58033 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58043 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58052 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58058 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58070 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58074 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 58083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58085 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58090 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58092 */   GIR_RootConstrainSelectedInstOperands,
     /* 58093 */   // GIR_Coverage, 1671,
     /* 58093 */   GIR_EraseRootFromParent_Done,
     /* 58094 */ // Label 1395: @58094
     /* 58094 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(58192), // Rule ID 1676 //
     /* 58099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58127 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58131 */   // MIs[1] Operand 1
     /* 58131 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58136 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58141 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58150 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58154 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58156 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58168 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 58181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58183 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58188 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58190 */   GIR_RootConstrainSelectedInstOperands,
     /* 58191 */   // GIR_Coverage, 1676,
     /* 58191 */   GIR_EraseRootFromParent_Done,
     /* 58192 */ // Label 1396: @58192
     /* 58192 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(58290), // Rule ID 1682 //
     /* 58197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58221 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58225 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58229 */   // MIs[1] Operand 1
     /* 58229 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58234 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58248 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58254 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 58279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58281 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58286 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58288 */   GIR_RootConstrainSelectedInstOperands,
     /* 58289 */   // GIR_Coverage, 1682,
     /* 58289 */   GIR_EraseRootFromParent_Done,
     /* 58290 */ // Label 1397: @58290
     /* 58290 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(58388), // Rule ID 1711 //
     /* 58295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58319 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58323 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58327 */   // MIs[1] Operand 1
     /* 58327 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58332 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58337 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58352 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58368 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58379 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58384 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58386 */   GIR_RootConstrainSelectedInstOperands,
     /* 58387 */   // GIR_Coverage, 1711,
     /* 58387 */   GIR_EraseRootFromParent_Done,
     /* 58388 */ // Label 1398: @58388
     /* 58388 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(58486), // Rule ID 1712 //
     /* 58393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58421 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58425 */   // MIs[1] Operand 1
     /* 58425 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 58430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58435 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58450 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58462 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58466 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58477 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58482 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58484 */   GIR_RootConstrainSelectedInstOperands,
     /* 58485 */   // GIR_Coverage, 1712,
     /* 58485 */   GIR_EraseRootFromParent_Done,
     /* 58486 */ // Label 1399: @58486
     /* 58486 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(58584), // Rule ID 1715 //
     /* 58491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58515 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58519 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58523 */   // MIs[1] Operand 1
     /* 58523 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 58528 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58533 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58542 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58548 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58564 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58575 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58580 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58582 */   GIR_RootConstrainSelectedInstOperands,
     /* 58583 */   // GIR_Coverage, 1715,
     /* 58583 */   GIR_EraseRootFromParent_Done,
     /* 58584 */ // Label 1400: @58584
     /* 58584 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58682), // Rule ID 1716 //
     /* 58589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58598 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58617 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58621 */   // MIs[1] Operand 1
     /* 58621 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 58626 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58631 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58640 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58646 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58658 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58662 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58673 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58678 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58680 */   GIR_RootConstrainSelectedInstOperands,
     /* 58681 */   // GIR_Coverage, 1716,
     /* 58681 */   GIR_EraseRootFromParent_Done,
     /* 58682 */ // Label 1401: @58682
     /* 58682 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58780), // Rule ID 1719 //
     /* 58687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58711 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58715 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58719 */   // MIs[1] Operand 1
     /* 58719 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58729 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58744 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58756 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58760 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58771 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58776 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58778 */   GIR_RootConstrainSelectedInstOperands,
     /* 58779 */   // GIR_Coverage, 1719,
     /* 58779 */   GIR_EraseRootFromParent_Done,
     /* 58780 */ // Label 1402: @58780
     /* 58780 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58878), // Rule ID 1721 //
     /* 58785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58809 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58813 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58817 */   // MIs[1] Operand 1
     /* 58817 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58822 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58827 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58842 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58854 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58858 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 58867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58869 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58874 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58876 */   GIR_RootConstrainSelectedInstOperands,
     /* 58877 */   // GIR_Coverage, 1721,
     /* 58877 */   GIR_EraseRootFromParent_Done,
     /* 58878 */ // Label 1403: @58878
     /* 58878 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58976), // Rule ID 1724 //
     /* 58883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58907 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58911 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58915 */   // MIs[1] Operand 1
     /* 58915 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58920 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58925 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58934 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58940 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 58940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58952 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58956 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 58965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58967 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58972 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58974 */   GIR_RootConstrainSelectedInstOperands,
     /* 58975 */   // GIR_Coverage, 1724,
     /* 58975 */   GIR_EraseRootFromParent_Done,
     /* 58976 */ // Label 1404: @58976
     /* 58976 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(59074), // Rule ID 1725 //
     /* 58981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58990 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59005 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59009 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59013 */   // MIs[1] Operand 1
     /* 59013 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59018 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59038 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59054 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59065 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59070 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59072 */   GIR_RootConstrainSelectedInstOperands,
     /* 59073 */   // GIR_Coverage, 1725,
     /* 59073 */   GIR_EraseRootFromParent_Done,
     /* 59074 */ // Label 1405: @59074
     /* 59074 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(59172), // Rule ID 1728 //
     /* 59079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59103 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59107 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59111 */   // MIs[1] Operand 1
     /* 59111 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59116 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59121 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59130 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59136 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 59143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59152 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59163 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59168 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59170 */   GIR_RootConstrainSelectedInstOperands,
     /* 59171 */   // GIR_Coverage, 1728,
     /* 59171 */   GIR_EraseRootFromParent_Done,
     /* 59172 */ // Label 1406: @59172
     /* 59172 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(59270), // Rule ID 1729 //
     /* 59177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59201 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59205 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59209 */   // MIs[1] Operand 1
     /* 59209 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59214 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59219 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59234 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59246 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59250 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59261 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59266 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59268 */   GIR_RootConstrainSelectedInstOperands,
     /* 59269 */   // GIR_Coverage, 1729,
     /* 59269 */   GIR_EraseRootFromParent_Done,
     /* 59270 */ // Label 1407: @59270
     /* 59270 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(59368), // Rule ID 1732 //
     /* 59275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59299 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59303 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59307 */   // MIs[1] Operand 1
     /* 59307 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 59312 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59317 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59326 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59332 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59344 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59348 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59359 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59364 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59366 */   GIR_RootConstrainSelectedInstOperands,
     /* 59367 */   // GIR_Coverage, 1732,
     /* 59367 */   GIR_EraseRootFromParent_Done,
     /* 59368 */ // Label 1408: @59368
     /* 59368 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(59466), // Rule ID 1733 //
     /* 59373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59397 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59401 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59405 */   // MIs[1] Operand 1
     /* 59405 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59410 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59430 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59442 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59446 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59457 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59462 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59464 */   GIR_RootConstrainSelectedInstOperands,
     /* 59465 */   // GIR_Coverage, 1733,
     /* 59465 */   GIR_EraseRootFromParent_Done,
     /* 59466 */ // Label 1409: @59466
     /* 59466 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(59564), // Rule ID 1736 //
     /* 59471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59499 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59503 */   // MIs[1] Operand 1
     /* 59503 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59508 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59513 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59528 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59540 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59544 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59555 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59560 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59562 */   GIR_RootConstrainSelectedInstOperands,
     /* 59563 */   // GIR_Coverage, 1736,
     /* 59563 */   GIR_EraseRootFromParent_Done,
     /* 59564 */ // Label 1410: @59564
     /* 59564 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(59662), // Rule ID 1737 //
     /* 59569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59593 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59597 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59601 */   // MIs[1] Operand 1
     /* 59601 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59606 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59611 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59620 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59626 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59638 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59653 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59658 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59660 */   GIR_RootConstrainSelectedInstOperands,
     /* 59661 */   // GIR_Coverage, 1737,
     /* 59661 */   GIR_EraseRootFromParent_Done,
     /* 59662 */ // Label 1411: @59662
     /* 59662 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(59760), // Rule ID 1740 //
     /* 59667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59691 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59695 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59699 */   // MIs[1] Operand 1
     /* 59699 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59709 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59718 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59722 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59724 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59736 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59740 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59751 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59756 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59758 */   GIR_RootConstrainSelectedInstOperands,
     /* 59759 */   // GIR_Coverage, 1740,
     /* 59759 */   GIR_EraseRootFromParent_Done,
     /* 59760 */ // Label 1412: @59760
     /* 59760 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(59858), // Rule ID 1742 //
     /* 59765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59793 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59797 */   // MIs[1] Operand 1
     /* 59797 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59807 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59822 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 59825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 59829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59834 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 59847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59849 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59854 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59856 */   GIR_RootConstrainSelectedInstOperands,
     /* 59857 */   // GIR_Coverage, 1742,
     /* 59857 */   GIR_EraseRootFromParent_Done,
     /* 59858 */ // Label 1413: @59858
     /* 59858 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(59956), // Rule ID 1744 //
     /* 59863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59887 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59891 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59895 */   // MIs[1] Operand 1
     /* 59895 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 59900 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59905 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59920 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59932 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59936 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 59945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59947 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59952 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59954 */   GIR_RootConstrainSelectedInstOperands,
     /* 59955 */   // GIR_Coverage, 1744,
     /* 59955 */   GIR_EraseRootFromParent_Done,
     /* 59956 */ // Label 1414: @59956
     /* 59956 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(60054), // Rule ID 1747 //
     /* 59961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59985 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59989 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59993 */   // MIs[1] Operand 1
     /* 59993 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 59998 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60003 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60012 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60018 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 60018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 60021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 60025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60030 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60034 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60045 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60050 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60052 */   GIR_RootConstrainSelectedInstOperands,
     /* 60053 */   // GIR_Coverage, 1747,
     /* 60053 */   GIR_EraseRootFromParent_Done,
     /* 60054 */ // Label 1415: @60054
     /* 60054 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(60152), // Rule ID 2270 //
     /* 60059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60087 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60091 */   // MIs[1] Operand 1
     /* 60091 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 60096 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60101 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60110 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60114 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60116 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60128 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60132 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60143 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60148 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60150 */   GIR_RootConstrainSelectedInstOperands,
     /* 60151 */   // GIR_Coverage, 2270,
     /* 60151 */   GIR_EraseRootFromParent_Done,
     /* 60152 */ // Label 1416: @60152
     /* 60152 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(60250), // Rule ID 2271 //
     /* 60157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60166 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60173 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60181 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60185 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60189 */   // MIs[1] Operand 1
     /* 60189 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 60194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60199 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60214 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60226 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60241 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60246 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60248 */   GIR_RootConstrainSelectedInstOperands,
     /* 60249 */   // GIR_Coverage, 2271,
     /* 60249 */   GIR_EraseRootFromParent_Done,
     /* 60250 */ // Label 1417: @60250
     /* 60250 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(60348), // Rule ID 2274 //
     /* 60255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60271 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60279 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60283 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60287 */   // MIs[1] Operand 1
     /* 60287 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 60292 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60312 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60324 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60328 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60339 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60344 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60346 */   GIR_RootConstrainSelectedInstOperands,
     /* 60347 */   // GIR_Coverage, 2274,
     /* 60347 */   GIR_EraseRootFromParent_Done,
     /* 60348 */ // Label 1418: @60348
     /* 60348 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(60446), // Rule ID 2275 //
     /* 60353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60377 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60381 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60385 */   // MIs[1] Operand 1
     /* 60385 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 60390 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60395 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60404 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60410 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60422 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60426 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60437 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60442 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60444 */   GIR_RootConstrainSelectedInstOperands,
     /* 60445 */   // GIR_Coverage, 2275,
     /* 60445 */   GIR_EraseRootFromParent_Done,
     /* 60446 */ // Label 1419: @60446
     /* 60446 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(60544), // Rule ID 2278 //
     /* 60451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60483 */   // MIs[1] Operand 1
     /* 60483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 60488 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60493 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60502 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60506 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60508 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60520 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60524 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60535 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60540 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60542 */   GIR_RootConstrainSelectedInstOperands,
     /* 60543 */   // GIR_Coverage, 2278,
     /* 60543 */   GIR_EraseRootFromParent_Done,
     /* 60544 */ // Label 1420: @60544
     /* 60544 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(60642), // Rule ID 2280 //
     /* 60549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60573 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60577 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60581 */   // MIs[1] Operand 1
     /* 60581 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60586 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60591 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60606 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60618 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60622 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 60631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60633 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60638 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60640 */   GIR_RootConstrainSelectedInstOperands,
     /* 60641 */   // GIR_Coverage, 2280,
     /* 60641 */   GIR_EraseRootFromParent_Done,
     /* 60642 */ // Label 1421: @60642
     /* 60642 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(60682), // Rule ID 296 //
     /* 60647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 60650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60671 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60675 */   // (select:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)  =>  (PseudoSELECT_I64:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)
     /* 60675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I64),
     /* 60680 */   GIR_RootConstrainSelectedInstOperands,
     /* 60681 */   // GIR_Coverage, 296,
     /* 60681 */   GIR_Done,
     /* 60682 */ // Label 1422: @60682
     /* 60682 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(60722), // Rule ID 298 //
     /* 60687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotMips4_32),
     /* 60690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60711 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60715 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D32:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)
     /* 60715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D32),
     /* 60720 */   GIR_RootConstrainSelectedInstOperands,
     /* 60721 */   // GIR_Coverage, 298,
     /* 60721 */   GIR_Done,
     /* 60722 */ // Label 1423: @60722
     /* 60722 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(60762), // Rule ID 299 //
     /* 60727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotMips4_32),
     /* 60730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60755 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)
     /* 60755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D64),
     /* 60760 */   GIR_RootConstrainSelectedInstOperands,
     /* 60761 */   // GIR_Coverage, 299,
     /* 60761 */   GIR_Done,
     /* 60762 */ // Label 1424: @60762
     /* 60762 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(60808), // Rule ID 1677 //
     /* 60767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60795 */   // (select:{ *:[i64] } GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 60798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60800 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60802 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60804 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60806 */   GIR_RootConstrainSelectedInstOperands,
     /* 60807 */   // GIR_Coverage, 1677,
     /* 60807 */   GIR_EraseRootFromParent_Done,
     /* 60808 */ // Label 1425: @60808
     /* 60808 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(60854), // Rule ID 1683 //
     /* 60813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60837 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60841 */   // (select:{ *:[i64] } GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 60844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60846 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60848 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60850 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60852 */   GIR_RootConstrainSelectedInstOperands,
     /* 60853 */   // GIR_Coverage, 1683,
     /* 60853 */   GIR_EraseRootFromParent_Done,
     /* 60854 */ // Label 1426: @60854
     /* 60854 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(60900), // Rule ID 1722 //
     /* 60859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60887 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 60887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 60890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60892 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60894 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60896 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60898 */   GIR_RootConstrainSelectedInstOperands,
     /* 60899 */   // GIR_Coverage, 1722,
     /* 60899 */   GIR_EraseRootFromParent_Done,
     /* 60900 */ // Label 1427: @60900
     /* 60900 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(60946), // Rule ID 1745 //
     /* 60905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60929 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60933 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 60936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60938 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60940 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60942 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60944 */   GIR_RootConstrainSelectedInstOperands,
     /* 60945 */   // GIR_Coverage, 1745,
     /* 60945 */   GIR_EraseRootFromParent_Done,
     /* 60946 */ // Label 1428: @60946
     /* 60946 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(60992), // Rule ID 1748 //
     /* 60951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60975 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60979 */   // (select:{ *:[f64] } GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60984 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60986 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60988 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60990 */   GIR_RootConstrainSelectedInstOperands,
     /* 60991 */   // GIR_Coverage, 1748,
     /* 60991 */   GIR_EraseRootFromParent_Done,
     /* 60992 */ // Label 1429: @60992
     /* 60992 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(61038), // Rule ID 2281 //
     /* 60997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 61000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61006 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61025 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 61025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 61028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61030 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 61032 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 61034 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 61036 */   GIR_RootConstrainSelectedInstOperands,
     /* 61037 */   // GIR_Coverage, 2281,
     /* 61037 */   GIR_EraseRootFromParent_Done,
     /* 61038 */ // Label 1430: @61038
     /* 61038 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(61116), // Rule ID 1789 //
     /* 61043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61059 */   // (select:{ *:[i64] } i64:{ *:[i64] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$cond), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, i64:{ *:[i64] }:$cond))
     /* 61059 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61062 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61066 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61071 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61075 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61093 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 61114 */   GIR_RootConstrainSelectedInstOperands,
     /* 61115 */   // GIR_Coverage, 1789,
     /* 61115 */   GIR_EraseRootFromParent_Done,
     /* 61116 */ // Label 1431: @61116
     /* 61116 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(61228), // Rule ID 1800 //
     /* 61121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61137 */   // (select:{ *:[i64] } i32:{ *:[i32] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)))
     /* 61137 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 61140 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61144 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61149 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 61155 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 61158 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61162 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61167 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61171 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 61174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 61176 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61179 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61183 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61188 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61206 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61210 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 61213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 61226 */   GIR_RootConstrainSelectedInstOperands,
     /* 61227 */   // GIR_Coverage, 1800,
     /* 61227 */   GIR_EraseRootFromParent_Done,
     /* 61228 */ // Label 1432: @61228
     /* 61228 */ GIM_Reject,
     /* 61229 */ // Label 1289: @61229
     /* 61229 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(61302),
     /* 61234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 61237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 61240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 61243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61255 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61259 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(61280), // Rule ID 583 //
     /* 61264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61267 */     // (vselect:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$wt, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (BSEL_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 61267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_D_PSEUDO),
     /* 61270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61272 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61274 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61276 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61278 */     GIR_RootConstrainSelectedInstOperands,
     /* 61279 */     // GIR_Coverage, 583,
     /* 61279 */     GIR_EraseRootFromParent_Done,
     /* 61280 */   // Label 1434: @61280
     /* 61280 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(61301), // Rule ID 585 //
     /* 61285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61288 */     // (vselect:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$wt, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (BSEL_FD_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 61288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FD_PSEUDO),
     /* 61291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61293 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61295 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61297 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61299 */     GIR_RootConstrainSelectedInstOperands,
     /* 61300 */     // GIR_Coverage, 585,
     /* 61300 */     GIR_EraseRootFromParent_Done,
     /* 61301 */   // Label 1435: @61301
     /* 61301 */   GIM_Reject,
     /* 61302 */ // Label 1433: @61302
     /* 61302 */ GIM_Reject,
     /* 61303 */ // Label 1290: @61303
     /* 61303 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(61376),
     /* 61308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 61311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 61314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 61317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61333 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(61354), // Rule ID 582 //
     /* 61338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61341 */     // (vselect:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$wt, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (BSEL_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 61341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_W_PSEUDO),
     /* 61344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61346 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61348 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61350 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61352 */     GIR_RootConstrainSelectedInstOperands,
     /* 61353 */     // GIR_Coverage, 582,
     /* 61353 */     GIR_EraseRootFromParent_Done,
     /* 61354 */   // Label 1437: @61354
     /* 61354 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(61375), // Rule ID 584 //
     /* 61359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61362 */     // (vselect:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$wt, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (BSEL_FW_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 61362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FW_PSEUDO),
     /* 61365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61367 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61369 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61371 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61373 */     GIR_RootConstrainSelectedInstOperands,
     /* 61374 */     // GIR_Coverage, 584,
     /* 61374 */     GIR_EraseRootFromParent_Done,
     /* 61375 */   // Label 1438: @61375
     /* 61375 */   GIM_Reject,
     /* 61376 */ // Label 1436: @61376
     /* 61376 */ GIM_Reject,
     /* 61377 */ // Label 1291: @61377
     /* 61377 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(61423), // Rule ID 581 //
     /* 61382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 61388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 61391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 61394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61410 */   // (vselect:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$wt, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (BSEL_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 61410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_H_PSEUDO),
     /* 61413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61415 */   GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61417 */   GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61419 */   GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61421 */   GIR_RootConstrainSelectedInstOperands,
     /* 61422 */   // GIR_Coverage, 581,
     /* 61422 */   GIR_EraseRootFromParent_Done,
     /* 61423 */ // Label 1439: @61423
     /* 61423 */ GIM_Reject,
     /* 61424 */ // Label 1292: @61424
     /* 61424 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(61518),
     /* 61429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 61432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 61435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 61438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61454 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(61475), // Rule ID 568 //
     /* 61459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61462 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (BMNZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMNZ_V),
     /* 61465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61467 */     GIR_RootToRootCopy, /*OpIdx*/3, // wd_in
     /* 61469 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 61471 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61473 */     GIR_RootConstrainSelectedInstOperands,
     /* 61474 */     // GIR_Coverage, 568,
     /* 61474 */     GIR_EraseRootFromParent_Done,
     /* 61475 */   // Label 1441: @61475
     /* 61475 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(61496), // Rule ID 570 //
     /* 61480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61483 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BMZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMZ_V),
     /* 61486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61488 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 61490 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61492 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61494 */     GIR_RootConstrainSelectedInstOperands,
     /* 61495 */     // GIR_Coverage, 570,
     /* 61495 */     GIR_EraseRootFromParent_Done,
     /* 61496 */   // Label 1442: @61496
     /* 61496 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(61517), // Rule ID 580 //
     /* 61501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61504 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BSEL_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_V),
     /* 61507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61509 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61511 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61513 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61515 */     GIR_RootConstrainSelectedInstOperands,
     /* 61516 */     // GIR_Coverage, 580,
     /* 61516 */     GIR_EraseRootFromParent_Done,
     /* 61517 */   // Label 1443: @61517
     /* 61517 */   GIM_Reject,
     /* 61518 */ // Label 1440: @61518
     /* 61518 */ GIM_Reject,
     /* 61519 */ // Label 1293: @61519
     /* 61519 */ GIM_Reject,
     /* 61520 */ // Label 44: @61520
     /* 61520 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1446*/ GIMT_Encode4(61628),
     /* 61531 */ /*GILLT_s32*//*Label 1444*/ GIMT_Encode4(61539),
     /* 61535 */ /*GILLT_s64*//*Label 1445*/ GIMT_Encode4(61594),
     /* 61539 */ // Label 1444: @61539
     /* 61539 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(61593),
     /* 61544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61562 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(61577), // Rule ID 331 //
     /* 61567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61570 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU),
     /* 61575 */     GIR_RootConstrainSelectedInstOperands,
     /* 61576 */     // GIR_Coverage, 331,
     /* 61576 */     GIR_Done,
     /* 61577 */   // Label 1448: @61577
     /* 61577 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(61592), // Rule ID 1181 //
     /* 61582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61585 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU_MMR6),
     /* 61590 */     GIR_RootConstrainSelectedInstOperands,
     /* 61591 */     // GIR_Coverage, 1181,
     /* 61591 */     GIR_Done,
     /* 61592 */   // Label 1449: @61592
     /* 61592 */   GIM_Reject,
     /* 61593 */ // Label 1447: @61593
     /* 61593 */ GIM_Reject,
     /* 61594 */ // Label 1445: @61594
     /* 61594 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(61627), // Rule ID 346 //
     /* 61599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61620 */   // (mulhu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUHU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUHU),
     /* 61625 */   GIR_RootConstrainSelectedInstOperands,
     /* 61626 */   // GIR_Coverage, 346,
     /* 61626 */   GIR_Done,
     /* 61627 */ // Label 1450: @61627
     /* 61627 */ GIM_Reject,
     /* 61628 */ // Label 1446: @61628
     /* 61628 */ GIM_Reject,
     /* 61629 */ // Label 45: @61629
     /* 61629 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1453*/ GIMT_Encode4(61737),
     /* 61640 */ /*GILLT_s32*//*Label 1451*/ GIMT_Encode4(61648),
     /* 61644 */ /*GILLT_s64*//*Label 1452*/ GIMT_Encode4(61703),
     /* 61648 */ // Label 1451: @61648
     /* 61648 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(61702),
     /* 61653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61671 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(61686), // Rule ID 330 //
     /* 61676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61679 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH),
     /* 61684 */     GIR_RootConstrainSelectedInstOperands,
     /* 61685 */     // GIR_Coverage, 330,
     /* 61685 */     GIR_Done,
     /* 61686 */   // Label 1455: @61686
     /* 61686 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(61701), // Rule ID 1180 //
     /* 61691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61694 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH_MMR6),
     /* 61699 */     GIR_RootConstrainSelectedInstOperands,
     /* 61700 */     // GIR_Coverage, 1180,
     /* 61700 */     GIR_Done,
     /* 61701 */   // Label 1456: @61701
     /* 61701 */   GIM_Reject,
     /* 61702 */ // Label 1454: @61702
     /* 61702 */ GIM_Reject,
     /* 61703 */ // Label 1452: @61703
     /* 61703 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(61736), // Rule ID 345 //
     /* 61708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61729 */   // (mulhs:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUH:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUH),
     /* 61734 */   GIR_RootConstrainSelectedInstOperands,
     /* 61735 */   // GIR_Coverage, 345,
     /* 61735 */   GIR_Done,
     /* 61736 */ // Label 1457: @61736
     /* 61736 */ GIM_Reject,
     /* 61737 */ // Label 1453: @61737
     /* 61737 */ GIM_Reject,
     /* 61738 */ // Label 46: @61738
     /* 61738 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1462*/ GIMT_Encode4(62650),
     /* 61749 */ /*GILLT_s32*//*Label 1458*/ GIMT_Encode4(61773),
     /* 61753 */ /*GILLT_s64*//*Label 1459*/ GIMT_Encode4(61977), GIMT_Encode4(0),
     /* 61761 */ /*GILLT_v2s64*//*Label 1460*/ GIMT_Encode4(62342), GIMT_Encode4(0),
     /* 61769 */ /*GILLT_v4s32*//*Label 1461*/ GIMT_Encode4(62496),
     /* 61773 */ // Label 1458: @61773
     /* 61773 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(61976),
     /* 61778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61788 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(61845), // Rule ID 163 //
     /* 61793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 61800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61828 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61833 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 61835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61843 */     GIR_RootConstrainSelectedInstOperands,
     /* 61844 */     // GIR_Coverage, 163,
     /* 61844 */     GIR_EraseRootFromParent_Done,
     /* 61845 */   // Label 1464: @61845
     /* 61845 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(61902), // Rule ID 2345 //
     /* 61850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 61861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61885 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft))  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61890 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 61892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61900 */     GIR_RootConstrainSelectedInstOperands,
     /* 61901 */     // GIR_Coverage, 2345,
     /* 61901 */     GIR_EraseRootFromParent_Done,
     /* 61902 */   // Label 1465: @61902
     /* 61902 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(61925), // Rule ID 151 //
     /* 61907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 61910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61918 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S),
     /* 61923 */     GIR_RootConstrainSelectedInstOperands,
     /* 61924 */     // GIR_Coverage, 151,
     /* 61924 */     GIR_Done,
     /* 61925 */   // Label 1466: @61925
     /* 61925 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(61948), // Rule ID 1130 //
     /* 61930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 61933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61941 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MM),
     /* 61946 */     GIR_RootConstrainSelectedInstOperands,
     /* 61947 */     // GIR_Coverage, 1130,
     /* 61947 */     GIR_Done,
     /* 61948 */   // Label 1467: @61948
     /* 61948 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(61975), // Rule ID 1188 //
     /* 61953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 61956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61964 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 61964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MMR6),
     /* 61967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61969 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 61971 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 61973 */     GIR_RootConstrainSelectedInstOperands,
     /* 61974 */     // GIR_Coverage, 1188,
     /* 61974 */     GIR_EraseRootFromParent_Done,
     /* 61975 */   // Label 1468: @61975
     /* 61975 */   GIM_Reject,
     /* 61976 */ // Label 1463: @61976
     /* 61976 */ GIM_Reject,
     /* 61977 */ // Label 1459: @61977
     /* 61977 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(62341),
     /* 61982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61988 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(62049), // Rule ID 165 //
     /* 61993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62032 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62037 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62047 */     GIR_RootConstrainSelectedInstOperands,
     /* 62048 */     // GIR_Coverage, 165,
     /* 62048 */     GIR_EraseRootFromParent_Done,
     /* 62049 */   // Label 1470: @62049
     /* 62049 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(62110), // Rule ID 167 //
     /* 62054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62093 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62098 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62108 */     GIR_RootConstrainSelectedInstOperands,
     /* 62109 */     // GIR_Coverage, 167,
     /* 62109 */     GIR_EraseRootFromParent_Done,
     /* 62110 */   // Label 1471: @62110
     /* 62110 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(62171), // Rule ID 2346 //
     /* 62115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62154 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62159 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62169 */     GIR_RootConstrainSelectedInstOperands,
     /* 62170 */     // GIR_Coverage, 2346,
     /* 62170 */     GIR_EraseRootFromParent_Done,
     /* 62171 */   // Label 1472: @62171
     /* 62171 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(62232), // Rule ID 2347 //
     /* 62176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62215 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62220 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62230 */     GIR_RootConstrainSelectedInstOperands,
     /* 62231 */     // GIR_Coverage, 2347,
     /* 62231 */     GIR_EraseRootFromParent_Done,
     /* 62232 */   // Label 1473: @62232
     /* 62232 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(62259), // Rule ID 152 //
     /* 62237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62252 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32),
     /* 62257 */     GIR_RootConstrainSelectedInstOperands,
     /* 62258 */     // GIR_Coverage, 152,
     /* 62258 */     GIR_Done,
     /* 62259 */   // Label 1474: @62259
     /* 62259 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(62286), // Rule ID 153 //
     /* 62264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 62267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62279 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64),
     /* 62284 */     GIR_RootConstrainSelectedInstOperands,
     /* 62285 */     // GIR_Coverage, 153,
     /* 62285 */     GIR_Done,
     /* 62286 */   // Label 1475: @62286
     /* 62286 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(62313), // Rule ID 1134 //
     /* 62291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 62294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62306 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32_MM),
     /* 62311 */     GIR_RootConstrainSelectedInstOperands,
     /* 62312 */     // GIR_Coverage, 1134,
     /* 62312 */     GIR_Done,
     /* 62313 */   // Label 1476: @62313
     /* 62313 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(62340), // Rule ID 1135 //
     /* 62318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 62321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62333 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64_MM),
     /* 62338 */     GIR_RootConstrainSelectedInstOperands,
     /* 62339 */     // GIR_Coverage, 1135,
     /* 62339 */     GIR_Done,
     /* 62340 */   // Label 1477: @62340
     /* 62340 */   GIM_Reject,
     /* 62341 */ // Label 1469: @62341
     /* 62341 */ GIM_Reject,
     /* 62342 */ // Label 1460: @62342
     /* 62342 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(62495),
     /* 62347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62357 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(62414), // Rule ID 2452 //
     /* 62362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62397 */     // (fadd:{ *:[v2f64] } (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$wd)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62402 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62412 */     GIR_RootConstrainSelectedInstOperands,
     /* 62413 */     // GIR_Coverage, 2452,
     /* 62413 */     GIR_EraseRootFromParent_Done,
     /* 62414 */   // Label 1479: @62414
     /* 62414 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(62471), // Rule ID 1984 //
     /* 62419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62454 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62459 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62469 */     GIR_RootConstrainSelectedInstOperands,
     /* 62470 */     // GIR_Coverage, 1984,
     /* 62470 */     GIR_EraseRootFromParent_Done,
     /* 62471 */   // Label 1480: @62471
     /* 62471 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(62494), // Rule ID 671 //
     /* 62476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62487 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D),
     /* 62492 */     GIR_RootConstrainSelectedInstOperands,
     /* 62493 */     // GIR_Coverage, 671,
     /* 62493 */     GIR_Done,
     /* 62494 */   // Label 1481: @62494
     /* 62494 */   GIM_Reject,
     /* 62495 */ // Label 1478: @62495
     /* 62495 */ GIM_Reject,
     /* 62496 */ // Label 1461: @62496
     /* 62496 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(62649),
     /* 62501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62511 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(62568), // Rule ID 2451 //
     /* 62516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62551 */     // (fadd:{ *:[v4f32] } (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$wd)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62556 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62566 */     GIR_RootConstrainSelectedInstOperands,
     /* 62567 */     // GIR_Coverage, 2451,
     /* 62567 */     GIR_EraseRootFromParent_Done,
     /* 62568 */   // Label 1483: @62568
     /* 62568 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(62625), // Rule ID 1983 //
     /* 62573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62608 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62613 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62623 */     GIR_RootConstrainSelectedInstOperands,
     /* 62624 */     // GIR_Coverage, 1983,
     /* 62624 */     GIR_EraseRootFromParent_Done,
     /* 62625 */   // Label 1484: @62625
     /* 62625 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(62648), // Rule ID 670 //
     /* 62630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62641 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_W),
     /* 62646 */     GIR_RootConstrainSelectedInstOperands,
     /* 62647 */     // GIR_Coverage, 670,
     /* 62647 */     GIR_Done,
     /* 62648 */   // Label 1485: @62648
     /* 62648 */   GIM_Reject,
     /* 62649 */ // Label 1482: @62649
     /* 62649 */ GIM_Reject,
     /* 62650 */ // Label 1462: @62650
     /* 62650 */ GIM_Reject,
     /* 62651 */ // Label 47: @62651
     /* 62651 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1490*/ GIMT_Encode4(63262),
     /* 62662 */ /*GILLT_s32*//*Label 1486*/ GIMT_Encode4(62686),
     /* 62666 */ /*GILLT_s64*//*Label 1487*/ GIMT_Encode4(62833), GIMT_Encode4(0),
     /* 62674 */ /*GILLT_v2s64*//*Label 1488*/ GIMT_Encode4(63076), GIMT_Encode4(0),
     /* 62682 */ /*GILLT_v4s32*//*Label 1489*/ GIMT_Encode4(63169),
     /* 62686 */ // Label 1486: @62686
     /* 62686 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(62832),
     /* 62691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 62694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 62697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62701 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(62758), // Rule ID 164 //
     /* 62706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 62721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 62725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62741 */     // (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_S),
     /* 62744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62746 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62756 */     GIR_RootConstrainSelectedInstOperands,
     /* 62757 */     // GIR_Coverage, 164,
     /* 62757 */     GIR_EraseRootFromParent_Done,
     /* 62758 */   // Label 1492: @62758
     /* 62758 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(62781), // Rule ID 160 //
     /* 62763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 62766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62774 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S),
     /* 62779 */     GIR_RootConstrainSelectedInstOperands,
     /* 62780 */     // GIR_Coverage, 160,
     /* 62780 */     GIR_Done,
     /* 62781 */   // Label 1493: @62781
     /* 62781 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(62804), // Rule ID 1133 //
     /* 62786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 62789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62797 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MM),
     /* 62802 */     GIR_RootConstrainSelectedInstOperands,
     /* 62803 */     // GIR_Coverage, 1133,
     /* 62803 */     GIR_Done,
     /* 62804 */   // Label 1494: @62804
     /* 62804 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(62831), // Rule ID 1189 //
     /* 62809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 62812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62820 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 62820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MMR6),
     /* 62823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62825 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 62827 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 62829 */     GIR_RootConstrainSelectedInstOperands,
     /* 62830 */     // GIR_Coverage, 1189,
     /* 62830 */     GIR_EraseRootFromParent_Done,
     /* 62831 */   // Label 1495: @62831
     /* 62831 */   GIM_Reject,
     /* 62832 */ // Label 1491: @62832
     /* 62832 */ GIM_Reject,
     /* 62833 */ // Label 1487: @62833
     /* 62833 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(63075),
     /* 62838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62844 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(62905), // Rule ID 166 //
     /* 62849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62888 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D32),
     /* 62891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62893 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62903 */     GIR_RootConstrainSelectedInstOperands,
     /* 62904 */     // GIR_Coverage, 166,
     /* 62904 */     GIR_EraseRootFromParent_Done,
     /* 62905 */   // Label 1497: @62905
     /* 62905 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(62966), // Rule ID 168 //
     /* 62910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62949 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D64),
     /* 62952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62954 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62964 */     GIR_RootConstrainSelectedInstOperands,
     /* 62965 */     // GIR_Coverage, 168,
     /* 62965 */     GIR_EraseRootFromParent_Done,
     /* 62966 */   // Label 1498: @62966
     /* 62966 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(62993), // Rule ID 161 //
     /* 62971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62986 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32),
     /* 62991 */     GIR_RootConstrainSelectedInstOperands,
     /* 62992 */     // GIR_Coverage, 161,
     /* 62992 */     GIR_Done,
     /* 62993 */   // Label 1499: @62993
     /* 62993 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(63020), // Rule ID 162 //
     /* 62998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63013 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64),
     /* 63018 */     GIR_RootConstrainSelectedInstOperands,
     /* 63019 */     // GIR_Coverage, 162,
     /* 63019 */     GIR_Done,
     /* 63020 */   // Label 1500: @63020
     /* 63020 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(63047), // Rule ID 1140 //
     /* 63025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63040 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32_MM),
     /* 63045 */     GIR_RootConstrainSelectedInstOperands,
     /* 63046 */     // GIR_Coverage, 1140,
     /* 63046 */     GIR_Done,
     /* 63047 */   // Label 1501: @63047
     /* 63047 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(63074), // Rule ID 1141 //
     /* 63052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63067 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64_MM),
     /* 63072 */     GIR_RootConstrainSelectedInstOperands,
     /* 63073 */     // GIR_Coverage, 1141,
     /* 63073 */     GIR_Done,
     /* 63074 */   // Label 1502: @63074
     /* 63074 */   GIM_Reject,
     /* 63075 */ // Label 1496: @63075
     /* 63075 */ GIM_Reject,
     /* 63076 */ // Label 1488: @63076
     /* 63076 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(63168),
     /* 63081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63095 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(63148), // Rule ID 1982 //
     /* 63100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63131 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_D),
     /* 63134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63136 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63146 */     GIR_RootConstrainSelectedInstOperands,
     /* 63147 */     // GIR_Coverage, 1982,
     /* 63147 */     GIR_EraseRootFromParent_Done,
     /* 63148 */   // Label 1504: @63148
     /* 63148 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(63167), // Rule ID 759 //
     /* 63153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63160 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D),
     /* 63165 */     GIR_RootConstrainSelectedInstOperands,
     /* 63166 */     // GIR_Coverage, 759,
     /* 63166 */     GIR_Done,
     /* 63167 */   // Label 1505: @63167
     /* 63167 */   GIM_Reject,
     /* 63168 */ // Label 1503: @63168
     /* 63168 */ GIM_Reject,
     /* 63169 */ // Label 1489: @63169
     /* 63169 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(63261),
     /* 63174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63188 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(63241), // Rule ID 1981 //
     /* 63193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63224 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_W),
     /* 63227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63229 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63239 */     GIR_RootConstrainSelectedInstOperands,
     /* 63240 */     // GIR_Coverage, 1981,
     /* 63240 */     GIR_EraseRootFromParent_Done,
     /* 63241 */   // Label 1507: @63241
     /* 63241 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(63260), // Rule ID 758 //
     /* 63246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63253 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_W),
     /* 63258 */     GIR_RootConstrainSelectedInstOperands,
     /* 63259 */     // GIR_Coverage, 758,
     /* 63259 */     GIR_Done,
     /* 63260 */   // Label 1508: @63260
     /* 63260 */   GIM_Reject,
     /* 63261 */ // Label 1506: @63261
     /* 63261 */ GIM_Reject,
     /* 63262 */ // Label 1490: @63262
     /* 63262 */ GIM_Reject,
     /* 63263 */ // Label 48: @63263
     /* 63263 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1513*/ GIMT_Encode4(63749),
     /* 63274 */ /*GILLT_s32*//*Label 1509*/ GIMT_Encode4(63298),
     /* 63278 */ /*GILLT_s64*//*Label 1510*/ GIMT_Encode4(63372), GIMT_Encode4(0),
     /* 63286 */ /*GILLT_v2s64*//*Label 1511*/ GIMT_Encode4(63493), GIMT_Encode4(0),
     /* 63294 */ /*GILLT_v4s32*//*Label 1512*/ GIMT_Encode4(63621),
     /* 63298 */ // Label 1509: @63298
     /* 63298 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(63371),
     /* 63303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63321 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(63336), // Rule ID 157 //
     /* 63326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63329 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S),
     /* 63334 */     GIR_RootConstrainSelectedInstOperands,
     /* 63335 */     // GIR_Coverage, 157,
     /* 63335 */     GIR_Done,
     /* 63336 */   // Label 1515: @63336
     /* 63336 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(63351), // Rule ID 1132 //
     /* 63341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63344 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MM),
     /* 63349 */     GIR_RootConstrainSelectedInstOperands,
     /* 63350 */     // GIR_Coverage, 1132,
     /* 63350 */     GIR_Done,
     /* 63351 */   // Label 1516: @63351
     /* 63351 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(63370), // Rule ID 1190 //
     /* 63356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63359 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MMR6),
     /* 63362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63364 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63366 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63368 */     GIR_RootConstrainSelectedInstOperands,
     /* 63369 */     // GIR_Coverage, 1190,
     /* 63369 */     GIR_EraseRootFromParent_Done,
     /* 63370 */   // Label 1517: @63370
     /* 63370 */   GIM_Reject,
     /* 63371 */ // Label 1514: @63371
     /* 63371 */ GIM_Reject,
     /* 63372 */ // Label 1510: @63372
     /* 63372 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(63492),
     /* 63377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63383 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(63410), // Rule ID 158 //
     /* 63388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63403 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32),
     /* 63408 */     GIR_RootConstrainSelectedInstOperands,
     /* 63409 */     // GIR_Coverage, 158,
     /* 63409 */     GIR_Done,
     /* 63410 */   // Label 1519: @63410
     /* 63410 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(63437), // Rule ID 159 //
     /* 63415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63430 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64),
     /* 63435 */     GIR_RootConstrainSelectedInstOperands,
     /* 63436 */     // GIR_Coverage, 159,
     /* 63436 */     GIR_Done,
     /* 63437 */   // Label 1520: @63437
     /* 63437 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(63464), // Rule ID 1138 //
     /* 63442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63457 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32_MM),
     /* 63462 */     GIR_RootConstrainSelectedInstOperands,
     /* 63463 */     // GIR_Coverage, 1138,
     /* 63463 */     GIR_Done,
     /* 63464 */   // Label 1521: @63464
     /* 63464 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(63491), // Rule ID 1139 //
     /* 63469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63484 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64_MM),
     /* 63489 */     GIR_RootConstrainSelectedInstOperands,
     /* 63490 */     // GIR_Coverage, 1139,
     /* 63490 */     GIR_Done,
     /* 63491 */   // Label 1522: @63491
     /* 63491 */   GIM_Reject,
     /* 63492 */ // Label 1518: @63492
     /* 63492 */ GIM_Reject,
     /* 63493 */ // Label 1511: @63493
     /* 63493 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(63620),
     /* 63498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63508 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63552), // Rule ID 2388 //
     /* 63513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63539 */     // (fmul:{ *:[v2f64] } (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63544 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63550 */     GIR_RootConstrainSelectedInstOperands,
     /* 63551 */     // GIR_Coverage, 2388,
     /* 63551 */     GIR_EraseRootFromParent_Done,
     /* 63552 */   // Label 1524: @63552
     /* 63552 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63596), // Rule ID 701 //
     /* 63557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63583 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63588 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63594 */     GIR_RootConstrainSelectedInstOperands,
     /* 63595 */     // GIR_Coverage, 701,
     /* 63595 */     GIR_EraseRootFromParent_Done,
     /* 63596 */   // Label 1525: @63596
     /* 63596 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63619), // Rule ID 737 //
     /* 63601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63612 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMUL_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D),
     /* 63617 */     GIR_RootConstrainSelectedInstOperands,
     /* 63618 */     // GIR_Coverage, 737,
     /* 63618 */     GIR_Done,
     /* 63619 */   // Label 1526: @63619
     /* 63619 */   GIM_Reject,
     /* 63620 */ // Label 1523: @63620
     /* 63620 */ GIM_Reject,
     /* 63621 */ // Label 1512: @63621
     /* 63621 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63748),
     /* 63626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63636 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63680), // Rule ID 2387 //
     /* 63641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63667 */     // (fmul:{ *:[v4f32] } (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63672 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63678 */     GIR_RootConstrainSelectedInstOperands,
     /* 63679 */     // GIR_Coverage, 2387,
     /* 63679 */     GIR_EraseRootFromParent_Done,
     /* 63680 */   // Label 1528: @63680
     /* 63680 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63724), // Rule ID 700 //
     /* 63685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63711 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63716 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63722 */     GIR_RootConstrainSelectedInstOperands,
     /* 63723 */     // GIR_Coverage, 700,
     /* 63723 */     GIR_EraseRootFromParent_Done,
     /* 63724 */   // Label 1529: @63724
     /* 63724 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63747), // Rule ID 736 //
     /* 63729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63740 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMUL_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_W),
     /* 63745 */     GIR_RootConstrainSelectedInstOperands,
     /* 63746 */     // GIR_Coverage, 736,
     /* 63746 */     GIR_Done,
     /* 63747 */   // Label 1530: @63747
     /* 63747 */   GIM_Reject,
     /* 63748 */ // Label 1527: @63748
     /* 63748 */ GIM_Reject,
     /* 63749 */ // Label 1513: @63749
     /* 63749 */ GIM_Reject,
     /* 63750 */ // Label 49: @63750
     /* 63750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1533*/ GIMT_Encode4(63855),
     /* 63761 */ /*GILLT_v2s64*//*Label 1531*/ GIMT_Encode4(63773), GIMT_Encode4(0),
     /* 63769 */ /*GILLT_v4s32*//*Label 1532*/ GIMT_Encode4(63814),
     /* 63773 */ // Label 1531: @63773
     /* 63773 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(63813), // Rule ID 725 //
     /* 63778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 63790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63802 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63806 */   // (fma:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 63811 */   GIR_RootConstrainSelectedInstOperands,
     /* 63812 */   // GIR_Coverage, 725,
     /* 63812 */   GIR_Done,
     /* 63813 */ // Label 1534: @63813
     /* 63813 */ GIM_Reject,
     /* 63814 */ // Label 1532: @63814
     /* 63814 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(63854), // Rule ID 724 //
     /* 63819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 63831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63847 */   // (fma:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 63852 */   GIR_RootConstrainSelectedInstOperands,
     /* 63853 */   // GIR_Coverage, 724,
     /* 63853 */   GIR_Done,
     /* 63854 */ // Label 1535: @63854
     /* 63854 */ GIM_Reject,
     /* 63855 */ // Label 1533: @63855
     /* 63855 */ GIM_Reject,
     /* 63856 */ // Label 50: @63856
     /* 63856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1540*/ GIMT_Encode4(64154),
     /* 63867 */ /*GILLT_s32*//*Label 1536*/ GIMT_Encode4(63891),
     /* 63871 */ /*GILLT_s64*//*Label 1537*/ GIMT_Encode4(63965), GIMT_Encode4(0),
     /* 63879 */ /*GILLT_v2s64*//*Label 1538*/ GIMT_Encode4(64086), GIMT_Encode4(0),
     /* 63887 */ /*GILLT_v4s32*//*Label 1539*/ GIMT_Encode4(64120),
     /* 63891 */ // Label 1536: @63891
     /* 63891 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(63964),
     /* 63896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63914 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(63929), // Rule ID 154 //
     /* 63919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63922 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S),
     /* 63927 */     GIR_RootConstrainSelectedInstOperands,
     /* 63928 */     // GIR_Coverage, 154,
     /* 63928 */     GIR_Done,
     /* 63929 */   // Label 1542: @63929
     /* 63929 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(63944), // Rule ID 1131 //
     /* 63934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63937 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MM),
     /* 63942 */     GIR_RootConstrainSelectedInstOperands,
     /* 63943 */     // GIR_Coverage, 1131,
     /* 63943 */     GIR_Done,
     /* 63944 */   // Label 1543: @63944
     /* 63944 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(63963), // Rule ID 1191 //
     /* 63949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63952 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MMR6),
     /* 63955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63957 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63959 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63961 */     GIR_RootConstrainSelectedInstOperands,
     /* 63962 */     // GIR_Coverage, 1191,
     /* 63962 */     GIR_EraseRootFromParent_Done,
     /* 63963 */   // Label 1544: @63963
     /* 63963 */   GIM_Reject,
     /* 63964 */ // Label 1541: @63964
     /* 63964 */ GIM_Reject,
     /* 63965 */ // Label 1537: @63965
     /* 63965 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(64085),
     /* 63970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63976 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(64003), // Rule ID 155 //
     /* 63981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63996 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32),
     /* 64001 */     GIR_RootConstrainSelectedInstOperands,
     /* 64002 */     // GIR_Coverage, 155,
     /* 64002 */     GIR_Done,
     /* 64003 */   // Label 1546: @64003
     /* 64003 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(64030), // Rule ID 156 //
     /* 64008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 64011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64023 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64),
     /* 64028 */     GIR_RootConstrainSelectedInstOperands,
     /* 64029 */     // GIR_Coverage, 156,
     /* 64029 */     GIR_Done,
     /* 64030 */   // Label 1547: @64030
     /* 64030 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(64057), // Rule ID 1136 //
     /* 64035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 64038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64050 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32_MM),
     /* 64055 */     GIR_RootConstrainSelectedInstOperands,
     /* 64056 */     // GIR_Coverage, 1136,
     /* 64056 */     GIR_Done,
     /* 64057 */   // Label 1548: @64057
     /* 64057 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(64084), // Rule ID 1137 //
     /* 64062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 64065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64077 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64_MM),
     /* 64082 */     GIR_RootConstrainSelectedInstOperands,
     /* 64083 */     // GIR_Coverage, 1137,
     /* 64083 */     GIR_Done,
     /* 64084 */   // Label 1549: @64084
     /* 64084 */   GIM_Reject,
     /* 64085 */ // Label 1545: @64085
     /* 64085 */ GIM_Reject,
     /* 64086 */ // Label 1538: @64086
     /* 64086 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(64119), // Rule ID 697 //
     /* 64091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 64100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64112 */   // (fdiv:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FDIV_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 64112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D),
     /* 64117 */   GIR_RootConstrainSelectedInstOperands,
     /* 64118 */   // GIR_Coverage, 697,
     /* 64118 */   GIR_Done,
     /* 64119 */ // Label 1550: @64119
     /* 64119 */ GIM_Reject,
     /* 64120 */ // Label 1539: @64120
     /* 64120 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(64153), // Rule ID 696 //
     /* 64125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 64134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64146 */   // (fdiv:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FDIV_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 64146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_W),
     /* 64151 */   GIR_RootConstrainSelectedInstOperands,
     /* 64152 */   // GIR_Coverage, 696,
     /* 64152 */   GIR_Done,
     /* 64153 */ // Label 1551: @64153
     /* 64153 */ GIM_Reject,
     /* 64154 */ // Label 1540: @64154
     /* 64154 */ GIM_Reject,
     /* 64155 */ // Label 51: @64155
     /* 64155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1554*/ GIMT_Encode4(64232),
     /* 64166 */ /*GILLT_v2s64*//*Label 1552*/ GIMT_Encode4(64178), GIMT_Encode4(0),
     /* 64174 */ /*GILLT_v4s32*//*Label 1553*/ GIMT_Encode4(64205),
     /* 64178 */ // Label 1552: @64178
     /* 64178 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(64204), // Rule ID 703 //
     /* 64183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64197 */   // (fexp2:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)  =>  (FEXP2_D_1_PSEUDO:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)
     /* 64197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D_1_PSEUDO),
     /* 64202 */   GIR_RootConstrainSelectedInstOperands,
     /* 64203 */   // GIR_Coverage, 703,
     /* 64203 */   GIR_Done,
     /* 64204 */ // Label 1555: @64204
     /* 64204 */ GIM_Reject,
     /* 64205 */ // Label 1553: @64205
     /* 64205 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(64231), // Rule ID 702 //
     /* 64210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64224 */   // (fexp2:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)  =>  (FEXP2_W_1_PSEUDO:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)
     /* 64224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W_1_PSEUDO),
     /* 64229 */   GIR_RootConstrainSelectedInstOperands,
     /* 64230 */   // GIR_Coverage, 702,
     /* 64230 */   GIR_Done,
     /* 64231 */ // Label 1556: @64231
     /* 64231 */ GIM_Reject,
     /* 64232 */ // Label 1554: @64232
     /* 64232 */ GIM_Reject,
     /* 64233 */ // Label 52: @64233
     /* 64233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1559*/ GIMT_Encode4(64310),
     /* 64244 */ /*GILLT_v2s64*//*Label 1557*/ GIMT_Encode4(64256), GIMT_Encode4(0),
     /* 64252 */ /*GILLT_v4s32*//*Label 1558*/ GIMT_Encode4(64283),
     /* 64256 */ // Label 1557: @64256
     /* 64256 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(64282), // Rule ID 723 //
     /* 64261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64275 */   // (flog2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FLOG2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 64275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_D),
     /* 64280 */   GIR_RootConstrainSelectedInstOperands,
     /* 64281 */   // GIR_Coverage, 723,
     /* 64281 */   GIR_Done,
     /* 64282 */ // Label 1560: @64282
     /* 64282 */ GIM_Reject,
     /* 64283 */ // Label 1558: @64283
     /* 64283 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(64309), // Rule ID 722 //
     /* 64288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64302 */   // (flog2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FLOG2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 64302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_W),
     /* 64307 */   GIR_RootConstrainSelectedInstOperands,
     /* 64308 */   // GIR_Coverage, 722,
     /* 64308 */   GIR_Done,
     /* 64309 */ // Label 1561: @64309
     /* 64309 */ GIM_Reject,
     /* 64310 */ // Label 1559: @64310
     /* 64310 */ GIM_Reject,
     /* 64311 */ // Label 53: @64311
     /* 64311 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1564*/ GIMT_Encode4(65679),
     /* 64322 */ /*GILLT_s32*//*Label 1562*/ GIMT_Encode4(64330),
     /* 64326 */ /*GILLT_s64*//*Label 1563*/ GIMT_Encode4(64857),
     /* 64330 */ // Label 1562: @64330
     /* 64330 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(64856),
     /* 64335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 64338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64342 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(64418), // Rule ID 1458 //
     /* 64347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64399 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64416 */     GIR_RootConstrainSelectedInstOperands,
     /* 64417 */     // GIR_Coverage, 1458,
     /* 64417 */     GIR_EraseRootFromParent_Done,
     /* 64418 */   // Label 1566: @64418
     /* 64418 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(64494), // Rule ID 2237 //
     /* 64423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64475 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64492 */     GIR_RootConstrainSelectedInstOperands,
     /* 64493 */     // GIR_Coverage, 2237,
     /* 64493 */     GIR_EraseRootFromParent_Done,
     /* 64494 */   // Label 1567: @64494
     /* 64494 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(64570), // Rule ID 2423 //
     /* 64499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64551 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64568 */     GIR_RootConstrainSelectedInstOperands,
     /* 64569 */     // GIR_Coverage, 2423,
     /* 64569 */     GIR_EraseRootFromParent_Done,
     /* 64570 */   // Label 1568: @64570
     /* 64570 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(64646), // Rule ID 2509 //
     /* 64575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64627 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64644 */     GIR_RootConstrainSelectedInstOperands,
     /* 64645 */     // GIR_Coverage, 2509,
     /* 64645 */     GIR_EraseRootFromParent_Done,
     /* 64646 */   // Label 1569: @64646
     /* 64646 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(64722), // Rule ID 1459 //
     /* 64651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64703 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S),
     /* 64706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64720 */     GIR_RootConstrainSelectedInstOperands,
     /* 64721 */     // GIR_Coverage, 1459,
     /* 64721 */     GIR_EraseRootFromParent_Done,
     /* 64722 */   // Label 1570: @64722
     /* 64722 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(64798), // Rule ID 2238 //
     /* 64727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64779 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S_MM),
     /* 64782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64796 */     GIR_RootConstrainSelectedInstOperands,
     /* 64797 */     // GIR_Coverage, 2238,
     /* 64797 */     GIR_EraseRootFromParent_Done,
     /* 64798 */   // Label 1571: @64798
     /* 64798 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(64817), // Rule ID 129 //
     /* 64803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat),
     /* 64806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64810 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S),
     /* 64815 */     GIR_RootConstrainSelectedInstOperands,
     /* 64816 */     // GIR_Coverage, 129,
     /* 64816 */     GIR_Done,
     /* 64817 */   // Label 1572: @64817
     /* 64817 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(64836), // Rule ID 1153 //
     /* 64822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 64825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64829 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MM),
     /* 64834 */     GIR_RootConstrainSelectedInstOperands,
     /* 64835 */     // GIR_Coverage, 1153,
     /* 64835 */     GIR_Done,
     /* 64836 */   // Label 1573: @64836
     /* 64836 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(64855), // Rule ID 1192 //
     /* 64841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 64844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64848 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MMR6),
     /* 64853 */     GIR_RootConstrainSelectedInstOperands,
     /* 64854 */     // GIR_Coverage, 1192,
     /* 64854 */     GIR_Done,
     /* 64855 */   // Label 1574: @64855
     /* 64855 */   GIM_Reject,
     /* 64856 */ // Label 1565: @64856
     /* 64856 */ GIM_Reject,
     /* 64857 */ // Label 1563: @64857
     /* 64857 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(65678),
     /* 64862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64865 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(64945), // Rule ID 1460 //
     /* 64870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 64905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 64909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64926 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 64929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64943 */     GIR_RootConstrainSelectedInstOperands,
     /* 64944 */     // GIR_Coverage, 1460,
     /* 64944 */     GIR_EraseRootFromParent_Done,
     /* 64945 */   // Label 1576: @64945
     /* 64945 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(65025), // Rule ID 1462 //
     /* 64950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 64985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 64989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65006 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65023 */     GIR_RootConstrainSelectedInstOperands,
     /* 65024 */     // GIR_Coverage, 1462,
     /* 65024 */     GIR_EraseRootFromParent_Done,
     /* 65025 */   // Label 1577: @65025
     /* 65025 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(65105), // Rule ID 2239 //
     /* 65030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65086 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65103 */     GIR_RootConstrainSelectedInstOperands,
     /* 65104 */     // GIR_Coverage, 2239,
     /* 65104 */     GIR_EraseRootFromParent_Done,
     /* 65105 */   // Label 1578: @65105
     /* 65105 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(65185), // Rule ID 2424 //
     /* 65110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65166 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 65169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65183 */     GIR_RootConstrainSelectedInstOperands,
     /* 65184 */     // GIR_Coverage, 2424,
     /* 65184 */     GIR_EraseRootFromParent_Done,
     /* 65185 */   // Label 1579: @65185
     /* 65185 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(65265), // Rule ID 2425 //
     /* 65190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65246 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65263 */     GIR_RootConstrainSelectedInstOperands,
     /* 65264 */     // GIR_Coverage, 2425,
     /* 65264 */     GIR_EraseRootFromParent_Done,
     /* 65265 */   // Label 1580: @65265
     /* 65265 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(65345), // Rule ID 2510 //
     /* 65270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65326 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65343 */     GIR_RootConstrainSelectedInstOperands,
     /* 65344 */     // GIR_Coverage, 2510,
     /* 65344 */     GIR_EraseRootFromParent_Done,
     /* 65345 */   // Label 1581: @65345
     /* 65345 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(65425), // Rule ID 1461 //
     /* 65350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65406 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32),
     /* 65409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65423 */     GIR_RootConstrainSelectedInstOperands,
     /* 65424 */     // GIR_Coverage, 1461,
     /* 65424 */     GIR_EraseRootFromParent_Done,
     /* 65425 */   // Label 1582: @65425
     /* 65425 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(65505), // Rule ID 1463 //
     /* 65430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65486 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D64),
     /* 65489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65503 */     GIR_RootConstrainSelectedInstOperands,
     /* 65504 */     // GIR_Coverage, 1463,
     /* 65504 */     GIR_EraseRootFromParent_Done,
     /* 65505 */   // Label 1583: @65505
     /* 65505 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(65585), // Rule ID 2240 //
     /* 65510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65566 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32_MM),
     /* 65569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65583 */     GIR_RootConstrainSelectedInstOperands,
     /* 65584 */     // GIR_Coverage, 2240,
     /* 65584 */     GIR_EraseRootFromParent_Done,
     /* 65585 */   // Label 1584: @65585
     /* 65585 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(65608), // Rule ID 130 //
     /* 65590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 65593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65601 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32),
     /* 65606 */     GIR_RootConstrainSelectedInstOperands,
     /* 65607 */     // GIR_Coverage, 130,
     /* 65607 */     GIR_Done,
     /* 65608 */   // Label 1585: @65608
     /* 65608 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(65631), // Rule ID 131 //
     /* 65613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 65616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65624 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64),
     /* 65629 */     GIR_RootConstrainSelectedInstOperands,
     /* 65630 */     // GIR_Coverage, 131,
     /* 65630 */     GIR_Done,
     /* 65631 */   // Label 1586: @65631
     /* 65631 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(65654), // Rule ID 1154 //
     /* 65636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 65639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65647 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32_MM),
     /* 65652 */     GIR_RootConstrainSelectedInstOperands,
     /* 65653 */     // GIR_Coverage, 1154,
     /* 65653 */     GIR_Done,
     /* 65654 */   // Label 1587: @65654
     /* 65654 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(65677), // Rule ID 1155 //
     /* 65659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 65662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65670 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64_MM),
     /* 65675 */     GIR_RootConstrainSelectedInstOperands,
     /* 65676 */     // GIR_Coverage, 1155,
     /* 65676 */     GIR_Done,
     /* 65677 */   // Label 1588: @65677
     /* 65677 */   GIM_Reject,
     /* 65678 */ // Label 1575: @65678
     /* 65678 */ GIM_Reject,
     /* 65679 */ // Label 1564: @65679
     /* 65679 */ GIM_Reject,
     /* 65680 */ // Label 54: @65680
     /* 65680 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1591*/ GIMT_Encode4(65857),
     /* 65691 */ /*GILLT_s32*//*Label 1589*/ GIMT_Encode4(65699),
     /* 65695 */ /*GILLT_s64*//*Label 1590*/ GIMT_Encode4(65726),
     /* 65699 */ // Label 1589: @65699
     /* 65699 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(65725), // Rule ID 1056 //
     /* 65704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65718 */   // (fpextend:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_W_PSEUDO:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)
     /* 65718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_W_PSEUDO),
     /* 65723 */   GIR_RootConstrainSelectedInstOperands,
     /* 65724 */   // GIR_Coverage, 1056,
     /* 65724 */   GIR_Done,
     /* 65725 */ // Label 1592: @65725
     /* 65725 */ GIM_Reject,
     /* 65726 */ // Label 1590: @65726
     /* 65726 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(65752), // Rule ID 1058 //
     /* 65731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65745 */   // (fpextend:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_D_PSEUDO:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)
     /* 65745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_D_PSEUDO),
     /* 65750 */   GIR_RootConstrainSelectedInstOperands,
     /* 65751 */   // GIR_Coverage, 1058,
     /* 65751 */   GIR_Done,
     /* 65752 */ // Label 1593: @65752
     /* 65752 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(65778), // Rule ID 1447 //
     /* 65757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65771 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S),
     /* 65776 */   GIR_RootConstrainSelectedInstOperands,
     /* 65777 */   // GIR_Coverage, 1447,
     /* 65777 */   GIR_Done,
     /* 65778 */ // Label 1594: @65778
     /* 65778 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(65804), // Rule ID 1457 //
     /* 65783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65797 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S),
     /* 65802 */   GIR_RootConstrainSelectedInstOperands,
     /* 65803 */   // GIR_Coverage, 1457,
     /* 65803 */   GIR_Done,
     /* 65804 */ // Label 1595: @65804
     /* 65804 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(65830), // Rule ID 2251 //
     /* 65809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 65812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65823 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S_MM),
     /* 65828 */   GIR_RootConstrainSelectedInstOperands,
     /* 65829 */   // GIR_Coverage, 2251,
     /* 65829 */   GIR_Done,
     /* 65830 */ // Label 1596: @65830
     /* 65830 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(65856), // Rule ID 2253 //
     /* 65835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 65838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65849 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S_MM),
     /* 65854 */   GIR_RootConstrainSelectedInstOperands,
     /* 65855 */   // GIR_Coverage, 2253,
     /* 65855 */   GIR_Done,
     /* 65856 */ // Label 1597: @65856
     /* 65856 */ GIM_Reject,
     /* 65857 */ // Label 1591: @65857
     /* 65857 */ GIM_Reject,
     /* 65858 */ // Label 55: @65858
     /* 65858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 1600*/ GIMT_Encode4(66020),
     /* 65869 */ /*GILLT_s16*//*Label 1598*/ GIMT_Encode4(65877),
     /* 65873 */ /*GILLT_s32*//*Label 1599*/ GIMT_Encode4(65930),
     /* 65877 */ // Label 1598: @65877
     /* 65877 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(65903), // Rule ID 1057 //
     /* 65882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65896 */   // (fpround:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MSA_FP_ROUND_W_PSEUDO:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 65896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_W_PSEUDO),
     /* 65901 */   GIR_RootConstrainSelectedInstOperands,
     /* 65902 */   // GIR_Coverage, 1057,
     /* 65902 */   GIR_Done,
     /* 65903 */ // Label 1601: @65903
     /* 65903 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(65929), // Rule ID 1059 //
     /* 65908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65922 */   // (fpround:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (MSA_FP_ROUND_D_PSEUDO:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_D_PSEUDO),
     /* 65927 */   GIR_RootConstrainSelectedInstOperands,
     /* 65928 */   // GIR_Coverage, 1059,
     /* 65928 */   GIR_Done,
     /* 65929 */ // Label 1602: @65929
     /* 65929 */ GIM_Reject,
     /* 65930 */ // Label 1599: @65930
     /* 65930 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(66019),
     /* 65935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65942 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(65961), // Rule ID 1446 //
     /* 65947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65954 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 65954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32),
     /* 65959 */     GIR_RootConstrainSelectedInstOperands,
     /* 65960 */     // GIR_Coverage, 1446,
     /* 65960 */     GIR_Done,
     /* 65961 */   // Label 1604: @65961
     /* 65961 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(65980), // Rule ID 1456 //
     /* 65966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65973 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 65973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64),
     /* 65978 */     GIR_RootConstrainSelectedInstOperands,
     /* 65979 */     // GIR_Coverage, 1456,
     /* 65979 */     GIR_Done,
     /* 65980 */   // Label 1605: @65980
     /* 65980 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(65999), // Rule ID 2250 //
     /* 65985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 65988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65992 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64_MM:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 65992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64_MM),
     /* 65997 */     GIR_RootConstrainSelectedInstOperands,
     /* 65998 */     // GIR_Coverage, 2250,
     /* 65998 */     GIR_Done,
     /* 65999 */   // Label 1606: @65999
     /* 65999 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(66018), // Rule ID 2252 //
     /* 66004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 66007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66011 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32_MM:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 66011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32_MM),
     /* 66016 */     GIR_RootConstrainSelectedInstOperands,
     /* 66017 */     // GIR_Coverage, 2252,
     /* 66017 */     GIR_Done,
     /* 66018 */   // Label 1607: @66018
     /* 66018 */   GIM_Reject,
     /* 66019 */ // Label 1603: @66019
     /* 66019 */ GIM_Reject,
     /* 66020 */ // Label 1600: @66020
     /* 66020 */ GIM_Reject,
     /* 66021 */ // Label 56: @66021
     /* 66021 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1610*/ GIMT_Encode4(66098),
     /* 66032 */ /*GILLT_v2s64*//*Label 1608*/ GIMT_Encode4(66044), GIMT_Encode4(0),
     /* 66040 */ /*GILLT_v4s32*//*Label 1609*/ GIMT_Encode4(66071),
     /* 66044 */ // Label 1608: @66044
     /* 66044 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(66070), // Rule ID 777 //
     /* 66049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66063 */   // (fp_to_sint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_D),
     /* 66068 */   GIR_RootConstrainSelectedInstOperands,
     /* 66069 */   // GIR_Coverage, 777,
     /* 66069 */   GIR_Done,
     /* 66070 */ // Label 1611: @66070
     /* 66070 */ GIM_Reject,
     /* 66071 */ // Label 1609: @66071
     /* 66071 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(66097), // Rule ID 776 //
     /* 66076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66090 */   // (fp_to_sint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_W),
     /* 66095 */   GIR_RootConstrainSelectedInstOperands,
     /* 66096 */   // GIR_Coverage, 776,
     /* 66096 */   GIR_Done,
     /* 66097 */ // Label 1612: @66097
     /* 66097 */ GIM_Reject,
     /* 66098 */ // Label 1610: @66098
     /* 66098 */ GIM_Reject,
     /* 66099 */ // Label 57: @66099
     /* 66099 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1615*/ GIMT_Encode4(66176),
     /* 66110 */ /*GILLT_v2s64*//*Label 1613*/ GIMT_Encode4(66122), GIMT_Encode4(0),
     /* 66118 */ /*GILLT_v4s32*//*Label 1614*/ GIMT_Encode4(66149),
     /* 66122 */ // Label 1613: @66122
     /* 66122 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(66148), // Rule ID 779 //
     /* 66127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66141 */   // (fp_to_uint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_D),
     /* 66146 */   GIR_RootConstrainSelectedInstOperands,
     /* 66147 */   // GIR_Coverage, 779,
     /* 66147 */   GIR_Done,
     /* 66148 */ // Label 1616: @66148
     /* 66148 */ GIM_Reject,
     /* 66149 */ // Label 1614: @66149
     /* 66149 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(66175), // Rule ID 778 //
     /* 66154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66168 */   // (fp_to_uint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_W),
     /* 66173 */   GIR_RootConstrainSelectedInstOperands,
     /* 66174 */   // GIR_Coverage, 778,
     /* 66174 */   GIR_Done,
     /* 66175 */ // Label 1617: @66175
     /* 66175 */ GIM_Reject,
     /* 66176 */ // Label 1615: @66176
     /* 66176 */ GIM_Reject,
     /* 66177 */ // Label 58: @66177
     /* 66177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1622*/ GIMT_Encode4(66429),
     /* 66188 */ /*GILLT_s32*//*Label 1618*/ GIMT_Encode4(66212),
     /* 66192 */ /*GILLT_s64*//*Label 1619*/ GIMT_Encode4(66296), GIMT_Encode4(0),
     /* 66200 */ /*GILLT_v2s64*//*Label 1620*/ GIMT_Encode4(66375), GIMT_Encode4(0),
     /* 66208 */ /*GILLT_v4s32*//*Label 1621*/ GIMT_Encode4(66402),
     /* 66212 */ // Label 1618: @66212
     /* 66212 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(66235), // Rule ID 1441 //
     /* 66217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66228 */   // (sint_to_fp:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_S_W:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_W),
     /* 66233 */   GIR_RootConstrainSelectedInstOperands,
     /* 66234 */   // GIR_Coverage, 1441,
     /* 66234 */   GIR_Done,
     /* 66235 */ // Label 1623: @66235
     /* 66235 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(66295), // Rule ID 1451 //
     /* 66240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66254 */   // (sint_to_fp:{ *:[f32] } GPR64Opnd:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[f32] } (PseudoCVT_S_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src), sub_lo:{ *:[i32] })
     /* 66254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_L),
     /* 66261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 66270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66277 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(Mips::sub_lo),
     /* 66284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66294 */   // GIR_Coverage, 1451,
     /* 66294 */   GIR_EraseRootFromParent_Done,
     /* 66295 */ // Label 1624: @66295
     /* 66295 */ GIM_Reject,
     /* 66296 */ // Label 1619: @66296
     /* 66296 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(66322), // Rule ID 1444 //
     /* 66301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotFP64bit),
     /* 66304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66315 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D32_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D32_W),
     /* 66320 */   GIR_RootConstrainSelectedInstOperands,
     /* 66321 */   // GIR_Coverage, 1444,
     /* 66321 */   GIR_Done,
     /* 66322 */ // Label 1625: @66322
     /* 66322 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(66348), // Rule ID 1450 //
     /* 66327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66341 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D64_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_W),
     /* 66346 */   GIR_RootConstrainSelectedInstOperands,
     /* 66347 */   // GIR_Coverage, 1450,
     /* 66347 */   GIR_Done,
     /* 66348 */ // Label 1626: @66348
     /* 66348 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(66374), // Rule ID 1452 //
     /* 66353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66367 */   // (sint_to_fp:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)  =>  (PseudoCVT_D64_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)
     /* 66367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_L),
     /* 66372 */   GIR_RootConstrainSelectedInstOperands,
     /* 66373 */   // GIR_Coverage, 1452,
     /* 66373 */   GIR_Done,
     /* 66374 */ // Label 1627: @66374
     /* 66374 */ GIM_Reject,
     /* 66375 */ // Label 1620: @66375
     /* 66375 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(66401), // Rule ID 709 //
     /* 66380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66394 */   // (sint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_S_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_D),
     /* 66399 */   GIR_RootConstrainSelectedInstOperands,
     /* 66400 */   // GIR_Coverage, 709,
     /* 66400 */   GIR_Done,
     /* 66401 */ // Label 1628: @66401
     /* 66401 */ GIM_Reject,
     /* 66402 */ // Label 1621: @66402
     /* 66402 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(66428), // Rule ID 708 //
     /* 66407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66421 */   // (sint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_S_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_W),
     /* 66426 */   GIR_RootConstrainSelectedInstOperands,
     /* 66427 */   // GIR_Coverage, 708,
     /* 66427 */   GIR_Done,
     /* 66428 */ // Label 1629: @66428
     /* 66428 */ GIM_Reject,
     /* 66429 */ // Label 1622: @66429
     /* 66429 */ GIM_Reject,
     /* 66430 */ // Label 59: @66430
     /* 66430 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1632*/ GIMT_Encode4(66507),
     /* 66441 */ /*GILLT_v2s64*//*Label 1630*/ GIMT_Encode4(66453), GIMT_Encode4(0),
     /* 66449 */ /*GILLT_v4s32*//*Label 1631*/ GIMT_Encode4(66480),
     /* 66453 */ // Label 1630: @66453
     /* 66453 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(66479), // Rule ID 711 //
     /* 66458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66472 */   // (uint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_U_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_D),
     /* 66477 */   GIR_RootConstrainSelectedInstOperands,
     /* 66478 */   // GIR_Coverage, 711,
     /* 66478 */   GIR_Done,
     /* 66479 */ // Label 1633: @66479
     /* 66479 */ GIM_Reject,
     /* 66480 */ // Label 1631: @66480
     /* 66480 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(66506), // Rule ID 710 //
     /* 66485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66499 */   // (uint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_U_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_W),
     /* 66504 */   GIR_RootConstrainSelectedInstOperands,
     /* 66505 */   // GIR_Coverage, 710,
     /* 66505 */   GIR_Done,
     /* 66506 */ // Label 1634: @66506
     /* 66506 */ GIM_Reject,
     /* 66507 */ // Label 1632: @66507
     /* 66507 */ GIM_Reject,
     /* 66508 */ // Label 60: @66508
     /* 66508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1639*/ GIMT_Encode4(66747),
     /* 66519 */ /*GILLT_s32*//*Label 1635*/ GIMT_Encode4(66543),
     /* 66523 */ /*GILLT_s64*//*Label 1636*/ GIMT_Encode4(66591), GIMT_Encode4(0),
     /* 66531 */ /*GILLT_v2s64*//*Label 1637*/ GIMT_Encode4(66693), GIMT_Encode4(0),
     /* 66539 */ /*GILLT_v4s32*//*Label 1638*/ GIMT_Encode4(66720),
     /* 66543 */ // Label 1635: @66543
     /* 66543 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(66590),
     /* 66548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66559 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(66574), // Rule ID 126 //
     /* 66564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66567 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S),
     /* 66572 */     GIR_RootConstrainSelectedInstOperands,
     /* 66573 */     // GIR_Coverage, 126,
     /* 66573 */     GIR_Done,
     /* 66574 */   // Label 1641: @66574
     /* 66574 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(66589), // Rule ID 1152 //
     /* 66579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_UseAbs),
     /* 66582 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S_MM),
     /* 66587 */     GIR_RootConstrainSelectedInstOperands,
     /* 66588 */     // GIR_Coverage, 1152,
     /* 66588 */     GIR_Done,
     /* 66589 */   // Label 1642: @66589
     /* 66589 */   GIM_Reject,
     /* 66590 */ // Label 1640: @66590
     /* 66590 */ GIM_Reject,
     /* 66591 */ // Label 1636: @66591
     /* 66591 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(66692),
     /* 66596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66599 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(66622), // Rule ID 127 //
     /* 66604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs),
     /* 66607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66615 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32),
     /* 66620 */     GIR_RootConstrainSelectedInstOperands,
     /* 66621 */     // GIR_Coverage, 127,
     /* 66621 */     GIR_Done,
     /* 66622 */   // Label 1644: @66622
     /* 66622 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(66645), // Rule ID 128 //
     /* 66627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66638 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64),
     /* 66643 */     GIR_RootConstrainSelectedInstOperands,
     /* 66644 */     // GIR_Coverage, 128,
     /* 66644 */     GIR_Done,
     /* 66645 */   // Label 1645: @66645
     /* 66645 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(66668), // Rule ID 1150 //
     /* 66650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 66653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66661 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32_MM),
     /* 66666 */     GIR_RootConstrainSelectedInstOperands,
     /* 66667 */     // GIR_Coverage, 1150,
     /* 66667 */     GIR_Done,
     /* 66668 */   // Label 1646: @66668
     /* 66668 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(66691), // Rule ID 1151 //
     /* 66673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 66676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66684 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64_MM),
     /* 66689 */     GIR_RootConstrainSelectedInstOperands,
     /* 66690 */     // GIR_Coverage, 1151,
     /* 66690 */     GIR_Done,
     /* 66691 */   // Label 1647: @66691
     /* 66691 */   GIM_Reject,
     /* 66692 */ // Label 1643: @66692
     /* 66692 */ GIM_Reject,
     /* 66693 */ // Label 1637: @66693
     /* 66693 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(66719), // Rule ID 1043 //
     /* 66698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66712 */   // (fabs:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FABS_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D),
     /* 66717 */   GIR_RootConstrainSelectedInstOperands,
     /* 66718 */   // GIR_Coverage, 1043,
     /* 66718 */   GIR_Done,
     /* 66719 */ // Label 1648: @66719
     /* 66719 */ GIM_Reject,
     /* 66720 */ // Label 1638: @66720
     /* 66720 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(66746), // Rule ID 1042 //
     /* 66725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66739 */   // (fabs:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FABS_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_W),
     /* 66744 */   GIR_RootConstrainSelectedInstOperands,
     /* 66745 */   // GIR_Coverage, 1042,
     /* 66745 */   GIR_Done,
     /* 66746 */ // Label 1649: @66746
     /* 66746 */ GIM_Reject,
     /* 66747 */ // Label 1639: @66747
     /* 66747 */ GIM_Reject,
     /* 66748 */ // Label 61: @66748
     /* 66748 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1652*/ GIMT_Encode4(66821),
     /* 66759 */ /*GILLT_s32*//*Label 1650*/ GIMT_Encode4(66767),
     /* 66763 */ /*GILLT_s64*//*Label 1651*/ GIMT_Encode4(66794),
     /* 66767 */ // Label 1650: @66767
     /* 66767 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(66793), // Rule ID 1785 //
     /* 66772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66782 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$src)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$src)
     /* 66782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66789 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66791 */   GIR_RootConstrainSelectedInstOperands,
     /* 66792 */   // GIR_Coverage, 1785,
     /* 66792 */   GIR_EraseRootFromParent_Done,
     /* 66793 */ // Label 1653: @66793
     /* 66793 */ GIM_Reject,
     /* 66794 */ // Label 1651: @66794
     /* 66794 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(66820), // Rule ID 1786 //
     /* 66799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66809 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$src)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$src, f64:{ *:[f64] }:$src)
     /* 66809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66818 */   GIR_RootConstrainSelectedInstOperands,
     /* 66819 */   // GIR_Coverage, 1786,
     /* 66819 */   GIR_EraseRootFromParent_Done,
     /* 66820 */ // Label 1654: @66820
     /* 66820 */ GIM_Reject,
     /* 66821 */ // Label 1652: @66821
     /* 66821 */ GIM_Reject,
     /* 66822 */ // Label 62: @66822
     /* 66822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1657*/ GIMT_Encode4(66893),
     /* 66833 */ /*GILLT_s32*//*Label 1655*/ GIMT_Encode4(66841),
     /* 66837 */ /*GILLT_s64*//*Label 1656*/ GIMT_Encode4(66867),
     /* 66841 */ // Label 1655: @66841
     /* 66841 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(66866), // Rule ID 1783 //
     /* 66846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66859 */   // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66864 */   GIR_RootConstrainSelectedInstOperands,
     /* 66865 */   // GIR_Coverage, 1783,
     /* 66865 */   GIR_Done,
     /* 66866 */ // Label 1658: @66866
     /* 66866 */ GIM_Reject,
     /* 66867 */ // Label 1656: @66867
     /* 66867 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(66892), // Rule ID 1784 //
     /* 66872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66885 */   // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66890 */   GIR_RootConstrainSelectedInstOperands,
     /* 66891 */   // GIR_Coverage, 1784,
     /* 66891 */   GIR_Done,
     /* 66892 */ // Label 1659: @66892
     /* 66892 */ GIM_Reject,
     /* 66893 */ // Label 1657: @66893
     /* 66893 */ GIM_Reject,
     /* 66894 */ // Label 63: @66894
     /* 66894 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1662*/ GIMT_Encode4(66965),
     /* 66905 */ /*GILLT_s32*//*Label 1660*/ GIMT_Encode4(66913),
     /* 66909 */ /*GILLT_s64*//*Label 1661*/ GIMT_Encode4(66939),
     /* 66913 */ // Label 1660: @66913
     /* 66913 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(66938), // Rule ID 1781 //
     /* 66918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66931 */   // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MAX_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S),
     /* 66936 */   GIR_RootConstrainSelectedInstOperands,
     /* 66937 */   // GIR_Coverage, 1781,
     /* 66937 */   GIR_Done,
     /* 66938 */ // Label 1663: @66938
     /* 66938 */ GIM_Reject,
     /* 66939 */ // Label 1661: @66939
     /* 66939 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(66964), // Rule ID 1782 //
     /* 66944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66957 */   // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MAX_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_D),
     /* 66962 */   GIR_RootConstrainSelectedInstOperands,
     /* 66963 */   // GIR_Coverage, 1782,
     /* 66963 */   GIR_Done,
     /* 66964 */ // Label 1664: @66964
     /* 66964 */ GIM_Reject,
     /* 66965 */ // Label 1662: @66965
     /* 66965 */ GIM_Reject,
     /* 66966 */ // Label 64: @66966
     /* 66966 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1669*/ GIMT_Encode4(67133),
     /* 66977 */ /*GILLT_v2s64*//*Label 1665*/ GIMT_Encode4(66997), GIMT_Encode4(0),
     /* 66985 */ /*GILLT_v4s32*//*Label 1666*/ GIMT_Encode4(67031),
     /* 66989 */ /*GILLT_v8s16*//*Label 1667*/ GIMT_Encode4(67065),
     /* 66993 */ /*GILLT_v16s8*//*Label 1668*/ GIMT_Encode4(67099),
     /* 66997 */ // Label 1665: @66997
     /* 66997 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(67030), // Rule ID 871 //
     /* 67002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67023 */   // (smin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_D),
     /* 67028 */   GIR_RootConstrainSelectedInstOperands,
     /* 67029 */   // GIR_Coverage, 871,
     /* 67029 */   GIR_Done,
     /* 67030 */ // Label 1670: @67030
     /* 67030 */ GIM_Reject,
     /* 67031 */ // Label 1666: @67031
     /* 67031 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(67064), // Rule ID 870 //
     /* 67036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67057 */   // (smin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_W),
     /* 67062 */   GIR_RootConstrainSelectedInstOperands,
     /* 67063 */   // GIR_Coverage, 870,
     /* 67063 */   GIR_Done,
     /* 67064 */ // Label 1671: @67064
     /* 67064 */ GIM_Reject,
     /* 67065 */ // Label 1667: @67065
     /* 67065 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(67098), // Rule ID 869 //
     /* 67070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67091 */   // (smin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_H),
     /* 67096 */   GIR_RootConstrainSelectedInstOperands,
     /* 67097 */   // GIR_Coverage, 869,
     /* 67097 */   GIR_Done,
     /* 67098 */ // Label 1672: @67098
     /* 67098 */ GIM_Reject,
     /* 67099 */ // Label 1668: @67099
     /* 67099 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(67132), // Rule ID 868 //
     /* 67104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67125 */   // (smin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_B),
     /* 67130 */   GIR_RootConstrainSelectedInstOperands,
     /* 67131 */   // GIR_Coverage, 868,
     /* 67131 */   GIR_Done,
     /* 67132 */ // Label 1673: @67132
     /* 67132 */ GIM_Reject,
     /* 67133 */ // Label 1669: @67133
     /* 67133 */ GIM_Reject,
     /* 67134 */ // Label 65: @67134
     /* 67134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1678*/ GIMT_Encode4(67301),
     /* 67145 */ /*GILLT_v2s64*//*Label 1674*/ GIMT_Encode4(67165), GIMT_Encode4(0),
     /* 67153 */ /*GILLT_v4s32*//*Label 1675*/ GIMT_Encode4(67199),
     /* 67157 */ /*GILLT_v8s16*//*Label 1676*/ GIMT_Encode4(67233),
     /* 67161 */ /*GILLT_v16s8*//*Label 1677*/ GIMT_Encode4(67267),
     /* 67165 */ // Label 1674: @67165
     /* 67165 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(67198), // Rule ID 851 //
     /* 67170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67191 */   // (smax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_D),
     /* 67196 */   GIR_RootConstrainSelectedInstOperands,
     /* 67197 */   // GIR_Coverage, 851,
     /* 67197 */   GIR_Done,
     /* 67198 */ // Label 1679: @67198
     /* 67198 */ GIM_Reject,
     /* 67199 */ // Label 1675: @67199
     /* 67199 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(67232), // Rule ID 850 //
     /* 67204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67225 */   // (smax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_W),
     /* 67230 */   GIR_RootConstrainSelectedInstOperands,
     /* 67231 */   // GIR_Coverage, 850,
     /* 67231 */   GIR_Done,
     /* 67232 */ // Label 1680: @67232
     /* 67232 */ GIM_Reject,
     /* 67233 */ // Label 1676: @67233
     /* 67233 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(67266), // Rule ID 849 //
     /* 67238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67259 */   // (smax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_H),
     /* 67264 */   GIR_RootConstrainSelectedInstOperands,
     /* 67265 */   // GIR_Coverage, 849,
     /* 67265 */   GIR_Done,
     /* 67266 */ // Label 1681: @67266
     /* 67266 */ GIM_Reject,
     /* 67267 */ // Label 1677: @67267
     /* 67267 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(67300), // Rule ID 848 //
     /* 67272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67293 */   // (smax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_B),
     /* 67298 */   GIR_RootConstrainSelectedInstOperands,
     /* 67299 */   // GIR_Coverage, 848,
     /* 67299 */   GIR_Done,
     /* 67300 */ // Label 1682: @67300
     /* 67300 */ GIM_Reject,
     /* 67301 */ // Label 1678: @67301
     /* 67301 */ GIM_Reject,
     /* 67302 */ // Label 66: @67302
     /* 67302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1687*/ GIMT_Encode4(67469),
     /* 67313 */ /*GILLT_v2s64*//*Label 1683*/ GIMT_Encode4(67333), GIMT_Encode4(0),
     /* 67321 */ /*GILLT_v4s32*//*Label 1684*/ GIMT_Encode4(67367),
     /* 67325 */ /*GILLT_v8s16*//*Label 1685*/ GIMT_Encode4(67401),
     /* 67329 */ /*GILLT_v16s8*//*Label 1686*/ GIMT_Encode4(67435),
     /* 67333 */ // Label 1683: @67333
     /* 67333 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(67366), // Rule ID 875 //
     /* 67338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67359 */   // (umin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_D),
     /* 67364 */   GIR_RootConstrainSelectedInstOperands,
     /* 67365 */   // GIR_Coverage, 875,
     /* 67365 */   GIR_Done,
     /* 67366 */ // Label 1688: @67366
     /* 67366 */ GIM_Reject,
     /* 67367 */ // Label 1684: @67367
     /* 67367 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(67400), // Rule ID 874 //
     /* 67372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67393 */   // (umin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_W),
     /* 67398 */   GIR_RootConstrainSelectedInstOperands,
     /* 67399 */   // GIR_Coverage, 874,
     /* 67399 */   GIR_Done,
     /* 67400 */ // Label 1689: @67400
     /* 67400 */ GIM_Reject,
     /* 67401 */ // Label 1685: @67401
     /* 67401 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(67434), // Rule ID 873 //
     /* 67406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67427 */   // (umin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_H),
     /* 67432 */   GIR_RootConstrainSelectedInstOperands,
     /* 67433 */   // GIR_Coverage, 873,
     /* 67433 */   GIR_Done,
     /* 67434 */ // Label 1690: @67434
     /* 67434 */ GIM_Reject,
     /* 67435 */ // Label 1686: @67435
     /* 67435 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(67468), // Rule ID 872 //
     /* 67440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67461 */   // (umin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_B),
     /* 67466 */   GIR_RootConstrainSelectedInstOperands,
     /* 67467 */   // GIR_Coverage, 872,
     /* 67467 */   GIR_Done,
     /* 67468 */ // Label 1691: @67468
     /* 67468 */ GIM_Reject,
     /* 67469 */ // Label 1687: @67469
     /* 67469 */ GIM_Reject,
     /* 67470 */ // Label 67: @67470
     /* 67470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1696*/ GIMT_Encode4(67637),
     /* 67481 */ /*GILLT_v2s64*//*Label 1692*/ GIMT_Encode4(67501), GIMT_Encode4(0),
     /* 67489 */ /*GILLT_v4s32*//*Label 1693*/ GIMT_Encode4(67535),
     /* 67493 */ /*GILLT_v8s16*//*Label 1694*/ GIMT_Encode4(67569),
     /* 67497 */ /*GILLT_v16s8*//*Label 1695*/ GIMT_Encode4(67603),
     /* 67501 */ // Label 1692: @67501
     /* 67501 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(67534), // Rule ID 855 //
     /* 67506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67527 */   // (umax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_D),
     /* 67532 */   GIR_RootConstrainSelectedInstOperands,
     /* 67533 */   // GIR_Coverage, 855,
     /* 67533 */   GIR_Done,
     /* 67534 */ // Label 1697: @67534
     /* 67534 */ GIM_Reject,
     /* 67535 */ // Label 1693: @67535
     /* 67535 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(67568), // Rule ID 854 //
     /* 67540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67561 */   // (umax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_W),
     /* 67566 */   GIR_RootConstrainSelectedInstOperands,
     /* 67567 */   // GIR_Coverage, 854,
     /* 67567 */   GIR_Done,
     /* 67568 */ // Label 1698: @67568
     /* 67568 */ GIM_Reject,
     /* 67569 */ // Label 1694: @67569
     /* 67569 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(67602), // Rule ID 853 //
     /* 67574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67595 */   // (umax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_H),
     /* 67600 */   GIR_RootConstrainSelectedInstOperands,
     /* 67601 */   // GIR_Coverage, 853,
     /* 67601 */   GIR_Done,
     /* 67602 */ // Label 1699: @67602
     /* 67602 */ GIM_Reject,
     /* 67603 */ // Label 1695: @67603
     /* 67603 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(67636), // Rule ID 852 //
     /* 67608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67629 */   // (umax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_B),
     /* 67634 */   GIR_RootConstrainSelectedInstOperands,
     /* 67635 */   // GIR_Coverage, 852,
     /* 67635 */   GIR_Done,
     /* 67636 */ // Label 1700: @67636
     /* 67636 */ GIM_Reject,
     /* 67637 */ // Label 1696: @67637
     /* 67637 */ GIM_Reject,
     /* 67638 */ // Label 68: @67638
     /* 67638 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(67761),
     /* 67643 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 67646 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(67667), // Rule ID 91 //
     /* 67651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC),
     /* 67654 */     // (br (bb:{ *:[Other] }):$target)  =>  (J (bb:{ *:[Other] }):$target)
     /* 67654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J),
     /* 67659 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67665 */     GIR_RootConstrainSelectedInstOperands,
     /* 67666 */     // GIR_Coverage, 91,
     /* 67666 */     GIR_Done,
     /* 67667 */   // Label 1702: @67667
     /* 67667 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(67688), // Rule ID 98 //
     /* 67672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 67675 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B (bb:{ *:[Other] }):$offset)
     /* 67675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B),
     /* 67680 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67686 */     GIR_RootConstrainSelectedInstOperands,
     /* 67687 */     // GIR_Coverage, 98,
     /* 67687 */     GIR_Done,
     /* 67688 */   // Label 1703: @67688
     /* 67688 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(67709), // Rule ID 1104 //
     /* 67693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocNotPIC),
     /* 67696 */     // (br (bb:{ *:[Other] }):$target)  =>  (J_MM (bb:{ *:[Other] }):$target)
     /* 67696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J_MM),
     /* 67701 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67707 */     GIR_RootConstrainSelectedInstOperands,
     /* 67708 */     // GIR_Coverage, 1104,
     /* 67708 */     GIR_Done,
     /* 67709 */   // Label 1704: @67709
     /* 67709 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(67730), // Rule ID 1113 //
     /* 67714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocPIC),
     /* 67717 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B_MM (bb:{ *:[Other] }):$offset)
     /* 67717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B_MM),
     /* 67722 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67728 */     GIR_RootConstrainSelectedInstOperands,
     /* 67729 */     // GIR_Coverage, 1113,
     /* 67729 */     GIR_Done,
     /* 67730 */   // Label 1705: @67730
     /* 67730 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(67745), // Rule ID 1171 //
     /* 67735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 67738 */     // (br (bb:{ *:[Other] }):$offset)  =>  (BC_MMR6 (bb:{ *:[Other] }):$offset)
     /* 67738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BC_MMR6),
     /* 67743 */     GIR_RootConstrainSelectedInstOperands,
     /* 67744 */     // GIR_Coverage, 1171,
     /* 67744 */     GIR_Done,
     /* 67745 */   // Label 1706: @67745
     /* 67745 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(67760), // Rule ID 1858 //
     /* 67750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 67753 */     // (br (bb:{ *:[Other] }):$imm16)  =>  (Bimm16 (bb:{ *:[Other] }):$imm16)
     /* 67753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Bimm16),
     /* 67758 */     GIR_RootConstrainSelectedInstOperands,
     /* 67759 */     // GIR_Coverage, 1858,
     /* 67759 */     GIR_Done,
     /* 67760 */   // Label 1707: @67760
     /* 67760 */   GIM_Reject,
     /* 67761 */ // Label 1701: @67761
     /* 67761 */ GIM_Reject,
     /* 67762 */ // Label 69: @67762
     /* 67762 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1712*/ GIMT_Encode4(68325),
     /* 67773 */ /*GILLT_v2s64*//*Label 1708*/ GIMT_Encode4(67793), GIMT_Encode4(0),
     /* 67781 */ /*GILLT_v4s32*//*Label 1709*/ GIMT_Encode4(67966),
     /* 67785 */ /*GILLT_v8s16*//*Label 1710*/ GIMT_Encode4(68139),
     /* 67789 */ /*GILLT_v16s8*//*Label 1711*/ GIMT_Encode4(68232),
     /* 67793 */ // Label 1708: @67793
     /* 67793 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(67965),
     /* 67798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67804 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(67844), // Rule ID 821 //
     /* 67809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 67831 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_D_VIDX_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 67831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX_PSEUDO),
     /* 67834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67836 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67838 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67840 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67842 */     GIR_RootConstrainSelectedInstOperands,
     /* 67843 */     // GIR_Coverage, 821,
     /* 67843 */     GIR_EraseRootFromParent_Done,
     /* 67844 */   // Label 1714: @67844
     /* 67844 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(67884), // Rule ID 823 //
     /* 67849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 67871 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FD_VIDX_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 67871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX_PSEUDO),
     /* 67874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67876 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67878 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67880 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67882 */     GIR_RootConstrainSelectedInstOperands,
     /* 67883 */     // GIR_Coverage, 823,
     /* 67883 */     GIR_EraseRootFromParent_Done,
     /* 67884 */   // Label 1715: @67884
     /* 67884 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(67924), // Rule ID 827 //
     /* 67889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 67895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67911 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_D_VIDX64_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 67911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX64_PSEUDO),
     /* 67914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67916 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67918 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67920 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67922 */     GIR_RootConstrainSelectedInstOperands,
     /* 67923 */     // GIR_Coverage, 827,
     /* 67923 */     GIR_EraseRootFromParent_Done,
     /* 67924 */   // Label 1716: @67924
     /* 67924 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(67964), // Rule ID 829 //
     /* 67929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 67935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67951 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FD_VIDX64_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 67951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX64_PSEUDO),
     /* 67954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67956 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67958 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67960 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67962 */     GIR_RootConstrainSelectedInstOperands,
     /* 67963 */     // GIR_Coverage, 829,
     /* 67963 */     GIR_EraseRootFromParent_Done,
     /* 67964 */   // Label 1717: @67964
     /* 67964 */   GIM_Reject,
     /* 67965 */ // Label 1713: @67965
     /* 67965 */ GIM_Reject,
     /* 67966 */ // Label 1709: @67966
     /* 67966 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(68138),
     /* 67971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 67977 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(68017), // Rule ID 820 //
     /* 67982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68004 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_W_VIDX_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX_PSEUDO),
     /* 68007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68009 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68011 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68013 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68015 */     GIR_RootConstrainSelectedInstOperands,
     /* 68016 */     // GIR_Coverage, 820,
     /* 68016 */     GIR_EraseRootFromParent_Done,
     /* 68017 */   // Label 1719: @68017
     /* 68017 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(68057), // Rule ID 822 //
     /* 68022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68044 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FW_VIDX_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX_PSEUDO),
     /* 68047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68049 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68051 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68053 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68055 */     GIR_RootConstrainSelectedInstOperands,
     /* 68056 */     // GIR_Coverage, 822,
     /* 68056 */     GIR_EraseRootFromParent_Done,
     /* 68057 */   // Label 1720: @68057
     /* 68057 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(68097), // Rule ID 826 //
     /* 68062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68084 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_W_VIDX64_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX64_PSEUDO),
     /* 68087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68089 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68091 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68093 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68095 */     GIR_RootConstrainSelectedInstOperands,
     /* 68096 */     // GIR_Coverage, 826,
     /* 68096 */     GIR_EraseRootFromParent_Done,
     /* 68097 */   // Label 1721: @68097
     /* 68097 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(68137), // Rule ID 828 //
     /* 68102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68124 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FW_VIDX64_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX64_PSEUDO),
     /* 68127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68129 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68131 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68133 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68135 */     GIR_RootConstrainSelectedInstOperands,
     /* 68136 */     // GIR_Coverage, 828,
     /* 68136 */     GIR_EraseRootFromParent_Done,
     /* 68137 */   // Label 1722: @68137
     /* 68137 */   GIM_Reject,
     /* 68138 */ // Label 1718: @68138
     /* 68138 */ GIM_Reject,
     /* 68139 */ // Label 1710: @68139
     /* 68139 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(68231),
     /* 68144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68150 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(68190), // Rule ID 819 //
     /* 68155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68177 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_H_VIDX_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX_PSEUDO),
     /* 68180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68182 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68184 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68186 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68188 */     GIR_RootConstrainSelectedInstOperands,
     /* 68189 */     // GIR_Coverage, 819,
     /* 68189 */     GIR_EraseRootFromParent_Done,
     /* 68190 */   // Label 1724: @68190
     /* 68190 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(68230), // Rule ID 825 //
     /* 68195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68217 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_H_VIDX64_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX64_PSEUDO),
     /* 68220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68222 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68224 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68226 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68228 */     GIR_RootConstrainSelectedInstOperands,
     /* 68229 */     // GIR_Coverage, 825,
     /* 68229 */     GIR_EraseRootFromParent_Done,
     /* 68230 */   // Label 1725: @68230
     /* 68230 */   GIM_Reject,
     /* 68231 */ // Label 1723: @68231
     /* 68231 */ GIM_Reject,
     /* 68232 */ // Label 1711: @68232
     /* 68232 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(68324),
     /* 68237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 68240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68243 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(68283), // Rule ID 818 //
     /* 68248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68270 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_B_VIDX_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX_PSEUDO),
     /* 68273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68275 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68277 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68279 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68281 */     GIR_RootConstrainSelectedInstOperands,
     /* 68282 */     // GIR_Coverage, 818,
     /* 68282 */     GIR_EraseRootFromParent_Done,
     /* 68283 */   // Label 1727: @68283
     /* 68283 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(68323), // Rule ID 824 //
     /* 68288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68310 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_B_VIDX64_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX64_PSEUDO),
     /* 68313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68315 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68317 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68319 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68321 */     GIR_RootConstrainSelectedInstOperands,
     /* 68322 */     // GIR_Coverage, 824,
     /* 68322 */     GIR_EraseRootFromParent_Done,
     /* 68323 */   // Label 1728: @68323
     /* 68323 */   GIM_Reject,
     /* 68324 */ // Label 1726: @68324
     /* 68324 */ GIM_Reject,
     /* 68325 */ // Label 1712: @68325
     /* 68325 */ GIM_Reject,
     /* 68326 */ // Label 70: @68326
     /* 68326 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(68377), // Rule ID 1985 //
     /* 68331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 68334 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 68337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 68355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 68359 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 68363 */   // MIs[1] Operand 1
     /* 68363 */   // No operand predicates
     /* 68363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68365 */   // (extractelt:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)  =>  (COPY_S_W:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)
     /* 68365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::COPY_S_W),
     /* 68368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68370 */   GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 68372 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 68375 */   GIR_RootConstrainSelectedInstOperands,
     /* 68376 */   // GIR_Coverage, 1985,
     /* 68376 */   GIR_EraseRootFromParent_Done,
     /* 68377 */ // Label 1729: @68377
     /* 68377 */ GIM_Reject,
     /* 68378 */ // Label 71: @68378
     /* 68378 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1736*/ GIMT_Encode4(68882),
     /* 68389 */ /*GILLT_s32*//*Label 1730*/ GIMT_Encode4(68421),
     /* 68393 */ /*GILLT_s64*//*Label 1731*/ GIMT_Encode4(68630), GIMT_Encode4(0),
     /* 68401 */ /*GILLT_v2s64*//*Label 1732*/ GIMT_Encode4(68774), GIMT_Encode4(0),
     /* 68409 */ /*GILLT_v4s32*//*Label 1733*/ GIMT_Encode4(68801),
     /* 68413 */ /*GILLT_v8s16*//*Label 1734*/ GIMT_Encode4(68828),
     /* 68417 */ /*GILLT_v16s8*//*Label 1735*/ GIMT_Encode4(68855),
     /* 68421 */ // Label 1730: @68421
     /* 68421 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(68629),
     /* 68426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68433 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(68479), // Rule ID 109 //
     /* 68438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68468 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO),
     /* 68471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68477 */     GIR_RootConstrainSelectedInstOperands,
     /* 68478 */     // GIR_Coverage, 109,
     /* 68478 */     GIR_EraseRootFromParent_Done,
     /* 68479 */   // Label 1738: @68479
     /* 68479 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(68525), // Rule ID 310 //
     /* 68484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68514 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_R6),
     /* 68517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68523 */     GIR_RootConstrainSelectedInstOperands,
     /* 68524 */     // GIR_Coverage, 310,
     /* 68524 */     GIR_EraseRootFromParent_Done,
     /* 68525 */   // Label 1739: @68525
     /* 68525 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(68571), // Rule ID 1100 //
     /* 68530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68554 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68560 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_MM),
     /* 68563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68569 */     GIR_RootConstrainSelectedInstOperands,
     /* 68570 */     // GIR_Coverage, 1100,
     /* 68570 */     GIR_EraseRootFromParent_Done,
     /* 68571 */   // Label 1740: @68571
     /* 68571 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(68590), // Rule ID 108 //
     /* 68576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68583 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ),
     /* 68588 */     GIR_RootConstrainSelectedInstOperands,
     /* 68589 */     // GIR_Coverage, 108,
     /* 68589 */     GIR_Done,
     /* 68590 */   // Label 1741: @68590
     /* 68590 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(68609), // Rule ID 311 //
     /* 68595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68602 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_R6),
     /* 68607 */     GIR_RootConstrainSelectedInstOperands,
     /* 68608 */     // GIR_Coverage, 311,
     /* 68608 */     GIR_Done,
     /* 68609 */   // Label 1742: @68609
     /* 68609 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(68628), // Rule ID 1099 //
     /* 68614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68621 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_MM),
     /* 68626 */     GIR_RootConstrainSelectedInstOperands,
     /* 68627 */     // GIR_Coverage, 1099,
     /* 68627 */     GIR_Done,
     /* 68628 */   // Label 1743: @68628
     /* 68628 */   GIM_Reject,
     /* 68629 */ // Label 1737: @68629
     /* 68629 */ GIM_Reject,
     /* 68630 */ // Label 1731: @68630
     /* 68630 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(68773),
     /* 68635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68642 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(68688), // Rule ID 264 //
     /* 68647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68671 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68677 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO),
     /* 68680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68686 */     GIR_RootConstrainSelectedInstOperands,
     /* 68687 */     // GIR_Coverage, 264,
     /* 68687 */     GIR_EraseRootFromParent_Done,
     /* 68688 */   // Label 1745: @68688
     /* 68688 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(68734), // Rule ID 339 //
     /* 68693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68717 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68723 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO_R6),
     /* 68726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68732 */     GIR_RootConstrainSelectedInstOperands,
     /* 68733 */     // GIR_Coverage, 339,
     /* 68733 */     GIR_EraseRootFromParent_Done,
     /* 68734 */   // Label 1746: @68734
     /* 68734 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(68753), // Rule ID 263 //
     /* 68739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68746 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ),
     /* 68751 */     GIR_RootConstrainSelectedInstOperands,
     /* 68752 */     // GIR_Coverage, 263,
     /* 68752 */     GIR_Done,
     /* 68753 */   // Label 1747: @68753
     /* 68753 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(68772), // Rule ID 340 //
     /* 68758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68765 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ_R6),
     /* 68770 */     GIR_RootConstrainSelectedInstOperands,
     /* 68771 */     // GIR_Coverage, 340,
     /* 68771 */     GIR_Done,
     /* 68772 */   // Label 1748: @68772
     /* 68772 */   GIM_Reject,
     /* 68773 */ // Label 1744: @68773
     /* 68773 */ GIM_Reject,
     /* 68774 */ // Label 1732: @68774
     /* 68774 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(68800), // Rule ID 915 //
     /* 68779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68793 */   // (ctlz:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLZC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 68793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_D),
     /* 68798 */   GIR_RootConstrainSelectedInstOperands,
     /* 68799 */   // GIR_Coverage, 915,
     /* 68799 */   GIR_Done,
     /* 68800 */ // Label 1749: @68800
     /* 68800 */ GIM_Reject,
     /* 68801 */ // Label 1733: @68801
     /* 68801 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(68827), // Rule ID 914 //
     /* 68806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68820 */   // (ctlz:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLZC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 68820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_W),
     /* 68825 */   GIR_RootConstrainSelectedInstOperands,
     /* 68826 */   // GIR_Coverage, 914,
     /* 68826 */   GIR_Done,
     /* 68827 */ // Label 1750: @68827
     /* 68827 */ GIM_Reject,
     /* 68828 */ // Label 1734: @68828
     /* 68828 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(68854), // Rule ID 913 //
     /* 68833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68847 */   // (ctlz:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLZC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 68847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_H),
     /* 68852 */   GIR_RootConstrainSelectedInstOperands,
     /* 68853 */   // GIR_Coverage, 913,
     /* 68853 */   GIR_Done,
     /* 68854 */ // Label 1751: @68854
     /* 68854 */ GIM_Reject,
     /* 68855 */ // Label 1735: @68855
     /* 68855 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(68881), // Rule ID 912 //
     /* 68860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 68866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68874 */   // (ctlz:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLZC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 68874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_B),
     /* 68879 */   GIR_RootConstrainSelectedInstOperands,
     /* 68880 */   // GIR_Coverage, 912,
     /* 68880 */   GIR_Done,
     /* 68881 */ // Label 1752: @68881
     /* 68881 */ GIM_Reject,
     /* 68882 */ // Label 1736: @68882
     /* 68882 */ GIM_Reject,
     /* 68883 */ // Label 72: @68883
     /* 68883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1759*/ GIMT_Encode4(69088),
     /* 68894 */ /*GILLT_s32*//*Label 1753*/ GIMT_Encode4(68926),
     /* 68898 */ /*GILLT_s64*//*Label 1754*/ GIMT_Encode4(68953), GIMT_Encode4(0),
     /* 68906 */ /*GILLT_v2s64*//*Label 1755*/ GIMT_Encode4(68980), GIMT_Encode4(0),
     /* 68914 */ /*GILLT_v4s32*//*Label 1756*/ GIMT_Encode4(69007),
     /* 68918 */ /*GILLT_v8s16*//*Label 1757*/ GIMT_Encode4(69034),
     /* 68922 */ /*GILLT_v16s8*//*Label 1758*/ GIMT_Encode4(69061),
     /* 68926 */ // Label 1753: @68926
     /* 68926 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(68952), // Rule ID 278 //
     /* 68931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 68934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68945 */   // (ctpop:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (POP:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::POP),
     /* 68950 */   GIR_RootConstrainSelectedInstOperands,
     /* 68951 */   // GIR_Coverage, 278,
     /* 68951 */   GIR_Done,
     /* 68952 */ // Label 1760: @68952
     /* 68952 */ GIM_Reject,
     /* 68953 */ // Label 1754: @68953
     /* 68953 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(68979), // Rule ID 279 //
     /* 68958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 68961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68972 */   // (ctpop:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DPOP:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DPOP),
     /* 68977 */   GIR_RootConstrainSelectedInstOperands,
     /* 68978 */   // GIR_Coverage, 279,
     /* 68978 */   GIR_Done,
     /* 68979 */ // Label 1761: @68979
     /* 68979 */ GIM_Reject,
     /* 68980 */ // Label 1755: @68980
     /* 68980 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(69006), // Rule ID 937 //
     /* 68985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68999 */   // (ctpop:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (PCNT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 68999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_D),
     /* 69004 */   GIR_RootConstrainSelectedInstOperands,
     /* 69005 */   // GIR_Coverage, 937,
     /* 69005 */   GIR_Done,
     /* 69006 */ // Label 1762: @69006
     /* 69006 */ GIM_Reject,
     /* 69007 */ // Label 1756: @69007
     /* 69007 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(69033), // Rule ID 936 //
     /* 69012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69026 */   // (ctpop:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (PCNT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 69026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_W),
     /* 69031 */   GIR_RootConstrainSelectedInstOperands,
     /* 69032 */   // GIR_Coverage, 936,
     /* 69032 */   GIR_Done,
     /* 69033 */ // Label 1763: @69033
     /* 69033 */ GIM_Reject,
     /* 69034 */ // Label 1757: @69034
     /* 69034 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(69060), // Rule ID 935 //
     /* 69039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69053 */   // (ctpop:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (PCNT_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 69053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_H),
     /* 69058 */   GIR_RootConstrainSelectedInstOperands,
     /* 69059 */   // GIR_Coverage, 935,
     /* 69059 */   GIR_Done,
     /* 69060 */ // Label 1764: @69060
     /* 69060 */ GIM_Reject,
     /* 69061 */ // Label 1758: @69061
     /* 69061 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(69087), // Rule ID 934 //
     /* 69066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 69072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69080 */   // (ctpop:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (PCNT_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 69080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_B),
     /* 69085 */   GIR_RootConstrainSelectedInstOperands,
     /* 69086 */   // GIR_Coverage, 934,
     /* 69086 */   GIR_Done,
     /* 69087 */ // Label 1765: @69087
     /* 69087 */ GIM_Reject,
     /* 69088 */ // Label 1759: @69088
     /* 69088 */ GIM_Reject,
     /* 69089 */ // Label 73: @69089
     /* 69089 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1768*/ GIMT_Encode4(69252),
     /* 69100 */ /*GILLT_s32*//*Label 1766*/ GIMT_Encode4(69108),
     /* 69104 */ /*GILLT_s64*//*Label 1767*/ GIMT_Encode4(69204),
     /* 69108 */ // Label 1766: @69108
     /* 69108 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(69203),
     /* 69113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69124 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(69163), // Rule ID 1427 //
     /* 69129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 69132 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR:{ *:[i32] } (WSBH:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH),
     /* 69139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 69153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69161 */     GIR_RootConstrainSelectedInstOperands,
     /* 69162 */     // GIR_Coverage, 1427,
     /* 69162 */     GIR_EraseRootFromParent_Done,
     /* 69163 */   // Label 1770: @69163
     /* 69163 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(69202), // Rule ID 2180 //
     /* 69168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69171 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR_MM:{ *:[i32] } (WSBH_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH_MM),
     /* 69178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 69192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69200 */     GIR_RootConstrainSelectedInstOperands,
     /* 69201 */     // GIR_Coverage, 2180,
     /* 69201 */     GIR_EraseRootFromParent_Done,
     /* 69202 */   // Label 1771: @69202
     /* 69202 */   GIM_Reject,
     /* 69203 */ // Label 1769: @69203
     /* 69203 */ GIM_Reject,
     /* 69204 */ // Label 1767: @69204
     /* 69204 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(69251), // Rule ID 1587 //
     /* 69209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc),
     /* 69212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69223 */   // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$rt)  =>  (DSHD:{ *:[i64] } (DSBH:{ *:[i64] } GPR64:{ *:[i64] }:$rt))
     /* 69223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSBH),
     /* 69230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69235 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSHD),
     /* 69244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69249 */   GIR_RootConstrainSelectedInstOperands,
     /* 69250 */   // GIR_Coverage, 1587,
     /* 69250 */   GIR_EraseRootFromParent_Done,
     /* 69251 */ // Label 1772: @69251
     /* 69251 */ GIM_Reject,
     /* 69252 */ // Label 1768: @69252
     /* 69252 */ GIM_Reject,
     /* 69253 */ // Label 74: @69253
     /* 69253 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1777*/ GIMT_Encode4(69492),
     /* 69264 */ /*GILLT_s32*//*Label 1773*/ GIMT_Encode4(69288),
     /* 69268 */ /*GILLT_s64*//*Label 1774*/ GIMT_Encode4(69336), GIMT_Encode4(0),
     /* 69276 */ /*GILLT_v2s64*//*Label 1775*/ GIMT_Encode4(69438), GIMT_Encode4(0),
     /* 69284 */ /*GILLT_v4s32*//*Label 1776*/ GIMT_Encode4(69465),
     /* 69288 */ // Label 1773: @69288
     /* 69288 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(69335),
     /* 69293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69304 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(69319), // Rule ID 132 //
     /* 69309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 69312 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S),
     /* 69317 */     GIR_RootConstrainSelectedInstOperands,
     /* 69318 */     // GIR_Coverage, 132,
     /* 69318 */     GIR_Done,
     /* 69319 */   // Label 1779: @69319
     /* 69319 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(69334), // Rule ID 1162 //
     /* 69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 69327 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S_MM),
     /* 69332 */     GIR_RootConstrainSelectedInstOperands,
     /* 69333 */     // GIR_Coverage, 1162,
     /* 69333 */     GIR_Done,
     /* 69334 */   // Label 1780: @69334
     /* 69334 */   GIM_Reject,
     /* 69335 */ // Label 1778: @69335
     /* 69335 */ GIM_Reject,
     /* 69336 */ // Label 1774: @69336
     /* 69336 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(69437),
     /* 69341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69344 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(69367), // Rule ID 133 //
     /* 69349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 69352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69360 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32),
     /* 69365 */     GIR_RootConstrainSelectedInstOperands,
     /* 69366 */     // GIR_Coverage, 133,
     /* 69366 */     GIR_Done,
     /* 69367 */   // Label 1782: @69367
     /* 69367 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(69390), // Rule ID 134 //
     /* 69372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 69375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69383 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64),
     /* 69388 */     GIR_RootConstrainSelectedInstOperands,
     /* 69389 */     // GIR_Coverage, 134,
     /* 69389 */     GIR_Done,
     /* 69390 */   // Label 1783: @69390
     /* 69390 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(69413), // Rule ID 1148 //
     /* 69395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 69398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69406 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32_MM),
     /* 69411 */     GIR_RootConstrainSelectedInstOperands,
     /* 69412 */     // GIR_Coverage, 1148,
     /* 69412 */     GIR_Done,
     /* 69413 */   // Label 1784: @69413
     /* 69413 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(69436), // Rule ID 1149 //
     /* 69418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 69421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69429 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64_MM),
     /* 69434 */     GIR_RootConstrainSelectedInstOperands,
     /* 69435 */     // GIR_Coverage, 1149,
     /* 69435 */     GIR_Done,
     /* 69436 */   // Label 1785: @69436
     /* 69436 */   GIM_Reject,
     /* 69437 */ // Label 1781: @69437
     /* 69437 */ GIM_Reject,
     /* 69438 */ // Label 1775: @69438
     /* 69438 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(69464), // Rule ID 757 //
     /* 69443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69457 */   // (fsqrt:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D),
     /* 69462 */   GIR_RootConstrainSelectedInstOperands,
     /* 69463 */   // GIR_Coverage, 757,
     /* 69463 */   GIR_Done,
     /* 69464 */ // Label 1786: @69464
     /* 69464 */ GIM_Reject,
     /* 69465 */ // Label 1776: @69465
     /* 69465 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(69491), // Rule ID 756 //
     /* 69470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69484 */   // (fsqrt:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_W),
     /* 69489 */   GIR_RootConstrainSelectedInstOperands,
     /* 69490 */   // GIR_Coverage, 756,
     /* 69490 */   GIR_Done,
     /* 69491 */ // Label 1787: @69491
     /* 69491 */ GIM_Reject,
     /* 69492 */ // Label 1777: @69492
     /* 69492 */ GIM_Reject,
     /* 69493 */ // Label 75: @69493
     /* 69493 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1790*/ GIMT_Encode4(69570),
     /* 69504 */ /*GILLT_v2s64*//*Label 1788*/ GIMT_Encode4(69516), GIMT_Encode4(0),
     /* 69512 */ /*GILLT_v4s32*//*Label 1789*/ GIMT_Encode4(69543),
     /* 69516 */ // Label 1788: @69516
     /* 69516 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(69542), // Rule ID 739 //
     /* 69521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69535 */   // (frint:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRINT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_D),
     /* 69540 */   GIR_RootConstrainSelectedInstOperands,
     /* 69541 */   // GIR_Coverage, 739,
     /* 69541 */   GIR_Done,
     /* 69542 */ // Label 1791: @69542
     /* 69542 */ GIM_Reject,
     /* 69543 */ // Label 1789: @69543
     /* 69543 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(69569), // Rule ID 738 //
     /* 69548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69562 */   // (frint:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRINT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_W),
     /* 69567 */   GIR_RootConstrainSelectedInstOperands,
     /* 69568 */   // GIR_Coverage, 738,
     /* 69568 */   GIR_Done,
     /* 69569 */ // Label 1792: @69569
     /* 69569 */ GIM_Reject,
     /* 69570 */ // Label 1790: @69570
     /* 69570 */ GIM_Reject,
     /* 69571 */ // Label 76: @69571
     /* 69571 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(69586), // Rule ID 90 //
     /* 69576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 69579 */   // (trap)  =>  (TRAP)
     /* 69579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP),
     /* 69584 */   GIR_RootConstrainSelectedInstOperands,
     /* 69585 */   // GIR_Coverage, 90,
     /* 69585 */   GIR_Done,
     /* 69586 */ // Label 1793: @69586
     /* 69586 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(69601), // Rule ID 1115 //
     /* 69591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69594 */   // (trap)  =>  (TRAP_MM)
     /* 69594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP_MM),
     /* 69599 */   GIR_RootConstrainSelectedInstOperands,
     /* 69600 */   // GIR_Coverage, 1115,
     /* 69600 */   GIR_Done,
     /* 69601 */ // Label 1794: @69601
     /* 69601 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(69616), // Rule ID 1901 //
     /* 69606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 69609 */   // (trap)  =>  (Break16)
     /* 69609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Break16),
     /* 69614 */   GIR_RootConstrainSelectedInstOperands,
     /* 69615 */   // GIR_Coverage, 1901,
     /* 69615 */   GIR_Done,
     /* 69616 */ // Label 1795: @69616
     /* 69616 */ GIM_Reject,
     /* 69617 */ // Label 77: @69617
     /* 69617 */ GIM_Reject,
     /* 69618 */ }; // Size: 69618 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
