/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 150;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 61,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 149,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 135,
  Feature_HasMMXBit = 107,
  Feature_HasSSE1Bit = 47,
  Feature_UseSSE1Bit = 54,
  Feature_HasSSE2Bit = 46,
  Feature_UseSSE2Bit = 55,
  Feature_HasSSE3Bit = 38,
  Feature_UseSSE3Bit = 64,
  Feature_HasSSSE3Bit = 108,
  Feature_UseSSSE3Bit = 65,
  Feature_UseSSE41Bit = 62,
  Feature_UseSSE42Bit = 69,
  Feature_HasSSE4ABit = 79,
  Feature_NoAVXBit = 75,
  Feature_HasAVXBit = 56,
  Feature_HasAVX2Bit = 50,
  Feature_HasAVX1OnlyBit = 48,
  Feature_HasEVEX512Bit = 142,
  Feature_HasAVX10_2Bit = 106,
  Feature_HasAVX10_2_512Bit = 105,
  Feature_NoAVX10_2Bit = 68,
  Feature_HasAVX512Bit = 92,
  Feature_UseAVXBit = 52,
  Feature_NoAVX512Bit = 43,
  Feature_HasCDIBit = 96,
  Feature_HasVPOPCNTDQBit = 100,
  Feature_HasDQIBit = 94,
  Feature_NoDQIBit = 66,
  Feature_HasBWIBit = 95,
  Feature_NoBWIBit = 63,
  Feature_HasVLXBit = 93,
  Feature_NoVLXBit = 42,
  Feature_NoVLX_Or_NoBWIBit = 60,
  Feature_HasVNNIBit = 102,
  Feature_HasVP2INTERSECTBit = 104,
  Feature_HasFP16Bit = 98,
  Feature_HasAVXVNNIINT16Bit = 91,
  Feature_HasAVXVNNIINT8Bit = 86,
  Feature_HasAVXVNNIBit = 80,
  Feature_NoVLX_Or_NoVNNIBit = 81,
  Feature_HasBITALGBit = 103,
  Feature_HasPOPCNTBit = 67,
  Feature_HasAESBit = 72,
  Feature_HasVAESBit = 74,
  Feature_NoVLX_Or_NoVAESBit = 73,
  Feature_HasFXSRBit = 39,
  Feature_HasX87Bit = 37,
  Feature_HasXSAVEBit = 124,
  Feature_HasXSAVEOPTBit = 125,
  Feature_HasXSAVECBit = 126,
  Feature_HasXSAVESBit = 127,
  Feature_HasPCLMULBit = 76,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 77,
  Feature_HasVPCLMULQDQBit = 78,
  Feature_HasGFNIBit = 83,
  Feature_HasFMABit = 40,
  Feature_HasFMA4Bit = 44,
  Feature_NoFMA4Bit = 41,
  Feature_HasXOPBit = 45,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 140,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 82,
  Feature_HasFSGSBaseBit = 128,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 139,
  Feature_HasVBMIBit = 97,
  Feature_HasVBMI2Bit = 101,
  Feature_HasIFMABit = 99,
  Feature_HasAVXIFMABit = 84,
  Feature_NoVLX_Or_NoIFMABit = 85,
  Feature_HasRTMBit = 110,
  Feature_HasSHABit = 71,
  Feature_HasSHA512Bit = 88,
  Feature_HasSM3Bit = 89,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 57,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 109,
  Feature_HasMWAITXBit = 138,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 131,
  Feature_FPStackf32Bit = 35,
  Feature_FPStackf64Bit = 36,
  Feature_HasSM4Bit = 90,
  Feature_HasCLFLUSHBit = 58,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 123,
  Feature_HasRDPIDBit = 130,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 129,
  Feature_HasCX8Bit = 136,
  Feature_HasCX16Bit = 137,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 115,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 87,
  Feature_HasKLBit = 111,
  Feature_HasRAOINTBit = 121,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 112,
  Feature_HasAMXBF16Bit = 114,
  Feature_HasAMXINT8Bit = 113,
  Feature_HasAMXCOMPLEXBit = 116,
  Feature_HasAMXFP8Bit = 117,
  Feature_HasAMXTRANSPOSEBit = 118,
  Feature_HasAMXAVX512Bit = 119,
  Feature_HasAMXTF32Bit = 120,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 122,
  Feature_HasCRC32Bit = 70,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 133,
  Feature_NotLP64Bit = 132,
  Feature_NotWin64WithoutFPBit = 134,
  Feature_IsPSBit = 144,
  Feature_NotPSBit = 143,
  Feature_KernelCodeBit = 145,
  Feature_NearDataBit = 147,
  Feature_IsNotPICBit = 146,
  Feature_OptForSizeBit = 51,
  Feature_OptForMinSizeBit = 49,
  Feature_OptForSpeedBit = 141,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 53,
  Feature_CallImmAddrBit = 148,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 34,
  Feature_HasMFenceBit = 59,
  Feature_UseIndirectThunkCallsBit = 33,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoDQI,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoAVX10_2,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoDQIBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoAVX10_2Bit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(287), /*)*//*default:*//*Label 70*/ GIMT_Encode4(90463),
     /*    10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(946),
     /*    14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(3304),
     /*    18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(5120), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(6345),
     /*    50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(12189),
     /*    54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(16581), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(25028), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(25195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(26952),
     /*   154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(28134), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   306 */ /*TargetOpcode::G_INTRINSIC*//*Label 10*/ GIMT_Encode4(28588),
     /*   310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 11*/ GIMT_Encode4(34186), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   322 */ /*TargetOpcode::G_ANYEXT*//*Label 12*/ GIMT_Encode4(37830),
     /*   326 */ /*TargetOpcode::G_TRUNC*//*Label 13*/ GIMT_Encode4(38265),
     /*   330 */ /*TargetOpcode::G_CONSTANT*//*Label 14*/ GIMT_Encode4(39278),
     /*   334 */ /*TargetOpcode::G_FCONSTANT*//*Label 15*/ GIMT_Encode4(39884), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   346 */ /*TargetOpcode::G_SEXT*//*Label 16*/ GIMT_Encode4(40337),
     /*   350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 17*/ GIMT_Encode4(41360),
     /*   354 */ /*TargetOpcode::G_ZEXT*//*Label 18*/ GIMT_Encode4(41602),
     /*   358 */ /*TargetOpcode::G_SHL*//*Label 19*/ GIMT_Encode4(42710),
     /*   362 */ /*TargetOpcode::G_LSHR*//*Label 20*/ GIMT_Encode4(43898),
     /*   366 */ /*TargetOpcode::G_ASHR*//*Label 21*/ GIMT_Encode4(44878),
     /*   370 */ /*TargetOpcode::G_FSHL*//*Label 22*/ GIMT_Encode4(45858),
     /*   374 */ /*TargetOpcode::G_FSHR*//*Label 23*/ GIMT_Encode4(46234),
     /*   378 */ /*TargetOpcode::G_ROTR*//*Label 24*/ GIMT_Encode4(46610),
     /*   382 */ /*TargetOpcode::G_ROTL*//*Label 25*/ GIMT_Encode4(48592),
     /*   386 */ /*TargetOpcode::G_ICMP*//*Label 26*/ GIMT_Encode4(50576), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   402 */ /*TargetOpcode::G_SELECT*//*Label 27*/ GIMT_Encode4(52233), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   446 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(59041),
     /*   450 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(59288),
     /*   454 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(59535),
     /*   458 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(59985),
     /*   462 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(60435),
     /*   466 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(60885), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   510 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(61335),
     /*   514 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(62351),
     /*   518 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(63367),
     /*   522 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(64383), GIMT_Encode4(0),
     /*   530 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(65511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   578 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(66527),
     /*   582 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(66650),
     /*   586 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(67220),
     /*   590 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(67547),
     /*   594 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(68044),
     /*   598 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(68246),
     /*   602 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(69508), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   614 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(70358), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   686 */ /*TargetOpcode::G_SMIN*//*Label 47*/ GIMT_Encode4(70481),
     /*   690 */ /*TargetOpcode::G_SMAX*//*Label 48*/ GIMT_Encode4(71578),
     /*   694 */ /*TargetOpcode::G_UMIN*//*Label 49*/ GIMT_Encode4(72675),
     /*   698 */ /*TargetOpcode::G_UMAX*//*Label 50*/ GIMT_Encode4(73772),
     /*   702 */ /*TargetOpcode::G_ABS*//*Label 51*/ GIMT_Encode4(74869), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   714 */ /*TargetOpcode::G_BR*//*Label 52*/ GIMT_Encode4(75734), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 53*/ GIMT_Encode4(75750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   754 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 54*/ GIMT_Encode4(78679),
     /*   758 */ /*TargetOpcode::G_CTTZ*//*Label 55*/ GIMT_Encode4(80661),
     /*   762 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 56*/ GIMT_Encode4(80784),
     /*   766 */ /*TargetOpcode::G_CTLZ*//*Label 57*/ GIMT_Encode4(80946), GIMT_Encode4(0),
     /*   774 */ /*TargetOpcode::G_CTPOP*//*Label 58*/ GIMT_Encode4(81727),
     /*   778 */ /*TargetOpcode::G_BSWAP*//*Label 59*/ GIMT_Encode4(83126), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   834 */ /*TargetOpcode::G_FSQRT*//*Label 60*/ GIMT_Encode4(83302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 61*/ GIMT_Encode4(84254),
     /*   878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 62*/ GIMT_Encode4(85270),
     /*   882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 63*/ GIMT_Encode4(86286),
     /*   886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 64*/ GIMT_Encode4(87302), GIMT_Encode4(0),
     /*   894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 65*/ GIMT_Encode4(88318),
     /*   898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 66*/ GIMT_Encode4(89446), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   934 */ /*TargetOpcode::G_TRAP*//*Label 67*/ GIMT_Encode4(90398),
     /*   938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 68*/ GIMT_Encode4(90411),
     /*   942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 69*/ GIMT_Encode4(90447),
     /*   946 */ // Label 0: @946
     /*   946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 87*/ GIMT_Encode4(3303),
     /*   957 */ /*GILLT_s8*//*Label 71*/ GIMT_Encode4(1053),
     /*   961 */ /*GILLT_s16*//*Label 72*/ GIMT_Encode4(1286),
     /*   965 */ /*GILLT_s32*//*Label 73*/ GIMT_Encode4(1587),
     /*   969 */ /*GILLT_s64*//*Label 74*/ GIMT_Encode4(1888), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   985 */ /*GILLT_v2s64*//*Label 75*/ GIMT_Encode4(2279), GIMT_Encode4(0),
     /*   993 */ /*GILLT_v4s32*//*Label 76*/ GIMT_Encode4(2373),
     /*   997 */ /*GILLT_v4s64*//*Label 77*/ GIMT_Encode4(2589), GIMT_Encode4(0),
     /*  1005 */ /*GILLT_v8s16*//*Label 78*/ GIMT_Encode4(2656),
     /*  1009 */ /*GILLT_v8s32*//*Label 79*/ GIMT_Encode4(2872),
     /*  1013 */ /*GILLT_v8s64*//*Label 80*/ GIMT_Encode4(2939), GIMT_Encode4(0),
     /*  1021 */ /*GILLT_v16s8*//*Label 81*/ GIMT_Encode4(2973),
     /*  1025 */ /*GILLT_v16s16*//*Label 82*/ GIMT_Encode4(3067),
     /*  1029 */ /*GILLT_v16s32*//*Label 83*/ GIMT_Encode4(3134), GIMT_Encode4(0),
     /*  1037 */ /*GILLT_v32s8*//*Label 84*/ GIMT_Encode4(3168),
     /*  1041 */ /*GILLT_v32s16*//*Label 85*/ GIMT_Encode4(3235), GIMT_Encode4(0),
     /*  1049 */ /*GILLT_v64s8*//*Label 86*/ GIMT_Encode4(3269),
     /*  1053 */ // Label 71: @1053
     /*  1053 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1285),
     /*  1058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  1061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  1064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1072 */   GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1096), // Rule ID 23307 //
     /*  1077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1084 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*  1087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1094 */     GIR_RootConstrainSelectedInstOperands,
     /*  1095 */     // GIR_Coverage, 23307,
     /*  1095 */     GIR_EraseRootFromParent_Done,
     /*  1096 */   // Label 89: @1096
     /*  1096 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1120), // Rule ID 23311 //
     /*  1101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1108 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*  1111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1118 */     GIR_RootConstrainSelectedInstOperands,
     /*  1119 */     // GIR_Coverage, 23311,
     /*  1119 */     GIR_EraseRootFromParent_Done,
     /*  1120 */   // Label 90: @1120
     /*  1120 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1144), // Rule ID 23397 //
     /*  1125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1132 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*  1135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1142 */     GIR_RootConstrainSelectedInstOperands,
     /*  1143 */     // GIR_Coverage, 23397,
     /*  1143 */     GIR_EraseRootFromParent_Done,
     /*  1144 */   // Label 91: @1144
     /*  1144 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1168), // Rule ID 23401 //
     /*  1149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1156 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*  1156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*  1159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1166 */     GIR_RootConstrainSelectedInstOperands,
     /*  1167 */     // GIR_Coverage, 23401,
     /*  1167 */     GIR_EraseRootFromParent_Done,
     /*  1168 */   // Label 92: @1168
     /*  1168 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1201), // Rule ID 23245 //
     /*  1173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1184 */     // MIs[1] Operand 1
     /*  1184 */     // No operand predicates
     /*  1184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1186 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  1186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  1189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1199 */     GIR_RootConstrainSelectedInstOperands,
     /*  1200 */     // GIR_Coverage, 23245,
     /*  1200 */     GIR_EraseRootFromParent_Done,
     /*  1201 */   // Label 93: @1201
     /*  1201 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1234), // Rule ID 23335 //
     /*  1206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1217 */     // MIs[1] Operand 1
     /*  1217 */     // No operand predicates
     /*  1217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1219 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  1219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*  1222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1232 */     GIR_RootConstrainSelectedInstOperands,
     /*  1233 */     // GIR_Coverage, 23335,
     /*  1233 */     GIR_EraseRootFromParent_Done,
     /*  1234 */   // Label 94: @1234
     /*  1234 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1259), // Rule ID 23237 //
     /*  1239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1246 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  1246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*  1251 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1257 */     GIR_RootConstrainSelectedInstOperands,
     /*  1258 */     // GIR_Coverage, 23237,
     /*  1258 */     GIR_Done,
     /*  1259 */   // Label 95: @1259
     /*  1259 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1284), // Rule ID 23327 //
     /*  1264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  1271 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  1271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*  1276 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1282 */     GIR_RootConstrainSelectedInstOperands,
     /*  1283 */     // GIR_Coverage, 23327,
     /*  1283 */     GIR_Done,
     /*  1284 */   // Label 96: @1284
     /*  1284 */   GIM_Reject,
     /*  1285 */ // Label 88: @1285
     /*  1285 */ GIM_Reject,
     /*  1286 */ // Label 72: @1286
     /*  1286 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1586),
     /*  1291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  1294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  1297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1305 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1339), // Rule ID 23047 //
     /*  1310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1313 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1324 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*  1324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*  1327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1337 */     GIR_RootConstrainSelectedInstOperands,
     /*  1338 */     // GIR_Coverage, 23047,
     /*  1338 */     GIR_EraseRootFromParent_Done,
     /*  1339 */   // Label 98: @1339
     /*  1339 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1373), // Rule ID 23053 //
     /*  1344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1347 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1358 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*  1358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*  1361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1371 */     GIR_RootConstrainSelectedInstOperands,
     /*  1372 */     // GIR_Coverage, 23053,
     /*  1372 */     GIR_EraseRootFromParent_Done,
     /*  1373 */   // Label 99: @1373
     /*  1373 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1397), // Rule ID 23308 //
     /*  1378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1385 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*  1388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1395 */     GIR_RootConstrainSelectedInstOperands,
     /*  1396 */     // GIR_Coverage, 23308,
     /*  1396 */     GIR_EraseRootFromParent_Done,
     /*  1397 */   // Label 100: @1397
     /*  1397 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1421), // Rule ID 23312 //
     /*  1402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1409 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*  1412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1419 */     GIR_RootConstrainSelectedInstOperands,
     /*  1420 */     // GIR_Coverage, 23312,
     /*  1420 */     GIR_EraseRootFromParent_Done,
     /*  1421 */   // Label 101: @1421
     /*  1421 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1445), // Rule ID 23398 //
     /*  1426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1433 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*  1436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1443 */     GIR_RootConstrainSelectedInstOperands,
     /*  1444 */     // GIR_Coverage, 23398,
     /*  1444 */     GIR_EraseRootFromParent_Done,
     /*  1445 */   // Label 102: @1445
     /*  1445 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1469), // Rule ID 23402 //
     /*  1450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1457 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*  1457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*  1460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1467 */     GIR_RootConstrainSelectedInstOperands,
     /*  1468 */     // GIR_Coverage, 23402,
     /*  1468 */     GIR_EraseRootFromParent_Done,
     /*  1469 */   // Label 103: @1469
     /*  1469 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1502), // Rule ID 23246 //
     /*  1474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1485 */     // MIs[1] Operand 1
     /*  1485 */     // No operand predicates
     /*  1485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1487 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  1487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  1490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1500 */     GIR_RootConstrainSelectedInstOperands,
     /*  1501 */     // GIR_Coverage, 23246,
     /*  1501 */     GIR_EraseRootFromParent_Done,
     /*  1502 */   // Label 104: @1502
     /*  1502 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1535), // Rule ID 23336 //
     /*  1507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1518 */     // MIs[1] Operand 1
     /*  1518 */     // No operand predicates
     /*  1518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1520 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  1520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*  1523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1533 */     GIR_RootConstrainSelectedInstOperands,
     /*  1534 */     // GIR_Coverage, 23336,
     /*  1534 */     GIR_EraseRootFromParent_Done,
     /*  1535 */   // Label 105: @1535
     /*  1535 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1560), // Rule ID 23238 //
     /*  1540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1547 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  1547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*  1552 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1558 */     GIR_RootConstrainSelectedInstOperands,
     /*  1559 */     // GIR_Coverage, 23238,
     /*  1559 */     GIR_Done,
     /*  1560 */   // Label 106: @1560
     /*  1560 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1585), // Rule ID 23328 //
     /*  1565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  1572 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  1572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*  1577 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1583 */     GIR_RootConstrainSelectedInstOperands,
     /*  1584 */     // GIR_Coverage, 23328,
     /*  1584 */     GIR_Done,
     /*  1585 */   // Label 107: @1585
     /*  1585 */   GIM_Reject,
     /*  1586 */ // Label 97: @1586
     /*  1586 */ GIM_Reject,
     /*  1587 */ // Label 73: @1587
     /*  1587 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1887),
     /*  1592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  1595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  1598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1606 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1640), // Rule ID 23048 //
     /*  1611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1614 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1625 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*  1625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*  1628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1638 */     GIR_RootConstrainSelectedInstOperands,
     /*  1639 */     // GIR_Coverage, 23048,
     /*  1639 */     GIR_EraseRootFromParent_Done,
     /*  1640 */   // Label 109: @1640
     /*  1640 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1674), // Rule ID 23054 //
     /*  1645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1648 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1659 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*  1659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*  1662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1672 */     GIR_RootConstrainSelectedInstOperands,
     /*  1673 */     // GIR_Coverage, 23054,
     /*  1673 */     GIR_EraseRootFromParent_Done,
     /*  1674 */   // Label 110: @1674
     /*  1674 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1698), // Rule ID 23309 //
     /*  1679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1686 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*  1689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1696 */     GIR_RootConstrainSelectedInstOperands,
     /*  1697 */     // GIR_Coverage, 23309,
     /*  1697 */     GIR_EraseRootFromParent_Done,
     /*  1698 */   // Label 111: @1698
     /*  1698 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1722), // Rule ID 23313 //
     /*  1703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  1706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1710 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*  1713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1720 */     GIR_RootConstrainSelectedInstOperands,
     /*  1721 */     // GIR_Coverage, 23313,
     /*  1721 */     GIR_EraseRootFromParent_Done,
     /*  1722 */   // Label 112: @1722
     /*  1722 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1746), // Rule ID 23399 //
     /*  1727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  1734 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*  1737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1744 */     GIR_RootConstrainSelectedInstOperands,
     /*  1745 */     // GIR_Coverage, 23399,
     /*  1745 */     GIR_EraseRootFromParent_Done,
     /*  1746 */   // Label 113: @1746
     /*  1746 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1770), // Rule ID 23403 //
     /*  1751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  1754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  1758 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  1758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*  1761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1768 */     GIR_RootConstrainSelectedInstOperands,
     /*  1769 */     // GIR_Coverage, 23403,
     /*  1769 */     GIR_EraseRootFromParent_Done,
     /*  1770 */   // Label 114: @1770
     /*  1770 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1803), // Rule ID 23247 //
     /*  1775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1786 */     // MIs[1] Operand 1
     /*  1786 */     // No operand predicates
     /*  1786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1788 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  1788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  1791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1801 */     GIR_RootConstrainSelectedInstOperands,
     /*  1802 */     // GIR_Coverage, 23247,
     /*  1802 */     GIR_EraseRootFromParent_Done,
     /*  1803 */   // Label 115: @1803
     /*  1803 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1836), // Rule ID 23337 //
     /*  1808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1819 */     // MIs[1] Operand 1
     /*  1819 */     // No operand predicates
     /*  1819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1821 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  1821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*  1824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1826 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  1831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1834 */     GIR_RootConstrainSelectedInstOperands,
     /*  1835 */     // GIR_Coverage, 23337,
     /*  1835 */     GIR_EraseRootFromParent_Done,
     /*  1836 */   // Label 116: @1836
     /*  1836 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1861), // Rule ID 23239 //
     /*  1841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1848 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  1848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*  1853 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1859 */     GIR_RootConstrainSelectedInstOperands,
     /*  1860 */     // GIR_Coverage, 23239,
     /*  1860 */     GIR_Done,
     /*  1861 */   // Label 117: @1861
     /*  1861 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1886), // Rule ID 23329 //
     /*  1866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  1873 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  1873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*  1878 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  1884 */     GIR_RootConstrainSelectedInstOperands,
     /*  1885 */     // GIR_Coverage, 23329,
     /*  1885 */     GIR_Done,
     /*  1886 */   // Label 118: @1886
     /*  1886 */   GIM_Reject,
     /*  1887 */ // Label 108: @1887
     /*  1887 */ GIM_Reject,
     /*  1888 */ // Label 74: @1888
     /*  1888 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2278),
     /*  1893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  1896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  1899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  1903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  1907 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1941), // Rule ID 23049 //
     /*  1912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1915 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1926 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*  1926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*  1929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1939 */     GIR_RootConstrainSelectedInstOperands,
     /*  1940 */     // GIR_Coverage, 23049,
     /*  1940 */     GIR_EraseRootFromParent_Done,
     /*  1941 */   // Label 120: @1941
     /*  1941 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1975), // Rule ID 23055 //
     /*  1946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  1949 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*  1960 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*  1960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*  1963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  1967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  1970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  1973 */     GIR_RootConstrainSelectedInstOperands,
     /*  1974 */     // GIR_Coverage, 23055,
     /*  1974 */     GIR_EraseRootFromParent_Done,
     /*  1975 */   // Label 121: @1975
     /*  1975 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2016), // Rule ID 23065 //
     /*  1980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  1983 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*  1994 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*  1994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*  1997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2001 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  2011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2014 */     GIR_RootConstrainSelectedInstOperands,
     /*  2015 */     // GIR_Coverage, 23065,
     /*  2015 */     GIR_EraseRootFromParent_Done,
     /*  2016 */   // Label 122: @2016
     /*  2016 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2057), // Rule ID 23067 //
     /*  2021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  2024 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*  2035 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*  2035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*  2038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2042 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  2052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2055 */     GIR_RootConstrainSelectedInstOperands,
     /*  2056 */     // GIR_Coverage, 23067,
     /*  2056 */     GIR_EraseRootFromParent_Done,
     /*  2057 */   // Label 123: @2057
     /*  2057 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2081), // Rule ID 23310 //
     /*  2062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  2065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  2069 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*  2072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2079 */     GIR_RootConstrainSelectedInstOperands,
     /*  2080 */     // GIR_Coverage, 23310,
     /*  2080 */     GIR_EraseRootFromParent_Done,
     /*  2081 */   // Label 124: @2081
     /*  2081 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2105), // Rule ID 23314 //
     /*  2086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*  2089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  2093 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*  2096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2103 */     GIR_RootConstrainSelectedInstOperands,
     /*  2104 */     // GIR_Coverage, 23314,
     /*  2104 */     GIR_EraseRootFromParent_Done,
     /*  2105 */   // Label 125: @2105
     /*  2105 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2129), // Rule ID 23400 //
     /*  2110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  2113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  2117 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*  2120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2127 */     GIR_RootConstrainSelectedInstOperands,
     /*  2128 */     // GIR_Coverage, 23400,
     /*  2128 */     GIR_EraseRootFromParent_Done,
     /*  2129 */   // Label 126: @2129
     /*  2129 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2153), // Rule ID 23404 //
     /*  2134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*  2137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  2141 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  2141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*  2144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  2148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2151 */     GIR_RootConstrainSelectedInstOperands,
     /*  2152 */     // GIR_Coverage, 23404,
     /*  2152 */     GIR_EraseRootFromParent_Done,
     /*  2153 */   // Label 127: @2153
     /*  2153 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2190), // Rule ID 23248 //
     /*  2158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  2161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  2169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  2173 */     // MIs[1] Operand 1
     /*  2173 */     // No operand predicates
     /*  2173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2175 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  2175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*  2178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  2185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2188 */     GIR_RootConstrainSelectedInstOperands,
     /*  2189 */     // GIR_Coverage, 23248,
     /*  2189 */     GIR_EraseRootFromParent_Done,
     /*  2190 */   // Label 128: @2190
     /*  2190 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2227), // Rule ID 23338 //
     /*  2195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  2198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  2206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  2210 */     // MIs[1] Operand 1
     /*  2210 */     // No operand predicates
     /*  2210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2212 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  2212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*  2215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  2219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  2222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  2225 */     GIR_RootConstrainSelectedInstOperands,
     /*  2226 */     // GIR_Coverage, 23338,
     /*  2226 */     GIR_EraseRootFromParent_Done,
     /*  2227 */   // Label 129: @2227
     /*  2227 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2252), // Rule ID 23240 //
     /*  2232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  2235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  2239 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  2239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*  2244 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  2250 */     GIR_RootConstrainSelectedInstOperands,
     /*  2251 */     // GIR_Coverage, 23240,
     /*  2251 */     GIR_Done,
     /*  2252 */   // Label 130: @2252
     /*  2252 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2277), // Rule ID 23330 //
     /*  2257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  2260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  2264 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  2264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*  2269 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  2275 */     GIR_RootConstrainSelectedInstOperands,
     /*  2276 */     // GIR_Coverage, 23330,
     /*  2276 */     GIR_Done,
     /*  2277 */   // Label 131: @2277
     /*  2277 */   GIM_Reject,
     /*  2278 */ // Label 119: @2278
     /*  2278 */ GIM_Reject,
     /*  2279 */ // Label 75: @2279
     /*  2279 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2372),
     /*  2284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2290 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2317), // Rule ID 2537 //
     /*  2295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  2298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2310 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  2310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*  2315 */     GIR_RootConstrainSelectedInstOperands,
     /*  2316 */     // GIR_Coverage, 2537,
     /*  2316 */     GIR_Done,
     /*  2317 */   // Label 133: @2317
     /*  2317 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2344), // Rule ID 2539 //
     /*  2322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  2325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2337 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  2337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*  2342 */     GIR_RootConstrainSelectedInstOperands,
     /*  2343 */     // GIR_Coverage, 2539,
     /*  2343 */     GIR_Done,
     /*  2344 */   // Label 134: @2344
     /*  2344 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2371), // Rule ID 4648 //
     /*  2349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2364 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  2364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*  2369 */     GIR_RootConstrainSelectedInstOperands,
     /*  2370 */     // GIR_Coverage, 4648,
     /*  2370 */     GIR_Done,
     /*  2371 */   // Label 135: @2371
     /*  2371 */   GIM_Reject,
     /*  2372 */ // Label 132: @2372
     /*  2372 */ GIM_Reject,
     /*  2373 */ // Label 76: @2373
     /*  2373 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2588),
     /*  2378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2384 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2445), // Rule ID 18314 //
     /*  2389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2428 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  2428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*  2431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*  2443 */     GIR_RootConstrainSelectedInstOperands,
     /*  2444 */     // GIR_Coverage, 18314,
     /*  2444 */     GIR_EraseRootFromParent_Done,
     /*  2445 */   // Label 137: @2445
     /*  2445 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2506), // Rule ID 25635 //
     /*  2450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2489 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  2489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*  2492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*  2504 */     GIR_RootConstrainSelectedInstOperands,
     /*  2505 */     // GIR_Coverage, 25635,
     /*  2505 */     GIR_EraseRootFromParent_Done,
     /*  2506 */   // Label 138: @2506
     /*  2506 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2533), // Rule ID 2531 //
     /*  2511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  2514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2526 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  2526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*  2531 */     GIR_RootConstrainSelectedInstOperands,
     /*  2532 */     // GIR_Coverage, 2531,
     /*  2532 */     GIR_Done,
     /*  2533 */   // Label 139: @2533
     /*  2533 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2560), // Rule ID 2533 //
     /*  2538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  2541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2553 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  2553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*  2558 */     GIR_RootConstrainSelectedInstOperands,
     /*  2559 */     // GIR_Coverage, 2533,
     /*  2559 */     GIR_Done,
     /*  2560 */   // Label 140: @2560
     /*  2560 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2587), // Rule ID 4675 //
     /*  2565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2580 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  2580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*  2585 */     GIR_RootConstrainSelectedInstOperands,
     /*  2586 */     // GIR_Coverage, 4675,
     /*  2586 */     GIR_Done,
     /*  2587 */   // Label 141: @2587
     /*  2587 */   GIM_Reject,
     /*  2588 */ // Label 136: @2588
     /*  2588 */ GIM_Reject,
     /*  2589 */ // Label 77: @2589
     /*  2589 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2655),
     /*  2594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  2597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  2600 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2627), // Rule ID 2541 //
     /*  2605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  2608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2620 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  2620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*  2625 */     GIR_RootConstrainSelectedInstOperands,
     /*  2626 */     // GIR_Coverage, 2541,
     /*  2626 */     GIR_Done,
     /*  2627 */   // Label 143: @2627
     /*  2627 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2654), // Rule ID 4639 //
     /*  2632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2647 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  2647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*  2652 */     GIR_RootConstrainSelectedInstOperands,
     /*  2653 */     // GIR_Coverage, 4639,
     /*  2653 */     GIR_Done,
     /*  2654 */   // Label 144: @2654
     /*  2654 */   GIM_Reject,
     /*  2655 */ // Label 142: @2655
     /*  2655 */ GIM_Reject,
     /*  2656 */ // Label 78: @2656
     /*  2656 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2871),
     /*  2661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2667 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2728), // Rule ID 18313 //
     /*  2672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2711 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  2711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  2714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*  2726 */     GIR_RootConstrainSelectedInstOperands,
     /*  2727 */     // GIR_Coverage, 18313,
     /*  2727 */     GIR_EraseRootFromParent_Done,
     /*  2728 */   // Label 146: @2728
     /*  2728 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2789), // Rule ID 25634 //
     /*  2733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  2736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2772 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  2772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  2775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  2777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  2781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  2785 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*  2787 */     GIR_RootConstrainSelectedInstOperands,
     /*  2788 */     // GIR_Coverage, 25634,
     /*  2788 */     GIR_EraseRootFromParent_Done,
     /*  2789 */   // Label 147: @2789
     /*  2789 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2816), // Rule ID 2525 //
     /*  2794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  2797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2809 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  2809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*  2814 */     GIR_RootConstrainSelectedInstOperands,
     /*  2815 */     // GIR_Coverage, 2525,
     /*  2815 */     GIR_Done,
     /*  2816 */   // Label 148: @2816
     /*  2816 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2843), // Rule ID 2527 //
     /*  2821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  2824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2836 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  2836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*  2841 */     GIR_RootConstrainSelectedInstOperands,
     /*  2842 */     // GIR_Coverage, 2527,
     /*  2842 */     GIR_Done,
     /*  2843 */   // Label 149: @2843
     /*  2843 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2870), // Rule ID 4696 //
     /*  2848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  2851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  2863 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  2863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*  2868 */     GIR_RootConstrainSelectedInstOperands,
     /*  2869 */     // GIR_Coverage, 4696,
     /*  2869 */     GIR_Done,
     /*  2870 */   // Label 150: @2870
     /*  2870 */   GIM_Reject,
     /*  2871 */ // Label 145: @2871
     /*  2871 */ GIM_Reject,
     /*  2872 */ // Label 79: @2872
     /*  2872 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2938),
     /*  2877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  2880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  2883 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2910), // Rule ID 2535 //
     /*  2888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  2891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  2903 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  2903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*  2908 */     GIR_RootConstrainSelectedInstOperands,
     /*  2909 */     // GIR_Coverage, 2535,
     /*  2909 */     GIR_Done,
     /*  2910 */   // Label 152: @2910
     /*  2910 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2937), // Rule ID 4666 //
     /*  2915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  2918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  2930 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  2930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*  2935 */     GIR_RootConstrainSelectedInstOperands,
     /*  2936 */     // GIR_Coverage, 4666,
     /*  2936 */     GIR_Done,
     /*  2937 */   // Label 153: @2937
     /*  2937 */   GIM_Reject,
     /*  2938 */ // Label 151: @2938
     /*  2938 */ GIM_Reject,
     /*  2939 */ // Label 80: @2939
     /*  2939 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2972), // Rule ID 4630 //
     /*  2944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  2947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  2950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  2953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  2957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  2961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  2965 */   // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  2965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*  2970 */   GIR_RootConstrainSelectedInstOperands,
     /*  2971 */   // GIR_Coverage, 4630,
     /*  2971 */   GIR_Done,
     /*  2972 */ // Label 154: @2972
     /*  2972 */ GIM_Reject,
     /*  2973 */ // Label 81: @2973
     /*  2973 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3066),
     /*  2978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2984 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3011), // Rule ID 2519 //
     /*  2989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  2992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  2996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3004 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  3004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*  3009 */     GIR_RootConstrainSelectedInstOperands,
     /*  3010 */     // GIR_Coverage, 2519,
     /*  3010 */     GIR_Done,
     /*  3011 */   // Label 156: @3011
     /*  3011 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3038), // Rule ID 2521 //
     /*  3016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  3019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  3031 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  3031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*  3036 */     GIR_RootConstrainSelectedInstOperands,
     /*  3037 */     // GIR_Coverage, 2521,
     /*  3037 */     GIR_Done,
     /*  3038 */   // Label 157: @3038
     /*  3038 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3065), // Rule ID 4714 //
     /*  3043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  3046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  3050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  3054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  3058 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  3058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*  3063 */     GIR_RootConstrainSelectedInstOperands,
     /*  3064 */     // GIR_Coverage, 4714,
     /*  3064 */     GIR_Done,
     /*  3065 */   // Label 158: @3065
     /*  3065 */   GIM_Reject,
     /*  3066 */ // Label 155: @3066
     /*  3066 */ GIM_Reject,
     /*  3067 */ // Label 82: @3067
     /*  3067 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3133),
     /*  3072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  3075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  3078 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3105), // Rule ID 2529 //
     /*  3083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  3086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3098 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  3098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*  3103 */     GIR_RootConstrainSelectedInstOperands,
     /*  3104 */     // GIR_Coverage, 2529,
     /*  3104 */     GIR_Done,
     /*  3105 */   // Label 160: @3105
     /*  3105 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3132), // Rule ID 4690 //
     /*  3110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  3113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3125 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  3125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*  3130 */     GIR_RootConstrainSelectedInstOperands,
     /*  3131 */     // GIR_Coverage, 4690,
     /*  3131 */     GIR_Done,
     /*  3132 */   // Label 161: @3132
     /*  3132 */   GIM_Reject,
     /*  3133 */ // Label 159: @3133
     /*  3133 */ GIM_Reject,
     /*  3134 */ // Label 83: @3134
     /*  3134 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3167), // Rule ID 4657 //
     /*  3139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  3142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  3145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  3148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3160 */   // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  3160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*  3165 */   GIR_RootConstrainSelectedInstOperands,
     /*  3166 */   // GIR_Coverage, 4657,
     /*  3166 */   GIR_Done,
     /*  3167 */ // Label 162: @3167
     /*  3167 */ GIM_Reject,
     /*  3168 */ // Label 84: @3168
     /*  3168 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3234),
     /*  3173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  3176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  3179 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3206), // Rule ID 2523 //
     /*  3184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  3187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  3199 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  3199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*  3204 */     GIR_RootConstrainSelectedInstOperands,
     /*  3205 */     // GIR_Coverage, 2523,
     /*  3205 */     GIR_Done,
     /*  3206 */   // Label 164: @3206
     /*  3206 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3233), // Rule ID 4708 //
     /*  3211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  3214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  3226 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  3226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*  3231 */     GIR_RootConstrainSelectedInstOperands,
     /*  3232 */     // GIR_Coverage, 4708,
     /*  3232 */     GIR_Done,
     /*  3233 */   // Label 165: @3233
     /*  3233 */   GIM_Reject,
     /*  3234 */ // Label 163: @3234
     /*  3234 */ GIM_Reject,
     /*  3235 */ // Label 85: @3235
     /*  3235 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3268), // Rule ID 4684 //
     /*  3240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  3243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  3246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  3249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3261 */   // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  3261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*  3266 */   GIR_RootConstrainSelectedInstOperands,
     /*  3267 */   // GIR_Coverage, 4684,
     /*  3267 */   GIR_Done,
     /*  3268 */ // Label 166: @3268
     /*  3268 */ GIM_Reject,
     /*  3269 */ // Label 86: @3269
     /*  3269 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3302), // Rule ID 4702 //
     /*  3274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  3277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  3280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  3283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  3295 */   // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  3295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*  3300 */   GIR_RootConstrainSelectedInstOperands,
     /*  3301 */   // GIR_Coverage, 4702,
     /*  3301 */   GIR_Done,
     /*  3302 */ // Label 167: @3302
     /*  3302 */ GIM_Reject,
     /*  3303 */ // Label 87: @3303
     /*  3303 */ GIM_Reject,
     /*  3304 */ // Label 1: @3304
     /*  3304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 184*/ GIMT_Encode4(5119),
     /*  3315 */ /*GILLT_s8*//*Label 168*/ GIMT_Encode4(3411),
     /*  3319 */ /*GILLT_s16*//*Label 169*/ GIMT_Encode4(3641),
     /*  3323 */ /*GILLT_s32*//*Label 170*/ GIMT_Encode4(3871),
     /*  3327 */ /*GILLT_s64*//*Label 171*/ GIMT_Encode4(4101), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  3343 */ /*GILLT_v2s64*//*Label 172*/ GIMT_Encode4(4339), GIMT_Encode4(0),
     /*  3351 */ /*GILLT_v4s32*//*Label 173*/ GIMT_Encode4(4433),
     /*  3355 */ /*GILLT_v4s64*//*Label 174*/ GIMT_Encode4(4527), GIMT_Encode4(0),
     /*  3363 */ /*GILLT_v8s16*//*Label 175*/ GIMT_Encode4(4594),
     /*  3367 */ /*GILLT_v8s32*//*Label 176*/ GIMT_Encode4(4688),
     /*  3371 */ /*GILLT_v8s64*//*Label 177*/ GIMT_Encode4(4755), GIMT_Encode4(0),
     /*  3379 */ /*GILLT_v16s8*//*Label 178*/ GIMT_Encode4(4789),
     /*  3383 */ /*GILLT_v16s16*//*Label 179*/ GIMT_Encode4(4883),
     /*  3387 */ /*GILLT_v16s32*//*Label 180*/ GIMT_Encode4(4950), GIMT_Encode4(0),
     /*  3395 */ /*GILLT_v32s8*//*Label 181*/ GIMT_Encode4(4984),
     /*  3399 */ /*GILLT_v32s16*//*Label 182*/ GIMT_Encode4(5051), GIMT_Encode4(0),
     /*  3407 */ /*GILLT_v64s8*//*Label 183*/ GIMT_Encode4(5085),
     /*  3411 */ // Label 168: @3411
     /*  3411 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3640),
     /*  3416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  3419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  3422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3426 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3454), // Rule ID 239 //
     /*  3431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3442 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*  3442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*  3445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3447 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3452 */     GIR_RootConstrainSelectedInstOperands,
     /*  3453 */     // GIR_Coverage, 239,
     /*  3453 */     GIR_EraseRootFromParent_Done,
     /*  3454 */   // Label 186: @3454
     /*  3454 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3482), // Rule ID 247 //
     /*  3459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3470 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*  3470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*  3473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3480 */     GIR_RootConstrainSelectedInstOperands,
     /*  3481 */     // GIR_Coverage, 247,
     /*  3481 */     GIR_EraseRootFromParent_Done,
     /*  3482 */   // Label 187: @3482
     /*  3482 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3507), // Rule ID 255 //
     /*  3487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3498 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  3498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*  3501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3505 */     GIR_RootConstrainSelectedInstOperands,
     /*  3506 */     // GIR_Coverage, 255,
     /*  3506 */     GIR_EraseRootFromParent_Done,
     /*  3507 */   // Label 188: @3507
     /*  3507 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3544), // Rule ID 23257 //
     /*  3512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3527 */     // MIs[1] Operand 1
     /*  3527 */     // No operand predicates
     /*  3527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3529 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  3529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*  3532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3542 */     GIR_RootConstrainSelectedInstOperands,
     /*  3543 */     // GIR_Coverage, 23257,
     /*  3543 */     GIR_EraseRootFromParent_Done,
     /*  3544 */   // Label 189: @3544
     /*  3544 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3581), // Rule ID 23347 //
     /*  3549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3564 */     // MIs[1] Operand 1
     /*  3564 */     // No operand predicates
     /*  3564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3566 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  3566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*  3569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3579 */     GIR_RootConstrainSelectedInstOperands,
     /*  3580 */     // GIR_Coverage, 23347,
     /*  3580 */     GIR_EraseRootFromParent_Done,
     /*  3581 */   // Label 190: @3581
     /*  3581 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3610), // Rule ID 23249 //
     /*  3586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3597 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  3597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*  3602 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3608 */     GIR_RootConstrainSelectedInstOperands,
     /*  3609 */     // GIR_Coverage, 23249,
     /*  3609 */     GIR_Done,
     /*  3610 */   // Label 191: @3610
     /*  3610 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3639), // Rule ID 23339 //
     /*  3615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  3626 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  3626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*  3631 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3637 */     GIR_RootConstrainSelectedInstOperands,
     /*  3638 */     // GIR_Coverage, 23339,
     /*  3638 */     GIR_Done,
     /*  3639 */   // Label 192: @3639
     /*  3639 */   GIM_Reject,
     /*  3640 */ // Label 185: @3640
     /*  3640 */ GIM_Reject,
     /*  3641 */ // Label 169: @3641
     /*  3641 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3870),
     /*  3646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  3649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  3652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3656 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3684), // Rule ID 240 //
     /*  3661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3672 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*  3672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*  3675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3682 */     GIR_RootConstrainSelectedInstOperands,
     /*  3683 */     // GIR_Coverage, 240,
     /*  3683 */     GIR_EraseRootFromParent_Done,
     /*  3684 */   // Label 194: @3684
     /*  3684 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3712), // Rule ID 248 //
     /*  3689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3700 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*  3700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*  3703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3710 */     GIR_RootConstrainSelectedInstOperands,
     /*  3711 */     // GIR_Coverage, 248,
     /*  3711 */     GIR_EraseRootFromParent_Done,
     /*  3712 */   // Label 195: @3712
     /*  3712 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3737), // Rule ID 256 //
     /*  3717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3728 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  3728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*  3731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3735 */     GIR_RootConstrainSelectedInstOperands,
     /*  3736 */     // GIR_Coverage, 256,
     /*  3736 */     GIR_EraseRootFromParent_Done,
     /*  3737 */   // Label 196: @3737
     /*  3737 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3774), // Rule ID 23258 //
     /*  3742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3757 */     // MIs[1] Operand 1
     /*  3757 */     // No operand predicates
     /*  3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3759 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  3759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*  3762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3772 */     GIR_RootConstrainSelectedInstOperands,
     /*  3773 */     // GIR_Coverage, 23258,
     /*  3773 */     GIR_EraseRootFromParent_Done,
     /*  3774 */   // Label 197: @3774
     /*  3774 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3811), // Rule ID 23348 //
     /*  3779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3794 */     // MIs[1] Operand 1
     /*  3794 */     // No operand predicates
     /*  3794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3796 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  3796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*  3799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3809 */     GIR_RootConstrainSelectedInstOperands,
     /*  3810 */     // GIR_Coverage, 23348,
     /*  3810 */     GIR_EraseRootFromParent_Done,
     /*  3811 */   // Label 198: @3811
     /*  3811 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3840), // Rule ID 23250 //
     /*  3816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3827 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  3827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*  3832 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3838 */     GIR_RootConstrainSelectedInstOperands,
     /*  3839 */     // GIR_Coverage, 23250,
     /*  3839 */     GIR_Done,
     /*  3840 */   // Label 199: @3840
     /*  3840 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3869), // Rule ID 23340 //
     /*  3845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  3848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  3856 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  3856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*  3861 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  3867 */     GIR_RootConstrainSelectedInstOperands,
     /*  3868 */     // GIR_Coverage, 23340,
     /*  3868 */     GIR_Done,
     /*  3869 */   // Label 200: @3869
     /*  3869 */   GIM_Reject,
     /*  3870 */ // Label 193: @3870
     /*  3870 */ GIM_Reject,
     /*  3871 */ // Label 170: @3871
     /*  3871 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4100),
     /*  3876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3886 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3914), // Rule ID 241 //
     /*  3891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3902 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  3902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*  3905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3907 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3912 */     GIR_RootConstrainSelectedInstOperands,
     /*  3913 */     // GIR_Coverage, 241,
     /*  3913 */     GIR_EraseRootFromParent_Done,
     /*  3914 */   // Label 202: @3914
     /*  3914 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3942), // Rule ID 249 //
     /*  3919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3930 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  3930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*  3933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  3940 */     GIR_RootConstrainSelectedInstOperands,
     /*  3941 */     // GIR_Coverage, 249,
     /*  3941 */     GIR_EraseRootFromParent_Done,
     /*  3942 */   // Label 203: @3942
     /*  3942 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3967), // Rule ID 257 //
     /*  3947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  3950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  3954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3958 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  3958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*  3961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  3965 */     GIR_RootConstrainSelectedInstOperands,
     /*  3966 */     // GIR_Coverage, 257,
     /*  3966 */     GIR_EraseRootFromParent_Done,
     /*  3967 */   // Label 204: @3967
     /*  3967 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4004), // Rule ID 23259 //
     /*  3972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  3975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  3979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  3983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  3987 */     // MIs[1] Operand 1
     /*  3987 */     // No operand predicates
     /*  3987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  3989 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  3989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*  3992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  3994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  3996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  3999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4002 */     GIR_RootConstrainSelectedInstOperands,
     /*  4003 */     // GIR_Coverage, 23259,
     /*  4003 */     GIR_EraseRootFromParent_Done,
     /*  4004 */   // Label 205: @4004
     /*  4004 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4041), // Rule ID 23349 //
     /*  4009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4024 */     // MIs[1] Operand 1
     /*  4024 */     // No operand predicates
     /*  4024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4026 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  4026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*  4029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  4033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  4036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4039 */     GIR_RootConstrainSelectedInstOperands,
     /*  4040 */     // GIR_Coverage, 23349,
     /*  4040 */     GIR_EraseRootFromParent_Done,
     /*  4041 */   // Label 206: @4041
     /*  4041 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4070), // Rule ID 23251 //
     /*  4046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4057 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  4057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*  4062 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4068 */     GIR_RootConstrainSelectedInstOperands,
     /*  4069 */     // GIR_Coverage, 23251,
     /*  4069 */     GIR_Done,
     /*  4070 */   // Label 207: @4070
     /*  4070 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(4099), // Rule ID 23341 //
     /*  4075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  4086 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  4086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*  4091 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4097 */     GIR_RootConstrainSelectedInstOperands,
     /*  4098 */     // GIR_Coverage, 23341,
     /*  4098 */     GIR_Done,
     /*  4099 */   // Label 208: @4099
     /*  4099 */   GIM_Reject,
     /*  4100 */ // Label 201: @4100
     /*  4100 */ GIM_Reject,
     /*  4101 */ // Label 171: @4101
     /*  4101 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(4338),
     /*  4106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4116 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(4144), // Rule ID 242 //
     /*  4121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  4128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4132 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*  4132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*  4135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  4139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4142 */     GIR_RootConstrainSelectedInstOperands,
     /*  4143 */     // GIR_Coverage, 242,
     /*  4143 */     GIR_EraseRootFromParent_Done,
     /*  4144 */   // Label 210: @4144
     /*  4144 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4172), // Rule ID 250 //
     /*  4149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  4152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  4156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4160 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*  4160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*  4163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4165 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  4167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4170 */     GIR_RootConstrainSelectedInstOperands,
     /*  4171 */     // GIR_Coverage, 250,
     /*  4171 */     GIR_EraseRootFromParent_Done,
     /*  4172 */   // Label 211: @4172
     /*  4172 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4197), // Rule ID 258 //
     /*  4177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  4180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  4184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4188 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*  4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  4195 */     GIR_RootConstrainSelectedInstOperands,
     /*  4196 */     // GIR_Coverage, 258,
     /*  4196 */     GIR_EraseRootFromParent_Done,
     /*  4197 */   // Label 212: @4197
     /*  4197 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4238), // Rule ID 23260 //
     /*  4202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  4221 */     // MIs[1] Operand 1
     /*  4221 */     // No operand predicates
     /*  4221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4223 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  4223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*  4226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  4230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  4233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4236 */     GIR_RootConstrainSelectedInstOperands,
     /*  4237 */     // GIR_Coverage, 23260,
     /*  4237 */     GIR_EraseRootFromParent_Done,
     /*  4238 */   // Label 213: @4238
     /*  4238 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4279), // Rule ID 23350 //
     /*  4243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  4262 */     // MIs[1] Operand 1
     /*  4262 */     // No operand predicates
     /*  4262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4264 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  4264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*  4267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  4269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  4271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  4274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  4277 */     GIR_RootConstrainSelectedInstOperands,
     /*  4278 */     // GIR_Coverage, 23350,
     /*  4278 */     GIR_EraseRootFromParent_Done,
     /*  4279 */   // Label 214: @4279
     /*  4279 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4308), // Rule ID 23252 //
     /*  4284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  4287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4295 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  4295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*  4300 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4306 */     GIR_RootConstrainSelectedInstOperands,
     /*  4307 */     // GIR_Coverage, 23252,
     /*  4307 */     GIR_Done,
     /*  4308 */   // Label 215: @4308
     /*  4308 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4337), // Rule ID 23342 //
     /*  4313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  4316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  4324 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  4324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*  4329 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  4335 */     GIR_RootConstrainSelectedInstOperands,
     /*  4336 */     // GIR_Coverage, 23342,
     /*  4336 */     GIR_Done,
     /*  4337 */   // Label 216: @4337
     /*  4337 */   GIM_Reject,
     /*  4338 */ // Label 209: @4338
     /*  4338 */ GIM_Reject,
     /*  4339 */ // Label 172: @4339
     /*  4339 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(4432),
     /*  4344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4350 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(4377), // Rule ID 2603 //
     /*  4355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  4358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4370 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  4370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*  4375 */     GIR_RootConstrainSelectedInstOperands,
     /*  4376 */     // GIR_Coverage, 2603,
     /*  4376 */     GIR_Done,
     /*  4377 */   // Label 218: @4377
     /*  4377 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(4404), // Rule ID 2605 //
     /*  4382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4397 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  4397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*  4402 */     GIR_RootConstrainSelectedInstOperands,
     /*  4403 */     // GIR_Coverage, 2605,
     /*  4403 */     GIR_Done,
     /*  4404 */   // Label 219: @4404
     /*  4404 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(4431), // Rule ID 4738 //
     /*  4409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4424 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  4424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*  4429 */     GIR_RootConstrainSelectedInstOperands,
     /*  4430 */     // GIR_Coverage, 4738,
     /*  4430 */     GIR_Done,
     /*  4431 */   // Label 220: @4431
     /*  4431 */   GIM_Reject,
     /*  4432 */ // Label 217: @4432
     /*  4432 */ GIM_Reject,
     /*  4433 */ // Label 173: @4433
     /*  4433 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(4526),
     /*  4438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4444 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(4471), // Rule ID 2597 //
     /*  4449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  4452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4464 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  4464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*  4469 */     GIR_RootConstrainSelectedInstOperands,
     /*  4470 */     // GIR_Coverage, 2597,
     /*  4470 */     GIR_Done,
     /*  4471 */   // Label 222: @4471
     /*  4471 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(4498), // Rule ID 2599 //
     /*  4476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4491 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  4491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*  4496 */     GIR_RootConstrainSelectedInstOperands,
     /*  4497 */     // GIR_Coverage, 2599,
     /*  4497 */     GIR_Done,
     /*  4498 */   // Label 223: @4498
     /*  4498 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(4525), // Rule ID 4765 //
     /*  4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4518 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  4518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*  4523 */     GIR_RootConstrainSelectedInstOperands,
     /*  4524 */     // GIR_Coverage, 4765,
     /*  4524 */     GIR_Done,
     /*  4525 */   // Label 224: @4525
     /*  4525 */   GIM_Reject,
     /*  4526 */ // Label 221: @4526
     /*  4526 */ GIM_Reject,
     /*  4527 */ // Label 174: @4527
     /*  4527 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4593),
     /*  4532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  4535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  4538 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4565), // Rule ID 2607 //
     /*  4543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  4546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4558 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  4558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*  4563 */     GIR_RootConstrainSelectedInstOperands,
     /*  4564 */     // GIR_Coverage, 2607,
     /*  4564 */     GIR_Done,
     /*  4565 */   // Label 226: @4565
     /*  4565 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4592), // Rule ID 4729 //
     /*  4570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4585 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  4585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*  4590 */     GIR_RootConstrainSelectedInstOperands,
     /*  4591 */     // GIR_Coverage, 4729,
     /*  4591 */     GIR_Done,
     /*  4592 */   // Label 227: @4592
     /*  4592 */   GIM_Reject,
     /*  4593 */ // Label 225: @4593
     /*  4593 */ GIM_Reject,
     /*  4594 */ // Label 175: @4594
     /*  4594 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4687),
     /*  4599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4605 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4632), // Rule ID 2591 //
     /*  4610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  4613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4625 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  4625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*  4630 */     GIR_RootConstrainSelectedInstOperands,
     /*  4631 */     // GIR_Coverage, 2591,
     /*  4631 */     GIR_Done,
     /*  4632 */   // Label 229: @4632
     /*  4632 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4659), // Rule ID 2593 //
     /*  4637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4652 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  4652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*  4657 */     GIR_RootConstrainSelectedInstOperands,
     /*  4658 */     // GIR_Coverage, 2593,
     /*  4658 */     GIR_Done,
     /*  4659 */   // Label 230: @4659
     /*  4659 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4686), // Rule ID 4786 //
     /*  4664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  4667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4679 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  4679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*  4684 */     GIR_RootConstrainSelectedInstOperands,
     /*  4685 */     // GIR_Coverage, 4786,
     /*  4685 */     GIR_Done,
     /*  4686 */   // Label 231: @4686
     /*  4686 */   GIM_Reject,
     /*  4687 */ // Label 228: @4687
     /*  4687 */ GIM_Reject,
     /*  4688 */ // Label 176: @4688
     /*  4688 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4754),
     /*  4693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  4696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  4699 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4726), // Rule ID 2601 //
     /*  4704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  4707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4719 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  4719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*  4724 */     GIR_RootConstrainSelectedInstOperands,
     /*  4725 */     // GIR_Coverage, 2601,
     /*  4725 */     GIR_Done,
     /*  4726 */   // Label 233: @4726
     /*  4726 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4753), // Rule ID 4756 //
     /*  4731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  4734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4746 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  4746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*  4751 */     GIR_RootConstrainSelectedInstOperands,
     /*  4752 */     // GIR_Coverage, 4756,
     /*  4752 */     GIR_Done,
     /*  4753 */   // Label 234: @4753
     /*  4753 */   GIM_Reject,
     /*  4754 */ // Label 232: @4754
     /*  4754 */ GIM_Reject,
     /*  4755 */ // Label 177: @4755
     /*  4755 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4788), // Rule ID 4720 //
     /*  4760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  4763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  4766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  4769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4781 */   // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  4781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*  4786 */   GIR_RootConstrainSelectedInstOperands,
     /*  4787 */   // GIR_Coverage, 4720,
     /*  4787 */   GIR_Done,
     /*  4788 */ // Label 235: @4788
     /*  4788 */ GIM_Reject,
     /*  4789 */ // Label 178: @4789
     /*  4789 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4882),
     /*  4794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4800 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4827), // Rule ID 2585 //
     /*  4805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  4808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4820 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  4820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  4825 */     GIR_RootConstrainSelectedInstOperands,
     /*  4826 */     // GIR_Coverage, 2585,
     /*  4826 */     GIR_Done,
     /*  4827 */   // Label 237: @4827
     /*  4827 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4854), // Rule ID 2587 //
     /*  4832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  4835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  4847 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  4847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  4852 */     GIR_RootConstrainSelectedInstOperands,
     /*  4853 */     // GIR_Coverage, 2587,
     /*  4853 */     GIR_Done,
     /*  4854 */   // Label 238: @4854
     /*  4854 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4881), // Rule ID 4804 //
     /*  4859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  4862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  4874 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  4874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  4879 */     GIR_RootConstrainSelectedInstOperands,
     /*  4880 */     // GIR_Coverage, 4804,
     /*  4880 */     GIR_Done,
     /*  4881 */   // Label 239: @4881
     /*  4881 */   GIM_Reject,
     /*  4882 */ // Label 236: @4882
     /*  4882 */ GIM_Reject,
     /*  4883 */ // Label 179: @4883
     /*  4883 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(4949),
     /*  4888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  4891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  4894 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(4921), // Rule ID 2595 //
     /*  4899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  4902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  4914 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  4914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  4919 */     GIR_RootConstrainSelectedInstOperands,
     /*  4920 */     // GIR_Coverage, 2595,
     /*  4920 */     GIR_Done,
     /*  4921 */   // Label 241: @4921
     /*  4921 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(4948), // Rule ID 4780 //
     /*  4926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  4929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  4941 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  4941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  4946 */     GIR_RootConstrainSelectedInstOperands,
     /*  4947 */     // GIR_Coverage, 4780,
     /*  4947 */     GIR_Done,
     /*  4948 */   // Label 242: @4948
     /*  4948 */   GIM_Reject,
     /*  4949 */ // Label 240: @4949
     /*  4949 */ GIM_Reject,
     /*  4950 */ // Label 180: @4950
     /*  4950 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(4983), // Rule ID 4747 //
     /*  4955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  4958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  4961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  4964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  4976 */   // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  4976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  4981 */   GIR_RootConstrainSelectedInstOperands,
     /*  4982 */   // GIR_Coverage, 4747,
     /*  4982 */   GIR_Done,
     /*  4983 */ // Label 243: @4983
     /*  4983 */ GIM_Reject,
     /*  4984 */ // Label 181: @4984
     /*  4984 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5050),
     /*  4989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  4992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  4995 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5022), // Rule ID 2589 //
     /*  5000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  5003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  5007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  5011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  5015 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  5015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  5020 */     GIR_RootConstrainSelectedInstOperands,
     /*  5021 */     // GIR_Coverage, 2589,
     /*  5021 */     GIR_Done,
     /*  5022 */   // Label 245: @5022
     /*  5022 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5049), // Rule ID 4798 //
     /*  5027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  5030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5042 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  5042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  5047 */     GIR_RootConstrainSelectedInstOperands,
     /*  5048 */     // GIR_Coverage, 4798,
     /*  5048 */     GIR_Done,
     /*  5049 */   // Label 246: @5049
     /*  5049 */   GIM_Reject,
     /*  5050 */ // Label 244: @5050
     /*  5050 */ GIM_Reject,
     /*  5051 */ // Label 182: @5051
     /*  5051 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(5084), // Rule ID 4774 //
     /*  5056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  5059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  5062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  5065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5077 */   // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  5077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  5082 */   GIR_RootConstrainSelectedInstOperands,
     /*  5083 */   // GIR_Coverage, 4774,
     /*  5083 */   GIR_Done,
     /*  5084 */ // Label 247: @5084
     /*  5084 */ GIM_Reject,
     /*  5085 */ // Label 183: @5085
     /*  5085 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(5118), // Rule ID 4792 //
     /*  5090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  5093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  5096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  5099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  5111 */   // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  5111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  5116 */   GIR_RootConstrainSelectedInstOperands,
     /*  5117 */   // GIR_Coverage, 4792,
     /*  5117 */   GIR_Done,
     /*  5118 */ // Label 248: @5118
     /*  5118 */ GIM_Reject,
     /*  5119 */ // Label 184: @5119
     /*  5119 */ GIM_Reject,
     /*  5120 */ // Label 2: @5120
     /*  5120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 261*/ GIMT_Encode4(6344),
     /*  5131 */ /*GILLT_s16*//*Label 249*/ GIMT_Encode4(5215),
     /*  5135 */ /*GILLT_s32*//*Label 250*/ GIMT_Encode4(5316),
     /*  5139 */ /*GILLT_s64*//*Label 251*/ GIMT_Encode4(5417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  5155 */ /*GILLT_v2s64*//*Label 252*/ GIMT_Encode4(5522), GIMT_Encode4(0),
     /*  5163 */ /*GILLT_v4s32*//*Label 253*/ GIMT_Encode4(5727),
     /*  5167 */ /*GILLT_v4s64*//*Label 254*/ GIMT_Encode4(5821), GIMT_Encode4(0),
     /*  5175 */ /*GILLT_v8s16*//*Label 255*/ GIMT_Encode4(6014),
     /*  5179 */ /*GILLT_v8s32*//*Label 256*/ GIMT_Encode4(6108),
     /*  5183 */ /*GILLT_v8s64*//*Label 257*/ GIMT_Encode4(6175), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  5195 */ /*GILLT_v16s16*//*Label 258*/ GIMT_Encode4(6209),
     /*  5199 */ /*GILLT_v16s32*//*Label 259*/ GIMT_Encode4(6276), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  5211 */ /*GILLT_v32s16*//*Label 260*/ GIMT_Encode4(6310),
     /*  5215 */ // Label 249: @5215
     /*  5215 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5315),
     /*  5220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  5223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  5226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5234 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5264), // Rule ID 23421 //
     /*  5239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5247 */     // MIs[1] Operand 1
     /*  5247 */     // No operand predicates
     /*  5247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5249 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  5249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  5252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  5256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  5259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  5262 */     GIR_RootConstrainSelectedInstOperands,
     /*  5263 */     // GIR_Coverage, 23421,
     /*  5263 */     GIR_EraseRootFromParent_Done,
     /*  5264 */   // Label 263: @5264
     /*  5264 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(5289), // Rule ID 23265 //
     /*  5269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  5272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5276 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  5276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  5281 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5287 */     GIR_RootConstrainSelectedInstOperands,
     /*  5288 */     // GIR_Coverage, 23265,
     /*  5288 */     GIR_Done,
     /*  5289 */   // Label 264: @5289
     /*  5289 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5314), // Rule ID 23355 //
     /*  5294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  5297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  5301 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  5301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  5306 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5312 */     GIR_RootConstrainSelectedInstOperands,
     /*  5313 */     // GIR_Coverage, 23355,
     /*  5313 */     GIR_Done,
     /*  5314 */   // Label 265: @5314
     /*  5314 */   GIM_Reject,
     /*  5315 */ // Label 262: @5315
     /*  5315 */ GIM_Reject,
     /*  5316 */ // Label 250: @5316
     /*  5316 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5416),
     /*  5321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5335 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(5365), // Rule ID 23422 //
     /*  5340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5348 */     // MIs[1] Operand 1
     /*  5348 */     // No operand predicates
     /*  5348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5350 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  5350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  5353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  5357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  5360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  5363 */     GIR_RootConstrainSelectedInstOperands,
     /*  5364 */     // GIR_Coverage, 23422,
     /*  5364 */     GIR_EraseRootFromParent_Done,
     /*  5365 */   // Label 267: @5365
     /*  5365 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(5390), // Rule ID 23266 //
     /*  5370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  5373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5377 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  5377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  5382 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5388 */     GIR_RootConstrainSelectedInstOperands,
     /*  5389 */     // GIR_Coverage, 23266,
     /*  5389 */     GIR_Done,
     /*  5390 */   // Label 268: @5390
     /*  5390 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(5415), // Rule ID 23356 //
     /*  5395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  5398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  5402 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  5402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  5407 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5413 */     GIR_RootConstrainSelectedInstOperands,
     /*  5414 */     // GIR_Coverage, 23356,
     /*  5414 */     GIR_Done,
     /*  5415 */   // Label 269: @5415
     /*  5415 */   GIM_Reject,
     /*  5416 */ // Label 266: @5416
     /*  5416 */ GIM_Reject,
     /*  5417 */ // Label 251: @5417
     /*  5417 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(5521),
     /*  5422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  5425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  5428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5436 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(5470), // Rule ID 23423 //
     /*  5441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  5453 */     // MIs[1] Operand 1
     /*  5453 */     // No operand predicates
     /*  5453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5455 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  5455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  5458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  5462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  5465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  5468 */     GIR_RootConstrainSelectedInstOperands,
     /*  5469 */     // GIR_Coverage, 23423,
     /*  5469 */     GIR_EraseRootFromParent_Done,
     /*  5470 */   // Label 271: @5470
     /*  5470 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(5495), // Rule ID 23267 //
     /*  5475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  5478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5482 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  5482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  5487 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5493 */     GIR_RootConstrainSelectedInstOperands,
     /*  5494 */     // GIR_Coverage, 23267,
     /*  5494 */     GIR_Done,
     /*  5495 */   // Label 272: @5495
     /*  5495 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(5520), // Rule ID 23357 //
     /*  5500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  5503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  5507 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  5507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  5512 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  5518 */     GIR_RootConstrainSelectedInstOperands,
     /*  5519 */     // GIR_Coverage, 23357,
     /*  5519 */     GIR_Done,
     /*  5520 */   // Label 273: @5520
     /*  5520 */   GIM_Reject,
     /*  5521 */ // Label 270: @5521
     /*  5521 */ GIM_Reject,
     /*  5522 */ // Label 252: @5522
     /*  5522 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(5726),
     /*  5527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  5530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  5533 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(5560), // Rule ID 5017 //
     /*  5538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  5541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5553 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  5553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  5558 */     GIR_RootConstrainSelectedInstOperands,
     /*  5559 */     // GIR_Coverage, 5017,
     /*  5559 */     GIR_Done,
     /*  5560 */   // Label 275: @5560
     /*  5560 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(5725), // Rule ID 20445 //
     /*  5565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  5568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  5572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5580 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  5580 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  5583 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5587 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  5594 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  5597 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5601 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5606 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  5609 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  5613 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  5616 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5621 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5626 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  5631 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  5634 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5638 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  5645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  5648 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5652 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5657 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  5660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  5664 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  5667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  5682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  5685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  5689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  5697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  5700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5707 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  5714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  5719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5724 */     // GIR_Coverage, 20445,
     /*  5724 */     GIR_EraseRootFromParent_Done,
     /*  5725 */   // Label 276: @5725
     /*  5725 */   GIM_Reject,
     /*  5726 */ // Label 274: @5726
     /*  5726 */ GIM_Reject,
     /*  5727 */ // Label 253: @5727
     /*  5727 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(5820),
     /*  5732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  5735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  5738 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(5765), // Rule ID 3236 //
     /*  5743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  5746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5758 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  5758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  5763 */     GIR_RootConstrainSelectedInstOperands,
     /*  5764 */     // GIR_Coverage, 3236,
     /*  5764 */     GIR_Done,
     /*  5765 */   // Label 278: @5765
     /*  5765 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(5792), // Rule ID 3244 //
     /*  5770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  5773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  5785 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  5785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  5790 */     GIR_RootConstrainSelectedInstOperands,
     /*  5791 */     // GIR_Coverage, 3244,
     /*  5791 */     GIR_Done,
     /*  5792 */   // Label 279: @5792
     /*  5792 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(5819), // Rule ID 4972 //
     /*  5797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  5800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  5812 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  5812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  5817 */     GIR_RootConstrainSelectedInstOperands,
     /*  5818 */     // GIR_Coverage, 4972,
     /*  5818 */     GIR_Done,
     /*  5819 */   // Label 280: @5819
     /*  5819 */   GIM_Reject,
     /*  5820 */ // Label 277: @5820
     /*  5820 */ GIM_Reject,
     /*  5821 */ // Label 254: @5821
     /*  5821 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(6013),
     /*  5826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  5829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  5832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  5844 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(5859), // Rule ID 5008 //
     /*  5849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  5852 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  5852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  5857 */     GIR_RootConstrainSelectedInstOperands,
     /*  5858 */     // GIR_Coverage, 5008,
     /*  5858 */     GIR_Done,
     /*  5859 */   // Label 282: @5859
     /*  5859 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(6012), // Rule ID 20443 //
     /*  5864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  5867 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  5867 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  5870 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5874 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  5881 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  5884 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5888 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5893 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  5896 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  5900 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  5903 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5908 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5913 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  5918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  5921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  5925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  5932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  5935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  5939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5944 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  5947 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  5951 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  5954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  5959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  5964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  5969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  5972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  5976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  5981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  5984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  5987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  5989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  5992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  5994 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  6001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  6006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  6011 */     // GIR_Coverage, 20443,
     /*  6011 */     GIR_EraseRootFromParent_Done,
     /*  6012 */   // Label 283: @6012
     /*  6012 */   GIM_Reject,
     /*  6013 */ // Label 281: @6013
     /*  6013 */ GIM_Reject,
     /*  6014 */ // Label 255: @6014
     /*  6014 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(6107),
     /*  6019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  6022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  6025 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(6052), // Rule ID 2567 //
     /*  6030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  6033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6045 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  6045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  6050 */     GIR_RootConstrainSelectedInstOperands,
     /*  6051 */     // GIR_Coverage, 2567,
     /*  6051 */     GIR_Done,
     /*  6052 */   // Label 285: @6052
     /*  6052 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(6079), // Rule ID 2569 //
     /*  6057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  6060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  6072 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  6072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  6077 */     GIR_RootConstrainSelectedInstOperands,
     /*  6078 */     // GIR_Coverage, 2569,
     /*  6078 */     GIR_Done,
     /*  6079 */   // Label 286: @6079
     /*  6079 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(6106), // Rule ID 4993 //
     /*  6084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  6087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  6091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  6095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  6099 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  6099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  6104 */     GIR_RootConstrainSelectedInstOperands,
     /*  6105 */     // GIR_Coverage, 4993,
     /*  6105 */     GIR_Done,
     /*  6106 */   // Label 287: @6106
     /*  6106 */   GIM_Reject,
     /*  6107 */ // Label 284: @6107
     /*  6107 */ GIM_Reject,
     /*  6108 */ // Label 256: @6108
     /*  6108 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(6174),
     /*  6113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  6116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  6119 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(6146), // Rule ID 3240 //
     /*  6124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  6127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6139 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  6139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  6144 */     GIR_RootConstrainSelectedInstOperands,
     /*  6145 */     // GIR_Coverage, 3240,
     /*  6145 */     GIR_Done,
     /*  6146 */   // Label 289: @6146
     /*  6146 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(6173), // Rule ID 4963 //
     /*  6151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  6154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6166 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  6166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  6171 */     GIR_RootConstrainSelectedInstOperands,
     /*  6172 */     // GIR_Coverage, 4963,
     /*  6172 */     GIR_Done,
     /*  6173 */   // Label 290: @6173
     /*  6173 */   GIM_Reject,
     /*  6174 */ // Label 288: @6174
     /*  6174 */ GIM_Reject,
     /*  6175 */ // Label 257: @6175
     /*  6175 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(6208), // Rule ID 4999 //
     /*  6180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  6183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  6186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  6189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6201 */   // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  6201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  6206 */   GIR_RootConstrainSelectedInstOperands,
     /*  6207 */   // GIR_Coverage, 4999,
     /*  6207 */   GIR_Done,
     /*  6208 */ // Label 291: @6208
     /*  6208 */ GIM_Reject,
     /*  6209 */ // Label 258: @6209
     /*  6209 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(6275),
     /*  6214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  6217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  6220 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(6247), // Rule ID 2571 //
     /*  6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  6240 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  6240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  6245 */     GIR_RootConstrainSelectedInstOperands,
     /*  6246 */     // GIR_Coverage, 2571,
     /*  6246 */     GIR_Done,
     /*  6247 */   // Label 293: @6247
     /*  6247 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(6274), // Rule ID 4987 //
     /*  6252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  6255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  6267 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  6267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  6272 */     GIR_RootConstrainSelectedInstOperands,
     /*  6273 */     // GIR_Coverage, 4987,
     /*  6273 */     GIR_Done,
     /*  6274 */   // Label 294: @6274
     /*  6274 */   GIM_Reject,
     /*  6275 */ // Label 292: @6275
     /*  6275 */ GIM_Reject,
     /*  6276 */ // Label 259: @6276
     /*  6276 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(6309), // Rule ID 4954 //
     /*  6281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  6284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  6287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  6290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6302 */   // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  6302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  6307 */   GIR_RootConstrainSelectedInstOperands,
     /*  6308 */   // GIR_Coverage, 4954,
     /*  6308 */   GIR_Done,
     /*  6309 */ // Label 295: @6309
     /*  6309 */ GIM_Reject,
     /*  6310 */ // Label 260: @6310
     /*  6310 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(6343), // Rule ID 4981 //
     /*  6315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  6318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  6321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  6324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  6336 */   // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  6336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  6341 */   GIR_RootConstrainSelectedInstOperands,
     /*  6342 */   // GIR_Coverage, 4981,
     /*  6342 */   GIR_Done,
     /*  6343 */ // Label 296: @6343
     /*  6343 */ GIM_Reject,
     /*  6344 */ // Label 261: @6344
     /*  6344 */ GIM_Reject,
     /*  6345 */ // Label 3: @6345
     /*  6345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 320*/ GIMT_Encode4(12188),
     /*  6356 */ /*GILLT_s1*//*Label 297*/ GIMT_Encode4(6456),
     /*  6360 */ /*GILLT_s8*//*Label 298*/ GIMT_Encode4(6802),
     /*  6364 */ /*GILLT_s16*//*Label 299*/ GIMT_Encode4(6939),
     /*  6368 */ /*GILLT_s32*//*Label 300*/ GIMT_Encode4(7380),
     /*  6372 */ /*GILLT_s64*//*Label 301*/ GIMT_Encode4(8566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  6384 */ /*GILLT_v2s1*//*Label 302*/ GIMT_Encode4(9630),
     /*  6388 */ /*GILLT_v2s64*//*Label 303*/ GIMT_Encode4(9976),
     /*  6392 */ /*GILLT_v4s1*//*Label 304*/ GIMT_Encode4(10070),
     /*  6396 */ /*GILLT_v4s32*//*Label 305*/ GIMT_Encode4(10416),
     /*  6400 */ /*GILLT_v4s64*//*Label 306*/ GIMT_Encode4(10510),
     /*  6404 */ /*GILLT_v8s1*//*Label 307*/ GIMT_Encode4(10604),
     /*  6408 */ /*GILLT_v8s16*//*Label 308*/ GIMT_Encode4(11102),
     /*  6412 */ /*GILLT_v8s32*//*Label 309*/ GIMT_Encode4(11196),
     /*  6416 */ /*GILLT_v8s64*//*Label 310*/ GIMT_Encode4(11290),
     /*  6420 */ /*GILLT_v16s1*//*Label 311*/ GIMT_Encode4(11324),
     /*  6424 */ /*GILLT_v16s8*//*Label 312*/ GIMT_Encode4(11484),
     /*  6428 */ /*GILLT_v16s16*//*Label 313*/ GIMT_Encode4(11578),
     /*  6432 */ /*GILLT_v16s32*//*Label 314*/ GIMT_Encode4(11672),
     /*  6436 */ /*GILLT_v32s1*//*Label 315*/ GIMT_Encode4(11706),
     /*  6440 */ /*GILLT_v32s8*//*Label 316*/ GIMT_Encode4(11866),
     /*  6444 */ /*GILLT_v32s16*//*Label 317*/ GIMT_Encode4(11960),
     /*  6448 */ /*GILLT_v64s1*//*Label 318*/ GIMT_Encode4(11994),
     /*  6452 */ /*GILLT_v64s8*//*Label 319*/ GIMT_Encode4(12154),
     /*  6456 */ // Label 297: @6456
     /*  6456 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(6801),
     /*  6461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  6464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  6467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6471 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(6591), // Rule ID 19935 //
     /*  6476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  6484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  6488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  6492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  6501 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  6507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  6509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  6515 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  6515 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  6518 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6522 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6527 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  6531 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  6539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  6552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  6560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  6564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6569 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  6572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  6575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  6577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  6585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  6590 */     // GIR_Coverage, 19935,
     /*  6590 */     GIR_EraseRootFromParent_Done,
     /*  6591 */   // Label 322: @6591
     /*  6591 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(6711), // Rule ID 25812 //
     /*  6596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  6604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  6608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  6612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  6616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  6625 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  6631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  6633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  6635 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  6635 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  6638 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6642 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6647 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  6651 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6656 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  6659 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6663 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6668 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  6672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  6680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  6684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  6692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  6695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  6697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  6705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  6710 */     // GIR_Coverage, 25812,
     /*  6710 */     GIR_EraseRootFromParent_Done,
     /*  6711 */   // Label 323: @6711
     /*  6711 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(6800), // Rule ID 19931 //
     /*  6716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  6724 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  6724 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  6727 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6731 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6736 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  6740 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  6748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6757 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  6761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  6766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  6769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  6773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  6778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  6781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  6784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  6786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  6794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  6799 */     // GIR_Coverage, 19931,
     /*  6799 */     GIR_EraseRootFromParent_Done,
     /*  6800 */   // Label 324: @6800
     /*  6800 */   GIM_Reject,
     /*  6801 */ // Label 321: @6801
     /*  6801 */ GIM_Reject,
     /*  6802 */ // Label 298: @6802
     /*  6802 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(6938),
     /*  6807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  6810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  6813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6821 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(6854), // Rule ID 23303 //
     /*  6826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  6829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  6833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  6837 */     // MIs[1] Operand 1
     /*  6837 */     // No operand predicates
     /*  6837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6839 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  6839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  6842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  6846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  6849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  6852 */     GIR_RootConstrainSelectedInstOperands,
     /*  6853 */     // GIR_Coverage, 23303,
     /*  6853 */     GIR_EraseRootFromParent_Done,
     /*  6854 */   // Label 326: @6854
     /*  6854 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(6887), // Rule ID 23393 //
     /*  6859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  6862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  6866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  6870 */     // MIs[1] Operand 1
     /*  6870 */     // No operand predicates
     /*  6870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6872 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  6872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  6875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  6877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  6879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  6882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  6885 */     GIR_RootConstrainSelectedInstOperands,
     /*  6886 */     // GIR_Coverage, 23393,
     /*  6886 */     GIR_EraseRootFromParent_Done,
     /*  6887 */   // Label 327: @6887
     /*  6887 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(6912), // Rule ID 23295 //
     /*  6892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  6895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6899 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  6899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  6904 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  6910 */     GIR_RootConstrainSelectedInstOperands,
     /*  6911 */     // GIR_Coverage, 23295,
     /*  6911 */     GIR_Done,
     /*  6912 */   // Label 328: @6912
     /*  6912 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(6937), // Rule ID 23385 //
     /*  6917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  6920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6924 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  6924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  6929 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  6935 */     GIR_RootConstrainSelectedInstOperands,
     /*  6936 */     // GIR_Coverage, 23385,
     /*  6936 */     GIR_Done,
     /*  6937 */   // Label 329: @6937
     /*  6937 */   GIM_Reject,
     /*  6938 */ // Label 325: @6938
     /*  6938 */ GIM_Reject,
     /*  6939 */ // Label 299: @6939
     /*  6939 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(7379),
     /*  6944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  6947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  6950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  6954 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(7056), // Rule ID 26481 //
     /*  6959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  6967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  6971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  6975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  6979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  6984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  6988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6990 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  6990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  6993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  6997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  7007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  7031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  7036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  7041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  7044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  7048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7054 */     GIR_RootConstrainSelectedInstOperands,
     /*  7055 */     // GIR_Coverage, 26481,
     /*  7055 */     GIR_EraseRootFromParent_Done,
     /*  7056 */   // Label 331: @7056
     /*  7056 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(7158), // Rule ID 23219 //
     /*  7061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  7073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  7077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  7081 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  7085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  7090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7092 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  7092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  7095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  7099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  7109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  7133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  7138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  7143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  7146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  7150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7156 */     GIR_RootConstrainSelectedInstOperands,
     /*  7157 */     // GIR_Coverage, 23219,
     /*  7157 */     GIR_EraseRootFromParent_Done,
     /*  7158 */   // Label 332: @7158
     /*  7158 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(7246), // Rule ID 23079 //
     /*  7163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7167 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  7178 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  7178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  7181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7190 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  7196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  7201 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  7206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  7209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  7213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7218 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  7235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  7240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  7245 */     // GIR_Coverage, 23079,
     /*  7245 */     GIR_EraseRootFromParent_Done,
     /*  7246 */   // Label 333: @7246
     /*  7246 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(7283), // Rule ID 23304 //
     /*  7251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  7254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  7266 */     // MIs[1] Operand 1
     /*  7266 */     // No operand predicates
     /*  7266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7268 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  7268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  7271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  7275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  7278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7281 */     GIR_RootConstrainSelectedInstOperands,
     /*  7282 */     // GIR_Coverage, 23304,
     /*  7282 */     GIR_EraseRootFromParent_Done,
     /*  7283 */   // Label 334: @7283
     /*  7283 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(7320), // Rule ID 23394 //
     /*  7288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  7291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  7303 */     // MIs[1] Operand 1
     /*  7303 */     // No operand predicates
     /*  7303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7305 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  7305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  7308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  7312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  7315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7318 */     GIR_RootConstrainSelectedInstOperands,
     /*  7319 */     // GIR_Coverage, 23394,
     /*  7319 */     GIR_EraseRootFromParent_Done,
     /*  7320 */   // Label 335: @7320
     /*  7320 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(7349), // Rule ID 23296 //
     /*  7325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  7328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7336 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  7336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  7341 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  7347 */     GIR_RootConstrainSelectedInstOperands,
     /*  7348 */     // GIR_Coverage, 23296,
     /*  7348 */     GIR_Done,
     /*  7349 */   // Label 336: @7349
     /*  7349 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(7378), // Rule ID 23386 //
     /*  7354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  7357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  7365 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  7365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  7370 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  7376 */     GIR_RootConstrainSelectedInstOperands,
     /*  7377 */     // GIR_Coverage, 23386,
     /*  7377 */     GIR_Done,
     /*  7378 */   // Label 337: @7378
     /*  7378 */   GIM_Reject,
     /*  7379 */ // Label 330: @7379
     /*  7379 */ GIM_Reject,
     /*  7380 */ // Label 300: @7380
     /*  7380 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(8565),
     /*  7385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  7388 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(7465), // Rule ID 25440 //
     /*  7393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  7428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7440 */     // MIs[2] src
     /*  7440 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7445 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  7449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7451 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  7454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7463 */     GIR_RootConstrainSelectedInstOperands,
     /*  7464 */     // GIR_Coverage, 25440,
     /*  7464 */     GIR_EraseRootFromParent_Done,
     /*  7465 */   // Label 339: @7465
     /*  7465 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(7542), // Rule ID 25452 //
     /*  7470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  7505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7517 */     // MIs[2] src
     /*  7517 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7522 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  7526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7528 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  7531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7540 */     GIR_RootConstrainSelectedInstOperands,
     /*  7541 */     // GIR_Coverage, 25452,
     /*  7541 */     GIR_EraseRootFromParent_Done,
     /*  7542 */   // Label 340: @7542
     /*  7542 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(7619), // Rule ID 17803 //
     /*  7547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  7582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7594 */     // MIs[2] src
     /*  7594 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  7603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7605 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  7608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7617 */     GIR_RootConstrainSelectedInstOperands,
     /*  7618 */     // GIR_Coverage, 17803,
     /*  7618 */     GIR_EraseRootFromParent_Done,
     /*  7619 */   // Label 341: @7619
     /*  7619 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(7696), // Rule ID 17815 //
     /*  7624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  7642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  7659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  7663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  7671 */     // MIs[2] src
     /*  7671 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  7680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  7682 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  7685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7694 */     GIR_RootConstrainSelectedInstOperands,
     /*  7695 */     // GIR_Coverage, 17815,
     /*  7695 */     GIR_EraseRootFromParent_Done,
     /*  7696 */   // Label 342: @7696
     /*  7696 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(7754), // Rule ID 25434 //
     /*  7701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7729 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  7733 */     // MIs[0] src
     /*  7733 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  7738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7740 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  7743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  7749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7752 */     GIR_RootConstrainSelectedInstOperands,
     /*  7753 */     // GIR_Coverage, 25434,
     /*  7753 */     GIR_EraseRootFromParent_Done,
     /*  7754 */   // Label 343: @7754
     /*  7754 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(7863), // Rule ID 26487 //
     /*  7759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  7770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  7774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  7782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  7786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  7791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7797 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  7797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  7800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  7804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  7814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  7838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  7843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  7848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  7851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  7855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7861 */     GIR_RootConstrainSelectedInstOperands,
     /*  7862 */     // GIR_Coverage, 26487,
     /*  7862 */     GIR_EraseRootFromParent_Done,
     /*  7863 */   // Label 344: @7863
     /*  7863 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(7917), // Rule ID 17797 //
     /*  7868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  7871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  7890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  7894 */     // MIs[1] src
     /*  7894 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  7899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  7903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7905 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  7905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  7908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  7912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  7915 */     GIR_RootConstrainSelectedInstOperands,
     /*  7916 */     // GIR_Coverage, 17797,
     /*  7916 */     GIR_EraseRootFromParent_Done,
     /*  7917 */   // Label 345: @7917
     /*  7917 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(8026), // Rule ID 23225 //
     /*  7922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  7925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  7933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  7937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  7941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  7945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  7949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  7953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  7958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  7960 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  7960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  7963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  7967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  7974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  7977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  7981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  7993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  7996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  8001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  8006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  8011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  8014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  8018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8024 */     GIR_RootConstrainSelectedInstOperands,
     /*  8025 */     // GIR_Coverage, 23225,
     /*  8025 */     GIR_EraseRootFromParent_Done,
     /*  8026 */   // Label 346: @8026
     /*  8026 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(8091), // Rule ID 23077 //
     /*  8031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8042 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  8053 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  8053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  8056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  8071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  8076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  8081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  8084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8089 */     GIR_RootConstrainSelectedInstOperands,
     /*  8090 */     // GIR_Coverage, 23077,
     /*  8090 */     GIR_EraseRootFromParent_Done,
     /*  8091 */   // Label 347: @8091
     /*  8091 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(8156), // Rule ID 23078 //
     /*  8096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8107 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  8118 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  8118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  8121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8130 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  8136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  8141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  8146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  8149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8154 */     GIR_RootConstrainSelectedInstOperands,
     /*  8155 */     // GIR_Coverage, 23078,
     /*  8155 */     GIR_EraseRootFromParent_Done,
     /*  8156 */   // Label 348: @8156
     /*  8156 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(8200), // Rule ID 23305 //
     /*  8161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  8164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  8183 */     // MIs[1] Operand 1
     /*  8183 */     // No operand predicates
     /*  8183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8185 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  8185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  8188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  8192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  8195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8198 */     GIR_RootConstrainSelectedInstOperands,
     /*  8199 */     // GIR_Coverage, 23305,
     /*  8199 */     GIR_EraseRootFromParent_Done,
     /*  8200 */   // Label 349: @8200
     /*  8200 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(8244), // Rule ID 23395 //
     /*  8205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  8208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  8227 */     // MIs[1] Operand 1
     /*  8227 */     // No operand predicates
     /*  8227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8229 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  8229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  8232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  8236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  8239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8242 */     GIR_RootConstrainSelectedInstOperands,
     /*  8243 */     // GIR_Coverage, 23395,
     /*  8243 */     GIR_EraseRootFromParent_Done,
     /*  8244 */   // Label 350: @8244
     /*  8244 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(8306), // Rule ID 17991 //
     /*  8249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  8252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8280 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8290 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  8293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  8301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8304 */     GIR_RootConstrainSelectedInstOperands,
     /*  8305 */     // GIR_Coverage, 17991,
     /*  8305 */     GIR_EraseRootFromParent_Done,
     /*  8306 */   // Label 351: @8306
     /*  8306 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(8368), // Rule ID 17995 //
     /*  8311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  8314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8352 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  8363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8366 */     GIR_RootConstrainSelectedInstOperands,
     /*  8367 */     // GIR_Coverage, 17995,
     /*  8367 */     GIR_EraseRootFromParent_Done,
     /*  8368 */   // Label 352: @8368
     /*  8368 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(8430), // Rule ID 25546 //
     /*  8373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  8376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8408 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8414 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  8417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  8425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8428 */     GIR_RootConstrainSelectedInstOperands,
     /*  8429 */     // GIR_Coverage, 25546,
     /*  8429 */     GIR_EraseRootFromParent_Done,
     /*  8430 */   // Label 353: @8430
     /*  8430 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(8492), // Rule ID 25550 //
     /*  8435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  8438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  8453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  8461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  8465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8476 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  8479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  8485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  8487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8490 */     GIR_RootConstrainSelectedInstOperands,
     /*  8491 */     // GIR_Coverage, 25550,
     /*  8491 */     GIR_EraseRootFromParent_Done,
     /*  8492 */   // Label 354: @8492
     /*  8492 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(8528), // Rule ID 23297 //
     /*  8497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  8500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8515 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  8520 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  8526 */     GIR_RootConstrainSelectedInstOperands,
     /*  8527 */     // GIR_Coverage, 23297,
     /*  8527 */     GIR_Done,
     /*  8528 */   // Label 355: @8528
     /*  8528 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(8564), // Rule ID 23387 //
     /*  8533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  8536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  8539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  8551 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  8551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  8556 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  8562 */     GIR_RootConstrainSelectedInstOperands,
     /*  8563 */     // GIR_Coverage, 23387,
     /*  8563 */     GIR_Done,
     /*  8564 */   // Label 356: @8564
     /*  8564 */   GIM_Reject,
     /*  8565 */ // Label 338: @8565
     /*  8565 */ GIM_Reject,
     /*  8566 */ // Label 301: @8566
     /*  8566 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(9629),
     /*  8571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  8574 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(8651), // Rule ID 25441 //
     /*  8579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8610 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  8614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8626 */     // MIs[2] src
     /*  8626 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8631 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  8635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8637 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  8640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8649 */     GIR_RootConstrainSelectedInstOperands,
     /*  8650 */     // GIR_Coverage, 25441,
     /*  8650 */     GIR_EraseRootFromParent_Done,
     /*  8651 */   // Label 358: @8651
     /*  8651 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(8728), // Rule ID 25453 //
     /*  8656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8687 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8703 */     // MIs[2] src
     /*  8703 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  8712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8714 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  8717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8726 */     GIR_RootConstrainSelectedInstOperands,
     /*  8727 */     // GIR_Coverage, 25453,
     /*  8727 */     GIR_EraseRootFromParent_Done,
     /*  8728 */   // Label 359: @8728
     /*  8728 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(8805), // Rule ID 17804 //
     /*  8733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8764 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8780 */     // MIs[2] src
     /*  8780 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8785 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  8789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8791 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  8794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8803 */     GIR_RootConstrainSelectedInstOperands,
     /*  8804 */     // GIR_Coverage, 17804,
     /*  8804 */     GIR_EraseRootFromParent_Done,
     /*  8805 */   // Label 360: @8805
     /*  8805 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(8882), // Rule ID 17816 //
     /*  8810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  8828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  8845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  8849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  8857 */     // MIs[2] src
     /*  8857 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  8866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  8868 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  8871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8880 */     GIR_RootConstrainSelectedInstOperands,
     /*  8881 */     // GIR_Coverage, 17816,
     /*  8881 */     GIR_EraseRootFromParent_Done,
     /*  8882 */   // Label 361: @8882
     /*  8882 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(8940), // Rule ID 25435 //
     /*  8887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  8890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  8902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  8910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8915 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  8919 */     // MIs[0] src
     /*  8919 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  8924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8926 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  8926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  8929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  8935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  8938 */     GIR_RootConstrainSelectedInstOperands,
     /*  8939 */     // GIR_Coverage, 25435,
     /*  8939 */     GIR_EraseRootFromParent_Done,
     /*  8940 */   // Label 362: @8940
     /*  8940 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(9049), // Rule ID 26493 //
     /*  8945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  8948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  8956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  8960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  8964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  8968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  8972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  8977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  8981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  8983 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  8983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  8986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  8990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  8997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  9000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  9004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  9016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  9019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  9034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  9037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  9041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9047 */     GIR_RootConstrainSelectedInstOperands,
     /*  9048 */     // GIR_Coverage, 26493,
     /*  9048 */     GIR_EraseRootFromParent_Done,
     /*  9049 */   // Label 363: @9049
     /*  9049 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(9103), // Rule ID 17798 //
     /*  9054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  9057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  9076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9080 */     // MIs[1] src
     /*  9080 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  9085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  9089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9091 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  9091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  9094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9096 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  9098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9101 */     GIR_RootConstrainSelectedInstOperands,
     /*  9102 */     // GIR_Coverage, 17798,
     /*  9102 */     GIR_EraseRootFromParent_Done,
     /*  9103 */   // Label 364: @9103
     /*  9103 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(9212), // Rule ID 23231 //
     /*  9108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  9127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  9135 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  9139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  9144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9146 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  9146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  9149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  9153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  9160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  9163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  9167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9172 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  9179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  9182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  9192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  9197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  9200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  9204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9210 */     GIR_RootConstrainSelectedInstOperands,
     /*  9211 */     // GIR_Coverage, 23231,
     /*  9211 */     GIR_EraseRootFromParent_Done,
     /*  9212 */   // Label 365: @9212
     /*  9212 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(9260), // Rule ID 23306 //
     /*  9217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  9220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  9239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  9243 */     // MIs[1] Operand 1
     /*  9243 */     // No operand predicates
     /*  9243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9245 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  9245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  9248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  9252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  9255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9258 */     GIR_RootConstrainSelectedInstOperands,
     /*  9259 */     // GIR_Coverage, 23306,
     /*  9259 */     GIR_EraseRootFromParent_Done,
     /*  9260 */   // Label 366: @9260
     /*  9260 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(9308), // Rule ID 23396 //
     /*  9265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  9268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  9287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  9291 */     // MIs[1] Operand 1
     /*  9291 */     // No operand predicates
     /*  9291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9293 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  9293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  9296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  9300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  9303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9306 */     GIR_RootConstrainSelectedInstOperands,
     /*  9307 */     // GIR_Coverage, 23396,
     /*  9307 */     GIR_EraseRootFromParent_Done,
     /*  9308 */   // Label 367: @9308
     /*  9308 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(9370), // Rule ID 17992 //
     /*  9313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  9316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  9327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9344 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9354 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  9357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  9365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9368 */     GIR_RootConstrainSelectedInstOperands,
     /*  9369 */     // GIR_Coverage, 17992,
     /*  9369 */     GIR_EraseRootFromParent_Done,
     /*  9370 */   // Label 368: @9370
     /*  9370 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(9432), // Rule ID 17996 //
     /*  9375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  9378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9416 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  9419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  9427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9430 */     GIR_RootConstrainSelectedInstOperands,
     /*  9431 */     // GIR_Coverage, 17996,
     /*  9431 */     GIR_EraseRootFromParent_Done,
     /*  9432 */   // Label 369: @9432
     /*  9432 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(9494), // Rule ID 25547 //
     /*  9437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  9440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9472 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9478 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  9481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  9489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9492 */     GIR_RootConstrainSelectedInstOperands,
     /*  9493 */     // GIR_Coverage, 25547,
     /*  9493 */     GIR_EraseRootFromParent_Done,
     /*  9494 */   // Label 370: @9494
     /*  9494 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(9556), // Rule ID 25551 //
     /*  9499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  9502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  9525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  9529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9534 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  9538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  9540 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  9543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  9551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  9554 */     GIR_RootConstrainSelectedInstOperands,
     /*  9555 */     // GIR_Coverage, 25551,
     /*  9555 */     GIR_EraseRootFromParent_Done,
     /*  9556 */   // Label 371: @9556
     /*  9556 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(9592), // Rule ID 23298 //
     /*  9561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  9564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9579 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  9584 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  9590 */     GIR_RootConstrainSelectedInstOperands,
     /*  9591 */     // GIR_Coverage, 23298,
     /*  9591 */     GIR_Done,
     /*  9592 */   // Label 372: @9592
     /*  9592 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(9628), // Rule ID 23388 //
     /*  9597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  9600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  9603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  9615 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  9615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  9620 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  9626 */     GIR_RootConstrainSelectedInstOperands,
     /*  9627 */     // GIR_Coverage, 23388,
     /*  9627 */     GIR_Done,
     /*  9628 */   // Label 373: @9628
     /*  9628 */   GIM_Reject,
     /*  9629 */ // Label 357: @9629
     /*  9629 */ GIM_Reject,
     /*  9630 */ // Label 302: @9630
     /*  9630 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(9975),
     /*  9635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  9638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  9641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9645 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(9765), // Rule ID 19936 //
     /*  9650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  9654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  9662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  9666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  9675 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  9681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  9683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  9689 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  9689 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  9692 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9696 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9701 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  9705 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  9713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9726 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  9734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  9738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  9749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  9764 */     // GIR_Coverage, 19936,
     /*  9764 */     GIR_EraseRootFromParent_Done,
     /*  9765 */   // Label 375: @9765
     /*  9765 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(9885), // Rule ID 25813 //
     /*  9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  9799 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  9805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  9807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  9809 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  9809 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  9812 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9816 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9821 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  9825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  9833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  9846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  9854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  9858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9866 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  9869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  9884 */     // GIR_Coverage, 25813,
     /*  9884 */     GIR_EraseRootFromParent_Done,
     /*  9885 */   // Label 376: @9885
     /*  9885 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(9974), // Rule ID 19932 //
     /*  9890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  9898 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  9898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  9901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9910 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  9914 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  9922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  9935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  9940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  9943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  9947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  9958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  9973 */     // GIR_Coverage, 19932,
     /*  9973 */     GIR_EraseRootFromParent_Done,
     /*  9974 */   // Label 377: @9974
     /*  9974 */   GIM_Reject,
     /*  9975 */ // Label 374: @9975
     /*  9975 */ GIM_Reject,
     /*  9976 */ // Label 303: @9976
     /*  9976 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(10069),
     /*  9981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  9987 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(10014), // Rule ID 2107 //
     /*  9992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  9995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  9999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10007 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 10007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 10012 */     GIR_RootConstrainSelectedInstOperands,
     /* 10013 */     // GIR_Coverage, 2107,
     /* 10013 */     GIR_Done,
     /* 10014 */   // Label 379: @10014
     /* 10014 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(10041), // Rule ID 2109 //
     /* 10019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 10022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10034 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 10034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 10039 */     GIR_RootConstrainSelectedInstOperands,
     /* 10040 */     // GIR_Coverage, 2109,
     /* 10040 */     GIR_Done,
     /* 10041 */   // Label 380: @10041
     /* 10041 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(10068), // Rule ID 5701 //
     /* 10046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 10049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10061 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 10061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /* 10066 */     GIR_RootConstrainSelectedInstOperands,
     /* 10067 */     // GIR_Coverage, 5701,
     /* 10067 */     GIR_Done,
     /* 10068 */   // Label 381: @10068
     /* 10068 */   GIM_Reject,
     /* 10069 */ // Label 378: @10069
     /* 10069 */ GIM_Reject,
     /* 10070 */ // Label 304: @10070
     /* 10070 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(10415),
     /* 10075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 10078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 10081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10085 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(10205), // Rule ID 19937 //
     /* 10090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 10094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 10102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 10106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10115 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10129 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 10129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10141 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 10145 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10166 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 10204 */     // GIR_Coverage, 19937,
     /* 10204 */     GIR_EraseRootFromParent_Done,
     /* 10205 */   // Label 383: @10205
     /* 10205 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(10325), // Rule ID 25814 //
     /* 10210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 10218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 10226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 10230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10239 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10249 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 10249 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10252 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10256 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10261 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 10265 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10306 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 10324 */     // GIR_Coverage, 25814,
     /* 10324 */     GIR_EraseRootFromParent_Done,
     /* 10325 */   // Label 384: @10325
     /* 10325 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(10414), // Rule ID 19933 //
     /* 10330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 10338 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 10338 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10341 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10345 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10350 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 10354 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 10375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /* 10387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10392 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 10413 */     // GIR_Coverage, 19933,
     /* 10413 */     GIR_EraseRootFromParent_Done,
     /* 10414 */   // Label 385: @10414
     /* 10414 */   GIM_Reject,
     /* 10415 */ // Label 382: @10415
     /* 10415 */ GIM_Reject,
     /* 10416 */ // Label 305: @10416
     /* 10416 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(10509),
     /* 10421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 10427 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(10454), // Rule ID 5728 //
     /* 10432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 10435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 10447 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 10447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /* 10452 */     GIR_RootConstrainSelectedInstOperands,
     /* 10453 */     // GIR_Coverage, 5728,
     /* 10453 */     GIR_Done,
     /* 10454 */   // Label 387: @10454
     /* 10454 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(10481), // Rule ID 18595 //
     /* 10459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 10462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10474 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 10474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 10479 */     GIR_RootConstrainSelectedInstOperands,
     /* 10480 */     // GIR_Coverage, 18595,
     /* 10480 */     GIR_Done,
     /* 10481 */   // Label 388: @10481
     /* 10481 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(10508), // Rule ID 18619 //
     /* 10486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 10489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 10501 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 10501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 10506 */     GIR_RootConstrainSelectedInstOperands,
     /* 10507 */     // GIR_Coverage, 18619,
     /* 10507 */     GIR_Done,
     /* 10508 */   // Label 389: @10508
     /* 10508 */   GIM_Reject,
     /* 10509 */ // Label 386: @10509
     /* 10509 */ GIM_Reject,
     /* 10510 */ // Label 306: @10510
     /* 10510 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(10603),
     /* 10515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 10518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 10521 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(10548), // Rule ID 2111 //
     /* 10526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 10529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10541 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 10541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 10546 */     GIR_RootConstrainSelectedInstOperands,
     /* 10547 */     // GIR_Coverage, 2111,
     /* 10547 */     GIR_Done,
     /* 10548 */   // Label 391: @10548
     /* 10548 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(10575), // Rule ID 5692 //
     /* 10553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 10556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 10560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 10568 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 10568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /* 10573 */     GIR_RootConstrainSelectedInstOperands,
     /* 10574 */     // GIR_Coverage, 5692,
     /* 10574 */     GIR_Done,
     /* 10575 */   // Label 392: @10575
     /* 10575 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(10602), // Rule ID 18564 //
     /* 10580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 10583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 10595 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 10595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 10600 */     GIR_RootConstrainSelectedInstOperands,
     /* 10601 */     // GIR_Coverage, 18564,
     /* 10601 */     GIR_Done,
     /* 10602 */   // Label 393: @10602
     /* 10602 */   GIM_Reject,
     /* 10603 */ // Label 390: @10603
     /* 10603 */ GIM_Reject,
     /* 10604 */ // Label 307: @10604
     /* 10604 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(11101),
     /* 10609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10619 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(10679), // Rule ID 4428 //
     /* 10624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 10627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 10631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10652 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10658 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10666 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 10666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /* 10669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 10677 */     GIR_RootConstrainSelectedInstOperands,
     /* 10678 */     // GIR_Coverage, 4428,
     /* 10678 */     GIR_EraseRootFromParent_Done,
     /* 10679 */   // Label 395: @10679
     /* 10679 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(10802), // Rule ID 19934 //
     /* 10684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 10687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 10691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10712 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10718 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10726 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 10726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10738 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 10742 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 10801 */     // GIR_Coverage, 19934,
     /* 10801 */     GIR_EraseRootFromParent_Done,
     /* 10802 */   // Label 396: @10802
     /* 10802 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(10862), // Rule ID 24137 //
     /* 10807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 10810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 10818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10839 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10849 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 10849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /* 10852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 10860 */     GIR_RootConstrainSelectedInstOperands,
     /* 10861 */     // GIR_Coverage, 24137,
     /* 10861 */     GIR_EraseRootFromParent_Done,
     /* 10862 */   // Label 397: @10862
     /* 10862 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(10985), // Rule ID 25811 //
     /* 10867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 10870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 10878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 10882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 10886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 10890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 10899 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 10905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 10907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 10909 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 10909 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 10912 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10916 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10921 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 10925 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 10933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 10946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 10951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 10954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 10958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 10969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 10984 */     // GIR_Coverage, 25811,
     /* 10984 */     GIR_EraseRootFromParent_Done,
     /* 10985 */   // Label 398: @10985
     /* 10985 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(11008), // Rule ID 4412 //
     /* 10990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 10993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 10997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 11001 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 11001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /* 11006 */     GIR_RootConstrainSelectedInstOperands,
     /* 11007 */     // GIR_Coverage, 4412,
     /* 11007 */     GIR_Done,
     /* 11008 */   // Label 399: @11008
     /* 11008 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(11100), // Rule ID 19930 //
     /* 11013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 11016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 11020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 11024 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 11024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 11027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11036 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 11040 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 11045 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 11048 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11052 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11057 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 11061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 11066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 11069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /* 11073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 11081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 11084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 11086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 11094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 11099 */     // GIR_Coverage, 19930,
     /* 11099 */     GIR_EraseRootFromParent_Done,
     /* 11100 */   // Label 400: @11100
     /* 11100 */   GIM_Reject,
     /* 11101 */ // Label 394: @11101
     /* 11101 */ GIM_Reject,
     /* 11102 */ // Label 308: @11102
     /* 11102 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(11195),
     /* 11107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 11110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 11113 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(11140), // Rule ID 18594 //
     /* 11118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 11121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11133 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 11133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 11138 */     GIR_RootConstrainSelectedInstOperands,
     /* 11139 */     // GIR_Coverage, 18594,
     /* 11139 */     GIR_Done,
     /* 11140 */   // Label 402: @11140
     /* 11140 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(11167), // Rule ID 18618 //
     /* 11145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 11148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11160 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 11160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 11165 */     GIR_RootConstrainSelectedInstOperands,
     /* 11166 */     // GIR_Coverage, 18618,
     /* 11166 */     GIR_Done,
     /* 11167 */   // Label 403: @11167
     /* 11167 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(11194), // Rule ID 20464 //
     /* 11172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11187 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 11187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /* 11192 */     GIR_RootConstrainSelectedInstOperands,
     /* 11193 */     // GIR_Coverage, 20464,
     /* 11193 */     GIR_Done,
     /* 11194 */   // Label 404: @11194
     /* 11194 */   GIM_Reject,
     /* 11195 */ // Label 401: @11195
     /* 11195 */ GIM_Reject,
     /* 11196 */ // Label 309: @11196
     /* 11196 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(11289),
     /* 11201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 11204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 11207 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(11234), // Rule ID 5719 //
     /* 11212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 11215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11227 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 11227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /* 11232 */     GIR_RootConstrainSelectedInstOperands,
     /* 11233 */     // GIR_Coverage, 5719,
     /* 11233 */     GIR_Done,
     /* 11234 */   // Label 406: @11234
     /* 11234 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(11261), // Rule ID 18539 //
     /* 11239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 11242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11254 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 11254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 11259 */     GIR_RootConstrainSelectedInstOperands,
     /* 11260 */     // GIR_Coverage, 18539,
     /* 11260 */     GIR_Done,
     /* 11261 */   // Label 407: @11261
     /* 11261 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(11288), // Rule ID 18563 //
     /* 11266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 11269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11281 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 11281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 11286 */     GIR_RootConstrainSelectedInstOperands,
     /* 11287 */     // GIR_Coverage, 18563,
     /* 11287 */     GIR_Done,
     /* 11288 */   // Label 408: @11288
     /* 11288 */   GIM_Reject,
     /* 11289 */ // Label 405: @11289
     /* 11289 */ GIM_Reject,
     /* 11290 */ // Label 310: @11290
     /* 11290 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(11323), // Rule ID 5683 //
     /* 11295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 11301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 11304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11316 */   // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 11316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /* 11321 */   GIR_RootConstrainSelectedInstOperands,
     /* 11322 */   // GIR_Coverage, 5683,
     /* 11322 */   GIR_Done,
     /* 11323 */ // Label 409: @11323
     /* 11323 */ GIM_Reject,
     /* 11324 */ // Label 311: @11324
     /* 11324 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(11483),
     /* 11329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 11332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 11335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11339 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(11399), // Rule ID 4429 //
     /* 11344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 11359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 11363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11372 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11386 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 11386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 11389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 11397 */     GIR_RootConstrainSelectedInstOperands,
     /* 11398 */     // GIR_Coverage, 4429,
     /* 11398 */     GIR_EraseRootFromParent_Done,
     /* 11399 */   // Label 411: @11399
     /* 11399 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(11459), // Rule ID 24138 //
     /* 11404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 11415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 11423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 11427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11436 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11446 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 11446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /* 11449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 11457 */     GIR_RootConstrainSelectedInstOperands,
     /* 11458 */     // GIR_Coverage, 24138,
     /* 11458 */     GIR_EraseRootFromParent_Done,
     /* 11459 */   // Label 412: @11459
     /* 11459 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(11482), // Rule ID 4413 //
     /* 11464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 11475 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 11475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /* 11480 */     GIR_RootConstrainSelectedInstOperands,
     /* 11481 */     // GIR_Coverage, 4413,
     /* 11481 */     GIR_Done,
     /* 11482 */   // Label 413: @11482
     /* 11482 */   GIM_Reject,
     /* 11483 */ // Label 410: @11483
     /* 11483 */ GIM_Reject,
     /* 11484 */ // Label 312: @11484
     /* 11484 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(11577),
     /* 11489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 11492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 11495 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(11522), // Rule ID 18593 //
     /* 11500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 11503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11515 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 11515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /* 11520 */     GIR_RootConstrainSelectedInstOperands,
     /* 11521 */     // GIR_Coverage, 18593,
     /* 11521 */     GIR_Done,
     /* 11522 */   // Label 415: @11522
     /* 11522 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(11549), // Rule ID 18617 //
     /* 11527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 11530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 11542 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 11542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /* 11547 */     GIR_RootConstrainSelectedInstOperands,
     /* 11548 */     // GIR_Coverage, 18617,
     /* 11548 */     GIR_Done,
     /* 11549 */   // Label 416: @11549
     /* 11549 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(11576), // Rule ID 20463 //
     /* 11554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 11569 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 11569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /* 11574 */     GIR_RootConstrainSelectedInstOperands,
     /* 11575 */     // GIR_Coverage, 20463,
     /* 11575 */     GIR_Done,
     /* 11576 */   // Label 417: @11576
     /* 11576 */   GIM_Reject,
     /* 11577 */ // Label 414: @11577
     /* 11577 */ GIM_Reject,
     /* 11578 */ // Label 313: @11578
     /* 11578 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(11671),
     /* 11583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 11586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 11589 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(11616), // Rule ID 18538 //
     /* 11594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 11597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11609 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 11609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 11614 */     GIR_RootConstrainSelectedInstOperands,
     /* 11615 */     // GIR_Coverage, 18538,
     /* 11615 */     GIR_Done,
     /* 11616 */   // Label 419: @11616
     /* 11616 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(11643), // Rule ID 18562 //
     /* 11621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 11624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11636 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 11636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 11641 */     GIR_RootConstrainSelectedInstOperands,
     /* 11642 */     // GIR_Coverage, 18562,
     /* 11642 */     GIR_Done,
     /* 11643 */   // Label 420: @11643
     /* 11643 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(11670), // Rule ID 20480 //
     /* 11648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11663 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 11663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /* 11668 */     GIR_RootConstrainSelectedInstOperands,
     /* 11669 */     // GIR_Coverage, 20480,
     /* 11669 */     GIR_Done,
     /* 11670 */   // Label 421: @11670
     /* 11670 */   GIM_Reject,
     /* 11671 */ // Label 418: @11671
     /* 11671 */ GIM_Reject,
     /* 11672 */ // Label 314: @11672
     /* 11672 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(11705), // Rule ID 5710 //
     /* 11677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 11683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 11686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11698 */   // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 11698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /* 11703 */   GIR_RootConstrainSelectedInstOperands,
     /* 11704 */   // GIR_Coverage, 5710,
     /* 11704 */   GIR_Done,
     /* 11705 */ // Label 422: @11705
     /* 11705 */ GIM_Reject,
     /* 11706 */ // Label 315: @11706
     /* 11706 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(11865),
     /* 11711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 11714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 11717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11721 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(11781), // Rule ID 4430 //
     /* 11726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 11729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 11741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 11745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11768 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 11768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /* 11771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11777 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 11779 */     GIR_RootConstrainSelectedInstOperands,
     /* 11780 */     // GIR_Coverage, 4430,
     /* 11780 */     GIR_EraseRootFromParent_Done,
     /* 11781 */   // Label 424: @11781
     /* 11781 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(11841), // Rule ID 24139 //
     /* 11786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 11789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 11797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 11801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 11805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 11809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 11818 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 11824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 11826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 11828 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 11828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /* 11831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 11837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 11839 */     GIR_RootConstrainSelectedInstOperands,
     /* 11840 */     // GIR_Coverage, 24139,
     /* 11840 */     GIR_EraseRootFromParent_Done,
     /* 11841 */   // Label 425: @11841
     /* 11841 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(11864), // Rule ID 4414 //
     /* 11846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 11849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 11857 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 11857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /* 11862 */     GIR_RootConstrainSelectedInstOperands,
     /* 11863 */     // GIR_Coverage, 4414,
     /* 11863 */     GIR_Done,
     /* 11864 */   // Label 426: @11864
     /* 11864 */   GIM_Reject,
     /* 11865 */ // Label 423: @11865
     /* 11865 */ GIM_Reject,
     /* 11866 */ // Label 316: @11866
     /* 11866 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(11959),
     /* 11871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 11874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 11877 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(11904), // Rule ID 18537 //
     /* 11882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 11885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11897 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 11897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /* 11902 */     GIR_RootConstrainSelectedInstOperands,
     /* 11903 */     // GIR_Coverage, 18537,
     /* 11903 */     GIR_Done,
     /* 11904 */   // Label 428: @11904
     /* 11904 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(11931), // Rule ID 18561 //
     /* 11909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 11912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 11924 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 11924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /* 11929 */     GIR_RootConstrainSelectedInstOperands,
     /* 11930 */     // GIR_Coverage, 18561,
     /* 11930 */     GIR_Done,
     /* 11931 */   // Label 429: @11931
     /* 11931 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(11958), // Rule ID 20479 //
     /* 11936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 11939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 11951 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 11951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /* 11956 */     GIR_RootConstrainSelectedInstOperands,
     /* 11957 */     // GIR_Coverage, 20479,
     /* 11957 */     GIR_Done,
     /* 11958 */   // Label 430: @11958
     /* 11958 */   GIM_Reject,
     /* 11959 */ // Label 427: @11959
     /* 11959 */ GIM_Reject,
     /* 11960 */ // Label 317: @11960
     /* 11960 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(11993), // Rule ID 20496 //
     /* 11965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 11968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 11971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 11974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 11986 */   // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 11986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /* 11991 */   GIR_RootConstrainSelectedInstOperands,
     /* 11992 */   // GIR_Coverage, 20496,
     /* 11992 */   GIR_Done,
     /* 11993 */ // Label 431: @11993
     /* 11993 */ GIM_Reject,
     /* 11994 */ // Label 318: @11994
     /* 11994 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(12153),
     /* 11999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 12002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 12005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12009 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(12069), // Rule ID 4431 //
     /* 12014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 12017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 12025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 12029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 12033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 12042 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 12048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 12050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 12056 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 12056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /* 12059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 12065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 12067 */     GIR_RootConstrainSelectedInstOperands,
     /* 12068 */     // GIR_Coverage, 4431,
     /* 12068 */     GIR_EraseRootFromParent_Done,
     /* 12069 */   // Label 433: @12069
     /* 12069 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(12129), // Rule ID 24140 //
     /* 12074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 12077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 12089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 12093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 12097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 12106 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 12112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 12114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 12116 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /* 12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 12125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 12127 */     GIR_RootConstrainSelectedInstOperands,
     /* 12128 */     // GIR_Coverage, 24140,
     /* 12128 */     GIR_EraseRootFromParent_Done,
     /* 12129 */   // Label 434: @12129
     /* 12129 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(12152), // Rule ID 4415 //
     /* 12134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 12137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 12145 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 12145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /* 12150 */     GIR_RootConstrainSelectedInstOperands,
     /* 12151 */     // GIR_Coverage, 4415,
     /* 12151 */     GIR_Done,
     /* 12152 */   // Label 435: @12152
     /* 12152 */   GIM_Reject,
     /* 12153 */ // Label 432: @12153
     /* 12153 */ GIM_Reject,
     /* 12154 */ // Label 319: @12154
     /* 12154 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(12187), // Rule ID 20495 //
     /* 12159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 12162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 12165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 12168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 12172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 12176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 12180 */   // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 12180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /* 12185 */   GIR_RootConstrainSelectedInstOperands,
     /* 12186 */   // GIR_Coverage, 20495,
     /* 12186 */   GIR_Done,
     /* 12187 */ // Label 436: @12187
     /* 12187 */ GIM_Reject,
     /* 12188 */ // Label 320: @12188
     /* 12188 */ GIM_Reject,
     /* 12189 */ // Label 4: @12189
     /* 12189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 460*/ GIMT_Encode4(16580),
     /* 12200 */ /*GILLT_s1*//*Label 437*/ GIMT_Encode4(12300),
     /* 12204 */ /*GILLT_s8*//*Label 438*/ GIMT_Encode4(12400),
     /* 12208 */ /*GILLT_s16*//*Label 439*/ GIMT_Encode4(12537),
     /* 12212 */ /*GILLT_s32*//*Label 440*/ GIMT_Encode4(12890),
     /* 12216 */ /*GILLT_s64*//*Label 441*/ GIMT_Encode4(14074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 12228 */ /*GILLT_v2s1*//*Label 442*/ GIMT_Encode4(15266),
     /* 12232 */ /*GILLT_v2s64*//*Label 443*/ GIMT_Encode4(15366),
     /* 12236 */ /*GILLT_v4s1*//*Label 444*/ GIMT_Encode4(15460),
     /* 12240 */ /*GILLT_v4s32*//*Label 445*/ GIMT_Encode4(15560),
     /* 12244 */ /*GILLT_v4s64*//*Label 446*/ GIMT_Encode4(15654),
     /* 12248 */ /*GILLT_v8s1*//*Label 447*/ GIMT_Encode4(15748),
     /* 12252 */ /*GILLT_v8s16*//*Label 448*/ GIMT_Encode4(15872),
     /* 12256 */ /*GILLT_v8s32*//*Label 449*/ GIMT_Encode4(15966),
     /* 12260 */ /*GILLT_v8s64*//*Label 450*/ GIMT_Encode4(16060),
     /* 12264 */ /*GILLT_v16s1*//*Label 451*/ GIMT_Encode4(16094),
     /* 12268 */ /*GILLT_v16s8*//*Label 452*/ GIMT_Encode4(16128),
     /* 12272 */ /*GILLT_v16s16*//*Label 453*/ GIMT_Encode4(16222),
     /* 12276 */ /*GILLT_v16s32*//*Label 454*/ GIMT_Encode4(16316),
     /* 12280 */ /*GILLT_v32s1*//*Label 455*/ GIMT_Encode4(16350),
     /* 12284 */ /*GILLT_v32s8*//*Label 456*/ GIMT_Encode4(16384),
     /* 12288 */ /*GILLT_v32s16*//*Label 457*/ GIMT_Encode4(16478),
     /* 12292 */ /*GILLT_v64s1*//*Label 458*/ GIMT_Encode4(16512),
     /* 12296 */ /*GILLT_v64s8*//*Label 459*/ GIMT_Encode4(16546),
     /* 12300 */ // Label 437: @12300
     /* 12300 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(12399), // Rule ID 19939 //
     /* 12305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 12308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 12311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 12315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 12319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 12323 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 12323 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 12326 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 12330 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12335 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 12339 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 12344 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 12347 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 12351 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12356 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 12360 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 12365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 12368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 12372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 12380 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 12383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 12385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 12388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 12393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 12398 */   // GIR_Coverage, 19939,
     /* 12398 */   GIR_EraseRootFromParent_Done,
     /* 12399 */ // Label 461: @12399
     /* 12399 */ GIM_Reject,
     /* 12400 */ // Label 438: @12400
     /* 12400 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(12536),
     /* 12405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 12408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 12411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12419 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(12452), // Rule ID 23279 //
     /* 12424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12435 */     // MIs[1] Operand 1
     /* 12435 */     // No operand predicates
     /* 12435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12437 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 12437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /* 12440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12450 */     GIR_RootConstrainSelectedInstOperands,
     /* 12451 */     // GIR_Coverage, 23279,
     /* 12451 */     GIR_EraseRootFromParent_Done,
     /* 12452 */   // Label 463: @12452
     /* 12452 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(12485), // Rule ID 23369 //
     /* 12457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12468 */     // MIs[1] Operand 1
     /* 12468 */     // No operand predicates
     /* 12468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12470 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 12470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /* 12473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12475 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12483 */     GIR_RootConstrainSelectedInstOperands,
     /* 12484 */     // GIR_Coverage, 23369,
     /* 12484 */     GIR_EraseRootFromParent_Done,
     /* 12485 */   // Label 464: @12485
     /* 12485 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(12510), // Rule ID 23271 //
     /* 12490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12497 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 12497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /* 12502 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12508 */     GIR_RootConstrainSelectedInstOperands,
     /* 12509 */     // GIR_Coverage, 23271,
     /* 12509 */     GIR_Done,
     /* 12510 */   // Label 465: @12510
     /* 12510 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(12535), // Rule ID 23361 //
     /* 12515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12522 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 12522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /* 12527 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12533 */     GIR_RootConstrainSelectedInstOperands,
     /* 12534 */     // GIR_Coverage, 23361,
     /* 12534 */     GIR_Done,
     /* 12535 */   // Label 466: @12535
     /* 12535 */   GIM_Reject,
     /* 12536 */ // Label 462: @12536
     /* 12536 */ GIM_Reject,
     /* 12537 */ // Label 439: @12537
     /* 12537 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(12889),
     /* 12542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 12545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 12548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12552 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(12654), // Rule ID 26482 //
     /* 12557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 12565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 12569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 12573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 12577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12588 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 12588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 12591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 12595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 12602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 12605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 12609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 12617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 12621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 12624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 12629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 12634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 12639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /* 12642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 12646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 12649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12652 */     GIR_RootConstrainSelectedInstOperands,
     /* 12653 */     // GIR_Coverage, 26482,
     /* 12653 */     GIR_EraseRootFromParent_Done,
     /* 12654 */   // Label 468: @12654
     /* 12654 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(12756), // Rule ID 23220 //
     /* 12659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 12671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 12675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 12679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 12683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 12688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12690 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 12690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 12693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 12697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 12704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 12707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 12711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 12716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 12719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 12723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 12726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 12731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 12736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 12741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /* 12744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 12751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12754 */     GIR_RootConstrainSelectedInstOperands,
     /* 12755 */     // GIR_Coverage, 23220,
     /* 12755 */     GIR_EraseRootFromParent_Done,
     /* 12756 */   // Label 469: @12756
     /* 12756 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(12793), // Rule ID 23280 //
     /* 12761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12776 */     // MIs[1] Operand 1
     /* 12776 */     // No operand predicates
     /* 12776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12778 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 12778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /* 12781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12791 */     GIR_RootConstrainSelectedInstOperands,
     /* 12792 */     // GIR_Coverage, 23280,
     /* 12792 */     GIR_EraseRootFromParent_Done,
     /* 12793 */   // Label 470: @12793
     /* 12793 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(12830), // Rule ID 23370 //
     /* 12798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 12809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 12813 */     // MIs[1] Operand 1
     /* 12813 */     // No operand predicates
     /* 12813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 12815 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 12815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /* 12818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 12822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 12825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12828 */     GIR_RootConstrainSelectedInstOperands,
     /* 12829 */     // GIR_Coverage, 23370,
     /* 12829 */     GIR_EraseRootFromParent_Done,
     /* 12830 */   // Label 471: @12830
     /* 12830 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(12859), // Rule ID 23272 //
     /* 12835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 12838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12846 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 12846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /* 12851 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12857 */     GIR_RootConstrainSelectedInstOperands,
     /* 12858 */     // GIR_Coverage, 23272,
     /* 12858 */     GIR_Done,
     /* 12859 */   // Label 472: @12859
     /* 12859 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(12888), // Rule ID 23362 //
     /* 12864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 12867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 12875 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 12875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /* 12880 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 12886 */     GIR_RootConstrainSelectedInstOperands,
     /* 12887 */     // GIR_Coverage, 23362,
     /* 12887 */     GIR_Done,
     /* 12888 */   // Label 473: @12888
     /* 12888 */   GIM_Reject,
     /* 12889 */ // Label 467: @12889
     /* 12889 */ GIM_Reject,
     /* 12890 */ // Label 440: @12890
     /* 12890 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(14073),
     /* 12895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 12898 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(12975), // Rule ID 25448 //
     /* 12903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 12906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 12913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 12921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 12925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 12929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 12934 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 12938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 12942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 12946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 12950 */     // MIs[2] src
     /* 12950 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 12955 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 12959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 12961 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 12961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /* 12964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 12966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 12970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 12973 */     GIR_RootConstrainSelectedInstOperands,
     /* 12974 */     // GIR_Coverage, 25448,
     /* 12974 */     GIR_EraseRootFromParent_Done,
     /* 12975 */   // Label 475: @12975
     /* 12975 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(13052), // Rule ID 25450 //
     /* 12980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 12983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 12990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 12994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 12998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 13015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 13019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13027 */     // MIs[2] src
     /* 13027 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13032 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 13036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13038 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /* 13041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13050 */     GIR_RootConstrainSelectedInstOperands,
     /* 13051 */     // GIR_Coverage, 25450,
     /* 13051 */     GIR_EraseRootFromParent_Done,
     /* 13052 */   // Label 476: @13052
     /* 13052 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(13130), // Rule ID 25436 //
     /* 13057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 13084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 13092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 13105 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13109 */     // MIs[0] src
     /* 13109 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13116 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 13125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13128 */     GIR_RootConstrainSelectedInstOperands,
     /* 13129 */     // GIR_Coverage, 25436,
     /* 13129 */     GIR_EraseRootFromParent_Done,
     /* 13130 */   // Label 477: @13130
     /* 13130 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(13207), // Rule ID 17811 //
     /* 13135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 13174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13182 */     // MIs[2] src
     /* 13182 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13187 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 13191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13193 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /* 13196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13205 */     GIR_RootConstrainSelectedInstOperands,
     /* 13206 */     // GIR_Coverage, 17811,
     /* 13206 */     GIR_EraseRootFromParent_Done,
     /* 13207 */   // Label 478: @13207
     /* 13207 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(13284), // Rule ID 17813 //
     /* 13212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 13251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13259 */     // MIs[2] src
     /* 13259 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 13268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13270 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /* 13273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13282 */     GIR_RootConstrainSelectedInstOperands,
     /* 13283 */     // GIR_Coverage, 17813,
     /* 13283 */     GIR_EraseRootFromParent_Done,
     /* 13284 */   // Label 479: @13284
     /* 13284 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(13358), // Rule ID 17799 //
     /* 13289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 13311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 13323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 13331 */     // MIs[2] src
     /* 13331 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13336 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 13340 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 13346 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13356 */     GIR_RootConstrainSelectedInstOperands,
     /* 13357 */     // GIR_Coverage, 17799,
     /* 13357 */     GIR_EraseRootFromParent_Done,
     /* 13358 */   // Label 480: @13358
     /* 13358 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(13416), // Rule ID 25444 //
     /* 13363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13391 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 13395 */     // MIs[0] src
     /* 13395 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13402 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /* 13405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13414 */     GIR_RootConstrainSelectedInstOperands,
     /* 13415 */     // GIR_Coverage, 25444,
     /* 13415 */     GIR_EraseRootFromParent_Done,
     /* 13416 */   // Label 481: @13416
     /* 13416 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(13474), // Rule ID 25446 //
     /* 13421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13453 */     // MIs[0] src
     /* 13453 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 13458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13460 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /* 13463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 13469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13472 */     GIR_RootConstrainSelectedInstOperands,
     /* 13473 */     // GIR_Coverage, 25446,
     /* 13473 */     GIR_EraseRootFromParent_Done,
     /* 13474 */   // Label 482: @13474
     /* 13474 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(13583), // Rule ID 26488 //
     /* 13479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 13502 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 13506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 13511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13517 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 13517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 13520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 13524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 13531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 13534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 13538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 13546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 13550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 13553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 13568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /* 13571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 13575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 13578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13581 */     GIR_RootConstrainSelectedInstOperands,
     /* 13582 */     // GIR_Coverage, 26488,
     /* 13582 */     GIR_EraseRootFromParent_Done,
     /* 13583 */   // Label 483: @13583
     /* 13583 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(13641), // Rule ID 25438 //
     /* 13588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 13599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 13603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 13615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13620 */     // MIs[0] src
     /* 13620 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 13625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13627 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /* 13636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13639 */     GIR_RootConstrainSelectedInstOperands,
     /* 13640 */     // GIR_Coverage, 25438,
     /* 13640 */     GIR_EraseRootFromParent_Done,
     /* 13641 */   // Label 484: @13641
     /* 13641 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(13695), // Rule ID 17807 //
     /* 13646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13672 */     // MIs[1] src
     /* 13672 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13677 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 13681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13683 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /* 13686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13693 */     GIR_RootConstrainSelectedInstOperands,
     /* 13694 */     // GIR_Coverage, 17807,
     /* 13694 */     GIR_EraseRootFromParent_Done,
     /* 13695 */   // Label 485: @13695
     /* 13695 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(13749), // Rule ID 17809 //
     /* 13700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 13722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 13726 */     // MIs[1] src
     /* 13726 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 13735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13737 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /* 13740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13747 */     GIR_RootConstrainSelectedInstOperands,
     /* 13748 */     // GIR_Coverage, 17809,
     /* 13748 */     GIR_EraseRootFromParent_Done,
     /* 13749 */   // Label 486: @13749
     /* 13749 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(13858), // Rule ID 23226 //
     /* 13754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 13781 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 13785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 13790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13792 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 13792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 13795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 13799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 13806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 13809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 13813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 13818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 13821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 13825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 13828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 13838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 13843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /* 13846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 13850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 13853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13856 */     GIR_RootConstrainSelectedInstOperands,
     /* 13857 */     // GIR_Coverage, 23226,
     /* 13857 */     GIR_EraseRootFromParent_Done,
     /* 13858 */   // Label 487: @13858
     /* 13858 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(13912), // Rule ID 17801 //
     /* 13863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 13866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 13885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 13889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 13893 */     // MIs[1] src
     /* 13893 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 13898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13900 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 13900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /* 13903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 13907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13910 */     GIR_RootConstrainSelectedInstOperands,
     /* 13911 */     // GIR_Coverage, 17801,
     /* 13911 */     GIR_EraseRootFromParent_Done,
     /* 13912 */   // Label 488: @13912
     /* 13912 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(13956), // Rule ID 23281 //
     /* 13917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 13920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13939 */     // MIs[1] Operand 1
     /* 13939 */     // No operand predicates
     /* 13939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13941 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 13941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /* 13944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 13948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 13951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13954 */     GIR_RootConstrainSelectedInstOperands,
     /* 13955 */     // GIR_Coverage, 23281,
     /* 13955 */     GIR_EraseRootFromParent_Done,
     /* 13956 */   // Label 489: @13956
     /* 13956 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(14000), // Rule ID 23371 //
     /* 13961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 13964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 13975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 13979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13983 */     // MIs[1] Operand 1
     /* 13983 */     // No operand predicates
     /* 13983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 13985 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 13985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /* 13988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 13990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 13992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 13995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 13998 */     GIR_RootConstrainSelectedInstOperands,
     /* 13999 */     // GIR_Coverage, 23371,
     /* 13999 */     GIR_EraseRootFromParent_Done,
     /* 14000 */   // Label 490: @14000
     /* 14000 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(14036), // Rule ID 23273 //
     /* 14005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 14008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 14011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14023 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 14023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /* 14028 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 14034 */     GIR_RootConstrainSelectedInstOperands,
     /* 14035 */     // GIR_Coverage, 23273,
     /* 14035 */     GIR_Done,
     /* 14036 */   // Label 491: @14036
     /* 14036 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(14072), // Rule ID 23363 //
     /* 14041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 14044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 14047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 14059 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 14059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /* 14064 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 14070 */     GIR_RootConstrainSelectedInstOperands,
     /* 14071 */     // GIR_Coverage, 23363,
     /* 14071 */     GIR_Done,
     /* 14072 */   // Label 492: @14072
     /* 14072 */   GIM_Reject,
     /* 14073 */ // Label 474: @14073
     /* 14073 */ GIM_Reject,
     /* 14074 */ // Label 441: @14074
     /* 14074 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(15265),
     /* 14079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 14082 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(14159), // Rule ID 25449 //
     /* 14087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14134 */     // MIs[2] src
     /* 14134 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14139 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 14143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14145 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /* 14148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14157 */     GIR_RootConstrainSelectedInstOperands,
     /* 14158 */     // GIR_Coverage, 25449,
     /* 14158 */     GIR_EraseRootFromParent_Done,
     /* 14159 */   // Label 494: @14159
     /* 14159 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(14236), // Rule ID 25451 //
     /* 14164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 14199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14211 */     // MIs[2] src
     /* 14211 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14216 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 14220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14222 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /* 14225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14234 */     GIR_RootConstrainSelectedInstOperands,
     /* 14235 */     // GIR_Coverage, 25451,
     /* 14235 */     GIR_EraseRootFromParent_Done,
     /* 14236 */   // Label 495: @14236
     /* 14236 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(14314), // Rule ID 25437 //
     /* 14241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 14268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14285 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 14289 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14293 */     // MIs[0] src
     /* 14293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 14298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14300 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 14303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 14309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14312 */     GIR_RootConstrainSelectedInstOperands,
     /* 14313 */     // GIR_Coverage, 25437,
     /* 14313 */     GIR_EraseRootFromParent_Done,
     /* 14314 */   // Label 496: @14314
     /* 14314 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(14391), // Rule ID 17812 //
     /* 14319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14366 */     // MIs[2] src
     /* 14366 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14371 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /* 14375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14377 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /* 14380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14389 */     GIR_RootConstrainSelectedInstOperands,
     /* 14390 */     // GIR_Coverage, 17812,
     /* 14390 */     GIR_EraseRootFromParent_Done,
     /* 14391 */   // Label 497: @14391
     /* 14391 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(14468), // Rule ID 17814 //
     /* 14396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14427 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 14435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14443 */     // MIs[2] src
     /* 14443 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14448 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 14452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14454 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /* 14457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14466 */     GIR_RootConstrainSelectedInstOperands,
     /* 14467 */     // GIR_Coverage, 17814,
     /* 14467 */     GIR_EraseRootFromParent_Done,
     /* 14468 */   // Label 498: @14468
     /* 14468 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(14542), // Rule ID 17800 //
     /* 14473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 14495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 14507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14515 */     // MIs[2] src
     /* 14515 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 14520 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 14524 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 14530 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 14533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 14537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14540 */     GIR_RootConstrainSelectedInstOperands,
     /* 14541 */     // GIR_Coverage, 17800,
     /* 14541 */     GIR_EraseRootFromParent_Done,
     /* 14542 */   // Label 499: @14542
     /* 14542 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(14600), // Rule ID 25445 //
     /* 14547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 14579 */     // MIs[0] src
     /* 14579 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14586 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /* 14589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14598 */     GIR_RootConstrainSelectedInstOperands,
     /* 14599 */     // GIR_Coverage, 25445,
     /* 14599 */     GIR_EraseRootFromParent_Done,
     /* 14600 */   // Label 500: @14600
     /* 14600 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(14658), // Rule ID 25447 //
     /* 14605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14633 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14637 */     // MIs[0] src
     /* 14637 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 14642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14644 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /* 14647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 14653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14656 */     GIR_RootConstrainSelectedInstOperands,
     /* 14657 */     // GIR_Coverage, 25447,
     /* 14657 */     GIR_EraseRootFromParent_Done,
     /* 14658 */   // Label 501: @14658
     /* 14658 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(14767), // Rule ID 26494 //
     /* 14663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 14686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 14690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 14695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14701 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 14701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 14704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 14708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 14713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 14715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 14718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 14722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 14727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 14730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 14734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 14737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 14742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 14747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 14752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /* 14755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 14759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 14762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14765 */     GIR_RootConstrainSelectedInstOperands,
     /* 14766 */     // GIR_Coverage, 26494,
     /* 14766 */     GIR_EraseRootFromParent_Done,
     /* 14767 */   // Label 502: @14767
     /* 14767 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(14825), // Rule ID 25439 //
     /* 14772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14795 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 14799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14804 */     // MIs[0] src
     /* 14804 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14811 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 14814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /* 14820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14823 */     GIR_RootConstrainSelectedInstOperands,
     /* 14824 */     // GIR_Coverage, 25439,
     /* 14824 */     GIR_EraseRootFromParent_Done,
     /* 14825 */   // Label 503: @14825
     /* 14825 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(14879), // Rule ID 17808 //
     /* 14830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14856 */     // MIs[1] src
     /* 14856 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 14861 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 14865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14867 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /* 14870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14872 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 14874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14877 */     GIR_RootConstrainSelectedInstOperands,
     /* 14878 */     // GIR_Coverage, 17808,
     /* 14878 */     GIR_EraseRootFromParent_Done,
     /* 14879 */   // Label 504: @14879
     /* 14879 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(14933), // Rule ID 17810 //
     /* 14884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 14887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 14906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14910 */     // MIs[1] src
     /* 14910 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 14915 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 14919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14921 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 14921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /* 14924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 14926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 14928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 14931 */     GIR_RootConstrainSelectedInstOperands,
     /* 14932 */     // GIR_Coverage, 17810,
     /* 14932 */     GIR_EraseRootFromParent_Done,
     /* 14933 */   // Label 505: @14933
     /* 14933 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(15042), // Rule ID 23232 //
     /* 14938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 14941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 14949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 14953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 14961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 14965 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 14969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 14974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14976 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 14976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 14979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 14983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 14988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 14990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 14993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 14997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 15009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 15012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 15017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 15022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 15027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /* 15030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 15034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15040 */     GIR_RootConstrainSelectedInstOperands,
     /* 15041 */     // GIR_Coverage, 23232,
     /* 15041 */     GIR_EraseRootFromParent_Done,
     /* 15042 */   // Label 506: @15042
     /* 15042 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(15096), // Rule ID 17802 //
     /* 15047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 15050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 15073 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /* 15077 */     // MIs[1] src
     /* 15077 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15084 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 15084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /* 15087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 15091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15094 */     GIR_RootConstrainSelectedInstOperands,
     /* 15095 */     // GIR_Coverage, 17802,
     /* 15095 */     GIR_EraseRootFromParent_Done,
     /* 15096 */   // Label 507: @15096
     /* 15096 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(15144), // Rule ID 23282 //
     /* 15101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 15104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 15127 */     // MIs[1] Operand 1
     /* 15127 */     // No operand predicates
     /* 15127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15129 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 15129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /* 15132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15134 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 15136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 15139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15142 */     GIR_RootConstrainSelectedInstOperands,
     /* 15143 */     // GIR_Coverage, 23282,
     /* 15143 */     GIR_EraseRootFromParent_Done,
     /* 15144 */   // Label 508: @15144
     /* 15144 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(15192), // Rule ID 23372 //
     /* 15149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 15152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 15175 */     // MIs[1] Operand 1
     /* 15175 */     // No operand predicates
     /* 15175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15177 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 15177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /* 15180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 15184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 15187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 15190 */     GIR_RootConstrainSelectedInstOperands,
     /* 15191 */     // GIR_Coverage, 23372,
     /* 15191 */     GIR_EraseRootFromParent_Done,
     /* 15192 */   // Label 509: @15192
     /* 15192 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(15228), // Rule ID 23274 //
     /* 15197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 15200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15215 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /* 15220 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 15226 */     GIR_RootConstrainSelectedInstOperands,
     /* 15227 */     // GIR_Coverage, 23274,
     /* 15227 */     GIR_Done,
     /* 15228 */   // Label 510: @15228
     /* 15228 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(15264), // Rule ID 23364 //
     /* 15233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 15236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 15239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 15251 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 15251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /* 15256 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 15262 */     GIR_RootConstrainSelectedInstOperands,
     /* 15263 */     // GIR_Coverage, 23364,
     /* 15263 */     GIR_Done,
     /* 15264 */   // Label 511: @15264
     /* 15264 */   GIM_Reject,
     /* 15265 */ // Label 493: @15265
     /* 15265 */ GIM_Reject,
     /* 15266 */ // Label 442: @15266
     /* 15266 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(15365), // Rule ID 19940 //
     /* 15271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 15274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 15277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 15281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 15285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 15289 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 15289 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 15292 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15296 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15301 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 15305 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 15313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 15326 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 15334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 15338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15343 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15346 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 15349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 15351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 15364 */   // GIR_Coverage, 19940,
     /* 15364 */   GIR_EraseRootFromParent_Done,
     /* 15365 */ // Label 512: @15365
     /* 15365 */ GIM_Reject,
     /* 15366 */ // Label 443: @15366
     /* 15366 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(15459),
     /* 15371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 15374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 15377 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(15404), // Rule ID 2113 //
     /* 15382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 15385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15397 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 15397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 15402 */     GIR_RootConstrainSelectedInstOperands,
     /* 15403 */     // GIR_Coverage, 2113,
     /* 15403 */     GIR_Done,
     /* 15404 */   // Label 514: @15404
     /* 15404 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(15431), // Rule ID 2115 //
     /* 15409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 15412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15424 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 15424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 15429 */     GIR_RootConstrainSelectedInstOperands,
     /* 15430 */     // GIR_Coverage, 2115,
     /* 15430 */     GIR_Done,
     /* 15431 */   // Label 515: @15431
     /* 15431 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(15458), // Rule ID 5755 //
     /* 15436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15451 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 15451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /* 15456 */     GIR_RootConstrainSelectedInstOperands,
     /* 15457 */     // GIR_Coverage, 5755,
     /* 15457 */     GIR_Done,
     /* 15458 */   // Label 516: @15458
     /* 15458 */   GIM_Reject,
     /* 15459 */ // Label 513: @15459
     /* 15459 */ GIM_Reject,
     /* 15460 */ // Label 444: @15460
     /* 15460 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(15559), // Rule ID 19941 //
     /* 15465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 15468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 15471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 15475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 15479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 15483 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 15483 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 15486 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15490 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15495 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 15499 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15504 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 15507 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15511 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15516 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 15520 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 15528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 15532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15540 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 15543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 15545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 15558 */   // GIR_Coverage, 19941,
     /* 15558 */   GIR_EraseRootFromParent_Done,
     /* 15559 */ // Label 517: @15559
     /* 15559 */ GIM_Reject,
     /* 15560 */ // Label 445: @15560
     /* 15560 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(15653),
     /* 15565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 15568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 15571 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(15598), // Rule ID 5782 //
     /* 15576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15591 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 15591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /* 15596 */     GIR_RootConstrainSelectedInstOperands,
     /* 15597 */     // GIR_Coverage, 5782,
     /* 15597 */     GIR_Done,
     /* 15598 */   // Label 519: @15598
     /* 15598 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(15625), // Rule ID 18598 //
     /* 15603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 15606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15618 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 15618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 15623 */     GIR_RootConstrainSelectedInstOperands,
     /* 15624 */     // GIR_Coverage, 18598,
     /* 15624 */     GIR_Done,
     /* 15625 */   // Label 520: @15625
     /* 15625 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(15652), // Rule ID 18622 //
     /* 15630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 15633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15645 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 15645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 15650 */     GIR_RootConstrainSelectedInstOperands,
     /* 15651 */     // GIR_Coverage, 18622,
     /* 15651 */     GIR_Done,
     /* 15652 */   // Label 521: @15652
     /* 15652 */   GIM_Reject,
     /* 15653 */ // Label 518: @15653
     /* 15653 */ GIM_Reject,
     /* 15654 */ // Label 446: @15654
     /* 15654 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(15747),
     /* 15659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 15662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 15665 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(15692), // Rule ID 2117 //
     /* 15670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 15673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15685 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 15685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 15690 */     GIR_RootConstrainSelectedInstOperands,
     /* 15691 */     // GIR_Coverage, 2117,
     /* 15691 */     GIR_Done,
     /* 15692 */   // Label 523: @15692
     /* 15692 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(15719), // Rule ID 5746 //
     /* 15697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15712 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 15712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /* 15717 */     GIR_RootConstrainSelectedInstOperands,
     /* 15718 */     // GIR_Coverage, 5746,
     /* 15718 */     GIR_Done,
     /* 15719 */   // Label 524: @15719
     /* 15719 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(15746), // Rule ID 18568 //
     /* 15724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 15727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 15739 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 15739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 15744 */     GIR_RootConstrainSelectedInstOperands,
     /* 15745 */     // GIR_Coverage, 18568,
     /* 15745 */     GIR_Done,
     /* 15746 */   // Label 525: @15746
     /* 15746 */   GIM_Reject,
     /* 15747 */ // Label 522: @15747
     /* 15747 */ GIM_Reject,
     /* 15748 */ // Label 447: @15748
     /* 15748 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(15871),
     /* 15753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 15756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 15759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 15763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 15767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 15771 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(15786), // Rule ID 4416 //
     /* 15776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 15779 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 15779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /* 15784 */     GIR_RootConstrainSelectedInstOperands,
     /* 15785 */     // GIR_Coverage, 4416,
     /* 15785 */     GIR_Done,
     /* 15786 */   // Label 527: @15786
     /* 15786 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(15870), // Rule ID 19938 //
     /* 15791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 15794 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 15794 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 15797 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15801 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15806 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 15810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 15818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 15831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 15836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 15839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 15843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 15848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 15851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 15854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 15856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 15859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 15861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 15869 */     // GIR_Coverage, 19938,
     /* 15869 */     GIR_EraseRootFromParent_Done,
     /* 15870 */   // Label 528: @15870
     /* 15870 */   GIM_Reject,
     /* 15871 */ // Label 526: @15871
     /* 15871 */ GIM_Reject,
     /* 15872 */ // Label 448: @15872
     /* 15872 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(15965),
     /* 15877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 15880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 15883 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(15910), // Rule ID 18597 //
     /* 15888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 15891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15903 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 15903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 15908 */     GIR_RootConstrainSelectedInstOperands,
     /* 15909 */     // GIR_Coverage, 18597,
     /* 15909 */     GIR_Done,
     /* 15910 */   // Label 530: @15910
     /* 15910 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(15937), // Rule ID 18621 //
     /* 15915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 15918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 15930 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 15930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 15935 */     GIR_RootConstrainSelectedInstOperands,
     /* 15936 */     // GIR_Coverage, 18621,
     /* 15936 */     GIR_Done,
     /* 15937 */   // Label 531: @15937
     /* 15937 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(15964), // Rule ID 20466 //
     /* 15942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 15945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 15957 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 15957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /* 15962 */     GIR_RootConstrainSelectedInstOperands,
     /* 15963 */     // GIR_Coverage, 20466,
     /* 15963 */     GIR_Done,
     /* 15964 */   // Label 532: @15964
     /* 15964 */   GIM_Reject,
     /* 15965 */ // Label 529: @15965
     /* 15965 */ GIM_Reject,
     /* 15966 */ // Label 449: @15966
     /* 15966 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(16059),
     /* 15971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 15974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 15977 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(16004), // Rule ID 5773 //
     /* 15982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 15985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 15997 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 15997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /* 16002 */     GIR_RootConstrainSelectedInstOperands,
     /* 16003 */     // GIR_Coverage, 5773,
     /* 16003 */     GIR_Done,
     /* 16004 */   // Label 534: @16004
     /* 16004 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(16031), // Rule ID 18542 //
     /* 16009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 16012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16024 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 16024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 16029 */     GIR_RootConstrainSelectedInstOperands,
     /* 16030 */     // GIR_Coverage, 18542,
     /* 16030 */     GIR_Done,
     /* 16031 */   // Label 535: @16031
     /* 16031 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(16058), // Rule ID 18567 //
     /* 16036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 16039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16051 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 16051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 16056 */     GIR_RootConstrainSelectedInstOperands,
     /* 16057 */     // GIR_Coverage, 18567,
     /* 16057 */     GIR_Done,
     /* 16058 */   // Label 536: @16058
     /* 16058 */   GIM_Reject,
     /* 16059 */ // Label 533: @16059
     /* 16059 */ GIM_Reject,
     /* 16060 */ // Label 450: @16060
     /* 16060 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(16093), // Rule ID 5737 //
     /* 16065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 16071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 16074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16086 */   // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 16086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /* 16091 */   GIR_RootConstrainSelectedInstOperands,
     /* 16092 */   // GIR_Coverage, 5737,
     /* 16092 */   GIR_Done,
     /* 16093 */ // Label 537: @16093
     /* 16093 */ GIM_Reject,
     /* 16094 */ // Label 451: @16094
     /* 16094 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(16127), // Rule ID 4417 //
     /* 16099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 16105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 16108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 16112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 16116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 16120 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 16120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /* 16125 */   GIR_RootConstrainSelectedInstOperands,
     /* 16126 */   // GIR_Coverage, 4417,
     /* 16126 */   GIR_Done,
     /* 16127 */ // Label 538: @16127
     /* 16127 */ GIM_Reject,
     /* 16128 */ // Label 452: @16128
     /* 16128 */ GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(16221),
     /* 16133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 16136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 16139 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(16166), // Rule ID 18596 //
     /* 16144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 16147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16159 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 16159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /* 16164 */     GIR_RootConstrainSelectedInstOperands,
     /* 16165 */     // GIR_Coverage, 18596,
     /* 16165 */     GIR_Done,
     /* 16166 */   // Label 540: @16166
     /* 16166 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(16193), // Rule ID 18620 //
     /* 16171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 16174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 16186 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 16186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /* 16191 */     GIR_RootConstrainSelectedInstOperands,
     /* 16192 */     // GIR_Coverage, 18620,
     /* 16192 */     GIR_Done,
     /* 16193 */   // Label 541: @16193
     /* 16193 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(16220), // Rule ID 20465 //
     /* 16198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 16201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 16205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 16209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 16213 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 16213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /* 16218 */     GIR_RootConstrainSelectedInstOperands,
     /* 16219 */     // GIR_Coverage, 20465,
     /* 16219 */     GIR_Done,
     /* 16220 */   // Label 542: @16220
     /* 16220 */   GIM_Reject,
     /* 16221 */ // Label 539: @16221
     /* 16221 */ GIM_Reject,
     /* 16222 */ // Label 453: @16222
     /* 16222 */ GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(16315),
     /* 16227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 16230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 16233 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(16260), // Rule ID 18541 //
     /* 16238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 16241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16253 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 16253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 16258 */     GIR_RootConstrainSelectedInstOperands,
     /* 16259 */     // GIR_Coverage, 18541,
     /* 16259 */     GIR_Done,
     /* 16260 */   // Label 544: @16260
     /* 16260 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(16287), // Rule ID 18566 //
     /* 16265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 16268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16280 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 16280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 16285 */     GIR_RootConstrainSelectedInstOperands,
     /* 16286 */     // GIR_Coverage, 18566,
     /* 16286 */     GIR_Done,
     /* 16287 */   // Label 545: @16287
     /* 16287 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(16314), // Rule ID 20482 //
     /* 16292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 16295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16307 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 16307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /* 16312 */     GIR_RootConstrainSelectedInstOperands,
     /* 16313 */     // GIR_Coverage, 20482,
     /* 16313 */     GIR_Done,
     /* 16314 */   // Label 546: @16314
     /* 16314 */   GIM_Reject,
     /* 16315 */ // Label 543: @16315
     /* 16315 */ GIM_Reject,
     /* 16316 */ // Label 454: @16316
     /* 16316 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(16349), // Rule ID 5764 //
     /* 16321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 16327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 16330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16342 */   // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 16342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /* 16347 */   GIR_RootConstrainSelectedInstOperands,
     /* 16348 */   // GIR_Coverage, 5764,
     /* 16348 */   GIR_Done,
     /* 16349 */ // Label 547: @16349
     /* 16349 */ GIM_Reject,
     /* 16350 */ // Label 455: @16350
     /* 16350 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(16383), // Rule ID 4418 //
     /* 16355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 16358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 16361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 16364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 16368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 16372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 16376 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 16376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /* 16381 */   GIR_RootConstrainSelectedInstOperands,
     /* 16382 */   // GIR_Coverage, 4418,
     /* 16382 */   GIR_Done,
     /* 16383 */ // Label 548: @16383
     /* 16383 */ GIM_Reject,
     /* 16384 */ // Label 456: @16384
     /* 16384 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(16477),
     /* 16389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 16392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 16395 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(16422), // Rule ID 18540 //
     /* 16400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 16403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16415 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 16415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /* 16420 */     GIR_RootConstrainSelectedInstOperands,
     /* 16421 */     // GIR_Coverage, 18540,
     /* 16421 */     GIR_Done,
     /* 16422 */   // Label 550: @16422
     /* 16422 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(16449), // Rule ID 18565 //
     /* 16427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 16430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 16442 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 16442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /* 16447 */     GIR_RootConstrainSelectedInstOperands,
     /* 16448 */     // GIR_Coverage, 18565,
     /* 16448 */     GIR_Done,
     /* 16449 */   // Label 551: @16449
     /* 16449 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(16476), // Rule ID 20481 //
     /* 16454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 16457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 16469 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 16469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /* 16474 */     GIR_RootConstrainSelectedInstOperands,
     /* 16475 */     // GIR_Coverage, 20481,
     /* 16475 */     GIR_Done,
     /* 16476 */   // Label 552: @16476
     /* 16476 */   GIM_Reject,
     /* 16477 */ // Label 549: @16477
     /* 16477 */ GIM_Reject,
     /* 16478 */ // Label 457: @16478
     /* 16478 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(16511), // Rule ID 20498 //
     /* 16483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 16489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 16492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16504 */   // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 16504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /* 16509 */   GIR_RootConstrainSelectedInstOperands,
     /* 16510 */   // GIR_Coverage, 20498,
     /* 16510 */   GIR_Done,
     /* 16511 */ // Label 553: @16511
     /* 16511 */ GIM_Reject,
     /* 16512 */ // Label 458: @16512
     /* 16512 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(16545), // Rule ID 4419 //
     /* 16517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 16520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 16523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 16526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 16530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 16534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 16538 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 16538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /* 16543 */   GIR_RootConstrainSelectedInstOperands,
     /* 16544 */   // GIR_Coverage, 4419,
     /* 16544 */   GIR_Done,
     /* 16545 */ // Label 554: @16545
     /* 16545 */ GIM_Reject,
     /* 16546 */ // Label 459: @16546
     /* 16546 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(16579), // Rule ID 20497 //
     /* 16551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 16554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 16557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 16560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 16572 */   // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 16572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /* 16577 */   GIR_RootConstrainSelectedInstOperands,
     /* 16578 */   // GIR_Coverage, 20497,
     /* 16578 */   GIR_Done,
     /* 16579 */ // Label 555: @16579
     /* 16579 */ GIM_Reject,
     /* 16580 */ // Label 460: @16580
     /* 16580 */ GIM_Reject,
     /* 16581 */ // Label 5: @16581
     /* 16581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 579*/ GIMT_Encode4(25027),
     /* 16592 */ /*GILLT_s1*//*Label 556*/ GIMT_Encode4(16692),
     /* 16596 */ /*GILLT_s8*//*Label 557*/ GIMT_Encode4(17250),
     /* 16600 */ /*GILLT_s16*//*Label 558*/ GIMT_Encode4(17453),
     /* 16604 */ /*GILLT_s32*//*Label 559*/ GIMT_Encode4(17898),
     /* 16608 */ /*GILLT_s64*//*Label 560*/ GIMT_Encode4(18511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 16620 */ /*GILLT_v2s1*//*Label 561*/ GIMT_Encode4(19083),
     /* 16624 */ /*GILLT_v2s64*//*Label 562*/ GIMT_Encode4(19625),
     /* 16628 */ /*GILLT_v4s1*//*Label 563*/ GIMT_Encode4(19997),
     /* 16632 */ /*GILLT_v4s32*//*Label 564*/ GIMT_Encode4(20539),
     /* 16636 */ /*GILLT_v4s64*//*Label 565*/ GIMT_Encode4(20911),
     /* 16640 */ /*GILLT_v8s1*//*Label 566*/ GIMT_Encode4(21283),
     /* 16644 */ /*GILLT_v8s16*//*Label 567*/ GIMT_Encode4(22081),
     /* 16648 */ /*GILLT_v8s32*//*Label 568*/ GIMT_Encode4(22453),
     /* 16652 */ /*GILLT_v8s64*//*Label 569*/ GIMT_Encode4(22825),
     /* 16656 */ /*GILLT_v16s1*//*Label 570*/ GIMT_Encode4(22903),
     /* 16660 */ /*GILLT_v16s8*//*Label 571*/ GIMT_Encode4(23161),
     /* 16664 */ /*GILLT_v16s16*//*Label 572*/ GIMT_Encode4(23533),
     /* 16668 */ /*GILLT_v16s32*//*Label 573*/ GIMT_Encode4(23905),
     /* 16672 */ /*GILLT_v32s1*//*Label 574*/ GIMT_Encode4(23983),
     /* 16676 */ /*GILLT_v32s8*//*Label 575*/ GIMT_Encode4(24241),
     /* 16680 */ /*GILLT_v32s16*//*Label 576*/ GIMT_Encode4(24613),
     /* 16684 */ /*GILLT_v64s1*//*Label 577*/ GIMT_Encode4(24691),
     /* 16688 */ /*GILLT_v64s8*//*Label 578*/ GIMT_Encode4(24949),
     /* 16692 */ // Label 556: @16692
     /* 16692 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17249),
     /* 16697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 16700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 16703 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(16827), // Rule ID 25817 //
     /* 16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16737 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 16743 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 16745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16751 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 16751 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 16754 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16758 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16763 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 16767 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 16775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16784 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 16788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 16796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 16800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16808 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 16811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 16818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 16826 */     // GIR_Coverage, 25817,
     /* 16826 */     GIR_EraseRootFromParent_Done,
     /* 16827 */   // Label 581: @16827
     /* 16827 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(16952), // Rule ID 19943 //
     /* 16832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 16844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 16848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 16852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 16872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 16874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16876 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 16876 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 16879 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16883 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16888 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 16892 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16897 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 16900 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16904 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16909 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 16913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 16918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 16921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 16925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 16936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 16941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 16943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 16951 */     // GIR_Coverage, 19943,
     /* 16951 */     GIR_EraseRootFromParent_Done,
     /* 16952 */   // Label 582: @16952
     /* 16952 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17076), // Rule ID 25818 //
     /* 16957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 16969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 16973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 16977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 16981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 16986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16990 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 16996 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 16998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17000 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 17000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 17003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17012 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 17016 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 17024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17033 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 17037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 17045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 17049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 17060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 17075 */     // GIR_Coverage, 25818,
     /* 17075 */     GIR_EraseRootFromParent_Done,
     /* 17076 */   // Label 583: @17076
     /* 17076 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(17155), // Rule ID 19929 //
     /* 17081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 17085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 17099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 17101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17103 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 17103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 17106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 17119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 17127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 17131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17136 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 17154 */     // GIR_Coverage, 19929,
     /* 17154 */     GIR_EraseRootFromParent_Done,
     /* 17155 */   // Label 584: @17155
     /* 17155 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(17248), // Rule ID 19947 //
     /* 17160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 17172 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /* 17172 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 17175 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17179 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17184 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 17188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 17196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17205 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 17209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 17214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 17217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 17221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 17232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 17247 */     // GIR_Coverage, 19947,
     /* 17247 */     GIR_EraseRootFromParent_Done,
     /* 17248 */   // Label 585: @17248
     /* 17248 */   GIM_Reject,
     /* 17249 */ // Label 580: @17249
     /* 17249 */ GIM_Reject,
     /* 17250 */ // Label 557: @17250
     /* 17250 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(17452),
     /* 17255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 17258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 17261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17269 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(17293), // Rule ID 23044 //
     /* 17274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /* 17278 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /* 17278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /* 17281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /* 17288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17291 */     GIR_RootConstrainSelectedInstOperands,
     /* 17292 */     // GIR_Coverage, 23044,
     /* 17292 */     GIR_EraseRootFromParent_Done,
     /* 17293 */   // Label 587: @17293
     /* 17293 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(17314), // Rule ID 243 //
     /* 17298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17305 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /* 17305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /* 17308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17312 */     GIR_RootConstrainSelectedInstOperands,
     /* 17313 */     // GIR_Coverage, 243,
     /* 17313 */     GIR_EraseRootFromParent_Done,
     /* 17314 */   // Label 588: @17314
     /* 17314 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(17335), // Rule ID 251 //
     /* 17319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 17322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17326 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /* 17326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /* 17329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17333 */     GIR_RootConstrainSelectedInstOperands,
     /* 17334 */     // GIR_Coverage, 251,
     /* 17334 */     GIR_EraseRootFromParent_Done,
     /* 17335 */   // Label 589: @17335
     /* 17335 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(17368), // Rule ID 23291 //
     /* 17340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17351 */     // MIs[1] Operand 1
     /* 17351 */     // No operand predicates
     /* 17351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17353 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 17353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /* 17356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17366 */     GIR_RootConstrainSelectedInstOperands,
     /* 17367 */     // GIR_Coverage, 23291,
     /* 17367 */     GIR_EraseRootFromParent_Done,
     /* 17368 */   // Label 590: @17368
     /* 17368 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(17401), // Rule ID 23381 //
     /* 17373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17384 */     // MIs[1] Operand 1
     /* 17384 */     // No operand predicates
     /* 17384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17386 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 17386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /* 17389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17399 */     GIR_RootConstrainSelectedInstOperands,
     /* 17400 */     // GIR_Coverage, 23381,
     /* 17400 */     GIR_EraseRootFromParent_Done,
     /* 17401 */   // Label 591: @17401
     /* 17401 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(17426), // Rule ID 23283 //
     /* 17406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17413 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 17413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /* 17418 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17424 */     GIR_RootConstrainSelectedInstOperands,
     /* 17425 */     // GIR_Coverage, 23283,
     /* 17425 */     GIR_Done,
     /* 17426 */   // Label 592: @17426
     /* 17426 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(17451), // Rule ID 23373 //
     /* 17431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17438 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 17438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /* 17443 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17449 */     GIR_RootConstrainSelectedInstOperands,
     /* 17450 */     // GIR_Coverage, 23373,
     /* 17450 */     GIR_Done,
     /* 17451 */   // Label 593: @17451
     /* 17451 */   GIM_Reject,
     /* 17452 */ // Label 586: @17452
     /* 17452 */ GIM_Reject,
     /* 17453 */ // Label 558: @17453
     /* 17453 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(17897),
     /* 17458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 17461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 17464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17468 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(17510), // Rule ID 23045 //
     /* 17473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17477 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /* 17488 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /* 17488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /* 17491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17495 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /* 17505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17508 */     GIR_RootConstrainSelectedInstOperands,
     /* 17509 */     // GIR_Coverage, 23045,
     /* 17509 */     GIR_EraseRootFromParent_Done,
     /* 17510 */   // Label 595: @17510
     /* 17510 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(17612), // Rule ID 26483 //
     /* 17515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 17523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 17527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 17531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 17535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17546 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 17546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 17549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 17553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 17560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 17563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 17567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 17579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 17582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 17587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 17592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 17597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /* 17600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17602 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 17604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17610 */     GIR_RootConstrainSelectedInstOperands,
     /* 17611 */     // GIR_Coverage, 26483,
     /* 17611 */     GIR_EraseRootFromParent_Done,
     /* 17612 */   // Label 596: @17612
     /* 17612 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(17714), // Rule ID 23221 //
     /* 17617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 17629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 17633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 17637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 17641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 17646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17648 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 17648 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 17651 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 17655 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 17662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 17665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 17669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17674 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 17677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 17681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 17684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 17689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 17694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 17699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /* 17702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17712 */     GIR_RootConstrainSelectedInstOperands,
     /* 17713 */     // GIR_Coverage, 23221,
     /* 17713 */     GIR_EraseRootFromParent_Done,
     /* 17714 */   // Label 597: @17714
     /* 17714 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(17739), // Rule ID 244 //
     /* 17719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17730 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 17730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /* 17733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17737 */     GIR_RootConstrainSelectedInstOperands,
     /* 17738 */     // GIR_Coverage, 244,
     /* 17738 */     GIR_EraseRootFromParent_Done,
     /* 17739 */   // Label 598: @17739
     /* 17739 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(17764), // Rule ID 252 //
     /* 17744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 17747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 17755 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 17755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /* 17758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17762 */     GIR_RootConstrainSelectedInstOperands,
     /* 17763 */     // GIR_Coverage, 252,
     /* 17763 */     GIR_EraseRootFromParent_Done,
     /* 17764 */   // Label 599: @17764
     /* 17764 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(17801), // Rule ID 23292 //
     /* 17769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17784 */     // MIs[1] Operand 1
     /* 17784 */     // No operand predicates
     /* 17784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17786 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 17786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /* 17789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17799 */     GIR_RootConstrainSelectedInstOperands,
     /* 17800 */     // GIR_Coverage, 23292,
     /* 17800 */     GIR_EraseRootFromParent_Done,
     /* 17801 */   // Label 600: @17801
     /* 17801 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(17838), // Rule ID 23382 //
     /* 17806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17821 */     // MIs[1] Operand 1
     /* 17821 */     // No operand predicates
     /* 17821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17823 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /* 17823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /* 17826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 17833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17836 */     GIR_RootConstrainSelectedInstOperands,
     /* 17837 */     // GIR_Coverage, 23382,
     /* 17837 */     GIR_EraseRootFromParent_Done,
     /* 17838 */   // Label 601: @17838
     /* 17838 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(17867), // Rule ID 23284 //
     /* 17843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 17846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17854 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 17854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /* 17859 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17865 */     GIR_RootConstrainSelectedInstOperands,
     /* 17866 */     // GIR_Coverage, 23284,
     /* 17866 */     GIR_Done,
     /* 17867 */   // Label 602: @17867
     /* 17867 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(17896), // Rule ID 23374 //
     /* 17872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 17875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 17883 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 17883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /* 17888 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 17894 */     GIR_RootConstrainSelectedInstOperands,
     /* 17895 */     // GIR_Coverage, 23374,
     /* 17895 */     GIR_Done,
     /* 17896 */   // Label 603: @17896
     /* 17896 */   GIM_Reject,
     /* 17897 */ // Label 594: @17897
     /* 17897 */ GIM_Reject,
     /* 17898 */ // Label 559: @17898
     /* 17898 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(18510),
     /* 17903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 17906 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(17955), // Rule ID 23046 //
     /* 17911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 17914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17922 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /* 17933 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /* 17933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /* 17936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 17938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 17940 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /* 17950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 17953 */     GIR_RootConstrainSelectedInstOperands,
     /* 17954 */     // GIR_Coverage, 23046,
     /* 17954 */     GIR_EraseRootFromParent_Done,
     /* 17955 */   // Label 605: @17955
     /* 17955 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(18013), // Rule ID 25442 //
     /* 17960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 17963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 17975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 17979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 17988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 17992 */     // MIs[0] src
     /* 17992 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 17997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17999 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 17999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /* 18002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 18008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18011 */     GIR_RootConstrainSelectedInstOperands,
     /* 18012 */     // GIR_Coverage, 25442,
     /* 18012 */     GIR_EraseRootFromParent_Done,
     /* 18013 */   // Label 606: @18013
     /* 18013 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(18122), // Rule ID 26489 //
     /* 18018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 18037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18056 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 18059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 18073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /* 18110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 18114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18120 */     GIR_RootConstrainSelectedInstOperands,
     /* 18121 */     // GIR_Coverage, 26489,
     /* 18121 */     GIR_EraseRootFromParent_Done,
     /* 18122 */   // Label 607: @18122
     /* 18122 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(18176), // Rule ID 17805 //
     /* 18127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 18130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 18149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 18153 */     // MIs[1] src
     /* 18153 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 18158 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 18162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18164 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 18164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /* 18167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 18171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18174 */     GIR_RootConstrainSelectedInstOperands,
     /* 18175 */     // GIR_Coverage, 17805,
     /* 18175 */     GIR_EraseRootFromParent_Done,
     /* 18176 */   // Label 608: @18176
     /* 18176 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18285), // Rule ID 23227 //
     /* 18181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 18204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18208 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18219 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 18222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 18236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 18265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /* 18273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18283 */     GIR_RootConstrainSelectedInstOperands,
     /* 18284 */     // GIR_Coverage, 23227,
     /* 18284 */     GIR_EraseRootFromParent_Done,
     /* 18285 */   // Label 609: @18285
     /* 18285 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18317), // Rule ID 245 //
     /* 18290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18308 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 18308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /* 18311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18315 */     GIR_RootConstrainSelectedInstOperands,
     /* 18316 */     // GIR_Coverage, 245,
     /* 18316 */     GIR_EraseRootFromParent_Done,
     /* 18317 */   // Label 610: @18317
     /* 18317 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18349), // Rule ID 253 //
     /* 18322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 18325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18340 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 18340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /* 18343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18347 */     GIR_RootConstrainSelectedInstOperands,
     /* 18348 */     // GIR_Coverage, 253,
     /* 18348 */     GIR_EraseRootFromParent_Done,
     /* 18349 */   // Label 611: @18349
     /* 18349 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18393), // Rule ID 23293 //
     /* 18354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18376 */     // MIs[1] Operand 1
     /* 18376 */     // No operand predicates
     /* 18376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18378 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 18378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /* 18381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 18388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18391 */     GIR_RootConstrainSelectedInstOperands,
     /* 18392 */     // GIR_Coverage, 23293,
     /* 18392 */     GIR_EraseRootFromParent_Done,
     /* 18393 */   // Label 612: @18393
     /* 18393 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18437), // Rule ID 23383 //
     /* 18398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 18401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18420 */     // MIs[1] Operand 1
     /* 18420 */     // No operand predicates
     /* 18420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18422 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /* 18422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /* 18425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 18432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18435 */     GIR_RootConstrainSelectedInstOperands,
     /* 18436 */     // GIR_Coverage, 23383,
     /* 18436 */     GIR_EraseRootFromParent_Done,
     /* 18437 */   // Label 613: @18437
     /* 18437 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18473), // Rule ID 23285 //
     /* 18442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18460 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 18460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /* 18465 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 18471 */     GIR_RootConstrainSelectedInstOperands,
     /* 18472 */     // GIR_Coverage, 23285,
     /* 18472 */     GIR_Done,
     /* 18473 */   // Label 614: @18473
     /* 18473 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(18509), // Rule ID 23375 //
     /* 18478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 18481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 18496 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 18496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /* 18501 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 18507 */     GIR_RootConstrainSelectedInstOperands,
     /* 18508 */     // GIR_Coverage, 23375,
     /* 18508 */     GIR_Done,
     /* 18509 */   // Label 615: @18509
     /* 18509 */   GIM_Reject,
     /* 18510 */ // Label 604: @18510
     /* 18510 */ GIM_Reject,
     /* 18511 */ // Label 560: @18511
     /* 18511 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(19082),
     /* 18516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 18519 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(18577), // Rule ID 25443 //
     /* 18524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 18527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 18539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 18543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 18547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 18556 */     // MIs[0] src
     /* 18556 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 18561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18563 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 18563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /* 18566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 18572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18575 */     GIR_RootConstrainSelectedInstOperands,
     /* 18576 */     // GIR_Coverage, 25443,
     /* 18576 */     GIR_EraseRootFromParent_Done,
     /* 18577 */   // Label 617: @18577
     /* 18577 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(18686), // Rule ID 26495 //
     /* 18582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 18601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18620 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 18623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 18637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /* 18674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 18678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18684 */     GIR_RootConstrainSelectedInstOperands,
     /* 18685 */     // GIR_Coverage, 26495,
     /* 18685 */     GIR_EraseRootFromParent_Done,
     /* 18686 */   // Label 618: @18686
     /* 18686 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(18740), // Rule ID 17806 //
     /* 18691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /* 18694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 18713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 18717 */     // MIs[1] src
     /* 18717 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 18722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 18726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18728 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /* 18728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /* 18731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 18735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18738 */     GIR_RootConstrainSelectedInstOperands,
     /* 18739 */     // GIR_Coverage, 17806,
     /* 18739 */     GIR_EraseRootFromParent_Done,
     /* 18740 */   // Label 619: @18740
     /* 18740 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(18849), // Rule ID 23233 //
     /* 18745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 18764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 18768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /* 18772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /* 18776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 18781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18783 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 18783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 18786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 18790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 18797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 18800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 18804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 18809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 18812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 18816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 18819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 18829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 18834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /* 18837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 18844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18847 */     GIR_RootConstrainSelectedInstOperands,
     /* 18848 */     // GIR_Coverage, 23233,
     /* 18848 */     GIR_EraseRootFromParent_Done,
     /* 18849 */   // Label 620: @18849
     /* 18849 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(18881), // Rule ID 246 //
     /* 18854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18872 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 18872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /* 18875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18879 */     GIR_RootConstrainSelectedInstOperands,
     /* 18880 */     // GIR_Coverage, 246,
     /* 18880 */     GIR_EraseRootFromParent_Done,
     /* 18881 */   // Label 621: @18881
     /* 18881 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(18913), // Rule ID 254 //
     /* 18886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 18889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 18904 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 18904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /* 18907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18911 */     GIR_RootConstrainSelectedInstOperands,
     /* 18912 */     // GIR_Coverage, 254,
     /* 18912 */     GIR_EraseRootFromParent_Done,
     /* 18913 */   // Label 622: @18913
     /* 18913 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(18961), // Rule ID 23294 //
     /* 18918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 18921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 18944 */     // MIs[1] Operand 1
     /* 18944 */     // No operand predicates
     /* 18944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18946 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 18946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /* 18949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 18953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 18956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 18959 */     GIR_RootConstrainSelectedInstOperands,
     /* 18960 */     // GIR_Coverage, 23294,
     /* 18960 */     GIR_EraseRootFromParent_Done,
     /* 18961 */   // Label 623: @18961
     /* 18961 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(19009), // Rule ID 23384 //
     /* 18966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 18969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 18972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 18980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 18992 */     // MIs[1] Operand 1
     /* 18992 */     // No operand predicates
     /* 18992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18994 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /* 18994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /* 18997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 18999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 19001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 19004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 19007 */     GIR_RootConstrainSelectedInstOperands,
     /* 19008 */     // GIR_Coverage, 23384,
     /* 19008 */     GIR_EraseRootFromParent_Done,
     /* 19009 */   // Label 624: @19009
     /* 19009 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(19045), // Rule ID 23286 //
     /* 19014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 19017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 19020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19032 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 19032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /* 19037 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 19043 */     GIR_RootConstrainSelectedInstOperands,
     /* 19044 */     // GIR_Coverage, 23286,
     /* 19044 */     GIR_Done,
     /* 19045 */   // Label 625: @19045
     /* 19045 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(19081), // Rule ID 23376 //
     /* 19050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 19053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 19056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 19068 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 19068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /* 19073 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 19079 */     GIR_RootConstrainSelectedInstOperands,
     /* 19080 */     // GIR_Coverage, 23376,
     /* 19080 */     GIR_Done,
     /* 19081 */   // Label 626: @19081
     /* 19081 */   GIM_Reject,
     /* 19082 */ // Label 616: @19082
     /* 19082 */ GIM_Reject,
     /* 19083 */ // Label 561: @19083
     /* 19083 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(19624),
     /* 19088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19098 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19218), // Rule ID 25819 //
     /* 19103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 19111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 19128 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 19136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 19142 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19154 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 19158 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 19179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 19191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19217 */     // GIR_Coverage, 25819,
     /* 19217 */     GIR_EraseRootFromParent_Done,
     /* 19218 */   // Label 628: @19218
     /* 19218 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(19339), // Rule ID 19944 //
     /* 19223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 19231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 19253 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19259 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 19261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 19263 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19275 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 19279 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 19300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 19312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19320 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19338 */     // GIR_Coverage, 19944,
     /* 19338 */     GIR_EraseRootFromParent_Done,
     /* 19339 */   // Label 629: @19339
     /* 19339 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19459), // Rule ID 25820 //
     /* 19344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 19356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 19360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 19364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 19373 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 19381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 19383 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19395 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 19399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 19420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 19432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19458 */     // GIR_Coverage, 25820,
     /* 19458 */     GIR_EraseRootFromParent_Done,
     /* 19459 */   // Label 630: @19459
     /* 19459 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19534), // Rule ID 19928 //
     /* 19464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 19480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19482 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 19510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19533 */     // GIR_Coverage, 19928,
     /* 19533 */     GIR_EraseRootFromParent_Done,
     /* 19534 */   // Label 631: @19534
     /* 19534 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19623), // Rule ID 19948 //
     /* 19539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 19547 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /* 19547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 19550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19559 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 19563 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 19571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 19584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 19589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 19592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 19596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 19607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 19617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 19622 */     // GIR_Coverage, 19948,
     /* 19622 */     GIR_EraseRootFromParent_Done,
     /* 19623 */   // Label 632: @19623
     /* 19623 */   GIM_Reject,
     /* 19624 */ // Label 627: @19624
     /* 19624 */ GIM_Reject,
     /* 19625 */ // Label 562: @19625
     /* 19625 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19996),
     /* 19630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 19633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19636 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19868), // Rule ID 22393 //
     /* 19641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 19644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 19648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 19664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19666 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 19666 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 19669 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 19673 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 19680 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 19683 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 19687 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19692 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 19695 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19699 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 19702 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 19707 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19712 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 19717 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 19720 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 19724 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 19731 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 19734 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 19738 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19743 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 19746 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19750 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 19753 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 19758 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19763 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 19768 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 19771 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 19775 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 19782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 19785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 19789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19794 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 19797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 19801 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 19804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 19809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 19819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 19822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 19826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 19831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 19834 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 19837 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 19840 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 19843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 19845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 19848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 19857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 19862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 19867 */     // GIR_Coverage, 22393,
     /* 19867 */     GIR_EraseRootFromParent_Done,
     /* 19868 */   // Label 634: @19868
     /* 19868 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19914), // Rule ID 22401 //
     /* 19873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 19876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 19894 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 19896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19898 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /* 19898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 19901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 19903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 19905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 19909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 19912 */     GIR_RootConstrainSelectedInstOperands,
     /* 19913 */     // GIR_Coverage, 22401,
     /* 19913 */     GIR_EraseRootFromParent_Done,
     /* 19914 */   // Label 635: @19914
     /* 19914 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19941), // Rule ID 2119 //
     /* 19919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 19922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19934 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 19934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 19939 */     GIR_RootConstrainSelectedInstOperands,
     /* 19940 */     // GIR_Coverage, 2119,
     /* 19940 */     GIR_Done,
     /* 19941 */   // Label 636: @19941
     /* 19941 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19968), // Rule ID 2121 //
     /* 19946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 19949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 19961 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 19961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 19966 */     GIR_RootConstrainSelectedInstOperands,
     /* 19967 */     // GIR_Coverage, 2121,
     /* 19967 */     GIR_Done,
     /* 19968 */   // Label 637: @19968
     /* 19968 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19995), // Rule ID 5809 //
     /* 19973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 19976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 19988 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 19988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /* 19993 */     GIR_RootConstrainSelectedInstOperands,
     /* 19994 */     // GIR_Coverage, 5809,
     /* 19994 */     GIR_Done,
     /* 19995 */   // Label 638: @19995
     /* 19995 */   GIM_Reject,
     /* 19996 */ // Label 633: @19996
     /* 19996 */ GIM_Reject,
     /* 19997 */ // Label 563: @19997
     /* 19997 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(20538),
     /* 20002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20012 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(20132), // Rule ID 25821 //
     /* 20017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 20025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 20042 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 20050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20056 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20068 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 20072 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 20093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 20105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20131 */     // GIR_Coverage, 25821,
     /* 20131 */     GIR_EraseRootFromParent_Done,
     /* 20132 */   // Label 640: @20132
     /* 20132 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(20253), // Rule ID 19945 //
     /* 20137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 20145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 20167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 20175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20177 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20177 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20180 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20184 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20189 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 20193 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 20214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 20226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20252 */     // GIR_Coverage, 19945,
     /* 20252 */     GIR_EraseRootFromParent_Done,
     /* 20253 */   // Label 641: @20253
     /* 20253 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(20373), // Rule ID 25822 //
     /* 20258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 20270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 20274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 20278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 20287 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20293 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 20295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20297 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20309 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 20313 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 20334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 20346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20354 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20372 */     // GIR_Coverage, 25822,
     /* 20372 */     GIR_EraseRootFromParent_Done,
     /* 20373 */   // Label 642: @20373
     /* 20373 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(20448), // Rule ID 19927 //
     /* 20378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20396 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20396 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20399 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20403 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20408 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 20424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20447 */     // GIR_Coverage, 19927,
     /* 20447 */     GIR_EraseRootFromParent_Done,
     /* 20448 */   // Label 643: @20448
     /* 20448 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(20537), // Rule ID 19949 //
     /* 20453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 20461 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /* 20461 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 20464 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20468 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20473 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 20477 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 20485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 20498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 20503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 20506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 20510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20518 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 20521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 20531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 20536 */     // GIR_Coverage, 19949,
     /* 20536 */     GIR_EraseRootFromParent_Done,
     /* 20537 */   // Label 644: @20537
     /* 20537 */   GIM_Reject,
     /* 20538 */ // Label 639: @20538
     /* 20538 */ GIM_Reject,
     /* 20539 */ // Label 564: @20539
     /* 20539 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(20910),
     /* 20544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 20547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20550 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(20782), // Rule ID 22392 //
     /* 20555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 20558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 20562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20570 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20576 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20580 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 20580 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 20583 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20587 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 20594 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 20597 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20601 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20606 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 20609 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20613 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 20616 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20621 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20626 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 20631 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 20634 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20638 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 20645 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 20648 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20652 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20657 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 20660 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20664 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 20667 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20672 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20677 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 20682 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 20685 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20689 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 20696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 20699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20708 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 20711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20715 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 20718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 20733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 20736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 20740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 20748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 20751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 20754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 20757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 20759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 20762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 20771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 20776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20781 */     // GIR_Coverage, 22392,
     /* 20781 */     GIR_EraseRootFromParent_Done,
     /* 20782 */   // Label 646: @20782
     /* 20782 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(20828), // Rule ID 22400 //
     /* 20787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 20790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20802 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20812 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /* 20812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 20815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 20817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 20819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 20821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 20823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 20826 */     GIR_RootConstrainSelectedInstOperands,
     /* 20827 */     // GIR_Coverage, 22400,
     /* 20827 */     GIR_EraseRootFromParent_Done,
     /* 20828 */   // Label 647: @20828
     /* 20828 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(20855), // Rule ID 5836 //
     /* 20833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 20836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 20848 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 20848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /* 20853 */     GIR_RootConstrainSelectedInstOperands,
     /* 20854 */     // GIR_Coverage, 5836,
     /* 20854 */     GIR_Done,
     /* 20855 */   // Label 648: @20855
     /* 20855 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(20882), // Rule ID 18601 //
     /* 20860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 20863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20875 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 20875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 20880 */     GIR_RootConstrainSelectedInstOperands,
     /* 20881 */     // GIR_Coverage, 18601,
     /* 20881 */     GIR_Done,
     /* 20882 */   // Label 649: @20882
     /* 20882 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(20909), // Rule ID 18625 //
     /* 20887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 20890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 20902 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 20902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 20907 */     GIR_RootConstrainSelectedInstOperands,
     /* 20908 */     // GIR_Coverage, 18625,
     /* 20908 */     GIR_Done,
     /* 20909 */   // Label 650: @20909
     /* 20909 */   GIM_Reject,
     /* 20910 */ // Label 645: @20910
     /* 20910 */ GIM_Reject,
     /* 20911 */ // Label 565: @20911
     /* 20911 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(21282),
     /* 20916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 20919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 20922 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(21154), // Rule ID 22397 //
     /* 20927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 20930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 20934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 20938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20942 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 20950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20952 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 20952 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 20955 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 20959 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 20966 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 20969 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 20973 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 20978 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 20981 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 20985 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 20988 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 20993 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 20998 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21003 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 21006 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 21010 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 21017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 21020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 21024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21029 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 21032 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 21036 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 21039 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 21044 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 21049 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 21057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 21061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 21068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 21071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 21075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21080 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 21083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 21087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 21090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 21095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 21100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 21108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 21112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 21123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 21126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 21129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21136 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 21143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 21148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 21153 */     // GIR_Coverage, 22397,
     /* 21153 */     GIR_EraseRootFromParent_Done,
     /* 21154 */   // Label 652: @21154
     /* 21154 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(21200), // Rule ID 22405 //
     /* 21159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 21162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 21182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21184 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /* 21184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 21187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 21198 */     GIR_RootConstrainSelectedInstOperands,
     /* 21199 */     // GIR_Coverage, 22405,
     /* 21199 */     GIR_EraseRootFromParent_Done,
     /* 21200 */   // Label 653: @21200
     /* 21200 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(21227), // Rule ID 2123 //
     /* 21205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 21208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21220 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 21220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 21225 */     GIR_RootConstrainSelectedInstOperands,
     /* 21226 */     // GIR_Coverage, 2123,
     /* 21226 */     GIR_Done,
     /* 21227 */   // Label 654: @21227
     /* 21227 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(21254), // Rule ID 5800 //
     /* 21232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 21235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 21247 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 21247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /* 21252 */     GIR_RootConstrainSelectedInstOperands,
     /* 21253 */     // GIR_Coverage, 5800,
     /* 21253 */     GIR_Done,
     /* 21254 */   // Label 655: @21254
     /* 21254 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(21281), // Rule ID 18572 //
     /* 21259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 21262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 21274 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 21274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 21279 */     GIR_RootConstrainSelectedInstOperands,
     /* 21280 */     // GIR_Coverage, 18572,
     /* 21280 */     GIR_Done,
     /* 21281 */   // Label 656: @21281
     /* 21281 */   GIM_Reject,
     /* 21282 */ // Label 651: @21282
     /* 21282 */ GIM_Reject,
     /* 21283 */ // Label 566: @21283
     /* 21283 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(22080),
     /* 21288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21298 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(21358), // Rule ID 24129 //
     /* 21303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21331 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21345 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /* 21348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 21356 */     GIR_RootConstrainSelectedInstOperands,
     /* 21357 */     // GIR_Coverage, 24129,
     /* 21357 */     GIR_EraseRootFromParent_Done,
     /* 21358 */   // Label 658: @21358
     /* 21358 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(21481), // Rule ID 25815 //
     /* 21363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21391 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21405 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21405 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 21408 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21412 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21417 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 21421 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 21454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 21465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21480 */     // GIR_Coverage, 25815,
     /* 21480 */     GIR_EraseRootFromParent_Done,
     /* 21481 */   // Label 659: @21481
     /* 21481 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(21544), // Rule ID 4420 //
     /* 21486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 21519 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21529 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /* 21532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 21542 */     GIR_RootConstrainSelectedInstOperands,
     /* 21543 */     // GIR_Coverage, 4420,
     /* 21543 */     GIR_EraseRootFromParent_Done,
     /* 21544 */   // Label 660: @21544
     /* 21544 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(21668), // Rule ID 19942 //
     /* 21549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 21582 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21592 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 21595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21604 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 21608 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 21641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 21652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21667 */     // GIR_Coverage, 19942,
     /* 21667 */     GIR_EraseRootFromParent_Done,
     /* 21668 */   // Label 661: @21668
     /* 21668 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(21728), // Rule ID 24130 //
     /* 21673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21705 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21711 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21715 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /* 21718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 21726 */     GIR_RootConstrainSelectedInstOperands,
     /* 21727 */     // GIR_Coverage, 24130,
     /* 21727 */     GIR_EraseRootFromParent_Done,
     /* 21728 */   // Label 662: @21728
     /* 21728 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(21851), // Rule ID 25816 //
     /* 21733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 21748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 21752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 21756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 21765 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 21773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21775 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 21778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21787 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /* 21791 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21808 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 21812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 21824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 21835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21850 */     // GIR_Coverage, 25816,
     /* 21850 */     GIR_EraseRootFromParent_Done,
     /* 21851 */   // Label 663: @21851
     /* 21851 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(21886), // Rule ID 4408 //
     /* 21856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 21875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21877 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /* 21877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /* 21880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 21884 */     GIR_RootConstrainSelectedInstOperands,
     /* 21885 */     // GIR_Coverage, 4408,
     /* 21885 */     GIR_EraseRootFromParent_Done,
     /* 21886 */   // Label 664: @21886
     /* 21886 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(21964), // Rule ID 19926 //
     /* 21891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /* 21894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 21910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21912 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 21912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 21915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 21928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 21933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 21936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 21940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 21945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 21948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 21950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 21953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 21955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 21958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 21963 */     // GIR_Coverage, 19926,
     /* 21963 */     GIR_EraseRootFromParent_Done,
     /* 21964 */   // Label 665: @21964
     /* 21964 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(21987), // Rule ID 4424 //
     /* 21969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 21972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21980 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /* 21980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /* 21985 */     GIR_RootConstrainSelectedInstOperands,
     /* 21986 */     // GIR_Coverage, 4424,
     /* 21986 */     GIR_Done,
     /* 21987 */   // Label 666: @21987
     /* 21987 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(22079), // Rule ID 19946 //
     /* 21992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /* 21995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 21999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 22003 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /* 22003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 22006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22015 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 22019 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 22024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 22027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 22040 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 22045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 22048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 22052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 22060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 22063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 22065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 22073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 22078 */     // GIR_Coverage, 19946,
     /* 22078 */     GIR_EraseRootFromParent_Done,
     /* 22079 */   // Label 667: @22079
     /* 22079 */   GIM_Reject,
     /* 22080 */ // Label 657: @22080
     /* 22080 */ GIM_Reject,
     /* 22081 */ // Label 567: @22081
     /* 22081 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(22452),
     /* 22086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 22089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22092 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(22324), // Rule ID 22391 //
     /* 22097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 22100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 22104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22118 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22122 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 22122 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 22125 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22129 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 22136 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 22139 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22143 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22148 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 22151 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22155 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 22158 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22163 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22168 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 22173 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 22176 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22180 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 22187 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 22190 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22194 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22199 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 22202 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22206 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 22209 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22214 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22219 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 22224 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 22227 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22231 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 22238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 22241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 22253 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 22260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22265 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 22275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 22278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 22282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 22290 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 22293 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 22296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 22299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 22301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22306 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 22313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 22318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22323 */     // GIR_Coverage, 22391,
     /* 22323 */     GIR_EraseRootFromParent_Done,
     /* 22324 */   // Label 669: @22324
     /* 22324 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(22370), // Rule ID 22399 //
     /* 22329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 22332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22354 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /* 22354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 22357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 22368 */     GIR_RootConstrainSelectedInstOperands,
     /* 22369 */     // GIR_Coverage, 22399,
     /* 22369 */     GIR_EraseRootFromParent_Done,
     /* 22370 */   // Label 670: @22370
     /* 22370 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(22397), // Rule ID 18600 //
     /* 22375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 22378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22390 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 22390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 22395 */     GIR_RootConstrainSelectedInstOperands,
     /* 22396 */     // GIR_Coverage, 18600,
     /* 22396 */     GIR_Done,
     /* 22397 */   // Label 671: @22397
     /* 22397 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(22424), // Rule ID 18624 //
     /* 22402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 22405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 22417 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 22417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 22422 */     GIR_RootConstrainSelectedInstOperands,
     /* 22423 */     // GIR_Coverage, 18624,
     /* 22423 */     GIR_Done,
     /* 22424 */   // Label 672: @22424
     /* 22424 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(22451), // Rule ID 20468 //
     /* 22429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 22432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 22444 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 22444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /* 22449 */     GIR_RootConstrainSelectedInstOperands,
     /* 22450 */     // GIR_Coverage, 20468,
     /* 22450 */     GIR_Done,
     /* 22451 */   // Label 673: @22451
     /* 22451 */   GIM_Reject,
     /* 22452 */ // Label 668: @22452
     /* 22452 */ GIM_Reject,
     /* 22453 */ // Label 568: @22453
     /* 22453 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(22824),
     /* 22458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 22461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 22464 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(22696), // Rule ID 22396 //
     /* 22469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 22472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22484 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22494 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 22494 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 22497 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22501 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 22508 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 22511 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22515 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22520 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 22523 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22527 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 22530 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22535 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22540 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22545 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 22548 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22552 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 22559 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 22562 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22566 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22571 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 22574 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22578 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 22581 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22586 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22591 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22596 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 22599 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 22603 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 22610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 22613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 22617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22622 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 22625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 22629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 22632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 22637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 22650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 22654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 22659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 22662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 22665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 22668 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 22671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 22673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 22676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22678 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 22685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 22690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 22695 */     // GIR_Coverage, 22396,
     /* 22695 */     GIR_EraseRootFromParent_Done,
     /* 22696 */   // Label 675: @22696
     /* 22696 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(22742), // Rule ID 22404 //
     /* 22701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 22704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22726 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /* 22726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 22729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 22740 */     GIR_RootConstrainSelectedInstOperands,
     /* 22741 */     // GIR_Coverage, 22404,
     /* 22741 */     GIR_EraseRootFromParent_Done,
     /* 22742 */   // Label 676: @22742
     /* 22742 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(22769), // Rule ID 5827 //
     /* 22747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 22750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 22762 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 22762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /* 22767 */     GIR_RootConstrainSelectedInstOperands,
     /* 22768 */     // GIR_Coverage, 5827,
     /* 22768 */     GIR_Done,
     /* 22769 */   // Label 677: @22769
     /* 22769 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(22796), // Rule ID 18545 //
     /* 22774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 22777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22789 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 22789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 22794 */     GIR_RootConstrainSelectedInstOperands,
     /* 22795 */     // GIR_Coverage, 18545,
     /* 22795 */     GIR_Done,
     /* 22796 */   // Label 678: @22796
     /* 22796 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(22823), // Rule ID 18571 //
     /* 22801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 22804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 22816 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 22816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 22821 */     GIR_RootConstrainSelectedInstOperands,
     /* 22822 */     // GIR_Coverage, 18571,
     /* 22822 */     GIR_Done,
     /* 22823 */   // Label 679: @22823
     /* 22823 */   GIM_Reject,
     /* 22824 */ // Label 674: @22824
     /* 22824 */ GIM_Reject,
     /* 22825 */ // Label 569: @22825
     /* 22825 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(22902),
     /* 22830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 22833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 22836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 22840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 22844 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(22882), // Rule ID 22389 //
     /* 22849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 22856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 22864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 22866 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /* 22866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 22869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 22877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 22880 */     GIR_RootConstrainSelectedInstOperands,
     /* 22881 */     // GIR_Coverage, 22389,
     /* 22881 */     GIR_EraseRootFromParent_Done,
     /* 22882 */   // Label 681: @22882
     /* 22882 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(22901), // Rule ID 5791 //
     /* 22887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 22894 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 22894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /* 22899 */     GIR_RootConstrainSelectedInstOperands,
     /* 22900 */     // GIR_Coverage, 5791,
     /* 22900 */     GIR_Done,
     /* 22901 */   // Label 682: @22901
     /* 22901 */   GIM_Reject,
     /* 22902 */ // Label 680: @22902
     /* 22902 */ GIM_Reject,
     /* 22903 */ // Label 570: @22903
     /* 22903 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(23160),
     /* 22908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 22911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 22914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 22918 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(22978), // Rule ID 24131 //
     /* 22923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 22930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 22934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 22938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 22942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 22947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 22951 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 22957 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 22959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 22963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 22965 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 22965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 22968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 22970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 22974 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 22976 */     GIR_RootConstrainSelectedInstOperands,
     /* 22977 */     // GIR_Coverage, 24131,
     /* 22977 */     GIR_EraseRootFromParent_Done,
     /* 22978 */   // Label 684: @22978
     /* 22978 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(23041), // Rule ID 4421 //
     /* 22983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 22986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 22990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 22994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 22998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 23002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 23016 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23022 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 23024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 23026 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 23026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 23029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 23035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 23039 */     GIR_RootConstrainSelectedInstOperands,
     /* 23040 */     // GIR_Coverage, 4421,
     /* 23040 */     GIR_EraseRootFromParent_Done,
     /* 23041 */   // Label 685: @23041
     /* 23041 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(23101), // Rule ID 24132 //
     /* 23046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 23061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 23065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 23069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 23078 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 23086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 23088 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 23088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /* 23091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 23097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 23099 */     GIR_RootConstrainSelectedInstOperands,
     /* 23100 */     // GIR_Coverage, 24132,
     /* 23100 */     GIR_EraseRootFromParent_Done,
     /* 23101 */   // Label 686: @23101
     /* 23101 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(23136), // Rule ID 4409 //
     /* 23106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23117 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23127 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /* 23127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 23130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23134 */     GIR_RootConstrainSelectedInstOperands,
     /* 23135 */     // GIR_Coverage, 4409,
     /* 23135 */     GIR_EraseRootFromParent_Done,
     /* 23136 */   // Label 687: @23136
     /* 23136 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(23159), // Rule ID 4425 //
     /* 23141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 23152 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /* 23152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /* 23157 */     GIR_RootConstrainSelectedInstOperands,
     /* 23158 */     // GIR_Coverage, 4425,
     /* 23158 */     GIR_Done,
     /* 23159 */   // Label 688: @23159
     /* 23159 */   GIM_Reject,
     /* 23160 */ // Label 683: @23160
     /* 23160 */ GIM_Reject,
     /* 23161 */ // Label 571: @23161
     /* 23161 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(23532),
     /* 23166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 23169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23172 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(23404), // Rule ID 22390 //
     /* 23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23202 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /* 23202 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 23205 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23209 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 23216 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 23219 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23223 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23228 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 23231 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23235 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /* 23238 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23243 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23248 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 23253 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 23256 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23260 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 23267 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 23270 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23274 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23279 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 23282 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23286 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 23289 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23294 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23299 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 23304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 23307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 23318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 23321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 23333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 23340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 23355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 23358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 23362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 23370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 23373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 23376 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 23379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 23381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 23384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23386 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 23393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 23398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23403 */     // GIR_Coverage, 22390,
     /* 23403 */     GIR_EraseRootFromParent_Done,
     /* 23404 */   // Label 690: @23404
     /* 23404 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(23450), // Rule ID 22398 //
     /* 23409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23434 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /* 23434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /* 23437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 23448 */     GIR_RootConstrainSelectedInstOperands,
     /* 23449 */     // GIR_Coverage, 22398,
     /* 23449 */     GIR_EraseRootFromParent_Done,
     /* 23450 */   // Label 691: @23450
     /* 23450 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(23477), // Rule ID 18599 //
     /* 23455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 23458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23470 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 23470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /* 23475 */     GIR_RootConstrainSelectedInstOperands,
     /* 23476 */     // GIR_Coverage, 18599,
     /* 23476 */     GIR_Done,
     /* 23477 */   // Label 692: @23477
     /* 23477 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(23504), // Rule ID 18623 //
     /* 23482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 23485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 23497 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 23497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /* 23502 */     GIR_RootConstrainSelectedInstOperands,
     /* 23503 */     // GIR_Coverage, 18623,
     /* 23503 */     GIR_Done,
     /* 23504 */   // Label 693: @23504
     /* 23504 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(23531), // Rule ID 20467 //
     /* 23509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 23524 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 23524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /* 23529 */     GIR_RootConstrainSelectedInstOperands,
     /* 23530 */     // GIR_Coverage, 20467,
     /* 23530 */     GIR_Done,
     /* 23531 */   // Label 694: @23531
     /* 23531 */   GIM_Reject,
     /* 23532 */ // Label 689: @23532
     /* 23532 */ GIM_Reject,
     /* 23533 */ // Label 572: @23533
     /* 23533 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(23904),
     /* 23538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 23541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 23544 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(23776), // Rule ID 22395 //
     /* 23549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 23552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23570 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23574 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 23574 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 23577 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23581 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 23588 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 23591 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23595 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23600 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 23603 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23607 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 23610 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23615 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23620 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23625 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 23628 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23632 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 23639 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 23642 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23646 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23651 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 23654 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23658 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 23661 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23666 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23671 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 23679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 23683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 23690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 23693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 23697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 23705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 23709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 23712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 23717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 23730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 23734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 23739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 23742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 23745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 23748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 23751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 23753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 23756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 23765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 23770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 23775 */     // GIR_Coverage, 22395,
     /* 23775 */     GIR_EraseRootFromParent_Done,
     /* 23776 */   // Label 696: @23776
     /* 23776 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(23822), // Rule ID 22403 //
     /* 23781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23806 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /* 23806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 23809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 23820 */     GIR_RootConstrainSelectedInstOperands,
     /* 23821 */     // GIR_Coverage, 22403,
     /* 23821 */     GIR_EraseRootFromParent_Done,
     /* 23822 */   // Label 697: @23822
     /* 23822 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(23849), // Rule ID 18544 //
     /* 23827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 23830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23842 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 23842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 23847 */     GIR_RootConstrainSelectedInstOperands,
     /* 23848 */     // GIR_Coverage, 18544,
     /* 23848 */     GIR_Done,
     /* 23849 */   // Label 698: @23849
     /* 23849 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(23876), // Rule ID 18570 //
     /* 23854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 23857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 23869 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 23869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 23874 */     GIR_RootConstrainSelectedInstOperands,
     /* 23875 */     // GIR_Coverage, 18570,
     /* 23875 */     GIR_Done,
     /* 23876 */   // Label 699: @23876
     /* 23876 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(23903), // Rule ID 20484 //
     /* 23881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 23884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 23896 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 23896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /* 23901 */     GIR_RootConstrainSelectedInstOperands,
     /* 23902 */     // GIR_Coverage, 20484,
     /* 23902 */     GIR_Done,
     /* 23903 */   // Label 700: @23903
     /* 23903 */   GIM_Reject,
     /* 23904 */ // Label 695: @23904
     /* 23904 */ GIM_Reject,
     /* 23905 */ // Label 573: @23905
     /* 23905 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(23982),
     /* 23910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 23913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 23916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 23920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 23924 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(23962), // Rule ID 22388 //
     /* 23929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 23936 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 23942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 23944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 23946 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /* 23946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 23949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 23951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 23957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 23960 */     GIR_RootConstrainSelectedInstOperands,
     /* 23961 */     // GIR_Coverage, 22388,
     /* 23961 */     GIR_EraseRootFromParent_Done,
     /* 23962 */   // Label 702: @23962
     /* 23962 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(23981), // Rule ID 5818 //
     /* 23967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 23970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 23974 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 23974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /* 23979 */     GIR_RootConstrainSelectedInstOperands,
     /* 23980 */     // GIR_Coverage, 5818,
     /* 23980 */     GIR_Done,
     /* 23981 */   // Label 703: @23981
     /* 23981 */   GIM_Reject,
     /* 23982 */ // Label 701: @23982
     /* 23982 */ GIM_Reject,
     /* 23983 */ // Label 574: @23983
     /* 23983 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(24240),
     /* 23988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 23991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 23994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 23998 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(24058), // Rule ID 24133 //
     /* 24003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 24018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 24022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24031 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24045 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /* 24048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 24056 */     GIR_RootConstrainSelectedInstOperands,
     /* 24057 */     // GIR_Coverage, 24133,
     /* 24057 */     GIR_EraseRootFromParent_Done,
     /* 24058 */   // Label 705: @24058
     /* 24058 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(24121), // Rule ID 4422 //
     /* 24063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 24078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 24082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 24096 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24102 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24106 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /* 24109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 24119 */     GIR_RootConstrainSelectedInstOperands,
     /* 24120 */     // GIR_Coverage, 4422,
     /* 24120 */     GIR_EraseRootFromParent_Done,
     /* 24121 */   // Label 706: @24121
     /* 24121 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(24181), // Rule ID 24134 //
     /* 24126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 24145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 24149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24168 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /* 24171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 24179 */     GIR_RootConstrainSelectedInstOperands,
     /* 24180 */     // GIR_Coverage, 24134,
     /* 24180 */     GIR_EraseRootFromParent_Done,
     /* 24181 */   // Label 707: @24181
     /* 24181 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(24216), // Rule ID 4410 //
     /* 24186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24207 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /* 24207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /* 24210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24214 */     GIR_RootConstrainSelectedInstOperands,
     /* 24215 */     // GIR_Coverage, 4410,
     /* 24215 */     GIR_EraseRootFromParent_Done,
     /* 24216 */   // Label 708: @24216
     /* 24216 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(24239), // Rule ID 4426 //
     /* 24221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 24232 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /* 24232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /* 24237 */     GIR_RootConstrainSelectedInstOperands,
     /* 24238 */     // GIR_Coverage, 4426,
     /* 24238 */     GIR_Done,
     /* 24239 */   // Label 709: @24239
     /* 24239 */   GIM_Reject,
     /* 24240 */ // Label 704: @24240
     /* 24240 */ GIM_Reject,
     /* 24241 */ // Label 575: @24241
     /* 24241 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(24612),
     /* 24246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 24249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 24252 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(24484), // Rule ID 22394 //
     /* 24257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 24260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24272 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24282 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /* 24282 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /* 24285 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 24289 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 24296 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 24299 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 24303 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24308 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 24311 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 24315 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /* 24318 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 24323 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24333 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 24336 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 24340 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 24347 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 24350 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 24354 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24359 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 24362 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 24366 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 24369 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 24374 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24379 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24384 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 24387 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 24391 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 24398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 24401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 24405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24410 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 24413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 24417 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 24420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 24425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 24438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 24442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 24447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 24450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 24453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 24456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 24459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 24461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 24464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24466 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 24473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 24478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 24483 */     // GIR_Coverage, 22394,
     /* 24483 */     GIR_EraseRootFromParent_Done,
     /* 24484 */   // Label 711: @24484
     /* 24484 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(24530), // Rule ID 22402 //
     /* 24489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 24492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24504 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24514 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /* 24514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /* 24517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 24528 */     GIR_RootConstrainSelectedInstOperands,
     /* 24529 */     // GIR_Coverage, 22402,
     /* 24529 */     GIR_EraseRootFromParent_Done,
     /* 24530 */   // Label 712: @24530
     /* 24530 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(24557), // Rule ID 18543 //
     /* 24535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 24538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24550 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 24550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /* 24555 */     GIR_RootConstrainSelectedInstOperands,
     /* 24556 */     // GIR_Coverage, 18543,
     /* 24556 */     GIR_Done,
     /* 24557 */   // Label 713: @24557
     /* 24557 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(24584), // Rule ID 18569 //
     /* 24562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /* 24565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 24577 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 24577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /* 24582 */     GIR_RootConstrainSelectedInstOperands,
     /* 24583 */     // GIR_Coverage, 18569,
     /* 24583 */     GIR_Done,
     /* 24584 */   // Label 714: @24584
     /* 24584 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(24611), // Rule ID 20483 //
     /* 24589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 24592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 24604 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 24604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /* 24609 */     GIR_RootConstrainSelectedInstOperands,
     /* 24610 */     // GIR_Coverage, 20483,
     /* 24610 */     GIR_Done,
     /* 24611 */   // Label 715: @24611
     /* 24611 */   GIM_Reject,
     /* 24612 */ // Label 710: @24612
     /* 24612 */ GIM_Reject,
     /* 24613 */ // Label 576: @24613
     /* 24613 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(24690),
     /* 24618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 24621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 24624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24632 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(24670), // Rule ID 22387 //
     /* 24637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 24640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24654 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /* 24654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 24657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24663 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 24668 */     GIR_RootConstrainSelectedInstOperands,
     /* 24669 */     // GIR_Coverage, 22387,
     /* 24669 */     GIR_EraseRootFromParent_Done,
     /* 24670 */   // Label 717: @24670
     /* 24670 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(24689), // Rule ID 20500 //
     /* 24675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 24678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24682 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 24682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /* 24687 */     GIR_RootConstrainSelectedInstOperands,
     /* 24688 */     // GIR_Coverage, 20500,
     /* 24688 */     GIR_Done,
     /* 24689 */   // Label 718: @24689
     /* 24689 */   GIM_Reject,
     /* 24690 */ // Label 716: @24690
     /* 24690 */ GIM_Reject,
     /* 24691 */ // Label 577: @24691
     /* 24691 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(24948),
     /* 24696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24706 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(24766), // Rule ID 24135 //
     /* 24711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24739 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24753 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /* 24756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24762 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 24764 */     GIR_RootConstrainSelectedInstOperands,
     /* 24765 */     // GIR_Coverage, 24135,
     /* 24765 */     GIR_EraseRootFromParent_Done,
     /* 24766 */   // Label 720: @24766
     /* 24766 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(24829), // Rule ID 4423 //
     /* 24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 24778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 24804 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24810 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24814 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /* 24817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 24827 */     GIR_RootConstrainSelectedInstOperands,
     /* 24828 */     // GIR_Coverage, 4423,
     /* 24828 */     GIR_EraseRootFromParent_Done,
     /* 24829 */   // Label 721: @24829
     /* 24829 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(24889), // Rule ID 24136 //
     /* 24834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 24849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 24853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 24857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 24866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 24874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 24876 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /* 24879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 24885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 24887 */     GIR_RootConstrainSelectedInstOperands,
     /* 24888 */     // GIR_Coverage, 24136,
     /* 24888 */     GIR_EraseRootFromParent_Done,
     /* 24889 */   // Label 722: @24889
     /* 24889 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(24924), // Rule ID 4411 //
     /* 24894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24905 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24915 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /* 24915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /* 24918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24922 */     GIR_RootConstrainSelectedInstOperands,
     /* 24923 */     // GIR_Coverage, 4411,
     /* 24923 */     GIR_EraseRootFromParent_Done,
     /* 24924 */   // Label 723: @24924
     /* 24924 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(24947), // Rule ID 4427 //
     /* 24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 24932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 24940 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /* 24940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /* 24945 */     GIR_RootConstrainSelectedInstOperands,
     /* 24946 */     // GIR_Coverage, 4427,
     /* 24946 */     GIR_Done,
     /* 24947 */   // Label 724: @24947
     /* 24947 */   GIM_Reject,
     /* 24948 */ // Label 719: @24948
     /* 24948 */ GIM_Reject,
     /* 24949 */ // Label 578: @24949
     /* 24949 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(25026),
     /* 24954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 24957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 24960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 24968 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(25006), // Rule ID 22386 //
     /* 24973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 24976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 24980 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 24986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 24988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 24990 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /* 24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /* 24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 24995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 24999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 25001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 25004 */     GIR_RootConstrainSelectedInstOperands,
     /* 25005 */     // GIR_Coverage, 22386,
     /* 25005 */     GIR_EraseRootFromParent_Done,
     /* 25006 */   // Label 726: @25006
     /* 25006 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(25025), // Rule ID 20499 //
     /* 25011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 25014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 25018 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 25018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /* 25023 */     GIR_RootConstrainSelectedInstOperands,
     /* 25024 */     // GIR_Coverage, 20499,
     /* 25024 */     GIR_Done,
     /* 25025 */   // Label 727: @25025
     /* 25025 */   GIM_Reject,
     /* 25026 */ // Label 725: @25026
     /* 25026 */ GIM_Reject,
     /* 25027 */ // Label 579: @25027
     /* 25027 */ GIM_Reject,
     /* 25028 */ // Label 6: @25028
     /* 25028 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(25194),
     /* 25033 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 25036 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 732*/ GIMT_Encode4(25193),
     /* 25047 */   /*GILLT_v16s1*//*Label 729*/ GIMT_Encode4(25079), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25063 */   /*GILLT_v32s1*//*Label 730*/ GIMT_Encode4(25117), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25075 */   /*GILLT_v64s1*//*Label 731*/ GIMT_Encode4(25155),
     /* 25079 */   // Label 729: @25079
     /* 25079 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(25116), // Rule ID 19950 //
     /* 25084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 25087 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 25090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 25093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 25101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 25105 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /* 25105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /* 25108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25110 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 25112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 25114 */     GIR_RootConstrainSelectedInstOperands,
     /* 25115 */     // GIR_Coverage, 19950,
     /* 25115 */     GIR_EraseRootFromParent_Done,
     /* 25116 */   // Label 733: @25116
     /* 25116 */   GIM_Reject,
     /* 25117 */   // Label 730: @25117
     /* 25117 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(25154), // Rule ID 19951 //
     /* 25122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 25125 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 25128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 25131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 25135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25143 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /* 25143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /* 25146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 25150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 25152 */     GIR_RootConstrainSelectedInstOperands,
     /* 25153 */     // GIR_Coverage, 19951,
     /* 25153 */     GIR_EraseRootFromParent_Done,
     /* 25154 */   // Label 734: @25154
     /* 25154 */   GIM_Reject,
     /* 25155 */   // Label 731: @25155
     /* 25155 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(25192), // Rule ID 19952 //
     /* 25160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 25163 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 25166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 25169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 25173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 25177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 25181 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /* 25181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /* 25184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25186 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 25188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 25190 */     GIR_RootConstrainSelectedInstOperands,
     /* 25191 */     // GIR_Coverage, 19952,
     /* 25191 */     GIR_EraseRootFromParent_Done,
     /* 25192 */   // Label 735: @25192
     /* 25192 */   GIM_Reject,
     /* 25193 */   // Label 732: @25193
     /* 25193 */   GIM_Reject,
     /* 25194 */ // Label 728: @25194
     /* 25194 */ GIM_Reject,
     /* 25195 */ // Label 7: @25195
     /* 25195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 744*/ GIMT_Encode4(26951),
     /* 25206 */ /*GILLT_s8*//*Label 736*/ GIMT_Encode4(25298),
     /* 25210 */ /*GILLT_s16*//*Label 737*/ GIMT_Encode4(25359),
     /* 25214 */ /*GILLT_s32*//*Label 738*/ GIMT_Encode4(26189),
     /* 25218 */ /*GILLT_s64*//*Label 739*/ GIMT_Encode4(26417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25250 */ /*GILLT_v8s1*//*Label 740*/ GIMT_Encode4(26645), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25266 */ /*GILLT_v16s1*//*Label 741*/ GIMT_Encode4(26727), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25282 */ /*GILLT_v32s1*//*Label 742*/ GIMT_Encode4(26809), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 25294 */ /*GILLT_v64s1*//*Label 743*/ GIMT_Encode4(26880),
     /* 25298 */ // Label 736: @25298
     /* 25298 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(25358), // Rule ID 19881 //
     /* 25303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 25306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 25310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 25314 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 25314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25326 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 25335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25340 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 25347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 25352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25357 */   // GIR_Coverage, 19881,
     /* 25357 */   GIR_EraseRootFromParent_Done,
     /* 25358 */ // Label 745: @25358
     /* 25358 */ GIM_Reject,
     /* 25359 */ // Label 737: @25359
     /* 25359 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(25419), // Rule ID 19878 //
     /* 25364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 25367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 25375 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 25375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25387 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25391 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 25396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25401 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25418 */   // GIR_Coverage, 19878,
     /* 25418 */   GIR_EraseRootFromParent_Done,
     /* 25419 */ // Label 746: @25419
     /* 25419 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(25520), // Rule ID 22587 //
     /* 25424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 25427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 25434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25438 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /* 25438 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 25441 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25445 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 25452 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 25455 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 25459 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25464 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 25467 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25471 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /* 25474 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25484 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 25489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 25492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /* 25496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25501 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 25514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 25519 */   // GIR_Coverage, 22587,
     /* 25519 */   GIR_EraseRootFromParent_Done,
     /* 25520 */ // Label 747: @25520
     /* 25520 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(25600), // Rule ID 22600 //
     /* 25525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 25528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 25539 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 25539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 25542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25551 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25555 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /* 25560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /* 25567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25572 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25582 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25599 */   // GIR_Coverage, 22600,
     /* 25599 */   GIR_EraseRootFromParent_Done,
     /* 25600 */ // Label 748: @25600
     /* 25600 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(25679), // Rule ID 18787 //
     /* 25605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /* 25608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25615 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /* 25615 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25618 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25622 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25627 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25631 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /* 25636 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25639 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /* 25643 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25648 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25661 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25678 */   // GIR_Coverage, 18787,
     /* 25678 */   GIR_EraseRootFromParent_Done,
     /* 25679 */ // Label 749: @25679
     /* 25679 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(25796), // Rule ID 18788 //
     /* 25684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /* 25687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 25694 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /* 25694 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 25697 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25701 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 25708 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 25711 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 25715 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25720 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 25723 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25727 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /* 25730 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25735 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25740 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 25745 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25748 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25752 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 25759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 25762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /* 25766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25771 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25774 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 25777 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 25790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 25795 */   // GIR_Coverage, 18788,
     /* 25795 */   GIR_EraseRootFromParent_Done,
     /* 25796 */ // Label 750: @25796
     /* 25796 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(25875), // Rule ID 18784 //
     /* 25801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 25804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 25811 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /* 25811 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25814 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25818 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25823 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25827 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /* 25832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 25835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /* 25839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25844 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25847 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25857 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 25864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 25869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 25874 */   // GIR_Coverage, 18784,
     /* 25874 */   GIR_EraseRootFromParent_Done,
     /* 25875 */ // Label 751: @25875
     /* 25875 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(25992), // Rule ID 18785 //
     /* 25880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 25883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 25886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 25890 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /* 25890 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 25893 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25897 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 25904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 25907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 25911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25916 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 25919 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 25923 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /* 25926 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25931 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 25936 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 25941 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 25944 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 25948 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 25955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 25958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /* 25962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 25967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 25970 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 25973 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 25976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 25978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 25981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 25983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 25986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 25991 */   // GIR_Coverage, 18785,
     /* 25991 */   GIR_EraseRootFromParent_Done,
     /* 25992 */ // Label 752: @25992
     /* 25992 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(26071), // Rule ID 22288 //
     /* 25997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 26000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 26003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 26007 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /* 26007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 26010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26019 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26023 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /* 26028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /* 26035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26043 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 26046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26053 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 26060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 26065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 26070 */   // GIR_Coverage, 22288,
     /* 26070 */   GIR_EraseRootFromParent_Done,
     /* 26071 */ // Label 753: @26071
     /* 26071 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(26188), // Rule ID 22289 //
     /* 26076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 26079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 26082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 26086 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /* 26086 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 26089 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26093 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 26100 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 26103 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 26107 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26112 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 26115 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26119 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /* 26122 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26127 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26132 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 26137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 26140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 26151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 26154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /* 26158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26163 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26166 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 26169 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 26172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 26187 */   // GIR_Coverage, 22289,
     /* 26187 */   GIR_EraseRootFromParent_Done,
     /* 26188 */ // Label 754: @26188
     /* 26188 */ GIM_Reject,
     /* 26189 */ // Label 738: @26189
     /* 26189 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(26215), // Rule ID 2912 //
     /* 26194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26208 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 26208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /* 26213 */   GIR_RootConstrainSelectedInstOperands,
     /* 26214 */   // GIR_Coverage, 2912,
     /* 26214 */   GIR_Done,
     /* 26215 */ // Label 755: @26215
     /* 26215 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(26241), // Rule ID 2913 //
     /* 26220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26234 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 26234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /* 26239 */   GIR_RootConstrainSelectedInstOperands,
     /* 26240 */   // GIR_Coverage, 2913,
     /* 26240 */   GIR_Done,
     /* 26241 */ // Label 756: @26241
     /* 26241 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(26267), // Rule ID 2922 //
     /* 26246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26260 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 26260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /* 26265 */   GIR_RootConstrainSelectedInstOperands,
     /* 26266 */   // GIR_Coverage, 2922,
     /* 26266 */   GIR_Done,
     /* 26267 */ // Label 757: @26267
     /* 26267 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(26293), // Rule ID 2923 //
     /* 26272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 26286 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 26286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /* 26291 */   GIR_RootConstrainSelectedInstOperands,
     /* 26292 */   // GIR_Coverage, 2923,
     /* 26292 */   GIR_Done,
     /* 26293 */ // Label 758: @26293
     /* 26293 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(26319), // Rule ID 4595 //
     /* 26298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26312 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 26312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /* 26317 */   GIR_RootConstrainSelectedInstOperands,
     /* 26318 */   // GIR_Coverage, 4595,
     /* 26318 */   GIR_Done,
     /* 26319 */ // Label 759: @26319
     /* 26319 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(26345), // Rule ID 4600 //
     /* 26324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26338 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 26338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /* 26343 */   GIR_RootConstrainSelectedInstOperands,
     /* 26344 */   // GIR_Coverage, 4600,
     /* 26344 */   GIR_Done,
     /* 26345 */ // Label 760: @26345
     /* 26345 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(26372), // Rule ID 19889 //
     /* 26350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 26353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 26361 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /* 26361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 26371 */   // GIR_Coverage, 19889,
     /* 26371 */   GIR_Done,
     /* 26372 */ // Label 761: @26372
     /* 26372 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(26416), // Rule ID 20323 //
     /* 26377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 26380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 26388 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /* 26388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /* 26395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26400 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /* 26409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26414 */   GIR_RootConstrainSelectedInstOperands,
     /* 26415 */   // GIR_Coverage, 20323,
     /* 26415 */   GIR_EraseRootFromParent_Done,
     /* 26416 */ // Label 762: @26416
     /* 26416 */ GIM_Reject,
     /* 26417 */ // Label 739: @26417
     /* 26417 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(26443), // Rule ID 2907 //
     /* 26422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26436 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 26436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /* 26441 */   GIR_RootConstrainSelectedInstOperands,
     /* 26442 */   // GIR_Coverage, 2907,
     /* 26442 */   GIR_Done,
     /* 26443 */ // Label 763: @26443
     /* 26443 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(26469), // Rule ID 2911 //
     /* 26448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26462 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 26462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /* 26467 */   GIR_RootConstrainSelectedInstOperands,
     /* 26468 */   // GIR_Coverage, 2911,
     /* 26468 */   GIR_Done,
     /* 26469 */ // Label 764: @26469
     /* 26469 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(26495), // Rule ID 2920 //
     /* 26474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 26477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26488 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 26488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /* 26493 */   GIR_RootConstrainSelectedInstOperands,
     /* 26494 */   // GIR_Coverage, 2920,
     /* 26494 */   GIR_Done,
     /* 26495 */ // Label 765: @26495
     /* 26495 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(26521), // Rule ID 2921 //
     /* 26500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 26503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 26514 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 26514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /* 26519 */   GIR_RootConstrainSelectedInstOperands,
     /* 26520 */   // GIR_Coverage, 2921,
     /* 26520 */   GIR_Done,
     /* 26521 */ // Label 766: @26521
     /* 26521 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(26547), // Rule ID 4593 //
     /* 26526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26540 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 26540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /* 26545 */   GIR_RootConstrainSelectedInstOperands,
     /* 26546 */   // GIR_Coverage, 4593,
     /* 26546 */   GIR_Done,
     /* 26547 */ // Label 767: @26547
     /* 26547 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(26573), // Rule ID 4594 //
     /* 26552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 26555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26566 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 26566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /* 26571 */   GIR_RootConstrainSelectedInstOperands,
     /* 26572 */   // GIR_Coverage, 4594,
     /* 26572 */   GIR_Done,
     /* 26573 */ // Label 768: @26573
     /* 26573 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(26600), // Rule ID 19891 //
     /* 26578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 26581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 26589 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /* 26589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 26599 */   // GIR_Coverage, 19891,
     /* 26599 */   GIR_Done,
     /* 26600 */ // Label 769: @26600
     /* 26600 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(26644), // Rule ID 20325 //
     /* 26605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 26608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 26616 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /* 26616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 26619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /* 26623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26628 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /* 26637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26642 */   GIR_RootConstrainSelectedInstOperands,
     /* 26643 */   // GIR_Coverage, 20325,
     /* 26643 */   GIR_EraseRootFromParent_Done,
     /* 26644 */ // Label 770: @26644
     /* 26644 */ GIM_Reject,
     /* 26645 */ // Label 740: @26645
     /* 26645 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(26726), // Rule ID 19880 //
     /* 26650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 26653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 26657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 26661 */   // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /* 26661 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 26664 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26668 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 26675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 26682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26694 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 26697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 26702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 26707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 26712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 26725 */   // GIR_Coverage, 19880,
     /* 26725 */   GIR_EraseRootFromParent_Done,
     /* 26726 */ // Label 771: @26726
     /* 26726 */ GIM_Reject,
     /* 26727 */ // Label 741: @26727
     /* 26727 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(26808), // Rule ID 19877 //
     /* 26732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 26735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 26739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 26743 */   // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /* 26743 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 26746 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 26750 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 26757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 26764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26769 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 26772 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26776 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /* 26779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 26789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 26794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 26807 */   // GIR_Coverage, 19877,
     /* 26807 */   GIR_EraseRootFromParent_Done,
     /* 26808 */ // Label 772: @26808
     /* 26808 */ GIM_Reject,
     /* 26809 */ // Label 742: @26809
     /* 26809 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(26879),
     /* 26814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 26817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 26821 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(26841), // Rule ID 19888 //
     /* 26826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 26830 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /* 26830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 26840 */     // GIR_Coverage, 19888,
     /* 26840 */     GIR_Done,
     /* 26841 */   // Label 774: @26841
     /* 26841 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(26878), // Rule ID 20322 //
     /* 26846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 26850 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /* 26850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 26853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /* 26857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /* 26871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26876 */     GIR_RootConstrainSelectedInstOperands,
     /* 26877 */     // GIR_Coverage, 20322,
     /* 26877 */     GIR_EraseRootFromParent_Done,
     /* 26878 */   // Label 775: @26878
     /* 26878 */   GIM_Reject,
     /* 26879 */ // Label 773: @26879
     /* 26879 */ GIM_Reject,
     /* 26880 */ // Label 743: @26880
     /* 26880 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(26950),
     /* 26885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 26888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 26892 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(26912), // Rule ID 19890 //
     /* 26897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 26901 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /* 26901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 26906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /* 26911 */     // GIR_Coverage, 19890,
     /* 26911 */     GIR_Done,
     /* 26912 */   // Label 777: @26912
     /* 26912 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(26949), // Rule ID 20324 //
     /* 26917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 26921 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /* 26921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 26924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /* 26928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 26933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 26937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 26939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /* 26942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 26944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 26947 */     GIR_RootConstrainSelectedInstOperands,
     /* 26948 */     // GIR_Coverage, 20324,
     /* 26948 */     GIR_EraseRootFromParent_Done,
     /* 26949 */   // Label 778: @26949
     /* 26949 */   GIM_Reject,
     /* 26950 */ // Label 776: @26950
     /* 26950 */ GIM_Reject,
     /* 26951 */ // Label 744: @26951
     /* 26951 */ GIM_Reject,
     /* 26952 */ // Label 8: @26952
     /* 26952 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 791*/ GIMT_Encode4(28133),
     /* 26963 */ /*GILLT_s16*//*Label 779*/ GIMT_Encode4(27047),
     /* 26967 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(27108),
     /* 26971 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(27319), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 26987 */ /*GILLT_v2s64*//*Label 782*/ GIMT_Encode4(27530), GIMT_Encode4(0),
     /* 26995 */ /*GILLT_v4s32*//*Label 783*/ GIMT_Encode4(27561),
     /* 26999 */ /*GILLT_v4s64*//*Label 784*/ GIMT_Encode4(27712), GIMT_Encode4(0),
     /* 27007 */ /*GILLT_v8s16*//*Label 785*/ GIMT_Encode4(27773),
     /* 27011 */ /*GILLT_v8s32*//*Label 786*/ GIMT_Encode4(27804),
     /* 27015 */ /*GILLT_v8s64*//*Label 787*/ GIMT_Encode4(27922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27027 */ /*GILLT_v16s16*//*Label 788*/ GIMT_Encode4(28013),
     /* 27031 */ /*GILLT_v16s32*//*Label 789*/ GIMT_Encode4(28044), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 27043 */ /*GILLT_v32s16*//*Label 790*/ GIMT_Encode4(28102),
     /* 27047 */ // Label 779: @27047
     /* 27047 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(27107), // Rule ID 22616 //
     /* 27052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 27055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 27058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 27062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 27066 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /* 27066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 27069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 27073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 27078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 27082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 27084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 27087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 27089 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 27096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 27106 */   // GIR_Coverage, 22616,
     /* 27106 */   GIR_EraseRootFromParent_Done,
     /* 27107 */ // Label 792: @27107
     /* 27107 */ GIM_Reject,
     /* 27108 */ // Label 780: @27108
     /* 27108 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(27138), // Rule ID 1752 //
     /* 27113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27127 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 27127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /* 27132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27136 */   GIR_RootConstrainSelectedInstOperands,
     /* 27137 */   // GIR_Coverage, 1752,
     /* 27137 */   GIR_Done,
     /* 27138 */ // Label 793: @27138
     /* 27138 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(27168), // Rule ID 1756 //
     /* 27143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27157 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 27157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /* 27162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27166 */   GIR_RootConstrainSelectedInstOperands,
     /* 27167 */   // GIR_Coverage, 1756,
     /* 27167 */   GIR_Done,
     /* 27168 */ // Label 794: @27168
     /* 27168 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(27198), // Rule ID 1776 //
     /* 27173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 27176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27187 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 27187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /* 27192 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27196 */   GIR_RootConstrainSelectedInstOperands,
     /* 27197 */   // GIR_Coverage, 1776,
     /* 27197 */   GIR_Done,
     /* 27198 */ // Label 795: @27198
     /* 27198 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(27228), // Rule ID 1780 //
     /* 27203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27217 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 27217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /* 27222 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27226 */   GIR_RootConstrainSelectedInstOperands,
     /* 27227 */   // GIR_Coverage, 1780,
     /* 27227 */   GIR_Done,
     /* 27228 */ // Label 796: @27228
     /* 27228 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(27258), // Rule ID 10349 //
     /* 27233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 27247 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 27247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /* 27252 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27256 */   GIR_RootConstrainSelectedInstOperands,
     /* 27257 */   // GIR_Coverage, 10349,
     /* 27257 */   GIR_Done,
     /* 27258 */ // Label 797: @27258
     /* 27258 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(27288), // Rule ID 10353 //
     /* 27263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 27277 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 27277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /* 27282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27286 */   GIR_RootConstrainSelectedInstOperands,
     /* 27287 */   // GIR_Coverage, 10353,
     /* 27287 */   GIR_Done,
     /* 27288 */ // Label 798: @27288
     /* 27288 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(27318), // Rule ID 22617 //
     /* 27293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 27296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 27299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 27303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 27307 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /* 27307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 27312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27316 */   GIR_RootConstrainSelectedInstOperands,
     /* 27317 */   // GIR_Coverage, 22617,
     /* 27317 */   GIR_Done,
     /* 27318 */ // Label 799: @27318
     /* 27318 */ GIM_Reject,
     /* 27319 */ // Label 781: @27319
     /* 27319 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(27349), // Rule ID 18436 //
     /* 27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27338 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /* 27343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27347 */   GIR_RootConstrainSelectedInstOperands,
     /* 27348 */   // GIR_Coverage, 18436,
     /* 27348 */   GIR_Done,
     /* 27349 */ // Label 800: @27349
     /* 27349 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(27379), // Rule ID 18438 //
     /* 27354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 27357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27368 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /* 27373 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27377 */   GIR_RootConstrainSelectedInstOperands,
     /* 27378 */   // GIR_Coverage, 18438,
     /* 27378 */   GIR_Done,
     /* 27379 */ // Label 801: @27379
     /* 27379 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(27409), // Rule ID 18440 //
     /* 27384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 27387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27398 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /* 27403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27407 */   GIR_RootConstrainSelectedInstOperands,
     /* 27408 */   // GIR_Coverage, 18440,
     /* 27408 */   GIR_Done,
     /* 27409 */ // Label 802: @27409
     /* 27409 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(27439), // Rule ID 18442 //
     /* 27414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27428 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /* 27433 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27437 */   GIR_RootConstrainSelectedInstOperands,
     /* 27438 */   // GIR_Coverage, 18442,
     /* 27438 */   GIR_Done,
     /* 27439 */ // Label 803: @27439
     /* 27439 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(27469), // Rule ID 21606 //
     /* 27444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 27450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 27458 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 27458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /* 27463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27467 */   GIR_RootConstrainSelectedInstOperands,
     /* 27468 */   // GIR_Coverage, 21606,
     /* 27468 */   GIR_Done,
     /* 27469 */ // Label 804: @27469
     /* 27469 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(27499), // Rule ID 21608 //
     /* 27474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 27477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 27480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 27488 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 27488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /* 27493 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27497 */   GIR_RootConstrainSelectedInstOperands,
     /* 27498 */   // GIR_Coverage, 21608,
     /* 27498 */   GIR_Done,
     /* 27499 */ // Label 805: @27499
     /* 27499 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(27529), // Rule ID 22619 //
     /* 27504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /* 27507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 27510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 27514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 27518 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /* 27518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 27523 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27527 */   GIR_RootConstrainSelectedInstOperands,
     /* 27528 */   // GIR_Coverage, 22619,
     /* 27528 */   GIR_Done,
     /* 27529 */ // Label 806: @27529
     /* 27529 */ GIM_Reject,
     /* 27530 */ // Label 782: @27530
     /* 27530 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(27560), // Rule ID 21831 //
     /* 27535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 27538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 27541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27549 */   // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /* 27549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /* 27554 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27558 */   GIR_RootConstrainSelectedInstOperands,
     /* 27559 */   // GIR_Coverage, 21831,
     /* 27559 */   GIR_Done,
     /* 27560 */ // Label 807: @27560
     /* 27560 */ GIM_Reject,
     /* 27561 */ // Label 783: @27561
     /* 27561 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(27591), // Rule ID 18490 //
     /* 27566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 27569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27580 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /* 27580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /* 27585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27589 */   GIR_RootConstrainSelectedInstOperands,
     /* 27590 */   // GIR_Coverage, 18490,
     /* 27590 */   GIR_Done,
     /* 27591 */ // Label 808: @27591
     /* 27591 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(27621), // Rule ID 18494 //
     /* 27596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 27599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 27602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 27610 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 27610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /* 27615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27619 */   GIR_RootConstrainSelectedInstOperands,
     /* 27620 */   // GIR_Coverage, 18494,
     /* 27620 */   GIR_Done,
     /* 27621 */ // Label 809: @27621
     /* 27621 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(27651), // Rule ID 18496 //
     /* 27626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 27629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 27640 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /* 27640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /* 27645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27649 */   GIR_RootConstrainSelectedInstOperands,
     /* 27650 */   // GIR_Coverage, 18496,
     /* 27650 */   GIR_Done,
     /* 27651 */ // Label 810: @27651
     /* 27651 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(27681), // Rule ID 21803 //
     /* 27656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 27659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27670 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /* 27670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /* 27675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27679 */   GIR_RootConstrainSelectedInstOperands,
     /* 27680 */   // GIR_Coverage, 21803,
     /* 27680 */   GIR_Done,
     /* 27681 */ // Label 811: @27681
     /* 27681 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(27711), // Rule ID 21807 //
     /* 27686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 27689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 27692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27700 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /* 27700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /* 27705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27709 */   GIR_RootConstrainSelectedInstOperands,
     /* 27710 */   // GIR_Coverage, 21807,
     /* 27710 */   GIR_Done,
     /* 27711 */ // Label 812: @27711
     /* 27711 */ GIM_Reject,
     /* 27712 */ // Label 784: @27712
     /* 27712 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(27742), // Rule ID 21827 //
     /* 27717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 27720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 27723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27731 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /* 27731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /* 27736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27740 */   GIR_RootConstrainSelectedInstOperands,
     /* 27741 */   // GIR_Coverage, 21827,
     /* 27741 */   GIR_Done,
     /* 27742 */ // Label 813: @27742
     /* 27742 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(27772), // Rule ID 21833 //
     /* 27747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 27750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 27753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27761 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /* 27761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /* 27766 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27770 */   GIR_RootConstrainSelectedInstOperands,
     /* 27771 */   // GIR_Coverage, 21833,
     /* 27771 */   GIR_Done,
     /* 27772 */ // Label 814: @27772
     /* 27772 */ GIM_Reject,
     /* 27773 */ // Label 785: @27773
     /* 27773 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(27803), // Rule ID 22602 //
     /* 27778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 27781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 27784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27792 */   // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /* 27792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /* 27797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27801 */   GIR_RootConstrainSelectedInstOperands,
     /* 27802 */   // GIR_Coverage, 22602,
     /* 27802 */   GIR_Done,
     /* 27803 */ // Label 815: @27803
     /* 27803 */ GIM_Reject,
     /* 27804 */ // Label 786: @27804
     /* 27804 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(27834), // Rule ID 18492 //
     /* 27809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 27812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 27815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 27819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 27823 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /* 27823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /* 27828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27832 */   GIR_RootConstrainSelectedInstOperands,
     /* 27833 */   // GIR_Coverage, 18492,
     /* 27833 */   GIR_Done,
     /* 27834 */ // Label 816: @27834
     /* 27834 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(27864), // Rule ID 21805 //
     /* 27839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 27842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 27845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27853 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /* 27853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /* 27858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27862 */   GIR_RootConstrainSelectedInstOperands,
     /* 27863 */   // GIR_Coverage, 21805,
     /* 27863 */   GIR_Done,
     /* 27864 */ // Label 817: @27864
     /* 27864 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(27891), // Rule ID 21811 //
     /* 27869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 27872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27880 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /* 27880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /* 27885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27889 */   GIR_RootConstrainSelectedInstOperands,
     /* 27890 */   // GIR_Coverage, 21811,
     /* 27890 */   GIR_Done,
     /* 27891 */ // Label 818: @27891
     /* 27891 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(27921), // Rule ID 22606 //
     /* 27896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 27899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 27902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 27910 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /* 27910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /* 27915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27919 */   GIR_RootConstrainSelectedInstOperands,
     /* 27920 */   // GIR_Coverage, 22606,
     /* 27920 */   GIR_Done,
     /* 27921 */ // Label 819: @27921
     /* 27921 */ GIM_Reject,
     /* 27922 */ // Label 787: @27922
     /* 27922 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(27952), // Rule ID 21839 //
     /* 27927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 27930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 27933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 27941 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /* 27941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /* 27946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27950 */   GIR_RootConstrainSelectedInstOperands,
     /* 27951 */   // GIR_Coverage, 21839,
     /* 27951 */   GIR_Done,
     /* 27952 */ // Label 820: @27952
     /* 27952 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(27982), // Rule ID 21843 //
     /* 27957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 27960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 27963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27971 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /* 27971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /* 27976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 27980 */   GIR_RootConstrainSelectedInstOperands,
     /* 27981 */   // GIR_Coverage, 21843,
     /* 27981 */   GIR_Done,
     /* 27982 */ // Label 821: @27982
     /* 27982 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(28012), // Rule ID 22612 //
     /* 27987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 27990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 27993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 27997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28001 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /* 28001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /* 28006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28010 */   GIR_RootConstrainSelectedInstOperands,
     /* 28011 */   // GIR_Coverage, 22612,
     /* 28011 */   GIR_Done,
     /* 28012 */ // Label 822: @28012
     /* 28012 */ GIM_Reject,
     /* 28013 */ // Label 788: @28013
     /* 28013 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(28043), // Rule ID 22604 //
     /* 28018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 28021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 28024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28032 */   // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /* 28032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /* 28037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28041 */   GIR_RootConstrainSelectedInstOperands,
     /* 28042 */   // GIR_Coverage, 22604,
     /* 28042 */   GIR_Done,
     /* 28043 */ // Label 823: @28043
     /* 28043 */ GIM_Reject,
     /* 28044 */ // Label 789: @28044
     /* 28044 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(28071), // Rule ID 21809 //
     /* 28049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 28052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28060 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /* 28060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /* 28065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28069 */   GIR_RootConstrainSelectedInstOperands,
     /* 28070 */   // GIR_Coverage, 21809,
     /* 28070 */   GIR_Done,
     /* 28071 */ // Label 824: @28071
     /* 28071 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(28101), // Rule ID 22610 //
     /* 28076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 28079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 28082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28090 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /* 28090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /* 28095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28099 */   GIR_RootConstrainSelectedInstOperands,
     /* 28100 */   // GIR_Coverage, 22610,
     /* 28100 */   GIR_Done,
     /* 28101 */ // Label 825: @28101
     /* 28101 */ GIM_Reject,
     /* 28102 */ // Label 790: @28102
     /* 28102 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(28132), // Rule ID 22608 //
     /* 28107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 28110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 28113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28121 */   // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /* 28121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /* 28126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28130 */   GIR_RootConstrainSelectedInstOperands,
     /* 28131 */   // GIR_Coverage, 22608,
     /* 28131 */   GIR_Done,
     /* 28132 */ // Label 826: @28132
     /* 28132 */ GIM_Reject,
     /* 28133 */ // Label 791: @28133
     /* 28133 */ GIM_Reject,
     /* 28134 */ // Label 9: @28134
     /* 28134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 831*/ GIMT_Encode4(28587),
     /* 28145 */ /*GILLT_s64*//*Label 827*/ GIMT_Encode4(28193), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 28161 */ /*GILLT_v2s64*//*Label 828*/ GIMT_Encode4(28404), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 28173 */ /*GILLT_v4s64*//*Label 829*/ GIMT_Encode4(28435), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 28189 */ /*GILLT_v8s64*//*Label 830*/ GIMT_Encode4(28496),
     /* 28193 */ // Label 827: @28193
     /* 28193 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(28223), // Rule ID 1754 //
     /* 28198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 28201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 28204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 28212 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 28212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /* 28217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28221 */   GIR_RootConstrainSelectedInstOperands,
     /* 28222 */   // GIR_Coverage, 1754,
     /* 28222 */   GIR_Done,
     /* 28223 */ // Label 832: @28223
     /* 28223 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(28253), // Rule ID 1758 //
     /* 28228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 28231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 28234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 28242 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 28242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /* 28247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28251 */   GIR_RootConstrainSelectedInstOperands,
     /* 28252 */   // GIR_Coverage, 1758,
     /* 28252 */   GIR_Done,
     /* 28253 */ // Label 833: @28253
     /* 28253 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(28283), // Rule ID 1778 //
     /* 28258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 28261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 28264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 28272 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 28272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /* 28277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28281 */   GIR_RootConstrainSelectedInstOperands,
     /* 28282 */   // GIR_Coverage, 1778,
     /* 28282 */   GIR_Done,
     /* 28283 */ // Label 834: @28283
     /* 28283 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(28313), // Rule ID 1782 //
     /* 28288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 28291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 28294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 28302 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 28302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /* 28307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28311 */   GIR_RootConstrainSelectedInstOperands,
     /* 28312 */   // GIR_Coverage, 1782,
     /* 28312 */   GIR_Done,
     /* 28313 */ // Label 835: @28313
     /* 28313 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(28343), // Rule ID 10351 //
     /* 28318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 28321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 28324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 28332 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 28332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /* 28337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28341 */   GIR_RootConstrainSelectedInstOperands,
     /* 28342 */   // GIR_Coverage, 10351,
     /* 28342 */   GIR_Done,
     /* 28343 */ // Label 836: @28343
     /* 28343 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(28373), // Rule ID 10355 //
     /* 28348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 28351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 28354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 28362 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 28362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /* 28367 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28371 */   GIR_RootConstrainSelectedInstOperands,
     /* 28372 */   // GIR_Coverage, 10355,
     /* 28372 */   GIR_Done,
     /* 28373 */ // Label 837: @28373
     /* 28373 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(28403), // Rule ID 22621 //
     /* 28378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /* 28381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 28384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 28388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 28392 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /* 28392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 28397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28401 */   GIR_RootConstrainSelectedInstOperands,
     /* 28402 */   // GIR_Coverage, 22621,
     /* 28402 */   GIR_Done,
     /* 28403 */ // Label 838: @28403
     /* 28403 */ GIM_Reject,
     /* 28404 */ // Label 828: @28404
     /* 28404 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(28434), // Rule ID 21835 //
     /* 28409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 28412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 28415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28423 */   // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /* 28423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /* 28428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28432 */   GIR_RootConstrainSelectedInstOperands,
     /* 28433 */   // GIR_Coverage, 21835,
     /* 28433 */   GIR_Done,
     /* 28434 */ // Label 839: @28434
     /* 28434 */ GIM_Reject,
     /* 28435 */ // Label 829: @28435
     /* 28435 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(28465), // Rule ID 21829 //
     /* 28440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 28443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 28446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28454 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /* 28454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /* 28459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28463 */   GIR_RootConstrainSelectedInstOperands,
     /* 28464 */   // GIR_Coverage, 21829,
     /* 28464 */   GIR_Done,
     /* 28465 */ // Label 840: @28465
     /* 28465 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(28495), // Rule ID 21837 //
     /* 28470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 28473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 28476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28484 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /* 28484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /* 28489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28493 */   GIR_RootConstrainSelectedInstOperands,
     /* 28494 */   // GIR_Coverage, 21837,
     /* 28494 */   GIR_Done,
     /* 28495 */ // Label 841: @28495
     /* 28495 */ GIM_Reject,
     /* 28496 */ // Label 830: @28496
     /* 28496 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(28526), // Rule ID 21841 //
     /* 28501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 28504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 28507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 28515 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /* 28515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /* 28520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28524 */   GIR_RootConstrainSelectedInstOperands,
     /* 28525 */   // GIR_Coverage, 21841,
     /* 28525 */   GIR_Done,
     /* 28526 */ // Label 842: @28526
     /* 28526 */ GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(28556), // Rule ID 21845 //
     /* 28531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 28534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 28537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28545 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /* 28545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /* 28550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28554 */   GIR_RootConstrainSelectedInstOperands,
     /* 28555 */   // GIR_Coverage, 21845,
     /* 28555 */   GIR_Done,
     /* 28556 */ // Label 843: @28556
     /* 28556 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(28586), // Rule ID 22614 //
     /* 28561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 28564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 28567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 28571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 28575 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /* 28575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /* 28580 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 28584 */   GIR_RootConstrainSelectedInstOperands,
     /* 28585 */   // GIR_Coverage, 22614,
     /* 28585 */   GIR_Done,
     /* 28586 */ // Label 844: @28586
     /* 28586 */ GIM_Reject,
     /* 28587 */ // Label 831: @28587
     /* 28587 */ GIM_Reject,
     /* 28588 */ // Label 10: @28588
     /* 28588 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(29577),
     /* 28593 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 28596 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(28632), // Rule ID 1526 //
     /* 28601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /* 28609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28623 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14805:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /* 28623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /* 28626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28630 */     GIR_RootConstrainSelectedInstOperands,
     /* 28631 */     // GIR_Coverage, 1526,
     /* 28631 */     GIR_EraseRootFromParent_Done,
     /* 28632 */   // Label 846: @28632
     /* 28632 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(28668), // Rule ID 1528 //
     /* 28637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /* 28645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28659 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14804:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /* 28659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /* 28662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28666 */     GIR_RootConstrainSelectedInstOperands,
     /* 28667 */     // GIR_Coverage, 1528,
     /* 28667 */     GIR_EraseRootFromParent_Done,
     /* 28668 */   // Label 847: @28668
     /* 28668 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(28704), // Rule ID 1530 //
     /* 28673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /* 28681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14803:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /* 28695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /* 28698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28702 */     GIR_RootConstrainSelectedInstOperands,
     /* 28703 */     // GIR_Coverage, 1530,
     /* 28703 */     GIR_EraseRootFromParent_Done,
     /* 28704 */   // Label 848: @28704
     /* 28704 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(28740), // Rule ID 1532 //
     /* 28709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /* 28717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28731 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14802:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /* 28731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /* 28734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28738 */     GIR_RootConstrainSelectedInstOperands,
     /* 28739 */     // GIR_Coverage, 1532,
     /* 28739 */     GIR_EraseRootFromParent_Done,
     /* 28740 */   // Label 849: @28740
     /* 28740 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(28776), // Rule ID 1534 //
     /* 28745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /* 28753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28767 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14801:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /* 28767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /* 28770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28774 */     GIR_RootConstrainSelectedInstOperands,
     /* 28775 */     // GIR_Coverage, 1534,
     /* 28775 */     GIR_EraseRootFromParent_Done,
     /* 28776 */   // Label 850: @28776
     /* 28776 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(28812), // Rule ID 1536 //
     /* 28781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /* 28789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28803 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14800:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /* 28803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /* 28806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28810 */     GIR_RootConstrainSelectedInstOperands,
     /* 28811 */     // GIR_Coverage, 1536,
     /* 28811 */     GIR_EraseRootFromParent_Done,
     /* 28812 */   // Label 851: @28812
     /* 28812 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(28848), // Rule ID 1538 //
     /* 28817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /* 28825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14799:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /* 28839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /* 28842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28846 */     GIR_RootConstrainSelectedInstOperands,
     /* 28847 */     // GIR_Coverage, 1538,
     /* 28847 */     GIR_EraseRootFromParent_Done,
     /* 28848 */   // Label 852: @28848
     /* 28848 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(28884), // Rule ID 1540 //
     /* 28853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /* 28861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28875 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14798:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /* 28875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /* 28878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28882 */     GIR_RootConstrainSelectedInstOperands,
     /* 28883 */     // GIR_Coverage, 1540,
     /* 28883 */     GIR_EraseRootFromParent_Done,
     /* 28884 */   // Label 853: @28884
     /* 28884 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(28920), // Rule ID 1542 //
     /* 28889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /* 28897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28911 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14797:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /* 28911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /* 28914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28918 */     GIR_RootConstrainSelectedInstOperands,
     /* 28919 */     // GIR_Coverage, 1542,
     /* 28919 */     GIR_EraseRootFromParent_Done,
     /* 28920 */   // Label 854: @28920
     /* 28920 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(28956), // Rule ID 1544 //
     /* 28925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /* 28933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28947 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14796:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /* 28947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /* 28950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28954 */     GIR_RootConstrainSelectedInstOperands,
     /* 28955 */     // GIR_Coverage, 1544,
     /* 28955 */     GIR_EraseRootFromParent_Done,
     /* 28956 */   // Label 855: @28956
     /* 28956 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(28992), // Rule ID 1546 //
     /* 28961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 28964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /* 28969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 28983 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14795:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /* 28983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /* 28986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 28988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 28990 */     GIR_RootConstrainSelectedInstOperands,
     /* 28991 */     // GIR_Coverage, 1546,
     /* 28991 */     GIR_EraseRootFromParent_Done,
     /* 28992 */   // Label 856: @28992
     /* 28992 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(29028), // Rule ID 1548 //
     /* 28997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /* 29005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29019 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14794:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /* 29019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /* 29022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29026 */     GIR_RootConstrainSelectedInstOperands,
     /* 29027 */     // GIR_Coverage, 1548,
     /* 29027 */     GIR_EraseRootFromParent_Done,
     /* 29028 */   // Label 857: @29028
     /* 29028 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(29064), // Rule ID 1550 //
     /* 29033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /* 29041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 29047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29055 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14793:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /* 29055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /* 29058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29062 */     GIR_RootConstrainSelectedInstOperands,
     /* 29063 */     // GIR_Coverage, 1550,
     /* 29063 */     GIR_EraseRootFromParent_Done,
     /* 29064 */   // Label 858: @29064
     /* 29064 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(29100), // Rule ID 1552 //
     /* 29069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /* 29077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 29083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29091 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14792:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /* 29091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /* 29094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29098 */     GIR_RootConstrainSelectedInstOperands,
     /* 29099 */     // GIR_Coverage, 1552,
     /* 29099 */     GIR_EraseRootFromParent_Done,
     /* 29100 */   // Label 859: @29100
     /* 29100 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(29136), // Rule ID 1554 //
     /* 29105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /* 29113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 29119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29127 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14791:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /* 29127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /* 29130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29132 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29134 */     GIR_RootConstrainSelectedInstOperands,
     /* 29135 */     // GIR_Coverage, 1554,
     /* 29135 */     GIR_EraseRootFromParent_Done,
     /* 29136 */   // Label 860: @29136
     /* 29136 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(29172), // Rule ID 1556 //
     /* 29141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /* 29149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29163 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14786:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 29163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /* 29166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29170 */     GIR_RootConstrainSelectedInstOperands,
     /* 29171 */     // GIR_Coverage, 1556,
     /* 29171 */     GIR_EraseRootFromParent_Done,
     /* 29172 */   // Label 861: @29172
     /* 29172 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(29208), // Rule ID 1560 //
     /* 29177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /* 29185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29199 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14783:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 29199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /* 29202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29206 */     GIR_RootConstrainSelectedInstOperands,
     /* 29207 */     // GIR_Coverage, 1560,
     /* 29207 */     GIR_EraseRootFromParent_Done,
     /* 29208 */   // Label 862: @29208
     /* 29208 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(29244), // Rule ID 1562 //
     /* 29213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /* 29221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 29224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 29227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29235 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14784:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 29235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /* 29238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29242 */     GIR_RootConstrainSelectedInstOperands,
     /* 29243 */     // GIR_Coverage, 1562,
     /* 29243 */     GIR_EraseRootFromParent_Done,
     /* 29244 */   // Label 863: @29244
     /* 29244 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(29280), // Rule ID 1564 //
     /* 29249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /* 29257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29271 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14785:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 29271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /* 29274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29278 */     GIR_RootConstrainSelectedInstOperands,
     /* 29279 */     // GIR_Coverage, 1564,
     /* 29279 */     GIR_EraseRootFromParent_Done,
     /* 29280 */   // Label 864: @29280
     /* 29280 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(29316), // Rule ID 1568 //
     /* 29285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /* 29293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29307 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14781:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 29307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /* 29310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29314 */     GIR_RootConstrainSelectedInstOperands,
     /* 29315 */     // GIR_Coverage, 1568,
     /* 29315 */     GIR_EraseRootFromParent_Done,
     /* 29316 */   // Label 865: @29316
     /* 29316 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(29352), // Rule ID 1570 //
     /* 29321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 29324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /* 29329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 29332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 29335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 29343 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14782:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 29343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /* 29346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29350 */     GIR_RootConstrainSelectedInstOperands,
     /* 29351 */     // GIR_Coverage, 1570,
     /* 29351 */     GIR_EraseRootFromParent_Done,
     /* 29352 */   // Label 866: @29352
     /* 29352 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(29388), // Rule ID 3360 //
     /* 29357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /* 29360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /* 29365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29379 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13067:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /* 29379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /* 29382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29386 */     GIR_RootConstrainSelectedInstOperands,
     /* 29387 */     // GIR_Coverage, 3360,
     /* 29387 */     GIR_EraseRootFromParent_Done,
     /* 29388 */   // Label 867: @29388
     /* 29388 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(29424), // Rule ID 3362 //
     /* 29393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 29396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /* 29401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29415 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13067:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /* 29415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /* 29418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29422 */     GIR_RootConstrainSelectedInstOperands,
     /* 29423 */     // GIR_Coverage, 3362,
     /* 29423 */     GIR_EraseRootFromParent_Done,
     /* 29424 */   // Label 868: @29424
     /* 29424 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(29462), // Rule ID 18713 //
     /* 29429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 29432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /* 29437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29451 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14491:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /* 29454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29456 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29460 */     GIR_RootConstrainSelectedInstOperands,
     /* 29461 */     // GIR_Coverage, 18713,
     /* 29461 */     GIR_EraseRootFromParent_Done,
     /* 29462 */   // Label 869: @29462
     /* 29462 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(29500), // Rule ID 18717 //
     /* 29467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /* 29475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29489 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14491:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /* 29492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29498 */     GIR_RootConstrainSelectedInstOperands,
     /* 29499 */     // GIR_Coverage, 18717,
     /* 29499 */     GIR_EraseRootFromParent_Done,
     /* 29500 */   // Label 870: @29500
     /* 29500 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(29538), // Rule ID 18733 //
     /* 29505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 29508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /* 29513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29527 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14489:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /* 29530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29532 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29534 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29536 */     GIR_RootConstrainSelectedInstOperands,
     /* 29537 */     // GIR_Coverage, 18733,
     /* 29537 */     GIR_EraseRootFromParent_Done,
     /* 29538 */   // Label 871: @29538
     /* 29538 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(29576), // Rule ID 18737 //
     /* 29543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /* 29551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29565 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14489:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /* 29565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /* 29568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29574 */     GIR_RootConstrainSelectedInstOperands,
     /* 29575 */     // GIR_Coverage, 18737,
     /* 29575 */     GIR_EraseRootFromParent_Done,
     /* 29576 */   // Label 872: @29576
     /* 29576 */   GIM_Reject,
     /* 29577 */ // Label 845: @29577
     /* 29577 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(32638),
     /* 29582 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 29585 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(29626), // Rule ID 3364 //
     /* 29590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /* 29593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /* 29598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29612 */     // MIs[0] src2
     /* 29612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 29615 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13068:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /* 29615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /* 29618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29622 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29624 */     GIR_RootConstrainSelectedInstOperands,
     /* 29625 */     // GIR_Coverage, 3364,
     /* 29625 */     GIR_EraseRootFromParent_Done,
     /* 29626 */   // Label 874: @29626
     /* 29626 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(29667), // Rule ID 3366 //
     /* 29631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 29634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /* 29639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 29642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 29645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29653 */     // MIs[0] src2
     /* 29653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 29656 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13068:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /* 29656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /* 29659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29663 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29665 */     GIR_RootConstrainSelectedInstOperands,
     /* 29666 */     // GIR_Coverage, 3366,
     /* 29666 */     GIR_EraseRootFromParent_Done,
     /* 29667 */   // Label 875: @29667
     /* 29667 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(29712), // Rule ID 17236 //
     /* 29672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /* 29680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 29689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29701 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14760:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 29701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /* 29704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29708 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29710 */     GIR_RootConstrainSelectedInstOperands,
     /* 29711 */     // GIR_Coverage, 17236,
     /* 29711 */     GIR_EraseRootFromParent_Done,
     /* 29712 */   // Label 876: @29712
     /* 29712 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(29757), // Rule ID 17238 //
     /* 29717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /* 29725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 29728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 29731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 29734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29746 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14761:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 29746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /* 29749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29753 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29755 */     GIR_RootConstrainSelectedInstOperands,
     /* 29756 */     // GIR_Coverage, 17238,
     /* 29756 */     GIR_EraseRootFromParent_Done,
     /* 29757 */   // Label 877: @29757
     /* 29757 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(29802), // Rule ID 17242 //
     /* 29762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /* 29770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 29779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 29791 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14763:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 29791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /* 29794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29798 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29800 */     GIR_RootConstrainSelectedInstOperands,
     /* 29801 */     // GIR_Coverage, 17242,
     /* 29801 */     GIR_EraseRootFromParent_Done,
     /* 29802 */   // Label 878: @29802
     /* 29802 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(29847), // Rule ID 17244 //
     /* 29807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /* 29810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /* 29815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 29818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 29821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 29824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 29836 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14764:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 29836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /* 29839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29843 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29845 */     GIR_RootConstrainSelectedInstOperands,
     /* 29846 */     // GIR_Coverage, 17244,
     /* 29846 */     GIR_EraseRootFromParent_Done,
     /* 29847 */   // Label 879: @29847
     /* 29847 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(29892), // Rule ID 3019 //
     /* 29852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /* 29860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 29863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 29866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 29869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29881 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14629:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 29881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /* 29884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29888 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29890 */     GIR_RootConstrainSelectedInstOperands,
     /* 29891 */     // GIR_Coverage, 3019,
     /* 29891 */     GIR_EraseRootFromParent_Done,
     /* 29892 */   // Label 880: @29892
     /* 29892 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(29937), // Rule ID 3021 //
     /* 29897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /* 29905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 29911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 29914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29926 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14633:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 29926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /* 29929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29933 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29935 */     GIR_RootConstrainSelectedInstOperands,
     /* 29936 */     // GIR_Coverage, 3021,
     /* 29936 */     GIR_EraseRootFromParent_Done,
     /* 29937 */   // Label 881: @29937
     /* 29937 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(29982), // Rule ID 3023 //
     /* 29942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /* 29950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 29953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 29956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 29959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 29971 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14631:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /* 29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 29976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 29978 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 29980 */     GIR_RootConstrainSelectedInstOperands,
     /* 29981 */     // GIR_Coverage, 3023,
     /* 29981 */     GIR_EraseRootFromParent_Done,
     /* 29982 */   // Label 882: @29982
     /* 29982 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(30027), // Rule ID 3025 //
     /* 29987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 29990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /* 29995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 29998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30016 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14613:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /* 30019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30023 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30025 */     GIR_RootConstrainSelectedInstOperands,
     /* 30026 */     // GIR_Coverage, 3025,
     /* 30026 */     GIR_EraseRootFromParent_Done,
     /* 30027 */   // Label 883: @30027
     /* 30027 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(30072), // Rule ID 3027 //
     /* 30032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 30035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /* 30040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30061 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14619:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /* 30064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30068 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30070 */     GIR_RootConstrainSelectedInstOperands,
     /* 30071 */     // GIR_Coverage, 3027,
     /* 30071 */     GIR_EraseRootFromParent_Done,
     /* 30072 */   // Label 884: @30072
     /* 30072 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(30117), // Rule ID 3043 //
     /* 30077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 30080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /* 30085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 30088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 30091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 30094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30106 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13520:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 30106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /* 30109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30113 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30115 */     GIR_RootConstrainSelectedInstOperands,
     /* 30116 */     // GIR_Coverage, 3043,
     /* 30116 */     GIR_EraseRootFromParent_Done,
     /* 30117 */   // Label 885: @30117
     /* 30117 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(30162), // Rule ID 3045 //
     /* 30122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 30125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /* 30130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 30133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 30136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 30139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30151 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13522:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 30151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /* 30154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30158 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30160 */     GIR_RootConstrainSelectedInstOperands,
     /* 30161 */     // GIR_Coverage, 3045,
     /* 30161 */     GIR_EraseRootFromParent_Done,
     /* 30162 */   // Label 886: @30162
     /* 30162 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(30207), // Rule ID 3047 //
     /* 30167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 30170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /* 30175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 30178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 30181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 30184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30196 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13521:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 30196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /* 30199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30203 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30205 */     GIR_RootConstrainSelectedInstOperands,
     /* 30206 */     // GIR_Coverage, 3047,
     /* 30206 */     GIR_EraseRootFromParent_Done,
     /* 30207 */   // Label 887: @30207
     /* 30207 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(30252), // Rule ID 3049 //
     /* 30212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 30215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /* 30220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 30223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 30226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 30229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30241 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13507:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 30241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /* 30244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30246 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30248 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30250 */     GIR_RootConstrainSelectedInstOperands,
     /* 30251 */     // GIR_Coverage, 3049,
     /* 30251 */     GIR_EraseRootFromParent_Done,
     /* 30252 */   // Label 888: @30252
     /* 30252 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(30297), // Rule ID 3051 //
     /* 30257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 30260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /* 30265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 30268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 30271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 30274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 30286 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13510:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 30286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /* 30289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30295 */     GIR_RootConstrainSelectedInstOperands,
     /* 30296 */     // GIR_Coverage, 3051,
     /* 30296 */     GIR_EraseRootFromParent_Done,
     /* 30297 */   // Label 889: @30297
     /* 30297 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(30342), // Rule ID 3061 //
     /* 30302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /* 30310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30331 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14629:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 30331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /* 30334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30336 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30338 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30340 */     GIR_RootConstrainSelectedInstOperands,
     /* 30341 */     // GIR_Coverage, 3061,
     /* 30341 */     GIR_EraseRootFromParent_Done,
     /* 30342 */   // Label 890: @30342
     /* 30342 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(30387), // Rule ID 3063 //
     /* 30347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /* 30355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30376 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14633:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /* 30379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30383 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30385 */     GIR_RootConstrainSelectedInstOperands,
     /* 30386 */     // GIR_Coverage, 3063,
     /* 30386 */     GIR_EraseRootFromParent_Done,
     /* 30387 */   // Label 891: @30387
     /* 30387 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(30432), // Rule ID 3065 //
     /* 30392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /* 30400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30421 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14631:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /* 30424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30428 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30430 */     GIR_RootConstrainSelectedInstOperands,
     /* 30431 */     // GIR_Coverage, 3065,
     /* 30431 */     GIR_EraseRootFromParent_Done,
     /* 30432 */   // Label 892: @30432
     /* 30432 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(30477), // Rule ID 3069 //
     /* 30437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /* 30445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30466 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14613:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /* 30469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30473 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30475 */     GIR_RootConstrainSelectedInstOperands,
     /* 30476 */     // GIR_Coverage, 3069,
     /* 30476 */     GIR_EraseRootFromParent_Done,
     /* 30477 */   // Label 893: @30477
     /* 30477 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(30522), // Rule ID 3071 //
     /* 30482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 30485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /* 30490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30511 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14619:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 30511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /* 30514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30518 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30520 */     GIR_RootConstrainSelectedInstOperands,
     /* 30521 */     // GIR_Coverage, 3071,
     /* 30521 */     GIR_EraseRootFromParent_Done,
     /* 30522 */   // Label 894: @30522
     /* 30522 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(30567), // Rule ID 3306 //
     /* 30527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /* 30535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 30544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 30556 */     // (intrinsic_wo_chain:{ *:[i32] } 14587:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 30556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /* 30559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30563 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30565 */     GIR_RootConstrainSelectedInstOperands,
     /* 30566 */     // GIR_Coverage, 3306,
     /* 30566 */     GIR_EraseRootFromParent_Done,
     /* 30567 */   // Label 895: @30567
     /* 30567 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(30612), // Rule ID 3308 //
     /* 30572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /* 30580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 30589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 30601 */     // (intrinsic_wo_chain:{ *:[i32] } 14585:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 30601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /* 30604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30610 */     GIR_RootConstrainSelectedInstOperands,
     /* 30611 */     // GIR_Coverage, 3308,
     /* 30611 */     GIR_EraseRootFromParent_Done,
     /* 30612 */   // Label 896: @30612
     /* 30612 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(30657), // Rule ID 3310 //
     /* 30617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /* 30625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30646 */     // (intrinsic_wo_chain:{ *:[i32] } 14586:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 30646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /* 30649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30651 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30653 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30655 */     GIR_RootConstrainSelectedInstOperands,
     /* 30656 */     // GIR_Coverage, 3310,
     /* 30656 */     GIR_EraseRootFromParent_Done,
     /* 30657 */   // Label 897: @30657
     /* 30657 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(30702), // Rule ID 3312 //
     /* 30662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /* 30665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /* 30670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 30673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 30676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 30679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30691 */     // (intrinsic_wo_chain:{ *:[i64] } 14588:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 30691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /* 30694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30698 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30700 */     GIR_RootConstrainSelectedInstOperands,
     /* 30701 */     // GIR_Coverage, 3312,
     /* 30701 */     GIR_EraseRootFromParent_Done,
     /* 30702 */   // Label 898: @30702
     /* 30702 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(30747), // Rule ID 3314 //
     /* 30707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /* 30715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 30724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 30736 */     // (intrinsic_wo_chain:{ *:[i32] } 14587:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /* 30736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /* 30739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30745 */     GIR_RootConstrainSelectedInstOperands,
     /* 30746 */     // GIR_Coverage, 3314,
     /* 30746 */     GIR_EraseRootFromParent_Done,
     /* 30747 */   // Label 899: @30747
     /* 30747 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(30792), // Rule ID 3316 //
     /* 30752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /* 30760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 30769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 30781 */     // (intrinsic_wo_chain:{ *:[i32] } 14585:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /* 30781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /* 30784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30788 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30790 */     GIR_RootConstrainSelectedInstOperands,
     /* 30791 */     // GIR_Coverage, 3316,
     /* 30791 */     GIR_EraseRootFromParent_Done,
     /* 30792 */   // Label 900: @30792
     /* 30792 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(30837), // Rule ID 3318 //
     /* 30797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /* 30805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 30826 */     // (intrinsic_wo_chain:{ *:[i32] } 14586:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 30826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /* 30829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30831 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30835 */     GIR_RootConstrainSelectedInstOperands,
     /* 30836 */     // GIR_Coverage, 3318,
     /* 30836 */     GIR_EraseRootFromParent_Done,
     /* 30837 */   // Label 901: @30837
     /* 30837 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(30882), // Rule ID 3320 //
     /* 30842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /* 30845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /* 30850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 30853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 30856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 30859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 30871 */     // (intrinsic_wo_chain:{ *:[i64] } 14588:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 30871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /* 30874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30878 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30880 */     GIR_RootConstrainSelectedInstOperands,
     /* 30881 */     // GIR_Coverage, 3320,
     /* 30881 */     GIR_EraseRootFromParent_Done,
     /* 30882 */   // Label 902: @30882
     /* 30882 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(30927), // Rule ID 3324 //
     /* 30887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /* 30895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14457:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /* 30919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30923 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30925 */     GIR_RootConstrainSelectedInstOperands,
     /* 30926 */     // GIR_Coverage, 3324,
     /* 30926 */     GIR_EraseRootFromParent_Done,
     /* 30927 */   // Label 903: @30927
     /* 30927 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(30972), // Rule ID 3326 //
     /* 30932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /* 30940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14455:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 30961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /* 30964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 30966 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 30968 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 30970 */     GIR_RootConstrainSelectedInstOperands,
     /* 30971 */     // GIR_Coverage, 3326,
     /* 30971 */     GIR_EraseRootFromParent_Done,
     /* 30972 */   // Label 904: @30972
     /* 30972 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(31017), // Rule ID 3328 //
     /* 30977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 30980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /* 30985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 30998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31006 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14456:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /* 31009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31011 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31013 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31015 */     GIR_RootConstrainSelectedInstOperands,
     /* 31016 */     // GIR_Coverage, 3328,
     /* 31016 */     GIR_EraseRootFromParent_Done,
     /* 31017 */   // Label 905: @31017
     /* 31017 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(31062), // Rule ID 3332 //
     /* 31022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 31025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /* 31030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31051 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14459:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /* 31054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31058 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31060 */     GIR_RootConstrainSelectedInstOperands,
     /* 31061 */     // GIR_Coverage, 3332,
     /* 31061 */     GIR_EraseRootFromParent_Done,
     /* 31062 */   // Label 906: @31062
     /* 31062 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(31107), // Rule ID 3334 //
     /* 31067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 31070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /* 31075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14460:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /* 31099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31101 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31103 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31105 */     GIR_RootConstrainSelectedInstOperands,
     /* 31106 */     // GIR_Coverage, 3334,
     /* 31106 */     GIR_EraseRootFromParent_Done,
     /* 31107 */   // Label 907: @31107
     /* 31107 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(31152), // Rule ID 3336 //
     /* 31112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 31115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /* 31120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31141 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13061:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /* 31144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31148 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31150 */     GIR_RootConstrainSelectedInstOperands,
     /* 31151 */     // GIR_Coverage, 3336,
     /* 31151 */     GIR_EraseRootFromParent_Done,
     /* 31152 */   // Label 908: @31152
     /* 31152 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(31197), // Rule ID 3338 //
     /* 31157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 31160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /* 31165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31186 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13064:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /* 31189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31193 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31195 */     GIR_RootConstrainSelectedInstOperands,
     /* 31196 */     // GIR_Coverage, 3338,
     /* 31196 */     GIR_EraseRootFromParent_Done,
     /* 31197 */   // Label 909: @31197
     /* 31197 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(31242), // Rule ID 3340 //
     /* 31202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 31205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /* 31210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31231 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13055:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /* 31234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31236 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31238 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31240 */     GIR_RootConstrainSelectedInstOperands,
     /* 31241 */     // GIR_Coverage, 3340,
     /* 31241 */     GIR_EraseRootFromParent_Done,
     /* 31242 */   // Label 910: @31242
     /* 31242 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(31287), // Rule ID 3342 //
     /* 31247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /* 31250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /* 31255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31276 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13058:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /* 31279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31283 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31285 */     GIR_RootConstrainSelectedInstOperands,
     /* 31286 */     // GIR_Coverage, 3342,
     /* 31286 */     GIR_EraseRootFromParent_Done,
     /* 31287 */   // Label 911: @31287
     /* 31287 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(31332), // Rule ID 3344 //
     /* 31292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 31295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /* 31300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31321 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13062:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /* 31324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31328 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31330 */     GIR_RootConstrainSelectedInstOperands,
     /* 31331 */     // GIR_Coverage, 3344,
     /* 31331 */     GIR_EraseRootFromParent_Done,
     /* 31332 */   // Label 912: @31332
     /* 31332 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(31377), // Rule ID 3346 //
     /* 31337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 31340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /* 31345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31366 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13065:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /* 31369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31373 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31375 */     GIR_RootConstrainSelectedInstOperands,
     /* 31376 */     // GIR_Coverage, 3346,
     /* 31376 */     GIR_EraseRootFromParent_Done,
     /* 31377 */   // Label 913: @31377
     /* 31377 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(31422), // Rule ID 3348 //
     /* 31382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 31385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /* 31390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31411 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13056:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /* 31414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31418 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31420 */     GIR_RootConstrainSelectedInstOperands,
     /* 31421 */     // GIR_Coverage, 3348,
     /* 31421 */     GIR_EraseRootFromParent_Done,
     /* 31422 */   // Label 914: @31422
     /* 31422 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(31467), // Rule ID 3350 //
     /* 31427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /* 31430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /* 31435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31456 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13059:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /* 31459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31463 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31465 */     GIR_RootConstrainSelectedInstOperands,
     /* 31466 */     // GIR_Coverage, 3350,
     /* 31466 */     GIR_EraseRootFromParent_Done,
     /* 31467 */   // Label 915: @31467
     /* 31467 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(31512), // Rule ID 3352 //
     /* 31472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /* 31480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31501 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13061:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /* 31504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31510 */     GIR_RootConstrainSelectedInstOperands,
     /* 31511 */     // GIR_Coverage, 3352,
     /* 31511 */     GIR_EraseRootFromParent_Done,
     /* 31512 */   // Label 916: @31512
     /* 31512 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(31557), // Rule ID 3354 //
     /* 31517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /* 31525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31546 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13064:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /* 31549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31555 */     GIR_RootConstrainSelectedInstOperands,
     /* 31556 */     // GIR_Coverage, 3354,
     /* 31556 */     GIR_EraseRootFromParent_Done,
     /* 31557 */   // Label 917: @31557
     /* 31557 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(31602), // Rule ID 3356 //
     /* 31562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /* 31570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31591 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13055:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /* 31594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31598 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31600 */     GIR_RootConstrainSelectedInstOperands,
     /* 31601 */     // GIR_Coverage, 3356,
     /* 31601 */     GIR_EraseRootFromParent_Done,
     /* 31602 */   // Label 918: @31602
     /* 31602 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(31647), // Rule ID 3358 //
     /* 31607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /* 31610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /* 31615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31636 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13058:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /* 31639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31643 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31645 */     GIR_RootConstrainSelectedInstOperands,
     /* 31646 */     // GIR_Coverage, 3358,
     /* 31646 */     GIR_EraseRootFromParent_Done,
     /* 31647 */   // Label 919: @31647
     /* 31647 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(31692), // Rule ID 3375 //
     /* 31652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /* 31655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /* 31660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31681 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14603:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 31681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /* 31684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31686 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 31688 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /* 31690 */     GIR_RootConstrainSelectedInstOperands,
     /* 31691 */     // GIR_Coverage, 3375,
     /* 31691 */     GIR_EraseRootFromParent_Done,
     /* 31692 */   // Label 920: @31692
     /* 31692 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(31737), // Rule ID 3377 //
     /* 31697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /* 31700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /* 31705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31726 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14605:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /* 31726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /* 31729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31731 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 31733 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /* 31735 */     GIR_RootConstrainSelectedInstOperands,
     /* 31736 */     // GIR_Coverage, 3377,
     /* 31736 */     GIR_EraseRootFromParent_Done,
     /* 31737 */   // Label 921: @31737
     /* 31737 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(31782), // Rule ID 3552 //
     /* 31742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 31745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /* 31750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31771 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14754:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 31771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /* 31774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31778 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31780 */     GIR_RootConstrainSelectedInstOperands,
     /* 31781 */     // GIR_Coverage, 3552,
     /* 31781 */     GIR_EraseRootFromParent_Done,
     /* 31782 */   // Label 922: @31782
     /* 31782 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(31827), // Rule ID 3553 //
     /* 31787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 31790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /* 31795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 31798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 31801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 31804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31816 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14755:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 31816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /* 31819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31823 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31825 */     GIR_RootConstrainSelectedInstOperands,
     /* 31826 */     // GIR_Coverage, 3553,
     /* 31826 */     GIR_EraseRootFromParent_Done,
     /* 31827 */   // Label 923: @31827
     /* 31827 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(31872), // Rule ID 3561 //
     /* 31832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /* 31840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31861 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14760:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /* 31864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31868 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31870 */     GIR_RootConstrainSelectedInstOperands,
     /* 31871 */     // GIR_Coverage, 3561,
     /* 31871 */     GIR_EraseRootFromParent_Done,
     /* 31872 */   // Label 924: @31872
     /* 31872 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(31917), // Rule ID 3563 //
     /* 31877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /* 31885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 31888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 31891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 31894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31906 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14761:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 31906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /* 31909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31913 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31915 */     GIR_RootConstrainSelectedInstOperands,
     /* 31916 */     // GIR_Coverage, 3563,
     /* 31916 */     GIR_EraseRootFromParent_Done,
     /* 31917 */   // Label 925: @31917
     /* 31917 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(31962), // Rule ID 3565 //
     /* 31922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /* 31930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 31951 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14763:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 31951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /* 31954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 31956 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 31958 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 31960 */     GIR_RootConstrainSelectedInstOperands,
     /* 31961 */     // GIR_Coverage, 3565,
     /* 31961 */     GIR_EraseRootFromParent_Done,
     /* 31962 */   // Label 926: @31962
     /* 31962 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(32007), // Rule ID 3567 //
     /* 31967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 31970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /* 31975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 31978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 31981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 31984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 31996 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14764:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 31996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /* 31999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32003 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32005 */     GIR_RootConstrainSelectedInstOperands,
     /* 32006 */     // GIR_Coverage, 3567,
     /* 32006 */     GIR_EraseRootFromParent_Done,
     /* 32007 */   // Label 927: @32007
     /* 32007 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(32052), // Rule ID 14057 //
     /* 32012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /* 32020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32041 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13061:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 32041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /* 32044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32048 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32050 */     GIR_RootConstrainSelectedInstOperands,
     /* 32051 */     // GIR_Coverage, 14057,
     /* 32051 */     GIR_EraseRootFromParent_Done,
     /* 32052 */   // Label 928: @32052
     /* 32052 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(32097), // Rule ID 14059 //
     /* 32057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /* 32065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32086 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13062:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 32086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /* 32089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32093 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32095 */     GIR_RootConstrainSelectedInstOperands,
     /* 32096 */     // GIR_Coverage, 14059,
     /* 32096 */     GIR_EraseRootFromParent_Done,
     /* 32097 */   // Label 929: @32097
     /* 32097 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(32142), // Rule ID 14061 //
     /* 32102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 32105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /* 32110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32131 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13063:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 32131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /* 32134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32138 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32140 */     GIR_RootConstrainSelectedInstOperands,
     /* 32141 */     // GIR_Coverage, 14061,
     /* 32141 */     GIR_EraseRootFromParent_Done,
     /* 32142 */   // Label 930: @32142
     /* 32142 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(32187), // Rule ID 14063 //
     /* 32147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /* 32155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32176 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13064:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 32176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /* 32179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32185 */     GIR_RootConstrainSelectedInstOperands,
     /* 32186 */     // GIR_Coverage, 14063,
     /* 32186 */     GIR_EraseRootFromParent_Done,
     /* 32187 */   // Label 931: @32187
     /* 32187 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(32232), // Rule ID 14065 //
     /* 32192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /* 32200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32221 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13065:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 32221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /* 32224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32228 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32230 */     GIR_RootConstrainSelectedInstOperands,
     /* 32231 */     // GIR_Coverage, 14065,
     /* 32231 */     GIR_EraseRootFromParent_Done,
     /* 32232 */   // Label 932: @32232
     /* 32232 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(32277), // Rule ID 14067 //
     /* 32237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 32240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /* 32245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32266 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13066:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 32266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /* 32269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32273 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32275 */     GIR_RootConstrainSelectedInstOperands,
     /* 32276 */     // GIR_Coverage, 14067,
     /* 32276 */     GIR_EraseRootFromParent_Done,
     /* 32277 */   // Label 933: @32277
     /* 32277 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(32322), // Rule ID 14069 //
     /* 32282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /* 32290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32311 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13055:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 32311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /* 32314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32318 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32320 */     GIR_RootConstrainSelectedInstOperands,
     /* 32321 */     // GIR_Coverage, 14069,
     /* 32321 */     GIR_EraseRootFromParent_Done,
     /* 32322 */   // Label 934: @32322
     /* 32322 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(32367), // Rule ID 14071 //
     /* 32327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /* 32335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32356 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13056:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 32356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /* 32359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32365 */     GIR_RootConstrainSelectedInstOperands,
     /* 32366 */     // GIR_Coverage, 14071,
     /* 32366 */     GIR_EraseRootFromParent_Done,
     /* 32367 */   // Label 935: @32367
     /* 32367 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(32412), // Rule ID 14073 //
     /* 32372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 32375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /* 32380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32401 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13057:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 32401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /* 32404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32408 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32410 */     GIR_RootConstrainSelectedInstOperands,
     /* 32411 */     // GIR_Coverage, 14073,
     /* 32411 */     GIR_EraseRootFromParent_Done,
     /* 32412 */   // Label 936: @32412
     /* 32412 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(32457), // Rule ID 14075 //
     /* 32417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /* 32425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 32446 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13058:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 32446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /* 32449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32453 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32455 */     GIR_RootConstrainSelectedInstOperands,
     /* 32456 */     // GIR_Coverage, 14075,
     /* 32456 */     GIR_EraseRootFromParent_Done,
     /* 32457 */   // Label 937: @32457
     /* 32457 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(32502), // Rule ID 14077 //
     /* 32462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /* 32465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /* 32470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 32473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 32476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 32479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 32491 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13059:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 32491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /* 32494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32498 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32500 */     GIR_RootConstrainSelectedInstOperands,
     /* 32501 */     // GIR_Coverage, 14077,
     /* 32501 */     GIR_EraseRootFromParent_Done,
     /* 32502 */   // Label 938: @32502
     /* 32502 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(32547), // Rule ID 14079 //
     /* 32507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /* 32510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /* 32515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 32518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 32521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 32524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32536 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13060:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 32536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /* 32539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32543 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32545 */     GIR_RootConstrainSelectedInstOperands,
     /* 32546 */     // GIR_Coverage, 14079,
     /* 32546 */     GIR_EraseRootFromParent_Done,
     /* 32547 */   // Label 939: @32547
     /* 32547 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(32592), // Rule ID 17240 //
     /* 32552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /* 32555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /* 32560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 32563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 32566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 32569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32581 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14762:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 32581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /* 32584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32588 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32590 */     GIR_RootConstrainSelectedInstOperands,
     /* 32591 */     // GIR_Coverage, 17240,
     /* 32591 */     GIR_EraseRootFromParent_Done,
     /* 32592 */   // Label 940: @32592
     /* 32592 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(32637), // Rule ID 17246 //
     /* 32597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /* 32600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /* 32605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 32608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 32611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 32614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 32626 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14765:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 32626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /* 32629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32633 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32635 */     GIR_RootConstrainSelectedInstOperands,
     /* 32636 */     // GIR_Coverage, 17246,
     /* 32636 */     GIR_EraseRootFromParent_Done,
     /* 32637 */   // Label 941: @32637
     /* 32637 */   GIM_Reject,
     /* 32638 */ // Label 873: @32638
     /* 32638 */ GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(34123),
     /* 32643 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 32646 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(32696), // Rule ID 3250 //
     /* 32651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoAVX10_2),
     /* 32654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /* 32659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32680 */     // MIs[0] src3
     /* 32680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32683 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14572:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /* 32686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32690 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32692 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32694 */     GIR_RootConstrainSelectedInstOperands,
     /* 32695 */     // GIR_Coverage, 3250,
     /* 32695 */     GIR_EraseRootFromParent_Done,
     /* 32696 */   // Label 943: @32696
     /* 32696 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(32746), // Rule ID 3252 //
     /* 32701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoAVX10_2),
     /* 32704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /* 32709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32730 */     // MIs[0] src3
     /* 32730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32733 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14571:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /* 32736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32740 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32742 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32744 */     GIR_RootConstrainSelectedInstOperands,
     /* 32745 */     // GIR_Coverage, 3252,
     /* 32745 */     GIR_EraseRootFromParent_Done,
     /* 32746 */   // Label 944: @32746
     /* 32746 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(32796), // Rule ID 3254 //
     /* 32751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoAVX10_2),
     /* 32754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /* 32759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 32762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 32765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 32768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 32780 */     // MIs[0] src3
     /* 32780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32783 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13093:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /* 32786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32790 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32792 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32794 */     GIR_RootConstrainSelectedInstOperands,
     /* 32795 */     // GIR_Coverage, 3254,
     /* 32795 */     GIR_EraseRootFromParent_Done,
     /* 32796 */   // Label 945: @32796
     /* 32796 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(32846), // Rule ID 3260 //
     /* 32801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 32804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /* 32809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32830 */     // MIs[0] src3
     /* 32830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32833 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14572:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /* 32836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32840 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32842 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32844 */     GIR_RootConstrainSelectedInstOperands,
     /* 32845 */     // GIR_Coverage, 3260,
     /* 32845 */     GIR_EraseRootFromParent_Done,
     /* 32846 */   // Label 946: @32846
     /* 32846 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(32896), // Rule ID 3262 //
     /* 32851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 32854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /* 32859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32880 */     // MIs[0] src3
     /* 32880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32883 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14571:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /* 32886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32890 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32892 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32894 */     GIR_RootConstrainSelectedInstOperands,
     /* 32895 */     // GIR_Coverage, 3262,
     /* 32895 */     GIR_EraseRootFromParent_Done,
     /* 32896 */   // Label 947: @32896
     /* 32896 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(32946), // Rule ID 3322 //
     /* 32901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 32904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /* 32909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32930 */     // MIs[0] src3
     /* 32930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32933 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14458:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /* 32936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32940 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32942 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32944 */     GIR_RootConstrainSelectedInstOperands,
     /* 32945 */     // GIR_Coverage, 3322,
     /* 32945 */     GIR_EraseRootFromParent_Done,
     /* 32946 */   // Label 948: @32946
     /* 32946 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(32996), // Rule ID 3368 //
     /* 32951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /* 32954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /* 32959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 32980 */     // MIs[0] src3
     /* 32980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 32983 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14423:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 32983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /* 32986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 32990 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 32992 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 32994 */     GIR_RootConstrainSelectedInstOperands,
     /* 32995 */     // GIR_Coverage, 3368,
     /* 32995 */     GIR_EraseRootFromParent_Done,
     /* 32996 */   // Label 949: @32996
     /* 32996 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(33046), // Rule ID 3370 //
     /* 33001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /* 33004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /* 33009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 33015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 33018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33030 */     // MIs[0] src3
     /* 33030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 33033 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14423:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 33033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /* 33036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33040 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33042 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33044 */     GIR_RootConstrainSelectedInstOperands,
     /* 33045 */     // GIR_Coverage, 3370,
     /* 33045 */     GIR_EraseRootFromParent_Done,
     /* 33046 */   // Label 950: @33046
     /* 33046 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(33096), // Rule ID 3372 //
     /* 33051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /* 33054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /* 33059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 33062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 33065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 33068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33080 */     // MIs[0] src3
     /* 33080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 33083 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14424:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 33083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /* 33086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33088 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33090 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33092 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33094 */     GIR_RootConstrainSelectedInstOperands,
     /* 33095 */     // GIR_Coverage, 3372,
     /* 33095 */     GIR_EraseRootFromParent_Done,
     /* 33096 */   // Label 951: @33096
     /* 33096 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(33146), // Rule ID 14081 //
     /* 33101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /* 33104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /* 33109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 33112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 33115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 33118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 33122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 33126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 33130 */     // MIs[0] src3
     /* 33130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 33133 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14425:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 33133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /* 33136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33140 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33142 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33144 */     GIR_RootConstrainSelectedInstOperands,
     /* 33145 */     // GIR_Coverage, 14081,
     /* 33145 */     GIR_EraseRootFromParent_Done,
     /* 33146 */   // Label 952: @33146
     /* 33146 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(33196), // Rule ID 14083 //
     /* 33151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /* 33154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /* 33159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 33165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 33168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 33172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 33176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 33180 */     // MIs[0] src3
     /* 33180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 33183 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14423:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 33183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /* 33186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33190 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33192 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33194 */     GIR_RootConstrainSelectedInstOperands,
     /* 33195 */     // GIR_Coverage, 14083,
     /* 33195 */     GIR_EraseRootFromParent_Done,
     /* 33196 */   // Label 953: @33196
     /* 33196 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(33246), // Rule ID 14085 //
     /* 33201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /* 33204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /* 33209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 33212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 33215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 33218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 33222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 33226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 33230 */     // MIs[0] src3
     /* 33230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 33233 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14424:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /* 33233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /* 33236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33240 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33242 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33244 */     GIR_RootConstrainSelectedInstOperands,
     /* 33245 */     // GIR_Coverage, 14085,
     /* 33245 */     GIR_EraseRootFromParent_Done,
     /* 33246 */   // Label 954: @33246
     /* 33246 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(33300), // Rule ID 1616 //
     /* 33251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /* 33259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33287 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14817:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /* 33290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33296 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33298 */     GIR_RootConstrainSelectedInstOperands,
     /* 33299 */     // GIR_Coverage, 1616,
     /* 33299 */     GIR_EraseRootFromParent_Done,
     /* 33300 */   // Label 955: @33300
     /* 33300 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(33354), // Rule ID 1618 //
     /* 33305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /* 33313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33341 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14816:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /* 33344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33348 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33350 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33352 */     GIR_RootConstrainSelectedInstOperands,
     /* 33353 */     // GIR_Coverage, 1618,
     /* 33353 */     GIR_EraseRootFromParent_Done,
     /* 33354 */   // Label 956: @33354
     /* 33354 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(33408), // Rule ID 1620 //
     /* 33359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /* 33367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 33370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 33379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33395 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14815:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /* 33395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /* 33398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33402 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33404 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33406 */     GIR_RootConstrainSelectedInstOperands,
     /* 33407 */     // GIR_Coverage, 1620,
     /* 33407 */     GIR_EraseRootFromParent_Done,
     /* 33408 */   // Label 957: @33408
     /* 33408 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(33462), // Rule ID 1622 //
     /* 33413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /* 33421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33449 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14814:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /* 33452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33456 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33458 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33460 */     GIR_RootConstrainSelectedInstOperands,
     /* 33461 */     // GIR_Coverage, 1622,
     /* 33461 */     GIR_EraseRootFromParent_Done,
     /* 33462 */   // Label 958: @33462
     /* 33462 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(33516), // Rule ID 1624 //
     /* 33467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /* 33475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 33478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 33487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33503 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14813:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /* 33503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /* 33506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33510 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33512 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33514 */     GIR_RootConstrainSelectedInstOperands,
     /* 33515 */     // GIR_Coverage, 1624,
     /* 33515 */     GIR_EraseRootFromParent_Done,
     /* 33516 */   // Label 959: @33516
     /* 33516 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(33570), // Rule ID 1626 //
     /* 33521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /* 33529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 33535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 33538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33557 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14812:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /* 33560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33562 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33564 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33566 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33568 */     GIR_RootConstrainSelectedInstOperands,
     /* 33569 */     // GIR_Coverage, 1626,
     /* 33569 */     GIR_EraseRootFromParent_Done,
     /* 33570 */   // Label 960: @33570
     /* 33570 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(33624), // Rule ID 1628 //
     /* 33575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /* 33583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33611 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14811:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /* 33614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33618 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33620 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33622 */     GIR_RootConstrainSelectedInstOperands,
     /* 33623 */     // GIR_Coverage, 1628,
     /* 33623 */     GIR_EraseRootFromParent_Done,
     /* 33624 */   // Label 961: @33624
     /* 33624 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(33678), // Rule ID 1630 //
     /* 33629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /* 33637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33665 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14810:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /* 33668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33672 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33674 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33676 */     GIR_RootConstrainSelectedInstOperands,
     /* 33677 */     // GIR_Coverage, 1630,
     /* 33677 */     GIR_EraseRootFromParent_Done,
     /* 33678 */   // Label 962: @33678
     /* 33678 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(33732), // Rule ID 1632 //
     /* 33683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /* 33691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33719 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14809:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /* 33722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33726 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33728 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33730 */     GIR_RootConstrainSelectedInstOperands,
     /* 33731 */     // GIR_Coverage, 1632,
     /* 33731 */     GIR_EraseRootFromParent_Done,
     /* 33732 */   // Label 963: @33732
     /* 33732 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(33786), // Rule ID 1634 //
     /* 33737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /* 33745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33773 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14808:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /* 33776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33778 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33782 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33784 */     GIR_RootConstrainSelectedInstOperands,
     /* 33785 */     // GIR_Coverage, 1634,
     /* 33785 */     GIR_EraseRootFromParent_Done,
     /* 33786 */   // Label 964: @33786
     /* 33786 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(33840), // Rule ID 1636 //
     /* 33791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /* 33799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 33802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33827 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14807:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 33827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /* 33830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33834 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33836 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33838 */     GIR_RootConstrainSelectedInstOperands,
     /* 33839 */     // GIR_Coverage, 1636,
     /* 33839 */     GIR_EraseRootFromParent_Done,
     /* 33840 */   // Label 965: @33840
     /* 33840 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(33894), // Rule ID 1638 //
     /* 33845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 33848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /* 33853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33881 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14806:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 33881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /* 33884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33888 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33890 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 33892 */     GIR_RootConstrainSelectedInstOperands,
     /* 33893 */     // GIR_Coverage, 1638,
     /* 33893 */     GIR_EraseRootFromParent_Done,
     /* 33894 */   // Label 966: @33894
     /* 33894 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(33960), // Rule ID 3330 //
     /* 33899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 33902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 33907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 33910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 33913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 33916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 33919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 33935 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14461:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 33935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 33939 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 33945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 33949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 33952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 33954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 33956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 33958 */     GIR_RootConstrainSelectedInstOperands,
     /* 33959 */     // GIR_Coverage, 3330,
     /* 33959 */     GIR_EraseRootFromParent_Done,
     /* 33960 */   // Label 967: @33960
     /* 33960 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(34014), // Rule ID 3554 //
     /* 33965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 33968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 33973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 33976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 33979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 33982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 33985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 33997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34001 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14756:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 34001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 34004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 34008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 34010 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 34012 */     GIR_RootConstrainSelectedInstOperands,
     /* 34013 */     // GIR_Coverage, 3554,
     /* 34013 */     GIR_EraseRootFromParent_Done,
     /* 34014 */   // Label 968: @34014
     /* 34014 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(34068), // Rule ID 3555 //
     /* 34019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 34022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 34027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 34030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 34033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 34036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 34039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34055 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14757:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 34055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 34058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 34062 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 34064 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 34066 */     GIR_RootConstrainSelectedInstOperands,
     /* 34067 */     // GIR_Coverage, 3555,
     /* 34067 */     GIR_EraseRootFromParent_Done,
     /* 34068 */   // Label 969: @34068
     /* 34068 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(34122), // Rule ID 3557 //
     /* 34073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 34076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 34081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 34084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 34087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 34090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 34093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14758:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 34109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 34112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 34116 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 34118 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 34120 */     GIR_RootConstrainSelectedInstOperands,
     /* 34121 */     // GIR_Coverage, 3557,
     /* 34121 */     GIR_EraseRootFromParent_Done,
     /* 34122 */   // Label 970: @34122
     /* 34122 */   GIM_Reject,
     /* 34123 */ // Label 942: @34123
     /* 34123 */ GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(34185), // Rule ID 3559 //
     /* 34128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 34131 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 34134 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 34139 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 34142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 34145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 34148 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 34151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34163 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 34167 */   // MIs[0] src4
     /* 34167 */   GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 34170 */   // (intrinsic_wo_chain:{ *:[v4i32] } 14759:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 34170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rr),
     /* 34173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34175 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 34177 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 34179 */   GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 34181 */   GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 34183 */   GIR_RootConstrainSelectedInstOperands,
     /* 34184 */   // GIR_Coverage, 3559,
     /* 34184 */   GIR_EraseRootFromParent_Done,
     /* 34185 */ // Label 971: @34185
     /* 34185 */ GIM_Reject,
     /* 34186 */ // Label 11: @34186
     /* 34186 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(34745),
     /* 34191 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 34194 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(34216), // Rule ID 149 //
     /* 34199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 34202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 34207 */     // (intrinsic_void 14453:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 34207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 34210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34214 */     GIR_RootConstrainSelectedInstOperands,
     /* 34215 */     // GIR_Coverage, 149,
     /* 34215 */     GIR_EraseRootFromParent_Done,
     /* 34216 */   // Label 973: @34216
     /* 34216 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(34238), // Rule ID 150 //
     /* 34221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 34224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 34229 */     // (intrinsic_void 14841:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 34229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 34232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34236 */     GIR_RootConstrainSelectedInstOperands,
     /* 34237 */     // GIR_Coverage, 150,
     /* 34237 */     GIR_EraseRootFromParent_Done,
     /* 34238 */   // Label 974: @34238
     /* 34238 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(34260), // Rule ID 151 //
     /* 34243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 34246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 34251 */     // (intrinsic_void 14827:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 34251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 34254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34258 */     GIR_RootConstrainSelectedInstOperands,
     /* 34259 */     // GIR_Coverage, 151,
     /* 34259 */     GIR_EraseRootFromParent_Done,
     /* 34260 */   // Label 975: @34260
     /* 34260 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(34282), // Rule ID 152 //
     /* 34265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 34268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 34273 */     // (intrinsic_void 14311:{ *:[iPTR] })  =>  (CLUI)
     /* 34273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 34276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34280 */     GIR_RootConstrainSelectedInstOperands,
     /* 34281 */     // GIR_Coverage, 152,
     /* 34281 */     GIR_EraseRootFromParent_Done,
     /* 34282 */   // Label 976: @34282
     /* 34282 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(34304), // Rule ID 153 //
     /* 34287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 34290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 34295 */     // (intrinsic_void 14635:{ *:[iPTR] })  =>  (STUI)
     /* 34295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 34298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34302 */     GIR_RootConstrainSelectedInstOperands,
     /* 34303 */     // GIR_Coverage, 153,
     /* 34303 */     GIR_EraseRootFromParent_Done,
     /* 34304 */   // Label 977: @34304
     /* 34304 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(34323), // Rule ID 2507 //
     /* 34309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 34314 */     // (intrinsic_void 14530:{ *:[iPTR] })  =>  (PAUSE)
     /* 34314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 34317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34321 */     GIR_RootConstrainSelectedInstOperands,
     /* 34322 */     // GIR_Coverage, 2507,
     /* 34322 */     GIR_EraseRootFromParent_Done,
     /* 34323 */   // Label 978: @34323
     /* 34323 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(34345), // Rule ID 2508 //
     /* 34328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 34331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 34336 */     // (intrinsic_void 14492:{ *:[iPTR] })  =>  (SFENCE)
     /* 34336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 34339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34343 */     GIR_RootConstrainSelectedInstOperands,
     /* 34344 */     // GIR_Coverage, 2508,
     /* 34344 */     GIR_EraseRootFromParent_Done,
     /* 34345 */   // Label 979: @34345
     /* 34345 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(34367), // Rule ID 2509 //
     /* 34350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 34353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 34358 */     // (intrinsic_void 14519:{ *:[iPTR] })  =>  (LFENCE)
     /* 34358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 34361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34365 */     GIR_RootConstrainSelectedInstOperands,
     /* 34366 */     // GIR_Coverage, 2509,
     /* 34366 */     GIR_EraseRootFromParent_Done,
     /* 34367 */   // Label 980: @34367
     /* 34367 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(34389), // Rule ID 2510 //
     /* 34372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 34375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 34380 */     // (intrinsic_void 14523:{ *:[iPTR] })  =>  (MFENCE)
     /* 34380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 34383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34387 */     GIR_RootConstrainSelectedInstOperands,
     /* 34388 */     // GIR_Coverage, 2510,
     /* 34388 */     GIR_EraseRootFromParent_Done,
     /* 34389 */   // Label 981: @34389
     /* 34389 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(34455), // Rule ID 3424 //
     /* 34394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 34397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 34402 */     // (intrinsic_void 13136:{ *:[iPTR] })  =>  (VZEROALL)
     /* 34402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 34405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 34408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 34411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 34414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 34417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 34420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 34423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 34426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 34429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 34432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 34435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 34438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 34441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 34444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 34447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 34450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 34453 */     GIR_RootConstrainSelectedInstOperands,
     /* 34454 */     // GIR_Coverage, 3424,
     /* 34454 */     GIR_EraseRootFromParent_Done,
     /* 34455 */   // Label 982: @34455
     /* 34455 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(34521), // Rule ID 3425 //
     /* 34460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 34463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 34468 */     // (intrinsic_void 13137:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 34468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 34471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 34474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 34477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 34480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 34483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 34486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 34489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 34492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 34495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 34498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 34501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 34504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 34507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 34510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 34513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 34516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 34519 */     GIR_RootConstrainSelectedInstOperands,
     /* 34520 */     // GIR_Coverage, 3425,
     /* 34520 */     GIR_EraseRootFromParent_Done,
     /* 34521 */   // Label 983: @34521
     /* 34521 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(34591), // Rule ID 17249 //
     /* 34526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 34529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 34534 */     // (intrinsic_void 14346:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 34534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 34537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 34540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 34543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 34546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 34549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 34552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 34555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 34558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 34561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 34564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 34567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 34570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 34573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 34576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 34579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 34582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 34585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34589 */     GIR_RootConstrainSelectedInstOperands,
     /* 34590 */     // GIR_Coverage, 17249,
     /* 34590 */     GIR_EraseRootFromParent_Done,
     /* 34591 */   // Label 984: @34591
     /* 34591 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(34613), // Rule ID 17432 //
     /* 34596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 34599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 34604 */     // (intrinsic_void 14779:{ *:[iPTR] })  =>  (XEND)
     /* 34604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 34607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34611 */     GIR_RootConstrainSelectedInstOperands,
     /* 34612 */     // GIR_Coverage, 17432,
     /* 34612 */     GIR_EraseRootFromParent_Done,
     /* 34613 */   // Label 985: @34613
     /* 34613 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(34659), // Rule ID 17444 //
     /* 34618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 34621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 34626 */     // (intrinsic_void 14705:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 34626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 34629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 34632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 34635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 34638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 34641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 34644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 34647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 34650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 34653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34657 */     GIR_RootConstrainSelectedInstOperands,
     /* 34658 */     // GIR_Coverage, 17444,
     /* 34658 */     GIR_EraseRootFromParent_Done,
     /* 34659 */   // Label 986: @34659
     /* 34659 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(34678), // Rule ID 17533 //
     /* 34664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 34669 */     // (intrinsic_void 14766:{ *:[iPTR] })  =>  (WBINVD)
     /* 34669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 34672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34676 */     GIR_RootConstrainSelectedInstOperands,
     /* 34677 */     // GIR_Coverage, 17533,
     /* 34677 */     GIR_EraseRootFromParent_Done,
     /* 34678 */   // Label 987: @34678
     /* 34678 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(34700), // Rule ID 17534 //
     /* 34683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 34686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 34691 */     // (intrinsic_void 14767:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 34691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 34694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34698 */     GIR_RootConstrainSelectedInstOperands,
     /* 34699 */     // GIR_Coverage, 17534,
     /* 34699 */     GIR_EraseRootFromParent_Done,
     /* 34700 */   // Label 988: @34700
     /* 34700 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(34722), // Rule ID 17539 //
     /* 34705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 34710 */     // (intrinsic_void 14448:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 34710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 34713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 34716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34720 */     GIR_RootConstrainSelectedInstOperands,
     /* 34721 */     // GIR_Coverage, 17539,
     /* 34721 */     GIR_EraseRootFromParent_Done,
     /* 34722 */   // Label 989: @34722
     /* 34722 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(34744), // Rule ID 17549 //
     /* 34727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 34732 */     // (intrinsic_void 14454:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 34732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 34735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 34738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34742 */     GIR_RootConstrainSelectedInstOperands,
     /* 34743 */     // GIR_Coverage, 17549,
     /* 34743 */     GIR_EraseRootFromParent_Done,
     /* 34744 */   // Label 990: @34744
     /* 34744 */   GIM_Reject,
     /* 34745 */ // Label 972: @34745
     /* 34745 */ GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(35754),
     /* 34750 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 34753 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(34783), // Rule ID 17522 //
     /* 34758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 34763 */     // MIs[0] Operand 1
     /* 34763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 34774 */     // (intrinsic_void 14336:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 34774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 34777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34781 */     GIR_RootConstrainSelectedInstOperands,
     /* 34782 */     // GIR_Coverage, 17522,
     /* 34782 */     GIR_EraseRootFromParent_Done,
     /* 34783 */   // Label 992: @34783
     /* 34783 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(34810), // Rule ID 17434 //
     /* 34788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 34791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 34796 */     // MIs[0] imm
     /* 34796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 34799 */     // (intrinsic_void 14777:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 34799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 34802 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 34804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34808 */     GIR_RootConstrainSelectedInstOperands,
     /* 34809 */     // GIR_Coverage, 17434,
     /* 34809 */     GIR_EraseRootFromParent_Done,
     /* 34810 */   // Label 993: @34810
     /* 34810 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(34837), // Rule ID 17446 //
     /* 34815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 34818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 34823 */     // MIs[0] src
     /* 34823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 34826 */     // (intrinsic_void 14708:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 34829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 34831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34835 */     GIR_RootConstrainSelectedInstOperands,
     /* 34836 */     // GIR_Coverage, 17446,
     /* 34836 */     GIR_EraseRootFromParent_Done,
     /* 34837 */   // Label 994: @34837
     /* 34837 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(34861), // Rule ID 17524 //
     /* 34842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 34847 */     // MIs[0] trap
     /* 34847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 34850 */     // (intrinsic_void 14336:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 34850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 34853 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 34855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34859 */     GIR_RootConstrainSelectedInstOperands,
     /* 34860 */     // GIR_Coverage, 17524,
     /* 34860 */     GIR_EraseRootFromParent_Done,
     /* 34861 */   // Label 995: @34861
     /* 34861 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(34895), // Rule ID 1 //
     /* 34866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 34869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 34874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34881 */     // (intrinsic_w_chain:{ *:[i32] } 14322:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 34881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 34884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 34889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34893 */     GIR_RootConstrainSelectedInstOperands,
     /* 34894 */     // GIR_Coverage, 1,
     /* 34894 */     GIR_EraseRootFromParent_Done,
     /* 34895 */   // Label 996: @34895
     /* 34895 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(34929), // Rule ID 2 //
     /* 34900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 34903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 34908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 34911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34915 */     // (intrinsic_w_chain:{ *:[i64] } 14323:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 34915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 34918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 34923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34927 */     GIR_RootConstrainSelectedInstOperands,
     /* 34928 */     // GIR_Coverage, 2,
     /* 34928 */     GIR_EraseRootFromParent_Done,
     /* 34929 */   // Label 997: @34929
     /* 34929 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(34960), // Rule ID 115 //
     /* 34934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 34937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 34942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 34949 */     // (intrinsic_w_chain:{ *:[i32] } 14462:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 34949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 34952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34958 */     GIR_RootConstrainSelectedInstOperands,
     /* 34959 */     // GIR_Coverage, 115,
     /* 34959 */     GIR_EraseRootFromParent_Done,
     /* 34960 */   // Label 998: @34960
     /* 34960 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(34991), // Rule ID 117 //
     /* 34965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 34968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 34973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 34976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 34980 */     // (intrinsic_w_chain:{ *:[i64] } 14462:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 34980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 34983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 34985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34989 */     GIR_RootConstrainSelectedInstOperands,
     /* 34990 */     // GIR_Coverage, 117,
     /* 34990 */     GIR_EraseRootFromParent_Done,
     /* 34991 */   // Label 999: @34991
     /* 34991 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(35022), // Rule ID 17431 //
     /* 34996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 34999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 35004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35011 */     // (intrinsic_w_chain:{ *:[i32] } 14778:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 35011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 35014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35020 */     GIR_RootConstrainSelectedInstOperands,
     /* 35021 */     // GIR_Coverage, 17431,
     /* 35021 */     GIR_EraseRootFromParent_Done,
     /* 35022 */   // Label 1000: @35022
     /* 35022 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(35053), // Rule ID 17566 //
     /* 35027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 35035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35042 */     // (intrinsic_w_chain:{ *:[i32] } 14429:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 35042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 35045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35051 */     GIR_RootConstrainSelectedInstOperands,
     /* 35052 */     // GIR_Coverage, 17566,
     /* 35052 */     GIR_EraseRootFromParent_Done,
     /* 35053 */   // Label 1001: @35053
     /* 35053 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(35084), // Rule ID 17567 //
     /* 35058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 35066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35073 */     // (intrinsic_w_chain:{ *:[i64] } 14430:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 35073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 35076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35082 */     GIR_RootConstrainSelectedInstOperands,
     /* 35083 */     // GIR_Coverage, 17567,
     /* 35083 */     GIR_EraseRootFromParent_Done,
     /* 35084 */   // Label 1002: @35084
     /* 35084 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(35115), // Rule ID 17568 //
     /* 35089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 35097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35104 */     // (intrinsic_w_chain:{ *:[i32] } 14431:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 35104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 35107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35113 */     GIR_RootConstrainSelectedInstOperands,
     /* 35114 */     // GIR_Coverage, 17568,
     /* 35114 */     GIR_EraseRootFromParent_Done,
     /* 35115 */   // Label 1003: @35115
     /* 35115 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(35146), // Rule ID 17569 //
     /* 35120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 35128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35135 */     // (intrinsic_w_chain:{ *:[i64] } 14432:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 35135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 35138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35144 */     GIR_RootConstrainSelectedInstOperands,
     /* 35145 */     // GIR_Coverage, 17569,
     /* 35145 */     GIR_EraseRootFromParent_Done,
     /* 35146 */   // Label 1004: @35146
     /* 35146 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(35177), // Rule ID 17575 //
     /* 35151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 35154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 35159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35166 */     // (intrinsic_w_chain:{ *:[i32] } 14433:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 35166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 35169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35175 */     GIR_RootConstrainSelectedInstOperands,
     /* 35176 */     // GIR_Coverage, 17575,
     /* 35176 */     GIR_EraseRootFromParent_Done,
     /* 35177 */   // Label 1005: @35177
     /* 35177 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(35234), // Rule ID 22828 //
     /* 35182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 35185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 35190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35197 */     // (intrinsic_w_chain:{ *:[i32] } 14433:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 35197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 35200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 35204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 35209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 35211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 35214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 35223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 35228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 35233 */     // GIR_Coverage, 22828,
     /* 35233 */     GIR_EraseRootFromParent_Done,
     /* 35234 */   // Label 1006: @35234
     /* 35234 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(35274), // Rule ID 3 //
     /* 35239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 35242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 35247 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35254 */     // (intrinsic_void 14324:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 35254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 35257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 35262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 35265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 35268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35272 */     GIR_RootConstrainSelectedInstOperands,
     /* 35273 */     // GIR_Coverage, 3,
     /* 35273 */     GIR_EraseRootFromParent_Done,
     /* 35274 */   // Label 1007: @35274
     /* 35274 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(35314), // Rule ID 4 //
     /* 35279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 35282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 35287 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35294 */     // (intrinsic_void 14325:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 35294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 35297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 35302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 35305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 35308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35312 */     GIR_RootConstrainSelectedInstOperands,
     /* 35313 */     // GIR_Coverage, 4,
     /* 35313 */     GIR_EraseRootFromParent_Done,
     /* 35314 */   // Label 1008: @35314
     /* 35314 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(35345), // Rule ID 154 //
     /* 35319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 35322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 35327 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35334 */     // (intrinsic_void 14452:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 35334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 35337 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 35339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35343 */     GIR_RootConstrainSelectedInstOperands,
     /* 35344 */     // GIR_Coverage, 154,
     /* 35344 */     GIR_EraseRootFromParent_Done,
     /* 35345 */   // Label 1009: @35345
     /* 35345 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(35376), // Rule ID 17535 //
     /* 35350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 35355 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35362 */     // (intrinsic_void 14334:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 35365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 35370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35374 */     GIR_RootConstrainSelectedInstOperands,
     /* 35375 */     // GIR_Coverage, 17535,
     /* 35375 */     GIR_EraseRootFromParent_Done,
     /* 35376 */   // Label 1010: @35376
     /* 35376 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(35407), // Rule ID 17536 //
     /* 35381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 35386 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35393 */     // (intrinsic_void 14335:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 35393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 35396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 35401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35405 */     GIR_RootConstrainSelectedInstOperands,
     /* 35406 */     // GIR_Coverage, 17536,
     /* 35406 */     GIR_EraseRootFromParent_Done,
     /* 35407 */   // Label 1011: @35407
     /* 35407 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(35438), // Rule ID 17570 //
     /* 35412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 35420 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35427 */     // (intrinsic_void 14768:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 35427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 35430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35436 */     GIR_RootConstrainSelectedInstOperands,
     /* 35437 */     // GIR_Coverage, 17570,
     /* 35437 */     GIR_EraseRootFromParent_Done,
     /* 35438 */   // Label 1012: @35438
     /* 35438 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(35469), // Rule ID 17571 //
     /* 35443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 35451 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35458 */     // (intrinsic_void 14769:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 35458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 35461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35467 */     GIR_RootConstrainSelectedInstOperands,
     /* 35468 */     // GIR_Coverage, 17571,
     /* 35468 */     GIR_EraseRootFromParent_Done,
     /* 35469 */   // Label 1013: @35469
     /* 35469 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(35500), // Rule ID 17572 //
     /* 35474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 35482 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35489 */     // (intrinsic_void 14770:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 35489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 35492 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35498 */     GIR_RootConstrainSelectedInstOperands,
     /* 35499 */     // GIR_Coverage, 17572,
     /* 35499 */     GIR_EraseRootFromParent_Done,
     /* 35500 */   // Label 1014: @35500
     /* 35500 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(35531), // Rule ID 17573 //
     /* 35505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 35508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 35513 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35520 */     // (intrinsic_void 14771:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 35520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 35523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35529 */     GIR_RootConstrainSelectedInstOperands,
     /* 35530 */     // GIR_Coverage, 17573,
     /* 35530 */     GIR_EraseRootFromParent_Done,
     /* 35531 */   // Label 1015: @35531
     /* 35531 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(35562), // Rule ID 17578 //
     /* 35536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 35539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 35544 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 35547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35551 */     // (intrinsic_void 14427:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 35551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 35554 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35560 */     GIR_RootConstrainSelectedInstOperands,
     /* 35561 */     // GIR_Coverage, 17578,
     /* 35561 */     GIR_EraseRootFromParent_Done,
     /* 35562 */   // Label 1016: @35562
     /* 35562 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(35593), // Rule ID 17579 //
     /* 35567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 35570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 35575 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 35578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35582 */     // (intrinsic_void 14428:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 35582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 35585 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35591 */     GIR_RootConstrainSelectedInstOperands,
     /* 35592 */     // GIR_Coverage, 17579,
     /* 35592 */     GIR_EraseRootFromParent_Done,
     /* 35593 */   // Label 1017: @35593
     /* 35593 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(35625), // Rule ID 114 //
     /* 35598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 35601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 35606 */     // MIs[0] src
     /* 35606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 35610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35614 */     // (intrinsic_void 14340:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 35614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 35617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35623 */     GIR_RootConstrainSelectedInstOperands,
     /* 35624 */     // GIR_Coverage, 114,
     /* 35624 */     GIR_EraseRootFromParent_Done,
     /* 35625 */   // Label 1018: @35625
     /* 35625 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(35657), // Rule ID 116 //
     /* 35630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 35633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 35638 */     // MIs[0] src
     /* 35638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 35642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35646 */     // (intrinsic_void 14340:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 35646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 35649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35655 */     GIR_RootConstrainSelectedInstOperands,
     /* 35656 */     // GIR_Coverage, 116,
     /* 35656 */     GIR_EraseRootFromParent_Done,
     /* 35657 */   // Label 1019: @35657
     /* 35657 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(35689), // Rule ID 126 //
     /* 35662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 35665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 35670 */     // MIs[0] src
     /* 35670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 35674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 35678 */     // (intrinsic_void 14725:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 35678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 35681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35687 */     GIR_RootConstrainSelectedInstOperands,
     /* 35688 */     // GIR_Coverage, 126,
     /* 35688 */     GIR_EraseRootFromParent_Done,
     /* 35689 */   // Label 1020: @35689
     /* 35689 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(35721), // Rule ID 127 //
     /* 35694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 35697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 35702 */     // MIs[0] src
     /* 35702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 35706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35710 */     // (intrinsic_void 14725:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 35710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 35713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35719 */     GIR_RootConstrainSelectedInstOperands,
     /* 35720 */     // GIR_Coverage, 127,
     /* 35720 */     GIR_EraseRootFromParent_Done,
     /* 35721 */   // Label 1021: @35721
     /* 35721 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(35753), // Rule ID 128 //
     /* 35726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 35729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 35734 */     // MIs[0] src
     /* 35734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 35738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35742 */     // (intrinsic_void 14725:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 35742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 35745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 35747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35751 */     GIR_RootConstrainSelectedInstOperands,
     /* 35752 */     // GIR_Coverage, 128,
     /* 35752 */     GIR_EraseRootFromParent_Done,
     /* 35753 */   // Label 1022: @35753
     /* 35753 */   GIM_Reject,
     /* 35754 */ // Label 991: @35754
     /* 35754 */ GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(36168),
     /* 35759 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 35762 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(35794), // Rule ID 17472 //
     /* 35767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 35770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 35775 */     // MIs[0] dst
     /* 35775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35778 */     // MIs[0] src
     /* 35778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35781 */     // (intrinsic_void 14723:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 35781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 35784 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35792 */     GIR_RootConstrainSelectedInstOperands,
     /* 35793 */     // GIR_Coverage, 17472,
     /* 35793 */     GIR_EraseRootFromParent_Done,
     /* 35794 */   // Label 1024: @35794
     /* 35794 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(35826), // Rule ID 17484 //
     /* 35799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 35802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 35807 */     // MIs[0] dst
     /* 35807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 35810 */     // MIs[0] src
     /* 35810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35813 */     // (intrinsic_void 14662:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 35813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 35816 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 35818 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35824 */     GIR_RootConstrainSelectedInstOperands,
     /* 35825 */     // GIR_Coverage, 17484,
     /* 35825 */     GIR_EraseRootFromParent_Done,
     /* 35826 */   // Label 1025: @35826
     /* 35826 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(35869), // Rule ID 17599 //
     /* 35831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 35836 */     // MIs[0] addr
     /* 35836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 35840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 35844 */     // MIs[0] accessinfo
     /* 35844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 35847 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 35847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 35850 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 35852 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 35854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 35857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 35860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 35863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35867 */     GIR_RootConstrainSelectedInstOperands,
     /* 35868 */     // GIR_Coverage, 17599,
     /* 35868 */     GIR_EraseRootFromParent_Done,
     /* 35869 */   // Label 1026: @35869
     /* 35869 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(35909), // Rule ID 17525 //
     /* 35874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 35877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 35882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35896 */     // (intrinsic_w_chain:{ *:[i64] } 14727:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 35896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 35899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35907 */     GIR_RootConstrainSelectedInstOperands,
     /* 35908 */     // GIR_Coverage, 17525,
     /* 35908 */     GIR_EraseRootFromParent_Done,
     /* 35909 */   // Label 1027: @35909
     /* 35909 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(35949), // Rule ID 17529 //
     /* 35914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 35917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 35922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 35928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 35936 */     // (intrinsic_w_chain:{ *:[i64] } 14727:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 35936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 35939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35947 */     GIR_RootConstrainSelectedInstOperands,
     /* 35948 */     // GIR_Coverage, 17529,
     /* 35948 */     GIR_EraseRootFromParent_Done,
     /* 35949 */   // Label 1028: @35949
     /* 35949 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(35986), // Rule ID 17537 //
     /* 35954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 35959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 35973 */     // (intrinsic_w_chain:{ *:[i32] } 14443:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 35973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 35976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 35978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35984 */     GIR_RootConstrainSelectedInstOperands,
     /* 35985 */     // GIR_Coverage, 17537,
     /* 35985 */     GIR_EraseRootFromParent_Done,
     /* 35986 */   // Label 1029: @35986
     /* 35986 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(36023), // Rule ID 17538 //
     /* 35991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 35996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 35999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 36002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36010 */     // (intrinsic_w_chain:{ *:[i64] } 14444:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 36010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 36013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 36017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36021 */     GIR_RootConstrainSelectedInstOperands,
     /* 36022 */     // GIR_Coverage, 17538,
     /* 36022 */     GIR_EraseRootFromParent_Done,
     /* 36023 */   // Label 1030: @36023
     /* 36023 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(36087), // Rule ID 3083 //
     /* 36028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 36031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 36036 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 36039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 36046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 36050 */     // (intrinsic_void 14568:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 36050 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 36054 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 36060 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 36064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 36068 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 36074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 36078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 36081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36085 */     GIR_RootConstrainSelectedInstOperands,
     /* 36086 */     // GIR_Coverage, 3083,
     /* 36086 */     GIR_EraseRootFromParent_Done,
     /* 36087 */   // Label 1031: @36087
     /* 36087 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(36127), // Rule ID 17527 //
     /* 36092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 36095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 36100 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 36103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 36106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36114 */     // (intrinsic_void 14728:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 36114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 36117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36125 */     GIR_RootConstrainSelectedInstOperands,
     /* 36126 */     // GIR_Coverage, 17527,
     /* 36126 */     GIR_EraseRootFromParent_Done,
     /* 36127 */   // Label 1032: @36127
     /* 36127 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(36167), // Rule ID 17531 //
     /* 36132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 36135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 36140 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 36143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 36146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 36154 */     // (intrinsic_void 14728:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 36154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 36157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36165 */     GIR_RootConstrainSelectedInstOperands,
     /* 36166 */     // GIR_Coverage, 17531,
     /* 36166 */     GIR_EraseRootFromParent_Done,
     /* 36167 */   // Label 1033: @36167
     /* 36167 */   GIM_Reject,
     /* 36168 */ // Label 1023: @36168
     /* 36168 */ GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(37741),
     /* 36173 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 36176 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(36213), // Rule ID 17451 //
     /* 36181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 36184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 36189 */     // MIs[0] src1
     /* 36189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36192 */     // MIs[0] src2
     /* 36192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36195 */     // MIs[0] src3
     /* 36195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36198 */     // (intrinsic_void 14680:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 36201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36205 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36211 */     GIR_RootConstrainSelectedInstOperands,
     /* 36212 */     // GIR_Coverage, 17451,
     /* 36212 */     GIR_EraseRootFromParent_Done,
     /* 36213 */   // Label 1035: @36213
     /* 36213 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(36250), // Rule ID 17452 //
     /* 36218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 36221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 36226 */     // MIs[0] src1
     /* 36226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36229 */     // MIs[0] src2
     /* 36229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36232 */     // MIs[0] src3
     /* 36232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36235 */     // (intrinsic_void 14682:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 36238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36242 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36248 */     GIR_RootConstrainSelectedInstOperands,
     /* 36249 */     // GIR_Coverage, 17452,
     /* 36249 */     GIR_EraseRootFromParent_Done,
     /* 36250 */   // Label 1036: @36250
     /* 36250 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(36287), // Rule ID 17453 //
     /* 36255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 36258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 36263 */     // MIs[0] src1
     /* 36263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36266 */     // MIs[0] src2
     /* 36266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36269 */     // MIs[0] src3
     /* 36269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36272 */     // (intrinsic_void 14684:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 36275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36279 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36285 */     GIR_RootConstrainSelectedInstOperands,
     /* 36286 */     // GIR_Coverage, 17453,
     /* 36286 */     GIR_EraseRootFromParent_Done,
     /* 36287 */   // Label 1037: @36287
     /* 36287 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(36324), // Rule ID 17454 //
     /* 36292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 36295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 36300 */     // MIs[0] src1
     /* 36300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36303 */     // MIs[0] src2
     /* 36303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36306 */     // MIs[0] src3
     /* 36306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36309 */     // (intrinsic_void 14686:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 36312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36316 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36322 */     GIR_RootConstrainSelectedInstOperands,
     /* 36323 */     // GIR_Coverage, 17454,
     /* 36323 */     GIR_EraseRootFromParent_Done,
     /* 36324 */   // Label 1038: @36324
     /* 36324 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(36361), // Rule ID 17456 //
     /* 36329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 36332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 36337 */     // MIs[0] src1
     /* 36337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36340 */     // MIs[0] src2
     /* 36340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36343 */     // MIs[0] src3
     /* 36343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36346 */     // (intrinsic_void 14674:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 36349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36353 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36359 */     GIR_RootConstrainSelectedInstOperands,
     /* 36360 */     // GIR_Coverage, 17456,
     /* 36360 */     GIR_EraseRootFromParent_Done,
     /* 36361 */   // Label 1039: @36361
     /* 36361 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(36398), // Rule ID 17458 //
     /* 36366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 36369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 36374 */     // MIs[0] src1
     /* 36374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36377 */     // MIs[0] src2
     /* 36377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36380 */     // MIs[0] src3
     /* 36380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36383 */     // (intrinsic_void 14688:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 36386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36388 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36390 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36396 */     GIR_RootConstrainSelectedInstOperands,
     /* 36397 */     // GIR_Coverage, 17458,
     /* 36397 */     GIR_EraseRootFromParent_Done,
     /* 36398 */   // Label 1040: @36398
     /* 36398 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(36435), // Rule ID 17461 //
     /* 36403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 36406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 36411 */     // MIs[0] src1
     /* 36411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36414 */     // MIs[0] src2
     /* 36414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36417 */     // MIs[0] src3
     /* 36417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36420 */     // (intrinsic_void 14656:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 36423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36433 */     GIR_RootConstrainSelectedInstOperands,
     /* 36434 */     // GIR_Coverage, 17461,
     /* 36434 */     GIR_EraseRootFromParent_Done,
     /* 36435 */   // Label 1041: @36435
     /* 36435 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(36472), // Rule ID 17462 //
     /* 36440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 36443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 36448 */     // MIs[0] src1
     /* 36448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36451 */     // MIs[0] src2
     /* 36451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36454 */     // MIs[0] src3
     /* 36454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36457 */     // (intrinsic_void 14658:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 36460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36464 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36470 */     GIR_RootConstrainSelectedInstOperands,
     /* 36471 */     // GIR_Coverage, 17462,
     /* 36471 */     GIR_EraseRootFromParent_Done,
     /* 36472 */   // Label 1042: @36472
     /* 36472 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(36509), // Rule ID 17463 //
     /* 36477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 36485 */     // MIs[0] src1
     /* 36485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36488 */     // MIs[0] src2
     /* 36488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36491 */     // MIs[0] src3
     /* 36491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36494 */     // (intrinsic_void 14676:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 36497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36499 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36501 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36507 */     GIR_RootConstrainSelectedInstOperands,
     /* 36508 */     // GIR_Coverage, 17463,
     /* 36508 */     GIR_EraseRootFromParent_Done,
     /* 36509 */   // Label 1043: @36509
     /* 36509 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(36546), // Rule ID 17464 //
     /* 36514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 36522 */     // MIs[0] src1
     /* 36522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36525 */     // MIs[0] src2
     /* 36525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36528 */     // MIs[0] src3
     /* 36528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36531 */     // (intrinsic_void 14678:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 36534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36538 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36544 */     GIR_RootConstrainSelectedInstOperands,
     /* 36545 */     // GIR_Coverage, 17464,
     /* 36545 */     GIR_EraseRootFromParent_Done,
     /* 36546 */   // Label 1044: @36546
     /* 36546 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(36583), // Rule ID 17465 //
     /* 36551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 36559 */     // MIs[0] src1
     /* 36559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36562 */     // MIs[0] src2
     /* 36562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36565 */     // MIs[0] src3
     /* 36565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36568 */     // (intrinsic_void 14690:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 36571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36575 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36581 */     GIR_RootConstrainSelectedInstOperands,
     /* 36582 */     // GIR_Coverage, 17465,
     /* 36582 */     GIR_EraseRootFromParent_Done,
     /* 36583 */   // Label 1045: @36583
     /* 36583 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(36620), // Rule ID 17466 //
     /* 36588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 36591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 36596 */     // MIs[0] src1
     /* 36596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36599 */     // MIs[0] src2
     /* 36599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36602 */     // MIs[0] src3
     /* 36602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36605 */     // (intrinsic_void 14692:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 36608 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36612 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36618 */     GIR_RootConstrainSelectedInstOperands,
     /* 36619 */     // GIR_Coverage, 17466,
     /* 36619 */     GIR_EraseRootFromParent_Done,
     /* 36620 */   // Label 1046: @36620
     /* 36620 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(36657), // Rule ID 17474 //
     /* 36625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 36628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 36633 */     // MIs[0] src1
     /* 36633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36636 */     // MIs[0] src2
     /* 36636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36639 */     // MIs[0] src3
     /* 36639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36642 */     // (intrinsic_void 14717:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 36645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36649 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36655 */     GIR_RootConstrainSelectedInstOperands,
     /* 36656 */     // GIR_Coverage, 17474,
     /* 36656 */     GIR_EraseRootFromParent_Done,
     /* 36657 */   // Label 1047: @36657
     /* 36657 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(36694), // Rule ID 17476 //
     /* 36662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 36665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 36670 */     // MIs[0] src1
     /* 36670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36673 */     // MIs[0] src2
     /* 36673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36676 */     // MIs[0] src3
     /* 36676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36679 */     // (intrinsic_void 14719:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 36682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36686 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36692 */     GIR_RootConstrainSelectedInstOperands,
     /* 36693 */     // GIR_Coverage, 17476,
     /* 36693 */     GIR_EraseRootFromParent_Done,
     /* 36694 */   // Label 1048: @36694
     /* 36694 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(36731), // Rule ID 17481 //
     /* 36699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 36702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 36707 */     // MIs[0] src1
     /* 36707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36710 */     // MIs[0] src2
     /* 36710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36713 */     // MIs[0] src3
     /* 36713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36716 */     // (intrinsic_void 14713:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 36719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36723 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36729 */     GIR_RootConstrainSelectedInstOperands,
     /* 36730 */     // GIR_Coverage, 17481,
     /* 36730 */     GIR_EraseRootFromParent_Done,
     /* 36731 */   // Label 1049: @36731
     /* 36731 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(36768), // Rule ID 17482 //
     /* 36736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 36739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 36744 */     // MIs[0] src1
     /* 36744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36747 */     // MIs[0] src2
     /* 36747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36750 */     // MIs[0] src3
     /* 36750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36753 */     // (intrinsic_void 14715:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 36756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36760 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36766 */     GIR_RootConstrainSelectedInstOperands,
     /* 36767 */     // GIR_Coverage, 17482,
     /* 36767 */     GIR_EraseRootFromParent_Done,
     /* 36768 */   // Label 1050: @36768
     /* 36768 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(36805), // Rule ID 17483 //
     /* 36773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 36776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 36781 */     // MIs[0] src1
     /* 36781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36784 */     // MIs[0] src2
     /* 36784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36787 */     // MIs[0] src3
     /* 36787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36790 */     // (intrinsic_void 14660:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 36793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36797 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36803 */     GIR_RootConstrainSelectedInstOperands,
     /* 36804 */     // GIR_Coverage, 17483,
     /* 36804 */     GIR_EraseRootFromParent_Done,
     /* 36805 */   // Label 1051: @36805
     /* 36805 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(36842), // Rule ID 17502 //
     /* 36810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 36813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 36818 */     // MIs[0] src1
     /* 36818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36821 */     // MIs[0] src2
     /* 36821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36824 */     // MIs[0] src3
     /* 36824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36827 */     // (intrinsic_void 14710:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 36830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36834 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36840 */     GIR_RootConstrainSelectedInstOperands,
     /* 36841 */     // GIR_Coverage, 17502,
     /* 36841 */     GIR_EraseRootFromParent_Done,
     /* 36842 */   // Label 1052: @36842
     /* 36842 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(36879), // Rule ID 17504 //
     /* 36847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 36850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 36855 */     // MIs[0] src1
     /* 36855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 36858 */     // MIs[0] src2
     /* 36858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36861 */     // MIs[0] src3
     /* 36861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 36864 */     // (intrinsic_void 14721:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 36864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 36867 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 36869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 36871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 36873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36877 */     GIR_RootConstrainSelectedInstOperands,
     /* 36878 */     // GIR_Coverage, 17504,
     /* 36878 */     GIR_EraseRootFromParent_Done,
     /* 36879 */   // Label 1053: @36879
     /* 36879 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(36932), // Rule ID 17485 //
     /* 36884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 36892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 36895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36902 */     // MIs[0] src1
     /* 36902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 36909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 36913 */     // MIs[1] Operand 1
     /* 36913 */     // No operand predicates
     /* 36913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 36915 */     // (intrinsic_w_chain:{ *:[v16f32] } 14664:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 36915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 36918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 36925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 36930 */     GIR_RootConstrainSelectedInstOperands,
     /* 36931 */     // GIR_Coverage, 17485,
     /* 36931 */     GIR_EraseRootFromParent_Done,
     /* 36932 */   // Label 1054: @36932
     /* 36932 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(36985), // Rule ID 17494 //
     /* 36937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 36945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 36948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 36955 */     // MIs[0] src1
     /* 36955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 36958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 36962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 36966 */     // MIs[1] Operand 1
     /* 36966 */     // No operand predicates
     /* 36966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 36968 */     // (intrinsic_w_chain:{ *:[v32f16] } 14670:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 36968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 36971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 36973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 36975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 36978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 36983 */     GIR_RootConstrainSelectedInstOperands,
     /* 36984 */     // GIR_Coverage, 17494,
     /* 36984 */     GIR_EraseRootFromParent_Done,
     /* 36985 */   // Label 1055: @36985
     /* 36985 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(37038), // Rule ID 17496 //
     /* 36990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 36993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 36998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 37001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 37008 */     // MIs[0] src1
     /* 37008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 37011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 37015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37019 */     // MIs[1] Operand 1
     /* 37019 */     // No operand predicates
     /* 37019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37021 */     // (intrinsic_w_chain:{ *:[v32f16] } 14672:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 37021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 37024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 37031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 37036 */     GIR_RootConstrainSelectedInstOperands,
     /* 37037 */     // GIR_Coverage, 17496,
     /* 37037 */     GIR_EraseRootFromParent_Done,
     /* 37038 */   // Label 1056: @37038
     /* 37038 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(37091), // Rule ID 17497 //
     /* 37043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 37046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 37051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 37054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 37061 */     // MIs[0] src1
     /* 37061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 37064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 37068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37072 */     // MIs[1] Operand 1
     /* 37072 */     // No operand predicates
     /* 37072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37074 */     // (intrinsic_w_chain:{ *:[v16i32] } 14703:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 37074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 37077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 37084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 37089 */     GIR_RootConstrainSelectedInstOperands,
     /* 37090 */     // GIR_Coverage, 17497,
     /* 37090 */     GIR_EraseRootFromParent_Done,
     /* 37091 */   // Label 1057: @37091
     /* 37091 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(37136), // Rule ID 17486 //
     /* 37096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 37099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 37104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 37107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 37114 */     // MIs[0] src1
     /* 37114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 37117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37121 */     // (intrinsic_w_chain:{ *:[v16f32] } 14664:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 37121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 37124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37128 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 37130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37134 */     GIR_RootConstrainSelectedInstOperands,
     /* 37135 */     // GIR_Coverage, 17486,
     /* 37135 */     GIR_EraseRootFromParent_Done,
     /* 37136 */   // Label 1058: @37136
     /* 37136 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(37181), // Rule ID 17493 //
     /* 37141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 37144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 37149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 37152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 37159 */     // MIs[0] src1
     /* 37159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 37162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37166 */     // (intrinsic_w_chain:{ *:[v32f16] } 14670:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 37166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 37169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37171 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37173 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 37175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37179 */     GIR_RootConstrainSelectedInstOperands,
     /* 37180 */     // GIR_Coverage, 17493,
     /* 37180 */     GIR_EraseRootFromParent_Done,
     /* 37181 */   // Label 1059: @37181
     /* 37181 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(37226), // Rule ID 17495 //
     /* 37186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 37189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 37194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 37197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 37204 */     // MIs[0] src1
     /* 37204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 37207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37211 */     // (intrinsic_w_chain:{ *:[v32f16] } 14672:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 37211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 37214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37218 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 37220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37224 */     GIR_RootConstrainSelectedInstOperands,
     /* 37225 */     // GIR_Coverage, 17495,
     /* 37225 */     GIR_EraseRootFromParent_Done,
     /* 37226 */   // Label 1060: @37226
     /* 37226 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(37271), // Rule ID 17498 //
     /* 37231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 37234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 37239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 37242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 37249 */     // MIs[0] src1
     /* 37249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 37252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37256 */     // (intrinsic_w_chain:{ *:[v16i32] } 14703:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 37256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 37259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 37265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37269 */     GIR_RootConstrainSelectedInstOperands,
     /* 37270 */     // GIR_Coverage, 17498,
     /* 37270 */     GIR_EraseRootFromParent_Done,
     /* 37271 */   // Label 1061: @37271
     /* 37271 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(37316), // Rule ID 122 //
     /* 37276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 37279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 37284 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 37290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37298 */     // MIs[0] cntl
     /* 37298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 37301 */     // (intrinsic_void 14344:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 37301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 37304 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 37306 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37308 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 37310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37314 */     GIR_RootConstrainSelectedInstOperands,
     /* 37315 */     // GIR_Coverage, 122,
     /* 37315 */     GIR_EraseRootFromParent_Done,
     /* 37316 */   // Label 1062: @37316
     /* 37316 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(37361), // Rule ID 124 //
     /* 37321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 37324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 37329 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 37332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 37335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 37339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37343 */     // MIs[0] cntl
     /* 37343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 37346 */     // (intrinsic_void 14345:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 37346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 37349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 37351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37353 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 37355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37359 */     GIR_RootConstrainSelectedInstOperands,
     /* 37360 */     // GIR_Coverage, 124,
     /* 37360 */     GIR_EraseRootFromParent_Done,
     /* 37361 */   // Label 1063: @37361
     /* 37361 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(37443), // Rule ID 17551 //
     /* 37366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 37371 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 37377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 37384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 37388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 37392 */     // (intrinsic_void 14840:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 37392 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37396 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37402 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 37406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37410 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 37420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37424 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 37434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 37437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37441 */     GIR_RootConstrainSelectedInstOperands,
     /* 37442 */     // GIR_Coverage, 17551,
     /* 37442 */     GIR_EraseRootFromParent_Done,
     /* 37443 */   // Label 1064: @37443
     /* 37443 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(37492), // Rule ID 17740 //
     /* 37448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 37451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 37456 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 37462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37477 */     // (intrinsic_void 14422:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 37477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 37480 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 37482 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 37484 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 37486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37490 */     GIR_RootConstrainSelectedInstOperands,
     /* 37491 */     // GIR_Coverage, 17740,
     /* 37491 */     GIR_EraseRootFromParent_Done,
     /* 37492 */   // Label 1065: @37492
     /* 37492 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(37554), // Rule ID 2900 //
     /* 37497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 37500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37505 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37519 */     // MIs[0] Operand 3
     /* 37519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 37523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37527 */     // (intrinsic_void 14520:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37531 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 37541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 37544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37546 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37552 */     GIR_RootConstrainSelectedInstOperands,
     /* 37553 */     // GIR_Coverage, 2900,
     /* 37553 */     GIR_EraseRootFromParent_Done,
     /* 37554 */   // Label 1066: @37554
     /* 37554 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(37616), // Rule ID 2901 //
     /* 37559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 37562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37567 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37581 */     // MIs[0] Operand 3
     /* 37581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 37585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37589 */     // (intrinsic_void 14520:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37593 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 37603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 37606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37608 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37614 */     GIR_RootConstrainSelectedInstOperands,
     /* 37615 */     // GIR_Coverage, 2901,
     /* 37615 */     GIR_EraseRootFromParent_Done,
     /* 37616 */   // Label 1067: @37616
     /* 37616 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(37678), // Rule ID 2902 //
     /* 37621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 37624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37629 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37643 */     // MIs[0] Operand 3
     /* 37643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 37647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37651 */     // (intrinsic_void 14520:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37655 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 37665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 37668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37670 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37676 */     GIR_RootConstrainSelectedInstOperands,
     /* 37677 */     // GIR_Coverage, 2902,
     /* 37677 */     GIR_EraseRootFromParent_Done,
     /* 37678 */   // Label 1068: @37678
     /* 37678 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(37740), // Rule ID 2903 //
     /* 37683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 37686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 37691 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 37694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 37697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37705 */     // MIs[0] Operand 3
     /* 37705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 37709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 37713 */     // (intrinsic_void 14520:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 37713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37717 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 37727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 37730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37732 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 37734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37738 */     GIR_RootConstrainSelectedInstOperands,
     /* 37739 */     // GIR_Coverage, 2903,
     /* 37739 */     GIR_EraseRootFromParent_Done,
     /* 37740 */   // Label 1069: @37740
     /* 37740 */   GIM_Reject,
     /* 37741 */ // Label 1034: @37741
     /* 37741 */ GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(37829), // Rule ID 17435 //
     /* 37746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 37749 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 37752 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 37757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 37760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 37763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 37766 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 37769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 37781 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 37785 */   // (intrinsic_void 14341:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 37785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37789 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37795 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 37799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37803 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37809 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 37813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 37816 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 37818 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 37820 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 37823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37827 */   GIR_RootConstrainSelectedInstOperands,
     /* 37828 */   // GIR_Coverage, 17435,
     /* 37828 */   GIR_EraseRootFromParent_Done,
     /* 37829 */ // Label 1070: @37829
     /* 37829 */ GIM_Reject,
     /* 37830 */ // Label 12: @37830
     /* 37830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1074*/ GIMT_Encode4(38264),
     /* 37841 */ /*GILLT_s16*//*Label 1071*/ GIMT_Encode4(37853),
     /* 37845 */ /*GILLT_s32*//*Label 1072*/ GIMT_Encode4(37911),
     /* 37849 */ /*GILLT_s64*//*Label 1073*/ GIMT_Encode4(38086),
     /* 37853 */ // Label 1071: @37853
     /* 37853 */ GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(37910), // Rule ID 23035 //
     /* 37858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 37861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 37865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 37869 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 37869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 37876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37881 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 37885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37892 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 37899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 37904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 37909 */   // GIR_Coverage, 23035,
     /* 37909 */   GIR_EraseRootFromParent_Done,
     /* 37910 */ // Label 1075: @37910
     /* 37910 */ GIM_Reject,
     /* 37911 */ // Label 1072: @37911
     /* 37911 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(37957), // Rule ID 19884 //
     /* 37916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 37919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 37931 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 37935 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 37940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37942 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 37942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37947 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37951 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 37956 */   // GIR_Coverage, 19884,
     /* 37956 */   GIR_EraseRootFromParent_Done,
     /* 37957 */ // Label 1076: @37957
     /* 37957 */ GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(38003), // Rule ID 19887 //
     /* 37962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 37965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 37969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 37977 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 37981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 37986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37988 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 37988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 38002 */   // GIR_Coverage, 19887,
     /* 38002 */   GIR_EraseRootFromParent_Done,
     /* 38003 */ // Label 1077: @38003
     /* 38003 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(38026), // Rule ID 23036 //
     /* 38008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 38011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38019 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 38019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 38024 */   GIR_RootConstrainSelectedInstOperands,
     /* 38025 */   // GIR_Coverage, 23036,
     /* 38025 */   GIR_Done,
     /* 38026 */ // Label 1078: @38026
     /* 38026 */ GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(38085), // Rule ID 23037 //
     /* 38031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 38038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38042 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 38042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38064 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 38066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 38069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 38074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 38079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 38084 */   // GIR_Coverage, 23037,
     /* 38084 */   GIR_EraseRootFromParent_Done,
     /* 38085 */ // Label 1079: @38085
     /* 38085 */ GIM_Reject,
     /* 38086 */ // Label 1073: @38086
     /* 38086 */ GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(38145), // Rule ID 23038 //
     /* 38091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 38094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 38098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38102 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 38102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 38109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38114 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 38123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 38128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 38134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 38139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 38144 */   // GIR_Coverage, 23038,
     /* 38144 */   GIR_EraseRootFromParent_Done,
     /* 38145 */ // Label 1080: @38145
     /* 38145 */ GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(38204), // Rule ID 23039 //
     /* 38150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 38157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38161 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 38161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 38168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38173 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 38182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 38187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 38193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 38198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 38203 */   // GIR_Coverage, 23039,
     /* 38203 */   GIR_EraseRootFromParent_Done,
     /* 38204 */ // Label 1081: @38204
     /* 38204 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(38263), // Rule ID 23040 //
     /* 38209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 38216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38220 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 38220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 38244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 38247 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 38252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 38257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 38262 */   // GIR_Coverage, 23040,
     /* 38262 */   GIR_EraseRootFromParent_Done,
     /* 38263 */ // Label 1082: @38263
     /* 38263 */ GIM_Reject,
     /* 38264 */ // Label 1074: @38264
     /* 38264 */ GIM_Reject,
     /* 38265 */ // Label 13: @38265
     /* 38265 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 1091*/ GIMT_Encode4(39277),
     /* 38276 */ /*GILLT_s8*//*Label 1083*/ GIMT_Encode4(38360),
     /* 38280 */ /*GILLT_s16*//*Label 1084*/ GIMT_Encode4(38644), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 38312 */ /*GILLT_v4s32*//*Label 1085*/ GIMT_Encode4(38683), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 38324 */ /*GILLT_v8s16*//*Label 1086*/ GIMT_Encode4(38823),
     /* 38328 */ /*GILLT_v8s32*//*Label 1087*/ GIMT_Encode4(38986), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 38340 */ /*GILLT_v16s8*//*Label 1088*/ GIMT_Encode4(39013),
     /* 38344 */ /*GILLT_v16s16*//*Label 1089*/ GIMT_Encode4(39223), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 38356 */ /*GILLT_v32s8*//*Label 1090*/ GIMT_Encode4(39250),
     /* 38360 */ // Label 1083: @38360
     /* 38360 */ GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(38435), // Rule ID 19879 //
     /* 38365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 38380 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 38384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 38389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38391 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 38412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38417 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38434 */   // GIR_Coverage, 19879,
     /* 38434 */   GIR_EraseRootFromParent_Done,
     /* 38435 */ // Label 1092: @38435
     /* 38435 */ GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(38498), // Rule ID 23097 //
     /* 38440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 38443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38454 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 38457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38466 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 38475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38480 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 38497 */   // GIR_Coverage, 23097,
     /* 38497 */   GIR_EraseRootFromParent_Done,
     /* 38498 */ // Label 1093: @38498
     /* 38498 */ GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(38561), // Rule ID 23098 //
     /* 38503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 38506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38517 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 38517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 38520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38529 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 38538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38543 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 38550 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 38555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 38560 */   // GIR_Coverage, 23098,
     /* 38560 */   GIR_EraseRootFromParent_Done,
     /* 38561 */ // Label 1094: @38561
     /* 38561 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(38602), // Rule ID 23102 //
     /* 38566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 38569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38580 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 38580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38585 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 38591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38601 */   // GIR_Coverage, 23102,
     /* 38601 */   GIR_EraseRootFromParent_Done,
     /* 38602 */ // Label 1095: @38602
     /* 38602 */ GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(38643), // Rule ID 23103 //
     /* 38607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 38610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 38613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 38617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38621 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 38621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38626 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 38632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 38637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 38642 */   // GIR_Coverage, 23103,
     /* 38642 */   GIR_EraseRootFromParent_Done,
     /* 38643 */ // Label 1096: @38643
     /* 38643 */ GIM_Reject,
     /* 38644 */ // Label 1084: @38644
     /* 38644 */ GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(38682), // Rule ID 23096 //
     /* 38649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 38652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 38656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 38660 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 38660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38665 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 38671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 38676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 38681 */   // GIR_Coverage, 23096,
     /* 38681 */   GIR_EraseRootFromParent_Done,
     /* 38682 */ // Label 1097: @38682
     /* 38682 */ GIM_Reject,
     /* 38683 */ // Label 1085: @38683
     /* 38683 */ GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(38822),
     /* 38688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 38691 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(38714), // Rule ID 12259 //
     /* 38696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 38699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38707 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 38707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 38712 */     GIR_RootConstrainSelectedInstOperands,
     /* 38713 */     // GIR_Coverage, 12259,
     /* 38713 */     GIR_Done,
     /* 38714 */   // Label 1099: @38714
     /* 38714 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(38821), // Rule ID 22004 //
     /* 38719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 38722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 38726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38730 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 38730 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 38733 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38737 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 38744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 38747 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38751 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38756 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 38759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38763 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 38766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 38771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 38776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 38784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 38788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38793 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 38796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38803 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 38810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 38815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38820 */     // GIR_Coverage, 22004,
     /* 38820 */     GIR_EraseRootFromParent_Done,
     /* 38821 */   // Label 1100: @38821
     /* 38821 */   GIM_Reject,
     /* 38822 */ // Label 1098: @38822
     /* 38822 */ GIM_Reject,
     /* 38823 */ // Label 1086: @38823
     /* 38823 */ GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(38849), // Rule ID 12235 //
     /* 38828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 38831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 38834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 38842 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 38842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 38847 */   GIR_RootConstrainSelectedInstOperands,
     /* 38848 */   // GIR_Coverage, 12235,
     /* 38848 */   GIR_Done,
     /* 38849 */ // Label 1101: @38849
     /* 38849 */ GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(38875), // Rule ID 12313 //
     /* 38854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 38857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 38860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 38864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38868 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 38868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 38873 */   GIR_RootConstrainSelectedInstOperands,
     /* 38874 */   // GIR_Coverage, 12313,
     /* 38874 */   GIR_Done,
     /* 38875 */ // Label 1102: @38875
     /* 38875 */ GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(38985), // Rule ID 22003 //
     /* 38880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 38883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 38886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 38890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 38894 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 38894 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 38897 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38901 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 38908 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 38911 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38915 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38920 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 38923 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 38927 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 38930 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 38935 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 38940 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 38948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 38952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38957 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 38960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 38965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38967 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 38974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 38979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 38984 */   // GIR_Coverage, 22003,
     /* 38984 */   GIR_EraseRootFromParent_Done,
     /* 38985 */ // Label 1103: @38985
     /* 38985 */ GIM_Reject,
     /* 38986 */ // Label 1087: @38986
     /* 38986 */ GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(39012), // Rule ID 12262 //
     /* 38991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 38994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 38997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 39001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 39005 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 39005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 39010 */   GIR_RootConstrainSelectedInstOperands,
     /* 39011 */   // GIR_Coverage, 12262,
     /* 39011 */   GIR_Done,
     /* 39012 */ // Label 1104: @39012
     /* 39012 */ GIM_Reject,
     /* 39013 */ // Label 1088: @39013
     /* 39013 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(39039), // Rule ID 12289 //
     /* 39018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 39021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 39024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 39028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 39032 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 39032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 39037 */   GIR_RootConstrainSelectedInstOperands,
     /* 39038 */   // GIR_Coverage, 12289,
     /* 39038 */   GIR_Done,
     /* 39039 */ // Label 1105: @39039
     /* 39039 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(39065), // Rule ID 12340 //
     /* 39044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 39047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 39050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 39054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 39058 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 39058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 39063 */   GIR_RootConstrainSelectedInstOperands,
     /* 39064 */   // GIR_Coverage, 12340,
     /* 39064 */   GIR_Done,
     /* 39065 */ // Label 1106: @39065
     /* 39065 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(39175), // Rule ID 22005 //
     /* 39070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 39073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 39076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 39080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 39084 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 39084 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 39087 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 39091 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 39098 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 39101 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 39105 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39110 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 39113 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 39117 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 39120 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 39125 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 39130 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 39135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 39138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 39142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39147 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 39150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39157 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 39164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 39169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 39174 */   // GIR_Coverage, 22005,
     /* 39174 */   GIR_EraseRootFromParent_Done,
     /* 39175 */ // Label 1107: @39175
     /* 39175 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(39222), // Rule ID 22096 //
     /* 39180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 39183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 39186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 39190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 39194 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 39194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 39197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 39201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39206 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 39210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 39215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39220 */   GIR_RootConstrainSelectedInstOperands,
     /* 39221 */   // GIR_Coverage, 22096,
     /* 39221 */   GIR_EraseRootFromParent_Done,
     /* 39222 */ // Label 1108: @39222
     /* 39222 */ GIM_Reject,
     /* 39223 */ // Label 1089: @39223
     /* 39223 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(39249), // Rule ID 12316 //
     /* 39228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 39231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 39234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 39238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 39242 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 39242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 39247 */   GIR_RootConstrainSelectedInstOperands,
     /* 39248 */   // GIR_Coverage, 12316,
     /* 39248 */   GIR_Done,
     /* 39249 */ // Label 1109: @39249
     /* 39249 */ GIM_Reject,
     /* 39250 */ // Label 1090: @39250
     /* 39250 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(39276), // Rule ID 12343 //
     /* 39255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 39258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 39261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 39265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 39269 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 39269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 39274 */   GIR_RootConstrainSelectedInstOperands,
     /* 39275 */   // GIR_Coverage, 12343,
     /* 39275 */   GIR_Done,
     /* 39276 */ // Label 1110: @39276
     /* 39276 */ GIM_Reject,
     /* 39277 */ // Label 1091: @39277
     /* 39277 */ GIM_Reject,
     /* 39278 */ // Label 14: @39278
     /* 39278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1115*/ GIMT_Encode4(39883),
     /* 39289 */ /*GILLT_s8*//*Label 1111*/ GIMT_Encode4(39305),
     /* 39293 */ /*GILLT_s16*//*Label 1112*/ GIMT_Encode4(39387),
     /* 39297 */ /*GILLT_s32*//*Label 1113*/ GIMT_Encode4(39587),
     /* 39301 */ /*GILLT_s64*//*Label 1114*/ GIMT_Encode4(39729),
     /* 39305 */ // Label 1111: @39305
     /* 39305 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(39386),
     /* 39310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 39314 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(39370), // Rule ID 22831 //
     /* 39319 */     // MIs[0] Operand 1
     /* 39319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39330 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 39330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39342 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39352 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 39359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 39364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39369 */     // GIR_Coverage, 22831,
     /* 39369 */     GIR_EraseRootFromParent_Done,
     /* 39370 */   // Label 1117: @39370
     /* 39370 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(39385), // Rule ID 19 //
     /* 39375 */     // MIs[0] Operand 1
     /* 39375 */     // No operand predicates
     /* 39375 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 39375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 39378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39383 */     GIR_RootConstrainSelectedInstOperands,
     /* 39384 */     // GIR_Coverage, 19,
     /* 39384 */     GIR_EraseRootFromParent_Done,
     /* 39385 */   // Label 1118: @39385
     /* 39385 */   GIM_Reject,
     /* 39386 */ // Label 1116: @39386
     /* 39386 */ GIM_Reject,
     /* 39387 */ // Label 1112: @39387
     /* 39387 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(39586),
     /* 39392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 39396 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(39452), // Rule ID 22832 //
     /* 39401 */     // MIs[0] Operand 1
     /* 39401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39412 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 39412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39424 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39434 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 39441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 39446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39451 */     // GIR_Coverage, 22832,
     /* 39451 */     GIR_EraseRootFromParent_Done,
     /* 39452 */   // Label 1120: @39452
     /* 39452 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(39511), // Rule ID 22834 //
     /* 39457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39460 */     // MIs[0] Operand 1
     /* 39460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 39471 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 39471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 39478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39483 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39493 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 39500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 39505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39510 */     // GIR_Coverage, 22834,
     /* 39510 */     GIR_EraseRootFromParent_Done,
     /* 39511 */   // Label 1121: @39511
     /* 39511 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(39570), // Rule ID 22835 //
     /* 39516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39519 */     // MIs[0] Operand 1
     /* 39519 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 39530 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 39530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 39537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39542 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 39550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39552 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 39559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 39564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 39569 */     // GIR_Coverage, 22835,
     /* 39569 */     GIR_EraseRootFromParent_Done,
     /* 39570 */   // Label 1122: @39570
     /* 39570 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(39585), // Rule ID 20 //
     /* 39575 */     // MIs[0] Operand 1
     /* 39575 */     // No operand predicates
     /* 39575 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 39575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 39578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39583 */     GIR_RootConstrainSelectedInstOperands,
     /* 39584 */     // GIR_Coverage, 20,
     /* 39584 */     GIR_EraseRootFromParent_Done,
     /* 39585 */   // Label 1123: @39585
     /* 39585 */   GIM_Reject,
     /* 39586 */ // Label 1119: @39586
     /* 39586 */ GIM_Reject,
     /* 39587 */ // Label 1113: @39587
     /* 39587 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(39617), // Rule ID 17600 //
     /* 39592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39596 */   // MIs[0] Operand 1
     /* 39596 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39607 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 39607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39612 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 39615 */   GIR_RootConstrainSelectedInstOperands,
     /* 39616 */   // GIR_Coverage, 17600,
     /* 39616 */   GIR_EraseRootFromParent_Done,
     /* 39617 */ // Label 1124: @39617
     /* 39617 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(39650), // Rule ID 17601 //
     /* 39622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39629 */   // MIs[0] Operand 1
     /* 39629 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 39640 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 39640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 39643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39645 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 39648 */   GIR_RootConstrainSelectedInstOperands,
     /* 39649 */   // GIR_Coverage, 17601,
     /* 39649 */   GIR_EraseRootFromParent_Done,
     /* 39650 */ // Label 1125: @39650
     /* 39650 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(39683), // Rule ID 17602 //
     /* 39655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 39658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39662 */   // MIs[0] Operand 1
     /* 39662 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 39673 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 39673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 39676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39678 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 39681 */   GIR_RootConstrainSelectedInstOperands,
     /* 39682 */   // GIR_Coverage, 17602,
     /* 39682 */   GIR_EraseRootFromParent_Done,
     /* 39683 */ // Label 1126: @39683
     /* 39683 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(39709), // Rule ID 17603 //
     /* 39688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 39691 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 39695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39699 */   // MIs[0] Operand 1
     /* 39699 */   // No operand predicates
     /* 39699 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 39699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 39702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39704 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39707 */   GIR_RootConstrainSelectedInstOperands,
     /* 39708 */   // GIR_Coverage, 17603,
     /* 39708 */   GIR_EraseRootFromParent_Done,
     /* 39709 */ // Label 1127: @39709
     /* 39709 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(39728), // Rule ID 21 //
     /* 39714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 39718 */   // MIs[0] Operand 1
     /* 39718 */   // No operand predicates
     /* 39718 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 39718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 39721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39723 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39726 */   GIR_RootConstrainSelectedInstOperands,
     /* 39727 */   // GIR_Coverage, 21,
     /* 39727 */   GIR_EraseRootFromParent_Done,
     /* 39728 */ // Label 1128: @39728
     /* 39728 */ GIM_Reject,
     /* 39729 */ // Label 1114: @39729
     /* 39729 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(39791), // Rule ID 22833 //
     /* 39734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39738 */   // MIs[0] Operand 1
     /* 39738 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 39749 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 39749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 39756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39761 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 39764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 39769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 39774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 39780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 39785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 39790 */   // GIR_Coverage, 22833,
     /* 39790 */   GIR_EraseRootFromParent_Done,
     /* 39791 */ // Label 1129: @39791
     /* 39791 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(39817), // Rule ID 17604 //
     /* 39796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 39799 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 39803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39807 */   // MIs[0] Operand 1
     /* 39807 */   // No operand predicates
     /* 39807 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 39810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39812 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39815 */   GIR_RootConstrainSelectedInstOperands,
     /* 39816 */   // GIR_Coverage, 17604,
     /* 39816 */   GIR_EraseRootFromParent_Done,
     /* 39817 */ // Label 1130: @39817
     /* 39817 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(39840), // Rule ID 17605 //
     /* 39822 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 39826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39830 */   // MIs[0] Operand 1
     /* 39830 */   // No operand predicates
     /* 39830 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 39833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39835 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39838 */   GIR_RootConstrainSelectedInstOperands,
     /* 39839 */   // GIR_Coverage, 17605,
     /* 39839 */   GIR_EraseRootFromParent_Done,
     /* 39840 */ // Label 1131: @39840
     /* 39840 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(39863), // Rule ID 22 //
     /* 39845 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 39849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39853 */   // MIs[0] Operand 1
     /* 39853 */   // No operand predicates
     /* 39853 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 39856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39858 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39861 */   GIR_RootConstrainSelectedInstOperands,
     /* 39862 */   // GIR_Coverage, 22,
     /* 39862 */   GIR_EraseRootFromParent_Done,
     /* 39863 */ // Label 1132: @39863
     /* 39863 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(39882), // Rule ID 23 //
     /* 39868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 39872 */   // MIs[0] Operand 1
     /* 39872 */   // No operand predicates
     /* 39872 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 39872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 39875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39877 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 39880 */   GIR_RootConstrainSelectedInstOperands,
     /* 39881 */   // GIR_Coverage, 23,
     /* 39881 */   GIR_EraseRootFromParent_Done,
     /* 39882 */ // Label 1133: @39882
     /* 39882 */ GIM_Reject,
     /* 39883 */ // Label 1115: @39883
     /* 39883 */ GIM_Reject,
     /* 39884 */ // Label 15: @39884
     /* 39884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 1137*/ GIMT_Encode4(40336),
     /* 39895 */ /*GILLT_s32*//*Label 1134*/ GIMT_Encode4(39907),
     /* 39899 */ /*GILLT_s64*//*Label 1135*/ GIMT_Encode4(40052),
     /* 39903 */ /*GILLT_s80*//*Label 1136*/ GIMT_Encode4(40197),
     /* 39907 */ // Label 1134: @39907
     /* 39907 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(39933), // Rule ID 1113 //
     /* 39912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39915 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 39919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39923 */   // MIs[0] Operand 1
     /* 39923 */   // No operand predicates
     /* 39923 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 39923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 39926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39928 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39931 */   GIR_RootConstrainSelectedInstOperands,
     /* 39932 */   // GIR_Coverage, 1113,
     /* 39932 */   GIR_EraseRootFromParent_Done,
     /* 39933 */ // Label 1138: @39933
     /* 39933 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(39959), // Rule ID 1114 //
     /* 39938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39941 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 39945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39949 */   // MIs[0] Operand 1
     /* 39949 */   // No operand predicates
     /* 39949 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 39949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 39952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39954 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 39957 */   GIR_RootConstrainSelectedInstOperands,
     /* 39958 */   // GIR_Coverage, 1114,
     /* 39958 */   GIR_EraseRootFromParent_Done,
     /* 39959 */ // Label 1139: @39959
     /* 39959 */ GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(40005), // Rule ID 18167 //
     /* 39964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 39967 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 39971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 39975 */   // MIs[0] Operand 1
     /* 39975 */   // No operand predicates
     /* 39975 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 39975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 39978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 39982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39987 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 39990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 39995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40000 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40003 */   GIR_RootConstrainSelectedInstOperands,
     /* 40004 */   // GIR_Coverage, 18167,
     /* 40004 */   GIR_EraseRootFromParent_Done,
     /* 40005 */ // Label 1140: @40005
     /* 40005 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(40051), // Rule ID 18168 //
     /* 40010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 40013 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 40017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 40021 */   // MIs[0] Operand 1
     /* 40021 */   // No operand predicates
     /* 40021 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 40021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 40024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 40028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40033 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 40036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 40041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40046 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40049 */   GIR_RootConstrainSelectedInstOperands,
     /* 40050 */   // GIR_Coverage, 18168,
     /* 40050 */   GIR_EraseRootFromParent_Done,
     /* 40051 */ // Label 1141: @40051
     /* 40051 */ GIM_Reject,
     /* 40052 */ // Label 1135: @40052
     /* 40052 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(40078), // Rule ID 1115 //
     /* 40057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 40060 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 40064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 40068 */   // MIs[0] Operand 1
     /* 40068 */   // No operand predicates
     /* 40068 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 40068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 40071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40073 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40076 */   GIR_RootConstrainSelectedInstOperands,
     /* 40077 */   // GIR_Coverage, 1115,
     /* 40077 */   GIR_EraseRootFromParent_Done,
     /* 40078 */ // Label 1142: @40078
     /* 40078 */ GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(40104), // Rule ID 1116 //
     /* 40083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 40086 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 40090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 40094 */   // MIs[0] Operand 1
     /* 40094 */   // No operand predicates
     /* 40094 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 40094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 40097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40099 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40102 */   GIR_RootConstrainSelectedInstOperands,
     /* 40103 */   // GIR_Coverage, 1116,
     /* 40103 */   GIR_EraseRootFromParent_Done,
     /* 40104 */ // Label 1143: @40104
     /* 40104 */ GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(40150), // Rule ID 18169 //
     /* 40109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 40112 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 40116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 40120 */   // MIs[0] Operand 1
     /* 40120 */   // No operand predicates
     /* 40120 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 40120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 40123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 40127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40132 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 40135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 40140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40145 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40148 */   GIR_RootConstrainSelectedInstOperands,
     /* 40149 */   // GIR_Coverage, 18169,
     /* 40149 */   GIR_EraseRootFromParent_Done,
     /* 40150 */ // Label 1144: @40150
     /* 40150 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(40196), // Rule ID 18170 //
     /* 40155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 40158 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 40162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 40166 */   // MIs[0] Operand 1
     /* 40166 */   // No operand predicates
     /* 40166 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 40166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 40169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 40173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40178 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 40181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 40186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40191 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40194 */   GIR_RootConstrainSelectedInstOperands,
     /* 40195 */   // GIR_Coverage, 18170,
     /* 40195 */   GIR_EraseRootFromParent_Done,
     /* 40196 */ // Label 1145: @40196
     /* 40196 */ GIM_Reject,
     /* 40197 */ // Label 1136: @40197
     /* 40197 */ GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(40223), // Rule ID 1117 //
     /* 40202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 40205 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 40209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 40213 */   // MIs[0] Operand 1
     /* 40213 */   // No operand predicates
     /* 40213 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 40213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 40216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40218 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40221 */   GIR_RootConstrainSelectedInstOperands,
     /* 40222 */   // GIR_Coverage, 1117,
     /* 40222 */   GIR_EraseRootFromParent_Done,
     /* 40223 */ // Label 1146: @40223
     /* 40223 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(40249), // Rule ID 1118 //
     /* 40228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 40231 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 40235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 40239 */   // MIs[0] Operand 1
     /* 40239 */   // No operand predicates
     /* 40239 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 40239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 40242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40244 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40247 */   GIR_RootConstrainSelectedInstOperands,
     /* 40248 */   // GIR_Coverage, 1118,
     /* 40248 */   GIR_EraseRootFromParent_Done,
     /* 40249 */ // Label 1147: @40249
     /* 40249 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(40292), // Rule ID 18171 //
     /* 40254 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 40258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 40262 */   // MIs[0] Operand 1
     /* 40262 */   // No operand predicates
     /* 40262 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 40262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 40265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 40269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40274 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 40277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 40282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40287 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40290 */   GIR_RootConstrainSelectedInstOperands,
     /* 40291 */   // GIR_Coverage, 18171,
     /* 40291 */   GIR_EraseRootFromParent_Done,
     /* 40292 */ // Label 1148: @40292
     /* 40292 */ GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(40335), // Rule ID 18172 //
     /* 40297 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 40301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 40305 */   // MIs[0] Operand 1
     /* 40305 */   // No operand predicates
     /* 40305 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 40305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 40308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 40312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40317 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 40320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 40325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40330 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 40333 */   GIR_RootConstrainSelectedInstOperands,
     /* 40334 */   // GIR_Coverage, 18172,
     /* 40334 */   GIR_EraseRootFromParent_Done,
     /* 40335 */ // Label 1149: @40335
     /* 40335 */ GIM_Reject,
     /* 40336 */ // Label 1137: @40336
     /* 40336 */ GIM_Reject,
     /* 40337 */ // Label 16: @40337
     /* 40337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 1165*/ GIMT_Encode4(41359),
     /* 40348 */ /*GILLT_s16*//*Label 1150*/ GIMT_Encode4(40440),
     /* 40352 */ /*GILLT_s32*//*Label 1151*/ GIMT_Encode4(40498),
     /* 40356 */ /*GILLT_s64*//*Label 1152*/ GIMT_Encode4(40545), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 40372 */ /*GILLT_v2s64*//*Label 1153*/ GIMT_Encode4(40618), GIMT_Encode4(0),
     /* 40380 */ /*GILLT_v4s32*//*Label 1154*/ GIMT_Encode4(40645),
     /* 40384 */ /*GILLT_v4s64*//*Label 1155*/ GIMT_Encode4(40672), GIMT_Encode4(0),
     /* 40392 */ /*GILLT_v8s16*//*Label 1156*/ GIMT_Encode4(40751),
     /* 40396 */ /*GILLT_v8s32*//*Label 1157*/ GIMT_Encode4(40820),
     /* 40400 */ /*GILLT_v8s64*//*Label 1158*/ GIMT_Encode4(40899), GIMT_Encode4(0),
     /* 40408 */ /*GILLT_v16s8*//*Label 1159*/ GIMT_Encode4(40978),
     /* 40412 */ /*GILLT_v16s16*//*Label 1160*/ GIMT_Encode4(41047),
     /* 40416 */ /*GILLT_v16s32*//*Label 1161*/ GIMT_Encode4(41173), GIMT_Encode4(0),
     /* 40424 */ /*GILLT_v32s8*//*Label 1162*/ GIMT_Encode4(41252),
     /* 40428 */ /*GILLT_v32s16*//*Label 1163*/ GIMT_Encode4(41279), GIMT_Encode4(0),
     /* 40436 */ /*GILLT_v64s8*//*Label 1164*/ GIMT_Encode4(41332),
     /* 40440 */ // Label 1150: @40440
     /* 40440 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(40497), // Rule ID 23092 //
     /* 40445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 40448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 40452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 40456 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 40456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 40459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 40463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 40472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 40477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40479 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 40486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 40491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 40496 */   // GIR_Coverage, 23092,
     /* 40496 */   GIR_EraseRootFromParent_Done,
     /* 40497 */ // Label 1166: @40497
     /* 40497 */ GIM_Reject,
     /* 40498 */ // Label 1151: @40498
     /* 40498 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(40521), // Rule ID 612 //
     /* 40503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 40506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 40510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 40514 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 40514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 40519 */   GIR_RootConstrainSelectedInstOperands,
     /* 40520 */   // GIR_Coverage, 612,
     /* 40520 */   GIR_Done,
     /* 40521 */ // Label 1167: @40521
     /* 40521 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(40544), // Rule ID 614 //
     /* 40526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 40529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 40533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 40537 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 40537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 40542 */   GIR_RootConstrainSelectedInstOperands,
     /* 40543 */   // GIR_Coverage, 614,
     /* 40543 */   GIR_Done,
     /* 40544 */ // Label 1168: @40544
     /* 40544 */ GIM_Reject,
     /* 40545 */ // Label 1152: @40545
     /* 40545 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(40568), // Rule ID 620 //
     /* 40550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 40553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 40557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 40561 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 40561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 40566 */   GIR_RootConstrainSelectedInstOperands,
     /* 40567 */   // GIR_Coverage, 620,
     /* 40567 */   GIR_Done,
     /* 40568 */ // Label 1169: @40568
     /* 40568 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(40591), // Rule ID 622 //
     /* 40573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 40576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 40580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 40584 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 40584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 40589 */   GIR_RootConstrainSelectedInstOperands,
     /* 40590 */   // GIR_Coverage, 622,
     /* 40590 */   GIR_Done,
     /* 40591 */ // Label 1170: @40591
     /* 40591 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(40617), // Rule ID 624 //
     /* 40596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 40599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 40602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 40606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 40610 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 40610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 40615 */   GIR_RootConstrainSelectedInstOperands,
     /* 40616 */   // GIR_Coverage, 624,
     /* 40616 */   GIR_Done,
     /* 40617 */ // Label 1171: @40617
     /* 40617 */ GIM_Reject,
     /* 40618 */ // Label 1153: @40618
     /* 40618 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(40644), // Rule ID 12591 //
     /* 40623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 40629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 40637 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 40637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 40642 */   GIR_RootConstrainSelectedInstOperands,
     /* 40643 */   // GIR_Coverage, 12591,
     /* 40643 */   GIR_Done,
     /* 40644 */ // Label 1172: @40644
     /* 40644 */ GIM_Reject,
     /* 40645 */ // Label 1154: @40645
     /* 40645 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(40671), // Rule ID 12588 //
     /* 40650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 40656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 40664 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 40664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 40669 */   GIR_RootConstrainSelectedInstOperands,
     /* 40670 */   // GIR_Coverage, 12588,
     /* 40670 */   GIR_Done,
     /* 40671 */ // Label 1173: @40671
     /* 40671 */ GIM_Reject,
     /* 40672 */ // Label 1155: @40672
     /* 40672 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(40698), // Rule ID 12568 //
     /* 40677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 40680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40691 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 40691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 40696 */   GIR_RootConstrainSelectedInstOperands,
     /* 40697 */   // GIR_Coverage, 12568,
     /* 40697 */   GIR_Done,
     /* 40698 */ // Label 1174: @40698
     /* 40698 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(40724), // Rule ID 12590 //
     /* 40703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 40709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 40717 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 40717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 40722 */   GIR_RootConstrainSelectedInstOperands,
     /* 40723 */   // GIR_Coverage, 12590,
     /* 40723 */   GIR_Done,
     /* 40724 */ // Label 1175: @40724
     /* 40724 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(40750), // Rule ID 18825 //
     /* 40729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 40732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 40739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 40743 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 40743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 40748 */   GIR_RootConstrainSelectedInstOperands,
     /* 40749 */   // GIR_Coverage, 18825,
     /* 40749 */   GIR_Done,
     /* 40750 */ // Label 1176: @40750
     /* 40750 */ GIM_Reject,
     /* 40751 */ // Label 1156: @40751
     /* 40751 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(40819),
     /* 40756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 40759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 40767 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(40782), // Rule ID 12585 //
     /* 40772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 40775 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 40775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 40780 */     GIR_RootConstrainSelectedInstOperands,
     /* 40781 */     // GIR_Coverage, 12585,
     /* 40781 */     GIR_Done,
     /* 40782 */   // Label 1178: @40782
     /* 40782 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(40818), // Rule ID 22108 //
     /* 40787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 40790 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 40790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 40793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 40797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 40806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 40808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 40811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 40813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40816 */     GIR_RootConstrainSelectedInstOperands,
     /* 40817 */     // GIR_Coverage, 22108,
     /* 40817 */     GIR_EraseRootFromParent_Done,
     /* 40818 */   // Label 1179: @40818
     /* 40818 */   GIM_Reject,
     /* 40819 */ // Label 1177: @40819
     /* 40819 */ GIM_Reject,
     /* 40820 */ // Label 1157: @40820
     /* 40820 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(40846), // Rule ID 12532 //
     /* 40825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 40828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40839 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 40839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 40844 */   GIR_RootConstrainSelectedInstOperands,
     /* 40845 */   // GIR_Coverage, 12532,
     /* 40845 */   GIR_Done,
     /* 40846 */ // Label 1180: @40846
     /* 40846 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(40872), // Rule ID 12587 //
     /* 40851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 40854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 40857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 40865 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 40865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 40870 */   GIR_RootConstrainSelectedInstOperands,
     /* 40871 */   // GIR_Coverage, 12587,
     /* 40871 */   GIR_Done,
     /* 40872 */ // Label 1181: @40872
     /* 40872 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(40898), // Rule ID 18823 //
     /* 40877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 40880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 40887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 40891 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 40891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 40896 */   GIR_RootConstrainSelectedInstOperands,
     /* 40897 */   // GIR_Coverage, 18823,
     /* 40897 */   GIR_Done,
     /* 40898 */ // Label 1182: @40898
     /* 40898 */ GIM_Reject,
     /* 40899 */ // Label 1158: @40899
     /* 40899 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(40925), // Rule ID 12556 //
     /* 40904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 40907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40918 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 40918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 40923 */   GIR_RootConstrainSelectedInstOperands,
     /* 40924 */   // GIR_Coverage, 12556,
     /* 40924 */   GIR_Done,
     /* 40925 */ // Label 1183: @40925
     /* 40925 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(40951), // Rule ID 12574 //
     /* 40930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 40933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 40936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 40944 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 40944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 40949 */   GIR_RootConstrainSelectedInstOperands,
     /* 40950 */   // GIR_Coverage, 12574,
     /* 40950 */   GIR_Done,
     /* 40951 */ // Label 1184: @40951
     /* 40951 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(40977), // Rule ID 12589 //
     /* 40956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 40959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 40962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 40966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 40970 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 40970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 40975 */   GIR_RootConstrainSelectedInstOperands,
     /* 40976 */   // GIR_Coverage, 12589,
     /* 40976 */   GIR_Done,
     /* 40977 */ // Label 1185: @40977
     /* 40977 */ GIM_Reject,
     /* 40978 */ // Label 1159: @40978
     /* 40978 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(41046),
     /* 40983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 40986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 40990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 40994 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(41009), // Rule ID 12582 //
     /* 40999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 41002 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 41002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 41007 */     GIR_RootConstrainSelectedInstOperands,
     /* 41008 */     // GIR_Coverage, 12582,
     /* 41008 */     GIR_Done,
     /* 41009 */   // Label 1187: @41009
     /* 41009 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(41045), // Rule ID 22106 //
     /* 41014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 41017 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 41017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 41020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 41024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 41033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 41038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41043 */     GIR_RootConstrainSelectedInstOperands,
     /* 41044 */     // GIR_Coverage, 22106,
     /* 41044 */     GIR_EraseRootFromParent_Done,
     /* 41045 */   // Label 1188: @41045
     /* 41045 */   GIM_Reject,
     /* 41046 */ // Label 1186: @41046
     /* 41046 */ GIM_Reject,
     /* 41047 */ // Label 1160: @41047
     /* 41047 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(41073), // Rule ID 12478 //
     /* 41052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 41055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 41062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 41066 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 41066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 41071 */   GIR_RootConstrainSelectedInstOperands,
     /* 41072 */   // GIR_Coverage, 12478,
     /* 41072 */   GIR_Done,
     /* 41073 */ // Label 1189: @41073
     /* 41073 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(41099), // Rule ID 12584 //
     /* 41078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 41081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 41084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 41088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 41092 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 41092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 41097 */   GIR_RootConstrainSelectedInstOperands,
     /* 41098 */   // GIR_Coverage, 12584,
     /* 41098 */   GIR_Done,
     /* 41099 */ // Label 1190: @41099
     /* 41099 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(41125), // Rule ID 18820 //
     /* 41104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 41107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 41114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 41118 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 41118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 41123 */   GIR_RootConstrainSelectedInstOperands,
     /* 41124 */   // GIR_Coverage, 18820,
     /* 41124 */   GIR_Done,
     /* 41125 */ // Label 1191: @41125
     /* 41125 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(41172), // Rule ID 22107 //
     /* 41130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 41133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 41136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 41140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 41144 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 41144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 41147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 41151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 41160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 41165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41170 */   GIR_RootConstrainSelectedInstOperands,
     /* 41171 */   // GIR_Coverage, 22107,
     /* 41171 */   GIR_EraseRootFromParent_Done,
     /* 41172 */ // Label 1192: @41172
     /* 41172 */ GIM_Reject,
     /* 41173 */ // Label 1161: @41173
     /* 41173 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(41199), // Rule ID 12502 //
     /* 41178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 41181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 41188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 41192 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 41192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 41197 */   GIR_RootConstrainSelectedInstOperands,
     /* 41198 */   // GIR_Coverage, 12502,
     /* 41198 */   GIR_Done,
     /* 41199 */ // Label 1193: @41199
     /* 41199 */ GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(41225), // Rule ID 12538 //
     /* 41204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 41207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 41210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 41214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 41218 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 41218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 41223 */   GIR_RootConstrainSelectedInstOperands,
     /* 41224 */   // GIR_Coverage, 12538,
     /* 41224 */   GIR_Done,
     /* 41225 */ // Label 1194: @41225
     /* 41225 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(41251), // Rule ID 12586 //
     /* 41230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 41233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 41236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 41240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 41244 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 41244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 41249 */   GIR_RootConstrainSelectedInstOperands,
     /* 41250 */   // GIR_Coverage, 12586,
     /* 41250 */   GIR_Done,
     /* 41251 */ // Label 1195: @41251
     /* 41251 */ GIM_Reject,
     /* 41252 */ // Label 1162: @41252
     /* 41252 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(41278), // Rule ID 12581 //
     /* 41257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 41260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 41263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 41267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 41271 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 41271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 41276 */   GIR_RootConstrainSelectedInstOperands,
     /* 41277 */   // GIR_Coverage, 12581,
     /* 41277 */   GIR_Done,
     /* 41278 */ // Label 1196: @41278
     /* 41278 */ GIM_Reject,
     /* 41279 */ // Label 1163: @41279
     /* 41279 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(41305), // Rule ID 12484 //
     /* 41284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 41287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 41290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 41294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 41298 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 41298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 41303 */   GIR_RootConstrainSelectedInstOperands,
     /* 41304 */   // GIR_Coverage, 12484,
     /* 41304 */   GIR_Done,
     /* 41305 */ // Label 1197: @41305
     /* 41305 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(41331), // Rule ID 12583 //
     /* 41310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 41313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 41316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 41320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 41324 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 41324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 41329 */   GIR_RootConstrainSelectedInstOperands,
     /* 41330 */   // GIR_Coverage, 12583,
     /* 41330 */   GIR_Done,
     /* 41331 */ // Label 1198: @41331
     /* 41331 */ GIM_Reject,
     /* 41332 */ // Label 1164: @41332
     /* 41332 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(41358), // Rule ID 12580 //
     /* 41337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 41340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 41343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 41347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 41351 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 41351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 41356 */   GIR_RootConstrainSelectedInstOperands,
     /* 41357 */   // GIR_Coverage, 12580,
     /* 41357 */   GIR_Done,
     /* 41358 */ // Label 1199: @41358
     /* 41358 */ GIM_Reject,
     /* 41359 */ // Label 1165: @41359
     /* 41359 */ GIM_Reject,
     /* 41360 */ // Label 17: @41360
     /* 41360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1202*/ GIMT_Encode4(41601),
     /* 41371 */ /*GILLT_s16*//*Label 1200*/ GIMT_Encode4(41379),
     /* 41375 */ /*GILLT_s32*//*Label 1201*/ GIMT_Encode4(41475),
     /* 41379 */ // Label 1200: @41379
     /* 41379 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(41474), // Rule ID 23088 //
     /* 41384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41395 */   // MIs[0] Operand 2
     /* 41395 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 41406 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 41406 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 41409 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41413 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41418 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 41424 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 41429 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 41434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 41441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41446 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 41449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41456 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 41463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 41468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41473 */   // GIR_Coverage, 23088,
     /* 41473 */   GIR_EraseRootFromParent_Done,
     /* 41474 */ // Label 1203: @41474
     /* 41474 */ GIM_Reject,
     /* 41475 */ // Label 1201: @41475
     /* 41475 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(41600),
     /* 41480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41491 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(41545), // Rule ID 23086 //
     /* 41496 */     // MIs[0] Operand 2
     /* 41496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 41507 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 41507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 41510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41519 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 41525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 41530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 41538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41543 */     GIR_RootConstrainSelectedInstOperands,
     /* 41544 */     // GIR_Coverage, 23086,
     /* 41544 */     GIR_EraseRootFromParent_Done,
     /* 41545 */   // Label 1205: @41545
     /* 41545 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(41599), // Rule ID 23087 //
     /* 41550 */     // MIs[0] Operand 2
     /* 41550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 41561 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 41561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 41564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41573 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 41579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 41584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 41592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41597 */     GIR_RootConstrainSelectedInstOperands,
     /* 41598 */     // GIR_Coverage, 23087,
     /* 41598 */     GIR_EraseRootFromParent_Done,
     /* 41599 */   // Label 1206: @41599
     /* 41599 */   GIM_Reject,
     /* 41600 */ // Label 1204: @41600
     /* 41600 */ GIM_Reject,
     /* 41601 */ // Label 1202: @41601
     /* 41601 */ GIM_Reject,
     /* 41602 */ // Label 18: @41602
     /* 41602 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1216*/ GIMT_Encode4(42709),
     /* 41613 */ /*GILLT_s16*//*Label 1207*/ GIMT_Encode4(41697),
     /* 41617 */ /*GILLT_s32*//*Label 1208*/ GIMT_Encode4(41755),
     /* 41621 */ /*GILLT_s64*//*Label 1209*/ GIMT_Encode4(41984), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41649 */ /*GILLT_v4s64*//*Label 1210*/ GIMT_Encode4(42408), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41661 */ /*GILLT_v8s32*//*Label 1211*/ GIMT_Encode4(42464),
     /* 41665 */ /*GILLT_v8s64*//*Label 1212*/ GIMT_Encode4(42520), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41677 */ /*GILLT_v16s16*//*Label 1213*/ GIMT_Encode4(42573),
     /* 41681 */ /*GILLT_v16s32*//*Label 1214*/ GIMT_Encode4(42629), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 41693 */ /*GILLT_v32s16*//*Label 1215*/ GIMT_Encode4(42682),
     /* 41697 */ // Label 1207: @41697
     /* 41697 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(41754), // Rule ID 23094 //
     /* 41702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 41713 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 41713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 41720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41725 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 41729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41736 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 41743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 41748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 41753 */   // GIR_Coverage, 23094,
     /* 41753 */   GIR_EraseRootFromParent_Done,
     /* 41754 */ // Label 1217: @41754
     /* 41754 */ GIM_Reject,
     /* 41755 */ // Label 1208: @41755
     /* 41755 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(41850), // Rule ID 23417 //
     /* 41760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 41763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 41770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 41778 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 41782 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 41786 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41791 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41795 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41799 */   // MIs[2] Operand 1
     /* 41799 */   // No operand predicates
     /* 41799 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 41801 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 41801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 41804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 41808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41813 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 41817 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 41820 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 41823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 41825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 41828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 41833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 41839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 41844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 41849 */   // GIR_Coverage, 23417,
     /* 41849 */   GIR_EraseRootFromParent_Done,
     /* 41850 */ // Label 1218: @41850
     /* 41850 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(41892), // Rule ID 19882 //
     /* 41855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 41870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 41874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 41879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41881 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 41881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 41884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41886 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 41890 */   GIR_RootConstrainSelectedInstOperands,
     /* 41891 */   // GIR_Coverage, 19882,
     /* 41891 */   GIR_EraseRootFromParent_Done,
     /* 41892 */ // Label 1219: @41892
     /* 41892 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(41937), // Rule ID 19885 //
     /* 41897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 41900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 41911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 41915 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 41919 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 41924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41926 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 41926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 41929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 41931 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 41935 */   GIR_RootConstrainSelectedInstOperands,
     /* 41936 */   // GIR_Coverage, 19885,
     /* 41936 */   GIR_EraseRootFromParent_Done,
     /* 41937 */ // Label 1220: @41937
     /* 41937 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(41960), // Rule ID 616 //
     /* 41942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 41945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 41953 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 41953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 41958 */   GIR_RootConstrainSelectedInstOperands,
     /* 41959 */   // GIR_Coverage, 616,
     /* 41959 */   GIR_Done,
     /* 41960 */ // Label 1221: @41960
     /* 41960 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(41983), // Rule ID 618 //
     /* 41965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 41972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 41976 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 41976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 41981 */   GIR_RootConstrainSelectedInstOperands,
     /* 41982 */   // GIR_Coverage, 618,
     /* 41982 */   GIR_Done,
     /* 41983 */ // Label 1222: @41983
     /* 41983 */ GIM_Reject,
     /* 41984 */ // Label 1209: @41984
     /* 41984 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(42079), // Rule ID 23419 //
     /* 41989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 41992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 41995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 41999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 42003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 42007 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 42011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 42015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 42020 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42024 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42028 */   // MIs[2] Operand 1
     /* 42028 */   // No operand predicates
     /* 42028 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 42030 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 42030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 42033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 42037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42042 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 42046 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 42049 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 42052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 42068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 42078 */   // GIR_Coverage, 23419,
     /* 42078 */   GIR_EraseRootFromParent_Done,
     /* 42079 */ // Label 1223: @42079
     /* 42079 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(42153), // Rule ID 19883 //
     /* 42084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 42087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 42091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 42095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 42099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 42103 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 42108 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42110 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 42110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 42113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 42117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42122 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 42126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 42142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 42152 */   // GIR_Coverage, 19883,
     /* 42152 */   GIR_EraseRootFromParent_Done,
     /* 42153 */ // Label 1224: @42153
     /* 42153 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(42230), // Rule ID 19886 //
     /* 42158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 42161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 42164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 42168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 42172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 42176 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 42180 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 42185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42187 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 42187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 42190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 42194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42199 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 42203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 42219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 42229 */   // GIR_Coverage, 19886,
     /* 42229 */   GIR_EraseRootFromParent_Done,
     /* 42230 */ // Label 1225: @42230
     /* 42230 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(42289), // Rule ID 18037 //
     /* 42235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 42238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 42242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 42246 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 42246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 42249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 42253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42258 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 42262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 42278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 42288 */   // GIR_Coverage, 18037,
     /* 42288 */   GIR_EraseRootFromParent_Done,
     /* 42289 */ // Label 1226: @42289
     /* 42289 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(42348), // Rule ID 18039 //
     /* 42294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 42297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 42301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 42305 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 42305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 42308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 42312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 42321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 42337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 42347 */   // GIR_Coverage, 18039,
     /* 42347 */   GIR_EraseRootFromParent_Done,
     /* 42348 */ // Label 1227: @42348
     /* 42348 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(42407), // Rule ID 18041 //
     /* 42353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 42356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 42360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 42364 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 42364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 42367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 42371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42376 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 42380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 42382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 42385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 42390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 42393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 42396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 42401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 42406 */   // GIR_Coverage, 18041,
     /* 42406 */   GIR_EraseRootFromParent_Done,
     /* 42407 */ // Label 1228: @42407
     /* 42407 */ GIM_Reject,
     /* 42408 */ // Label 1210: @42408
     /* 42408 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(42463),
     /* 42413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 42416 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(42439), // Rule ID 12460 //
     /* 42421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 42424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42432 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 42432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 42437 */     GIR_RootConstrainSelectedInstOperands,
     /* 42438 */     // GIR_Coverage, 12460,
     /* 42438 */     GIR_Done,
     /* 42439 */   // Label 1230: @42439
     /* 42439 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(42462), // Rule ID 18848 //
     /* 42444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 42447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 42451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 42455 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 42455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 42460 */     GIR_RootConstrainSelectedInstOperands,
     /* 42461 */     // GIR_Coverage, 18848,
     /* 42461 */     GIR_Done,
     /* 42462 */   // Label 1231: @42462
     /* 42462 */   GIM_Reject,
     /* 42463 */ // Label 1229: @42463
     /* 42463 */ GIM_Reject,
     /* 42464 */ // Label 1211: @42464
     /* 42464 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(42519),
     /* 42469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42472 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(42495), // Rule ID 12424 //
     /* 42477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 42480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42488 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 42488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 42493 */     GIR_RootConstrainSelectedInstOperands,
     /* 42494 */     // GIR_Coverage, 12424,
     /* 42494 */     GIR_Done,
     /* 42495 */   // Label 1233: @42495
     /* 42495 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(42518), // Rule ID 18846 //
     /* 42500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 42503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 42507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 42511 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 42511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 42516 */     GIR_RootConstrainSelectedInstOperands,
     /* 42517 */     // GIR_Coverage, 18846,
     /* 42517 */     GIR_Done,
     /* 42518 */   // Label 1234: @42518
     /* 42518 */   GIM_Reject,
     /* 42519 */ // Label 1232: @42519
     /* 42519 */ GIM_Reject,
     /* 42520 */ // Label 1212: @42520
     /* 42520 */ GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(42546), // Rule ID 12448 //
     /* 42525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42539 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 42539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 42544 */   GIR_RootConstrainSelectedInstOperands,
     /* 42545 */   // GIR_Coverage, 12448,
     /* 42545 */   GIR_Done,
     /* 42546 */ // Label 1235: @42546
     /* 42546 */ GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(42572), // Rule ID 12466 //
     /* 42551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 42557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42565 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 42565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 42570 */   GIR_RootConstrainSelectedInstOperands,
     /* 42571 */   // GIR_Coverage, 12466,
     /* 42571 */   GIR_Done,
     /* 42572 */ // Label 1236: @42572
     /* 42572 */ GIM_Reject,
     /* 42573 */ // Label 1213: @42573
     /* 42573 */ GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(42628),
     /* 42578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42581 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(42604), // Rule ID 12370 //
     /* 42586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 42589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42597 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 42597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 42602 */     GIR_RootConstrainSelectedInstOperands,
     /* 42603 */     // GIR_Coverage, 12370,
     /* 42603 */     GIR_Done,
     /* 42604 */   // Label 1238: @42604
     /* 42604 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(42627), // Rule ID 18843 //
     /* 42609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 42612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 42616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 42620 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 42620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 42625 */     GIR_RootConstrainSelectedInstOperands,
     /* 42626 */     // GIR_Coverage, 18843,
     /* 42626 */     GIR_Done,
     /* 42627 */   // Label 1239: @42627
     /* 42627 */   GIM_Reject,
     /* 42628 */ // Label 1237: @42628
     /* 42628 */ GIM_Reject,
     /* 42629 */ // Label 1214: @42629
     /* 42629 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(42655), // Rule ID 12394 //
     /* 42634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 42648 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 42648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 42653 */   GIR_RootConstrainSelectedInstOperands,
     /* 42654 */   // GIR_Coverage, 12394,
     /* 42654 */   GIR_Done,
     /* 42655 */ // Label 1240: @42655
     /* 42655 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(42681), // Rule ID 12430 //
     /* 42660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 42663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 42666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42674 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 42674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 42679 */   GIR_RootConstrainSelectedInstOperands,
     /* 42680 */   // GIR_Coverage, 12430,
     /* 42680 */   GIR_Done,
     /* 42681 */ // Label 1241: @42681
     /* 42681 */ GIM_Reject,
     /* 42682 */ // Label 1215: @42682
     /* 42682 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(42708), // Rule ID 12376 //
     /* 42687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 42690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 42693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 42697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 42701 */   // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 42701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 42706 */   GIR_RootConstrainSelectedInstOperands,
     /* 42707 */   // GIR_Coverage, 12376,
     /* 42707 */   GIR_Done,
     /* 42708 */ // Label 1242: @42708
     /* 42708 */ GIM_Reject,
     /* 42709 */ // Label 1216: @42709
     /* 42709 */ GIM_Reject,
     /* 42710 */ // Label 19: @42710
     /* 42710 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1247*/ GIMT_Encode4(43897),
     /* 42721 */ /*GILLT_s8*//*Label 1243*/ GIMT_Encode4(42737),
     /* 42725 */ /*GILLT_s16*//*Label 1244*/ GIMT_Encode4(42952),
     /* 42729 */ /*GILLT_s32*//*Label 1245*/ GIMT_Encode4(43167),
     /* 42733 */ /*GILLT_s64*//*Label 1246*/ GIMT_Encode4(43532),
     /* 42737 */ // Label 1243: @42737
     /* 42737 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(42951),
     /* 42742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 42745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 42748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 42752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 42756 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(42782), // Rule ID 23119 //
     /* 42761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42768 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 42768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 42771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42780 */     GIR_RootConstrainSelectedInstOperands,
     /* 42781 */     // GIR_Coverage, 23119,
     /* 42781 */     GIR_EraseRootFromParent_Done,
     /* 42782 */   // Label 1249: @42782
     /* 42782 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(42808), // Rule ID 23123 //
     /* 42787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 42790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42794 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 42794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 42797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42806 */     GIR_RootConstrainSelectedInstOperands,
     /* 42807 */     // GIR_Coverage, 23123,
     /* 42807 */     GIR_EraseRootFromParent_Done,
     /* 42808 */   // Label 1250: @42808
     /* 42808 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(42841), // Rule ID 658 //
     /* 42813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42824 */     // MIs[1] Operand 1
     /* 42824 */     // No operand predicates
     /* 42824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42826 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 42829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42839 */     GIR_RootConstrainSelectedInstOperands,
     /* 42840 */     // GIR_Coverage, 658,
     /* 42840 */     GIR_EraseRootFromParent_Done,
     /* 42841 */   // Label 1251: @42841
     /* 42841 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(42874), // Rule ID 662 //
     /* 42846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42857 */     // MIs[1] Operand 1
     /* 42857 */     // No operand predicates
     /* 42857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 42859 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 42859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 42862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 42869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42872 */     GIR_RootConstrainSelectedInstOperands,
     /* 42873 */     // GIR_Coverage, 662,
     /* 42873 */     GIR_EraseRootFromParent_Done,
     /* 42874 */   // Label 1252: @42874
     /* 42874 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(42912), // Rule ID 674 //
     /* 42879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 42886 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 42886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 42890 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 42900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 42903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42910 */     GIR_RootConstrainSelectedInstOperands,
     /* 42911 */     // GIR_Coverage, 674,
     /* 42911 */     GIR_EraseRootFromParent_Done,
     /* 42912 */   // Label 1253: @42912
     /* 42912 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(42950), // Rule ID 678 //
     /* 42917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 42920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 42924 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 42924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 42928 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 42934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 42938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 42941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42948 */     GIR_RootConstrainSelectedInstOperands,
     /* 42949 */     // GIR_Coverage, 678,
     /* 42949 */     GIR_EraseRootFromParent_Done,
     /* 42950 */   // Label 1254: @42950
     /* 42950 */   GIM_Reject,
     /* 42951 */ // Label 1248: @42951
     /* 42951 */ GIM_Reject,
     /* 42952 */ // Label 1244: @42952
     /* 42952 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(43166),
     /* 42957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 42960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 42963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 42967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 42971 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(42997), // Rule ID 23120 //
     /* 42976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 42979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 42983 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 42983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 42986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 42988 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 42992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 42995 */     GIR_RootConstrainSelectedInstOperands,
     /* 42996 */     // GIR_Coverage, 23120,
     /* 42996 */     GIR_EraseRootFromParent_Done,
     /* 42997 */   // Label 1256: @42997
     /* 42997 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(43023), // Rule ID 23124 //
     /* 43002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 43005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43009 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 43009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 43012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43014 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43021 */     GIR_RootConstrainSelectedInstOperands,
     /* 43022 */     // GIR_Coverage, 23124,
     /* 43022 */     GIR_EraseRootFromParent_Done,
     /* 43023 */   // Label 1257: @43023
     /* 43023 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(43056), // Rule ID 659 //
     /* 43028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43039 */     // MIs[1] Operand 1
     /* 43039 */     // No operand predicates
     /* 43039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43041 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 43044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43046 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43054 */     GIR_RootConstrainSelectedInstOperands,
     /* 43055 */     // GIR_Coverage, 659,
     /* 43055 */     GIR_EraseRootFromParent_Done,
     /* 43056 */   // Label 1258: @43056
     /* 43056 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(43089), // Rule ID 663 //
     /* 43061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43072 */     // MIs[1] Operand 1
     /* 43072 */     // No operand predicates
     /* 43072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43074 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 43077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43087 */     GIR_RootConstrainSelectedInstOperands,
     /* 43088 */     // GIR_Coverage, 663,
     /* 43088 */     GIR_EraseRootFromParent_Done,
     /* 43089 */   // Label 1259: @43089
     /* 43089 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(43127), // Rule ID 675 //
     /* 43094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43101 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 43101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43105 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 43118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43125 */     GIR_RootConstrainSelectedInstOperands,
     /* 43126 */     // GIR_Coverage, 675,
     /* 43126 */     GIR_EraseRootFromParent_Done,
     /* 43127 */   // Label 1260: @43127
     /* 43127 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(43165), // Rule ID 679 //
     /* 43132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43139 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 43139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43143 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 43156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43163 */     GIR_RootConstrainSelectedInstOperands,
     /* 43164 */     // GIR_Coverage, 679,
     /* 43164 */     GIR_EraseRootFromParent_Done,
     /* 43165 */   // Label 1261: @43165
     /* 43165 */   GIM_Reject,
     /* 43166 */ // Label 1255: @43166
     /* 43166 */ GIM_Reject,
     /* 43167 */ // Label 1245: @43167
     /* 43167 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(43531),
     /* 43172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 43175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 43182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 43186 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(43212), // Rule ID 23121 //
     /* 43191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43198 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 43198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 43201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43210 */     GIR_RootConstrainSelectedInstOperands,
     /* 43211 */     // GIR_Coverage, 23121,
     /* 43211 */     GIR_EraseRootFromParent_Done,
     /* 43212 */   // Label 1263: @43212
     /* 43212 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(43238), // Rule ID 23125 //
     /* 43217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 43220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43224 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 43224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 43227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43236 */     GIR_RootConstrainSelectedInstOperands,
     /* 43237 */     // GIR_Coverage, 23125,
     /* 43237 */     GIR_EraseRootFromParent_Done,
     /* 43238 */   // Label 1264: @43238
     /* 43238 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(43271), // Rule ID 660 //
     /* 43243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43254 */     // MIs[1] Operand 1
     /* 43254 */     // No operand predicates
     /* 43254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43256 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 43259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43269 */     GIR_RootConstrainSelectedInstOperands,
     /* 43270 */     // GIR_Coverage, 660,
     /* 43270 */     GIR_EraseRootFromParent_Done,
     /* 43271 */   // Label 1265: @43271
     /* 43271 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(43304), // Rule ID 664 //
     /* 43276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43287 */     // MIs[1] Operand 1
     /* 43287 */     // No operand predicates
     /* 43287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43289 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 43292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43302 */     GIR_RootConstrainSelectedInstOperands,
     /* 43303 */     // GIR_Coverage, 664,
     /* 43303 */     GIR_EraseRootFromParent_Done,
     /* 43304 */   // Label 1266: @43304
     /* 43304 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(43379), // Rule ID 18115 //
     /* 43309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 43312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43316 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 43319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 43357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 43362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 43370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43377 */     GIR_RootConstrainSelectedInstOperands,
     /* 43378 */     // GIR_Coverage, 18115,
     /* 43378 */     GIR_EraseRootFromParent_Done,
     /* 43379 */   // Label 1267: @43379
     /* 43379 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(43454), // Rule ID 18147 //
     /* 43384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 43387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43391 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 43394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43417 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 43432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 43437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 43445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43452 */     GIR_RootConstrainSelectedInstOperands,
     /* 43453 */     // GIR_Coverage, 18147,
     /* 43453 */     GIR_EraseRootFromParent_Done,
     /* 43454 */   // Label 1268: @43454
     /* 43454 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(43492), // Rule ID 676 //
     /* 43459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43466 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 43466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43470 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 43483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43490 */     GIR_RootConstrainSelectedInstOperands,
     /* 43491 */     // GIR_Coverage, 676,
     /* 43491 */     GIR_EraseRootFromParent_Done,
     /* 43492 */   // Label 1269: @43492
     /* 43492 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(43530), // Rule ID 680 //
     /* 43497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43504 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 43504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43508 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 43521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43528 */     GIR_RootConstrainSelectedInstOperands,
     /* 43529 */     // GIR_Coverage, 680,
     /* 43529 */     GIR_EraseRootFromParent_Done,
     /* 43530 */   // Label 1270: @43530
     /* 43530 */   GIM_Reject,
     /* 43531 */ // Label 1262: @43531
     /* 43531 */ GIM_Reject,
     /* 43532 */ // Label 1246: @43532
     /* 43532 */ GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(43896),
     /* 43537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 43540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 43547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 43551 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(43577), // Rule ID 23122 //
     /* 43556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43563 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 43563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 43566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43575 */     GIR_RootConstrainSelectedInstOperands,
     /* 43576 */     // GIR_Coverage, 23122,
     /* 43576 */     GIR_EraseRootFromParent_Done,
     /* 43577 */   // Label 1272: @43577
     /* 43577 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(43603), // Rule ID 23126 //
     /* 43582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 43585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 43589 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 43589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 43592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43596 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43601 */     GIR_RootConstrainSelectedInstOperands,
     /* 43602 */     // GIR_Coverage, 23126,
     /* 43602 */     GIR_EraseRootFromParent_Done,
     /* 43603 */   // Label 1273: @43603
     /* 43603 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(43636), // Rule ID 661 //
     /* 43608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43619 */     // MIs[1] Operand 1
     /* 43619 */     // No operand predicates
     /* 43619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43621 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 43624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43634 */     GIR_RootConstrainSelectedInstOperands,
     /* 43635 */     // GIR_Coverage, 661,
     /* 43635 */     GIR_EraseRootFromParent_Done,
     /* 43636 */   // Label 1274: @43636
     /* 43636 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(43669), // Rule ID 665 //
     /* 43641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43652 */     // MIs[1] Operand 1
     /* 43652 */     // No operand predicates
     /* 43652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43654 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 43657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43667 */     GIR_RootConstrainSelectedInstOperands,
     /* 43668 */     // GIR_Coverage, 665,
     /* 43668 */     GIR_EraseRootFromParent_Done,
     /* 43669 */   // Label 1275: @43669
     /* 43669 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(43744), // Rule ID 18116 //
     /* 43674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 43677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43681 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 43684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 43698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 43735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43742 */     GIR_RootConstrainSelectedInstOperands,
     /* 43743 */     // GIR_Coverage, 18116,
     /* 43743 */     GIR_EraseRootFromParent_Done,
     /* 43744 */   // Label 1276: @43744
     /* 43744 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(43819), // Rule ID 18148 //
     /* 43749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 43752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43756 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 43756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 43759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 43763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 43770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 43773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 43777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 43785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 43789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 43792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 43802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 43807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 43810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43812 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43817 */     GIR_RootConstrainSelectedInstOperands,
     /* 43818 */     // GIR_Coverage, 18148,
     /* 43818 */     GIR_EraseRootFromParent_Done,
     /* 43819 */   // Label 1277: @43819
     /* 43819 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(43857), // Rule ID 677 //
     /* 43824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43831 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 43831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43835 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 43848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43850 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43855 */     GIR_RootConstrainSelectedInstOperands,
     /* 43856 */     // GIR_Coverage, 677,
     /* 43856 */     GIR_EraseRootFromParent_Done,
     /* 43857 */   // Label 1278: @43857
     /* 43857 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(43895), // Rule ID 681 //
     /* 43862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 43869 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 43869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43873 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 43883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 43886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43893 */     GIR_RootConstrainSelectedInstOperands,
     /* 43894 */     // GIR_Coverage, 681,
     /* 43894 */     GIR_EraseRootFromParent_Done,
     /* 43895 */   // Label 1279: @43895
     /* 43895 */   GIM_Reject,
     /* 43896 */ // Label 1271: @43896
     /* 43896 */ GIM_Reject,
     /* 43897 */ // Label 1247: @43897
     /* 43897 */ GIM_Reject,
     /* 43898 */ // Label 20: @43898
     /* 43898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1284*/ GIMT_Encode4(44877),
     /* 43909 */ /*GILLT_s8*//*Label 1280*/ GIMT_Encode4(43925),
     /* 43913 */ /*GILLT_s16*//*Label 1281*/ GIMT_Encode4(44088),
     /* 43917 */ /*GILLT_s32*//*Label 1282*/ GIMT_Encode4(44251),
     /* 43921 */ /*GILLT_s64*//*Label 1283*/ GIMT_Encode4(44564),
     /* 43925 */ // Label 1280: @43925
     /* 43925 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(44087),
     /* 43930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 43933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 43936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 43944 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(43977), // Rule ID 690 //
     /* 43949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 43952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43960 */     // MIs[1] Operand 1
     /* 43960 */     // No operand predicates
     /* 43960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43962 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 43965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 43967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 43969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 43972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 43975 */     GIR_RootConstrainSelectedInstOperands,
     /* 43976 */     // GIR_Coverage, 690,
     /* 43976 */     GIR_EraseRootFromParent_Done,
     /* 43977 */   // Label 1286: @43977
     /* 43977 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(44010), // Rule ID 694 //
     /* 43982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 43985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43993 */     // MIs[1] Operand 1
     /* 43993 */     // No operand predicates
     /* 43993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43995 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 43995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 43998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44008 */     GIR_RootConstrainSelectedInstOperands,
     /* 44009 */     // GIR_Coverage, 694,
     /* 44009 */     GIR_EraseRootFromParent_Done,
     /* 44010 */   // Label 1287: @44010
     /* 44010 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(44048), // Rule ID 706 //
     /* 44015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44022 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 44022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44026 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 44039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44046 */     GIR_RootConstrainSelectedInstOperands,
     /* 44047 */     // GIR_Coverage, 706,
     /* 44047 */     GIR_EraseRootFromParent_Done,
     /* 44048 */   // Label 1288: @44048
     /* 44048 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(44086), // Rule ID 710 //
     /* 44053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44060 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 44060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 44077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44084 */     GIR_RootConstrainSelectedInstOperands,
     /* 44085 */     // GIR_Coverage, 710,
     /* 44085 */     GIR_EraseRootFromParent_Done,
     /* 44086 */   // Label 1289: @44086
     /* 44086 */   GIM_Reject,
     /* 44087 */ // Label 1285: @44087
     /* 44087 */ GIM_Reject,
     /* 44088 */ // Label 1281: @44088
     /* 44088 */ GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(44250),
     /* 44093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 44096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 44103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 44107 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(44140), // Rule ID 691 //
     /* 44112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44123 */     // MIs[1] Operand 1
     /* 44123 */     // No operand predicates
     /* 44123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44125 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 44128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44138 */     GIR_RootConstrainSelectedInstOperands,
     /* 44139 */     // GIR_Coverage, 691,
     /* 44139 */     GIR_EraseRootFromParent_Done,
     /* 44140 */   // Label 1291: @44140
     /* 44140 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(44173), // Rule ID 695 //
     /* 44145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44156 */     // MIs[1] Operand 1
     /* 44156 */     // No operand predicates
     /* 44156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44158 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 44161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44171 */     GIR_RootConstrainSelectedInstOperands,
     /* 44172 */     // GIR_Coverage, 695,
     /* 44172 */     GIR_EraseRootFromParent_Done,
     /* 44173 */   // Label 1292: @44173
     /* 44173 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(44211), // Rule ID 707 //
     /* 44178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44185 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 44185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 44202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44209 */     GIR_RootConstrainSelectedInstOperands,
     /* 44210 */     // GIR_Coverage, 707,
     /* 44210 */     GIR_EraseRootFromParent_Done,
     /* 44211 */   // Label 1293: @44211
     /* 44211 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(44249), // Rule ID 711 //
     /* 44216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44223 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 44223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44227 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 44240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44247 */     GIR_RootConstrainSelectedInstOperands,
     /* 44248 */     // GIR_Coverage, 711,
     /* 44248 */     GIR_EraseRootFromParent_Done,
     /* 44249 */   // Label 1294: @44249
     /* 44249 */   GIM_Reject,
     /* 44250 */ // Label 1290: @44250
     /* 44250 */ GIM_Reject,
     /* 44251 */ // Label 1282: @44251
     /* 44251 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(44563),
     /* 44256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 44259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 44266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 44270 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(44303), // Rule ID 692 //
     /* 44275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44286 */     // MIs[1] Operand 1
     /* 44286 */     // No operand predicates
     /* 44286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44288 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 44291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44293 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44301 */     GIR_RootConstrainSelectedInstOperands,
     /* 44302 */     // GIR_Coverage, 692,
     /* 44302 */     GIR_EraseRootFromParent_Done,
     /* 44303 */   // Label 1296: @44303
     /* 44303 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(44336), // Rule ID 696 //
     /* 44308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44319 */     // MIs[1] Operand 1
     /* 44319 */     // No operand predicates
     /* 44319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44321 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 44324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44334 */     GIR_RootConstrainSelectedInstOperands,
     /* 44335 */     // GIR_Coverage, 696,
     /* 44335 */     GIR_EraseRootFromParent_Done,
     /* 44336 */   // Label 1297: @44336
     /* 44336 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(44411), // Rule ID 18107 //
     /* 44341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 44344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44348 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 44351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 44365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 44402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44409 */     GIR_RootConstrainSelectedInstOperands,
     /* 44410 */     // GIR_Coverage, 18107,
     /* 44410 */     GIR_EraseRootFromParent_Done,
     /* 44411 */   // Label 1298: @44411
     /* 44411 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(44486), // Rule ID 18139 //
     /* 44416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 44419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44423 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 44426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 44440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44449 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 44469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 44477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44479 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44484 */     GIR_RootConstrainSelectedInstOperands,
     /* 44485 */     // GIR_Coverage, 18139,
     /* 44485 */     GIR_EraseRootFromParent_Done,
     /* 44486 */   // Label 1299: @44486
     /* 44486 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(44524), // Rule ID 708 //
     /* 44491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44498 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 44498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44502 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 44515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44522 */     GIR_RootConstrainSelectedInstOperands,
     /* 44523 */     // GIR_Coverage, 708,
     /* 44523 */     GIR_EraseRootFromParent_Done,
     /* 44524 */   // Label 1300: @44524
     /* 44524 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(44562), // Rule ID 712 //
     /* 44529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44536 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 44536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44540 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 44553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44560 */     GIR_RootConstrainSelectedInstOperands,
     /* 44561 */     // GIR_Coverage, 712,
     /* 44561 */     GIR_EraseRootFromParent_Done,
     /* 44562 */   // Label 1301: @44562
     /* 44562 */   GIM_Reject,
     /* 44563 */ // Label 1295: @44563
     /* 44563 */ GIM_Reject,
     /* 44564 */ // Label 1283: @44564
     /* 44564 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(44876),
     /* 44569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 44572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 44579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 44583 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(44616), // Rule ID 693 //
     /* 44588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44599 */     // MIs[1] Operand 1
     /* 44599 */     // No operand predicates
     /* 44599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44601 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 44604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44614 */     GIR_RootConstrainSelectedInstOperands,
     /* 44615 */     // GIR_Coverage, 693,
     /* 44615 */     GIR_EraseRootFromParent_Done,
     /* 44616 */   // Label 1303: @44616
     /* 44616 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(44649), // Rule ID 697 //
     /* 44621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44632 */     // MIs[1] Operand 1
     /* 44632 */     // No operand predicates
     /* 44632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44634 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 44637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44647 */     GIR_RootConstrainSelectedInstOperands,
     /* 44648 */     // GIR_Coverage, 697,
     /* 44648 */     GIR_EraseRootFromParent_Done,
     /* 44649 */   // Label 1304: @44649
     /* 44649 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(44724), // Rule ID 18108 //
     /* 44654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 44657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44661 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 44664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 44678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 44715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44722 */     GIR_RootConstrainSelectedInstOperands,
     /* 44723 */     // GIR_Coverage, 18108,
     /* 44723 */     GIR_EraseRootFromParent_Done,
     /* 44724 */   // Label 1305: @44724
     /* 44724 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(44799), // Rule ID 18140 //
     /* 44729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 44732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44736 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 44736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 44739 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 44743 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 44750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 44753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 44757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 44765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 44769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 44772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 44782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 44787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 44790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44792 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 44797 */     GIR_RootConstrainSelectedInstOperands,
     /* 44798 */     // GIR_Coverage, 18140,
     /* 44798 */     GIR_EraseRootFromParent_Done,
     /* 44799 */   // Label 1306: @44799
     /* 44799 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(44837), // Rule ID 709 //
     /* 44804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44811 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 44811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44815 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 44828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44835 */     GIR_RootConstrainSelectedInstOperands,
     /* 44836 */     // GIR_Coverage, 709,
     /* 44836 */     GIR_EraseRootFromParent_Done,
     /* 44837 */   // Label 1307: @44837
     /* 44837 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(44875), // Rule ID 713 //
     /* 44842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 44849 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 44849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 44853 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 44859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 44863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 44866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44873 */     GIR_RootConstrainSelectedInstOperands,
     /* 44874 */     // GIR_Coverage, 713,
     /* 44874 */     GIR_EraseRootFromParent_Done,
     /* 44875 */   // Label 1308: @44875
     /* 44875 */   GIM_Reject,
     /* 44876 */ // Label 1302: @44876
     /* 44876 */ GIM_Reject,
     /* 44877 */ // Label 1284: @44877
     /* 44877 */ GIM_Reject,
     /* 44878 */ // Label 21: @44878
     /* 44878 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1313*/ GIMT_Encode4(45857),
     /* 44889 */ /*GILLT_s8*//*Label 1309*/ GIMT_Encode4(44905),
     /* 44893 */ /*GILLT_s16*//*Label 1310*/ GIMT_Encode4(45068),
     /* 44897 */ /*GILLT_s32*//*Label 1311*/ GIMT_Encode4(45231),
     /* 44901 */ /*GILLT_s64*//*Label 1312*/ GIMT_Encode4(45544),
     /* 44905 */ // Label 1309: @44905
     /* 44905 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(45067),
     /* 44910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 44913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 44916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 44924 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(44957), // Rule ID 722 //
     /* 44929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44940 */     // MIs[1] Operand 1
     /* 44940 */     // No operand predicates
     /* 44940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44942 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 44945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44955 */     GIR_RootConstrainSelectedInstOperands,
     /* 44956 */     // GIR_Coverage, 722,
     /* 44956 */     GIR_EraseRootFromParent_Done,
     /* 44957 */   // Label 1315: @44957
     /* 44957 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(44990), // Rule ID 726 //
     /* 44962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 44965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44973 */     // MIs[1] Operand 1
     /* 44973 */     // No operand predicates
     /* 44973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 44975 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 44975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 44978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 44980 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 44982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 44985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 44988 */     GIR_RootConstrainSelectedInstOperands,
     /* 44989 */     // GIR_Coverage, 726,
     /* 44989 */     GIR_EraseRootFromParent_Done,
     /* 44990 */   // Label 1316: @44990
     /* 44990 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(45028), // Rule ID 738 //
     /* 44995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 44998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45002 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 45002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45006 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 45019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45026 */     GIR_RootConstrainSelectedInstOperands,
     /* 45027 */     // GIR_Coverage, 738,
     /* 45027 */     GIR_EraseRootFromParent_Done,
     /* 45028 */   // Label 1317: @45028
     /* 45028 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(45066), // Rule ID 742 //
     /* 45033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45040 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 45040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45044 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 45057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45064 */     GIR_RootConstrainSelectedInstOperands,
     /* 45065 */     // GIR_Coverage, 742,
     /* 45065 */     GIR_EraseRootFromParent_Done,
     /* 45066 */   // Label 1318: @45066
     /* 45066 */   GIM_Reject,
     /* 45067 */ // Label 1314: @45067
     /* 45067 */ GIM_Reject,
     /* 45068 */ // Label 1310: @45068
     /* 45068 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(45230),
     /* 45073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 45076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 45079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 45083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 45087 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(45120), // Rule ID 723 //
     /* 45092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45103 */     // MIs[1] Operand 1
     /* 45103 */     // No operand predicates
     /* 45103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45105 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 45108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45118 */     GIR_RootConstrainSelectedInstOperands,
     /* 45119 */     // GIR_Coverage, 723,
     /* 45119 */     GIR_EraseRootFromParent_Done,
     /* 45120 */   // Label 1320: @45120
     /* 45120 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(45153), // Rule ID 727 //
     /* 45125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45136 */     // MIs[1] Operand 1
     /* 45136 */     // No operand predicates
     /* 45136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45138 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 45141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45151 */     GIR_RootConstrainSelectedInstOperands,
     /* 45152 */     // GIR_Coverage, 727,
     /* 45152 */     GIR_EraseRootFromParent_Done,
     /* 45153 */   // Label 1321: @45153
     /* 45153 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(45191), // Rule ID 739 //
     /* 45158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45165 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 45165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45169 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 45182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45189 */     GIR_RootConstrainSelectedInstOperands,
     /* 45190 */     // GIR_Coverage, 739,
     /* 45190 */     GIR_EraseRootFromParent_Done,
     /* 45191 */   // Label 1322: @45191
     /* 45191 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(45229), // Rule ID 743 //
     /* 45196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45203 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 45203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45207 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 45220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45227 */     GIR_RootConstrainSelectedInstOperands,
     /* 45228 */     // GIR_Coverage, 743,
     /* 45228 */     GIR_EraseRootFromParent_Done,
     /* 45229 */   // Label 1323: @45229
     /* 45229 */   GIM_Reject,
     /* 45230 */ // Label 1319: @45230
     /* 45230 */ GIM_Reject,
     /* 45231 */ // Label 1311: @45231
     /* 45231 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(45543),
     /* 45236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 45239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 45242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45250 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(45283), // Rule ID 724 //
     /* 45255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45266 */     // MIs[1] Operand 1
     /* 45266 */     // No operand predicates
     /* 45266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45268 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 45271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45281 */     GIR_RootConstrainSelectedInstOperands,
     /* 45282 */     // GIR_Coverage, 724,
     /* 45282 */     GIR_EraseRootFromParent_Done,
     /* 45283 */   // Label 1325: @45283
     /* 45283 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(45316), // Rule ID 728 //
     /* 45288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45299 */     // MIs[1] Operand 1
     /* 45299 */     // No operand predicates
     /* 45299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45301 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 45304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45306 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45314 */     GIR_RootConstrainSelectedInstOperands,
     /* 45315 */     // GIR_Coverage, 728,
     /* 45315 */     GIR_EraseRootFromParent_Done,
     /* 45316 */   // Label 1326: @45316
     /* 45316 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(45391), // Rule ID 18099 //
     /* 45321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 45324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45328 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45354 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45361 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 45369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 45374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 45382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45389 */     GIR_RootConstrainSelectedInstOperands,
     /* 45390 */     // GIR_Coverage, 18099,
     /* 45390 */     GIR_EraseRootFromParent_Done,
     /* 45391 */   // Label 1327: @45391
     /* 45391 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(45466), // Rule ID 18131 //
     /* 45396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 45399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45403 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45436 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 45444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 45449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 45457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45464 */     GIR_RootConstrainSelectedInstOperands,
     /* 45465 */     // GIR_Coverage, 18131,
     /* 45465 */     GIR_EraseRootFromParent_Done,
     /* 45466 */   // Label 1328: @45466
     /* 45466 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(45504), // Rule ID 740 //
     /* 45471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45478 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 45478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45482 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 45495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45502 */     GIR_RootConstrainSelectedInstOperands,
     /* 45503 */     // GIR_Coverage, 740,
     /* 45503 */     GIR_EraseRootFromParent_Done,
     /* 45504 */   // Label 1329: @45504
     /* 45504 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(45542), // Rule ID 744 //
     /* 45509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45516 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 45516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45520 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 45533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45540 */     GIR_RootConstrainSelectedInstOperands,
     /* 45541 */     // GIR_Coverage, 744,
     /* 45541 */     GIR_EraseRootFromParent_Done,
     /* 45542 */   // Label 1330: @45542
     /* 45542 */   GIM_Reject,
     /* 45543 */ // Label 1324: @45543
     /* 45543 */ GIM_Reject,
     /* 45544 */ // Label 1312: @45544
     /* 45544 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(45856),
     /* 45549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 45555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 45563 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(45596), // Rule ID 725 //
     /* 45568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45579 */     // MIs[1] Operand 1
     /* 45579 */     // No operand predicates
     /* 45579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45581 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 45584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45594 */     GIR_RootConstrainSelectedInstOperands,
     /* 45595 */     // GIR_Coverage, 725,
     /* 45595 */     GIR_EraseRootFromParent_Done,
     /* 45596 */   // Label 1332: @45596
     /* 45596 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(45629), // Rule ID 729 //
     /* 45601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45612 */     // MIs[1] Operand 1
     /* 45612 */     // No operand predicates
     /* 45612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45614 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 45614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 45617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 45624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45627 */     GIR_RootConstrainSelectedInstOperands,
     /* 45628 */     // GIR_Coverage, 729,
     /* 45628 */     GIR_EraseRootFromParent_Done,
     /* 45629 */   // Label 1333: @45629
     /* 45629 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(45704), // Rule ID 18100 //
     /* 45634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 45637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45641 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 45644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 45658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 45695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45702 */     GIR_RootConstrainSelectedInstOperands,
     /* 45703 */     // GIR_Coverage, 18100,
     /* 45703 */     GIR_EraseRootFromParent_Done,
     /* 45704 */   // Label 1334: @45704
     /* 45704 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(45779), // Rule ID 18132 //
     /* 45709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 45712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 45716 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 45716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 45719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 45723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 45733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 45737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 45745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 45749 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 45752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 45762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 45767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 45770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45777 */     GIR_RootConstrainSelectedInstOperands,
     /* 45778 */     // GIR_Coverage, 18132,
     /* 45778 */     GIR_EraseRootFromParent_Done,
     /* 45779 */   // Label 1335: @45779
     /* 45779 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(45817), // Rule ID 741 //
     /* 45784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45791 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 45791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45795 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 45808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45815 */     GIR_RootConstrainSelectedInstOperands,
     /* 45816 */     // GIR_Coverage, 741,
     /* 45816 */     GIR_EraseRootFromParent_Done,
     /* 45817 */   // Label 1336: @45817
     /* 45817 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(45855), // Rule ID 745 //
     /* 45822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45829 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 45829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45833 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 45843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 45846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45853 */     GIR_RootConstrainSelectedInstOperands,
     /* 45854 */     // GIR_Coverage, 745,
     /* 45854 */     GIR_EraseRootFromParent_Done,
     /* 45855 */   // Label 1337: @45855
     /* 45855 */   GIM_Reject,
     /* 45856 */ // Label 1331: @45856
     /* 45856 */ GIM_Reject,
     /* 45857 */ // Label 1313: @45857
     /* 45857 */ GIM_Reject,
     /* 45858 */ // Label 22: @45858
     /* 45858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1340*/ GIMT_Encode4(46233),
     /* 45869 */ /*GILLT_s32*//*Label 1338*/ GIMT_Encode4(45877),
     /* 45873 */ /*GILLT_s64*//*Label 1339*/ GIMT_Encode4(46055),
     /* 45877 */ // Label 1338: @45877
     /* 45877 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(46054),
     /* 45882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 45885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 45891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 45903 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(45938), // Rule ID 819 //
     /* 45908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45919 */     // MIs[1] Operand 1
     /* 45919 */     // No operand predicates
     /* 45919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45921 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 45924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45928 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45936 */     GIR_RootConstrainSelectedInstOperands,
     /* 45937 */     // GIR_Coverage, 819,
     /* 45937 */     GIR_EraseRootFromParent_Done,
     /* 45938 */   // Label 1342: @45938
     /* 45938 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(45973), // Rule ID 825 //
     /* 45943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 45946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 45950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45954 */     // MIs[1] Operand 1
     /* 45954 */     // No operand predicates
     /* 45954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45956 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 45956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 45959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 45961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 45963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 45965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 45968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 45971 */     GIR_RootConstrainSelectedInstOperands,
     /* 45972 */     // GIR_Coverage, 825,
     /* 45972 */     GIR_EraseRootFromParent_Done,
     /* 45973 */   // Label 1343: @45973
     /* 45973 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(46013), // Rule ID 822 //
     /* 45978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 45981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 45985 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 45985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45989 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 45999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 46002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 46008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46011 */     GIR_RootConstrainSelectedInstOperands,
     /* 46012 */     // GIR_Coverage, 822,
     /* 46012 */     GIR_EraseRootFromParent_Done,
     /* 46013 */   // Label 1344: @46013
     /* 46013 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(46053), // Rule ID 828 //
     /* 46018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46025 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 46025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46029 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 46042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 46048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46051 */     GIR_RootConstrainSelectedInstOperands,
     /* 46052 */     // GIR_Coverage, 828,
     /* 46052 */     GIR_EraseRootFromParent_Done,
     /* 46053 */   // Label 1345: @46053
     /* 46053 */   GIM_Reject,
     /* 46054 */ // Label 1341: @46054
     /* 46054 */ GIM_Reject,
     /* 46055 */ // Label 1339: @46055
     /* 46055 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(46232),
     /* 46060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 46063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 46066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 46069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46081 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(46116), // Rule ID 820 //
     /* 46086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46097 */     // MIs[1] Operand 1
     /* 46097 */     // No operand predicates
     /* 46097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46099 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 46102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 46108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46114 */     GIR_RootConstrainSelectedInstOperands,
     /* 46115 */     // GIR_Coverage, 820,
     /* 46115 */     GIR_EraseRootFromParent_Done,
     /* 46116 */   // Label 1347: @46116
     /* 46116 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(46151), // Rule ID 826 //
     /* 46121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46132 */     // MIs[1] Operand 1
     /* 46132 */     // No operand predicates
     /* 46132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46134 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 46137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 46143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46149 */     GIR_RootConstrainSelectedInstOperands,
     /* 46150 */     // GIR_Coverage, 826,
     /* 46150 */     GIR_EraseRootFromParent_Done,
     /* 46151 */   // Label 1348: @46151
     /* 46151 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(46191), // Rule ID 823 //
     /* 46156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46163 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 46163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46167 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 46180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46184 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 46186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46189 */     GIR_RootConstrainSelectedInstOperands,
     /* 46190 */     // GIR_Coverage, 823,
     /* 46190 */     GIR_EraseRootFromParent_Done,
     /* 46191 */   // Label 1349: @46191
     /* 46191 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(46231), // Rule ID 829 //
     /* 46196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46203 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 46203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46207 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 46220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 46226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46229 */     GIR_RootConstrainSelectedInstOperands,
     /* 46230 */     // GIR_Coverage, 829,
     /* 46230 */     GIR_EraseRootFromParent_Done,
     /* 46231 */   // Label 1350: @46231
     /* 46231 */   GIM_Reject,
     /* 46232 */ // Label 1346: @46232
     /* 46232 */ GIM_Reject,
     /* 46233 */ // Label 1340: @46233
     /* 46233 */ GIM_Reject,
     /* 46234 */ // Label 23: @46234
     /* 46234 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1353*/ GIMT_Encode4(46609),
     /* 46245 */ /*GILLT_s32*//*Label 1351*/ GIMT_Encode4(46253),
     /* 46249 */ /*GILLT_s64*//*Label 1352*/ GIMT_Encode4(46431),
     /* 46253 */ // Label 1351: @46253
     /* 46253 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(46430),
     /* 46258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 46261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 46264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 46267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 46271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 46275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 46279 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(46314), // Rule ID 843 //
     /* 46284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46295 */     // MIs[1] Operand 1
     /* 46295 */     // No operand predicates
     /* 46295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46297 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 46300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46302 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46304 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46312 */     GIR_RootConstrainSelectedInstOperands,
     /* 46313 */     // GIR_Coverage, 843,
     /* 46313 */     GIR_EraseRootFromParent_Done,
     /* 46314 */   // Label 1355: @46314
     /* 46314 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(46349), // Rule ID 849 //
     /* 46319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46330 */     // MIs[1] Operand 1
     /* 46330 */     // No operand predicates
     /* 46330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46332 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 46335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46339 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46347 */     GIR_RootConstrainSelectedInstOperands,
     /* 46348 */     // GIR_Coverage, 849,
     /* 46348 */     GIR_EraseRootFromParent_Done,
     /* 46349 */   // Label 1356: @46349
     /* 46349 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(46389), // Rule ID 846 //
     /* 46354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46361 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 46361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46365 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 46378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46380 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46387 */     GIR_RootConstrainSelectedInstOperands,
     /* 46388 */     // GIR_Coverage, 846,
     /* 46388 */     GIR_EraseRootFromParent_Done,
     /* 46389 */   // Label 1357: @46389
     /* 46389 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(46429), // Rule ID 852 //
     /* 46394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46401 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 46401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46405 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 46418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46427 */     GIR_RootConstrainSelectedInstOperands,
     /* 46428 */     // GIR_Coverage, 852,
     /* 46428 */     GIR_EraseRootFromParent_Done,
     /* 46429 */   // Label 1358: @46429
     /* 46429 */   GIM_Reject,
     /* 46430 */ // Label 1354: @46430
     /* 46430 */ GIM_Reject,
     /* 46431 */ // Label 1352: @46431
     /* 46431 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(46608),
     /* 46436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 46439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 46442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 46445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 46457 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(46492), // Rule ID 844 //
     /* 46462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46473 */     // MIs[1] Operand 1
     /* 46473 */     // No operand predicates
     /* 46473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46475 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 46478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46490 */     GIR_RootConstrainSelectedInstOperands,
     /* 46491 */     // GIR_Coverage, 844,
     /* 46491 */     GIR_EraseRootFromParent_Done,
     /* 46492 */   // Label 1360: @46492
     /* 46492 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(46527), // Rule ID 850 //
     /* 46497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 46504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46508 */     // MIs[1] Operand 1
     /* 46508 */     // No operand predicates
     /* 46508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46510 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 46510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 46513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 46522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46525 */     GIR_RootConstrainSelectedInstOperands,
     /* 46526 */     // GIR_Coverage, 850,
     /* 46526 */     GIR_EraseRootFromParent_Done,
     /* 46527 */   // Label 1361: @46527
     /* 46527 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(46567), // Rule ID 847 //
     /* 46532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46539 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 46539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46543 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 46556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46558 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46565 */     GIR_RootConstrainSelectedInstOperands,
     /* 46566 */     // GIR_Coverage, 847,
     /* 46566 */     GIR_EraseRootFromParent_Done,
     /* 46567 */   // Label 1362: @46567
     /* 46567 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(46607), // Rule ID 853 //
     /* 46572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46579 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 46579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46583 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 46593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 46596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 46600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 46602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46605 */     GIR_RootConstrainSelectedInstOperands,
     /* 46606 */     // GIR_Coverage, 853,
     /* 46606 */     GIR_EraseRootFromParent_Done,
     /* 46607 */   // Label 1363: @46607
     /* 46607 */   GIM_Reject,
     /* 46608 */ // Label 1359: @46608
     /* 46608 */ GIM_Reject,
     /* 46609 */ // Label 1353: @46609
     /* 46609 */ GIM_Reject,
     /* 46610 */ // Label 24: @46610
     /* 46610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 1374*/ GIMT_Encode4(48591),
     /* 46621 */ /*GILLT_s8*//*Label 1364*/ GIMT_Encode4(46697),
     /* 46625 */ /*GILLT_s16*//*Label 1365*/ GIMT_Encode4(46908),
     /* 46629 */ /*GILLT_s32*//*Label 1366*/ GIMT_Encode4(47119),
     /* 46633 */ /*GILLT_s64*//*Label 1367*/ GIMT_Encode4(47423), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 46649 */ /*GILLT_v2s64*//*Label 1368*/ GIMT_Encode4(47727), GIMT_Encode4(0),
     /* 46657 */ /*GILLT_v4s32*//*Label 1369*/ GIMT_Encode4(47932),
     /* 46661 */ /*GILLT_v4s64*//*Label 1370*/ GIMT_Encode4(48137), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 46673 */ /*GILLT_v8s32*//*Label 1371*/ GIMT_Encode4(48330),
     /* 46677 */ /*GILLT_v8s64*//*Label 1372*/ GIMT_Encode4(48523), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 46693 */ /*GILLT_v16s32*//*Label 1373*/ GIMT_Encode4(48557),
     /* 46697 */ // Label 1364: @46697
     /* 46697 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(46907),
     /* 46702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 46705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 46708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 46712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 46716 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(46740), // Rule ID 18047 //
     /* 46721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 46728 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 46731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46738 */     GIR_RootConstrainSelectedInstOperands,
     /* 46739 */     // GIR_Coverage, 18047,
     /* 46739 */     GIR_EraseRootFromParent_Done,
     /* 46740 */   // Label 1376: @46740
     /* 46740 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(46764), // Rule ID 18055 //
     /* 46745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 46748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 46752 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 46755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46762 */     GIR_RootConstrainSelectedInstOperands,
     /* 46763 */     // GIR_Coverage, 18055,
     /* 46763 */     GIR_EraseRootFromParent_Done,
     /* 46764 */   // Label 1377: @46764
     /* 46764 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(46797), // Rule ID 786 //
     /* 46769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46780 */     // MIs[1] Operand 1
     /* 46780 */     // No operand predicates
     /* 46780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46782 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 46785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46795 */     GIR_RootConstrainSelectedInstOperands,
     /* 46796 */     // GIR_Coverage, 786,
     /* 46796 */     GIR_EraseRootFromParent_Done,
     /* 46797 */   // Label 1378: @46797
     /* 46797 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(46830), // Rule ID 790 //
     /* 46802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46813 */     // MIs[1] Operand 1
     /* 46813 */     // No operand predicates
     /* 46813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46815 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 46818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 46825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46828 */     GIR_RootConstrainSelectedInstOperands,
     /* 46829 */     // GIR_Coverage, 790,
     /* 46829 */     GIR_EraseRootFromParent_Done,
     /* 46830 */   // Label 1379: @46830
     /* 46830 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(46868), // Rule ID 802 //
     /* 46835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46842 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46846 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 46859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46866 */     GIR_RootConstrainSelectedInstOperands,
     /* 46867 */     // GIR_Coverage, 802,
     /* 46867 */     GIR_EraseRootFromParent_Done,
     /* 46868 */   // Label 1380: @46868
     /* 46868 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(46906), // Rule ID 806 //
     /* 46873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 46876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 46880 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 46880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 46884 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 46894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 46897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46904 */     GIR_RootConstrainSelectedInstOperands,
     /* 46905 */     // GIR_Coverage, 806,
     /* 46905 */     GIR_EraseRootFromParent_Done,
     /* 46906 */   // Label 1381: @46906
     /* 46906 */   GIM_Reject,
     /* 46907 */ // Label 1375: @46907
     /* 46907 */ GIM_Reject,
     /* 46908 */ // Label 1365: @46908
     /* 46908 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(47118),
     /* 46913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 46916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 46919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 46923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 46927 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(46951), // Rule ID 18048 //
     /* 46932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 46939 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 46939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 46942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46949 */     GIR_RootConstrainSelectedInstOperands,
     /* 46950 */     // GIR_Coverage, 18048,
     /* 46950 */     GIR_EraseRootFromParent_Done,
     /* 46951 */   // Label 1383: @46951
     /* 46951 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(46975), // Rule ID 18056 //
     /* 46956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 46959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 46963 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 46963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 46966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 46970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 46973 */     GIR_RootConstrainSelectedInstOperands,
     /* 46974 */     // GIR_Coverage, 18056,
     /* 46974 */     GIR_EraseRootFromParent_Done,
     /* 46975 */   // Label 1384: @46975
     /* 46975 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(47008), // Rule ID 787 //
     /* 46980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 46983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 46987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 46991 */     // MIs[1] Operand 1
     /* 46991 */     // No operand predicates
     /* 46991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 46993 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 46993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 46996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 46998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47006 */     GIR_RootConstrainSelectedInstOperands,
     /* 47007 */     // GIR_Coverage, 787,
     /* 47007 */     GIR_EraseRootFromParent_Done,
     /* 47008 */   // Label 1385: @47008
     /* 47008 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(47041), // Rule ID 791 //
     /* 47013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47024 */     // MIs[1] Operand 1
     /* 47024 */     // No operand predicates
     /* 47024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47026 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 47029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47039 */     GIR_RootConstrainSelectedInstOperands,
     /* 47040 */     // GIR_Coverage, 791,
     /* 47040 */     GIR_EraseRootFromParent_Done,
     /* 47041 */   // Label 1386: @47041
     /* 47041 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(47079), // Rule ID 803 //
     /* 47046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47053 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 47053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47057 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 47070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47072 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47077 */     GIR_RootConstrainSelectedInstOperands,
     /* 47078 */     // GIR_Coverage, 803,
     /* 47078 */     GIR_EraseRootFromParent_Done,
     /* 47079 */   // Label 1387: @47079
     /* 47079 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(47117), // Rule ID 807 //
     /* 47084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47091 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 47091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47095 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 47108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47115 */     GIR_RootConstrainSelectedInstOperands,
     /* 47116 */     // GIR_Coverage, 807,
     /* 47116 */     GIR_EraseRootFromParent_Done,
     /* 47117 */   // Label 1388: @47117
     /* 47117 */   GIM_Reject,
     /* 47118 */ // Label 1382: @47118
     /* 47118 */ GIM_Reject,
     /* 47119 */ // Label 1366: @47119
     /* 47119 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(47422),
     /* 47124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 47127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 47130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 47134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 47138 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(47168), // Rule ID 18091 //
     /* 47143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 47146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47154 */     // MIs[1] Operand 1
     /* 47154 */     // No operand predicates
     /* 47154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47156 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 47156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 47159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 47163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47166 */     GIR_RootConstrainSelectedInstOperands,
     /* 47167 */     // GIR_Coverage, 18091,
     /* 47167 */     GIR_EraseRootFromParent_Done,
     /* 47168 */   // Label 1390: @47168
     /* 47168 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(47198), // Rule ID 18123 //
     /* 47173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 47176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47184 */     // MIs[1] Operand 1
     /* 47184 */     // No operand predicates
     /* 47184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47186 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 47186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 47189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 47193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47196 */     GIR_RootConstrainSelectedInstOperands,
     /* 47197 */     // GIR_Coverage, 18123,
     /* 47197 */     GIR_EraseRootFromParent_Done,
     /* 47198 */   // Label 1391: @47198
     /* 47198 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(47231), // Rule ID 868 //
     /* 47203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 47206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47214 */     // MIs[1] Operand 1
     /* 47214 */     // No operand predicates
     /* 47214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47216 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 47216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 47219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47229 */     GIR_RootConstrainSelectedInstOperands,
     /* 47230 */     // GIR_Coverage, 868,
     /* 47230 */     GIR_EraseRootFromParent_Done,
     /* 47231 */   // Label 1392: @47231
     /* 47231 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(47255), // Rule ID 18049 //
     /* 47236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 47243 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 47243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 47246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47253 */     GIR_RootConstrainSelectedInstOperands,
     /* 47254 */     // GIR_Coverage, 18049,
     /* 47254 */     GIR_EraseRootFromParent_Done,
     /* 47255 */   // Label 1393: @47255
     /* 47255 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(47279), // Rule ID 18057 //
     /* 47260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 47263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 47267 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 47267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 47270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47277 */     GIR_RootConstrainSelectedInstOperands,
     /* 47278 */     // GIR_Coverage, 18057,
     /* 47278 */     GIR_EraseRootFromParent_Done,
     /* 47279 */   // Label 1394: @47279
     /* 47279 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(47312), // Rule ID 788 //
     /* 47284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47295 */     // MIs[1] Operand 1
     /* 47295 */     // No operand predicates
     /* 47295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47297 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 47300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47310 */     GIR_RootConstrainSelectedInstOperands,
     /* 47311 */     // GIR_Coverage, 788,
     /* 47311 */     GIR_EraseRootFromParent_Done,
     /* 47312 */   // Label 1395: @47312
     /* 47312 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(47345), // Rule ID 792 //
     /* 47317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47328 */     // MIs[1] Operand 1
     /* 47328 */     // No operand predicates
     /* 47328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47330 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 47333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47335 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47343 */     GIR_RootConstrainSelectedInstOperands,
     /* 47344 */     // GIR_Coverage, 792,
     /* 47344 */     GIR_EraseRootFromParent_Done,
     /* 47345 */   // Label 1396: @47345
     /* 47345 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(47383), // Rule ID 804 //
     /* 47350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47357 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 47357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47361 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 47374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47381 */     GIR_RootConstrainSelectedInstOperands,
     /* 47382 */     // GIR_Coverage, 804,
     /* 47382 */     GIR_EraseRootFromParent_Done,
     /* 47383 */   // Label 1397: @47383
     /* 47383 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(47421), // Rule ID 808 //
     /* 47388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47395 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 47395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47399 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 47412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47419 */     GIR_RootConstrainSelectedInstOperands,
     /* 47420 */     // GIR_Coverage, 808,
     /* 47420 */     GIR_EraseRootFromParent_Done,
     /* 47421 */   // Label 1398: @47421
     /* 47421 */   GIM_Reject,
     /* 47422 */ // Label 1389: @47422
     /* 47422 */ GIM_Reject,
     /* 47423 */ // Label 1367: @47423
     /* 47423 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(47726),
     /* 47428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 47431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 47434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 47438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 47442 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(47472), // Rule ID 18092 //
     /* 47447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 47450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47458 */     // MIs[1] Operand 1
     /* 47458 */     // No operand predicates
     /* 47458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47460 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 47460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 47463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 47467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47470 */     GIR_RootConstrainSelectedInstOperands,
     /* 47471 */     // GIR_Coverage, 18092,
     /* 47471 */     GIR_EraseRootFromParent_Done,
     /* 47472 */   // Label 1400: @47472
     /* 47472 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(47502), // Rule ID 18124 //
     /* 47477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 47480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47488 */     // MIs[1] Operand 1
     /* 47488 */     // No operand predicates
     /* 47488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47490 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 47490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 47493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 47497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47500 */     GIR_RootConstrainSelectedInstOperands,
     /* 47501 */     // GIR_Coverage, 18124,
     /* 47501 */     GIR_EraseRootFromParent_Done,
     /* 47502 */   // Label 1401: @47502
     /* 47502 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(47535), // Rule ID 869 //
     /* 47507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 47510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47518 */     // MIs[1] Operand 1
     /* 47518 */     // No operand predicates
     /* 47518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47520 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 47520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 47523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 47530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47533 */     GIR_RootConstrainSelectedInstOperands,
     /* 47534 */     // GIR_Coverage, 869,
     /* 47534 */     GIR_EraseRootFromParent_Done,
     /* 47535 */   // Label 1402: @47535
     /* 47535 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(47559), // Rule ID 18050 //
     /* 47540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 47547 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 47550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47557 */     GIR_RootConstrainSelectedInstOperands,
     /* 47558 */     // GIR_Coverage, 18050,
     /* 47558 */     GIR_EraseRootFromParent_Done,
     /* 47559 */   // Label 1403: @47559
     /* 47559 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(47583), // Rule ID 18058 //
     /* 47564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 47567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 47571 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 47574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47581 */     GIR_RootConstrainSelectedInstOperands,
     /* 47582 */     // GIR_Coverage, 18058,
     /* 47582 */     GIR_EraseRootFromParent_Done,
     /* 47583 */   // Label 1404: @47583
     /* 47583 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(47616), // Rule ID 789 //
     /* 47588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47599 */     // MIs[1] Operand 1
     /* 47599 */     // No operand predicates
     /* 47599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47601 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 47604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47614 */     GIR_RootConstrainSelectedInstOperands,
     /* 47615 */     // GIR_Coverage, 789,
     /* 47615 */     GIR_EraseRootFromParent_Done,
     /* 47616 */   // Label 1405: @47616
     /* 47616 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(47649), // Rule ID 793 //
     /* 47621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 47628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 47632 */     // MIs[1] Operand 1
     /* 47632 */     // No operand predicates
     /* 47632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 47634 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 47634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 47637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 47644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47647 */     GIR_RootConstrainSelectedInstOperands,
     /* 47648 */     // GIR_Coverage, 793,
     /* 47648 */     GIR_EraseRootFromParent_Done,
     /* 47649 */   // Label 1406: @47649
     /* 47649 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(47687), // Rule ID 805 //
     /* 47654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 47657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47661 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47665 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 47678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47685 */     GIR_RootConstrainSelectedInstOperands,
     /* 47686 */     // GIR_Coverage, 805,
     /* 47686 */     GIR_EraseRootFromParent_Done,
     /* 47687 */   // Label 1407: @47687
     /* 47687 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(47725), // Rule ID 809 //
     /* 47692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 47695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 47699 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 47699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47703 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 47713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 47716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 47720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 47723 */     GIR_RootConstrainSelectedInstOperands,
     /* 47724 */     // GIR_Coverage, 809,
     /* 47724 */     GIR_EraseRootFromParent_Done,
     /* 47725 */   // Label 1408: @47725
     /* 47725 */   GIM_Reject,
     /* 47726 */ // Label 1399: @47726
     /* 47726 */ GIM_Reject,
     /* 47727 */ // Label 1368: @47727
     /* 47727 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(47931),
     /* 47732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 47735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 47738 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(47765), // Rule ID 7999 //
     /* 47743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 47746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47758 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 47758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 47763 */     GIR_RootConstrainSelectedInstOperands,
     /* 47764 */     // GIR_Coverage, 7999,
     /* 47764 */     GIR_Done,
     /* 47765 */   // Label 1410: @47765
     /* 47765 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(47930), // Rule ID 21251 //
     /* 47770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 47773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 47777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47785 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 47785 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 47788 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47792 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 47799 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 47802 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47806 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47811 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 47814 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 47818 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 47821 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47826 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47831 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 47836 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 47839 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47843 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 47850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 47853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 47857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47862 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 47865 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 47869 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 47872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 47877 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 47887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 47890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 47894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47899 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 47902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 47905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 47910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 47912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 47919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 47924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 47929 */     // GIR_Coverage, 21251,
     /* 47929 */     GIR_EraseRootFromParent_Done,
     /* 47930 */   // Label 1411: @47930
     /* 47930 */   GIM_Reject,
     /* 47931 */ // Label 1409: @47931
     /* 47931 */ GIM_Reject,
     /* 47932 */ // Label 1369: @47932
     /* 47932 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(48136),
     /* 47937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 47940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 47943 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(47970), // Rule ID 7972 //
     /* 47948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 47951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47963 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 47963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 47968 */     GIR_RootConstrainSelectedInstOperands,
     /* 47969 */     // GIR_Coverage, 7972,
     /* 47969 */     GIR_Done,
     /* 47970 */   // Label 1413: @47970
     /* 47970 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(48135), // Rule ID 21253 //
     /* 47975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 47978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 47982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 47990 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 47990 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 47993 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 47997 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 48004 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 48007 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48011 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48016 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 48019 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 48023 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 48026 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48031 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48036 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 48041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 48044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 48055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 48058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48067 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 48070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 48074 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 48077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 48092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 48095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 48099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 48107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 48110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48117 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 48124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 48129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48134 */     // GIR_Coverage, 21253,
     /* 48134 */     GIR_EraseRootFromParent_Done,
     /* 48135 */   // Label 1414: @48135
     /* 48135 */   GIM_Reject,
     /* 48136 */ // Label 1412: @48136
     /* 48136 */ GIM_Reject,
     /* 48137 */ // Label 1370: @48137
     /* 48137 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(48329),
     /* 48142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 48145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 48148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 48152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 48156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 48160 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(48175), // Rule ID 7990 //
     /* 48165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 48168 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 48168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 48173 */     GIR_RootConstrainSelectedInstOperands,
     /* 48174 */     // GIR_Coverage, 7990,
     /* 48174 */     GIR_Done,
     /* 48175 */   // Label 1416: @48175
     /* 48175 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(48328), // Rule ID 21252 //
     /* 48180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 48183 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 48183 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 48186 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48190 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 48197 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 48200 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48204 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48209 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 48212 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 48216 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 48219 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48224 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48229 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48234 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 48237 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48241 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 48248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 48251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48260 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 48263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 48267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 48270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 48288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 48292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 48300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 48303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48310 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 48317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48327 */     // GIR_Coverage, 21252,
     /* 48327 */     GIR_EraseRootFromParent_Done,
     /* 48328 */   // Label 1417: @48328
     /* 48328 */   GIM_Reject,
     /* 48329 */ // Label 1415: @48329
     /* 48329 */ GIM_Reject,
     /* 48330 */ // Label 1371: @48330
     /* 48330 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(48522),
     /* 48335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 48338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 48341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 48345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 48349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 48353 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(48368), // Rule ID 7963 //
     /* 48358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 48361 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 48361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 48366 */     GIR_RootConstrainSelectedInstOperands,
     /* 48367 */     // GIR_Coverage, 7963,
     /* 48367 */     GIR_Done,
     /* 48368 */   // Label 1419: @48368
     /* 48368 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(48521), // Rule ID 21254 //
     /* 48373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 48376 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 48376 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 48379 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48383 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 48390 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 48393 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48397 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48402 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 48405 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 48409 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 48412 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48417 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48422 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48427 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 48430 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 48434 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 48441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 48444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 48448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48453 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 48456 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 48460 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 48463 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 48468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 48481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 48485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 48493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 48496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48503 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 48510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 48515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 48520 */     // GIR_Coverage, 21254,
     /* 48520 */     GIR_EraseRootFromParent_Done,
     /* 48521 */   // Label 1420: @48521
     /* 48521 */   GIM_Reject,
     /* 48522 */ // Label 1418: @48522
     /* 48522 */ GIM_Reject,
     /* 48523 */ // Label 1372: @48523
     /* 48523 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(48556), // Rule ID 7981 //
     /* 48528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 48531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 48534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 48537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48549 */   // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 48549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 48554 */   GIR_RootConstrainSelectedInstOperands,
     /* 48555 */   // GIR_Coverage, 7981,
     /* 48555 */   GIR_Done,
     /* 48556 */ // Label 1421: @48556
     /* 48556 */ GIM_Reject,
     /* 48557 */ // Label 1373: @48557
     /* 48557 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(48590), // Rule ID 7954 //
     /* 48562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 48565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 48568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 48571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 48583 */   // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 48583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 48588 */   GIR_RootConstrainSelectedInstOperands,
     /* 48589 */   // GIR_Coverage, 7954,
     /* 48589 */   GIR_Done,
     /* 48590 */ // Label 1422: @48590
     /* 48590 */ GIM_Reject,
     /* 48591 */ // Label 1374: @48591
     /* 48591 */ GIM_Reject,
     /* 48592 */ // Label 25: @48592
     /* 48592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 1435*/ GIMT_Encode4(50575),
     /* 48603 */ /*GILLT_s8*//*Label 1423*/ GIMT_Encode4(48679),
     /* 48607 */ /*GILLT_s16*//*Label 1424*/ GIMT_Encode4(48890),
     /* 48611 */ /*GILLT_s32*//*Label 1425*/ GIMT_Encode4(49101),
     /* 48615 */ /*GILLT_s64*//*Label 1426*/ GIMT_Encode4(49345), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 48631 */ /*GILLT_v2s64*//*Label 1427*/ GIMT_Encode4(49589), GIMT_Encode4(0),
     /* 48639 */ /*GILLT_v4s32*//*Label 1428*/ GIMT_Encode4(49821),
     /* 48643 */ /*GILLT_v4s64*//*Label 1429*/ GIMT_Encode4(50053), GIMT_Encode4(0),
     /* 48651 */ /*GILLT_v8s16*//*Label 1430*/ GIMT_Encode4(50246),
     /* 48655 */ /*GILLT_v8s32*//*Label 1431*/ GIMT_Encode4(50280),
     /* 48659 */ /*GILLT_v8s64*//*Label 1432*/ GIMT_Encode4(50473), GIMT_Encode4(0),
     /* 48667 */ /*GILLT_v16s8*//*Label 1433*/ GIMT_Encode4(50507), GIMT_Encode4(0),
     /* 48675 */ /*GILLT_v16s32*//*Label 1434*/ GIMT_Encode4(50541),
     /* 48679 */ // Label 1423: @48679
     /* 48679 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(48889),
     /* 48684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 48687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 48690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 48694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 48698 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(48722), // Rule ID 18043 //
     /* 48703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 48710 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 48713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48720 */     GIR_RootConstrainSelectedInstOperands,
     /* 48721 */     // GIR_Coverage, 18043,
     /* 48721 */     GIR_EraseRootFromParent_Done,
     /* 48722 */   // Label 1437: @48722
     /* 48722 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(48746), // Rule ID 18051 //
     /* 48727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 48730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 48734 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 48737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48744 */     GIR_RootConstrainSelectedInstOperands,
     /* 48745 */     // GIR_Coverage, 18051,
     /* 48745 */     GIR_EraseRootFromParent_Done,
     /* 48746 */   // Label 1438: @48746
     /* 48746 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(48779), // Rule ID 754 //
     /* 48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48762 */     // MIs[1] Operand 1
     /* 48762 */     // No operand predicates
     /* 48762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48764 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 48767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48777 */     GIR_RootConstrainSelectedInstOperands,
     /* 48778 */     // GIR_Coverage, 754,
     /* 48778 */     GIR_EraseRootFromParent_Done,
     /* 48779 */   // Label 1439: @48779
     /* 48779 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(48812), // Rule ID 758 //
     /* 48784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48795 */     // MIs[1] Operand 1
     /* 48795 */     // No operand predicates
     /* 48795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48797 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 48800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48810 */     GIR_RootConstrainSelectedInstOperands,
     /* 48811 */     // GIR_Coverage, 758,
     /* 48811 */     GIR_EraseRootFromParent_Done,
     /* 48812 */   // Label 1440: @48812
     /* 48812 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(48850), // Rule ID 770 //
     /* 48817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48824 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48828 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 48841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48848 */     GIR_RootConstrainSelectedInstOperands,
     /* 48849 */     // GIR_Coverage, 770,
     /* 48849 */     GIR_EraseRootFromParent_Done,
     /* 48850 */   // Label 1441: @48850
     /* 48850 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(48888), // Rule ID 774 //
     /* 48855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 48862 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 48862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 48866 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 48876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 48879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48886 */     GIR_RootConstrainSelectedInstOperands,
     /* 48887 */     // GIR_Coverage, 774,
     /* 48887 */     GIR_EraseRootFromParent_Done,
     /* 48888 */   // Label 1442: @48888
     /* 48888 */   GIM_Reject,
     /* 48889 */ // Label 1436: @48889
     /* 48889 */ GIM_Reject,
     /* 48890 */ // Label 1424: @48890
     /* 48890 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(49100),
     /* 48895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 48898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 48901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 48905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 48909 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(48933), // Rule ID 18044 //
     /* 48914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 48921 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 48921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 48924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48931 */     GIR_RootConstrainSelectedInstOperands,
     /* 48932 */     // GIR_Coverage, 18044,
     /* 48932 */     GIR_EraseRootFromParent_Done,
     /* 48933 */   // Label 1444: @48933
     /* 48933 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(48957), // Rule ID 18052 //
     /* 48938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 48941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 48945 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 48945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 48948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48955 */     GIR_RootConstrainSelectedInstOperands,
     /* 48956 */     // GIR_Coverage, 18052,
     /* 48956 */     GIR_EraseRootFromParent_Done,
     /* 48957 */   // Label 1445: @48957
     /* 48957 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(48990), // Rule ID 755 //
     /* 48962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 48965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 48969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 48973 */     // MIs[1] Operand 1
     /* 48973 */     // No operand predicates
     /* 48973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 48975 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 48975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 48978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 48980 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 48982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 48985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 48988 */     GIR_RootConstrainSelectedInstOperands,
     /* 48989 */     // GIR_Coverage, 755,
     /* 48989 */     GIR_EraseRootFromParent_Done,
     /* 48990 */   // Label 1446: @48990
     /* 48990 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(49023), // Rule ID 759 //
     /* 48995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 48998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49006 */     // MIs[1] Operand 1
     /* 49006 */     // No operand predicates
     /* 49006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49008 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 49011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49021 */     GIR_RootConstrainSelectedInstOperands,
     /* 49022 */     // GIR_Coverage, 759,
     /* 49022 */     GIR_EraseRootFromParent_Done,
     /* 49023 */   // Label 1447: @49023
     /* 49023 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(49061), // Rule ID 771 //
     /* 49028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49035 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 49035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49039 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 49052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49059 */     GIR_RootConstrainSelectedInstOperands,
     /* 49060 */     // GIR_Coverage, 771,
     /* 49060 */     GIR_EraseRootFromParent_Done,
     /* 49061 */   // Label 1448: @49061
     /* 49061 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(49099), // Rule ID 775 //
     /* 49066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49073 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 49073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49077 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 49090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49097 */     GIR_RootConstrainSelectedInstOperands,
     /* 49098 */     // GIR_Coverage, 775,
     /* 49098 */     GIR_EraseRootFromParent_Done,
     /* 49099 */   // Label 1449: @49099
     /* 49099 */   GIM_Reject,
     /* 49100 */ // Label 1443: @49100
     /* 49100 */ GIM_Reject,
     /* 49101 */ // Label 1425: @49101
     /* 49101 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(49344),
     /* 49106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 49112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 49116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 49120 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(49153), // Rule ID 866 //
     /* 49125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 49128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49136 */     // MIs[1] Operand 1
     /* 49136 */     // No operand predicates
     /* 49136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49138 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 49138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 49141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 49148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49151 */     GIR_RootConstrainSelectedInstOperands,
     /* 49152 */     // GIR_Coverage, 866,
     /* 49152 */     GIR_EraseRootFromParent_Done,
     /* 49153 */   // Label 1451: @49153
     /* 49153 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(49177), // Rule ID 18045 //
     /* 49158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 49165 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 49165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 49168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49175 */     GIR_RootConstrainSelectedInstOperands,
     /* 49176 */     // GIR_Coverage, 18045,
     /* 49176 */     GIR_EraseRootFromParent_Done,
     /* 49177 */   // Label 1452: @49177
     /* 49177 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(49201), // Rule ID 18053 //
     /* 49182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 49185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 49189 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 49189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 49192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49199 */     GIR_RootConstrainSelectedInstOperands,
     /* 49200 */     // GIR_Coverage, 18053,
     /* 49200 */     GIR_EraseRootFromParent_Done,
     /* 49201 */   // Label 1453: @49201
     /* 49201 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(49234), // Rule ID 756 //
     /* 49206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49217 */     // MIs[1] Operand 1
     /* 49217 */     // No operand predicates
     /* 49217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49219 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 49222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49232 */     GIR_RootConstrainSelectedInstOperands,
     /* 49233 */     // GIR_Coverage, 756,
     /* 49233 */     GIR_EraseRootFromParent_Done,
     /* 49234 */   // Label 1454: @49234
     /* 49234 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(49267), // Rule ID 760 //
     /* 49239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49250 */     // MIs[1] Operand 1
     /* 49250 */     // No operand predicates
     /* 49250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49252 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 49255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49265 */     GIR_RootConstrainSelectedInstOperands,
     /* 49266 */     // GIR_Coverage, 760,
     /* 49266 */     GIR_EraseRootFromParent_Done,
     /* 49267 */   // Label 1455: @49267
     /* 49267 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(49305), // Rule ID 772 //
     /* 49272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49279 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 49279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49283 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 49296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49303 */     GIR_RootConstrainSelectedInstOperands,
     /* 49304 */     // GIR_Coverage, 772,
     /* 49304 */     GIR_EraseRootFromParent_Done,
     /* 49305 */   // Label 1456: @49305
     /* 49305 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(49343), // Rule ID 776 //
     /* 49310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49317 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 49317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49321 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 49334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49336 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49341 */     GIR_RootConstrainSelectedInstOperands,
     /* 49342 */     // GIR_Coverage, 776,
     /* 49342 */     GIR_EraseRootFromParent_Done,
     /* 49343 */   // Label 1457: @49343
     /* 49343 */   GIM_Reject,
     /* 49344 */ // Label 1450: @49344
     /* 49344 */ GIM_Reject,
     /* 49345 */ // Label 1426: @49345
     /* 49345 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(49588),
     /* 49350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 49353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 49356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 49360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 49364 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(49397), // Rule ID 867 //
     /* 49369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 49372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49380 */     // MIs[1] Operand 1
     /* 49380 */     // No operand predicates
     /* 49380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49382 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 49382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 49385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49387 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 49392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49395 */     GIR_RootConstrainSelectedInstOperands,
     /* 49396 */     // GIR_Coverage, 867,
     /* 49396 */     GIR_EraseRootFromParent_Done,
     /* 49397 */   // Label 1459: @49397
     /* 49397 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(49421), // Rule ID 18046 //
     /* 49402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 49409 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 49412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49419 */     GIR_RootConstrainSelectedInstOperands,
     /* 49420 */     // GIR_Coverage, 18046,
     /* 49420 */     GIR_EraseRootFromParent_Done,
     /* 49421 */   // Label 1460: @49421
     /* 49421 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(49445), // Rule ID 18054 //
     /* 49426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 49429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 49433 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 49436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49443 */     GIR_RootConstrainSelectedInstOperands,
     /* 49444 */     // GIR_Coverage, 18054,
     /* 49444 */     GIR_EraseRootFromParent_Done,
     /* 49445 */   // Label 1461: @49445
     /* 49445 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(49478), // Rule ID 757 //
     /* 49450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49461 */     // MIs[1] Operand 1
     /* 49461 */     // No operand predicates
     /* 49461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49463 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 49466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49476 */     GIR_RootConstrainSelectedInstOperands,
     /* 49477 */     // GIR_Coverage, 757,
     /* 49477 */     GIR_EraseRootFromParent_Done,
     /* 49478 */   // Label 1462: @49478
     /* 49478 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(49511), // Rule ID 761 //
     /* 49483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 49490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 49494 */     // MIs[1] Operand 1
     /* 49494 */     // No operand predicates
     /* 49494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49496 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 49496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 49499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 49506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49509 */     GIR_RootConstrainSelectedInstOperands,
     /* 49510 */     // GIR_Coverage, 761,
     /* 49510 */     GIR_EraseRootFromParent_Done,
     /* 49511 */   // Label 1463: @49511
     /* 49511 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(49549), // Rule ID 773 //
     /* 49516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 49519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49523 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49527 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 49540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49547 */     GIR_RootConstrainSelectedInstOperands,
     /* 49548 */     // GIR_Coverage, 773,
     /* 49548 */     GIR_EraseRootFromParent_Done,
     /* 49549 */   // Label 1464: @49549
     /* 49549 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(49587), // Rule ID 777 //
     /* 49554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 49557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 49561 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 49561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49565 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 49575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 49578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 49582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 49585 */     GIR_RootConstrainSelectedInstOperands,
     /* 49586 */     // GIR_Coverage, 777,
     /* 49586 */     GIR_EraseRootFromParent_Done,
     /* 49587 */   // Label 1465: @49587
     /* 49587 */   GIM_Reject,
     /* 49588 */ // Label 1458: @49588
     /* 49588 */ GIM_Reject,
     /* 49589 */ // Label 1427: @49589
     /* 49589 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(49820),
     /* 49594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 49597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 49600 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(49627), // Rule ID 1578 //
     /* 49605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 49608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49620 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 49620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 49625 */     GIR_RootConstrainSelectedInstOperands,
     /* 49626 */     // GIR_Coverage, 1578,
     /* 49626 */     GIR_Done,
     /* 49627 */   // Label 1467: @49627
     /* 49627 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(49654), // Rule ID 8053 //
     /* 49632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 49635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49647 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 49647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 49652 */     GIR_RootConstrainSelectedInstOperands,
     /* 49653 */     // GIR_Coverage, 8053,
     /* 49653 */     GIR_Done,
     /* 49654 */   // Label 1468: @49654
     /* 49654 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(49819), // Rule ID 21243 //
     /* 49659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 49662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 49666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49674 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 49674 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 49677 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49681 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 49688 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 49691 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49695 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49700 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 49703 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 49707 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 49710 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49715 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49720 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49725 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 49728 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49732 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 49739 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 49742 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49746 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49751 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 49754 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 49758 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 49761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 49779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 49783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49788 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 49791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 49794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 49799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 49801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 49808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 49813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49818 */     // GIR_Coverage, 21243,
     /* 49818 */     GIR_EraseRootFromParent_Done,
     /* 49819 */   // Label 1469: @49819
     /* 49819 */   GIM_Reject,
     /* 49820 */ // Label 1466: @49820
     /* 49820 */ GIM_Reject,
     /* 49821 */ // Label 1428: @49821
     /* 49821 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(50052),
     /* 49826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 49829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 49832 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(49859), // Rule ID 1575 //
     /* 49837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 49840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 49852 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 49852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 49857 */     GIR_RootConstrainSelectedInstOperands,
     /* 49858 */     // GIR_Coverage, 1575,
     /* 49858 */     GIR_Done,
     /* 49859 */   // Label 1471: @49859
     /* 49859 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(49886), // Rule ID 8026 //
     /* 49864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 49867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49879 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 49879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 49884 */     GIR_RootConstrainSelectedInstOperands,
     /* 49885 */     // GIR_Coverage, 8026,
     /* 49885 */     GIR_Done,
     /* 49886 */   // Label 1472: @49886
     /* 49886 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(50051), // Rule ID 21245 //
     /* 49891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 49894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 49898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 49906 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 49906 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 49909 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49913 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 49920 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 49923 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49927 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49932 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 49935 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 49939 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 49942 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49947 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 49952 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 49957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 49960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 49964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 49971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 49974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 49978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49983 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 49986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 49990 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 49993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 49998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 50008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 50011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 50015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50023 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 50026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50033 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 50040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 50045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50050 */     // GIR_Coverage, 21245,
     /* 50050 */     GIR_EraseRootFromParent_Done,
     /* 50051 */   // Label 1473: @50051
     /* 50051 */   GIM_Reject,
     /* 50052 */ // Label 1470: @50052
     /* 50052 */ GIM_Reject,
     /* 50053 */ // Label 1429: @50053
     /* 50053 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(50245),
     /* 50058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 50061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 50064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50076 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(50091), // Rule ID 8044 //
     /* 50081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 50084 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 50084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 50089 */     GIR_RootConstrainSelectedInstOperands,
     /* 50090 */     // GIR_Coverage, 8044,
     /* 50090 */     GIR_Done,
     /* 50091 */   // Label 1475: @50091
     /* 50091 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(50244), // Rule ID 21244 //
     /* 50096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 50099 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 50099 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 50102 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50106 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 50113 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 50116 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50120 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50125 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 50128 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 50132 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 50135 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50140 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50145 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 50153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 50167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 50183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 50186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 50204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 50208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 50219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50226 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 50233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50243 */     // GIR_Coverage, 21244,
     /* 50243 */     GIR_EraseRootFromParent_Done,
     /* 50244 */   // Label 1476: @50244
     /* 50244 */   GIM_Reject,
     /* 50245 */ // Label 1474: @50245
     /* 50245 */ GIM_Reject,
     /* 50246 */ // Label 1430: @50246
     /* 50246 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(50279), // Rule ID 1581 //
     /* 50251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 50254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 50257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 50260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50272 */   // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 50272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 50277 */   GIR_RootConstrainSelectedInstOperands,
     /* 50278 */   // GIR_Coverage, 1581,
     /* 50278 */   GIR_Done,
     /* 50279 */ // Label 1477: @50279
     /* 50279 */ GIM_Reject,
     /* 50280 */ // Label 1431: @50280
     /* 50280 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(50472),
     /* 50285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 50288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 50291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50303 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(50318), // Rule ID 8017 //
     /* 50308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 50311 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 50311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 50316 */     GIR_RootConstrainSelectedInstOperands,
     /* 50317 */     // GIR_Coverage, 8017,
     /* 50317 */     GIR_Done,
     /* 50318 */   // Label 1479: @50318
     /* 50318 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(50471), // Rule ID 21246 //
     /* 50323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 50326 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 50326 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 50329 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50333 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 50340 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 50343 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50347 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50352 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 50355 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 50359 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 50362 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50367 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50372 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50377 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 50380 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50384 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 50394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50403 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 50410 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 50413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 50431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 50435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 50446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 50460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 50465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50470 */     // GIR_Coverage, 21246,
     /* 50470 */     GIR_EraseRootFromParent_Done,
     /* 50471 */   // Label 1480: @50471
     /* 50471 */   GIM_Reject,
     /* 50472 */ // Label 1478: @50472
     /* 50472 */ GIM_Reject,
     /* 50473 */ // Label 1432: @50473
     /* 50473 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(50506), // Rule ID 8035 //
     /* 50478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 50481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 50484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 50487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50499 */   // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 50499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 50504 */   GIR_RootConstrainSelectedInstOperands,
     /* 50505 */   // GIR_Coverage, 8035,
     /* 50505 */   GIR_Done,
     /* 50506 */ // Label 1481: @50506
     /* 50506 */ GIM_Reject,
     /* 50507 */ // Label 1433: @50507
     /* 50507 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(50540), // Rule ID 1572 //
     /* 50512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 50515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 50518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 50521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 50533 */   // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 50533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 50538 */   GIR_RootConstrainSelectedInstOperands,
     /* 50539 */   // GIR_Coverage, 1572,
     /* 50539 */   GIR_Done,
     /* 50540 */ // Label 1482: @50540
     /* 50540 */ GIM_Reject,
     /* 50541 */ // Label 1434: @50541
     /* 50541 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(50574), // Rule ID 8008 //
     /* 50546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 50549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 50552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 50555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 50567 */   // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 50567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 50572 */   GIR_RootConstrainSelectedInstOperands,
     /* 50573 */   // GIR_Coverage, 8008,
     /* 50573 */   GIR_Done,
     /* 50574 */ // Label 1483: @50574
     /* 50574 */ GIM_Reject,
     /* 50575 */ // Label 1435: @50575
     /* 50575 */ GIM_Reject,
     /* 50576 */ // Label 26: @50576
     /* 50576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 1490*/ GIMT_Encode4(52232),
     /* 50587 */ /*GILLT_v2s1*//*Label 1484*/ GIMT_Encode4(50655), GIMT_Encode4(0),
     /* 50595 */ /*GILLT_v4s1*//*Label 1485*/ GIMT_Encode4(50816), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50607 */ /*GILLT_v8s1*//*Label 1486*/ GIMT_Encode4(51163), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50623 */ /*GILLT_v16s1*//*Label 1487*/ GIMT_Encode4(51560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50639 */ /*GILLT_v32s1*//*Label 1488*/ GIMT_Encode4(51957), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 50651 */ /*GILLT_v64s1*//*Label 1489*/ GIMT_Encode4(52181),
     /* 50655 */ // Label 1484: @50655
     /* 50655 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(50815),
     /* 50660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 50663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 50666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 50670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50679 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(50710), // Rule ID 12603 //
     /* 50684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50701 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 50701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 50704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50706 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50708 */     GIR_RootConstrainSelectedInstOperands,
     /* 50709 */     // GIR_Coverage, 12603,
     /* 50709 */     GIR_EraseRootFromParent_Done,
     /* 50710 */   // Label 1492: @50710
     /* 50710 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(50814), // Rule ID 22105 //
     /* 50715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 50718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50722 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50728 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50732 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 50732 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 50735 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50739 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50746 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 50749 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50753 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50758 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50761 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 50765 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 50768 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50773 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 50778 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 50783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 50786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 50790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50795 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 50798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 50803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 50813 */     // GIR_Coverage, 22105,
     /* 50813 */     GIR_EraseRootFromParent_Done,
     /* 50814 */   // Label 1493: @50814
     /* 50814 */   GIM_Reject,
     /* 50815 */ // Label 1491: @50815
     /* 50815 */ GIM_Reject,
     /* 50816 */ // Label 1485: @50816
     /* 50816 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(50866), // Rule ID 12600 //
     /* 50821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 50827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 50830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50834 */   // MIs[0] Operand 1
     /* 50834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50843 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50849 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50857 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 50857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 50860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50862 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50864 */   GIR_RootConstrainSelectedInstOperands,
     /* 50865 */   // GIR_Coverage, 12600,
     /* 50865 */   GIR_EraseRootFromParent_Done,
     /* 50866 */ // Label 1494: @50866
     /* 50866 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(50916), // Rule ID 12602 //
     /* 50871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 50874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 50877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 50880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50884 */   // MIs[0] Operand 1
     /* 50884 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50893 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50899 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50901 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 50905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50907 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 50907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 50910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 50912 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 50914 */   GIR_RootConstrainSelectedInstOperands,
     /* 50915 */   // GIR_Coverage, 12602,
     /* 50915 */   GIR_EraseRootFromParent_Done,
     /* 50916 */ // Label 1495: @50916
     /* 50916 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(51039), // Rule ID 22103 //
     /* 50921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 50924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 50927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 50930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 50934 */   // MIs[0] Operand 1
     /* 50934 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 50939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 50943 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 50949 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 50951 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 50955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50957 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 50957 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 50960 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 50964 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 50971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 50974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 50978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50983 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 50986 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 50990 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 50993 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 50998 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51003 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 51008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 51011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 51015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51020 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51033 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 51038 */   // GIR_Coverage, 22103,
     /* 51038 */   GIR_EraseRootFromParent_Done,
     /* 51039 */ // Label 1496: @51039
     /* 51039 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(51162), // Rule ID 22104 //
     /* 51044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 51047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 51050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 51053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 51057 */   // MIs[0] Operand 1
     /* 51057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51066 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51072 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51080 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 51080 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 51083 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51087 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51094 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 51097 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51101 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51106 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51109 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51113 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 51116 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51121 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51126 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 51131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 51134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 51138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51143 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 51161 */   // GIR_Coverage, 22104,
     /* 51161 */   GIR_EraseRootFromParent_Done,
     /* 51162 */ // Label 1497: @51162
     /* 51162 */ GIM_Reject,
     /* 51163 */ // Label 1486: @51163
     /* 51163 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(51213), // Rule ID 12597 //
     /* 51168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 51174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 51177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 51181 */   // MIs[0] Operand 1
     /* 51181 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51190 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51196 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51204 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 51204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 51207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51209 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51211 */   GIR_RootConstrainSelectedInstOperands,
     /* 51212 */   // GIR_Coverage, 12597,
     /* 51212 */   GIR_EraseRootFromParent_Done,
     /* 51213 */ // Label 1498: @51213
     /* 51213 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(51263), // Rule ID 12599 //
     /* 51218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 51221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 51224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 51227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 51231 */   // MIs[0] Operand 1
     /* 51231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51236 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51240 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51246 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51248 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51254 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 51254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 51257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51259 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51261 */   GIR_RootConstrainSelectedInstOperands,
     /* 51262 */   // GIR_Coverage, 12599,
     /* 51262 */   GIR_EraseRootFromParent_Done,
     /* 51263 */ // Label 1499: @51263
     /* 51263 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(51313), // Rule ID 12601 //
     /* 51268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 51271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 51274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 51277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 51281 */   // MIs[0] Operand 1
     /* 51281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51290 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51296 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 51302 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51304 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 51304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 51307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51309 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51311 */   GIR_RootConstrainSelectedInstOperands,
     /* 51312 */   // GIR_Coverage, 12601,
     /* 51312 */   GIR_EraseRootFromParent_Done,
     /* 51313 */ // Label 1500: @51313
     /* 51313 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(51436), // Rule ID 22101 //
     /* 51318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 51321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 51324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 51327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 51331 */   // MIs[0] Operand 1
     /* 51331 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51340 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51346 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51348 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51354 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 51354 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 51357 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51361 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51368 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 51371 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51375 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51380 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51383 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51387 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 51390 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51395 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51400 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 51405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 51408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 51412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51417 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 51435 */   // GIR_Coverage, 22101,
     /* 51435 */   GIR_EraseRootFromParent_Done,
     /* 51436 */ // Label 1501: @51436
     /* 51436 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(51559), // Rule ID 22102 //
     /* 51441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 51444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 51447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 51450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 51454 */   // MIs[0] Operand 1
     /* 51454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51463 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51469 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51477 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 51477 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 51480 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51484 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 51494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51503 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51506 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51510 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 51513 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51518 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51523 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 51528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 51531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 51535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51540 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 51558 */   // GIR_Coverage, 22102,
     /* 51558 */   GIR_EraseRootFromParent_Done,
     /* 51559 */ // Label 1502: @51559
     /* 51559 */ GIM_Reject,
     /* 51560 */ // Label 1487: @51560
     /* 51560 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(51610), // Rule ID 12594 //
     /* 51565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 51571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 51574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51578 */   // MIs[0] Operand 1
     /* 51578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51587 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51593 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51601 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 51601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 51604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51606 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51608 */   GIR_RootConstrainSelectedInstOperands,
     /* 51609 */   // GIR_Coverage, 12594,
     /* 51609 */   GIR_EraseRootFromParent_Done,
     /* 51610 */ // Label 1503: @51610
     /* 51610 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(51660), // Rule ID 12596 //
     /* 51615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 51621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 51624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51628 */   // MIs[0] Operand 1
     /* 51628 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51637 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51643 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51645 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51651 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 51651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 51654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51656 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51658 */   GIR_RootConstrainSelectedInstOperands,
     /* 51659 */   // GIR_Coverage, 12596,
     /* 51659 */   GIR_EraseRootFromParent_Done,
     /* 51660 */ // Label 1504: @51660
     /* 51660 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(51710), // Rule ID 12598 //
     /* 51665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 51668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 51671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 51674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51678 */   // MIs[0] Operand 1
     /* 51678 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51687 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51693 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51695 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 51699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51701 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 51701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 51704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51706 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 51708 */   GIR_RootConstrainSelectedInstOperands,
     /* 51709 */   // GIR_Coverage, 12598,
     /* 51709 */   GIR_EraseRootFromParent_Done,
     /* 51710 */ // Label 1505: @51710
     /* 51710 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(51833), // Rule ID 22099 //
     /* 51715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 51718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 51721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 51724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51728 */   // MIs[0] Operand 1
     /* 51728 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51737 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51743 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51745 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 51749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51751 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 51751 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 51754 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51758 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51765 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 51768 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51772 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51777 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51780 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51784 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 51787 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51792 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51797 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 51802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 51805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 51809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51814 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 51832 */   // GIR_Coverage, 22099,
     /* 51832 */   GIR_EraseRootFromParent_Done,
     /* 51833 */ // Label 1506: @51833
     /* 51833 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(51956), // Rule ID 22100 //
     /* 51838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 51841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 51844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 51847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 51851 */   // MIs[0] Operand 1
     /* 51851 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51860 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51866 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51868 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51874 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 51874 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 51877 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 51881 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 51888 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 51891 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 51895 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51900 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 51903 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 51907 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 51910 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 51915 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 51920 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 51925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 51928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 51932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51937 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 51940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 51945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 51947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 51955 */   // GIR_Coverage, 22100,
     /* 51955 */   GIR_EraseRootFromParent_Done,
     /* 51956 */ // Label 1507: @51956
     /* 51956 */ GIM_Reject,
     /* 51957 */ // Label 1488: @51957
     /* 51957 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(52007), // Rule ID 12593 //
     /* 51962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 51965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 51968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 51971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 51975 */   // MIs[0] Operand 1
     /* 51975 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 51980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 51984 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 51990 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 51992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 51996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51998 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 51998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 52001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52003 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 52005 */   GIR_RootConstrainSelectedInstOperands,
     /* 52006 */   // GIR_Coverage, 12593,
     /* 52006 */   GIR_EraseRootFromParent_Done,
     /* 52007 */ // Label 1508: @52007
     /* 52007 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(52057), // Rule ID 12595 //
     /* 52012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 52015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 52018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 52021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 52025 */   // MIs[0] Operand 1
     /* 52025 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 52030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 52034 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52040 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52042 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 52046 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52048 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 52048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 52051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52053 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 52055 */   GIR_RootConstrainSelectedInstOperands,
     /* 52056 */   // GIR_Coverage, 12595,
     /* 52056 */   GIR_EraseRootFromParent_Done,
     /* 52057 */ // Label 1509: @52057
     /* 52057 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(52180), // Rule ID 22098 //
     /* 52062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 52065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 52068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 52071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 52075 */   // MIs[0] Operand 1
     /* 52075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 52080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 52084 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52090 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 52096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52098 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 52098 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 52101 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52105 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 52112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 52115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52124 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 52127 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 52131 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 52134 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52139 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52144 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 52149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 52152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 52156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52161 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 52179 */   // GIR_Coverage, 22098,
     /* 52179 */   GIR_EraseRootFromParent_Done,
     /* 52180 */ // Label 1510: @52180
     /* 52180 */ GIM_Reject,
     /* 52181 */ // Label 1489: @52181
     /* 52181 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(52231), // Rule ID 12592 //
     /* 52186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 52189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 52192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 52195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 52199 */   // MIs[0] Operand 1
     /* 52199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 52204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 52208 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52214 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 52220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52222 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 52222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 52225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52227 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 52229 */   GIR_RootConstrainSelectedInstOperands,
     /* 52230 */   // GIR_Coverage, 12592,
     /* 52230 */   GIR_EraseRootFromParent_Done,
     /* 52231 */ // Label 1511: @52231
     /* 52231 */ GIM_Reject,
     /* 52232 */ // Label 1490: @52232
     /* 52232 */ GIM_Reject,
     /* 52233 */ // Label 27: @52233
     /* 52233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 1524*/ GIMT_Encode4(59040),
     /* 52244 */ /*GILLT_v2s64*//*Label 1512*/ GIMT_Encode4(52312), GIMT_Encode4(0),
     /* 52252 */ /*GILLT_v4s32*//*Label 1513*/ GIMT_Encode4(53176),
     /* 52256 */ /*GILLT_v4s64*//*Label 1514*/ GIMT_Encode4(54040), GIMT_Encode4(0),
     /* 52264 */ /*GILLT_v8s16*//*Label 1515*/ GIMT_Encode4(54820),
     /* 52268 */ /*GILLT_v8s32*//*Label 1516*/ GIMT_Encode4(55684),
     /* 52272 */ /*GILLT_v8s64*//*Label 1517*/ GIMT_Encode4(56464), GIMT_Encode4(0),
     /* 52280 */ /*GILLT_v16s8*//*Label 1518*/ GIMT_Encode4(56845),
     /* 52284 */ /*GILLT_v16s16*//*Label 1519*/ GIMT_Encode4(57285),
     /* 52288 */ /*GILLT_v16s32*//*Label 1520*/ GIMT_Encode4(58065), GIMT_Encode4(0),
     /* 52296 */ /*GILLT_v32s8*//*Label 1521*/ GIMT_Encode4(58406),
     /* 52300 */ /*GILLT_v32s16*//*Label 1522*/ GIMT_Encode4(58810), GIMT_Encode4(0),
     /* 52308 */ /*GILLT_v64s8*//*Label 1523*/ GIMT_Encode4(58954),
     /* 52312 */ // Label 1512: @52312
     /* 52312 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(53175),
     /* 52317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 52320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 52323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 52326 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(52371), // Rule ID 4486 //
     /* 52331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52350 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52356 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52360 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 52360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 52363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52365 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 52369 */     GIR_RootConstrainSelectedInstOperands,
     /* 52370 */     // GIR_Coverage, 4486,
     /* 52370 */     GIR_EraseRootFromParent_Done,
     /* 52371 */   // Label 1526: @52371
     /* 52371 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(52416), // Rule ID 4540 //
     /* 52376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52405 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 52405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 52408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52410 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 52414 */     GIR_RootConstrainSelectedInstOperands,
     /* 52415 */     // GIR_Coverage, 4540,
     /* 52415 */     GIR_EraseRootFromParent_Done,
     /* 52416 */   // Label 1527: @52416
     /* 52416 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(52565), // Rule ID 20224 //
     /* 52421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52450 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52450 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 52453 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52457 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 52464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52476 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 52479 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52483 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 52486 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52491 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52496 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 52504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 52529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52534 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 52540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52547 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52564 */     // GIR_Coverage, 20224,
     /* 52564 */     GIR_EraseRootFromParent_Done,
     /* 52565 */   // Label 1528: @52565
     /* 52565 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(52714), // Rule ID 20226 //
     /* 52570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 52589 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 52595 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 52597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52599 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52599 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 52602 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52606 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 52613 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52616 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52620 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52625 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 52628 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52632 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 52635 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52640 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52645 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 52653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 52678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 52689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52696 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52713 */     // GIR_Coverage, 20226,
     /* 52713 */     GIR_EraseRootFromParent_Done,
     /* 52714 */   // Label 1529: @52714
     /* 52714 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(52751), // Rule ID 4488 //
     /* 52719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52738 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 52738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 52741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 52745 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 52749 */     GIR_RootConstrainSelectedInstOperands,
     /* 52750 */     // GIR_Coverage, 4488,
     /* 52750 */     GIR_EraseRootFromParent_Done,
     /* 52751 */   // Label 1530: @52751
     /* 52751 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(52788), // Rule ID 4542 //
     /* 52756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 52759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52775 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 52775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 52778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 52782 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 52784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 52786 */     GIR_RootConstrainSelectedInstOperands,
     /* 52787 */     // GIR_Coverage, 4542,
     /* 52787 */     GIR_EraseRootFromParent_Done,
     /* 52788 */   // Label 1531: @52788
     /* 52788 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(52981), // Rule ID 20223 //
     /* 52793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 52812 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 52812 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 52815 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52819 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 52826 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 52829 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52833 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52838 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 52841 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 52845 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 52848 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52853 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52858 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52863 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 52866 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52870 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52875 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 52879 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 52884 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 52887 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 52891 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 52898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 52901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 52905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52910 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 52913 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 52917 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 52920 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 52925 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 52935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 52938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 52942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 52950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 52953 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 52956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 52961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 52963 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 52970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 52975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 52980 */     // GIR_Coverage, 20223,
     /* 52980 */     GIR_EraseRootFromParent_Done,
     /* 52981 */   // Label 1532: @52981
     /* 52981 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(53174), // Rule ID 20225 //
     /* 52986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 52989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 52993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 52997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53005 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53005 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 53008 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53012 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 53019 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 53022 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53026 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53031 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 53034 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53038 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 53041 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53046 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53051 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53056 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 53059 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53063 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53068 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53072 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 53077 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 53080 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53084 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 53091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 53094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53103 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 53106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 53110 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 53113 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 53131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 53135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 53146 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 53149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53156 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53173 */     // GIR_Coverage, 20225,
     /* 53173 */     GIR_EraseRootFromParent_Done,
     /* 53174 */   // Label 1533: @53174
     /* 53174 */   GIM_Reject,
     /* 53175 */ // Label 1525: @53175
     /* 53175 */ GIM_Reject,
     /* 53176 */ // Label 1513: @53176
     /* 53176 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(54039),
     /* 53181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 53184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 53187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 53190 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(53235), // Rule ID 4468 //
     /* 53195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53214 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53220 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53224 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 53224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 53227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53229 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 53233 */     GIR_RootConstrainSelectedInstOperands,
     /* 53234 */     // GIR_Coverage, 4468,
     /* 53234 */     GIR_EraseRootFromParent_Done,
     /* 53235 */   // Label 1535: @53235
     /* 53235 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(53280), // Rule ID 4526 //
     /* 53240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53269 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 53269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 53272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53274 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 53278 */     GIR_RootConstrainSelectedInstOperands,
     /* 53279 */     // GIR_Coverage, 4526,
     /* 53279 */     GIR_EraseRootFromParent_Done,
     /* 53280 */   // Label 1536: @53280
     /* 53280 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(53429), // Rule ID 20216 //
     /* 53285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53314 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53314 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 53317 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53321 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 53328 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53331 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53335 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53340 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 53343 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53347 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 53350 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53355 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53360 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53365 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 53368 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53372 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 53393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 53404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53428 */     // GIR_Coverage, 20216,
     /* 53428 */     GIR_EraseRootFromParent_Done,
     /* 53429 */   // Label 1537: @53429
     /* 53429 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(53578), // Rule ID 20218 //
     /* 53434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 53453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 53459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 53461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53463 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53463 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 53466 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53470 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 53477 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53480 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53484 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53489 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 53492 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53496 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 53499 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53504 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53509 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 53517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53526 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53530 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 53542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 53553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53577 */     // GIR_Coverage, 20218,
     /* 53577 */     GIR_EraseRootFromParent_Done,
     /* 53578 */   // Label 1538: @53578
     /* 53578 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(53615), // Rule ID 4470 //
     /* 53583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53602 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 53602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 53605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53607 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 53609 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 53613 */     GIR_RootConstrainSelectedInstOperands,
     /* 53614 */     // GIR_Coverage, 4470,
     /* 53614 */     GIR_EraseRootFromParent_Done,
     /* 53615 */   // Label 1539: @53615
     /* 53615 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(53652), // Rule ID 4527 //
     /* 53620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 53623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53639 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 53639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 53642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53644 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 53646 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 53648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 53650 */     GIR_RootConstrainSelectedInstOperands,
     /* 53651 */     // GIR_Coverage, 4527,
     /* 53651 */     GIR_EraseRootFromParent_Done,
     /* 53652 */   // Label 1540: @53652
     /* 53652 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(53845), // Rule ID 20215 //
     /* 53657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53676 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53676 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 53679 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53683 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 53690 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 53693 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53697 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53702 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 53705 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53709 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 53712 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53717 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53722 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53727 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 53730 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53734 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53739 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53743 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53748 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53751 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53755 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 53762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 53765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53774 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 53777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 53781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 53784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 53806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 53814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 53817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 53820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 53827 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 53834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 53839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53844 */     // GIR_Coverage, 20215,
     /* 53844 */     GIR_EraseRootFromParent_Done,
     /* 53845 */   // Label 1541: @53845
     /* 53845 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(54038), // Rule ID 20217 //
     /* 53850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 53853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 53857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 53861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 53869 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 53869 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 53872 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53876 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 53883 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 53886 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53890 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53895 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 53898 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 53902 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 53905 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53910 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53915 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53920 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 53923 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 53927 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53932 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 53936 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 53941 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 53944 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 53948 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 53955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 53958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 53962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53967 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 53970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 53974 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 53977 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 53982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 53987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 53992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 53995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 53999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 54010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 54013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 54027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 54032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54037 */     // GIR_Coverage, 20217,
     /* 54037 */     GIR_EraseRootFromParent_Done,
     /* 54038 */   // Label 1542: @54038
     /* 54038 */   GIM_Reject,
     /* 54039 */ // Label 1534: @54039
     /* 54039 */ GIM_Reject,
     /* 54040 */ // Label 1514: @54040
     /* 54040 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(54819),
     /* 54045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 54048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 54051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 54054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 54062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54066 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(54099), // Rule ID 4481 //
     /* 54071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 54074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54078 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54084 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54088 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 54088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 54091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54093 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 54097 */     GIR_RootConstrainSelectedInstOperands,
     /* 54098 */     // GIR_Coverage, 4481,
     /* 54098 */     GIR_EraseRootFromParent_Done,
     /* 54099 */   // Label 1544: @54099
     /* 54099 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(54132), // Rule ID 4535 //
     /* 54104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 54107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54111 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54117 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54121 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 54121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 54124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54126 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 54130 */     GIR_RootConstrainSelectedInstOperands,
     /* 54131 */     // GIR_Coverage, 4535,
     /* 54131 */     GIR_EraseRootFromParent_Done,
     /* 54132 */   // Label 1545: @54132
     /* 54132 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(54269), // Rule ID 20228 //
     /* 54137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 54140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54154 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 54154 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 54157 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54161 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 54168 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 54171 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54175 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54180 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 54183 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54187 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 54190 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54195 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54200 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 54208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54217 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54221 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 54229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 54233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 54244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54268 */     // GIR_Coverage, 20228,
     /* 54268 */     GIR_EraseRootFromParent_Done,
     /* 54269 */   // Label 1546: @54269
     /* 54269 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(54406), // Rule ID 20230 //
     /* 54274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 54277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54287 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54291 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 54291 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 54294 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54298 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 54305 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 54308 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54312 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54317 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 54320 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54324 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 54327 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54332 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54337 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 54345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 54366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 54370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 54381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54388 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54405 */     // GIR_Coverage, 20230,
     /* 54405 */     GIR_EraseRootFromParent_Done,
     /* 54406 */   // Label 1547: @54406
     /* 54406 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(54431), // Rule ID 4483 //
     /* 54411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 54414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54418 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 54418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 54421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54423 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 54425 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 54429 */     GIR_RootConstrainSelectedInstOperands,
     /* 54430 */     // GIR_Coverage, 4483,
     /* 54430 */     GIR_EraseRootFromParent_Done,
     /* 54431 */   // Label 1548: @54431
     /* 54431 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(54456), // Rule ID 4537 //
     /* 54436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 54439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54443 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 54443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 54446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54448 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 54450 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 54454 */     GIR_RootConstrainSelectedInstOperands,
     /* 54455 */     // GIR_Coverage, 4537,
     /* 54455 */     GIR_EraseRootFromParent_Done,
     /* 54456 */   // Label 1549: @54456
     /* 54456 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(54637), // Rule ID 20227 //
     /* 54461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 54464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54468 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 54468 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 54471 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54475 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 54482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 54485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54494 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 54497 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54501 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 54504 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54509 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54514 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54519 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 54522 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54526 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54531 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54535 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 54543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 54554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 54557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 54569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 54573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 54576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 54594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 54598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 54609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 54612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54619 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54636 */     // GIR_Coverage, 20227,
     /* 54636 */     GIR_EraseRootFromParent_Done,
     /* 54637 */   // Label 1550: @54637
     /* 54637 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(54818), // Rule ID 20229 //
     /* 54642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 54645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 54649 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 54649 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 54652 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54656 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 54663 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 54666 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54670 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54675 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 54678 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54682 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 54685 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54690 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54695 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54700 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 54703 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54707 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54712 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54716 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 54724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 54735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 54738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54747 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 54750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 54754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 54757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 54775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 54779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 54787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 54790 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 54793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 54807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 54812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54817 */     // GIR_Coverage, 20229,
     /* 54817 */     GIR_EraseRootFromParent_Done,
     /* 54818 */   // Label 1551: @54818
     /* 54818 */   GIM_Reject,
     /* 54819 */ // Label 1543: @54819
     /* 54819 */ GIM_Reject,
     /* 54820 */ // Label 1515: @54820
     /* 54820 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(55683),
     /* 54825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 54828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 54831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 54834 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(54879), // Rule ID 4568 //
     /* 54839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 54842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54858 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54864 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54868 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 54868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 54871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 54873 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 54875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 54877 */     GIR_RootConstrainSelectedInstOperands,
     /* 54878 */     // GIR_Coverage, 4568,
     /* 54878 */     GIR_EraseRootFromParent_Done,
     /* 54879 */   // Label 1553: @54879
     /* 54879 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(55028), // Rule ID 20236 //
     /* 54884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 54887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 54891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 54895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 54899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 54903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 54909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 54911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54913 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 54913 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 54916 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 54920 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 54927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 54930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 54934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54939 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 54942 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 54946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 54949 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 54954 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 54959 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 54964 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 54967 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 54971 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54976 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 54980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 54985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 54988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 54992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54997 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 55003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55010 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 55017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 55022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55027 */     // GIR_Coverage, 20236,
     /* 55027 */     GIR_EraseRootFromParent_Done,
     /* 55028 */   // Label 1554: @55028
     /* 55028 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(55177), // Rule ID 20240 //
     /* 55033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 55036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 55040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55062 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 55062 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 55065 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55069 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 55076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 55079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55088 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 55091 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55095 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 55098 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55103 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55108 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55113 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 55116 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55120 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55125 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 55134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 55137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 55141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55146 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 55152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55159 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 55166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 55171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55176 */     // GIR_Coverage, 20240,
     /* 55176 */     GIR_EraseRootFromParent_Done,
     /* 55177 */   // Label 1555: @55177
     /* 55177 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(55222), // Rule ID 20312 //
     /* 55182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 55185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55201 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55207 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55211 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 55211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 55214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55216 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 55220 */     GIR_RootConstrainSelectedInstOperands,
     /* 55221 */     // GIR_Coverage, 20312,
     /* 55221 */     GIR_EraseRootFromParent_Done,
     /* 55222 */   // Label 1556: @55222
     /* 55222 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(55259), // Rule ID 4569 //
     /* 55227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 55230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55246 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 55246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 55249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55251 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 55253 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 55257 */     GIR_RootConstrainSelectedInstOperands,
     /* 55258 */     // GIR_Coverage, 4569,
     /* 55258 */     GIR_EraseRootFromParent_Done,
     /* 55259 */   // Label 1557: @55259
     /* 55259 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(55452), // Rule ID 20235 //
     /* 55264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 55267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 55271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55283 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 55283 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 55286 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55290 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 55297 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 55300 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55304 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55309 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 55312 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55316 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 55319 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55324 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55329 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55334 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 55337 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55341 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55346 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55350 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 55355 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 55358 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55362 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 55369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 55372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55381 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 55384 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 55388 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 55391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55396 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 55409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 55413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55418 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55421 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 55424 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 55427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55434 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 55441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 55446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55451 */     // GIR_Coverage, 20235,
     /* 55451 */     GIR_EraseRootFromParent_Done,
     /* 55452 */   // Label 1558: @55452
     /* 55452 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(55645), // Rule ID 20239 //
     /* 55457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 55460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 55464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55476 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 55476 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 55479 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55483 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 55490 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 55493 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55497 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55502 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 55505 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55509 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 55512 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55517 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55522 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55527 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 55530 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55534 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55539 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55543 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 55548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 55551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 55562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 55565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55574 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 55577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 55581 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 55584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 55599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 55602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 55606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 55617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 55620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55627 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 55634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 55639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55644 */     // GIR_Coverage, 20239,
     /* 55644 */     GIR_EraseRootFromParent_Done,
     /* 55645 */   // Label 1559: @55645
     /* 55645 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(55682), // Rule ID 20311 //
     /* 55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 55653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 55669 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 55669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 55672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55674 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 55676 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 55680 */     GIR_RootConstrainSelectedInstOperands,
     /* 55681 */     // GIR_Coverage, 20311,
     /* 55681 */     GIR_EraseRootFromParent_Done,
     /* 55682 */   // Label 1560: @55682
     /* 55682 */   GIM_Reject,
     /* 55683 */ // Label 1552: @55683
     /* 55683 */ GIM_Reject,
     /* 55684 */ // Label 1516: @55684
     /* 55684 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(56463),
     /* 55689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 55692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 55695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 55698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 55706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 55710 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(55743), // Rule ID 4463 //
     /* 55715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 55718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55722 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55728 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55732 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55737 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 55741 */     GIR_RootConstrainSelectedInstOperands,
     /* 55742 */     // GIR_Coverage, 4463,
     /* 55742 */     GIR_EraseRootFromParent_Done,
     /* 55743 */   // Label 1562: @55743
     /* 55743 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(55776), // Rule ID 4522 //
     /* 55748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 55751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55765 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 55765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 55768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55770 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 55772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 55774 */     GIR_RootConstrainSelectedInstOperands,
     /* 55775 */     // GIR_Coverage, 4522,
     /* 55775 */     GIR_EraseRootFromParent_Done,
     /* 55776 */   // Label 1563: @55776
     /* 55776 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(55913), // Rule ID 20220 //
     /* 55781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 55784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55788 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55794 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55798 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 55798 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 55801 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55805 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 55812 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 55815 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55819 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55824 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 55827 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55831 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 55834 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55839 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55844 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 55852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55861 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 55865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 55870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 55873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 55877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 55885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 55888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 55895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 55902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55912 */     // GIR_Coverage, 20220,
     /* 55912 */     GIR_EraseRootFromParent_Done,
     /* 55913 */   // Label 1564: @55913
     /* 55913 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(56050), // Rule ID 20222 //
     /* 55918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 55921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 55925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 55931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 55933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55935 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 55935 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 55938 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 55942 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 55949 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 55952 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 55956 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55961 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 55964 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 55968 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 55971 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 55976 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 55981 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 55986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 55989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 55993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56002 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 56010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 56014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56019 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 56025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56032 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 56039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56049 */     // GIR_Coverage, 20222,
     /* 56049 */     GIR_EraseRootFromParent_Done,
     /* 56050 */   // Label 1565: @56050
     /* 56050 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(56075), // Rule ID 4465 //
     /* 56055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 56058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 56062 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 56062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 56065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56067 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56069 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56073 */     GIR_RootConstrainSelectedInstOperands,
     /* 56074 */     // GIR_Coverage, 4465,
     /* 56074 */     GIR_EraseRootFromParent_Done,
     /* 56075 */   // Label 1566: @56075
     /* 56075 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(56100), // Rule ID 4523 //
     /* 56080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 56083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 56087 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 56087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 56090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56092 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56094 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56098 */     GIR_RootConstrainSelectedInstOperands,
     /* 56099 */     // GIR_Coverage, 4523,
     /* 56099 */     GIR_EraseRootFromParent_Done,
     /* 56100 */   // Label 1567: @56100
     /* 56100 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(56281), // Rule ID 20219 //
     /* 56105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 56108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 56112 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 56112 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 56115 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56119 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 56126 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 56129 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56133 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56138 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 56141 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 56145 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 56148 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56153 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56158 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56163 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 56166 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56170 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56175 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56179 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56184 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 56187 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56191 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 56198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 56201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56210 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 56213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 56217 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 56220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 56238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 56242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 56253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 56256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56263 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 56270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56280 */     // GIR_Coverage, 20219,
     /* 56280 */     GIR_EraseRootFromParent_Done,
     /* 56281 */   // Label 1568: @56281
     /* 56281 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(56462), // Rule ID 20221 //
     /* 56286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 56289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 56293 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 56293 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 56296 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56300 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 56307 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 56310 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56314 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56319 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 56322 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 56326 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 56329 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56334 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56339 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56344 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 56347 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56351 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56356 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56360 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56365 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 56368 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56372 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 56379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 56382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56391 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 56394 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 56398 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 56401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56406 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 56419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 56423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56431 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 56434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 56437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56444 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 56451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 56456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56461 */     // GIR_Coverage, 20221,
     /* 56461 */     GIR_EraseRootFromParent_Done,
     /* 56462 */   // Label 1569: @56462
     /* 56462 */   GIM_Reject,
     /* 56463 */ // Label 1561: @56463
     /* 56463 */ GIM_Reject,
     /* 56464 */ // Label 1517: @56464
     /* 56464 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(56844),
     /* 56469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 56472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 56475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 56478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56482 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(56551), // Rule ID 20213 //
     /* 56487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 56495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 56499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 56503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 56508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 56512 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56518 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 56520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 56524 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56530 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 56532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 56538 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 56538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 56541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 56547 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 56549 */     GIR_RootConstrainSelectedInstOperands,
     /* 56550 */     // GIR_Coverage, 20213,
     /* 56550 */     GIR_EraseRootFromParent_Done,
     /* 56551 */   // Label 1571: @56551
     /* 56551 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(56598), // Rule ID 3596 //
     /* 56556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 56567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 56575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 56579 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 56587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 56589 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 56589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 56592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56594 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56596 */     GIR_RootConstrainSelectedInstOperands,
     /* 56597 */     // GIR_Coverage, 3596,
     /* 56597 */     GIR_EraseRootFromParent_Done,
     /* 56598 */   // Label 1572: @56598
     /* 56598 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(56695), // Rule ID 20211 //
     /* 56603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 56611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56625 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 56625 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 56628 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56632 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56637 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 56641 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 56646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 56649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 56653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56658 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 56661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 56666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56675 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 56678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 56683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 56686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56691 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 56693 */     GIR_RootConstrainSelectedInstOperands,
     /* 56694 */     // GIR_Coverage, 20211,
     /* 56694 */     GIR_EraseRootFromParent_Done,
     /* 56695 */   // Label 1573: @56695
     /* 56695 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(56736), // Rule ID 4476 //
     /* 56700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56725 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 56725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 56728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56730 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56732 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56734 */     GIR_RootConstrainSelectedInstOperands,
     /* 56735 */     // GIR_Coverage, 4476,
     /* 56735 */     GIR_EraseRootFromParent_Done,
     /* 56736 */   // Label 1574: @56736
     /* 56736 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(56777), // Rule ID 4530 //
     /* 56741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56756 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56762 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56766 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 56766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 56769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56771 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56773 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56775 */     GIR_RootConstrainSelectedInstOperands,
     /* 56776 */     // GIR_Coverage, 4530,
     /* 56776 */     GIR_EraseRootFromParent_Done,
     /* 56777 */   // Label 1575: @56777
     /* 56777 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(56810), // Rule ID 4478 //
     /* 56782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56797 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 56797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 56800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56802 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56804 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56808 */     GIR_RootConstrainSelectedInstOperands,
     /* 56809 */     // GIR_Coverage, 4478,
     /* 56809 */     GIR_EraseRootFromParent_Done,
     /* 56810 */   // Label 1576: @56810
     /* 56810 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(56843), // Rule ID 4532 //
     /* 56815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 56818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 56822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 56830 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 56830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 56833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56835 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 56837 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56839 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 56841 */     GIR_RootConstrainSelectedInstOperands,
     /* 56842 */     // GIR_Coverage, 4532,
     /* 56842 */     GIR_EraseRootFromParent_Done,
     /* 56843 */   // Label 1577: @56843
     /* 56843 */   GIM_Reject,
     /* 56844 */ // Label 1570: @56844
     /* 56844 */ GIM_Reject,
     /* 56845 */ // Label 1518: @56845
     /* 56845 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(57284),
     /* 56850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 56853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 56856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 56859 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(56904), // Rule ID 4556 //
     /* 56864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 56867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56889 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56893 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 56893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 56896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 56898 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 56900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 56902 */     GIR_RootConstrainSelectedInstOperands,
     /* 56903 */     // GIR_Coverage, 4556,
     /* 56903 */     GIR_EraseRootFromParent_Done,
     /* 56904 */   // Label 1579: @56904
     /* 56904 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(57053), // Rule ID 20232 //
     /* 56909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 56912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 56916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 56920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 56924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 56928 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 56934 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 56936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56938 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 56938 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 56941 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 56945 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 56952 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 56955 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 56959 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56964 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 56967 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 56971 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 56974 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 56979 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 56984 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 56989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 56992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 56996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57001 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 57010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 57013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 57017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 57028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 57042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 57047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57052 */     // GIR_Coverage, 20232,
     /* 57052 */     GIR_EraseRootFromParent_Done,
     /* 57053 */   // Label 1580: @57053
     /* 57053 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(57090), // Rule ID 4557 //
     /* 57058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 57065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 57073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 57077 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 57077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 57080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57082 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 57084 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57086 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57088 */     GIR_RootConstrainSelectedInstOperands,
     /* 57089 */     // GIR_Coverage, 4557,
     /* 57089 */     GIR_EraseRootFromParent_Done,
     /* 57090 */   // Label 1581: @57090
     /* 57090 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(57283), // Rule ID 20231 //
     /* 57095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 57102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 57110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 57114 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 57114 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 57117 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57121 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 57128 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 57131 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57135 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57140 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 57143 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57147 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 57150 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57155 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57160 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 57165 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 57168 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57172 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57177 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57181 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 57186 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 57189 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57193 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 57200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 57203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57212 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 57215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 57219 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 57222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 57237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 57240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 57244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 57255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 57258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57265 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 57272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 57277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57282 */     // GIR_Coverage, 20231,
     /* 57282 */     GIR_EraseRootFromParent_Done,
     /* 57283 */   // Label 1582: @57283
     /* 57283 */   GIM_Reject,
     /* 57284 */ // Label 1578: @57284
     /* 57284 */ GIM_Reject,
     /* 57285 */ // Label 1519: @57285
     /* 57285 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(58064),
     /* 57290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 57293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 57296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 57299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 57307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57311 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(57344), // Rule ID 4564 //
     /* 57316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57329 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57333 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 57333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 57336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57338 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 57342 */     GIR_RootConstrainSelectedInstOperands,
     /* 57343 */     // GIR_Coverage, 4564,
     /* 57343 */     GIR_EraseRootFromParent_Done,
     /* 57344 */   // Label 1584: @57344
     /* 57344 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(57481), // Rule ID 20238 //
     /* 57349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57366 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57366 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 57369 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57373 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 57380 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57383 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57387 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57392 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 57395 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57399 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 57402 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57407 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57412 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 57420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 57445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 57456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57463 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57480 */     // GIR_Coverage, 20238,
     /* 57480 */     GIR_EraseRootFromParent_Done,
     /* 57481 */   // Label 1585: @57481
     /* 57481 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(57618), // Rule ID 20242 //
     /* 57486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57493 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57499 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57503 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57503 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 57506 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57510 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 57517 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57520 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57524 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57529 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 57532 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57536 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 57539 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57544 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57549 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 57557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 57582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 57593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57600 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57617 */     // GIR_Coverage, 20242,
     /* 57617 */     GIR_EraseRootFromParent_Done,
     /* 57618 */   // Label 1586: @57618
     /* 57618 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(57651), // Rule ID 20302 //
     /* 57623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 57630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 57636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 57638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57640 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 57640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 57643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57645 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57649 */     GIR_RootConstrainSelectedInstOperands,
     /* 57650 */     // GIR_Coverage, 20302,
     /* 57650 */     GIR_EraseRootFromParent_Done,
     /* 57651 */   // Label 1587: @57651
     /* 57651 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(57676), // Rule ID 4565 //
     /* 57656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 57659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57663 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 57663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 57666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57668 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 57670 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 57672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 57674 */     GIR_RootConstrainSelectedInstOperands,
     /* 57675 */     // GIR_Coverage, 4565,
     /* 57675 */     GIR_EraseRootFromParent_Done,
     /* 57676 */   // Label 1588: @57676
     /* 57676 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(57857), // Rule ID 20237 //
     /* 57681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57688 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57688 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 57691 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57695 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 57702 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 57705 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57709 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57714 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 57717 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57721 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 57724 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57729 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57734 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57739 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 57742 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57746 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57751 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57755 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57760 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57763 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57767 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 57774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 57777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57786 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 57789 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 57793 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 57796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57801 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 57818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 57826 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 57829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 57832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 57839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 57846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57856 */     // GIR_Coverage, 20237,
     /* 57856 */     GIR_EraseRootFromParent_Done,
     /* 57857 */   // Label 1589: @57857
     /* 57857 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(58038), // Rule ID 20241 //
     /* 57862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 57865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 57869 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 57869 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 57872 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57876 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 57883 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 57886 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57890 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57895 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 57898 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 57902 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 57905 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57910 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57915 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57920 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 57923 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 57927 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57932 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 57936 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 57941 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 57944 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 57948 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 57955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 57958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 57962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57967 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 57970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 57974 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 57977 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 57982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 57987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 57992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 57995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 57999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 58007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 58010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 58013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 58027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58037 */     // GIR_Coverage, 20241,
     /* 58037 */     GIR_EraseRootFromParent_Done,
     /* 58038 */   // Label 1590: @58038
     /* 58038 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(58063), // Rule ID 20301 //
     /* 58043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58050 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 58050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 58053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58055 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58057 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58061 */     GIR_RootConstrainSelectedInstOperands,
     /* 58062 */     // GIR_Coverage, 20301,
     /* 58062 */     GIR_EraseRootFromParent_Done,
     /* 58063 */   // Label 1591: @58063
     /* 58063 */   GIM_Reject,
     /* 58064 */ // Label 1583: @58064
     /* 58064 */ GIM_Reject,
     /* 58065 */ // Label 1520: @58065
     /* 58065 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(58405),
     /* 58070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 58073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 58076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 58079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58083 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(58152), // Rule ID 20214 //
     /* 58088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 58096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 58100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 58104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 58109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 58113 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 58121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 58125 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58131 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 58133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 58139 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 58139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 58142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 58148 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 58150 */     GIR_RootConstrainSelectedInstOperands,
     /* 58151 */     // GIR_Coverage, 20214,
     /* 58151 */     GIR_EraseRootFromParent_Done,
     /* 58152 */   // Label 1593: @58152
     /* 58152 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(58199), // Rule ID 3595 //
     /* 58157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 58160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 58168 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 58176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 58180 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58186 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 58188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 58190 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 58190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 58193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58195 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58197 */     GIR_RootConstrainSelectedInstOperands,
     /* 58198 */     // GIR_Coverage, 3595,
     /* 58198 */     GIR_EraseRootFromParent_Done,
     /* 58199 */   // Label 1594: @58199
     /* 58199 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(58256), // Rule ID 20212 //
     /* 58204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 58212 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58218 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58226 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 58226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 58229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 58233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 58242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 58247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58252 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 58254 */     GIR_RootConstrainSelectedInstOperands,
     /* 58255 */     // GIR_Coverage, 20212,
     /* 58255 */     GIR_EraseRootFromParent_Done,
     /* 58256 */   // Label 1595: @58256
     /* 58256 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(58297), // Rule ID 4458 //
     /* 58261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 58264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58276 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58282 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58286 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 58286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 58289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58291 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58295 */     GIR_RootConstrainSelectedInstOperands,
     /* 58296 */     // GIR_Coverage, 4458,
     /* 58296 */     GIR_EraseRootFromParent_Done,
     /* 58297 */   // Label 1596: @58297
     /* 58297 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(58338), // Rule ID 4518 //
     /* 58302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 58305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58317 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58323 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58327 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 58327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 58330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58332 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58336 */     GIR_RootConstrainSelectedInstOperands,
     /* 58337 */     // GIR_Coverage, 4518,
     /* 58337 */     GIR_EraseRootFromParent_Done,
     /* 58338 */   // Label 1597: @58338
     /* 58338 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(58371), // Rule ID 4460 //
     /* 58343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 58346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58358 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 58358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 58361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58365 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58369 */     GIR_RootConstrainSelectedInstOperands,
     /* 58370 */     // GIR_Coverage, 4460,
     /* 58370 */     GIR_EraseRootFromParent_Done,
     /* 58371 */   // Label 1598: @58371
     /* 58371 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(58404), // Rule ID 4519 //
     /* 58376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 58379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 58383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58391 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 58391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 58394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58396 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58398 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58402 */     GIR_RootConstrainSelectedInstOperands,
     /* 58403 */     // GIR_Coverage, 4519,
     /* 58403 */     GIR_EraseRootFromParent_Done,
     /* 58404 */   // Label 1599: @58404
     /* 58404 */   GIM_Reject,
     /* 58405 */ // Label 1592: @58405
     /* 58405 */ GIM_Reject,
     /* 58406 */ // Label 1521: @58406
     /* 58406 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(58809),
     /* 58411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 58414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 58417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 58420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 58428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58432 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(58465), // Rule ID 4552 //
     /* 58437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58454 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 58454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 58457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58459 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58463 */     GIR_RootConstrainSelectedInstOperands,
     /* 58464 */     // GIR_Coverage, 4552,
     /* 58464 */     GIR_EraseRootFromParent_Done,
     /* 58465 */   // Label 1601: @58465
     /* 58465 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(58602), // Rule ID 20234 //
     /* 58470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 58473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58483 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58487 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 58487 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 58490 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 58494 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 58501 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 58504 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 58508 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58513 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 58516 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 58520 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 58523 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 58528 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58533 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 58541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 58554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 58559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 58562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 58566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58571 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 58574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 58577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 58591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58601 */     // GIR_Coverage, 20234,
     /* 58601 */     GIR_EraseRootFromParent_Done,
     /* 58602 */   // Label 1602: @58602
     /* 58602 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(58627), // Rule ID 4553 //
     /* 58607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 58610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58614 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 58614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 58617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58619 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58621 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58625 */     GIR_RootConstrainSelectedInstOperands,
     /* 58626 */     // GIR_Coverage, 4553,
     /* 58626 */     GIR_EraseRootFromParent_Done,
     /* 58627 */   // Label 1603: @58627
     /* 58627 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(58808), // Rule ID 20233 //
     /* 58632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 58635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 58639 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 58639 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 58642 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 58646 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 58653 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 58656 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 58660 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58665 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 58668 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 58672 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 58675 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 58680 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58685 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58690 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 58693 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58697 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58702 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 58706 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 58711 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 58714 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 58718 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 58725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 58728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 58732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58737 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 58740 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 58744 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 58747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 58752 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 58765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 58769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 58777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 58780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 58783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 58788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58790 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 58797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 58802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 58807 */     // GIR_Coverage, 20233,
     /* 58807 */     GIR_EraseRootFromParent_Done,
     /* 58808 */   // Label 1604: @58808
     /* 58808 */   GIM_Reject,
     /* 58809 */ // Label 1600: @58809
     /* 58809 */ GIM_Reject,
     /* 58810 */ // Label 1522: @58810
     /* 58810 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(58953),
     /* 58815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 58818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 58821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 58824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 58832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58836 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(58869), // Rule ID 4560 //
     /* 58841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58858 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 58858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 58861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58863 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 58867 */     GIR_RootConstrainSelectedInstOperands,
     /* 58868 */     // GIR_Coverage, 4560,
     /* 58868 */     GIR_EraseRootFromParent_Done,
     /* 58869 */   // Label 1606: @58869
     /* 58869 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(58902), // Rule ID 20292 //
     /* 58874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 58889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58891 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 58891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 58894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58896 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58900 */     GIR_RootConstrainSelectedInstOperands,
     /* 58901 */     // GIR_Coverage, 20292,
     /* 58901 */     GIR_EraseRootFromParent_Done,
     /* 58902 */   // Label 1607: @58902
     /* 58902 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(58927), // Rule ID 4561 //
     /* 58907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58914 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 58914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 58917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58919 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58921 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58925 */     GIR_RootConstrainSelectedInstOperands,
     /* 58926 */     // GIR_Coverage, 4561,
     /* 58926 */     GIR_EraseRootFromParent_Done,
     /* 58927 */   // Label 1608: @58927
     /* 58927 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(58952), // Rule ID 20291 //
     /* 58932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58939 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 58939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 58942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 58944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 58946 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 58948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 58950 */     GIR_RootConstrainSelectedInstOperands,
     /* 58951 */     // GIR_Coverage, 20291,
     /* 58951 */     GIR_EraseRootFromParent_Done,
     /* 58952 */   // Label 1609: @58952
     /* 58952 */   GIM_Reject,
     /* 58953 */ // Label 1605: @58953
     /* 58953 */ GIM_Reject,
     /* 58954 */ // Label 1523: @58954
     /* 58954 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(59039),
     /* 58959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 58962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 58965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 58968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 58976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 58980 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(59013), // Rule ID 4548 //
     /* 58985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 58988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 58992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 58998 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 59000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59002 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 59002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 59005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 59007 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 59009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 59011 */     GIR_RootConstrainSelectedInstOperands,
     /* 59012 */     // GIR_Coverage, 4548,
     /* 59012 */     GIR_EraseRootFromParent_Done,
     /* 59013 */   // Label 1611: @59013
     /* 59013 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(59038), // Rule ID 4549 //
     /* 59018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59025 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 59025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 59028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 59030 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 59032 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 59034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 59036 */     GIR_RootConstrainSelectedInstOperands,
     /* 59037 */     // GIR_Coverage, 4549,
     /* 59037 */     GIR_EraseRootFromParent_Done,
     /* 59038 */   // Label 1612: @59038
     /* 59038 */   GIM_Reject,
     /* 59039 */ // Label 1610: @59039
     /* 59039 */ GIM_Reject,
     /* 59040 */ // Label 1524: @59040
     /* 59040 */ GIM_Reject,
     /* 59041 */ // Label 28: @59041
     /* 59041 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 1616*/ GIMT_Encode4(59287),
     /* 59052 */ /*GILLT_v8s16*//*Label 1613*/ GIMT_Encode4(59092), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59072 */ /*GILLT_v16s16*//*Label 1614*/ GIMT_Encode4(59186), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59088 */ /*GILLT_v32s16*//*Label 1615*/ GIMT_Encode4(59253),
     /* 59092 */ // Label 1613: @59092
     /* 59092 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(59185),
     /* 59097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 59100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 59103 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(59130), // Rule ID 2573 //
     /* 59108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59123 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 59128 */     GIR_RootConstrainSelectedInstOperands,
     /* 59129 */     // GIR_Coverage, 2573,
     /* 59129 */     GIR_Done,
     /* 59130 */   // Label 1618: @59130
     /* 59130 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(59157), // Rule ID 2575 //
     /* 59135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59150 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 59155 */     GIR_RootConstrainSelectedInstOperands,
     /* 59156 */     // GIR_Coverage, 2575,
     /* 59156 */     GIR_Done,
     /* 59157 */   // Label 1619: @59157
     /* 59157 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(59184), // Rule ID 5056 //
     /* 59162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59177 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 59177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 59182 */     GIR_RootConstrainSelectedInstOperands,
     /* 59183 */     // GIR_Coverage, 5056,
     /* 59183 */     GIR_Done,
     /* 59184 */   // Label 1620: @59184
     /* 59184 */   GIM_Reject,
     /* 59185 */ // Label 1617: @59185
     /* 59185 */ GIM_Reject,
     /* 59186 */ // Label 1614: @59186
     /* 59186 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(59252),
     /* 59191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 59194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 59197 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(59224), // Rule ID 2577 //
     /* 59202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59217 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 59217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 59222 */     GIR_RootConstrainSelectedInstOperands,
     /* 59223 */     // GIR_Coverage, 2577,
     /* 59223 */     GIR_Done,
     /* 59224 */   // Label 1622: @59224
     /* 59224 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(59251), // Rule ID 5050 //
     /* 59229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59244 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 59244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 59249 */     GIR_RootConstrainSelectedInstOperands,
     /* 59250 */     // GIR_Coverage, 5050,
     /* 59250 */     GIR_Done,
     /* 59251 */   // Label 1623: @59251
     /* 59251 */   GIM_Reject,
     /* 59252 */ // Label 1621: @59252
     /* 59252 */ GIM_Reject,
     /* 59253 */ // Label 1615: @59253
     /* 59253 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(59286), // Rule ID 5044 //
     /* 59258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 59264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 59267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59279 */   // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 59279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 59284 */   GIR_RootConstrainSelectedInstOperands,
     /* 59285 */   // GIR_Coverage, 5044,
     /* 59285 */   GIR_Done,
     /* 59286 */ // Label 1624: @59286
     /* 59286 */ GIM_Reject,
     /* 59287 */ // Label 1616: @59287
     /* 59287 */ GIM_Reject,
     /* 59288 */ // Label 29: @59288
     /* 59288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 1628*/ GIMT_Encode4(59534),
     /* 59299 */ /*GILLT_v8s16*//*Label 1625*/ GIMT_Encode4(59339), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59319 */ /*GILLT_v16s16*//*Label 1626*/ GIMT_Encode4(59433), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59335 */ /*GILLT_v32s16*//*Label 1627*/ GIMT_Encode4(59500),
     /* 59339 */ // Label 1625: @59339
     /* 59339 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(59432),
     /* 59344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 59347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 59350 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(59377), // Rule ID 2579 //
     /* 59355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59370 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 59375 */     GIR_RootConstrainSelectedInstOperands,
     /* 59376 */     // GIR_Coverage, 2579,
     /* 59376 */     GIR_Done,
     /* 59377 */   // Label 1630: @59377
     /* 59377 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(59404), // Rule ID 2581 //
     /* 59382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59397 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 59402 */     GIR_RootConstrainSelectedInstOperands,
     /* 59403 */     // GIR_Coverage, 2581,
     /* 59403 */     GIR_Done,
     /* 59404 */   // Label 1631: @59404
     /* 59404 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(59431), // Rule ID 5038 //
     /* 59409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59424 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 59424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 59429 */     GIR_RootConstrainSelectedInstOperands,
     /* 59430 */     // GIR_Coverage, 5038,
     /* 59430 */     GIR_Done,
     /* 59431 */   // Label 1632: @59431
     /* 59431 */   GIM_Reject,
     /* 59432 */ // Label 1629: @59432
     /* 59432 */ GIM_Reject,
     /* 59433 */ // Label 1626: @59433
     /* 59433 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(59499),
     /* 59438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 59441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 59444 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(59471), // Rule ID 2583 //
     /* 59449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59464 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 59464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 59469 */     GIR_RootConstrainSelectedInstOperands,
     /* 59470 */     // GIR_Coverage, 2583,
     /* 59470 */     GIR_Done,
     /* 59471 */   // Label 1634: @59471
     /* 59471 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(59498), // Rule ID 5032 //
     /* 59476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59491 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 59491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 59496 */     GIR_RootConstrainSelectedInstOperands,
     /* 59497 */     // GIR_Coverage, 5032,
     /* 59497 */     GIR_Done,
     /* 59498 */   // Label 1635: @59498
     /* 59498 */   GIM_Reject,
     /* 59499 */ // Label 1633: @59499
     /* 59499 */ GIM_Reject,
     /* 59500 */ // Label 1627: @59500
     /* 59500 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(59533), // Rule ID 5026 //
     /* 59505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 59511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 59514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59526 */   // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 59526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 59531 */   GIR_RootConstrainSelectedInstOperands,
     /* 59532 */   // GIR_Coverage, 5026,
     /* 59532 */   GIR_Done,
     /* 59533 */ // Label 1636: @59533
     /* 59533 */ GIM_Reject,
     /* 59534 */ // Label 1628: @59534
     /* 59534 */ GIM_Reject,
     /* 59535 */ // Label 30: @59535
     /* 59535 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1643*/ GIMT_Encode4(59984),
     /* 59546 */ /*GILLT_v8s16*//*Label 1637*/ GIMT_Encode4(59594), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59562 */ /*GILLT_v16s8*//*Label 1638*/ GIMT_Encode4(59688),
     /* 59566 */ /*GILLT_v16s16*//*Label 1639*/ GIMT_Encode4(59782), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 59578 */ /*GILLT_v32s8*//*Label 1640*/ GIMT_Encode4(59849),
     /* 59582 */ /*GILLT_v32s16*//*Label 1641*/ GIMT_Encode4(59916), GIMT_Encode4(0),
     /* 59590 */ /*GILLT_v64s8*//*Label 1642*/ GIMT_Encode4(59950),
     /* 59594 */ // Label 1637: @59594
     /* 59594 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(59687),
     /* 59599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 59602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 59605 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(59632), // Rule ID 2561 //
     /* 59610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59625 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 59630 */     GIR_RootConstrainSelectedInstOperands,
     /* 59631 */     // GIR_Coverage, 2561,
     /* 59631 */     GIR_Done,
     /* 59632 */   // Label 1645: @59632
     /* 59632 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(59659), // Rule ID 2563 //
     /* 59637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59652 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 59652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 59657 */     GIR_RootConstrainSelectedInstOperands,
     /* 59658 */     // GIR_Coverage, 2563,
     /* 59658 */     GIR_Done,
     /* 59659 */   // Label 1646: @59659
     /* 59659 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(59686), // Rule ID 4894 //
     /* 59664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59679 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 59679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 59684 */     GIR_RootConstrainSelectedInstOperands,
     /* 59685 */     // GIR_Coverage, 4894,
     /* 59685 */     GIR_Done,
     /* 59686 */   // Label 1647: @59686
     /* 59686 */   GIM_Reject,
     /* 59687 */ // Label 1644: @59687
     /* 59687 */ GIM_Reject,
     /* 59688 */ // Label 1638: @59688
     /* 59688 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(59781),
     /* 59693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 59696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 59699 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(59726), // Rule ID 2555 //
     /* 59704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 59707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59719 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 59719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 59724 */     GIR_RootConstrainSelectedInstOperands,
     /* 59725 */     // GIR_Coverage, 2555,
     /* 59725 */     GIR_Done,
     /* 59726 */   // Label 1649: @59726
     /* 59726 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(59753), // Rule ID 2557 //
     /* 59731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 59734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 59746 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 59746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 59751 */     GIR_RootConstrainSelectedInstOperands,
     /* 59752 */     // GIR_Coverage, 2557,
     /* 59752 */     GIR_Done,
     /* 59753 */   // Label 1650: @59753
     /* 59753 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(59780), // Rule ID 4912 //
     /* 59758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 59773 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 59773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 59778 */     GIR_RootConstrainSelectedInstOperands,
     /* 59779 */     // GIR_Coverage, 4912,
     /* 59779 */     GIR_Done,
     /* 59780 */   // Label 1651: @59780
     /* 59780 */   GIM_Reject,
     /* 59781 */ // Label 1648: @59781
     /* 59781 */ GIM_Reject,
     /* 59782 */ // Label 1639: @59782
     /* 59782 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(59848),
     /* 59787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 59790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 59793 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(59820), // Rule ID 2565 //
     /* 59798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59813 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 59813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 59818 */     GIR_RootConstrainSelectedInstOperands,
     /* 59819 */     // GIR_Coverage, 2565,
     /* 59819 */     GIR_Done,
     /* 59820 */   // Label 1653: @59820
     /* 59820 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(59847), // Rule ID 4888 //
     /* 59825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59840 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 59840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 59845 */     GIR_RootConstrainSelectedInstOperands,
     /* 59846 */     // GIR_Coverage, 4888,
     /* 59846 */     GIR_Done,
     /* 59847 */   // Label 1654: @59847
     /* 59847 */   GIM_Reject,
     /* 59848 */ // Label 1652: @59848
     /* 59848 */ GIM_Reject,
     /* 59849 */ // Label 1640: @59849
     /* 59849 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(59915),
     /* 59854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 59857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 59860 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(59887), // Rule ID 2559 //
     /* 59865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 59868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 59880 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 59880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 59885 */     GIR_RootConstrainSelectedInstOperands,
     /* 59886 */     // GIR_Coverage, 2559,
     /* 59886 */     GIR_Done,
     /* 59887 */   // Label 1656: @59887
     /* 59887 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(59914), // Rule ID 4906 //
     /* 59892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 59895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 59907 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 59907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 59912 */     GIR_RootConstrainSelectedInstOperands,
     /* 59913 */     // GIR_Coverage, 4906,
     /* 59913 */     GIR_Done,
     /* 59914 */   // Label 1657: @59914
     /* 59914 */   GIM_Reject,
     /* 59915 */ // Label 1655: @59915
     /* 59915 */ GIM_Reject,
     /* 59916 */ // Label 1641: @59916
     /* 59916 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(59949), // Rule ID 4882 //
     /* 59921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 59927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 59930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59942 */   // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 59942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 59947 */   GIR_RootConstrainSelectedInstOperands,
     /* 59948 */   // GIR_Coverage, 4882,
     /* 59948 */   GIR_Done,
     /* 59949 */ // Label 1658: @59949
     /* 59949 */ GIM_Reject,
     /* 59950 */ // Label 1642: @59950
     /* 59950 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(59983), // Rule ID 4900 //
     /* 59955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 59958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 59961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 59964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 59976 */   // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 59976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 59981 */   GIR_RootConstrainSelectedInstOperands,
     /* 59982 */   // GIR_Coverage, 4900,
     /* 59982 */   GIR_Done,
     /* 59983 */ // Label 1659: @59983
     /* 59983 */ GIM_Reject,
     /* 59984 */ // Label 1643: @59984
     /* 59984 */ GIM_Reject,
     /* 59985 */ // Label 31: @59985
     /* 59985 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1666*/ GIMT_Encode4(60434),
     /* 59996 */ /*GILLT_v8s16*//*Label 1660*/ GIMT_Encode4(60044), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60012 */ /*GILLT_v16s8*//*Label 1661*/ GIMT_Encode4(60138),
     /* 60016 */ /*GILLT_v16s16*//*Label 1662*/ GIMT_Encode4(60232), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60028 */ /*GILLT_v32s8*//*Label 1663*/ GIMT_Encode4(60299),
     /* 60032 */ /*GILLT_v32s16*//*Label 1664*/ GIMT_Encode4(60366), GIMT_Encode4(0),
     /* 60040 */ /*GILLT_v64s8*//*Label 1665*/ GIMT_Encode4(60400),
     /* 60044 */ // Label 1660: @60044
     /* 60044 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(60137),
     /* 60049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 60052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 60055 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(60082), // Rule ID 2549 //
     /* 60060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60075 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 60080 */     GIR_RootConstrainSelectedInstOperands,
     /* 60081 */     // GIR_Coverage, 2549,
     /* 60081 */     GIR_Done,
     /* 60082 */   // Label 1668: @60082
     /* 60082 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(60109), // Rule ID 2551 //
     /* 60087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60102 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 60107 */     GIR_RootConstrainSelectedInstOperands,
     /* 60108 */     // GIR_Coverage, 2551,
     /* 60108 */     GIR_Done,
     /* 60109 */   // Label 1669: @60109
     /* 60109 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(60136), // Rule ID 4822 //
     /* 60114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60129 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 60129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 60134 */     GIR_RootConstrainSelectedInstOperands,
     /* 60135 */     // GIR_Coverage, 4822,
     /* 60135 */     GIR_Done,
     /* 60136 */   // Label 1670: @60136
     /* 60136 */   GIM_Reject,
     /* 60137 */ // Label 1667: @60137
     /* 60137 */ GIM_Reject,
     /* 60138 */ // Label 1661: @60138
     /* 60138 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(60231),
     /* 60143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 60146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 60149 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(60176), // Rule ID 2543 //
     /* 60154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60169 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 60174 */     GIR_RootConstrainSelectedInstOperands,
     /* 60175 */     // GIR_Coverage, 2543,
     /* 60175 */     GIR_Done,
     /* 60176 */   // Label 1672: @60176
     /* 60176 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(60203), // Rule ID 2545 //
     /* 60181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60196 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 60201 */     GIR_RootConstrainSelectedInstOperands,
     /* 60202 */     // GIR_Coverage, 2545,
     /* 60202 */     GIR_Done,
     /* 60203 */   // Label 1673: @60203
     /* 60203 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(60230), // Rule ID 4840 //
     /* 60208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60223 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 60223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 60228 */     GIR_RootConstrainSelectedInstOperands,
     /* 60229 */     // GIR_Coverage, 4840,
     /* 60229 */     GIR_Done,
     /* 60230 */   // Label 1674: @60230
     /* 60230 */   GIM_Reject,
     /* 60231 */ // Label 1671: @60231
     /* 60231 */ GIM_Reject,
     /* 60232 */ // Label 1662: @60232
     /* 60232 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(60298),
     /* 60237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 60240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 60243 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(60270), // Rule ID 2553 //
     /* 60248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60263 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 60263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 60268 */     GIR_RootConstrainSelectedInstOperands,
     /* 60269 */     // GIR_Coverage, 2553,
     /* 60269 */     GIR_Done,
     /* 60270 */   // Label 1676: @60270
     /* 60270 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(60297), // Rule ID 4816 //
     /* 60275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60290 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 60290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 60295 */     GIR_RootConstrainSelectedInstOperands,
     /* 60296 */     // GIR_Coverage, 4816,
     /* 60296 */     GIR_Done,
     /* 60297 */   // Label 1677: @60297
     /* 60297 */   GIM_Reject,
     /* 60298 */ // Label 1675: @60298
     /* 60298 */ GIM_Reject,
     /* 60299 */ // Label 1663: @60299
     /* 60299 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(60365),
     /* 60304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 60307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 60310 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(60337), // Rule ID 2547 //
     /* 60315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60330 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 60330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 60335 */     GIR_RootConstrainSelectedInstOperands,
     /* 60336 */     // GIR_Coverage, 2547,
     /* 60336 */     GIR_Done,
     /* 60337 */   // Label 1679: @60337
     /* 60337 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(60364), // Rule ID 4834 //
     /* 60342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60357 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 60357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 60362 */     GIR_RootConstrainSelectedInstOperands,
     /* 60363 */     // GIR_Coverage, 4834,
     /* 60363 */     GIR_Done,
     /* 60364 */   // Label 1680: @60364
     /* 60364 */   GIM_Reject,
     /* 60365 */ // Label 1678: @60365
     /* 60365 */ GIM_Reject,
     /* 60366 */ // Label 1664: @60366
     /* 60366 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(60399), // Rule ID 4810 //
     /* 60371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 60377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 60380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60392 */   // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 60392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 60397 */   GIR_RootConstrainSelectedInstOperands,
     /* 60398 */   // GIR_Coverage, 4810,
     /* 60398 */   GIR_Done,
     /* 60399 */ // Label 1681: @60399
     /* 60399 */ GIM_Reject,
     /* 60400 */ // Label 1665: @60400
     /* 60400 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(60433), // Rule ID 4828 //
     /* 60405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 60411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 60414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60426 */   // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 60426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 60431 */   GIR_RootConstrainSelectedInstOperands,
     /* 60432 */   // GIR_Coverage, 4828,
     /* 60432 */   GIR_Done,
     /* 60433 */ // Label 1682: @60433
     /* 60433 */ GIM_Reject,
     /* 60434 */ // Label 1666: @60434
     /* 60434 */ GIM_Reject,
     /* 60435 */ // Label 32: @60435
     /* 60435 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1689*/ GIMT_Encode4(60884),
     /* 60446 */ /*GILLT_v8s16*//*Label 1683*/ GIMT_Encode4(60494), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60462 */ /*GILLT_v16s8*//*Label 1684*/ GIMT_Encode4(60588),
     /* 60466 */ /*GILLT_v16s16*//*Label 1685*/ GIMT_Encode4(60682), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60478 */ /*GILLT_v32s8*//*Label 1686*/ GIMT_Encode4(60749),
     /* 60482 */ /*GILLT_v32s16*//*Label 1687*/ GIMT_Encode4(60816), GIMT_Encode4(0),
     /* 60490 */ /*GILLT_v64s8*//*Label 1688*/ GIMT_Encode4(60850),
     /* 60494 */ // Label 1683: @60494
     /* 60494 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(60587),
     /* 60499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 60502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 60505 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(60532), // Rule ID 2627 //
     /* 60510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60525 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 60530 */     GIR_RootConstrainSelectedInstOperands,
     /* 60531 */     // GIR_Coverage, 2627,
     /* 60531 */     GIR_Done,
     /* 60532 */   // Label 1691: @60532
     /* 60532 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(60559), // Rule ID 2629 //
     /* 60537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60552 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 60557 */     GIR_RootConstrainSelectedInstOperands,
     /* 60558 */     // GIR_Coverage, 2629,
     /* 60558 */     GIR_Done,
     /* 60559 */   // Label 1692: @60559
     /* 60559 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(60586), // Rule ID 4930 //
     /* 60564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60579 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 60579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 60584 */     GIR_RootConstrainSelectedInstOperands,
     /* 60585 */     // GIR_Coverage, 4930,
     /* 60585 */     GIR_Done,
     /* 60586 */   // Label 1693: @60586
     /* 60586 */   GIM_Reject,
     /* 60587 */ // Label 1690: @60587
     /* 60587 */ GIM_Reject,
     /* 60588 */ // Label 1684: @60588
     /* 60588 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(60681),
     /* 60593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 60596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 60599 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(60626), // Rule ID 2621 //
     /* 60604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60619 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 60624 */     GIR_RootConstrainSelectedInstOperands,
     /* 60625 */     // GIR_Coverage, 2621,
     /* 60625 */     GIR_Done,
     /* 60626 */   // Label 1695: @60626
     /* 60626 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(60653), // Rule ID 2623 //
     /* 60631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60646 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 60646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 60651 */     GIR_RootConstrainSelectedInstOperands,
     /* 60652 */     // GIR_Coverage, 2623,
     /* 60652 */     GIR_Done,
     /* 60653 */   // Label 1696: @60653
     /* 60653 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(60680), // Rule ID 4948 //
     /* 60658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 60673 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 60673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 60678 */     GIR_RootConstrainSelectedInstOperands,
     /* 60679 */     // GIR_Coverage, 4948,
     /* 60679 */     GIR_Done,
     /* 60680 */   // Label 1697: @60680
     /* 60680 */   GIM_Reject,
     /* 60681 */ // Label 1694: @60681
     /* 60681 */ GIM_Reject,
     /* 60682 */ // Label 1685: @60682
     /* 60682 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(60748),
     /* 60687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 60690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 60693 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(60720), // Rule ID 2631 //
     /* 60698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60713 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 60713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 60718 */     GIR_RootConstrainSelectedInstOperands,
     /* 60719 */     // GIR_Coverage, 2631,
     /* 60719 */     GIR_Done,
     /* 60720 */   // Label 1699: @60720
     /* 60720 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(60747), // Rule ID 4924 //
     /* 60725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60740 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 60740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 60745 */     GIR_RootConstrainSelectedInstOperands,
     /* 60746 */     // GIR_Coverage, 4924,
     /* 60746 */     GIR_Done,
     /* 60747 */   // Label 1700: @60747
     /* 60747 */   GIM_Reject,
     /* 60748 */ // Label 1698: @60748
     /* 60748 */ GIM_Reject,
     /* 60749 */ // Label 1686: @60749
     /* 60749 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(60815),
     /* 60754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 60757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 60760 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(60787), // Rule ID 2625 //
     /* 60765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 60768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 60780 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 60780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 60785 */     GIR_RootConstrainSelectedInstOperands,
     /* 60786 */     // GIR_Coverage, 2625,
     /* 60786 */     GIR_Done,
     /* 60787 */   // Label 1702: @60787
     /* 60787 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(60814), // Rule ID 4942 //
     /* 60792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 60795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 60807 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 60807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 60812 */     GIR_RootConstrainSelectedInstOperands,
     /* 60813 */     // GIR_Coverage, 4942,
     /* 60813 */     GIR_Done,
     /* 60814 */   // Label 1703: @60814
     /* 60814 */   GIM_Reject,
     /* 60815 */ // Label 1701: @60815
     /* 60815 */ GIM_Reject,
     /* 60816 */ // Label 1687: @60816
     /* 60816 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(60849), // Rule ID 4918 //
     /* 60821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 60827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 60830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60842 */   // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 60842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 60847 */   GIR_RootConstrainSelectedInstOperands,
     /* 60848 */   // GIR_Coverage, 4918,
     /* 60848 */   GIR_Done,
     /* 60849 */ // Label 1704: @60849
     /* 60849 */ GIM_Reject,
     /* 60850 */ // Label 1688: @60850
     /* 60850 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(60883), // Rule ID 4936 //
     /* 60855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 60858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 60861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 60864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 60876 */   // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 60876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 60881 */   GIR_RootConstrainSelectedInstOperands,
     /* 60882 */   // GIR_Coverage, 4936,
     /* 60882 */   GIR_Done,
     /* 60883 */ // Label 1705: @60883
     /* 60883 */ GIM_Reject,
     /* 60884 */ // Label 1689: @60884
     /* 60884 */ GIM_Reject,
     /* 60885 */ // Label 33: @60885
     /* 60885 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 1712*/ GIMT_Encode4(61334),
     /* 60896 */ /*GILLT_v8s16*//*Label 1706*/ GIMT_Encode4(60944), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60912 */ /*GILLT_v16s8*//*Label 1707*/ GIMT_Encode4(61038),
     /* 60916 */ /*GILLT_v16s16*//*Label 1708*/ GIMT_Encode4(61132), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 60928 */ /*GILLT_v32s8*//*Label 1709*/ GIMT_Encode4(61199),
     /* 60932 */ /*GILLT_v32s16*//*Label 1710*/ GIMT_Encode4(61266), GIMT_Encode4(0),
     /* 60940 */ /*GILLT_v64s8*//*Label 1711*/ GIMT_Encode4(61300),
     /* 60944 */ // Label 1706: @60944
     /* 60944 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(61037),
     /* 60949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 60952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 60955 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(60982), // Rule ID 2615 //
     /* 60960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 60963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60975 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 60975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 60980 */     GIR_RootConstrainSelectedInstOperands,
     /* 60981 */     // GIR_Coverage, 2615,
     /* 60981 */     GIR_Done,
     /* 60982 */   // Label 1714: @60982
     /* 60982 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(61009), // Rule ID 2617 //
     /* 60987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 60990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 60998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61002 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 61002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 61007 */     GIR_RootConstrainSelectedInstOperands,
     /* 61008 */     // GIR_Coverage, 2617,
     /* 61008 */     GIR_Done,
     /* 61009 */   // Label 1715: @61009
     /* 61009 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(61036), // Rule ID 4858 //
     /* 61014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 61017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61029 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 61029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 61034 */     GIR_RootConstrainSelectedInstOperands,
     /* 61035 */     // GIR_Coverage, 4858,
     /* 61035 */     GIR_Done,
     /* 61036 */   // Label 1716: @61036
     /* 61036 */   GIM_Reject,
     /* 61037 */ // Label 1713: @61037
     /* 61037 */ GIM_Reject,
     /* 61038 */ // Label 1707: @61038
     /* 61038 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(61131),
     /* 61043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 61046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 61049 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(61076), // Rule ID 2609 //
     /* 61054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 61057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61069 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 61069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 61074 */     GIR_RootConstrainSelectedInstOperands,
     /* 61075 */     // GIR_Coverage, 2609,
     /* 61075 */     GIR_Done,
     /* 61076 */   // Label 1718: @61076
     /* 61076 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(61103), // Rule ID 2611 //
     /* 61081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 61084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61096 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 61096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 61101 */     GIR_RootConstrainSelectedInstOperands,
     /* 61102 */     // GIR_Coverage, 2611,
     /* 61102 */     GIR_Done,
     /* 61103 */   // Label 1719: @61103
     /* 61103 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(61130), // Rule ID 4876 //
     /* 61108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 61111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61123 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 61123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 61128 */     GIR_RootConstrainSelectedInstOperands,
     /* 61129 */     // GIR_Coverage, 4876,
     /* 61129 */     GIR_Done,
     /* 61130 */   // Label 1720: @61130
     /* 61130 */   GIM_Reject,
     /* 61131 */ // Label 1717: @61131
     /* 61131 */ GIM_Reject,
     /* 61132 */ // Label 1708: @61132
     /* 61132 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(61198),
     /* 61137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 61140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 61143 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(61170), // Rule ID 2619 //
     /* 61148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 61151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61163 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 61163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 61168 */     GIR_RootConstrainSelectedInstOperands,
     /* 61169 */     // GIR_Coverage, 2619,
     /* 61169 */     GIR_Done,
     /* 61170 */   // Label 1722: @61170
     /* 61170 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(61197), // Rule ID 4852 //
     /* 61175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 61178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61190 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 61190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 61195 */     GIR_RootConstrainSelectedInstOperands,
     /* 61196 */     // GIR_Coverage, 4852,
     /* 61196 */     GIR_Done,
     /* 61197 */   // Label 1723: @61197
     /* 61197 */   GIM_Reject,
     /* 61198 */ // Label 1721: @61198
     /* 61198 */ GIM_Reject,
     /* 61199 */ // Label 1709: @61199
     /* 61199 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(61265),
     /* 61204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 61207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 61210 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(61237), // Rule ID 2613 //
     /* 61215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 61218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 61230 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 61230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 61235 */     GIR_RootConstrainSelectedInstOperands,
     /* 61236 */     // GIR_Coverage, 2613,
     /* 61236 */     GIR_Done,
     /* 61237 */   // Label 1725: @61237
     /* 61237 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(61264), // Rule ID 4870 //
     /* 61242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 61245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 61257 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 61257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 61262 */     GIR_RootConstrainSelectedInstOperands,
     /* 61263 */     // GIR_Coverage, 4870,
     /* 61263 */     GIR_Done,
     /* 61264 */   // Label 1726: @61264
     /* 61264 */   GIM_Reject,
     /* 61265 */ // Label 1724: @61265
     /* 61265 */ GIM_Reject,
     /* 61266 */ // Label 1710: @61266
     /* 61266 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(61299), // Rule ID 4846 //
     /* 61271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 61274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 61277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 61280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61292 */   // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 61292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 61297 */   GIR_RootConstrainSelectedInstOperands,
     /* 61298 */   // GIR_Coverage, 4846,
     /* 61298 */   GIR_Done,
     /* 61299 */ // Label 1727: @61299
     /* 61299 */ GIM_Reject,
     /* 61300 */ // Label 1711: @61300
     /* 61300 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(61333), // Rule ID 4864 //
     /* 61305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 61308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 61311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 61314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 61326 */   // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 61326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 61331 */   GIR_RootConstrainSelectedInstOperands,
     /* 61332 */   // GIR_Coverage, 4864,
     /* 61332 */   GIR_Done,
     /* 61333 */ // Label 1728: @61333
     /* 61333 */ GIM_Reject,
     /* 61334 */ // Label 1712: @61334
     /* 61334 */ GIM_Reject,
     /* 61335 */ // Label 34: @61335
     /* 61335 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1742*/ GIMT_Encode4(62350),
     /* 61346 */ /*GILLT_s16*//*Label 1729*/ GIMT_Encode4(61430),
     /* 61350 */ /*GILLT_s32*//*Label 1730*/ GIMT_Encode4(61468),
     /* 61354 */ /*GILLT_s64*//*Label 1731*/ GIMT_Encode4(61611),
     /* 61358 */ /*GILLT_s80*//*Label 1732*/ GIMT_Encode4(61754), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 61370 */ /*GILLT_v2s64*//*Label 1733*/ GIMT_Encode4(61798), GIMT_Encode4(0),
     /* 61378 */ /*GILLT_v4s32*//*Label 1734*/ GIMT_Encode4(61904),
     /* 61382 */ /*GILLT_v4s64*//*Label 1735*/ GIMT_Encode4(62010), GIMT_Encode4(0),
     /* 61390 */ /*GILLT_v8s16*//*Label 1736*/ GIMT_Encode4(62085),
     /* 61394 */ /*GILLT_v8s32*//*Label 1737*/ GIMT_Encode4(62123),
     /* 61398 */ /*GILLT_v8s64*//*Label 1738*/ GIMT_Encode4(62198), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 61410 */ /*GILLT_v16s16*//*Label 1739*/ GIMT_Encode4(62236),
     /* 61414 */ /*GILLT_v16s32*//*Label 1740*/ GIMT_Encode4(62274), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 61426 */ /*GILLT_v32s16*//*Label 1741*/ GIMT_Encode4(62312),
     /* 61430 */ // Label 1729: @61430
     /* 61430 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(61467), // Rule ID 5950 //
     /* 61435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 61438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 61441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 61444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 61448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 61452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 61456 */   // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 61456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 61461 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61465 */   GIR_RootConstrainSelectedInstOperands,
     /* 61466 */   // GIR_Coverage, 5950,
     /* 61466 */   GIR_Done,
     /* 61467 */ // Label 1743: @61467
     /* 61467 */ GIM_Reject,
     /* 61468 */ // Label 1730: @61468
     /* 61468 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(61610),
     /* 61473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61479 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(61516), // Rule ID 884 //
     /* 61484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 61487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 61491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 61495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 61499 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 61499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 61504 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 61510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 61514 */     GIR_RootConstrainSelectedInstOperands,
     /* 61515 */     // GIR_Coverage, 884,
     /* 61515 */     GIR_Done,
     /* 61516 */   // Label 1745: @61516
     /* 61516 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(61547), // Rule ID 2156 //
     /* 61521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 61524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61536 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 61536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 61541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61545 */     GIR_RootConstrainSelectedInstOperands,
     /* 61546 */     // GIR_Coverage, 2156,
     /* 61546 */     GIR_Done,
     /* 61547 */   // Label 1746: @61547
     /* 61547 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(61578), // Rule ID 2164 //
     /* 61552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 61555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 61567 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 61567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 61572 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61576 */     GIR_RootConstrainSelectedInstOperands,
     /* 61577 */     // GIR_Coverage, 2164,
     /* 61577 */     GIR_Done,
     /* 61578 */   // Label 1747: @61578
     /* 61578 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(61609), // Rule ID 5912 //
     /* 61583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 61586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 61590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 61594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 61598 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 61598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 61603 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61607 */     GIR_RootConstrainSelectedInstOperands,
     /* 61608 */     // GIR_Coverage, 5912,
     /* 61608 */     GIR_Done,
     /* 61609 */   // Label 1748: @61609
     /* 61609 */   GIM_Reject,
     /* 61610 */ // Label 1744: @61610
     /* 61610 */ GIM_Reject,
     /* 61611 */ // Label 1731: @61611
     /* 61611 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(61753),
     /* 61616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61622 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(61659), // Rule ID 886 //
     /* 61627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 61630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 61634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 61638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 61642 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 61642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 61647 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 61653 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 61657 */     GIR_RootConstrainSelectedInstOperands,
     /* 61658 */     // GIR_Coverage, 886,
     /* 61658 */     GIR_Done,
     /* 61659 */   // Label 1750: @61659
     /* 61659 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(61690), // Rule ID 2160 //
     /* 61664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 61667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61679 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 61679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 61684 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61688 */     GIR_RootConstrainSelectedInstOperands,
     /* 61689 */     // GIR_Coverage, 2160,
     /* 61689 */     GIR_Done,
     /* 61690 */   // Label 1751: @61690
     /* 61690 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(61721), // Rule ID 2168 //
     /* 61695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 61698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 61710 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 61710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 61715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61719 */     GIR_RootConstrainSelectedInstOperands,
     /* 61720 */     // GIR_Coverage, 2168,
     /* 61720 */     GIR_Done,
     /* 61721 */   // Label 1752: @61721
     /* 61721 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(61752), // Rule ID 5931 //
     /* 61726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 61729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 61733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 61737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 61741 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 61741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 61746 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61750 */     GIR_RootConstrainSelectedInstOperands,
     /* 61751 */     // GIR_Coverage, 5931,
     /* 61751 */     GIR_Done,
     /* 61752 */   // Label 1753: @61752
     /* 61752 */   GIM_Reject,
     /* 61753 */ // Label 1749: @61753
     /* 61753 */ GIM_Reject,
     /* 61754 */ // Label 1732: @61754
     /* 61754 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(61797), // Rule ID 888 //
     /* 61759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 61762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 61765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 61768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 61772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 61776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 61780 */   // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 61780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 61785 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 61791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 61795 */   GIR_RootConstrainSelectedInstOperands,
     /* 61796 */   // GIR_Coverage, 888,
     /* 61796 */   GIR_Done,
     /* 61797 */ // Label 1754: @61797
     /* 61797 */ GIM_Reject,
     /* 61798 */ // Label 1733: @61798
     /* 61798 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(61903),
     /* 61803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 61806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 61809 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(61840), // Rule ID 2136 //
     /* 61814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 61817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61829 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 61829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 61834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61838 */     GIR_RootConstrainSelectedInstOperands,
     /* 61839 */     // GIR_Coverage, 2136,
     /* 61839 */     GIR_Done,
     /* 61840 */   // Label 1756: @61840
     /* 61840 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(61871), // Rule ID 2152 //
     /* 61845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 61848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61860 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 61860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 61865 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61869 */     GIR_RootConstrainSelectedInstOperands,
     /* 61870 */     // GIR_Coverage, 2152,
     /* 61870 */     GIR_Done,
     /* 61871 */   // Label 1757: @61871
     /* 61871 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(61902), // Rule ID 6302 //
     /* 61876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 61879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61891 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 61891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 61896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61900 */     GIR_RootConstrainSelectedInstOperands,
     /* 61901 */     // GIR_Coverage, 6302,
     /* 61901 */     GIR_Done,
     /* 61902 */   // Label 1758: @61902
     /* 61902 */   GIM_Reject,
     /* 61903 */ // Label 1755: @61903
     /* 61903 */ GIM_Reject,
     /* 61904 */ // Label 1734: @61904
     /* 61904 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(62009),
     /* 61909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 61912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 61915 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(61946), // Rule ID 2132 //
     /* 61920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 61923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61935 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 61935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 61940 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61944 */     GIR_RootConstrainSelectedInstOperands,
     /* 61945 */     // GIR_Coverage, 2132,
     /* 61945 */     GIR_Done,
     /* 61946 */   // Label 1760: @61946
     /* 61946 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(61977), // Rule ID 2148 //
     /* 61951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 61954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 61966 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 61966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 61971 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 61975 */     GIR_RootConstrainSelectedInstOperands,
     /* 61976 */     // GIR_Coverage, 2148,
     /* 61976 */     GIR_Done,
     /* 61977 */   // Label 1761: @61977
     /* 61977 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(62008), // Rule ID 6278 //
     /* 61982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 61985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 61997 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 61997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 62002 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62006 */     GIR_RootConstrainSelectedInstOperands,
     /* 62007 */     // GIR_Coverage, 6278,
     /* 62007 */     GIR_Done,
     /* 62008 */   // Label 1762: @62008
     /* 62008 */   GIM_Reject,
     /* 62009 */ // Label 1759: @62009
     /* 62009 */ GIM_Reject,
     /* 62010 */ // Label 1735: @62010
     /* 62010 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(62084),
     /* 62015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 62018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 62021 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(62052), // Rule ID 2144 //
     /* 62026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62041 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 62041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 62046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62050 */     GIR_RootConstrainSelectedInstOperands,
     /* 62051 */     // GIR_Coverage, 2144,
     /* 62051 */     GIR_Done,
     /* 62052 */   // Label 1764: @62052
     /* 62052 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(62083), // Rule ID 6314 //
     /* 62057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62072 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 62072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 62077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62081 */     GIR_RootConstrainSelectedInstOperands,
     /* 62082 */     // GIR_Coverage, 6314,
     /* 62082 */     GIR_Done,
     /* 62083 */   // Label 1765: @62083
     /* 62083 */   GIM_Reject,
     /* 62084 */ // Label 1763: @62084
     /* 62084 */ GIM_Reject,
     /* 62085 */ // Label 1736: @62085
     /* 62085 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(62122), // Rule ID 6338 //
     /* 62090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 62093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 62096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 62099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62111 */   // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 62111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 62116 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62120 */   GIR_RootConstrainSelectedInstOperands,
     /* 62121 */   // GIR_Coverage, 6338,
     /* 62121 */   GIR_Done,
     /* 62122 */ // Label 1766: @62122
     /* 62122 */ GIM_Reject,
     /* 62123 */ // Label 1737: @62123
     /* 62123 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(62197),
     /* 62128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 62131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 62134 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(62165), // Rule ID 2140 //
     /* 62139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 62154 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 62154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 62159 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62163 */     GIR_RootConstrainSelectedInstOperands,
     /* 62164 */     // GIR_Coverage, 2140,
     /* 62164 */     GIR_Done,
     /* 62165 */   // Label 1768: @62165
     /* 62165 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(62196), // Rule ID 6290 //
     /* 62170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62185 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 62185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 62190 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62194 */     GIR_RootConstrainSelectedInstOperands,
     /* 62195 */     // GIR_Coverage, 6290,
     /* 62195 */     GIR_Done,
     /* 62196 */   // Label 1769: @62196
     /* 62196 */   GIM_Reject,
     /* 62197 */ // Label 1767: @62197
     /* 62197 */ GIM_Reject,
     /* 62198 */ // Label 1738: @62198
     /* 62198 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(62235), // Rule ID 6266 //
     /* 62203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 62209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 62212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62224 */   // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 62224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 62229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62233 */   GIR_RootConstrainSelectedInstOperands,
     /* 62234 */   // GIR_Coverage, 6266,
     /* 62234 */   GIR_Done,
     /* 62235 */ // Label 1770: @62235
     /* 62235 */ GIM_Reject,
     /* 62236 */ // Label 1739: @62236
     /* 62236 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(62273), // Rule ID 6350 //
     /* 62241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 62244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 62247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 62250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 62262 */   // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 62262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 62267 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62271 */   GIR_RootConstrainSelectedInstOperands,
     /* 62272 */   // GIR_Coverage, 6350,
     /* 62272 */   GIR_Done,
     /* 62273 */ // Label 1771: @62273
     /* 62273 */ GIM_Reject,
     /* 62274 */ // Label 1740: @62274
     /* 62274 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(62311), // Rule ID 6254 //
     /* 62279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 62285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 62288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62300 */   // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 62300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 62305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62309 */   GIR_RootConstrainSelectedInstOperands,
     /* 62310 */   // GIR_Coverage, 6254,
     /* 62310 */   GIR_Done,
     /* 62311 */ // Label 1772: @62311
     /* 62311 */ GIM_Reject,
     /* 62312 */ // Label 1741: @62312
     /* 62312 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(62349), // Rule ID 6326 //
     /* 62317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 62320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 62323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 62326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 62338 */   // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 62338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 62343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62347 */   GIR_RootConstrainSelectedInstOperands,
     /* 62348 */   // GIR_Coverage, 6326,
     /* 62348 */   GIR_Done,
     /* 62349 */ // Label 1773: @62349
     /* 62349 */ GIM_Reject,
     /* 62350 */ // Label 1742: @62350
     /* 62350 */ GIM_Reject,
     /* 62351 */ // Label 35: @62351
     /* 62351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1787*/ GIMT_Encode4(63366),
     /* 62362 */ /*GILLT_s16*//*Label 1774*/ GIMT_Encode4(62446),
     /* 62366 */ /*GILLT_s32*//*Label 1775*/ GIMT_Encode4(62484),
     /* 62370 */ /*GILLT_s64*//*Label 1776*/ GIMT_Encode4(62627),
     /* 62374 */ /*GILLT_s80*//*Label 1777*/ GIMT_Encode4(62770), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 62386 */ /*GILLT_v2s64*//*Label 1778*/ GIMT_Encode4(62814), GIMT_Encode4(0),
     /* 62394 */ /*GILLT_v4s32*//*Label 1779*/ GIMT_Encode4(62920),
     /* 62398 */ /*GILLT_v4s64*//*Label 1780*/ GIMT_Encode4(63026), GIMT_Encode4(0),
     /* 62406 */ /*GILLT_v8s16*//*Label 1781*/ GIMT_Encode4(63101),
     /* 62410 */ /*GILLT_v8s32*//*Label 1782*/ GIMT_Encode4(63139),
     /* 62414 */ /*GILLT_v8s64*//*Label 1783*/ GIMT_Encode4(63214), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 62426 */ /*GILLT_v16s16*//*Label 1784*/ GIMT_Encode4(63252),
     /* 62430 */ /*GILLT_v16s32*//*Label 1785*/ GIMT_Encode4(63290), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 62442 */ /*GILLT_v32s16*//*Label 1786*/ GIMT_Encode4(63328),
     /* 62446 */ // Label 1774: @62446
     /* 62446 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(62483), // Rule ID 6064 //
     /* 62451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 62454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 62457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 62460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 62464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 62468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 62472 */   // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 62472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 62477 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62481 */   GIR_RootConstrainSelectedInstOperands,
     /* 62482 */   // GIR_Coverage, 6064,
     /* 62482 */   GIR_Done,
     /* 62483 */ // Label 1788: @62483
     /* 62483 */ GIM_Reject,
     /* 62484 */ // Label 1775: @62484
     /* 62484 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(62626),
     /* 62489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 62492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 62495 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(62532), // Rule ID 890 //
     /* 62500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 62503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 62507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 62511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 62515 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 62515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 62520 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 62526 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 62530 */     GIR_RootConstrainSelectedInstOperands,
     /* 62531 */     // GIR_Coverage, 890,
     /* 62531 */     GIR_Done,
     /* 62532 */   // Label 1790: @62532
     /* 62532 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(62563), // Rule ID 2236 //
     /* 62537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 62540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62552 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 62552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 62557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62561 */     GIR_RootConstrainSelectedInstOperands,
     /* 62562 */     // GIR_Coverage, 2236,
     /* 62562 */     GIR_Done,
     /* 62563 */   // Label 1791: @62563
     /* 62563 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(62594), // Rule ID 2244 //
     /* 62568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 62571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 62583 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 62583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 62588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62592 */     GIR_RootConstrainSelectedInstOperands,
     /* 62593 */     // GIR_Coverage, 2244,
     /* 62593 */     GIR_Done,
     /* 62594 */   // Label 1792: @62594
     /* 62594 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(62625), // Rule ID 6026 //
     /* 62599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 62606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 62610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 62614 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 62614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 62619 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62623 */     GIR_RootConstrainSelectedInstOperands,
     /* 62624 */     // GIR_Coverage, 6026,
     /* 62624 */     GIR_Done,
     /* 62625 */   // Label 1793: @62625
     /* 62625 */   GIM_Reject,
     /* 62626 */ // Label 1789: @62626
     /* 62626 */ GIM_Reject,
     /* 62627 */ // Label 1776: @62627
     /* 62627 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(62769),
     /* 62632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62638 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(62675), // Rule ID 892 //
     /* 62643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 62646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 62650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 62654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 62658 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 62658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 62663 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 62669 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 62673 */     GIR_RootConstrainSelectedInstOperands,
     /* 62674 */     // GIR_Coverage, 892,
     /* 62674 */     GIR_Done,
     /* 62675 */   // Label 1795: @62675
     /* 62675 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(62706), // Rule ID 2240 //
     /* 62680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 62683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62695 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 62695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 62700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62704 */     GIR_RootConstrainSelectedInstOperands,
     /* 62705 */     // GIR_Coverage, 2240,
     /* 62705 */     GIR_Done,
     /* 62706 */   // Label 1796: @62706
     /* 62706 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(62737), // Rule ID 2248 //
     /* 62711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 62714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 62726 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 62726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 62731 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62735 */     GIR_RootConstrainSelectedInstOperands,
     /* 62736 */     // GIR_Coverage, 2248,
     /* 62736 */     GIR_Done,
     /* 62737 */   // Label 1797: @62737
     /* 62737 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(62768), // Rule ID 6045 //
     /* 62742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 62745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 62749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 62753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 62757 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 62757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 62762 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62766 */     GIR_RootConstrainSelectedInstOperands,
     /* 62767 */     // GIR_Coverage, 6045,
     /* 62767 */     GIR_Done,
     /* 62768 */   // Label 1798: @62768
     /* 62768 */   GIM_Reject,
     /* 62769 */ // Label 1794: @62769
     /* 62769 */ GIM_Reject,
     /* 62770 */ // Label 1777: @62770
     /* 62770 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(62813), // Rule ID 894 //
     /* 62775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 62778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 62781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 62784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 62788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 62792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 62796 */   // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 62796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 62801 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 62807 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 62811 */   GIR_RootConstrainSelectedInstOperands,
     /* 62812 */   // GIR_Coverage, 894,
     /* 62812 */   GIR_Done,
     /* 62813 */ // Label 1799: @62813
     /* 62813 */ GIM_Reject,
     /* 62814 */ // Label 1778: @62814
     /* 62814 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(62919),
     /* 62819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62825 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(62856), // Rule ID 2216 //
     /* 62830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62845 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 62845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 62850 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62854 */     GIR_RootConstrainSelectedInstOperands,
     /* 62855 */     // GIR_Coverage, 2216,
     /* 62855 */     GIR_Done,
     /* 62856 */   // Label 1801: @62856
     /* 62856 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(62887), // Rule ID 2232 //
     /* 62861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 62864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62876 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 62876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 62881 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62885 */     GIR_RootConstrainSelectedInstOperands,
     /* 62886 */     // GIR_Coverage, 2232,
     /* 62886 */     GIR_Done,
     /* 62887 */   // Label 1802: @62887
     /* 62887 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(62918), // Rule ID 6536 //
     /* 62892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 62895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 62907 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 62907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 62912 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62916 */     GIR_RootConstrainSelectedInstOperands,
     /* 62917 */     // GIR_Coverage, 6536,
     /* 62917 */     GIR_Done,
     /* 62918 */   // Label 1803: @62918
     /* 62918 */   GIM_Reject,
     /* 62919 */ // Label 1800: @62919
     /* 62919 */ GIM_Reject,
     /* 62920 */ // Label 1779: @62920
     /* 62920 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(63025),
     /* 62925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62931 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(62962), // Rule ID 2212 //
     /* 62936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 62939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62951 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 62951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 62956 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62960 */     GIR_RootConstrainSelectedInstOperands,
     /* 62961 */     // GIR_Coverage, 2212,
     /* 62961 */     GIR_Done,
     /* 62962 */   // Label 1805: @62962
     /* 62962 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(62993), // Rule ID 2228 //
     /* 62967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 62970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 62982 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 62982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 62987 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 62991 */     GIR_RootConstrainSelectedInstOperands,
     /* 62992 */     // GIR_Coverage, 2228,
     /* 62992 */     GIR_Done,
     /* 62993 */   // Label 1806: @62993
     /* 62993 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(63024), // Rule ID 6512 //
     /* 62998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63013 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 63013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 63018 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63022 */     GIR_RootConstrainSelectedInstOperands,
     /* 63023 */     // GIR_Coverage, 6512,
     /* 63023 */     GIR_Done,
     /* 63024 */   // Label 1807: @63024
     /* 63024 */   GIM_Reject,
     /* 63025 */ // Label 1804: @63025
     /* 63025 */ GIM_Reject,
     /* 63026 */ // Label 1780: @63026
     /* 63026 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(63100),
     /* 63031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 63034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 63037 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(63068), // Rule ID 2224 //
     /* 63042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63057 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 63057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 63062 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63066 */     GIR_RootConstrainSelectedInstOperands,
     /* 63067 */     // GIR_Coverage, 2224,
     /* 63067 */     GIR_Done,
     /* 63068 */   // Label 1809: @63068
     /* 63068 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(63099), // Rule ID 6548 //
     /* 63073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63088 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 63088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 63093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63097 */     GIR_RootConstrainSelectedInstOperands,
     /* 63098 */     // GIR_Coverage, 6548,
     /* 63098 */     GIR_Done,
     /* 63099 */   // Label 1810: @63099
     /* 63099 */   GIM_Reject,
     /* 63100 */ // Label 1808: @63100
     /* 63100 */ GIM_Reject,
     /* 63101 */ // Label 1781: @63101
     /* 63101 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(63138), // Rule ID 6572 //
     /* 63106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 63109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 63112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 63115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63127 */   // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 63127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 63132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63136 */   GIR_RootConstrainSelectedInstOperands,
     /* 63137 */   // GIR_Coverage, 6572,
     /* 63137 */   GIR_Done,
     /* 63138 */ // Label 1811: @63138
     /* 63138 */ GIM_Reject,
     /* 63139 */ // Label 1782: @63139
     /* 63139 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(63213),
     /* 63144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 63147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 63150 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(63181), // Rule ID 2220 //
     /* 63155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 63170 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 63170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 63175 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63179 */     GIR_RootConstrainSelectedInstOperands,
     /* 63180 */     // GIR_Coverage, 2220,
     /* 63180 */     GIR_Done,
     /* 63181 */   // Label 1813: @63181
     /* 63181 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(63212), // Rule ID 6524 //
     /* 63186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63201 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 63201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 63206 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63210 */     GIR_RootConstrainSelectedInstOperands,
     /* 63211 */     // GIR_Coverage, 6524,
     /* 63211 */     GIR_Done,
     /* 63212 */   // Label 1814: @63212
     /* 63212 */   GIM_Reject,
     /* 63213 */ // Label 1812: @63213
     /* 63213 */ GIM_Reject,
     /* 63214 */ // Label 1783: @63214
     /* 63214 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(63251), // Rule ID 6500 //
     /* 63219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 63225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 63228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63240 */   // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 63240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 63245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63249 */   GIR_RootConstrainSelectedInstOperands,
     /* 63250 */   // GIR_Coverage, 6500,
     /* 63250 */   GIR_Done,
     /* 63251 */ // Label 1815: @63251
     /* 63251 */ GIM_Reject,
     /* 63252 */ // Label 1784: @63252
     /* 63252 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(63289), // Rule ID 6584 //
     /* 63257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 63260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 63263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 63266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 63278 */   // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 63278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 63283 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63287 */   GIR_RootConstrainSelectedInstOperands,
     /* 63288 */   // GIR_Coverage, 6584,
     /* 63288 */   GIR_Done,
     /* 63289 */ // Label 1816: @63289
     /* 63289 */ GIM_Reject,
     /* 63290 */ // Label 1785: @63290
     /* 63290 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(63327), // Rule ID 6488 //
     /* 63295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 63301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 63304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63316 */   // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 63316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 63321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63325 */   GIR_RootConstrainSelectedInstOperands,
     /* 63326 */   // GIR_Coverage, 6488,
     /* 63326 */   GIR_Done,
     /* 63327 */ // Label 1817: @63327
     /* 63327 */ GIM_Reject,
     /* 63328 */ // Label 1786: @63328
     /* 63328 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(63365), // Rule ID 6560 //
     /* 63333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 63336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 63339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 63342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 63354 */   // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 63354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 63359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63363 */   GIR_RootConstrainSelectedInstOperands,
     /* 63364 */   // GIR_Coverage, 6560,
     /* 63364 */   GIR_Done,
     /* 63365 */ // Label 1818: @63365
     /* 63365 */ GIM_Reject,
     /* 63366 */ // Label 1787: @63366
     /* 63366 */ GIM_Reject,
     /* 63367 */ // Label 36: @63367
     /* 63367 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1832*/ GIMT_Encode4(64382),
     /* 63378 */ /*GILLT_s16*//*Label 1819*/ GIMT_Encode4(63462),
     /* 63382 */ /*GILLT_s32*//*Label 1820*/ GIMT_Encode4(63500),
     /* 63386 */ /*GILLT_s64*//*Label 1821*/ GIMT_Encode4(63643),
     /* 63390 */ /*GILLT_s80*//*Label 1822*/ GIMT_Encode4(63786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 63402 */ /*GILLT_v2s64*//*Label 1823*/ GIMT_Encode4(63830), GIMT_Encode4(0),
     /* 63410 */ /*GILLT_v4s32*//*Label 1824*/ GIMT_Encode4(63936),
     /* 63414 */ /*GILLT_v4s64*//*Label 1825*/ GIMT_Encode4(64042), GIMT_Encode4(0),
     /* 63422 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(64117),
     /* 63426 */ /*GILLT_v8s32*//*Label 1827*/ GIMT_Encode4(64155),
     /* 63430 */ /*GILLT_v8s64*//*Label 1828*/ GIMT_Encode4(64230), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 63442 */ /*GILLT_v16s16*//*Label 1829*/ GIMT_Encode4(64268),
     /* 63446 */ /*GILLT_v16s32*//*Label 1830*/ GIMT_Encode4(64306), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 63458 */ /*GILLT_v32s16*//*Label 1831*/ GIMT_Encode4(64344),
     /* 63462 */ // Label 1819: @63462
     /* 63462 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(63499), // Rule ID 6007 //
     /* 63467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 63470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 63473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 63476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 63480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 63484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 63488 */   // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 63488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 63493 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63497 */   GIR_RootConstrainSelectedInstOperands,
     /* 63498 */   // GIR_Coverage, 6007,
     /* 63498 */   GIR_Done,
     /* 63499 */ // Label 1833: @63499
     /* 63499 */ GIM_Reject,
     /* 63500 */ // Label 1820: @63500
     /* 63500 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(63642),
     /* 63505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63511 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(63548), // Rule ID 896 //
     /* 63516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 63519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 63523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 63527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 63531 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 63531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 63536 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 63542 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 63546 */     GIR_RootConstrainSelectedInstOperands,
     /* 63547 */     // GIR_Coverage, 896,
     /* 63547 */     GIR_Done,
     /* 63548 */   // Label 1835: @63548
     /* 63548 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(63579), // Rule ID 2196 //
     /* 63553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 63556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63568 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 63568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 63573 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63577 */     GIR_RootConstrainSelectedInstOperands,
     /* 63578 */     // GIR_Coverage, 2196,
     /* 63578 */     GIR_Done,
     /* 63579 */   // Label 1836: @63579
     /* 63579 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(63610), // Rule ID 2204 //
     /* 63584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 63587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 63599 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 63599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 63604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63608 */     GIR_RootConstrainSelectedInstOperands,
     /* 63609 */     // GIR_Coverage, 2204,
     /* 63609 */     GIR_Done,
     /* 63610 */   // Label 1837: @63610
     /* 63610 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(63641), // Rule ID 5969 //
     /* 63615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 63622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 63626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 63630 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 63630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 63635 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63639 */     GIR_RootConstrainSelectedInstOperands,
     /* 63640 */     // GIR_Coverage, 5969,
     /* 63640 */     GIR_Done,
     /* 63641 */   // Label 1838: @63641
     /* 63641 */   GIM_Reject,
     /* 63642 */ // Label 1834: @63642
     /* 63642 */ GIM_Reject,
     /* 63643 */ // Label 1821: @63643
     /* 63643 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(63785),
     /* 63648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63654 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(63691), // Rule ID 898 //
     /* 63659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 63662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 63666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 63670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 63674 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 63674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 63679 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 63685 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 63689 */     GIR_RootConstrainSelectedInstOperands,
     /* 63690 */     // GIR_Coverage, 898,
     /* 63690 */     GIR_Done,
     /* 63691 */   // Label 1840: @63691
     /* 63691 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(63722), // Rule ID 2200 //
     /* 63696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 63699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63711 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 63711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 63716 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63720 */     GIR_RootConstrainSelectedInstOperands,
     /* 63721 */     // GIR_Coverage, 2200,
     /* 63721 */     GIR_Done,
     /* 63722 */   // Label 1841: @63722
     /* 63722 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(63753), // Rule ID 2208 //
     /* 63727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 63730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 63742 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 63742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 63747 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63751 */     GIR_RootConstrainSelectedInstOperands,
     /* 63752 */     // GIR_Coverage, 2208,
     /* 63752 */     GIR_Done,
     /* 63753 */   // Label 1842: @63753
     /* 63753 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(63784), // Rule ID 5988 //
     /* 63758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 63761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 63765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 63769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 63773 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 63773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 63778 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63782 */     GIR_RootConstrainSelectedInstOperands,
     /* 63783 */     // GIR_Coverage, 5988,
     /* 63783 */     GIR_Done,
     /* 63784 */   // Label 1843: @63784
     /* 63784 */   GIM_Reject,
     /* 63785 */ // Label 1839: @63785
     /* 63785 */ GIM_Reject,
     /* 63786 */ // Label 1822: @63786
     /* 63786 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(63829), // Rule ID 900 //
     /* 63791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 63794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 63797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 63800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 63804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 63808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 63812 */   // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 63812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 63817 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 63823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 63827 */   GIR_RootConstrainSelectedInstOperands,
     /* 63828 */   // GIR_Coverage, 900,
     /* 63828 */   GIR_Done,
     /* 63829 */ // Label 1844: @63829
     /* 63829 */ GIM_Reject,
     /* 63830 */ // Label 1823: @63830
     /* 63830 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(63935),
     /* 63835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63841 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(63872), // Rule ID 2176 //
     /* 63846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63861 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 63861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 63866 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63870 */     GIR_RootConstrainSelectedInstOperands,
     /* 63871 */     // GIR_Coverage, 2176,
     /* 63871 */     GIR_Done,
     /* 63872 */   // Label 1846: @63872
     /* 63872 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(63903), // Rule ID 2192 //
     /* 63877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 63880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63892 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 63892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 63897 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63901 */     GIR_RootConstrainSelectedInstOperands,
     /* 63902 */     // GIR_Coverage, 2192,
     /* 63902 */     GIR_Done,
     /* 63903 */   // Label 1847: @63903
     /* 63903 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(63934), // Rule ID 6419 //
     /* 63908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 63911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 63923 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 63923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 63928 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63932 */     GIR_RootConstrainSelectedInstOperands,
     /* 63933 */     // GIR_Coverage, 6419,
     /* 63933 */     GIR_Done,
     /* 63934 */   // Label 1848: @63934
     /* 63934 */   GIM_Reject,
     /* 63935 */ // Label 1845: @63935
     /* 63935 */ GIM_Reject,
     /* 63936 */ // Label 1824: @63936
     /* 63936 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(64041),
     /* 63941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63947 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(63978), // Rule ID 2172 //
     /* 63952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 63955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63967 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 63967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 63972 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 63976 */     GIR_RootConstrainSelectedInstOperands,
     /* 63977 */     // GIR_Coverage, 2172,
     /* 63977 */     GIR_Done,
     /* 63978 */   // Label 1850: @63978
     /* 63978 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(64009), // Rule ID 2188 //
     /* 63983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 63986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 63998 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 63998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 64003 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64007 */     GIR_RootConstrainSelectedInstOperands,
     /* 64008 */     // GIR_Coverage, 2188,
     /* 64008 */     GIR_Done,
     /* 64009 */   // Label 1851: @64009
     /* 64009 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(64040), // Rule ID 6395 //
     /* 64014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64029 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 64029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 64034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64038 */     GIR_RootConstrainSelectedInstOperands,
     /* 64039 */     // GIR_Coverage, 6395,
     /* 64039 */     GIR_Done,
     /* 64040 */   // Label 1852: @64040
     /* 64040 */   GIM_Reject,
     /* 64041 */ // Label 1849: @64041
     /* 64041 */ GIM_Reject,
     /* 64042 */ // Label 1825: @64042
     /* 64042 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(64116),
     /* 64047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 64050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 64053 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(64084), // Rule ID 2184 //
     /* 64058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 64061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64073 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 64073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 64078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64082 */     GIR_RootConstrainSelectedInstOperands,
     /* 64083 */     // GIR_Coverage, 2184,
     /* 64083 */     GIR_Done,
     /* 64084 */   // Label 1854: @64084
     /* 64084 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(64115), // Rule ID 6431 //
     /* 64089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64104 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 64104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 64109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64113 */     GIR_RootConstrainSelectedInstOperands,
     /* 64114 */     // GIR_Coverage, 6431,
     /* 64114 */     GIR_Done,
     /* 64115 */   // Label 1855: @64115
     /* 64115 */   GIM_Reject,
     /* 64116 */ // Label 1853: @64116
     /* 64116 */ GIM_Reject,
     /* 64117 */ // Label 1826: @64117
     /* 64117 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(64154), // Rule ID 6455 //
     /* 64122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 64125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 64128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 64131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64143 */   // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 64143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 64148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64152 */   GIR_RootConstrainSelectedInstOperands,
     /* 64153 */   // GIR_Coverage, 6455,
     /* 64153 */   GIR_Done,
     /* 64154 */ // Label 1856: @64154
     /* 64154 */ GIM_Reject,
     /* 64155 */ // Label 1827: @64155
     /* 64155 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(64229),
     /* 64160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 64163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 64166 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(64197), // Rule ID 2180 //
     /* 64171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 64174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 64186 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 64186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 64191 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64195 */     GIR_RootConstrainSelectedInstOperands,
     /* 64196 */     // GIR_Coverage, 2180,
     /* 64196 */     GIR_Done,
     /* 64197 */   // Label 1858: @64197
     /* 64197 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(64228), // Rule ID 6407 //
     /* 64202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64217 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 64217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 64222 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64226 */     GIR_RootConstrainSelectedInstOperands,
     /* 64227 */     // GIR_Coverage, 6407,
     /* 64227 */     GIR_Done,
     /* 64228 */   // Label 1859: @64228
     /* 64228 */   GIM_Reject,
     /* 64229 */ // Label 1857: @64229
     /* 64229 */ GIM_Reject,
     /* 64230 */ // Label 1828: @64230
     /* 64230 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(64267), // Rule ID 6383 //
     /* 64235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 64241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 64244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64256 */   // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 64256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 64261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64265 */   GIR_RootConstrainSelectedInstOperands,
     /* 64266 */   // GIR_Coverage, 6383,
     /* 64266 */   GIR_Done,
     /* 64267 */ // Label 1860: @64267
     /* 64267 */ GIM_Reject,
     /* 64268 */ // Label 1829: @64268
     /* 64268 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(64305), // Rule ID 6467 //
     /* 64273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 64276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 64279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 64282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 64294 */   // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 64294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 64299 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64303 */   GIR_RootConstrainSelectedInstOperands,
     /* 64304 */   // GIR_Coverage, 6467,
     /* 64304 */   GIR_Done,
     /* 64305 */ // Label 1861: @64305
     /* 64305 */ GIM_Reject,
     /* 64306 */ // Label 1830: @64306
     /* 64306 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(64343), // Rule ID 6371 //
     /* 64311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 64317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 64320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64332 */   // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 64332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 64337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64341 */   GIR_RootConstrainSelectedInstOperands,
     /* 64342 */   // GIR_Coverage, 6371,
     /* 64342 */   GIR_Done,
     /* 64343 */ // Label 1862: @64343
     /* 64343 */ GIM_Reject,
     /* 64344 */ // Label 1831: @64344
     /* 64344 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(64381), // Rule ID 6443 //
     /* 64349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 64352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 64355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 64358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 64370 */   // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 64370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 64375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64379 */   GIR_RootConstrainSelectedInstOperands,
     /* 64380 */   // GIR_Coverage, 6443,
     /* 64380 */   GIR_Done,
     /* 64381 */ // Label 1863: @64381
     /* 64381 */ GIM_Reject,
     /* 64382 */ // Label 1832: @64382
     /* 64382 */ GIM_Reject,
     /* 64383 */ // Label 37: @64383
     /* 64383 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1876*/ GIMT_Encode4(65510),
     /* 64394 */ /*GILLT_s16*//*Label 1864*/ GIMT_Encode4(64478),
     /* 64398 */ /*GILLT_s32*//*Label 1865*/ GIMT_Encode4(64525),
     /* 64402 */ /*GILLT_s64*//*Label 1866*/ GIMT_Encode4(64650), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 64418 */ /*GILLT_v2s64*//*Label 1867*/ GIMT_Encode4(64775), GIMT_Encode4(0),
     /* 64426 */ /*GILLT_v4s32*//*Label 1868*/ GIMT_Encode4(64900),
     /* 64430 */ /*GILLT_v4s64*//*Label 1869*/ GIMT_Encode4(65025), GIMT_Encode4(0),
     /* 64438 */ /*GILLT_v8s16*//*Label 1870*/ GIMT_Encode4(65150),
     /* 64442 */ /*GILLT_v8s32*//*Label 1871*/ GIMT_Encode4(65197),
     /* 64446 */ /*GILLT_v8s64*//*Label 1872*/ GIMT_Encode4(65322), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 64458 */ /*GILLT_v16s16*//*Label 1873*/ GIMT_Encode4(65369),
     /* 64462 */ /*GILLT_v16s32*//*Label 1874*/ GIMT_Encode4(65416), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 64474 */ /*GILLT_v32s16*//*Label 1875*/ GIMT_Encode4(65463),
     /* 64478 */ // Label 1864: @64478
     /* 64478 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(64524), // Rule ID 10148 //
     /* 64483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 64486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 64489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 64492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 64495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 64511 */   // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 64511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 64514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64516 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64520 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64522 */   GIR_RootConstrainSelectedInstOperands,
     /* 64523 */   // GIR_Coverage, 10148,
     /* 64523 */   GIR_EraseRootFromParent_Done,
     /* 64524 */ // Label 1877: @64524
     /* 64524 */ GIM_Reject,
     /* 64525 */ // Label 1865: @64525
     /* 64525 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(64649),
     /* 64530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 64533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 64536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 64539 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(64576), // Rule ID 1295 //
     /* 64544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 64547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64563 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 64563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 64566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64572 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64574 */     GIR_RootConstrainSelectedInstOperands,
     /* 64575 */     // GIR_Coverage, 1295,
     /* 64575 */     GIR_EraseRootFromParent_Done,
     /* 64576 */   // Label 1879: @64576
     /* 64576 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(64611), // Rule ID 1359 //
     /* 64581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 64584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 64600 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 64600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 64605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64609 */     GIR_RootConstrainSelectedInstOperands,
     /* 64610 */     // GIR_Coverage, 1359,
     /* 64610 */     GIR_Done,
     /* 64611 */   // Label 1880: @64611
     /* 64611 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(64648), // Rule ID 10130 //
     /* 64616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 64635 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 64635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 64638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64640 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64644 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64646 */     GIR_RootConstrainSelectedInstOperands,
     /* 64647 */     // GIR_Coverage, 10130,
     /* 64647 */     GIR_EraseRootFromParent_Done,
     /* 64648 */   // Label 1881: @64648
     /* 64648 */   GIM_Reject,
     /* 64649 */ // Label 1878: @64649
     /* 64649 */ GIM_Reject,
     /* 64650 */ // Label 1866: @64650
     /* 64650 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(64774),
     /* 64655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 64661 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 64664 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(64701), // Rule ID 1303 //
     /* 64669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 64672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64688 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 64688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 64691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64697 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64699 */     GIR_RootConstrainSelectedInstOperands,
     /* 64700 */     // GIR_Coverage, 1303,
     /* 64700 */     GIR_EraseRootFromParent_Done,
     /* 64701 */   // Label 1883: @64701
     /* 64701 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(64736), // Rule ID 1443 //
     /* 64706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 64709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 64725 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 64725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 64730 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64734 */     GIR_RootConstrainSelectedInstOperands,
     /* 64735 */     // GIR_Coverage, 1443,
     /* 64735 */     GIR_Done,
     /* 64736 */   // Label 1884: @64736
     /* 64736 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(64773), // Rule ID 10139 //
     /* 64741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 64744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 64760 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 64760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 64763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64769 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64771 */     GIR_RootConstrainSelectedInstOperands,
     /* 64772 */     // GIR_Coverage, 10139,
     /* 64772 */     GIR_EraseRootFromParent_Done,
     /* 64773 */   // Label 1885: @64773
     /* 64773 */   GIM_Reject,
     /* 64774 */ // Label 1882: @64774
     /* 64774 */ GIM_Reject,
     /* 64775 */ // Label 1867: @64775
     /* 64775 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(64899),
     /* 64780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 64786 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 64789 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(64826), // Rule ID 1183 //
     /* 64794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 64797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64813 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 64813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 64816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64818 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64822 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64824 */     GIR_RootConstrainSelectedInstOperands,
     /* 64825 */     // GIR_Coverage, 1183,
     /* 64825 */     GIR_EraseRootFromParent_Done,
     /* 64826 */   // Label 1887: @64826
     /* 64826 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(64861), // Rule ID 1467 //
     /* 64831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 64834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64850 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 64850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 64855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64859 */     GIR_RootConstrainSelectedInstOperands,
     /* 64860 */     // GIR_Coverage, 1467,
     /* 64860 */     GIR_Done,
     /* 64861 */   // Label 1888: @64861
     /* 64861 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(64898), // Rule ID 8507 //
     /* 64866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64885 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 64885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 64888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64894 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64896 */     GIR_RootConstrainSelectedInstOperands,
     /* 64897 */     // GIR_Coverage, 8507,
     /* 64897 */     GIR_EraseRootFromParent_Done,
     /* 64898 */   // Label 1889: @64898
     /* 64898 */   GIM_Reject,
     /* 64899 */ // Label 1886: @64899
     /* 64899 */ GIM_Reject,
     /* 64900 */ // Label 1868: @64900
     /* 64900 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(65024),
     /* 64905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 64911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 64914 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(64951), // Rule ID 1135 //
     /* 64919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 64922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64938 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 64938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 64941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 64943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 64945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 64947 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 64949 */     GIR_RootConstrainSelectedInstOperands,
     /* 64950 */     // GIR_Coverage, 1135,
     /* 64950 */     GIR_EraseRootFromParent_Done,
     /* 64951 */   // Label 1891: @64951
     /* 64951 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(64986), // Rule ID 1383 //
     /* 64956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 64959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 64975 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 64975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 64980 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 64984 */     GIR_RootConstrainSelectedInstOperands,
     /* 64985 */     // GIR_Coverage, 1383,
     /* 64985 */     GIR_Done,
     /* 64986 */   // Label 1892: @64986
     /* 64986 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(65023), // Rule ID 8468 //
     /* 64991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 64994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 64998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65010 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 65010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 65013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65019 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65021 */     GIR_RootConstrainSelectedInstOperands,
     /* 65022 */     // GIR_Coverage, 8468,
     /* 65022 */     GIR_EraseRootFromParent_Done,
     /* 65023 */   // Label 1893: @65023
     /* 65023 */   GIM_Reject,
     /* 65024 */ // Label 1890: @65024
     /* 65024 */ GIM_Reject,
     /* 65025 */ // Label 1869: @65025
     /* 65025 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(65149),
     /* 65030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 65033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 65036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 65039 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(65076), // Rule ID 1191 //
     /* 65044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 65047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65063 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 65063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 65066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65074 */     GIR_RootConstrainSelectedInstOperands,
     /* 65075 */     // GIR_Coverage, 1191,
     /* 65075 */     GIR_EraseRootFromParent_Done,
     /* 65076 */   // Label 1895: @65076
     /* 65076 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(65111), // Rule ID 1473 //
     /* 65081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 65084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65100 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 65100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 65105 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65109 */     GIR_RootConstrainSelectedInstOperands,
     /* 65110 */     // GIR_Coverage, 1473,
     /* 65110 */     GIR_Done,
     /* 65111 */   // Label 1896: @65111
     /* 65111 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(65148), // Rule ID 8495 //
     /* 65116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 65119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65135 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 65135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 65138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65144 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65146 */     GIR_RootConstrainSelectedInstOperands,
     /* 65147 */     // GIR_Coverage, 8495,
     /* 65147 */     GIR_EraseRootFromParent_Done,
     /* 65148 */   // Label 1897: @65148
     /* 65148 */   GIM_Reject,
     /* 65149 */ // Label 1894: @65149
     /* 65149 */ GIM_Reject,
     /* 65150 */ // Label 1870: @65150
     /* 65150 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(65196), // Rule ID 8429 //
     /* 65155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 65158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 65161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 65164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 65167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65179 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 65183 */   // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 65183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 65186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65188 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65192 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65194 */   GIR_RootConstrainSelectedInstOperands,
     /* 65195 */   // GIR_Coverage, 8429,
     /* 65195 */   GIR_EraseRootFromParent_Done,
     /* 65196 */ // Label 1898: @65196
     /* 65196 */ GIM_Reject,
     /* 65197 */ // Label 1871: @65197
     /* 65197 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(65321),
     /* 65202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 65205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 65208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 65211 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(65248), // Rule ID 1143 //
     /* 65216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 65219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65235 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 65235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 65238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65244 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65246 */     GIR_RootConstrainSelectedInstOperands,
     /* 65247 */     // GIR_Coverage, 1143,
     /* 65247 */     GIR_EraseRootFromParent_Done,
     /* 65248 */   // Label 1900: @65248
     /* 65248 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(65283), // Rule ID 1389 //
     /* 65253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 65256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 65272 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 65272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 65277 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65281 */     GIR_RootConstrainSelectedInstOperands,
     /* 65282 */     // GIR_Coverage, 1389,
     /* 65282 */     GIR_Done,
     /* 65283 */   // Label 1901: @65283
     /* 65283 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(65320), // Rule ID 8456 //
     /* 65288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 65291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65307 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 65307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 65310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65316 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65318 */     GIR_RootConstrainSelectedInstOperands,
     /* 65319 */     // GIR_Coverage, 8456,
     /* 65319 */     GIR_EraseRootFromParent_Done,
     /* 65320 */   // Label 1902: @65320
     /* 65320 */   GIM_Reject,
     /* 65321 */ // Label 1899: @65321
     /* 65321 */ GIM_Reject,
     /* 65322 */ // Label 1872: @65322
     /* 65322 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(65368), // Rule ID 8480 //
     /* 65327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 65333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 65336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 65339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65351 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65355 */   // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 65355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 65358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65360 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65364 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65366 */   GIR_RootConstrainSelectedInstOperands,
     /* 65367 */   // GIR_Coverage, 8480,
     /* 65367 */   GIR_EraseRootFromParent_Done,
     /* 65368 */ // Label 1903: @65368
     /* 65368 */ GIM_Reject,
     /* 65369 */ // Label 1873: @65369
     /* 65369 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(65415), // Rule ID 8417 //
     /* 65374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 65377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 65380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 65383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 65386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65398 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 65402 */   // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 65402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 65405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65407 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65411 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65413 */   GIR_RootConstrainSelectedInstOperands,
     /* 65414 */   // GIR_Coverage, 8417,
     /* 65414 */   GIR_EraseRootFromParent_Done,
     /* 65415 */ // Label 1904: @65415
     /* 65415 */ GIM_Reject,
     /* 65416 */ // Label 1874: @65416
     /* 65416 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(65462), // Rule ID 8441 //
     /* 65421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 65427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 65430 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 65433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65445 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65449 */   // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 65449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 65452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65454 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65458 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65460 */   GIR_RootConstrainSelectedInstOperands,
     /* 65461 */   // GIR_Coverage, 8441,
     /* 65461 */   GIR_EraseRootFromParent_Done,
     /* 65462 */ // Label 1905: @65462
     /* 65462 */ GIM_Reject,
     /* 65463 */ // Label 1875: @65463
     /* 65463 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(65509), // Rule ID 8402 //
     /* 65468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 65471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 65474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 65477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 65480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 65496 */   // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 65496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 65499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 65501 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 65503 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 65505 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 65507 */   GIR_RootConstrainSelectedInstOperands,
     /* 65508 */   // GIR_Coverage, 8402,
     /* 65508 */   GIR_EraseRootFromParent_Done,
     /* 65509 */ // Label 1906: @65509
     /* 65509 */ GIM_Reject,
     /* 65510 */ // Label 1876: @65510
     /* 65510 */ GIM_Reject,
     /* 65511 */ // Label 38: @65511
     /* 65511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1920*/ GIMT_Encode4(66526),
     /* 65522 */ /*GILLT_s16*//*Label 1907*/ GIMT_Encode4(65606),
     /* 65526 */ /*GILLT_s32*//*Label 1908*/ GIMT_Encode4(65644),
     /* 65530 */ /*GILLT_s64*//*Label 1909*/ GIMT_Encode4(65787),
     /* 65534 */ /*GILLT_s80*//*Label 1910*/ GIMT_Encode4(65930), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 65546 */ /*GILLT_v2s64*//*Label 1911*/ GIMT_Encode4(65974), GIMT_Encode4(0),
     /* 65554 */ /*GILLT_v4s32*//*Label 1912*/ GIMT_Encode4(66080),
     /* 65558 */ /*GILLT_v4s64*//*Label 1913*/ GIMT_Encode4(66186), GIMT_Encode4(0),
     /* 65566 */ /*GILLT_v8s16*//*Label 1914*/ GIMT_Encode4(66261),
     /* 65570 */ /*GILLT_v8s32*//*Label 1915*/ GIMT_Encode4(66299),
     /* 65574 */ /*GILLT_v8s64*//*Label 1916*/ GIMT_Encode4(66374), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 65586 */ /*GILLT_v16s16*//*Label 1917*/ GIMT_Encode4(66412),
     /* 65590 */ /*GILLT_v16s32*//*Label 1918*/ GIMT_Encode4(66450), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 65602 */ /*GILLT_v32s16*//*Label 1919*/ GIMT_Encode4(66488),
     /* 65606 */ // Label 1907: @65606
     /* 65606 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(65643), // Rule ID 6121 //
     /* 65611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 65614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 65620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 65624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 65628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 65632 */   // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 65632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 65637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65641 */   GIR_RootConstrainSelectedInstOperands,
     /* 65642 */   // GIR_Coverage, 6121,
     /* 65642 */   GIR_Done,
     /* 65643 */ // Label 1921: @65643
     /* 65643 */ GIM_Reject,
     /* 65644 */ // Label 1908: @65644
     /* 65644 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(65786),
     /* 65649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 65655 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(65692), // Rule ID 902 //
     /* 65660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 65663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 65667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 65671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 65675 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 65675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 65680 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 65686 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 65690 */     GIR_RootConstrainSelectedInstOperands,
     /* 65691 */     // GIR_Coverage, 902,
     /* 65691 */     GIR_Done,
     /* 65692 */   // Label 1923: @65692
     /* 65692 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(65723), // Rule ID 2276 //
     /* 65697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 65700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65712 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 65712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 65717 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65721 */     GIR_RootConstrainSelectedInstOperands,
     /* 65722 */     // GIR_Coverage, 2276,
     /* 65722 */     GIR_Done,
     /* 65723 */   // Label 1924: @65723
     /* 65723 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(65754), // Rule ID 2284 //
     /* 65728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 65731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 65743 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 65743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 65748 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65752 */     GIR_RootConstrainSelectedInstOperands,
     /* 65753 */     // GIR_Coverage, 2284,
     /* 65753 */     GIR_Done,
     /* 65754 */   // Label 1925: @65754
     /* 65754 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(65785), // Rule ID 6083 //
     /* 65759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 65766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 65770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 65774 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 65774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 65779 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65783 */     GIR_RootConstrainSelectedInstOperands,
     /* 65784 */     // GIR_Coverage, 6083,
     /* 65784 */     GIR_Done,
     /* 65785 */   // Label 1926: @65785
     /* 65785 */   GIM_Reject,
     /* 65786 */ // Label 1922: @65786
     /* 65786 */ GIM_Reject,
     /* 65787 */ // Label 1909: @65787
     /* 65787 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(65929),
     /* 65792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 65798 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(65835), // Rule ID 904 //
     /* 65803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 65806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 65810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 65814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 65818 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 65818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 65823 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 65829 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 65833 */     GIR_RootConstrainSelectedInstOperands,
     /* 65834 */     // GIR_Coverage, 904,
     /* 65834 */     GIR_Done,
     /* 65835 */   // Label 1928: @65835
     /* 65835 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(65866), // Rule ID 2280 //
     /* 65840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 65843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65855 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 65855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 65860 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65864 */     GIR_RootConstrainSelectedInstOperands,
     /* 65865 */     // GIR_Coverage, 2280,
     /* 65865 */     GIR_Done,
     /* 65866 */   // Label 1929: @65866
     /* 65866 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(65897), // Rule ID 2288 //
     /* 65871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 65874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 65886 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 65886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 65891 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65895 */     GIR_RootConstrainSelectedInstOperands,
     /* 65896 */     // GIR_Coverage, 2288,
     /* 65896 */     GIR_Done,
     /* 65897 */   // Label 1930: @65897
     /* 65897 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(65928), // Rule ID 6102 //
     /* 65902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 65905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 65909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 65913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 65917 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 65917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 65922 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 65926 */     GIR_RootConstrainSelectedInstOperands,
     /* 65927 */     // GIR_Coverage, 6102,
     /* 65927 */     GIR_Done,
     /* 65928 */   // Label 1931: @65928
     /* 65928 */   GIM_Reject,
     /* 65929 */ // Label 1927: @65929
     /* 65929 */ GIM_Reject,
     /* 65930 */ // Label 1910: @65930
     /* 65930 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(65973), // Rule ID 906 //
     /* 65935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 65938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 65941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 65944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 65948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 65952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 65956 */   // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 65956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 65961 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 65967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 65971 */   GIR_RootConstrainSelectedInstOperands,
     /* 65972 */   // GIR_Coverage, 906,
     /* 65972 */   GIR_Done,
     /* 65973 */ // Label 1932: @65973
     /* 65973 */ GIM_Reject,
     /* 65974 */ // Label 1911: @65974
     /* 65974 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(66079),
     /* 65979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 65982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 65985 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(66016), // Rule ID 2256 //
     /* 65990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 65993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 65997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66005 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 66005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 66010 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66014 */     GIR_RootConstrainSelectedInstOperands,
     /* 66015 */     // GIR_Coverage, 2256,
     /* 66015 */     GIR_Done,
     /* 66016 */   // Label 1934: @66016
     /* 66016 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(66047), // Rule ID 2272 //
     /* 66021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 66024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66036 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 66036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 66041 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66045 */     GIR_RootConstrainSelectedInstOperands,
     /* 66046 */     // GIR_Coverage, 2272,
     /* 66046 */     GIR_Done,
     /* 66047 */   // Label 1935: @66047
     /* 66047 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(66078), // Rule ID 6653 //
     /* 66052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 66055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66067 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 66067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 66072 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66076 */     GIR_RootConstrainSelectedInstOperands,
     /* 66077 */     // GIR_Coverage, 6653,
     /* 66077 */     GIR_Done,
     /* 66078 */   // Label 1936: @66078
     /* 66078 */   GIM_Reject,
     /* 66079 */ // Label 1933: @66079
     /* 66079 */ GIM_Reject,
     /* 66080 */ // Label 1912: @66080
     /* 66080 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(66185),
     /* 66085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 66091 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(66122), // Rule ID 2252 //
     /* 66096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 66099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66111 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 66111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 66116 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66120 */     GIR_RootConstrainSelectedInstOperands,
     /* 66121 */     // GIR_Coverage, 2252,
     /* 66121 */     GIR_Done,
     /* 66122 */   // Label 1938: @66122
     /* 66122 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(66153), // Rule ID 2268 //
     /* 66127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 66130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 66142 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 66142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 66147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66151 */     GIR_RootConstrainSelectedInstOperands,
     /* 66152 */     // GIR_Coverage, 2268,
     /* 66152 */     GIR_Done,
     /* 66153 */   // Label 1939: @66153
     /* 66153 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(66184), // Rule ID 6629 //
     /* 66158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 66161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66173 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 66173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 66178 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66182 */     GIR_RootConstrainSelectedInstOperands,
     /* 66183 */     // GIR_Coverage, 6629,
     /* 66183 */     GIR_Done,
     /* 66184 */   // Label 1940: @66184
     /* 66184 */   GIM_Reject,
     /* 66185 */ // Label 1937: @66185
     /* 66185 */ GIM_Reject,
     /* 66186 */ // Label 1913: @66186
     /* 66186 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(66260),
     /* 66191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 66194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 66197 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(66228), // Rule ID 2264 //
     /* 66202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 66205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66217 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 66217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 66222 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66226 */     GIR_RootConstrainSelectedInstOperands,
     /* 66227 */     // GIR_Coverage, 2264,
     /* 66227 */     GIR_Done,
     /* 66228 */   // Label 1942: @66228
     /* 66228 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(66259), // Rule ID 6665 //
     /* 66233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 66236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66248 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 66248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 66253 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66257 */     GIR_RootConstrainSelectedInstOperands,
     /* 66258 */     // GIR_Coverage, 6665,
     /* 66258 */     GIR_Done,
     /* 66259 */   // Label 1943: @66259
     /* 66259 */   GIM_Reject,
     /* 66260 */ // Label 1941: @66260
     /* 66260 */ GIM_Reject,
     /* 66261 */ // Label 1914: @66261
     /* 66261 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(66298), // Rule ID 6689 //
     /* 66266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 66269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 66272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 66275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 66287 */   // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 66287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 66292 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66296 */   GIR_RootConstrainSelectedInstOperands,
     /* 66297 */   // GIR_Coverage, 6689,
     /* 66297 */   GIR_Done,
     /* 66298 */ // Label 1944: @66298
     /* 66298 */ GIM_Reject,
     /* 66299 */ // Label 1915: @66299
     /* 66299 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(66373),
     /* 66304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 66307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 66310 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(66341), // Rule ID 2260 //
     /* 66315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 66318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 66330 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 66330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 66335 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66339 */     GIR_RootConstrainSelectedInstOperands,
     /* 66340 */     // GIR_Coverage, 2260,
     /* 66340 */     GIR_Done,
     /* 66341 */   // Label 1946: @66341
     /* 66341 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(66372), // Rule ID 6641 //
     /* 66346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 66349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66361 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 66361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 66366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66370 */     GIR_RootConstrainSelectedInstOperands,
     /* 66371 */     // GIR_Coverage, 6641,
     /* 66371 */     GIR_Done,
     /* 66372 */   // Label 1947: @66372
     /* 66372 */   GIM_Reject,
     /* 66373 */ // Label 1945: @66373
     /* 66373 */ GIM_Reject,
     /* 66374 */ // Label 1916: @66374
     /* 66374 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(66411), // Rule ID 6617 //
     /* 66379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 66385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 66388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66400 */   // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 66400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 66405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66409 */   GIR_RootConstrainSelectedInstOperands,
     /* 66410 */   // GIR_Coverage, 6617,
     /* 66410 */   GIR_Done,
     /* 66411 */ // Label 1948: @66411
     /* 66411 */ GIM_Reject,
     /* 66412 */ // Label 1917: @66412
     /* 66412 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(66449), // Rule ID 6701 //
     /* 66417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 66420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 66423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 66426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 66438 */   // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 66438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 66443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66447 */   GIR_RootConstrainSelectedInstOperands,
     /* 66448 */   // GIR_Coverage, 6701,
     /* 66448 */   GIR_Done,
     /* 66449 */ // Label 1949: @66449
     /* 66449 */ GIM_Reject,
     /* 66450 */ // Label 1918: @66450
     /* 66450 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(66487), // Rule ID 6605 //
     /* 66455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 66461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 66464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66476 */   // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 66476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 66481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66485 */   GIR_RootConstrainSelectedInstOperands,
     /* 66486 */   // GIR_Coverage, 6605,
     /* 66486 */   GIR_Done,
     /* 66487 */ // Label 1950: @66487
     /* 66487 */ GIM_Reject,
     /* 66488 */ // Label 1919: @66488
     /* 66488 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(66525), // Rule ID 6677 //
     /* 66493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 66499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 66502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 66514 */   // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 66514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 66519 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66523 */   GIR_RootConstrainSelectedInstOperands,
     /* 66524 */   // GIR_Coverage, 6677,
     /* 66524 */   GIR_Done,
     /* 66525 */ // Label 1951: @66525
     /* 66525 */ GIM_Reject,
     /* 66526 */ // Label 1920: @66526
     /* 66526 */ GIM_Reject,
     /* 66527 */ // Label 39: @66527
     /* 66527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 1955*/ GIMT_Encode4(66649),
     /* 66538 */ /*GILLT_s32*//*Label 1952*/ GIMT_Encode4(66550),
     /* 66542 */ /*GILLT_s64*//*Label 1953*/ GIMT_Encode4(66583),
     /* 66546 */ /*GILLT_s80*//*Label 1954*/ GIMT_Encode4(66616),
     /* 66550 */ // Label 1952: @66550
     /* 66550 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(66582), // Rule ID 1039 //
     /* 66555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66569 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 66569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 66574 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 66580 */   GIR_RootConstrainSelectedInstOperands,
     /* 66581 */   // GIR_Coverage, 1039,
     /* 66581 */   GIR_Done,
     /* 66582 */ // Label 1956: @66582
     /* 66582 */ GIM_Reject,
     /* 66583 */ // Label 1953: @66583
     /* 66583 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(66615), // Rule ID 1040 //
     /* 66588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 66591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66602 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 66602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 66607 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 66613 */   GIR_RootConstrainSelectedInstOperands,
     /* 66614 */   // GIR_Coverage, 1040,
     /* 66614 */   GIR_Done,
     /* 66615 */ // Label 1957: @66615
     /* 66615 */ GIM_Reject,
     /* 66616 */ // Label 1954: @66616
     /* 66616 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(66648), // Rule ID 1041 //
     /* 66621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 66624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 66627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66635 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 66635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 66640 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 66646 */   GIR_RootConstrainSelectedInstOperands,
     /* 66647 */   // GIR_Coverage, 1041,
     /* 66647 */   GIR_Done,
     /* 66648 */ // Label 1958: @66648
     /* 66648 */ GIM_Reject,
     /* 66649 */ // Label 1955: @66649
     /* 66649 */ GIM_Reject,
     /* 66650 */ // Label 40: @66650
     /* 66650 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 1966*/ GIMT_Encode4(67219),
     /* 66661 */ /*GILLT_s32*//*Label 1959*/ GIMT_Encode4(66729),
     /* 66665 */ /*GILLT_s64*//*Label 1960*/ GIMT_Encode4(66775),
     /* 66669 */ /*GILLT_s80*//*Label 1961*/ GIMT_Encode4(66971), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 66693 */ /*GILLT_v4s64*//*Label 1962*/ GIMT_Encode4(67032), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 66705 */ /*GILLT_v8s32*//*Label 1963*/ GIMT_Encode4(67096),
     /* 66709 */ /*GILLT_v8s64*//*Label 1964*/ GIMT_Encode4(67127), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 66725 */ /*GILLT_v16s32*//*Label 1965*/ GIMT_Encode4(67188),
     /* 66729 */ // Label 1959: @66729
     /* 66729 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(66774), // Rule ID 21649 //
     /* 66734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 66740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 66744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 66748 */   // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 66748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 66751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 66765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66772 */   GIR_RootConstrainSelectedInstOperands,
     /* 66773 */   // GIR_Coverage, 21649,
     /* 66773 */   GIR_EraseRootFromParent_Done,
     /* 66774 */ // Label 1967: @66774
     /* 66774 */ GIM_Reject,
     /* 66775 */ // Label 1960: @66775
     /* 66775 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(66805), // Rule ID 1889 //
     /* 66780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 66783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 66790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 66794 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 66794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 66799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 66803 */   GIR_RootConstrainSelectedInstOperands,
     /* 66804 */   // GIR_Coverage, 1889,
     /* 66804 */   GIR_Done,
     /* 66805 */ // Label 1968: @66805
     /* 66805 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(66835), // Rule ID 18174 //
     /* 66810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 66820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66824 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 66824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 66834 */   // GIR_Coverage, 18174,
     /* 66834 */   GIR_Done,
     /* 66835 */ // Label 1969: @66835
     /* 66835 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(66880), // Rule ID 18447 //
     /* 66840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 66843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 66850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 66854 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 66854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 66871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66878 */   GIR_RootConstrainSelectedInstOperands,
     /* 66879 */   // GIR_Coverage, 18447,
     /* 66879 */   GIR_EraseRootFromParent_Done,
     /* 66880 */ // Label 1970: @66880
     /* 66880 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(66925), // Rule ID 21643 //
     /* 66885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 66888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 66895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 66899 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 66899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 66916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66921 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66923 */   GIR_RootConstrainSelectedInstOperands,
     /* 66924 */   // GIR_Coverage, 21643,
     /* 66924 */   GIR_EraseRootFromParent_Done,
     /* 66925 */ // Label 1971: @66925
     /* 66925 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(66970), // Rule ID 21653 //
     /* 66930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 66933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 66936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 66940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 66944 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 66944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 66951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 66961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 66966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66968 */   GIR_RootConstrainSelectedInstOperands,
     /* 66969 */   // GIR_Coverage, 21653,
     /* 66969 */   GIR_EraseRootFromParent_Done,
     /* 66970 */ // Label 1972: @66970
     /* 66970 */ GIM_Reject,
     /* 66971 */ // Label 1961: @66971
     /* 66971 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(67001), // Rule ID 18176 //
     /* 66976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 66979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 66986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 66990 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 66990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 67000 */   // GIR_Coverage, 18176,
     /* 67000 */   GIR_Done,
     /* 67001 */ // Label 1973: @67001
     /* 67001 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(67031), // Rule ID 18178 //
     /* 67006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 67009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 67016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 67020 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 67020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 67030 */   // GIR_Coverage, 18178,
     /* 67030 */   GIR_Done,
     /* 67031 */ // Label 1974: @67031
     /* 67031 */ GIM_Reject,
     /* 67032 */ // Label 1962: @67032
     /* 67032 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(67095),
     /* 67037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67040 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(67067), // Rule ID 1932 //
     /* 67045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 67048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 67052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 67056 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 67056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 67061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67065 */     GIR_RootConstrainSelectedInstOperands,
     /* 67066 */     // GIR_Coverage, 1932,
     /* 67066 */     GIR_Done,
     /* 67067 */   // Label 1976: @67067
     /* 67067 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(67094), // Rule ID 10572 //
     /* 67072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 67075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 67079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 67083 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 67083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 67088 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67092 */     GIR_RootConstrainSelectedInstOperands,
     /* 67093 */     // GIR_Coverage, 10572,
     /* 67093 */     GIR_Done,
     /* 67094 */   // Label 1977: @67094
     /* 67094 */   GIM_Reject,
     /* 67095 */ // Label 1975: @67095
     /* 67095 */ GIM_Reject,
     /* 67096 */ // Label 1963: @67096
     /* 67096 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(67126), // Rule ID 10635 //
     /* 67101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 67104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 67111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 67115 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 67115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 67120 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67124 */   GIR_RootConstrainSelectedInstOperands,
     /* 67125 */   // GIR_Coverage, 10635,
     /* 67125 */   GIR_Done,
     /* 67126 */ // Label 1978: @67126
     /* 67126 */ GIM_Reject,
     /* 67127 */ // Label 1964: @67127
     /* 67127 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(67157), // Rule ID 10547 //
     /* 67132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 67138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 67142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 67146 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 67146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 67151 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67155 */   GIR_RootConstrainSelectedInstOperands,
     /* 67156 */   // GIR_Coverage, 10547,
     /* 67156 */   GIR_Done,
     /* 67157 */ // Label 1979: @67157
     /* 67157 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(67187), // Rule ID 10661 //
     /* 67162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 67172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 67176 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 67176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 67181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67185 */   GIR_RootConstrainSelectedInstOperands,
     /* 67186 */   // GIR_Coverage, 10661,
     /* 67186 */   GIR_Done,
     /* 67187 */ // Label 1980: @67187
     /* 67187 */ GIM_Reject,
     /* 67188 */ // Label 1965: @67188
     /* 67188 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(67218), // Rule ID 10610 //
     /* 67193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 67199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 67203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 67207 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 67207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 67212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67216 */   GIR_RootConstrainSelectedInstOperands,
     /* 67217 */   // GIR_Coverage, 10610,
     /* 67217 */   GIR_Done,
     /* 67218 */ // Label 1981: @67218
     /* 67218 */ GIM_Reject,
     /* 67219 */ // Label 1966: @67219
     /* 67219 */ GIM_Reject,
     /* 67220 */ // Label 41: @67220
     /* 67220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1985*/ GIMT_Encode4(67546),
     /* 67231 */ /*GILLT_s16*//*Label 1982*/ GIMT_Encode4(67243),
     /* 67235 */ /*GILLT_s32*//*Label 1983*/ GIMT_Encode4(67334),
     /* 67239 */ /*GILLT_s64*//*Label 1984*/ GIMT_Encode4(67515),
     /* 67243 */ // Label 1982: @67243
     /* 67243 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(67288), // Rule ID 21657 //
     /* 67248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67262 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 67262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 67265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 67279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 67284 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 67286 */   GIR_RootConstrainSelectedInstOperands,
     /* 67287 */   // GIR_Coverage, 21657,
     /* 67287 */   GIR_EraseRootFromParent_Done,
     /* 67288 */ // Label 1986: @67288
     /* 67288 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(67333), // Rule ID 21659 //
     /* 67293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67307 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 67307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 67310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 67324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 67329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 67331 */   GIR_RootConstrainSelectedInstOperands,
     /* 67332 */   // GIR_Coverage, 21659,
     /* 67332 */   GIR_EraseRootFromParent_Done,
     /* 67333 */ // Label 1987: @67333
     /* 67333 */ GIM_Reject,
     /* 67334 */ // Label 1983: @67334
     /* 67334 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(67364), // Rule ID 1877 //
     /* 67339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 67342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67353 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 67353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 67358 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67362 */   GIR_RootConstrainSelectedInstOperands,
     /* 67363 */   // GIR_Coverage, 1877,
     /* 67363 */   GIR_Done,
     /* 67364 */ // Label 1988: @67364
     /* 67364 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(67394), // Rule ID 18180 //
     /* 67369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 67372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 67379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 67383 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 67383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 67393 */   // GIR_Coverage, 18180,
     /* 67393 */   GIR_Done,
     /* 67394 */ // Label 1989: @67394
     /* 67394 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(67424), // Rule ID 18182 //
     /* 67399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 67402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 67405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 67409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 67413 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 67413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 67423 */   // GIR_Coverage, 18182,
     /* 67423 */   GIR_Done,
     /* 67424 */ // Label 1990: @67424
     /* 67424 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(67469), // Rule ID 18445 //
     /* 67429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67443 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 67443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 67446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 67460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 67465 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 67467 */   GIR_RootConstrainSelectedInstOperands,
     /* 67468 */   // GIR_Coverage, 18445,
     /* 67468 */   GIR_EraseRootFromParent_Done,
     /* 67469 */ // Label 1991: @67469
     /* 67469 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(67514), // Rule ID 21647 //
     /* 67474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67488 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 67488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 67491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 67495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 67500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 67502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 67505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 67507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 67510 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 67512 */   GIR_RootConstrainSelectedInstOperands,
     /* 67513 */   // GIR_Coverage, 21647,
     /* 67513 */   GIR_EraseRootFromParent_Done,
     /* 67514 */ // Label 1992: @67514
     /* 67514 */ GIM_Reject,
     /* 67515 */ // Label 1984: @67515
     /* 67515 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(67545), // Rule ID 18184 //
     /* 67520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 67523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 67526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 67530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 67534 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 67534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 67539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 67544 */   // GIR_Coverage, 18184,
     /* 67544 */   GIR_Done,
     /* 67545 */ // Label 1993: @67545
     /* 67545 */ GIM_Reject,
     /* 67546 */ // Label 1985: @67546
     /* 67546 */ GIM_Reject,
     /* 67547 */ // Label 42: @67547
     /* 67547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 1997*/ GIMT_Encode4(68043),
     /* 67558 */ /*GILLT_s32*//*Label 1994*/ GIMT_Encode4(67590),
     /* 67562 */ /*GILLT_s64*//*Label 1995*/ GIMT_Encode4(67801), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 67586 */ /*GILLT_v4s32*//*Label 1996*/ GIMT_Encode4(68012),
     /* 67590 */ // Label 1994: @67590
     /* 67590 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(67620), // Rule ID 1737 //
     /* 67595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67609 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 67609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 67614 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67618 */   GIR_RootConstrainSelectedInstOperands,
     /* 67619 */   // GIR_Coverage, 1737,
     /* 67619 */   GIR_Done,
     /* 67620 */ // Label 1998: @67620
     /* 67620 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(67650), // Rule ID 1745 //
     /* 67625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67639 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 67639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 67644 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67648 */   GIR_RootConstrainSelectedInstOperands,
     /* 67649 */   // GIR_Coverage, 1745,
     /* 67649 */   GIR_Done,
     /* 67650 */ // Label 1999: @67650
     /* 67650 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(67680), // Rule ID 1761 //
     /* 67655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 67658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67669 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 67669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 67674 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67678 */   GIR_RootConstrainSelectedInstOperands,
     /* 67679 */   // GIR_Coverage, 1761,
     /* 67679 */   GIR_Done,
     /* 67680 */ // Label 2000: @67680
     /* 67680 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(67710), // Rule ID 1769 //
     /* 67685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 67688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67699 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 67699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 67704 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67708 */   GIR_RootConstrainSelectedInstOperands,
     /* 67709 */   // GIR_Coverage, 1769,
     /* 67709 */   GIR_Done,
     /* 67710 */ // Label 2001: @67710
     /* 67710 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(67740), // Rule ID 10358 //
     /* 67715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67729 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 67729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 67734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67738 */   GIR_RootConstrainSelectedInstOperands,
     /* 67739 */   // GIR_Coverage, 10358,
     /* 67739 */   GIR_Done,
     /* 67740 */ // Label 2002: @67740
     /* 67740 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(67770), // Rule ID 10376 //
     /* 67745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67759 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 67759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 67764 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67768 */   GIR_RootConstrainSelectedInstOperands,
     /* 67769 */   // GIR_Coverage, 10376,
     /* 67769 */   GIR_Done,
     /* 67770 */ // Label 2003: @67770
     /* 67770 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(67800), // Rule ID 15166 //
     /* 67775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 67781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 67785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 67789 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 67789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 67794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67798 */   GIR_RootConstrainSelectedInstOperands,
     /* 67799 */   // GIR_Coverage, 15166,
     /* 67799 */   GIR_Done,
     /* 67800 */ // Label 2004: @67800
     /* 67800 */ GIM_Reject,
     /* 67801 */ // Label 1995: @67801
     /* 67801 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(67831), // Rule ID 1741 //
     /* 67806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67820 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 67820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 67825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67829 */   GIR_RootConstrainSelectedInstOperands,
     /* 67830 */   // GIR_Coverage, 1741,
     /* 67830 */   GIR_Done,
     /* 67831 */ // Label 2005: @67831
     /* 67831 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(67861), // Rule ID 1749 //
     /* 67836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 67839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67850 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 67850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 67855 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67859 */   GIR_RootConstrainSelectedInstOperands,
     /* 67860 */   // GIR_Coverage, 1749,
     /* 67860 */   GIR_Done,
     /* 67861 */ // Label 2006: @67861
     /* 67861 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(67891), // Rule ID 1765 //
     /* 67866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 67869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 67880 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 67880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 67885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67889 */   GIR_RootConstrainSelectedInstOperands,
     /* 67890 */   // GIR_Coverage, 1765,
     /* 67890 */   GIR_Done,
     /* 67891 */ // Label 2007: @67891
     /* 67891 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(67921), // Rule ID 1773 //
     /* 67896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 67899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 67910 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 67910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 67915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67919 */   GIR_RootConstrainSelectedInstOperands,
     /* 67920 */   // GIR_Coverage, 1773,
     /* 67920 */   GIR_Done,
     /* 67921 */ // Label 2008: @67921
     /* 67921 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(67951), // Rule ID 10367 //
     /* 67926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 67940 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 67940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 67945 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67949 */   GIR_RootConstrainSelectedInstOperands,
     /* 67950 */   // GIR_Coverage, 10367,
     /* 67950 */   GIR_Done,
     /* 67951 */ // Label 2009: @67951
     /* 67951 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(67981), // Rule ID 10385 //
     /* 67956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 67959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 67970 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 67970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 67975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 67979 */   GIR_RootConstrainSelectedInstOperands,
     /* 67980 */   // GIR_Coverage, 10385,
     /* 67980 */   GIR_Done,
     /* 67981 */ // Label 2010: @67981
     /* 67981 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(68011), // Rule ID 15175 //
     /* 67986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 67989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 67992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 67996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 68000 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 68000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 68005 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68009 */   GIR_RootConstrainSelectedInstOperands,
     /* 68010 */   // GIR_Coverage, 15175,
     /* 68010 */   GIR_Done,
     /* 68011 */ // Label 2011: @68011
     /* 68011 */ GIM_Reject,
     /* 68012 */ // Label 1996: @68012
     /* 68012 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(68042), // Rule ID 18499 //
     /* 68017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 68020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 68023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 68031 */   // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 68031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 68036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68040 */   GIR_RootConstrainSelectedInstOperands,
     /* 68041 */   // GIR_Coverage, 18499,
     /* 68041 */   GIR_Done,
     /* 68042 */ // Label 2012: @68042
     /* 68042 */ GIM_Reject,
     /* 68043 */ // Label 1997: @68043
     /* 68043 */ GIM_Reject,
     /* 68044 */ // Label 43: @68044
     /* 68044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2015*/ GIMT_Encode4(68245),
     /* 68055 */ /*GILLT_s32*//*Label 2013*/ GIMT_Encode4(68063),
     /* 68059 */ /*GILLT_s64*//*Label 2014*/ GIMT_Encode4(68154),
     /* 68063 */ // Label 2013: @68063
     /* 68063 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(68093), // Rule ID 10394 //
     /* 68068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 68082 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 68082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 68087 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68091 */   GIR_RootConstrainSelectedInstOperands,
     /* 68092 */   // GIR_Coverage, 10394,
     /* 68092 */   GIR_Done,
     /* 68093 */ // Label 2016: @68093
     /* 68093 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(68123), // Rule ID 10412 //
     /* 68098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 68112 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 68112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 68117 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68121 */   GIR_RootConstrainSelectedInstOperands,
     /* 68122 */   // GIR_Coverage, 10412,
     /* 68122 */   GIR_Done,
     /* 68123 */ // Label 2017: @68123
     /* 68123 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(68153), // Rule ID 15184 //
     /* 68128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 68131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 68134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 68142 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 68142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 68147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68151 */   GIR_RootConstrainSelectedInstOperands,
     /* 68152 */   // GIR_Coverage, 15184,
     /* 68152 */   GIR_Done,
     /* 68153 */ // Label 2018: @68153
     /* 68153 */ GIM_Reject,
     /* 68154 */ // Label 2014: @68154
     /* 68154 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(68184), // Rule ID 10403 //
     /* 68159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 68173 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 68173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 68178 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68182 */   GIR_RootConstrainSelectedInstOperands,
     /* 68183 */   // GIR_Coverage, 10403,
     /* 68183 */   GIR_Done,
     /* 68184 */ // Label 2019: @68184
     /* 68184 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(68214), // Rule ID 10421 //
     /* 68189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 68203 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 68203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 68208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68212 */   GIR_RootConstrainSelectedInstOperands,
     /* 68213 */   // GIR_Coverage, 10421,
     /* 68213 */   GIR_Done,
     /* 68214 */ // Label 2020: @68214
     /* 68214 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(68244), // Rule ID 15193 //
     /* 68219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 68222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 68225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 68233 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 68233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 68238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68242 */   GIR_RootConstrainSelectedInstOperands,
     /* 68243 */   // GIR_Coverage, 15193,
     /* 68243 */   GIR_Done,
     /* 68244 */ // Label 2021: @68244
     /* 68244 */ GIM_Reject,
     /* 68245 */ // Label 2015: @68245
     /* 68245 */ GIM_Reject,
     /* 68246 */ // Label 44: @68246
     /* 68246 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2034*/ GIMT_Encode4(69507),
     /* 68257 */ /*GILLT_s16*//*Label 2022*/ GIMT_Encode4(68341),
     /* 68261 */ /*GILLT_s32*//*Label 2023*/ GIMT_Encode4(68432),
     /* 68265 */ /*GILLT_s64*//*Label 2024*/ GIMT_Encode4(68673), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 68281 */ /*GILLT_v2s64*//*Label 2025*/ GIMT_Encode4(68910), GIMT_Encode4(0),
     /* 68289 */ /*GILLT_v4s32*//*Label 2026*/ GIMT_Encode4(68941),
     /* 68293 */ /*GILLT_v4s64*//*Label 2027*/ GIMT_Encode4(69062), GIMT_Encode4(0),
     /* 68301 */ /*GILLT_v8s16*//*Label 2028*/ GIMT_Encode4(69145),
     /* 68305 */ /*GILLT_v8s32*//*Label 2029*/ GIMT_Encode4(69236),
     /* 68309 */ /*GILLT_v8s64*//*Label 2030*/ GIMT_Encode4(69327), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 68321 */ /*GILLT_v16s16*//*Label 2031*/ GIMT_Encode4(69384),
     /* 68325 */ /*GILLT_v16s32*//*Label 2032*/ GIMT_Encode4(69445), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 68337 */ /*GILLT_v32s16*//*Label 2033*/ GIMT_Encode4(69476),
     /* 68341 */ // Label 2022: @68341
     /* 68341 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(68386), // Rule ID 22628 //
     /* 68346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 68349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 68356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68360 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 68360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 68363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 68377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68384 */   GIR_RootConstrainSelectedInstOperands,
     /* 68385 */   // GIR_Coverage, 22628,
     /* 68385 */   GIR_EraseRootFromParent_Done,
     /* 68386 */ // Label 2035: @68386
     /* 68386 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(68431), // Rule ID 22630 //
     /* 68391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 68394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 68401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68405 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 68405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 68408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 68422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68429 */   GIR_RootConstrainSelectedInstOperands,
     /* 68430 */   // GIR_Coverage, 22630,
     /* 68430 */   GIR_EraseRootFromParent_Done,
     /* 68431 */ // Label 2036: @68431
     /* 68431 */ GIM_Reject,
     /* 68432 */ // Label 2023: @68432
     /* 68432 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(68462), // Rule ID 1785 //
     /* 68437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 68440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68451 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 68451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 68456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68460 */   GIR_RootConstrainSelectedInstOperands,
     /* 68461 */   // GIR_Coverage, 1785,
     /* 68461 */   GIR_Done,
     /* 68462 */ // Label 2037: @68462
     /* 68462 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(68492), // Rule ID 1789 //
     /* 68467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 68470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68481 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 68481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 68486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68490 */   GIR_RootConstrainSelectedInstOperands,
     /* 68491 */   // GIR_Coverage, 1789,
     /* 68491 */   GIR_Done,
     /* 68492 */ // Label 2038: @68492
     /* 68492 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(68537), // Rule ID 18429 //
     /* 68497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68511 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 68511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 68528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68535 */   GIR_RootConstrainSelectedInstOperands,
     /* 68536 */   // GIR_Coverage, 18429,
     /* 68536 */   GIR_EraseRootFromParent_Done,
     /* 68537 */ // Label 2039: @68537
     /* 68537 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(68582), // Rule ID 18431 //
     /* 68542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 68552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68556 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 68556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 68573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68580 */   GIR_RootConstrainSelectedInstOperands,
     /* 68581 */   // GIR_Coverage, 18431,
     /* 68581 */   GIR_EraseRootFromParent_Done,
     /* 68582 */ // Label 2040: @68582
     /* 68582 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(68627), // Rule ID 21583 //
     /* 68587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 68597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68601 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 68601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 68618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68623 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68625 */   GIR_RootConstrainSelectedInstOperands,
     /* 68626 */   // GIR_Coverage, 21583,
     /* 68626 */   GIR_EraseRootFromParent_Done,
     /* 68627 */ // Label 2041: @68627
     /* 68627 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(68672), // Rule ID 21585 //
     /* 68632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 68642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68646 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 68646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 68649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 68663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68668 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68670 */   GIR_RootConstrainSelectedInstOperands,
     /* 68671 */   // GIR_Coverage, 21585,
     /* 68671 */   GIR_EraseRootFromParent_Done,
     /* 68672 */ // Label 2042: @68672
     /* 68672 */ GIM_Reject,
     /* 68673 */ // Label 2024: @68673
     /* 68673 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(68699), // Rule ID 1793 //
     /* 68678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 68681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68692 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 68692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 68697 */   GIR_RootConstrainSelectedInstOperands,
     /* 68698 */   // GIR_Coverage, 1793,
     /* 68698 */   GIR_Done,
     /* 68699 */ // Label 2043: @68699
     /* 68699 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(68729), // Rule ID 1797 //
     /* 68704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 68707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68718 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 68718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 68723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68727 */   GIR_RootConstrainSelectedInstOperands,
     /* 68728 */   // GIR_Coverage, 1797,
     /* 68728 */   GIR_Done,
     /* 68729 */ // Label 2044: @68729
     /* 68729 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(68774), // Rule ID 18433 //
     /* 68734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68748 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 68748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 68765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68772 */   GIR_RootConstrainSelectedInstOperands,
     /* 68773 */   // GIR_Coverage, 18433,
     /* 68773 */   GIR_EraseRootFromParent_Done,
     /* 68774 */ // Label 2045: @68774
     /* 68774 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(68819), // Rule ID 18435 //
     /* 68779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 68782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 68789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68793 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 68793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 68810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68817 */   GIR_RootConstrainSelectedInstOperands,
     /* 68818 */   // GIR_Coverage, 18435,
     /* 68818 */   GIR_EraseRootFromParent_Done,
     /* 68819 */ // Label 2046: @68819
     /* 68819 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(68864), // Rule ID 21587 //
     /* 68824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 68834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 68838 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 68838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 68855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68860 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68862 */   GIR_RootConstrainSelectedInstOperands,
     /* 68863 */   // GIR_Coverage, 21587,
     /* 68863 */   GIR_EraseRootFromParent_Done,
     /* 68864 */ // Label 2047: @68864
     /* 68864 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(68909), // Rule ID 21589 //
     /* 68869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 68872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 68879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 68883 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 68883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 68886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 68890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 68895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 68897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 68900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 68902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 68905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 68907 */   GIR_RootConstrainSelectedInstOperands,
     /* 68908 */   // GIR_Coverage, 21589,
     /* 68908 */   GIR_EraseRootFromParent_Done,
     /* 68909 */ // Label 2048: @68909
     /* 68909 */ GIM_Reject,
     /* 68910 */ // Label 2025: @68910
     /* 68910 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(68940), // Rule ID 11372 //
     /* 68915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 68918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 68929 */   // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 68929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 68934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68938 */   GIR_RootConstrainSelectedInstOperands,
     /* 68939 */   // GIR_Coverage, 11372,
     /* 68939 */   GIR_Done,
     /* 68940 */ // Label 2049: @68940
     /* 68940 */ GIM_Reject,
     /* 68941 */ // Label 2026: @68941
     /* 68941 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(68971), // Rule ID 1865 //
     /* 68946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 68949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68960 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 68960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 68965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68969 */   GIR_RootConstrainSelectedInstOperands,
     /* 68970 */   // GIR_Coverage, 1865,
     /* 68970 */   GIR_Done,
     /* 68971 */ // Label 2050: @68971
     /* 68971 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(69001), // Rule ID 1873 //
     /* 68976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 68979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 68990 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 68990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 68995 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 68999 */   GIR_RootConstrainSelectedInstOperands,
     /* 69000 */   // GIR_Coverage, 1873,
     /* 69000 */   GIR_Done,
     /* 69001 */ // Label 2051: @69001
     /* 69001 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(69031), // Rule ID 10748 //
     /* 69006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69020 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 69020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 69025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69029 */   GIR_RootConstrainSelectedInstOperands,
     /* 69030 */   // GIR_Coverage, 10748,
     /* 69030 */   GIR_Done,
     /* 69031 */ // Label 2052: @69031
     /* 69031 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(69061), // Rule ID 11504 //
     /* 69036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 69042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69050 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 69050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 69055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69059 */   GIR_RootConstrainSelectedInstOperands,
     /* 69060 */   // GIR_Coverage, 11504,
     /* 69060 */   GIR_Done,
     /* 69061 */ // Label 2053: @69061
     /* 69061 */ GIM_Reject,
     /* 69062 */ // Label 2027: @69062
     /* 69062 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(69088), // Rule ID 1944 //
     /* 69067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 69070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 69077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 69081 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 69081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 69086 */   GIR_RootConstrainSelectedInstOperands,
     /* 69087 */   // GIR_Coverage, 1944,
     /* 69087 */   GIR_Done,
     /* 69088 */ // Label 2054: @69088
     /* 69088 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(69114), // Rule ID 10721 //
     /* 69093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69107 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 69107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 69112 */   GIR_RootConstrainSelectedInstOperands,
     /* 69113 */   // GIR_Coverage, 10721,
     /* 69113 */   GIR_Done,
     /* 69114 */ // Label 2055: @69114
     /* 69114 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(69144), // Rule ID 11384 //
     /* 69119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 69125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69133 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 69133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 69138 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69142 */   GIR_RootConstrainSelectedInstOperands,
     /* 69143 */   // GIR_Coverage, 11384,
     /* 69143 */   GIR_Done,
     /* 69144 */ // Label 2056: @69144
     /* 69144 */ GIM_Reject,
     /* 69145 */ // Label 2028: @69145
     /* 69145 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(69175), // Rule ID 11450 //
     /* 69150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69164 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 69164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 69169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69173 */   GIR_RootConstrainSelectedInstOperands,
     /* 69174 */   // GIR_Coverage, 11450,
     /* 69174 */   GIR_Done,
     /* 69175 */ // Label 2057: @69175
     /* 69175 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(69205), // Rule ID 14816 //
     /* 69180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69194 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 69194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 69199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69203 */   GIR_RootConstrainSelectedInstOperands,
     /* 69204 */   // GIR_Coverage, 14816,
     /* 69204 */   GIR_Done,
     /* 69205 */ // Label 2058: @69205
     /* 69205 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(69235), // Rule ID 15116 //
     /* 69210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 69216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69224 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 69224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 69229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69233 */   GIR_RootConstrainSelectedInstOperands,
     /* 69234 */   // GIR_Coverage, 15116,
     /* 69234 */   GIR_Done,
     /* 69235 */ // Label 2059: @69235
     /* 69235 */ GIM_Reject,
     /* 69236 */ // Label 2029: @69236
     /* 69236 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(69266), // Rule ID 1869 //
     /* 69241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 69244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 69251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 69255 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 69255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 69260 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69264 */   GIR_RootConstrainSelectedInstOperands,
     /* 69265 */   // GIR_Coverage, 1869,
     /* 69265 */   GIR_Done,
     /* 69266 */ // Label 2060: @69266
     /* 69266 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(69296), // Rule ID 10760 //
     /* 69271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69285 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 69285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 69290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69294 */   GIR_RootConstrainSelectedInstOperands,
     /* 69295 */   // GIR_Coverage, 10760,
     /* 69295 */   GIR_Done,
     /* 69296 */ // Label 2061: @69296
     /* 69296 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(69326), // Rule ID 11489 //
     /* 69301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 69304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 69307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69315 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 69315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 69320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69324 */   GIR_RootConstrainSelectedInstOperands,
     /* 69325 */   // GIR_Coverage, 11489,
     /* 69325 */   GIR_Done,
     /* 69326 */ // Label 2062: @69326
     /* 69326 */ GIM_Reject,
     /* 69327 */ // Label 2030: @69327
     /* 69327 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(69353), // Rule ID 10697 //
     /* 69332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 69338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69346 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 69346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 69351 */   GIR_RootConstrainSelectedInstOperands,
     /* 69352 */   // GIR_Coverage, 10697,
     /* 69352 */   GIR_Done,
     /* 69353 */ // Label 2063: @69353
     /* 69353 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(69383), // Rule ID 11357 //
     /* 69358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 69361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 69364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69372 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 69372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 69377 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69381 */   GIR_RootConstrainSelectedInstOperands,
     /* 69382 */   // GIR_Coverage, 11357,
     /* 69382 */   GIR_Done,
     /* 69383 */ // Label 2064: @69383
     /* 69383 */ GIM_Reject,
     /* 69384 */ // Label 2031: @69384
     /* 69384 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(69414), // Rule ID 11435 //
     /* 69389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 69395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69403 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 69403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 69408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69412 */   GIR_RootConstrainSelectedInstOperands,
     /* 69413 */   // GIR_Coverage, 11435,
     /* 69413 */   GIR_Done,
     /* 69414 */ // Label 2065: @69414
     /* 69414 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(69444), // Rule ID 14828 //
     /* 69419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 69422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 69425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69433 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 69433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 69438 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69442 */   GIR_RootConstrainSelectedInstOperands,
     /* 69443 */   // GIR_Coverage, 14828,
     /* 69443 */   GIR_Done,
     /* 69444 */ // Label 2066: @69444
     /* 69444 */ GIM_Reject,
     /* 69445 */ // Label 2032: @69445
     /* 69445 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(69475), // Rule ID 10733 //
     /* 69450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 69456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69464 */   // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 69464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 69469 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69473 */   GIR_RootConstrainSelectedInstOperands,
     /* 69474 */   // GIR_Coverage, 10733,
     /* 69474 */   GIR_Done,
     /* 69475 */ // Label 2067: @69475
     /* 69475 */ GIM_Reject,
     /* 69476 */ // Label 2033: @69476
     /* 69476 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(69506), // Rule ID 14801 //
     /* 69481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 69487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 69495 */   // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 69495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 69500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69504 */   GIR_RootConstrainSelectedInstOperands,
     /* 69505 */   // GIR_Coverage, 14801,
     /* 69505 */   GIR_Done,
     /* 69506 */ // Label 2068: @69506
     /* 69506 */ GIM_Reject,
     /* 69507 */ // Label 2034: @69507
     /* 69507 */ GIM_Reject,
     /* 69508 */ // Label 45: @69508
     /* 69508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2081*/ GIMT_Encode4(70357),
     /* 69519 */ /*GILLT_s16*//*Label 2069*/ GIMT_Encode4(69603),
     /* 69523 */ /*GILLT_s32*//*Label 2070*/ GIMT_Encode4(69694),
     /* 69527 */ /*GILLT_s64*//*Label 2071*/ GIMT_Encode4(69785), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 69543 */ /*GILLT_v2s64*//*Label 2072*/ GIMT_Encode4(69876), GIMT_Encode4(0),
     /* 69551 */ /*GILLT_v4s32*//*Label 2073*/ GIMT_Encode4(69907),
     /* 69555 */ /*GILLT_v4s64*//*Label 2074*/ GIMT_Encode4(69968), GIMT_Encode4(0),
     /* 69563 */ /*GILLT_v8s16*//*Label 2075*/ GIMT_Encode4(70025),
     /* 69567 */ /*GILLT_v8s32*//*Label 2076*/ GIMT_Encode4(70116),
     /* 69571 */ /*GILLT_v8s64*//*Label 2077*/ GIMT_Encode4(70177), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 69583 */ /*GILLT_v16s16*//*Label 2078*/ GIMT_Encode4(70234),
     /* 69587 */ /*GILLT_v16s32*//*Label 2079*/ GIMT_Encode4(70295), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 69599 */ /*GILLT_v32s16*//*Label 2080*/ GIMT_Encode4(70326),
     /* 69603 */ // Label 2069: @69603
     /* 69603 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(69648), // Rule ID 22636 //
     /* 69608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 69618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 69622 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 69622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 69625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 69639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69644 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69646 */   GIR_RootConstrainSelectedInstOperands,
     /* 69647 */   // GIR_Coverage, 22636,
     /* 69647 */   GIR_EraseRootFromParent_Done,
     /* 69648 */ // Label 2082: @69648
     /* 69648 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(69693), // Rule ID 22638 //
     /* 69653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 69656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 69663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 69667 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 69667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 69670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 69684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69691 */   GIR_RootConstrainSelectedInstOperands,
     /* 69692 */   // GIR_Coverage, 22638,
     /* 69692 */   GIR_EraseRootFromParent_Done,
     /* 69693 */ // Label 2083: @69693
     /* 69693 */ GIM_Reject,
     /* 69694 */ // Label 2070: @69694
     /* 69694 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(69739), // Rule ID 21599 //
     /* 69699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 69709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 69713 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 69713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 69730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69737 */   GIR_RootConstrainSelectedInstOperands,
     /* 69738 */   // GIR_Coverage, 21599,
     /* 69738 */   GIR_EraseRootFromParent_Done,
     /* 69739 */ // Label 2084: @69739
     /* 69739 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(69784), // Rule ID 21601 //
     /* 69744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 69754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 69758 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 69758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 69775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69782 */   GIR_RootConstrainSelectedInstOperands,
     /* 69783 */   // GIR_Coverage, 21601,
     /* 69783 */   GIR_EraseRootFromParent_Done,
     /* 69784 */ // Label 2085: @69784
     /* 69784 */ GIM_Reject,
     /* 69785 */ // Label 2071: @69785
     /* 69785 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(69830), // Rule ID 21603 //
     /* 69790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 69800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 69804 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 69804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 69821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69826 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69828 */   GIR_RootConstrainSelectedInstOperands,
     /* 69829 */   // GIR_Coverage, 21603,
     /* 69829 */   GIR_EraseRootFromParent_Done,
     /* 69830 */ // Label 2086: @69830
     /* 69830 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(69875), // Rule ID 21605 //
     /* 69835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 69838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 69845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 69849 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 69849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 69856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 69866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 69868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69871 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 69873 */   GIR_RootConstrainSelectedInstOperands,
     /* 69874 */   // GIR_Coverage, 21605,
     /* 69874 */   GIR_EraseRootFromParent_Done,
     /* 69875 */ // Label 2087: @69875
     /* 69875 */ GIM_Reject,
     /* 69876 */ // Label 2072: @69876
     /* 69876 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(69906), // Rule ID 11411 //
     /* 69881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69895 */   // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 69895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 69900 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69904 */   GIR_RootConstrainSelectedInstOperands,
     /* 69905 */   // GIR_Coverage, 11411,
     /* 69905 */   GIR_Done,
     /* 69906 */ // Label 2088: @69906
     /* 69906 */ GIM_Reject,
     /* 69907 */ // Label 2073: @69907
     /* 69907 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(69937), // Rule ID 10955 //
     /* 69912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69926 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 69926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 69931 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69935 */   GIR_RootConstrainSelectedInstOperands,
     /* 69936 */   // GIR_Coverage, 10955,
     /* 69936 */   GIR_Done,
     /* 69937 */ // Label 2089: @69937
     /* 69937 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(69967), // Rule ID 11531 //
     /* 69942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 69945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 69948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69956 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 69956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 69961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 69965 */   GIR_RootConstrainSelectedInstOperands,
     /* 69966 */   // GIR_Coverage, 11531,
     /* 69966 */   GIR_Done,
     /* 69967 */ // Label 2090: @69967
     /* 69967 */ GIM_Reject,
     /* 69968 */ // Label 2074: @69968
     /* 69968 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(69994), // Rule ID 10928 //
     /* 69973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 69976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 69983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 69987 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 69987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 69992 */   GIR_RootConstrainSelectedInstOperands,
     /* 69993 */   // GIR_Coverage, 10928,
     /* 69993 */   GIR_Done,
     /* 69994 */ // Label 2091: @69994
     /* 69994 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(70024), // Rule ID 11423 //
     /* 69999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 70002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 70005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70013 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 70013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 70018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70022 */   GIR_RootConstrainSelectedInstOperands,
     /* 70023 */   // GIR_Coverage, 11423,
     /* 70023 */   GIR_Done,
     /* 70024 */ // Label 2092: @70024
     /* 70024 */ GIM_Reject,
     /* 70025 */ // Label 2075: @70025
     /* 70025 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(70055), // Rule ID 11477 //
     /* 70030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 70033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 70036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70044 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 70044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 70049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70053 */   GIR_RootConstrainSelectedInstOperands,
     /* 70054 */   // GIR_Coverage, 11477,
     /* 70054 */   GIR_Done,
     /* 70055 */ // Label 2093: @70055
     /* 70055 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(70085), // Rule ID 14669 //
     /* 70060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 70063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 70066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70074 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 70074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 70079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70083 */   GIR_RootConstrainSelectedInstOperands,
     /* 70084 */   // GIR_Coverage, 14669,
     /* 70084 */   GIR_Done,
     /* 70085 */ // Label 2094: @70085
     /* 70085 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(70115), // Rule ID 15131 //
     /* 70090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 70093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 70096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70104 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 70104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 70109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70113 */   GIR_RootConstrainSelectedInstOperands,
     /* 70114 */   // GIR_Coverage, 15131,
     /* 70114 */   GIR_Done,
     /* 70115 */ // Label 2095: @70115
     /* 70115 */ GIM_Reject,
     /* 70116 */ // Label 2076: @70116
     /* 70116 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(70146), // Rule ID 10967 //
     /* 70121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 70124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 70127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70135 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 70135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 70140 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70144 */   GIR_RootConstrainSelectedInstOperands,
     /* 70145 */   // GIR_Coverage, 10967,
     /* 70145 */   GIR_Done,
     /* 70146 */ // Label 2096: @70146
     /* 70146 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(70176), // Rule ID 11516 //
     /* 70151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 70154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 70157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70165 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 70165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 70170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70174 */   GIR_RootConstrainSelectedInstOperands,
     /* 70175 */   // GIR_Coverage, 11516,
     /* 70175 */   GIR_Done,
     /* 70176 */ // Label 2097: @70176
     /* 70176 */ GIM_Reject,
     /* 70177 */ // Label 2077: @70177
     /* 70177 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(70203), // Rule ID 10904 //
     /* 70182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 70185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 70188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70196 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 70196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 70201 */   GIR_RootConstrainSelectedInstOperands,
     /* 70202 */   // GIR_Coverage, 10904,
     /* 70202 */   GIR_Done,
     /* 70203 */ // Label 2098: @70203
     /* 70203 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(70233), // Rule ID 11396 //
     /* 70208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 70211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 70214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70222 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 70222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 70227 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70231 */   GIR_RootConstrainSelectedInstOperands,
     /* 70232 */   // GIR_Coverage, 11396,
     /* 70232 */   GIR_Done,
     /* 70233 */ // Label 2099: @70233
     /* 70233 */ GIM_Reject,
     /* 70234 */ // Label 2078: @70234
     /* 70234 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(70264), // Rule ID 11462 //
     /* 70239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 70242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 70245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70253 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 70253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 70258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70262 */   GIR_RootConstrainSelectedInstOperands,
     /* 70263 */   // GIR_Coverage, 11462,
     /* 70263 */   GIR_Done,
     /* 70264 */ // Label 2100: @70264
     /* 70264 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(70294), // Rule ID 14681 //
     /* 70269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 70272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 70275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70283 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 70283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 70288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70292 */   GIR_RootConstrainSelectedInstOperands,
     /* 70293 */   // GIR_Coverage, 14681,
     /* 70293 */   GIR_Done,
     /* 70294 */ // Label 2101: @70294
     /* 70294 */ GIM_Reject,
     /* 70295 */ // Label 2079: @70295
     /* 70295 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(70325), // Rule ID 10940 //
     /* 70300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 70303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 70306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70314 */   // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 70314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 70319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70323 */   GIR_RootConstrainSelectedInstOperands,
     /* 70324 */   // GIR_Coverage, 10940,
     /* 70324 */   GIR_Done,
     /* 70325 */ // Label 2102: @70325
     /* 70325 */ GIM_Reject,
     /* 70326 */ // Label 2080: @70326
     /* 70326 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(70356), // Rule ID 14654 //
     /* 70331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 70334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 70337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 70345 */   // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 70345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 70350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 70354 */   GIR_RootConstrainSelectedInstOperands,
     /* 70355 */   // GIR_Coverage, 14654,
     /* 70355 */   GIR_Done,
     /* 70356 */ // Label 2103: @70356
     /* 70356 */ GIM_Reject,
     /* 70357 */ // Label 2081: @70357
     /* 70357 */ GIM_Reject,
     /* 70358 */ // Label 46: @70358
     /* 70358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2107*/ GIMT_Encode4(70480),
     /* 70369 */ /*GILLT_s32*//*Label 2104*/ GIMT_Encode4(70381),
     /* 70373 */ /*GILLT_s64*//*Label 2105*/ GIMT_Encode4(70414),
     /* 70377 */ /*GILLT_s80*//*Label 2106*/ GIMT_Encode4(70447),
     /* 70381 */ // Label 2104: @70381
     /* 70381 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(70413), // Rule ID 1042 //
     /* 70386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 70389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 70392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 70396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 70400 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 70400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 70405 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 70411 */   GIR_RootConstrainSelectedInstOperands,
     /* 70412 */   // GIR_Coverage, 1042,
     /* 70412 */   GIR_Done,
     /* 70413 */ // Label 2108: @70413
     /* 70413 */ GIM_Reject,
     /* 70414 */ // Label 2105: @70414
     /* 70414 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(70446), // Rule ID 1043 //
     /* 70419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 70422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 70425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 70429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 70433 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 70433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 70438 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 70444 */   GIR_RootConstrainSelectedInstOperands,
     /* 70445 */   // GIR_Coverage, 1043,
     /* 70445 */   GIR_Done,
     /* 70446 */ // Label 2109: @70446
     /* 70446 */ GIM_Reject,
     /* 70447 */ // Label 2106: @70447
     /* 70447 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(70479), // Rule ID 1044 //
     /* 70452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 70455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 70458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 70462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 70466 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 70466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 70471 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 70477 */   GIR_RootConstrainSelectedInstOperands,
     /* 70478 */   // GIR_Coverage, 1044,
     /* 70478 */   GIR_Done,
     /* 70479 */ // Label 2110: @70479
     /* 70479 */ GIM_Reject,
     /* 70480 */ // Label 2107: @70480
     /* 70480 */ GIM_Reject,
     /* 70481 */ // Label 47: @70481
     /* 70481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2123*/ GIMT_Encode4(71577),
     /* 70492 */ /*GILLT_v2s64*//*Label 2111*/ GIMT_Encode4(70560), GIMT_Encode4(0),
     /* 70500 */ /*GILLT_v4s32*//*Label 2112*/ GIMT_Encode4(70765),
     /* 70504 */ /*GILLT_v4s64*//*Label 2113*/ GIMT_Encode4(70859), GIMT_Encode4(0),
     /* 70512 */ /*GILLT_v8s16*//*Label 2114*/ GIMT_Encode4(71052),
     /* 70516 */ /*GILLT_v8s32*//*Label 2115*/ GIMT_Encode4(71146),
     /* 70520 */ /*GILLT_v8s64*//*Label 2116*/ GIMT_Encode4(71213), GIMT_Encode4(0),
     /* 70528 */ /*GILLT_v16s8*//*Label 2117*/ GIMT_Encode4(71247),
     /* 70532 */ /*GILLT_v16s16*//*Label 2118*/ GIMT_Encode4(71341),
     /* 70536 */ /*GILLT_v16s32*//*Label 2119*/ GIMT_Encode4(71408), GIMT_Encode4(0),
     /* 70544 */ /*GILLT_v32s8*//*Label 2120*/ GIMT_Encode4(71442),
     /* 70548 */ /*GILLT_v32s16*//*Label 2121*/ GIMT_Encode4(71509), GIMT_Encode4(0),
     /* 70556 */ /*GILLT_v64s8*//*Label 2122*/ GIMT_Encode4(71543),
     /* 70560 */ // Label 2111: @70560
     /* 70560 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(70764),
     /* 70565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 70568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 70571 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(70598), // Rule ID 5584 //
     /* 70576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70591 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 70591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 70596 */     GIR_RootConstrainSelectedInstOperands,
     /* 70597 */     // GIR_Coverage, 5584,
     /* 70597 */     GIR_Done,
     /* 70598 */   // Label 2125: @70598
     /* 70598 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(70763), // Rule ID 20461 //
     /* 70603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 70606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 70610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70618 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 70618 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 70621 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70625 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 70632 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 70635 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70639 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70644 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 70647 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 70651 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 70654 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70659 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70664 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 70669 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 70672 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70676 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 70683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 70686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70695 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 70698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 70702 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 70705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 70720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 70723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 70727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 70735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 70738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 70740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 70743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 70745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 70752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 70757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70762 */     // GIR_Coverage, 20461,
     /* 70762 */     GIR_EraseRootFromParent_Done,
     /* 70763 */   // Label 2126: @70763
     /* 70763 */   GIM_Reject,
     /* 70764 */ // Label 2124: @70764
     /* 70764 */ GIM_Reject,
     /* 70765 */ // Label 2112: @70765
     /* 70765 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(70858),
     /* 70770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 70773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 70776 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(70803), // Rule ID 3182 //
     /* 70781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 70784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70796 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 70796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 70801 */     GIR_RootConstrainSelectedInstOperands,
     /* 70802 */     // GIR_Coverage, 3182,
     /* 70802 */     GIR_Done,
     /* 70803 */   // Label 2128: @70803
     /* 70803 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(70830), // Rule ID 3220 //
     /* 70808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 70811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 70823 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 70823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 70828 */     GIR_RootConstrainSelectedInstOperands,
     /* 70829 */     // GIR_Coverage, 3220,
     /* 70829 */     GIR_Done,
     /* 70830 */   // Label 2129: @70830
     /* 70830 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(70857), // Rule ID 5557 //
     /* 70835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 70850 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 70850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 70855 */     GIR_RootConstrainSelectedInstOperands,
     /* 70856 */     // GIR_Coverage, 5557,
     /* 70856 */     GIR_Done,
     /* 70857 */   // Label 2130: @70857
     /* 70857 */   GIM_Reject,
     /* 70858 */ // Label 2127: @70858
     /* 70858 */ GIM_Reject,
     /* 70859 */ // Label 2113: @70859
     /* 70859 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(71051),
     /* 70864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 70867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 70870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 70882 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(70897), // Rule ID 5575 //
     /* 70887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 70890 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 70890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 70895 */     GIR_RootConstrainSelectedInstOperands,
     /* 70896 */     // GIR_Coverage, 5575,
     /* 70896 */     GIR_Done,
     /* 70897 */   // Label 2132: @70897
     /* 70897 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(71050), // Rule ID 20459 //
     /* 70902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 70905 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 70905 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 70908 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70912 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 70919 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 70922 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70926 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70931 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 70934 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 70938 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 70941 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70946 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 70951 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 70956 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 70959 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 70963 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 70970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 70973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 70977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 70982 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 70985 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 70989 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 70992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 70997 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71002 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 71007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 71010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 71014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71019 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 71022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 71025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 71027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 71030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 71032 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 71039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 71044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71049 */     // GIR_Coverage, 20459,
     /* 71049 */     GIR_EraseRootFromParent_Done,
     /* 71050 */   // Label 2133: @71050
     /* 71050 */   GIM_Reject,
     /* 71051 */ // Label 2131: @71051
     /* 71051 */ GIM_Reject,
     /* 71052 */ // Label 2114: @71052
     /* 71052 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(71145),
     /* 71057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 71060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 71063 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(71090), // Rule ID 2639 //
     /* 71068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 71071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71083 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 71083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 71088 */     GIR_RootConstrainSelectedInstOperands,
     /* 71089 */     // GIR_Coverage, 2639,
     /* 71089 */     GIR_Done,
     /* 71090 */   // Label 2135: @71090
     /* 71090 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(71117), // Rule ID 2641 //
     /* 71095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 71098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71110 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 71110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 71115 */     GIR_RootConstrainSelectedInstOperands,
     /* 71116 */     // GIR_Coverage, 2641,
     /* 71116 */     GIR_Done,
     /* 71117 */   // Label 2136: @71117
     /* 71117 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(71144), // Rule ID 5533 //
     /* 71122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71137 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 71137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 71142 */     GIR_RootConstrainSelectedInstOperands,
     /* 71143 */     // GIR_Coverage, 5533,
     /* 71143 */     GIR_Done,
     /* 71144 */   // Label 2137: @71144
     /* 71144 */   GIM_Reject,
     /* 71145 */ // Label 2134: @71145
     /* 71145 */ GIM_Reject,
     /* 71146 */ // Label 2115: @71146
     /* 71146 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(71212),
     /* 71151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 71154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 71157 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(71184), // Rule ID 3200 //
     /* 71162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 71165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71177 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 71177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 71182 */     GIR_RootConstrainSelectedInstOperands,
     /* 71183 */     // GIR_Coverage, 3200,
     /* 71183 */     GIR_Done,
     /* 71184 */   // Label 2139: @71184
     /* 71184 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(71211), // Rule ID 5548 //
     /* 71189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71204 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 71204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 71209 */     GIR_RootConstrainSelectedInstOperands,
     /* 71210 */     // GIR_Coverage, 5548,
     /* 71210 */     GIR_Done,
     /* 71211 */   // Label 2140: @71211
     /* 71211 */   GIM_Reject,
     /* 71212 */ // Label 2138: @71212
     /* 71212 */ GIM_Reject,
     /* 71213 */ // Label 2116: @71213
     /* 71213 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(71246), // Rule ID 5566 //
     /* 71218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 71221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 71224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 71227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71239 */   // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 71239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 71244 */   GIR_RootConstrainSelectedInstOperands,
     /* 71245 */   // GIR_Coverage, 5566,
     /* 71245 */   GIR_Done,
     /* 71246 */ // Label 2141: @71246
     /* 71246 */ GIM_Reject,
     /* 71247 */ // Label 2117: @71247
     /* 71247 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(71340),
     /* 71252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 71255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 71258 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(71285), // Rule ID 3192 //
     /* 71263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 71266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71278 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 71278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 71283 */     GIR_RootConstrainSelectedInstOperands,
     /* 71284 */     // GIR_Coverage, 3192,
     /* 71284 */     GIR_Done,
     /* 71285 */   // Label 2143: @71285
     /* 71285 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(71312), // Rule ID 3218 //
     /* 71290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 71293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71305 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 71305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 71310 */     GIR_RootConstrainSelectedInstOperands,
     /* 71311 */     // GIR_Coverage, 3218,
     /* 71311 */     GIR_Done,
     /* 71312 */   // Label 2144: @71312
     /* 71312 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(71339), // Rule ID 5515 //
     /* 71317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71332 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 71332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 71337 */     GIR_RootConstrainSelectedInstOperands,
     /* 71338 */     // GIR_Coverage, 5515,
     /* 71338 */     GIR_Done,
     /* 71339 */   // Label 2145: @71339
     /* 71339 */   GIM_Reject,
     /* 71340 */ // Label 2142: @71340
     /* 71340 */ GIM_Reject,
     /* 71341 */ // Label 2118: @71341
     /* 71341 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(71407),
     /* 71346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 71349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 71352 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(71379), // Rule ID 2643 //
     /* 71357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 71360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71372 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 71372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 71377 */     GIR_RootConstrainSelectedInstOperands,
     /* 71378 */     // GIR_Coverage, 2643,
     /* 71378 */     GIR_Done,
     /* 71379 */   // Label 2147: @71379
     /* 71379 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(71406), // Rule ID 5527 //
     /* 71384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71399 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 71399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 71404 */     GIR_RootConstrainSelectedInstOperands,
     /* 71405 */     // GIR_Coverage, 5527,
     /* 71405 */     GIR_Done,
     /* 71406 */   // Label 2148: @71406
     /* 71406 */   GIM_Reject,
     /* 71407 */ // Label 2146: @71407
     /* 71407 */ GIM_Reject,
     /* 71408 */ // Label 2119: @71408
     /* 71408 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(71441), // Rule ID 5539 //
     /* 71413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 71416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 71419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 71422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71434 */   // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 71434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 71439 */   GIR_RootConstrainSelectedInstOperands,
     /* 71440 */   // GIR_Coverage, 5539,
     /* 71440 */   GIR_Done,
     /* 71441 */ // Label 2149: @71441
     /* 71441 */ GIM_Reject,
     /* 71442 */ // Label 2120: @71442
     /* 71442 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(71508),
     /* 71447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 71450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 71453 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(71480), // Rule ID 3210 //
     /* 71458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 71461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 71473 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 71473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 71478 */     GIR_RootConstrainSelectedInstOperands,
     /* 71479 */     // GIR_Coverage, 3210,
     /* 71479 */     GIR_Done,
     /* 71480 */   // Label 2151: @71480
     /* 71480 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(71507), // Rule ID 5509 //
     /* 71485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 71488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71500 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 71500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 71505 */     GIR_RootConstrainSelectedInstOperands,
     /* 71506 */     // GIR_Coverage, 5509,
     /* 71506 */     GIR_Done,
     /* 71507 */   // Label 2152: @71507
     /* 71507 */   GIM_Reject,
     /* 71508 */ // Label 2150: @71508
     /* 71508 */ GIM_Reject,
     /* 71509 */ // Label 2121: @71509
     /* 71509 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(71542), // Rule ID 5521 //
     /* 71514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 71517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 71520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 71523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71535 */   // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 71535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 71540 */   GIR_RootConstrainSelectedInstOperands,
     /* 71541 */   // GIR_Coverage, 5521,
     /* 71541 */   GIR_Done,
     /* 71542 */ // Label 2153: @71542
     /* 71542 */ GIM_Reject,
     /* 71543 */ // Label 2122: @71543
     /* 71543 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(71576), // Rule ID 5503 //
     /* 71548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 71551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 71554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 71557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 71569 */   // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 71569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 71574 */   GIR_RootConstrainSelectedInstOperands,
     /* 71575 */   // GIR_Coverage, 5503,
     /* 71575 */   GIR_Done,
     /* 71576 */ // Label 2154: @71576
     /* 71576 */ GIM_Reject,
     /* 71577 */ // Label 2123: @71577
     /* 71577 */ GIM_Reject,
     /* 71578 */ // Label 48: @71578
     /* 71578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2167*/ GIMT_Encode4(72674),
     /* 71589 */ /*GILLT_v2s64*//*Label 2155*/ GIMT_Encode4(71657), GIMT_Encode4(0),
     /* 71597 */ /*GILLT_v4s32*//*Label 2156*/ GIMT_Encode4(71862),
     /* 71601 */ /*GILLT_v4s64*//*Label 2157*/ GIMT_Encode4(71956), GIMT_Encode4(0),
     /* 71609 */ /*GILLT_v8s16*//*Label 2158*/ GIMT_Encode4(72149),
     /* 71613 */ /*GILLT_v8s32*//*Label 2159*/ GIMT_Encode4(72243),
     /* 71617 */ /*GILLT_v8s64*//*Label 2160*/ GIMT_Encode4(72310), GIMT_Encode4(0),
     /* 71625 */ /*GILLT_v16s8*//*Label 2161*/ GIMT_Encode4(72344),
     /* 71629 */ /*GILLT_v16s16*//*Label 2162*/ GIMT_Encode4(72438),
     /* 71633 */ /*GILLT_v16s32*//*Label 2163*/ GIMT_Encode4(72505), GIMT_Encode4(0),
     /* 71641 */ /*GILLT_v32s8*//*Label 2164*/ GIMT_Encode4(72539),
     /* 71645 */ /*GILLT_v32s16*//*Label 2165*/ GIMT_Encode4(72606), GIMT_Encode4(0),
     /* 71653 */ /*GILLT_v64s8*//*Label 2166*/ GIMT_Encode4(72640),
     /* 71657 */ // Label 2155: @71657
     /* 71657 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(71861),
     /* 71662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 71665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 71668 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(71695), // Rule ID 5404 //
     /* 71673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71688 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 71688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 71693 */     GIR_RootConstrainSelectedInstOperands,
     /* 71694 */     // GIR_Coverage, 5404,
     /* 71694 */     GIR_Done,
     /* 71695 */   // Label 2169: @71695
     /* 71695 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(71860), // Rule ID 20457 //
     /* 71700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 71703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 71707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71715 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 71715 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 71718 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 71722 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 71729 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 71732 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 71736 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71741 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 71744 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 71748 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 71751 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 71756 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71761 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 71766 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 71769 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 71773 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 71780 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 71783 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 71787 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71792 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 71795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 71799 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 71802 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 71807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 71817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 71820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 71824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 71829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 71832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 71835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 71837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 71840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 71842 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 71849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 71854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 71859 */     // GIR_Coverage, 20457,
     /* 71859 */     GIR_EraseRootFromParent_Done,
     /* 71860 */   // Label 2170: @71860
     /* 71860 */   GIM_Reject,
     /* 71861 */ // Label 2168: @71861
     /* 71861 */ GIM_Reject,
     /* 71862 */ // Label 2156: @71862
     /* 71862 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(71955),
     /* 71867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 71870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 71873 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(71900), // Rule ID 3186 //
     /* 71878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 71881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71893 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 71893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 71898 */     GIR_RootConstrainSelectedInstOperands,
     /* 71899 */     // GIR_Coverage, 3186,
     /* 71899 */     GIR_Done,
     /* 71900 */   // Label 2172: @71900
     /* 71900 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(71927), // Rule ID 3228 //
     /* 71905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 71908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 71920 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 71920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 71925 */     GIR_RootConstrainSelectedInstOperands,
     /* 71926 */     // GIR_Coverage, 3228,
     /* 71926 */     GIR_Done,
     /* 71927 */   // Label 2173: @71927
     /* 71927 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(71954), // Rule ID 5377 //
     /* 71932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 71947 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 71947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 71952 */     GIR_RootConstrainSelectedInstOperands,
     /* 71953 */     // GIR_Coverage, 5377,
     /* 71953 */     GIR_Done,
     /* 71954 */   // Label 2174: @71954
     /* 71954 */   GIM_Reject,
     /* 71955 */ // Label 2171: @71955
     /* 71955 */ GIM_Reject,
     /* 71956 */ // Label 2157: @71956
     /* 71956 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(72148),
     /* 71961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 71964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 71967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 71979 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(71994), // Rule ID 5395 //
     /* 71984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 71987 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 71987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 71992 */     GIR_RootConstrainSelectedInstOperands,
     /* 71993 */     // GIR_Coverage, 5395,
     /* 71993 */     GIR_Done,
     /* 71994 */   // Label 2176: @71994
     /* 71994 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(72147), // Rule ID 20455 //
     /* 71999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 72002 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 72002 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 72005 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72009 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 72016 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 72019 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72023 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72028 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 72031 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 72035 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 72038 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72043 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72048 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 72053 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 72056 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72060 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 72067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 72070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72079 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 72082 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 72086 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 72089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 72104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 72107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 72111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 72119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 72122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 72124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 72127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 72129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 72136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 72141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72146 */     // GIR_Coverage, 20455,
     /* 72146 */     GIR_EraseRootFromParent_Done,
     /* 72147 */   // Label 2177: @72147
     /* 72147 */   GIM_Reject,
     /* 72148 */ // Label 2175: @72148
     /* 72148 */ GIM_Reject,
     /* 72149 */ // Label 2158: @72149
     /* 72149 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(72242),
     /* 72154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 72157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 72160 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(72187), // Rule ID 2651 //
     /* 72165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 72168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72180 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 72180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 72185 */     GIR_RootConstrainSelectedInstOperands,
     /* 72186 */     // GIR_Coverage, 2651,
     /* 72186 */     GIR_Done,
     /* 72187 */   // Label 2179: @72187
     /* 72187 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(72214), // Rule ID 2653 //
     /* 72192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 72195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72207 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 72207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 72212 */     GIR_RootConstrainSelectedInstOperands,
     /* 72213 */     // GIR_Coverage, 2653,
     /* 72213 */     GIR_Done,
     /* 72214 */   // Label 2180: @72214
     /* 72214 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(72241), // Rule ID 5353 //
     /* 72219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72234 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 72234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 72239 */     GIR_RootConstrainSelectedInstOperands,
     /* 72240 */     // GIR_Coverage, 5353,
     /* 72240 */     GIR_Done,
     /* 72241 */   // Label 2181: @72241
     /* 72241 */   GIM_Reject,
     /* 72242 */ // Label 2178: @72242
     /* 72242 */ GIM_Reject,
     /* 72243 */ // Label 2159: @72243
     /* 72243 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(72309),
     /* 72248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 72251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 72254 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(72281), // Rule ID 3204 //
     /* 72259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 72262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72274 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 72274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 72279 */     GIR_RootConstrainSelectedInstOperands,
     /* 72280 */     // GIR_Coverage, 3204,
     /* 72280 */     GIR_Done,
     /* 72281 */   // Label 2183: @72281
     /* 72281 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(72308), // Rule ID 5368 //
     /* 72286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 72289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72301 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 72301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 72306 */     GIR_RootConstrainSelectedInstOperands,
     /* 72307 */     // GIR_Coverage, 5368,
     /* 72307 */     GIR_Done,
     /* 72308 */   // Label 2184: @72308
     /* 72308 */   GIM_Reject,
     /* 72309 */ // Label 2182: @72309
     /* 72309 */ GIM_Reject,
     /* 72310 */ // Label 2160: @72310
     /* 72310 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(72343), // Rule ID 5386 //
     /* 72315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 72318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 72321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 72324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72336 */   // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 72336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 72341 */   GIR_RootConstrainSelectedInstOperands,
     /* 72342 */   // GIR_Coverage, 5386,
     /* 72342 */   GIR_Done,
     /* 72343 */ // Label 2185: @72343
     /* 72343 */ GIM_Reject,
     /* 72344 */ // Label 2161: @72344
     /* 72344 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(72437),
     /* 72349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 72352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 72355 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(72382), // Rule ID 3196 //
     /* 72360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 72363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72375 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 72375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 72380 */     GIR_RootConstrainSelectedInstOperands,
     /* 72381 */     // GIR_Coverage, 3196,
     /* 72381 */     GIR_Done,
     /* 72382 */   // Label 2187: @72382
     /* 72382 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(72409), // Rule ID 3226 //
     /* 72387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 72390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72402 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 72402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 72407 */     GIR_RootConstrainSelectedInstOperands,
     /* 72408 */     // GIR_Coverage, 3226,
     /* 72408 */     GIR_Done,
     /* 72409 */   // Label 2188: @72409
     /* 72409 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(72436), // Rule ID 5335 //
     /* 72414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72429 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 72429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 72434 */     GIR_RootConstrainSelectedInstOperands,
     /* 72435 */     // GIR_Coverage, 5335,
     /* 72435 */     GIR_Done,
     /* 72436 */   // Label 2189: @72436
     /* 72436 */   GIM_Reject,
     /* 72437 */ // Label 2186: @72437
     /* 72437 */ GIM_Reject,
     /* 72438 */ // Label 2162: @72438
     /* 72438 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(72504),
     /* 72443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 72446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 72449 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(72476), // Rule ID 2655 //
     /* 72454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 72457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72469 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 72469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 72474 */     GIR_RootConstrainSelectedInstOperands,
     /* 72475 */     // GIR_Coverage, 2655,
     /* 72475 */     GIR_Done,
     /* 72476 */   // Label 2191: @72476
     /* 72476 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(72503), // Rule ID 5347 //
     /* 72481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72496 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 72496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 72501 */     GIR_RootConstrainSelectedInstOperands,
     /* 72502 */     // GIR_Coverage, 5347,
     /* 72502 */     GIR_Done,
     /* 72503 */   // Label 2192: @72503
     /* 72503 */   GIM_Reject,
     /* 72504 */ // Label 2190: @72504
     /* 72504 */ GIM_Reject,
     /* 72505 */ // Label 2163: @72505
     /* 72505 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(72538), // Rule ID 5359 //
     /* 72510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 72513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 72516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 72519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72531 */   // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 72531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 72536 */   GIR_RootConstrainSelectedInstOperands,
     /* 72537 */   // GIR_Coverage, 5359,
     /* 72537 */   GIR_Done,
     /* 72538 */ // Label 2193: @72538
     /* 72538 */ GIM_Reject,
     /* 72539 */ // Label 2164: @72539
     /* 72539 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(72605),
     /* 72544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 72547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 72550 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(72577), // Rule ID 3214 //
     /* 72555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 72558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 72570 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 72570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 72575 */     GIR_RootConstrainSelectedInstOperands,
     /* 72576 */     // GIR_Coverage, 3214,
     /* 72576 */     GIR_Done,
     /* 72577 */   // Label 2195: @72577
     /* 72577 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(72604), // Rule ID 5329 //
     /* 72582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 72585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 72597 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 72597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 72602 */     GIR_RootConstrainSelectedInstOperands,
     /* 72603 */     // GIR_Coverage, 5329,
     /* 72603 */     GIR_Done,
     /* 72604 */   // Label 2196: @72604
     /* 72604 */   GIM_Reject,
     /* 72605 */ // Label 2194: @72605
     /* 72605 */ GIM_Reject,
     /* 72606 */ // Label 2165: @72606
     /* 72606 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(72639), // Rule ID 5341 //
     /* 72611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 72614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 72617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 72620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72632 */   // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 72632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 72637 */   GIR_RootConstrainSelectedInstOperands,
     /* 72638 */   // GIR_Coverage, 5341,
     /* 72638 */   GIR_Done,
     /* 72639 */ // Label 2197: @72639
     /* 72639 */ GIM_Reject,
     /* 72640 */ // Label 2166: @72640
     /* 72640 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(72673), // Rule ID 5323 //
     /* 72645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 72648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 72651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 72654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 72666 */   // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 72666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 72671 */   GIR_RootConstrainSelectedInstOperands,
     /* 72672 */   // GIR_Coverage, 5323,
     /* 72672 */   GIR_Done,
     /* 72673 */ // Label 2198: @72673
     /* 72673 */ GIM_Reject,
     /* 72674 */ // Label 2167: @72674
     /* 72674 */ GIM_Reject,
     /* 72675 */ // Label 49: @72675
     /* 72675 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2211*/ GIMT_Encode4(73771),
     /* 72686 */ /*GILLT_v2s64*//*Label 2199*/ GIMT_Encode4(72754), GIMT_Encode4(0),
     /* 72694 */ /*GILLT_v4s32*//*Label 2200*/ GIMT_Encode4(72959),
     /* 72698 */ /*GILLT_v4s64*//*Label 2201*/ GIMT_Encode4(73053), GIMT_Encode4(0),
     /* 72706 */ /*GILLT_v8s16*//*Label 2202*/ GIMT_Encode4(73246),
     /* 72710 */ /*GILLT_v8s32*//*Label 2203*/ GIMT_Encode4(73340),
     /* 72714 */ /*GILLT_v8s64*//*Label 2204*/ GIMT_Encode4(73407), GIMT_Encode4(0),
     /* 72722 */ /*GILLT_v16s8*//*Label 2205*/ GIMT_Encode4(73441),
     /* 72726 */ /*GILLT_v16s16*//*Label 2206*/ GIMT_Encode4(73535),
     /* 72730 */ /*GILLT_v16s32*//*Label 2207*/ GIMT_Encode4(73602), GIMT_Encode4(0),
     /* 72738 */ /*GILLT_v32s8*//*Label 2208*/ GIMT_Encode4(73636),
     /* 72742 */ /*GILLT_v32s16*//*Label 2209*/ GIMT_Encode4(73703), GIMT_Encode4(0),
     /* 72750 */ /*GILLT_v64s8*//*Label 2210*/ GIMT_Encode4(73737),
     /* 72754 */ // Label 2199: @72754
     /* 72754 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(72958),
     /* 72759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 72762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 72765 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(72792), // Rule ID 5674 //
     /* 72770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 72773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72785 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 72785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 72790 */     GIR_RootConstrainSelectedInstOperands,
     /* 72791 */     // GIR_Coverage, 5674,
     /* 72791 */     GIR_Done,
     /* 72792 */   // Label 2213: @72792
     /* 72792 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(72957), // Rule ID 20453 //
     /* 72797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 72800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 72804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 72812 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 72812 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 72815 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72819 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 72826 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 72829 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72833 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72838 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 72841 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 72845 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 72848 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72853 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72858 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 72863 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 72866 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 72870 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 72877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 72880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 72884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72889 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 72892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 72896 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 72899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 72904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 72914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 72917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 72921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 72926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 72929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 72932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 72934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 72937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 72939 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 72946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 72951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 72956 */     // GIR_Coverage, 20453,
     /* 72956 */     GIR_EraseRootFromParent_Done,
     /* 72957 */   // Label 2214: @72957
     /* 72957 */   GIM_Reject,
     /* 72958 */ // Label 2212: @72958
     /* 72958 */ GIM_Reject,
     /* 72959 */ // Label 2200: @72959
     /* 72959 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(73052),
     /* 72964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 72967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 72970 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(72997), // Rule ID 3184 //
     /* 72975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 72978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 72990 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 72990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 72995 */     GIR_RootConstrainSelectedInstOperands,
     /* 72996 */     // GIR_Coverage, 3184,
     /* 72996 */     GIR_Done,
     /* 72997 */   // Label 2216: @72997
     /* 72997 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(73024), // Rule ID 3222 //
     /* 73002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 73005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73017 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 73017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 73022 */     GIR_RootConstrainSelectedInstOperands,
     /* 73023 */     // GIR_Coverage, 3222,
     /* 73023 */     GIR_Done,
     /* 73024 */   // Label 2217: @73024
     /* 73024 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(73051), // Rule ID 5647 //
     /* 73029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73044 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 73044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 73049 */     GIR_RootConstrainSelectedInstOperands,
     /* 73050 */     // GIR_Coverage, 5647,
     /* 73050 */     GIR_Done,
     /* 73051 */   // Label 2218: @73051
     /* 73051 */   GIM_Reject,
     /* 73052 */ // Label 2215: @73052
     /* 73052 */ GIM_Reject,
     /* 73053 */ // Label 2201: @73053
     /* 73053 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(73245),
     /* 73058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 73061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 73064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73076 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(73091), // Rule ID 5665 //
     /* 73081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73084 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 73084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 73089 */     GIR_RootConstrainSelectedInstOperands,
     /* 73090 */     // GIR_Coverage, 5665,
     /* 73090 */     GIR_Done,
     /* 73091 */   // Label 2220: @73091
     /* 73091 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(73244), // Rule ID 20451 //
     /* 73096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 73099 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 73099 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 73102 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73106 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 73113 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 73116 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73120 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73125 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 73128 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 73132 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 73135 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73140 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73145 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 73150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 73153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 73164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 73167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 73179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 73183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 73186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 73201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 73204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 73208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 73216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 73219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 73221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 73224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 73226 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 73233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 73238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73243 */     // GIR_Coverage, 20451,
     /* 73243 */     GIR_EraseRootFromParent_Done,
     /* 73244 */   // Label 2221: @73244
     /* 73244 */   GIM_Reject,
     /* 73245 */ // Label 2219: @73245
     /* 73245 */ GIM_Reject,
     /* 73246 */ // Label 2202: @73246
     /* 73246 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(73339),
     /* 73251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 73254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 73257 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(73284), // Rule ID 3194 //
     /* 73262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 73265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73277 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 73277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 73282 */     GIR_RootConstrainSelectedInstOperands,
     /* 73283 */     // GIR_Coverage, 3194,
     /* 73283 */     GIR_Done,
     /* 73284 */   // Label 2223: @73284
     /* 73284 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(73311), // Rule ID 3224 //
     /* 73289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 73292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73304 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 73304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 73309 */     GIR_RootConstrainSelectedInstOperands,
     /* 73310 */     // GIR_Coverage, 3224,
     /* 73310 */     GIR_Done,
     /* 73311 */   // Label 2224: @73311
     /* 73311 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(73338), // Rule ID 5623 //
     /* 73316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73331 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 73331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 73336 */     GIR_RootConstrainSelectedInstOperands,
     /* 73337 */     // GIR_Coverage, 5623,
     /* 73337 */     GIR_Done,
     /* 73338 */   // Label 2225: @73338
     /* 73338 */   GIM_Reject,
     /* 73339 */ // Label 2222: @73339
     /* 73339 */ GIM_Reject,
     /* 73340 */ // Label 2203: @73340
     /* 73340 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(73406),
     /* 73345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 73348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 73351 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(73378), // Rule ID 3202 //
     /* 73356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 73359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73371 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 73371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 73376 */     GIR_RootConstrainSelectedInstOperands,
     /* 73377 */     // GIR_Coverage, 3202,
     /* 73377 */     GIR_Done,
     /* 73378 */   // Label 2227: @73378
     /* 73378 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(73405), // Rule ID 5638 //
     /* 73383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73398 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 73398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 73403 */     GIR_RootConstrainSelectedInstOperands,
     /* 73404 */     // GIR_Coverage, 5638,
     /* 73404 */     GIR_Done,
     /* 73405 */   // Label 2228: @73405
     /* 73405 */   GIM_Reject,
     /* 73406 */ // Label 2226: @73406
     /* 73406 */ GIM_Reject,
     /* 73407 */ // Label 2204: @73407
     /* 73407 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(73440), // Rule ID 5656 //
     /* 73412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 73415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 73418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 73421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73433 */   // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 73433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 73438 */   GIR_RootConstrainSelectedInstOperands,
     /* 73439 */   // GIR_Coverage, 5656,
     /* 73439 */   GIR_Done,
     /* 73440 */ // Label 2229: @73440
     /* 73440 */ GIM_Reject,
     /* 73441 */ // Label 2205: @73441
     /* 73441 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(73534),
     /* 73446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 73449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 73452 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(73479), // Rule ID 2633 //
     /* 73457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 73460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73472 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 73472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 73477 */     GIR_RootConstrainSelectedInstOperands,
     /* 73478 */     // GIR_Coverage, 2633,
     /* 73478 */     GIR_Done,
     /* 73479 */   // Label 2231: @73479
     /* 73479 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(73506), // Rule ID 2635 //
     /* 73484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 73487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 73499 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 73499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 73504 */     GIR_RootConstrainSelectedInstOperands,
     /* 73505 */     // GIR_Coverage, 2635,
     /* 73505 */     GIR_Done,
     /* 73506 */   // Label 2232: @73506
     /* 73506 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(73533), // Rule ID 5605 //
     /* 73511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73526 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 73526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 73531 */     GIR_RootConstrainSelectedInstOperands,
     /* 73532 */     // GIR_Coverage, 5605,
     /* 73532 */     GIR_Done,
     /* 73533 */   // Label 2233: @73533
     /* 73533 */   GIM_Reject,
     /* 73534 */ // Label 2230: @73534
     /* 73534 */ GIM_Reject,
     /* 73535 */ // Label 2206: @73535
     /* 73535 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(73601),
     /* 73540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 73543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 73546 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(73573), // Rule ID 3212 //
     /* 73551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 73554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73566 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 73566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 73571 */     GIR_RootConstrainSelectedInstOperands,
     /* 73572 */     // GIR_Coverage, 3212,
     /* 73572 */     GIR_Done,
     /* 73573 */   // Label 2235: @73573
     /* 73573 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(73600), // Rule ID 5617 //
     /* 73578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73593 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 73593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 73598 */     GIR_RootConstrainSelectedInstOperands,
     /* 73599 */     // GIR_Coverage, 5617,
     /* 73599 */     GIR_Done,
     /* 73600 */   // Label 2236: @73600
     /* 73600 */   GIM_Reject,
     /* 73601 */ // Label 2234: @73601
     /* 73601 */ GIM_Reject,
     /* 73602 */ // Label 2207: @73602
     /* 73602 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(73635), // Rule ID 5629 //
     /* 73607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 73610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 73613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 73616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73628 */   // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 73628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 73633 */   GIR_RootConstrainSelectedInstOperands,
     /* 73634 */   // GIR_Coverage, 5629,
     /* 73634 */   GIR_Done,
     /* 73635 */ // Label 2237: @73635
     /* 73635 */ GIM_Reject,
     /* 73636 */ // Label 2208: @73636
     /* 73636 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(73702),
     /* 73641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 73644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 73647 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(73674), // Rule ID 2637 //
     /* 73652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 73655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 73667 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 73667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 73672 */     GIR_RootConstrainSelectedInstOperands,
     /* 73673 */     // GIR_Coverage, 2637,
     /* 73673 */     GIR_Done,
     /* 73674 */   // Label 2239: @73674
     /* 73674 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(73701), // Rule ID 5599 //
     /* 73679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 73682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 73694 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 73694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 73699 */     GIR_RootConstrainSelectedInstOperands,
     /* 73700 */     // GIR_Coverage, 5599,
     /* 73700 */     GIR_Done,
     /* 73701 */   // Label 2240: @73701
     /* 73701 */   GIM_Reject,
     /* 73702 */ // Label 2238: @73702
     /* 73702 */ GIM_Reject,
     /* 73703 */ // Label 2209: @73703
     /* 73703 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(73736), // Rule ID 5611 //
     /* 73708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 73711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 73714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 73717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73729 */   // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 73729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 73734 */   GIR_RootConstrainSelectedInstOperands,
     /* 73735 */   // GIR_Coverage, 5611,
     /* 73735 */   GIR_Done,
     /* 73736 */ // Label 2241: @73736
     /* 73736 */ GIM_Reject,
     /* 73737 */ // Label 2210: @73737
     /* 73737 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(73770), // Rule ID 5593 //
     /* 73742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 73745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 73748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 73751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 73763 */   // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 73763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 73768 */   GIR_RootConstrainSelectedInstOperands,
     /* 73769 */   // GIR_Coverage, 5593,
     /* 73769 */   GIR_Done,
     /* 73770 */ // Label 2242: @73770
     /* 73770 */ GIM_Reject,
     /* 73771 */ // Label 2211: @73771
     /* 73771 */ GIM_Reject,
     /* 73772 */ // Label 50: @73772
     /* 73772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2255*/ GIMT_Encode4(74868),
     /* 73783 */ /*GILLT_v2s64*//*Label 2243*/ GIMT_Encode4(73851), GIMT_Encode4(0),
     /* 73791 */ /*GILLT_v4s32*//*Label 2244*/ GIMT_Encode4(74056),
     /* 73795 */ /*GILLT_v4s64*//*Label 2245*/ GIMT_Encode4(74150), GIMT_Encode4(0),
     /* 73803 */ /*GILLT_v8s16*//*Label 2246*/ GIMT_Encode4(74343),
     /* 73807 */ /*GILLT_v8s32*//*Label 2247*/ GIMT_Encode4(74437),
     /* 73811 */ /*GILLT_v8s64*//*Label 2248*/ GIMT_Encode4(74504), GIMT_Encode4(0),
     /* 73819 */ /*GILLT_v16s8*//*Label 2249*/ GIMT_Encode4(74538),
     /* 73823 */ /*GILLT_v16s16*//*Label 2250*/ GIMT_Encode4(74632),
     /* 73827 */ /*GILLT_v16s32*//*Label 2251*/ GIMT_Encode4(74699), GIMT_Encode4(0),
     /* 73835 */ /*GILLT_v32s8*//*Label 2252*/ GIMT_Encode4(74733),
     /* 73839 */ /*GILLT_v32s16*//*Label 2253*/ GIMT_Encode4(74800), GIMT_Encode4(0),
     /* 73847 */ /*GILLT_v64s8*//*Label 2254*/ GIMT_Encode4(74834),
     /* 73851 */ // Label 2243: @73851
     /* 73851 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(74055),
     /* 73856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 73859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 73862 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(73889), // Rule ID 5494 //
     /* 73867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 73870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73882 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 73882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 73887 */     GIR_RootConstrainSelectedInstOperands,
     /* 73888 */     // GIR_Coverage, 5494,
     /* 73888 */     GIR_Done,
     /* 73889 */   // Label 2257: @73889
     /* 73889 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(74054), // Rule ID 20449 //
     /* 73894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 73897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 73901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 73909 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 73909 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 73912 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73916 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 73923 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 73926 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73930 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73935 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 73938 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 73942 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 73945 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 73950 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 73955 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 73960 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 73963 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 73967 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 73974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 73977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 73981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 73986 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 73989 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 73993 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 73996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 74001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 74011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 74014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 74018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74023 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 74026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 74029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 74031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 74034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 74036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 74043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 74048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74053 */     // GIR_Coverage, 20449,
     /* 74053 */     GIR_EraseRootFromParent_Done,
     /* 74054 */   // Label 2258: @74054
     /* 74054 */   GIM_Reject,
     /* 74055 */ // Label 2256: @74055
     /* 74055 */ GIM_Reject,
     /* 74056 */ // Label 2244: @74056
     /* 74056 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(74149),
     /* 74061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 74064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 74067 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(74094), // Rule ID 3188 //
     /* 74072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 74075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74087 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 74087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 74092 */     GIR_RootConstrainSelectedInstOperands,
     /* 74093 */     // GIR_Coverage, 3188,
     /* 74093 */     GIR_Done,
     /* 74094 */   // Label 2260: @74094
     /* 74094 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(74121), // Rule ID 3230 //
     /* 74099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 74102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74114 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 74114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 74119 */     GIR_RootConstrainSelectedInstOperands,
     /* 74120 */     // GIR_Coverage, 3230,
     /* 74120 */     GIR_Done,
     /* 74121 */   // Label 2261: @74121
     /* 74121 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(74148), // Rule ID 5467 //
     /* 74126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74141 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 74141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 74146 */     GIR_RootConstrainSelectedInstOperands,
     /* 74147 */     // GIR_Coverage, 5467,
     /* 74147 */     GIR_Done,
     /* 74148 */   // Label 2262: @74148
     /* 74148 */   GIM_Reject,
     /* 74149 */ // Label 2259: @74149
     /* 74149 */ GIM_Reject,
     /* 74150 */ // Label 2245: @74150
     /* 74150 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(74342),
     /* 74155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 74158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 74161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74173 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(74188), // Rule ID 5485 //
     /* 74178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74181 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 74181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 74186 */     GIR_RootConstrainSelectedInstOperands,
     /* 74187 */     // GIR_Coverage, 5485,
     /* 74187 */     GIR_Done,
     /* 74188 */   // Label 2264: @74188
     /* 74188 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(74341), // Rule ID 20447 //
     /* 74193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 74196 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 74196 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 74199 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 74203 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 74210 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 74213 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 74217 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74222 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 74225 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 74229 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 74232 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 74237 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74242 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 74247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 74250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 74254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 74261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 74264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 74268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 74276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 74280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 74283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 74288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 74298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 74301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 74305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 74310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 74313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 74316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 74318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 74321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 74323 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 74330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 74335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 74340 */     // GIR_Coverage, 20447,
     /* 74340 */     GIR_EraseRootFromParent_Done,
     /* 74341 */   // Label 2265: @74341
     /* 74341 */   GIM_Reject,
     /* 74342 */ // Label 2263: @74342
     /* 74342 */ GIM_Reject,
     /* 74343 */ // Label 2246: @74343
     /* 74343 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(74436),
     /* 74348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 74351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 74354 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(74381), // Rule ID 3198 //
     /* 74359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 74362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74374 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 74374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 74379 */     GIR_RootConstrainSelectedInstOperands,
     /* 74380 */     // GIR_Coverage, 3198,
     /* 74380 */     GIR_Done,
     /* 74381 */   // Label 2267: @74381
     /* 74381 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(74408), // Rule ID 3232 //
     /* 74386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 74389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74401 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 74401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 74406 */     GIR_RootConstrainSelectedInstOperands,
     /* 74407 */     // GIR_Coverage, 3232,
     /* 74407 */     GIR_Done,
     /* 74408 */   // Label 2268: @74408
     /* 74408 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(74435), // Rule ID 5443 //
     /* 74413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74428 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 74428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 74433 */     GIR_RootConstrainSelectedInstOperands,
     /* 74434 */     // GIR_Coverage, 5443,
     /* 74434 */     GIR_Done,
     /* 74435 */   // Label 2269: @74435
     /* 74435 */   GIM_Reject,
     /* 74436 */ // Label 2266: @74436
     /* 74436 */ GIM_Reject,
     /* 74437 */ // Label 2247: @74437
     /* 74437 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(74503),
     /* 74442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 74445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 74448 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(74475), // Rule ID 3206 //
     /* 74453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 74456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74468 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 74468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 74473 */     GIR_RootConstrainSelectedInstOperands,
     /* 74474 */     // GIR_Coverage, 3206,
     /* 74474 */     GIR_Done,
     /* 74475 */   // Label 2271: @74475
     /* 74475 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(74502), // Rule ID 5458 //
     /* 74480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74495 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 74495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 74500 */     GIR_RootConstrainSelectedInstOperands,
     /* 74501 */     // GIR_Coverage, 5458,
     /* 74501 */     GIR_Done,
     /* 74502 */   // Label 2272: @74502
     /* 74502 */   GIM_Reject,
     /* 74503 */ // Label 2270: @74503
     /* 74503 */ GIM_Reject,
     /* 74504 */ // Label 2248: @74504
     /* 74504 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(74537), // Rule ID 5476 //
     /* 74509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 74512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 74515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 74518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74530 */   // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 74530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 74535 */   GIR_RootConstrainSelectedInstOperands,
     /* 74536 */   // GIR_Coverage, 5476,
     /* 74536 */   GIR_Done,
     /* 74537 */ // Label 2273: @74537
     /* 74537 */ GIM_Reject,
     /* 74538 */ // Label 2249: @74538
     /* 74538 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(74631),
     /* 74543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 74546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 74549 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(74576), // Rule ID 2645 //
     /* 74554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 74557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74569 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 74569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 74574 */     GIR_RootConstrainSelectedInstOperands,
     /* 74575 */     // GIR_Coverage, 2645,
     /* 74575 */     GIR_Done,
     /* 74576 */   // Label 2275: @74576
     /* 74576 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(74603), // Rule ID 2647 //
     /* 74581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 74584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 74596 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 74596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 74601 */     GIR_RootConstrainSelectedInstOperands,
     /* 74602 */     // GIR_Coverage, 2647,
     /* 74602 */     GIR_Done,
     /* 74603 */   // Label 2276: @74603
     /* 74603 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(74630), // Rule ID 5425 //
     /* 74608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74623 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 74623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 74628 */     GIR_RootConstrainSelectedInstOperands,
     /* 74629 */     // GIR_Coverage, 5425,
     /* 74629 */     GIR_Done,
     /* 74630 */   // Label 2277: @74630
     /* 74630 */   GIM_Reject,
     /* 74631 */ // Label 2274: @74631
     /* 74631 */ GIM_Reject,
     /* 74632 */ // Label 2250: @74632
     /* 74632 */ GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(74698),
     /* 74637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 74640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 74643 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(74670), // Rule ID 3216 //
     /* 74648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 74651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74663 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 74663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 74668 */     GIR_RootConstrainSelectedInstOperands,
     /* 74669 */     // GIR_Coverage, 3216,
     /* 74669 */     GIR_Done,
     /* 74670 */   // Label 2279: @74670
     /* 74670 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(74697), // Rule ID 5437 //
     /* 74675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74690 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 74690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 74695 */     GIR_RootConstrainSelectedInstOperands,
     /* 74696 */     // GIR_Coverage, 5437,
     /* 74696 */     GIR_Done,
     /* 74697 */   // Label 2280: @74697
     /* 74697 */   GIM_Reject,
     /* 74698 */ // Label 2278: @74698
     /* 74698 */ GIM_Reject,
     /* 74699 */ // Label 2251: @74699
     /* 74699 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(74732), // Rule ID 5449 //
     /* 74704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 74707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 74710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 74713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74725 */   // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 74725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 74730 */   GIR_RootConstrainSelectedInstOperands,
     /* 74731 */   // GIR_Coverage, 5449,
     /* 74731 */   GIR_Done,
     /* 74732 */ // Label 2281: @74732
     /* 74732 */ GIM_Reject,
     /* 74733 */ // Label 2252: @74733
     /* 74733 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(74799),
     /* 74738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 74741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 74744 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(74771), // Rule ID 2649 //
     /* 74749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 74752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 74764 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 74764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 74769 */     GIR_RootConstrainSelectedInstOperands,
     /* 74770 */     // GIR_Coverage, 2649,
     /* 74770 */     GIR_Done,
     /* 74771 */   // Label 2283: @74771
     /* 74771 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(74798), // Rule ID 5419 //
     /* 74776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 74779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 74791 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 74791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 74796 */     GIR_RootConstrainSelectedInstOperands,
     /* 74797 */     // GIR_Coverage, 5419,
     /* 74797 */     GIR_Done,
     /* 74798 */   // Label 2284: @74798
     /* 74798 */   GIM_Reject,
     /* 74799 */ // Label 2282: @74799
     /* 74799 */ GIM_Reject,
     /* 74800 */ // Label 2253: @74800
     /* 74800 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(74833), // Rule ID 5431 //
     /* 74805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 74808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 74811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 74814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74826 */   // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 74826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 74831 */   GIR_RootConstrainSelectedInstOperands,
     /* 74832 */   // GIR_Coverage, 5431,
     /* 74832 */   GIR_Done,
     /* 74833 */ // Label 2285: @74833
     /* 74833 */ GIM_Reject,
     /* 74834 */ // Label 2254: @74834
     /* 74834 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(74867), // Rule ID 5413 //
     /* 74839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 74842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 74845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 74848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 74860 */   // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 74860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 74865 */   GIR_RootConstrainSelectedInstOperands,
     /* 74866 */   // GIR_Coverage, 5413,
     /* 74866 */   GIR_Done,
     /* 74867 */ // Label 2286: @74867
     /* 74867 */ GIM_Reject,
     /* 74868 */ // Label 2255: @74868
     /* 74868 */ GIM_Reject,
     /* 74869 */ // Label 51: @74869
     /* 74869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2299*/ GIMT_Encode4(75733),
     /* 74880 */ /*GILLT_v2s64*//*Label 2287*/ GIMT_Encode4(74948), GIMT_Encode4(0),
     /* 74888 */ /*GILLT_v4s32*//*Label 2288*/ GIMT_Encode4(75088),
     /* 74892 */ /*GILLT_v4s64*//*Label 2289*/ GIMT_Encode4(75167), GIMT_Encode4(0),
     /* 74900 */ /*GILLT_v8s16*//*Label 2290*/ GIMT_Encode4(75299),
     /* 74904 */ /*GILLT_v8s32*//*Label 2291*/ GIMT_Encode4(75378),
     /* 74908 */ /*GILLT_v8s64*//*Label 2292*/ GIMT_Encode4(75434), GIMT_Encode4(0),
     /* 74916 */ /*GILLT_v16s8*//*Label 2293*/ GIMT_Encode4(75461),
     /* 74920 */ /*GILLT_v16s16*//*Label 2294*/ GIMT_Encode4(75540),
     /* 74924 */ /*GILLT_v16s32*//*Label 2295*/ GIMT_Encode4(75596), GIMT_Encode4(0),
     /* 74932 */ /*GILLT_v32s8*//*Label 2296*/ GIMT_Encode4(75623),
     /* 74936 */ /*GILLT_v32s16*//*Label 2297*/ GIMT_Encode4(75679), GIMT_Encode4(0),
     /* 74944 */ /*GILLT_v64s8*//*Label 2298*/ GIMT_Encode4(75706),
     /* 74948 */ // Label 2287: @74948
     /* 74948 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(75087),
     /* 74953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 74956 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(74979), // Rule ID 13261 //
     /* 74961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 74964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74972 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 74972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 74977 */     GIR_RootConstrainSelectedInstOperands,
     /* 74978 */     // GIR_Coverage, 13261,
     /* 74978 */     GIR_Done,
     /* 74979 */   // Label 2301: @74979
     /* 74979 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(75086), // Rule ID 22271 //
     /* 74984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 74987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 74991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 74995 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 74995 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 74998 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 75002 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 75009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 75012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 75016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75021 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 75024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 75028 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 75031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 75036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 75041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 75046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 75049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 75053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75058 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 75061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 75063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75068 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 75075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 75080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 75085 */     // GIR_Coverage, 22271,
     /* 75085 */     GIR_EraseRootFromParent_Done,
     /* 75086 */   // Label 2302: @75086
     /* 75086 */   GIM_Reject,
     /* 75087 */ // Label 2300: @75087
     /* 75087 */ GIM_Reject,
     /* 75088 */ // Label 2288: @75088
     /* 75088 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(75166),
     /* 75093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 75096 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(75119), // Rule ID 2991 //
     /* 75101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 75104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75112 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 75112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 75117 */     GIR_RootConstrainSelectedInstOperands,
     /* 75118 */     // GIR_Coverage, 2991,
     /* 75118 */     GIR_Done,
     /* 75119 */   // Label 2304: @75119
     /* 75119 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(75142), // Rule ID 3003 //
     /* 75124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 75127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75135 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 75135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 75140 */     GIR_RootConstrainSelectedInstOperands,
     /* 75141 */     // GIR_Coverage, 3003,
     /* 75141 */     GIR_Done,
     /* 75142 */   // Label 2305: @75142
     /* 75142 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(75165), // Rule ID 13288 //
     /* 75147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 75150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75158 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 75158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 75163 */     GIR_RootConstrainSelectedInstOperands,
     /* 75164 */     // GIR_Coverage, 13288,
     /* 75164 */     GIR_Done,
     /* 75165 */   // Label 2306: @75165
     /* 75165 */   GIM_Reject,
     /* 75166 */ // Label 2303: @75166
     /* 75166 */ GIM_Reject,
     /* 75167 */ // Label 2289: @75167
     /* 75167 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(75298),
     /* 75172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 75175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75183 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(75198), // Rule ID 13252 //
     /* 75188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 75191 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 75191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 75196 */     GIR_RootConstrainSelectedInstOperands,
     /* 75197 */     // GIR_Coverage, 13252,
     /* 75197 */     GIR_Done,
     /* 75198 */   // Label 2308: @75198
     /* 75198 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(75297), // Rule ID 22270 //
     /* 75203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 75206 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 75206 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 75209 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 75213 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 75220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 75223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 75227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75232 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 75235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 75239 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 75242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 75247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 75252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 75257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 75260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 75264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 75269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 75272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 75274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75279 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 75286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 75291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 75296 */     // GIR_Coverage, 22270,
     /* 75296 */     GIR_EraseRootFromParent_Done,
     /* 75297 */   // Label 2309: @75297
     /* 75297 */   GIM_Reject,
     /* 75298 */ // Label 2307: @75298
     /* 75298 */ GIM_Reject,
     /* 75299 */ // Label 2290: @75299
     /* 75299 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(75377),
     /* 75304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 75307 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(75330), // Rule ID 2989 //
     /* 75312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 75315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75323 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 75323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 75328 */     GIR_RootConstrainSelectedInstOperands,
     /* 75329 */     // GIR_Coverage, 2989,
     /* 75329 */     GIR_Done,
     /* 75330 */   // Label 2311: @75330
     /* 75330 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(75353), // Rule ID 3001 //
     /* 75335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 75338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75346 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 75346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 75351 */     GIR_RootConstrainSelectedInstOperands,
     /* 75352 */     // GIR_Coverage, 3001,
     /* 75352 */     GIR_Done,
     /* 75353 */   // Label 2312: @75353
     /* 75353 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(75376), // Rule ID 13309 //
     /* 75358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75369 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 75369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 75374 */     GIR_RootConstrainSelectedInstOperands,
     /* 75375 */     // GIR_Coverage, 13309,
     /* 75375 */     GIR_Done,
     /* 75376 */   // Label 2313: @75376
     /* 75376 */   GIM_Reject,
     /* 75377 */ // Label 2310: @75377
     /* 75377 */ GIM_Reject,
     /* 75378 */ // Label 2291: @75378
     /* 75378 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(75433),
     /* 75383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 75386 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(75409), // Rule ID 2997 //
     /* 75391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 75394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75402 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 75402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 75407 */     GIR_RootConstrainSelectedInstOperands,
     /* 75408 */     // GIR_Coverage, 2997,
     /* 75408 */     GIR_Done,
     /* 75409 */   // Label 2315: @75409
     /* 75409 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(75432), // Rule ID 13279 //
     /* 75414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 75417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75425 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 75425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 75430 */     GIR_RootConstrainSelectedInstOperands,
     /* 75431 */     // GIR_Coverage, 13279,
     /* 75431 */     GIR_Done,
     /* 75432 */   // Label 2316: @75432
     /* 75432 */   GIM_Reject,
     /* 75433 */ // Label 2314: @75433
     /* 75433 */ GIM_Reject,
     /* 75434 */ // Label 2292: @75434
     /* 75434 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(75460), // Rule ID 13243 //
     /* 75439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 75442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 75445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75453 */   // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 75453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 75458 */   GIR_RootConstrainSelectedInstOperands,
     /* 75459 */   // GIR_Coverage, 13243,
     /* 75459 */   GIR_Done,
     /* 75460 */ // Label 2317: @75460
     /* 75460 */ GIM_Reject,
     /* 75461 */ // Label 2293: @75461
     /* 75461 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(75539),
     /* 75466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 75469 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(75492), // Rule ID 2987 //
     /* 75474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 75477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75485 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 75485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 75490 */     GIR_RootConstrainSelectedInstOperands,
     /* 75491 */     // GIR_Coverage, 2987,
     /* 75491 */     GIR_Done,
     /* 75492 */   // Label 2319: @75492
     /* 75492 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(75515), // Rule ID 2999 //
     /* 75497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 75500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 75508 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 75508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 75513 */     GIR_RootConstrainSelectedInstOperands,
     /* 75514 */     // GIR_Coverage, 2999,
     /* 75514 */     GIR_Done,
     /* 75515 */   // Label 2320: @75515
     /* 75515 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(75538), // Rule ID 13327 //
     /* 75520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 75531 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 75531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 75536 */     GIR_RootConstrainSelectedInstOperands,
     /* 75537 */     // GIR_Coverage, 13327,
     /* 75537 */     GIR_Done,
     /* 75538 */   // Label 2321: @75538
     /* 75538 */   GIM_Reject,
     /* 75539 */ // Label 2318: @75539
     /* 75539 */ GIM_Reject,
     /* 75540 */ // Label 2294: @75540
     /* 75540 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(75595),
     /* 75545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 75548 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(75571), // Rule ID 2995 //
     /* 75553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 75556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75564 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 75564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 75569 */     GIR_RootConstrainSelectedInstOperands,
     /* 75570 */     // GIR_Coverage, 2995,
     /* 75570 */     GIR_Done,
     /* 75571 */   // Label 2323: @75571
     /* 75571 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(75594), // Rule ID 13303 //
     /* 75576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75587 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 75587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 75592 */     GIR_RootConstrainSelectedInstOperands,
     /* 75593 */     // GIR_Coverage, 13303,
     /* 75593 */     GIR_Done,
     /* 75594 */   // Label 2324: @75594
     /* 75594 */   GIM_Reject,
     /* 75595 */ // Label 2322: @75595
     /* 75595 */ GIM_Reject,
     /* 75596 */ // Label 2295: @75596
     /* 75596 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(75622), // Rule ID 13270 //
     /* 75601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 75604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 75607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75615 */   // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 75615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 75620 */   GIR_RootConstrainSelectedInstOperands,
     /* 75621 */   // GIR_Coverage, 13270,
     /* 75621 */   GIR_Done,
     /* 75622 */ // Label 2325: @75622
     /* 75622 */ GIM_Reject,
     /* 75623 */ // Label 2296: @75623
     /* 75623 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(75678),
     /* 75628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 75631 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(75654), // Rule ID 2993 //
     /* 75636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 75639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 75647 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 75647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 75652 */     GIR_RootConstrainSelectedInstOperands,
     /* 75653 */     // GIR_Coverage, 2993,
     /* 75653 */     GIR_Done,
     /* 75654 */   // Label 2327: @75654
     /* 75654 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(75677), // Rule ID 13321 //
     /* 75659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 75662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 75670 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 75670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 75675 */     GIR_RootConstrainSelectedInstOperands,
     /* 75676 */     // GIR_Coverage, 13321,
     /* 75676 */     GIR_Done,
     /* 75677 */   // Label 2328: @75677
     /* 75677 */   GIM_Reject,
     /* 75678 */ // Label 2326: @75678
     /* 75678 */ GIM_Reject,
     /* 75679 */ // Label 2297: @75679
     /* 75679 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(75705), // Rule ID 13297 //
     /* 75684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 75687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 75690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75698 */   // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 75698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 75703 */   GIR_RootConstrainSelectedInstOperands,
     /* 75704 */   // GIR_Coverage, 13297,
     /* 75704 */   GIR_Done,
     /* 75705 */ // Label 2329: @75705
     /* 75705 */ GIM_Reject,
     /* 75706 */ // Label 2298: @75706
     /* 75706 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(75732), // Rule ID 13315 //
     /* 75711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 75714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 75717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 75725 */   // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 75725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 75730 */   GIR_RootConstrainSelectedInstOperands,
     /* 75731 */   // GIR_Coverage, 13315,
     /* 75731 */   GIR_Done,
     /* 75732 */ // Label 2330: @75732
     /* 75732 */ GIM_Reject,
     /* 75733 */ // Label 2299: @75733
     /* 75733 */ GIM_Reject,
     /* 75734 */ // Label 52: @75734
     /* 75734 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(75749), // Rule ID 628 //
     /* 75739 */   // MIs[0] dst
     /* 75739 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 75742 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 75742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 75747 */   GIR_RootConstrainSelectedInstOperands,
     /* 75748 */   // GIR_Coverage, 628,
     /* 75748 */   GIR_Done,
     /* 75749 */ // Label 2331: @75749
     /* 75749 */ GIM_Reject,
     /* 75750 */ // Label 53: @75750
     /* 75750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 2346*/ GIMT_Encode4(78678),
     /* 75761 */ /*GILLT_s1*//*Label 2332*/ GIMT_Encode4(75849), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 75789 */ /*GILLT_v2s1*//*Label 2333*/ GIMT_Encode4(76090),
     /* 75793 */ /*GILLT_v2s64*//*Label 2334*/ GIMT_Encode4(76291),
     /* 75797 */ /*GILLT_v4s1*//*Label 2335*/ GIMT_Encode4(76772),
     /* 75801 */ /*GILLT_v4s32*//*Label 2336*/ GIMT_Encode4(76933),
     /* 75805 */ /*GILLT_v4s64*//*Label 2337*/ GIMT_Encode4(77414),
     /* 75809 */ /*GILLT_v8s1*//*Label 2338*/ GIMT_Encode4(77497),
     /* 75813 */ /*GILLT_v8s16*//*Label 2339*/ GIMT_Encode4(77618),
     /* 75817 */ /*GILLT_v8s32*//*Label 2340*/ GIMT_Encode4(78099), GIMT_Encode4(0),
     /* 75825 */ /*GILLT_v16s1*//*Label 2341*/ GIMT_Encode4(78182),
     /* 75829 */ /*GILLT_v16s8*//*Label 2342*/ GIMT_Encode4(78263),
     /* 75833 */ /*GILLT_v16s16*//*Label 2343*/ GIMT_Encode4(78504), GIMT_Encode4(0),
     /* 75841 */ /*GILLT_v32s1*//*Label 2344*/ GIMT_Encode4(78587),
     /* 75845 */ /*GILLT_v32s8*//*Label 2345*/ GIMT_Encode4(78628),
     /* 75849 */ // Label 2332: @75849
     /* 75849 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(75889), // Rule ID 20049 //
     /* 75854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 75857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 75865 */   // MIs[0] Operand 2
     /* 75865 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75876 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 75876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75888 */   // GIR_Coverage, 20049,
     /* 75888 */   GIR_EraseRootFromParent_Done,
     /* 75889 */ // Label 2347: @75889
     /* 75889 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(75929), // Rule ID 20051 //
     /* 75894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 75897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 75905 */   // MIs[0] Operand 2
     /* 75905 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75916 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 75916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75921 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75928 */   // GIR_Coverage, 20051,
     /* 75928 */   GIR_EraseRootFromParent_Done,
     /* 75929 */ // Label 2348: @75929
     /* 75929 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(75969), // Rule ID 20053 //
     /* 75934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 75937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 75945 */   // MIs[0] Operand 2
     /* 75945 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75956 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 75956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 75961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 75963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 75968 */   // GIR_Coverage, 20053,
     /* 75968 */   GIR_EraseRootFromParent_Done,
     /* 75969 */ // Label 2349: @75969
     /* 75969 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(76009), // Rule ID 20055 //
     /* 75974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 75977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 75981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 75985 */   // MIs[0] Operand 2
     /* 75985 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 75996 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 75996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 75999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 76008 */   // GIR_Coverage, 20055,
     /* 76008 */   GIR_EraseRootFromParent_Done,
     /* 76009 */ // Label 2350: @76009
     /* 76009 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(76049), // Rule ID 20057 //
     /* 76014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 76017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 76021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 76025 */   // MIs[0] Operand 2
     /* 76025 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76036 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 76036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 76048 */   // GIR_Coverage, 20057,
     /* 76048 */   GIR_EraseRootFromParent_Done,
     /* 76049 */ // Label 2351: @76049
     /* 76049 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(76089), // Rule ID 20059 //
     /* 76054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 76057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 76061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 76065 */   // MIs[0] Operand 2
     /* 76065 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76076 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 76076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 76088 */   // GIR_Coverage, 20059,
     /* 76088 */   GIR_EraseRootFromParent_Done,
     /* 76089 */ // Label 2352: @76089
     /* 76089 */ GIM_Reject,
     /* 76090 */ // Label 2333: @76090
     /* 76090 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(76130), // Rule ID 20061 //
     /* 76095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 76098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 76102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76106 */   // MIs[0] Operand 2
     /* 76106 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76117 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 76117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76122 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 76129 */   // GIR_Coverage, 20061,
     /* 76129 */   GIR_EraseRootFromParent_Done,
     /* 76130 */ // Label 2353: @76130
     /* 76130 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(76170), // Rule ID 20063 //
     /* 76135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 76138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 76142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 76146 */   // MIs[0] Operand 2
     /* 76146 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76157 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 76157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76162 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 76169 */   // GIR_Coverage, 20063,
     /* 76169 */   GIR_EraseRootFromParent_Done,
     /* 76170 */ // Label 2354: @76170
     /* 76170 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(76210), // Rule ID 20065 //
     /* 76175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 76178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 76182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 76186 */   // MIs[0] Operand 2
     /* 76186 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76197 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 76197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 76209 */   // GIR_Coverage, 20065,
     /* 76209 */   GIR_EraseRootFromParent_Done,
     /* 76210 */ // Label 2355: @76210
     /* 76210 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(76250), // Rule ID 20067 //
     /* 76215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 76218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 76222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 76226 */   // MIs[0] Operand 2
     /* 76226 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76237 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 76237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 76249 */   // GIR_Coverage, 20067,
     /* 76249 */   GIR_EraseRootFromParent_Done,
     /* 76250 */ // Label 2356: @76250
     /* 76250 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(76290), // Rule ID 20069 //
     /* 76255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 76258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 76262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 76266 */   // MIs[0] Operand 2
     /* 76266 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76277 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 76277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76282 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 76289 */   // GIR_Coverage, 20069,
     /* 76289 */   GIR_EraseRootFromParent_Done,
     /* 76290 */ // Label 2357: @76290
     /* 76290 */ GIM_Reject,
     /* 76291 */ // Label 2334: @76291
     /* 76291 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(76362), // Rule ID 19500 //
     /* 76296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 76299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 76306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76310 */   // MIs[0] Operand 2
     /* 76310 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76321 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76333 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76339 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 76352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76360 */   GIR_RootConstrainSelectedInstOperands,
     /* 76361 */   // GIR_Coverage, 19500,
     /* 76361 */   GIR_EraseRootFromParent_Done,
     /* 76362 */ // Label 2358: @76362
     /* 76362 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(76433), // Rule ID 19501 //
     /* 76367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 76370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 76377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76381 */   // MIs[0] Operand 2
     /* 76381 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76392 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76404 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 76423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76431 */   GIR_RootConstrainSelectedInstOperands,
     /* 76432 */   // GIR_Coverage, 19501,
     /* 76432 */   GIR_EraseRootFromParent_Done,
     /* 76433 */ // Label 2359: @76433
     /* 76433 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(76504), // Rule ID 19507 //
     /* 76438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 76441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 76448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76452 */   // MIs[0] Operand 2
     /* 76452 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76463 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76475 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 76494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76502 */   GIR_RootConstrainSelectedInstOperands,
     /* 76503 */   // GIR_Coverage, 19507,
     /* 76503 */   GIR_EraseRootFromParent_Done,
     /* 76504 */ // Label 2360: @76504
     /* 76504 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(76575), // Rule ID 19508 //
     /* 76509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 76512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 76519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76523 */   // MIs[0] Operand 2
     /* 76523 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 76534 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 76537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76546 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 76565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 76573 */   GIR_RootConstrainSelectedInstOperands,
     /* 76574 */   // GIR_Coverage, 19508,
     /* 76574 */   GIR_EraseRootFromParent_Done,
     /* 76575 */ // Label 2361: @76575
     /* 76575 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(76624), // Rule ID 23452 //
     /* 76580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 76583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 76587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 76591 */   // MIs[0] Operand 2
     /* 76591 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76602 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 76602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76607 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 76618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 76623 */   // GIR_Coverage, 23452,
     /* 76623 */   GIR_EraseRootFromParent_Done,
     /* 76624 */ // Label 2362: @76624
     /* 76624 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(76673), // Rule ID 23455 //
     /* 76629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 76632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 76636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 76640 */   // MIs[0] Operand 2
     /* 76640 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76651 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 76651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76656 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 76667 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 76672 */   // GIR_Coverage, 23455,
     /* 76672 */   GIR_EraseRootFromParent_Done,
     /* 76673 */ // Label 2363: @76673
     /* 76673 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(76722), // Rule ID 23473 //
     /* 76678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 76685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76689 */   // MIs[0] Operand 2
     /* 76689 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76700 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 76700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76705 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 76716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76721 */   // GIR_Coverage, 23473,
     /* 76721 */   GIR_EraseRootFromParent_Done,
     /* 76722 */ // Label 2364: @76722
     /* 76722 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(76771), // Rule ID 23476 //
     /* 76727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 76730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 76734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76738 */   // MIs[0] Operand 2
     /* 76738 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76749 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 76749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76754 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 76760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 76765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76770 */   // GIR_Coverage, 23476,
     /* 76770 */   GIR_EraseRootFromParent_Done,
     /* 76771 */ // Label 2365: @76771
     /* 76771 */ GIM_Reject,
     /* 76772 */ // Label 2335: @76772
     /* 76772 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(76812), // Rule ID 20071 //
     /* 76777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 76780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 76788 */   // MIs[0] Operand 2
     /* 76788 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76799 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 76799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76804 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76811 */   // GIR_Coverage, 20071,
     /* 76811 */   GIR_EraseRootFromParent_Done,
     /* 76812 */ // Label 2366: @76812
     /* 76812 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(76852), // Rule ID 20073 //
     /* 76817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 76820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 76828 */   // MIs[0] Operand 2
     /* 76828 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76839 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 76839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76851 */   // GIR_Coverage, 20073,
     /* 76851 */   GIR_EraseRootFromParent_Done,
     /* 76852 */ // Label 2367: @76852
     /* 76852 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(76892), // Rule ID 20075 //
     /* 76857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 76860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 76868 */   // MIs[0] Operand 2
     /* 76868 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76879 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 76879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76884 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76891 */   // GIR_Coverage, 20075,
     /* 76891 */   GIR_EraseRootFromParent_Done,
     /* 76892 */ // Label 2368: @76892
     /* 76892 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(76932), // Rule ID 20077 //
     /* 76897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 76900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 76904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 76908 */   // MIs[0] Operand 2
     /* 76908 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 76919 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 76919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 76926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 76931 */   // GIR_Coverage, 20077,
     /* 76931 */   GIR_EraseRootFromParent_Done,
     /* 76932 */ // Label 2369: @76932
     /* 76932 */ GIM_Reject,
     /* 76933 */ // Label 2336: @76933
     /* 76933 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(77004), // Rule ID 19502 //
     /* 76938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 76941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 76944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 76948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 76952 */   // MIs[0] Operand 2
     /* 76952 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 76963 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 76963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 76966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 76970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 76975 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 76981 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 76986 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 76991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 76994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 76996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 76999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77002 */   GIR_RootConstrainSelectedInstOperands,
     /* 77003 */   // GIR_Coverage, 19502,
     /* 77003 */   GIR_EraseRootFromParent_Done,
     /* 77004 */ // Label 2370: @77004
     /* 77004 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(77075), // Rule ID 19503 //
     /* 77009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 77012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 77015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 77019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77023 */   // MIs[0] Operand 2
     /* 77023 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 77034 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 77037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77046 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 77065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77073 */   GIR_RootConstrainSelectedInstOperands,
     /* 77074 */   // GIR_Coverage, 19503,
     /* 77074 */   GIR_EraseRootFromParent_Done,
     /* 77075 */ // Label 2371: @77075
     /* 77075 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(77146), // Rule ID 19509 //
     /* 77080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 77086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77094 */   // MIs[0] Operand 2
     /* 77094 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 77105 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 77108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77117 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77123 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 77136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77144 */   GIR_RootConstrainSelectedInstOperands,
     /* 77145 */   // GIR_Coverage, 19509,
     /* 77145 */   GIR_EraseRootFromParent_Done,
     /* 77146 */ // Label 2372: @77146
     /* 77146 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(77217), // Rule ID 19510 //
     /* 77151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 77157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77165 */   // MIs[0] Operand 2
     /* 77165 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 77176 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 77179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77188 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77194 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 77207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77215 */   GIR_RootConstrainSelectedInstOperands,
     /* 77216 */   // GIR_Coverage, 19510,
     /* 77216 */   GIR_EraseRootFromParent_Done,
     /* 77217 */ // Label 2373: @77217
     /* 77217 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(77266), // Rule ID 23446 //
     /* 77222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 77225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 77229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 77233 */   // MIs[0] Operand 2
     /* 77233 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77244 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 77244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77249 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 77260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 77265 */   // GIR_Coverage, 23446,
     /* 77265 */   GIR_EraseRootFromParent_Done,
     /* 77266 */ // Label 2374: @77266
     /* 77266 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(77315), // Rule ID 23449 //
     /* 77271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 77274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 77278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 77282 */   // MIs[0] Operand 2
     /* 77282 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77293 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 77293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77298 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 77309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 77314 */   // GIR_Coverage, 23449,
     /* 77314 */   GIR_EraseRootFromParent_Done,
     /* 77315 */ // Label 2375: @77315
     /* 77315 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(77364), // Rule ID 23467 //
     /* 77320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 77323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 77327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77331 */   // MIs[0] Operand 2
     /* 77331 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77342 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 77342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77347 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 77358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77363 */   // GIR_Coverage, 23467,
     /* 77363 */   GIR_EraseRootFromParent_Done,
     /* 77364 */ // Label 2376: @77364
     /* 77364 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(77413), // Rule ID 23470 //
     /* 77369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 77372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 77376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77380 */   // MIs[0] Operand 2
     /* 77380 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77391 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 77391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77396 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 77407 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77412 */   // GIR_Coverage, 23470,
     /* 77412 */   GIR_EraseRootFromParent_Done,
     /* 77413 */ // Label 2377: @77413
     /* 77413 */ GIM_Reject,
     /* 77414 */ // Label 2337: @77414
     /* 77414 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(77496),
     /* 77419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 77422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 77426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77430 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77441 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(77468), // Rule ID 23494 //
     /* 77446 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77451 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77467 */     // GIR_Coverage, 23494,
     /* 77467 */     GIR_EraseRootFromParent_Done,
     /* 77468 */   // Label 2379: @77468
     /* 77468 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(77495), // Rule ID 23497 //
     /* 77473 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 77473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77478 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77494 */     // GIR_Coverage, 23497,
     /* 77494 */     GIR_EraseRootFromParent_Done,
     /* 77495 */   // Label 2380: @77495
     /* 77495 */   GIM_Reject,
     /* 77496 */ // Label 2378: @77496
     /* 77496 */ GIM_Reject,
     /* 77497 */ // Label 2338: @77497
     /* 77497 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(77537), // Rule ID 20079 //
     /* 77502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 77505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 77509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 77513 */   // MIs[0] Operand 2
     /* 77513 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77524 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 77524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 77536 */   // GIR_Coverage, 20079,
     /* 77536 */   GIR_EraseRootFromParent_Done,
     /* 77537 */ // Label 2381: @77537
     /* 77537 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(77577), // Rule ID 20081 //
     /* 77542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 77545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 77549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 77553 */   // MIs[0] Operand 2
     /* 77553 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77564 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 77564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77569 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 77576 */   // GIR_Coverage, 20081,
     /* 77576 */   GIR_EraseRootFromParent_Done,
     /* 77577 */ // Label 2382: @77577
     /* 77577 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(77617), // Rule ID 20083 //
     /* 77582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 77585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 77589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 77593 */   // MIs[0] Operand 2
     /* 77593 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77604 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 77604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 77611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 77616 */   // GIR_Coverage, 20083,
     /* 77616 */   GIR_EraseRootFromParent_Done,
     /* 77617 */ // Label 2383: @77617
     /* 77617 */ GIM_Reject,
     /* 77618 */ // Label 2339: @77618
     /* 77618 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(77689), // Rule ID 19504 //
     /* 77623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 77626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 77633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77637 */   // MIs[0] Operand 2
     /* 77637 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77648 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77660 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 77679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77687 */   GIR_RootConstrainSelectedInstOperands,
     /* 77688 */   // GIR_Coverage, 19504,
     /* 77688 */   GIR_EraseRootFromParent_Done,
     /* 77689 */ // Label 2384: @77689
     /* 77689 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(77760), // Rule ID 19505 //
     /* 77694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 77697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 77704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77708 */   // MIs[0] Operand 2
     /* 77708 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77719 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77731 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 77750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77758 */   GIR_RootConstrainSelectedInstOperands,
     /* 77759 */   // GIR_Coverage, 19505,
     /* 77759 */   GIR_EraseRootFromParent_Done,
     /* 77760 */ // Label 2385: @77760
     /* 77760 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(77831), // Rule ID 19511 //
     /* 77765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77779 */   // MIs[0] Operand 2
     /* 77779 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77790 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77802 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 77821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77829 */   GIR_RootConstrainSelectedInstOperands,
     /* 77830 */   // GIR_Coverage, 19511,
     /* 77830 */   GIR_EraseRootFromParent_Done,
     /* 77831 */ // Label 2386: @77831
     /* 77831 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(77902), // Rule ID 19512 //
     /* 77836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 77839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 77842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 77846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 77850 */   // MIs[0] Operand 2
     /* 77850 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 77861 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 77861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 77864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 77873 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 77879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 77884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 77889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 77892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 77897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 77900 */   GIR_RootConstrainSelectedInstOperands,
     /* 77901 */   // GIR_Coverage, 19512,
     /* 77901 */   GIR_EraseRootFromParent_Done,
     /* 77902 */ // Label 2387: @77902
     /* 77902 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(77951), // Rule ID 23458 //
     /* 77907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 77910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 77914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 77918 */   // MIs[0] Operand 2
     /* 77918 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77929 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 77929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77934 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 77945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 77950 */   // GIR_Coverage, 23458,
     /* 77950 */   GIR_EraseRootFromParent_Done,
     /* 77951 */ // Label 2388: @77951
     /* 77951 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(78000), // Rule ID 23464 //
     /* 77956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 77959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 77963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 77967 */   // MIs[0] Operand 2
     /* 77967 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 77978 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 77978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 77981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 77983 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 77989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 77994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 77999 */   // GIR_Coverage, 23464,
     /* 77999 */   GIR_EraseRootFromParent_Done,
     /* 78000 */ // Label 2389: @78000
     /* 78000 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(78049), // Rule ID 23479 //
     /* 78005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 78008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 78012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78016 */   // MIs[0] Operand 2
     /* 78016 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78027 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 78027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78032 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 78038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 78043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78048 */   // GIR_Coverage, 23479,
     /* 78048 */   GIR_EraseRootFromParent_Done,
     /* 78049 */ // Label 2390: @78049
     /* 78049 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(78098), // Rule ID 23485 //
     /* 78054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 78057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 78061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78065 */   // MIs[0] Operand 2
     /* 78065 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78076 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 78076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78081 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 78087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 78092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78097 */   // GIR_Coverage, 23485,
     /* 78097 */   GIR_EraseRootFromParent_Done,
     /* 78098 */ // Label 2391: @78098
     /* 78098 */ GIM_Reject,
     /* 78099 */ // Label 2340: @78099
     /* 78099 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(78181),
     /* 78104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 78107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78115 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78126 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(78153), // Rule ID 23488 //
     /* 78131 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 78131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78136 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78152 */     // GIR_Coverage, 23488,
     /* 78152 */     GIR_EraseRootFromParent_Done,
     /* 78153 */   // Label 2393: @78153
     /* 78153 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(78180), // Rule ID 23491 //
     /* 78158 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 78158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78163 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78179 */     // GIR_Coverage, 23491,
     /* 78179 */     GIR_EraseRootFromParent_Done,
     /* 78180 */   // Label 2394: @78180
     /* 78180 */   GIM_Reject,
     /* 78181 */ // Label 2392: @78181
     /* 78181 */ GIM_Reject,
     /* 78182 */ // Label 2341: @78182
     /* 78182 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(78222), // Rule ID 20085 //
     /* 78187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 78190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 78194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 78198 */   // MIs[0] Operand 2
     /* 78198 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78209 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 78209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 78221 */   // GIR_Coverage, 20085,
     /* 78221 */   GIR_EraseRootFromParent_Done,
     /* 78222 */ // Label 2395: @78222
     /* 78222 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(78262), // Rule ID 20087 //
     /* 78227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 78230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 78234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 78238 */   // MIs[0] Operand 2
     /* 78238 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78249 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 78249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 78261 */   // GIR_Coverage, 20087,
     /* 78261 */   GIR_EraseRootFromParent_Done,
     /* 78262 */ // Label 2396: @78262
     /* 78262 */ GIM_Reject,
     /* 78263 */ // Label 2342: @78263
     /* 78263 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(78334), // Rule ID 19506 //
     /* 78268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 78271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 78274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 78278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78282 */   // MIs[0] Operand 2
     /* 78282 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 78293 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 78293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 78296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 78305 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 78324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 78329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 78332 */   GIR_RootConstrainSelectedInstOperands,
     /* 78333 */   // GIR_Coverage, 19506,
     /* 78333 */   GIR_EraseRootFromParent_Done,
     /* 78334 */ // Label 2397: @78334
     /* 78334 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(78405), // Rule ID 19513 //
     /* 78339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 78342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 78345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78353 */   // MIs[0] Operand 2
     /* 78353 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 78364 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 78364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 78367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 78376 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78382 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 78395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 78400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 78403 */   GIR_RootConstrainSelectedInstOperands,
     /* 78404 */   // GIR_Coverage, 19513,
     /* 78404 */   GIR_EraseRootFromParent_Done,
     /* 78405 */ // Label 2398: @78405
     /* 78405 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(78454), // Rule ID 23461 //
     /* 78410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 78413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 78417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 78421 */   // MIs[0] Operand 2
     /* 78421 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78432 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 78432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78437 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 78443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 78448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 78453 */   // GIR_Coverage, 23461,
     /* 78453 */   GIR_EraseRootFromParent_Done,
     /* 78454 */ // Label 2399: @78454
     /* 78454 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(78503), // Rule ID 23482 //
     /* 78459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 78462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 78466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78470 */   // MIs[0] Operand 2
     /* 78470 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78481 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 78481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78486 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 78492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 78497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78502 */   // GIR_Coverage, 23482,
     /* 78502 */   GIR_EraseRootFromParent_Done,
     /* 78503 */ // Label 2400: @78503
     /* 78503 */ GIM_Reject,
     /* 78504 */ // Label 2343: @78504
     /* 78504 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(78586),
     /* 78509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 78512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78520 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78531 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(78558), // Rule ID 23500 //
     /* 78536 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 78536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78541 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78557 */     // GIR_Coverage, 23500,
     /* 78557 */     GIR_EraseRootFromParent_Done,
     /* 78558 */   // Label 2402: @78558
     /* 78558 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(78585), // Rule ID 23506 //
     /* 78563 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 78563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78568 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78584 */     // GIR_Coverage, 23506,
     /* 78584 */     GIR_EraseRootFromParent_Done,
     /* 78585 */   // Label 2403: @78585
     /* 78585 */   GIM_Reject,
     /* 78586 */ // Label 2401: @78586
     /* 78586 */ GIM_Reject,
     /* 78587 */ // Label 2344: @78587
     /* 78587 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(78627), // Rule ID 20089 //
     /* 78592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 78595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 78599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 78603 */   // MIs[0] Operand 2
     /* 78603 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78614 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 78614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78619 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 78626 */   // GIR_Coverage, 20089,
     /* 78626 */   GIR_EraseRootFromParent_Done,
     /* 78627 */ // Label 2404: @78627
     /* 78627 */ GIM_Reject,
     /* 78628 */ // Label 2345: @78628
     /* 78628 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(78677), // Rule ID 23503 //
     /* 78633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 78636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 78640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 78644 */   // MIs[0] Operand 2
     /* 78644 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 78655 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 78655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 78658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78660 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 78666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 78671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 78676 */   // GIR_Coverage, 23503,
     /* 78676 */   GIR_EraseRootFromParent_Done,
     /* 78677 */ // Label 2405: @78677
     /* 78677 */ GIM_Reject,
     /* 78678 */ // Label 2346: @78678
     /* 78678 */ GIM_Reject,
     /* 78679 */ // Label 54: @78679
     /* 78679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2418*/ GIMT_Encode4(80660),
     /* 78690 */ /*GILLT_v2s64*//*Label 2406*/ GIMT_Encode4(78758), GIMT_Encode4(0),
     /* 78698 */ /*GILLT_v4s32*//*Label 2407*/ GIMT_Encode4(78960),
     /* 78702 */ /*GILLT_v4s64*//*Label 2408*/ GIMT_Encode4(79162), GIMT_Encode4(0),
     /* 78710 */ /*GILLT_v8s16*//*Label 2409*/ GIMT_Encode4(79364),
     /* 78714 */ /*GILLT_v8s32*//*Label 2410*/ GIMT_Encode4(79479),
     /* 78718 */ /*GILLT_v8s64*//*Label 2411*/ GIMT_Encode4(79681), GIMT_Encode4(0),
     /* 78726 */ /*GILLT_v16s8*//*Label 2412*/ GIMT_Encode4(79883),
     /* 78730 */ /*GILLT_v16s16*//*Label 2413*/ GIMT_Encode4(79998),
     /* 78734 */ /*GILLT_v16s32*//*Label 2414*/ GIMT_Encode4(80113), GIMT_Encode4(0),
     /* 78742 */ /*GILLT_v32s8*//*Label 2415*/ GIMT_Encode4(80315),
     /* 78746 */ /*GILLT_v32s16*//*Label 2416*/ GIMT_Encode4(80430), GIMT_Encode4(0),
     /* 78754 */ /*GILLT_v64s8*//*Label 2417*/ GIMT_Encode4(80545),
     /* 78758 */ // Label 2406: @78758
     /* 78758 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(78959),
     /* 78763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 78766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 78769 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 78772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 78784 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(78817), // Rule ID 22143 //
     /* 78789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78806 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 78806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 78809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78811 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78815 */     GIR_RootConstrainSelectedInstOperands,
     /* 78816 */     // GIR_Coverage, 22143,
     /* 78816 */     GIR_EraseRootFromParent_Done,
     /* 78817 */   // Label 2420: @78817
     /* 78817 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(78850), // Rule ID 22179 //
     /* 78822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78829 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 78835 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 78837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78839 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 78839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 78842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78844 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78848 */     GIR_RootConstrainSelectedInstOperands,
     /* 78849 */     // GIR_Coverage, 22179,
     /* 78849 */     GIR_EraseRootFromParent_Done,
     /* 78850 */   // Label 2421: @78850
     /* 78850 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(78879), // Rule ID 22142 //
     /* 78855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78868 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 78868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 78871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78873 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78877 */     GIR_RootConstrainSelectedInstOperands,
     /* 78878 */     // GIR_Coverage, 22142,
     /* 78878 */     GIR_EraseRootFromParent_Done,
     /* 78879 */   // Label 2422: @78879
     /* 78879 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(78908), // Rule ID 22178 //
     /* 78884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 78895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 78897 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 78897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 78900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78902 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78906 */     GIR_RootConstrainSelectedInstOperands,
     /* 78907 */     // GIR_Coverage, 22178,
     /* 78907 */     GIR_EraseRootFromParent_Done,
     /* 78908 */   // Label 2423: @78908
     /* 78908 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(78933), // Rule ID 22144 //
     /* 78913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78920 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 78920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 78923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78925 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78927 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78931 */     GIR_RootConstrainSelectedInstOperands,
     /* 78932 */     // GIR_Coverage, 22144,
     /* 78932 */     GIR_EraseRootFromParent_Done,
     /* 78933 */   // Label 2424: @78933
     /* 78933 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(78958), // Rule ID 22180 //
     /* 78938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78945 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 78945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 78948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 78950 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 78952 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 78954 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 78956 */     GIR_RootConstrainSelectedInstOperands,
     /* 78957 */     // GIR_Coverage, 22180,
     /* 78957 */     GIR_EraseRootFromParent_Done,
     /* 78958 */   // Label 2425: @78958
     /* 78958 */   GIM_Reject,
     /* 78959 */ // Label 2419: @78959
     /* 78959 */ GIM_Reject,
     /* 78960 */ // Label 2407: @78960
     /* 78960 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(79161),
     /* 78965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 78968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 78971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 78974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 78982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 78986 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(79019), // Rule ID 22125 //
     /* 78991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 78994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 78998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79008 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 79008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 79011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79013 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79017 */     GIR_RootConstrainSelectedInstOperands,
     /* 79018 */     // GIR_Coverage, 22125,
     /* 79018 */     GIR_EraseRootFromParent_Done,
     /* 79019 */   // Label 2427: @79019
     /* 79019 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(79052), // Rule ID 22161 //
     /* 79024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79031 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79037 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79041 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 79041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 79044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79046 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79048 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79050 */     GIR_RootConstrainSelectedInstOperands,
     /* 79051 */     // GIR_Coverage, 22161,
     /* 79051 */     GIR_EraseRootFromParent_Done,
     /* 79052 */   // Label 2428: @79052
     /* 79052 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(79081), // Rule ID 22124 //
     /* 79057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79070 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 79070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 79073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79075 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79079 */     GIR_RootConstrainSelectedInstOperands,
     /* 79080 */     // GIR_Coverage, 22124,
     /* 79080 */     GIR_EraseRootFromParent_Done,
     /* 79081 */   // Label 2429: @79081
     /* 79081 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(79110), // Rule ID 22160 //
     /* 79086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79099 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 79099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 79102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79104 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79106 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79108 */     GIR_RootConstrainSelectedInstOperands,
     /* 79109 */     // GIR_Coverage, 22160,
     /* 79109 */     GIR_EraseRootFromParent_Done,
     /* 79110 */   // Label 2430: @79110
     /* 79110 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(79135), // Rule ID 22126 //
     /* 79115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79122 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 79122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 79125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79127 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79129 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79131 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79133 */     GIR_RootConstrainSelectedInstOperands,
     /* 79134 */     // GIR_Coverage, 22126,
     /* 79134 */     GIR_EraseRootFromParent_Done,
     /* 79135 */   // Label 2431: @79135
     /* 79135 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(79160), // Rule ID 22162 //
     /* 79140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79147 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 79147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 79150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79152 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79154 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79158 */     GIR_RootConstrainSelectedInstOperands,
     /* 79159 */     // GIR_Coverage, 22162,
     /* 79159 */     GIR_EraseRootFromParent_Done,
     /* 79160 */   // Label 2432: @79160
     /* 79160 */   GIM_Reject,
     /* 79161 */ // Label 2426: @79161
     /* 79161 */ GIM_Reject,
     /* 79162 */ // Label 2408: @79162
     /* 79162 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(79363),
     /* 79167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 79170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 79173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 79176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 79188 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(79221), // Rule ID 22137 //
     /* 79193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79210 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 79210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 79213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79215 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79219 */     GIR_RootConstrainSelectedInstOperands,
     /* 79220 */     // GIR_Coverage, 22137,
     /* 79220 */     GIR_EraseRootFromParent_Done,
     /* 79221 */   // Label 2434: @79221
     /* 79221 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(79254), // Rule ID 22173 //
     /* 79226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79243 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 79243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 79246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79248 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79252 */     GIR_RootConstrainSelectedInstOperands,
     /* 79253 */     // GIR_Coverage, 22173,
     /* 79253 */     GIR_EraseRootFromParent_Done,
     /* 79254 */   // Label 2435: @79254
     /* 79254 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(79283), // Rule ID 22136 //
     /* 79259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79272 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 79272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 79275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79277 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79281 */     GIR_RootConstrainSelectedInstOperands,
     /* 79282 */     // GIR_Coverage, 22136,
     /* 79282 */     GIR_EraseRootFromParent_Done,
     /* 79283 */   // Label 2436: @79283
     /* 79283 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(79312), // Rule ID 22172 //
     /* 79288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79301 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 79301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 79304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79306 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79308 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79310 */     GIR_RootConstrainSelectedInstOperands,
     /* 79311 */     // GIR_Coverage, 22172,
     /* 79311 */     GIR_EraseRootFromParent_Done,
     /* 79312 */   // Label 2437: @79312
     /* 79312 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(79337), // Rule ID 22138 //
     /* 79317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79324 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 79324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 79327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79329 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79331 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79335 */     GIR_RootConstrainSelectedInstOperands,
     /* 79336 */     // GIR_Coverage, 22138,
     /* 79336 */     GIR_EraseRootFromParent_Done,
     /* 79337 */   // Label 2438: @79337
     /* 79337 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(79362), // Rule ID 22174 //
     /* 79342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79349 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 79349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 79352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79354 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79356 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79360 */     GIR_RootConstrainSelectedInstOperands,
     /* 79361 */     // GIR_Coverage, 22174,
     /* 79361 */     GIR_EraseRootFromParent_Done,
     /* 79362 */   // Label 2439: @79362
     /* 79362 */   GIM_Reject,
     /* 79363 */ // Label 2433: @79363
     /* 79363 */ GIM_Reject,
     /* 79364 */ // Label 2409: @79364
     /* 79364 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(79478),
     /* 79369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 79372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 79375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 79378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 79390 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(79423), // Rule ID 22545 //
     /* 79395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79412 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 79412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 79415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79417 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79421 */     GIR_RootConstrainSelectedInstOperands,
     /* 79422 */     // GIR_Coverage, 22545,
     /* 79422 */     GIR_EraseRootFromParent_Done,
     /* 79423 */   // Label 2441: @79423
     /* 79423 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(79452), // Rule ID 22544 //
     /* 79428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79441 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 79441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 79444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79446 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79450 */     GIR_RootConstrainSelectedInstOperands,
     /* 79451 */     // GIR_Coverage, 22544,
     /* 79451 */     GIR_EraseRootFromParent_Done,
     /* 79452 */   // Label 2442: @79452
     /* 79452 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(79477), // Rule ID 22546 //
     /* 79457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79464 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 79464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 79467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79469 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79471 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79475 */     GIR_RootConstrainSelectedInstOperands,
     /* 79476 */     // GIR_Coverage, 22546,
     /* 79476 */     GIR_EraseRootFromParent_Done,
     /* 79477 */   // Label 2443: @79477
     /* 79477 */   GIM_Reject,
     /* 79478 */ // Label 2440: @79478
     /* 79478 */ GIM_Reject,
     /* 79479 */ // Label 2410: @79479
     /* 79479 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(79680),
     /* 79484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 79487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 79490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 79493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 79505 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(79538), // Rule ID 22119 //
     /* 79510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79517 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79523 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79527 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 79527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 79530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79532 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79536 */     GIR_RootConstrainSelectedInstOperands,
     /* 79537 */     // GIR_Coverage, 22119,
     /* 79537 */     GIR_EraseRootFromParent_Done,
     /* 79538 */   // Label 2445: @79538
     /* 79538 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(79571), // Rule ID 22155 //
     /* 79543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79550 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79556 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79560 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 79560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 79563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79565 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79569 */     GIR_RootConstrainSelectedInstOperands,
     /* 79570 */     // GIR_Coverage, 22155,
     /* 79570 */     GIR_EraseRootFromParent_Done,
     /* 79571 */   // Label 2446: @79571
     /* 79571 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(79600), // Rule ID 22118 //
     /* 79576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79589 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 79589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 79592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79594 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79596 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79598 */     GIR_RootConstrainSelectedInstOperands,
     /* 79599 */     // GIR_Coverage, 22118,
     /* 79599 */     GIR_EraseRootFromParent_Done,
     /* 79600 */   // Label 2447: @79600
     /* 79600 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(79629), // Rule ID 22154 //
     /* 79605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79618 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 79618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 79621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79623 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79627 */     GIR_RootConstrainSelectedInstOperands,
     /* 79628 */     // GIR_Coverage, 22154,
     /* 79628 */     GIR_EraseRootFromParent_Done,
     /* 79629 */   // Label 2448: @79629
     /* 79629 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(79654), // Rule ID 22120 //
     /* 79634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79641 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 79641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 79644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79646 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79648 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79652 */     GIR_RootConstrainSelectedInstOperands,
     /* 79653 */     // GIR_Coverage, 22120,
     /* 79653 */     GIR_EraseRootFromParent_Done,
     /* 79654 */   // Label 2449: @79654
     /* 79654 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(79679), // Rule ID 22156 //
     /* 79659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 79662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 79666 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 79666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 79669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79671 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79673 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79677 */     GIR_RootConstrainSelectedInstOperands,
     /* 79678 */     // GIR_Coverage, 22156,
     /* 79678 */     GIR_EraseRootFromParent_Done,
     /* 79679 */   // Label 2450: @79679
     /* 79679 */   GIM_Reject,
     /* 79680 */ // Label 2444: @79680
     /* 79680 */ GIM_Reject,
     /* 79681 */ // Label 2411: @79681
     /* 79681 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(79882),
     /* 79686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 79689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 79692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 79695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 79707 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(79740), // Rule ID 22131 //
     /* 79712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79725 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79729 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 79729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 79732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79734 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79738 */     GIR_RootConstrainSelectedInstOperands,
     /* 79739 */     // GIR_Coverage, 22131,
     /* 79739 */     GIR_EraseRootFromParent_Done,
     /* 79740 */   // Label 2452: @79740
     /* 79740 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(79773), // Rule ID 22167 //
     /* 79745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79758 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79762 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 79762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 79765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79767 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79771 */     GIR_RootConstrainSelectedInstOperands,
     /* 79772 */     // GIR_Coverage, 22167,
     /* 79772 */     GIR_EraseRootFromParent_Done,
     /* 79773 */   // Label 2453: @79773
     /* 79773 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(79802), // Rule ID 22130 //
     /* 79778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79791 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 79791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 79794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79796 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79800 */     GIR_RootConstrainSelectedInstOperands,
     /* 79801 */     // GIR_Coverage, 22130,
     /* 79801 */     GIR_EraseRootFromParent_Done,
     /* 79802 */   // Label 2454: @79802
     /* 79802 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(79831), // Rule ID 22166 //
     /* 79807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79820 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 79820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 79823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79825 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79829 */     GIR_RootConstrainSelectedInstOperands,
     /* 79830 */     // GIR_Coverage, 22166,
     /* 79830 */     GIR_EraseRootFromParent_Done,
     /* 79831 */   // Label 2455: @79831
     /* 79831 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(79856), // Rule ID 22132 //
     /* 79836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79843 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 79843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 79846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79848 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79850 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79854 */     GIR_RootConstrainSelectedInstOperands,
     /* 79855 */     // GIR_Coverage, 22132,
     /* 79855 */     GIR_EraseRootFromParent_Done,
     /* 79856 */   // Label 2456: @79856
     /* 79856 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(79881), // Rule ID 22168 //
     /* 79861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 79864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 79868 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 79868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 79871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79873 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79875 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79879 */     GIR_RootConstrainSelectedInstOperands,
     /* 79880 */     // GIR_Coverage, 22168,
     /* 79880 */     GIR_EraseRootFromParent_Done,
     /* 79881 */   // Label 2457: @79881
     /* 79881 */   GIM_Reject,
     /* 79882 */ // Label 2451: @79882
     /* 79882 */ GIM_Reject,
     /* 79883 */ // Label 2412: @79883
     /* 79883 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(79997),
     /* 79888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 79891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 79894 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 79897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 79909 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(79942), // Rule ID 22527 //
     /* 79914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79921 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 79927 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 79929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79931 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 79931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 79934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79936 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79940 */     GIR_RootConstrainSelectedInstOperands,
     /* 79941 */     // GIR_Coverage, 22527,
     /* 79941 */     GIR_EraseRootFromParent_Done,
     /* 79942 */   // Label 2459: @79942
     /* 79942 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(79971), // Rule ID 22526 //
     /* 79947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 79954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 79958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 79960 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 79960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 79963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79965 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79969 */     GIR_RootConstrainSelectedInstOperands,
     /* 79970 */     // GIR_Coverage, 22526,
     /* 79970 */     GIR_EraseRootFromParent_Done,
     /* 79971 */   // Label 2460: @79971
     /* 79971 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(79996), // Rule ID 22528 //
     /* 79976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 79979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 79983 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 79983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 79986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 79988 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 79990 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 79992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 79994 */     GIR_RootConstrainSelectedInstOperands,
     /* 79995 */     // GIR_Coverage, 22528,
     /* 79995 */     GIR_EraseRootFromParent_Done,
     /* 79996 */   // Label 2461: @79996
     /* 79996 */   GIM_Reject,
     /* 79997 */ // Label 2458: @79997
     /* 79997 */ GIM_Reject,
     /* 79998 */ // Label 2413: @79998
     /* 79998 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(80112),
     /* 80003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 80006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 80009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 80012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 80024 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(80057), // Rule ID 22539 //
     /* 80029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80036 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80042 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80046 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 80046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 80049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80051 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80055 */     GIR_RootConstrainSelectedInstOperands,
     /* 80056 */     // GIR_Coverage, 22539,
     /* 80056 */     GIR_EraseRootFromParent_Done,
     /* 80057 */   // Label 2463: @80057
     /* 80057 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(80086), // Rule ID 22538 //
     /* 80062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80075 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 80075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 80078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80080 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80084 */     GIR_RootConstrainSelectedInstOperands,
     /* 80085 */     // GIR_Coverage, 22538,
     /* 80085 */     GIR_EraseRootFromParent_Done,
     /* 80086 */   // Label 2464: @80086
     /* 80086 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(80111), // Rule ID 22540 //
     /* 80091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80098 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 80098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 80101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80103 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80105 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80109 */     GIR_RootConstrainSelectedInstOperands,
     /* 80110 */     // GIR_Coverage, 22540,
     /* 80110 */     GIR_EraseRootFromParent_Done,
     /* 80111 */   // Label 2465: @80111
     /* 80111 */   GIM_Reject,
     /* 80112 */ // Label 2462: @80112
     /* 80112 */ GIM_Reject,
     /* 80113 */ // Label 2414: @80113
     /* 80113 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(80314),
     /* 80118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 80121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 80124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 80127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 80139 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(80172), // Rule ID 22113 //
     /* 80144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 80147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80157 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80161 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 80161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 80164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80166 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80170 */     GIR_RootConstrainSelectedInstOperands,
     /* 80171 */     // GIR_Coverage, 22113,
     /* 80171 */     GIR_EraseRootFromParent_Done,
     /* 80172 */   // Label 2467: @80172
     /* 80172 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(80205), // Rule ID 22149 //
     /* 80177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 80180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80184 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80190 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80194 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 80194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 80197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80199 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80203 */     GIR_RootConstrainSelectedInstOperands,
     /* 80204 */     // GIR_Coverage, 22149,
     /* 80204 */     GIR_EraseRootFromParent_Done,
     /* 80205 */   // Label 2468: @80205
     /* 80205 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(80234), // Rule ID 22112 //
     /* 80210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 80213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80223 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 80223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 80226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80228 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80230 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80232 */     GIR_RootConstrainSelectedInstOperands,
     /* 80233 */     // GIR_Coverage, 22112,
     /* 80233 */     GIR_EraseRootFromParent_Done,
     /* 80234 */   // Label 2469: @80234
     /* 80234 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(80263), // Rule ID 22148 //
     /* 80239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 80242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80252 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 80252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 80255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80257 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80259 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80261 */     GIR_RootConstrainSelectedInstOperands,
     /* 80262 */     // GIR_Coverage, 22148,
     /* 80262 */     GIR_EraseRootFromParent_Done,
     /* 80263 */   // Label 2470: @80263
     /* 80263 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(80288), // Rule ID 22114 //
     /* 80268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 80271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80275 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 80275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 80278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80280 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80282 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80286 */     GIR_RootConstrainSelectedInstOperands,
     /* 80287 */     // GIR_Coverage, 22114,
     /* 80287 */     GIR_EraseRootFromParent_Done,
     /* 80288 */   // Label 2471: @80288
     /* 80288 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(80313), // Rule ID 22150 //
     /* 80293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 80296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80300 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 80300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 80303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80305 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80307 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80311 */     GIR_RootConstrainSelectedInstOperands,
     /* 80312 */     // GIR_Coverage, 22150,
     /* 80312 */     GIR_EraseRootFromParent_Done,
     /* 80313 */   // Label 2472: @80313
     /* 80313 */   GIM_Reject,
     /* 80314 */ // Label 2466: @80314
     /* 80314 */ GIM_Reject,
     /* 80315 */ // Label 2415: @80315
     /* 80315 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(80429),
     /* 80320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 80323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 80326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 80329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 80341 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(80374), // Rule ID 22521 //
     /* 80346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80363 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 80363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 80366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80368 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80372 */     GIR_RootConstrainSelectedInstOperands,
     /* 80373 */     // GIR_Coverage, 22521,
     /* 80373 */     GIR_EraseRootFromParent_Done,
     /* 80374 */   // Label 2474: @80374
     /* 80374 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(80403), // Rule ID 22520 //
     /* 80379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80392 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 80392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 80395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80397 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80401 */     GIR_RootConstrainSelectedInstOperands,
     /* 80402 */     // GIR_Coverage, 22520,
     /* 80402 */     GIR_EraseRootFromParent_Done,
     /* 80403 */   // Label 2475: @80403
     /* 80403 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(80428), // Rule ID 22522 //
     /* 80408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 80411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 80415 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 80415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 80418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80420 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80422 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80426 */     GIR_RootConstrainSelectedInstOperands,
     /* 80427 */     // GIR_Coverage, 22522,
     /* 80427 */     GIR_EraseRootFromParent_Done,
     /* 80428 */   // Label 2476: @80428
     /* 80428 */   GIM_Reject,
     /* 80429 */ // Label 2473: @80429
     /* 80429 */ GIM_Reject,
     /* 80430 */ // Label 2416: @80430
     /* 80430 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(80544),
     /* 80435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 80438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 80441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 80444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 80456 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(80489), // Rule ID 22533 //
     /* 80461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80478 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 80478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 80481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80483 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80487 */     GIR_RootConstrainSelectedInstOperands,
     /* 80488 */     // GIR_Coverage, 22533,
     /* 80488 */     GIR_EraseRootFromParent_Done,
     /* 80489 */   // Label 2478: @80489
     /* 80489 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(80518), // Rule ID 22532 //
     /* 80494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80507 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 80507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 80510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80512 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80516 */     GIR_RootConstrainSelectedInstOperands,
     /* 80517 */     // GIR_Coverage, 22532,
     /* 80517 */     GIR_EraseRootFromParent_Done,
     /* 80518 */   // Label 2479: @80518
     /* 80518 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(80543), // Rule ID 22534 //
     /* 80523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80530 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 80530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 80533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80535 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80537 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80541 */     GIR_RootConstrainSelectedInstOperands,
     /* 80542 */     // GIR_Coverage, 22534,
     /* 80542 */     GIR_EraseRootFromParent_Done,
     /* 80543 */   // Label 2480: @80543
     /* 80543 */   GIM_Reject,
     /* 80544 */ // Label 2477: @80544
     /* 80544 */ GIM_Reject,
     /* 80545 */ // Label 2417: @80545
     /* 80545 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(80659),
     /* 80550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 80553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 80556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 80559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 80571 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(80604), // Rule ID 22515 //
     /* 80576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 80589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 80591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80593 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 80593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 80596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80598 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80602 */     GIR_RootConstrainSelectedInstOperands,
     /* 80603 */     // GIR_Coverage, 22515,
     /* 80603 */     GIR_EraseRootFromParent_Done,
     /* 80604 */   // Label 2482: @80604
     /* 80604 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(80633), // Rule ID 22514 //
     /* 80609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 80616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 80620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 80622 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 80622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 80625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80627 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80629 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80631 */     GIR_RootConstrainSelectedInstOperands,
     /* 80632 */     // GIR_Coverage, 22514,
     /* 80632 */     GIR_EraseRootFromParent_Done,
     /* 80633 */   // Label 2483: @80633
     /* 80633 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(80658), // Rule ID 22516 //
     /* 80638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 80641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 80645 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 80645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 80648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80650 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 80652 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 80654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80656 */     GIR_RootConstrainSelectedInstOperands,
     /* 80657 */     // GIR_Coverage, 22516,
     /* 80657 */     GIR_EraseRootFromParent_Done,
     /* 80658 */   // Label 2484: @80658
     /* 80658 */   GIM_Reject,
     /* 80659 */ // Label 2481: @80659
     /* 80659 */ GIM_Reject,
     /* 80660 */ // Label 2418: @80660
     /* 80660 */ GIM_Reject,
     /* 80661 */ // Label 55: @80661
     /* 80661 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2488*/ GIMT_Encode4(80783),
     /* 80672 */ /*GILLT_s16*//*Label 2485*/ GIMT_Encode4(80684),
     /* 80676 */ /*GILLT_s32*//*Label 2486*/ GIMT_Encode4(80717),
     /* 80680 */ /*GILLT_s64*//*Label 2487*/ GIMT_Encode4(80750),
     /* 80684 */ // Label 2485: @80684
     /* 80684 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(80716), // Rule ID 76 //
     /* 80689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 80692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 80695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80703 */   // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 80703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 80708 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80714 */   GIR_RootConstrainSelectedInstOperands,
     /* 80715 */   // GIR_Coverage, 76,
     /* 80715 */   GIR_Done,
     /* 80716 */ // Label 2489: @80716
     /* 80716 */ GIM_Reject,
     /* 80717 */ // Label 2486: @80717
     /* 80717 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(80749), // Rule ID 78 //
     /* 80722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 80725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 80728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80736 */   // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 80736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 80741 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80747 */   GIR_RootConstrainSelectedInstOperands,
     /* 80748 */   // GIR_Coverage, 78,
     /* 80748 */   GIR_Done,
     /* 80749 */ // Label 2490: @80749
     /* 80749 */ GIM_Reject,
     /* 80750 */ // Label 2487: @80750
     /* 80750 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(80782), // Rule ID 80 //
     /* 80755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 80758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 80761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80769 */   // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 80769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 80774 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 80780 */   GIR_RootConstrainSelectedInstOperands,
     /* 80781 */   // GIR_Coverage, 80,
     /* 80781 */   GIR_Done,
     /* 80782 */ // Label 2491: @80782
     /* 80782 */ GIM_Reject,
     /* 80783 */ // Label 2488: @80783
     /* 80783 */ GIM_Reject,
     /* 80784 */ // Label 56: @80784
     /* 80784 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2495*/ GIMT_Encode4(80945),
     /* 80795 */ /*GILLT_s16*//*Label 2492*/ GIMT_Encode4(80807),
     /* 80799 */ /*GILLT_s32*//*Label 2493*/ GIMT_Encode4(80853),
     /* 80803 */ /*GILLT_s64*//*Label 2494*/ GIMT_Encode4(80899),
     /* 80807 */ // Label 2492: @80807
     /* 80807 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(80852), // Rule ID 23427 //
     /* 80812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 80815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 80823 */   // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 80823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 80826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 80840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 80845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80847 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 80850 */   GIR_RootConstrainSelectedInstOperands,
     /* 80851 */   // GIR_Coverage, 23427,
     /* 80851 */   GIR_EraseRootFromParent_Done,
     /* 80852 */ // Label 2496: @80852
     /* 80852 */ GIM_Reject,
     /* 80853 */ // Label 2493: @80853
     /* 80853 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(80898), // Rule ID 23428 //
     /* 80858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 80861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 80869 */   // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 80869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 80872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 80886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 80891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80893 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 80896 */   GIR_RootConstrainSelectedInstOperands,
     /* 80897 */   // GIR_Coverage, 23428,
     /* 80897 */   GIR_EraseRootFromParent_Done,
     /* 80898 */ // Label 2497: @80898
     /* 80898 */ GIM_Reject,
     /* 80899 */ // Label 2494: @80899
     /* 80899 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(80944), // Rule ID 23429 //
     /* 80904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 80907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 80915 */   // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 80915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 80918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 80922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 80927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 80929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 80932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 80934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 80937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 80939 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 80942 */   GIR_RootConstrainSelectedInstOperands,
     /* 80943 */   // GIR_Coverage, 23429,
     /* 80943 */   GIR_EraseRootFromParent_Done,
     /* 80944 */ // Label 2498: @80944
     /* 80944 */ GIM_Reject,
     /* 80945 */ // Label 2495: @80945
     /* 80945 */ GIM_Reject,
     /* 80946 */ // Label 57: @80946
     /* 80946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 2508*/ GIMT_Encode4(81726),
     /* 80957 */ /*GILLT_s16*//*Label 2499*/ GIMT_Encode4(81029),
     /* 80961 */ /*GILLT_s32*//*Label 2500*/ GIMT_Encode4(81062),
     /* 80965 */ /*GILLT_s64*//*Label 2501*/ GIMT_Encode4(81095), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 80981 */ /*GILLT_v2s64*//*Label 2502*/ GIMT_Encode4(81128), GIMT_Encode4(0),
     /* 80989 */ /*GILLT_v4s32*//*Label 2503*/ GIMT_Encode4(81268),
     /* 80993 */ /*GILLT_v4s64*//*Label 2504*/ GIMT_Encode4(81408), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 81005 */ /*GILLT_v8s32*//*Label 2505*/ GIMT_Encode4(81540),
     /* 81009 */ /*GILLT_v8s64*//*Label 2506*/ GIMT_Encode4(81672), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 81025 */ /*GILLT_v16s32*//*Label 2507*/ GIMT_Encode4(81699),
     /* 81029 */ // Label 2499: @81029
     /* 81029 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(81061), // Rule ID 70 //
     /* 81034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 81037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 81040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 81044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 81048 */   // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 81048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 81053 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81059 */   GIR_RootConstrainSelectedInstOperands,
     /* 81060 */   // GIR_Coverage, 70,
     /* 81060 */   GIR_Done,
     /* 81061 */ // Label 2509: @81061
     /* 81061 */ GIM_Reject,
     /* 81062 */ // Label 2500: @81062
     /* 81062 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(81094), // Rule ID 72 //
     /* 81067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 81070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 81073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 81077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 81081 */   // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 81081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 81086 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81092 */   GIR_RootConstrainSelectedInstOperands,
     /* 81093 */   // GIR_Coverage, 72,
     /* 81093 */   GIR_Done,
     /* 81094 */ // Label 2510: @81094
     /* 81094 */ GIM_Reject,
     /* 81095 */ // Label 2501: @81095
     /* 81095 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(81127), // Rule ID 74 //
     /* 81100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 81103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 81106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 81110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 81114 */   // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 81114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 81119 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81125 */   GIR_RootConstrainSelectedInstOperands,
     /* 81126 */   // GIR_Coverage, 74,
     /* 81126 */   GIR_Done,
     /* 81127 */ // Label 2511: @81127
     /* 81127 */ GIM_Reject,
     /* 81128 */ // Label 2502: @81128
     /* 81128 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(81267),
     /* 81133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 81136 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(81159), // Rule ID 13351 //
     /* 81141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 81144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81152 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 81152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 81157 */     GIR_RootConstrainSelectedInstOperands,
     /* 81158 */     // GIR_Coverage, 13351,
     /* 81158 */     GIR_Done,
     /* 81159 */   // Label 2513: @81159
     /* 81159 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(81266), // Rule ID 22273 //
     /* 81164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 81167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 81171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81175 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 81175 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 81178 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81182 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 81192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81201 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81204 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81208 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 81211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81221 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 81226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 81233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81248 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 81255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 81260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81265 */     // GIR_Coverage, 22273,
     /* 81265 */     GIR_EraseRootFromParent_Done,
     /* 81266 */   // Label 2514: @81266
     /* 81266 */   GIM_Reject,
     /* 81267 */ // Label 2512: @81267
     /* 81267 */ GIM_Reject,
     /* 81268 */ // Label 2503: @81268
     /* 81268 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(81407),
     /* 81273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 81276 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(81299), // Rule ID 13378 //
     /* 81281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 81284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81292 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 81292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 81297 */     GIR_RootConstrainSelectedInstOperands,
     /* 81298 */     // GIR_Coverage, 13378,
     /* 81298 */     GIR_Done,
     /* 81299 */   // Label 2516: @81299
     /* 81299 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(81406), // Rule ID 22275 //
     /* 81304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 81307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 81311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81315 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 81315 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 81318 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81322 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 81332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81341 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81344 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81348 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 81351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 81366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 81373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81388 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 81395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 81400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81405 */     // GIR_Coverage, 22275,
     /* 81405 */     GIR_EraseRootFromParent_Done,
     /* 81406 */   // Label 2517: @81406
     /* 81406 */   GIM_Reject,
     /* 81407 */ // Label 2515: @81407
     /* 81407 */ GIM_Reject,
     /* 81408 */ // Label 2504: @81408
     /* 81408 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(81539),
     /* 81413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 81416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81424 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(81439), // Rule ID 13342 //
     /* 81429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 81432 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 81432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 81437 */     GIR_RootConstrainSelectedInstOperands,
     /* 81438 */     // GIR_Coverage, 13342,
     /* 81438 */     GIR_Done,
     /* 81439 */   // Label 2519: @81439
     /* 81439 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(81538), // Rule ID 22272 //
     /* 81444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 81447 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 81447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 81450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81461 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 81464 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81468 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81473 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81476 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81480 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 81483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 81505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81510 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81520 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 81527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81537 */     // GIR_Coverage, 22272,
     /* 81537 */     GIR_EraseRootFromParent_Done,
     /* 81538 */   // Label 2520: @81538
     /* 81538 */   GIM_Reject,
     /* 81539 */ // Label 2518: @81539
     /* 81539 */ GIM_Reject,
     /* 81540 */ // Label 2505: @81540
     /* 81540 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(81671),
     /* 81545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 81548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 81556 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(81571), // Rule ID 13369 //
     /* 81561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 81564 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 81564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 81569 */     GIR_RootConstrainSelectedInstOperands,
     /* 81570 */     // GIR_Coverage, 13369,
     /* 81570 */     GIR_Done,
     /* 81571 */   // Label 2522: @81571
     /* 81571 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(81670), // Rule ID 22274 //
     /* 81576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 81579 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 81579 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 81582 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81586 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 81596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81605 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 81608 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 81612 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 81615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 81620 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81625 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 81633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 81637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 81645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 81647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 81650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 81652 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 81659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 81664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 81669 */     // GIR_Coverage, 22274,
     /* 81669 */     GIR_EraseRootFromParent_Done,
     /* 81670 */   // Label 2523: @81670
     /* 81670 */   GIM_Reject,
     /* 81671 */ // Label 2521: @81671
     /* 81671 */ GIM_Reject,
     /* 81672 */ // Label 2506: @81672
     /* 81672 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(81698), // Rule ID 13333 //
     /* 81677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 81680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 81683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81691 */   // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 81691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 81696 */   GIR_RootConstrainSelectedInstOperands,
     /* 81697 */   // GIR_Coverage, 13333,
     /* 81697 */   GIR_Done,
     /* 81698 */ // Label 2524: @81698
     /* 81698 */ GIM_Reject,
     /* 81699 */ // Label 2507: @81699
     /* 81699 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(81725), // Rule ID 13360 //
     /* 81704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 81707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 81710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 81718 */   // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 81718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 81723 */   GIR_RootConstrainSelectedInstOperands,
     /* 81724 */   // GIR_Coverage, 13360,
     /* 81724 */   GIR_Done,
     /* 81725 */ // Label 2525: @81725
     /* 81725 */ GIM_Reject,
     /* 81726 */ // Label 2508: @81726
     /* 81726 */ GIM_Reject,
     /* 81727 */ // Label 58: @81727
     /* 81727 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2541*/ GIMT_Encode4(83125),
     /* 81738 */ /*GILLT_s16*//*Label 2526*/ GIMT_Encode4(81830),
     /* 81742 */ /*GILLT_s32*//*Label 2527*/ GIMT_Encode4(81863),
     /* 81746 */ /*GILLT_s64*//*Label 2528*/ GIMT_Encode4(81896), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 81762 */ /*GILLT_v2s64*//*Label 2529*/ GIMT_Encode4(81929), GIMT_Encode4(0),
     /* 81770 */ /*GILLT_v4s32*//*Label 2530*/ GIMT_Encode4(82069),
     /* 81774 */ /*GILLT_v4s64*//*Label 2531*/ GIMT_Encode4(82209), GIMT_Encode4(0),
     /* 81782 */ /*GILLT_v8s16*//*Label 2532*/ GIMT_Encode4(82341),
     /* 81786 */ /*GILLT_v8s32*//*Label 2533*/ GIMT_Encode4(82481),
     /* 81790 */ /*GILLT_v8s64*//*Label 2534*/ GIMT_Encode4(82613), GIMT_Encode4(0),
     /* 81798 */ /*GILLT_v16s8*//*Label 2535*/ GIMT_Encode4(82640),
     /* 81802 */ /*GILLT_v16s16*//*Label 2536*/ GIMT_Encode4(82780),
     /* 81806 */ /*GILLT_v16s32*//*Label 2537*/ GIMT_Encode4(82912), GIMT_Encode4(0),
     /* 81814 */ /*GILLT_v32s8*//*Label 2538*/ GIMT_Encode4(82939),
     /* 81818 */ /*GILLT_v32s16*//*Label 2539*/ GIMT_Encode4(83071), GIMT_Encode4(0),
     /* 81826 */ /*GILLT_v64s8*//*Label 2540*/ GIMT_Encode4(83098),
     /* 81830 */ // Label 2526: @81830
     /* 81830 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(81862), // Rule ID 3172 //
     /* 81835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 81838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 81841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 81845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 81849 */   // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 81849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 81854 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81860 */   GIR_RootConstrainSelectedInstOperands,
     /* 81861 */   // GIR_Coverage, 3172,
     /* 81861 */   GIR_Done,
     /* 81862 */ // Label 2542: @81862
     /* 81862 */ GIM_Reject,
     /* 81863 */ // Label 2527: @81863
     /* 81863 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(81895), // Rule ID 3174 //
     /* 81868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 81871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 81874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 81878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 81882 */   // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 81882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 81887 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81893 */   GIR_RootConstrainSelectedInstOperands,
     /* 81894 */   // GIR_Coverage, 3174,
     /* 81894 */   GIR_Done,
     /* 81895 */ // Label 2543: @81895
     /* 81895 */ GIM_Reject,
     /* 81896 */ // Label 2528: @81896
     /* 81896 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(81928), // Rule ID 3176 //
     /* 81901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 81904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 81907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 81911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 81915 */   // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 81915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 81920 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 81926 */   GIR_RootConstrainSelectedInstOperands,
     /* 81927 */   // GIR_Coverage, 3176,
     /* 81927 */   GIR_Done,
     /* 81928 */ // Label 2544: @81928
     /* 81928 */ GIM_Reject,
     /* 81929 */ // Label 2529: @81929
     /* 81929 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(82068),
     /* 81934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 81937 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(81960), // Rule ID 13459 //
     /* 81942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 81945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81953 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 81953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 81958 */     GIR_RootConstrainSelectedInstOperands,
     /* 81959 */     // GIR_Coverage, 13459,
     /* 81959 */     GIR_Done,
     /* 81960 */   // Label 2546: @81960
     /* 81960 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(82067), // Rule ID 22277 //
     /* 81965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 81968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 81972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 81976 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 81976 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 81979 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 81983 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 81988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 81990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 81993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 81997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82002 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 82012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 82027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 82034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 82056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 82061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82066 */     // GIR_Coverage, 22277,
     /* 82066 */     GIR_EraseRootFromParent_Done,
     /* 82067 */   // Label 2547: @82067
     /* 82067 */   GIM_Reject,
     /* 82068 */ // Label 2545: @82068
     /* 82068 */ GIM_Reject,
     /* 82069 */ // Label 2530: @82069
     /* 82069 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(82208),
     /* 82074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 82077 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(82100), // Rule ID 13486 //
     /* 82082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 82085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82093 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 82093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 82098 */     GIR_RootConstrainSelectedInstOperands,
     /* 82099 */     // GIR_Coverage, 13486,
     /* 82099 */     GIR_Done,
     /* 82100 */   // Label 2549: @82100
     /* 82100 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(82207), // Rule ID 22279 //
     /* 82105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 82108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 82112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82116 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 82116 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 82119 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82123 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 82133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82142 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82145 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82149 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 82152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82162 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 82167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 82174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 82196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 82201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82206 */     // GIR_Coverage, 22279,
     /* 82206 */     GIR_EraseRootFromParent_Done,
     /* 82207 */   // Label 2550: @82207
     /* 82207 */   GIM_Reject,
     /* 82208 */ // Label 2548: @82208
     /* 82208 */ GIM_Reject,
     /* 82209 */ // Label 2531: @82209
     /* 82209 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(82340),
     /* 82214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 82217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82225 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(82240), // Rule ID 13450 //
     /* 82230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 82233 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 82233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 82238 */     GIR_RootConstrainSelectedInstOperands,
     /* 82239 */     // GIR_Coverage, 13450,
     /* 82239 */     GIR_Done,
     /* 82240 */   // Label 2552: @82240
     /* 82240 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(82339), // Rule ID 22276 //
     /* 82245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 82248 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 82251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 82265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 82284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 82306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 82328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82338 */     // GIR_Coverage, 22276,
     /* 82338 */     GIR_EraseRootFromParent_Done,
     /* 82339 */   // Label 2553: @82339
     /* 82339 */   GIM_Reject,
     /* 82340 */ // Label 2551: @82340
     /* 82340 */ GIM_Reject,
     /* 82341 */ // Label 2532: @82341
     /* 82341 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(82480),
     /* 82346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 82349 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(82372), // Rule ID 14513 //
     /* 82354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82365 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 82365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 82370 */     GIR_RootConstrainSelectedInstOperands,
     /* 82371 */     // GIR_Coverage, 14513,
     /* 82371 */     GIR_Done,
     /* 82372 */   // Label 2555: @82372
     /* 82372 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(82479), // Rule ID 22586 //
     /* 82377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 82384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82388 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 82388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 82391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 82405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 82424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 82439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 82446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82461 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 82468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 82473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82478 */     // GIR_Coverage, 22586,
     /* 82478 */     GIR_EraseRootFromParent_Done,
     /* 82479 */   // Label 2556: @82479
     /* 82479 */   GIM_Reject,
     /* 82480 */ // Label 2554: @82480
     /* 82480 */ GIM_Reject,
     /* 82481 */ // Label 2533: @82481
     /* 82481 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(82612),
     /* 82486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 82489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82497 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(82512), // Rule ID 13477 //
     /* 82502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 82505 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 82505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 82510 */     GIR_RootConstrainSelectedInstOperands,
     /* 82511 */     // GIR_Coverage, 13477,
     /* 82511 */     GIR_Done,
     /* 82512 */   // Label 2558: @82512
     /* 82512 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(82611), // Rule ID 22278 //
     /* 82517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 82520 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82520 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 82523 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82527 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 82537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82546 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82549 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82553 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 82556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82566 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 82578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82593 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 82600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82610 */     // GIR_Coverage, 22278,
     /* 82610 */     GIR_EraseRootFromParent_Done,
     /* 82611 */   // Label 2559: @82611
     /* 82611 */   GIM_Reject,
     /* 82612 */ // Label 2557: @82612
     /* 82612 */ GIM_Reject,
     /* 82613 */ // Label 2534: @82613
     /* 82613 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(82639), // Rule ID 13441 //
     /* 82618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 82621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 82624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82632 */   // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 82632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 82637 */   GIR_RootConstrainSelectedInstOperands,
     /* 82638 */   // GIR_Coverage, 13441,
     /* 82638 */   GIR_Done,
     /* 82639 */ // Label 2560: @82639
     /* 82639 */ GIM_Reject,
     /* 82640 */ // Label 2535: @82640
     /* 82640 */ GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(82779),
     /* 82645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 82648 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(82671), // Rule ID 14495 //
     /* 82653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82664 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 82664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 82669 */     GIR_RootConstrainSelectedInstOperands,
     /* 82670 */     // GIR_Coverage, 14495,
     /* 82670 */     GIR_Done,
     /* 82671 */   // Label 2562: @82671
     /* 82671 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(82778), // Rule ID 22584 //
     /* 82676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 82683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 82687 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 82687 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 82690 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82694 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 82704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82713 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82716 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82720 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 82723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 82738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 82745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82750 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82760 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 82767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 82772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82777 */     // GIR_Coverage, 22584,
     /* 82777 */     GIR_EraseRootFromParent_Done,
     /* 82778 */   // Label 2563: @82778
     /* 82778 */   GIM_Reject,
     /* 82779 */ // Label 2561: @82779
     /* 82779 */ GIM_Reject,
     /* 82780 */ // Label 2536: @82780
     /* 82780 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(82911),
     /* 82785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 82788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82796 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(82811), // Rule ID 14507 //
     /* 82801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82804 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 82804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 82809 */     GIR_RootConstrainSelectedInstOperands,
     /* 82810 */     // GIR_Coverage, 14507,
     /* 82810 */     GIR_Done,
     /* 82811 */   // Label 2565: @82811
     /* 82811 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(82910), // Rule ID 22585 //
     /* 82816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82819 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82819 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 82822 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82826 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 82836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82845 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 82848 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 82852 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 82855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 82860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 82873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 82877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 82885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 82887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 82890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 82892 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 82899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 82904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 82909 */     // GIR_Coverage, 22585,
     /* 82909 */     GIR_EraseRootFromParent_Done,
     /* 82910 */   // Label 2566: @82910
     /* 82910 */   GIM_Reject,
     /* 82911 */ // Label 2564: @82911
     /* 82911 */ GIM_Reject,
     /* 82912 */ // Label 2537: @82912
     /* 82912 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(82938), // Rule ID 13468 //
     /* 82917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 82920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 82923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 82931 */   // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 82931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 82936 */   GIR_RootConstrainSelectedInstOperands,
     /* 82937 */   // GIR_Coverage, 13468,
     /* 82937 */   GIR_Done,
     /* 82938 */ // Label 2567: @82938
     /* 82938 */ GIM_Reject,
     /* 82939 */ // Label 2538: @82939
     /* 82939 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(83070),
     /* 82944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 82947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 82955 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(82970), // Rule ID 14489 //
     /* 82960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 82963 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 82963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 82968 */     GIR_RootConstrainSelectedInstOperands,
     /* 82969 */     // GIR_Coverage, 14489,
     /* 82969 */     GIR_Done,
     /* 82970 */   // Label 2569: @82970
     /* 82970 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(83069), // Rule ID 22583 //
     /* 82975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 82978 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 82978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 82981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 82985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 82990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 82992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 82995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 82999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83004 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 83007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 83011 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 83014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 83019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 83024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 83029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 83032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 83036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 83044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 83049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83051 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 83058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 83063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 83068 */     // GIR_Coverage, 22583,
     /* 83068 */     GIR_EraseRootFromParent_Done,
     /* 83069 */   // Label 2570: @83069
     /* 83069 */   GIM_Reject,
     /* 83070 */ // Label 2568: @83070
     /* 83070 */ GIM_Reject,
     /* 83071 */ // Label 2539: @83071
     /* 83071 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(83097), // Rule ID 14501 //
     /* 83076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 83079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 83082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83090 */   // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 83090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 83095 */   GIR_RootConstrainSelectedInstOperands,
     /* 83096 */   // GIR_Coverage, 14501,
     /* 83096 */   GIR_Done,
     /* 83097 */ // Label 2571: @83097
     /* 83097 */ GIM_Reject,
     /* 83098 */ // Label 2540: @83098
     /* 83098 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(83124), // Rule ID 14483 //
     /* 83103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 83106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 83109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 83117 */   // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 83117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 83122 */   GIR_RootConstrainSelectedInstOperands,
     /* 83123 */   // GIR_Coverage, 14483,
     /* 83123 */   GIR_Done,
     /* 83124 */ // Label 2572: @83124
     /* 83124 */ GIM_Reject,
     /* 83125 */ // Label 2541: @83125
     /* 83125 */ GIM_Reject,
     /* 83126 */ // Label 59: @83126
     /* 83126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(83301),
     /* 83137 */ /*GILLT_s16*//*Label 2573*/ GIMT_Encode4(83149),
     /* 83141 */ /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(83205),
     /* 83145 */ /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(83253),
     /* 83149 */ // Label 2573: @83149
     /* 83149 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(83204),
     /* 83154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 83157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 83161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 83165 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(83180), // Rule ID 61 //
     /* 83170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 83173 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 83173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 83178 */     GIR_RootConstrainSelectedInstOperands,
     /* 83179 */     // GIR_Coverage, 61,
     /* 83179 */     GIR_Done,
     /* 83180 */   // Label 2578: @83180
     /* 83180 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(83203), // Rule ID 23433 //
     /* 83185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 83188 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 83188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 83191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 83198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 83201 */     GIR_RootConstrainSelectedInstOperands,
     /* 83202 */     // GIR_Coverage, 23433,
     /* 83202 */     GIR_EraseRootFromParent_Done,
     /* 83203 */   // Label 2579: @83203
     /* 83203 */   GIM_Reject,
     /* 83204 */ // Label 2577: @83204
     /* 83204 */ GIM_Reject,
     /* 83205 */ // Label 2574: @83205
     /* 83205 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(83252),
     /* 83210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 83213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 83217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 83221 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(83236), // Rule ID 5 //
     /* 83226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 83229 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 83229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 83234 */     GIR_RootConstrainSelectedInstOperands,
     /* 83235 */     // GIR_Coverage, 5,
     /* 83235 */     GIR_Done,
     /* 83236 */   // Label 2581: @83236
     /* 83236 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(83251), // Rule ID 62 //
     /* 83241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 83244 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 83244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 83249 */     GIR_RootConstrainSelectedInstOperands,
     /* 83250 */     // GIR_Coverage, 62,
     /* 83250 */     GIR_Done,
     /* 83251 */   // Label 2582: @83251
     /* 83251 */   GIM_Reject,
     /* 83252 */ // Label 2580: @83252
     /* 83252 */ GIM_Reject,
     /* 83253 */ // Label 2575: @83253
     /* 83253 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(83300),
     /* 83258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 83261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 83265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 83269 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(83284), // Rule ID 6 //
     /* 83274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 83277 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 83277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 83282 */     GIR_RootConstrainSelectedInstOperands,
     /* 83283 */     // GIR_Coverage, 6,
     /* 83283 */     GIR_Done,
     /* 83284 */   // Label 2584: @83284
     /* 83284 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(83299), // Rule ID 63 //
     /* 83289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 83292 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 83292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 83297 */     GIR_RootConstrainSelectedInstOperands,
     /* 83298 */     // GIR_Coverage, 63,
     /* 83298 */     GIR_Done,
     /* 83299 */   // Label 2585: @83299
     /* 83299 */   GIM_Reject,
     /* 83300 */ // Label 2583: @83300
     /* 83300 */ GIM_Reject,
     /* 83301 */ // Label 2576: @83301
     /* 83301 */ GIM_Reject,
     /* 83302 */ // Label 60: @83302
     /* 83302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2599*/ GIMT_Encode4(84253),
     /* 83313 */ /*GILLT_s16*//*Label 2586*/ GIMT_Encode4(83397),
     /* 83317 */ /*GILLT_s32*//*Label 2587*/ GIMT_Encode4(83443),
     /* 83321 */ /*GILLT_s64*//*Label 2588*/ GIMT_Encode4(83597),
     /* 83325 */ /*GILLT_s80*//*Label 2589*/ GIMT_Encode4(83751), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83337 */ /*GILLT_v2s64*//*Label 2590*/ GIMT_Encode4(83788), GIMT_Encode4(0),
     /* 83345 */ /*GILLT_v4s32*//*Label 2591*/ GIMT_Encode4(83879),
     /* 83349 */ /*GILLT_v4s64*//*Label 2592*/ GIMT_Encode4(83970), GIMT_Encode4(0),
     /* 83357 */ /*GILLT_v8s16*//*Label 2593*/ GIMT_Encode4(84034),
     /* 83361 */ /*GILLT_v8s32*//*Label 2594*/ GIMT_Encode4(84065),
     /* 83365 */ /*GILLT_v8s64*//*Label 2595*/ GIMT_Encode4(84129), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83377 */ /*GILLT_v16s16*//*Label 2596*/ GIMT_Encode4(84160),
     /* 83381 */ /*GILLT_v16s32*//*Label 2597*/ GIMT_Encode4(84191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 83393 */ /*GILLT_v32s16*//*Label 2598*/ GIMT_Encode4(84222),
     /* 83397 */ // Label 2586: @83397
     /* 83397 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(83442), // Rule ID 21866 //
     /* 83402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 83405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 83408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 83416 */   // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 83416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 83419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 83433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83440 */   GIR_RootConstrainSelectedInstOperands,
     /* 83441 */   // GIR_Coverage, 21866,
     /* 83441 */   GIR_EraseRootFromParent_Done,
     /* 83442 */ // Label 2600: @83442
     /* 83442 */ GIM_Reject,
     /* 83443 */ // Label 2587: @83443
     /* 83443 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(83596),
     /* 83448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 83451 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(83484), // Rule ID 1046 //
     /* 83456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 83459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 83463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 83467 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 83467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 83472 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 83478 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 83482 */     GIR_RootConstrainSelectedInstOperands,
     /* 83483 */     // GIR_Coverage, 1046,
     /* 83483 */     GIR_Done,
     /* 83484 */   // Label 2602: @83484
     /* 83484 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(83511), // Rule ID 2444 //
     /* 83489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 83492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83500 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 83500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 83505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83509 */     GIR_RootConstrainSelectedInstOperands,
     /* 83510 */     // GIR_Coverage, 2444,
     /* 83510 */     GIR_Done,
     /* 83511 */   // Label 2603: @83511
     /* 83511 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(83553), // Rule ID 18722 //
     /* 83516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 83519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 83527 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 83527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 83530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 83544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83551 */     GIR_RootConstrainSelectedInstOperands,
     /* 83552 */     // GIR_Coverage, 18722,
     /* 83552 */     GIR_EraseRootFromParent_Done,
     /* 83553 */   // Label 2604: @83553
     /* 83553 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(83595), // Rule ID 21870 //
     /* 83558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 83561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 83565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 83569 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 83569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 83572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 83586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83593 */     GIR_RootConstrainSelectedInstOperands,
     /* 83594 */     // GIR_Coverage, 21870,
     /* 83594 */     GIR_EraseRootFromParent_Done,
     /* 83595 */   // Label 2605: @83595
     /* 83595 */   GIM_Reject,
     /* 83596 */ // Label 2601: @83596
     /* 83596 */ GIM_Reject,
     /* 83597 */ // Label 2588: @83597
     /* 83597 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(83750),
     /* 83602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 83605 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(83638), // Rule ID 1048 //
     /* 83610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 83613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 83617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 83621 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 83621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 83626 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 83632 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 83636 */     GIR_RootConstrainSelectedInstOperands,
     /* 83637 */     // GIR_Coverage, 1048,
     /* 83637 */     GIR_Done,
     /* 83638 */   // Label 2607: @83638
     /* 83638 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(83665), // Rule ID 2460 //
     /* 83643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 83646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83654 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 83654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 83659 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83663 */     GIR_RootConstrainSelectedInstOperands,
     /* 83664 */     // GIR_Coverage, 2460,
     /* 83664 */     GIR_Done,
     /* 83665 */   // Label 2608: @83665
     /* 83665 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(83707), // Rule ID 18726 //
     /* 83670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 83673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 83681 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 83681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 83684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 83698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83705 */     GIR_RootConstrainSelectedInstOperands,
     /* 83706 */     // GIR_Coverage, 18726,
     /* 83706 */     GIR_EraseRootFromParent_Done,
     /* 83707 */   // Label 2609: @83707
     /* 83707 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(83749), // Rule ID 21874 //
     /* 83712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 83715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 83719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 83723 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 83723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 83726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 83730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 83735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 83737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 83740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 83742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 83745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 83747 */     GIR_RootConstrainSelectedInstOperands,
     /* 83748 */     // GIR_Coverage, 21874,
     /* 83748 */     GIR_EraseRootFromParent_Done,
     /* 83749 */   // Label 2610: @83749
     /* 83749 */   GIM_Reject,
     /* 83750 */ // Label 2606: @83750
     /* 83750 */ GIM_Reject,
     /* 83751 */ // Label 2589: @83751
     /* 83751 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(83787), // Rule ID 1050 //
     /* 83756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 83759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 83762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 83766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 83770 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 83770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 83775 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 83781 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 83785 */   GIR_RootConstrainSelectedInstOperands,
     /* 83786 */   // GIR_Coverage, 1050,
     /* 83786 */   GIR_Done,
     /* 83787 */ // Label 2611: @83787
     /* 83787 */ GIM_Reject,
     /* 83788 */ // Label 2590: @83788
     /* 83788 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(83878),
     /* 83793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 83796 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(83823), // Rule ID 2464 //
     /* 83801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83812 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 83812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 83817 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83821 */     GIR_RootConstrainSelectedInstOperands,
     /* 83822 */     // GIR_Coverage, 2464,
     /* 83822 */     GIR_Done,
     /* 83823 */   // Label 2613: @83823
     /* 83823 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(83850), // Rule ID 2472 //
     /* 83828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 83831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83839 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 83839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 83844 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83848 */     GIR_RootConstrainSelectedInstOperands,
     /* 83849 */     // GIR_Coverage, 2472,
     /* 83849 */     GIR_Done,
     /* 83850 */   // Label 2614: @83850
     /* 83850 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(83877), // Rule ID 12080 //
     /* 83855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 83858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83866 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 83866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 83871 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83875 */     GIR_RootConstrainSelectedInstOperands,
     /* 83876 */     // GIR_Coverage, 12080,
     /* 83876 */     GIR_Done,
     /* 83877 */   // Label 2615: @83877
     /* 83877 */   GIM_Reject,
     /* 83878 */ // Label 2612: @83878
     /* 83878 */ GIM_Reject,
     /* 83879 */ // Label 2591: @83879
     /* 83879 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(83969),
     /* 83884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 83887 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(83914), // Rule ID 2448 //
     /* 83892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83903 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 83903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 83908 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83912 */     GIR_RootConstrainSelectedInstOperands,
     /* 83913 */     // GIR_Coverage, 2448,
     /* 83913 */     GIR_Done,
     /* 83914 */   // Label 2617: @83914
     /* 83914 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(83941), // Rule ID 2456 //
     /* 83919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 83922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 83930 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 83930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 83935 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83939 */     GIR_RootConstrainSelectedInstOperands,
     /* 83940 */     // GIR_Coverage, 2456,
     /* 83940 */     GIR_Done,
     /* 83941 */   // Label 2618: @83941
     /* 83941 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(83968), // Rule ID 12056 //
     /* 83946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 83949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 83957 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 83957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 83962 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 83966 */     GIR_RootConstrainSelectedInstOperands,
     /* 83967 */     // GIR_Coverage, 12056,
     /* 83967 */     GIR_Done,
     /* 83968 */   // Label 2619: @83968
     /* 83968 */   GIM_Reject,
     /* 83969 */ // Label 2616: @83969
     /* 83969 */ GIM_Reject,
     /* 83970 */ // Label 2592: @83970
     /* 83970 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(84033),
     /* 83975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 83978 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(84005), // Rule ID 2468 //
     /* 83983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 83986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 83990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 83994 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 83994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 83999 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84003 */     GIR_RootConstrainSelectedInstOperands,
     /* 84004 */     // GIR_Coverage, 2468,
     /* 84004 */     GIR_Done,
     /* 84005 */   // Label 2621: @84005
     /* 84005 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(84032), // Rule ID 12092 //
     /* 84010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 84013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84021 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 84021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 84026 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84030 */     GIR_RootConstrainSelectedInstOperands,
     /* 84031 */     // GIR_Coverage, 12092,
     /* 84031 */     GIR_Done,
     /* 84032 */   // Label 2622: @84032
     /* 84032 */   GIM_Reject,
     /* 84033 */ // Label 2620: @84033
     /* 84033 */ GIM_Reject,
     /* 84034 */ // Label 2593: @84034
     /* 84034 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(84064), // Rule ID 12008 //
     /* 84039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 84042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 84045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84053 */   // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 84053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 84058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84062 */   GIR_RootConstrainSelectedInstOperands,
     /* 84063 */   // GIR_Coverage, 12008,
     /* 84063 */   GIR_Done,
     /* 84064 */ // Label 2623: @84064
     /* 84064 */ GIM_Reject,
     /* 84065 */ // Label 2594: @84065
     /* 84065 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(84128),
     /* 84070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 84073 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(84100), // Rule ID 2452 //
     /* 84078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84089 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 84089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 84094 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84098 */     GIR_RootConstrainSelectedInstOperands,
     /* 84099 */     // GIR_Coverage, 2452,
     /* 84099 */     GIR_Done,
     /* 84100 */   // Label 2625: @84100
     /* 84100 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(84127), // Rule ID 12068 //
     /* 84105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 84108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84116 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 84116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 84121 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84125 */     GIR_RootConstrainSelectedInstOperands,
     /* 84126 */     // GIR_Coverage, 12068,
     /* 84126 */     GIR_Done,
     /* 84127 */   // Label 2626: @84127
     /* 84127 */   GIM_Reject,
     /* 84128 */ // Label 2624: @84128
     /* 84128 */ GIM_Reject,
     /* 84129 */ // Label 2595: @84129
     /* 84129 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(84159), // Rule ID 12044 //
     /* 84134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 84140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84148 */   // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 84148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 84153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84157 */   GIR_RootConstrainSelectedInstOperands,
     /* 84158 */   // GIR_Coverage, 12044,
     /* 84158 */   GIR_Done,
     /* 84159 */ // Label 2627: @84159
     /* 84159 */ GIM_Reject,
     /* 84160 */ // Label 2596: @84160
     /* 84160 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(84190), // Rule ID 12020 //
     /* 84165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 84168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 84171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84179 */   // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 84179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 84184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84188 */   GIR_RootConstrainSelectedInstOperands,
     /* 84189 */   // GIR_Coverage, 12020,
     /* 84189 */   GIR_Done,
     /* 84190 */ // Label 2628: @84190
     /* 84190 */ GIM_Reject,
     /* 84191 */ // Label 2597: @84191
     /* 84191 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(84221), // Rule ID 12032 //
     /* 84196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 84202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84210 */   // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 84210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 84215 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84219 */   GIR_RootConstrainSelectedInstOperands,
     /* 84220 */   // GIR_Coverage, 12032,
     /* 84220 */   GIR_Done,
     /* 84221 */ // Label 2629: @84221
     /* 84221 */ GIM_Reject,
     /* 84222 */ // Label 2598: @84222
     /* 84222 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(84252), // Rule ID 11996 //
     /* 84227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 84230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 84233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 84241 */   // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 84241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 84246 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84250 */   GIR_RootConstrainSelectedInstOperands,
     /* 84251 */   // GIR_Coverage, 11996,
     /* 84251 */   GIR_Done,
     /* 84252 */ // Label 2630: @84252
     /* 84252 */ GIM_Reject,
     /* 84253 */ // Label 2599: @84253
     /* 84253 */ GIM_Reject,
     /* 84254 */ // Label 61: @84254
     /* 84254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2644*/ GIMT_Encode4(85269),
     /* 84265 */ /*GILLT_s16*//*Label 2631*/ GIMT_Encode4(84349),
     /* 84269 */ /*GILLT_s32*//*Label 2632*/ GIMT_Encode4(84387),
     /* 84273 */ /*GILLT_s64*//*Label 2633*/ GIMT_Encode4(84530),
     /* 84277 */ /*GILLT_s80*//*Label 2634*/ GIMT_Encode4(84673), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 84289 */ /*GILLT_v2s64*//*Label 2635*/ GIMT_Encode4(84717), GIMT_Encode4(0),
     /* 84297 */ /*GILLT_v4s32*//*Label 2636*/ GIMT_Encode4(84823),
     /* 84301 */ /*GILLT_v4s64*//*Label 2637*/ GIMT_Encode4(84929), GIMT_Encode4(0),
     /* 84309 */ /*GILLT_v8s16*//*Label 2638*/ GIMT_Encode4(85004),
     /* 84313 */ /*GILLT_v8s32*//*Label 2639*/ GIMT_Encode4(85042),
     /* 84317 */ /*GILLT_v8s64*//*Label 2640*/ GIMT_Encode4(85117), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 84329 */ /*GILLT_v16s16*//*Label 2641*/ GIMT_Encode4(85155),
     /* 84333 */ /*GILLT_v16s32*//*Label 2642*/ GIMT_Encode4(85193), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 84345 */ /*GILLT_v32s16*//*Label 2643*/ GIMT_Encode4(85231),
     /* 84349 */ // Label 2631: @84349
     /* 84349 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(84386), // Rule ID 5949 //
     /* 84354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 84357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 84360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 84363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 84367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 84371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 84375 */   // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 84375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 84380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84384 */   GIR_RootConstrainSelectedInstOperands,
     /* 84385 */   // GIR_Coverage, 5949,
     /* 84385 */   GIR_Done,
     /* 84386 */ // Label 2645: @84386
     /* 84386 */ GIM_Reject,
     /* 84387 */ // Label 2632: @84387
     /* 84387 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(84529),
     /* 84392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 84395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 84398 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(84435), // Rule ID 883 //
     /* 84403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 84406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 84410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 84414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 84418 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 84418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 84423 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 84429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 84433 */     GIR_RootConstrainSelectedInstOperands,
     /* 84434 */     // GIR_Coverage, 883,
     /* 84434 */     GIR_Done,
     /* 84435 */   // Label 2647: @84435
     /* 84435 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(84466), // Rule ID 2155 //
     /* 84440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 84443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84455 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 84455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 84460 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84464 */     GIR_RootConstrainSelectedInstOperands,
     /* 84465 */     // GIR_Coverage, 2155,
     /* 84465 */     GIR_Done,
     /* 84466 */   // Label 2648: @84466
     /* 84466 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(84497), // Rule ID 2163 //
     /* 84471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 84474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 84486 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 84486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 84491 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84495 */     GIR_RootConstrainSelectedInstOperands,
     /* 84496 */     // GIR_Coverage, 2163,
     /* 84496 */     GIR_Done,
     /* 84497 */   // Label 2649: @84497
     /* 84497 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(84528), // Rule ID 5911 //
     /* 84502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 84509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 84513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 84517 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 84517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 84522 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84526 */     GIR_RootConstrainSelectedInstOperands,
     /* 84527 */     // GIR_Coverage, 5911,
     /* 84527 */     GIR_Done,
     /* 84528 */   // Label 2650: @84528
     /* 84528 */   GIM_Reject,
     /* 84529 */ // Label 2646: @84529
     /* 84529 */ GIM_Reject,
     /* 84530 */ // Label 2633: @84530
     /* 84530 */ GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(84672),
     /* 84535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 84538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 84541 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(84578), // Rule ID 885 //
     /* 84546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 84549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 84553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 84557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 84561 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 84561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 84566 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 84572 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 84576 */     GIR_RootConstrainSelectedInstOperands,
     /* 84577 */     // GIR_Coverage, 885,
     /* 84577 */     GIR_Done,
     /* 84578 */   // Label 2652: @84578
     /* 84578 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(84609), // Rule ID 2159 //
     /* 84583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 84586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84598 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 84598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 84603 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84607 */     GIR_RootConstrainSelectedInstOperands,
     /* 84608 */     // GIR_Coverage, 2159,
     /* 84608 */     GIR_Done,
     /* 84609 */   // Label 2653: @84609
     /* 84609 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(84640), // Rule ID 2167 //
     /* 84614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 84617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 84629 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 84629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 84634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84638 */     GIR_RootConstrainSelectedInstOperands,
     /* 84639 */     // GIR_Coverage, 2167,
     /* 84639 */     GIR_Done,
     /* 84640 */   // Label 2654: @84640
     /* 84640 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(84671), // Rule ID 5930 //
     /* 84645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 84648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 84652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 84656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 84660 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 84660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 84665 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84669 */     GIR_RootConstrainSelectedInstOperands,
     /* 84670 */     // GIR_Coverage, 5930,
     /* 84670 */     GIR_Done,
     /* 84671 */   // Label 2655: @84671
     /* 84671 */   GIM_Reject,
     /* 84672 */ // Label 2651: @84672
     /* 84672 */ GIM_Reject,
     /* 84673 */ // Label 2634: @84673
     /* 84673 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(84716), // Rule ID 887 //
     /* 84678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 84681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 84684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 84687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 84691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 84695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 84699 */   // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 84699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 84704 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 84710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 84714 */   GIR_RootConstrainSelectedInstOperands,
     /* 84715 */   // GIR_Coverage, 887,
     /* 84715 */   GIR_Done,
     /* 84716 */ // Label 2656: @84716
     /* 84716 */ GIM_Reject,
     /* 84717 */ // Label 2635: @84717
     /* 84717 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(84822),
     /* 84722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 84725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 84728 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(84759), // Rule ID 2135 //
     /* 84733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84748 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 84748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 84753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84757 */     GIR_RootConstrainSelectedInstOperands,
     /* 84758 */     // GIR_Coverage, 2135,
     /* 84758 */     GIR_Done,
     /* 84759 */   // Label 2658: @84759
     /* 84759 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(84790), // Rule ID 2151 //
     /* 84764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 84767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84779 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 84779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 84784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84788 */     GIR_RootConstrainSelectedInstOperands,
     /* 84789 */     // GIR_Coverage, 2151,
     /* 84789 */     GIR_Done,
     /* 84790 */   // Label 2659: @84790
     /* 84790 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(84821), // Rule ID 6301 //
     /* 84795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84810 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 84810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 84815 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84819 */     GIR_RootConstrainSelectedInstOperands,
     /* 84820 */     // GIR_Coverage, 6301,
     /* 84820 */     GIR_Done,
     /* 84821 */   // Label 2660: @84821
     /* 84821 */   GIM_Reject,
     /* 84822 */ // Label 2657: @84822
     /* 84822 */ GIM_Reject,
     /* 84823 */ // Label 2636: @84823
     /* 84823 */ GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(84928),
     /* 84828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 84831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 84834 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(84865), // Rule ID 2131 //
     /* 84839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84854 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 84854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 84859 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84863 */     GIR_RootConstrainSelectedInstOperands,
     /* 84864 */     // GIR_Coverage, 2131,
     /* 84864 */     GIR_Done,
     /* 84865 */   // Label 2662: @84865
     /* 84865 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(84896), // Rule ID 2147 //
     /* 84870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 84873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 84885 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 84885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 84890 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84894 */     GIR_RootConstrainSelectedInstOperands,
     /* 84895 */     // GIR_Coverage, 2147,
     /* 84895 */     GIR_Done,
     /* 84896 */   // Label 2663: @84896
     /* 84896 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(84927), // Rule ID 6277 //
     /* 84901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 84916 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 84916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 84921 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84925 */     GIR_RootConstrainSelectedInstOperands,
     /* 84926 */     // GIR_Coverage, 6277,
     /* 84926 */     GIR_Done,
     /* 84927 */   // Label 2664: @84927
     /* 84927 */   GIM_Reject,
     /* 84928 */ // Label 2661: @84928
     /* 84928 */ GIM_Reject,
     /* 84929 */ // Label 2637: @84929
     /* 84929 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(85003),
     /* 84934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 84937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 84940 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(84971), // Rule ID 2143 //
     /* 84945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 84948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 84960 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 84960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 84965 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 84969 */     GIR_RootConstrainSelectedInstOperands,
     /* 84970 */     // GIR_Coverage, 2143,
     /* 84970 */     GIR_Done,
     /* 84971 */   // Label 2666: @84971
     /* 84971 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(85002), // Rule ID 6313 //
     /* 84976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 84979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 84991 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 84991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 84996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85000 */     GIR_RootConstrainSelectedInstOperands,
     /* 85001 */     // GIR_Coverage, 6313,
     /* 85001 */     GIR_Done,
     /* 85002 */   // Label 2667: @85002
     /* 85002 */   GIM_Reject,
     /* 85003 */ // Label 2665: @85003
     /* 85003 */ GIM_Reject,
     /* 85004 */ // Label 2638: @85004
     /* 85004 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(85041), // Rule ID 6337 //
     /* 85009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 85012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 85015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 85018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85030 */   // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 85030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 85035 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85039 */   GIR_RootConstrainSelectedInstOperands,
     /* 85040 */   // GIR_Coverage, 6337,
     /* 85040 */   GIR_Done,
     /* 85041 */ // Label 2668: @85041
     /* 85041 */ GIM_Reject,
     /* 85042 */ // Label 2639: @85042
     /* 85042 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(85116),
     /* 85047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 85050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 85053 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(85084), // Rule ID 2139 //
     /* 85058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85073 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 85073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 85078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85082 */     GIR_RootConstrainSelectedInstOperands,
     /* 85083 */     // GIR_Coverage, 2139,
     /* 85083 */     GIR_Done,
     /* 85084 */   // Label 2670: @85084
     /* 85084 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(85115), // Rule ID 6289 //
     /* 85089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85104 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 85104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 85109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85113 */     GIR_RootConstrainSelectedInstOperands,
     /* 85114 */     // GIR_Coverage, 6289,
     /* 85114 */     GIR_Done,
     /* 85115 */   // Label 2671: @85115
     /* 85115 */   GIM_Reject,
     /* 85116 */ // Label 2669: @85116
     /* 85116 */ GIM_Reject,
     /* 85117 */ // Label 2640: @85117
     /* 85117 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(85154), // Rule ID 6265 //
     /* 85122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 85128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 85131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85143 */   // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 85143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 85148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85152 */   GIR_RootConstrainSelectedInstOperands,
     /* 85153 */   // GIR_Coverage, 6265,
     /* 85153 */   GIR_Done,
     /* 85154 */ // Label 2672: @85154
     /* 85154 */ GIM_Reject,
     /* 85155 */ // Label 2641: @85155
     /* 85155 */ GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(85192), // Rule ID 6349 //
     /* 85160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 85163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 85166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 85169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85181 */   // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 85181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 85186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85190 */   GIR_RootConstrainSelectedInstOperands,
     /* 85191 */   // GIR_Coverage, 6349,
     /* 85191 */   GIR_Done,
     /* 85192 */ // Label 2673: @85192
     /* 85192 */ GIM_Reject,
     /* 85193 */ // Label 2642: @85193
     /* 85193 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(85230), // Rule ID 6253 //
     /* 85198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 85204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 85207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85219 */   // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 85219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 85224 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85228 */   GIR_RootConstrainSelectedInstOperands,
     /* 85229 */   // GIR_Coverage, 6253,
     /* 85229 */   GIR_Done,
     /* 85230 */ // Label 2674: @85230
     /* 85230 */ GIM_Reject,
     /* 85231 */ // Label 2643: @85231
     /* 85231 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(85268), // Rule ID 6325 //
     /* 85236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 85239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 85242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 85245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 85257 */   // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 85257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 85262 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85266 */   GIR_RootConstrainSelectedInstOperands,
     /* 85267 */   // GIR_Coverage, 6325,
     /* 85267 */   GIR_Done,
     /* 85268 */ // Label 2675: @85268
     /* 85268 */ GIM_Reject,
     /* 85269 */ // Label 2644: @85269
     /* 85269 */ GIM_Reject,
     /* 85270 */ // Label 62: @85270
     /* 85270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2689*/ GIMT_Encode4(86285),
     /* 85281 */ /*GILLT_s16*//*Label 2676*/ GIMT_Encode4(85365),
     /* 85285 */ /*GILLT_s32*//*Label 2677*/ GIMT_Encode4(85403),
     /* 85289 */ /*GILLT_s64*//*Label 2678*/ GIMT_Encode4(85546),
     /* 85293 */ /*GILLT_s80*//*Label 2679*/ GIMT_Encode4(85689), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 85305 */ /*GILLT_v2s64*//*Label 2680*/ GIMT_Encode4(85733), GIMT_Encode4(0),
     /* 85313 */ /*GILLT_v4s32*//*Label 2681*/ GIMT_Encode4(85839),
     /* 85317 */ /*GILLT_v4s64*//*Label 2682*/ GIMT_Encode4(85945), GIMT_Encode4(0),
     /* 85325 */ /*GILLT_v8s16*//*Label 2683*/ GIMT_Encode4(86020),
     /* 85329 */ /*GILLT_v8s32*//*Label 2684*/ GIMT_Encode4(86058),
     /* 85333 */ /*GILLT_v8s64*//*Label 2685*/ GIMT_Encode4(86133), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 85345 */ /*GILLT_v16s16*//*Label 2686*/ GIMT_Encode4(86171),
     /* 85349 */ /*GILLT_v16s32*//*Label 2687*/ GIMT_Encode4(86209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 85361 */ /*GILLT_v32s16*//*Label 2688*/ GIMT_Encode4(86247),
     /* 85365 */ // Label 2676: @85365
     /* 85365 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(85402), // Rule ID 6063 //
     /* 85370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 85373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 85376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 85379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 85383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 85387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 85391 */   // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 85391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 85396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85400 */   GIR_RootConstrainSelectedInstOperands,
     /* 85401 */   // GIR_Coverage, 6063,
     /* 85401 */   GIR_Done,
     /* 85402 */ // Label 2690: @85402
     /* 85402 */ GIM_Reject,
     /* 85403 */ // Label 2677: @85403
     /* 85403 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(85545),
     /* 85408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 85411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 85414 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(85451), // Rule ID 889 //
     /* 85419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 85422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 85426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 85430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 85434 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 85434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 85439 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 85445 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 85449 */     GIR_RootConstrainSelectedInstOperands,
     /* 85450 */     // GIR_Coverage, 889,
     /* 85450 */     GIR_Done,
     /* 85451 */   // Label 2692: @85451
     /* 85451 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(85482), // Rule ID 2235 //
     /* 85456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 85459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85471 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 85471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 85476 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85480 */     GIR_RootConstrainSelectedInstOperands,
     /* 85481 */     // GIR_Coverage, 2235,
     /* 85481 */     GIR_Done,
     /* 85482 */   // Label 2693: @85482
     /* 85482 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(85513), // Rule ID 2243 //
     /* 85487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 85490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 85502 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 85502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 85507 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85511 */     GIR_RootConstrainSelectedInstOperands,
     /* 85512 */     // GIR_Coverage, 2243,
     /* 85512 */     GIR_Done,
     /* 85513 */   // Label 2694: @85513
     /* 85513 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(85544), // Rule ID 6025 //
     /* 85518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 85525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 85529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 85533 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 85533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 85538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85542 */     GIR_RootConstrainSelectedInstOperands,
     /* 85543 */     // GIR_Coverage, 6025,
     /* 85543 */     GIR_Done,
     /* 85544 */   // Label 2695: @85544
     /* 85544 */   GIM_Reject,
     /* 85545 */ // Label 2691: @85545
     /* 85545 */ GIM_Reject,
     /* 85546 */ // Label 2678: @85546
     /* 85546 */ GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(85688),
     /* 85551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 85554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 85557 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(85594), // Rule ID 891 //
     /* 85562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 85565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 85569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 85573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 85577 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 85577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 85582 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 85588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 85592 */     GIR_RootConstrainSelectedInstOperands,
     /* 85593 */     // GIR_Coverage, 891,
     /* 85593 */     GIR_Done,
     /* 85594 */   // Label 2697: @85594
     /* 85594 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(85625), // Rule ID 2239 //
     /* 85599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 85602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85614 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 85614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 85619 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85623 */     GIR_RootConstrainSelectedInstOperands,
     /* 85624 */     // GIR_Coverage, 2239,
     /* 85624 */     GIR_Done,
     /* 85625 */   // Label 2698: @85625
     /* 85625 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(85656), // Rule ID 2247 //
     /* 85630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 85633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 85645 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 85645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 85650 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85654 */     GIR_RootConstrainSelectedInstOperands,
     /* 85655 */     // GIR_Coverage, 2247,
     /* 85655 */     GIR_Done,
     /* 85656 */   // Label 2699: @85656
     /* 85656 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(85687), // Rule ID 6044 //
     /* 85661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 85664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 85668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 85672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 85676 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 85676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 85681 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85685 */     GIR_RootConstrainSelectedInstOperands,
     /* 85686 */     // GIR_Coverage, 6044,
     /* 85686 */     GIR_Done,
     /* 85687 */   // Label 2700: @85687
     /* 85687 */   GIM_Reject,
     /* 85688 */ // Label 2696: @85688
     /* 85688 */ GIM_Reject,
     /* 85689 */ // Label 2679: @85689
     /* 85689 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(85732), // Rule ID 893 //
     /* 85694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 85697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 85700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 85703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 85707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 85711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 85715 */   // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 85715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 85720 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 85726 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 85730 */   GIR_RootConstrainSelectedInstOperands,
     /* 85731 */   // GIR_Coverage, 893,
     /* 85731 */   GIR_Done,
     /* 85732 */ // Label 2701: @85732
     /* 85732 */ GIM_Reject,
     /* 85733 */ // Label 2680: @85733
     /* 85733 */ GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(85838),
     /* 85738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 85741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 85744 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(85775), // Rule ID 2215 //
     /* 85749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85764 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 85764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 85769 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85773 */     GIR_RootConstrainSelectedInstOperands,
     /* 85774 */     // GIR_Coverage, 2215,
     /* 85774 */     GIR_Done,
     /* 85775 */   // Label 2703: @85775
     /* 85775 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(85806), // Rule ID 2231 //
     /* 85780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 85783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85795 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 85795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 85800 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85804 */     GIR_RootConstrainSelectedInstOperands,
     /* 85805 */     // GIR_Coverage, 2231,
     /* 85805 */     GIR_Done,
     /* 85806 */   // Label 2704: @85806
     /* 85806 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(85837), // Rule ID 6535 //
     /* 85811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85826 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 85826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 85831 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85835 */     GIR_RootConstrainSelectedInstOperands,
     /* 85836 */     // GIR_Coverage, 6535,
     /* 85836 */     GIR_Done,
     /* 85837 */   // Label 2705: @85837
     /* 85837 */   GIM_Reject,
     /* 85838 */ // Label 2702: @85838
     /* 85838 */ GIM_Reject,
     /* 85839 */ // Label 2681: @85839
     /* 85839 */ GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(85944),
     /* 85844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 85847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 85850 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(85881), // Rule ID 2211 //
     /* 85855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85870 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 85870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 85875 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85879 */     GIR_RootConstrainSelectedInstOperands,
     /* 85880 */     // GIR_Coverage, 2211,
     /* 85880 */     GIR_Done,
     /* 85881 */   // Label 2707: @85881
     /* 85881 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(85912), // Rule ID 2227 //
     /* 85886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 85889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 85901 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 85901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 85906 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85910 */     GIR_RootConstrainSelectedInstOperands,
     /* 85911 */     // GIR_Coverage, 2227,
     /* 85911 */     GIR_Done,
     /* 85912 */   // Label 2708: @85912
     /* 85912 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(85943), // Rule ID 6511 //
     /* 85917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 85932 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 85932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 85937 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85941 */     GIR_RootConstrainSelectedInstOperands,
     /* 85942 */     // GIR_Coverage, 6511,
     /* 85942 */     GIR_Done,
     /* 85943 */   // Label 2709: @85943
     /* 85943 */   GIM_Reject,
     /* 85944 */ // Label 2706: @85944
     /* 85944 */ GIM_Reject,
     /* 85945 */ // Label 2682: @85945
     /* 85945 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(86019),
     /* 85950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 85953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 85956 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(85987), // Rule ID 2223 //
     /* 85961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 85964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 85976 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 85976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 85981 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 85985 */     GIR_RootConstrainSelectedInstOperands,
     /* 85986 */     // GIR_Coverage, 2223,
     /* 85986 */     GIR_Done,
     /* 85987 */   // Label 2711: @85987
     /* 85987 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(86018), // Rule ID 6547 //
     /* 85992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 85995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 85999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86007 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 86007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 86012 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86016 */     GIR_RootConstrainSelectedInstOperands,
     /* 86017 */     // GIR_Coverage, 6547,
     /* 86017 */     GIR_Done,
     /* 86018 */   // Label 2712: @86018
     /* 86018 */   GIM_Reject,
     /* 86019 */ // Label 2710: @86019
     /* 86019 */ GIM_Reject,
     /* 86020 */ // Label 2683: @86020
     /* 86020 */ GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(86057), // Rule ID 6571 //
     /* 86025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 86028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 86031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 86034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86046 */   // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 86046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 86051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86055 */   GIR_RootConstrainSelectedInstOperands,
     /* 86056 */   // GIR_Coverage, 6571,
     /* 86056 */   GIR_Done,
     /* 86057 */ // Label 2713: @86057
     /* 86057 */ GIM_Reject,
     /* 86058 */ // Label 2684: @86058
     /* 86058 */ GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(86132),
     /* 86063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 86066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 86069 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(86100), // Rule ID 2219 //
     /* 86074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86089 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 86089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 86094 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86098 */     GIR_RootConstrainSelectedInstOperands,
     /* 86099 */     // GIR_Coverage, 2219,
     /* 86099 */     GIR_Done,
     /* 86100 */   // Label 2715: @86100
     /* 86100 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(86131), // Rule ID 6523 //
     /* 86105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86120 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 86120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 86125 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86129 */     GIR_RootConstrainSelectedInstOperands,
     /* 86130 */     // GIR_Coverage, 6523,
     /* 86130 */     GIR_Done,
     /* 86131 */   // Label 2716: @86131
     /* 86131 */   GIM_Reject,
     /* 86132 */ // Label 2714: @86132
     /* 86132 */ GIM_Reject,
     /* 86133 */ // Label 2685: @86133
     /* 86133 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(86170), // Rule ID 6499 //
     /* 86138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 86144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 86147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86159 */   // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 86159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 86164 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86168 */   GIR_RootConstrainSelectedInstOperands,
     /* 86169 */   // GIR_Coverage, 6499,
     /* 86169 */   GIR_Done,
     /* 86170 */ // Label 2717: @86170
     /* 86170 */ GIM_Reject,
     /* 86171 */ // Label 2686: @86171
     /* 86171 */ GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(86208), // Rule ID 6583 //
     /* 86176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 86179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 86182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 86185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 86197 */   // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 86197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 86202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86206 */   GIR_RootConstrainSelectedInstOperands,
     /* 86207 */   // GIR_Coverage, 6583,
     /* 86207 */   GIR_Done,
     /* 86208 */ // Label 2718: @86208
     /* 86208 */ GIM_Reject,
     /* 86209 */ // Label 2687: @86209
     /* 86209 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(86246), // Rule ID 6487 //
     /* 86214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 86220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 86223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86235 */   // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 86235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 86240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86244 */   GIR_RootConstrainSelectedInstOperands,
     /* 86245 */   // GIR_Coverage, 6487,
     /* 86245 */   GIR_Done,
     /* 86246 */ // Label 2719: @86246
     /* 86246 */ GIM_Reject,
     /* 86247 */ // Label 2688: @86247
     /* 86247 */ GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(86284), // Rule ID 6559 //
     /* 86252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 86255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 86258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 86261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 86273 */   // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 86273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 86278 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86282 */   GIR_RootConstrainSelectedInstOperands,
     /* 86283 */   // GIR_Coverage, 6559,
     /* 86283 */   GIR_Done,
     /* 86284 */ // Label 2720: @86284
     /* 86284 */ GIM_Reject,
     /* 86285 */ // Label 2689: @86285
     /* 86285 */ GIM_Reject,
     /* 86286 */ // Label 63: @86286
     /* 86286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2734*/ GIMT_Encode4(87301),
     /* 86297 */ /*GILLT_s16*//*Label 2721*/ GIMT_Encode4(86381),
     /* 86301 */ /*GILLT_s32*//*Label 2722*/ GIMT_Encode4(86419),
     /* 86305 */ /*GILLT_s64*//*Label 2723*/ GIMT_Encode4(86562),
     /* 86309 */ /*GILLT_s80*//*Label 2724*/ GIMT_Encode4(86705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 86321 */ /*GILLT_v2s64*//*Label 2725*/ GIMT_Encode4(86749), GIMT_Encode4(0),
     /* 86329 */ /*GILLT_v4s32*//*Label 2726*/ GIMT_Encode4(86855),
     /* 86333 */ /*GILLT_v4s64*//*Label 2727*/ GIMT_Encode4(86961), GIMT_Encode4(0),
     /* 86341 */ /*GILLT_v8s16*//*Label 2728*/ GIMT_Encode4(87036),
     /* 86345 */ /*GILLT_v8s32*//*Label 2729*/ GIMT_Encode4(87074),
     /* 86349 */ /*GILLT_v8s64*//*Label 2730*/ GIMT_Encode4(87149), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 86361 */ /*GILLT_v16s16*//*Label 2731*/ GIMT_Encode4(87187),
     /* 86365 */ /*GILLT_v16s32*//*Label 2732*/ GIMT_Encode4(87225), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 86377 */ /*GILLT_v32s16*//*Label 2733*/ GIMT_Encode4(87263),
     /* 86381 */ // Label 2721: @86381
     /* 86381 */ GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(86418), // Rule ID 6006 //
     /* 86386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 86389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 86392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 86395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 86399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 86403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 86407 */   // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 86407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 86412 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86416 */   GIR_RootConstrainSelectedInstOperands,
     /* 86417 */   // GIR_Coverage, 6006,
     /* 86417 */   GIR_Done,
     /* 86418 */ // Label 2735: @86418
     /* 86418 */ GIM_Reject,
     /* 86419 */ // Label 2722: @86419
     /* 86419 */ GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(86561),
     /* 86424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 86427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 86430 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(86467), // Rule ID 895 //
     /* 86435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 86438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 86442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 86446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 86450 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 86450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 86455 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 86461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 86465 */     GIR_RootConstrainSelectedInstOperands,
     /* 86466 */     // GIR_Coverage, 895,
     /* 86466 */     GIR_Done,
     /* 86467 */   // Label 2737: @86467
     /* 86467 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(86498), // Rule ID 2195 //
     /* 86472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 86475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86487 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 86487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 86492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86496 */     GIR_RootConstrainSelectedInstOperands,
     /* 86497 */     // GIR_Coverage, 2195,
     /* 86497 */     GIR_Done,
     /* 86498 */   // Label 2738: @86498
     /* 86498 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(86529), // Rule ID 2203 //
     /* 86503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 86506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 86518 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 86518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 86523 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86527 */     GIR_RootConstrainSelectedInstOperands,
     /* 86528 */     // GIR_Coverage, 2203,
     /* 86528 */     GIR_Done,
     /* 86529 */   // Label 2739: @86529
     /* 86529 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(86560), // Rule ID 5968 //
     /* 86534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 86541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 86545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 86549 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 86549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 86554 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86558 */     GIR_RootConstrainSelectedInstOperands,
     /* 86559 */     // GIR_Coverage, 5968,
     /* 86559 */     GIR_Done,
     /* 86560 */   // Label 2740: @86560
     /* 86560 */   GIM_Reject,
     /* 86561 */ // Label 2736: @86561
     /* 86561 */ GIM_Reject,
     /* 86562 */ // Label 2723: @86562
     /* 86562 */ GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(86704),
     /* 86567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 86570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 86573 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(86610), // Rule ID 897 //
     /* 86578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 86581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 86585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 86589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 86593 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 86593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 86598 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 86604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 86608 */     GIR_RootConstrainSelectedInstOperands,
     /* 86609 */     // GIR_Coverage, 897,
     /* 86609 */     GIR_Done,
     /* 86610 */   // Label 2742: @86610
     /* 86610 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(86641), // Rule ID 2199 //
     /* 86615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 86618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86630 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 86630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 86635 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86639 */     GIR_RootConstrainSelectedInstOperands,
     /* 86640 */     // GIR_Coverage, 2199,
     /* 86640 */     GIR_Done,
     /* 86641 */   // Label 2743: @86641
     /* 86641 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(86672), // Rule ID 2207 //
     /* 86646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 86649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 86661 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 86661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 86666 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86670 */     GIR_RootConstrainSelectedInstOperands,
     /* 86671 */     // GIR_Coverage, 2207,
     /* 86671 */     GIR_Done,
     /* 86672 */   // Label 2744: @86672
     /* 86672 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(86703), // Rule ID 5987 //
     /* 86677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 86680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 86684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 86688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 86692 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 86692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 86697 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86701 */     GIR_RootConstrainSelectedInstOperands,
     /* 86702 */     // GIR_Coverage, 5987,
     /* 86702 */     GIR_Done,
     /* 86703 */   // Label 2745: @86703
     /* 86703 */   GIM_Reject,
     /* 86704 */ // Label 2741: @86704
     /* 86704 */ GIM_Reject,
     /* 86705 */ // Label 2724: @86705
     /* 86705 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(86748), // Rule ID 899 //
     /* 86710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 86713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 86716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 86719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 86723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 86727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 86731 */   // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 86731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 86736 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 86742 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 86746 */   GIR_RootConstrainSelectedInstOperands,
     /* 86747 */   // GIR_Coverage, 899,
     /* 86747 */   GIR_Done,
     /* 86748 */ // Label 2746: @86748
     /* 86748 */ GIM_Reject,
     /* 86749 */ // Label 2725: @86749
     /* 86749 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(86854),
     /* 86754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 86757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 86760 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(86791), // Rule ID 2175 //
     /* 86765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86780 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 86780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 86785 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86789 */     GIR_RootConstrainSelectedInstOperands,
     /* 86790 */     // GIR_Coverage, 2175,
     /* 86790 */     GIR_Done,
     /* 86791 */   // Label 2748: @86791
     /* 86791 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(86822), // Rule ID 2191 //
     /* 86796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 86799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86811 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 86811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 86816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86820 */     GIR_RootConstrainSelectedInstOperands,
     /* 86821 */     // GIR_Coverage, 2191,
     /* 86821 */     GIR_Done,
     /* 86822 */   // Label 2749: @86822
     /* 86822 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(86853), // Rule ID 6418 //
     /* 86827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86842 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 86842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 86847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86851 */     GIR_RootConstrainSelectedInstOperands,
     /* 86852 */     // GIR_Coverage, 6418,
     /* 86852 */     GIR_Done,
     /* 86853 */   // Label 2750: @86853
     /* 86853 */   GIM_Reject,
     /* 86854 */ // Label 2747: @86854
     /* 86854 */ GIM_Reject,
     /* 86855 */ // Label 2726: @86855
     /* 86855 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(86960),
     /* 86860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 86863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 86866 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(86897), // Rule ID 2171 //
     /* 86871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86886 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 86886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 86891 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86895 */     GIR_RootConstrainSelectedInstOperands,
     /* 86896 */     // GIR_Coverage, 2171,
     /* 86896 */     GIR_Done,
     /* 86897 */   // Label 2752: @86897
     /* 86897 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(86928), // Rule ID 2187 //
     /* 86902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 86905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 86917 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 86917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 86922 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86926 */     GIR_RootConstrainSelectedInstOperands,
     /* 86927 */     // GIR_Coverage, 2187,
     /* 86927 */     GIR_Done,
     /* 86928 */   // Label 2753: @86928
     /* 86928 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(86959), // Rule ID 6394 //
     /* 86933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 86936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 86948 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 86948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 86953 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 86957 */     GIR_RootConstrainSelectedInstOperands,
     /* 86958 */     // GIR_Coverage, 6394,
     /* 86958 */     GIR_Done,
     /* 86959 */   // Label 2754: @86959
     /* 86959 */   GIM_Reject,
     /* 86960 */ // Label 2751: @86960
     /* 86960 */ GIM_Reject,
     /* 86961 */ // Label 2727: @86961
     /* 86961 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(87035),
     /* 86966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 86969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 86972 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(87003), // Rule ID 2183 //
     /* 86977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 86980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 86992 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 86992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 86997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87001 */     GIR_RootConstrainSelectedInstOperands,
     /* 87002 */     // GIR_Coverage, 2183,
     /* 87002 */     GIR_Done,
     /* 87003 */   // Label 2756: @87003
     /* 87003 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(87034), // Rule ID 6430 //
     /* 87008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87023 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 87023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 87028 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87032 */     GIR_RootConstrainSelectedInstOperands,
     /* 87033 */     // GIR_Coverage, 6430,
     /* 87033 */     GIR_Done,
     /* 87034 */   // Label 2757: @87034
     /* 87034 */   GIM_Reject,
     /* 87035 */ // Label 2755: @87035
     /* 87035 */ GIM_Reject,
     /* 87036 */ // Label 2728: @87036
     /* 87036 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(87073), // Rule ID 6454 //
     /* 87041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 87044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 87047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 87050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87062 */   // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 87062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 87067 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87071 */   GIR_RootConstrainSelectedInstOperands,
     /* 87072 */   // GIR_Coverage, 6454,
     /* 87072 */   GIR_Done,
     /* 87073 */ // Label 2758: @87073
     /* 87073 */ GIM_Reject,
     /* 87074 */ // Label 2729: @87074
     /* 87074 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(87148),
     /* 87079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 87082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 87085 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(87116), // Rule ID 2179 //
     /* 87090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 87105 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 87105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 87110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87114 */     GIR_RootConstrainSelectedInstOperands,
     /* 87115 */     // GIR_Coverage, 2179,
     /* 87115 */     GIR_Done,
     /* 87116 */   // Label 2760: @87116
     /* 87116 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(87147), // Rule ID 6406 //
     /* 87121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87136 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 87136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 87141 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87145 */     GIR_RootConstrainSelectedInstOperands,
     /* 87146 */     // GIR_Coverage, 6406,
     /* 87146 */     GIR_Done,
     /* 87147 */   // Label 2761: @87147
     /* 87147 */   GIM_Reject,
     /* 87148 */ // Label 2759: @87148
     /* 87148 */ GIM_Reject,
     /* 87149 */ // Label 2730: @87149
     /* 87149 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(87186), // Rule ID 6382 //
     /* 87154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 87160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 87163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87175 */   // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 87175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 87180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87184 */   GIR_RootConstrainSelectedInstOperands,
     /* 87185 */   // GIR_Coverage, 6382,
     /* 87185 */   GIR_Done,
     /* 87186 */ // Label 2762: @87186
     /* 87186 */ GIM_Reject,
     /* 87187 */ // Label 2731: @87187
     /* 87187 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(87224), // Rule ID 6466 //
     /* 87192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 87195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 87198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 87201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 87213 */   // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 87213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 87218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87222 */   GIR_RootConstrainSelectedInstOperands,
     /* 87223 */   // GIR_Coverage, 6466,
     /* 87223 */   GIR_Done,
     /* 87224 */ // Label 2763: @87224
     /* 87224 */ GIM_Reject,
     /* 87225 */ // Label 2732: @87225
     /* 87225 */ GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(87262), // Rule ID 6370 //
     /* 87230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 87236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 87239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87251 */   // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 87251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 87256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87260 */   GIR_RootConstrainSelectedInstOperands,
     /* 87261 */   // GIR_Coverage, 6370,
     /* 87261 */   GIR_Done,
     /* 87262 */ // Label 2764: @87262
     /* 87262 */ GIM_Reject,
     /* 87263 */ // Label 2733: @87263
     /* 87263 */ GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(87300), // Rule ID 6442 //
     /* 87268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 87271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 87274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 87277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 87289 */   // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 87289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 87294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87298 */   GIR_RootConstrainSelectedInstOperands,
     /* 87299 */   // GIR_Coverage, 6442,
     /* 87299 */   GIR_Done,
     /* 87300 */ // Label 2765: @87300
     /* 87300 */ GIM_Reject,
     /* 87301 */ // Label 2734: @87301
     /* 87301 */ GIM_Reject,
     /* 87302 */ // Label 64: @87302
     /* 87302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2779*/ GIMT_Encode4(88317),
     /* 87313 */ /*GILLT_s16*//*Label 2766*/ GIMT_Encode4(87397),
     /* 87317 */ /*GILLT_s32*//*Label 2767*/ GIMT_Encode4(87435),
     /* 87321 */ /*GILLT_s64*//*Label 2768*/ GIMT_Encode4(87578),
     /* 87325 */ /*GILLT_s80*//*Label 2769*/ GIMT_Encode4(87721), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 87337 */ /*GILLT_v2s64*//*Label 2770*/ GIMT_Encode4(87765), GIMT_Encode4(0),
     /* 87345 */ /*GILLT_v4s32*//*Label 2771*/ GIMT_Encode4(87871),
     /* 87349 */ /*GILLT_v4s64*//*Label 2772*/ GIMT_Encode4(87977), GIMT_Encode4(0),
     /* 87357 */ /*GILLT_v8s16*//*Label 2773*/ GIMT_Encode4(88052),
     /* 87361 */ /*GILLT_v8s32*//*Label 2774*/ GIMT_Encode4(88090),
     /* 87365 */ /*GILLT_v8s64*//*Label 2775*/ GIMT_Encode4(88165), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 87377 */ /*GILLT_v16s16*//*Label 2776*/ GIMT_Encode4(88203),
     /* 87381 */ /*GILLT_v16s32*//*Label 2777*/ GIMT_Encode4(88241), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 87393 */ /*GILLT_v32s16*//*Label 2778*/ GIMT_Encode4(88279),
     /* 87397 */ // Label 2766: @87397
     /* 87397 */ GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(87434), // Rule ID 6120 //
     /* 87402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 87405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 87408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 87411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 87415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 87419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 87423 */   // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 87423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 87428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87432 */   GIR_RootConstrainSelectedInstOperands,
     /* 87433 */   // GIR_Coverage, 6120,
     /* 87433 */   GIR_Done,
     /* 87434 */ // Label 2780: @87434
     /* 87434 */ GIM_Reject,
     /* 87435 */ // Label 2767: @87435
     /* 87435 */ GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(87577),
     /* 87440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 87443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 87446 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(87483), // Rule ID 901 //
     /* 87451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 87454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 87458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 87462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 87466 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 87466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 87471 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 87477 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 87481 */     GIR_RootConstrainSelectedInstOperands,
     /* 87482 */     // GIR_Coverage, 901,
     /* 87482 */     GIR_Done,
     /* 87483 */   // Label 2782: @87483
     /* 87483 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(87514), // Rule ID 2275 //
     /* 87488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 87491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87503 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 87503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 87508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87512 */     GIR_RootConstrainSelectedInstOperands,
     /* 87513 */     // GIR_Coverage, 2275,
     /* 87513 */     GIR_Done,
     /* 87514 */   // Label 2783: @87514
     /* 87514 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(87545), // Rule ID 2283 //
     /* 87519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 87522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 87534 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 87534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 87539 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87543 */     GIR_RootConstrainSelectedInstOperands,
     /* 87544 */     // GIR_Coverage, 2283,
     /* 87544 */     GIR_Done,
     /* 87545 */   // Label 2784: @87545
     /* 87545 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(87576), // Rule ID 6082 //
     /* 87550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 87557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 87561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 87565 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 87565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 87570 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87574 */     GIR_RootConstrainSelectedInstOperands,
     /* 87575 */     // GIR_Coverage, 6082,
     /* 87575 */     GIR_Done,
     /* 87576 */   // Label 2785: @87576
     /* 87576 */   GIM_Reject,
     /* 87577 */ // Label 2781: @87577
     /* 87577 */ GIM_Reject,
     /* 87578 */ // Label 2768: @87578
     /* 87578 */ GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(87720),
     /* 87583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 87586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 87589 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(87626), // Rule ID 903 //
     /* 87594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 87597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 87601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 87605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 87609 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 87609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 87614 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 87620 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 87624 */     GIR_RootConstrainSelectedInstOperands,
     /* 87625 */     // GIR_Coverage, 903,
     /* 87625 */     GIR_Done,
     /* 87626 */   // Label 2787: @87626
     /* 87626 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(87657), // Rule ID 2279 //
     /* 87631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 87634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87646 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 87646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 87651 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87655 */     GIR_RootConstrainSelectedInstOperands,
     /* 87656 */     // GIR_Coverage, 2279,
     /* 87656 */     GIR_Done,
     /* 87657 */   // Label 2788: @87657
     /* 87657 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(87688), // Rule ID 2287 //
     /* 87662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 87665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 87677 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 87677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 87682 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87686 */     GIR_RootConstrainSelectedInstOperands,
     /* 87687 */     // GIR_Coverage, 2287,
     /* 87687 */     GIR_Done,
     /* 87688 */   // Label 2789: @87688
     /* 87688 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(87719), // Rule ID 6101 //
     /* 87693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 87696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 87700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 87704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 87708 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 87708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 87713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87717 */     GIR_RootConstrainSelectedInstOperands,
     /* 87718 */     // GIR_Coverage, 6101,
     /* 87718 */     GIR_Done,
     /* 87719 */   // Label 2790: @87719
     /* 87719 */   GIM_Reject,
     /* 87720 */ // Label 2786: @87720
     /* 87720 */ GIM_Reject,
     /* 87721 */ // Label 2769: @87721
     /* 87721 */ GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(87764), // Rule ID 905 //
     /* 87726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 87729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 87732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 87735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 87739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 87743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 87747 */   // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 87747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 87752 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 87758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 87762 */   GIR_RootConstrainSelectedInstOperands,
     /* 87763 */   // GIR_Coverage, 905,
     /* 87763 */   GIR_Done,
     /* 87764 */ // Label 2791: @87764
     /* 87764 */ GIM_Reject,
     /* 87765 */ // Label 2770: @87765
     /* 87765 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(87870),
     /* 87770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 87773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 87776 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(87807), // Rule ID 2255 //
     /* 87781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87796 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 87796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 87801 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87805 */     GIR_RootConstrainSelectedInstOperands,
     /* 87806 */     // GIR_Coverage, 2255,
     /* 87806 */     GIR_Done,
     /* 87807 */   // Label 2793: @87807
     /* 87807 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(87838), // Rule ID 2271 //
     /* 87812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 87815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87827 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 87827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 87832 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87836 */     GIR_RootConstrainSelectedInstOperands,
     /* 87837 */     // GIR_Coverage, 2271,
     /* 87837 */     GIR_Done,
     /* 87838 */   // Label 2794: @87838
     /* 87838 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(87869), // Rule ID 6652 //
     /* 87843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87858 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 87858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 87863 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87867 */     GIR_RootConstrainSelectedInstOperands,
     /* 87868 */     // GIR_Coverage, 6652,
     /* 87868 */     GIR_Done,
     /* 87869 */   // Label 2795: @87869
     /* 87869 */   GIM_Reject,
     /* 87870 */ // Label 2792: @87870
     /* 87870 */ GIM_Reject,
     /* 87871 */ // Label 2771: @87871
     /* 87871 */ GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(87976),
     /* 87876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 87879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 87882 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(87913), // Rule ID 2251 //
     /* 87887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87902 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 87902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 87907 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87911 */     GIR_RootConstrainSelectedInstOperands,
     /* 87912 */     // GIR_Coverage, 2251,
     /* 87912 */     GIR_Done,
     /* 87913 */   // Label 2797: @87913
     /* 87913 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(87944), // Rule ID 2267 //
     /* 87918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 87921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 87933 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 87933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 87938 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87942 */     GIR_RootConstrainSelectedInstOperands,
     /* 87943 */     // GIR_Coverage, 2267,
     /* 87943 */     GIR_Done,
     /* 87944 */   // Label 2798: @87944
     /* 87944 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(87975), // Rule ID 6628 //
     /* 87949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 87952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 87964 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 87964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 87969 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 87973 */     GIR_RootConstrainSelectedInstOperands,
     /* 87974 */     // GIR_Coverage, 6628,
     /* 87974 */     GIR_Done,
     /* 87975 */   // Label 2799: @87975
     /* 87975 */   GIM_Reject,
     /* 87976 */ // Label 2796: @87976
     /* 87976 */ GIM_Reject,
     /* 87977 */ // Label 2772: @87977
     /* 87977 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(88051),
     /* 87982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 87985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 87988 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(88019), // Rule ID 2263 //
     /* 87993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 87996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88008 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 88008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 88013 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88017 */     GIR_RootConstrainSelectedInstOperands,
     /* 88018 */     // GIR_Coverage, 2263,
     /* 88018 */     GIR_Done,
     /* 88019 */   // Label 2801: @88019
     /* 88019 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(88050), // Rule ID 6664 //
     /* 88024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88039 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 88039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 88044 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88048 */     GIR_RootConstrainSelectedInstOperands,
     /* 88049 */     // GIR_Coverage, 6664,
     /* 88049 */     GIR_Done,
     /* 88050 */   // Label 2802: @88050
     /* 88050 */   GIM_Reject,
     /* 88051 */ // Label 2800: @88051
     /* 88051 */ GIM_Reject,
     /* 88052 */ // Label 2773: @88052
     /* 88052 */ GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(88089), // Rule ID 6688 //
     /* 88057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 88060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 88063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 88066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88078 */   // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 88078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 88083 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88087 */   GIR_RootConstrainSelectedInstOperands,
     /* 88088 */   // GIR_Coverage, 6688,
     /* 88088 */   GIR_Done,
     /* 88089 */ // Label 2803: @88089
     /* 88089 */ GIM_Reject,
     /* 88090 */ // Label 2774: @88090
     /* 88090 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(88164),
     /* 88095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 88098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 88101 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(88132), // Rule ID 2259 //
     /* 88106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 88109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88121 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 88121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 88126 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88130 */     GIR_RootConstrainSelectedInstOperands,
     /* 88131 */     // GIR_Coverage, 2259,
     /* 88131 */     GIR_Done,
     /* 88132 */   // Label 2805: @88132
     /* 88132 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(88163), // Rule ID 6640 //
     /* 88137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88152 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 88152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 88157 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88161 */     GIR_RootConstrainSelectedInstOperands,
     /* 88162 */     // GIR_Coverage, 6640,
     /* 88162 */     GIR_Done,
     /* 88163 */   // Label 2806: @88163
     /* 88163 */   GIM_Reject,
     /* 88164 */ // Label 2804: @88164
     /* 88164 */ GIM_Reject,
     /* 88165 */ // Label 2775: @88165
     /* 88165 */ GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(88202), // Rule ID 6616 //
     /* 88170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 88176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 88179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88191 */   // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 88191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 88196 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88200 */   GIR_RootConstrainSelectedInstOperands,
     /* 88201 */   // GIR_Coverage, 6616,
     /* 88201 */   GIR_Done,
     /* 88202 */ // Label 2807: @88202
     /* 88202 */ GIM_Reject,
     /* 88203 */ // Label 2776: @88203
     /* 88203 */ GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(88240), // Rule ID 6700 //
     /* 88208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 88211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 88214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 88217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 88229 */   // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 88229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 88234 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88238 */   GIR_RootConstrainSelectedInstOperands,
     /* 88239 */   // GIR_Coverage, 6700,
     /* 88239 */   GIR_Done,
     /* 88240 */ // Label 2808: @88240
     /* 88240 */ GIM_Reject,
     /* 88241 */ // Label 2777: @88241
     /* 88241 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(88278), // Rule ID 6604 //
     /* 88246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 88252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 88255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88267 */   // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 88267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 88272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88276 */   GIR_RootConstrainSelectedInstOperands,
     /* 88277 */   // GIR_Coverage, 6604,
     /* 88277 */   GIR_Done,
     /* 88278 */ // Label 2809: @88278
     /* 88278 */ GIM_Reject,
     /* 88279 */ // Label 2778: @88279
     /* 88279 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(88316), // Rule ID 6676 //
     /* 88284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 88287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 88290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 88293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 88305 */   // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 88305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 88310 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88314 */   GIR_RootConstrainSelectedInstOperands,
     /* 88315 */   // GIR_Coverage, 6676,
     /* 88315 */   GIR_Done,
     /* 88316 */ // Label 2810: @88316
     /* 88316 */ GIM_Reject,
     /* 88317 */ // Label 2779: @88317
     /* 88317 */ GIM_Reject,
     /* 88318 */ // Label 65: @88318
     /* 88318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2823*/ GIMT_Encode4(89445),
     /* 88329 */ /*GILLT_s16*//*Label 2811*/ GIMT_Encode4(88413),
     /* 88333 */ /*GILLT_s32*//*Label 2812*/ GIMT_Encode4(88460),
     /* 88337 */ /*GILLT_s64*//*Label 2813*/ GIMT_Encode4(88585), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 88353 */ /*GILLT_v2s64*//*Label 2814*/ GIMT_Encode4(88710), GIMT_Encode4(0),
     /* 88361 */ /*GILLT_v4s32*//*Label 2815*/ GIMT_Encode4(88835),
     /* 88365 */ /*GILLT_v4s64*//*Label 2816*/ GIMT_Encode4(88960), GIMT_Encode4(0),
     /* 88373 */ /*GILLT_v8s16*//*Label 2817*/ GIMT_Encode4(89085),
     /* 88377 */ /*GILLT_v8s32*//*Label 2818*/ GIMT_Encode4(89132),
     /* 88381 */ /*GILLT_v8s64*//*Label 2819*/ GIMT_Encode4(89257), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 88393 */ /*GILLT_v16s16*//*Label 2820*/ GIMT_Encode4(89304),
     /* 88397 */ /*GILLT_v16s32*//*Label 2821*/ GIMT_Encode4(89351), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 88409 */ /*GILLT_v32s16*//*Label 2822*/ GIMT_Encode4(89398),
     /* 88413 */ // Label 2811: @88413
     /* 88413 */ GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(88459), // Rule ID 10147 //
     /* 88418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 88421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 88424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 88427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 88430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 88446 */   // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 88446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 88449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88451 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88455 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88457 */   GIR_RootConstrainSelectedInstOperands,
     /* 88458 */   // GIR_Coverage, 10147,
     /* 88458 */   GIR_EraseRootFromParent_Done,
     /* 88459 */ // Label 2824: @88459
     /* 88459 */ GIM_Reject,
     /* 88460 */ // Label 2812: @88460
     /* 88460 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(88584),
     /* 88465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 88468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 88471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 88474 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(88511), // Rule ID 1294 //
     /* 88479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 88482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88498 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 88498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 88501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88507 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88509 */     GIR_RootConstrainSelectedInstOperands,
     /* 88510 */     // GIR_Coverage, 1294,
     /* 88510 */     GIR_EraseRootFromParent_Done,
     /* 88511 */   // Label 2826: @88511
     /* 88511 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(88546), // Rule ID 1358 //
     /* 88516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 88519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 88535 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 88535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 88540 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88544 */     GIR_RootConstrainSelectedInstOperands,
     /* 88545 */     // GIR_Coverage, 1358,
     /* 88545 */     GIR_Done,
     /* 88546 */   // Label 2827: @88546
     /* 88546 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(88583), // Rule ID 10129 //
     /* 88551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 88570 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 88570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 88573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88575 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88577 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88579 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88581 */     GIR_RootConstrainSelectedInstOperands,
     /* 88582 */     // GIR_Coverage, 10129,
     /* 88582 */     GIR_EraseRootFromParent_Done,
     /* 88583 */   // Label 2828: @88583
     /* 88583 */   GIM_Reject,
     /* 88584 */ // Label 2825: @88584
     /* 88584 */ GIM_Reject,
     /* 88585 */ // Label 2813: @88585
     /* 88585 */ GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(88709),
     /* 88590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 88593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 88596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 88599 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(88636), // Rule ID 1302 //
     /* 88604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 88607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88623 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 88623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 88626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88632 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88634 */     GIR_RootConstrainSelectedInstOperands,
     /* 88635 */     // GIR_Coverage, 1302,
     /* 88635 */     GIR_EraseRootFromParent_Done,
     /* 88636 */   // Label 2830: @88636
     /* 88636 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(88671), // Rule ID 1442 //
     /* 88641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 88644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 88660 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 88660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 88665 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88669 */     GIR_RootConstrainSelectedInstOperands,
     /* 88670 */     // GIR_Coverage, 1442,
     /* 88670 */     GIR_Done,
     /* 88671 */   // Label 2831: @88671
     /* 88671 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(88708), // Rule ID 10138 //
     /* 88676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 88679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 88695 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 88695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 88698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88704 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88706 */     GIR_RootConstrainSelectedInstOperands,
     /* 88707 */     // GIR_Coverage, 10138,
     /* 88707 */     GIR_EraseRootFromParent_Done,
     /* 88708 */   // Label 2832: @88708
     /* 88708 */   GIM_Reject,
     /* 88709 */ // Label 2829: @88709
     /* 88709 */ GIM_Reject,
     /* 88710 */ // Label 2814: @88710
     /* 88710 */ GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(88834),
     /* 88715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 88718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 88721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 88724 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(88761), // Rule ID 1182 //
     /* 88729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88748 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 88748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 88751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88757 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88759 */     GIR_RootConstrainSelectedInstOperands,
     /* 88760 */     // GIR_Coverage, 1182,
     /* 88760 */     GIR_EraseRootFromParent_Done,
     /* 88761 */   // Label 2834: @88761
     /* 88761 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(88796), // Rule ID 1466 //
     /* 88766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 88769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88785 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 88785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 88790 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88794 */     GIR_RootConstrainSelectedInstOperands,
     /* 88795 */     // GIR_Coverage, 1466,
     /* 88795 */     GIR_Done,
     /* 88796 */   // Label 2835: @88796
     /* 88796 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(88833), // Rule ID 8506 //
     /* 88801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88820 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 88820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 88823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88829 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88831 */     GIR_RootConstrainSelectedInstOperands,
     /* 88832 */     // GIR_Coverage, 8506,
     /* 88832 */     GIR_EraseRootFromParent_Done,
     /* 88833 */   // Label 2836: @88833
     /* 88833 */   GIM_Reject,
     /* 88834 */ // Label 2833: @88834
     /* 88834 */ GIM_Reject,
     /* 88835 */ // Label 2815: @88835
     /* 88835 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(88959),
     /* 88840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 88843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 88846 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 88849 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(88886), // Rule ID 1134 //
     /* 88854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88873 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 88873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 88876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88878 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88880 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88882 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88884 */     GIR_RootConstrainSelectedInstOperands,
     /* 88885 */     // GIR_Coverage, 1134,
     /* 88885 */     GIR_EraseRootFromParent_Done,
     /* 88886 */   // Label 2838: @88886
     /* 88886 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(88921), // Rule ID 1382 //
     /* 88891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 88894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 88910 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 88910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 88915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 88919 */     GIR_RootConstrainSelectedInstOperands,
     /* 88920 */     // GIR_Coverage, 1382,
     /* 88920 */     GIR_Done,
     /* 88921 */   // Label 2839: @88921
     /* 88921 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(88958), // Rule ID 8467 //
     /* 88926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 88929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 88945 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 88945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 88948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 88950 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 88952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 88954 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 88956 */     GIR_RootConstrainSelectedInstOperands,
     /* 88957 */     // GIR_Coverage, 8467,
     /* 88957 */     GIR_EraseRootFromParent_Done,
     /* 88958 */   // Label 2840: @88958
     /* 88958 */   GIM_Reject,
     /* 88959 */ // Label 2837: @88959
     /* 88959 */ GIM_Reject,
     /* 88960 */ // Label 2816: @88960
     /* 88960 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(89084),
     /* 88965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 88968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 88971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 88974 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(89011), // Rule ID 1190 //
     /* 88979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 88982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 88998 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 88998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 89001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89007 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89009 */     GIR_RootConstrainSelectedInstOperands,
     /* 89010 */     // GIR_Coverage, 1190,
     /* 89010 */     GIR_EraseRootFromParent_Done,
     /* 89011 */   // Label 2842: @89011
     /* 89011 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(89046), // Rule ID 1472 //
     /* 89016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 89019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89035 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 89035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 89040 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89044 */     GIR_RootConstrainSelectedInstOperands,
     /* 89045 */     // GIR_Coverage, 1472,
     /* 89045 */     GIR_Done,
     /* 89046 */   // Label 2843: @89046
     /* 89046 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(89083), // Rule ID 8494 //
     /* 89051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 89054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89070 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 89070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 89073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89079 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89081 */     GIR_RootConstrainSelectedInstOperands,
     /* 89082 */     // GIR_Coverage, 8494,
     /* 89082 */     GIR_EraseRootFromParent_Done,
     /* 89083 */   // Label 2844: @89083
     /* 89083 */   GIM_Reject,
     /* 89084 */ // Label 2841: @89084
     /* 89084 */ GIM_Reject,
     /* 89085 */ // Label 2817: @89085
     /* 89085 */ GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(89131), // Rule ID 8428 //
     /* 89090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 89093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 89096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 89099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 89102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 89118 */   // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 89118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 89121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89123 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89127 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89129 */   GIR_RootConstrainSelectedInstOperands,
     /* 89130 */   // GIR_Coverage, 8428,
     /* 89130 */   GIR_EraseRootFromParent_Done,
     /* 89131 */ // Label 2845: @89131
     /* 89131 */ GIM_Reject,
     /* 89132 */ // Label 2818: @89132
     /* 89132 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(89256),
     /* 89137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 89140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 89143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 89146 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(89183), // Rule ID 1142 //
     /* 89151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 89154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89170 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 89170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 89173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89179 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89181 */     GIR_RootConstrainSelectedInstOperands,
     /* 89182 */     // GIR_Coverage, 1142,
     /* 89182 */     GIR_EraseRootFromParent_Done,
     /* 89183 */   // Label 2847: @89183
     /* 89183 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(89218), // Rule ID 1388 //
     /* 89188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 89191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 89207 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 89207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 89212 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89216 */     GIR_RootConstrainSelectedInstOperands,
     /* 89217 */     // GIR_Coverage, 1388,
     /* 89217 */     GIR_Done,
     /* 89218 */   // Label 2848: @89218
     /* 89218 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(89255), // Rule ID 8455 //
     /* 89223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 89226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89242 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 89242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 89245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89247 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89251 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89253 */     GIR_RootConstrainSelectedInstOperands,
     /* 89254 */     // GIR_Coverage, 8455,
     /* 89254 */     GIR_EraseRootFromParent_Done,
     /* 89255 */   // Label 2849: @89255
     /* 89255 */   GIM_Reject,
     /* 89256 */ // Label 2846: @89256
     /* 89256 */ GIM_Reject,
     /* 89257 */ // Label 2819: @89257
     /* 89257 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(89303), // Rule ID 8479 //
     /* 89262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 89268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 89271 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 89274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89286 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89290 */   // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 89290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 89293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89295 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89299 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89301 */   GIR_RootConstrainSelectedInstOperands,
     /* 89302 */   // GIR_Coverage, 8479,
     /* 89302 */   GIR_EraseRootFromParent_Done,
     /* 89303 */ // Label 2850: @89303
     /* 89303 */ GIM_Reject,
     /* 89304 */ // Label 2820: @89304
     /* 89304 */ GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(89350), // Rule ID 8416 //
     /* 89309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 89312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 89315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 89318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 89321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 89337 */   // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 89337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 89340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89342 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89344 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89346 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89348 */   GIR_RootConstrainSelectedInstOperands,
     /* 89349 */   // GIR_Coverage, 8416,
     /* 89349 */   GIR_EraseRootFromParent_Done,
     /* 89350 */ // Label 2851: @89350
     /* 89350 */ GIM_Reject,
     /* 89351 */ // Label 2821: @89351
     /* 89351 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(89397), // Rule ID 8440 //
     /* 89356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 89362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 89365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 89368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89380 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89384 */   // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 89384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 89387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89389 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89393 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89395 */   GIR_RootConstrainSelectedInstOperands,
     /* 89396 */   // GIR_Coverage, 8440,
     /* 89396 */   GIR_EraseRootFromParent_Done,
     /* 89397 */ // Label 2852: @89397
     /* 89397 */ GIM_Reject,
     /* 89398 */ // Label 2822: @89398
     /* 89398 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(89444), // Rule ID 8401 //
     /* 89403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 89406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 89409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 89412 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 89415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89427 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 89431 */   // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 89431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 89434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89436 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 89438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 89440 */   GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 89442 */   GIR_RootConstrainSelectedInstOperands,
     /* 89443 */   // GIR_Coverage, 8401,
     /* 89443 */   GIR_EraseRootFromParent_Done,
     /* 89444 */ // Label 2853: @89444
     /* 89444 */ GIM_Reject,
     /* 89445 */ // Label 2823: @89445
     /* 89445 */ GIM_Reject,
     /* 89446 */ // Label 66: @89446
     /* 89446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2867*/ GIMT_Encode4(90397),
     /* 89457 */ /*GILLT_s16*//*Label 2854*/ GIMT_Encode4(89541),
     /* 89461 */ /*GILLT_s32*//*Label 2855*/ GIMT_Encode4(89587),
     /* 89465 */ /*GILLT_s64*//*Label 2856*/ GIMT_Encode4(89741),
     /* 89469 */ /*GILLT_s80*//*Label 2857*/ GIMT_Encode4(89895), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 89481 */ /*GILLT_v2s64*//*Label 2858*/ GIMT_Encode4(89932), GIMT_Encode4(0),
     /* 89489 */ /*GILLT_v4s32*//*Label 2859*/ GIMT_Encode4(90023),
     /* 89493 */ /*GILLT_v4s64*//*Label 2860*/ GIMT_Encode4(90114), GIMT_Encode4(0),
     /* 89501 */ /*GILLT_v8s16*//*Label 2861*/ GIMT_Encode4(90178),
     /* 89505 */ /*GILLT_v8s32*//*Label 2862*/ GIMT_Encode4(90209),
     /* 89509 */ /*GILLT_v8s64*//*Label 2863*/ GIMT_Encode4(90273), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 89521 */ /*GILLT_v16s16*//*Label 2864*/ GIMT_Encode4(90304),
     /* 89525 */ /*GILLT_v16s32*//*Label 2865*/ GIMT_Encode4(90335), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 89537 */ /*GILLT_v32s16*//*Label 2866*/ GIMT_Encode4(90366),
     /* 89541 */ // Label 2854: @89541
     /* 89541 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(89586), // Rule ID 21865 //
     /* 89546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 89549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 89552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 89556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 89560 */   // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 89560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 89563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 89577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89582 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89584 */   GIR_RootConstrainSelectedInstOperands,
     /* 89585 */   // GIR_Coverage, 21865,
     /* 89585 */   GIR_EraseRootFromParent_Done,
     /* 89586 */ // Label 2868: @89586
     /* 89586 */ GIM_Reject,
     /* 89587 */ // Label 2855: @89587
     /* 89587 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(89740),
     /* 89592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 89595 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(89628), // Rule ID 1045 //
     /* 89600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 89603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 89607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 89611 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 89611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 89616 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 89622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 89626 */     GIR_RootConstrainSelectedInstOperands,
     /* 89627 */     // GIR_Coverage, 1045,
     /* 89627 */     GIR_Done,
     /* 89628 */   // Label 2870: @89628
     /* 89628 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(89655), // Rule ID 2443 //
     /* 89633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 89636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89644 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 89644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 89649 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89653 */     GIR_RootConstrainSelectedInstOperands,
     /* 89654 */     // GIR_Coverage, 2443,
     /* 89654 */     GIR_Done,
     /* 89655 */   // Label 2871: @89655
     /* 89655 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(89697), // Rule ID 18721 //
     /* 89660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 89663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 89671 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 89671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 89674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 89688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89695 */     GIR_RootConstrainSelectedInstOperands,
     /* 89696 */     // GIR_Coverage, 18721,
     /* 89696 */     GIR_EraseRootFromParent_Done,
     /* 89697 */   // Label 2872: @89697
     /* 89697 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(89739), // Rule ID 21869 //
     /* 89702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 89709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 89713 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 89713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 89716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 89730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89737 */     GIR_RootConstrainSelectedInstOperands,
     /* 89738 */     // GIR_Coverage, 21869,
     /* 89738 */     GIR_EraseRootFromParent_Done,
     /* 89739 */   // Label 2873: @89739
     /* 89739 */   GIM_Reject,
     /* 89740 */ // Label 2869: @89740
     /* 89740 */ GIM_Reject,
     /* 89741 */ // Label 2856: @89741
     /* 89741 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(89894),
     /* 89746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 89749 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(89782), // Rule ID 1047 //
     /* 89754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 89757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 89761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 89765 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 89765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 89770 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 89776 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 89780 */     GIR_RootConstrainSelectedInstOperands,
     /* 89781 */     // GIR_Coverage, 1047,
     /* 89781 */     GIR_Done,
     /* 89782 */   // Label 2875: @89782
     /* 89782 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(89809), // Rule ID 2459 //
     /* 89787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 89790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89798 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 89798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 89803 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89807 */     GIR_RootConstrainSelectedInstOperands,
     /* 89808 */     // GIR_Coverage, 2459,
     /* 89808 */     GIR_Done,
     /* 89809 */   // Label 2876: @89809
     /* 89809 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(89851), // Rule ID 18725 //
     /* 89814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 89817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 89825 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 89825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 89828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 89842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89849 */     GIR_RootConstrainSelectedInstOperands,
     /* 89850 */     // GIR_Coverage, 18725,
     /* 89850 */     GIR_EraseRootFromParent_Done,
     /* 89851 */   // Label 2877: @89851
     /* 89851 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(89893), // Rule ID 21873 //
     /* 89856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 89859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 89863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 89867 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 89867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 89870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 89874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 89879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 89881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 89884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 89886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 89889 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 89891 */     GIR_RootConstrainSelectedInstOperands,
     /* 89892 */     // GIR_Coverage, 21873,
     /* 89892 */     GIR_EraseRootFromParent_Done,
     /* 89893 */   // Label 2878: @89893
     /* 89893 */   GIM_Reject,
     /* 89894 */ // Label 2874: @89894
     /* 89894 */ GIM_Reject,
     /* 89895 */ // Label 2857: @89895
     /* 89895 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(89931), // Rule ID 1049 //
     /* 89900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 89903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 89906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 89910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 89914 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 89914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 89919 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 89925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 89929 */   GIR_RootConstrainSelectedInstOperands,
     /* 89930 */   // GIR_Coverage, 1049,
     /* 89930 */   GIR_Done,
     /* 89931 */ // Label 2879: @89931
     /* 89931 */ GIM_Reject,
     /* 89932 */ // Label 2858: @89932
     /* 89932 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(90022),
     /* 89937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 89940 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(89967), // Rule ID 2463 //
     /* 89945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 89948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89956 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 89956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 89961 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89965 */     GIR_RootConstrainSelectedInstOperands,
     /* 89966 */     // GIR_Coverage, 2463,
     /* 89966 */     GIR_Done,
     /* 89967 */   // Label 2881: @89967
     /* 89967 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(89994), // Rule ID 2471 //
     /* 89972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 89975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 89983 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 89983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 89988 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 89992 */     GIR_RootConstrainSelectedInstOperands,
     /* 89993 */     // GIR_Coverage, 2471,
     /* 89993 */     GIR_Done,
     /* 89994 */   // Label 2882: @89994
     /* 89994 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(90021), // Rule ID 12079 //
     /* 89999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 90002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 90006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 90010 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 90010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 90015 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90019 */     GIR_RootConstrainSelectedInstOperands,
     /* 90020 */     // GIR_Coverage, 12079,
     /* 90020 */     GIR_Done,
     /* 90021 */   // Label 2883: @90021
     /* 90021 */   GIM_Reject,
     /* 90022 */ // Label 2880: @90022
     /* 90022 */ GIM_Reject,
     /* 90023 */ // Label 2859: @90023
     /* 90023 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(90113),
     /* 90028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 90031 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(90058), // Rule ID 2447 //
     /* 90036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 90039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 90043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 90047 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 90047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 90052 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90056 */     GIR_RootConstrainSelectedInstOperands,
     /* 90057 */     // GIR_Coverage, 2447,
     /* 90057 */     GIR_Done,
     /* 90058 */   // Label 2885: @90058
     /* 90058 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(90085), // Rule ID 2455 //
     /* 90063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 90066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 90070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 90074 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 90074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 90079 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90083 */     GIR_RootConstrainSelectedInstOperands,
     /* 90084 */     // GIR_Coverage, 2455,
     /* 90084 */     GIR_Done,
     /* 90085 */   // Label 2886: @90085
     /* 90085 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(90112), // Rule ID 12055 //
     /* 90090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 90093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 90097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 90101 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 90101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 90106 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90110 */     GIR_RootConstrainSelectedInstOperands,
     /* 90111 */     // GIR_Coverage, 12055,
     /* 90111 */     GIR_Done,
     /* 90112 */   // Label 2887: @90112
     /* 90112 */   GIM_Reject,
     /* 90113 */ // Label 2884: @90113
     /* 90113 */ GIM_Reject,
     /* 90114 */ // Label 2860: @90114
     /* 90114 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(90177),
     /* 90119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 90122 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(90149), // Rule ID 2467 //
     /* 90127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 90130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 90134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 90138 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 90138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 90143 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90147 */     GIR_RootConstrainSelectedInstOperands,
     /* 90148 */     // GIR_Coverage, 2467,
     /* 90148 */     GIR_Done,
     /* 90149 */   // Label 2889: @90149
     /* 90149 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(90176), // Rule ID 12091 //
     /* 90154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 90157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 90161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 90165 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 90165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 90170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90174 */     GIR_RootConstrainSelectedInstOperands,
     /* 90175 */     // GIR_Coverage, 12091,
     /* 90175 */     GIR_Done,
     /* 90176 */   // Label 2890: @90176
     /* 90176 */   GIM_Reject,
     /* 90177 */ // Label 2888: @90177
     /* 90177 */ GIM_Reject,
     /* 90178 */ // Label 2861: @90178
     /* 90178 */ GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(90208), // Rule ID 12007 //
     /* 90183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 90186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 90189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 90193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 90197 */   // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 90197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 90202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90206 */   GIR_RootConstrainSelectedInstOperands,
     /* 90207 */   // GIR_Coverage, 12007,
     /* 90207 */   GIR_Done,
     /* 90208 */ // Label 2891: @90208
     /* 90208 */ GIM_Reject,
     /* 90209 */ // Label 2862: @90209
     /* 90209 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(90272),
     /* 90214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 90217 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(90244), // Rule ID 2451 //
     /* 90222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 90225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 90229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 90233 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 90233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 90238 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90242 */     GIR_RootConstrainSelectedInstOperands,
     /* 90243 */     // GIR_Coverage, 2451,
     /* 90243 */     GIR_Done,
     /* 90244 */   // Label 2893: @90244
     /* 90244 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(90271), // Rule ID 12067 //
     /* 90249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 90252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 90256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 90260 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 90260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 90265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90269 */     GIR_RootConstrainSelectedInstOperands,
     /* 90270 */     // GIR_Coverage, 12067,
     /* 90270 */     GIR_Done,
     /* 90271 */   // Label 2894: @90271
     /* 90271 */   GIM_Reject,
     /* 90272 */ // Label 2892: @90272
     /* 90272 */ GIM_Reject,
     /* 90273 */ // Label 2863: @90273
     /* 90273 */ GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(90303), // Rule ID 12043 //
     /* 90278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 90281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 90284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90292 */   // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 90292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 90297 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90301 */   GIR_RootConstrainSelectedInstOperands,
     /* 90302 */   // GIR_Coverage, 12043,
     /* 90302 */   GIR_Done,
     /* 90303 */ // Label 2895: @90303
     /* 90303 */ GIM_Reject,
     /* 90304 */ // Label 2864: @90304
     /* 90304 */ GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(90334), // Rule ID 12019 //
     /* 90309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 90312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 90315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 90319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 90323 */   // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 90323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 90328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90332 */   GIR_RootConstrainSelectedInstOperands,
     /* 90333 */   // GIR_Coverage, 12019,
     /* 90333 */   GIR_Done,
     /* 90334 */ // Label 2896: @90334
     /* 90334 */ GIM_Reject,
     /* 90335 */ // Label 2865: @90335
     /* 90335 */ GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(90365), // Rule ID 12031 //
     /* 90340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 90343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 90346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90354 */   // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 90354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 90359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90363 */   GIR_RootConstrainSelectedInstOperands,
     /* 90364 */   // GIR_Coverage, 12031,
     /* 90364 */   GIR_Done,
     /* 90365 */ // Label 2897: @90365
     /* 90365 */ GIM_Reject,
     /* 90366 */ // Label 2866: @90366
     /* 90366 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(90396), // Rule ID 11995 //
     /* 90371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 90374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 90377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 90385 */   // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 90385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 90390 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 90394 */   GIR_RootConstrainSelectedInstOperands,
     /* 90395 */   // GIR_Coverage, 11995,
     /* 90395 */   GIR_Done,
     /* 90396 */ // Label 2898: @90396
     /* 90396 */ GIM_Reject,
     /* 90397 */ // Label 2867: @90397
     /* 90397 */ GIM_Reject,
     /* 90398 */ // Label 67: @90398
     /* 90398 */ GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(90410), // Rule ID 17521 //
     /* 90403 */   // (trap)  =>  (TRAP)
     /* 90403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 90408 */   GIR_RootConstrainSelectedInstOperands,
     /* 90409 */   // GIR_Coverage, 17521,
     /* 90409 */   GIR_Done,
     /* 90410 */ // Label 2899: @90410
     /* 90410 */ GIM_Reject,
     /* 90411 */ // Label 68: @90411
     /* 90411 */ GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(90426), // Rule ID 22824 //
     /* 90416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 90419 */   // (debugtrap)  =>  (INT3)
     /* 90419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 90424 */   GIR_RootConstrainSelectedInstOperands,
     /* 90425 */   // GIR_Coverage, 22824,
     /* 90425 */   GIR_Done,
     /* 90426 */ // Label 2900: @90426
     /* 90426 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(90446), // Rule ID 22825 //
     /* 90431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 90434 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 90434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 90437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 90440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 90444 */   GIR_RootConstrainSelectedInstOperands,
     /* 90445 */   // GIR_Coverage, 22825,
     /* 90445 */   GIR_EraseRootFromParent_Done,
     /* 90446 */ // Label 2901: @90446
     /* 90446 */ GIM_Reject,
     /* 90447 */ // Label 69: @90447
     /* 90447 */ GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(90462), // Rule ID 17523 //
     /* 90452 */   // MIs[0] kind
     /* 90452 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 90455 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 90455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 90460 */   GIR_RootConstrainSelectedInstOperands,
     /* 90461 */   // GIR_Coverage, 17523,
     /* 90461 */   GIR_Done,
     /* 90462 */ // Label 2902: @90462
     /* 90462 */ GIM_Reject,
     /* 90463 */ // Label 70: @90463
     /* 90463 */ GIM_Reject,
     /* 90464 */ }; // Size: 90464 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
